/* xg.c: Guile and Ruby bindings for gdk/gtk/pango, some of glib
 *   this file generated automatically from makexg.scm and xgdata.scm
 *   needs xen.h
 *
 *   compile-time flags:
 *     HAVE_GDK_DRAW_PIXBUF for gtk 2.1 additions
 *     HAVE_GTK_TREE_VIEW_COLUMN_CELL_GET_POSITION for gtk 2.2
 *     HAVE_GTK_FILE_CHOOSER_DIALOG_NEW for gtk 2.3
 *     HAVE_GTK_EXPANDER_GET_USE_MARKUP for gtk 2.3.1
 *     HAVE_GTK_MENU_SHELL_CANCEL for gtk 2.3.2
 *     HAVE_GTK_COMBO_BOX_POPUP for gtk 2.3.4
 *     HAVE_GTK_COMBO_BOX_ENTRY_NEW_TEXT for gtk 2.3.5
 *     HAVE_GBOOLEAN_GTK_FILE_CHOOSER_SET_FILENAME for gtk 2.3.6
 *     HAVE_GTK_ABOUT_DIALOG_NEW for gtk 2.5.0
 *     HAVE_GTK_LABEL_SET_ELLIPSIZE for gtk 2.5.1
 *     HAVE_GTK_FILE_CHOOSER_BUTTON_NEW for gtk 2.5.2
 *     HAVE_GTK_MENU_TOOL_BUTTON_NEW for gtk 2.5.3 and 2.5.4
 *     HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE for gtk 2.5.5
 *     HAVE_GDK_PANGO_RENDERER_NEW for gtk 2.5.6
 *     HAVE_GTK_TEXT_LAYOUT_GET_ITER_AT_POSITION for gtk 2.6.0
 *
 * reference args initial values are usually ignored, resultant values are returned in a list.
 * null ptrs are passed and returned as #f, trailing "user_data" callback function arguments are optional (default: #f).
 * where supported, "..." args are passed as a list, trailing NULL or -1 should be omitted.
 * 'xg is added to *features*
 *
 * added funcs:
 *    (xg-version) -> date string.
 *    (->string val) interprets 'val' as a string.
 *    (c-array->list arr len) derefs each member of arr, returning lisp list, len=#f: null terminated array
 *    (list->c-array lst ctype) packages each member of list as c-type "type" returning (wrapped) c array
 *    (make-target-entry lst) returns a GtkTargetEntry table, each member of 'lst' should be (list target flags info)
 *    (GdkColor #:optional pixel red green blue) -> GdkColor struct
 *    (GdkCursor #:optional type ref_count) -> GdkCursor struct
 *    (GdkPoint #:optional x y) -> GdkPoint struct
 *    (GdkRectangle #:optional x y width height) -> GdkRectangle struct
 *    (GtkStockItem) -> GtkStockItem struct
 *    (GtkTextIter) -> GtkTextIter struct
 *    (GtkTreeIter) -> GtkTreeIter struct
 *    (GtkRequisition #:optional width height) -> GtkRequisition struct
 *    (PangoColor) -> PangoColor struct
 *    (PangoRectangle) -> PangoRectangle struct
 *    (PangoLogAttr) -> PangoLogAttr struct
 *
 * omitted functions and macros:
 *     anything with a va_list or GtkArg* argument.
 *     most of the unusual keysym names
 *     all *_CLASS, *_IFACE macros
 *     win32-specific functions
 *
 * HISTORY:
 *     21-Feb:    changed libxm to libxg, xm-version to xg-version.
 *     10-Jan:    plugged some memory leaks.
 *     4-Jan:     removed deprecated XEN_VECTOR_ELEMENTS.
 *     --------
 *     30-Dec:    gtk 2.6.0 changes.
 *     8-Dec:     added some g_log handler funcs.
 *     6-Dec:     added check for lost callback context.
 *                tightened type (pointer) checking considerably (#f only acceptable if explicit @ used in xgdata.scm).
 *                gtk 2.5.6 and pango 1.7.0 changes.
 *     3-Dec:     changed GPOINTER cast func to accept non-lists.
 *     15-Nov:    gtk 2.5.5 changes.
 *     29-Oct:    gtk 2.5.4 changes.
 *     27-Aug:    gtk 2.5.2 changes. removed the PANGO_ENGINE and PANGO_BACKEND stuff.
 *     5-Aug:     gtk 2.5.1 changes.
 *     21-Jul:    gtk 2.5.0 changes.
 *     2-Jun:     gdk_atom_name needs to free return value
 *     28-May:    GtkFileSelection struct support put back in -- need ok_button et al.
 *     14-Apr:    make-target-entry.
 *     4-Apr:     various additions, deletions, and bugfixes for snd-test 26
 *     29-Mar:    support for some ... args.
 *     22-Mar:    g_source_remove and related changes.
 *     11-Mar:    gtk 2.3.6 changes.
 *     4-Mar:     gtk 2.3.5 changes.
 *     26-Feb:    gtk 3.2.4 changes.
 *     12-Feb:    g_list_nth_data (Kjetil S. Matheussen).
 *     6-Feb:     gtk 2.3.2 changes.
 *     --------
 *     16-Dec:    gtk 2.3.1 changes.
 *     1-Dec:     gtk 2.3 changes.
 *     15-Sep:    removed client_window GtkIMMulticontext struct field (for Gtk 2.2.4).
 *     26-May:    removed nugatory GdkInputFunction stuff and some unused type converters.
 *     7-Apr:     GTK_RC_STYLE has two incompatible definitions in gtk! (gtkwidget.h, gtkrc.h) -- will use int case.
 *     1-Apr:     gdk_property_get uses scm_mem2string in some cases now.
 *     31-Mar:    gchar* -> xen string bugfix (thanks to Friedrich Delgado Friedrichs).
 *     10-Mar:    Ruby Xm_Version.
 *     6-Jan:     gtk 2.2 changes.
 *     --------
 *     18-Nov:    Ruby/Gtk bugfixes.
 *     28-Oct:    gtk 2.1 additions.
 *     25-Oct:    removed (deprecated) gdk_set_pointer_hooks
 *     31-Jul:    removed GTK 1.n support
 *     24-Jul:    changed Guile prefix (R5RS reserves vertical-bar).
 *     19-Jul:    XG_FIELD_PRE for change from using vertical-bar (reserved in R5RS)
 *     2-Jun:     removed deprecated and broken stuff
 *     4-Apr:     minor changes for Gtk 2.0.2
 *     13-Mar:    Gtk 2.0.0
 *     12-Mar:    support for GtkDestroyNotify callbacks
 *     27-Feb:    remove gtk_tree_view_column_cell_render, gtk_tree_view_column_cell_focus, 
 *                  gtk_tree_view_column_cell_draw_focus and gtk_tree_view_column_cell_set_dirty (privatized in 1.3.15)
 *                add (on HAVE-* switches) gtk_file_selection_get_selections, gtk_file_selection_set_select_multiple
 *                  and gtk_file_selection_get_select_multiple (new functions in 1.3.15)
 *                  also gtk_tree_path_new_first void and gtk_tree_model_get_iter_first (new names in 1.3.15)
 *     26-Feb:    Gtk 1.2.10 support, also 1.3.15
 *     25-Feb:    dialog example in libxm.html
 *                Ruby support via xg-ruby.c
 *     21-Feb:    #f=NULL throughout, gdk-pixbuf, GTypes.
 *     11-Feb-02: initial version.
 */

#include <config.h>

#if UNDEF_USE_SND
  #undef USE_SND
  #define USE_SND 0
#endif

#include <glib.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <string.h>
#include <stdlib.h>

#if USE_SND
  /* USE_SND causes xm to use Snd's error handlers which are much smarter than xen's fallback versions */
  #include "snd.h"
#else
  #include "xen.h"
#endif
#ifndef CALLOC
  #define CALLOC(a, b)  calloc((size_t)(a), (size_t)(b))
  #define FREE(a)       free(a)
#endif

/* -------------------------------- smob for GC -------------------------------- */
static XEN_OBJECT_TYPE xm_obj_tag;
#if HAVE_GUILE
static size_t xm_obj_free(XEN obj)
{
  void *val;
  val = (void *)XEN_OBJECT_REF(obj);
  FREE(val);
  return(0);
}
#endif
#if HAVE_RUBY
static void *xm_obj_free(XEN obj)
{
  FREE((void *)obj);
  return(NULL);
}
#endif
static XEN make_xm_obj(void *ptr)
{
  XEN_MAKE_AND_RETURN_OBJECT(xm_obj_tag, ptr, 0, xm_obj_free);
}
static void define_xm_obj(void)
{
  xm_obj_tag = XEN_MAKE_OBJECT_TYPE("XmObj", sizeof(void *));
#if HAVE_GUILE
  scm_set_smob_free(xm_obj_tag, xm_obj_free);
#endif
}  

/* prefix for all names */
#if HAVE_GUILE
  #define XG_PRE ""
  #define XG_FIELD_PRE "."
  #define XG_POST ""
#else
/* for Ruby, XG PRE needs to be uppercase */
  #define XG_PRE "R"
  #define XG_POST ""
  #define XG_FIELD_PRE "R"
#endif

#define WRAP_FOR_XEN(Name, Value) XEN_LIST_2(C_STRING_TO_XEN_SYMBOL(Name), C_TO_XEN_ULONG((unsigned long)Value))
#define WRAP_P(Name, Value) (XEN_LIST_P(Value) && \
                            (XEN_LIST_LENGTH(Value) >= 2) && \
                            (XEN_SYMBOL_P(XEN_CAR(Value))) && \
                            (strcmp(Name, XEN_SYMBOL_TO_C_STRING(XEN_CAR(Value))) == 0))

#define XM_TYPE(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {return(WRAP_FOR_XEN(#Name, val));} \
  static XType XEN_TO_C_ ## Name (XEN val) {return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \
  static bool XEN_ ## Name ## _P(XEN val) {return(WRAP_P(#Name, val));}

#define XM_TYPE_1(Name, XType) \
  static XType XEN_TO_C_ ## Name (XEN val) {return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \
  static bool XEN_ ## Name ## _P(XEN val) {return(WRAP_P(#Name, val));}

#define XM_TYPE_NO_P(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {return(WRAP_FOR_XEN(#Name, val));} \
  static XType XEN_TO_C_ ## Name (XEN val) {return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \

#define XM_TYPE_NO_P_2(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {return(WRAP_FOR_XEN(#Name, val));}

#define XM_TYPE_PTR(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {if (val) return(WRAP_FOR_XEN(#Name, val)); return(XEN_FALSE);} \
  static XType XEN_TO_C_ ## Name (XEN val) {if (XEN_FALSE_P(val)) return(NULL); return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \
  static bool XEN_ ## Name ## _P(XEN val) {return(WRAP_P(#Name, val));}

#define XM_TYPE_PTR_NO_P(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {if (val) return(WRAP_FOR_XEN(#Name, val)); return(XEN_FALSE);} \
  static XType XEN_TO_C_ ## Name (XEN val) {if (XEN_FALSE_P(val)) return(NULL); return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \

#define XM_TYPE_PTR_1(Name, XType) \
  static XType XEN_TO_C_ ## Name (XEN val) {if (XEN_FALSE_P(val)) return(NULL); return((XType)XEN_TO_C_ULONG(XEN_CADR(val)));} \
  static bool XEN_ ## Name ## _P(XEN val) {return(WRAP_P(#Name, val));}

#define XM_TYPE_PTR_2(Name, XType) \
  static XEN C_TO_XEN_ ## Name (XType val) {if (val) return(WRAP_FOR_XEN(#Name, val)); return(XEN_FALSE);} \

/* type checks for callback wrappers */
#define XEN_lambda2_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_lambda3_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkCallback_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_GSourceFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 1)))
#define XEN_GtkDestroyNotify_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 1)))
#define XEN_GdkFilterFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GdkEventFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_GtkFunction_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 1)))
#define XEN_GtkKeySnoopFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkMenuPositionFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkTextTagTableForeach_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_GtkAccelMapForeach_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkTreeModelForeachFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#define XEN_GtkTreeSelectionForeachFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#define XEN_GtkClipboardReceivedFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkClipboardTextReceivedFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkClipboardTargetsReceivedFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#define XEN_GtkTextCharPredicate_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_GtkTreeViewColumnDropFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkTreeViewMappingFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkTreeViewSearchEqualFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkTreeCellDataFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkTreeIterCompareFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#define XEN_GtkTreeSelectionFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 5)))
#define XEN_GtkClipboardGetFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#define XEN_GtkClipboardClearFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
#define XEN_GtkFileFilterFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 2)))
#define XEN_GtkEntryCompletionMatchFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
#define XEN_GtkTreeViewRowSeparatorFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GtkIconViewForeachFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
#define XEN_GtkClipboardImageReceivedFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_GLogFunc_P(Arg)  XEN_FALSE_P(Arg) || (XEN_PROCEDURE_P(Arg) && (XEN_REQUIRED_ARGS_OK(Arg, 4)))
#endif

#define XEN_lambda_P(Arg) XEN_PROCEDURE_P(Arg)
#define XEN_GCallback_P(Arg) XEN_PROCEDURE_P(Arg) && ((XEN_REQUIRED_ARGS_OK(Arg, 2)) || (XEN_REQUIRED_ARGS_OK(Arg, 3)))
#define XEN_TO_C_lambda2(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_child_func
#define XEN_TO_C_lambda3(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_find_func
#define XEN_TO_C_GtkCallback(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_func2
#define XEN_TO_C_GSourceFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_timer_func
#define XEN_TO_C_GtkDestroyNotify(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_destroy_func
#define XEN_TO_C_GdkFilterFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_filter_func
#define XEN_TO_C_GdkEventFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_event_func
#define XEN_TO_C_GtkFunction(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_func1
#define XEN_TO_C_GtkKeySnoopFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_snoop_func
#define XEN_TO_C_GtkMenuPositionFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_menu_position_func
#define XEN_TO_C_GtkTextTagTableForeach(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_text_tag_table_foreach
#define XEN_TO_C_GtkAccelMapForeach(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_accel_map_foreach
#define XEN_TO_C_GtkTreeModelForeachFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_model_func
#define XEN_TO_C_GtkTreeSelectionForeachFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_tree_selection_func
#define XEN_TO_C_GtkClipboardReceivedFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_received
#define XEN_TO_C_GtkClipboardTextReceivedFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_text_received
#define XEN_TO_C_GtkClipboardTargetsReceivedFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_targets_received
#define XEN_TO_C_GtkTextCharPredicate(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_text_char_predicate
#define XEN_TO_C_GtkTreeViewColumnDropFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_tree_column
#define XEN_TO_C_GtkTreeViewMappingFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_tree_mapping
#define XEN_TO_C_GtkTreeViewSearchEqualFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_tree_search
#define XEN_TO_C_GtkTreeCellDataFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_cell_data
#define XEN_TO_C_GtkTreeIterCompareFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_iter_compare
#define XEN_TO_C_GtkTreeSelectionFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_tree_selection
#define XEN_TO_C_GtkClipboardGetFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_get
#define XEN_TO_C_GtkClipboardClearFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_clear
#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
#define XEN_TO_C_GtkFileFilterFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_file_filter
#define XEN_TO_C_GtkEntryCompletionMatchFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_entry_completion_match
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
#define XEN_TO_C_GtkTreeViewRowSeparatorFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_row_separator
#define XEN_TO_C_GtkIconViewForeachFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_icon_view_foreach
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
#define XEN_TO_C_GtkClipboardImageReceivedFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_clip_image_received
#define XEN_TO_C_GLogFunc(Arg) XEN_FALSE_P(Arg) ? NULL : gxg_g_message_log_func
#endif

#define XEN_TO_C_GCallback(Arg) ((XEN_REQUIRED_ARGS_OK(Arg, 3)) ? (GCallback)gxg_func3 : (GCallback)gxg_func2)
#define XEN_TO_C_lambda_data(Arg) (gpointer)gxg_ptr
#define XEN_lambda_data_P(Arg) 1
#define C_TO_XEN_GtkTreeViewSearchEqualFunc(Arg) WRAP_FOR_XEN("GtkTreeViewSearchEqualFunc", Arg)
#define C_TO_XEN_GtkTreeIterCompareFunc(Arg) WRAP_FOR_XEN("GtkTreeViewSearchEqualFunc", Arg)
#define C_TO_XEN_GtkTreeSelectionFunc(Arg) WRAP_FOR_XEN("GtkTreeSelectionFunc", Arg)
#define C_TO_XEN_GtkMenuPositionFunc(Arg) WRAP_FOR_XEN("GtkMenuPositionFunc", Arg)
#define C_TO_XEN_GtkDestroyNotify(Arg) WRAP_FOR_XEN("GtkDestroyNotify", Arg)
#define XEN_TO_C_GdkFilterReturn(Arg) (GdkFilterReturn)XEN_TO_C_INT(Arg)
#define XEN_TO_C_String(Arg) ((XEN_STRING_P(Arg)) ? XEN_TO_C_STRING(Arg) : NULL)
#define C_TO_XEN_String(Arg) ((Arg != NULL) ? C_TO_XEN_STRING(Arg) : XEN_FALSE)
#define XEN_String_P(Arg) ((XEN_FALSE_P(Arg)) || (XEN_STRING_P(Arg)))


/* ---------------------------------------- types ---------------------------------------- */

XM_TYPE_PTR(GdkWindow_, GdkWindow*)
XM_TYPE_PTR(GtkAccelKey_, GtkAccelKey*)
XM_TYPE_PTR(GClosure_, GClosure*)
XM_TYPE_PTR(GtkWidget_, GtkWidget*)
XM_TYPE_PTR_2(GdkXEvent_, GdkXEvent*)
XM_TYPE_PTR(GdkEvent_, GdkEvent*)
XM_TYPE_PTR(GdkEventKey_, GdkEventKey*)
XM_TYPE_PTR(GtkMenu_, GtkMenu*)
XM_TYPE_PTR(gint_, gint*)
XM_TYPE_PTR(gboolean_, gboolean*)
XM_TYPE_PTR(GtkTextTag_, GtkTextTag*)
#define C_TO_XEN_gchar_(Arg) C_TO_XEN_String(Arg)
#define XEN_TO_C_gchar_(Arg) (gchar*)(XEN_TO_C_String(Arg))
#define XEN_gchar__P(Arg) XEN_String_P(Arg)
#define C_TO_XEN_guint(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_guint(Arg) (guint)(XEN_TO_C_ULONG(Arg))
#define XEN_guint_P(Arg) XEN_ULONG_P(Arg)
#define C_TO_XEN_GdkModifierType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkModifierType(Arg) (GdkModifierType)(XEN_TO_C_INT(Arg))
#define XEN_GdkModifierType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_gboolean(Arg) C_TO_XEN_BOOLEAN(Arg)
#define XEN_TO_C_gboolean(Arg) (gboolean)(XEN_TO_C_BOOLEAN(Arg))
#define XEN_gboolean_P(Arg) XEN_BOOLEAN_P(Arg)
XM_TYPE_PTR(GtkTreeModel_, GtkTreeModel*)
XM_TYPE_PTR(GtkTreePath_, GtkTreePath*)
XM_TYPE_PTR(GtkTreeIter_, GtkTreeIter*)
XM_TYPE_PTR(GtkClipboard_, GtkClipboard*)
XM_TYPE_PTR(GtkSelectionData_, GtkSelectionData*)
XM_TYPE_PTR_2(GdkAtom_, GdkAtom*)
#define C_TO_XEN_gint(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_gint(Arg) (gint)(XEN_TO_C_INT(Arg))
#define XEN_gint_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_gunichar(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_gunichar(Arg) (gunichar)(XEN_TO_C_ULONG(Arg))
#define XEN_gunichar_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE_PTR(GtkTreeView_, GtkTreeView*)
XM_TYPE_PTR(GtkTreeViewColumn_, GtkTreeViewColumn*)
XM_TYPE_PTR(GtkCellRenderer_, GtkCellRenderer*)
XM_TYPE_PTR(GtkTreeSelection_, GtkTreeSelection*)
XM_TYPE_PTR(GdkPixbuf_, GdkPixbuf*)
#define C_TO_XEN_GLogLevelFlags(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GLogLevelFlags(Arg) (GLogLevelFlags)(XEN_TO_C_INT(Arg))
#define XEN_GLogLevelFlags_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GType(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_GType(Arg) (GType)(XEN_TO_C_ULONG(Arg))
#define XEN_GType_P(Arg) XEN_ULONG_P(Arg)
#define C_TO_XEN_GQuark(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_GQuark(Arg) (GQuark)(XEN_TO_C_ULONG(Arg))
#define XEN_GQuark_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE_PTR_1(GClosureNotify, GClosureNotify)
#define XEN_TO_C_GSignalFlags(Arg) (GSignalFlags)(XEN_TO_C_INT(Arg))
#define XEN_GSignalFlags_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_1(GSignalAccumulator, GSignalAccumulator)
XM_TYPE_PTR(gpointer, gpointer)
XM_TYPE_1(GSignalCMarshaller, GSignalCMarshaller)
XM_TYPE_PTR_1(GType_, GType*)
XM_TYPE_PTR_1(GSignalQuery_, GSignalQuery*)
XM_TYPE_PTR(guint_, guint*)
XM_TYPE_PTR_2(GSignalInvocationHint_, GSignalInvocationHint*)
#define C_TO_XEN_gulong(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_gulong(Arg) (gulong)(XEN_TO_C_ULONG(Arg))
#define XEN_gulong_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE_1(GSignalEmissionHook, GSignalEmissionHook)
#define XEN_TO_C_GConnectFlags(Arg) (GConnectFlags)(XEN_TO_C_INT(Arg))
#define XEN_GConnectFlags_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GSignalMatchType(Arg) (GSignalMatchType)(XEN_TO_C_INT(Arg))
#define XEN_GSignalMatchType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkColormap_, GdkColormap*)
XM_TYPE_PTR(GdkVisual_, GdkVisual*)
XM_TYPE_PTR(GdkColor_, GdkColor*)
XM_TYPE_PTR(GdkCursor_, GdkCursor*)
#define C_TO_XEN_GdkCursorType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkCursorType(Arg) (GdkCursorType)(XEN_TO_C_INT(Arg))
#define XEN_GdkCursorType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkPixmap_, GdkPixmap*)
XM_TYPE_PTR(GdkDragContext_, GdkDragContext*)
#define C_TO_XEN_GdkDragAction(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkDragAction(Arg) (GdkDragAction)(XEN_TO_C_INT(Arg))
#define XEN_GdkDragAction_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_guint32(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_guint32(Arg) (guint32)(XEN_TO_C_ULONG(Arg))
#define XEN_guint32_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE(GdkAtom, GdkAtom)
XM_TYPE_PTR(GList_, GList*)
#define C_TO_XEN_GdkDragProtocol(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkDragProtocol(Arg) (GdkDragProtocol)(XEN_TO_C_INT(Arg))
#define XEN_GdkDragProtocol_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkDrawable_, GdkDrawable*)
XM_TYPE_PTR(GdkGC_, GdkGC*)
XM_TYPE_PTR(GdkPoint_, GdkPoint*)
XM_TYPE_PTR(GdkImage_, GdkImage*)
XM_TYPE_PTR_1(GdkSegment_, GdkSegment*)
XM_TYPE_PTR(PangoFont_, PangoFont*)
XM_TYPE_PTR(PangoGlyphString_, PangoGlyphString*)
XM_TYPE_PTR(PangoLayoutLine_, PangoLayoutLine*)
XM_TYPE_PTR(PangoLayout_, PangoLayout*)
XM_TYPE_PTR(GdkRegion_, GdkRegion*)
#define C_TO_XEN_gdouble(Arg) C_TO_XEN_DOUBLE(Arg)
#define XEN_TO_C_gdouble(Arg) (gdouble)(XEN_TO_C_DOUBLE(Arg))
#define XEN_gdouble_P(Arg) XEN_NUMBER_P(Arg)
#define XEN_TO_C_GdkAxisUse(Arg) (GdkAxisUse)(XEN_TO_C_INT(Arg))
#define XEN_GdkAxisUse_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GdkGCValues_, GdkGCValues*)
#define XEN_TO_C_GdkGCValuesMask(Arg) (GdkGCValuesMask)(XEN_TO_C_INT(Arg))
#define XEN_GdkGCValuesMask_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkFunction(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkFunction(Arg) (GdkFunction)(XEN_TO_C_INT(Arg))
#define XEN_GdkFunction_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkFill(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkFill(Arg) (GdkFill)(XEN_TO_C_INT(Arg))
#define XEN_GdkFill_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkBitmap_, GdkBitmap*)
XM_TYPE_PTR(GdkRectangle_, GdkRectangle*)
#define C_TO_XEN_GdkSubwindowMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkSubwindowMode(Arg) (GdkSubwindowMode)(XEN_TO_C_INT(Arg))
#define XEN_GdkSubwindowMode_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkLineStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkLineStyle(Arg) (GdkLineStyle)(XEN_TO_C_INT(Arg))
#define XEN_GdkLineStyle_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkCapStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkCapStyle(Arg) (GdkCapStyle)(XEN_TO_C_INT(Arg))
#define XEN_GdkCapStyle_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkJoinStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkJoinStyle(Arg) (GdkJoinStyle)(XEN_TO_C_INT(Arg))
#define XEN_GdkJoinStyle_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(gint8_, gint8*)
XM_TYPE_PTR(gchar__, gchar**)
#define C_TO_XEN_char_(Arg) C_TO_XEN_String(Arg)
#define XEN_TO_C_char_(Arg) (char*)(XEN_TO_C_String(Arg))
#define XEN_char__P(Arg) XEN_String_P(Arg)
#define C_TO_XEN_GdkGrabStatus(Arg) C_TO_XEN_INT(Arg)
#define C_TO_XEN_GdkEventMask(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkEventMask(Arg) (GdkEventMask)(XEN_TO_C_INT(Arg))
#define XEN_GdkEventMask_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkImageType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkImageType(Arg) (GdkImageType)(XEN_TO_C_INT(Arg))
#define XEN_GdkImageType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkDevice_, GdkDevice*)
#define C_TO_XEN_GdkInputSource(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkInputSource(Arg) (GdkInputSource)(XEN_TO_C_INT(Arg))
#define XEN_GdkInputSource_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkInputMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkInputMode(Arg) (GdkInputMode)(XEN_TO_C_INT(Arg))
#define XEN_GdkInputMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(gdouble_, gdouble*)
XM_TYPE_PTR(GdkTimeCoord__, GdkTimeCoord**)
#define C_TO_XEN_GdkExtensionMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkExtensionMode(Arg) (GdkExtensionMode)(XEN_TO_C_INT(Arg))
#define XEN_GdkExtensionMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkKeymap_, GdkKeymap*)
XM_TYPE_PTR(GdkKeymapKey_, GdkKeymapKey*)
#define C_TO_XEN_PangoDirection(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoDirection(Arg) (PangoDirection)(XEN_TO_C_INT(Arg))
#define XEN_PangoDirection_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(PangoContext_, PangoContext*)
XM_TYPE_PTR(PangoAttribute_, PangoAttribute*)
#define C_TO_XEN_int(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_int(Arg) (int)(XEN_TO_C_INT(Arg))
#define XEN_int_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkNativeWindow(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_GdkNativeWindow(Arg) (GdkNativeWindow)(XEN_TO_C_ULONG(Arg))
#define XEN_GdkNativeWindow_P(Arg) XEN_ULONG_P(Arg)
#define C_TO_XEN_guchar_(Arg) C_TO_XEN_String(Arg)
#define XEN_TO_C_guchar_(Arg) (guchar*)(XEN_TO_C_String(Arg))
#define XEN_guchar__P(Arg) XEN_String_P(Arg)
#define XEN_TO_C_GdkPropMode(Arg) (GdkPropMode)(XEN_TO_C_INT(Arg))
#define XEN_GdkPropMode_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GdkFillRule(Arg) (GdkFillRule)(XEN_TO_C_INT(Arg))
#define XEN_GdkFillRule_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkOverlapType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkRgbDither(Arg) (GdkRgbDither)(XEN_TO_C_INT(Arg))
#define XEN_GdkRgbDither_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GdkRgbCmap_, GdkRgbCmap*)
XM_TYPE_PTR(guint32_, guint32*)
#define C_TO_XEN_GdkVisualType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkVisualType(Arg) (GdkVisualType)(XEN_TO_C_INT(Arg))
#define XEN_GdkVisualType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_2(GdkVisualType_, GdkVisualType*)
XM_TYPE_PTR_1(GdkWindowAttr_, GdkWindowAttr*)
#define C_TO_XEN_GdkWindowType(Arg) C_TO_XEN_INT(Arg)
#define C_TO_XEN_GdkWindowState(Arg) C_TO_XEN_INT(Arg)
#define C_TO_XEN_GdkWMDecoration(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkWMDecoration(Arg) (GdkWMDecoration)(XEN_TO_C_INT(Arg))
#define XEN_GdkWMDecoration_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GdkWMFunction(Arg) (GdkWMFunction)(XEN_TO_C_INT(Arg))
#define XEN_GdkWMFunction_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GdkWindowEdge(Arg) (GdkWindowEdge)(XEN_TO_C_INT(Arg))
#define XEN_GdkWindowEdge_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GdkGeometry_, GdkGeometry*)
XM_TYPE_PTR(GtkWindow_, GtkWindow*)
#define C_TO_XEN_GdkWindowTypeHint(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkWindowTypeHint(Arg) (GdkWindowTypeHint)(XEN_TO_C_INT(Arg))
#define XEN_GdkWindowTypeHint_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GdkWindowHints(Arg) (GdkWindowHints)(XEN_TO_C_INT(Arg))
#define XEN_GdkWindowHints_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE(GdkColorspace, GdkColorspace)
XM_TYPE_PTR_2(GError_, GError*)
XM_TYPE_1(GdkPixbufDestroyNotify, GdkPixbufDestroyNotify)
XM_TYPE_PTR(char__, char**)
XM_TYPE_PTR_1(guint8_, guint8*)
#define C_TO_XEN_guchar(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_guchar(Arg) (guchar)(XEN_TO_C_INT(Arg))
#define XEN_guchar_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_gfloat(Arg) C_TO_XEN_DOUBLE(Arg)
#define XEN_TO_C_gfloat(Arg) (gfloat)(XEN_TO_C_DOUBLE(Arg))
#define XEN_gfloat_P(Arg) XEN_NUMBER_P(Arg)
#define XEN_TO_C_double(Arg) (double)(XEN_TO_C_DOUBLE(Arg))
#define XEN_double_P(Arg) XEN_NUMBER_P(Arg)
XM_TYPE_1(GdkInterpType, GdkInterpType)
XM_TYPE_PTR(GdkPixbufAnimation_, GdkPixbufAnimation*)
XM_TYPE_PTR(GdkPixbufAnimationIter_, GdkPixbufAnimationIter*)
XM_TYPE_PTR_1(GTimeVal_, GTimeVal*)
XM_TYPE_PTR(GdkPixbufLoader_, GdkPixbufLoader*)
#define XEN_TO_C_gsize(Arg) (gsize)(XEN_TO_C_INT(Arg))
#define XEN_gsize_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkType(Arg) C_TO_XEN_ULONG(Arg)
#define XEN_TO_C_GtkType(Arg) (GtkType)(XEN_TO_C_ULONG(Arg))
#define XEN_GtkType_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE_PTR(GtkAccelGroup_, GtkAccelGroup*)
#define XEN_TO_C_GtkAccelFlags(Arg) (GtkAccelFlags)(XEN_TO_C_INT(Arg))
#define XEN_GtkAccelFlags_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GObject_, GObject*)
XM_TYPE_PTR(GSList_, GSList*)
XM_TYPE_PTR_2(GtkAccelGroupEntry_, GtkAccelGroupEntry*)
XM_TYPE_PTR_1(GtkAccelLabel_, GtkAccelLabel*)
XM_TYPE_PTR(GScanner_, GScanner*)
XM_TYPE_PTR_1(GtkAccessible_, GtkAccessible*)
XM_TYPE_PTR(GtkObject_, GtkObject*)
XM_TYPE_PTR(GtkAdjustment_, GtkAdjustment*)
XM_TYPE_PTR_1(GtkAlignment_, GtkAlignment*)
#define XEN_TO_C_GtkArrowType(Arg) (GtkArrowType)(XEN_TO_C_INT(Arg))
#define XEN_GtkArrowType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkShadowType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkShadowType(Arg) (GtkShadowType)(XEN_TO_C_INT(Arg))
#define XEN_GtkShadowType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkArrow_, GtkArrow*)
XM_TYPE_PTR_1(GtkAspectFrame_, GtkAspectFrame*)
#define C_TO_XEN_GtkButtonBoxStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkButtonBoxStyle(Arg) (GtkButtonBoxStyle)(XEN_TO_C_INT(Arg))
#define XEN_GtkButtonBoxStyle_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkButtonBox_, GtkButtonBox*)
XM_TYPE_PTR(GtkBindingSet_, GtkBindingSet*)
#define XEN_TO_C_GtkPathType(Arg) (GtkPathType)(XEN_TO_C_INT(Arg))
#define XEN_GtkPathType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkPathPriorityType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkPathPriorityType(Arg) (GtkPathPriorityType)(XEN_TO_C_INT(Arg))
#define XEN_GtkPathPriorityType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkBin_, GtkBin*)
XM_TYPE_PTR_1(GtkBox_, GtkBox*)
#define C_TO_XEN_GtkPackType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkPackType(Arg) (GtkPackType)(XEN_TO_C_INT(Arg))
#define XEN_GtkPackType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkButton_, GtkButton*)
#define C_TO_XEN_GtkReliefStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkReliefStyle(Arg) (GtkReliefStyle)(XEN_TO_C_INT(Arg))
#define XEN_GtkReliefStyle_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkCalendar_, GtkCalendar*)
XM_TYPE_PTR(GtkCellEditable_, GtkCellEditable*)
#define XEN_TO_C_GtkCellRendererState(Arg) (GtkCellRendererState)(XEN_TO_C_INT(Arg))
#define XEN_GtkCellRendererState_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkCellRendererText_, GtkCellRendererText*)
XM_TYPE_PTR_1(GtkCellRendererToggle_, GtkCellRendererToggle*)
XM_TYPE_PTR_1(GtkCheckMenuItem_, GtkCheckMenuItem*)
XM_TYPE_PTR(GtkTargetEntry_, GtkTargetEntry*)
XM_TYPE_PTR_1(GtkColorSelection_, GtkColorSelection*)
#define C_TO_XEN_guint16(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_guint16(Arg) (guint16)(XEN_TO_C_INT(Arg))
#define XEN_guint16_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkContainer_, GtkContainer*)
#define C_TO_XEN_GtkResizeMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkResizeMode(Arg) (GtkResizeMode)(XEN_TO_C_INT(Arg))
#define XEN_GtkResizeMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkCurve_, GtkCurve*)
XM_TYPE_PTR_1(gfloat_, gfloat*)
#define XEN_TO_C_GtkCurveType(Arg) (GtkCurveType)(XEN_TO_C_INT(Arg))
#define XEN_GtkCurveType_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GtkDialogFlags(Arg) (GtkDialogFlags)(XEN_TO_C_INT(Arg))
#define XEN_GtkDialogFlags_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_etc_P(Arg) (XEN_LIST_P(Arg))
XM_TYPE_PTR_1(GtkDialog_, GtkDialog*)
#define XEN_TO_C_GtkDestDefaults(Arg) (GtkDestDefaults)(XEN_TO_C_INT(Arg))
#define XEN_GtkDestDefaults_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkTargetList_, GtkTargetList*)
XM_TYPE_PTR_1(GtkEditable_, GtkEditable*)
XM_TYPE_PTR_1(GtkEntry_, GtkEntry*)
XM_TYPE_PTR_1(GtkFileSelection_, GtkFileSelection*)
XM_TYPE_PTR_1(GtkFixed_, GtkFixed*)
XM_TYPE_PTR_1(GtkFontSelection_, GtkFontSelection*)
XM_TYPE_PTR_1(GtkFontSelectionDialog_, GtkFontSelectionDialog*)
XM_TYPE_PTR_1(GtkFrame_, GtkFrame*)
XM_TYPE_PTR_1(GtkHandleBox_, GtkHandleBox*)
#define C_TO_XEN_GtkPositionType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkPositionType(Arg) (GtkPositionType)(XEN_TO_C_INT(Arg))
#define XEN_GtkPositionType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkIconFactory_, GtkIconFactory*)
XM_TYPE_PTR(GtkIconSet_, GtkIconSet*)
#define C_TO_XEN_GtkIconSize(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkIconSize(Arg) (GtkIconSize)(XEN_TO_C_INT(Arg))
#define XEN_GtkIconSize_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkStyle_, GtkStyle*)
#define C_TO_XEN_GtkTextDirection(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkTextDirection(Arg) (GtkTextDirection)(XEN_TO_C_INT(Arg))
#define XEN_GtkTextDirection_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkStateType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkStateType(Arg) (GtkStateType)(XEN_TO_C_INT(Arg))
#define XEN_GtkStateType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkIconSource_, GtkIconSource*)
XM_TYPE_PTR_2(GtkIconSize_, GtkIconSize*)
XM_TYPE_PTR_1(GtkImage_, GtkImage*)
#define C_TO_XEN_GtkImageType(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GtkImageMenuItem_, GtkImageMenuItem*)
XM_TYPE_PTR(GtkIMContext_, GtkIMContext*)
XM_TYPE_PTR(PangoAttrList_, PangoAttrList*)
XM_TYPE_PTR_1(GtkIMContextSimple_, GtkIMContextSimple*)
XM_TYPE_PTR_1(guint16_, guint16*)
XM_TYPE_PTR_1(GtkIMMulticontext_, GtkIMMulticontext*)
XM_TYPE_PTR_1(GtkMenuShell_, GtkMenuShell*)
XM_TYPE_PTR_1(GtkItem_, GtkItem*)
XM_TYPE_PTR_1(GtkLabel_, GtkLabel*)
#define C_TO_XEN_GtkJustification(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkJustification(Arg) (GtkJustification)(XEN_TO_C_INT(Arg))
#define XEN_GtkJustification_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkLayout_, GtkLayout*)
XM_TYPE_PTR(GtkListStore_, GtkListStore*)
XM_TYPE_PTR(PangoLanguage_, PangoLanguage*)
#define XEN_xen_P(Arg) ((XEN_LIST_P(Arg)) && (XEN_LIST_LENGTH(Arg) > 2))
#define XEN_TO_C_xen(Arg) ((gpointer)Arg)
XM_TYPE_PTR_1(GtkMenuItem_, GtkMenuItem*)
XM_TYPE_PTR_1(GtkMisc_, GtkMisc*)
XM_TYPE_PTR_1(GtkNotebook_, GtkNotebook*)
XM_TYPE_PTR_1(GtkPaned_, GtkPaned*)
XM_TYPE_PTR_1(GtkPlug_, GtkPlug*)
XM_TYPE_PTR_1(GtkProgressBar_, GtkProgressBar*)
#define C_TO_XEN_GtkProgressBarOrientation(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkProgressBarOrientation(Arg) (GtkProgressBarOrientation)(XEN_TO_C_INT(Arg))
#define XEN_GtkProgressBarOrientation_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkRadioButton_, GtkRadioButton*)
XM_TYPE_PTR_1(GtkRadioMenuItem_, GtkRadioMenuItem*)
XM_TYPE_PTR_1(GtkRange_, GtkRange*)
#define C_TO_XEN_GtkUpdateType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkUpdateType(Arg) (GtkUpdateType)(XEN_TO_C_INT(Arg))
#define XEN_GtkUpdateType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkRcStyle_, GtkRcStyle*)
XM_TYPE_PTR_1(GtkRuler_, GtkRuler*)
#define C_TO_XEN_GtkMetricType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkMetricType(Arg) (GtkMetricType)(XEN_TO_C_INT(Arg))
#define XEN_GtkMetricType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkScale_, GtkScale*)
XM_TYPE_PTR_1(GtkScrolledWindow_, GtkScrolledWindow*)
#define C_TO_XEN_GtkPolicyType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkPolicyType(Arg) (GtkPolicyType)(XEN_TO_C_INT(Arg))
#define XEN_GtkPolicyType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkCornerType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkCornerType(Arg) (GtkCornerType)(XEN_TO_C_INT(Arg))
#define XEN_GtkCornerType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkSizeGroup_, GtkSizeGroup*)
#define C_TO_XEN_GtkSizeGroupMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkSizeGroupMode(Arg) (GtkSizeGroupMode)(XEN_TO_C_INT(Arg))
#define XEN_GtkSizeGroupMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkSocket_, GtkSocket*)
XM_TYPE_PTR_1(GtkSpinButton_, GtkSpinButton*)
#define C_TO_XEN_GtkSpinButtonUpdatePolicy(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkSpinButtonUpdatePolicy(Arg) (GtkSpinButtonUpdatePolicy)(XEN_TO_C_INT(Arg))
#define XEN_GtkSpinButtonUpdatePolicy_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GtkSpinType(Arg) (GtkSpinType)(XEN_TO_C_INT(Arg))
#define XEN_GtkSpinType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkStatusbar_, GtkStatusbar*)
XM_TYPE_PTR(GtkStockItem_, GtkStockItem*)
#define C_TO_XEN_GtkOrientation(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkOrientation(Arg) (GtkOrientation)(XEN_TO_C_INT(Arg))
#define XEN_GtkOrientation_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GtkExpanderStyle(Arg) (GtkExpanderStyle)(XEN_TO_C_INT(Arg))
#define XEN_GtkExpanderStyle_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkBorder_, GtkBorder*)
XM_TYPE_PTR_1(GtkTable_, GtkTable*)
#define XEN_TO_C_GtkAttachOptions(Arg) (GtkAttachOptions)(XEN_TO_C_INT(Arg))
#define XEN_GtkAttachOptions_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkTextBuffer_, GtkTextBuffer*)
XM_TYPE_PTR(GtkTextTagTable_, GtkTextTagTable*)
XM_TYPE_PTR(GtkTextIter_, GtkTextIter*)
XM_TYPE_PTR(GtkTextChildAnchor_, GtkTextChildAnchor*)
XM_TYPE_PTR(GtkTextMark_, GtkTextMark*)
XM_TYPE_PTR(GtkTextAttributes_, GtkTextAttributes*)
#define XEN_TO_C_GtkTextSearchFlags(Arg) (GtkTextSearchFlags)(XEN_TO_C_INT(Arg))
#define XEN_GtkTextSearchFlags_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkTextView_, GtkTextView*)
#define C_TO_XEN_GtkTextWindowType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkTextWindowType(Arg) (GtkTextWindowType)(XEN_TO_C_INT(Arg))
#define XEN_GtkTextWindowType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkWrapMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkWrapMode(Arg) (GtkWrapMode)(XEN_TO_C_INT(Arg))
#define XEN_GtkWrapMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(PangoTabArray_, PangoTabArray*)
XM_TYPE_PTR_1(GtkToggleButton_, GtkToggleButton*)
XM_TYPE_PTR_1(GtkToolbar_, GtkToolbar*)
#define C_TO_XEN_GtkToolbarStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkToolbarStyle(Arg) (GtkToolbarStyle)(XEN_TO_C_INT(Arg))
#define XEN_GtkToolbarStyle_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkTooltips_, GtkTooltips*)
XM_TYPE_PTR_2(GtkTooltipsData_, GtkTooltipsData*)
XM_TYPE_PTR_1(GtkTreeDragSource_, GtkTreeDragSource*)
XM_TYPE_PTR_1(GtkTreeDragDest_, GtkTreeDragDest*)
XM_TYPE_PTR(GtkTreeRowReference_, GtkTreeRowReference*)
#define C_TO_XEN_GtkTreeModelFlags(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GtkTreeModelSort_, GtkTreeModelSort*)
#define C_TO_XEN_GtkSelectionMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkSelectionMode(Arg) (GtkSelectionMode)(XEN_TO_C_INT(Arg))
#define XEN_GtkSelectionMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkTreeModel__, GtkTreeModel**)
XM_TYPE_PTR_1(GtkTreeSortable_, GtkTreeSortable*)
#define C_TO_XEN_GtkSortType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkSortType(Arg) (GtkSortType)(XEN_TO_C_INT(Arg))
#define XEN_GtkSortType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(GtkTreeStore_, GtkTreeStore*)
#define C_TO_XEN_GtkTreeViewColumnSizing(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkTreeViewColumnSizing(Arg) (GtkTreeViewColumnSizing)(XEN_TO_C_INT(Arg))
#define XEN_GtkTreeViewColumnSizing_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GtkTreeViewDropPosition(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkTreeViewDropPosition(Arg) (GtkTreeViewDropPosition)(XEN_TO_C_INT(Arg))
#define XEN_GtkTreeViewDropPosition_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkViewport_, GtkViewport*)
XM_TYPE_PTR(GtkRequisition_, GtkRequisition*)
XM_TYPE_PTR_1(GtkAllocation_, GtkAllocation*)
#define XEN_TO_C_GtkDirectionType(Arg) (GtkDirectionType)(XEN_TO_C_INT(Arg))
#define XEN_GtkDirectionType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_2(AtkObject_, AtkObject*)
XM_TYPE_PTR(PangoFontDescription_, PangoFontDescription*)
#define XEN_TO_C_GtkWindowType(Arg) (GtkWindowType)(XEN_TO_C_INT(Arg))
#define XEN_GtkWindowType_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_GtkWindowPosition(Arg) (GtkWindowPosition)(XEN_TO_C_INT(Arg))
#define XEN_GtkWindowPosition_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_GdkGravity(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GdkGravity(Arg) (GdkGravity)(XEN_TO_C_INT(Arg))
#define XEN_GdkGravity_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(PangoColor_, PangoColor*)
#define C_TO_XEN_PangoAttrType(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoAttrType(Arg) (PangoAttrType)(XEN_TO_C_INT(Arg))
#define XEN_PangoAttrType_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_PangoStyle(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoStyle(Arg) (PangoStyle)(XEN_TO_C_INT(Arg))
#define XEN_PangoStyle_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_PangoWeight(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoWeight(Arg) (PangoWeight)(XEN_TO_C_INT(Arg))
#define XEN_PangoWeight_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_PangoVariant(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoVariant(Arg) (PangoVariant)(XEN_TO_C_INT(Arg))
#define XEN_PangoVariant_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_PangoStretch(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoStretch(Arg) (PangoStretch)(XEN_TO_C_INT(Arg))
#define XEN_PangoStretch_P(Arg) XEN_INTEGER_P(Arg)
#define XEN_TO_C_PangoUnderline(Arg) (PangoUnderline)(XEN_TO_C_INT(Arg))
#define XEN_PangoUnderline_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(PangoRectangle_, PangoRectangle*)
XM_TYPE_PTR(PangoAttrIterator_, PangoAttrIterator*)
XM_TYPE_PTR_1(PangoAttrList__, PangoAttrList**)
XM_TYPE_PTR_1(gunichar_, gunichar*)
XM_TYPE_PTR_1(PangoAnalysis_, PangoAnalysis*)
XM_TYPE_PTR(PangoLogAttr_, PangoLogAttr*)
XM_TYPE_PTR_2(PangoFontFamily__, PangoFontFamily**)
XM_TYPE_PTR_2(PangoFontset_, PangoFontset*)
XM_TYPE_PTR(PangoFontMetrics_, PangoFontMetrics*)
XM_TYPE_PTR(PangoCoverage_, PangoCoverage*)
#define C_TO_XEN_PangoCoverageLevel(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoCoverageLevel(Arg) (PangoCoverageLevel)(XEN_TO_C_INT(Arg))
#define XEN_PangoCoverageLevel_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(PangoFontDescription__, PangoFontDescription**)
#define C_TO_XEN_PangoFontMask(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoFontMask(Arg) (PangoFontMask)(XEN_TO_C_INT(Arg))
#define XEN_PangoFontMask_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(PangoFontFamily_, PangoFontFamily*)
XM_TYPE_PTR_2(PangoFontFace__, PangoFontFace**)
XM_TYPE_PTR(PangoFontFace_, PangoFontFace*)
#define XEN_TO_C_PangoGlyph(Arg) (PangoGlyph)(XEN_TO_C_ULONG(Arg))
#define XEN_PangoGlyph_P(Arg) XEN_ULONG_P(Arg)
XM_TYPE_PTR_1(PangoFontMap_, PangoFontMap*)
XM_TYPE_PTR(PangoItem_, PangoItem*)
#define C_TO_XEN_PangoWrapMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoWrapMode(Arg) (PangoWrapMode)(XEN_TO_C_INT(Arg))
#define XEN_PangoWrapMode_P(Arg) XEN_INTEGER_P(Arg)
#define C_TO_XEN_PangoAlignment(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoAlignment(Arg) (PangoAlignment)(XEN_TO_C_INT(Arg))
#define XEN_PangoAlignment_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR(int_, int*)
XM_TYPE_PTR(PangoLayoutIter_, PangoLayoutIter*)
XM_TYPE_PTR_2(PangoLayoutRun_, PangoLayoutRun*)
#define C_TO_XEN_GdkEventType(Arg) C_TO_XEN_INT(Arg)
#define C_TO_XEN_gint8(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_gint8(Arg) (gint8)(XEN_TO_C_INT(Arg))
XM_TYPE_PTR(GdkEventAny_, GdkEventAny*)
XM_TYPE_PTR_1(GdkEventExpose_, GdkEventExpose*)
XM_TYPE_PTR_1(GdkEventNoExpose_, GdkEventNoExpose*)
#define C_TO_XEN_GdkVisibilityState(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventVisibility_, GdkEventVisibility*)
#define C_TO_XEN_gint16(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventMotion_, GdkEventMotion*)
XM_TYPE_PTR_1(GdkEventButton_, GdkEventButton*)
#define C_TO_XEN_GdkScrollDirection(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventScroll_, GdkEventScroll*)
#define C_TO_XEN_guint8(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_guint8(Arg) (guint8)(XEN_TO_C_INT(Arg))
#define C_TO_XEN_GdkCrossingMode(Arg) C_TO_XEN_INT(Arg)
#define C_TO_XEN_GdkNotifyType(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventCrossing_, GdkEventCrossing*)
XM_TYPE_PTR_1(GdkEventFocus_, GdkEventFocus*)
XM_TYPE_PTR_1(GdkEventConfigure_, GdkEventConfigure*)
XM_TYPE_PTR_1(GdkEventProperty_, GdkEventProperty*)
XM_TYPE_PTR_1(GdkEventSelection_, GdkEventSelection*)
XM_TYPE_PTR_1(GdkEventProximity_, GdkEventProximity*)
#define C_TO_XEN_GdkSettingAction(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventSetting_, GdkEventSetting*)
XM_TYPE_PTR_1(GdkEventWindowState_, GdkEventWindowState*)
#define C_TO_XEN_gshort(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_1(GdkEventDND_, GdkEventDND*)
#define C_TO_XEN_GdkByteOrder(Arg) C_TO_XEN_INT(Arg)
XM_TYPE_PTR_2(GdkDeviceAxis_, GdkDeviceAxis*)
XM_TYPE_PTR_2(GdkDeviceKey_, GdkDeviceKey*)
XM_TYPE_PTR_1(GtkColorSelectionDialog_, GtkColorSelectionDialog*)
XM_TYPE_PTR_2(GdkGC__, GdkGC**)
XM_TYPE_PTR_2(GdkPixmap__, GdkPixmap**)
XM_TYPE_PTR_2(GArray_, GArray*)
#define XEN_TO_C_gssize(Arg) (gssize)(XEN_TO_C_INT(Arg))
#define XEN_gssize_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GValue_, GValue*)
#if HAVE_GDK_DRAW_PIXBUF
XM_TYPE_PTR(GdkDisplay_, GdkDisplay*)
XM_TYPE_PTR(GdkScreen_, GdkScreen*)
#endif

#if HAVE_GTK_TREE_VIEW_COLUMN_CELL_GET_POSITION
XM_TYPE_PTR_1(GdkBitmap__, GdkBitmap**)
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
XM_TYPE_PTR(GtkFileFilterInfo_, GtkFileFilterInfo*)
XM_TYPE_PTR(GtkEntryCompletion_, GtkEntryCompletion*)
#define C_TO_XEN_GtkCalendarDisplayOptions(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkCalendarDisplayOptions(Arg) (GtkCalendarDisplayOptions)(XEN_TO_C_INT(Arg))
#define XEN_GtkCalendarDisplayOptions_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkEventBox_, GtkEventBox*)
XM_TYPE_PTR(GtkToolItem_, GtkToolItem*)
#define C_TO_XEN_GtkFileChooserAction(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkFileChooserAction(Arg) (GtkFileChooserAction)(XEN_TO_C_INT(Arg))
#define XEN_GtkFileChooserAction_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkTreeModelFilter_, GtkTreeModelFilter*)
XM_TYPE_PTR(GtkAction_, GtkAction*)
XM_TYPE_PTR(GtkActionGroup_, GtkActionGroup*)
XM_TYPE_PTR_1(GtkActionEntry_, GtkActionEntry*)
XM_TYPE_PTR_1(GtkToggleActionEntry_, GtkToggleActionEntry*)
XM_TYPE_PTR_1(GtkComboBox_, GtkComboBox*)
XM_TYPE_PTR_1(GtkComboBoxEntry_, GtkComboBoxEntry*)
XM_TYPE_PTR_1(GtkExpander_, GtkExpander*)
XM_TYPE_PTR_1(GtkFontButton_, GtkFontButton*)
XM_TYPE_PTR_1(GtkColorButton_, GtkColorButton*)
XM_TYPE_PTR(GtkUIManager_, GtkUIManager*)
#define XEN_TO_C_GtkUIManagerItemType(Arg) (GtkUIManagerItemType)(XEN_TO_C_INT(Arg))
#define XEN_GtkUIManagerItemType_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkRadioToolButton_, GtkRadioToolButton*)
XM_TYPE_PTR(GtkRadioAction_, GtkRadioAction*)
XM_TYPE_PTR_1(GtkSeparatorToolItem_, GtkSeparatorToolItem*)
XM_TYPE_PTR(GtkToggleAction_, GtkToggleAction*)
XM_TYPE_PTR_1(GtkToggleToolButton_, GtkToggleToolButton*)
XM_TYPE_PTR(GtkFileFilter_, GtkFileFilter*)
#define C_TO_XEN_GtkFileFilterFlags(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_GtkFileFilterFlags(Arg) (GtkFileFilterFlags)(XEN_TO_C_INT(Arg))
#define XEN_GtkFileFilterFlags_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkCellLayout_, GtkCellLayout*)
XM_TYPE_1(GtkCellLayoutDataFunc, GtkCellLayoutDataFunc)
XM_TYPE_PTR_1(GtkFileChooser_, GtkFileChooser*)
XM_TYPE_PTR(GtkIconTheme_, GtkIconTheme*)
XM_TYPE_PTR(GtkIconInfo_, GtkIconInfo*)
#define XEN_TO_C_GtkIconLookupFlags(Arg) (GtkIconLookupFlags)(XEN_TO_C_INT(Arg))
#define XEN_GtkIconLookupFlags_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_PTR_1(GtkToolButton_, GtkToolButton*)
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
XM_TYPE_PTR_2(GtkAccelMap_, GtkAccelMap*)
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
XM_TYPE_PTR(GtkIconView_, GtkIconView*)
XM_TYPE_PTR_1(GtkCellView_, GtkCellView*)
XM_TYPE_PTR_1(GtkAboutDialog_, GtkAboutDialog*)
#endif

#if HAVE_GTK_LABEL_SET_ELLIPSIZE
#define C_TO_XEN_PangoEllipsizeMode(Arg) C_TO_XEN_INT(Arg)
#define XEN_TO_C_PangoEllipsizeMode(Arg) (PangoEllipsizeMode)(XEN_TO_C_INT(Arg))
#define XEN_PangoEllipsizeMode_P(Arg) XEN_INTEGER_P(Arg)
XM_TYPE_1(PangoAttrFilterFunc, PangoAttrFilterFunc)
XM_TYPE_NO_P_2(PangoScript, PangoScript)
XM_TYPE_PTR(PangoScriptIter_, PangoScriptIter*)
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
XM_TYPE_PTR_1(GtkFileChooserButton_, GtkFileChooserButton*)
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
XM_TYPE_PTR_1(GtkMenuToolButton_, GtkMenuToolButton*)
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
XM_TYPE_PTR_1(PangoMatrix_, PangoMatrix*)
XM_TYPE_PTR_1(GdkTrapezoid_, GdkTrapezoid*)
XM_TYPE_PTR(PangoRenderer_, PangoRenderer*)
XM_TYPE_PTR_1(GdkPangoRenderer_, GdkPangoRenderer*)
XM_TYPE_1(PangoRenderPart, PangoRenderPart)
#endif

#define XLS(a, b) XEN_TO_C_gchar_(XEN_LIST_REF(a, b))
#define XLI(a, b) XEN_TO_C_INT(XEN_LIST_REF(a, b))
#define XLG(a, b) XEN_TO_C_GType(XEN_LIST_REF(a, b))
#define XLT(a, b) XEN_TO_C_GtkTextTag_(XEN_LIST_REF(a, b))

static XEN c_to_xen_string(XEN str)
{
  return(C_TO_XEN_STRING((char *)XEN_TO_C_ULONG(str)));
}

/* -------------------------------- gc protection -------------------------------- */

static XEN xm_protected = XEN_FALSE;
static int xm_protected_size = 0;
static XEN xm_gc_table = XEN_FALSE;
static int last_xm_unprotect = -1;

static int xm_protect(XEN obj)
{
  int i, new_size;
  XEN new_table;
  if (last_xm_unprotect >= 0)
    {
      i = last_xm_unprotect;
      if (XEN_FALSE_P(XEN_VECTOR_REF(xm_protected, i)))
	{
	  XEN_VECTOR_SET(xm_protected, i, obj);
	  last_xm_unprotect = -1;
	  return(i);
	}
      last_xm_unprotect = -1;
    }
  for (i = 0; i < xm_protected_size; i++)
    if (XEN_FALSE_P(XEN_VECTOR_REF(xm_protected, i)))
      {
	XEN_VECTOR_SET(xm_protected, i, obj);
	return(i);
      }
  new_size = xm_protected_size * 2;
  new_table = XEN_MAKE_VECTOR(new_size, XEN_FALSE);
  for (i = 0; i < xm_protected_size; i++)
    {
      XEN_VECTOR_SET(new_table, i, XEN_VECTOR_REF(xm_protected, i));
      XEN_VECTOR_SET(xm_protected, i, XEN_FALSE);
    }
  XEN_VECTOR_SET(new_table, xm_protected_size, obj);
  XEN_VECTOR_SET(xm_gc_table, 0, new_table);
  i = xm_protected_size;
  xm_protected_size = new_size;
  xm_protected = new_table;
  return(i);
}

#if 0
static void xm_unprotect_idler(guint id)
{
  int i;
  XEN cur, idler;
  for (i = 0; i < xm_protected_size; i++)
    {
      cur = XEN_VECTOR_REF(xm_protected, i);
      if ((XEN_LIST_P(cur)) && (XEN_LIST_LENGTH(cur) == 3) && (XEN_LIST_P(XEN_CADDR(cur))))
        {
          idler = XEN_CADDR(cur);
          if ((XEN_SYMBOL_P(XEN_CAR(idler))) &&
              (strcmp("idler", XEN_SYMBOL_TO_C_STRING(XEN_CAR(idler))) == 0) &&
              (id == (guint)(XEN_TO_C_INT(XEN_CADR(idler)))))
            {
              velts[i] = XEN_FALSE;
              last_xm_unprotect = i;
              return;
            }}}
}
#endif
static void xm_unprotect_at(int ind)
{
  XEN_VECTOR_SET(xm_protected, ind, XEN_FALSE);
  last_xm_unprotect = ind;
}



/* ---------------------------------------- callback handlers ---------------------------------------- */

#if WITH_GTK_AND_X11
  #include "xg-x11.h"
  #define gxg_static
#else
  #define gxg_static static
#endif

static gboolean gxg_child_func(GdkWindow* window, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_2(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GdkWindow_(window),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static gboolean gxg_find_func(GtkAccelKey* key, GClosure* closure, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_3(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkAccelKey_(key),
                                      C_TO_XEN_GClosure_(closure),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_func2(GtkWidget* w, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_2(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkWidget_(w),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static gboolean gxg_timer_func(gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_1(XEN_CAR((XEN)func_data),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_destroy_func(gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_1(XEN_CADDDR((XEN)func_data),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static GdkFilterReturn gxg_filter_func(GdkXEvent* xevent, GdkEvent* event, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((GdkFilterReturn)0);
  return(XEN_TO_C_GdkFilterReturn(XEN_CALL_3(XEN_CAR((XEN)func_data),
                                             C_TO_XEN_GdkXEvent_(xevent),
                                             C_TO_XEN_GdkEvent_(event),
                                             XEN_CADR((XEN)func_data),
                                             c__FUNCTION__)));
}
static void gxg_event_func(GdkEvent* event, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_2(XEN_CAR((XEN)func_data),
             C_TO_XEN_GdkEvent_(event),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static gboolean gxg_func1(gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_1(XEN_CAR((XEN)func_data),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static gint gxg_snoop_func(GtkWidget* widget, GdkEventKey* event, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gint)0);
  return(XEN_TO_C_gint(XEN_CALL_3(XEN_CAR((XEN)func_data),
                                  C_TO_XEN_GtkWidget_(widget),
                                  C_TO_XEN_GdkEventKey_(event),
                                  XEN_CADR((XEN)func_data),
                                  c__FUNCTION__)));
}
static void gxg_menu_position_func(GtkMenu* menu, gint* x, gint* y, gboolean* push, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_5(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkMenu_(menu),
             C_TO_XEN_gint_(x),
             C_TO_XEN_gint_(y),
             C_TO_XEN_gboolean_(push),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_text_tag_table_foreach(GtkTextTag* tag, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_2(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkTextTag_(tag),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_accel_map_foreach(gpointer func_data, const gchar* accel_path, guint accel_key, GdkModifierType accel_mods, gboolean changed)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_5(XEN_CAR((XEN)func_data),
             XEN_CADR((XEN)func_data),
             C_TO_XEN_gchar_(accel_path),
             C_TO_XEN_guint(accel_key),
             C_TO_XEN_GdkModifierType(accel_mods),
             C_TO_XEN_gboolean(changed),
             c__FUNCTION__);
}
static gboolean gxg_model_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_4(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkTreeModel_(model),
                                      C_TO_XEN_GtkTreePath_(path),
                                      C_TO_XEN_GtkTreeIter_(iter),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_tree_selection_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_4(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkTreeModel_(model),
             C_TO_XEN_GtkTreePath_(path),
             C_TO_XEN_GtkTreeIter_(iter),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_clip_received(GtkClipboard* clipboard, GtkSelectionData* selection_data, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_3(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             C_TO_XEN_GtkSelectionData_(selection_data),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_clip_text_received(GtkClipboard* clipboard, const gchar* text, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_3(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             C_TO_XEN_gchar_(text),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_clip_targets_received(GtkClipboard* clipboard, GdkAtom* atoms, gint n_atoms, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_4(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             C_TO_XEN_GdkAtom_(atoms),
             C_TO_XEN_gint(n_atoms),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static gboolean gxg_text_char_predicate(gunichar ch, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_2(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_gunichar(ch),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static gboolean gxg_tree_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, GtkTreeViewColumn* prev_column, GtkTreeViewColumn* next_column, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_5(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkTreeView_(tree_view),
                                      C_TO_XEN_GtkTreeViewColumn_(column),
                                      C_TO_XEN_GtkTreeViewColumn_(prev_column),
                                      C_TO_XEN_GtkTreeViewColumn_(next_column),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_tree_mapping(GtkTreeView* tree_view, GtkTreePath* path, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_3(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkTreeView_(tree_view),
             C_TO_XEN_GtkTreePath_(path),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static gboolean gxg_tree_search(GtkTreeModel* model, gint column, const gchar* key, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_5(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkTreeModel_(model),
                                      C_TO_XEN_gint(column),
                                      C_TO_XEN_gchar_(key),
                                      C_TO_XEN_GtkTreeIter_(iter),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_cell_data(GtkTreeViewColumn* tree_column, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_5(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkTreeViewColumn_(tree_column),
             C_TO_XEN_GtkCellRenderer_(cell),
             C_TO_XEN_GtkTreeModel_(tree_model),
             C_TO_XEN_GtkTreeIter_(iter),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static gint gxg_iter_compare(GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gint)0);
  return(XEN_TO_C_gint(XEN_CALL_4(XEN_CAR((XEN)func_data),
                                  C_TO_XEN_GtkTreeModel_(model),
                                  C_TO_XEN_GtkTreeIter_(a),
                                  C_TO_XEN_GtkTreeIter_(b),
                                  XEN_CADR((XEN)func_data),
                                  c__FUNCTION__)));
}
static gboolean gxg_tree_selection(GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_5(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkTreeSelection_(selection),
                                      C_TO_XEN_GtkTreeModel_(model),
                                      C_TO_XEN_GtkTreePath_(path),
                                      C_TO_XEN_gboolean(path_currently_selected),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_clip_get(GtkClipboard* clipboard, GtkSelectionData* selection_data, guint info, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_4(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             C_TO_XEN_GtkSelectionData_(selection_data),
             C_TO_XEN_guint(info),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_clip_clear(GtkClipboard* clipboard, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_2(XEN_CADDR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
static gboolean gxg_file_filter(const GtkFileFilterInfo* info, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_2(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkFileFilterInfo_((GtkFileFilterInfo *)info),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static gboolean gxg_entry_completion_match(GtkEntryCompletion* completion, const gchar* key, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_4(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkEntryCompletion_(completion),
                                      C_TO_XEN_gchar_(key),
                                      C_TO_XEN_GtkTreeIter_(iter),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
static gboolean gxg_row_separator(GtkTreeModel* model, GtkTreeIter* iter, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return((gboolean)0);
  return(XEN_TO_C_gboolean(XEN_CALL_3(XEN_CAR((XEN)func_data),
                                      C_TO_XEN_GtkTreeModel_(model),
                                      C_TO_XEN_GtkTreeIter_(iter),
                                      XEN_CADR((XEN)func_data),
                                      c__FUNCTION__)));
}
static void gxg_icon_view_foreach(GtkIconView* icon_view, GtkTreePath* path, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_3(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkIconView_(icon_view),
             C_TO_XEN_GtkTreePath_(path),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
static void gxg_clip_image_received(GtkClipboard* clipboard, GdkPixbuf* pixbuf, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_3(XEN_CAR((XEN)func_data),
             C_TO_XEN_GtkClipboard_(clipboard),
             C_TO_XEN_GdkPixbuf_(pixbuf),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
static void gxg_g_message_log_func(const gchar* domain, GLogLevelFlags log_level, const gchar* message, gpointer func_data)
{
  if (!XEN_LIST_P((XEN)func_data)) return;
  XEN_CALL_4(XEN_CAR((XEN)func_data),
             C_TO_XEN_gchar_(domain),
             C_TO_XEN_GLogLevelFlags(log_level),
             C_TO_XEN_gchar_(message),
             XEN_CADR((XEN)func_data),
             c__FUNCTION__);
}
#endif


static gboolean gxg_func3(GtkWidget *w, GdkEventAny *ev, gpointer data)
{
  return(XEN_TO_C_BOOLEAN(XEN_CALL_3(XEN_CAR((XEN)data),
                          C_TO_XEN_GtkWidget_(w),
                          C_TO_XEN_GdkEventAny_(ev),
                          XEN_CADR((XEN)data),
                          c__FUNCTION__)));
}



/* ---------------------------------------- functions ---------------------------------------- */

static XEN gxg_g_type_name(XEN type)
{
  #define H_g_type_name "gchar* g_type_name(GType type)"
  XEN_ASSERT_TYPE(XEN_GType_P(type), type, 1, "g_type_name", "GType");
  return(C_TO_XEN_gchar_(g_type_name(XEN_TO_C_GType(type))));
}
static XEN gxg_g_type_qname(XEN type)
{
  #define H_g_type_qname "GQuark g_type_qname(GType type)"
  XEN_ASSERT_TYPE(XEN_GType_P(type), type, 1, "g_type_qname", "GType");
  return(C_TO_XEN_GQuark(g_type_qname(XEN_TO_C_GType(type))));
}
static XEN gxg_g_type_from_name(XEN name)
{
  #define H_g_type_from_name "GType g_type_from_name(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "g_type_from_name", "gchar*");
  return(C_TO_XEN_GType(g_type_from_name(XEN_TO_C_gchar_(name))));
}
static XEN gxg_g_type_parent(XEN type)
{
  #define H_g_type_parent "GType g_type_parent(GType type)"
  XEN_ASSERT_TYPE(XEN_GType_P(type), type, 1, "g_type_parent", "GType");
  return(C_TO_XEN_GType(g_type_parent(XEN_TO_C_GType(type))));
}
static XEN gxg_g_type_is_a(XEN type, XEN is_a_type)
{
  #define H_g_type_is_a "gboolean g_type_is_a(GType type, GType is_a_type)"
  XEN_ASSERT_TYPE(XEN_GType_P(type), type, 1, "g_type_is_a", "GType");
  XEN_ASSERT_TYPE(XEN_GType_P(is_a_type), is_a_type, 2, "g_type_is_a", "GType");
  return(C_TO_XEN_gboolean(g_type_is_a(XEN_TO_C_GType(type), XEN_TO_C_GType(is_a_type))));
}
static XEN gxg_g_cclosure_new(XEN func, XEN func_data, XEN destroy_data)
{
  #define H_g_cclosure_new "GClosure* g_cclosure_new(GCallback func, lambda_data func_data, GClosureNotify destroy_data)"
  XEN_ASSERT_TYPE(XEN_GCallback_P(func), func, 1, "g_cclosure_new", "GCallback");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 2, "g_cclosure_new", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GClosureNotify_P(destroy_data) || XEN_FALSE_P(destroy_data), destroy_data, 3, "g_cclosure_new", "GClosureNotify");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_GClosure_(g_cclosure_new(XEN_TO_C_GCallback(func), XEN_TO_C_lambda_data(func_data), XEN_TO_C_GClosureNotify(destroy_data)));
    return(result);
   }
}
static XEN gxg_g_signal_newv(XEN arglist)
{
  #define H_g_signal_newv "guint g_signal_newv(gchar* signal_name, GType itype, GSignalFlags signal_flags, \
GClosure* class_closure, GSignalAccumulator accumulator, gpointer accu_data, GSignalCMarshaller c_marshaller, \
GType return_type, guint n_params, GType* param_types)"
  XEN signal_name, itype, signal_flags, class_closure, accumulator, accu_data, c_marshaller, return_type, n_params, param_types;
  signal_name = XEN_LIST_REF(arglist, 0);
  itype = XEN_LIST_REF(arglist, 1);
  signal_flags = XEN_LIST_REF(arglist, 2);
  class_closure = XEN_LIST_REF(arglist, 3);
  accumulator = XEN_LIST_REF(arglist, 4);
  accu_data = XEN_LIST_REF(arglist, 5);
  c_marshaller = XEN_LIST_REF(arglist, 6);
  return_type = XEN_LIST_REF(arglist, 7);
  n_params = XEN_LIST_REF(arglist, 8);
  param_types = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_gchar__P(signal_name), signal_name, 1, "g_signal_newv", "gchar*");
  XEN_ASSERT_TYPE(XEN_GType_P(itype), itype, 2, "g_signal_newv", "GType");
  XEN_ASSERT_TYPE(XEN_GSignalFlags_P(signal_flags), signal_flags, 3, "g_signal_newv", "GSignalFlags");
  XEN_ASSERT_TYPE(XEN_GClosure__P(class_closure) || XEN_FALSE_P(class_closure), class_closure, 4, "g_signal_newv", "GClosure*");
  XEN_ASSERT_TYPE(XEN_GSignalAccumulator_P(accumulator), accumulator, 5, "g_signal_newv", "GSignalAccumulator");
  XEN_ASSERT_TYPE(XEN_gpointer_P(accu_data), accu_data, 6, "g_signal_newv", "gpointer");
  XEN_ASSERT_TYPE(XEN_GSignalCMarshaller_P(c_marshaller), c_marshaller, 7, "g_signal_newv", "GSignalCMarshaller");
  XEN_ASSERT_TYPE(XEN_GType_P(return_type), return_type, 8, "g_signal_newv", "GType");
  XEN_ASSERT_TYPE(XEN_guint_P(n_params), n_params, 9, "g_signal_newv", "guint");
  XEN_ASSERT_TYPE(XEN_GType__P(param_types), param_types, 10, "g_signal_newv", "GType*");
  return(C_TO_XEN_guint(g_signal_newv(XEN_TO_C_gchar_(signal_name), XEN_TO_C_GType(itype), XEN_TO_C_GSignalFlags(signal_flags), 
                                      XEN_TO_C_GClosure_(class_closure), XEN_TO_C_GSignalAccumulator(accumulator), XEN_TO_C_gpointer(accu_data), 
                                      XEN_TO_C_GSignalCMarshaller(c_marshaller), XEN_TO_C_GType(return_type), XEN_TO_C_guint(n_params), 
                                      XEN_TO_C_GType_(param_types))));
}
static XEN gxg_g_signal_lookup(XEN name, XEN itype)
{
  #define H_g_signal_lookup "guint g_signal_lookup(gchar* name, GType itype)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "g_signal_lookup", "gchar*");
  XEN_ASSERT_TYPE(XEN_GType_P(itype), itype, 2, "g_signal_lookup", "GType");
  return(C_TO_XEN_guint(g_signal_lookup(XEN_TO_C_gchar_(name), XEN_TO_C_GType(itype))));
}
static XEN gxg_g_signal_name(XEN signal_id)
{
  #define H_g_signal_name "gchar* g_signal_name(guint signal_id)"
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 1, "g_signal_name", "guint");
  return(C_TO_XEN_gchar_(g_signal_name(XEN_TO_C_guint(signal_id))));
}
static XEN gxg_g_signal_query(XEN signal_id, XEN query)
{
  #define H_g_signal_query "void g_signal_query(guint signal_id, GSignalQuery* query)"
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 1, "g_signal_query", "guint");
  XEN_ASSERT_TYPE(XEN_GSignalQuery__P(query), query, 2, "g_signal_query", "GSignalQuery*");
  g_signal_query(XEN_TO_C_guint(signal_id), XEN_TO_C_GSignalQuery_(query));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_list_ids(XEN itype, XEN n_ids)
{
  #define H_g_signal_list_ids "guint* g_signal_list_ids(GType itype, guint* n_ids)"
  XEN_ASSERT_TYPE(XEN_GType_P(itype), itype, 1, "g_signal_list_ids", "GType");
  XEN_ASSERT_TYPE(XEN_guint__P(n_ids), n_ids, 2, "g_signal_list_ids", "guint*");
  return(C_TO_XEN_guint_(g_signal_list_ids(XEN_TO_C_GType(itype), XEN_TO_C_guint_(n_ids))));
}
static XEN gxg_g_signal_parse_name(XEN detailed_signal, XEN itype, XEN signal_id_p, XEN detail_p, XEN force_detail_quark)
{
  #define H_g_signal_parse_name "gboolean g_signal_parse_name(gchar* detailed_signal, GType itype, guint* [signal_id_p], \
GQuark* [detail_p], gboolean force_detail_quark)"
  guint ref_signal_id_p;
  GQuark ref_detail_p;
  XEN_ASSERT_TYPE(XEN_gchar__P(detailed_signal), detailed_signal, 1, "g_signal_parse_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GType_P(itype), itype, 2, "g_signal_parse_name", "GType");
  XEN_ASSERT_TYPE(XEN_gboolean_P(force_detail_quark), force_detail_quark, 5, "g_signal_parse_name", "gboolean");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(g_signal_parse_name(XEN_TO_C_gchar_(detailed_signal), XEN_TO_C_GType(itype), &ref_signal_id_p, 
                                                   &ref_detail_p, XEN_TO_C_gboolean(force_detail_quark)));
    return(XEN_LIST_3(result, C_TO_XEN_guint(ref_signal_id_p), C_TO_XEN_GQuark(ref_detail_p)));
   }
}
static XEN gxg_g_signal_get_invocation_hint(XEN instance)
{
  #define H_g_signal_get_invocation_hint "GSignalInvocationHint* g_signal_get_invocation_hint(gpointer instance)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_get_invocation_hint", "gpointer");
  return(C_TO_XEN_GSignalInvocationHint_(g_signal_get_invocation_hint(XEN_TO_C_gpointer(instance))));
}
static XEN gxg_g_signal_stop_emission(XEN instance, XEN signal_id, XEN detail)
{
  #define H_g_signal_stop_emission "void g_signal_stop_emission(gpointer instance, guint signal_id, GQuark detail)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_stop_emission", "gpointer");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 2, "g_signal_stop_emission", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 3, "g_signal_stop_emission", "GQuark");
  g_signal_stop_emission(XEN_TO_C_gpointer(instance), XEN_TO_C_guint(signal_id), XEN_TO_C_GQuark(detail));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_stop_emission_by_name(XEN instance, XEN detailed_signal)
{
  #define H_g_signal_stop_emission_by_name "void g_signal_stop_emission_by_name(gpointer instance, gchar* detailed_signal)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_stop_emission_by_name", "gpointer");
  XEN_ASSERT_TYPE(XEN_gchar__P(detailed_signal), detailed_signal, 2, "g_signal_stop_emission_by_name", "gchar*");
  g_signal_stop_emission_by_name(XEN_TO_C_gpointer(instance), XEN_TO_C_gchar_(detailed_signal));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_add_emission_hook(XEN signal_id, XEN quark, XEN hook_func, XEN func_data, XEN data_destroy)
{
  #define H_g_signal_add_emission_hook "gulong g_signal_add_emission_hook(guint signal_id, GQuark quark, \
GSignalEmissionHook hook_func, lambda_data func_data, GtkDestroyNotify data_destroy)"
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 1, "g_signal_add_emission_hook", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(quark), quark, 2, "g_signal_add_emission_hook", "GQuark");
  XEN_ASSERT_TYPE(XEN_GSignalEmissionHook_P(hook_func), hook_func, 3, "g_signal_add_emission_hook", "GSignalEmissionHook");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "g_signal_add_emission_hook", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(data_destroy), data_destroy, 5, "g_signal_add_emission_hook", "GtkDestroyNotify");
  {
    XEN result = XEN_FALSE;
    XEN gxg_ptr = XEN_LIST_5(XEN_FALSE, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, data_destroy);
    result = C_TO_XEN_gulong(g_signal_add_emission_hook(XEN_TO_C_guint(signal_id), XEN_TO_C_GQuark(quark), XEN_TO_C_GSignalEmissionHook(hook_func), 
                                                        XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(data_destroy)));
    return(result);
   }
}
static XEN gxg_g_signal_remove_emission_hook(XEN signal_id, XEN hook_id)
{
  #define H_g_signal_remove_emission_hook "void g_signal_remove_emission_hook(guint signal_id, gulong hook_id)"
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 1, "g_signal_remove_emission_hook", "guint");
  XEN_ASSERT_TYPE(XEN_gulong_P(hook_id), hook_id, 2, "g_signal_remove_emission_hook", "gulong");
  g_signal_remove_emission_hook(XEN_TO_C_guint(signal_id), XEN_TO_C_gulong(hook_id));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_has_handler_pending(XEN instance, XEN signal_id, XEN detail, XEN may_be_blocked)
{
  #define H_g_signal_has_handler_pending "gboolean g_signal_has_handler_pending(gpointer instance, guint signal_id, \
GQuark detail, gboolean may_be_blocked)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_has_handler_pending", "gpointer");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 2, "g_signal_has_handler_pending", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 3, "g_signal_has_handler_pending", "GQuark");
  XEN_ASSERT_TYPE(XEN_gboolean_P(may_be_blocked), may_be_blocked, 4, "g_signal_has_handler_pending", "gboolean");
  return(C_TO_XEN_gboolean(g_signal_has_handler_pending(XEN_TO_C_gpointer(instance), XEN_TO_C_guint(signal_id), XEN_TO_C_GQuark(detail), 
                                                        XEN_TO_C_gboolean(may_be_blocked))));
}
static XEN gxg_g_signal_connect_closure_by_id(XEN instance, XEN signal_id, XEN detail, XEN closure, XEN after)
{
  #define H_g_signal_connect_closure_by_id "gulong g_signal_connect_closure_by_id(gpointer instance, \
guint signal_id, GQuark detail, GClosure* closure, gboolean after)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_connect_closure_by_id", "gpointer");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 2, "g_signal_connect_closure_by_id", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 3, "g_signal_connect_closure_by_id", "GQuark");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure), closure, 4, "g_signal_connect_closure_by_id", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(after), after, 5, "g_signal_connect_closure_by_id", "gboolean");
  return(C_TO_XEN_gulong(g_signal_connect_closure_by_id(XEN_TO_C_gpointer(instance), XEN_TO_C_guint(signal_id), XEN_TO_C_GQuark(detail), 
                                                        XEN_TO_C_GClosure_(closure), XEN_TO_C_gboolean(after))));
}
static XEN gxg_g_signal_connect_closure(XEN instance, XEN detailed_signal, XEN closure, XEN after)
{
  #define H_g_signal_connect_closure "gulong g_signal_connect_closure(gpointer instance, gchar* detailed_signal, \
GClosure* closure, gboolean after)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_connect_closure", "gpointer");
  XEN_ASSERT_TYPE(XEN_gchar__P(detailed_signal), detailed_signal, 2, "g_signal_connect_closure", "gchar*");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure), closure, 3, "g_signal_connect_closure", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(after), after, 4, "g_signal_connect_closure", "gboolean");
  return(C_TO_XEN_gulong(g_signal_connect_closure(XEN_TO_C_gpointer(instance), XEN_TO_C_gchar_(detailed_signal), XEN_TO_C_GClosure_(closure), 
                                                  XEN_TO_C_gboolean(after))));
}
static XEN gxg_g_signal_connect_data(XEN instance, XEN detailed_signal, XEN func, XEN func_data, XEN destroy_data, XEN connect_flags)
{
  #define H_g_signal_connect_data "gulong g_signal_connect_data(gpointer instance, gchar* detailed_signal, \
GCallback func, lambda_data func_data, GClosureNotify destroy_data, GConnectFlags connect_flags)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_connect_data", "gpointer");
  XEN_ASSERT_TYPE(XEN_gchar__P(detailed_signal), detailed_signal, 2, "g_signal_connect_data", "gchar*");
  XEN_ASSERT_TYPE(XEN_GCallback_P(func), func, 3, "g_signal_connect_data", "GCallback");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "g_signal_connect_data", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GClosureNotify_P(destroy_data) || XEN_FALSE_P(destroy_data), destroy_data, 5, "g_signal_connect_data", "GClosureNotify");
  XEN_ASSERT_TYPE(XEN_GConnectFlags_P(connect_flags), connect_flags, 6, "g_signal_connect_data", "GConnectFlags");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_gulong(g_signal_connect_data(XEN_TO_C_gpointer(instance), XEN_TO_C_gchar_(detailed_signal), XEN_TO_C_GCallback(func), 
                                                   XEN_TO_C_lambda_data(func_data), XEN_TO_C_GClosureNotify(destroy_data), 
                                                   XEN_TO_C_GConnectFlags(connect_flags)));
    return(result);
   }
}
static XEN gxg_g_signal_handler_block(XEN instance, XEN handler_id)
{
  #define H_g_signal_handler_block "void g_signal_handler_block(gpointer instance, gulong handler_id)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handler_block", "gpointer");
  XEN_ASSERT_TYPE(XEN_gulong_P(handler_id), handler_id, 2, "g_signal_handler_block", "gulong");
  g_signal_handler_block(XEN_TO_C_gpointer(instance), XEN_TO_C_gulong(handler_id));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_handler_unblock(XEN instance, XEN handler_id)
{
  #define H_g_signal_handler_unblock "void g_signal_handler_unblock(gpointer instance, gulong handler_id)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handler_unblock", "gpointer");
  XEN_ASSERT_TYPE(XEN_gulong_P(handler_id), handler_id, 2, "g_signal_handler_unblock", "gulong");
  g_signal_handler_unblock(XEN_TO_C_gpointer(instance), XEN_TO_C_gulong(handler_id));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_handler_disconnect(XEN instance, XEN handler_id)
{
  #define H_g_signal_handler_disconnect "void g_signal_handler_disconnect(gpointer instance, gulong handler_id)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handler_disconnect", "gpointer");
  XEN_ASSERT_TYPE(XEN_gulong_P(handler_id), handler_id, 2, "g_signal_handler_disconnect", "gulong");
  g_signal_handler_disconnect(XEN_TO_C_gpointer(instance), XEN_TO_C_gulong(handler_id));
  return(XEN_FALSE);
}
static XEN gxg_g_signal_handler_is_connected(XEN instance, XEN handler_id)
{
  #define H_g_signal_handler_is_connected "gboolean g_signal_handler_is_connected(gpointer instance, \
gulong handler_id)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handler_is_connected", "gpointer");
  XEN_ASSERT_TYPE(XEN_gulong_P(handler_id), handler_id, 2, "g_signal_handler_is_connected", "gulong");
  return(C_TO_XEN_gboolean(g_signal_handler_is_connected(XEN_TO_C_gpointer(instance), XEN_TO_C_gulong(handler_id))));
}
static XEN gxg_g_signal_handler_find(XEN instance, XEN mask, XEN signal_id, XEN detail, XEN closure, XEN func, XEN data)
{
  #define H_g_signal_handler_find "gulong g_signal_handler_find(gpointer instance, GSignalMatchType mask, \
guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handler_find", "gpointer");
  XEN_ASSERT_TYPE(XEN_GSignalMatchType_P(mask), mask, 2, "g_signal_handler_find", "GSignalMatchType");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 3, "g_signal_handler_find", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 4, "g_signal_handler_find", "GQuark");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 5, "g_signal_handler_find", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(func), func, 6, "g_signal_handler_find", "gpointer");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 7, "g_signal_handler_find", "gpointer");
  return(C_TO_XEN_gulong(g_signal_handler_find(XEN_TO_C_gpointer(instance), XEN_TO_C_GSignalMatchType(mask), XEN_TO_C_guint(signal_id), 
                                               XEN_TO_C_GQuark(detail), XEN_TO_C_GClosure_(closure), XEN_TO_C_gpointer(func), 
                                               XEN_TO_C_gpointer(data))));
}
static XEN gxg_g_signal_handlers_block_matched(XEN instance, XEN mask, XEN signal_id, XEN detail, XEN closure, XEN func, XEN data)
{
  #define H_g_signal_handlers_block_matched "guint g_signal_handlers_block_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handlers_block_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_GSignalMatchType_P(mask), mask, 2, "g_signal_handlers_block_matched", "GSignalMatchType");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 3, "g_signal_handlers_block_matched", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 4, "g_signal_handlers_block_matched", "GQuark");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 5, "g_signal_handlers_block_matched", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(func), func, 6, "g_signal_handlers_block_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 7, "g_signal_handlers_block_matched", "gpointer");
  return(C_TO_XEN_guint(g_signal_handlers_block_matched(XEN_TO_C_gpointer(instance), XEN_TO_C_GSignalMatchType(mask), XEN_TO_C_guint(signal_id), 
                                                        XEN_TO_C_GQuark(detail), XEN_TO_C_GClosure_(closure), XEN_TO_C_gpointer(func), 
                                                        XEN_TO_C_gpointer(data))));
}
static XEN gxg_g_signal_handlers_unblock_matched(XEN instance, XEN mask, XEN signal_id, XEN detail, XEN closure, XEN func, XEN data)
{
  #define H_g_signal_handlers_unblock_matched "guint g_signal_handlers_unblock_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handlers_unblock_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_GSignalMatchType_P(mask), mask, 2, "g_signal_handlers_unblock_matched", "GSignalMatchType");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 3, "g_signal_handlers_unblock_matched", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 4, "g_signal_handlers_unblock_matched", "GQuark");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 5, "g_signal_handlers_unblock_matched", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(func), func, 6, "g_signal_handlers_unblock_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 7, "g_signal_handlers_unblock_matched", "gpointer");
  return(C_TO_XEN_guint(g_signal_handlers_unblock_matched(XEN_TO_C_gpointer(instance), XEN_TO_C_GSignalMatchType(mask), XEN_TO_C_guint(signal_id), 
                                                          XEN_TO_C_GQuark(detail), XEN_TO_C_GClosure_(closure), XEN_TO_C_gpointer(func), 
                                                          XEN_TO_C_gpointer(data))));
}
static XEN gxg_g_signal_handlers_disconnect_matched(XEN instance, XEN mask, XEN signal_id, XEN detail, XEN closure, XEN func, XEN data)
{
  #define H_g_signal_handlers_disconnect_matched "guint g_signal_handlers_disconnect_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handlers_disconnect_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_GSignalMatchType_P(mask), mask, 2, "g_signal_handlers_disconnect_matched", "GSignalMatchType");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 3, "g_signal_handlers_disconnect_matched", "guint");
  XEN_ASSERT_TYPE(XEN_GQuark_P(detail), detail, 4, "g_signal_handlers_disconnect_matched", "GQuark");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 5, "g_signal_handlers_disconnect_matched", "GClosure*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(func), func, 6, "g_signal_handlers_disconnect_matched", "gpointer");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 7, "g_signal_handlers_disconnect_matched", "gpointer");
  return(C_TO_XEN_guint(g_signal_handlers_disconnect_matched(XEN_TO_C_gpointer(instance), XEN_TO_C_GSignalMatchType(mask), 
                                                             XEN_TO_C_guint(signal_id), XEN_TO_C_GQuark(detail), XEN_TO_C_GClosure_(closure), 
                                                             XEN_TO_C_gpointer(func), XEN_TO_C_gpointer(data))));
}
static XEN gxg_g_signal_handlers_destroy(XEN instance)
{
  #define H_g_signal_handlers_destroy "void g_signal_handlers_destroy(gpointer instance)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(instance), instance, 1, "g_signal_handlers_destroy", "gpointer");
  g_signal_handlers_destroy(XEN_TO_C_gpointer(instance));
  return(XEN_FALSE);
}
static XEN gxg_g_object_ref(XEN object)
{
  #define H_g_object_ref "gpointer g_object_ref(gpointer object)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(object), object, 1, "g_object_ref", "gpointer");
  return(C_TO_XEN_gpointer(g_object_ref(XEN_TO_C_gpointer(object))));
}
static XEN gxg_g_object_unref(XEN object)
{
  #define H_g_object_unref "void g_object_unref(gpointer object)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(object), object, 1, "g_object_unref", "gpointer");
  g_object_unref(XEN_TO_C_gpointer(object));
  return(XEN_FALSE);
}
static XEN gxg_gdk_colormap_get_type(void)
{
  #define H_gdk_colormap_get_type "GType gdk_colormap_get_type( void)"
  return(C_TO_XEN_GType(gdk_colormap_get_type()));
}
static XEN gxg_gdk_colormap_new(XEN visual, XEN allocate)
{
  #define H_gdk_colormap_new "GdkColormap* gdk_colormap_new(GdkVisual* visual, gboolean allocate)"
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(visual), visual, 1, "gdk_colormap_new", "GdkVisual*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(allocate), allocate, 2, "gdk_colormap_new", "gboolean");
  return(C_TO_XEN_GdkColormap_(gdk_colormap_new(XEN_TO_C_GdkVisual_(visual), XEN_TO_C_gboolean(allocate))));
}
static XEN gxg_gdk_colormap_get_system(void)
{
  #define H_gdk_colormap_get_system "GdkColormap* gdk_colormap_get_system( void)"
  return(C_TO_XEN_GdkColormap_(gdk_colormap_get_system()));
}
static XEN gxg_gdk_colormap_alloc_colors(XEN colormap, XEN colors, XEN ncolors, XEN writeable, XEN best_match, XEN success)
{
  #define H_gdk_colormap_alloc_colors "gint gdk_colormap_alloc_colors(GdkColormap* colormap, GdkColor* colors, \
gint ncolors, gboolean writeable, gboolean best_match, gboolean* success)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gdk_colormap_alloc_colors", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(colors), colors, 2, "gdk_colormap_alloc_colors", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gint_P(ncolors), ncolors, 3, "gdk_colormap_alloc_colors", "gint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(writeable), writeable, 4, "gdk_colormap_alloc_colors", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(best_match), best_match, 5, "gdk_colormap_alloc_colors", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean__P(success), success, 6, "gdk_colormap_alloc_colors", "gboolean*");
  return(C_TO_XEN_gint(gdk_colormap_alloc_colors(XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkColor_(colors), XEN_TO_C_gint(ncolors), 
                                                 XEN_TO_C_gboolean(writeable), XEN_TO_C_gboolean(best_match), XEN_TO_C_gboolean_(success))));
}
static XEN gxg_gdk_colormap_alloc_color(XEN colormap, XEN color, XEN writeable, XEN best_match)
{
  #define H_gdk_colormap_alloc_color "gboolean gdk_colormap_alloc_color(GdkColormap* colormap, GdkColor* color, \
gboolean writeable, gboolean best_match)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gdk_colormap_alloc_color", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_colormap_alloc_color", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(writeable), writeable, 3, "gdk_colormap_alloc_color", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(best_match), best_match, 4, "gdk_colormap_alloc_color", "gboolean");
  return(C_TO_XEN_gboolean(gdk_colormap_alloc_color(XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkColor_(color), XEN_TO_C_gboolean(writeable), 
                                                    XEN_TO_C_gboolean(best_match))));
}
static XEN gxg_gdk_colormap_query_color(XEN colormap, XEN pixel, XEN result)
{
  #define H_gdk_colormap_query_color "void gdk_colormap_query_color(GdkColormap* colormap, gulong pixel, \
GdkColor* result)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gdk_colormap_query_color", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_gulong_P(pixel), pixel, 2, "gdk_colormap_query_color", "gulong");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(result), result, 3, "gdk_colormap_query_color", "GdkColor*");
  gdk_colormap_query_color(XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_gulong(pixel), XEN_TO_C_GdkColor_(result));
  return(XEN_FALSE);
}
static XEN gxg_gdk_colormap_get_visual(XEN colormap)
{
  #define H_gdk_colormap_get_visual "GdkVisual* gdk_colormap_get_visual(GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gdk_colormap_get_visual", "GdkColormap*");
  return(C_TO_XEN_GdkVisual_(gdk_colormap_get_visual(XEN_TO_C_GdkColormap_(colormap))));
}
static XEN gxg_gdk_color_copy(XEN color)
{
  #define H_gdk_color_copy "GdkColor* gdk_color_copy(GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 1, "gdk_color_copy", "GdkColor*");
  return(C_TO_XEN_GdkColor_(gdk_color_copy(XEN_TO_C_GdkColor_(color))));
}
static XEN gxg_gdk_color_free(XEN color)
{
  #define H_gdk_color_free "void gdk_color_free(GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 1, "gdk_color_free", "GdkColor*");
  gdk_color_free(XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_color_parse(XEN spec, XEN color)
{
  #define H_gdk_color_parse "gint gdk_color_parse(gchar* spec, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_gchar__P(spec), spec, 1, "gdk_color_parse", "gchar*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_color_parse", "GdkColor*");
  return(C_TO_XEN_gint(gdk_color_parse(XEN_TO_C_gchar_(spec), XEN_TO_C_GdkColor_(color))));
}
static XEN gxg_gdk_color_hash(XEN colora)
{
  #define H_gdk_color_hash "guint gdk_color_hash(GdkColor* colora)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(colora), colora, 1, "gdk_color_hash", "GdkColor*");
  return(C_TO_XEN_guint(gdk_color_hash(XEN_TO_C_GdkColor_(colora))));
}
static XEN gxg_gdk_color_equal(XEN colora, XEN colorb)
{
  #define H_gdk_color_equal "gboolean gdk_color_equal(GdkColor* colora, GdkColor* colorb)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(colora), colora, 1, "gdk_color_equal", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(colorb), colorb, 2, "gdk_color_equal", "GdkColor*");
  return(C_TO_XEN_gboolean(gdk_color_equal(XEN_TO_C_GdkColor_(colora), XEN_TO_C_GdkColor_(colorb))));
}
static XEN gxg_gdk_color_get_type(void)
{
  #define H_gdk_color_get_type "GType gdk_color_get_type( void)"
  return(C_TO_XEN_GType(gdk_color_get_type()));
}
static XEN gxg_gdk_cursor_get_type(void)
{
  #define H_gdk_cursor_get_type "GType gdk_cursor_get_type( void)"
  return(C_TO_XEN_GType(gdk_cursor_get_type()));
}
static XEN gxg_gdk_cursor_new(XEN cursor_type)
{
  #define H_gdk_cursor_new "GdkCursor* gdk_cursor_new(GdkCursorType cursor_type)"
  XEN_ASSERT_TYPE(XEN_GdkCursorType_P(cursor_type), cursor_type, 1, "gdk_cursor_new", "GdkCursorType");
  return(C_TO_XEN_GdkCursor_(gdk_cursor_new(XEN_TO_C_GdkCursorType(cursor_type))));
}
static XEN gxg_gdk_cursor_new_from_pixmap(XEN source, XEN mask, XEN fg, XEN bg, XEN x, XEN y)
{
  #define H_gdk_cursor_new_from_pixmap "GdkCursor* gdk_cursor_new_from_pixmap(GdkPixmap* source, GdkPixmap* mask, \
GdkColor* fg, GdkColor* bg, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(source), source, 1, "gdk_cursor_new_from_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(mask), mask, 2, "gdk_cursor_new_from_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(fg), fg, 3, "gdk_cursor_new_from_pixmap", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(bg), bg, 4, "gdk_cursor_new_from_pixmap", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 5, "gdk_cursor_new_from_pixmap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 6, "gdk_cursor_new_from_pixmap", "gint");
  return(C_TO_XEN_GdkCursor_(gdk_cursor_new_from_pixmap(XEN_TO_C_GdkPixmap_(source), XEN_TO_C_GdkPixmap_(mask), XEN_TO_C_GdkColor_(fg), 
                                                        XEN_TO_C_GdkColor_(bg), XEN_TO_C_gint(x), XEN_TO_C_gint(y))));
}
static XEN gxg_gdk_cursor_ref(XEN cursor)
{
  #define H_gdk_cursor_ref "GdkCursor* gdk_cursor_ref(GdkCursor* cursor)"
  XEN_ASSERT_TYPE(XEN_GdkCursor__P(cursor), cursor, 1, "gdk_cursor_ref", "GdkCursor*");
  return(C_TO_XEN_GdkCursor_(gdk_cursor_ref(XEN_TO_C_GdkCursor_(cursor))));
}
static XEN gxg_gdk_cursor_unref(XEN cursor)
{
  #define H_gdk_cursor_unref "void gdk_cursor_unref(GdkCursor* cursor)"
  XEN_ASSERT_TYPE(XEN_GdkCursor__P(cursor), cursor, 1, "gdk_cursor_unref", "GdkCursor*");
  gdk_cursor_unref(XEN_TO_C_GdkCursor_(cursor));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drag_context_get_type(void)
{
  #define H_gdk_drag_context_get_type "GType gdk_drag_context_get_type( void)"
  return(C_TO_XEN_GType(gdk_drag_context_get_type()));
}
static XEN gxg_gdk_drag_context_new(void)
{
  #define H_gdk_drag_context_new "GdkDragContext* gdk_drag_context_new( void)"
  return(C_TO_XEN_GdkDragContext_(gdk_drag_context_new()));
}
static XEN gxg_gdk_drag_status(XEN context, XEN action, XEN time)
{
  #define H_gdk_drag_status "void gdk_drag_status(GdkDragContext* context, GdkDragAction action, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_status", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(action), action, 2, "gdk_drag_status", "GdkDragAction");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gdk_drag_status", "guint32");
  gdk_drag_status(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkDragAction(action), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drop_reply(XEN context, XEN ok, XEN time)
{
  #define H_gdk_drop_reply "void gdk_drop_reply(GdkDragContext* context, gboolean ok, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drop_reply", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(ok), ok, 2, "gdk_drop_reply", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gdk_drop_reply", "guint32");
  gdk_drop_reply(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_gboolean(ok), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drop_finish(XEN context, XEN success, XEN time)
{
  #define H_gdk_drop_finish "void gdk_drop_finish(GdkDragContext* context, gboolean success, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drop_finish", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(success), success, 2, "gdk_drop_finish", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gdk_drop_finish", "guint32");
  gdk_drop_finish(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_gboolean(success), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drag_get_selection(XEN context)
{
  #define H_gdk_drag_get_selection "GdkAtom gdk_drag_get_selection(GdkDragContext* context)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_get_selection", "GdkDragContext*");
  return(C_TO_XEN_GdkAtom(gdk_drag_get_selection(XEN_TO_C_GdkDragContext_(context))));
}
static XEN gxg_gdk_drag_begin(XEN window, XEN targets)
{
  #define H_gdk_drag_begin "GdkDragContext* gdk_drag_begin(GdkWindow* window, GList* targets)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_drag_begin", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GList__P(targets), targets, 2, "gdk_drag_begin", "GList*");
  return(C_TO_XEN_GdkDragContext_(gdk_drag_begin(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GList_(targets))));
}
static XEN gxg_gdk_drag_get_protocol(XEN xid, XEN protocol)
{
  #define H_gdk_drag_get_protocol "guint32 gdk_drag_get_protocol(guint32 xid, GdkDragProtocol* [protocol])"
  GdkDragProtocol ref_protocol;
  XEN_ASSERT_TYPE(XEN_guint32_P(xid), xid, 1, "gdk_drag_get_protocol", "guint32");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_guint32(gdk_drag_get_protocol(XEN_TO_C_guint32(xid), &ref_protocol));
    return(XEN_LIST_2(result, C_TO_XEN_GdkDragProtocol(ref_protocol)));
   }
}
static XEN gxg_gdk_drag_find_window(XEN context, XEN drag_window, XEN x_root, XEN y_root, XEN dest_window, XEN protocol)
{
  #define H_gdk_drag_find_window "void gdk_drag_find_window(GdkDragContext* context, GdkWindow* drag_window, \
gint x_root, gint y_root, GdkWindow** [dest_window], GdkDragProtocol* [protocol])"
  GdkWindow* ref_dest_window = NULL;
  GdkDragProtocol ref_protocol;
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_find_window", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(drag_window), drag_window, 2, "gdk_drag_find_window", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x_root), x_root, 3, "gdk_drag_find_window", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y_root), y_root, 4, "gdk_drag_find_window", "gint");
  gdk_drag_find_window(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkWindow_(drag_window), XEN_TO_C_gint(x_root), XEN_TO_C_gint(y_root), 
                       &ref_dest_window, &ref_protocol);
  return(XEN_LIST_2(C_TO_XEN_GdkWindow_(ref_dest_window), C_TO_XEN_GdkDragProtocol(ref_protocol)));
}
static XEN gxg_gdk_drag_motion(XEN context, XEN dest_window, XEN protocol, XEN x_root, XEN y_root, XEN suggested_action, XEN possible_actions, XEN time)
{
  #define H_gdk_drag_motion "gboolean gdk_drag_motion(GdkDragContext* context, GdkWindow* dest_window, \
GdkDragProtocol protocol, gint x_root, gint y_root, GdkDragAction suggested_action, GdkDragAction possible_actions, \
guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_motion", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(dest_window), dest_window, 2, "gdk_drag_motion", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkDragProtocol_P(protocol), protocol, 3, "gdk_drag_motion", "GdkDragProtocol");
  XEN_ASSERT_TYPE(XEN_gint_P(x_root), x_root, 4, "gdk_drag_motion", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y_root), y_root, 5, "gdk_drag_motion", "gint");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(suggested_action), suggested_action, 6, "gdk_drag_motion", "GdkDragAction");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(possible_actions), possible_actions, 7, "gdk_drag_motion", "GdkDragAction");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 8, "gdk_drag_motion", "guint32");
  return(C_TO_XEN_gboolean(gdk_drag_motion(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkWindow_(dest_window), XEN_TO_C_GdkDragProtocol(protocol), 
                                           XEN_TO_C_gint(x_root), XEN_TO_C_gint(y_root), XEN_TO_C_GdkDragAction(suggested_action), 
                                           XEN_TO_C_GdkDragAction(possible_actions), XEN_TO_C_guint32(time))));
}
static XEN gxg_gdk_drag_drop(XEN context, XEN time)
{
  #define H_gdk_drag_drop "void gdk_drag_drop(GdkDragContext* context, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_drop", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 2, "gdk_drag_drop", "guint32");
  gdk_drag_drop(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drag_abort(XEN context, XEN time)
{
  #define H_gdk_drag_abort "void gdk_drag_abort(GdkDragContext* context, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_abort", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 2, "gdk_drag_abort", "guint32");
  gdk_drag_abort(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drawable_get_type(void)
{
  #define H_gdk_drawable_get_type "GType gdk_drawable_get_type( void)"
  return(C_TO_XEN_GType(gdk_drawable_get_type()));
}
static XEN gxg_gdk_drawable_get_size(XEN drawable, XEN width, XEN height)
{
  #define H_gdk_drawable_get_size "void gdk_drawable_get_size(GdkDrawable* drawable, gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_size", "GdkDrawable*");
  gdk_drawable_get_size(XEN_TO_C_GdkDrawable_(drawable), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gdk_drawable_set_colormap(XEN drawable, XEN colormap)
{
  #define H_gdk_drawable_set_colormap "void gdk_drawable_set_colormap(GdkDrawable* drawable, GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_set_colormap", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gdk_drawable_set_colormap", "GdkColormap*");
  gdk_drawable_set_colormap(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkColormap_(colormap));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drawable_get_colormap(XEN drawable)
{
  #define H_gdk_drawable_get_colormap "GdkColormap* gdk_drawable_get_colormap(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_colormap", "GdkDrawable*");
  return(C_TO_XEN_GdkColormap_(gdk_drawable_get_colormap(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_drawable_get_visual(XEN drawable)
{
  #define H_gdk_drawable_get_visual "GdkVisual* gdk_drawable_get_visual(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_visual", "GdkDrawable*");
  return(C_TO_XEN_GdkVisual_(gdk_drawable_get_visual(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_drawable_get_depth(XEN drawable)
{
  #define H_gdk_drawable_get_depth "gint gdk_drawable_get_depth(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_depth", "GdkDrawable*");
  return(C_TO_XEN_gint(gdk_drawable_get_depth(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_draw_point(XEN drawable, XEN gc, XEN x, XEN y)
{
  #define H_gdk_draw_point "void gdk_draw_point(GdkDrawable* drawable, GdkGC* gc, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_point", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_point", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_point", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_point", "gint");
  gdk_draw_point(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_line(XEN drawable, XEN gc, XEN x1, XEN y1, XEN x2, XEN y2)
{
  #define H_gdk_draw_line "void gdk_draw_line(GdkDrawable* drawable, GdkGC* gc, gint x1, gint y1, gint x2, \
gint y2)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_line", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_line", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x1), x1, 3, "gdk_draw_line", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y1), y1, 4, "gdk_draw_line", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(x2), x2, 5, "gdk_draw_line", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y2), y2, 6, "gdk_draw_line", "gint");
  gdk_draw_line(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x1), XEN_TO_C_gint(y1), XEN_TO_C_gint(x2), 
                XEN_TO_C_gint(y2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_rectangle(XEN drawable, XEN gc, XEN filled, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gdk_draw_rectangle "void gdk_draw_rectangle(GdkDrawable* drawable, GdkGC* gc, gboolean filled, \
gint x, gint y, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_rectangle", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_rectangle", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(filled), filled, 3, "gdk_draw_rectangle", "gboolean");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 4, "gdk_draw_rectangle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 5, "gdk_draw_rectangle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 6, "gdk_draw_rectangle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 7, "gdk_draw_rectangle", "gint");
  gdk_draw_rectangle(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gboolean(filled), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                     XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_arc(XEN drawable, XEN gc, XEN filled, XEN x, XEN y, XEN width, XEN height, XEN angle1, XEN angle2)
{
  #define H_gdk_draw_arc "void gdk_draw_arc(GdkDrawable* drawable, GdkGC* gc, gboolean filled, gint x, \
gint y, gint width, gint height, gint angle1, gint angle2)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_arc", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_arc", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(filled), filled, 3, "gdk_draw_arc", "gboolean");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 4, "gdk_draw_arc", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 5, "gdk_draw_arc", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 6, "gdk_draw_arc", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 7, "gdk_draw_arc", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(angle1), angle1, 8, "gdk_draw_arc", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(angle2), angle2, 9, "gdk_draw_arc", "gint");
  gdk_draw_arc(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gboolean(filled), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
               XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_gint(angle1), XEN_TO_C_gint(angle2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_polygon(XEN drawable, XEN gc, XEN filled, XEN points, XEN npoints)
{
  #define H_gdk_draw_polygon "void gdk_draw_polygon(GdkDrawable* drawable, GdkGC* gc, gboolean filled, \
GdkPoint* points, gint npoints)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_polygon", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_polygon", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(filled), filled, 3, "gdk_draw_polygon", "gboolean");
  XEN_ASSERT_TYPE(XEN_GdkPoint__P(points), points, 4, "gdk_draw_polygon", "GdkPoint*");
  XEN_ASSERT_TYPE(XEN_gint_P(npoints), npoints, 5, "gdk_draw_polygon", "gint");
  gdk_draw_polygon(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gboolean(filled), XEN_TO_C_GdkPoint_(points), 
                   XEN_TO_C_gint(npoints));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_drawable(XEN drawable, XEN gc, XEN src, XEN xsrc, XEN ysrc, XEN xdest, XEN ydest, XEN width, XEN height)
{
  #define H_gdk_draw_drawable "void gdk_draw_drawable(GdkDrawable* drawable, GdkGC* gc, GdkDrawable* src, \
gint xsrc, gint ysrc, gint xdest, gint ydest, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_drawable", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_drawable", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(src), src, 3, "gdk_draw_drawable", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_gint_P(xsrc), xsrc, 4, "gdk_draw_drawable", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ysrc), ysrc, 5, "gdk_draw_drawable", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(xdest), xdest, 6, "gdk_draw_drawable", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ydest), ydest, 7, "gdk_draw_drawable", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 8, "gdk_draw_drawable", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 9, "gdk_draw_drawable", "gint");
  gdk_draw_drawable(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkDrawable_(src), XEN_TO_C_gint(xsrc), 
                    XEN_TO_C_gint(ysrc), XEN_TO_C_gint(xdest), XEN_TO_C_gint(ydest), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_image(XEN drawable, XEN gc, XEN image, XEN xsrc, XEN ysrc, XEN xdest, XEN ydest, XEN width, XEN height)
{
  #define H_gdk_draw_image "void gdk_draw_image(GdkDrawable* drawable, GdkGC* gc, GdkImage* image, gint xsrc, \
gint ysrc, gint xdest, gint ydest, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_image", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkImage__P(image), image, 3, "gdk_draw_image", "GdkImage*");
  XEN_ASSERT_TYPE(XEN_gint_P(xsrc), xsrc, 4, "gdk_draw_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ysrc), ysrc, 5, "gdk_draw_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(xdest), xdest, 6, "gdk_draw_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ydest), ydest, 7, "gdk_draw_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 8, "gdk_draw_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 9, "gdk_draw_image", "gint");
  gdk_draw_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkImage_(image), XEN_TO_C_gint(xsrc), XEN_TO_C_gint(ysrc), 
                 XEN_TO_C_gint(xdest), XEN_TO_C_gint(ydest), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_points(XEN drawable, XEN gc, XEN points, XEN npoints)
{
  #define H_gdk_draw_points "void gdk_draw_points(GdkDrawable* drawable, GdkGC* gc, GdkPoint* points, \
gint npoints)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_points", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_points", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkPoint__P(points), points, 3, "gdk_draw_points", "GdkPoint*");
  XEN_ASSERT_TYPE(XEN_gint_P(npoints), npoints, 4, "gdk_draw_points", "gint");
  gdk_draw_points(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkPoint_(points), XEN_TO_C_gint(npoints));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_segments(XEN drawable, XEN gc, XEN segs, XEN nsegs)
{
  #define H_gdk_draw_segments "void gdk_draw_segments(GdkDrawable* drawable, GdkGC* gc, GdkSegment* segs, \
gint nsegs)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_segments", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_segments", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkSegment__P(segs), segs, 3, "gdk_draw_segments", "GdkSegment*");
  XEN_ASSERT_TYPE(XEN_gint_P(nsegs), nsegs, 4, "gdk_draw_segments", "gint");
  gdk_draw_segments(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkSegment_(segs), XEN_TO_C_gint(nsegs));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_lines(XEN drawable, XEN gc, XEN points, XEN npoints)
{
  #define H_gdk_draw_lines "void gdk_draw_lines(GdkDrawable* drawable, GdkGC* gc, GdkPoint* points, gint npoints)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_lines", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_lines", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkPoint__P(points), points, 3, "gdk_draw_lines", "GdkPoint*");
  XEN_ASSERT_TYPE(XEN_gint_P(npoints), npoints, 4, "gdk_draw_lines", "gint");
  gdk_draw_lines(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkPoint_(points), XEN_TO_C_gint(npoints));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_glyphs(XEN drawable, XEN gc, XEN font, XEN x, XEN y, XEN glyphs)
{
  #define H_gdk_draw_glyphs "void gdk_draw_glyphs(GdkDrawable* drawable, GdkGC* gc, PangoFont* font, \
gint x, gint y, PangoGlyphString* glyphs)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_glyphs", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_glyphs", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 3, "gdk_draw_glyphs", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 4, "gdk_draw_glyphs", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 5, "gdk_draw_glyphs", "gint");
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 6, "gdk_draw_glyphs", "PangoGlyphString*");
  gdk_draw_glyphs(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_PangoFont_(font), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                  XEN_TO_C_PangoGlyphString_(glyphs));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_layout_line(XEN drawable, XEN gc, XEN x, XEN y, XEN line)
{
  #define H_gdk_draw_layout_line "void gdk_draw_layout_line(GdkDrawable* drawable, GdkGC* gc, gint x, \
gint y, PangoLayoutLine* line)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_layout_line", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_layout_line", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_layout_line", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_layout_line", "gint");
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 5, "gdk_draw_layout_line", "PangoLayoutLine*");
  gdk_draw_layout_line(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_PangoLayoutLine_(line));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_layout(XEN drawable, XEN gc, XEN x, XEN y, XEN layout)
{
  #define H_gdk_draw_layout "void gdk_draw_layout(GdkDrawable* drawable, GdkGC* gc, gint x, gint y, PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_layout", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_layout", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_layout", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_layout", "gint");
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 5, "gdk_draw_layout", "PangoLayout*");
  gdk_draw_layout(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_PangoLayout_(layout));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_layout_line_with_colors(XEN drawable, XEN gc, XEN x, XEN y, XEN line, XEN foreground, XEN background)
{
  #define H_gdk_draw_layout_line_with_colors "void gdk_draw_layout_line_with_colors(GdkDrawable* drawable, \
GdkGC* gc, gint x, gint y, PangoLayoutLine* line, GdkColor* foreground, GdkColor* background)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_layout_line_with_colors", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_layout_line_with_colors", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_layout_line_with_colors", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_layout_line_with_colors", "gint");
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 5, "gdk_draw_layout_line_with_colors", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(foreground) || XEN_FALSE_P(foreground), foreground, 6, "gdk_draw_layout_line_with_colors", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(background) || XEN_FALSE_P(background), background, 7, "gdk_draw_layout_line_with_colors", "GdkColor*");
  gdk_draw_layout_line_with_colors(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                                   XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_GdkColor_(foreground), XEN_TO_C_GdkColor_(background));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_layout_with_colors(XEN drawable, XEN gc, XEN x, XEN y, XEN layout, XEN foreground, XEN background)
{
  #define H_gdk_draw_layout_with_colors "void gdk_draw_layout_with_colors(GdkDrawable* drawable, GdkGC* gc, \
gint x, gint y, PangoLayout* layout, GdkColor* foreground, GdkColor* background)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_layout_with_colors", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_layout_with_colors", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_layout_with_colors", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_layout_with_colors", "gint");
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 5, "gdk_draw_layout_with_colors", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(foreground) || XEN_FALSE_P(foreground), foreground, 6, "gdk_draw_layout_with_colors", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(background) || XEN_FALSE_P(background), background, 7, "gdk_draw_layout_with_colors", "GdkColor*");
  gdk_draw_layout_with_colors(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_PangoLayout_(layout), 
                              XEN_TO_C_GdkColor_(foreground), XEN_TO_C_GdkColor_(background));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drawable_get_image(XEN drawable, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gdk_drawable_get_image "GdkImage* gdk_drawable_get_image(GdkDrawable* drawable, gint x, gint y, \
gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_drawable_get_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_drawable_get_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 4, "gdk_drawable_get_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 5, "gdk_drawable_get_image", "gint");
  return(C_TO_XEN_GdkImage_(gdk_drawable_get_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                                                   XEN_TO_C_gint(height))));
}
static XEN gxg_gdk_drawable_get_clip_region(XEN drawable)
{
  #define H_gdk_drawable_get_clip_region "GdkRegion* gdk_drawable_get_clip_region(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_clip_region", "GdkDrawable*");
  return(C_TO_XEN_GdkRegion_(gdk_drawable_get_clip_region(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_drawable_get_visible_region(XEN drawable)
{
  #define H_gdk_drawable_get_visible_region "GdkRegion* gdk_drawable_get_visible_region(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_get_visible_region", "GdkDrawable*");
  return(C_TO_XEN_GdkRegion_(gdk_drawable_get_visible_region(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_cursor_type_get_type(void)
{
  #define H_gdk_cursor_type_get_type "GType gdk_cursor_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_cursor_type_get_type()));
}
static XEN gxg_gdk_drag_action_get_type(void)
{
  #define H_gdk_drag_action_get_type "GType gdk_drag_action_get_type( void)"
  return(C_TO_XEN_GType(gdk_drag_action_get_type()));
}
static XEN gxg_gdk_drag_protocol_get_type(void)
{
  #define H_gdk_drag_protocol_get_type "GType gdk_drag_protocol_get_type( void)"
  return(C_TO_XEN_GType(gdk_drag_protocol_get_type()));
}
static XEN gxg_gdk_filter_return_get_type(void)
{
  #define H_gdk_filter_return_get_type "GType gdk_filter_return_get_type( void)"
  return(C_TO_XEN_GType(gdk_filter_return_get_type()));
}
static XEN gxg_gdk_event_type_get_type(void)
{
  #define H_gdk_event_type_get_type "GType gdk_event_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_event_type_get_type()));
}
static XEN gxg_gdk_event_mask_get_type(void)
{
  #define H_gdk_event_mask_get_type "GType gdk_event_mask_get_type( void)"
  return(C_TO_XEN_GType(gdk_event_mask_get_type()));
}
static XEN gxg_gdk_visibility_state_get_type(void)
{
  #define H_gdk_visibility_state_get_type "GType gdk_visibility_state_get_type( void)"
  return(C_TO_XEN_GType(gdk_visibility_state_get_type()));
}
static XEN gxg_gdk_scroll_direction_get_type(void)
{
  #define H_gdk_scroll_direction_get_type "GType gdk_scroll_direction_get_type( void)"
  return(C_TO_XEN_GType(gdk_scroll_direction_get_type()));
}
static XEN gxg_gdk_notify_type_get_type(void)
{
  #define H_gdk_notify_type_get_type "GType gdk_notify_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_notify_type_get_type()));
}
static XEN gxg_gdk_crossing_mode_get_type(void)
{
  #define H_gdk_crossing_mode_get_type "GType gdk_crossing_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_crossing_mode_get_type()));
}
static XEN gxg_gdk_property_state_get_type(void)
{
  #define H_gdk_property_state_get_type "GType gdk_property_state_get_type( void)"
  return(C_TO_XEN_GType(gdk_property_state_get_type()));
}
static XEN gxg_gdk_window_state_get_type(void)
{
  #define H_gdk_window_state_get_type "GType gdk_window_state_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_state_get_type()));
}
static XEN gxg_gdk_setting_action_get_type(void)
{
  #define H_gdk_setting_action_get_type "GType gdk_setting_action_get_type( void)"
  return(C_TO_XEN_GType(gdk_setting_action_get_type()));
}
static XEN gxg_gdk_font_type_get_type(void)
{
  #define H_gdk_font_type_get_type "GType gdk_font_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_font_type_get_type()));
}
static XEN gxg_gdk_cap_style_get_type(void)
{
  #define H_gdk_cap_style_get_type "GType gdk_cap_style_get_type( void)"
  return(C_TO_XEN_GType(gdk_cap_style_get_type()));
}
static XEN gxg_gdk_fill_get_type(void)
{
  #define H_gdk_fill_get_type "GType gdk_fill_get_type( void)"
  return(C_TO_XEN_GType(gdk_fill_get_type()));
}
static XEN gxg_gdk_function_get_type(void)
{
  #define H_gdk_function_get_type "GType gdk_function_get_type( void)"
  return(C_TO_XEN_GType(gdk_function_get_type()));
}
static XEN gxg_gdk_join_style_get_type(void)
{
  #define H_gdk_join_style_get_type "GType gdk_join_style_get_type( void)"
  return(C_TO_XEN_GType(gdk_join_style_get_type()));
}
static XEN gxg_gdk_line_style_get_type(void)
{
  #define H_gdk_line_style_get_type "GType gdk_line_style_get_type( void)"
  return(C_TO_XEN_GType(gdk_line_style_get_type()));
}
static XEN gxg_gdk_subwindow_mode_get_type(void)
{
  #define H_gdk_subwindow_mode_get_type "GType gdk_subwindow_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_subwindow_mode_get_type()));
}
static XEN gxg_gdk_gc_values_mask_get_type(void)
{
  #define H_gdk_gc_values_mask_get_type "GType gdk_gc_values_mask_get_type( void)"
  return(C_TO_XEN_GType(gdk_gc_values_mask_get_type()));
}
static XEN gxg_gdk_image_type_get_type(void)
{
  #define H_gdk_image_type_get_type "GType gdk_image_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_image_type_get_type()));
}
static XEN gxg_gdk_extension_mode_get_type(void)
{
  #define H_gdk_extension_mode_get_type "GType gdk_extension_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_extension_mode_get_type()));
}
static XEN gxg_gdk_input_source_get_type(void)
{
  #define H_gdk_input_source_get_type "GType gdk_input_source_get_type( void)"
  return(C_TO_XEN_GType(gdk_input_source_get_type()));
}
static XEN gxg_gdk_input_mode_get_type(void)
{
  #define H_gdk_input_mode_get_type "GType gdk_input_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_input_mode_get_type()));
}
static XEN gxg_gdk_axis_use_get_type(void)
{
  #define H_gdk_axis_use_get_type "GType gdk_axis_use_get_type( void)"
  return(C_TO_XEN_GType(gdk_axis_use_get_type()));
}
static XEN gxg_gdk_prop_mode_get_type(void)
{
  #define H_gdk_prop_mode_get_type "GType gdk_prop_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_prop_mode_get_type()));
}
static XEN gxg_gdk_fill_rule_get_type(void)
{
  #define H_gdk_fill_rule_get_type "GType gdk_fill_rule_get_type( void)"
  return(C_TO_XEN_GType(gdk_fill_rule_get_type()));
}
static XEN gxg_gdk_overlap_type_get_type(void)
{
  #define H_gdk_overlap_type_get_type "GType gdk_overlap_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_overlap_type_get_type()));
}
static XEN gxg_gdk_rgb_dither_get_type(void)
{
  #define H_gdk_rgb_dither_get_type "GType gdk_rgb_dither_get_type( void)"
  return(C_TO_XEN_GType(gdk_rgb_dither_get_type()));
}
static XEN gxg_gdk_byte_order_get_type(void)
{
  #define H_gdk_byte_order_get_type "GType gdk_byte_order_get_type( void)"
  return(C_TO_XEN_GType(gdk_byte_order_get_type()));
}
static XEN gxg_gdk_modifier_type_get_type(void)
{
  #define H_gdk_modifier_type_get_type "GType gdk_modifier_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_modifier_type_get_type()));
}
static XEN gxg_gdk_input_condition_get_type(void)
{
  #define H_gdk_input_condition_get_type "GType gdk_input_condition_get_type( void)"
  return(C_TO_XEN_GType(gdk_input_condition_get_type()));
}
static XEN gxg_gdk_status_get_type(void)
{
  #define H_gdk_status_get_type "GType gdk_status_get_type( void)"
  return(C_TO_XEN_GType(gdk_status_get_type()));
}
static XEN gxg_gdk_grab_status_get_type(void)
{
  #define H_gdk_grab_status_get_type "GType gdk_grab_status_get_type( void)"
  return(C_TO_XEN_GType(gdk_grab_status_get_type()));
}
static XEN gxg_gdk_visual_type_get_type(void)
{
  #define H_gdk_visual_type_get_type "GType gdk_visual_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_visual_type_get_type()));
}
static XEN gxg_gdk_window_class_get_type(void)
{
  #define H_gdk_window_class_get_type "GType gdk_window_class_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_class_get_type()));
}
static XEN gxg_gdk_window_type_get_type(void)
{
  #define H_gdk_window_type_get_type "GType gdk_window_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_type_get_type()));
}
static XEN gxg_gdk_window_attributes_type_get_type(void)
{
  #define H_gdk_window_attributes_type_get_type "GType gdk_window_attributes_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_attributes_type_get_type()));
}
static XEN gxg_gdk_window_hints_get_type(void)
{
  #define H_gdk_window_hints_get_type "GType gdk_window_hints_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_hints_get_type()));
}
static XEN gxg_gdk_window_type_hint_get_type(void)
{
  #define H_gdk_window_type_hint_get_type "GType gdk_window_type_hint_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_type_hint_get_type()));
}
static XEN gxg_gdk_wm_decoration_get_type(void)
{
  #define H_gdk_wm_decoration_get_type "GType gdk_wm_decoration_get_type( void)"
  return(C_TO_XEN_GType(gdk_wm_decoration_get_type()));
}
static XEN gxg_gdk_wm_function_get_type(void)
{
  #define H_gdk_wm_function_get_type "GType gdk_wm_function_get_type( void)"
  return(C_TO_XEN_GType(gdk_wm_function_get_type()));
}
static XEN gxg_gdk_gravity_get_type(void)
{
  #define H_gdk_gravity_get_type "GType gdk_gravity_get_type( void)"
  return(C_TO_XEN_GType(gdk_gravity_get_type()));
}
static XEN gxg_gdk_window_edge_get_type(void)
{
  #define H_gdk_window_edge_get_type "GType gdk_window_edge_get_type( void)"
  return(C_TO_XEN_GType(gdk_window_edge_get_type()));
}
static XEN gxg_gdk_event_get_type(void)
{
  #define H_gdk_event_get_type "GType gdk_event_get_type( void)"
  return(C_TO_XEN_GType(gdk_event_get_type()));
}
static XEN gxg_gdk_events_pending(void)
{
  #define H_gdk_events_pending "gboolean gdk_events_pending( void)"
  return(C_TO_XEN_gboolean(gdk_events_pending()));
}
static XEN gxg_gdk_event_get(void)
{
  #define H_gdk_event_get "GdkEvent* gdk_event_get( void)"
  return(C_TO_XEN_GdkEvent_(gdk_event_get()));
}
static XEN gxg_gdk_event_peek(void)
{
  #define H_gdk_event_peek "GdkEvent* gdk_event_peek( void)"
  return(C_TO_XEN_GdkEvent_(gdk_event_peek()));
}
static XEN gxg_gdk_event_get_graphics_expose(XEN window)
{
  #define H_gdk_event_get_graphics_expose "GdkEvent* gdk_event_get_graphics_expose(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_event_get_graphics_expose", "GdkWindow*");
  return(C_TO_XEN_GdkEvent_(gdk_event_get_graphics_expose(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_event_put(XEN event)
{
  #define H_gdk_event_put "void gdk_event_put(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_put", "GdkEvent*");
  gdk_event_put(XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gdk_event_copy(XEN event)
{
  #define H_gdk_event_copy "GdkEvent* gdk_event_copy(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_copy", "GdkEvent*");
  return(C_TO_XEN_GdkEvent_(gdk_event_copy(XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gdk_event_free(XEN event)
{
  #define H_gdk_event_free "void gdk_event_free(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_free", "GdkEvent*");
  gdk_event_free(XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gdk_event_get_time(XEN event)
{
  #define H_gdk_event_get_time "guint32 gdk_event_get_time(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event) || XEN_FALSE_P(event), event, 1, "gdk_event_get_time", "GdkEvent*");
  return(C_TO_XEN_guint32(gdk_event_get_time(XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gdk_event_get_state(XEN event, XEN state)
{
  #define H_gdk_event_get_state "gboolean gdk_event_get_state(GdkEvent* event, GdkModifierType* [state])"
  GdkModifierType ref_state;
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_get_state", "GdkEvent*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_event_get_state(XEN_TO_C_GdkEvent_(event), &ref_state));
    return(XEN_LIST_2(result, C_TO_XEN_GdkModifierType(ref_state)));
   }
}
static XEN gxg_gdk_event_get_coords(XEN event, XEN x_win, XEN y_win)
{
  #define H_gdk_event_get_coords "gboolean gdk_event_get_coords(GdkEvent* event, gdouble* [x_win], gdouble* [y_win])"
  gdouble ref_x_win;
  gdouble ref_y_win;
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_get_coords", "GdkEvent*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_event_get_coords(XEN_TO_C_GdkEvent_(event), &ref_x_win, &ref_y_win));
    return(XEN_LIST_3(result, C_TO_XEN_gdouble(ref_x_win), C_TO_XEN_gdouble(ref_y_win)));
   }
}
static XEN gxg_gdk_event_get_root_coords(XEN event, XEN x_root, XEN y_root)
{
  #define H_gdk_event_get_root_coords "gboolean gdk_event_get_root_coords(GdkEvent* event, gdouble* [x_root], \
gdouble* [y_root])"
  gdouble ref_x_root;
  gdouble ref_y_root;
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_get_root_coords", "GdkEvent*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_event_get_root_coords(XEN_TO_C_GdkEvent_(event), &ref_x_root, &ref_y_root));
    return(XEN_LIST_3(result, C_TO_XEN_gdouble(ref_x_root), C_TO_XEN_gdouble(ref_y_root)));
   }
}
static XEN gxg_gdk_event_get_axis(XEN event, XEN axis_use, XEN value)
{
  #define H_gdk_event_get_axis "gboolean gdk_event_get_axis(GdkEvent* event, GdkAxisUse axis_use, gdouble* [value])"
  gdouble ref_value;
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_get_axis", "GdkEvent*");
  XEN_ASSERT_TYPE(XEN_GdkAxisUse_P(axis_use), axis_use, 2, "gdk_event_get_axis", "GdkAxisUse");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_event_get_axis(XEN_TO_C_GdkEvent_(event), XEN_TO_C_GdkAxisUse(axis_use), &ref_value));
    return(XEN_LIST_2(result, C_TO_XEN_gdouble(ref_value)));
   }
}
static XEN gxg_gdk_event_handler_set(XEN func, XEN func_data, XEN notify)
{
  #define H_gdk_event_handler_set "void gdk_event_handler_set(GdkEventFunc func, lambda_data func_data, \
GtkDestroyNotify notify)"
  XEN_ASSERT_TYPE(XEN_GdkEventFunc_P(func), func, 1, "gdk_event_handler_set", "GdkEventFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 2, "gdk_event_handler_set", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(notify), notify, 3, "gdk_event_handler_set", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, notify);
    gdk_event_handler_set(XEN_TO_C_GdkEventFunc(func), XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(notify));
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_set_show_events(XEN show_events)
{
  #define H_gdk_set_show_events "void gdk_set_show_events(gboolean show_events)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_events), show_events, 1, "gdk_set_show_events", "gboolean");
  gdk_set_show_events(XEN_TO_C_gboolean(show_events));
  return(XEN_FALSE);
}
static XEN gxg_gdk_get_show_events(void)
{
  #define H_gdk_get_show_events "gboolean gdk_get_show_events( void)"
  return(C_TO_XEN_gboolean(gdk_get_show_events()));
}
static XEN gxg_gdk_add_client_message_filter(XEN message_type, XEN func, XEN func_data)
{
  #define H_gdk_add_client_message_filter "void gdk_add_client_message_filter(GdkAtom message_type, GdkFilterFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(message_type), message_type, 1, "gdk_add_client_message_filter", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkFilterFunc_P(func), func, 2, "gdk_add_client_message_filter", "GdkFilterFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gdk_add_client_message_filter", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gdk_add_client_message_filter(XEN_TO_C_GdkAtom(message_type), XEN_TO_C_GdkFilterFunc(func), XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_gc_get_type(void)
{
  #define H_gdk_gc_get_type "GType gdk_gc_get_type( void)"
  return(C_TO_XEN_GType(gdk_gc_get_type()));
}
static XEN gxg_gdk_gc_new(XEN drawable)
{
  #define H_gdk_gc_new "GdkGC* gdk_gc_new(GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_gc_new", "GdkDrawable*");
  return(C_TO_XEN_GdkGC_(gdk_gc_new(XEN_TO_C_GdkDrawable_(drawable))));
}
static XEN gxg_gdk_gc_new_with_values(XEN drawable, XEN values, XEN values_mask)
{
  #define H_gdk_gc_new_with_values "GdkGC* gdk_gc_new_with_values(GdkDrawable* drawable, GdkGCValues* values, \
GdkGCValuesMask values_mask)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_gc_new_with_values", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(values), values, 2, "gdk_gc_new_with_values", "GdkGCValues*");
  XEN_ASSERT_TYPE(XEN_GdkGCValuesMask_P(values_mask), values_mask, 3, "gdk_gc_new_with_values", "GdkGCValuesMask");
  return(C_TO_XEN_GdkGC_(gdk_gc_new_with_values(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGCValues_(values), XEN_TO_C_GdkGCValuesMask(values_mask))));
}
static XEN gxg_gdk_gc_get_values(XEN gc, XEN values)
{
  #define H_gdk_gc_get_values "void gdk_gc_get_values(GdkGC* gc, GdkGCValues* values)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_get_values", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(values), values, 2, "gdk_gc_get_values", "GdkGCValues*");
  gdk_gc_get_values(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkGCValues_(values));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_values(XEN gc, XEN values, XEN values_mask)
{
  #define H_gdk_gc_set_values "void gdk_gc_set_values(GdkGC* gc, GdkGCValues* values, GdkGCValuesMask values_mask)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_values", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(values), values, 2, "gdk_gc_set_values", "GdkGCValues*");
  XEN_ASSERT_TYPE(XEN_GdkGCValuesMask_P(values_mask), values_mask, 3, "gdk_gc_set_values", "GdkGCValuesMask");
  gdk_gc_set_values(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkGCValues_(values), XEN_TO_C_GdkGCValuesMask(values_mask));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_foreground(XEN gc, XEN color)
{
  #define H_gdk_gc_set_foreground "void gdk_gc_set_foreground(GdkGC* gc, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_foreground", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_gc_set_foreground", "GdkColor*");
  gdk_gc_set_foreground(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_background(XEN gc, XEN color)
{
  #define H_gdk_gc_set_background "void gdk_gc_set_background(GdkGC* gc, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_background", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_gc_set_background", "GdkColor*");
  gdk_gc_set_background(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_function(XEN gc, XEN function)
{
  #define H_gdk_gc_set_function "void gdk_gc_set_function(GdkGC* gc, GdkFunction function)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_function", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkFunction_P(function), function, 2, "gdk_gc_set_function", "GdkFunction");
  gdk_gc_set_function(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkFunction(function));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_fill(XEN gc, XEN fill)
{
  #define H_gdk_gc_set_fill "void gdk_gc_set_fill(GdkGC* gc, GdkFill fill)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_fill", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkFill_P(fill), fill, 2, "gdk_gc_set_fill", "GdkFill");
  gdk_gc_set_fill(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkFill(fill));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_tile(XEN gc, XEN tile)
{
  #define H_gdk_gc_set_tile "void gdk_gc_set_tile(GdkGC* gc, GdkPixmap* tile)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_tile", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(tile), tile, 2, "gdk_gc_set_tile", "GdkPixmap*");
  gdk_gc_set_tile(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkPixmap_(tile));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_stipple(XEN gc, XEN stipple)
{
  #define H_gdk_gc_set_stipple "void gdk_gc_set_stipple(GdkGC* gc, GdkPixmap* stipple)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_stipple", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(stipple), stipple, 2, "gdk_gc_set_stipple", "GdkPixmap*");
  gdk_gc_set_stipple(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkPixmap_(stipple));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_ts_origin(XEN gc, XEN x, XEN y)
{
  #define H_gdk_gc_set_ts_origin "void gdk_gc_set_ts_origin(GdkGC* gc, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_ts_origin", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_gc_set_ts_origin", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_gc_set_ts_origin", "gint");
  gdk_gc_set_ts_origin(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_clip_origin(XEN gc, XEN x, XEN y)
{
  #define H_gdk_gc_set_clip_origin "void gdk_gc_set_clip_origin(GdkGC* gc, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_clip_origin", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_gc_set_clip_origin", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_gc_set_clip_origin", "gint");
  gdk_gc_set_clip_origin(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_clip_mask(XEN gc, XEN mask)
{
  #define H_gdk_gc_set_clip_mask "void gdk_gc_set_clip_mask(GdkGC* gc, GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_clip_mask", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask), mask, 2, "gdk_gc_set_clip_mask", "GdkBitmap*");
  gdk_gc_set_clip_mask(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkBitmap_(mask));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_clip_rectangle(XEN gc, XEN rectangle)
{
  #define H_gdk_gc_set_clip_rectangle "void gdk_gc_set_clip_rectangle(GdkGC* gc, GdkRectangle* rectangle)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_clip_rectangle", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rectangle), rectangle, 2, "gdk_gc_set_clip_rectangle", "GdkRectangle*");
  gdk_gc_set_clip_rectangle(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkRectangle_(rectangle));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_clip_region(XEN gc, XEN region)
{
  #define H_gdk_gc_set_clip_region "void gdk_gc_set_clip_region(GdkGC* gc, GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_clip_region", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 2, "gdk_gc_set_clip_region", "GdkRegion*");
  gdk_gc_set_clip_region(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkRegion_(region));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_subwindow(XEN gc, XEN mode)
{
  #define H_gdk_gc_set_subwindow "void gdk_gc_set_subwindow(GdkGC* gc, GdkSubwindowMode mode)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_subwindow", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkSubwindowMode_P(mode), mode, 2, "gdk_gc_set_subwindow", "GdkSubwindowMode");
  gdk_gc_set_subwindow(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkSubwindowMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_exposures(XEN gc, XEN exposures)
{
  #define H_gdk_gc_set_exposures "void gdk_gc_set_exposures(GdkGC* gc, gboolean exposures)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_exposures", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(exposures), exposures, 2, "gdk_gc_set_exposures", "gboolean");
  gdk_gc_set_exposures(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gboolean(exposures));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_line_attributes(XEN gc, XEN line_width, XEN line_style, XEN cap_style, XEN join_style)
{
  #define H_gdk_gc_set_line_attributes "void gdk_gc_set_line_attributes(GdkGC* gc, gint line_width, GdkLineStyle line_style, \
GdkCapStyle cap_style, GdkJoinStyle join_style)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_line_attributes", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(line_width), line_width, 2, "gdk_gc_set_line_attributes", "gint");
  XEN_ASSERT_TYPE(XEN_GdkLineStyle_P(line_style), line_style, 3, "gdk_gc_set_line_attributes", "GdkLineStyle");
  XEN_ASSERT_TYPE(XEN_GdkCapStyle_P(cap_style), cap_style, 4, "gdk_gc_set_line_attributes", "GdkCapStyle");
  XEN_ASSERT_TYPE(XEN_GdkJoinStyle_P(join_style), join_style, 5, "gdk_gc_set_line_attributes", "GdkJoinStyle");
  gdk_gc_set_line_attributes(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(line_width), XEN_TO_C_GdkLineStyle(line_style), XEN_TO_C_GdkCapStyle(cap_style), 
                             XEN_TO_C_GdkJoinStyle(join_style));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_dashes(XEN gc, XEN dash_offset, XEN dash_list, XEN n)
{
  #define H_gdk_gc_set_dashes "void gdk_gc_set_dashes(GdkGC* gc, gint dash_offset, gint8* dash_list, \
gint n)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_dashes", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(dash_offset), dash_offset, 2, "gdk_gc_set_dashes", "gint");
  XEN_ASSERT_TYPE(XEN_gint8__P(dash_list), dash_list, 3, "gdk_gc_set_dashes", "gint8*");
  XEN_ASSERT_TYPE(XEN_gint_P(n), n, 4, "gdk_gc_set_dashes", "gint");
  gdk_gc_set_dashes(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(dash_offset), XEN_TO_C_gint8_(dash_list), XEN_TO_C_gint(n));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_offset(XEN gc, XEN x_offset, XEN y_offset)
{
  #define H_gdk_gc_offset "void gdk_gc_offset(GdkGC* gc, gint x_offset, gint y_offset)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_offset", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x_offset), x_offset, 2, "gdk_gc_offset", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y_offset), y_offset, 3, "gdk_gc_offset", "gint");
  gdk_gc_offset(XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x_offset), XEN_TO_C_gint(y_offset));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_copy(XEN dst_gc, XEN src_gc)
{
  #define H_gdk_gc_copy "void gdk_gc_copy(GdkGC* dst_gc, GdkGC* src_gc)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(dst_gc), dst_gc, 1, "gdk_gc_copy", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(src_gc), src_gc, 2, "gdk_gc_copy", "GdkGC*");
  gdk_gc_copy(XEN_TO_C_GdkGC_(dst_gc), XEN_TO_C_GdkGC_(src_gc));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_colormap(XEN gc, XEN colormap)
{
  #define H_gdk_gc_set_colormap "void gdk_gc_set_colormap(GdkGC* gc, GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_colormap", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gdk_gc_set_colormap", "GdkColormap*");
  gdk_gc_set_colormap(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkColormap_(colormap));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_get_colormap(XEN gc)
{
  #define H_gdk_gc_get_colormap "GdkColormap* gdk_gc_get_colormap(GdkGC* gc)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_get_colormap", "GdkGC*");
  return(C_TO_XEN_GdkColormap_(gdk_gc_get_colormap(XEN_TO_C_GdkGC_(gc))));
}
static XEN gxg_gdk_gc_set_rgb_fg_color(XEN gc, XEN color)
{
  #define H_gdk_gc_set_rgb_fg_color "void gdk_gc_set_rgb_fg_color(GdkGC* gc, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_rgb_fg_color", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_gc_set_rgb_fg_color", "GdkColor*");
  gdk_gc_set_rgb_fg_color(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_gc_set_rgb_bg_color(XEN gc, XEN color)
{
  #define H_gdk_gc_set_rgb_bg_color "void gdk_gc_set_rgb_bg_color(GdkGC* gc, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gdk_gc_set_rgb_bg_color", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_gc_set_rgb_bg_color", "GdkColor*");
  gdk_gc_set_rgb_bg_color(XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_init(XEN argc, XEN argv)
{
  #define H_gdk_init "void gdk_init(gint* {argc}, gchar*** |argv|)"
  gint ref_argc;
  gchar** ref_argv = NULL;
  ref_argc = XEN_TO_C_gint(argc);
  ref_argv = (gchar**)calloc(ref_argc, sizeof(gchar*));
  {
   int i;
   XEN lst;
   lst = XEN_COPY_ARG(argv);
   for (i = 0; i < ref_argc; i++, lst = XEN_CDR(lst)) ref_argv[i] = XEN_TO_C_gchar_(XEN_CAR(lst));
  }
  gdk_init(&ref_argc, &ref_argv);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_argc), C_TO_XEN_gchar__(ref_argv)));
}
static XEN gxg_gdk_init_check(XEN argc, XEN argv)
{
  #define H_gdk_init_check "gboolean gdk_init_check(gint* {argc}, gchar*** |argv|)"
  gint ref_argc;
  gchar** ref_argv = NULL;
  ref_argc = XEN_TO_C_gint(argc);
  ref_argv = (gchar**)calloc(ref_argc, sizeof(gchar*));
  {
   int i;
   XEN lst;
   lst = XEN_COPY_ARG(argv);
   for (i = 0; i < ref_argc; i++, lst = XEN_CDR(lst)) ref_argv[i] = XEN_TO_C_gchar_(XEN_CAR(lst));
  }
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_init_check(&ref_argc, &ref_argv));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_argc), C_TO_XEN_gchar__(ref_argv)));
   }
}
static XEN gxg_gdk_set_locale(void)
{
  #define H_gdk_set_locale "gchar* gdk_set_locale( void)"
  return(C_TO_XEN_gchar_(gdk_set_locale()));
}
static XEN gxg_gdk_get_program_class(void)
{
  #define H_gdk_get_program_class "char* gdk_get_program_class( void)"
  return(C_TO_XEN_char_(gdk_get_program_class()));
}
static XEN gxg_gdk_set_program_class(XEN program_class)
{
  #define H_gdk_set_program_class "void gdk_set_program_class(char* program_class)"
  XEN_ASSERT_TYPE(XEN_char__P(program_class), program_class, 1, "gdk_set_program_class", "char*");
  gdk_set_program_class(XEN_TO_C_char_(program_class));
  return(XEN_FALSE);
}
static XEN gxg_gdk_error_trap_push(void)
{
  #define H_gdk_error_trap_push "void gdk_error_trap_push( void)"
  gdk_error_trap_push();
  return(XEN_FALSE);
}
static XEN gxg_gdk_error_trap_pop(void)
{
  #define H_gdk_error_trap_pop "gint gdk_error_trap_pop( void)"
  return(C_TO_XEN_gint(gdk_error_trap_pop()));
}
static XEN gxg_gdk_get_display(void)
{
  #define H_gdk_get_display "gchar* gdk_get_display( void)"
  {
   gchar* result;
   XEN rtn;
   result = gdk_get_display();
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gdk_pointer_grab(XEN window, XEN owner_events, XEN event_mask, XEN confine_to, XEN cursor, XEN time)
{
  #define H_gdk_pointer_grab "GdkGrabStatus gdk_pointer_grab(GdkWindow* window, gboolean owner_events, \
GdkEventMask event_mask, GdkWindow* confine_to, GdkCursor* cursor, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_pointer_grab", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(owner_events), owner_events, 2, "gdk_pointer_grab", "gboolean");
  XEN_ASSERT_TYPE(XEN_GdkEventMask_P(event_mask), event_mask, 3, "gdk_pointer_grab", "GdkEventMask");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(confine_to), confine_to, 4, "gdk_pointer_grab", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkCursor__P(cursor), cursor, 5, "gdk_pointer_grab", "GdkCursor*");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 6, "gdk_pointer_grab", "guint32");
  return(C_TO_XEN_GdkGrabStatus(gdk_pointer_grab(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(owner_events), XEN_TO_C_GdkEventMask(event_mask), 
                                                 XEN_TO_C_GdkWindow_(confine_to), XEN_TO_C_GdkCursor_(cursor), XEN_TO_C_guint32(time))));
}
static XEN gxg_gdk_pointer_ungrab(XEN time)
{
  #define H_gdk_pointer_ungrab "void gdk_pointer_ungrab(guint32 time)"
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 1, "gdk_pointer_ungrab", "guint32");
  gdk_pointer_ungrab(XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_keyboard_grab(XEN window, XEN owner_events, XEN time)
{
  #define H_gdk_keyboard_grab "GdkGrabStatus gdk_keyboard_grab(GdkWindow* window, gboolean owner_events, \
guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_keyboard_grab", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(owner_events), owner_events, 2, "gdk_keyboard_grab", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gdk_keyboard_grab", "guint32");
  return(C_TO_XEN_GdkGrabStatus(gdk_keyboard_grab(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(owner_events), XEN_TO_C_guint32(time))));
}
static XEN gxg_gdk_keyboard_ungrab(XEN time)
{
  #define H_gdk_keyboard_ungrab "void gdk_keyboard_ungrab(guint32 time)"
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 1, "gdk_keyboard_ungrab", "guint32");
  gdk_keyboard_ungrab(XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pointer_is_grabbed(void)
{
  #define H_gdk_pointer_is_grabbed "gboolean gdk_pointer_is_grabbed( void)"
  return(C_TO_XEN_gboolean(gdk_pointer_is_grabbed()));
}
static XEN gxg_gdk_screen_width(void)
{
  #define H_gdk_screen_width "gint gdk_screen_width( void)"
  return(C_TO_XEN_gint(gdk_screen_width()));
}
static XEN gxg_gdk_screen_height(void)
{
  #define H_gdk_screen_height "gint gdk_screen_height( void)"
  return(C_TO_XEN_gint(gdk_screen_height()));
}
static XEN gxg_gdk_screen_width_mm(void)
{
  #define H_gdk_screen_width_mm "gint gdk_screen_width_mm( void)"
  return(C_TO_XEN_gint(gdk_screen_width_mm()));
}
static XEN gxg_gdk_screen_height_mm(void)
{
  #define H_gdk_screen_height_mm "gint gdk_screen_height_mm( void)"
  return(C_TO_XEN_gint(gdk_screen_height_mm()));
}
static XEN gxg_gdk_flush(void)
{
  #define H_gdk_flush "void gdk_flush( void)"
  gdk_flush();
  return(XEN_FALSE);
}
static XEN gxg_gdk_beep(void)
{
  #define H_gdk_beep "void gdk_beep( void)"
  gdk_beep();
  return(XEN_FALSE);
}
static XEN gxg_gdk_set_double_click_time(XEN msec)
{
  #define H_gdk_set_double_click_time "void gdk_set_double_click_time(guint msec)"
  XEN_ASSERT_TYPE(XEN_guint_P(msec), msec, 1, "gdk_set_double_click_time", "guint");
  gdk_set_double_click_time(XEN_TO_C_guint(msec));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rectangle_intersect(XEN src1, XEN src2, XEN dest)
{
  #define H_gdk_rectangle_intersect "gboolean gdk_rectangle_intersect(GdkRectangle* src1, GdkRectangle* src2, \
GdkRectangle* dest)"
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(src1), src1, 1, "gdk_rectangle_intersect", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(src2), src2, 2, "gdk_rectangle_intersect", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(dest), dest, 3, "gdk_rectangle_intersect", "GdkRectangle*");
  return(C_TO_XEN_gboolean(gdk_rectangle_intersect(XEN_TO_C_GdkRectangle_(src1), XEN_TO_C_GdkRectangle_(src2), XEN_TO_C_GdkRectangle_(dest))));
}
static XEN gxg_gdk_rectangle_union(XEN src1, XEN src2, XEN dest)
{
  #define H_gdk_rectangle_union "void gdk_rectangle_union(GdkRectangle* src1, GdkRectangle* src2, GdkRectangle* dest)"
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(src1), src1, 1, "gdk_rectangle_union", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(src2), src2, 2, "gdk_rectangle_union", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(dest), dest, 3, "gdk_rectangle_union", "GdkRectangle*");
  gdk_rectangle_union(XEN_TO_C_GdkRectangle_(src1), XEN_TO_C_GdkRectangle_(src2), XEN_TO_C_GdkRectangle_(dest));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rectangle_get_type(void)
{
  #define H_gdk_rectangle_get_type "GType gdk_rectangle_get_type( void)"
  return(C_TO_XEN_GType(gdk_rectangle_get_type()));
}
static XEN gxg_gdk_event_send_clientmessage_toall(XEN event)
{
  #define H_gdk_event_send_clientmessage_toall "void gdk_event_send_clientmessage_toall(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_send_clientmessage_toall", "GdkEvent*");
  gdk_event_send_clientmessage_toall(XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gdk_event_send_client_message(XEN event, XEN xid)
{
  #define H_gdk_event_send_client_message "gboolean gdk_event_send_client_message(GdkEvent* event, guint32 xid)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gdk_event_send_client_message", "GdkEvent*");
  XEN_ASSERT_TYPE(XEN_guint32_P(xid), xid, 2, "gdk_event_send_client_message", "guint32");
  return(C_TO_XEN_gboolean(gdk_event_send_client_message(XEN_TO_C_GdkEvent_(event), XEN_TO_C_guint32(xid))));
}
static XEN gxg_gdk_threads_enter(void)
{
  #define H_gdk_threads_enter "void gdk_threads_enter( void)"
  gdk_threads_enter();
  return(XEN_FALSE);
}
static XEN gxg_gdk_threads_leave(void)
{
  #define H_gdk_threads_leave "void gdk_threads_leave( void)"
  gdk_threads_leave();
  return(XEN_FALSE);
}
static XEN gxg_gdk_threads_init(void)
{
  #define H_gdk_threads_init "void gdk_threads_init( void)"
  gdk_threads_init();
  return(XEN_FALSE);
}
static XEN gxg_gdk_image_get_type(void)
{
  #define H_gdk_image_get_type "GType gdk_image_get_type( void)"
  return(C_TO_XEN_GType(gdk_image_get_type()));
}
static XEN gxg_gdk_image_new(XEN type, XEN visual, XEN width, XEN height)
{
  #define H_gdk_image_new "GdkImage* gdk_image_new(GdkImageType type, GdkVisual* visual, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GdkImageType_P(type), type, 1, "gdk_image_new", "GdkImageType");
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(visual), visual, 2, "gdk_image_new", "GdkVisual*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 3, "gdk_image_new", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 4, "gdk_image_new", "gint");
  return(C_TO_XEN_GdkImage_(gdk_image_new(XEN_TO_C_GdkImageType(type), XEN_TO_C_GdkVisual_(visual), XEN_TO_C_gint(width), 
                                          XEN_TO_C_gint(height))));
}
static XEN gxg_gdk_device_get_type(void)
{
  #define H_gdk_device_get_type "GType gdk_device_get_type( void)"
  return(C_TO_XEN_GType(gdk_device_get_type()));
}
static XEN gxg_gdk_devices_list(void)
{
  #define H_gdk_devices_list "GList* gdk_devices_list( void)"
  return(C_TO_XEN_GList_(gdk_devices_list()));
}
static XEN gxg_gdk_device_set_source(XEN device, XEN source)
{
  #define H_gdk_device_set_source "void gdk_device_set_source(GdkDevice* device, GdkInputSource source)"
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_set_source", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_GdkInputSource_P(source), source, 2, "gdk_device_set_source", "GdkInputSource");
  gdk_device_set_source(XEN_TO_C_GdkDevice_(device), XEN_TO_C_GdkInputSource(source));
  return(XEN_FALSE);
}
static XEN gxg_gdk_device_set_mode(XEN device, XEN mode)
{
  #define H_gdk_device_set_mode "gboolean gdk_device_set_mode(GdkDevice* device, GdkInputMode mode)"
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_set_mode", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_GdkInputMode_P(mode), mode, 2, "gdk_device_set_mode", "GdkInputMode");
  return(C_TO_XEN_gboolean(gdk_device_set_mode(XEN_TO_C_GdkDevice_(device), XEN_TO_C_GdkInputMode(mode))));
}
static XEN gxg_gdk_device_set_key(XEN device, XEN index, XEN keyval, XEN modifiers)
{
  #define H_gdk_device_set_key "void gdk_device_set_key(GdkDevice* device, guint index, guint keyval, \
GdkModifierType modifiers)"
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_set_key", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_guint_P(index), index, 2, "gdk_device_set_key", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 3, "gdk_device_set_key", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 4, "gdk_device_set_key", "GdkModifierType");
  gdk_device_set_key(XEN_TO_C_GdkDevice_(device), XEN_TO_C_guint(index), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers));
  return(XEN_FALSE);
}
static XEN gxg_gdk_device_set_axis_use(XEN device, XEN index, XEN use)
{
  #define H_gdk_device_set_axis_use "void gdk_device_set_axis_use(GdkDevice* device, guint index, GdkAxisUse use)"
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_set_axis_use", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_guint_P(index), index, 2, "gdk_device_set_axis_use", "guint");
  XEN_ASSERT_TYPE(XEN_GdkAxisUse_P(use), use, 3, "gdk_device_set_axis_use", "GdkAxisUse");
  gdk_device_set_axis_use(XEN_TO_C_GdkDevice_(device), XEN_TO_C_guint(index), XEN_TO_C_GdkAxisUse(use));
  return(XEN_FALSE);
}
static XEN gxg_gdk_device_get_state(XEN device, XEN window, XEN axes, XEN mask)
{
  #define H_gdk_device_get_state "void gdk_device_get_state(GdkDevice* device, GdkWindow* window, gdouble* axes, \
GdkModifierType* [mask])"
  GdkModifierType ref_mask;
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_get_state", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gdk_device_get_state", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gdouble__P(axes), axes, 3, "gdk_device_get_state", "gdouble*");
  gdk_device_get_state(XEN_TO_C_GdkDevice_(device), XEN_TO_C_GdkWindow_(window), XEN_TO_C_gdouble_(axes), &ref_mask);
  return(XEN_LIST_1(C_TO_XEN_GdkModifierType(ref_mask)));
}
static XEN gxg_gdk_device_get_history(XEN device, XEN window, XEN start, XEN stop, XEN events, XEN n_events)
{
  #define H_gdk_device_get_history "gboolean gdk_device_get_history(GdkDevice* device, GdkWindow* window, \
guint32 start, guint32 stop, GdkTimeCoord*** [events], gint* [n_events])"
  GdkTimeCoord** ref_events = NULL;
  gint ref_n_events;
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_get_history", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gdk_device_get_history", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_guint32_P(start), start, 3, "gdk_device_get_history", "guint32");
  XEN_ASSERT_TYPE(XEN_guint32_P(stop), stop, 4, "gdk_device_get_history", "guint32");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_device_get_history(XEN_TO_C_GdkDevice_(device), XEN_TO_C_GdkWindow_(window), XEN_TO_C_guint32(start), 
                                                      XEN_TO_C_guint32(stop), &ref_events, &ref_n_events));
    return(XEN_LIST_3(result, C_TO_XEN_GdkTimeCoord__(ref_events), C_TO_XEN_gint(ref_n_events)));
   }
}
static XEN gxg_gdk_device_free_history(XEN events, XEN n_events)
{
  #define H_gdk_device_free_history "void gdk_device_free_history(GdkTimeCoord** events, gint n_events)"
  XEN_ASSERT_TYPE(XEN_GdkTimeCoord___P(events), events, 1, "gdk_device_free_history", "GdkTimeCoord**");
  XEN_ASSERT_TYPE(XEN_gint_P(n_events), n_events, 2, "gdk_device_free_history", "gint");
  gdk_device_free_history(XEN_TO_C_GdkTimeCoord__(events), XEN_TO_C_gint(n_events));
  return(XEN_FALSE);
}
static XEN gxg_gdk_device_get_axis(XEN device, XEN axes, XEN use, XEN value)
{
  #define H_gdk_device_get_axis "gboolean gdk_device_get_axis(GdkDevice* device, gdouble* axes, GdkAxisUse use, \
gdouble* value)"
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(device), device, 1, "gdk_device_get_axis", "GdkDevice*");
  XEN_ASSERT_TYPE(XEN_gdouble__P(axes), axes, 2, "gdk_device_get_axis", "gdouble*");
  XEN_ASSERT_TYPE(XEN_GdkAxisUse_P(use), use, 3, "gdk_device_get_axis", "GdkAxisUse");
  XEN_ASSERT_TYPE(XEN_gdouble__P(value), value, 4, "gdk_device_get_axis", "gdouble*");
  return(C_TO_XEN_gboolean(gdk_device_get_axis(XEN_TO_C_GdkDevice_(device), XEN_TO_C_gdouble_(axes), XEN_TO_C_GdkAxisUse(use), 
                                               XEN_TO_C_gdouble_(value))));
}
static XEN gxg_gdk_input_set_extension_events(XEN window, XEN mask, XEN mode)
{
  #define H_gdk_input_set_extension_events "void gdk_input_set_extension_events(GdkWindow* window, gint mask, \
GdkExtensionMode mode)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_input_set_extension_events", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(mask), mask, 2, "gdk_input_set_extension_events", "gint");
  XEN_ASSERT_TYPE(XEN_GdkExtensionMode_P(mode), mode, 3, "gdk_input_set_extension_events", "GdkExtensionMode");
  gdk_input_set_extension_events(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(mask), XEN_TO_C_GdkExtensionMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gdk_device_get_core_pointer(void)
{
  #define H_gdk_device_get_core_pointer "GdkDevice* gdk_device_get_core_pointer( void)"
  return(C_TO_XEN_GdkDevice_(gdk_device_get_core_pointer()));
}
static XEN gxg_gdk_keymap_get_type(void)
{
  #define H_gdk_keymap_get_type "GType gdk_keymap_get_type( void)"
  return(C_TO_XEN_GType(gdk_keymap_get_type()));
}
static XEN gxg_gdk_keymap_get_default(void)
{
  #define H_gdk_keymap_get_default "GdkKeymap* gdk_keymap_get_default( void)"
  return(C_TO_XEN_GdkKeymap_(gdk_keymap_get_default()));
}
static XEN gxg_gdk_keymap_lookup_key(XEN keymap, XEN key)
{
  #define H_gdk_keymap_lookup_key "guint gdk_keymap_lookup_key(GdkKeymap* keymap, GdkKeymapKey* key)"
  XEN_ASSERT_TYPE(XEN_GdkKeymap__P(keymap), keymap, 1, "gdk_keymap_lookup_key", "GdkKeymap*");
  XEN_ASSERT_TYPE(XEN_GdkKeymapKey__P(key), key, 2, "gdk_keymap_lookup_key", "GdkKeymapKey*");
  return(C_TO_XEN_guint(gdk_keymap_lookup_key(XEN_TO_C_GdkKeymap_(keymap), XEN_TO_C_GdkKeymapKey_(key))));
}
static XEN gxg_gdk_keymap_get_entries_for_keyval(XEN keymap, XEN keyval, XEN keys, XEN n_keys)
{
  #define H_gdk_keymap_get_entries_for_keyval "gboolean gdk_keymap_get_entries_for_keyval(GdkKeymap* keymap, \
guint keyval, GdkKeymapKey** [keys], gint* [n_keys])"
  GdkKeymapKey* ref_keys = NULL;
  gint ref_n_keys;
  XEN_ASSERT_TYPE(XEN_GdkKeymap__P(keymap), keymap, 1, "gdk_keymap_get_entries_for_keyval", "GdkKeymap*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gdk_keymap_get_entries_for_keyval", "guint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_keymap_get_entries_for_keyval(XEN_TO_C_GdkKeymap_(keymap), XEN_TO_C_guint(keyval), &ref_keys, 
                                                                 &ref_n_keys));
    return(XEN_LIST_3(result, C_TO_XEN_GdkKeymapKey_(ref_keys), C_TO_XEN_gint(ref_n_keys)));
   }
}
static XEN gxg_gdk_keymap_get_entries_for_keycode(XEN keymap, XEN hardware_keycode, XEN keys, XEN keyvals, XEN n_entries)
{
  #define H_gdk_keymap_get_entries_for_keycode "gboolean gdk_keymap_get_entries_for_keycode(GdkKeymap* keymap, \
guint hardware_keycode, GdkKeymapKey** [keys], guint** [keyvals], gint* [n_entries])"
  GdkKeymapKey* ref_keys = NULL;
  guint* ref_keyvals = NULL;
  gint ref_n_entries;
  XEN_ASSERT_TYPE(XEN_GdkKeymap__P(keymap), keymap, 1, "gdk_keymap_get_entries_for_keycode", "GdkKeymap*");
  XEN_ASSERT_TYPE(XEN_guint_P(hardware_keycode), hardware_keycode, 2, "gdk_keymap_get_entries_for_keycode", "guint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_keymap_get_entries_for_keycode(XEN_TO_C_GdkKeymap_(keymap), XEN_TO_C_guint(hardware_keycode), 
                                                                  &ref_keys, &ref_keyvals, &ref_n_entries));
    return(XEN_LIST_4(result, C_TO_XEN_GdkKeymapKey_(ref_keys), C_TO_XEN_guint_(ref_keyvals), C_TO_XEN_gint(ref_n_entries)));
   }
}
static XEN gxg_gdk_keymap_get_direction(XEN keymap)
{
  #define H_gdk_keymap_get_direction "PangoDirection gdk_keymap_get_direction(GdkKeymap* keymap)"
  XEN_ASSERT_TYPE(XEN_GdkKeymap__P(keymap), keymap, 1, "gdk_keymap_get_direction", "GdkKeymap*");
  return(C_TO_XEN_PangoDirection(gdk_keymap_get_direction(XEN_TO_C_GdkKeymap_(keymap))));
}
static XEN gxg_gdk_keyval_name(XEN keyval)
{
  #define H_gdk_keyval_name "gchar* gdk_keyval_name(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_name", "guint");
  return(C_TO_XEN_gchar_(gdk_keyval_name(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_keyval_from_name(XEN keyval_name)
{
  #define H_gdk_keyval_from_name "guint gdk_keyval_from_name(gchar* keyval_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(keyval_name), keyval_name, 1, "gdk_keyval_from_name", "gchar*");
  return(C_TO_XEN_guint(gdk_keyval_from_name(XEN_TO_C_gchar_(keyval_name))));
}
static XEN gxg_gdk_keyval_convert_case(XEN symbol, XEN lower, XEN upper)
{
  #define H_gdk_keyval_convert_case "void gdk_keyval_convert_case(guint symbol, guint* [lower], guint* [upper])"
  guint ref_lower;
  guint ref_upper;
  XEN_ASSERT_TYPE(XEN_guint_P(symbol), symbol, 1, "gdk_keyval_convert_case", "guint");
  gdk_keyval_convert_case(XEN_TO_C_guint(symbol), &ref_lower, &ref_upper);
  return(XEN_LIST_2(C_TO_XEN_guint(ref_lower), C_TO_XEN_guint(ref_upper)));
}
static XEN gxg_gdk_keyval_to_upper(XEN keyval)
{
  #define H_gdk_keyval_to_upper "guint gdk_keyval_to_upper(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_to_upper", "guint");
  return(C_TO_XEN_guint(gdk_keyval_to_upper(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_keyval_to_lower(XEN keyval)
{
  #define H_gdk_keyval_to_lower "guint gdk_keyval_to_lower(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_to_lower", "guint");
  return(C_TO_XEN_guint(gdk_keyval_to_lower(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_keyval_is_upper(XEN keyval)
{
  #define H_gdk_keyval_is_upper "gboolean gdk_keyval_is_upper(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_is_upper", "guint");
  return(C_TO_XEN_gboolean(gdk_keyval_is_upper(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_keyval_is_lower(XEN keyval)
{
  #define H_gdk_keyval_is_lower "gboolean gdk_keyval_is_lower(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_is_lower", "guint");
  return(C_TO_XEN_gboolean(gdk_keyval_is_lower(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_keyval_to_unicode(XEN keyval)
{
  #define H_gdk_keyval_to_unicode "guint32 gdk_keyval_to_unicode(guint keyval)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gdk_keyval_to_unicode", "guint");
  return(C_TO_XEN_guint32(gdk_keyval_to_unicode(XEN_TO_C_guint(keyval))));
}
static XEN gxg_gdk_unicode_to_keyval(XEN wc)
{
  #define H_gdk_unicode_to_keyval "guint gdk_unicode_to_keyval(guint32 wc)"
  XEN_ASSERT_TYPE(XEN_guint32_P(wc), wc, 1, "gdk_unicode_to_keyval", "guint32");
  return(C_TO_XEN_guint(gdk_unicode_to_keyval(XEN_TO_C_guint32(wc))));
}
static XEN gxg_gdk_pango_context_get(void)
{
  #define H_gdk_pango_context_get "PangoContext* gdk_pango_context_get( void)"
  return(C_TO_XEN_PangoContext_(gdk_pango_context_get()));
}
static XEN gxg_gdk_pango_layout_line_get_clip_region(XEN line, XEN x_origin, XEN y_origin, XEN index_ranges, XEN n_ranges)
{
  #define H_gdk_pango_layout_line_get_clip_region "GdkRegion* gdk_pango_layout_line_get_clip_region(PangoLayoutLine* line, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "gdk_pango_layout_line_get_clip_region", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_gint_P(x_origin), x_origin, 2, "gdk_pango_layout_line_get_clip_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y_origin), y_origin, 3, "gdk_pango_layout_line_get_clip_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint__P(index_ranges), index_ranges, 4, "gdk_pango_layout_line_get_clip_region", "gint*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_ranges), n_ranges, 5, "gdk_pango_layout_line_get_clip_region", "gint");
  return(C_TO_XEN_GdkRegion_(gdk_pango_layout_line_get_clip_region(XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_gint(x_origin), 
                                                                   XEN_TO_C_gint(y_origin), XEN_TO_C_gint_(index_ranges), 
                                                                   XEN_TO_C_gint(n_ranges))));
}
static XEN gxg_gdk_pango_layout_get_clip_region(XEN layout, XEN x_origin, XEN y_origin, XEN index_ranges, XEN n_ranges)
{
  #define H_gdk_pango_layout_get_clip_region "GdkRegion* gdk_pango_layout_get_clip_region(PangoLayout* layout, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "gdk_pango_layout_get_clip_region", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_gint_P(x_origin), x_origin, 2, "gdk_pango_layout_get_clip_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y_origin), y_origin, 3, "gdk_pango_layout_get_clip_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint__P(index_ranges), index_ranges, 4, "gdk_pango_layout_get_clip_region", "gint*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_ranges), n_ranges, 5, "gdk_pango_layout_get_clip_region", "gint");
  return(C_TO_XEN_GdkRegion_(gdk_pango_layout_get_clip_region(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_gint(x_origin), XEN_TO_C_gint(y_origin), 
                                                              XEN_TO_C_gint_(index_ranges), XEN_TO_C_gint(n_ranges))));
}
static XEN gxg_gdk_pango_attr_stipple_new(XEN stipple)
{
  #define H_gdk_pango_attr_stipple_new "PangoAttribute* gdk_pango_attr_stipple_new(GdkBitmap* stipple)"
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(stipple), stipple, 1, "gdk_pango_attr_stipple_new", "GdkBitmap*");
  return(C_TO_XEN_PangoAttribute_(gdk_pango_attr_stipple_new(XEN_TO_C_GdkBitmap_(stipple))));
}
static XEN gxg_gdk_pango_attr_embossed_new(XEN embossed)
{
  #define H_gdk_pango_attr_embossed_new "PangoAttribute* gdk_pango_attr_embossed_new(gboolean embossed)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(embossed), embossed, 1, "gdk_pango_attr_embossed_new", "gboolean");
  return(C_TO_XEN_PangoAttribute_(gdk_pango_attr_embossed_new(XEN_TO_C_gboolean(embossed))));
}
static XEN gxg_gdk_pixbuf_render_threshold_alpha(XEN pixbuf, XEN bitmap, XEN src_x, XEN src_y, XEN dest_x, XEN dest_y, XEN width, XEN height, XEN alpha_threshold)
{
  #define H_gdk_pixbuf_render_threshold_alpha "void gdk_pixbuf_render_threshold_alpha(GdkPixbuf* pixbuf, \
GdkBitmap* bitmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height, int alpha_threshold)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_render_threshold_alpha", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(bitmap), bitmap, 2, "gdk_pixbuf_render_threshold_alpha", "GdkBitmap*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 3, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 4, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 5, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 6, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 7, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 8, "gdk_pixbuf_render_threshold_alpha", "int");
  XEN_ASSERT_TYPE(XEN_int_P(alpha_threshold), alpha_threshold, 9, "gdk_pixbuf_render_threshold_alpha", "int");
  gdk_pixbuf_render_threshold_alpha(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_GdkBitmap_(bitmap), XEN_TO_C_int(src_x), XEN_TO_C_int(src_y), 
                                    XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), XEN_TO_C_int(width), XEN_TO_C_int(height), 
                                    XEN_TO_C_int(alpha_threshold));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pixbuf_render_pixmap_and_mask_for_colormap(XEN pixbuf, XEN colormap, XEN pixmap_return, XEN mask_return, XEN alpha_threshold)
{
  #define H_gdk_pixbuf_render_pixmap_and_mask_for_colormap "void gdk_pixbuf_render_pixmap_and_mask_for_colormap(GdkPixbuf* pixbuf, \
GdkColormap* colormap, GdkPixmap** [pixmap_return], GdkBitmap** [mask_return], int alpha_threshold)"
  GdkPixmap* ref_pixmap_return = NULL;
  GdkBitmap* ref_mask_return = NULL;
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_render_pixmap_and_mask_for_colormap", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gdk_pixbuf_render_pixmap_and_mask_for_colormap", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_int_P(alpha_threshold), alpha_threshold, 5, "gdk_pixbuf_render_pixmap_and_mask_for_colormap", "int");
  gdk_pixbuf_render_pixmap_and_mask_for_colormap(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_GdkColormap_(colormap), &ref_pixmap_return, 
                                                 &ref_mask_return, XEN_TO_C_int(alpha_threshold));
  return(XEN_LIST_2(C_TO_XEN_GdkPixmap_(ref_pixmap_return), C_TO_XEN_GdkBitmap_(ref_mask_return)));
}
static XEN gxg_gdk_pixbuf_render_pixmap_and_mask(XEN pixbuf, XEN pixmap_return, XEN mask_return, XEN alpha_threshold)
{
  #define H_gdk_pixbuf_render_pixmap_and_mask "void gdk_pixbuf_render_pixmap_and_mask(GdkPixbuf* pixbuf, \
GdkPixmap** [pixmap_return], GdkBitmap** [mask_return], int alpha_threshold)"
  GdkPixmap* ref_pixmap_return = NULL;
  GdkBitmap* ref_mask_return = NULL;
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_render_pixmap_and_mask", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(alpha_threshold), alpha_threshold, 4, "gdk_pixbuf_render_pixmap_and_mask", "int");
  gdk_pixbuf_render_pixmap_and_mask(XEN_TO_C_GdkPixbuf_(pixbuf), &ref_pixmap_return, &ref_mask_return, XEN_TO_C_int(alpha_threshold));
  return(XEN_LIST_2(C_TO_XEN_GdkPixmap_(ref_pixmap_return), C_TO_XEN_GdkBitmap_(ref_mask_return)));
}
static XEN gxg_gdk_pixbuf_get_from_drawable(XEN dest, XEN src, XEN cmap, XEN src_x, XEN src_y, XEN dest_x, XEN dest_y, XEN width, XEN height)
{
  #define H_gdk_pixbuf_get_from_drawable "GdkPixbuf* gdk_pixbuf_get_from_drawable(GdkPixbuf* dest, GdkDrawable* src, \
GdkColormap* cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest) || XEN_FALSE_P(dest), dest, 1, "gdk_pixbuf_get_from_drawable", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(src), src, 2, "gdk_pixbuf_get_from_drawable", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(cmap) || XEN_FALSE_P(cmap), cmap, 3, "gdk_pixbuf_get_from_drawable", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 4, "gdk_pixbuf_get_from_drawable", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 5, "gdk_pixbuf_get_from_drawable", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 6, "gdk_pixbuf_get_from_drawable", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 7, "gdk_pixbuf_get_from_drawable", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 8, "gdk_pixbuf_get_from_drawable", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 9, "gdk_pixbuf_get_from_drawable", "int");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_get_from_drawable(XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_GdkDrawable_(src), XEN_TO_C_GdkColormap_(cmap), 
                                                          XEN_TO_C_int(src_x), XEN_TO_C_int(src_y), XEN_TO_C_int(dest_x), 
                                                          XEN_TO_C_int(dest_y), XEN_TO_C_int(width), XEN_TO_C_int(height))));
}
static XEN gxg_gdk_pixbuf_get_from_image(XEN dest, XEN src, XEN cmap, XEN src_x, XEN src_y, XEN dest_x, XEN dest_y, XEN width, XEN height)
{
  #define H_gdk_pixbuf_get_from_image "GdkPixbuf* gdk_pixbuf_get_from_image(GdkPixbuf* dest, GdkImage* src, \
GdkColormap* cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest) || XEN_FALSE_P(dest), dest, 1, "gdk_pixbuf_get_from_image", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkImage__P(src), src, 2, "gdk_pixbuf_get_from_image", "GdkImage*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(cmap) || XEN_FALSE_P(cmap), cmap, 3, "gdk_pixbuf_get_from_image", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 4, "gdk_pixbuf_get_from_image", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 5, "gdk_pixbuf_get_from_image", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 6, "gdk_pixbuf_get_from_image", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 7, "gdk_pixbuf_get_from_image", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 8, "gdk_pixbuf_get_from_image", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 9, "gdk_pixbuf_get_from_image", "int");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_get_from_image(XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_GdkImage_(src), XEN_TO_C_GdkColormap_(cmap), 
                                                       XEN_TO_C_int(src_x), XEN_TO_C_int(src_y), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), 
                                                       XEN_TO_C_int(width), XEN_TO_C_int(height))));
}
static XEN gxg_gdk_pixmap_get_type(void)
{
  #define H_gdk_pixmap_get_type "GType gdk_pixmap_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixmap_get_type()));
}
static XEN gxg_gdk_pixmap_foreign_new(XEN anid)
{
  #define H_gdk_pixmap_foreign_new "GdkPixmap* gdk_pixmap_foreign_new(GdkNativeWindow anid)"
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(anid), anid, 1, "gdk_pixmap_foreign_new", "GdkNativeWindow");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_foreign_new(XEN_TO_C_GdkNativeWindow(anid))));
}
static XEN gxg_gdk_pixmap_lookup(XEN anid)
{
  #define H_gdk_pixmap_lookup "GdkPixmap* gdk_pixmap_lookup(GdkNativeWindow anid)"
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(anid), anid, 1, "gdk_pixmap_lookup", "GdkNativeWindow");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_lookup(XEN_TO_C_GdkNativeWindow(anid))));
}
static XEN gxg_gdk_atom_intern(XEN atom_name, XEN only_if_exists)
{
  #define H_gdk_atom_intern "GdkAtom gdk_atom_intern(gchar* atom_name, gboolean only_if_exists)"
  XEN_ASSERT_TYPE(XEN_gchar__P(atom_name), atom_name, 1, "gdk_atom_intern", "gchar*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(only_if_exists), only_if_exists, 2, "gdk_atom_intern", "gboolean");
  return(C_TO_XEN_GdkAtom(gdk_atom_intern(XEN_TO_C_gchar_(atom_name), XEN_TO_C_gboolean(only_if_exists))));
}
static XEN gxg_gdk_atom_name(XEN atom)
{
  #define H_gdk_atom_name "gchar* gdk_atom_name(GdkAtom atom)"
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(atom), atom, 1, "gdk_atom_name", "GdkAtom");
  {
   gchar* result;
   XEN rtn;
   result = gdk_atom_name(XEN_TO_C_GdkAtom(atom));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gdk_property_get(XEN arglist)
{
  #define H_gdk_property_get "gboolean gdk_property_get(GdkWindow* window, GdkAtom property, GdkAtom type, \
gulong offset, gulong length, gint pdelete, GdkAtom* [actual_property_type], gint* [actual_format], gint* [actual_length], \
guchar** [data])"
  GdkAtom ref_actual_property_type;
  gint ref_actual_format;
  gint ref_actual_length;
  guchar* ref_data = NULL;
  XEN window, property, type, offset, length, pdelete;
  window = XEN_LIST_REF(arglist, 0);
  property = XEN_LIST_REF(arglist, 1);
  type = XEN_LIST_REF(arglist, 2);
  offset = XEN_LIST_REF(arglist, 3);
  length = XEN_LIST_REF(arglist, 4);
  pdelete = XEN_LIST_REF(arglist, 5);
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_property_get", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(property), property, 2, "gdk_property_get", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(type), type, 3, "gdk_property_get", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_gulong_P(offset), offset, 4, "gdk_property_get", "gulong");
  XEN_ASSERT_TYPE(XEN_gulong_P(length), length, 5, "gdk_property_get", "gulong");
  XEN_ASSERT_TYPE(XEN_gint_P(pdelete), pdelete, 6, "gdk_property_get", "gint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_property_get(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkAtom(property), XEN_TO_C_GdkAtom(type), 
                                                XEN_TO_C_gulong(offset), XEN_TO_C_gulong(length), XEN_TO_C_gint(pdelete), 
                                                &ref_actual_property_type, &ref_actual_format, &ref_actual_length, &ref_data));
    {
      XEN data_val = XEN_FALSE;
      if (ref_actual_property_type == GDK_TARGET_STRING)
	data_val = C_TO_XEN_STRING((char *)ref_data);
      else if (ref_actual_length > 0) data_val = C_TO_XEN_STRINGN((char *)ref_data, ref_actual_length * ref_actual_format / 8);
     return(XEN_LIST_5(result, C_TO_XEN_GdkAtom(ref_actual_property_type), C_TO_XEN_gint(ref_actual_format), 
                       C_TO_XEN_gint(ref_actual_length), data_val));
    }
  }
}
static XEN gxg_gdk_property_change(XEN window, XEN property, XEN type, XEN format, XEN mode, XEN data, XEN nelements)
{
  #define H_gdk_property_change "void gdk_property_change(GdkWindow* window, GdkAtom property, GdkAtom type, \
gint format, GdkPropMode mode, guchar* data, gint nelements)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_property_change", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(property), property, 2, "gdk_property_change", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(type), type, 3, "gdk_property_change", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_gint_P(format), format, 4, "gdk_property_change", "gint");
  XEN_ASSERT_TYPE(XEN_GdkPropMode_P(mode), mode, 5, "gdk_property_change", "GdkPropMode");
  XEN_ASSERT_TYPE(XEN_guchar__P(data), data, 6, "gdk_property_change", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(nelements), nelements, 7, "gdk_property_change", "gint");
  gdk_property_change(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkAtom(property), XEN_TO_C_GdkAtom(type), XEN_TO_C_gint(format), 
                      XEN_TO_C_GdkPropMode(mode), XEN_TO_C_guchar_(data), XEN_TO_C_gint(nelements));
  return(XEN_FALSE);
}
static XEN gxg_gdk_property_delete(XEN window, XEN property)
{
  #define H_gdk_property_delete "void gdk_property_delete(GdkWindow* window, GdkAtom property)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_property_delete", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(property), property, 2, "gdk_property_delete", "GdkAtom");
  gdk_property_delete(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkAtom(property));
  return(XEN_FALSE);
}
static XEN gxg_gdk_utf8_to_string_target(XEN str)
{
  #define H_gdk_utf8_to_string_target "gchar* gdk_utf8_to_string_target(gchar* str)"
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 1, "gdk_utf8_to_string_target", "gchar*");
  {
   gchar* result;
   XEN rtn;
   result = gdk_utf8_to_string_target(XEN_TO_C_gchar_(str));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gdk_region_new(void)
{
  #define H_gdk_region_new "GdkRegion* gdk_region_new( void)"
  return(C_TO_XEN_GdkRegion_(gdk_region_new()));
}
static XEN gxg_gdk_region_polygon(XEN points, XEN npoints, XEN fill_rule)
{
  #define H_gdk_region_polygon "GdkRegion* gdk_region_polygon(GdkPoint* points, gint npoints, GdkFillRule fill_rule)"
  XEN_ASSERT_TYPE(XEN_GdkPoint__P(points), points, 1, "gdk_region_polygon", "GdkPoint*");
  XEN_ASSERT_TYPE(XEN_gint_P(npoints), npoints, 2, "gdk_region_polygon", "gint");
  XEN_ASSERT_TYPE(XEN_GdkFillRule_P(fill_rule), fill_rule, 3, "gdk_region_polygon", "GdkFillRule");
  return(C_TO_XEN_GdkRegion_(gdk_region_polygon(XEN_TO_C_GdkPoint_(points), XEN_TO_C_gint(npoints), XEN_TO_C_GdkFillRule(fill_rule))));
}
static XEN gxg_gdk_region_copy(XEN region)
{
  #define H_gdk_region_copy "GdkRegion* gdk_region_copy(GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_copy", "GdkRegion*");
  return(C_TO_XEN_GdkRegion_(gdk_region_copy(XEN_TO_C_GdkRegion_(region))));
}
static XEN gxg_gdk_region_rectangle(XEN rectangle)
{
  #define H_gdk_region_rectangle "GdkRegion* gdk_region_rectangle(GdkRectangle* rectangle)"
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rectangle), rectangle, 1, "gdk_region_rectangle", "GdkRectangle*");
  return(C_TO_XEN_GdkRegion_(gdk_region_rectangle(XEN_TO_C_GdkRectangle_(rectangle))));
}
static XEN gxg_gdk_region_destroy(XEN region)
{
  #define H_gdk_region_destroy "void gdk_region_destroy(GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_destroy", "GdkRegion*");
  gdk_region_destroy(XEN_TO_C_GdkRegion_(region));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_get_clipbox(XEN region, XEN rectangle)
{
  #define H_gdk_region_get_clipbox "void gdk_region_get_clipbox(GdkRegion* region, GdkRectangle* rectangle)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_get_clipbox", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rectangle), rectangle, 2, "gdk_region_get_clipbox", "GdkRectangle*");
  gdk_region_get_clipbox(XEN_TO_C_GdkRegion_(region), XEN_TO_C_GdkRectangle_(rectangle));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_get_rectangles(XEN region, XEN rectangles, XEN n_rectangles)
{
  #define H_gdk_region_get_rectangles "void gdk_region_get_rectangles(GdkRegion* region, GdkRectangle** [rectangles], \
gint* [n_rectangles])"
  GdkRectangle* ref_rectangles = NULL;
  gint ref_n_rectangles;
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_get_rectangles", "GdkRegion*");
  gdk_region_get_rectangles(XEN_TO_C_GdkRegion_(region), &ref_rectangles, &ref_n_rectangles);
  return(XEN_LIST_2(C_TO_XEN_GdkRectangle_(ref_rectangles), C_TO_XEN_gint(ref_n_rectangles)));
}
static XEN gxg_gdk_region_empty(XEN region)
{
  #define H_gdk_region_empty "gboolean gdk_region_empty(GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_empty", "GdkRegion*");
  return(C_TO_XEN_gboolean(gdk_region_empty(XEN_TO_C_GdkRegion_(region))));
}
static XEN gxg_gdk_region_equal(XEN region1, XEN region2)
{
  #define H_gdk_region_equal "gboolean gdk_region_equal(GdkRegion* region1, GdkRegion* region2)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region1), region1, 1, "gdk_region_equal", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region2), region2, 2, "gdk_region_equal", "GdkRegion*");
  return(C_TO_XEN_gboolean(gdk_region_equal(XEN_TO_C_GdkRegion_(region1), XEN_TO_C_GdkRegion_(region2))));
}
static XEN gxg_gdk_region_point_in(XEN region, XEN x, XEN y)
{
  #define H_gdk_region_point_in "gboolean gdk_region_point_in(GdkRegion* region, int x, int y)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_point_in", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 2, "gdk_region_point_in", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 3, "gdk_region_point_in", "int");
  return(C_TO_XEN_gboolean(gdk_region_point_in(XEN_TO_C_GdkRegion_(region), XEN_TO_C_int(x), XEN_TO_C_int(y))));
}
static XEN gxg_gdk_region_rect_in(XEN region, XEN rect)
{
  #define H_gdk_region_rect_in "GdkOverlapType gdk_region_rect_in(GdkRegion* region, GdkRectangle* rect)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_rect_in", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 2, "gdk_region_rect_in", "GdkRectangle*");
  return(C_TO_XEN_GdkOverlapType(gdk_region_rect_in(XEN_TO_C_GdkRegion_(region), XEN_TO_C_GdkRectangle_(rect))));
}
static XEN gxg_gdk_region_offset(XEN region, XEN dx, XEN dy)
{
  #define H_gdk_region_offset "void gdk_region_offset(GdkRegion* region, gint dx, gint dy)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_offset", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_gint_P(dx), dx, 2, "gdk_region_offset", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(dy), dy, 3, "gdk_region_offset", "gint");
  gdk_region_offset(XEN_TO_C_GdkRegion_(region), XEN_TO_C_gint(dx), XEN_TO_C_gint(dy));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_shrink(XEN region, XEN dx, XEN dy)
{
  #define H_gdk_region_shrink "void gdk_region_shrink(GdkRegion* region, gint dx, gint dy)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_shrink", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_gint_P(dx), dx, 2, "gdk_region_shrink", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(dy), dy, 3, "gdk_region_shrink", "gint");
  gdk_region_shrink(XEN_TO_C_GdkRegion_(region), XEN_TO_C_gint(dx), XEN_TO_C_gint(dy));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_union_with_rect(XEN region, XEN rect)
{
  #define H_gdk_region_union_with_rect "void gdk_region_union_with_rect(GdkRegion* region, GdkRectangle* rect)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 1, "gdk_region_union_with_rect", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 2, "gdk_region_union_with_rect", "GdkRectangle*");
  gdk_region_union_with_rect(XEN_TO_C_GdkRegion_(region), XEN_TO_C_GdkRectangle_(rect));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_intersect(XEN source1, XEN source2)
{
  #define H_gdk_region_intersect "void gdk_region_intersect(GdkRegion* source1, GdkRegion* source2)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source1), source1, 1, "gdk_region_intersect", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source2), source2, 2, "gdk_region_intersect", "GdkRegion*");
  gdk_region_intersect(XEN_TO_C_GdkRegion_(source1), XEN_TO_C_GdkRegion_(source2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_union(XEN source1, XEN source2)
{
  #define H_gdk_region_union "void gdk_region_union(GdkRegion* source1, GdkRegion* source2)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source1), source1, 1, "gdk_region_union", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source2), source2, 2, "gdk_region_union", "GdkRegion*");
  gdk_region_union(XEN_TO_C_GdkRegion_(source1), XEN_TO_C_GdkRegion_(source2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_subtract(XEN source1, XEN source2)
{
  #define H_gdk_region_subtract "void gdk_region_subtract(GdkRegion* source1, GdkRegion* source2)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source1), source1, 1, "gdk_region_subtract", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source2), source2, 2, "gdk_region_subtract", "GdkRegion*");
  gdk_region_subtract(XEN_TO_C_GdkRegion_(source1), XEN_TO_C_GdkRegion_(source2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_region_xor(XEN source1, XEN source2)
{
  #define H_gdk_region_xor "void gdk_region_xor(GdkRegion* source1, GdkRegion* source2)"
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source1), source1, 1, "gdk_region_xor", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(source2), source2, 2, "gdk_region_xor", "GdkRegion*");
  gdk_region_xor(XEN_TO_C_GdkRegion_(source1), XEN_TO_C_GdkRegion_(source2));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rgb_find_color(XEN colormap, XEN color)
{
  #define H_gdk_rgb_find_color "void gdk_rgb_find_color(GdkColormap* colormap, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gdk_rgb_find_color", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_rgb_find_color", "GdkColor*");
  gdk_rgb_find_color(XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_rgb_image(XEN drawable, XEN gc, XEN x, XEN y, XEN width, XEN height, XEN dith, XEN rgb_buf, XEN rowstride)
{
  #define H_gdk_draw_rgb_image "void gdk_draw_rgb_image(GdkDrawable* drawable, GdkGC* gc, gint x, gint y, \
gint width, gint height, GdkRgbDither dith, guchar* rgb_buf, gint rowstride)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_rgb_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_rgb_image", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_rgb_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_rgb_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_rgb_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_rgb_image", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_rgb_image", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(rgb_buf), rgb_buf, 8, "gdk_draw_rgb_image", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_rgb_image", "gint");
  gdk_draw_rgb_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                     XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(rgb_buf), XEN_TO_C_gint(rowstride));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_rgb_image_dithalign(XEN arglist)
{
  #define H_gdk_draw_rgb_image_dithalign "void gdk_draw_rgb_image_dithalign(GdkDrawable* drawable, GdkGC* gc, \
gint x, gint y, gint width, gint height, GdkRgbDither dith, guchar* rgb_buf, gint rowstride, gint xdith, \
gint ydith)"
  XEN drawable, gc, x, y, width, height, dith, rgb_buf, rowstride, xdith, ydith;
  drawable = XEN_LIST_REF(arglist, 0);
  gc = XEN_LIST_REF(arglist, 1);
  x = XEN_LIST_REF(arglist, 2);
  y = XEN_LIST_REF(arglist, 3);
  width = XEN_LIST_REF(arglist, 4);
  height = XEN_LIST_REF(arglist, 5);
  dith = XEN_LIST_REF(arglist, 6);
  rgb_buf = XEN_LIST_REF(arglist, 7);
  rowstride = XEN_LIST_REF(arglist, 8);
  xdith = XEN_LIST_REF(arglist, 9);
  ydith = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_rgb_image_dithalign", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_rgb_image_dithalign", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_rgb_image_dithalign", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(rgb_buf), rgb_buf, 8, "gdk_draw_rgb_image_dithalign", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(xdith), xdith, 10, "gdk_draw_rgb_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ydith), ydith, 11, "gdk_draw_rgb_image_dithalign", "gint");
  gdk_draw_rgb_image_dithalign(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                               XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(rgb_buf), 
                               XEN_TO_C_gint(rowstride), XEN_TO_C_gint(xdith), XEN_TO_C_gint(ydith));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_draw_rgb_32_image(XEN drawable, XEN gc, XEN x, XEN y, XEN width, XEN height, XEN dith, XEN buf, XEN rowstride)
{
  #define H_gdk_draw_rgb_32_image "void gdk_draw_rgb_32_image(GdkDrawable* drawable, GdkGC* gc, gint x, \
gint y, gint width, gint height, GdkRgbDither dith, guchar* buf, gint rowstride)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_rgb_32_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_rgb_32_image", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_rgb_32_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_rgb_32_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_rgb_32_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_rgb_32_image", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_rgb_32_image", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(buf), buf, 8, "gdk_draw_rgb_32_image", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_rgb_32_image", "gint");
  gdk_draw_rgb_32_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                        XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(buf), XEN_TO_C_gint(rowstride));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_rgb_32_image_dithalign(XEN arglist)
{
  #define H_gdk_draw_rgb_32_image_dithalign "void gdk_draw_rgb_32_image_dithalign(GdkDrawable* drawable, \
GdkGC* gc, gint x, gint y, gint width, gint height, GdkRgbDither dith, guchar* buf, gint rowstride, gint xdith, \
gint ydith)"
  XEN drawable, gc, x, y, width, height, dith, buf, rowstride, xdith, ydith;
  drawable = XEN_LIST_REF(arglist, 0);
  gc = XEN_LIST_REF(arglist, 1);
  x = XEN_LIST_REF(arglist, 2);
  y = XEN_LIST_REF(arglist, 3);
  width = XEN_LIST_REF(arglist, 4);
  height = XEN_LIST_REF(arglist, 5);
  dith = XEN_LIST_REF(arglist, 6);
  buf = XEN_LIST_REF(arglist, 7);
  rowstride = XEN_LIST_REF(arglist, 8);
  xdith = XEN_LIST_REF(arglist, 9);
  ydith = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_rgb_32_image_dithalign", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_rgb_32_image_dithalign", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_rgb_32_image_dithalign", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(buf), buf, 8, "gdk_draw_rgb_32_image_dithalign", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(xdith), xdith, 10, "gdk_draw_rgb_32_image_dithalign", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ydith), ydith, 11, "gdk_draw_rgb_32_image_dithalign", "gint");
  gdk_draw_rgb_32_image_dithalign(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                                  XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(buf), 
                                  XEN_TO_C_gint(rowstride), XEN_TO_C_gint(xdith), XEN_TO_C_gint(ydith));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_draw_gray_image(XEN drawable, XEN gc, XEN x, XEN y, XEN width, XEN height, XEN dith, XEN buf, XEN rowstride)
{
  #define H_gdk_draw_gray_image "void gdk_draw_gray_image(GdkDrawable* drawable, GdkGC* gc, gint x, gint y, \
gint width, gint height, GdkRgbDither dith, guchar* buf, gint rowstride)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_gray_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_gray_image", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_gray_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_gray_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_gray_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_gray_image", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_gray_image", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(buf), buf, 8, "gdk_draw_gray_image", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_gray_image", "gint");
  gdk_draw_gray_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                      XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(buf), XEN_TO_C_gint(rowstride));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_indexed_image(XEN arglist)
{
  #define H_gdk_draw_indexed_image "void gdk_draw_indexed_image(GdkDrawable* drawable, GdkGC* gc, gint x, \
gint y, gint width, gint height, GdkRgbDither dith, guchar* buf, gint rowstride, GdkRgbCmap* cmap)"
  XEN drawable, gc, x, y, width, height, dith, buf, rowstride, cmap;
  drawable = XEN_LIST_REF(arglist, 0);
  gc = XEN_LIST_REF(arglist, 1);
  x = XEN_LIST_REF(arglist, 2);
  y = XEN_LIST_REF(arglist, 3);
  width = XEN_LIST_REF(arglist, 4);
  height = XEN_LIST_REF(arglist, 5);
  dith = XEN_LIST_REF(arglist, 6);
  buf = XEN_LIST_REF(arglist, 7);
  rowstride = XEN_LIST_REF(arglist, 8);
  cmap = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_indexed_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_indexed_image", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_draw_indexed_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_draw_indexed_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 5, "gdk_draw_indexed_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 6, "gdk_draw_indexed_image", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dith), dith, 7, "gdk_draw_indexed_image", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_guchar__P(buf), buf, 8, "gdk_draw_indexed_image", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(rowstride), rowstride, 9, "gdk_draw_indexed_image", "gint");
  XEN_ASSERT_TYPE(XEN_GdkRgbCmap__P(cmap), cmap, 10, "gdk_draw_indexed_image", "GdkRgbCmap*");
  gdk_draw_indexed_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                         XEN_TO_C_gint(height), XEN_TO_C_GdkRgbDither(dith), XEN_TO_C_guchar_(buf), XEN_TO_C_gint(rowstride), 
                         XEN_TO_C_GdkRgbCmap_(cmap));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_rgb_cmap_new(XEN colors, XEN n_colors)
{
  #define H_gdk_rgb_cmap_new "GdkRgbCmap* gdk_rgb_cmap_new(guint32* colors, gint n_colors)"
  XEN_ASSERT_TYPE(XEN_guint32__P(colors), colors, 1, "gdk_rgb_cmap_new", "guint32*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_colors), n_colors, 2, "gdk_rgb_cmap_new", "gint");
  return(C_TO_XEN_GdkRgbCmap_(gdk_rgb_cmap_new(XEN_TO_C_guint32_(colors), XEN_TO_C_gint(n_colors))));
}
static XEN gxg_gdk_rgb_cmap_free(XEN cmap)
{
  #define H_gdk_rgb_cmap_free "void gdk_rgb_cmap_free(GdkRgbCmap* cmap)"
  XEN_ASSERT_TYPE(XEN_GdkRgbCmap__P(cmap), cmap, 1, "gdk_rgb_cmap_free", "GdkRgbCmap*");
  gdk_rgb_cmap_free(XEN_TO_C_GdkRgbCmap_(cmap));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rgb_ditherable(void)
{
  #define H_gdk_rgb_ditherable "gboolean gdk_rgb_ditherable( void)"
  return(C_TO_XEN_gboolean(gdk_rgb_ditherable()));
}
static XEN gxg_gdk_rgb_set_verbose(XEN verbose)
{
  #define H_gdk_rgb_set_verbose "void gdk_rgb_set_verbose(gboolean verbose)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(verbose), verbose, 1, "gdk_rgb_set_verbose", "gboolean");
  gdk_rgb_set_verbose(XEN_TO_C_gboolean(verbose));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rgb_set_install(XEN install)
{
  #define H_gdk_rgb_set_install "void gdk_rgb_set_install(gboolean install)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(install), install, 1, "gdk_rgb_set_install", "gboolean");
  gdk_rgb_set_install(XEN_TO_C_gboolean(install));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rgb_set_min_colors(XEN min_colors)
{
  #define H_gdk_rgb_set_min_colors "void gdk_rgb_set_min_colors(gint min_colors)"
  XEN_ASSERT_TYPE(XEN_gint_P(min_colors), min_colors, 1, "gdk_rgb_set_min_colors", "gint");
  gdk_rgb_set_min_colors(XEN_TO_C_gint(min_colors));
  return(XEN_FALSE);
}
static XEN gxg_gdk_rgb_get_colormap(void)
{
  #define H_gdk_rgb_get_colormap "GdkColormap* gdk_rgb_get_colormap( void)"
  return(C_TO_XEN_GdkColormap_(gdk_rgb_get_colormap()));
}
static XEN gxg_gdk_rgb_get_visual(void)
{
  #define H_gdk_rgb_get_visual "GdkVisual* gdk_rgb_get_visual( void)"
  return(C_TO_XEN_GdkVisual_(gdk_rgb_get_visual()));
}
static XEN gxg_gdk_selection_owner_set(XEN owner, XEN selection, XEN time, XEN send_event)
{
  #define H_gdk_selection_owner_set "gboolean gdk_selection_owner_set(GdkWindow* owner, GdkAtom selection, \
guint32 time, gboolean send_event)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(owner), owner, 1, "gdk_selection_owner_set", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gdk_selection_owner_set", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gdk_selection_owner_set", "guint32");
  XEN_ASSERT_TYPE(XEN_gboolean_P(send_event), send_event, 4, "gdk_selection_owner_set", "gboolean");
  return(C_TO_XEN_gboolean(gdk_selection_owner_set(XEN_TO_C_GdkWindow_(owner), XEN_TO_C_GdkAtom(selection), XEN_TO_C_guint32(time), 
                                                   XEN_TO_C_gboolean(send_event))));
}
static XEN gxg_gdk_selection_owner_get(XEN selection)
{
  #define H_gdk_selection_owner_get "GdkWindow* gdk_selection_owner_get(GdkAtom selection)"
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 1, "gdk_selection_owner_get", "GdkAtom");
  return(C_TO_XEN_GdkWindow_(gdk_selection_owner_get(XEN_TO_C_GdkAtom(selection))));
}
static XEN gxg_gdk_selection_convert(XEN requestor, XEN selection, XEN target, XEN time)
{
  #define H_gdk_selection_convert "void gdk_selection_convert(GdkWindow* requestor, GdkAtom selection, \
GdkAtom target, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(requestor), requestor, 1, "gdk_selection_convert", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gdk_selection_convert", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 3, "gdk_selection_convert", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 4, "gdk_selection_convert", "guint32");
  gdk_selection_convert(XEN_TO_C_GdkWindow_(requestor), XEN_TO_C_GdkAtom(selection), XEN_TO_C_GdkAtom(target), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_selection_property_get(XEN requestor, XEN data, XEN prop_type, XEN prop_format)
{
  #define H_gdk_selection_property_get "gboolean gdk_selection_property_get(GdkWindow* requestor, guchar** [data], \
GdkAtom* [prop_type], gint* [prop_format])"
  guchar* ref_data = NULL;
  GdkAtom ref_prop_type;
  gint ref_prop_format;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(requestor), requestor, 1, "gdk_selection_property_get", "GdkWindow*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_selection_property_get(XEN_TO_C_GdkWindow_(requestor), &ref_data, &ref_prop_type, &ref_prop_format));
    return(XEN_LIST_4(result, C_TO_XEN_guchar_(ref_data), C_TO_XEN_GdkAtom(ref_prop_type), C_TO_XEN_gint(ref_prop_format)));
   }
}
static XEN gxg_gdk_selection_send_notify(XEN requestor, XEN selection, XEN target, XEN property, XEN time)
{
  #define H_gdk_selection_send_notify "void gdk_selection_send_notify(guint32 requestor, GdkAtom selection, \
GdkAtom target, GdkAtom property, guint32 time)"
  XEN_ASSERT_TYPE(XEN_guint32_P(requestor), requestor, 1, "gdk_selection_send_notify", "guint32");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gdk_selection_send_notify", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 3, "gdk_selection_send_notify", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(property), property, 4, "gdk_selection_send_notify", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 5, "gdk_selection_send_notify", "guint32");
  gdk_selection_send_notify(XEN_TO_C_guint32(requestor), XEN_TO_C_GdkAtom(selection), XEN_TO_C_GdkAtom(target), XEN_TO_C_GdkAtom(property), 
                            XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_visual_get_type(void)
{
  #define H_gdk_visual_get_type "GType gdk_visual_get_type( void)"
  return(C_TO_XEN_GType(gdk_visual_get_type()));
}
static XEN gxg_gdk_visual_get_best_depth(void)
{
  #define H_gdk_visual_get_best_depth "gint gdk_visual_get_best_depth( void)"
  return(C_TO_XEN_gint(gdk_visual_get_best_depth()));
}
static XEN gxg_gdk_visual_get_best_type(void)
{
  #define H_gdk_visual_get_best_type "GdkVisualType gdk_visual_get_best_type( void)"
  return(C_TO_XEN_GdkVisualType(gdk_visual_get_best_type()));
}
static XEN gxg_gdk_visual_get_system(void)
{
  #define H_gdk_visual_get_system "GdkVisual* gdk_visual_get_system( void)"
  return(C_TO_XEN_GdkVisual_(gdk_visual_get_system()));
}
static XEN gxg_gdk_visual_get_best(void)
{
  #define H_gdk_visual_get_best "GdkVisual* gdk_visual_get_best( void)"
  return(C_TO_XEN_GdkVisual_(gdk_visual_get_best()));
}
static XEN gxg_gdk_visual_get_best_with_depth(XEN depth)
{
  #define H_gdk_visual_get_best_with_depth "GdkVisual* gdk_visual_get_best_with_depth(gint depth)"
  XEN_ASSERT_TYPE(XEN_gint_P(depth), depth, 1, "gdk_visual_get_best_with_depth", "gint");
  return(C_TO_XEN_GdkVisual_(gdk_visual_get_best_with_depth(XEN_TO_C_gint(depth))));
}
static XEN gxg_gdk_visual_get_best_with_type(XEN visual_type)
{
  #define H_gdk_visual_get_best_with_type "GdkVisual* gdk_visual_get_best_with_type(GdkVisualType visual_type)"
  XEN_ASSERT_TYPE(XEN_GdkVisualType_P(visual_type), visual_type, 1, "gdk_visual_get_best_with_type", "GdkVisualType");
  return(C_TO_XEN_GdkVisual_(gdk_visual_get_best_with_type(XEN_TO_C_GdkVisualType(visual_type))));
}
static XEN gxg_gdk_visual_get_best_with_both(XEN depth, XEN visual_type)
{
  #define H_gdk_visual_get_best_with_both "GdkVisual* gdk_visual_get_best_with_both(gint depth, GdkVisualType visual_type)"
  XEN_ASSERT_TYPE(XEN_gint_P(depth), depth, 1, "gdk_visual_get_best_with_both", "gint");
  XEN_ASSERT_TYPE(XEN_GdkVisualType_P(visual_type), visual_type, 2, "gdk_visual_get_best_with_both", "GdkVisualType");
  return(C_TO_XEN_GdkVisual_(gdk_visual_get_best_with_both(XEN_TO_C_gint(depth), XEN_TO_C_GdkVisualType(visual_type))));
}
static XEN gxg_gdk_query_depths(XEN depths, XEN count)
{
  #define H_gdk_query_depths "void gdk_query_depths(gint** [depths], gint* [count])"
  gint* ref_depths = NULL;
  gint ref_count;
  gdk_query_depths(&ref_depths, &ref_count);
  return(XEN_LIST_2(C_TO_XEN_gint_(ref_depths), C_TO_XEN_gint(ref_count)));
}
static XEN gxg_gdk_query_visual_types(XEN visual_types, XEN count)
{
  #define H_gdk_query_visual_types "void gdk_query_visual_types(GdkVisualType** [visual_types], gint* [count])"
  GdkVisualType* ref_visual_types = NULL;
  gint ref_count;
  gdk_query_visual_types(&ref_visual_types, &ref_count);
  return(XEN_LIST_2(C_TO_XEN_GdkVisualType_(ref_visual_types), C_TO_XEN_gint(ref_count)));
}
static XEN gxg_gdk_list_visuals(void)
{
  #define H_gdk_list_visuals "GList* gdk_list_visuals( void)"
  return(C_TO_XEN_GList_(gdk_list_visuals()));
}
static XEN gxg_gdk_window_new(XEN parent, XEN attributes, XEN attributes_mask)
{
  #define H_gdk_window_new "GdkWindow* gdk_window_new(GdkWindow* parent, GdkWindowAttr* attributes, gint attributes_mask)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(parent), parent, 1, "gdk_window_new", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(attributes), attributes, 2, "gdk_window_new", "GdkWindowAttr*");
  XEN_ASSERT_TYPE(XEN_gint_P(attributes_mask), attributes_mask, 3, "gdk_window_new", "gint");
  return(C_TO_XEN_GdkWindow_(gdk_window_new(XEN_TO_C_GdkWindow_(parent), XEN_TO_C_GdkWindowAttr_(attributes), XEN_TO_C_gint(attributes_mask))));
}
static XEN gxg_gdk_window_destroy(XEN window)
{
  #define H_gdk_window_destroy "void gdk_window_destroy(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_destroy", "GdkWindow*");
  gdk_window_destroy(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_window_type(XEN window)
{
  #define H_gdk_window_get_window_type "GdkWindowType gdk_window_get_window_type(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_window_type", "GdkWindow*");
  return(C_TO_XEN_GdkWindowType(gdk_window_get_window_type(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_at_pointer(XEN win_x, XEN win_y)
{
  #define H_gdk_window_at_pointer "GdkWindow* gdk_window_at_pointer(gint* [win_x], gint* [win_y])"
  gint ref_win_x;
  gint ref_win_y;
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkWindow_(gdk_window_at_pointer(&ref_win_x, &ref_win_y));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_win_x), C_TO_XEN_gint(ref_win_y)));
   }
}
static XEN gxg_gdk_window_show(XEN window)
{
  #define H_gdk_window_show "void gdk_window_show(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_show", "GdkWindow*");
  gdk_window_show(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_hide(XEN window)
{
  #define H_gdk_window_hide "void gdk_window_hide(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_hide", "GdkWindow*");
  gdk_window_hide(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_withdraw(XEN window)
{
  #define H_gdk_window_withdraw "void gdk_window_withdraw(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_withdraw", "GdkWindow*");
  gdk_window_withdraw(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_show_unraised(XEN window)
{
  #define H_gdk_window_show_unraised "void gdk_window_show_unraised(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_show_unraised", "GdkWindow*");
  gdk_window_show_unraised(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_move(XEN window, XEN x, XEN y)
{
  #define H_gdk_window_move "void gdk_window_move(GdkWindow* window, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_move", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_window_move", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_window_move", "gint");
  gdk_window_move(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_resize(XEN window, XEN width, XEN height)
{
  #define H_gdk_window_resize "void gdk_window_resize(GdkWindow* window, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_resize", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gdk_window_resize", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gdk_window_resize", "gint");
  gdk_window_resize(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_move_resize(XEN window, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gdk_window_move_resize "void gdk_window_move_resize(GdkWindow* window, gint x, gint y, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_move_resize", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_window_move_resize", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_window_move_resize", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 4, "gdk_window_move_resize", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 5, "gdk_window_move_resize", "gint");
  gdk_window_move_resize(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_reparent(XEN window, XEN new_parent, XEN x, XEN y)
{
  #define H_gdk_window_reparent "void gdk_window_reparent(GdkWindow* window, GdkWindow* new_parent, gint x, \
gint y)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_reparent", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(new_parent), new_parent, 2, "gdk_window_reparent", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_window_reparent", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_window_reparent", "gint");
  gdk_window_reparent(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindow_(new_parent), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_clear(XEN window)
{
  #define H_gdk_window_clear "void gdk_window_clear(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_clear", "GdkWindow*");
  gdk_window_clear(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_clear_area(XEN window, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gdk_window_clear_area "void gdk_window_clear_area(GdkWindow* window, gint x, gint y, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_clear_area", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_window_clear_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_window_clear_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 4, "gdk_window_clear_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 5, "gdk_window_clear_area", "gint");
  gdk_window_clear_area(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_clear_area_e(XEN window, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gdk_window_clear_area_e "void gdk_window_clear_area_e(GdkWindow* window, gint x, gint y, \
gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_clear_area_e", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gdk_window_clear_area_e", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gdk_window_clear_area_e", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 4, "gdk_window_clear_area_e", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 5, "gdk_window_clear_area_e", "gint");
  gdk_window_clear_area_e(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_raise(XEN window)
{
  #define H_gdk_window_raise "void gdk_window_raise(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_raise", "GdkWindow*");
  gdk_window_raise(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_lower(XEN window)
{
  #define H_gdk_window_lower "void gdk_window_lower(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_lower", "GdkWindow*");
  gdk_window_lower(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_focus(XEN window, XEN timestamp)
{
  #define H_gdk_window_focus "void gdk_window_focus(GdkWindow* window, guint32 timestamp)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_focus", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_guint32_P(timestamp), timestamp, 2, "gdk_window_focus", "guint32");
  gdk_window_focus(XEN_TO_C_GdkWindow_(window), XEN_TO_C_guint32(timestamp));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_user_data(XEN window, XEN user_data)
{
  #define H_gdk_window_set_user_data "void gdk_window_set_user_data(GdkWindow* window, gpointer user_data)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window) || XEN_FALSE_P(window), window, 1, "gdk_window_set_user_data", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(user_data), user_data, 2, "gdk_window_set_user_data", "gpointer");
  gdk_window_set_user_data(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gpointer(user_data));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_override_redirect(XEN window, XEN override_redirect)
{
  #define H_gdk_window_set_override_redirect "void gdk_window_set_override_redirect(GdkWindow* window, \
gboolean override_redirect)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_override_redirect", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(override_redirect), override_redirect, 2, "gdk_window_set_override_redirect", "gboolean");
  gdk_window_set_override_redirect(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(override_redirect));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_add_filter(XEN window, XEN func, XEN func_data)
{
  #define H_gdk_window_add_filter "void gdk_window_add_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_add_filter", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkFilterFunc_P(func), func, 2, "gdk_window_add_filter", "GdkFilterFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gdk_window_add_filter", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gdk_window_add_filter(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkFilterFunc(func), XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_window_remove_filter(XEN window, XEN func, XEN func_data)
{
  #define H_gdk_window_remove_filter "void gdk_window_remove_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_remove_filter", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkFilterFunc_P(func), func, 2, "gdk_window_remove_filter", "GdkFilterFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gdk_window_remove_filter", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gdk_window_remove_filter(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkFilterFunc(func), XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_window_scroll(XEN window, XEN dx, XEN dy)
{
  #define H_gdk_window_scroll "void gdk_window_scroll(GdkWindow* window, gint dx, gint dy)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_scroll", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(dx), dx, 2, "gdk_window_scroll", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(dy), dy, 3, "gdk_window_scroll", "gint");
  gdk_window_scroll(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(dx), XEN_TO_C_gint(dy));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_shape_combine_mask(XEN window, XEN mask, XEN x, XEN y)
{
  #define H_gdk_window_shape_combine_mask "void gdk_window_shape_combine_mask(GdkWindow* window, GdkBitmap* mask, \
gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_shape_combine_mask", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask), mask, 2, "gdk_window_shape_combine_mask", "GdkBitmap*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_window_shape_combine_mask", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_window_shape_combine_mask", "gint");
  gdk_window_shape_combine_mask(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkBitmap_(mask), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_shape_combine_region(XEN window, XEN shape_region, XEN offset_x, XEN offset_y)
{
  #define H_gdk_window_shape_combine_region "void gdk_window_shape_combine_region(GdkWindow* window, \
GdkRegion* shape_region, gint offset_x, gint offset_y)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_shape_combine_region", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(shape_region), shape_region, 2, "gdk_window_shape_combine_region", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_gint_P(offset_x), offset_x, 3, "gdk_window_shape_combine_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(offset_y), offset_y, 4, "gdk_window_shape_combine_region", "gint");
  gdk_window_shape_combine_region(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRegion_(shape_region), XEN_TO_C_gint(offset_x), 
                                  XEN_TO_C_gint(offset_y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_child_shapes(XEN window)
{
  #define H_gdk_window_set_child_shapes "void gdk_window_set_child_shapes(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_child_shapes", "GdkWindow*");
  gdk_window_set_child_shapes(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_merge_child_shapes(XEN window)
{
  #define H_gdk_window_merge_child_shapes "void gdk_window_merge_child_shapes(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_merge_child_shapes", "GdkWindow*");
  gdk_window_merge_child_shapes(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_is_visible(XEN window)
{
  #define H_gdk_window_is_visible "gboolean gdk_window_is_visible(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_is_visible", "GdkWindow*");
  return(C_TO_XEN_gboolean(gdk_window_is_visible(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_is_viewable(XEN window)
{
  #define H_gdk_window_is_viewable "gboolean gdk_window_is_viewable(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_is_viewable", "GdkWindow*");
  return(C_TO_XEN_gboolean(gdk_window_is_viewable(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_get_state(XEN window)
{
  #define H_gdk_window_get_state "GdkWindowState gdk_window_get_state(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_state", "GdkWindow*");
  return(C_TO_XEN_GdkWindowState(gdk_window_get_state(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_set_static_gravities(XEN window, XEN use_static)
{
  #define H_gdk_window_set_static_gravities "gboolean gdk_window_set_static_gravities(GdkWindow* window, \
gboolean use_static)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_static_gravities", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_static), use_static, 2, "gdk_window_set_static_gravities", "gboolean");
  return(C_TO_XEN_gboolean(gdk_window_set_static_gravities(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(use_static))));
}
static XEN gxg_gdk_window_foreign_new(XEN anid)
{
  #define H_gdk_window_foreign_new "GdkWindow* gdk_window_foreign_new(GdkNativeWindow anid)"
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(anid), anid, 1, "gdk_window_foreign_new", "GdkNativeWindow");
  return(C_TO_XEN_GdkWindow_(gdk_window_foreign_new(XEN_TO_C_GdkNativeWindow(anid))));
}
static XEN gxg_gdk_window_lookup(XEN anid)
{
  #define H_gdk_window_lookup "GdkWindow* gdk_window_lookup(GdkNativeWindow anid)"
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(anid), anid, 1, "gdk_window_lookup", "GdkNativeWindow");
  return(C_TO_XEN_GdkWindow_(gdk_window_lookup(XEN_TO_C_GdkNativeWindow(anid))));
}
static XEN gxg_gdk_window_get_root_origin(XEN window, XEN x, XEN y)
{
  #define H_gdk_window_get_root_origin "void gdk_window_get_root_origin(GdkWindow* window, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_root_origin", "GdkWindow*");
  gdk_window_get_root_origin(XEN_TO_C_GdkWindow_(window), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gdk_window_get_frame_extents(XEN window, XEN rect)
{
  #define H_gdk_window_get_frame_extents "void gdk_window_get_frame_extents(GdkWindow* window, GdkRectangle* rect)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_frame_extents", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 2, "gdk_window_get_frame_extents", "GdkRectangle*");
  gdk_window_get_frame_extents(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRectangle_(rect));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_pointer(XEN window, XEN x, XEN y, XEN mask)
{
  #define H_gdk_window_get_pointer "GdkWindow* gdk_window_get_pointer(GdkWindow* window, gint* [x], gint* [y], \
GdkModifierType* [mask])"
  gint ref_x;
  gint ref_y;
  GdkModifierType ref_mask;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_pointer", "GdkWindow*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkWindow_(gdk_window_get_pointer(XEN_TO_C_GdkWindow_(window), &ref_x, &ref_y, &ref_mask));
    return(XEN_LIST_4(result, C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y), C_TO_XEN_GdkModifierType(ref_mask)));
   }
}
static XEN gxg_gdk_window_get_parent(XEN window)
{
  #define H_gdk_window_get_parent "GdkWindow* gdk_window_get_parent(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_parent", "GdkWindow*");
  return(C_TO_XEN_GdkWindow_(gdk_window_get_parent(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_get_toplevel(XEN window)
{
  #define H_gdk_window_get_toplevel "GdkWindow* gdk_window_get_toplevel(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_toplevel", "GdkWindow*");
  return(C_TO_XEN_GdkWindow_(gdk_window_get_toplevel(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_get_children(XEN window)
{
  #define H_gdk_window_get_children "GList* gdk_window_get_children(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_children", "GdkWindow*");
  return(C_TO_XEN_GList_(gdk_window_get_children(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_peek_children(XEN window)
{
  #define H_gdk_window_peek_children "GList* gdk_window_peek_children(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_peek_children", "GdkWindow*");
  return(C_TO_XEN_GList_(gdk_window_peek_children(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_get_events(XEN window)
{
  #define H_gdk_window_get_events "GdkEventMask gdk_window_get_events(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_events", "GdkWindow*");
  return(C_TO_XEN_GdkEventMask(gdk_window_get_events(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_set_events(XEN window, XEN event_mask)
{
  #define H_gdk_window_set_events "void gdk_window_set_events(GdkWindow* window, GdkEventMask event_mask)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_events", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkEventMask_P(event_mask), event_mask, 2, "gdk_window_set_events", "GdkEventMask");
  gdk_window_set_events(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkEventMask(event_mask));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_icon_list(XEN window, XEN pixbufs)
{
  #define H_gdk_window_set_icon_list "void gdk_window_set_icon_list(GdkWindow* window, GList* pixbufs)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_icon_list", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GList__P(pixbufs), pixbufs, 2, "gdk_window_set_icon_list", "GList*");
  gdk_window_set_icon_list(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GList_(pixbufs));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_icon(XEN window, XEN icon_window, XEN pixmap, XEN mask)
{
  #define H_gdk_window_set_icon "void gdk_window_set_icon(GdkWindow* window, GdkWindow* icon_window, \
GdkPixmap* pixmap, GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_icon", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(icon_window), icon_window, 2, "gdk_window_set_icon", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap), pixmap, 3, "gdk_window_set_icon", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask), mask, 4, "gdk_window_set_icon", "GdkBitmap*");
  gdk_window_set_icon(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindow_(icon_window), XEN_TO_C_GdkPixmap_(pixmap), XEN_TO_C_GdkBitmap_(mask));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_icon_name(XEN window, XEN name)
{
  #define H_gdk_window_set_icon_name "void gdk_window_set_icon_name(GdkWindow* window, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_icon_name", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gdk_window_set_icon_name", "gchar*");
  gdk_window_set_icon_name(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_group(XEN window, XEN leader)
{
  #define H_gdk_window_set_group "void gdk_window_set_group(GdkWindow* window, GdkWindow* leader)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_group", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(leader), leader, 2, "gdk_window_set_group", "GdkWindow*");
  gdk_window_set_group(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindow_(leader));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_decorations(XEN window, XEN decorations)
{
  #define H_gdk_window_set_decorations "void gdk_window_set_decorations(GdkWindow* window, GdkWMDecoration decorations)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_decorations", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWMDecoration_P(decorations), decorations, 2, "gdk_window_set_decorations", "GdkWMDecoration");
  gdk_window_set_decorations(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWMDecoration(decorations));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_decorations(XEN window, XEN decorations)
{
  #define H_gdk_window_get_decorations "gboolean gdk_window_get_decorations(GdkWindow* window, GdkWMDecoration* [decorations])"
  GdkWMDecoration ref_decorations;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_decorations", "GdkWindow*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_window_get_decorations(XEN_TO_C_GdkWindow_(window), &ref_decorations));
    return(XEN_LIST_2(result, C_TO_XEN_GdkWMDecoration(ref_decorations)));
   }
}
static XEN gxg_gdk_window_set_functions(XEN window, XEN functions)
{
  #define H_gdk_window_set_functions "void gdk_window_set_functions(GdkWindow* window, GdkWMFunction functions)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_functions", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWMFunction_P(functions), functions, 2, "gdk_window_set_functions", "GdkWMFunction");
  gdk_window_set_functions(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWMFunction(functions));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_toplevels(void)
{
  #define H_gdk_window_get_toplevels "GList* gdk_window_get_toplevels( void)"
  return(C_TO_XEN_GList_(gdk_window_get_toplevels()));
}
static XEN gxg_gdk_window_iconify(XEN window)
{
  #define H_gdk_window_iconify "void gdk_window_iconify(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_iconify", "GdkWindow*");
  gdk_window_iconify(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_deiconify(XEN window)
{
  #define H_gdk_window_deiconify "void gdk_window_deiconify(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_deiconify", "GdkWindow*");
  gdk_window_deiconify(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_stick(XEN window)
{
  #define H_gdk_window_stick "void gdk_window_stick(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_stick", "GdkWindow*");
  gdk_window_stick(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_unstick(XEN window)
{
  #define H_gdk_window_unstick "void gdk_window_unstick(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_unstick", "GdkWindow*");
  gdk_window_unstick(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_maximize(XEN window)
{
  #define H_gdk_window_maximize "void gdk_window_maximize(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_maximize", "GdkWindow*");
  gdk_window_maximize(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_unmaximize(XEN window)
{
  #define H_gdk_window_unmaximize "void gdk_window_unmaximize(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_unmaximize", "GdkWindow*");
  gdk_window_unmaximize(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_register_dnd(XEN window)
{
  #define H_gdk_window_register_dnd "void gdk_window_register_dnd(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_register_dnd", "GdkWindow*");
  gdk_window_register_dnd(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_begin_resize_drag(XEN window, XEN edge, XEN button, XEN root_x, XEN root_y, XEN timestamp)
{
  #define H_gdk_window_begin_resize_drag "void gdk_window_begin_resize_drag(GdkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_begin_resize_drag", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindowEdge_P(edge), edge, 2, "gdk_window_begin_resize_drag", "GdkWindowEdge");
  XEN_ASSERT_TYPE(XEN_gint_P(button), button, 3, "gdk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_x), root_x, 4, "gdk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_y), root_y, 5, "gdk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_guint32_P(timestamp), timestamp, 6, "gdk_window_begin_resize_drag", "guint32");
  gdk_window_begin_resize_drag(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindowEdge(edge), XEN_TO_C_gint(button), XEN_TO_C_gint(root_x), 
                               XEN_TO_C_gint(root_y), XEN_TO_C_guint32(timestamp));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_begin_move_drag(XEN window, XEN button, XEN root_x, XEN root_y, XEN timestamp)
{
  #define H_gdk_window_begin_move_drag "void gdk_window_begin_move_drag(GdkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_begin_move_drag", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(button), button, 2, "gdk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_x), root_x, 3, "gdk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_y), root_y, 4, "gdk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_guint32_P(timestamp), timestamp, 5, "gdk_window_begin_move_drag", "guint32");
  gdk_window_begin_move_drag(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gint(button), XEN_TO_C_gint(root_x), XEN_TO_C_gint(root_y), 
                             XEN_TO_C_guint32(timestamp));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_invalidate_rect(XEN window, XEN rect, XEN invalidate_children)
{
  #define H_gdk_window_invalidate_rect "void gdk_window_invalidate_rect(GdkWindow* window, GdkRectangle* rect, \
gboolean invalidate_children)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_invalidate_rect", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 2, "gdk_window_invalidate_rect", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(invalidate_children), invalidate_children, 3, "gdk_window_invalidate_rect", "gboolean");
  gdk_window_invalidate_rect(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRectangle_(rect), XEN_TO_C_gboolean(invalidate_children));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_invalidate_region(XEN window, XEN region, XEN invalidate_children)
{
  #define H_gdk_window_invalidate_region "void gdk_window_invalidate_region(GdkWindow* window, GdkRegion* region, \
gboolean invalidate_children)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_invalidate_region", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 2, "gdk_window_invalidate_region", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(invalidate_children), invalidate_children, 3, "gdk_window_invalidate_region", "gboolean");
  gdk_window_invalidate_region(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRegion_(region), XEN_TO_C_gboolean(invalidate_children));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_invalidate_maybe_recurse(XEN window, XEN region, XEN func, XEN func_data)
{
  #define H_gdk_window_invalidate_maybe_recurse "void gdk_window_invalidate_maybe_recurse(GdkWindow* window, \
GdkRegion* region, lambda2 func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_invalidate_maybe_recurse", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 2, "gdk_window_invalidate_maybe_recurse", "GdkRegion*");
  XEN_ASSERT_TYPE(XEN_lambda2_P(func), func, 3, "gdk_window_invalidate_maybe_recurse", "lambda2");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gdk_window_invalidate_maybe_recurse", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gdk_window_invalidate_maybe_recurse(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRegion_(region), XEN_TO_C_lambda2(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_window_get_update_area(XEN window)
{
  #define H_gdk_window_get_update_area "GdkRegion* gdk_window_get_update_area(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_update_area", "GdkWindow*");
  return(C_TO_XEN_GdkRegion_(gdk_window_get_update_area(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_window_freeze_updates(XEN window)
{
  #define H_gdk_window_freeze_updates "void gdk_window_freeze_updates(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_freeze_updates", "GdkWindow*");
  gdk_window_freeze_updates(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_thaw_updates(XEN window)
{
  #define H_gdk_window_thaw_updates "void gdk_window_thaw_updates(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_thaw_updates", "GdkWindow*");
  gdk_window_thaw_updates(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_process_all_updates(void)
{
  #define H_gdk_window_process_all_updates "void gdk_window_process_all_updates( void)"
  gdk_window_process_all_updates();
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_process_updates(XEN window, XEN update_children)
{
  #define H_gdk_window_process_updates "void gdk_window_process_updates(GdkWindow* window, gboolean update_children)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_process_updates", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(update_children), update_children, 2, "gdk_window_process_updates", "gboolean");
  gdk_window_process_updates(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(update_children));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_debug_updates(XEN setting)
{
  #define H_gdk_window_set_debug_updates "void gdk_window_set_debug_updates(gboolean setting)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 1, "gdk_window_set_debug_updates", "gboolean");
  gdk_window_set_debug_updates(XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_constrain_size(XEN geometry, XEN flags, XEN width, XEN height, XEN new_width, XEN new_height)
{
  #define H_gdk_window_constrain_size "void gdk_window_constrain_size(GdkGeometry* geometry, guint flags, \
gint width, gint height, gint* [new_width], gint* [new_height])"
  gint ref_new_width;
  gint ref_new_height;
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(geometry), geometry, 1, "gdk_window_constrain_size", "GdkGeometry*");
  XEN_ASSERT_TYPE(XEN_guint_P(flags), flags, 2, "gdk_window_constrain_size", "guint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 3, "gdk_window_constrain_size", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 4, "gdk_window_constrain_size", "gint");
  gdk_window_constrain_size(XEN_TO_C_GdkGeometry_(geometry), XEN_TO_C_guint(flags), XEN_TO_C_gint(width), XEN_TO_C_gint(height), 
                            &ref_new_width, &ref_new_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_new_width), C_TO_XEN_gint(ref_new_height)));
}
static XEN gxg_gdk_window_get_internal_paint_info(XEN window, XEN real_drawable, XEN x_offset, XEN y_offset)
{
  #define H_gdk_window_get_internal_paint_info "void gdk_window_get_internal_paint_info(GdkWindow* window, \
GdkDrawable** [real_drawable], gint* [x_offset], gint* [y_offset])"
  GdkDrawable* ref_real_drawable = NULL;
  gint ref_x_offset;
  gint ref_y_offset;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_internal_paint_info", "GdkWindow*");
  gdk_window_get_internal_paint_info(XEN_TO_C_GdkWindow_(window), &ref_real_drawable, &ref_x_offset, &ref_y_offset);
  return(XEN_LIST_3(C_TO_XEN_GdkDrawable_(ref_real_drawable), C_TO_XEN_gint(ref_x_offset), C_TO_XEN_gint(ref_y_offset)));
}
static XEN gxg_gtk_window_remove_embedded_xid(XEN window, XEN xid)
{
  #define H_gtk_window_remove_embedded_xid "void gtk_window_remove_embedded_xid(GtkWindow* window, guint xid)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_remove_embedded_xid", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_guint_P(xid), xid, 2, "gtk_window_remove_embedded_xid", "guint");
  gtk_window_remove_embedded_xid(XEN_TO_C_GtkWindow_(window), XEN_TO_C_guint(xid));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_add_embedded_xid(XEN window, XEN xid)
{
  #define H_gtk_window_add_embedded_xid "void gtk_window_add_embedded_xid(GtkWindow* window, guint xid)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_add_embedded_xid", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_guint_P(xid), xid, 2, "gtk_window_add_embedded_xid", "guint");
  gtk_window_add_embedded_xid(XEN_TO_C_GtkWindow_(window), XEN_TO_C_guint(xid));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_type_hint(XEN window, XEN hint)
{
  #define H_gdk_window_set_type_hint "void gdk_window_set_type_hint(GdkWindow* window, GdkWindowTypeHint hint)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_type_hint", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindowTypeHint_P(hint), hint, 2, "gdk_window_set_type_hint", "GdkWindowTypeHint");
  gdk_window_set_type_hint(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindowTypeHint(hint));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_modal_hint(XEN window, XEN modal)
{
  #define H_gdk_window_set_modal_hint "void gdk_window_set_modal_hint(GdkWindow* window, gboolean modal)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_modal_hint", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(modal), modal, 2, "gdk_window_set_modal_hint", "gboolean");
  gdk_window_set_modal_hint(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(modal));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_geometry_hints(XEN window, XEN geometry, XEN geom_mask)
{
  #define H_gdk_window_set_geometry_hints "void gdk_window_set_geometry_hints(GdkWindow* window, GdkGeometry* geometry, \
GdkWindowHints geom_mask)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_geometry_hints", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(geometry), geometry, 2, "gdk_window_set_geometry_hints", "GdkGeometry*");
  XEN_ASSERT_TYPE(XEN_GdkWindowHints_P(geom_mask), geom_mask, 3, "gdk_window_set_geometry_hints", "GdkWindowHints");
  gdk_window_set_geometry_hints(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkGeometry_(geometry), XEN_TO_C_GdkWindowHints(geom_mask));
  return(XEN_FALSE);
}
static XEN gxg_gdk_set_sm_client_id(XEN sm_client_id)
{
  #define H_gdk_set_sm_client_id "void gdk_set_sm_client_id(gchar* sm_client_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(sm_client_id), sm_client_id, 1, "gdk_set_sm_client_id", "gchar*");
  gdk_set_sm_client_id(XEN_TO_C_gchar_(sm_client_id));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_begin_paint_rect(XEN window, XEN rectangle)
{
  #define H_gdk_window_begin_paint_rect "void gdk_window_begin_paint_rect(GdkWindow* window, GdkRectangle* rectangle)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_begin_paint_rect", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rectangle), rectangle, 2, "gdk_window_begin_paint_rect", "GdkRectangle*");
  gdk_window_begin_paint_rect(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRectangle_(rectangle));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_begin_paint_region(XEN window, XEN region)
{
  #define H_gdk_window_begin_paint_region "void gdk_window_begin_paint_region(GdkWindow* window, GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_begin_paint_region", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 2, "gdk_window_begin_paint_region", "GdkRegion*");
  gdk_window_begin_paint_region(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkRegion_(region));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_end_paint(XEN window)
{
  #define H_gdk_window_end_paint "void gdk_window_end_paint(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_end_paint", "GdkWindow*");
  gdk_window_end_paint(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_title(XEN window, XEN title)
{
  #define H_gdk_window_set_title "void gdk_window_set_title(GdkWindow* window, gchar* title)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_title", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gdk_window_set_title", "gchar*");
  gdk_window_set_title(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_role(XEN window, XEN role)
{
  #define H_gdk_window_set_role "void gdk_window_set_role(GdkWindow* window, gchar* role)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_role", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(role), role, 2, "gdk_window_set_role", "gchar*");
  gdk_window_set_role(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gchar_(role));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_transient_for(XEN window, XEN parent)
{
  #define H_gdk_window_set_transient_for "void gdk_window_set_transient_for(GdkWindow* window, GdkWindow* parent)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_transient_for", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(parent), parent, 2, "gdk_window_set_transient_for", "GdkWindow*");
  gdk_window_set_transient_for(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkWindow_(parent));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_background(XEN window, XEN color)
{
  #define H_gdk_window_set_background "void gdk_window_set_background(GdkWindow* window, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_background", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gdk_window_set_background", "GdkColor*");
  gdk_window_set_background(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_back_pixmap(XEN window, XEN pixmap, XEN parent_relative)
{
  #define H_gdk_window_set_back_pixmap "void gdk_window_set_back_pixmap(GdkWindow* window, GdkPixmap* pixmap, \
gboolean parent_relative)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_back_pixmap", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap), pixmap, 2, "gdk_window_set_back_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(parent_relative), parent_relative, 3, "gdk_window_set_back_pixmap", "gboolean");
  gdk_window_set_back_pixmap(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkPixmap_(pixmap), XEN_TO_C_gboolean(parent_relative));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_cursor(XEN window, XEN cursor)
{
  #define H_gdk_window_set_cursor "void gdk_window_set_cursor(GdkWindow* window, GdkCursor* cursor)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_cursor", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkCursor__P(cursor), cursor, 2, "gdk_window_set_cursor", "GdkCursor*");
  gdk_window_set_cursor(XEN_TO_C_GdkWindow_(window), XEN_TO_C_GdkCursor_(cursor));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_user_data(XEN window, XEN data)
{
  #define H_gdk_window_get_user_data "void gdk_window_get_user_data(GdkWindow* window, gpointer* [data])"
  gpointer ref_data;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_user_data", "GdkWindow*");
  gdk_window_get_user_data(XEN_TO_C_GdkWindow_(window), &ref_data);
  return(XEN_LIST_1(C_TO_XEN_gpointer(ref_data)));
}
static XEN gxg_gdk_window_get_geometry(XEN window, XEN x, XEN y, XEN width, XEN height, XEN depth)
{
  #define H_gdk_window_get_geometry "void gdk_window_get_geometry(GdkWindow* window, gint* [x], gint* [y], \
gint* [width], gint* [height], gint* [depth])"
  gint ref_x;
  gint ref_y;
  gint ref_width;
  gint ref_height;
  gint ref_depth;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_geometry", "GdkWindow*");
  gdk_window_get_geometry(XEN_TO_C_GdkWindow_(window), &ref_x, &ref_y, &ref_width, &ref_height, &ref_depth);
  return(XEN_LIST_5(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y), C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height), C_TO_XEN_gint(ref_depth)));
}
static XEN gxg_gdk_window_get_position(XEN window, XEN x, XEN y)
{
  #define H_gdk_window_get_position "void gdk_window_get_position(GdkWindow* window, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_position", "GdkWindow*");
  gdk_window_get_position(XEN_TO_C_GdkWindow_(window), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gdk_window_get_origin(XEN window, XEN x, XEN y)
{
  #define H_gdk_window_get_origin "gint gdk_window_get_origin(GdkWindow* window, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_origin", "GdkWindow*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gint(gdk_window_get_origin(XEN_TO_C_GdkWindow_(window), &ref_x, &ref_y));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
   }
}
static XEN gxg_gdk_get_default_root_window(void)
{
  #define H_gdk_get_default_root_window "GdkWindow* gdk_get_default_root_window( void)"
  return(C_TO_XEN_GdkWindow_(gdk_get_default_root_window()));
}
static XEN gxg_gdk_pixbuf_error_quark(void)
{
  #define H_gdk_pixbuf_error_quark "GQuark gdk_pixbuf_error_quark( void)"
  return(C_TO_XEN_GQuark(gdk_pixbuf_error_quark()));
}
static XEN gxg_gdk_pixbuf_get_type(void)
{
  #define H_gdk_pixbuf_get_type "GType gdk_pixbuf_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_get_type()));
}
static XEN gxg_gdk_pixbuf_get_colorspace(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_colorspace "GdkColorspace gdk_pixbuf_get_colorspace(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_colorspace", "GdkPixbuf*");
  return(C_TO_XEN_GdkColorspace(gdk_pixbuf_get_colorspace(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_n_channels(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_n_channels "int gdk_pixbuf_get_n_channels(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_n_channels", "GdkPixbuf*");
  return(C_TO_XEN_int(gdk_pixbuf_get_n_channels(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_has_alpha(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_has_alpha "gboolean gdk_pixbuf_get_has_alpha(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_has_alpha", "GdkPixbuf*");
  return(C_TO_XEN_gboolean(gdk_pixbuf_get_has_alpha(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_bits_per_sample(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_bits_per_sample "int gdk_pixbuf_get_bits_per_sample(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_bits_per_sample", "GdkPixbuf*");
  return(C_TO_XEN_int(gdk_pixbuf_get_bits_per_sample(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_pixels(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_pixels "guchar* gdk_pixbuf_get_pixels(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_pixels", "GdkPixbuf*");
  return(C_TO_XEN_guchar_(gdk_pixbuf_get_pixels(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_width(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_width "int gdk_pixbuf_get_width(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_width", "GdkPixbuf*");
  return(C_TO_XEN_int(gdk_pixbuf_get_width(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_height(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_height "int gdk_pixbuf_get_height(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_height", "GdkPixbuf*");
  return(C_TO_XEN_int(gdk_pixbuf_get_height(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_get_rowstride(XEN pixbuf)
{
  #define H_gdk_pixbuf_get_rowstride "int gdk_pixbuf_get_rowstride(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_rowstride", "GdkPixbuf*");
  return(C_TO_XEN_int(gdk_pixbuf_get_rowstride(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_new(XEN colorspace, XEN has_alpha, XEN bits_per_sample, XEN width, XEN height)
{
  #define H_gdk_pixbuf_new "GdkPixbuf* gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, \
int width, int height)"
  XEN_ASSERT_TYPE(XEN_GdkColorspace_P(colorspace), colorspace, 1, "gdk_pixbuf_new", "GdkColorspace");
  XEN_ASSERT_TYPE(XEN_gboolean_P(has_alpha), has_alpha, 2, "gdk_pixbuf_new", "gboolean");
  XEN_ASSERT_TYPE(XEN_int_P(bits_per_sample), bits_per_sample, 3, "gdk_pixbuf_new", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 4, "gdk_pixbuf_new", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 5, "gdk_pixbuf_new", "int");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new(XEN_TO_C_GdkColorspace(colorspace), XEN_TO_C_gboolean(has_alpha), XEN_TO_C_int(bits_per_sample), 
                                            XEN_TO_C_int(width), XEN_TO_C_int(height))));
}
static XEN gxg_gdk_pixbuf_copy(XEN pixbuf)
{
  #define H_gdk_pixbuf_copy "GdkPixbuf* gdk_pixbuf_copy(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_copy", "GdkPixbuf*");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_copy(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gdk_pixbuf_new_subpixbuf(XEN src_pixbuf, XEN src_x, XEN src_y, XEN width, XEN height)
{
  #define H_gdk_pixbuf_new_subpixbuf "GdkPixbuf* gdk_pixbuf_new_subpixbuf(GdkPixbuf* src_pixbuf, int src_x, \
int src_y, int width, int height)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src_pixbuf), src_pixbuf, 1, "gdk_pixbuf_new_subpixbuf", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 2, "gdk_pixbuf_new_subpixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 3, "gdk_pixbuf_new_subpixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 4, "gdk_pixbuf_new_subpixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 5, "gdk_pixbuf_new_subpixbuf", "int");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new_subpixbuf(XEN_TO_C_GdkPixbuf_(src_pixbuf), XEN_TO_C_int(src_x), XEN_TO_C_int(src_y), 
                                                      XEN_TO_C_int(width), XEN_TO_C_int(height))));
}
static XEN gxg_gdk_pixbuf_new_from_file(XEN filename, XEN error)
{
  #define H_gdk_pixbuf_new_from_file "GdkPixbuf* gdk_pixbuf_new_from_file(char* filename, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 1, "gdk_pixbuf_new_from_file", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new_from_file(XEN_TO_C_char_(filename), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_new_from_data(XEN data, XEN colorspace, XEN has_alpha, XEN bits_per_sample, XEN width, XEN height, XEN rowstride, XEN destroy_fn, XEN destroy_fn_data)
{
  #define H_gdk_pixbuf_new_from_data "GdkPixbuf* gdk_pixbuf_new_from_data(guchar* data, GdkColorspace colorspace, \
gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride, GdkPixbufDestroyNotify destroy_fn, \
gpointer destroy_fn_data)"
  XEN_ASSERT_TYPE(XEN_guchar__P(data), data, 1, "gdk_pixbuf_new_from_data", "guchar*");
  XEN_ASSERT_TYPE(XEN_GdkColorspace_P(colorspace), colorspace, 2, "gdk_pixbuf_new_from_data", "GdkColorspace");
  XEN_ASSERT_TYPE(XEN_gboolean_P(has_alpha), has_alpha, 3, "gdk_pixbuf_new_from_data", "gboolean");
  XEN_ASSERT_TYPE(XEN_int_P(bits_per_sample), bits_per_sample, 4, "gdk_pixbuf_new_from_data", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 5, "gdk_pixbuf_new_from_data", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 6, "gdk_pixbuf_new_from_data", "int");
  XEN_ASSERT_TYPE(XEN_int_P(rowstride), rowstride, 7, "gdk_pixbuf_new_from_data", "int");
  XEN_ASSERT_TYPE(XEN_GdkPixbufDestroyNotify_P(destroy_fn), destroy_fn, 8, "gdk_pixbuf_new_from_data", "GdkPixbufDestroyNotify");
  XEN_ASSERT_TYPE(XEN_gpointer_P(destroy_fn_data), destroy_fn_data, 9, "gdk_pixbuf_new_from_data", "gpointer");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new_from_data(XEN_TO_C_guchar_(data), XEN_TO_C_GdkColorspace(colorspace), XEN_TO_C_gboolean(has_alpha), 
                                                      XEN_TO_C_int(bits_per_sample), XEN_TO_C_int(width), XEN_TO_C_int(height), 
                                                      XEN_TO_C_int(rowstride), XEN_TO_C_GdkPixbufDestroyNotify(destroy_fn), 
                                                      XEN_TO_C_gpointer(destroy_fn_data))));
}
static XEN gxg_gdk_pixbuf_new_from_xpm_data(XEN data)
{
  #define H_gdk_pixbuf_new_from_xpm_data "GdkPixbuf* gdk_pixbuf_new_from_xpm_data(char** data)"
  XEN_ASSERT_TYPE(XEN_char___P(data), data, 1, "gdk_pixbuf_new_from_xpm_data", "char**");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new_from_xpm_data((const char**)XEN_TO_C_char__(data))));
}
static XEN gxg_gdk_pixbuf_new_from_inline(XEN data_length, XEN data, XEN copy_pixels, XEN error)
{
  #define H_gdk_pixbuf_new_from_inline "GdkPixbuf* gdk_pixbuf_new_from_inline(gint data_length, guint8* data, \
gboolean copy_pixels, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_gint_P(data_length), data_length, 1, "gdk_pixbuf_new_from_inline", "gint");
  XEN_ASSERT_TYPE(XEN_guint8__P(data), data, 2, "gdk_pixbuf_new_from_inline", "guint8*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(copy_pixels), copy_pixels, 3, "gdk_pixbuf_new_from_inline", "gboolean");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbuf_(gdk_pixbuf_new_from_inline(XEN_TO_C_gint(data_length), XEN_TO_C_guint8_(data), XEN_TO_C_gboolean(copy_pixels), 
                                                            &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_fill(XEN pixbuf, XEN pixel)
{
  #define H_gdk_pixbuf_fill "void gdk_pixbuf_fill(GdkPixbuf* pixbuf, guint32 pixel)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_fill", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_guint32_P(pixel), pixel, 2, "gdk_pixbuf_fill", "guint32");
  gdk_pixbuf_fill(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_guint32(pixel));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pixbuf_savev(XEN pixbuf, XEN filename, XEN type, XEN option_keys, XEN option_values, XEN error)
{
  #define H_gdk_pixbuf_savev "gboolean gdk_pixbuf_savev(GdkPixbuf* pixbuf, char* filename, char* type, \
char** option_keys, char** option_values, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_savev", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 2, "gdk_pixbuf_savev", "char*");
  XEN_ASSERT_TYPE(XEN_char__P(type), type, 3, "gdk_pixbuf_savev", "char*");
  XEN_ASSERT_TYPE(XEN_char___P(option_keys), option_keys, 4, "gdk_pixbuf_savev", "char**");
  XEN_ASSERT_TYPE(XEN_char___P(option_values), option_values, 5, "gdk_pixbuf_savev", "char**");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_pixbuf_savev(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_char_(filename), XEN_TO_C_char_(type), 
                                                XEN_TO_C_char__(option_keys), XEN_TO_C_char__(option_values), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_add_alpha(XEN pixbuf, XEN substitute_color, XEN r, XEN g, XEN b)
{
  #define H_gdk_pixbuf_add_alpha "GdkPixbuf* gdk_pixbuf_add_alpha(GdkPixbuf* pixbuf, gboolean substitute_color, \
guchar r, guchar g, guchar b)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_add_alpha", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(substitute_color), substitute_color, 2, "gdk_pixbuf_add_alpha", "gboolean");
  XEN_ASSERT_TYPE(XEN_guchar_P(r), r, 3, "gdk_pixbuf_add_alpha", "guchar");
  XEN_ASSERT_TYPE(XEN_guchar_P(g), g, 4, "gdk_pixbuf_add_alpha", "guchar");
  XEN_ASSERT_TYPE(XEN_guchar_P(b), b, 5, "gdk_pixbuf_add_alpha", "guchar");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_add_alpha(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_gboolean(substitute_color), XEN_TO_C_guchar(r), 
                                                  XEN_TO_C_guchar(g), XEN_TO_C_guchar(b))));
}
static XEN gxg_gdk_pixbuf_copy_area(XEN src_pixbuf, XEN src_x, XEN src_y, XEN width, XEN height, XEN dest_pixbuf, XEN dest_x, XEN dest_y)
{
  #define H_gdk_pixbuf_copy_area "void gdk_pixbuf_copy_area(GdkPixbuf* src_pixbuf, int src_x, int src_y, \
int width, int height, GdkPixbuf* dest_pixbuf, int dest_x, int dest_y)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src_pixbuf), src_pixbuf, 1, "gdk_pixbuf_copy_area", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 2, "gdk_pixbuf_copy_area", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 3, "gdk_pixbuf_copy_area", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 4, "gdk_pixbuf_copy_area", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 5, "gdk_pixbuf_copy_area", "int");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest_pixbuf), dest_pixbuf, 6, "gdk_pixbuf_copy_area", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 7, "gdk_pixbuf_copy_area", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 8, "gdk_pixbuf_copy_area", "int");
  gdk_pixbuf_copy_area(XEN_TO_C_GdkPixbuf_(src_pixbuf), XEN_TO_C_int(src_x), XEN_TO_C_int(src_y), XEN_TO_C_int(width), XEN_TO_C_int(height), 
                       XEN_TO_C_GdkPixbuf_(dest_pixbuf), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pixbuf_saturate_and_pixelate(XEN src, XEN dest, XEN saturation, XEN pixelate)
{
  #define H_gdk_pixbuf_saturate_and_pixelate "void gdk_pixbuf_saturate_and_pixelate(GdkPixbuf* src, GdkPixbuf* dest, \
gfloat saturation, gboolean pixelate)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_saturate_and_pixelate", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest), dest, 2, "gdk_pixbuf_saturate_and_pixelate", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(saturation), saturation, 3, "gdk_pixbuf_saturate_and_pixelate", "gfloat");
  XEN_ASSERT_TYPE(XEN_gboolean_P(pixelate), pixelate, 4, "gdk_pixbuf_saturate_and_pixelate", "gboolean");
  gdk_pixbuf_saturate_and_pixelate(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_gfloat(saturation), XEN_TO_C_gboolean(pixelate));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pixbuf_scale(XEN arglist)
{
  #define H_gdk_pixbuf_scale "void gdk_pixbuf_scale(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, int dest_y, \
int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type)"
  XEN src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type;
  src = XEN_LIST_REF(arglist, 0);
  dest = XEN_LIST_REF(arglist, 1);
  dest_x = XEN_LIST_REF(arglist, 2);
  dest_y = XEN_LIST_REF(arglist, 3);
  dest_width = XEN_LIST_REF(arglist, 4);
  dest_height = XEN_LIST_REF(arglist, 5);
  offset_x = XEN_LIST_REF(arglist, 6);
  offset_y = XEN_LIST_REF(arglist, 7);
  scale_x = XEN_LIST_REF(arglist, 8);
  scale_y = XEN_LIST_REF(arglist, 9);
  interp_type = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_scale", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest), dest, 2, "gdk_pixbuf_scale", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 3, "gdk_pixbuf_scale", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 4, "gdk_pixbuf_scale", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_width), dest_width, 5, "gdk_pixbuf_scale", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_height), dest_height, 6, "gdk_pixbuf_scale", "int");
  XEN_ASSERT_TYPE(XEN_double_P(offset_x), offset_x, 7, "gdk_pixbuf_scale", "double");
  XEN_ASSERT_TYPE(XEN_double_P(offset_y), offset_y, 8, "gdk_pixbuf_scale", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_x), scale_x, 9, "gdk_pixbuf_scale", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_y), scale_y, 10, "gdk_pixbuf_scale", "double");
  XEN_ASSERT_TYPE(XEN_GdkInterpType_P(interp_type), interp_type, 11, "gdk_pixbuf_scale", "GdkInterpType");
  gdk_pixbuf_scale(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), XEN_TO_C_int(dest_width), 
                   XEN_TO_C_int(dest_height), XEN_TO_C_double(offset_x), XEN_TO_C_double(offset_y), XEN_TO_C_double(scale_x), 
                   XEN_TO_C_double(scale_y), XEN_TO_C_GdkInterpType(interp_type));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_pixbuf_composite(XEN arglist)
{
  #define H_gdk_pixbuf_composite "void gdk_pixbuf_composite(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, \
int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, \
GdkInterpType interp_type, int overall_alpha)"
  XEN src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha;
  src = XEN_LIST_REF(arglist, 0);
  dest = XEN_LIST_REF(arglist, 1);
  dest_x = XEN_LIST_REF(arglist, 2);
  dest_y = XEN_LIST_REF(arglist, 3);
  dest_width = XEN_LIST_REF(arglist, 4);
  dest_height = XEN_LIST_REF(arglist, 5);
  offset_x = XEN_LIST_REF(arglist, 6);
  offset_y = XEN_LIST_REF(arglist, 7);
  scale_x = XEN_LIST_REF(arglist, 8);
  scale_y = XEN_LIST_REF(arglist, 9);
  interp_type = XEN_LIST_REF(arglist, 10);
  overall_alpha = XEN_LIST_REF(arglist, 11);
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_composite", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest), dest, 2, "gdk_pixbuf_composite", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 3, "gdk_pixbuf_composite", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 4, "gdk_pixbuf_composite", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_width), dest_width, 5, "gdk_pixbuf_composite", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_height), dest_height, 6, "gdk_pixbuf_composite", "int");
  XEN_ASSERT_TYPE(XEN_double_P(offset_x), offset_x, 7, "gdk_pixbuf_composite", "double");
  XEN_ASSERT_TYPE(XEN_double_P(offset_y), offset_y, 8, "gdk_pixbuf_composite", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_x), scale_x, 9, "gdk_pixbuf_composite", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_y), scale_y, 10, "gdk_pixbuf_composite", "double");
  XEN_ASSERT_TYPE(XEN_GdkInterpType_P(interp_type), interp_type, 11, "gdk_pixbuf_composite", "GdkInterpType");
  XEN_ASSERT_TYPE(XEN_int_P(overall_alpha), overall_alpha, 12, "gdk_pixbuf_composite", "int");
  gdk_pixbuf_composite(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), XEN_TO_C_int(dest_width), 
                       XEN_TO_C_int(dest_height), XEN_TO_C_double(offset_x), XEN_TO_C_double(offset_y), XEN_TO_C_double(scale_x), 
                       XEN_TO_C_double(scale_y), XEN_TO_C_GdkInterpType(interp_type), XEN_TO_C_int(overall_alpha));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_pixbuf_composite_color(XEN arglist)
{
  #define H_gdk_pixbuf_composite_color "void gdk_pixbuf_composite_color(GdkPixbuf* src, GdkPixbuf* dest, \
int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, \
double scale_y, GdkInterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, \
guint32 color1, guint32 color2)"
  XEN src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha, check_x, check_y, check_size, color1, color2;
  src = XEN_LIST_REF(arglist, 0);
  dest = XEN_LIST_REF(arglist, 1);
  dest_x = XEN_LIST_REF(arglist, 2);
  dest_y = XEN_LIST_REF(arglist, 3);
  dest_width = XEN_LIST_REF(arglist, 4);
  dest_height = XEN_LIST_REF(arglist, 5);
  offset_x = XEN_LIST_REF(arglist, 6);
  offset_y = XEN_LIST_REF(arglist, 7);
  scale_x = XEN_LIST_REF(arglist, 8);
  scale_y = XEN_LIST_REF(arglist, 9);
  interp_type = XEN_LIST_REF(arglist, 10);
  overall_alpha = XEN_LIST_REF(arglist, 11);
  check_x = XEN_LIST_REF(arglist, 12);
  check_y = XEN_LIST_REF(arglist, 13);
  check_size = XEN_LIST_REF(arglist, 14);
  color1 = XEN_LIST_REF(arglist, 15);
  color2 = XEN_LIST_REF(arglist, 16);
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_composite_color", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(dest), dest, 2, "gdk_pixbuf_composite_color", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 3, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 4, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_width), dest_width, 5, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_height), dest_height, 6, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_double_P(offset_x), offset_x, 7, "gdk_pixbuf_composite_color", "double");
  XEN_ASSERT_TYPE(XEN_double_P(offset_y), offset_y, 8, "gdk_pixbuf_composite_color", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_x), scale_x, 9, "gdk_pixbuf_composite_color", "double");
  XEN_ASSERT_TYPE(XEN_double_P(scale_y), scale_y, 10, "gdk_pixbuf_composite_color", "double");
  XEN_ASSERT_TYPE(XEN_GdkInterpType_P(interp_type), interp_type, 11, "gdk_pixbuf_composite_color", "GdkInterpType");
  XEN_ASSERT_TYPE(XEN_int_P(overall_alpha), overall_alpha, 12, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(check_x), check_x, 13, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(check_y), check_y, 14, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_int_P(check_size), check_size, 15, "gdk_pixbuf_composite_color", "int");
  XEN_ASSERT_TYPE(XEN_guint32_P(color1), color1, 16, "gdk_pixbuf_composite_color", "guint32");
  XEN_ASSERT_TYPE(XEN_guint32_P(color2), color2, 17, "gdk_pixbuf_composite_color", "guint32");
  gdk_pixbuf_composite_color(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_GdkPixbuf_(dest), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), 
                             XEN_TO_C_int(dest_width), XEN_TO_C_int(dest_height), XEN_TO_C_double(offset_x), XEN_TO_C_double(offset_y), 
                             XEN_TO_C_double(scale_x), XEN_TO_C_double(scale_y), XEN_TO_C_GdkInterpType(interp_type), XEN_TO_C_int(overall_alpha), 
                             XEN_TO_C_int(check_x), XEN_TO_C_int(check_y), XEN_TO_C_int(check_size), XEN_TO_C_guint32(color1), 
                             XEN_TO_C_guint32(color2));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gdk_pixbuf_scale_simple(XEN src, XEN dest_width, XEN dest_height, XEN interp_type)
{
  #define H_gdk_pixbuf_scale_simple "GdkPixbuf* gdk_pixbuf_scale_simple(GdkPixbuf* src, int dest_width, \
int dest_height, GdkInterpType interp_type)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_scale_simple", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_width), dest_width, 2, "gdk_pixbuf_scale_simple", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_height), dest_height, 3, "gdk_pixbuf_scale_simple", "int");
  XEN_ASSERT_TYPE(XEN_GdkInterpType_P(interp_type), interp_type, 4, "gdk_pixbuf_scale_simple", "GdkInterpType");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_scale_simple(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_int(dest_width), XEN_TO_C_int(dest_height), 
                                                     XEN_TO_C_GdkInterpType(interp_type))));
}
static XEN gxg_gdk_pixbuf_composite_color_simple(XEN src, XEN dest_width, XEN dest_height, XEN interp_type, XEN overall_alpha, XEN check_size, XEN color1, XEN color2)
{
  #define H_gdk_pixbuf_composite_color_simple "GdkPixbuf* gdk_pixbuf_composite_color_simple(GdkPixbuf* src, \
int dest_width, int dest_height, GdkInterpType interp_type, int overall_alpha, int check_size, guint32 color1, \
guint32 color2)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(src), src, 1, "gdk_pixbuf_composite_color_simple", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(dest_width), dest_width, 2, "gdk_pixbuf_composite_color_simple", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_height), dest_height, 3, "gdk_pixbuf_composite_color_simple", "int");
  XEN_ASSERT_TYPE(XEN_GdkInterpType_P(interp_type), interp_type, 4, "gdk_pixbuf_composite_color_simple", "GdkInterpType");
  XEN_ASSERT_TYPE(XEN_int_P(overall_alpha), overall_alpha, 5, "gdk_pixbuf_composite_color_simple", "int");
  XEN_ASSERT_TYPE(XEN_int_P(check_size), check_size, 6, "gdk_pixbuf_composite_color_simple", "int");
  XEN_ASSERT_TYPE(XEN_guint32_P(color1), color1, 7, "gdk_pixbuf_composite_color_simple", "guint32");
  XEN_ASSERT_TYPE(XEN_guint32_P(color2), color2, 8, "gdk_pixbuf_composite_color_simple", "guint32");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_composite_color_simple(XEN_TO_C_GdkPixbuf_(src), XEN_TO_C_int(dest_width), XEN_TO_C_int(dest_height), 
                                                               XEN_TO_C_GdkInterpType(interp_type), XEN_TO_C_int(overall_alpha), 
                                                               XEN_TO_C_int(check_size), XEN_TO_C_guint32(color1), XEN_TO_C_guint32(color2))));
}
static XEN gxg_gdk_pixbuf_animation_get_type(void)
{
  #define H_gdk_pixbuf_animation_get_type "GType gdk_pixbuf_animation_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_animation_get_type()));
}
static XEN gxg_gdk_pixbuf_animation_new_from_file(XEN filename, XEN error)
{
  #define H_gdk_pixbuf_animation_new_from_file "GdkPixbufAnimation* gdk_pixbuf_animation_new_from_file(char* filename, \
GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 1, "gdk_pixbuf_animation_new_from_file", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbufAnimation_(gdk_pixbuf_animation_new_from_file(XEN_TO_C_char_(filename), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_animation_get_width(XEN animation)
{
  #define H_gdk_pixbuf_animation_get_width "int gdk_pixbuf_animation_get_width(GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gdk_pixbuf_animation_get_width", "GdkPixbufAnimation*");
  return(C_TO_XEN_int(gdk_pixbuf_animation_get_width(XEN_TO_C_GdkPixbufAnimation_(animation))));
}
static XEN gxg_gdk_pixbuf_animation_get_height(XEN animation)
{
  #define H_gdk_pixbuf_animation_get_height "int gdk_pixbuf_animation_get_height(GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gdk_pixbuf_animation_get_height", "GdkPixbufAnimation*");
  return(C_TO_XEN_int(gdk_pixbuf_animation_get_height(XEN_TO_C_GdkPixbufAnimation_(animation))));
}
static XEN gxg_gdk_pixbuf_animation_is_static_image(XEN animation)
{
  #define H_gdk_pixbuf_animation_is_static_image "gboolean gdk_pixbuf_animation_is_static_image(GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gdk_pixbuf_animation_is_static_image", "GdkPixbufAnimation*");
  return(C_TO_XEN_gboolean(gdk_pixbuf_animation_is_static_image(XEN_TO_C_GdkPixbufAnimation_(animation))));
}
static XEN gxg_gdk_pixbuf_animation_get_static_image(XEN animation)
{
  #define H_gdk_pixbuf_animation_get_static_image "GdkPixbuf* gdk_pixbuf_animation_get_static_image(GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gdk_pixbuf_animation_get_static_image", "GdkPixbufAnimation*");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_animation_get_static_image(XEN_TO_C_GdkPixbufAnimation_(animation))));
}
static XEN gxg_gdk_pixbuf_animation_get_iter(XEN animation, XEN start_time)
{
  #define H_gdk_pixbuf_animation_get_iter "GdkPixbufAnimationIter* gdk_pixbuf_animation_get_iter(GdkPixbufAnimation* animation, \
GTimeVal* start_time)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gdk_pixbuf_animation_get_iter", "GdkPixbufAnimation*");
  XEN_ASSERT_TYPE(XEN_GTimeVal__P(start_time), start_time, 2, "gdk_pixbuf_animation_get_iter", "GTimeVal*");
  return(C_TO_XEN_GdkPixbufAnimationIter_(gdk_pixbuf_animation_get_iter(XEN_TO_C_GdkPixbufAnimation_(animation), XEN_TO_C_GTimeVal_(start_time))));
}
static XEN gxg_gdk_pixbuf_animation_iter_get_type(void)
{
  #define H_gdk_pixbuf_animation_iter_get_type "GType gdk_pixbuf_animation_iter_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_animation_iter_get_type()));
}
static XEN gxg_gdk_pixbuf_animation_iter_get_delay_time(XEN iter)
{
  #define H_gdk_pixbuf_animation_iter_get_delay_time "int gdk_pixbuf_animation_iter_get_delay_time(GdkPixbufAnimationIter* iter)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimationIter__P(iter), iter, 1, "gdk_pixbuf_animation_iter_get_delay_time", "GdkPixbufAnimationIter*");
  return(C_TO_XEN_int(gdk_pixbuf_animation_iter_get_delay_time(XEN_TO_C_GdkPixbufAnimationIter_(iter))));
}
static XEN gxg_gdk_pixbuf_animation_iter_get_pixbuf(XEN iter)
{
  #define H_gdk_pixbuf_animation_iter_get_pixbuf "GdkPixbuf* gdk_pixbuf_animation_iter_get_pixbuf(GdkPixbufAnimationIter* iter)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimationIter__P(iter), iter, 1, "gdk_pixbuf_animation_iter_get_pixbuf", "GdkPixbufAnimationIter*");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_animation_iter_get_pixbuf(XEN_TO_C_GdkPixbufAnimationIter_(iter))));
}
static XEN gxg_gdk_pixbuf_animation_iter_on_currently_loading_frame(XEN iter)
{
  #define H_gdk_pixbuf_animation_iter_on_currently_loading_frame "gboolean gdk_pixbuf_animation_iter_on_currently_loading_frame(GdkPixbufAnimationIter* iter)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimationIter__P(iter), iter, 1, "gdk_pixbuf_animation_iter_on_currently_loading_frame", "GdkPixbufAnimationIter*");
  return(C_TO_XEN_gboolean(gdk_pixbuf_animation_iter_on_currently_loading_frame(XEN_TO_C_GdkPixbufAnimationIter_(iter))));
}
static XEN gxg_gdk_pixbuf_animation_iter_advance(XEN iter, XEN current_time)
{
  #define H_gdk_pixbuf_animation_iter_advance "gboolean gdk_pixbuf_animation_iter_advance(GdkPixbufAnimationIter* iter, \
GTimeVal* current_time)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimationIter__P(iter), iter, 1, "gdk_pixbuf_animation_iter_advance", "GdkPixbufAnimationIter*");
  XEN_ASSERT_TYPE(XEN_GTimeVal__P(current_time), current_time, 2, "gdk_pixbuf_animation_iter_advance", "GTimeVal*");
  return(C_TO_XEN_gboolean(gdk_pixbuf_animation_iter_advance(XEN_TO_C_GdkPixbufAnimationIter_(iter), XEN_TO_C_GTimeVal_(current_time))));
}
static XEN gxg_gdk_pixbuf_get_option(XEN pixbuf, XEN key)
{
  #define H_gdk_pixbuf_get_option "gchar* gdk_pixbuf_get_option(GdkPixbuf* pixbuf, gchar* key)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gdk_pixbuf_get_option", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_gchar__P(key), key, 2, "gdk_pixbuf_get_option", "gchar*");
  return(C_TO_XEN_gchar_(gdk_pixbuf_get_option(XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_gchar_(key))));
}
static XEN gxg_gdk_pixbuf_loader_get_type(void)
{
  #define H_gdk_pixbuf_loader_get_type "GType gdk_pixbuf_loader_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_loader_get_type()));
}
static XEN gxg_gdk_pixbuf_loader_new(void)
{
  #define H_gdk_pixbuf_loader_new "GdkPixbufLoader* gdk_pixbuf_loader_new( void)"
  return(C_TO_XEN_GdkPixbufLoader_(gdk_pixbuf_loader_new()));
}
static XEN gxg_gdk_pixbuf_loader_new_with_type(XEN image_type, XEN error)
{
  #define H_gdk_pixbuf_loader_new_with_type "GdkPixbufLoader* gdk_pixbuf_loader_new_with_type(char* image_type, \
GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_char__P(image_type), image_type, 1, "gdk_pixbuf_loader_new_with_type", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbufLoader_(gdk_pixbuf_loader_new_with_type(XEN_TO_C_char_(image_type), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_loader_write(XEN loader, XEN buf, XEN count, XEN error)
{
  #define H_gdk_pixbuf_loader_write "gboolean gdk_pixbuf_loader_write(GdkPixbufLoader* loader, guchar* buf, \
gsize count, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GdkPixbufLoader__P(loader), loader, 1, "gdk_pixbuf_loader_write", "GdkPixbufLoader*");
  XEN_ASSERT_TYPE(XEN_guchar__P(buf), buf, 2, "gdk_pixbuf_loader_write", "guchar*");
  XEN_ASSERT_TYPE(XEN_gsize_P(count), count, 3, "gdk_pixbuf_loader_write", "gsize");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_pixbuf_loader_write(XEN_TO_C_GdkPixbufLoader_(loader), XEN_TO_C_guchar_(buf), XEN_TO_C_gsize(count), 
                                                       &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_loader_get_pixbuf(XEN loader)
{
  #define H_gdk_pixbuf_loader_get_pixbuf "GdkPixbuf* gdk_pixbuf_loader_get_pixbuf(GdkPixbufLoader* loader)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufLoader__P(loader), loader, 1, "gdk_pixbuf_loader_get_pixbuf", "GdkPixbufLoader*");
  return(C_TO_XEN_GdkPixbuf_(gdk_pixbuf_loader_get_pixbuf(XEN_TO_C_GdkPixbufLoader_(loader))));
}
static XEN gxg_gdk_pixbuf_loader_get_animation(XEN loader)
{
  #define H_gdk_pixbuf_loader_get_animation "GdkPixbufAnimation* gdk_pixbuf_loader_get_animation(GdkPixbufLoader* loader)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufLoader__P(loader), loader, 1, "gdk_pixbuf_loader_get_animation", "GdkPixbufLoader*");
  return(C_TO_XEN_GdkPixbufAnimation_(gdk_pixbuf_loader_get_animation(XEN_TO_C_GdkPixbufLoader_(loader))));
}
static XEN gxg_gdk_pixbuf_loader_close(XEN loader, XEN error)
{
  #define H_gdk_pixbuf_loader_close "gboolean gdk_pixbuf_loader_close(GdkPixbufLoader* loader, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GdkPixbufLoader__P(loader), loader, 1, "gdk_pixbuf_loader_close", "GdkPixbufLoader*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gdk_pixbuf_loader_close(XEN_TO_C_GdkPixbufLoader_(loader), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gdk_pixbuf_alpha_mode_get_type(void)
{
  #define H_gdk_pixbuf_alpha_mode_get_type "GType gdk_pixbuf_alpha_mode_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_alpha_mode_get_type()));
}
static XEN gxg_gdk_colorspace_get_type(void)
{
  #define H_gdk_colorspace_get_type "GType gdk_colorspace_get_type( void)"
  return(C_TO_XEN_GType(gdk_colorspace_get_type()));
}
static XEN gxg_gdk_pixbuf_error_get_type(void)
{
  #define H_gdk_pixbuf_error_get_type "GType gdk_pixbuf_error_get_type( void)"
  return(C_TO_XEN_GType(gdk_pixbuf_error_get_type()));
}
static XEN gxg_gdk_interp_type_get_type(void)
{
  #define H_gdk_interp_type_get_type "GType gdk_interp_type_get_type( void)"
  return(C_TO_XEN_GType(gdk_interp_type_get_type()));
}
static XEN gxg_gtk_vbox_get_type(void)
{
  #define H_gtk_vbox_get_type "GtkType gtk_vbox_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vbox_get_type()));
}
static XEN gxg_gtk_vbox_new(XEN homogeneous, XEN spacing)
{
  #define H_gtk_vbox_new "GtkWidget* gtk_vbox_new(gboolean homogeneous, gint spacing)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 1, "gtk_vbox_new", "gboolean");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_vbox_new", "gint");
  return(C_TO_XEN_GtkWidget_(gtk_vbox_new(XEN_TO_C_gboolean(homogeneous), XEN_TO_C_gint(spacing))));
}
static XEN gxg_gtk_accel_group_get_type(void)
{
  #define H_gtk_accel_group_get_type "GType gtk_accel_group_get_type( void)"
  return(C_TO_XEN_GType(gtk_accel_group_get_type()));
}
static XEN gxg_gtk_accel_group_new(void)
{
  #define H_gtk_accel_group_new "GtkAccelGroup* gtk_accel_group_new( void)"
  return(C_TO_XEN_GtkAccelGroup_(gtk_accel_group_new()));
}
static XEN gxg_gtk_accel_group_lock(XEN accel_group)
{
  #define H_gtk_accel_group_lock "void gtk_accel_group_lock(GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_lock", "GtkAccelGroup*");
  gtk_accel_group_lock(XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_group_unlock(XEN accel_group)
{
  #define H_gtk_accel_group_unlock "void gtk_accel_group_unlock(GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_unlock", "GtkAccelGroup*");
  gtk_accel_group_unlock(XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_group_connect(XEN accel_group, XEN accel_key, XEN accel_mods, XEN accel_flags, XEN closure)
{
  #define H_gtk_accel_group_connect "void gtk_accel_group_connect(GtkAccelGroup* accel_group, guint accel_key, \
GdkModifierType accel_mods, GtkAccelFlags accel_flags, GClosure* closure)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_connect", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_group_connect", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_group_connect", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_GtkAccelFlags_P(accel_flags), accel_flags, 4, "gtk_accel_group_connect", "GtkAccelFlags");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 5, "gtk_accel_group_connect", "GClosure*");
  gtk_accel_group_connect(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods), 
                          XEN_TO_C_GtkAccelFlags(accel_flags), XEN_TO_C_GClosure_(closure));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_group_connect_by_path(XEN accel_group, XEN accel_path, XEN closure)
{
  #define H_gtk_accel_group_connect_by_path "void gtk_accel_group_connect_by_path(GtkAccelGroup* accel_group, \
gchar* accel_path, GClosure* closure)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_connect_by_path", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 2, "gtk_accel_group_connect_by_path", "gchar*");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 3, "gtk_accel_group_connect_by_path", "GClosure*");
  gtk_accel_group_connect_by_path(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_gchar_(accel_path), XEN_TO_C_GClosure_(closure));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_group_disconnect(XEN accel_group, XEN closure)
{
  #define H_gtk_accel_group_disconnect "gboolean gtk_accel_group_disconnect(GtkAccelGroup* accel_group, \
GClosure* closure)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_disconnect", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 2, "gtk_accel_group_disconnect", "GClosure*");
  return(C_TO_XEN_gboolean(gtk_accel_group_disconnect(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_GClosure_(closure))));
}
static XEN gxg_gtk_accel_group_disconnect_key(XEN accel_group, XEN accel_key, XEN accel_mods)
{
  #define H_gtk_accel_group_disconnect_key "gboolean gtk_accel_group_disconnect_key(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_disconnect_key", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_group_disconnect_key", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_group_disconnect_key", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_accel_group_disconnect_key(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_guint(accel_key), 
                                                          XEN_TO_C_GdkModifierType(accel_mods))));
}
static XEN gxg_gtk_accel_groups_activate(XEN object, XEN accel_key, XEN accel_mods)
{
  #define H_gtk_accel_groups_activate "gboolean gtk_accel_groups_activate(GObject* object, guint accel_key, \
GdkModifierType accel_mods)"
  XEN_ASSERT_TYPE(XEN_GObject__P(object), object, 1, "gtk_accel_groups_activate", "GObject*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_groups_activate", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_groups_activate", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_accel_groups_activate(XEN_TO_C_GObject_(object), XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods))));
}
static XEN gxg_gtk_accel_groups_from_object(XEN object)
{
  #define H_gtk_accel_groups_from_object "GSList* gtk_accel_groups_from_object(GObject* object)"
  XEN_ASSERT_TYPE(XEN_GObject__P(object), object, 1, "gtk_accel_groups_from_object", "GObject*");
  return(C_TO_XEN_GSList_(gtk_accel_groups_from_object(XEN_TO_C_GObject_(object))));
}
static XEN gxg_gtk_accel_group_find(XEN accel_group, XEN func, XEN func_data)
{
  #define H_gtk_accel_group_find "GtkAccelKey* gtk_accel_group_find(GtkAccelGroup* accel_group, lambda3 func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_find", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_lambda3_P(func), func, 2, "gtk_accel_group_find", "lambda3");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_accel_group_find", "lambda_data");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_GtkAccelKey_(gtk_accel_group_find(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_lambda3(func), XEN_TO_C_lambda_data(func_data)));
    xm_unprotect_at(loc);
    return(result);
   }
}
static XEN gxg_gtk_accel_group_from_accel_closure(XEN closure)
{
  #define H_gtk_accel_group_from_accel_closure "GtkAccelGroup* gtk_accel_group_from_accel_closure(GClosure* closure)"
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 1, "gtk_accel_group_from_accel_closure", "GClosure*");
  return(C_TO_XEN_GtkAccelGroup_(gtk_accel_group_from_accel_closure(XEN_TO_C_GClosure_(closure))));
}
static XEN gxg_gtk_accelerator_valid(XEN keyval, XEN modifiers)
{
  #define H_gtk_accelerator_valid "gboolean gtk_accelerator_valid(guint keyval, GdkModifierType modifiers)"
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 1, "gtk_accelerator_valid", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 2, "gtk_accelerator_valid", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_accelerator_valid(XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers))));
}
static XEN gxg_gtk_accelerator_parse(XEN accelerator, XEN accelerator_key, XEN accelerator_mods)
{
  #define H_gtk_accelerator_parse "void gtk_accelerator_parse(gchar* accelerator, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  XEN_ASSERT_TYPE(XEN_gchar__P(accelerator), accelerator, 1, "gtk_accelerator_parse", "gchar*");
  gtk_accelerator_parse(XEN_TO_C_gchar_(accelerator), &ref_accelerator_key, &ref_accelerator_mods);
  return(XEN_LIST_2(C_TO_XEN_guint(ref_accelerator_key), C_TO_XEN_GdkModifierType(ref_accelerator_mods)));
}
static XEN gxg_gtk_accelerator_name(XEN accelerator_key, XEN accelerator_mods)
{
  #define H_gtk_accelerator_name "gchar* gtk_accelerator_name(guint accelerator_key, GdkModifierType accelerator_mods)"
  XEN_ASSERT_TYPE(XEN_guint_P(accelerator_key), accelerator_key, 1, "gtk_accelerator_name", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accelerator_mods), accelerator_mods, 2, "gtk_accelerator_name", "GdkModifierType");
  {
   gchar* result;
   XEN rtn;
   result = gtk_accelerator_name(XEN_TO_C_guint(accelerator_key), XEN_TO_C_GdkModifierType(accelerator_mods));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_accelerator_set_default_mod_mask(XEN default_mod_mask)
{
  #define H_gtk_accelerator_set_default_mod_mask "void gtk_accelerator_set_default_mod_mask(GdkModifierType default_mod_mask)"
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(default_mod_mask), default_mod_mask, 1, "gtk_accelerator_set_default_mod_mask", "GdkModifierType");
  gtk_accelerator_set_default_mod_mask(XEN_TO_C_GdkModifierType(default_mod_mask));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accelerator_get_default_mod_mask(void)
{
  #define H_gtk_accelerator_get_default_mod_mask "guint gtk_accelerator_get_default_mod_mask( void)"
  return(C_TO_XEN_guint(gtk_accelerator_get_default_mod_mask()));
}
static XEN gxg_gtk_accel_group_query(XEN accel_group, XEN accel_key, XEN accel_mods, XEN n_entries)
{
  #define H_gtk_accel_group_query "GtkAccelGroupEntry* gtk_accel_group_query(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods, guint* [n_entries])"
  guint ref_n_entries;
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_query", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_group_query", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_group_query", "GdkModifierType");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GtkAccelGroupEntry_(gtk_accel_group_query(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_guint(accel_key), 
                                                                XEN_TO_C_GdkModifierType(accel_mods), &ref_n_entries));
    return(XEN_LIST_2(result, C_TO_XEN_guint(ref_n_entries)));
   }
}
static XEN gxg_gtk_accel_label_get_type(void)
{
  #define H_gtk_accel_label_get_type "GtkType gtk_accel_label_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_accel_label_get_type()));
}
static XEN gxg_gtk_accel_label_new(XEN string)
{
  #define H_gtk_accel_label_new "GtkWidget* gtk_accel_label_new(gchar* string)"
  XEN_ASSERT_TYPE(XEN_gchar__P(string), string, 1, "gtk_accel_label_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_accel_label_new(XEN_TO_C_gchar_(string))));
}
static XEN gxg_gtk_accel_label_get_accel_widget(XEN accel_label)
{
  #define H_gtk_accel_label_get_accel_widget "GtkWidget* gtk_accel_label_get_accel_widget(GtkAccelLabel* accel_label)"
  XEN_ASSERT_TYPE(XEN_GtkAccelLabel__P(accel_label), accel_label, 1, "gtk_accel_label_get_accel_widget", "GtkAccelLabel*");
  return(C_TO_XEN_GtkWidget_(gtk_accel_label_get_accel_widget(XEN_TO_C_GtkAccelLabel_(accel_label))));
}
static XEN gxg_gtk_accel_label_get_accel_width(XEN accel_label)
{
  #define H_gtk_accel_label_get_accel_width "guint gtk_accel_label_get_accel_width(GtkAccelLabel* accel_label)"
  XEN_ASSERT_TYPE(XEN_GtkAccelLabel__P(accel_label), accel_label, 1, "gtk_accel_label_get_accel_width", "GtkAccelLabel*");
  return(C_TO_XEN_guint(gtk_accel_label_get_accel_width(XEN_TO_C_GtkAccelLabel_(accel_label))));
}
static XEN gxg_gtk_accel_label_set_accel_widget(XEN accel_label, XEN accel_widget)
{
  #define H_gtk_accel_label_set_accel_widget "void gtk_accel_label_set_accel_widget(GtkAccelLabel* accel_label, \
GtkWidget* accel_widget)"
  XEN_ASSERT_TYPE(XEN_GtkAccelLabel__P(accel_label), accel_label, 1, "gtk_accel_label_set_accel_widget", "GtkAccelLabel*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(accel_widget), accel_widget, 2, "gtk_accel_label_set_accel_widget", "GtkWidget*");
  gtk_accel_label_set_accel_widget(XEN_TO_C_GtkAccelLabel_(accel_label), XEN_TO_C_GtkWidget_(accel_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_label_set_accel_closure(XEN accel_label, XEN closure)
{
  #define H_gtk_accel_label_set_accel_closure "void gtk_accel_label_set_accel_closure(GtkAccelLabel* accel_label, \
GClosure* closure)"
  XEN_ASSERT_TYPE(XEN_GtkAccelLabel__P(accel_label), accel_label, 1, "gtk_accel_label_set_accel_closure", "GtkAccelLabel*");
  XEN_ASSERT_TYPE(XEN_GClosure__P(closure) || XEN_FALSE_P(closure), closure, 2, "gtk_accel_label_set_accel_closure", "GClosure*");
  gtk_accel_label_set_accel_closure(XEN_TO_C_GtkAccelLabel_(accel_label), XEN_TO_C_GClosure_(closure));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_label_refetch(XEN accel_label)
{
  #define H_gtk_accel_label_refetch "gboolean gtk_accel_label_refetch(GtkAccelLabel* accel_label)"
  XEN_ASSERT_TYPE(XEN_GtkAccelLabel__P(accel_label), accel_label, 1, "gtk_accel_label_refetch", "GtkAccelLabel*");
  return(C_TO_XEN_gboolean(gtk_accel_label_refetch(XEN_TO_C_GtkAccelLabel_(accel_label))));
}
static XEN gxg_gtk_accel_map_add_entry(XEN accel_path, XEN accel_key, XEN accel_mods)
{
  #define H_gtk_accel_map_add_entry "void gtk_accel_map_add_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods)"
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 1, "gtk_accel_map_add_entry", "gchar*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_map_add_entry", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_map_add_entry", "GdkModifierType");
  gtk_accel_map_add_entry(XEN_TO_C_gchar_(accel_path), XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_lookup_entry(XEN accel_path, XEN key)
{
  #define H_gtk_accel_map_lookup_entry "gboolean gtk_accel_map_lookup_entry(gchar* accel_path, GtkAccelKey* key)"
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 1, "gtk_accel_map_lookup_entry", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkAccelKey__P(key), key, 2, "gtk_accel_map_lookup_entry", "GtkAccelKey*");
  return(C_TO_XEN_gboolean(gtk_accel_map_lookup_entry(XEN_TO_C_gchar_(accel_path), XEN_TO_C_GtkAccelKey_(key))));
}
static XEN gxg_gtk_accel_map_change_entry(XEN accel_path, XEN accel_key, XEN accel_mods, XEN replace)
{
  #define H_gtk_accel_map_change_entry "gboolean gtk_accel_map_change_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods, gboolean replace)"
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 1, "gtk_accel_map_change_entry", "gchar*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 2, "gtk_accel_map_change_entry", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 3, "gtk_accel_map_change_entry", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_gboolean_P(replace), replace, 4, "gtk_accel_map_change_entry", "gboolean");
  return(C_TO_XEN_gboolean(gtk_accel_map_change_entry(XEN_TO_C_gchar_(accel_path), XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods), 
                                                      XEN_TO_C_gboolean(replace))));
}
static XEN gxg_gtk_accel_map_load(XEN file_name)
{
  #define H_gtk_accel_map_load "void gtk_accel_map_load(gchar* file_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(file_name), file_name, 1, "gtk_accel_map_load", "gchar*");
  gtk_accel_map_load(XEN_TO_C_gchar_(file_name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_save(XEN file_name)
{
  #define H_gtk_accel_map_save "void gtk_accel_map_save(gchar* file_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(file_name), file_name, 1, "gtk_accel_map_save", "gchar*");
  gtk_accel_map_save(XEN_TO_C_gchar_(file_name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_foreach(XEN func_data, XEN func)
{
  #define H_gtk_accel_map_foreach "void gtk_accel_map_foreach(lambda_data func_data, GtkAccelMapForeach func)"
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 1, "gtk_accel_map_foreach", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkAccelMapForeach_P(func), func, 2, "gtk_accel_map_foreach", "GtkAccelMapForeach");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_accel_map_foreach(XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkAccelMapForeach(func));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_accel_map_load_fd(XEN fd)
{
  #define H_gtk_accel_map_load_fd "void gtk_accel_map_load_fd(gint fd)"
  XEN_ASSERT_TYPE(XEN_gint_P(fd), fd, 1, "gtk_accel_map_load_fd", "gint");
  gtk_accel_map_load_fd(XEN_TO_C_gint(fd));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_load_scanner(XEN scanner)
{
  #define H_gtk_accel_map_load_scanner "void gtk_accel_map_load_scanner(GScanner* scanner)"
  XEN_ASSERT_TYPE(XEN_GScanner__P(scanner), scanner, 1, "gtk_accel_map_load_scanner", "GScanner*");
  gtk_accel_map_load_scanner(XEN_TO_C_GScanner_(scanner));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_save_fd(XEN fd)
{
  #define H_gtk_accel_map_save_fd "void gtk_accel_map_save_fd(gint fd)"
  XEN_ASSERT_TYPE(XEN_gint_P(fd), fd, 1, "gtk_accel_map_save_fd", "gint");
  gtk_accel_map_save_fd(XEN_TO_C_gint(fd));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_add_filter(XEN filter_pattern)
{
  #define H_gtk_accel_map_add_filter "void gtk_accel_map_add_filter(gchar* filter_pattern)"
  XEN_ASSERT_TYPE(XEN_gchar__P(filter_pattern), filter_pattern, 1, "gtk_accel_map_add_filter", "gchar*");
  gtk_accel_map_add_filter(XEN_TO_C_gchar_(filter_pattern));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accel_map_foreach_unfiltered(XEN func_data, XEN func)
{
  #define H_gtk_accel_map_foreach_unfiltered "void gtk_accel_map_foreach_unfiltered(lambda_data func_data, \
GtkAccelMapForeach func)"
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 1, "gtk_accel_map_foreach_unfiltered", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkAccelMapForeach_P(func), func, 2, "gtk_accel_map_foreach_unfiltered", "GtkAccelMapForeach");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_accel_map_foreach_unfiltered(XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkAccelMapForeach(func));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_accessible_get_type(void)
{
  #define H_gtk_accessible_get_type "GtkType gtk_accessible_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_accessible_get_type()));
}
static XEN gxg_gtk_accessible_connect_widget_destroyed(XEN accessible)
{
  #define H_gtk_accessible_connect_widget_destroyed "void gtk_accessible_connect_widget_destroyed(GtkAccessible* accessible)"
  XEN_ASSERT_TYPE(XEN_GtkAccessible__P(accessible), accessible, 1, "gtk_accessible_connect_widget_destroyed", "GtkAccessible*");
  gtk_accessible_connect_widget_destroyed(XEN_TO_C_GtkAccessible_(accessible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_adjustment_get_type(void)
{
  #define H_gtk_adjustment_get_type "GtkType gtk_adjustment_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_adjustment_get_type()));
}
static XEN gxg_gtk_adjustment_new(XEN value, XEN lower, XEN upper, XEN step_increment, XEN page_increment, XEN page_size)
{
  #define H_gtk_adjustment_new "GtkObject* gtk_adjustment_new(gdouble value, gdouble lower, gdouble upper, \
gdouble step_increment, gdouble page_increment, gdouble page_size)"
  XEN_ASSERT_TYPE(XEN_gdouble_P(value), value, 1, "gtk_adjustment_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(lower), lower, 2, "gtk_adjustment_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(upper), upper, 3, "gtk_adjustment_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step_increment), step_increment, 4, "gtk_adjustment_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(page_increment), page_increment, 5, "gtk_adjustment_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(page_size), page_size, 6, "gtk_adjustment_new", "gdouble");
  return(C_TO_XEN_GtkObject_(gtk_adjustment_new(XEN_TO_C_gdouble(value), XEN_TO_C_gdouble(lower), XEN_TO_C_gdouble(upper), 
                                                XEN_TO_C_gdouble(step_increment), XEN_TO_C_gdouble(page_increment), XEN_TO_C_gdouble(page_size))));
}
static XEN gxg_gtk_adjustment_changed(XEN adjustment)
{
  #define H_gtk_adjustment_changed "void gtk_adjustment_changed(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment), adjustment, 1, "gtk_adjustment_changed", "GtkAdjustment*");
  gtk_adjustment_changed(XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_adjustment_value_changed(XEN adjustment)
{
  #define H_gtk_adjustment_value_changed "void gtk_adjustment_value_changed(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment), adjustment, 1, "gtk_adjustment_value_changed", "GtkAdjustment*");
  gtk_adjustment_value_changed(XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_adjustment_clamp_page(XEN adjustment, XEN lower, XEN upper)
{
  #define H_gtk_adjustment_clamp_page "void gtk_adjustment_clamp_page(GtkAdjustment* adjustment, gdouble lower, \
gdouble upper)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment), adjustment, 1, "gtk_adjustment_clamp_page", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(lower), lower, 2, "gtk_adjustment_clamp_page", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(upper), upper, 3, "gtk_adjustment_clamp_page", "gdouble");
  gtk_adjustment_clamp_page(XEN_TO_C_GtkAdjustment_(adjustment), XEN_TO_C_gdouble(lower), XEN_TO_C_gdouble(upper));
  return(XEN_FALSE);
}
static XEN gxg_gtk_adjustment_get_value(XEN adjustment)
{
  #define H_gtk_adjustment_get_value "gdouble gtk_adjustment_get_value(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment), adjustment, 1, "gtk_adjustment_get_value", "GtkAdjustment*");
  return(C_TO_XEN_gdouble(gtk_adjustment_get_value(XEN_TO_C_GtkAdjustment_(adjustment))));
}
static XEN gxg_gtk_adjustment_set_value(XEN adjustment, XEN value)
{
  #define H_gtk_adjustment_set_value "void gtk_adjustment_set_value(GtkAdjustment* adjustment, gdouble value)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment), adjustment, 1, "gtk_adjustment_set_value", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(value), value, 2, "gtk_adjustment_set_value", "gdouble");
  gtk_adjustment_set_value(XEN_TO_C_GtkAdjustment_(adjustment), XEN_TO_C_gdouble(value));
  return(XEN_FALSE);
}
static XEN gxg_gtk_alignment_get_type(void)
{
  #define H_gtk_alignment_get_type "GtkType gtk_alignment_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_alignment_get_type()));
}
static XEN gxg_gtk_alignment_new(XEN xalign, XEN yalign, XEN xscale, XEN yscale)
{
  #define H_gtk_alignment_new "GtkWidget* gtk_alignment_new(gfloat xalign, gfloat yalign, gfloat xscale, \
gfloat yscale)"
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 1, "gtk_alignment_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 2, "gtk_alignment_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xscale), xscale, 3, "gtk_alignment_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yscale), yscale, 4, "gtk_alignment_new", "gfloat");
  return(C_TO_XEN_GtkWidget_(gtk_alignment_new(XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign), XEN_TO_C_gfloat(xscale), 
                                               XEN_TO_C_gfloat(yscale))));
}
static XEN gxg_gtk_alignment_set(XEN alignment, XEN xalign, XEN yalign, XEN xscale, XEN yscale)
{
  #define H_gtk_alignment_set "void gtk_alignment_set(GtkAlignment* alignment, gfloat xalign, gfloat yalign, \
gfloat xscale, gfloat yscale)"
  XEN_ASSERT_TYPE(XEN_GtkAlignment__P(alignment), alignment, 1, "gtk_alignment_set", "GtkAlignment*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_alignment_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_alignment_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xscale), xscale, 4, "gtk_alignment_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yscale), yscale, 5, "gtk_alignment_set", "gfloat");
  gtk_alignment_set(XEN_TO_C_GtkAlignment_(alignment), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign), XEN_TO_C_gfloat(xscale), 
                    XEN_TO_C_gfloat(yscale));
  return(XEN_FALSE);
}
static XEN gxg_gtk_arrow_get_type(void)
{
  #define H_gtk_arrow_get_type "GtkType gtk_arrow_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_arrow_get_type()));
}
static XEN gxg_gtk_arrow_new(XEN arrow_type, XEN shadow_type)
{
  #define H_gtk_arrow_new "GtkWidget* gtk_arrow_new(GtkArrowType arrow_type, GtkShadowType shadow_type)"
  XEN_ASSERT_TYPE(XEN_GtkArrowType_P(arrow_type), arrow_type, 1, "gtk_arrow_new", "GtkArrowType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 2, "gtk_arrow_new", "GtkShadowType");
  return(C_TO_XEN_GtkWidget_(gtk_arrow_new(XEN_TO_C_GtkArrowType(arrow_type), XEN_TO_C_GtkShadowType(shadow_type))));
}
static XEN gxg_gtk_arrow_set(XEN arrow, XEN arrow_type, XEN shadow_type)
{
  #define H_gtk_arrow_set "void gtk_arrow_set(GtkArrow* arrow, GtkArrowType arrow_type, GtkShadowType shadow_type)"
  XEN_ASSERT_TYPE(XEN_GtkArrow__P(arrow), arrow, 1, "gtk_arrow_set", "GtkArrow*");
  XEN_ASSERT_TYPE(XEN_GtkArrowType_P(arrow_type), arrow_type, 2, "gtk_arrow_set", "GtkArrowType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 3, "gtk_arrow_set", "GtkShadowType");
  gtk_arrow_set(XEN_TO_C_GtkArrow_(arrow), XEN_TO_C_GtkArrowType(arrow_type), XEN_TO_C_GtkShadowType(shadow_type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_aspect_frame_get_type(void)
{
  #define H_gtk_aspect_frame_get_type "GtkType gtk_aspect_frame_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_aspect_frame_get_type()));
}
static XEN gxg_gtk_aspect_frame_new(XEN label, XEN xalign, XEN yalign, XEN ratio, XEN obey_child)
{
  #define H_gtk_aspect_frame_new "GtkWidget* gtk_aspect_frame_new(gchar* label, gfloat xalign, gfloat yalign, \
gfloat ratio, gboolean obey_child)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_aspect_frame_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_aspect_frame_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_aspect_frame_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(ratio), ratio, 4, "gtk_aspect_frame_new", "gfloat");
  XEN_ASSERT_TYPE(XEN_gboolean_P(obey_child), obey_child, 5, "gtk_aspect_frame_new", "gboolean");
  return(C_TO_XEN_GtkWidget_(gtk_aspect_frame_new(XEN_TO_C_gchar_(label), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign), 
                                                  XEN_TO_C_gfloat(ratio), XEN_TO_C_gboolean(obey_child))));
}
static XEN gxg_gtk_aspect_frame_set(XEN aspect_frame, XEN xalign, XEN yalign, XEN ratio, XEN obey_child)
{
  #define H_gtk_aspect_frame_set "void gtk_aspect_frame_set(GtkAspectFrame* aspect_frame, gfloat xalign, \
gfloat yalign, gfloat ratio, gboolean obey_child)"
  XEN_ASSERT_TYPE(XEN_GtkAspectFrame__P(aspect_frame), aspect_frame, 1, "gtk_aspect_frame_set", "GtkAspectFrame*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_aspect_frame_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_aspect_frame_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(ratio), ratio, 4, "gtk_aspect_frame_set", "gfloat");
  XEN_ASSERT_TYPE(XEN_gboolean_P(obey_child), obey_child, 5, "gtk_aspect_frame_set", "gboolean");
  gtk_aspect_frame_set(XEN_TO_C_GtkAspectFrame_(aspect_frame), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign), XEN_TO_C_gfloat(ratio), 
                       XEN_TO_C_gboolean(obey_child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_box_get_type(void)
{
  #define H_gtk_button_box_get_type "GtkType gtk_button_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_button_box_get_type()));
}
static XEN gxg_gtk_button_box_get_layout(XEN widget)
{
  #define H_gtk_button_box_get_layout "GtkButtonBoxStyle gtk_button_box_get_layout(GtkButtonBox* widget)"
  XEN_ASSERT_TYPE(XEN_GtkButtonBox__P(widget), widget, 1, "gtk_button_box_get_layout", "GtkButtonBox*");
  return(C_TO_XEN_GtkButtonBoxStyle(gtk_button_box_get_layout(XEN_TO_C_GtkButtonBox_(widget))));
}
static XEN gxg_gtk_button_box_set_layout(XEN widget, XEN layout_style)
{
  #define H_gtk_button_box_set_layout "void gtk_button_box_set_layout(GtkButtonBox* widget, GtkButtonBoxStyle layout_style)"
  XEN_ASSERT_TYPE(XEN_GtkButtonBox__P(widget), widget, 1, "gtk_button_box_set_layout", "GtkButtonBox*");
  XEN_ASSERT_TYPE(XEN_GtkButtonBoxStyle_P(layout_style), layout_style, 2, "gtk_button_box_set_layout", "GtkButtonBoxStyle");
  gtk_button_box_set_layout(XEN_TO_C_GtkButtonBox_(widget), XEN_TO_C_GtkButtonBoxStyle(layout_style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_box_set_child_secondary(XEN widget, XEN child, XEN is_secondary)
{
  #define H_gtk_button_box_set_child_secondary "void gtk_button_box_set_child_secondary(GtkButtonBox* widget, \
GtkWidget* child, gboolean is_secondary)"
  XEN_ASSERT_TYPE(XEN_GtkButtonBox__P(widget), widget, 1, "gtk_button_box_set_child_secondary", "GtkButtonBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_button_box_set_child_secondary", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_secondary), is_secondary, 3, "gtk_button_box_set_child_secondary", "gboolean");
  gtk_button_box_set_child_secondary(XEN_TO_C_GtkButtonBox_(widget), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(is_secondary));
  return(XEN_FALSE);
}
static XEN gxg_gtk_binding_set_new(XEN set_name)
{
  #define H_gtk_binding_set_new "GtkBindingSet* gtk_binding_set_new(gchar* set_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(set_name), set_name, 1, "gtk_binding_set_new", "gchar*");
  return(C_TO_XEN_GtkBindingSet_(gtk_binding_set_new(XEN_TO_C_gchar_(set_name))));
}
static XEN gxg_gtk_binding_set_by_class(XEN object_class)
{
  #define H_gtk_binding_set_by_class "GtkBindingSet* gtk_binding_set_by_class(gpointer object_class)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(object_class), object_class, 1, "gtk_binding_set_by_class", "gpointer");
  return(C_TO_XEN_GtkBindingSet_(gtk_binding_set_by_class(XEN_TO_C_gpointer(object_class))));
}
static XEN gxg_gtk_binding_set_find(XEN set_name)
{
  #define H_gtk_binding_set_find "GtkBindingSet* gtk_binding_set_find(gchar* set_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(set_name), set_name, 1, "gtk_binding_set_find", "gchar*");
  return(C_TO_XEN_GtkBindingSet_(gtk_binding_set_find(XEN_TO_C_gchar_(set_name))));
}
static XEN gxg_gtk_bindings_activate(XEN object, XEN keyval, XEN modifiers)
{
  #define H_gtk_bindings_activate "gboolean gtk_bindings_activate(GtkObject* object, guint keyval, GdkModifierType modifiers)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 1, "gtk_bindings_activate", "GtkObject*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_bindings_activate", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 3, "gtk_bindings_activate", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_bindings_activate(XEN_TO_C_GtkObject_(object), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers))));
}
static XEN gxg_gtk_binding_set_activate(XEN binding_set, XEN keyval, XEN modifiers, XEN object)
{
  #define H_gtk_binding_set_activate "gboolean gtk_binding_set_activate(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers, GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_GtkBindingSet__P(binding_set), binding_set, 1, "gtk_binding_set_activate", "GtkBindingSet*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_binding_set_activate", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 3, "gtk_binding_set_activate", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 4, "gtk_binding_set_activate", "GtkObject*");
  return(C_TO_XEN_gboolean(gtk_binding_set_activate(XEN_TO_C_GtkBindingSet_(binding_set), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers), 
                                                    XEN_TO_C_GtkObject_(object))));
}
static XEN gxg_gtk_binding_entry_clear(XEN binding_set, XEN keyval, XEN modifiers)
{
  #define H_gtk_binding_entry_clear "void gtk_binding_entry_clear(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  XEN_ASSERT_TYPE(XEN_GtkBindingSet__P(binding_set), binding_set, 1, "gtk_binding_entry_clear", "GtkBindingSet*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_binding_entry_clear", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 3, "gtk_binding_entry_clear", "GdkModifierType");
  gtk_binding_entry_clear(XEN_TO_C_GtkBindingSet_(binding_set), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers));
  return(XEN_FALSE);
}
static XEN gxg_gtk_binding_set_add_path(XEN binding_set, XEN path_type, XEN path_pattern, XEN priority)
{
  #define H_gtk_binding_set_add_path "void gtk_binding_set_add_path(GtkBindingSet* binding_set, GtkPathType path_type, \
gchar* path_pattern, GtkPathPriorityType priority)"
  XEN_ASSERT_TYPE(XEN_GtkBindingSet__P(binding_set), binding_set, 1, "gtk_binding_set_add_path", "GtkBindingSet*");
  XEN_ASSERT_TYPE(XEN_GtkPathType_P(path_type), path_type, 2, "gtk_binding_set_add_path", "GtkPathType");
  XEN_ASSERT_TYPE(XEN_gchar__P(path_pattern), path_pattern, 3, "gtk_binding_set_add_path", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkPathPriorityType_P(priority), priority, 4, "gtk_binding_set_add_path", "GtkPathPriorityType");
  gtk_binding_set_add_path(XEN_TO_C_GtkBindingSet_(binding_set), XEN_TO_C_GtkPathType(path_type), XEN_TO_C_gchar_(path_pattern), 
                           XEN_TO_C_GtkPathPriorityType(priority));
  return(XEN_FALSE);
}
static XEN gxg_gtk_binding_entry_remove(XEN binding_set, XEN keyval, XEN modifiers)
{
  #define H_gtk_binding_entry_remove "void gtk_binding_entry_remove(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  XEN_ASSERT_TYPE(XEN_GtkBindingSet__P(binding_set), binding_set, 1, "gtk_binding_entry_remove", "GtkBindingSet*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_binding_entry_remove", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 3, "gtk_binding_entry_remove", "GdkModifierType");
  gtk_binding_entry_remove(XEN_TO_C_GtkBindingSet_(binding_set), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers));
  return(XEN_FALSE);
}
static XEN gxg_gtk_binding_entry_add_signall(XEN binding_set, XEN keyval, XEN modifiers, XEN signal_name, XEN binding_args)
{
  #define H_gtk_binding_entry_add_signall "void gtk_binding_entry_add_signall(GtkBindingSet* binding_set, \
guint keyval, GdkModifierType modifiers, gchar* signal_name, GSList* binding_args)"
  XEN_ASSERT_TYPE(XEN_GtkBindingSet__P(binding_set), binding_set, 1, "gtk_binding_entry_add_signall", "GtkBindingSet*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_binding_entry_add_signall", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifiers), modifiers, 3, "gtk_binding_entry_add_signall", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_gchar__P(signal_name), signal_name, 4, "gtk_binding_entry_add_signall", "gchar*");
  XEN_ASSERT_TYPE(XEN_GSList__P(binding_args), binding_args, 5, "gtk_binding_entry_add_signall", "GSList*");
  gtk_binding_entry_add_signall(XEN_TO_C_GtkBindingSet_(binding_set), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifiers), 
                                XEN_TO_C_gchar_(signal_name), XEN_TO_C_GSList_(binding_args));
  return(XEN_FALSE);
}
static XEN gxg_gtk_binding_parse_binding(XEN scanner)
{
  #define H_gtk_binding_parse_binding "guint gtk_binding_parse_binding(GScanner* scanner)"
  XEN_ASSERT_TYPE(XEN_GScanner__P(scanner), scanner, 1, "gtk_binding_parse_binding", "GScanner*");
  return(C_TO_XEN_guint(gtk_binding_parse_binding(XEN_TO_C_GScanner_(scanner))));
}
static XEN gxg_gtk_bin_get_type(void)
{
  #define H_gtk_bin_get_type "GtkType gtk_bin_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_bin_get_type()));
}
static XEN gxg_gtk_bin_get_child(XEN bin)
{
  #define H_gtk_bin_get_child "GtkWidget* gtk_bin_get_child(GtkBin* bin)"
  XEN_ASSERT_TYPE(XEN_GtkBin__P(bin), bin, 1, "gtk_bin_get_child", "GtkBin*");
  return(C_TO_XEN_GtkWidget_(gtk_bin_get_child(XEN_TO_C_GtkBin_(bin))));
}
static XEN gxg_gtk_box_get_type(void)
{
  #define H_gtk_box_get_type "GtkType gtk_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_box_get_type()));
}
static XEN gxg_gtk_box_pack_start(XEN box, XEN child, XEN expand, XEN fill, XEN padding)
{
  #define H_gtk_box_pack_start "void gtk_box_pack_start(GtkBox* box, GtkWidget* child, gboolean expand, \
gboolean fill, guint padding)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_pack_start", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_box_pack_start", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_box_pack_start", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 4, "gtk_box_pack_start", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint_P(padding), padding, 5, "gtk_box_pack_start", "guint");
  gtk_box_pack_start(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(expand), XEN_TO_C_gboolean(fill), 
                     XEN_TO_C_guint(padding));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_pack_end(XEN box, XEN child, XEN expand, XEN fill, XEN padding)
{
  #define H_gtk_box_pack_end "void gtk_box_pack_end(GtkBox* box, GtkWidget* child, gboolean expand, gboolean fill, \
guint padding)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_pack_end", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_box_pack_end", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_box_pack_end", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 4, "gtk_box_pack_end", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint_P(padding), padding, 5, "gtk_box_pack_end", "guint");
  gtk_box_pack_end(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(expand), XEN_TO_C_gboolean(fill), 
                   XEN_TO_C_guint(padding));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_pack_start_defaults(XEN box, XEN widget)
{
  #define H_gtk_box_pack_start_defaults "void gtk_box_pack_start_defaults(GtkBox* box, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_pack_start_defaults", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_box_pack_start_defaults", "GtkWidget*");
  gtk_box_pack_start_defaults(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_pack_end_defaults(XEN box, XEN widget)
{
  #define H_gtk_box_pack_end_defaults "void gtk_box_pack_end_defaults(GtkBox* box, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_pack_end_defaults", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_box_pack_end_defaults", "GtkWidget*");
  gtk_box_pack_end_defaults(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_set_homogeneous(XEN box, XEN homogeneous)
{
  #define H_gtk_box_set_homogeneous "void gtk_box_set_homogeneous(GtkBox* box, gboolean homogeneous)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_set_homogeneous", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 2, "gtk_box_set_homogeneous", "gboolean");
  gtk_box_set_homogeneous(XEN_TO_C_GtkBox_(box), XEN_TO_C_gboolean(homogeneous));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_get_homogeneous(XEN box)
{
  #define H_gtk_box_get_homogeneous "gboolean gtk_box_get_homogeneous(GtkBox* box)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_get_homogeneous", "GtkBox*");
  return(C_TO_XEN_gboolean(gtk_box_get_homogeneous(XEN_TO_C_GtkBox_(box))));
}
static XEN gxg_gtk_box_set_spacing(XEN box, XEN spacing)
{
  #define H_gtk_box_set_spacing "void gtk_box_set_spacing(GtkBox* box, gint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_set_spacing", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_box_set_spacing", "gint");
  gtk_box_set_spacing(XEN_TO_C_GtkBox_(box), XEN_TO_C_gint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_get_spacing(XEN box)
{
  #define H_gtk_box_get_spacing "gint gtk_box_get_spacing(GtkBox* box)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_get_spacing", "GtkBox*");
  return(C_TO_XEN_gint(gtk_box_get_spacing(XEN_TO_C_GtkBox_(box))));
}
static XEN gxg_gtk_box_reorder_child(XEN box, XEN child, XEN position)
{
  #define H_gtk_box_reorder_child "void gtk_box_reorder_child(GtkBox* box, GtkWidget* child, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_reorder_child", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_box_reorder_child", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_box_reorder_child", "gint");
  gtk_box_reorder_child(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_box_query_child_packing(XEN box, XEN child, XEN expand, XEN fill, XEN padding, XEN pack_type)
{
  #define H_gtk_box_query_child_packing "void gtk_box_query_child_packing(GtkBox* box, GtkWidget* child, \
gboolean* [expand], gboolean* [fill], guint* [padding], GtkPackType* [pack_type])"
  gboolean ref_expand;
  gboolean ref_fill;
  guint ref_padding;
  GtkPackType ref_pack_type;
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_query_child_packing", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_box_query_child_packing", "GtkWidget*");
  gtk_box_query_child_packing(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(child), &ref_expand, &ref_fill, &ref_padding, &ref_pack_type);
  return(XEN_LIST_4(C_TO_XEN_gboolean(ref_expand), C_TO_XEN_gboolean(ref_fill), C_TO_XEN_guint(ref_padding), C_TO_XEN_GtkPackType(ref_pack_type)));
}
static XEN gxg_gtk_box_set_child_packing(XEN box, XEN child, XEN expand, XEN fill, XEN padding, XEN pack_type)
{
  #define H_gtk_box_set_child_packing "void gtk_box_set_child_packing(GtkBox* box, GtkWidget* child, \
gboolean expand, gboolean fill, guint padding, GtkPackType pack_type)"
  XEN_ASSERT_TYPE(XEN_GtkBox__P(box), box, 1, "gtk_box_set_child_packing", "GtkBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_box_set_child_packing", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_box_set_child_packing", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 4, "gtk_box_set_child_packing", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint_P(padding), padding, 5, "gtk_box_set_child_packing", "guint");
  XEN_ASSERT_TYPE(XEN_GtkPackType_P(pack_type), pack_type, 6, "gtk_box_set_child_packing", "GtkPackType");
  gtk_box_set_child_packing(XEN_TO_C_GtkBox_(box), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(expand), XEN_TO_C_gboolean(fill), 
                            XEN_TO_C_guint(padding), XEN_TO_C_GtkPackType(pack_type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_type(void)
{
  #define H_gtk_button_get_type "GtkType gtk_button_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_button_get_type()));
}
static XEN gxg_gtk_button_new(void)
{
  #define H_gtk_button_new "GtkWidget* gtk_button_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_button_new()));
}
static XEN gxg_gtk_button_new_with_label(XEN label)
{
  #define H_gtk_button_new_with_label "GtkWidget* gtk_button_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_button_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_button_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_button_new_from_stock(XEN stock_id)
{
  #define H_gtk_button_new_from_stock "GtkWidget* gtk_button_new_from_stock(gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_button_new_from_stock", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_button_new_from_stock(XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_button_new_with_mnemonic(XEN label)
{
  #define H_gtk_button_new_with_mnemonic "GtkWidget* gtk_button_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_button_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_button_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_button_pressed(XEN button)
{
  #define H_gtk_button_pressed "void gtk_button_pressed(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_pressed", "GtkButton*");
  gtk_button_pressed(XEN_TO_C_GtkButton_(button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_released(XEN button)
{
  #define H_gtk_button_released "void gtk_button_released(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_released", "GtkButton*");
  gtk_button_released(XEN_TO_C_GtkButton_(button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_clicked(XEN button)
{
  #define H_gtk_button_clicked "void gtk_button_clicked(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_clicked", "GtkButton*");
  gtk_button_clicked(XEN_TO_C_GtkButton_(button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_enter(XEN button)
{
  #define H_gtk_button_enter "void gtk_button_enter(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_enter", "GtkButton*");
  gtk_button_enter(XEN_TO_C_GtkButton_(button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_leave(XEN button)
{
  #define H_gtk_button_leave "void gtk_button_leave(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_leave", "GtkButton*");
  gtk_button_leave(XEN_TO_C_GtkButton_(button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_set_relief(XEN button, XEN newstyle)
{
  #define H_gtk_button_set_relief "void gtk_button_set_relief(GtkButton* button, GtkReliefStyle newstyle)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_relief", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_GtkReliefStyle_P(newstyle), newstyle, 2, "gtk_button_set_relief", "GtkReliefStyle");
  gtk_button_set_relief(XEN_TO_C_GtkButton_(button), XEN_TO_C_GtkReliefStyle(newstyle));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_relief(XEN button)
{
  #define H_gtk_button_get_relief "GtkReliefStyle gtk_button_get_relief(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_relief", "GtkButton*");
  return(C_TO_XEN_GtkReliefStyle(gtk_button_get_relief(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_button_set_label(XEN button, XEN label)
{
  #define H_gtk_button_set_label "void gtk_button_set_label(GtkButton* button, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_label", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_button_set_label", "gchar*");
  gtk_button_set_label(XEN_TO_C_GtkButton_(button), XEN_TO_C_gchar_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_label(XEN button)
{
  #define H_gtk_button_get_label "gchar* gtk_button_get_label(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_label", "GtkButton*");
  return(C_TO_XEN_gchar_(gtk_button_get_label(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_button_set_use_underline(XEN button, XEN use_underline)
{
  #define H_gtk_button_set_use_underline "void gtk_button_set_use_underline(GtkButton* button, gboolean use_underline)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_use_underline", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_underline), use_underline, 2, "gtk_button_set_use_underline", "gboolean");
  gtk_button_set_use_underline(XEN_TO_C_GtkButton_(button), XEN_TO_C_gboolean(use_underline));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_use_underline(XEN button)
{
  #define H_gtk_button_get_use_underline "gboolean gtk_button_get_use_underline(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_use_underline", "GtkButton*");
  return(C_TO_XEN_gboolean(gtk_button_get_use_underline(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_button_set_use_stock(XEN button, XEN use_stock)
{
  #define H_gtk_button_set_use_stock "void gtk_button_set_use_stock(GtkButton* button, gboolean use_stock)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_use_stock", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_stock), use_stock, 2, "gtk_button_set_use_stock", "gboolean");
  gtk_button_set_use_stock(XEN_TO_C_GtkButton_(button), XEN_TO_C_gboolean(use_stock));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_use_stock(XEN button)
{
  #define H_gtk_button_get_use_stock "gboolean gtk_button_get_use_stock(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_use_stock", "GtkButton*");
  return(C_TO_XEN_gboolean(gtk_button_get_use_stock(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_calendar_get_type(void)
{
  #define H_gtk_calendar_get_type "GtkType gtk_calendar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_calendar_get_type()));
}
static XEN gxg_gtk_calendar_new(void)
{
  #define H_gtk_calendar_new "GtkWidget* gtk_calendar_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_calendar_new()));
}
static XEN gxg_gtk_calendar_select_month(XEN calendar, XEN month, XEN year)
{
  #define H_gtk_calendar_select_month "gboolean gtk_calendar_select_month(GtkCalendar* calendar, guint month, \
guint year)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_select_month", "GtkCalendar*");
  XEN_ASSERT_TYPE(XEN_guint_P(month), month, 2, "gtk_calendar_select_month", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(year), year, 3, "gtk_calendar_select_month", "guint");
  return(C_TO_XEN_gboolean(gtk_calendar_select_month(XEN_TO_C_GtkCalendar_(calendar), XEN_TO_C_guint(month), XEN_TO_C_guint(year))));
}
static XEN gxg_gtk_calendar_select_day(XEN calendar, XEN day)
{
  #define H_gtk_calendar_select_day "void gtk_calendar_select_day(GtkCalendar* calendar, guint day)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_select_day", "GtkCalendar*");
  XEN_ASSERT_TYPE(XEN_guint_P(day), day, 2, "gtk_calendar_select_day", "guint");
  gtk_calendar_select_day(XEN_TO_C_GtkCalendar_(calendar), XEN_TO_C_guint(day));
  return(XEN_FALSE);
}
static XEN gxg_gtk_calendar_mark_day(XEN calendar, XEN day)
{
  #define H_gtk_calendar_mark_day "gboolean gtk_calendar_mark_day(GtkCalendar* calendar, guint day)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_mark_day", "GtkCalendar*");
  XEN_ASSERT_TYPE(XEN_guint_P(day), day, 2, "gtk_calendar_mark_day", "guint");
  return(C_TO_XEN_gboolean(gtk_calendar_mark_day(XEN_TO_C_GtkCalendar_(calendar), XEN_TO_C_guint(day))));
}
static XEN gxg_gtk_calendar_unmark_day(XEN calendar, XEN day)
{
  #define H_gtk_calendar_unmark_day "gboolean gtk_calendar_unmark_day(GtkCalendar* calendar, guint day)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_unmark_day", "GtkCalendar*");
  XEN_ASSERT_TYPE(XEN_guint_P(day), day, 2, "gtk_calendar_unmark_day", "guint");
  return(C_TO_XEN_gboolean(gtk_calendar_unmark_day(XEN_TO_C_GtkCalendar_(calendar), XEN_TO_C_guint(day))));
}
static XEN gxg_gtk_calendar_clear_marks(XEN calendar)
{
  #define H_gtk_calendar_clear_marks "void gtk_calendar_clear_marks(GtkCalendar* calendar)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_clear_marks", "GtkCalendar*");
  gtk_calendar_clear_marks(XEN_TO_C_GtkCalendar_(calendar));
  return(XEN_FALSE);
}
static XEN gxg_gtk_calendar_get_date(XEN calendar, XEN year, XEN month, XEN day)
{
  #define H_gtk_calendar_get_date "void gtk_calendar_get_date(GtkCalendar* calendar, guint* [year], guint* [month], \
guint* [day])"
  guint ref_year;
  guint ref_month;
  guint ref_day;
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_get_date", "GtkCalendar*");
  gtk_calendar_get_date(XEN_TO_C_GtkCalendar_(calendar), &ref_year, &ref_month, &ref_day);
  return(XEN_LIST_3(C_TO_XEN_guint(ref_year), C_TO_XEN_guint(ref_month), C_TO_XEN_guint(ref_day)));
}
static XEN gxg_gtk_calendar_freeze(XEN calendar)
{
  #define H_gtk_calendar_freeze "void gtk_calendar_freeze(GtkCalendar* calendar)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_freeze", "GtkCalendar*");
  gtk_calendar_freeze(XEN_TO_C_GtkCalendar_(calendar));
  return(XEN_FALSE);
}
static XEN gxg_gtk_calendar_thaw(XEN calendar)
{
  #define H_gtk_calendar_thaw "void gtk_calendar_thaw(GtkCalendar* calendar)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_thaw", "GtkCalendar*");
  gtk_calendar_thaw(XEN_TO_C_GtkCalendar_(calendar));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_editable_get_type(void)
{
  #define H_gtk_cell_editable_get_type "GType gtk_cell_editable_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_editable_get_type()));
}
static XEN gxg_gtk_cell_editable_start_editing(XEN cell_editable, XEN event)
{
  #define H_gtk_cell_editable_start_editing "void gtk_cell_editable_start_editing(GtkCellEditable* cell_editable, \
GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GtkCellEditable__P(cell_editable), cell_editable, 1, "gtk_cell_editable_start_editing", "GtkCellEditable*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event) || XEN_FALSE_P(event), event, 2, "gtk_cell_editable_start_editing", "GdkEvent*");
  gtk_cell_editable_start_editing(XEN_TO_C_GtkCellEditable_(cell_editable), XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_editable_editing_done(XEN cell_editable)
{
  #define H_gtk_cell_editable_editing_done "void gtk_cell_editable_editing_done(GtkCellEditable* cell_editable)"
  XEN_ASSERT_TYPE(XEN_GtkCellEditable__P(cell_editable), cell_editable, 1, "gtk_cell_editable_editing_done", "GtkCellEditable*");
  gtk_cell_editable_editing_done(XEN_TO_C_GtkCellEditable_(cell_editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_editable_remove_widget(XEN cell_editable)
{
  #define H_gtk_cell_editable_remove_widget "void gtk_cell_editable_remove_widget(GtkCellEditable* cell_editable)"
  XEN_ASSERT_TYPE(XEN_GtkCellEditable__P(cell_editable), cell_editable, 1, "gtk_cell_editable_remove_widget", "GtkCellEditable*");
  gtk_cell_editable_remove_widget(XEN_TO_C_GtkCellEditable_(cell_editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_get_type(void)
{
  #define H_gtk_cell_renderer_get_type "GType gtk_cell_renderer_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_renderer_get_type()));
}
static XEN gxg_gtk_cell_renderer_get_size(XEN cell, XEN widget, XEN cell_area, XEN x_offset, XEN y_offset, XEN width, XEN height)
{
  #define H_gtk_cell_renderer_get_size "void gtk_cell_renderer_get_size(GtkCellRenderer* cell, GtkWidget* widget, \
GdkRectangle* cell_area, gint* [x_offset], gint* [y_offset], gint* [width], gint* [height])"
  gint ref_x_offset;
  gint ref_y_offset;
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_get_size", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_cell_renderer_get_size", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(cell_area) || XEN_FALSE_P(cell_area), cell_area, 3, "gtk_cell_renderer_get_size", "GdkRectangle*");
  gtk_cell_renderer_get_size(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkRectangle_(cell_area), 
                             &ref_x_offset, &ref_y_offset, &ref_width, &ref_height);
  return(XEN_LIST_4(C_TO_XEN_gint(ref_x_offset), C_TO_XEN_gint(ref_y_offset), C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_cell_renderer_render(XEN cell, XEN window, XEN widget, XEN background_area, XEN cell_area, XEN expose_area, XEN flags)
{
  #define H_gtk_cell_renderer_render "void gtk_cell_renderer_render(GtkCellRenderer* cell, GdkWindow* window, \
GtkWidget* widget, GdkRectangle* background_area, GdkRectangle* cell_area, GdkRectangle* expose_area, \
GtkCellRendererState flags)"
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_render", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_cell_renderer_render", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 3, "gtk_cell_renderer_render", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(background_area), background_area, 4, "gtk_cell_renderer_render", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(cell_area), cell_area, 5, "gtk_cell_renderer_render", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(expose_area), expose_area, 6, "gtk_cell_renderer_render", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkCellRendererState_P(flags), flags, 7, "gtk_cell_renderer_render", "GtkCellRendererState");
  gtk_cell_renderer_render(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkRectangle_(background_area), 
                           XEN_TO_C_GdkRectangle_(cell_area), XEN_TO_C_GdkRectangle_(expose_area), XEN_TO_C_GtkCellRendererState(flags));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_activate(XEN cell, XEN event, XEN widget, XEN path, XEN background_area, XEN cell_area, XEN flags)
{
  #define H_gtk_cell_renderer_activate "gboolean gtk_cell_renderer_activate(GtkCellRenderer* cell, GdkEvent* event, \
GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags)"
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_activate", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gtk_cell_renderer_activate", "GdkEvent*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 3, "gtk_cell_renderer_activate", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 4, "gtk_cell_renderer_activate", "gchar*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(background_area), background_area, 5, "gtk_cell_renderer_activate", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(cell_area), cell_area, 6, "gtk_cell_renderer_activate", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkCellRendererState_P(flags), flags, 7, "gtk_cell_renderer_activate", "GtkCellRendererState");
  return(C_TO_XEN_gboolean(gtk_cell_renderer_activate(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_GdkEvent_(event), XEN_TO_C_GtkWidget_(widget), 
                                                      XEN_TO_C_gchar_(path), XEN_TO_C_GdkRectangle_(background_area), XEN_TO_C_GdkRectangle_(cell_area), 
                                                      XEN_TO_C_GtkCellRendererState(flags))));
}
static XEN gxg_gtk_cell_renderer_start_editing(XEN cell, XEN event, XEN widget, XEN path, XEN background_area, XEN cell_area, XEN flags)
{
  #define H_gtk_cell_renderer_start_editing "GtkCellEditable* gtk_cell_renderer_start_editing(GtkCellRenderer* cell, \
GdkEvent* event, GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, \
GtkCellRendererState flags)"
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_start_editing", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event) || XEN_FALSE_P(event), event, 2, "gtk_cell_renderer_start_editing", "GdkEvent*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 3, "gtk_cell_renderer_start_editing", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 4, "gtk_cell_renderer_start_editing", "gchar*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(background_area), background_area, 5, "gtk_cell_renderer_start_editing", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(cell_area), cell_area, 6, "gtk_cell_renderer_start_editing", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkCellRendererState_P(flags), flags, 7, "gtk_cell_renderer_start_editing", "GtkCellRendererState");
  return(C_TO_XEN_GtkCellEditable_(gtk_cell_renderer_start_editing(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_GdkEvent_(event), 
                                                                   XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(path), XEN_TO_C_GdkRectangle_(background_area), 
                                                                   XEN_TO_C_GdkRectangle_(cell_area), XEN_TO_C_GtkCellRendererState(flags))));
}
static XEN gxg_gtk_cell_renderer_set_fixed_size(XEN cell, XEN width, XEN height)
{
  #define H_gtk_cell_renderer_set_fixed_size "void gtk_cell_renderer_set_fixed_size(GtkCellRenderer* cell, \
gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_set_fixed_size", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_cell_renderer_set_fixed_size", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gtk_cell_renderer_set_fixed_size", "gint");
  gtk_cell_renderer_set_fixed_size(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_get_fixed_size(XEN cell, XEN width, XEN height)
{
  #define H_gtk_cell_renderer_get_fixed_size "void gtk_cell_renderer_get_fixed_size(GtkCellRenderer* cell, \
gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_get_fixed_size", "GtkCellRenderer*");
  gtk_cell_renderer_get_fixed_size(XEN_TO_C_GtkCellRenderer_(cell), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_cell_renderer_pixbuf_get_type(void)
{
  #define H_gtk_cell_renderer_pixbuf_get_type "GtkType gtk_cell_renderer_pixbuf_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_cell_renderer_pixbuf_get_type()));
}
static XEN gxg_gtk_cell_renderer_pixbuf_new(void)
{
  #define H_gtk_cell_renderer_pixbuf_new "GtkCellRenderer* gtk_cell_renderer_pixbuf_new( void)"
  return(C_TO_XEN_GtkCellRenderer_(gtk_cell_renderer_pixbuf_new()));
}
static XEN gxg_gtk_cell_renderer_text_get_type(void)
{
  #define H_gtk_cell_renderer_text_get_type "GtkType gtk_cell_renderer_text_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_cell_renderer_text_get_type()));
}
static XEN gxg_gtk_cell_renderer_text_new(void)
{
  #define H_gtk_cell_renderer_text_new "GtkCellRenderer* gtk_cell_renderer_text_new( void)"
  return(C_TO_XEN_GtkCellRenderer_(gtk_cell_renderer_text_new()));
}
static XEN gxg_gtk_cell_renderer_text_set_fixed_height_from_font(XEN renderer, XEN number_of_rows)
{
  #define H_gtk_cell_renderer_text_set_fixed_height_from_font "void gtk_cell_renderer_text_set_fixed_height_from_font(GtkCellRendererText* renderer, \
gint number_of_rows)"
  XEN_ASSERT_TYPE(XEN_GtkCellRendererText__P(renderer), renderer, 1, "gtk_cell_renderer_text_set_fixed_height_from_font", "GtkCellRendererText*");
  XEN_ASSERT_TYPE(XEN_gint_P(number_of_rows), number_of_rows, 2, "gtk_cell_renderer_text_set_fixed_height_from_font", "gint");
  gtk_cell_renderer_text_set_fixed_height_from_font(XEN_TO_C_GtkCellRendererText_(renderer), XEN_TO_C_gint(number_of_rows));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_toggle_get_type(void)
{
  #define H_gtk_cell_renderer_toggle_get_type "GtkType gtk_cell_renderer_toggle_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_cell_renderer_toggle_get_type()));
}
static XEN gxg_gtk_cell_renderer_toggle_new(void)
{
  #define H_gtk_cell_renderer_toggle_new "GtkCellRenderer* gtk_cell_renderer_toggle_new( void)"
  return(C_TO_XEN_GtkCellRenderer_(gtk_cell_renderer_toggle_new()));
}
static XEN gxg_gtk_cell_renderer_toggle_get_radio(XEN toggle)
{
  #define H_gtk_cell_renderer_toggle_get_radio "gboolean gtk_cell_renderer_toggle_get_radio(GtkCellRendererToggle* toggle)"
  XEN_ASSERT_TYPE(XEN_GtkCellRendererToggle__P(toggle), toggle, 1, "gtk_cell_renderer_toggle_get_radio", "GtkCellRendererToggle*");
  return(C_TO_XEN_gboolean(gtk_cell_renderer_toggle_get_radio(XEN_TO_C_GtkCellRendererToggle_(toggle))));
}
static XEN gxg_gtk_cell_renderer_toggle_set_radio(XEN toggle, XEN radio)
{
  #define H_gtk_cell_renderer_toggle_set_radio "void gtk_cell_renderer_toggle_set_radio(GtkCellRendererToggle* toggle, \
gboolean radio)"
  XEN_ASSERT_TYPE(XEN_GtkCellRendererToggle__P(toggle), toggle, 1, "gtk_cell_renderer_toggle_set_radio", "GtkCellRendererToggle*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(radio), radio, 2, "gtk_cell_renderer_toggle_set_radio", "gboolean");
  gtk_cell_renderer_toggle_set_radio(XEN_TO_C_GtkCellRendererToggle_(toggle), XEN_TO_C_gboolean(radio));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_toggle_get_active(XEN toggle)
{
  #define H_gtk_cell_renderer_toggle_get_active "gboolean gtk_cell_renderer_toggle_get_active(GtkCellRendererToggle* toggle)"
  XEN_ASSERT_TYPE(XEN_GtkCellRendererToggle__P(toggle), toggle, 1, "gtk_cell_renderer_toggle_get_active", "GtkCellRendererToggle*");
  return(C_TO_XEN_gboolean(gtk_cell_renderer_toggle_get_active(XEN_TO_C_GtkCellRendererToggle_(toggle))));
}
static XEN gxg_gtk_cell_renderer_toggle_set_active(XEN toggle, XEN setting)
{
  #define H_gtk_cell_renderer_toggle_set_active "void gtk_cell_renderer_toggle_set_active(GtkCellRendererToggle* toggle, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkCellRendererToggle__P(toggle), toggle, 1, "gtk_cell_renderer_toggle_set_active", "GtkCellRendererToggle*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_cell_renderer_toggle_set_active", "gboolean");
  gtk_cell_renderer_toggle_set_active(XEN_TO_C_GtkCellRendererToggle_(toggle), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_button_get_type(void)
{
  #define H_gtk_check_button_get_type "GtkType gtk_check_button_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_check_button_get_type()));
}
static XEN gxg_gtk_check_button_new(void)
{
  #define H_gtk_check_button_new "GtkWidget* gtk_check_button_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_check_button_new()));
}
static XEN gxg_gtk_check_button_new_with_label(XEN label)
{
  #define H_gtk_check_button_new_with_label "GtkWidget* gtk_check_button_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_check_button_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_check_button_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_check_button_new_with_mnemonic(XEN label)
{
  #define H_gtk_check_button_new_with_mnemonic "GtkWidget* gtk_check_button_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_check_button_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_check_button_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_check_menu_item_get_type(void)
{
  #define H_gtk_check_menu_item_get_type "GtkType gtk_check_menu_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_check_menu_item_get_type()));
}
static XEN gxg_gtk_check_menu_item_new(void)
{
  #define H_gtk_check_menu_item_new "GtkWidget* gtk_check_menu_item_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_check_menu_item_new()));
}
static XEN gxg_gtk_check_menu_item_new_with_label(XEN label)
{
  #define H_gtk_check_menu_item_new_with_label "GtkWidget* gtk_check_menu_item_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_check_menu_item_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_check_menu_item_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_check_menu_item_new_with_mnemonic(XEN label)
{
  #define H_gtk_check_menu_item_new_with_mnemonic "GtkWidget* gtk_check_menu_item_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_check_menu_item_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_check_menu_item_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_check_menu_item_set_active(XEN check_menu_item, XEN is_active)
{
  #define H_gtk_check_menu_item_set_active "void gtk_check_menu_item_set_active(GtkCheckMenuItem* check_menu_item, \
gboolean is_active)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_active", "GtkCheckMenuItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_active), is_active, 2, "gtk_check_menu_item_set_active", "gboolean");
  gtk_check_menu_item_set_active(XEN_TO_C_GtkCheckMenuItem_(check_menu_item), XEN_TO_C_gboolean(is_active));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_menu_item_get_active(XEN check_menu_item)
{
  #define H_gtk_check_menu_item_get_active "gboolean gtk_check_menu_item_get_active(GtkCheckMenuItem* check_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_active", "GtkCheckMenuItem*");
  return(C_TO_XEN_gboolean(gtk_check_menu_item_get_active(XEN_TO_C_GtkCheckMenuItem_(check_menu_item))));
}
static XEN gxg_gtk_check_menu_item_toggled(XEN check_menu_item)
{
  #define H_gtk_check_menu_item_toggled "void gtk_check_menu_item_toggled(GtkCheckMenuItem* check_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_toggled", "GtkCheckMenuItem*");
  gtk_check_menu_item_toggled(XEN_TO_C_GtkCheckMenuItem_(check_menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_menu_item_set_inconsistent(XEN check_menu_item, XEN setting)
{
  #define H_gtk_check_menu_item_set_inconsistent "void gtk_check_menu_item_set_inconsistent(GtkCheckMenuItem* check_menu_item, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_inconsistent", "GtkCheckMenuItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_check_menu_item_set_inconsistent", "gboolean");
  gtk_check_menu_item_set_inconsistent(XEN_TO_C_GtkCheckMenuItem_(check_menu_item), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_menu_item_get_inconsistent(XEN check_menu_item)
{
  #define H_gtk_check_menu_item_get_inconsistent "gboolean gtk_check_menu_item_get_inconsistent(GtkCheckMenuItem* check_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_inconsistent", "GtkCheckMenuItem*");
  return(C_TO_XEN_gboolean(gtk_check_menu_item_get_inconsistent(XEN_TO_C_GtkCheckMenuItem_(check_menu_item))));
}
static XEN gxg_gtk_clipboard_get(XEN selection)
{
  #define H_gtk_clipboard_get "GtkClipboard* gtk_clipboard_get(GdkAtom selection)"
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 1, "gtk_clipboard_get", "GdkAtom");
  return(C_TO_XEN_GtkClipboard_(gtk_clipboard_get(XEN_TO_C_GdkAtom(selection))));
}
static XEN gxg_gtk_clipboard_set_with_data(XEN clipboard, XEN targets, XEN n_targets, XEN func, XEN clear_func, XEN func_data)
{
  #define H_gtk_clipboard_set_with_data "gboolean gtk_clipboard_set_with_data(GtkClipboard* clipboard, \
GtkTargetEntry* targets, guint n_targets, GtkClipboardGetFunc func, GtkClipboardClearFunc clear_func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_set_with_data", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 2, "gtk_clipboard_set_with_data", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_targets), n_targets, 3, "gtk_clipboard_set_with_data", "guint");
  XEN_ASSERT_TYPE(XEN_GtkClipboardGetFunc_P(func), func, 4, "gtk_clipboard_set_with_data", "GtkClipboardGetFunc");
  XEN_ASSERT_TYPE(XEN_GtkClipboardClearFunc_P(clear_func), clear_func, 5, "gtk_clipboard_set_with_data", "GtkClipboardClearFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 6, "gtk_clipboard_set_with_data", "lambda_data");
  {
    XEN result = XEN_FALSE;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, clear_func);
    result = C_TO_XEN_gboolean(gtk_clipboard_set_with_data(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkTargetEntry_(targets), 
                                                           XEN_TO_C_guint(n_targets), XEN_TO_C_GtkClipboardGetFunc(func), 
                                                           XEN_TO_C_GtkClipboardClearFunc(clear_func), XEN_TO_C_lambda_data(func_data)));
    return(result);
   }
}
static XEN gxg_gtk_clipboard_get_owner(XEN clipboard)
{
  #define H_gtk_clipboard_get_owner "GObject* gtk_clipboard_get_owner(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_get_owner", "GtkClipboard*");
  return(C_TO_XEN_GObject_(gtk_clipboard_get_owner(XEN_TO_C_GtkClipboard_(clipboard))));
}
static XEN gxg_gtk_clipboard_clear(XEN clipboard)
{
  #define H_gtk_clipboard_clear "void gtk_clipboard_clear(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_clear", "GtkClipboard*");
  gtk_clipboard_clear(XEN_TO_C_GtkClipboard_(clipboard));
  return(XEN_FALSE);
}
static XEN gxg_gtk_clipboard_set_text(XEN clipboard, XEN text, XEN len)
{
  #define H_gtk_clipboard_set_text "void gtk_clipboard_set_text(GtkClipboard* clipboard, gchar* text, \
gint len)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_set_text", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_clipboard_set_text", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_clipboard_set_text", "gint");
  gtk_clipboard_set_text(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_gchar_(text), XEN_TO_C_gint(len));
  return(XEN_FALSE);
}
static XEN gxg_gtk_clipboard_request_contents(XEN clipboard, XEN target, XEN func, XEN func_data)
{
  #define H_gtk_clipboard_request_contents "void gtk_clipboard_request_contents(GtkClipboard* clipboard, \
GdkAtom target, GtkClipboardReceivedFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_request_contents", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_clipboard_request_contents", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GtkClipboardReceivedFunc_P(func), func, 3, "gtk_clipboard_request_contents", "GtkClipboardReceivedFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_clipboard_request_contents", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_clipboard_request_contents(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GdkAtom(target), XEN_TO_C_GtkClipboardReceivedFunc(func), 
                               XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_clipboard_request_text(XEN clipboard, XEN func, XEN func_data)
{
  #define H_gtk_clipboard_request_text "void gtk_clipboard_request_text(GtkClipboard* clipboard, GtkClipboardTextReceivedFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_request_text", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkClipboardTextReceivedFunc_P(func), func, 2, "gtk_clipboard_request_text", "GtkClipboardTextReceivedFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_clipboard_request_text", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_clipboard_request_text(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkClipboardTextReceivedFunc(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_clipboard_wait_for_contents(XEN clipboard, XEN target)
{
  #define H_gtk_clipboard_wait_for_contents "GtkSelectionData* gtk_clipboard_wait_for_contents(GtkClipboard* clipboard, \
GdkAtom target)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_for_contents", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_clipboard_wait_for_contents", "GdkAtom");
  return(C_TO_XEN_GtkSelectionData_(gtk_clipboard_wait_for_contents(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GdkAtom(target))));
}
static XEN gxg_gtk_clipboard_wait_for_text(XEN clipboard)
{
  #define H_gtk_clipboard_wait_for_text "gchar* gtk_clipboard_wait_for_text(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_for_text", "GtkClipboard*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_clipboard_wait_for_text(XEN_TO_C_GtkClipboard_(clipboard));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_clipboard_wait_is_text_available(XEN clipboard)
{
  #define H_gtk_clipboard_wait_is_text_available "gboolean gtk_clipboard_wait_is_text_available(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_is_text_available", "GtkClipboard*");
  return(C_TO_XEN_gboolean(gtk_clipboard_wait_is_text_available(XEN_TO_C_GtkClipboard_(clipboard))));
}
static XEN gxg_gtk_color_selection_dialog_get_type(void)
{
  #define H_gtk_color_selection_dialog_get_type "GtkType gtk_color_selection_dialog_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_color_selection_dialog_get_type()));
}
static XEN gxg_gtk_color_selection_dialog_new(XEN title)
{
  #define H_gtk_color_selection_dialog_new "GtkWidget* gtk_color_selection_dialog_new(gchar* title)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_color_selection_dialog_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_color_selection_dialog_new(XEN_TO_C_gchar_(title))));
}
static XEN gxg_gtk_color_selection_get_type(void)
{
  #define H_gtk_color_selection_get_type "GtkType gtk_color_selection_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_color_selection_get_type()));
}
static XEN gxg_gtk_color_selection_new(void)
{
  #define H_gtk_color_selection_new "GtkWidget* gtk_color_selection_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_color_selection_new()));
}
static XEN gxg_gtk_color_selection_get_has_opacity_control(XEN colorsel)
{
  #define H_gtk_color_selection_get_has_opacity_control "gboolean gtk_color_selection_get_has_opacity_control(GtkColorSelection* colorsel)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_has_opacity_control", "GtkColorSelection*");
  return(C_TO_XEN_gboolean(gtk_color_selection_get_has_opacity_control(XEN_TO_C_GtkColorSelection_(colorsel))));
}
static XEN gxg_gtk_color_selection_set_has_opacity_control(XEN colorsel, XEN has_opacity)
{
  #define H_gtk_color_selection_set_has_opacity_control "void gtk_color_selection_set_has_opacity_control(GtkColorSelection* colorsel, \
gboolean has_opacity)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_has_opacity_control", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(has_opacity), has_opacity, 2, "gtk_color_selection_set_has_opacity_control", "gboolean");
  gtk_color_selection_set_has_opacity_control(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_gboolean(has_opacity));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_get_has_palette(XEN colorsel)
{
  #define H_gtk_color_selection_get_has_palette "gboolean gtk_color_selection_get_has_palette(GtkColorSelection* colorsel)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_has_palette", "GtkColorSelection*");
  return(C_TO_XEN_gboolean(gtk_color_selection_get_has_palette(XEN_TO_C_GtkColorSelection_(colorsel))));
}
static XEN gxg_gtk_color_selection_set_has_palette(XEN colorsel, XEN has_palette)
{
  #define H_gtk_color_selection_set_has_palette "void gtk_color_selection_set_has_palette(GtkColorSelection* colorsel, \
gboolean has_palette)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_has_palette", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(has_palette), has_palette, 2, "gtk_color_selection_set_has_palette", "gboolean");
  gtk_color_selection_set_has_palette(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_gboolean(has_palette));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_set_current_color(XEN colorsel, XEN color)
{
  #define H_gtk_color_selection_set_current_color "void gtk_color_selection_set_current_color(GtkColorSelection* colorsel, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_current_color", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_selection_set_current_color", "GdkColor*");
  gtk_color_selection_set_current_color(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_set_current_alpha(XEN colorsel, XEN alpha)
{
  #define H_gtk_color_selection_set_current_alpha "void gtk_color_selection_set_current_alpha(GtkColorSelection* colorsel, \
guint16 alpha)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_current_alpha", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_guint16_P(alpha), alpha, 2, "gtk_color_selection_set_current_alpha", "guint16");
  gtk_color_selection_set_current_alpha(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_guint16(alpha));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_get_current_color(XEN colorsel, XEN color)
{
  #define H_gtk_color_selection_get_current_color "void gtk_color_selection_get_current_color(GtkColorSelection* colorsel, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_current_color", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_selection_get_current_color", "GdkColor*");
  gtk_color_selection_get_current_color(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_get_current_alpha(XEN colorsel)
{
  #define H_gtk_color_selection_get_current_alpha "guint16 gtk_color_selection_get_current_alpha(GtkColorSelection* colorsel)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_current_alpha", "GtkColorSelection*");
  return(C_TO_XEN_guint16(gtk_color_selection_get_current_alpha(XEN_TO_C_GtkColorSelection_(colorsel))));
}
static XEN gxg_gtk_color_selection_set_previous_color(XEN colorsel, XEN color)
{
  #define H_gtk_color_selection_set_previous_color "void gtk_color_selection_set_previous_color(GtkColorSelection* colorsel, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_previous_color", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_selection_set_previous_color", "GdkColor*");
  gtk_color_selection_set_previous_color(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_set_previous_alpha(XEN colorsel, XEN alpha)
{
  #define H_gtk_color_selection_set_previous_alpha "void gtk_color_selection_set_previous_alpha(GtkColorSelection* colorsel, \
guint16 alpha)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_set_previous_alpha", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_guint16_P(alpha), alpha, 2, "gtk_color_selection_set_previous_alpha", "guint16");
  gtk_color_selection_set_previous_alpha(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_guint16(alpha));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_get_previous_color(XEN colorsel, XEN color)
{
  #define H_gtk_color_selection_get_previous_color "void gtk_color_selection_get_previous_color(GtkColorSelection* colorsel, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_previous_color", "GtkColorSelection*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_selection_get_previous_color", "GdkColor*");
  gtk_color_selection_get_previous_color(XEN_TO_C_GtkColorSelection_(colorsel), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_selection_get_previous_alpha(XEN colorsel)
{
  #define H_gtk_color_selection_get_previous_alpha "guint16 gtk_color_selection_get_previous_alpha(GtkColorSelection* colorsel)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_get_previous_alpha", "GtkColorSelection*");
  return(C_TO_XEN_guint16(gtk_color_selection_get_previous_alpha(XEN_TO_C_GtkColorSelection_(colorsel))));
}
static XEN gxg_gtk_color_selection_is_adjusting(XEN colorsel)
{
  #define H_gtk_color_selection_is_adjusting "gboolean gtk_color_selection_is_adjusting(GtkColorSelection* colorsel)"
  XEN_ASSERT_TYPE(XEN_GtkColorSelection__P(colorsel), colorsel, 1, "gtk_color_selection_is_adjusting", "GtkColorSelection*");
  return(C_TO_XEN_gboolean(gtk_color_selection_is_adjusting(XEN_TO_C_GtkColorSelection_(colorsel))));
}
static XEN gxg_gtk_color_selection_palette_from_string(XEN str, XEN colors, XEN n_colors)
{
  #define H_gtk_color_selection_palette_from_string "gboolean gtk_color_selection_palette_from_string(gchar* str, \
GdkColor** [colors], gint* [n_colors])"
  GdkColor* ref_colors = NULL;
  gint ref_n_colors;
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 1, "gtk_color_selection_palette_from_string", "gchar*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_color_selection_palette_from_string(XEN_TO_C_gchar_(str), &ref_colors, &ref_n_colors));
    return(XEN_LIST_3(result, C_TO_XEN_GdkColor_(ref_colors), C_TO_XEN_gint(ref_n_colors)));
   }
}
static XEN gxg_gtk_color_selection_palette_to_string(XEN colors, XEN n_colors)
{
  #define H_gtk_color_selection_palette_to_string "gchar* gtk_color_selection_palette_to_string(GdkColor* colors, \
gint n_colors)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(colors), colors, 1, "gtk_color_selection_palette_to_string", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_colors), n_colors, 2, "gtk_color_selection_palette_to_string", "gint");
  {
   gchar* result;
   XEN rtn;
   result = gtk_color_selection_palette_to_string(XEN_TO_C_GdkColor_(colors), XEN_TO_C_gint(n_colors));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_GTK_IS_RESIZE_CONTAINER(XEN widget)
{
  #define H_GTK_IS_RESIZE_CONTAINER "gboolean GTK_IS_RESIZE_CONTAINER(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "GTK_IS_RESIZE_CONTAINER", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_IS_RESIZE_CONTAINER(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_container_get_type(void)
{
  #define H_gtk_container_get_type "GtkType gtk_container_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_container_get_type()));
}
static XEN gxg_gtk_container_set_border_width(XEN container, XEN border_width)
{
  #define H_gtk_container_set_border_width "void gtk_container_set_border_width(GtkContainer* container, \
guint border_width)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_set_border_width", "GtkContainer*");
  XEN_ASSERT_TYPE(XEN_guint_P(border_width), border_width, 2, "gtk_container_set_border_width", "guint");
  gtk_container_set_border_width(XEN_TO_C_GtkContainer_(container), XEN_TO_C_guint(border_width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_container_get_border_width(XEN container)
{
  #define H_gtk_container_get_border_width "guint gtk_container_get_border_width(GtkContainer* container)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_get_border_width", "GtkContainer*");
  return(C_TO_XEN_guint(gtk_container_get_border_width(XEN_TO_C_GtkContainer_(container))));
}
static XEN gxg_gtk_container_add(XEN container, XEN widget)
{
  #define H_gtk_container_add "void gtk_container_add(GtkContainer* container, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_add", "GtkContainer*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_container_add", "GtkWidget*");
  gtk_container_add(XEN_TO_C_GtkContainer_(container), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_container_remove(XEN container, XEN widget)
{
  #define H_gtk_container_remove "void gtk_container_remove(GtkContainer* container, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_remove", "GtkContainer*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_container_remove", "GtkWidget*");
  gtk_container_remove(XEN_TO_C_GtkContainer_(container), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_container_set_resize_mode(XEN container, XEN resize_mode)
{
  #define H_gtk_container_set_resize_mode "void gtk_container_set_resize_mode(GtkContainer* container, \
GtkResizeMode resize_mode)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_set_resize_mode", "GtkContainer*");
  XEN_ASSERT_TYPE(XEN_GtkResizeMode_P(resize_mode), resize_mode, 2, "gtk_container_set_resize_mode", "GtkResizeMode");
  gtk_container_set_resize_mode(XEN_TO_C_GtkContainer_(container), XEN_TO_C_GtkResizeMode(resize_mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_container_get_resize_mode(XEN container)
{
  #define H_gtk_container_get_resize_mode "GtkResizeMode gtk_container_get_resize_mode(GtkContainer* container)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_get_resize_mode", "GtkContainer*");
  return(C_TO_XEN_GtkResizeMode(gtk_container_get_resize_mode(XEN_TO_C_GtkContainer_(container))));
}
static XEN gxg_gtk_container_check_resize(XEN container)
{
  #define H_gtk_container_check_resize "void gtk_container_check_resize(GtkContainer* container)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_check_resize", "GtkContainer*");
  gtk_container_check_resize(XEN_TO_C_GtkContainer_(container));
  return(XEN_FALSE);
}
static XEN gxg_gtk_container_foreach(XEN container, XEN func, XEN func_data)
{
  #define H_gtk_container_foreach "void gtk_container_foreach(GtkContainer* container, GtkCallback func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_foreach", "GtkContainer*");
  XEN_ASSERT_TYPE(XEN_GtkCallback_P(func), func, 2, "gtk_container_foreach", "GtkCallback");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_container_foreach", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_container_foreach(XEN_TO_C_GtkContainer_(container), XEN_TO_C_GtkCallback(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_container_get_children(XEN container)
{
  #define H_gtk_container_get_children "GList* gtk_container_get_children(GtkContainer* container)"
  XEN_ASSERT_TYPE(XEN_GtkContainer__P(container), container, 1, "gtk_container_get_children", "GtkContainer*");
  return(C_TO_XEN_GList_(gtk_container_get_children(XEN_TO_C_GtkContainer_(container))));
}
static XEN gxg_gtk_curve_get_type(void)
{
  #define H_gtk_curve_get_type "GtkType gtk_curve_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_curve_get_type()));
}
static XEN gxg_gtk_curve_new(void)
{
  #define H_gtk_curve_new "GtkWidget* gtk_curve_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_curve_new()));
}
static XEN gxg_gtk_curve_reset(XEN curve)
{
  #define H_gtk_curve_reset "void gtk_curve_reset(GtkCurve* curve)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_reset", "GtkCurve*");
  gtk_curve_reset(XEN_TO_C_GtkCurve_(curve));
  return(XEN_FALSE);
}
static XEN gxg_gtk_curve_set_gamma(XEN curve, XEN gamma)
{
  #define H_gtk_curve_set_gamma "void gtk_curve_set_gamma(GtkCurve* curve, gfloat gamma)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_set_gamma", "GtkCurve*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(gamma), gamma, 2, "gtk_curve_set_gamma", "gfloat");
  gtk_curve_set_gamma(XEN_TO_C_GtkCurve_(curve), XEN_TO_C_gfloat(gamma));
  return(XEN_FALSE);
}
static XEN gxg_gtk_curve_set_range(XEN curve, XEN min_x, XEN max_x, XEN min_y, XEN max_y)
{
  #define H_gtk_curve_set_range "void gtk_curve_set_range(GtkCurve* curve, gfloat min_x, gfloat max_x, \
gfloat min_y, gfloat max_y)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_set_range", "GtkCurve*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(min_x), min_x, 2, "gtk_curve_set_range", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(max_x), max_x, 3, "gtk_curve_set_range", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(min_y), min_y, 4, "gtk_curve_set_range", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(max_y), max_y, 5, "gtk_curve_set_range", "gfloat");
  gtk_curve_set_range(XEN_TO_C_GtkCurve_(curve), XEN_TO_C_gfloat(min_x), XEN_TO_C_gfloat(max_x), XEN_TO_C_gfloat(min_y), 
                      XEN_TO_C_gfloat(max_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_curve_get_vector(XEN curve, XEN veclen, XEN vector)
{
  #define H_gtk_curve_get_vector "void gtk_curve_get_vector(GtkCurve* curve, int veclen, gfloat* vector)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_get_vector", "GtkCurve*");
  XEN_ASSERT_TYPE(XEN_int_P(veclen), veclen, 2, "gtk_curve_get_vector", "int");
  XEN_ASSERT_TYPE(XEN_gfloat__P(vector), vector, 3, "gtk_curve_get_vector", "gfloat*");
  gtk_curve_get_vector(XEN_TO_C_GtkCurve_(curve), XEN_TO_C_int(veclen), XEN_TO_C_gfloat_(vector));
  return(XEN_FALSE);
}
static XEN gxg_gtk_curve_set_vector(XEN curve, XEN veclen, XEN vector)
{
  #define H_gtk_curve_set_vector "void gtk_curve_set_vector(GtkCurve* curve, int veclen, gfloat* vector)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_set_vector", "GtkCurve*");
  XEN_ASSERT_TYPE(XEN_int_P(veclen), veclen, 2, "gtk_curve_set_vector", "int");
  XEN_ASSERT_TYPE(XEN_gfloat__P(vector), vector, 3, "gtk_curve_set_vector", "gfloat*");
  gtk_curve_set_vector(XEN_TO_C_GtkCurve_(curve), XEN_TO_C_int(veclen), XEN_TO_C_gfloat_(vector));
  return(XEN_FALSE);
}
static XEN gxg_gtk_curve_set_curve_type(XEN curve, XEN type)
{
  #define H_gtk_curve_set_curve_type "void gtk_curve_set_curve_type(GtkCurve* curve, GtkCurveType type)"
  XEN_ASSERT_TYPE(XEN_GtkCurve__P(curve), curve, 1, "gtk_curve_set_curve_type", "GtkCurve*");
  XEN_ASSERT_TYPE(XEN_GtkCurveType_P(type), type, 2, "gtk_curve_set_curve_type", "GtkCurveType");
  gtk_curve_set_curve_type(XEN_TO_C_GtkCurve_(curve), XEN_TO_C_GtkCurveType(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_get_type(void)
{
  #define H_gtk_dialog_get_type "GtkType gtk_dialog_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_dialog_get_type()));
}
static XEN gxg_gtk_dialog_new(void)
{
  #define H_gtk_dialog_new "GtkWidget* gtk_dialog_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_dialog_new()));
}
static XEN gxg_gtk_dialog_new_with_buttons(XEN title, XEN parent, XEN flags, XEN buttons)
{
  #define H_gtk_dialog_new_with_buttons "GtkWidget* gtk_dialog_new_with_buttons(gchar* title, GtkWindow* parent, \
GtkDialogFlags flags, etc buttons)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_dialog_new_with_buttons", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(parent) || XEN_FALSE_P(parent), parent, 2, "gtk_dialog_new_with_buttons", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkDialogFlags_P(flags), flags, 3, "gtk_dialog_new_with_buttons", "GtkDialogFlags");
  if (XEN_NOT_BOUND_P(buttons)) buttons = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_etc_P(buttons), buttons, 4, "gtk_dialog_new_with_buttons", "etc");
  {
    int etc_len = 0;
    GtkWidget* result = NULL;
    gchar* p_arg0;
    GtkWindow* p_arg1;
    GtkDialogFlags p_arg2;
    if (XEN_LIST_P(buttons)) etc_len = XEN_LIST_LENGTH(buttons);
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_dialog_new_with_buttons", 3, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_dialog_new_with_buttons", 3, buttons, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_gchar_(title);
    p_arg1 = XEN_TO_C_GtkWindow_(parent);
    p_arg2 = XEN_TO_C_GtkDialogFlags(flags);
    switch (etc_len)
      {
        case 0: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, NULL); break;
        case 2: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), NULL); break;
        case 4: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), NULL); break;
        case 6: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), NULL); break;
        case 8: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), NULL); break;
        case 10: result = gtk_dialog_new_with_buttons(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), XLS(buttons, 8), XLI(buttons, 9), NULL); break;
      }
    return(C_TO_XEN_GtkWidget_(result));
  }
}
static XEN gxg_gtk_dialog_add_action_widget(XEN dialog, XEN child, XEN response_id)
{
  #define H_gtk_dialog_add_action_widget "void gtk_dialog_add_action_widget(GtkDialog* dialog, GtkWidget* child, \
gint response_id)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_add_action_widget", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_dialog_add_action_widget", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(response_id), response_id, 3, "gtk_dialog_add_action_widget", "gint");
  gtk_dialog_add_action_widget(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(response_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_add_button(XEN dialog, XEN button_text, XEN response_id)
{
  #define H_gtk_dialog_add_button "GtkWidget* gtk_dialog_add_button(GtkDialog* dialog, gchar* button_text, \
gint response_id)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_add_button", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(button_text), button_text, 2, "gtk_dialog_add_button", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(response_id), response_id, 3, "gtk_dialog_add_button", "gint");
  return(C_TO_XEN_GtkWidget_(gtk_dialog_add_button(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gchar_(button_text), XEN_TO_C_gint(response_id))));
}
static XEN gxg_gtk_dialog_add_buttons(XEN dialog, XEN buttons)
{
  #define H_gtk_dialog_add_buttons "void gtk_dialog_add_buttons(GtkDialog* dialog, etc buttons)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_add_buttons", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_etc_P(buttons), buttons, 2, "gtk_dialog_add_buttons", "etc");
  {
    int etc_len = 0;
    GtkDialog* p_arg0;
    if (XEN_LIST_P(buttons)) etc_len = XEN_LIST_LENGTH(buttons);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_dialog_add_buttons", 1, buttons, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_dialog_add_buttons", 1, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_dialog_add_buttons", 1, buttons, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkDialog_(dialog);
    switch (etc_len)
      {
        case 2: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), NULL); break;
        case 4: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), NULL); break;
        case 6: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), NULL); break;
        case 8: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), NULL); break;
        case 10: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), XLS(buttons, 8), XLI(buttons, 9), NULL); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_dialog_set_response_sensitive(XEN dialog, XEN response_id, XEN setting)
{
  #define H_gtk_dialog_set_response_sensitive "void gtk_dialog_set_response_sensitive(GtkDialog* dialog, \
gint response_id, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_set_response_sensitive", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gint_P(response_id), response_id, 2, "gtk_dialog_set_response_sensitive", "gint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 3, "gtk_dialog_set_response_sensitive", "gboolean");
  gtk_dialog_set_response_sensitive(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gint(response_id), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_set_default_response(XEN dialog, XEN response_id)
{
  #define H_gtk_dialog_set_default_response "void gtk_dialog_set_default_response(GtkDialog* dialog, \
gint response_id)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_set_default_response", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gint_P(response_id), response_id, 2, "gtk_dialog_set_default_response", "gint");
  gtk_dialog_set_default_response(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gint(response_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_set_has_separator(XEN dialog, XEN setting)
{
  #define H_gtk_dialog_set_has_separator "void gtk_dialog_set_has_separator(GtkDialog* dialog, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_set_has_separator", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_dialog_set_has_separator", "gboolean");
  gtk_dialog_set_has_separator(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_get_has_separator(XEN dialog)
{
  #define H_gtk_dialog_get_has_separator "gboolean gtk_dialog_get_has_separator(GtkDialog* dialog)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_get_has_separator", "GtkDialog*");
  return(C_TO_XEN_gboolean(gtk_dialog_get_has_separator(XEN_TO_C_GtkDialog_(dialog))));
}
static XEN gxg_gtk_dialog_response(XEN dialog, XEN response_id)
{
  #define H_gtk_dialog_response "void gtk_dialog_response(GtkDialog* dialog, gint response_id)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_response", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gint_P(response_id), response_id, 2, "gtk_dialog_response", "gint");
  gtk_dialog_response(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gint(response_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_dialog_run(XEN dialog)
{
  #define H_gtk_dialog_run "gint gtk_dialog_run(GtkDialog* dialog)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_run", "GtkDialog*");
  return(C_TO_XEN_gint(gtk_dialog_run(XEN_TO_C_GtkDialog_(dialog))));
}
static XEN gxg_gtk_drag_get_data(XEN widget, XEN context, XEN target, XEN time)
{
  #define H_gtk_drag_get_data "void gtk_drag_get_data(GtkWidget* widget, GdkDragContext* context, GdkAtom target, \
guint32 time)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_get_data", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 2, "gtk_drag_get_data", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 3, "gtk_drag_get_data", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 4, "gtk_drag_get_data", "guint32");
  gtk_drag_get_data(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkAtom(target), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_finish(XEN context, XEN success, XEN del, XEN time)
{
  #define H_gtk_drag_finish "void gtk_drag_finish(GdkDragContext* context, gboolean success, gboolean del, \
guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_finish", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(success), success, 2, "gtk_drag_finish", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(del), del, 3, "gtk_drag_finish", "gboolean");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 4, "gtk_drag_finish", "guint32");
  gtk_drag_finish(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_gboolean(success), XEN_TO_C_gboolean(del), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_get_source_widget(XEN context)
{
  #define H_gtk_drag_get_source_widget "GtkWidget* gtk_drag_get_source_widget(GdkDragContext* context)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_get_source_widget", "GdkDragContext*");
  return(C_TO_XEN_GtkWidget_(gtk_drag_get_source_widget(XEN_TO_C_GdkDragContext_(context))));
}
static XEN gxg_gtk_drag_highlight(XEN widget)
{
  #define H_gtk_drag_highlight "void gtk_drag_highlight(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_highlight", "GtkWidget*");
  gtk_drag_highlight(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_unhighlight(XEN widget)
{
  #define H_gtk_drag_unhighlight "void gtk_drag_unhighlight(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_unhighlight", "GtkWidget*");
  gtk_drag_unhighlight(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_dest_set(XEN widget, XEN flags, XEN targets, XEN n_targets, XEN actions)
{
  #define H_gtk_drag_dest_set "void gtk_drag_dest_set(GtkWidget* widget, GtkDestDefaults flags, GtkTargetEntry* targets, \
gint n_targets, GdkDragAction actions)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_set", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkDestDefaults_P(flags), flags, 2, "gtk_drag_dest_set", "GtkDestDefaults");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 3, "gtk_drag_dest_set", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_targets), n_targets, 4, "gtk_drag_dest_set", "gint");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(actions), actions, 5, "gtk_drag_dest_set", "GdkDragAction");
  gtk_drag_dest_set(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkDestDefaults(flags), XEN_TO_C_GtkTargetEntry_(targets), XEN_TO_C_gint(n_targets), 
                    XEN_TO_C_GdkDragAction(actions));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_dest_set_proxy(XEN widget, XEN proxy_window, XEN protocol, XEN use_coordinates)
{
  #define H_gtk_drag_dest_set_proxy "void gtk_drag_dest_set_proxy(GtkWidget* widget, GdkWindow* proxy_window, \
GdkDragProtocol protocol, gboolean use_coordinates)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_set_proxy", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(proxy_window), proxy_window, 2, "gtk_drag_dest_set_proxy", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkDragProtocol_P(protocol), protocol, 3, "gtk_drag_dest_set_proxy", "GdkDragProtocol");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_coordinates), use_coordinates, 4, "gtk_drag_dest_set_proxy", "gboolean");
  gtk_drag_dest_set_proxy(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkWindow_(proxy_window), XEN_TO_C_GdkDragProtocol(protocol), 
                          XEN_TO_C_gboolean(use_coordinates));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_dest_unset(XEN widget)
{
  #define H_gtk_drag_dest_unset "void gtk_drag_dest_unset(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_unset", "GtkWidget*");
  gtk_drag_dest_unset(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_dest_find_target(XEN widget, XEN context, XEN target_list)
{
  #define H_gtk_drag_dest_find_target "GdkAtom gtk_drag_dest_find_target(GtkWidget* widget, GdkDragContext* context, \
GtkTargetList* target_list)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_find_target", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 2, "gtk_drag_dest_find_target", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(target_list) || XEN_FALSE_P(target_list), target_list, 3, "gtk_drag_dest_find_target", "GtkTargetList*");
  return(C_TO_XEN_GdkAtom(gtk_drag_dest_find_target(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GtkTargetList_(target_list))));
}
static XEN gxg_gtk_drag_dest_get_target_list(XEN widget)
{
  #define H_gtk_drag_dest_get_target_list "GtkTargetList* gtk_drag_dest_get_target_list(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_get_target_list", "GtkWidget*");
  return(C_TO_XEN_GtkTargetList_(gtk_drag_dest_get_target_list(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_drag_dest_set_target_list(XEN widget, XEN target_list)
{
  #define H_gtk_drag_dest_set_target_list "void gtk_drag_dest_set_target_list(GtkWidget* widget, GtkTargetList* target_list)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_set_target_list", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(target_list) || XEN_FALSE_P(target_list), target_list, 2, "gtk_drag_dest_set_target_list", "GtkTargetList*");
  gtk_drag_dest_set_target_list(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkTargetList_(target_list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_set(XEN widget, XEN start_button_mask, XEN targets, XEN n_targets, XEN actions)
{
  #define H_gtk_drag_source_set "void gtk_drag_source_set(GtkWidget* widget, GdkModifierType start_button_mask, \
GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_set", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(start_button_mask), start_button_mask, 2, "gtk_drag_source_set", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 3, "gtk_drag_source_set", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_targets), n_targets, 4, "gtk_drag_source_set", "gint");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(actions), actions, 5, "gtk_drag_source_set", "GdkDragAction");
  gtk_drag_source_set(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkModifierType(start_button_mask), XEN_TO_C_GtkTargetEntry_(targets), 
                      XEN_TO_C_gint(n_targets), XEN_TO_C_GdkDragAction(actions));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_unset(XEN widget)
{
  #define H_gtk_drag_source_unset "void gtk_drag_source_unset(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_unset", "GtkWidget*");
  gtk_drag_source_unset(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_set_icon(XEN widget, XEN colormap, XEN pixmap, XEN mask)
{
  #define H_gtk_drag_source_set_icon "void gtk_drag_source_set_icon(GtkWidget* widget, GdkColormap* colormap, \
GdkPixmap* pixmap, GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_set_icon", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gtk_drag_source_set_icon", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap), pixmap, 3, "gtk_drag_source_set_icon", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask), mask, 4, "gtk_drag_source_set_icon", "GdkBitmap*");
  gtk_drag_source_set_icon(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkPixmap_(pixmap), XEN_TO_C_GdkBitmap_(mask));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_set_icon_pixbuf(XEN widget, XEN pixbuf)
{
  #define H_gtk_drag_source_set_icon_pixbuf "void gtk_drag_source_set_icon_pixbuf(GtkWidget* widget, \
GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_set_icon_pixbuf", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 2, "gtk_drag_source_set_icon_pixbuf", "GdkPixbuf*");
  gtk_drag_source_set_icon_pixbuf(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_set_icon_stock(XEN widget, XEN stock_id)
{
  #define H_gtk_drag_source_set_icon_stock "void gtk_drag_source_set_icon_stock(GtkWidget* widget, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_set_icon_stock", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_drag_source_set_icon_stock", "gchar*");
  gtk_drag_source_set_icon_stock(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(stock_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_begin(XEN widget, XEN targets, XEN actions, XEN button, XEN event)
{
  #define H_gtk_drag_begin "GdkDragContext* gtk_drag_begin(GtkWidget* widget, GtkTargetList* targets, \
GdkDragAction actions, gint button, GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_begin", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(targets), targets, 2, "gtk_drag_begin", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(actions), actions, 3, "gtk_drag_begin", "GdkDragAction");
  XEN_ASSERT_TYPE(XEN_gint_P(button), button, 4, "gtk_drag_begin", "gint");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 5, "gtk_drag_begin", "GdkEvent*");
  return(C_TO_XEN_GdkDragContext_(gtk_drag_begin(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkTargetList_(targets), XEN_TO_C_GdkDragAction(actions), 
                                                 XEN_TO_C_gint(button), XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gtk_drag_set_icon_widget(XEN context, XEN widget, XEN hot_x, XEN hot_y)
{
  #define H_gtk_drag_set_icon_widget "void gtk_drag_set_icon_widget(GdkDragContext* context, GtkWidget* widget, \
gint hot_x, gint hot_y)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_set_icon_widget", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_drag_set_icon_widget", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_x), hot_x, 3, "gtk_drag_set_icon_widget", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_y), hot_y, 4, "gtk_drag_set_icon_widget", "gint");
  gtk_drag_set_icon_widget(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(hot_x), XEN_TO_C_gint(hot_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_set_icon_pixmap(XEN context, XEN colormap, XEN pixmap, XEN mask, XEN hot_x, XEN hot_y)
{
  #define H_gtk_drag_set_icon_pixmap "void gtk_drag_set_icon_pixmap(GdkDragContext* context, GdkColormap* colormap, \
GdkPixmap* pixmap, GdkBitmap* mask, gint hot_x, gint hot_y)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_set_icon_pixmap", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gtk_drag_set_icon_pixmap", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap), pixmap, 3, "gtk_drag_set_icon_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask), mask, 4, "gtk_drag_set_icon_pixmap", "GdkBitmap*");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_x), hot_x, 5, "gtk_drag_set_icon_pixmap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_y), hot_y, 6, "gtk_drag_set_icon_pixmap", "gint");
  gtk_drag_set_icon_pixmap(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkPixmap_(pixmap), 
                           XEN_TO_C_GdkBitmap_(mask), XEN_TO_C_gint(hot_x), XEN_TO_C_gint(hot_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_set_icon_pixbuf(XEN context, XEN pixbuf, XEN hot_x, XEN hot_y)
{
  #define H_gtk_drag_set_icon_pixbuf "void gtk_drag_set_icon_pixbuf(GdkDragContext* context, GdkPixbuf* pixbuf, \
gint hot_x, gint hot_y)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_set_icon_pixbuf", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 2, "gtk_drag_set_icon_pixbuf", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_x), hot_x, 3, "gtk_drag_set_icon_pixbuf", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_y), hot_y, 4, "gtk_drag_set_icon_pixbuf", "gint");
  gtk_drag_set_icon_pixbuf(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_gint(hot_x), XEN_TO_C_gint(hot_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_set_icon_stock(XEN context, XEN stock_id, XEN hot_x, XEN hot_y)
{
  #define H_gtk_drag_set_icon_stock "void gtk_drag_set_icon_stock(GdkDragContext* context, gchar* stock_id, \
gint hot_x, gint hot_y)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_set_icon_stock", "GdkDragContext*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_drag_set_icon_stock", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_x), hot_x, 3, "gtk_drag_set_icon_stock", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(hot_y), hot_y, 4, "gtk_drag_set_icon_stock", "gint");
  gtk_drag_set_icon_stock(XEN_TO_C_GdkDragContext_(context), XEN_TO_C_gchar_(stock_id), XEN_TO_C_gint(hot_x), XEN_TO_C_gint(hot_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_set_icon_default(XEN context)
{
  #define H_gtk_drag_set_icon_default "void gtk_drag_set_icon_default(GdkDragContext* context)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gtk_drag_set_icon_default", "GdkDragContext*");
  gtk_drag_set_icon_default(XEN_TO_C_GdkDragContext_(context));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_check_threshold(XEN widget, XEN start_x, XEN start_y, XEN current_x, XEN current_y)
{
  #define H_gtk_drag_check_threshold "gboolean gtk_drag_check_threshold(GtkWidget* widget, gint start_x, \
gint start_y, gint current_x, gint current_y)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_check_threshold", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(start_x), start_x, 2, "gtk_drag_check_threshold", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(start_y), start_y, 3, "gtk_drag_check_threshold", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(current_x), current_x, 4, "gtk_drag_check_threshold", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(current_y), current_y, 5, "gtk_drag_check_threshold", "gint");
  return(C_TO_XEN_gboolean(gtk_drag_check_threshold(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(start_x), XEN_TO_C_gint(start_y), 
                                                    XEN_TO_C_gint(current_x), XEN_TO_C_gint(current_y))));
}
static XEN gxg_gtk_drawing_area_get_type(void)
{
  #define H_gtk_drawing_area_get_type "GtkType gtk_drawing_area_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_drawing_area_get_type()));
}
static XEN gxg_gtk_drawing_area_new(void)
{
  #define H_gtk_drawing_area_new "GtkWidget* gtk_drawing_area_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_drawing_area_new()));
}
static XEN gxg_gtk_editable_get_type(void)
{
  #define H_gtk_editable_get_type "GtkType gtk_editable_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_editable_get_type()));
}
static XEN gxg_gtk_editable_select_region(XEN editable, XEN start, XEN end)
{
  #define H_gtk_editable_select_region "void gtk_editable_select_region(GtkEditable* editable, gint start, \
gint end)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_select_region", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gint_P(start), start, 2, "gtk_editable_select_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(end), end, 3, "gtk_editable_select_region", "gint");
  gtk_editable_select_region(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gint(start), XEN_TO_C_gint(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_get_selection_bounds(XEN editable, XEN start, XEN end)
{
  #define H_gtk_editable_get_selection_bounds "gboolean gtk_editable_get_selection_bounds(GtkEditable* editable, \
gint* [start], gint* [end])"
  gint ref_start;
  gint ref_end;
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_get_selection_bounds", "GtkEditable*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_editable_get_selection_bounds(XEN_TO_C_GtkEditable_(editable), &ref_start, &ref_end));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_start), C_TO_XEN_gint(ref_end)));
   }
}
static XEN gxg_gtk_editable_insert_text(XEN editable, XEN new_text, XEN new_text_length, XEN position)
{
  #define H_gtk_editable_insert_text "void gtk_editable_insert_text(GtkEditable* editable, gchar* new_text, \
gint new_text_length, gint* [position])"
  gint ref_position;
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_insert_text", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gchar__P(new_text), new_text, 2, "gtk_editable_insert_text", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(new_text_length), new_text_length, 3, "gtk_editable_insert_text", "gint");
  gtk_editable_insert_text(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gchar_(new_text), XEN_TO_C_gint(new_text_length), &ref_position);
  return(XEN_LIST_1(C_TO_XEN_gint(ref_position)));
}
static XEN gxg_gtk_editable_delete_text(XEN editable, XEN start_pos, XEN end_pos)
{
  #define H_gtk_editable_delete_text "void gtk_editable_delete_text(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_delete_text", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gint_P(start_pos), start_pos, 2, "gtk_editable_delete_text", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(end_pos), end_pos, 3, "gtk_editable_delete_text", "gint");
  gtk_editable_delete_text(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gint(start_pos), XEN_TO_C_gint(end_pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_get_chars(XEN editable, XEN start_pos, XEN end_pos)
{
  #define H_gtk_editable_get_chars "gchar* gtk_editable_get_chars(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_get_chars", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gint_P(start_pos), start_pos, 2, "gtk_editable_get_chars", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(end_pos), end_pos, 3, "gtk_editable_get_chars", "gint");
  {
   gchar* result;
   XEN rtn;
   result = gtk_editable_get_chars(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gint(start_pos), 
                                                                     XEN_TO_C_gint(end_pos));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_editable_cut_clipboard(XEN editable)
{
  #define H_gtk_editable_cut_clipboard "void gtk_editable_cut_clipboard(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_cut_clipboard", "GtkEditable*");
  gtk_editable_cut_clipboard(XEN_TO_C_GtkEditable_(editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_copy_clipboard(XEN editable)
{
  #define H_gtk_editable_copy_clipboard "void gtk_editable_copy_clipboard(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_copy_clipboard", "GtkEditable*");
  gtk_editable_copy_clipboard(XEN_TO_C_GtkEditable_(editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_paste_clipboard(XEN editable)
{
  #define H_gtk_editable_paste_clipboard "void gtk_editable_paste_clipboard(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_paste_clipboard", "GtkEditable*");
  gtk_editable_paste_clipboard(XEN_TO_C_GtkEditable_(editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_delete_selection(XEN editable)
{
  #define H_gtk_editable_delete_selection "void gtk_editable_delete_selection(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_delete_selection", "GtkEditable*");
  gtk_editable_delete_selection(XEN_TO_C_GtkEditable_(editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_set_position(XEN editable, XEN position)
{
  #define H_gtk_editable_set_position "void gtk_editable_set_position(GtkEditable* editable, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_set_position", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_editable_set_position", "gint");
  gtk_editable_set_position(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_get_position(XEN editable)
{
  #define H_gtk_editable_get_position "gint gtk_editable_get_position(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_get_position", "GtkEditable*");
  return(C_TO_XEN_gint(gtk_editable_get_position(XEN_TO_C_GtkEditable_(editable))));
}
static XEN gxg_gtk_editable_set_editable(XEN editable, XEN is_editable)
{
  #define H_gtk_editable_set_editable "void gtk_editable_set_editable(GtkEditable* editable, gboolean is_editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_set_editable", "GtkEditable*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_editable), is_editable, 2, "gtk_editable_set_editable", "gboolean");
  gtk_editable_set_editable(XEN_TO_C_GtkEditable_(editable), XEN_TO_C_gboolean(is_editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_editable_get_editable(XEN editable)
{
  #define H_gtk_editable_get_editable "gboolean gtk_editable_get_editable(GtkEditable* editable)"
  XEN_ASSERT_TYPE(XEN_GtkEditable__P(editable), editable, 1, "gtk_editable_get_editable", "GtkEditable*");
  return(C_TO_XEN_gboolean(gtk_editable_get_editable(XEN_TO_C_GtkEditable_(editable))));
}
static XEN gxg_gtk_entry_get_type(void)
{
  #define H_gtk_entry_get_type "GtkType gtk_entry_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_entry_get_type()));
}
static XEN gxg_gtk_entry_new(void)
{
  #define H_gtk_entry_new "GtkWidget* gtk_entry_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_entry_new()));
}
static XEN gxg_gtk_entry_set_visibility(XEN entry, XEN visible)
{
  #define H_gtk_entry_set_visibility "void gtk_entry_set_visibility(GtkEntry* entry, gboolean visible)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_visibility", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible), visible, 2, "gtk_entry_set_visibility", "gboolean");
  gtk_entry_set_visibility(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gboolean(visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_visibility(XEN entry)
{
  #define H_gtk_entry_get_visibility "gboolean gtk_entry_get_visibility(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_visibility", "GtkEntry*");
  return(C_TO_XEN_gboolean(gtk_entry_get_visibility(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_invisible_char(XEN entry, XEN ch)
{
  #define H_gtk_entry_set_invisible_char "void gtk_entry_set_invisible_char(GtkEntry* entry, gunichar ch)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_invisible_char", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gunichar_P(ch), ch, 2, "gtk_entry_set_invisible_char", "gunichar");
  gtk_entry_set_invisible_char(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gunichar(ch));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_invisible_char(XEN entry)
{
  #define H_gtk_entry_get_invisible_char "gunichar gtk_entry_get_invisible_char(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_invisible_char", "GtkEntry*");
  return(C_TO_XEN_gunichar(gtk_entry_get_invisible_char(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_has_frame(XEN entry, XEN setting)
{
  #define H_gtk_entry_set_has_frame "void gtk_entry_set_has_frame(GtkEntry* entry, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_has_frame", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_entry_set_has_frame", "gboolean");
  gtk_entry_set_has_frame(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_has_frame(XEN entry)
{
  #define H_gtk_entry_get_has_frame "gboolean gtk_entry_get_has_frame(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_has_frame", "GtkEntry*");
  return(C_TO_XEN_gboolean(gtk_entry_get_has_frame(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_max_length(XEN entry, XEN max)
{
  #define H_gtk_entry_set_max_length "void gtk_entry_set_max_length(GtkEntry* entry, gint max)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_max_length", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(max), max, 2, "gtk_entry_set_max_length", "gint");
  gtk_entry_set_max_length(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gint(max));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_max_length(XEN entry)
{
  #define H_gtk_entry_get_max_length "gint gtk_entry_get_max_length(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_max_length", "GtkEntry*");
  return(C_TO_XEN_gint(gtk_entry_get_max_length(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_activates_default(XEN entry, XEN setting)
{
  #define H_gtk_entry_set_activates_default "void gtk_entry_set_activates_default(GtkEntry* entry, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_activates_default", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_entry_set_activates_default", "gboolean");
  gtk_entry_set_activates_default(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_activates_default(XEN entry)
{
  #define H_gtk_entry_get_activates_default "gboolean gtk_entry_get_activates_default(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_activates_default", "GtkEntry*");
  return(C_TO_XEN_gboolean(gtk_entry_get_activates_default(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_width_chars(XEN entry, XEN n_chars)
{
  #define H_gtk_entry_set_width_chars "void gtk_entry_set_width_chars(GtkEntry* entry, gint n_chars)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_width_chars", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_chars), n_chars, 2, "gtk_entry_set_width_chars", "gint");
  gtk_entry_set_width_chars(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gint(n_chars));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_width_chars(XEN entry)
{
  #define H_gtk_entry_get_width_chars "gint gtk_entry_get_width_chars(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_width_chars", "GtkEntry*");
  return(C_TO_XEN_gint(gtk_entry_get_width_chars(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_set_text(XEN entry, XEN text)
{
  #define H_gtk_entry_set_text "void gtk_entry_set_text(GtkEntry* entry, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_text", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_entry_set_text", "gchar*");
  gtk_entry_set_text(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_text(XEN entry)
{
  #define H_gtk_entry_get_text "gchar* gtk_entry_get_text(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_text", "GtkEntry*");
  return(C_TO_XEN_gchar_(gtk_entry_get_text(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_get_layout(XEN entry)
{
  #define H_gtk_entry_get_layout "PangoLayout* gtk_entry_get_layout(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_layout", "GtkEntry*");
  return(C_TO_XEN_PangoLayout_(gtk_entry_get_layout(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_entry_get_layout_offsets(XEN entry, XEN x, XEN y)
{
  #define H_gtk_entry_get_layout_offsets "void gtk_entry_get_layout_offsets(GtkEntry* entry, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_layout_offsets", "GtkEntry*");
  gtk_entry_get_layout_offsets(XEN_TO_C_GtkEntry_(entry), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gtk_event_box_get_type(void)
{
  #define H_gtk_event_box_get_type "GtkType gtk_event_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_event_box_get_type()));
}
static XEN gxg_gtk_event_box_new(void)
{
  #define H_gtk_event_box_new "GtkWidget* gtk_event_box_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_event_box_new()));
}
static XEN gxg_gtk_file_selection_get_type(void)
{
  #define H_gtk_file_selection_get_type "GtkType gtk_file_selection_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_file_selection_get_type()));
}
static XEN gxg_gtk_file_selection_new(XEN title)
{
  #define H_gtk_file_selection_new "GtkWidget* gtk_file_selection_new(gchar* title)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_file_selection_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_file_selection_new(XEN_TO_C_gchar_(title))));
}
static XEN gxg_gtk_file_selection_set_filename(XEN filesel, XEN filename)
{
  #define H_gtk_file_selection_set_filename "void gtk_file_selection_set_filename(GtkFileSelection* filesel, \
gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_set_filename", "GtkFileSelection*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 2, "gtk_file_selection_set_filename", "gchar*");
  gtk_file_selection_set_filename(XEN_TO_C_GtkFileSelection_(filesel), XEN_TO_C_gchar_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_selection_get_filename(XEN filesel)
{
  #define H_gtk_file_selection_get_filename "gchar* gtk_file_selection_get_filename(GtkFileSelection* filesel)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_get_filename", "GtkFileSelection*");
  return(C_TO_XEN_gchar_(gtk_file_selection_get_filename(XEN_TO_C_GtkFileSelection_(filesel))));
}
static XEN gxg_gtk_file_selection_complete(XEN filesel, XEN pattern)
{
  #define H_gtk_file_selection_complete "void gtk_file_selection_complete(GtkFileSelection* filesel, \
gchar* pattern)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_complete", "GtkFileSelection*");
  XEN_ASSERT_TYPE(XEN_gchar__P(pattern), pattern, 2, "gtk_file_selection_complete", "gchar*");
  gtk_file_selection_complete(XEN_TO_C_GtkFileSelection_(filesel), XEN_TO_C_gchar_(pattern));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_selection_show_fileop_buttons(XEN filesel)
{
  #define H_gtk_file_selection_show_fileop_buttons "void gtk_file_selection_show_fileop_buttons(GtkFileSelection* filesel)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_show_fileop_buttons", "GtkFileSelection*");
  gtk_file_selection_show_fileop_buttons(XEN_TO_C_GtkFileSelection_(filesel));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_selection_hide_fileop_buttons(XEN filesel)
{
  #define H_gtk_file_selection_hide_fileop_buttons "void gtk_file_selection_hide_fileop_buttons(GtkFileSelection* filesel)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_hide_fileop_buttons", "GtkFileSelection*");
  gtk_file_selection_hide_fileop_buttons(XEN_TO_C_GtkFileSelection_(filesel));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_selection_get_selections(XEN filesel)
{
  #define H_gtk_file_selection_get_selections "gchar** gtk_file_selection_get_selections(GtkFileSelection* filesel)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_get_selections", "GtkFileSelection*");
  return(C_TO_XEN_gchar__(gtk_file_selection_get_selections(XEN_TO_C_GtkFileSelection_(filesel))));
}
static XEN gxg_gtk_file_selection_set_select_multiple(XEN filesel, XEN select_multiple)
{
  #define H_gtk_file_selection_set_select_multiple "void gtk_file_selection_set_select_multiple(GtkFileSelection* filesel, \
gboolean select_multiple)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_set_select_multiple", "GtkFileSelection*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(select_multiple), select_multiple, 2, "gtk_file_selection_set_select_multiple", "gboolean");
  gtk_file_selection_set_select_multiple(XEN_TO_C_GtkFileSelection_(filesel), XEN_TO_C_gboolean(select_multiple));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_selection_get_select_multiple(XEN filesel)
{
  #define H_gtk_file_selection_get_select_multiple "gboolean gtk_file_selection_get_select_multiple(GtkFileSelection* filesel)"
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(filesel), filesel, 1, "gtk_file_selection_get_select_multiple", "GtkFileSelection*");
  return(C_TO_XEN_gboolean(gtk_file_selection_get_select_multiple(XEN_TO_C_GtkFileSelection_(filesel))));
}
static XEN gxg_gtk_icon_set_get_type(void)
{
  #define H_gtk_icon_set_get_type "GType gtk_icon_set_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_set_get_type()));
}
static XEN gxg_gtk_icon_source_get_type(void)
{
  #define H_gtk_icon_source_get_type "GType gtk_icon_source_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_source_get_type()));
}
static XEN gxg_gtk_selection_data_get_type(void)
{
  #define H_gtk_selection_data_get_type "GType gtk_selection_data_get_type( void)"
  return(C_TO_XEN_GType(gtk_selection_data_get_type()));
}
static XEN gxg_gtk_border_get_type(void)
{
  #define H_gtk_border_get_type "GType gtk_border_get_type( void)"
  return(C_TO_XEN_GType(gtk_border_get_type()));
}
static XEN gxg_gtk_tree_path_get_type(void)
{
  #define H_gtk_tree_path_get_type "GType gtk_tree_path_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_path_get_type()));
}
static XEN gxg_gtk_tree_iter_get_type(void)
{
  #define H_gtk_tree_iter_get_type "GType gtk_tree_iter_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_iter_get_type()));
}
static XEN gxg_gtk_identifier_get_type(void)
{
  #define H_gtk_identifier_get_type "GType gtk_identifier_get_type( void)"
  return(C_TO_XEN_GType(gtk_identifier_get_type()));
}
static XEN gxg_gtk_requisition_get_type(void)
{
  #define H_gtk_requisition_get_type "GType gtk_requisition_get_type( void)"
  return(C_TO_XEN_GType(gtk_requisition_get_type()));
}
static XEN gxg_gtk_fixed_get_type(void)
{
  #define H_gtk_fixed_get_type "GtkType gtk_fixed_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_fixed_get_type()));
}
static XEN gxg_gtk_fixed_new(void)
{
  #define H_gtk_fixed_new "GtkWidget* gtk_fixed_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_fixed_new()));
}
static XEN gxg_gtk_fixed_put(XEN fixed, XEN widget, XEN x, XEN y)
{
  #define H_gtk_fixed_put "void gtk_fixed_put(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkFixed__P(fixed), fixed, 1, "gtk_fixed_put", "GtkFixed*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_fixed_put", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gtk_fixed_put", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gtk_fixed_put", "gint");
  gtk_fixed_put(XEN_TO_C_GtkFixed_(fixed), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_fixed_move(XEN fixed, XEN widget, XEN x, XEN y)
{
  #define H_gtk_fixed_move "void gtk_fixed_move(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkFixed__P(fixed), fixed, 1, "gtk_fixed_move", "GtkFixed*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_fixed_move", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gtk_fixed_move", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gtk_fixed_move", "gint");
  gtk_fixed_move(XEN_TO_C_GtkFixed_(fixed), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_fixed_set_has_window(XEN fixed, XEN has_window)
{
  #define H_gtk_fixed_set_has_window "void gtk_fixed_set_has_window(GtkFixed* fixed, gboolean has_window)"
  XEN_ASSERT_TYPE(XEN_GtkFixed__P(fixed), fixed, 1, "gtk_fixed_set_has_window", "GtkFixed*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(has_window), has_window, 2, "gtk_fixed_set_has_window", "gboolean");
  gtk_fixed_set_has_window(XEN_TO_C_GtkFixed_(fixed), XEN_TO_C_gboolean(has_window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_fixed_get_has_window(XEN fixed)
{
  #define H_gtk_fixed_get_has_window "gboolean gtk_fixed_get_has_window(GtkFixed* fixed)"
  XEN_ASSERT_TYPE(XEN_GtkFixed__P(fixed), fixed, 1, "gtk_fixed_get_has_window", "GtkFixed*");
  return(C_TO_XEN_gboolean(gtk_fixed_get_has_window(XEN_TO_C_GtkFixed_(fixed))));
}
static XEN gxg_gtk_font_selection_get_type(void)
{
  #define H_gtk_font_selection_get_type "GtkType gtk_font_selection_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_font_selection_get_type()));
}
static XEN gxg_gtk_font_selection_new(void)
{
  #define H_gtk_font_selection_new "GtkWidget* gtk_font_selection_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_font_selection_new()));
}
static XEN gxg_gtk_font_selection_get_font_name(XEN fontsel)
{
  #define H_gtk_font_selection_get_font_name "gchar* gtk_font_selection_get_font_name(GtkFontSelection* fontsel)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelection__P(fontsel), fontsel, 1, "gtk_font_selection_get_font_name", "GtkFontSelection*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_font_selection_get_font_name(XEN_TO_C_GtkFontSelection_(fontsel));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_font_selection_set_font_name(XEN fontsel, XEN fontname)
{
  #define H_gtk_font_selection_set_font_name "gboolean gtk_font_selection_set_font_name(GtkFontSelection* fontsel, \
gchar* fontname)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelection__P(fontsel), fontsel, 1, "gtk_font_selection_set_font_name", "GtkFontSelection*");
  XEN_ASSERT_TYPE(XEN_gchar__P(fontname), fontname, 2, "gtk_font_selection_set_font_name", "gchar*");
  return(C_TO_XEN_gboolean(gtk_font_selection_set_font_name(XEN_TO_C_GtkFontSelection_(fontsel), XEN_TO_C_gchar_(fontname))));
}
static XEN gxg_gtk_font_selection_get_preview_text(XEN fontsel)
{
  #define H_gtk_font_selection_get_preview_text "gchar* gtk_font_selection_get_preview_text(GtkFontSelection* fontsel)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelection__P(fontsel), fontsel, 1, "gtk_font_selection_get_preview_text", "GtkFontSelection*");
  return(C_TO_XEN_gchar_(gtk_font_selection_get_preview_text(XEN_TO_C_GtkFontSelection_(fontsel))));
}
static XEN gxg_gtk_font_selection_set_preview_text(XEN fontsel, XEN text)
{
  #define H_gtk_font_selection_set_preview_text "void gtk_font_selection_set_preview_text(GtkFontSelection* fontsel, \
gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelection__P(fontsel), fontsel, 1, "gtk_font_selection_set_preview_text", "GtkFontSelection*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_font_selection_set_preview_text", "gchar*");
  gtk_font_selection_set_preview_text(XEN_TO_C_GtkFontSelection_(fontsel), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_font_selection_dialog_get_type(void)
{
  #define H_gtk_font_selection_dialog_get_type "GtkType gtk_font_selection_dialog_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_font_selection_dialog_get_type()));
}
static XEN gxg_gtk_font_selection_dialog_new(XEN title)
{
  #define H_gtk_font_selection_dialog_new "GtkWidget* gtk_font_selection_dialog_new(gchar* title)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_font_selection_dialog_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_font_selection_dialog_new(XEN_TO_C_gchar_(title))));
}
static XEN gxg_gtk_font_selection_dialog_get_font_name(XEN fsd)
{
  #define H_gtk_font_selection_dialog_get_font_name "gchar* gtk_font_selection_dialog_get_font_name(GtkFontSelectionDialog* fsd)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(fsd), fsd, 1, "gtk_font_selection_dialog_get_font_name", "GtkFontSelectionDialog*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_font_selection_dialog_get_font_name(XEN_TO_C_GtkFontSelectionDialog_(fsd));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_font_selection_dialog_set_font_name(XEN fsd, XEN fontname)
{
  #define H_gtk_font_selection_dialog_set_font_name "gboolean gtk_font_selection_dialog_set_font_name(GtkFontSelectionDialog* fsd, \
gchar* fontname)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(fsd), fsd, 1, "gtk_font_selection_dialog_set_font_name", "GtkFontSelectionDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(fontname), fontname, 2, "gtk_font_selection_dialog_set_font_name", "gchar*");
  return(C_TO_XEN_gboolean(gtk_font_selection_dialog_set_font_name(XEN_TO_C_GtkFontSelectionDialog_(fsd), XEN_TO_C_gchar_(fontname))));
}
static XEN gxg_gtk_font_selection_dialog_get_preview_text(XEN fsd)
{
  #define H_gtk_font_selection_dialog_get_preview_text "gchar* gtk_font_selection_dialog_get_preview_text(GtkFontSelectionDialog* fsd)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(fsd), fsd, 1, "gtk_font_selection_dialog_get_preview_text", "GtkFontSelectionDialog*");
  return(C_TO_XEN_gchar_(gtk_font_selection_dialog_get_preview_text(XEN_TO_C_GtkFontSelectionDialog_(fsd))));
}
static XEN gxg_gtk_font_selection_dialog_set_preview_text(XEN fsd, XEN text)
{
  #define H_gtk_font_selection_dialog_set_preview_text "void gtk_font_selection_dialog_set_preview_text(GtkFontSelectionDialog* fsd, \
gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(fsd), fsd, 1, "gtk_font_selection_dialog_set_preview_text", "GtkFontSelectionDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_font_selection_dialog_set_preview_text", "gchar*");
  gtk_font_selection_dialog_set_preview_text(XEN_TO_C_GtkFontSelectionDialog_(fsd), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_frame_get_type(void)
{
  #define H_gtk_frame_get_type "GtkType gtk_frame_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_frame_get_type()));
}
static XEN gxg_gtk_frame_new(XEN label)
{
  #define H_gtk_frame_new "GtkWidget* gtk_frame_new(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_frame_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_frame_new(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_frame_set_label(XEN frame, XEN label)
{
  #define H_gtk_frame_set_label "void gtk_frame_set_label(GtkFrame* frame, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_set_label", "GtkFrame*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_frame_set_label", "gchar*");
  gtk_frame_set_label(XEN_TO_C_GtkFrame_(frame), XEN_TO_C_gchar_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_frame_get_label(XEN frame)
{
  #define H_gtk_frame_get_label "gchar* gtk_frame_get_label(GtkFrame* frame)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_get_label", "GtkFrame*");
  return(C_TO_XEN_gchar_(gtk_frame_get_label(XEN_TO_C_GtkFrame_(frame))));
}
static XEN gxg_gtk_frame_set_label_widget(XEN frame, XEN label_widget)
{
  #define H_gtk_frame_set_label_widget "void gtk_frame_set_label_widget(GtkFrame* frame, GtkWidget* label_widget)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_set_label_widget", "GtkFrame*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(label_widget), label_widget, 2, "gtk_frame_set_label_widget", "GtkWidget*");
  gtk_frame_set_label_widget(XEN_TO_C_GtkFrame_(frame), XEN_TO_C_GtkWidget_(label_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_frame_get_label_widget(XEN frame)
{
  #define H_gtk_frame_get_label_widget "GtkWidget* gtk_frame_get_label_widget(GtkFrame* frame)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_get_label_widget", "GtkFrame*");
  return(C_TO_XEN_GtkWidget_(gtk_frame_get_label_widget(XEN_TO_C_GtkFrame_(frame))));
}
static XEN gxg_gtk_frame_set_label_align(XEN frame, XEN xalign, XEN yalign)
{
  #define H_gtk_frame_set_label_align "void gtk_frame_set_label_align(GtkFrame* frame, gfloat xalign, \
gfloat yalign)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_set_label_align", "GtkFrame*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_frame_set_label_align", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_frame_set_label_align", "gfloat");
  gtk_frame_set_label_align(XEN_TO_C_GtkFrame_(frame), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_frame_get_label_align(XEN frame, XEN xalign, XEN yalign)
{
  #define H_gtk_frame_get_label_align "void gtk_frame_get_label_align(GtkFrame* frame, gfloat* [xalign], \
gfloat* [yalign])"
  gfloat ref_xalign;
  gfloat ref_yalign;
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_get_label_align", "GtkFrame*");
  gtk_frame_get_label_align(XEN_TO_C_GtkFrame_(frame), &ref_xalign, &ref_yalign);
  return(XEN_LIST_2(C_TO_XEN_gfloat(ref_xalign), C_TO_XEN_gfloat(ref_yalign)));
}
static XEN gxg_gtk_frame_set_shadow_type(XEN frame, XEN type)
{
  #define H_gtk_frame_set_shadow_type "void gtk_frame_set_shadow_type(GtkFrame* frame, GtkShadowType type)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_set_shadow_type", "GtkFrame*");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(type), type, 2, "gtk_frame_set_shadow_type", "GtkShadowType");
  gtk_frame_set_shadow_type(XEN_TO_C_GtkFrame_(frame), XEN_TO_C_GtkShadowType(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_frame_get_shadow_type(XEN frame)
{
  #define H_gtk_frame_get_shadow_type "GtkShadowType gtk_frame_get_shadow_type(GtkFrame* frame)"
  XEN_ASSERT_TYPE(XEN_GtkFrame__P(frame), frame, 1, "gtk_frame_get_shadow_type", "GtkFrame*");
  return(C_TO_XEN_GtkShadowType(gtk_frame_get_shadow_type(XEN_TO_C_GtkFrame_(frame))));
}
static XEN gxg_gtk_gamma_curve_get_type(void)
{
  #define H_gtk_gamma_curve_get_type "GtkType gtk_gamma_curve_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_gamma_curve_get_type()));
}
static XEN gxg_gtk_gamma_curve_new(void)
{
  #define H_gtk_gamma_curve_new "GtkWidget* gtk_gamma_curve_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_gamma_curve_new()));
}
static XEN gxg_gtk_gc_get(XEN depth, XEN colormap, XEN values, XEN values_mask)
{
  #define H_gtk_gc_get "GdkGC* gtk_gc_get(gint depth, GdkColormap* colormap, GdkGCValues* values, GdkGCValuesMask values_mask)"
  XEN_ASSERT_TYPE(XEN_gint_P(depth), depth, 1, "gtk_gc_get", "gint");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gtk_gc_get", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(values), values, 3, "gtk_gc_get", "GdkGCValues*");
  XEN_ASSERT_TYPE(XEN_GdkGCValuesMask_P(values_mask), values_mask, 4, "gtk_gc_get", "GdkGCValuesMask");
  return(C_TO_XEN_GdkGC_(gtk_gc_get(XEN_TO_C_gint(depth), XEN_TO_C_GdkColormap_(colormap), XEN_TO_C_GdkGCValues_(values), 
                                    XEN_TO_C_GdkGCValuesMask(values_mask))));
}
static XEN gxg_gtk_gc_release(XEN gc)
{
  #define H_gtk_gc_release "void gtk_gc_release(GdkGC* gc)"
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 1, "gtk_gc_release", "GdkGC*");
  gtk_gc_release(XEN_TO_C_GdkGC_(gc));
  return(XEN_FALSE);
}
static XEN gxg_gtk_handle_box_get_type(void)
{
  #define H_gtk_handle_box_get_type "GtkType gtk_handle_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_handle_box_get_type()));
}
static XEN gxg_gtk_handle_box_new(void)
{
  #define H_gtk_handle_box_new "GtkWidget* gtk_handle_box_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_handle_box_new()));
}
static XEN gxg_gtk_handle_box_set_shadow_type(XEN handle_box, XEN type)
{
  #define H_gtk_handle_box_set_shadow_type "void gtk_handle_box_set_shadow_type(GtkHandleBox* handle_box, \
GtkShadowType type)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_set_shadow_type", "GtkHandleBox*");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(type), type, 2, "gtk_handle_box_set_shadow_type", "GtkShadowType");
  gtk_handle_box_set_shadow_type(XEN_TO_C_GtkHandleBox_(handle_box), XEN_TO_C_GtkShadowType(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_handle_box_get_shadow_type(XEN handle_box)
{
  #define H_gtk_handle_box_get_shadow_type "GtkShadowType gtk_handle_box_get_shadow_type(GtkHandleBox* handle_box)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_get_shadow_type", "GtkHandleBox*");
  return(C_TO_XEN_GtkShadowType(gtk_handle_box_get_shadow_type(XEN_TO_C_GtkHandleBox_(handle_box))));
}
static XEN gxg_gtk_handle_box_set_handle_position(XEN handle_box, XEN position)
{
  #define H_gtk_handle_box_set_handle_position "void gtk_handle_box_set_handle_position(GtkHandleBox* handle_box, \
GtkPositionType position)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_set_handle_position", "GtkHandleBox*");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(position), position, 2, "gtk_handle_box_set_handle_position", "GtkPositionType");
  gtk_handle_box_set_handle_position(XEN_TO_C_GtkHandleBox_(handle_box), XEN_TO_C_GtkPositionType(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_handle_box_get_handle_position(XEN handle_box)
{
  #define H_gtk_handle_box_get_handle_position "GtkPositionType gtk_handle_box_get_handle_position(GtkHandleBox* handle_box)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_get_handle_position", "GtkHandleBox*");
  return(C_TO_XEN_GtkPositionType(gtk_handle_box_get_handle_position(XEN_TO_C_GtkHandleBox_(handle_box))));
}
static XEN gxg_gtk_handle_box_set_snap_edge(XEN handle_box, XEN edge)
{
  #define H_gtk_handle_box_set_snap_edge "void gtk_handle_box_set_snap_edge(GtkHandleBox* handle_box, \
GtkPositionType edge)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_set_snap_edge", "GtkHandleBox*");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(edge), edge, 2, "gtk_handle_box_set_snap_edge", "GtkPositionType");
  gtk_handle_box_set_snap_edge(XEN_TO_C_GtkHandleBox_(handle_box), XEN_TO_C_GtkPositionType(edge));
  return(XEN_FALSE);
}
static XEN gxg_gtk_handle_box_get_snap_edge(XEN handle_box)
{
  #define H_gtk_handle_box_get_snap_edge "GtkPositionType gtk_handle_box_get_snap_edge(GtkHandleBox* handle_box)"
  XEN_ASSERT_TYPE(XEN_GtkHandleBox__P(handle_box), handle_box, 1, "gtk_handle_box_get_snap_edge", "GtkHandleBox*");
  return(C_TO_XEN_GtkPositionType(gtk_handle_box_get_snap_edge(XEN_TO_C_GtkHandleBox_(handle_box))));
}
static XEN gxg_gtk_hbutton_box_get_type(void)
{
  #define H_gtk_hbutton_box_get_type "GtkType gtk_hbutton_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hbutton_box_get_type()));
}
static XEN gxg_gtk_hbutton_box_new(void)
{
  #define H_gtk_hbutton_box_new "GtkWidget* gtk_hbutton_box_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_hbutton_box_new()));
}
static XEN gxg_gtk_hbox_get_type(void)
{
  #define H_gtk_hbox_get_type "GtkType gtk_hbox_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hbox_get_type()));
}
static XEN gxg_gtk_hbox_new(XEN homogeneous, XEN spacing)
{
  #define H_gtk_hbox_new "GtkWidget* gtk_hbox_new(gboolean homogeneous, gint spacing)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 1, "gtk_hbox_new", "gboolean");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_hbox_new", "gint");
  return(C_TO_XEN_GtkWidget_(gtk_hbox_new(XEN_TO_C_gboolean(homogeneous), XEN_TO_C_gint(spacing))));
}
static XEN gxg_gtk_hpaned_get_type(void)
{
  #define H_gtk_hpaned_get_type "GtkType gtk_hpaned_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hpaned_get_type()));
}
static XEN gxg_gtk_hpaned_new(void)
{
  #define H_gtk_hpaned_new "GtkWidget* gtk_hpaned_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_hpaned_new()));
}
static XEN gxg_gtk_hruler_get_type(void)
{
  #define H_gtk_hruler_get_type "GtkType gtk_hruler_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hruler_get_type()));
}
static XEN gxg_gtk_hruler_new(void)
{
  #define H_gtk_hruler_new "GtkWidget* gtk_hruler_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_hruler_new()));
}
static XEN gxg_gtk_hscale_get_type(void)
{
  #define H_gtk_hscale_get_type "GtkType gtk_hscale_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hscale_get_type()));
}
static XEN gxg_gtk_hscale_new(XEN adjustment)
{
  #define H_gtk_hscale_new "GtkWidget* gtk_hscale_new(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 1, "gtk_hscale_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_hscale_new(XEN_TO_C_GtkAdjustment_(adjustment))));
}
static XEN gxg_gtk_hscale_new_with_range(XEN min, XEN max, XEN step)
{
  #define H_gtk_hscale_new_with_range "GtkWidget* gtk_hscale_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  XEN_ASSERT_TYPE(XEN_gdouble_P(min), min, 1, "gtk_hscale_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max), max, 2, "gtk_hscale_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step), step, 3, "gtk_hscale_new_with_range", "gdouble");
  return(C_TO_XEN_GtkWidget_(gtk_hscale_new_with_range(XEN_TO_C_gdouble(min), XEN_TO_C_gdouble(max), XEN_TO_C_gdouble(step))));
}
static XEN gxg_gtk_hscrollbar_get_type(void)
{
  #define H_gtk_hscrollbar_get_type "GtkType gtk_hscrollbar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hscrollbar_get_type()));
}
static XEN gxg_gtk_hscrollbar_new(XEN adjustment)
{
  #define H_gtk_hscrollbar_new "GtkWidget* gtk_hscrollbar_new(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 1, "gtk_hscrollbar_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_hscrollbar_new(XEN_TO_C_GtkAdjustment_(adjustment))));
}
static XEN gxg_gtk_hseparator_get_type(void)
{
  #define H_gtk_hseparator_get_type "GtkType gtk_hseparator_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_hseparator_get_type()));
}
static XEN gxg_gtk_hseparator_new(void)
{
  #define H_gtk_hseparator_new "GtkWidget* gtk_hseparator_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_hseparator_new()));
}
static XEN gxg_gtk_icon_factory_get_type(void)
{
  #define H_gtk_icon_factory_get_type "GType gtk_icon_factory_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_factory_get_type()));
}
static XEN gxg_gtk_icon_factory_new(void)
{
  #define H_gtk_icon_factory_new "GtkIconFactory* gtk_icon_factory_new( void)"
  return(C_TO_XEN_GtkIconFactory_(gtk_icon_factory_new()));
}
static XEN gxg_gtk_icon_factory_add(XEN factory, XEN stock_id, XEN icon_set)
{
  #define H_gtk_icon_factory_add "void gtk_icon_factory_add(GtkIconFactory* factory, gchar* stock_id, \
GtkIconSet* icon_set)"
  XEN_ASSERT_TYPE(XEN_GtkIconFactory__P(factory), factory, 1, "gtk_icon_factory_add", "GtkIconFactory*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_icon_factory_add", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 3, "gtk_icon_factory_add", "GtkIconSet*");
  gtk_icon_factory_add(XEN_TO_C_GtkIconFactory_(factory), XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkIconSet_(icon_set));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_factory_lookup(XEN factory, XEN stock_id)
{
  #define H_gtk_icon_factory_lookup "GtkIconSet* gtk_icon_factory_lookup(GtkIconFactory* factory, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GtkIconFactory__P(factory), factory, 1, "gtk_icon_factory_lookup", "GtkIconFactory*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_icon_factory_lookup", "gchar*");
  return(C_TO_XEN_GtkIconSet_(gtk_icon_factory_lookup(XEN_TO_C_GtkIconFactory_(factory), XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_icon_factory_add_default(XEN factory)
{
  #define H_gtk_icon_factory_add_default "void gtk_icon_factory_add_default(GtkIconFactory* factory)"
  XEN_ASSERT_TYPE(XEN_GtkIconFactory__P(factory), factory, 1, "gtk_icon_factory_add_default", "GtkIconFactory*");
  gtk_icon_factory_add_default(XEN_TO_C_GtkIconFactory_(factory));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_factory_remove_default(XEN factory)
{
  #define H_gtk_icon_factory_remove_default "void gtk_icon_factory_remove_default(GtkIconFactory* factory)"
  XEN_ASSERT_TYPE(XEN_GtkIconFactory__P(factory), factory, 1, "gtk_icon_factory_remove_default", "GtkIconFactory*");
  gtk_icon_factory_remove_default(XEN_TO_C_GtkIconFactory_(factory));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_factory_lookup_default(XEN stock_id)
{
  #define H_gtk_icon_factory_lookup_default "GtkIconSet* gtk_icon_factory_lookup_default(gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_icon_factory_lookup_default", "gchar*");
  return(C_TO_XEN_GtkIconSet_(gtk_icon_factory_lookup_default(XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_icon_size_lookup(XEN size, XEN width, XEN height)
{
  #define H_gtk_icon_size_lookup "gboolean gtk_icon_size_lookup(GtkIconSize size, gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 1, "gtk_icon_size_lookup", "GtkIconSize");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_icon_size_lookup(XEN_TO_C_GtkIconSize(size), &ref_width, &ref_height));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
   }
}
static XEN gxg_gtk_icon_size_register(XEN name, XEN width, XEN height)
{
  #define H_gtk_icon_size_register "GtkIconSize gtk_icon_size_register(gchar* name, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_icon_size_register", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_icon_size_register", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gtk_icon_size_register", "gint");
  return(C_TO_XEN_GtkIconSize(gtk_icon_size_register(XEN_TO_C_gchar_(name), XEN_TO_C_gint(width), XEN_TO_C_gint(height))));
}
static XEN gxg_gtk_icon_size_register_alias(XEN alias, XEN target)
{
  #define H_gtk_icon_size_register_alias "void gtk_icon_size_register_alias(gchar* alias, GtkIconSize target)"
  XEN_ASSERT_TYPE(XEN_gchar__P(alias), alias, 1, "gtk_icon_size_register_alias", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(target), target, 2, "gtk_icon_size_register_alias", "GtkIconSize");
  gtk_icon_size_register_alias(XEN_TO_C_gchar_(alias), XEN_TO_C_GtkIconSize(target));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_size_from_name(XEN name)
{
  #define H_gtk_icon_size_from_name "GtkIconSize gtk_icon_size_from_name(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_icon_size_from_name", "gchar*");
  return(C_TO_XEN_GtkIconSize(gtk_icon_size_from_name(XEN_TO_C_gchar_(name))));
}
static XEN gxg_gtk_icon_size_get_name(XEN size)
{
  #define H_gtk_icon_size_get_name "gchar* gtk_icon_size_get_name(GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 1, "gtk_icon_size_get_name", "GtkIconSize");
  return(C_TO_XEN_gchar_(gtk_icon_size_get_name(XEN_TO_C_GtkIconSize(size))));
}
static XEN gxg_gtk_icon_set_new(void)
{
  #define H_gtk_icon_set_new "GtkIconSet* gtk_icon_set_new( void)"
  return(C_TO_XEN_GtkIconSet_(gtk_icon_set_new()));
}
static XEN gxg_gtk_icon_set_new_from_pixbuf(XEN pixbuf)
{
  #define H_gtk_icon_set_new_from_pixbuf "GtkIconSet* gtk_icon_set_new_from_pixbuf(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gtk_icon_set_new_from_pixbuf", "GdkPixbuf*");
  return(C_TO_XEN_GtkIconSet_(gtk_icon_set_new_from_pixbuf(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gtk_icon_set_ref(XEN icon_set)
{
  #define H_gtk_icon_set_ref "GtkIconSet* gtk_icon_set_ref(GtkIconSet* icon_set)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_ref", "GtkIconSet*");
  return(C_TO_XEN_GtkIconSet_(gtk_icon_set_ref(XEN_TO_C_GtkIconSet_(icon_set))));
}
static XEN gxg_gtk_icon_set_unref(XEN icon_set)
{
  #define H_gtk_icon_set_unref "void gtk_icon_set_unref(GtkIconSet* icon_set)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_unref", "GtkIconSet*");
  gtk_icon_set_unref(XEN_TO_C_GtkIconSet_(icon_set));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_set_copy(XEN icon_set)
{
  #define H_gtk_icon_set_copy "GtkIconSet* gtk_icon_set_copy(GtkIconSet* icon_set)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_copy", "GtkIconSet*");
  return(C_TO_XEN_GtkIconSet_(gtk_icon_set_copy(XEN_TO_C_GtkIconSet_(icon_set))));
}
static XEN gxg_gtk_icon_set_render_icon(XEN icon_set, XEN style, XEN direction, XEN state, XEN size, XEN widget, XEN detail)
{
  #define H_gtk_icon_set_render_icon "GdkPixbuf* gtk_icon_set_render_icon(GtkIconSet* icon_set, GtkStyle* style, \
GtkTextDirection direction, GtkStateType state, GtkIconSize size, GtkWidget* widget, char* detail)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_render_icon", "GtkIconSet*");
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style) || XEN_FALSE_P(style), style, 2, "gtk_icon_set_render_icon", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GtkTextDirection_P(direction), direction, 3, "gtk_icon_set_render_icon", "GtkTextDirection");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 4, "gtk_icon_set_render_icon", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 5, "gtk_icon_set_render_icon", "GtkIconSize");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget) || XEN_FALSE_P(widget), widget, 6, "gtk_icon_set_render_icon", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_char__P(detail), detail, 7, "gtk_icon_set_render_icon", "char*");
  return(C_TO_XEN_GdkPixbuf_(gtk_icon_set_render_icon(XEN_TO_C_GtkIconSet_(icon_set), XEN_TO_C_GtkStyle_(style), XEN_TO_C_GtkTextDirection(direction), 
                                                      XEN_TO_C_GtkStateType(state), XEN_TO_C_GtkIconSize(size), XEN_TO_C_GtkWidget_(widget), 
                                                      XEN_TO_C_char_(detail))));
}
static XEN gxg_gtk_icon_set_add_source(XEN icon_set, XEN source)
{
  #define H_gtk_icon_set_add_source "void gtk_icon_set_add_source(GtkIconSet* icon_set, GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_add_source", "GtkIconSet*");
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 2, "gtk_icon_set_add_source", "GtkIconSource*");
  gtk_icon_set_add_source(XEN_TO_C_GtkIconSet_(icon_set), XEN_TO_C_GtkIconSource_(source));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_set_get_sizes(XEN icon_set, XEN sizes, XEN n_sizes)
{
  #define H_gtk_icon_set_get_sizes "void gtk_icon_set_get_sizes(GtkIconSet* icon_set, GtkIconSize** [sizes], \
gint* [n_sizes])"
  GtkIconSize* ref_sizes = NULL;
  gint ref_n_sizes;
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_icon_set_get_sizes", "GtkIconSet*");
  gtk_icon_set_get_sizes(XEN_TO_C_GtkIconSet_(icon_set), &ref_sizes, &ref_n_sizes);
  return(XEN_LIST_2(C_TO_XEN_GtkIconSize_(ref_sizes), C_TO_XEN_gint(ref_n_sizes)));
}
static XEN gxg_gtk_icon_source_new(void)
{
  #define H_gtk_icon_source_new "GtkIconSource* gtk_icon_source_new( void)"
  return(C_TO_XEN_GtkIconSource_(gtk_icon_source_new()));
}
static XEN gxg_gtk_icon_source_copy(XEN source)
{
  #define H_gtk_icon_source_copy "GtkIconSource* gtk_icon_source_copy(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_copy", "GtkIconSource*");
  return(C_TO_XEN_GtkIconSource_(gtk_icon_source_copy(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_free(XEN source)
{
  #define H_gtk_icon_source_free "void gtk_icon_source_free(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_free", "GtkIconSource*");
  gtk_icon_source_free(XEN_TO_C_GtkIconSource_(source));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_filename(XEN source, XEN filename)
{
  #define H_gtk_icon_source_set_filename "void gtk_icon_source_set_filename(GtkIconSource* source, gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_filename", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 2, "gtk_icon_source_set_filename", "gchar*");
  gtk_icon_source_set_filename(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_gchar_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_pixbuf(XEN source, XEN pixbuf)
{
  #define H_gtk_icon_source_set_pixbuf "void gtk_icon_source_set_pixbuf(GtkIconSource* source, GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_pixbuf", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf) || XEN_FALSE_P(pixbuf), pixbuf, 2, "gtk_icon_source_set_pixbuf", "GdkPixbuf*");
  gtk_icon_source_set_pixbuf(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_get_filename(XEN source)
{
  #define H_gtk_icon_source_get_filename "gchar* gtk_icon_source_get_filename(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_filename", "GtkIconSource*");
  return(C_TO_XEN_gchar_(gtk_icon_source_get_filename(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_get_pixbuf(XEN source)
{
  #define H_gtk_icon_source_get_pixbuf "GdkPixbuf* gtk_icon_source_get_pixbuf(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_pixbuf", "GtkIconSource*");
  return(C_TO_XEN_GdkPixbuf_(gtk_icon_source_get_pixbuf(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_set_direction_wildcarded(XEN source, XEN setting)
{
  #define H_gtk_icon_source_set_direction_wildcarded "void gtk_icon_source_set_direction_wildcarded(GtkIconSource* source, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_direction_wildcarded", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_icon_source_set_direction_wildcarded", "gboolean");
  gtk_icon_source_set_direction_wildcarded(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_state_wildcarded(XEN source, XEN setting)
{
  #define H_gtk_icon_source_set_state_wildcarded "void gtk_icon_source_set_state_wildcarded(GtkIconSource* source, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_state_wildcarded", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_icon_source_set_state_wildcarded", "gboolean");
  gtk_icon_source_set_state_wildcarded(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_size_wildcarded(XEN source, XEN setting)
{
  #define H_gtk_icon_source_set_size_wildcarded "void gtk_icon_source_set_size_wildcarded(GtkIconSource* source, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_size_wildcarded", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_icon_source_set_size_wildcarded", "gboolean");
  gtk_icon_source_set_size_wildcarded(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_get_size_wildcarded(XEN source)
{
  #define H_gtk_icon_source_get_size_wildcarded "gboolean gtk_icon_source_get_size_wildcarded(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_size_wildcarded", "GtkIconSource*");
  return(C_TO_XEN_gboolean(gtk_icon_source_get_size_wildcarded(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_get_state_wildcarded(XEN source)
{
  #define H_gtk_icon_source_get_state_wildcarded "gboolean gtk_icon_source_get_state_wildcarded(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_state_wildcarded", "GtkIconSource*");
  return(C_TO_XEN_gboolean(gtk_icon_source_get_state_wildcarded(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_get_direction_wildcarded(XEN source)
{
  #define H_gtk_icon_source_get_direction_wildcarded "gboolean gtk_icon_source_get_direction_wildcarded(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_direction_wildcarded", "GtkIconSource*");
  return(C_TO_XEN_gboolean(gtk_icon_source_get_direction_wildcarded(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_set_direction(XEN source, XEN direction)
{
  #define H_gtk_icon_source_set_direction "void gtk_icon_source_set_direction(GtkIconSource* source, \
GtkTextDirection direction)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_direction", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_GtkTextDirection_P(direction), direction, 2, "gtk_icon_source_set_direction", "GtkTextDirection");
  gtk_icon_source_set_direction(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_GtkTextDirection(direction));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_state(XEN source, XEN state)
{
  #define H_gtk_icon_source_set_state "void gtk_icon_source_set_state(GtkIconSource* source, GtkStateType state)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_state", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_icon_source_set_state", "GtkStateType");
  gtk_icon_source_set_state(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_GtkStateType(state));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_set_size(XEN source, XEN size)
{
  #define H_gtk_icon_source_set_size "void gtk_icon_source_set_size(GtkIconSource* source, GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_set_size", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 2, "gtk_icon_source_set_size", "GtkIconSize");
  gtk_icon_source_set_size(XEN_TO_C_GtkIconSource_(source), XEN_TO_C_GtkIconSize(size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_get_direction(XEN source)
{
  #define H_gtk_icon_source_get_direction "GtkTextDirection gtk_icon_source_get_direction(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_direction", "GtkIconSource*");
  return(C_TO_XEN_GtkTextDirection(gtk_icon_source_get_direction(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_get_state(XEN source)
{
  #define H_gtk_icon_source_get_state "GtkStateType gtk_icon_source_get_state(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_state", "GtkIconSource*");
  return(C_TO_XEN_GtkStateType(gtk_icon_source_get_state(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_icon_source_get_size(XEN source)
{
  #define H_gtk_icon_source_get_size "GtkIconSize gtk_icon_source_get_size(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_size", "GtkIconSource*");
  return(C_TO_XEN_GtkIconSize(gtk_icon_source_get_size(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_image_get_type(void)
{
  #define H_gtk_image_get_type "GtkType gtk_image_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_image_get_type()));
}
static XEN gxg_gtk_image_new(void)
{
  #define H_gtk_image_new "GtkWidget* gtk_image_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_image_new()));
}
static XEN gxg_gtk_image_new_from_pixmap(XEN pixmap, XEN mask)
{
  #define H_gtk_image_new_from_pixmap "GtkWidget* gtk_image_new_from_pixmap(GdkPixmap* pixmap, GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap) || XEN_FALSE_P(pixmap), pixmap, 1, "gtk_image_new_from_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask) || XEN_FALSE_P(mask), mask, 2, "gtk_image_new_from_pixmap", "GdkBitmap*");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_pixmap(XEN_TO_C_GdkPixmap_(pixmap), XEN_TO_C_GdkBitmap_(mask))));
}
static XEN gxg_gtk_image_new_from_image(XEN image, XEN mask)
{
  #define H_gtk_image_new_from_image "GtkWidget* gtk_image_new_from_image(GdkImage* image, GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GdkImage__P(image) || XEN_FALSE_P(image), image, 1, "gtk_image_new_from_image", "GdkImage*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask) || XEN_FALSE_P(mask), mask, 2, "gtk_image_new_from_image", "GdkBitmap*");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_image(XEN_TO_C_GdkImage_(image), XEN_TO_C_GdkBitmap_(mask))));
}
static XEN gxg_gtk_image_new_from_file(XEN filename)
{
  #define H_gtk_image_new_from_file "GtkWidget* gtk_image_new_from_file(gchar* filename)"
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 1, "gtk_image_new_from_file", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_file(XEN_TO_C_gchar_(filename))));
}
static XEN gxg_gtk_image_new_from_pixbuf(XEN pixbuf)
{
  #define H_gtk_image_new_from_pixbuf "GtkWidget* gtk_image_new_from_pixbuf(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf) || XEN_FALSE_P(pixbuf), pixbuf, 1, "gtk_image_new_from_pixbuf", "GdkPixbuf*");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_pixbuf(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gtk_image_new_from_stock(XEN stock_id, XEN size)
{
  #define H_gtk_image_new_from_stock "GtkWidget* gtk_image_new_from_stock(gchar* stock_id, GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_image_new_from_stock", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 2, "gtk_image_new_from_stock", "GtkIconSize");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_stock(XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkIconSize(size))));
}
static XEN gxg_gtk_image_new_from_icon_set(XEN icon_set, XEN size)
{
  #define H_gtk_image_new_from_icon_set "GtkWidget* gtk_image_new_from_icon_set(GtkIconSet* icon_set, \
GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 1, "gtk_image_new_from_icon_set", "GtkIconSet*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 2, "gtk_image_new_from_icon_set", "GtkIconSize");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_icon_set(XEN_TO_C_GtkIconSet_(icon_set), XEN_TO_C_GtkIconSize(size))));
}
static XEN gxg_gtk_image_new_from_animation(XEN animation)
{
  #define H_gtk_image_new_from_animation "GtkWidget* gtk_image_new_from_animation(GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation), animation, 1, "gtk_image_new_from_animation", "GdkPixbufAnimation*");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_animation(XEN_TO_C_GdkPixbufAnimation_(animation))));
}
static XEN gxg_gtk_image_set_from_pixmap(XEN image, XEN pixmap, XEN mask)
{
  #define H_gtk_image_set_from_pixmap "void gtk_image_set_from_pixmap(GtkImage* image, GdkPixmap* pixmap, \
GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_pixmap", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_GdkPixmap__P(pixmap) || XEN_FALSE_P(pixmap), pixmap, 2, "gtk_image_set_from_pixmap", "GdkPixmap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask) || XEN_FALSE_P(mask), mask, 3, "gtk_image_set_from_pixmap", "GdkBitmap*");
  gtk_image_set_from_pixmap(XEN_TO_C_GtkImage_(image), XEN_TO_C_GdkPixmap_(pixmap), XEN_TO_C_GdkBitmap_(mask));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_image(XEN image, XEN gdk_image, XEN mask)
{
  #define H_gtk_image_set_from_image "void gtk_image_set_from_image(GtkImage* image, GdkImage* gdk_image, \
GdkBitmap* mask)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_image", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_GdkImage__P(gdk_image) || XEN_FALSE_P(gdk_image), gdk_image, 2, "gtk_image_set_from_image", "GdkImage*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(mask) || XEN_FALSE_P(mask), mask, 3, "gtk_image_set_from_image", "GdkBitmap*");
  gtk_image_set_from_image(XEN_TO_C_GtkImage_(image), XEN_TO_C_GdkImage_(gdk_image), XEN_TO_C_GdkBitmap_(mask));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_file(XEN image, XEN filename)
{
  #define H_gtk_image_set_from_file "void gtk_image_set_from_file(GtkImage* image, gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_file", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 2, "gtk_image_set_from_file", "gchar*");
  gtk_image_set_from_file(XEN_TO_C_GtkImage_(image), XEN_TO_C_gchar_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_pixbuf(XEN image, XEN pixbuf)
{
  #define H_gtk_image_set_from_pixbuf "void gtk_image_set_from_pixbuf(GtkImage* image, GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_pixbuf", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf) || XEN_FALSE_P(pixbuf), pixbuf, 2, "gtk_image_set_from_pixbuf", "GdkPixbuf*");
  gtk_image_set_from_pixbuf(XEN_TO_C_GtkImage_(image), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_stock(XEN image, XEN stock_id, XEN size)
{
  #define H_gtk_image_set_from_stock "void gtk_image_set_from_stock(GtkImage* image, gchar* stock_id, \
GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_stock", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_image_set_from_stock", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 3, "gtk_image_set_from_stock", "GtkIconSize");
  gtk_image_set_from_stock(XEN_TO_C_GtkImage_(image), XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkIconSize(size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_icon_set(XEN image, XEN icon_set, XEN size)
{
  #define H_gtk_image_set_from_icon_set "void gtk_image_set_from_icon_set(GtkImage* image, GtkIconSet* icon_set, \
GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_icon_set", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_GtkIconSet__P(icon_set), icon_set, 2, "gtk_image_set_from_icon_set", "GtkIconSet*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 3, "gtk_image_set_from_icon_set", "GtkIconSize");
  gtk_image_set_from_icon_set(XEN_TO_C_GtkImage_(image), XEN_TO_C_GtkIconSet_(icon_set), XEN_TO_C_GtkIconSize(size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_from_animation(XEN image, XEN animation)
{
  #define H_gtk_image_set_from_animation "void gtk_image_set_from_animation(GtkImage* image, GdkPixbufAnimation* animation)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_animation", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_GdkPixbufAnimation__P(animation) || XEN_FALSE_P(animation), animation, 2, "gtk_image_set_from_animation", "GdkPixbufAnimation*");
  gtk_image_set_from_animation(XEN_TO_C_GtkImage_(image), XEN_TO_C_GdkPixbufAnimation_(animation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_get_storage_type(XEN image)
{
  #define H_gtk_image_get_storage_type "GtkImageType gtk_image_get_storage_type(GtkImage* image)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_storage_type", "GtkImage*");
  return(C_TO_XEN_GtkImageType(gtk_image_get_storage_type(XEN_TO_C_GtkImage_(image))));
}
static XEN gxg_gtk_image_get_pixmap(XEN image, XEN pixmap, XEN mask)
{
  #define H_gtk_image_get_pixmap "void gtk_image_get_pixmap(GtkImage* image, GdkPixmap** [pixmap], GdkBitmap** [mask])"
  GdkPixmap* ref_pixmap = NULL;
  GdkBitmap* ref_mask = NULL;
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_pixmap", "GtkImage*");
  gtk_image_get_pixmap(XEN_TO_C_GtkImage_(image), &ref_pixmap, &ref_mask);
  return(XEN_LIST_2(C_TO_XEN_GdkPixmap_(ref_pixmap), C_TO_XEN_GdkBitmap_(ref_mask)));
}
static XEN gxg_gtk_image_get_image(XEN image, XEN gdk_image, XEN mask)
{
  #define H_gtk_image_get_image "void gtk_image_get_image(GtkImage* image, GdkImage** [gdk_image], GdkBitmap** [mask])"
  GdkImage* ref_gdk_image = NULL;
  GdkBitmap* ref_mask = NULL;
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_image", "GtkImage*");
  gtk_image_get_image(XEN_TO_C_GtkImage_(image), &ref_gdk_image, &ref_mask);
  return(XEN_LIST_2(C_TO_XEN_GdkImage_(ref_gdk_image), C_TO_XEN_GdkBitmap_(ref_mask)));
}
static XEN gxg_gtk_image_get_pixbuf(XEN image)
{
  #define H_gtk_image_get_pixbuf "GdkPixbuf* gtk_image_get_pixbuf(GtkImage* image)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_pixbuf", "GtkImage*");
  return(C_TO_XEN_GdkPixbuf_(gtk_image_get_pixbuf(XEN_TO_C_GtkImage_(image))));
}
static XEN gxg_gtk_image_get_stock(XEN image, XEN stock_id, XEN size)
{
  #define H_gtk_image_get_stock "void gtk_image_get_stock(GtkImage* image, gchar** [stock_id], GtkIconSize* [size])"
  gchar* ref_stock_id = NULL;
  GtkIconSize ref_size;
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_stock", "GtkImage*");
  gtk_image_get_stock(XEN_TO_C_GtkImage_(image), &ref_stock_id, &ref_size);
  return(XEN_LIST_2(C_TO_XEN_gchar_(ref_stock_id), C_TO_XEN_GtkIconSize(ref_size)));
}
static XEN gxg_gtk_image_get_icon_set(XEN image, XEN icon_set, XEN size)
{
  #define H_gtk_image_get_icon_set "void gtk_image_get_icon_set(GtkImage* image, GtkIconSet** [icon_set], \
GtkIconSize* [size])"
  GtkIconSet* ref_icon_set = NULL;
  GtkIconSize ref_size;
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_icon_set", "GtkImage*");
  gtk_image_get_icon_set(XEN_TO_C_GtkImage_(image), &ref_icon_set, &ref_size);
  return(XEN_LIST_2(C_TO_XEN_GtkIconSet_(ref_icon_set), C_TO_XEN_GtkIconSize(ref_size)));
}
static XEN gxg_gtk_image_get_animation(XEN image)
{
  #define H_gtk_image_get_animation "GdkPixbufAnimation* gtk_image_get_animation(GtkImage* image)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_animation", "GtkImage*");
  return(C_TO_XEN_GdkPixbufAnimation_(gtk_image_get_animation(XEN_TO_C_GtkImage_(image))));
}
static XEN gxg_gtk_image_menu_item_get_type(void)
{
  #define H_gtk_image_menu_item_get_type "GtkType gtk_image_menu_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_image_menu_item_get_type()));
}
static XEN gxg_gtk_image_menu_item_new(void)
{
  #define H_gtk_image_menu_item_new "GtkWidget* gtk_image_menu_item_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_image_menu_item_new()));
}
static XEN gxg_gtk_image_menu_item_new_with_label(XEN label)
{
  #define H_gtk_image_menu_item_new_with_label "GtkWidget* gtk_image_menu_item_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_image_menu_item_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_image_menu_item_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_image_menu_item_new_with_mnemonic(XEN label)
{
  #define H_gtk_image_menu_item_new_with_mnemonic "GtkWidget* gtk_image_menu_item_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_image_menu_item_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_image_menu_item_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_image_menu_item_new_from_stock(XEN stock_id, XEN accel_group)
{
  #define H_gtk_image_menu_item_new_from_stock "GtkWidget* gtk_image_menu_item_new_from_stock(gchar* stock_id, \
GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_image_menu_item_new_from_stock", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group) || XEN_FALSE_P(accel_group), accel_group, 2, "gtk_image_menu_item_new_from_stock", "GtkAccelGroup*");
  return(C_TO_XEN_GtkWidget_(gtk_image_menu_item_new_from_stock(XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkAccelGroup_(accel_group))));
}
static XEN gxg_gtk_image_menu_item_set_image(XEN image_menu_item, XEN image)
{
  #define H_gtk_image_menu_item_set_image "void gtk_image_menu_item_set_image(GtkImageMenuItem* image_menu_item, \
GtkWidget* image)"
  XEN_ASSERT_TYPE(XEN_GtkImageMenuItem__P(image_menu_item), image_menu_item, 1, "gtk_image_menu_item_set_image", "GtkImageMenuItem*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(image), image, 2, "gtk_image_menu_item_set_image", "GtkWidget*");
  gtk_image_menu_item_set_image(XEN_TO_C_GtkImageMenuItem_(image_menu_item), XEN_TO_C_GtkWidget_(image));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_menu_item_get_image(XEN image_menu_item)
{
  #define H_gtk_image_menu_item_get_image "GtkWidget* gtk_image_menu_item_get_image(GtkImageMenuItem* image_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkImageMenuItem__P(image_menu_item), image_menu_item, 1, "gtk_image_menu_item_get_image", "GtkImageMenuItem*");
  return(C_TO_XEN_GtkWidget_(gtk_image_menu_item_get_image(XEN_TO_C_GtkImageMenuItem_(image_menu_item))));
}
static XEN gxg_gtk_im_context_get_type(void)
{
  #define H_gtk_im_context_get_type "GtkType gtk_im_context_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_im_context_get_type()));
}
static XEN gxg_gtk_im_context_set_client_window(XEN context, XEN window)
{
  #define H_gtk_im_context_set_client_window "void gtk_im_context_set_client_window(GtkIMContext* context, \
GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_set_client_window", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window) || XEN_FALSE_P(window), window, 2, "gtk_im_context_set_client_window", "GdkWindow*");
  gtk_im_context_set_client_window(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_get_preedit_string(XEN context, XEN str, XEN attrs, XEN cursor_pos)
{
  #define H_gtk_im_context_get_preedit_string "void gtk_im_context_get_preedit_string(GtkIMContext* context, \
gchar** [str], PangoAttrList** [attrs], gint* [cursor_pos])"
  gchar* ref_str = NULL;
  PangoAttrList* ref_attrs = NULL;
  gint ref_cursor_pos;
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_get_preedit_string", "GtkIMContext*");
  gtk_im_context_get_preedit_string(XEN_TO_C_GtkIMContext_(context), &ref_str, &ref_attrs, &ref_cursor_pos);
  return(XEN_LIST_3(C_TO_XEN_gchar_(ref_str), C_TO_XEN_PangoAttrList_(ref_attrs), C_TO_XEN_gint(ref_cursor_pos)));
}
static XEN gxg_gtk_im_context_filter_keypress(XEN context, XEN event)
{
  #define H_gtk_im_context_filter_keypress "gboolean gtk_im_context_filter_keypress(GtkIMContext* context, \
GdkEventKey* event)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_filter_keypress", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(event), event, 2, "gtk_im_context_filter_keypress", "GdkEventKey*");
  return(C_TO_XEN_gboolean(gtk_im_context_filter_keypress(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_GdkEventKey_(event))));
}
static XEN gxg_gtk_im_context_focus_in(XEN context)
{
  #define H_gtk_im_context_focus_in "void gtk_im_context_focus_in(GtkIMContext* context)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_focus_in", "GtkIMContext*");
  gtk_im_context_focus_in(XEN_TO_C_GtkIMContext_(context));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_focus_out(XEN context)
{
  #define H_gtk_im_context_focus_out "void gtk_im_context_focus_out(GtkIMContext* context)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_focus_out", "GtkIMContext*");
  gtk_im_context_focus_out(XEN_TO_C_GtkIMContext_(context));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_reset(XEN context)
{
  #define H_gtk_im_context_reset "void gtk_im_context_reset(GtkIMContext* context)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_reset", "GtkIMContext*");
  gtk_im_context_reset(XEN_TO_C_GtkIMContext_(context));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_set_cursor_location(XEN context, XEN area)
{
  #define H_gtk_im_context_set_cursor_location "void gtk_im_context_set_cursor_location(GtkIMContext* context, \
GdkRectangle* area)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_set_cursor_location", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 2, "gtk_im_context_set_cursor_location", "GdkRectangle*");
  gtk_im_context_set_cursor_location(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_GdkRectangle_(area));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_set_use_preedit(XEN context, XEN use_preedit)
{
  #define H_gtk_im_context_set_use_preedit "void gtk_im_context_set_use_preedit(GtkIMContext* context, \
gboolean use_preedit)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_set_use_preedit", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_preedit), use_preedit, 2, "gtk_im_context_set_use_preedit", "gboolean");
  gtk_im_context_set_use_preedit(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_gboolean(use_preedit));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_set_surrounding(XEN context, XEN text, XEN len, XEN cursor_index)
{
  #define H_gtk_im_context_set_surrounding "void gtk_im_context_set_surrounding(GtkIMContext* context, \
gchar* text, gint len, gint cursor_index)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_set_surrounding", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_im_context_set_surrounding", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_im_context_set_surrounding", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(cursor_index), cursor_index, 4, "gtk_im_context_set_surrounding", "gint");
  gtk_im_context_set_surrounding(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_gchar_(text), XEN_TO_C_gint(len), XEN_TO_C_gint(cursor_index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_context_get_surrounding(XEN context, XEN text, XEN cursor_index)
{
  #define H_gtk_im_context_get_surrounding "gboolean gtk_im_context_get_surrounding(GtkIMContext* context, \
gchar** [text], gint* [cursor_index])"
  gchar* ref_text = NULL;
  gint ref_cursor_index;
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_get_surrounding", "GtkIMContext*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_im_context_get_surrounding(XEN_TO_C_GtkIMContext_(context), &ref_text, &ref_cursor_index));
    return(XEN_LIST_3(result, C_TO_XEN_gchar_(ref_text), C_TO_XEN_gint(ref_cursor_index)));
   }
}
static XEN gxg_gtk_im_context_delete_surrounding(XEN context, XEN offset, XEN n_chars)
{
  #define H_gtk_im_context_delete_surrounding "gboolean gtk_im_context_delete_surrounding(GtkIMContext* context, \
gint offset, gint n_chars)"
  XEN_ASSERT_TYPE(XEN_GtkIMContext__P(context), context, 1, "gtk_im_context_delete_surrounding", "GtkIMContext*");
  XEN_ASSERT_TYPE(XEN_gint_P(offset), offset, 2, "gtk_im_context_delete_surrounding", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(n_chars), n_chars, 3, "gtk_im_context_delete_surrounding", "gint");
  return(C_TO_XEN_gboolean(gtk_im_context_delete_surrounding(XEN_TO_C_GtkIMContext_(context), XEN_TO_C_gint(offset), XEN_TO_C_gint(n_chars))));
}
static XEN gxg_gtk_im_context_simple_get_type(void)
{
  #define H_gtk_im_context_simple_get_type "GtkType gtk_im_context_simple_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_im_context_simple_get_type()));
}
static XEN gxg_gtk_im_context_simple_new(void)
{
  #define H_gtk_im_context_simple_new "GtkIMContext* gtk_im_context_simple_new( void)"
  return(C_TO_XEN_GtkIMContext_(gtk_im_context_simple_new()));
}
static XEN gxg_gtk_im_context_simple_add_table(XEN context_simple, XEN data, XEN max_seq_len, XEN n_seqs)
{
  #define H_gtk_im_context_simple_add_table "void gtk_im_context_simple_add_table(GtkIMContextSimple* context_simple, \
guint16* data, gint max_seq_len, gint n_seqs)"
  XEN_ASSERT_TYPE(XEN_GtkIMContextSimple__P(context_simple), context_simple, 1, "gtk_im_context_simple_add_table", "GtkIMContextSimple*");
  XEN_ASSERT_TYPE(XEN_guint16__P(data), data, 2, "gtk_im_context_simple_add_table", "guint16*");
  XEN_ASSERT_TYPE(XEN_gint_P(max_seq_len), max_seq_len, 3, "gtk_im_context_simple_add_table", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(n_seqs), n_seqs, 4, "gtk_im_context_simple_add_table", "gint");
  gtk_im_context_simple_add_table(XEN_TO_C_GtkIMContextSimple_(context_simple), XEN_TO_C_guint16_(data), XEN_TO_C_gint(max_seq_len), 
                                  XEN_TO_C_gint(n_seqs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_im_multicontext_get_type(void)
{
  #define H_gtk_im_multicontext_get_type "GtkType gtk_im_multicontext_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_im_multicontext_get_type()));
}
static XEN gxg_gtk_im_multicontext_new(void)
{
  #define H_gtk_im_multicontext_new "GtkIMContext* gtk_im_multicontext_new( void)"
  return(C_TO_XEN_GtkIMContext_(gtk_im_multicontext_new()));
}
static XEN gxg_gtk_im_multicontext_append_menuitems(XEN context, XEN menushell)
{
  #define H_gtk_im_multicontext_append_menuitems "void gtk_im_multicontext_append_menuitems(GtkIMMulticontext* context, \
GtkMenuShell* menushell)"
  XEN_ASSERT_TYPE(XEN_GtkIMMulticontext__P(context), context, 1, "gtk_im_multicontext_append_menuitems", "GtkIMMulticontext*");
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menushell), menushell, 2, "gtk_im_multicontext_append_menuitems", "GtkMenuShell*");
  gtk_im_multicontext_append_menuitems(XEN_TO_C_GtkIMMulticontext_(context), XEN_TO_C_GtkMenuShell_(menushell));
  return(XEN_FALSE);
}
static XEN gxg_gtk_input_dialog_get_type(void)
{
  #define H_gtk_input_dialog_get_type "GtkType gtk_input_dialog_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_input_dialog_get_type()));
}
static XEN gxg_gtk_input_dialog_new(void)
{
  #define H_gtk_input_dialog_new "GtkWidget* gtk_input_dialog_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_input_dialog_new()));
}
static XEN gxg_gtk_invisible_get_type(void)
{
  #define H_gtk_invisible_get_type "GtkType gtk_invisible_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_invisible_get_type()));
}
static XEN gxg_gtk_invisible_new(void)
{
  #define H_gtk_invisible_new "GtkWidget* gtk_invisible_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_invisible_new()));
}
static XEN gxg_gtk_item_get_type(void)
{
  #define H_gtk_item_get_type "GtkType gtk_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_item_get_type()));
}
static XEN gxg_gtk_item_select(XEN item)
{
  #define H_gtk_item_select "void gtk_item_select(GtkItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkItem__P(item), item, 1, "gtk_item_select", "GtkItem*");
  gtk_item_select(XEN_TO_C_GtkItem_(item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_item_deselect(XEN item)
{
  #define H_gtk_item_deselect "void gtk_item_deselect(GtkItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkItem__P(item), item, 1, "gtk_item_deselect", "GtkItem*");
  gtk_item_deselect(XEN_TO_C_GtkItem_(item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_item_toggle(XEN item)
{
  #define H_gtk_item_toggle "void gtk_item_toggle(GtkItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkItem__P(item), item, 1, "gtk_item_toggle", "GtkItem*");
  gtk_item_toggle(XEN_TO_C_GtkItem_(item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_type(void)
{
  #define H_gtk_label_get_type "GtkType gtk_label_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_label_get_type()));
}
static XEN gxg_gtk_label_new(XEN str)
{
  #define H_gtk_label_new "GtkWidget* gtk_label_new(char* str)"
  XEN_ASSERT_TYPE(XEN_char__P(str), str, 1, "gtk_label_new", "char*");
  return(C_TO_XEN_GtkWidget_(gtk_label_new(XEN_TO_C_char_(str))));
}
static XEN gxg_gtk_label_new_with_mnemonic(XEN str)
{
  #define H_gtk_label_new_with_mnemonic "GtkWidget* gtk_label_new_with_mnemonic(char* str)"
  XEN_ASSERT_TYPE(XEN_char__P(str), str, 1, "gtk_label_new_with_mnemonic", "char*");
  return(C_TO_XEN_GtkWidget_(gtk_label_new_with_mnemonic(XEN_TO_C_char_(str))));
}
static XEN gxg_gtk_label_set_text(XEN label, XEN str)
{
  #define H_gtk_label_set_text "void gtk_label_set_text(GtkLabel* label, char* str)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_text", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_char__P(str), str, 2, "gtk_label_set_text", "char*");
  gtk_label_set_text(XEN_TO_C_GtkLabel_(label), XEN_TO_C_char_(str));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_text(XEN label)
{
  #define H_gtk_label_get_text "gchar* gtk_label_get_text(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_text", "GtkLabel*");
  return(C_TO_XEN_gchar_(gtk_label_get_text(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_attributes(XEN label, XEN attrs)
{
  #define H_gtk_label_set_attributes "void gtk_label_set_attributes(GtkLabel* label, PangoAttrList* attrs)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_attributes", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(attrs), attrs, 2, "gtk_label_set_attributes", "PangoAttrList*");
  gtk_label_set_attributes(XEN_TO_C_GtkLabel_(label), XEN_TO_C_PangoAttrList_(attrs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_attributes(XEN label)
{
  #define H_gtk_label_get_attributes "PangoAttrList* gtk_label_get_attributes(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_attributes", "GtkLabel*");
  return(C_TO_XEN_PangoAttrList_(gtk_label_get_attributes(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_label(XEN label, XEN str)
{
  #define H_gtk_label_set_label "void gtk_label_set_label(GtkLabel* label, gchar* str)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_label", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_label_set_label", "gchar*");
  gtk_label_set_label(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gchar_(str));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_label(XEN label)
{
  #define H_gtk_label_get_label "gchar* gtk_label_get_label(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_label", "GtkLabel*");
  return(C_TO_XEN_gchar_(gtk_label_get_label(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_markup(XEN label, XEN str)
{
  #define H_gtk_label_set_markup "void gtk_label_set_markup(GtkLabel* label, gchar* str)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_markup", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_label_set_markup", "gchar*");
  gtk_label_set_markup(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gchar_(str));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_set_use_markup(XEN label, XEN setting)
{
  #define H_gtk_label_set_use_markup "void gtk_label_set_use_markup(GtkLabel* label, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_use_markup", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_label_set_use_markup", "gboolean");
  gtk_label_set_use_markup(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_use_markup(XEN label)
{
  #define H_gtk_label_get_use_markup "gboolean gtk_label_get_use_markup(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_use_markup", "GtkLabel*");
  return(C_TO_XEN_gboolean(gtk_label_get_use_markup(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_use_underline(XEN label, XEN setting)
{
  #define H_gtk_label_set_use_underline "void gtk_label_set_use_underline(GtkLabel* label, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_use_underline", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_label_set_use_underline", "gboolean");
  gtk_label_set_use_underline(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_use_underline(XEN label)
{
  #define H_gtk_label_get_use_underline "gboolean gtk_label_get_use_underline(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_use_underline", "GtkLabel*");
  return(C_TO_XEN_gboolean(gtk_label_get_use_underline(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_markup_with_mnemonic(XEN label, XEN str)
{
  #define H_gtk_label_set_markup_with_mnemonic "void gtk_label_set_markup_with_mnemonic(GtkLabel* label, \
gchar* str)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_markup_with_mnemonic", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_label_set_markup_with_mnemonic", "gchar*");
  gtk_label_set_markup_with_mnemonic(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gchar_(str));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_mnemonic_keyval(XEN label)
{
  #define H_gtk_label_get_mnemonic_keyval "guint gtk_label_get_mnemonic_keyval(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_mnemonic_keyval", "GtkLabel*");
  return(C_TO_XEN_guint(gtk_label_get_mnemonic_keyval(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_mnemonic_widget(XEN label, XEN widget)
{
  #define H_gtk_label_set_mnemonic_widget "void gtk_label_set_mnemonic_widget(GtkLabel* label, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_mnemonic_widget", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_label_set_mnemonic_widget", "GtkWidget*");
  gtk_label_set_mnemonic_widget(XEN_TO_C_GtkLabel_(label), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_mnemonic_widget(XEN label)
{
  #define H_gtk_label_get_mnemonic_widget "GtkWidget* gtk_label_get_mnemonic_widget(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_mnemonic_widget", "GtkLabel*");
  return(C_TO_XEN_GtkWidget_(gtk_label_get_mnemonic_widget(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_text_with_mnemonic(XEN label, XEN str)
{
  #define H_gtk_label_set_text_with_mnemonic "void gtk_label_set_text_with_mnemonic(GtkLabel* label, \
gchar* str)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_text_with_mnemonic", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_label_set_text_with_mnemonic", "gchar*");
  gtk_label_set_text_with_mnemonic(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gchar_(str));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_set_justify(XEN label, XEN jtype)
{
  #define H_gtk_label_set_justify "void gtk_label_set_justify(GtkLabel* label, GtkJustification jtype)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_justify", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_GtkJustification_P(jtype), jtype, 2, "gtk_label_set_justify", "GtkJustification");
  gtk_label_set_justify(XEN_TO_C_GtkLabel_(label), XEN_TO_C_GtkJustification(jtype));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_justify(XEN label)
{
  #define H_gtk_label_get_justify "GtkJustification gtk_label_get_justify(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_justify", "GtkLabel*");
  return(C_TO_XEN_GtkJustification(gtk_label_get_justify(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_pattern(XEN label, XEN pattern)
{
  #define H_gtk_label_set_pattern "void gtk_label_set_pattern(GtkLabel* label, gchar* pattern)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_pattern", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gchar__P(pattern), pattern, 2, "gtk_label_set_pattern", "gchar*");
  gtk_label_set_pattern(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gchar_(pattern));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_set_line_wrap(XEN label, XEN wrap)
{
  #define H_gtk_label_set_line_wrap "void gtk_label_set_line_wrap(GtkLabel* label, gboolean wrap)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_line_wrap", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(wrap), wrap, 2, "gtk_label_set_line_wrap", "gboolean");
  gtk_label_set_line_wrap(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gboolean(wrap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_line_wrap(XEN label)
{
  #define H_gtk_label_get_line_wrap "gboolean gtk_label_get_line_wrap(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_line_wrap", "GtkLabel*");
  return(C_TO_XEN_gboolean(gtk_label_get_line_wrap(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_set_selectable(XEN label, XEN setting)
{
  #define H_gtk_label_set_selectable "void gtk_label_set_selectable(GtkLabel* label, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_selectable", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_label_set_selectable", "gboolean");
  gtk_label_set_selectable(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_selectable(XEN label)
{
  #define H_gtk_label_get_selectable "gboolean gtk_label_get_selectable(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_selectable", "GtkLabel*");
  return(C_TO_XEN_gboolean(gtk_label_get_selectable(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_select_region(XEN label, XEN start_offset, XEN end_offset)
{
  #define H_gtk_label_select_region "void gtk_label_select_region(GtkLabel* label, gint start_offset, \
gint end_offset)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_select_region", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gint_P(start_offset), start_offset, 2, "gtk_label_select_region", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(end_offset), end_offset, 3, "gtk_label_select_region", "gint");
  gtk_label_select_region(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gint(start_offset), XEN_TO_C_gint(end_offset));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_selection_bounds(XEN label, XEN start, XEN end)
{
  #define H_gtk_label_get_selection_bounds "gboolean gtk_label_get_selection_bounds(GtkLabel* label, \
gint* [start], gint* [end])"
  gint ref_start;
  gint ref_end;
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_selection_bounds", "GtkLabel*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_label_get_selection_bounds(XEN_TO_C_GtkLabel_(label), &ref_start, &ref_end));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_start), C_TO_XEN_gint(ref_end)));
   }
}
static XEN gxg_gtk_label_get_layout(XEN label)
{
  #define H_gtk_label_get_layout "PangoLayout* gtk_label_get_layout(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_layout", "GtkLabel*");
  return(C_TO_XEN_PangoLayout_(gtk_label_get_layout(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_label_get_layout_offsets(XEN label, XEN x, XEN y)
{
  #define H_gtk_label_get_layout_offsets "void gtk_label_get_layout_offsets(GtkLabel* label, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_layout_offsets", "GtkLabel*");
  gtk_label_get_layout_offsets(XEN_TO_C_GtkLabel_(label), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gtk_layout_get_type(void)
{
  #define H_gtk_layout_get_type "GtkType gtk_layout_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_layout_get_type()));
}
static XEN gxg_gtk_layout_new(XEN hadjustment, XEN vadjustment)
{
  #define H_gtk_layout_new "GtkWidget* gtk_layout_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 1, "gtk_layout_new", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(vadjustment) || XEN_FALSE_P(vadjustment), vadjustment, 2, "gtk_layout_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_layout_new(XEN_TO_C_GtkAdjustment_(hadjustment), XEN_TO_C_GtkAdjustment_(vadjustment))));
}
static XEN gxg_gtk_layout_put(XEN layout, XEN child_widget, XEN x, XEN y)
{
  #define H_gtk_layout_put "void gtk_layout_put(GtkLayout* layout, GtkWidget* child_widget, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_put", "GtkLayout*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child_widget), child_widget, 2, "gtk_layout_put", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gtk_layout_put", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gtk_layout_put", "gint");
  gtk_layout_put(XEN_TO_C_GtkLayout_(layout), XEN_TO_C_GtkWidget_(child_widget), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_layout_move(XEN layout, XEN child_widget, XEN x, XEN y)
{
  #define H_gtk_layout_move "void gtk_layout_move(GtkLayout* layout, GtkWidget* child_widget, gint x, \
gint y)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_move", "GtkLayout*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child_widget), child_widget, 2, "gtk_layout_move", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gtk_layout_move", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gtk_layout_move", "gint");
  gtk_layout_move(XEN_TO_C_GtkLayout_(layout), XEN_TO_C_GtkWidget_(child_widget), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_layout_set_size(XEN layout, XEN width, XEN height)
{
  #define H_gtk_layout_set_size "void gtk_layout_set_size(GtkLayout* layout, guint width, guint height)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_set_size", "GtkLayout*");
  XEN_ASSERT_TYPE(XEN_guint_P(width), width, 2, "gtk_layout_set_size", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(height), height, 3, "gtk_layout_set_size", "guint");
  gtk_layout_set_size(XEN_TO_C_GtkLayout_(layout), XEN_TO_C_guint(width), XEN_TO_C_guint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_layout_get_size(XEN layout, XEN width, XEN height)
{
  #define H_gtk_layout_get_size "void gtk_layout_get_size(GtkLayout* layout, guint* [width], guint* [height])"
  guint ref_width;
  guint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_get_size", "GtkLayout*");
  gtk_layout_get_size(XEN_TO_C_GtkLayout_(layout), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_guint(ref_width), C_TO_XEN_guint(ref_height)));
}
static XEN gxg_gtk_layout_get_hadjustment(XEN layout)
{
  #define H_gtk_layout_get_hadjustment "GtkAdjustment* gtk_layout_get_hadjustment(GtkLayout* layout)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_get_hadjustment", "GtkLayout*");
  return(C_TO_XEN_GtkAdjustment_(gtk_layout_get_hadjustment(XEN_TO_C_GtkLayout_(layout))));
}
static XEN gxg_gtk_layout_get_vadjustment(XEN layout)
{
  #define H_gtk_layout_get_vadjustment "GtkAdjustment* gtk_layout_get_vadjustment(GtkLayout* layout)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_get_vadjustment", "GtkLayout*");
  return(C_TO_XEN_GtkAdjustment_(gtk_layout_get_vadjustment(XEN_TO_C_GtkLayout_(layout))));
}
static XEN gxg_gtk_layout_set_hadjustment(XEN layout, XEN adjustment)
{
  #define H_gtk_layout_set_hadjustment "void gtk_layout_set_hadjustment(GtkLayout* layout, GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_set_hadjustment", "GtkLayout*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_layout_set_hadjustment", "GtkAdjustment*");
  gtk_layout_set_hadjustment(XEN_TO_C_GtkLayout_(layout), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_layout_set_vadjustment(XEN layout, XEN adjustment)
{
  #define H_gtk_layout_set_vadjustment "void gtk_layout_set_vadjustment(GtkLayout* layout, GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkLayout__P(layout), layout, 1, "gtk_layout_set_vadjustment", "GtkLayout*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_layout_set_vadjustment", "GtkAdjustment*");
  gtk_layout_set_vadjustment(XEN_TO_C_GtkLayout_(layout), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_get_type(void)
{
  #define H_gtk_list_store_get_type "GtkType gtk_list_store_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_list_store_get_type()));
}
static XEN gxg_gtk_list_store_new(XEN n_columns, XEN types)
{
  #define H_gtk_list_store_new "GtkListStore* gtk_list_store_new(gint n_columns, etc types)"
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 1, "gtk_list_store_new", "gint");
  XEN_ASSERT_TYPE(XEN_etc_P(types), types, 2, "gtk_list_store_new", "etc");
  {
    int etc_len = 0;
    GtkListStore* result = NULL;
    gint p_arg0;
    if (XEN_LIST_P(types)) etc_len = XEN_LIST_LENGTH(types);
    if (etc_len < 1) XEN_OUT_OF_RANGE_ERROR("gtk_list_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) XEN_OUT_OF_RANGE_ERROR("gtk_list_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = XEN_TO_C_gint(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_list_store_new(p_arg0, XLG(types, 0)); break;
        case 2: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1)); break;
        case 3: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2)); break;
        case 4: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3)); break;
        case 5: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4)); break;
        case 6: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4), XLG(types, 5)); break;
      }
    return(C_TO_XEN_GtkListStore_(result));
  }
}
static XEN gxg_gtk_list_store_newv(XEN n_columns, XEN types)
{
  #define H_gtk_list_store_newv "GtkListStore* gtk_list_store_newv(gint n_columns, GType* types)"
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 1, "gtk_list_store_newv", "gint");
  XEN_ASSERT_TYPE(XEN_GType__P(types), types, 2, "gtk_list_store_newv", "GType*");
  return(C_TO_XEN_GtkListStore_(gtk_list_store_newv(XEN_TO_C_gint(n_columns), XEN_TO_C_GType_(types))));
}
static XEN gxg_gtk_list_store_set_column_types(XEN list_store, XEN n_columns, XEN types)
{
  #define H_gtk_list_store_set_column_types "void gtk_list_store_set_column_types(GtkListStore* list_store, \
gint n_columns, GType* types)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_set_column_types", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 2, "gtk_list_store_set_column_types", "gint");
  XEN_ASSERT_TYPE(XEN_GType__P(types), types, 3, "gtk_list_store_set_column_types", "GType*");
  gtk_list_store_set_column_types(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_gint(n_columns), XEN_TO_C_GType_(types));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_set(XEN list_store, XEN iter, XEN values)
{
  #define H_gtk_list_store_set "void gtk_list_store_set(GtkListStore* list_store, GtkTreeIter* iter, \
etc values)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_set", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_set", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_etc_P(values), values, 3, "gtk_list_store_set", "etc");
  {
    int etc_len = 0;
    GtkListStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (XEN_LIST_P(values)) etc_len = XEN_LIST_LENGTH(values);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_list_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_list_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_list_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkListStore_(list_store);
    p_arg1 = XEN_TO_C_GtkTreeIter_(iter);
    switch (etc_len)
      {
        case 2: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), -1); break;
        case 4: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), -1); break;
        case 6: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), -1); break;
        case 8: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), -1); break;
        case 10: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), XLI(values, 8), XLS(values, 9), -1); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_list_store_insert(XEN list_store, XEN iter, XEN position)
{
  #define H_gtk_list_store_insert "void gtk_list_store_insert(GtkListStore* list_store, GtkTreeIter* iter, \
gint position)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_insert", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_insert", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_list_store_insert", "gint");
  gtk_list_store_insert(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_insert_before(XEN list_store, XEN iter, XEN sibling)
{
  #define H_gtk_list_store_insert_before "void gtk_list_store_insert_before(GtkListStore* list_store, \
GtkTreeIter* iter, GtkTreeIter* sibling)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_insert_before", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_insert_before", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sibling) || XEN_FALSE_P(sibling), sibling, 3, "gtk_list_store_insert_before", "GtkTreeIter*");
  gtk_list_store_insert_before(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(sibling));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_insert_after(XEN list_store, XEN iter, XEN sibling)
{
  #define H_gtk_list_store_insert_after "void gtk_list_store_insert_after(GtkListStore* list_store, GtkTreeIter* iter, \
GtkTreeIter* sibling)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_insert_after", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_insert_after", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sibling) || XEN_FALSE_P(sibling), sibling, 3, "gtk_list_store_insert_after", "GtkTreeIter*");
  gtk_list_store_insert_after(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(sibling));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_prepend(XEN list_store, XEN iter)
{
  #define H_gtk_list_store_prepend "void gtk_list_store_prepend(GtkListStore* list_store, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_prepend", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_prepend", "GtkTreeIter*");
  gtk_list_store_prepend(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_append(XEN list_store, XEN iter)
{
  #define H_gtk_list_store_append "void gtk_list_store_append(GtkListStore* list_store, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_append", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_append", "GtkTreeIter*");
  gtk_list_store_append(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_clear(XEN list_store)
{
  #define H_gtk_list_store_clear "void gtk_list_store_clear(GtkListStore* list_store)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_clear", "GtkListStore*");
  gtk_list_store_clear(XEN_TO_C_GtkListStore_(list_store));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_version(XEN required_major, XEN required_minor, XEN required_micro)
{
  #define H_gtk_check_version "gchar* gtk_check_version(guint required_major, guint required_minor, guint required_micro)"
  XEN_ASSERT_TYPE(XEN_guint_P(required_major), required_major, 1, "gtk_check_version", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(required_minor), required_minor, 2, "gtk_check_version", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(required_micro), required_micro, 3, "gtk_check_version", "guint");
  return(C_TO_XEN_gchar_(gtk_check_version(XEN_TO_C_guint(required_major), XEN_TO_C_guint(required_minor), XEN_TO_C_guint(required_micro))));
}
static XEN gxg_gtk_init(XEN argc, XEN argv)
{
  #define H_gtk_init "void gtk_init(int* {argc}, char*** |argv|)"
  int ref_argc;
  char** ref_argv = NULL;
  ref_argc = XEN_TO_C_int(argc);
  ref_argv = (char**)calloc(ref_argc, sizeof(char*));
  {
   int i;
   XEN lst;
   lst = XEN_COPY_ARG(argv);
   for (i = 0; i < ref_argc; i++, lst = XEN_CDR(lst)) ref_argv[i] = XEN_TO_C_char_(XEN_CAR(lst));
  }
  gtk_init(&ref_argc, &ref_argv);
  return(XEN_LIST_2(C_TO_XEN_int(ref_argc), C_TO_XEN_char__(ref_argv)));
}
static XEN gxg_gtk_init_check(XEN argc, XEN argv)
{
  #define H_gtk_init_check "gboolean gtk_init_check(int* {argc}, char*** |argv|)"
  int ref_argc;
  char** ref_argv = NULL;
  ref_argc = XEN_TO_C_int(argc);
  ref_argv = (char**)calloc(ref_argc, sizeof(char*));
  {
   int i;
   XEN lst;
   lst = XEN_COPY_ARG(argv);
   for (i = 0; i < ref_argc; i++, lst = XEN_CDR(lst)) ref_argv[i] = XEN_TO_C_char_(XEN_CAR(lst));
  }
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_init_check(&ref_argc, &ref_argv));
    return(XEN_LIST_3(result, C_TO_XEN_int(ref_argc), C_TO_XEN_char__(ref_argv)));
   }
}
static XEN gxg_gtk_disable_setlocale(void)
{
  #define H_gtk_disable_setlocale "void gtk_disable_setlocale( void)"
  gtk_disable_setlocale();
  return(XEN_FALSE);
}
static XEN gxg_gtk_set_locale(void)
{
  #define H_gtk_set_locale "gchar* gtk_set_locale( void)"
  return(C_TO_XEN_gchar_(gtk_set_locale()));
}
static XEN gxg_gtk_get_default_language(void)
{
  #define H_gtk_get_default_language "PangoLanguage* gtk_get_default_language( void)"
  return(C_TO_XEN_PangoLanguage_(gtk_get_default_language()));
}
static XEN gxg_gtk_events_pending(void)
{
  #define H_gtk_events_pending "gint gtk_events_pending( void)"
  return(C_TO_XEN_gint(gtk_events_pending()));
}
static XEN gxg_gtk_main_do_event(XEN event)
{
  #define H_gtk_main_do_event "void gtk_main_do_event(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 1, "gtk_main_do_event", "GdkEvent*");
  gtk_main_do_event(XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gtk_main(void)
{
  #define H_gtk_main "void gtk_main( void)"
  gtk_main();
  return(XEN_FALSE);
}
static XEN gxg_gtk_main_level(void)
{
  #define H_gtk_main_level "guint gtk_main_level( void)"
  return(C_TO_XEN_guint(gtk_main_level()));
}
static XEN gxg_gtk_main_quit(void)
{
  #define H_gtk_main_quit "void gtk_main_quit( void)"
  gtk_main_quit();
  return(XEN_FALSE);
}
static XEN gxg_gtk_main_iteration(void)
{
  #define H_gtk_main_iteration "gboolean gtk_main_iteration( void)"
  return(C_TO_XEN_gboolean(gtk_main_iteration()));
}
static XEN gxg_gtk_main_iteration_do(XEN blocking)
{
  #define H_gtk_main_iteration_do "gboolean gtk_main_iteration_do(gboolean blocking)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(blocking), blocking, 1, "gtk_main_iteration_do", "gboolean");
  return(C_TO_XEN_gboolean(gtk_main_iteration_do(XEN_TO_C_gboolean(blocking))));
}
static XEN gxg_gtk_true(void)
{
  #define H_gtk_true "gboolean gtk_true( void)"
  return(C_TO_XEN_gboolean(gtk_true()));
}
static XEN gxg_gtk_false(void)
{
  #define H_gtk_false "gboolean gtk_false( void)"
  return(C_TO_XEN_gboolean(gtk_false()));
}
static XEN gxg_gtk_grab_add(XEN widget)
{
  #define H_gtk_grab_add "void gtk_grab_add(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_grab_add", "GtkWidget*");
  gtk_grab_add(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_grab_get_current(void)
{
  #define H_gtk_grab_get_current "GtkWidget* gtk_grab_get_current( void)"
  return(C_TO_XEN_GtkWidget_(gtk_grab_get_current()));
}
static XEN gxg_gtk_grab_remove(XEN widget)
{
  #define H_gtk_grab_remove "void gtk_grab_remove(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_grab_remove", "GtkWidget*");
  gtk_grab_remove(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_init_add(XEN func, XEN func_data)
{
  #define H_gtk_init_add "void gtk_init_add(GtkFunction func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkFunction_P(func), func, 1, "gtk_init_add", "GtkFunction");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 2, "gtk_init_add", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_init_add(XEN_TO_C_GtkFunction(func), XEN_TO_C_lambda_data(func_data));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), XEN_FALSE, C_TO_XEN_INT(loc)));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_quit_add_destroy(XEN main_level, XEN object)
{
  #define H_gtk_quit_add_destroy "void gtk_quit_add_destroy(guint main_level, GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_guint_P(main_level), main_level, 1, "gtk_quit_add_destroy", "guint");
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 2, "gtk_quit_add_destroy", "GtkObject*");
  gtk_quit_add_destroy(XEN_TO_C_guint(main_level), XEN_TO_C_GtkObject_(object));
  return(XEN_FALSE);
}
static XEN gxg_gtk_quit_add(XEN main_level, XEN func, XEN func_data)
{
  #define H_gtk_quit_add "guint gtk_quit_add(guint main_level, GtkFunction func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_guint_P(main_level), main_level, 1, "gtk_quit_add", "guint");
  XEN_ASSERT_TYPE(XEN_GtkFunction_P(func), func, 2, "gtk_quit_add", "GtkFunction");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_quit_add", "lambda_data");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_guint(gtk_quit_add(XEN_TO_C_guint(main_level), XEN_TO_C_GtkFunction(func), XEN_TO_C_lambda_data(func_data)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_gtk_quit_remove(XEN quit_handler_id)
{
  #define H_gtk_quit_remove "void gtk_quit_remove(guint quit_handler_id)"
  XEN_ASSERT_TYPE(XEN_guint_P(quit_handler_id), quit_handler_id, 1, "gtk_quit_remove", "guint");
  gtk_quit_remove(XEN_TO_C_guint(quit_handler_id));
  xm_unprotect_at(XEN_TO_C_INT(XEN_CADDR(quit_handler_id)));
  return(XEN_FALSE);
}
static XEN gxg_gtk_quit_remove_by_data(XEN data)
{
  #define H_gtk_quit_remove_by_data "void gtk_quit_remove_by_data(xen data)"
  XEN_ASSERT_TYPE(XEN_xen_P(data), data, 1, "gtk_quit_remove_by_data", "xen");
  gtk_quit_remove_by_data(XEN_TO_C_xen(data));
  xm_unprotect_at(XEN_TO_C_INT(XEN_CADDR(data)));
  return(XEN_FALSE);
}
static XEN gxg_gtk_key_snooper_install(XEN func, XEN func_data)
{
  #define H_gtk_key_snooper_install "guint gtk_key_snooper_install(GtkKeySnoopFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkKeySnoopFunc_P(func), func, 1, "gtk_key_snooper_install", "GtkKeySnoopFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 2, "gtk_key_snooper_install", "lambda_data");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_guint(gtk_key_snooper_install(XEN_TO_C_GtkKeySnoopFunc(func), XEN_TO_C_lambda_data(func_data)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_gtk_key_snooper_remove(XEN snooper_handler_id)
{
  #define H_gtk_key_snooper_remove "void gtk_key_snooper_remove(guint snooper_handler_id)"
  XEN_ASSERT_TYPE(XEN_guint_P(snooper_handler_id), snooper_handler_id, 1, "gtk_key_snooper_remove", "guint");
  gtk_key_snooper_remove(XEN_TO_C_guint(snooper_handler_id));
  xm_unprotect_at(XEN_TO_C_INT(XEN_CADDR(snooper_handler_id)));
  return(XEN_FALSE);
}
static XEN gxg_gtk_get_current_event(void)
{
  #define H_gtk_get_current_event "GdkEvent* gtk_get_current_event( void)"
  return(C_TO_XEN_GdkEvent_(gtk_get_current_event()));
}
static XEN gxg_gtk_get_current_event_time(void)
{
  #define H_gtk_get_current_event_time "guint32 gtk_get_current_event_time( void)"
  return(C_TO_XEN_guint32(gtk_get_current_event_time()));
}
static XEN gxg_gtk_get_current_event_state(XEN state)
{
  #define H_gtk_get_current_event_state "gboolean gtk_get_current_event_state(GdkModifierType* [state])"
  GdkModifierType ref_state;
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_get_current_event_state(&ref_state));
    return(XEN_LIST_2(result, C_TO_XEN_GdkModifierType(ref_state)));
   }
}
static XEN gxg_gtk_get_event_widget(XEN event)
{
  #define H_gtk_get_event_widget "GtkWidget* gtk_get_event_widget(GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event) || XEN_FALSE_P(event), event, 1, "gtk_get_event_widget", "GdkEvent*");
  return(C_TO_XEN_GtkWidget_(gtk_get_event_widget(XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gtk_propagate_event(XEN widget, XEN event)
{
  #define H_gtk_propagate_event "void gtk_propagate_event(GtkWidget* widget, GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_propagate_event", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gtk_propagate_event", "GdkEvent*");
  gtk_propagate_event(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_bar_get_type(void)
{
  #define H_gtk_menu_bar_get_type "GtkType gtk_menu_bar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_menu_bar_get_type()));
}
static XEN gxg_gtk_menu_bar_new(void)
{
  #define H_gtk_menu_bar_new "GtkWidget* gtk_menu_bar_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_menu_bar_new()));
}
static XEN gxg_gtk_menu_get_type(void)
{
  #define H_gtk_menu_get_type "GtkType gtk_menu_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_menu_get_type()));
}
static XEN gxg_gtk_menu_new(void)
{
  #define H_gtk_menu_new "GtkWidget* gtk_menu_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_menu_new()));
}
static XEN gxg_gtk_menu_popup(XEN menu, XEN parent_menu_shell, XEN parent_menu_item, XEN func, XEN func_data, XEN button, XEN activate_time)
{
  #define H_gtk_menu_popup "void gtk_menu_popup(GtkMenu* menu, GtkWidget* parent_menu_shell, GtkWidget* parent_menu_item, \
GtkMenuPositionFunc func, lambda_data func_data, guint button, guint32 activate_time)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_popup", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(parent_menu_shell) || XEN_FALSE_P(parent_menu_shell), parent_menu_shell, 2, "gtk_menu_popup", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(parent_menu_item) || XEN_FALSE_P(parent_menu_item), parent_menu_item, 3, "gtk_menu_popup", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkMenuPositionFunc_P(func), func, 4, "gtk_menu_popup", "GtkMenuPositionFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 5, "gtk_menu_popup", "lambda_data");
  XEN_ASSERT_TYPE(XEN_guint_P(button), button, 6, "gtk_menu_popup", "guint");
  XEN_ASSERT_TYPE(XEN_guint32_P(activate_time), activate_time, 7, "gtk_menu_popup", "guint32");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gtk_menu_popup(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_GtkWidget_(parent_menu_shell), XEN_TO_C_GtkWidget_(parent_menu_item), XEN_TO_C_GtkMenuPositionFunc(func), 
               XEN_TO_C_lambda_data(func_data), XEN_TO_C_guint(button), XEN_TO_C_guint32(activate_time));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_menu_reposition(XEN menu)
{
  #define H_gtk_menu_reposition "void gtk_menu_reposition(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_reposition", "GtkMenu*");
  gtk_menu_reposition(XEN_TO_C_GtkMenu_(menu));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_popdown(XEN menu)
{
  #define H_gtk_menu_popdown "void gtk_menu_popdown(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_popdown", "GtkMenu*");
  gtk_menu_popdown(XEN_TO_C_GtkMenu_(menu));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_get_active(XEN menu)
{
  #define H_gtk_menu_get_active "GtkWidget* gtk_menu_get_active(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_get_active", "GtkMenu*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_get_active(XEN_TO_C_GtkMenu_(menu))));
}
static XEN gxg_gtk_menu_set_active(XEN menu, XEN index)
{
  #define H_gtk_menu_set_active "void gtk_menu_set_active(GtkMenu* menu, guint index)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_active", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_guint_P(index), index, 2, "gtk_menu_set_active", "guint");
  gtk_menu_set_active(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_guint(index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_set_accel_group(XEN menu, XEN accel_group)
{
  #define H_gtk_menu_set_accel_group "void gtk_menu_set_accel_group(GtkMenu* menu, GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_accel_group", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group) || XEN_FALSE_P(accel_group), accel_group, 2, "gtk_menu_set_accel_group", "GtkAccelGroup*");
  gtk_menu_set_accel_group(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_get_accel_group(XEN menu)
{
  #define H_gtk_menu_get_accel_group "GtkAccelGroup* gtk_menu_get_accel_group(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_get_accel_group", "GtkMenu*");
  return(C_TO_XEN_GtkAccelGroup_(gtk_menu_get_accel_group(XEN_TO_C_GtkMenu_(menu))));
}
static XEN gxg_gtk_menu_set_accel_path(XEN menu, XEN accel_path)
{
  #define H_gtk_menu_set_accel_path "void gtk_menu_set_accel_path(GtkMenu* menu, gchar* accel_path)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_accel_path", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 2, "gtk_menu_set_accel_path", "gchar*");
  gtk_menu_set_accel_path(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_gchar_(accel_path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_detach(XEN menu)
{
  #define H_gtk_menu_detach "void gtk_menu_detach(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_detach", "GtkMenu*");
  gtk_menu_detach(XEN_TO_C_GtkMenu_(menu));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_get_attach_widget(XEN menu)
{
  #define H_gtk_menu_get_attach_widget "GtkWidget* gtk_menu_get_attach_widget(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_get_attach_widget", "GtkMenu*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_get_attach_widget(XEN_TO_C_GtkMenu_(menu))));
}
static XEN gxg_gtk_menu_set_tearoff_state(XEN menu, XEN torn_off)
{
  #define H_gtk_menu_set_tearoff_state "void gtk_menu_set_tearoff_state(GtkMenu* menu, gboolean torn_off)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_tearoff_state", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(torn_off), torn_off, 2, "gtk_menu_set_tearoff_state", "gboolean");
  gtk_menu_set_tearoff_state(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_gboolean(torn_off));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_get_tearoff_state(XEN menu)
{
  #define H_gtk_menu_get_tearoff_state "gboolean gtk_menu_get_tearoff_state(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_get_tearoff_state", "GtkMenu*");
  return(C_TO_XEN_gboolean(gtk_menu_get_tearoff_state(XEN_TO_C_GtkMenu_(menu))));
}
static XEN gxg_gtk_menu_set_title(XEN menu, XEN title)
{
  #define H_gtk_menu_set_title "void gtk_menu_set_title(GtkMenu* menu, gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_title", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_menu_set_title", "gchar*");
  gtk_menu_set_title(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_get_title(XEN menu)
{
  #define H_gtk_menu_get_title "gchar* gtk_menu_get_title(GtkMenu* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_get_title", "GtkMenu*");
  return(C_TO_XEN_gchar_(gtk_menu_get_title(XEN_TO_C_GtkMenu_(menu))));
}
static XEN gxg_gtk_menu_reorder_child(XEN menu, XEN child, XEN position)
{
  #define H_gtk_menu_reorder_child "void gtk_menu_reorder_child(GtkMenu* menu, GtkWidget* child, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_reorder_child", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_menu_reorder_child", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_menu_reorder_child", "gint");
  gtk_menu_reorder_child(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_get_type(void)
{
  #define H_gtk_menu_item_get_type "GtkType gtk_menu_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_menu_item_get_type()));
}
static XEN gxg_gtk_menu_item_new(void)
{
  #define H_gtk_menu_item_new "GtkWidget* gtk_menu_item_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_menu_item_new()));
}
static XEN gxg_gtk_menu_item_new_with_label(XEN label)
{
  #define H_gtk_menu_item_new_with_label "GtkWidget* gtk_menu_item_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_menu_item_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_item_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_menu_item_new_with_mnemonic(XEN label)
{
  #define H_gtk_menu_item_new_with_mnemonic "GtkWidget* gtk_menu_item_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_menu_item_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_item_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_menu_item_set_submenu(XEN menu_item, XEN submenu)
{
  #define H_gtk_menu_item_set_submenu "void gtk_menu_item_set_submenu(GtkMenuItem* menu_item, GtkWidget* submenu)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_set_submenu", "GtkMenuItem*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(submenu), submenu, 2, "gtk_menu_item_set_submenu", "GtkWidget*");
  gtk_menu_item_set_submenu(XEN_TO_C_GtkMenuItem_(menu_item), XEN_TO_C_GtkWidget_(submenu));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_get_submenu(XEN menu_item)
{
  #define H_gtk_menu_item_get_submenu "GtkWidget* gtk_menu_item_get_submenu(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_get_submenu", "GtkMenuItem*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_item_get_submenu(XEN_TO_C_GtkMenuItem_(menu_item))));
}
static XEN gxg_gtk_menu_item_remove_submenu(XEN menu_item)
{
  #define H_gtk_menu_item_remove_submenu "void gtk_menu_item_remove_submenu(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_remove_submenu", "GtkMenuItem*");
  gtk_menu_item_remove_submenu(XEN_TO_C_GtkMenuItem_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_select(XEN menu_item)
{
  #define H_gtk_menu_item_select "void gtk_menu_item_select(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_select", "GtkMenuItem*");
  gtk_menu_item_select(XEN_TO_C_GtkMenuItem_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_deselect(XEN menu_item)
{
  #define H_gtk_menu_item_deselect "void gtk_menu_item_deselect(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_deselect", "GtkMenuItem*");
  gtk_menu_item_deselect(XEN_TO_C_GtkMenuItem_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_activate(XEN menu_item)
{
  #define H_gtk_menu_item_activate "void gtk_menu_item_activate(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_activate", "GtkMenuItem*");
  gtk_menu_item_activate(XEN_TO_C_GtkMenuItem_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_toggle_size_request(XEN menu_item, XEN requisition)
{
  #define H_gtk_menu_item_toggle_size_request "void gtk_menu_item_toggle_size_request(GtkMenuItem* menu_item, \
gint* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_toggle_size_request", "GtkMenuItem*");
  XEN_ASSERT_TYPE(XEN_gint__P(requisition), requisition, 2, "gtk_menu_item_toggle_size_request", "gint*");
  gtk_menu_item_toggle_size_request(XEN_TO_C_GtkMenuItem_(menu_item), XEN_TO_C_gint_(requisition));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_toggle_size_allocate(XEN menu_item, XEN allocation)
{
  #define H_gtk_menu_item_toggle_size_allocate "void gtk_menu_item_toggle_size_allocate(GtkMenuItem* menu_item, \
gint allocation)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_toggle_size_allocate", "GtkMenuItem*");
  XEN_ASSERT_TYPE(XEN_gint_P(allocation), allocation, 2, "gtk_menu_item_toggle_size_allocate", "gint");
  gtk_menu_item_toggle_size_allocate(XEN_TO_C_GtkMenuItem_(menu_item), XEN_TO_C_gint(allocation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_set_right_justified(XEN menu_item, XEN right_justified)
{
  #define H_gtk_menu_item_set_right_justified "void gtk_menu_item_set_right_justified(GtkMenuItem* menu_item, \
gboolean right_justified)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_set_right_justified", "GtkMenuItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(right_justified), right_justified, 2, "gtk_menu_item_set_right_justified", "gboolean");
  gtk_menu_item_set_right_justified(XEN_TO_C_GtkMenuItem_(menu_item), XEN_TO_C_gboolean(right_justified));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_item_get_right_justified(XEN menu_item)
{
  #define H_gtk_menu_item_get_right_justified "gboolean gtk_menu_item_get_right_justified(GtkMenuItem* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_get_right_justified", "GtkMenuItem*");
  return(C_TO_XEN_gboolean(gtk_menu_item_get_right_justified(XEN_TO_C_GtkMenuItem_(menu_item))));
}
static XEN gxg_gtk_menu_item_set_accel_path(XEN menu_item, XEN accel_path)
{
  #define H_gtk_menu_item_set_accel_path "void gtk_menu_item_set_accel_path(GtkMenuItem* menu_item, gchar* accel_path)"
  XEN_ASSERT_TYPE(XEN_GtkMenuItem__P(menu_item), menu_item, 1, "gtk_menu_item_set_accel_path", "GtkMenuItem*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 2, "gtk_menu_item_set_accel_path", "gchar*");
  gtk_menu_item_set_accel_path(XEN_TO_C_GtkMenuItem_(menu_item), XEN_TO_C_gchar_(accel_path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_get_type(void)
{
  #define H_gtk_menu_shell_get_type "GtkType gtk_menu_shell_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_menu_shell_get_type()));
}
static XEN gxg_gtk_menu_shell_append(XEN menu_shell, XEN child)
{
  #define H_gtk_menu_shell_append "void gtk_menu_shell_append(GtkMenuShell* menu_shell, GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_append", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_menu_shell_append", "GtkWidget*");
  gtk_menu_shell_append(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_GtkWidget_(child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_prepend(XEN menu_shell, XEN child)
{
  #define H_gtk_menu_shell_prepend "void gtk_menu_shell_prepend(GtkMenuShell* menu_shell, GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_prepend", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_menu_shell_prepend", "GtkWidget*");
  gtk_menu_shell_prepend(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_GtkWidget_(child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_insert(XEN menu_shell, XEN child, XEN position)
{
  #define H_gtk_menu_shell_insert "void gtk_menu_shell_insert(GtkMenuShell* menu_shell, GtkWidget* child, \
gint position)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_insert", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_menu_shell_insert", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_menu_shell_insert", "gint");
  gtk_menu_shell_insert(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_deactivate(XEN menu_shell)
{
  #define H_gtk_menu_shell_deactivate "void gtk_menu_shell_deactivate(GtkMenuShell* menu_shell)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_deactivate", "GtkMenuShell*");
  gtk_menu_shell_deactivate(XEN_TO_C_GtkMenuShell_(menu_shell));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_select_item(XEN menu_shell, XEN menu_item)
{
  #define H_gtk_menu_shell_select_item "void gtk_menu_shell_select_item(GtkMenuShell* menu_shell, GtkWidget* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_select_item", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_item), menu_item, 2, "gtk_menu_shell_select_item", "GtkWidget*");
  gtk_menu_shell_select_item(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_GtkWidget_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_deselect(XEN menu_shell)
{
  #define H_gtk_menu_shell_deselect "void gtk_menu_shell_deselect(GtkMenuShell* menu_shell)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_deselect", "GtkMenuShell*");
  gtk_menu_shell_deselect(XEN_TO_C_GtkMenuShell_(menu_shell));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_shell_activate_item(XEN menu_shell, XEN menu_item, XEN force_deactivate)
{
  #define H_gtk_menu_shell_activate_item "void gtk_menu_shell_activate_item(GtkMenuShell* menu_shell, \
GtkWidget* menu_item, gboolean force_deactivate)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_activate_item", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_item), menu_item, 2, "gtk_menu_shell_activate_item", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(force_deactivate), force_deactivate, 3, "gtk_menu_shell_activate_item", "gboolean");
  gtk_menu_shell_activate_item(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_GtkWidget_(menu_item), XEN_TO_C_gboolean(force_deactivate));
  return(XEN_FALSE);
}
static XEN gxg_gtk_message_dialog_get_type(void)
{
  #define H_gtk_message_dialog_get_type "GtkType gtk_message_dialog_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_message_dialog_get_type()));
}
static XEN gxg_gtk_misc_get_type(void)
{
  #define H_gtk_misc_get_type "GtkType gtk_misc_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_misc_get_type()));
}
static XEN gxg_gtk_misc_set_alignment(XEN misc, XEN xalign, XEN yalign)
{
  #define H_gtk_misc_set_alignment "void gtk_misc_set_alignment(GtkMisc* misc, gfloat xalign, gfloat yalign)"
  XEN_ASSERT_TYPE(XEN_GtkMisc__P(misc), misc, 1, "gtk_misc_set_alignment", "GtkMisc*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_misc_set_alignment", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_misc_set_alignment", "gfloat");
  gtk_misc_set_alignment(XEN_TO_C_GtkMisc_(misc), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_misc_get_alignment(XEN misc, XEN xalign, XEN yalign)
{
  #define H_gtk_misc_get_alignment "void gtk_misc_get_alignment(GtkMisc* misc, gfloat* [xalign], gfloat* [yalign])"
  gfloat ref_xalign;
  gfloat ref_yalign;
  XEN_ASSERT_TYPE(XEN_GtkMisc__P(misc), misc, 1, "gtk_misc_get_alignment", "GtkMisc*");
  gtk_misc_get_alignment(XEN_TO_C_GtkMisc_(misc), &ref_xalign, &ref_yalign);
  return(XEN_LIST_2(C_TO_XEN_gfloat(ref_xalign), C_TO_XEN_gfloat(ref_yalign)));
}
static XEN gxg_gtk_misc_set_padding(XEN misc, XEN xpad, XEN ypad)
{
  #define H_gtk_misc_set_padding "void gtk_misc_set_padding(GtkMisc* misc, gint xpad, gint ypad)"
  XEN_ASSERT_TYPE(XEN_GtkMisc__P(misc), misc, 1, "gtk_misc_set_padding", "GtkMisc*");
  XEN_ASSERT_TYPE(XEN_gint_P(xpad), xpad, 2, "gtk_misc_set_padding", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ypad), ypad, 3, "gtk_misc_set_padding", "gint");
  gtk_misc_set_padding(XEN_TO_C_GtkMisc_(misc), XEN_TO_C_gint(xpad), XEN_TO_C_gint(ypad));
  return(XEN_FALSE);
}
static XEN gxg_gtk_misc_get_padding(XEN misc, XEN xpad, XEN ypad)
{
  #define H_gtk_misc_get_padding "void gtk_misc_get_padding(GtkMisc* misc, gint* [xpad], gint* [ypad])"
  gint ref_xpad;
  gint ref_ypad;
  XEN_ASSERT_TYPE(XEN_GtkMisc__P(misc), misc, 1, "gtk_misc_get_padding", "GtkMisc*");
  gtk_misc_get_padding(XEN_TO_C_GtkMisc_(misc), &ref_xpad, &ref_ypad);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_xpad), C_TO_XEN_gint(ref_ypad)));
}
static XEN gxg_gtk_notebook_get_type(void)
{
  #define H_gtk_notebook_get_type "GtkType gtk_notebook_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_notebook_get_type()));
}
static XEN gxg_gtk_notebook_new(void)
{
  #define H_gtk_notebook_new "GtkWidget* gtk_notebook_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_notebook_new()));
}
static XEN gxg_gtk_notebook_remove_page(XEN notebook, XEN page_num)
{
  #define H_gtk_notebook_remove_page "void gtk_notebook_remove_page(GtkNotebook* notebook, gint page_num)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_remove_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gint_P(page_num), page_num, 2, "gtk_notebook_remove_page", "gint");
  gtk_notebook_remove_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gint(page_num));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_current_page(XEN notebook)
{
  #define H_gtk_notebook_get_current_page "gint gtk_notebook_get_current_page(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_current_page", "GtkNotebook*");
  return(C_TO_XEN_gint(gtk_notebook_get_current_page(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_notebook_get_nth_page(XEN notebook, XEN page_num)
{
  #define H_gtk_notebook_get_nth_page "GtkWidget* gtk_notebook_get_nth_page(GtkNotebook* notebook, gint page_num)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_nth_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gint_P(page_num), page_num, 2, "gtk_notebook_get_nth_page", "gint");
  return(C_TO_XEN_GtkWidget_(gtk_notebook_get_nth_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gint(page_num))));
}
static XEN gxg_gtk_notebook_page_num(XEN notebook, XEN child)
{
  #define H_gtk_notebook_page_num "gint gtk_notebook_page_num(GtkNotebook* notebook, GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_page_num", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_page_num", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_notebook_page_num(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_notebook_set_current_page(XEN notebook, XEN page_num)
{
  #define H_gtk_notebook_set_current_page "void gtk_notebook_set_current_page(GtkNotebook* notebook, \
gint page_num)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_current_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gint_P(page_num), page_num, 2, "gtk_notebook_set_current_page", "gint");
  gtk_notebook_set_current_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gint(page_num));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_next_page(XEN notebook)
{
  #define H_gtk_notebook_next_page "void gtk_notebook_next_page(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_next_page", "GtkNotebook*");
  gtk_notebook_next_page(XEN_TO_C_GtkNotebook_(notebook));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_prev_page(XEN notebook)
{
  #define H_gtk_notebook_prev_page "void gtk_notebook_prev_page(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_prev_page", "GtkNotebook*");
  gtk_notebook_prev_page(XEN_TO_C_GtkNotebook_(notebook));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_set_show_border(XEN notebook, XEN show_border)
{
  #define H_gtk_notebook_set_show_border "void gtk_notebook_set_show_border(GtkNotebook* notebook, gboolean show_border)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_show_border", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_border), show_border, 2, "gtk_notebook_set_show_border", "gboolean");
  gtk_notebook_set_show_border(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gboolean(show_border));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_show_border(XEN notebook)
{
  #define H_gtk_notebook_get_show_border "gboolean gtk_notebook_get_show_border(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_show_border", "GtkNotebook*");
  return(C_TO_XEN_gboolean(gtk_notebook_get_show_border(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_notebook_set_show_tabs(XEN notebook, XEN show_tabs)
{
  #define H_gtk_notebook_set_show_tabs "void gtk_notebook_set_show_tabs(GtkNotebook* notebook, gboolean show_tabs)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_show_tabs", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_tabs), show_tabs, 2, "gtk_notebook_set_show_tabs", "gboolean");
  gtk_notebook_set_show_tabs(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gboolean(show_tabs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_show_tabs(XEN notebook)
{
  #define H_gtk_notebook_get_show_tabs "gboolean gtk_notebook_get_show_tabs(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_show_tabs", "GtkNotebook*");
  return(C_TO_XEN_gboolean(gtk_notebook_get_show_tabs(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_notebook_set_tab_pos(XEN notebook, XEN pos)
{
  #define H_gtk_notebook_set_tab_pos "void gtk_notebook_set_tab_pos(GtkNotebook* notebook, GtkPositionType pos)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_tab_pos", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(pos), pos, 2, "gtk_notebook_set_tab_pos", "GtkPositionType");
  gtk_notebook_set_tab_pos(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkPositionType(pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_tab_pos(XEN notebook)
{
  #define H_gtk_notebook_get_tab_pos "GtkPositionType gtk_notebook_get_tab_pos(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_tab_pos", "GtkNotebook*");
  return(C_TO_XEN_GtkPositionType(gtk_notebook_get_tab_pos(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_notebook_set_scrollable(XEN notebook, XEN scrollable)
{
  #define H_gtk_notebook_set_scrollable "void gtk_notebook_set_scrollable(GtkNotebook* notebook, gboolean scrollable)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_scrollable", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(scrollable), scrollable, 2, "gtk_notebook_set_scrollable", "gboolean");
  gtk_notebook_set_scrollable(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_gboolean(scrollable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_scrollable(XEN notebook)
{
  #define H_gtk_notebook_get_scrollable "gboolean gtk_notebook_get_scrollable(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_scrollable", "GtkNotebook*");
  return(C_TO_XEN_gboolean(gtk_notebook_get_scrollable(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_notebook_popup_enable(XEN notebook)
{
  #define H_gtk_notebook_popup_enable "void gtk_notebook_popup_enable(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_popup_enable", "GtkNotebook*");
  gtk_notebook_popup_enable(XEN_TO_C_GtkNotebook_(notebook));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_popup_disable(XEN notebook)
{
  #define H_gtk_notebook_popup_disable "void gtk_notebook_popup_disable(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_popup_disable", "GtkNotebook*");
  gtk_notebook_popup_disable(XEN_TO_C_GtkNotebook_(notebook));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_tab_label(XEN notebook, XEN child)
{
  #define H_gtk_notebook_get_tab_label "GtkWidget* gtk_notebook_get_tab_label(GtkNotebook* notebook, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_tab_label", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_get_tab_label", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_notebook_get_tab_label(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_notebook_set_tab_label(XEN notebook, XEN child, XEN tab_label)
{
  #define H_gtk_notebook_set_tab_label "void gtk_notebook_set_tab_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_tab_label", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_set_tab_label", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_set_tab_label", "GtkWidget*");
  gtk_notebook_set_tab_label(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_set_tab_label_text(XEN notebook, XEN child, XEN tab_text)
{
  #define H_gtk_notebook_set_tab_label_text "void gtk_notebook_set_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* tab_text)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_tab_label_text", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_set_tab_label_text", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tab_text), tab_text, 3, "gtk_notebook_set_tab_label_text", "gchar*");
  gtk_notebook_set_tab_label_text(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gchar_(tab_text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_tab_label_text(XEN notebook, XEN child)
{
  #define H_gtk_notebook_get_tab_label_text "gchar* gtk_notebook_get_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_tab_label_text", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_get_tab_label_text", "GtkWidget*");
  return(C_TO_XEN_gchar_(gtk_notebook_get_tab_label_text(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_notebook_get_menu_label(XEN notebook, XEN child)
{
  #define H_gtk_notebook_get_menu_label "GtkWidget* gtk_notebook_get_menu_label(GtkNotebook* notebook, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_menu_label", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_get_menu_label", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_notebook_get_menu_label(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_notebook_set_menu_label(XEN notebook, XEN child, XEN menu_label)
{
  #define H_gtk_notebook_set_menu_label "void gtk_notebook_set_menu_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* menu_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_menu_label", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_set_menu_label", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_label), menu_label, 3, "gtk_notebook_set_menu_label", "GtkWidget*");
  gtk_notebook_set_menu_label(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(menu_label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_set_menu_label_text(XEN notebook, XEN child, XEN menu_text)
{
  #define H_gtk_notebook_set_menu_label_text "void gtk_notebook_set_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* menu_text)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_menu_label_text", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_set_menu_label_text", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(menu_text), menu_text, 3, "gtk_notebook_set_menu_label_text", "gchar*");
  gtk_notebook_set_menu_label_text(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gchar_(menu_text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_menu_label_text(XEN notebook, XEN child)
{
  #define H_gtk_notebook_get_menu_label_text "gchar* gtk_notebook_get_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_menu_label_text", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_get_menu_label_text", "GtkWidget*");
  return(C_TO_XEN_gchar_(gtk_notebook_get_menu_label_text(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_notebook_query_tab_label_packing(XEN notebook, XEN child, XEN expand, XEN fill, XEN pack_type)
{
  #define H_gtk_notebook_query_tab_label_packing "void gtk_notebook_query_tab_label_packing(GtkNotebook* notebook, \
GtkWidget* child, gboolean* [expand], gboolean* [fill], GtkPackType* [pack_type])"
  gboolean ref_expand;
  gboolean ref_fill;
  GtkPackType ref_pack_type;
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_query_tab_label_packing", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_query_tab_label_packing", "GtkWidget*");
  gtk_notebook_query_tab_label_packing(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), &ref_expand, &ref_fill, 
                                       &ref_pack_type);
  return(XEN_LIST_3(C_TO_XEN_gboolean(ref_expand), C_TO_XEN_gboolean(ref_fill), C_TO_XEN_GtkPackType(ref_pack_type)));
}
static XEN gxg_gtk_notebook_set_tab_label_packing(XEN notebook, XEN child, XEN expand, XEN fill, XEN pack_type)
{
  #define H_gtk_notebook_set_tab_label_packing "void gtk_notebook_set_tab_label_packing(GtkNotebook* notebook, \
GtkWidget* child, gboolean expand, gboolean fill, GtkPackType pack_type)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_set_tab_label_packing", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_set_tab_label_packing", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_notebook_set_tab_label_packing", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 4, "gtk_notebook_set_tab_label_packing", "gboolean");
  XEN_ASSERT_TYPE(XEN_GtkPackType_P(pack_type), pack_type, 5, "gtk_notebook_set_tab_label_packing", "GtkPackType");
  gtk_notebook_set_tab_label_packing(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(expand), 
                                     XEN_TO_C_gboolean(fill), XEN_TO_C_GtkPackType(pack_type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_reorder_child(XEN notebook, XEN child, XEN position)
{
  #define H_gtk_notebook_reorder_child "void gtk_notebook_reorder_child(GtkNotebook* notebook, GtkWidget* child, \
gint position)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_reorder_child", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_reorder_child", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_notebook_reorder_child", "gint");
  gtk_notebook_reorder_child(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_GTK_OBJECT_TYPE_NAME(XEN object)
{
  #define H_GTK_OBJECT_TYPE_NAME "char* GTK_OBJECT_TYPE_NAME(GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 1, "GTK_OBJECT_TYPE_NAME", "GtkObject*");
  return(C_TO_XEN_char_(GTK_OBJECT_TYPE_NAME(XEN_TO_C_GtkObject_(object))));
}
static XEN gxg_GTK_OBJECT_FLAGS(XEN obj)
{
  #define H_GTK_OBJECT_FLAGS "int GTK_OBJECT_FLAGS(GtkObject* obj)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(obj), obj, 1, "GTK_OBJECT_FLAGS", "GtkObject*");
  return(C_TO_XEN_int(GTK_OBJECT_FLAGS(XEN_TO_C_GtkObject_(obj))));
}
static XEN gxg_GTK_OBJECT_FLOATING(XEN obj)
{
  #define H_GTK_OBJECT_FLOATING "gboolean GTK_OBJECT_FLOATING(GtkObject* obj)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(obj), obj, 1, "GTK_OBJECT_FLOATING", "GtkObject*");
  return(C_TO_XEN_gboolean(GTK_OBJECT_FLOATING(XEN_TO_C_GtkObject_(obj))));
}
static XEN gxg_GTK_OBJECT_SET_FLAGS(XEN obj, XEN flag)
{
  #define H_GTK_OBJECT_SET_FLAGS "void GTK_OBJECT_SET_FLAGS(GtkObject* obj, int flag)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(obj), obj, 1, "GTK_OBJECT_SET_FLAGS", "GtkObject*");
  XEN_ASSERT_TYPE(XEN_int_P(flag), flag, 2, "GTK_OBJECT_SET_FLAGS", "int");
  GTK_OBJECT_SET_FLAGS(XEN_TO_C_GtkObject_(obj), XEN_TO_C_int(flag));
  return(XEN_FALSE);
}
static XEN gxg_GTK_OBJECT_UNSET_FLAGS(XEN obj, XEN flag)
{
  #define H_GTK_OBJECT_UNSET_FLAGS "void GTK_OBJECT_UNSET_FLAGS(GtkObject* obj, int flag)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(obj), obj, 1, "GTK_OBJECT_UNSET_FLAGS", "GtkObject*");
  XEN_ASSERT_TYPE(XEN_int_P(flag), flag, 2, "GTK_OBJECT_UNSET_FLAGS", "int");
  GTK_OBJECT_UNSET_FLAGS(XEN_TO_C_GtkObject_(obj), XEN_TO_C_int(flag));
  return(XEN_FALSE);
}
static XEN gxg_gtk_object_get_type(void)
{
  #define H_gtk_object_get_type "GtkType gtk_object_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_object_get_type()));
}
static XEN gxg_gtk_object_sink(XEN object)
{
  #define H_gtk_object_sink "void gtk_object_sink(GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 1, "gtk_object_sink", "GtkObject*");
  gtk_object_sink(XEN_TO_C_GtkObject_(object));
  return(XEN_FALSE);
}
static XEN gxg_gtk_object_destroy(XEN object)
{
  #define H_gtk_object_destroy "void gtk_object_destroy(GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 1, "gtk_object_destroy", "GtkObject*");
  gtk_object_destroy(XEN_TO_C_GtkObject_(object));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_get_type(void)
{
  #define H_gtk_paned_get_type "GtkType gtk_paned_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_paned_get_type()));
}
static XEN gxg_gtk_paned_add1(XEN paned, XEN child)
{
  #define H_gtk_paned_add1 "void gtk_paned_add1(GtkPaned* paned, GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_add1", "GtkPaned*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_paned_add1", "GtkWidget*");
  gtk_paned_add1(XEN_TO_C_GtkPaned_(paned), XEN_TO_C_GtkWidget_(child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_add2(XEN paned, XEN child)
{
  #define H_gtk_paned_add2 "void gtk_paned_add2(GtkPaned* paned, GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_add2", "GtkPaned*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_paned_add2", "GtkWidget*");
  gtk_paned_add2(XEN_TO_C_GtkPaned_(paned), XEN_TO_C_GtkWidget_(child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_pack1(XEN paned, XEN child, XEN resize, XEN shrink)
{
  #define H_gtk_paned_pack1 "void gtk_paned_pack1(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_pack1", "GtkPaned*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_paned_pack1", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(resize), resize, 3, "gtk_paned_pack1", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(shrink), shrink, 4, "gtk_paned_pack1", "gboolean");
  gtk_paned_pack1(XEN_TO_C_GtkPaned_(paned), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(resize), XEN_TO_C_gboolean(shrink));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_pack2(XEN paned, XEN child, XEN resize, XEN shrink)
{
  #define H_gtk_paned_pack2 "void gtk_paned_pack2(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_pack2", "GtkPaned*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_paned_pack2", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(resize), resize, 3, "gtk_paned_pack2", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(shrink), shrink, 4, "gtk_paned_pack2", "gboolean");
  gtk_paned_pack2(XEN_TO_C_GtkPaned_(paned), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gboolean(resize), XEN_TO_C_gboolean(shrink));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_get_position(XEN paned)
{
  #define H_gtk_paned_get_position "gint gtk_paned_get_position(GtkPaned* paned)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_get_position", "GtkPaned*");
  return(C_TO_XEN_gint(gtk_paned_get_position(XEN_TO_C_GtkPaned_(paned))));
}
static XEN gxg_gtk_paned_set_position(XEN paned, XEN position)
{
  #define H_gtk_paned_set_position "void gtk_paned_set_position(GtkPaned* paned, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_set_position", "GtkPaned*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_paned_set_position", "gint");
  gtk_paned_set_position(XEN_TO_C_GtkPaned_(paned), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_plug_get_type(void)
{
  #define H_gtk_plug_get_type "GtkType gtk_plug_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_plug_get_type()));
}
static XEN gxg_gtk_plug_construct(XEN plug, XEN socket_id)
{
  #define H_gtk_plug_construct "void gtk_plug_construct(GtkPlug* plug, GdkNativeWindow socket_id)"
  XEN_ASSERT_TYPE(XEN_GtkPlug__P(plug), plug, 1, "gtk_plug_construct", "GtkPlug*");
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(socket_id), socket_id, 2, "gtk_plug_construct", "GdkNativeWindow");
  gtk_plug_construct(XEN_TO_C_GtkPlug_(plug), XEN_TO_C_GdkNativeWindow(socket_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_plug_new(XEN socket_id)
{
  #define H_gtk_plug_new "GtkWidget* gtk_plug_new(GdkNativeWindow socket_id)"
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(socket_id), socket_id, 1, "gtk_plug_new", "GdkNativeWindow");
  return(C_TO_XEN_GtkWidget_(gtk_plug_new(XEN_TO_C_GdkNativeWindow(socket_id))));
}
static XEN gxg_gtk_plug_get_id(XEN plug)
{
  #define H_gtk_plug_get_id "GdkNativeWindow gtk_plug_get_id(GtkPlug* plug)"
  XEN_ASSERT_TYPE(XEN_GtkPlug__P(plug), plug, 1, "gtk_plug_get_id", "GtkPlug*");
  return(C_TO_XEN_GdkNativeWindow(gtk_plug_get_id(XEN_TO_C_GtkPlug_(plug))));
}
static XEN gxg_gtk_progress_bar_get_type(void)
{
  #define H_gtk_progress_bar_get_type "GtkType gtk_progress_bar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_progress_bar_get_type()));
}
static XEN gxg_gtk_progress_bar_new(void)
{
  #define H_gtk_progress_bar_new "GtkWidget* gtk_progress_bar_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_progress_bar_new()));
}
static XEN gxg_gtk_progress_bar_pulse(XEN pbar)
{
  #define H_gtk_progress_bar_pulse "void gtk_progress_bar_pulse(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_pulse", "GtkProgressBar*");
  gtk_progress_bar_pulse(XEN_TO_C_GtkProgressBar_(pbar));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_set_text(XEN pbar, XEN text)
{
  #define H_gtk_progress_bar_set_text "void gtk_progress_bar_set_text(GtkProgressBar* pbar, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_set_text", "GtkProgressBar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_progress_bar_set_text", "gchar*");
  gtk_progress_bar_set_text(XEN_TO_C_GtkProgressBar_(pbar), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_set_fraction(XEN pbar, XEN fraction)
{
  #define H_gtk_progress_bar_set_fraction "void gtk_progress_bar_set_fraction(GtkProgressBar* pbar, gdouble fraction)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_set_fraction", "GtkProgressBar*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(fraction), fraction, 2, "gtk_progress_bar_set_fraction", "gdouble");
  gtk_progress_bar_set_fraction(XEN_TO_C_GtkProgressBar_(pbar), XEN_TO_C_gdouble(fraction));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_set_pulse_step(XEN pbar, XEN fraction)
{
  #define H_gtk_progress_bar_set_pulse_step "void gtk_progress_bar_set_pulse_step(GtkProgressBar* pbar, \
gdouble fraction)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_set_pulse_step", "GtkProgressBar*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(fraction), fraction, 2, "gtk_progress_bar_set_pulse_step", "gdouble");
  gtk_progress_bar_set_pulse_step(XEN_TO_C_GtkProgressBar_(pbar), XEN_TO_C_gdouble(fraction));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_set_orientation(XEN pbar, XEN orientation)
{
  #define H_gtk_progress_bar_set_orientation "void gtk_progress_bar_set_orientation(GtkProgressBar* pbar, \
GtkProgressBarOrientation orientation)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_set_orientation", "GtkProgressBar*");
  XEN_ASSERT_TYPE(XEN_GtkProgressBarOrientation_P(orientation), orientation, 2, "gtk_progress_bar_set_orientation", "GtkProgressBarOrientation");
  gtk_progress_bar_set_orientation(XEN_TO_C_GtkProgressBar_(pbar), XEN_TO_C_GtkProgressBarOrientation(orientation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_get_text(XEN pbar)
{
  #define H_gtk_progress_bar_get_text "gchar* gtk_progress_bar_get_text(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_get_text", "GtkProgressBar*");
  return(C_TO_XEN_gchar_(gtk_progress_bar_get_text(XEN_TO_C_GtkProgressBar_(pbar))));
}
static XEN gxg_gtk_progress_bar_get_fraction(XEN pbar)
{
  #define H_gtk_progress_bar_get_fraction "gdouble gtk_progress_bar_get_fraction(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_get_fraction", "GtkProgressBar*");
  return(C_TO_XEN_gdouble(gtk_progress_bar_get_fraction(XEN_TO_C_GtkProgressBar_(pbar))));
}
static XEN gxg_gtk_progress_bar_get_pulse_step(XEN pbar)
{
  #define H_gtk_progress_bar_get_pulse_step "gdouble gtk_progress_bar_get_pulse_step(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_get_pulse_step", "GtkProgressBar*");
  return(C_TO_XEN_gdouble(gtk_progress_bar_get_pulse_step(XEN_TO_C_GtkProgressBar_(pbar))));
}
static XEN gxg_gtk_progress_bar_get_orientation(XEN pbar)
{
  #define H_gtk_progress_bar_get_orientation "GtkProgressBarOrientation gtk_progress_bar_get_orientation(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_get_orientation", "GtkProgressBar*");
  return(C_TO_XEN_GtkProgressBarOrientation(gtk_progress_bar_get_orientation(XEN_TO_C_GtkProgressBar_(pbar))));
}
static XEN gxg_gtk_radio_button_get_type(void)
{
  #define H_gtk_radio_button_get_type "GtkType gtk_radio_button_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_radio_button_get_type()));
}
static XEN gxg_gtk_radio_button_new(XEN group)
{
  #define H_gtk_radio_button_new "GtkWidget* gtk_radio_button_new(GSList* group)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_button_new", "GSList*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new(XEN_TO_C_GSList_(group))));
}
static XEN gxg_gtk_radio_button_new_from_widget(XEN group)
{
  #define H_gtk_radio_button_new_from_widget "GtkWidget* gtk_radio_button_new_from_widget(GtkRadioButton* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioButton__P(group), group, 1, "gtk_radio_button_new_from_widget", "GtkRadioButton*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new_from_widget(XEN_TO_C_GtkRadioButton_(group))));
}
static XEN gxg_gtk_radio_button_new_with_label(XEN group, XEN label)
{
  #define H_gtk_radio_button_new_with_label "GtkWidget* gtk_radio_button_new_with_label(GSList* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_button_new_with_label", "GSList*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_button_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new_with_label(XEN_TO_C_GSList_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_button_new_with_label_from_widget(XEN group, XEN label)
{
  #define H_gtk_radio_button_new_with_label_from_widget "GtkWidget* gtk_radio_button_new_with_label_from_widget(GtkRadioButton* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkRadioButton__P(group), group, 1, "gtk_radio_button_new_with_label_from_widget", "GtkRadioButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_button_new_with_label_from_widget", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new_with_label_from_widget(XEN_TO_C_GtkRadioButton_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_button_new_with_mnemonic(XEN group, XEN label)
{
  #define H_gtk_radio_button_new_with_mnemonic "GtkWidget* gtk_radio_button_new_with_mnemonic(GSList* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_button_new_with_mnemonic", "GSList*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_button_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new_with_mnemonic(XEN_TO_C_GSList_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_button_new_with_mnemonic_from_widget(XEN group, XEN label)
{
  #define H_gtk_radio_button_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_button_new_with_mnemonic_from_widget(GtkRadioButton* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkRadioButton__P(group), group, 1, "gtk_radio_button_new_with_mnemonic_from_widget", "GtkRadioButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_button_new_with_mnemonic_from_widget", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_button_new_with_mnemonic_from_widget(XEN_TO_C_GtkRadioButton_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_button_get_group(XEN radio_button)
{
  #define H_gtk_radio_button_get_group "GSList* gtk_radio_button_get_group(GtkRadioButton* radio_button)"
  XEN_ASSERT_TYPE(XEN_GtkRadioButton__P(radio_button), radio_button, 1, "gtk_radio_button_get_group", "GtkRadioButton*");
  return(C_TO_XEN_GSList_(gtk_radio_button_get_group(XEN_TO_C_GtkRadioButton_(radio_button))));
}
static XEN gxg_gtk_radio_button_set_group(XEN radio_button, XEN group)
{
  #define H_gtk_radio_button_set_group "void gtk_radio_button_set_group(GtkRadioButton* radio_button, \
GSList* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioButton__P(radio_button), radio_button, 1, "gtk_radio_button_set_group", "GtkRadioButton*");
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 2, "gtk_radio_button_set_group", "GSList*");
  gtk_radio_button_set_group(XEN_TO_C_GtkRadioButton_(radio_button), XEN_TO_C_GSList_(group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_radio_menu_item_get_type(void)
{
  #define H_gtk_radio_menu_item_get_type "GtkType gtk_radio_menu_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_radio_menu_item_get_type()));
}
static XEN gxg_gtk_radio_menu_item_new(XEN group)
{
  #define H_gtk_radio_menu_item_new "GtkWidget* gtk_radio_menu_item_new(GSList* group)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_menu_item_new", "GSList*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new(XEN_TO_C_GSList_(group))));
}
static XEN gxg_gtk_radio_menu_item_new_with_label(XEN group, XEN label)
{
  #define H_gtk_radio_menu_item_new_with_label "GtkWidget* gtk_radio_menu_item_new_with_label(GSList* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_menu_item_new_with_label", "GSList*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_menu_item_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new_with_label(XEN_TO_C_GSList_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_menu_item_new_with_mnemonic(XEN group, XEN label)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic "GtkWidget* gtk_radio_menu_item_new_with_mnemonic(GSList* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_menu_item_new_with_mnemonic", "GSList*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_menu_item_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new_with_mnemonic(XEN_TO_C_GSList_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_menu_item_get_group(XEN radio_menu_item)
{
  #define H_gtk_radio_menu_item_get_group "GSList* gtk_radio_menu_item_get_group(GtkRadioMenuItem* radio_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkRadioMenuItem__P(radio_menu_item), radio_menu_item, 1, "gtk_radio_menu_item_get_group", "GtkRadioMenuItem*");
  return(C_TO_XEN_GSList_(gtk_radio_menu_item_get_group(XEN_TO_C_GtkRadioMenuItem_(radio_menu_item))));
}
static XEN gxg_gtk_radio_menu_item_set_group(XEN radio_menu_item, XEN group)
{
  #define H_gtk_radio_menu_item_set_group "void gtk_radio_menu_item_set_group(GtkRadioMenuItem* radio_menu_item, \
GSList* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioMenuItem__P(radio_menu_item), radio_menu_item, 1, "gtk_radio_menu_item_set_group", "GtkRadioMenuItem*");
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 2, "gtk_radio_menu_item_set_group", "GSList*");
  gtk_radio_menu_item_set_group(XEN_TO_C_GtkRadioMenuItem_(radio_menu_item), XEN_TO_C_GSList_(group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_get_type(void)
{
  #define H_gtk_range_get_type "GtkType gtk_range_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_range_get_type()));
}
static XEN gxg_gtk_range_set_update_policy(XEN range, XEN policy)
{
  #define H_gtk_range_set_update_policy "void gtk_range_set_update_policy(GtkRange* range, GtkUpdateType policy)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_update_policy", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_GtkUpdateType_P(policy), policy, 2, "gtk_range_set_update_policy", "GtkUpdateType");
  gtk_range_set_update_policy(XEN_TO_C_GtkRange_(range), XEN_TO_C_GtkUpdateType(policy));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_get_update_policy(XEN range)
{
  #define H_gtk_range_get_update_policy "GtkUpdateType gtk_range_get_update_policy(GtkRange* range)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_get_update_policy", "GtkRange*");
  return(C_TO_XEN_GtkUpdateType(gtk_range_get_update_policy(XEN_TO_C_GtkRange_(range))));
}
static XEN gxg_gtk_range_set_adjustment(XEN range, XEN adjustment)
{
  #define H_gtk_range_set_adjustment "void gtk_range_set_adjustment(GtkRange* range, GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_adjustment", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_range_set_adjustment", "GtkAdjustment*");
  gtk_range_set_adjustment(XEN_TO_C_GtkRange_(range), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_get_adjustment(XEN range)
{
  #define H_gtk_range_get_adjustment "GtkAdjustment* gtk_range_get_adjustment(GtkRange* range)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_get_adjustment", "GtkRange*");
  return(C_TO_XEN_GtkAdjustment_(gtk_range_get_adjustment(XEN_TO_C_GtkRange_(range))));
}
static XEN gxg_gtk_range_set_inverted(XEN range, XEN setting)
{
  #define H_gtk_range_set_inverted "void gtk_range_set_inverted(GtkRange* range, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_inverted", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_range_set_inverted", "gboolean");
  gtk_range_set_inverted(XEN_TO_C_GtkRange_(range), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_get_inverted(XEN range)
{
  #define H_gtk_range_get_inverted "gboolean gtk_range_get_inverted(GtkRange* range)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_get_inverted", "GtkRange*");
  return(C_TO_XEN_gboolean(gtk_range_get_inverted(XEN_TO_C_GtkRange_(range))));
}
static XEN gxg_gtk_range_set_increments(XEN range, XEN step, XEN page)
{
  #define H_gtk_range_set_increments "void gtk_range_set_increments(GtkRange* range, gdouble step, gdouble page)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_increments", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step), step, 2, "gtk_range_set_increments", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(page), page, 3, "gtk_range_set_increments", "gdouble");
  gtk_range_set_increments(XEN_TO_C_GtkRange_(range), XEN_TO_C_gdouble(step), XEN_TO_C_gdouble(page));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_set_range(XEN range, XEN min, XEN max)
{
  #define H_gtk_range_set_range "void gtk_range_set_range(GtkRange* range, gdouble min, gdouble max)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_range", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(min), min, 2, "gtk_range_set_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max), max, 3, "gtk_range_set_range", "gdouble");
  gtk_range_set_range(XEN_TO_C_GtkRange_(range), XEN_TO_C_gdouble(min), XEN_TO_C_gdouble(max));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_set_value(XEN range, XEN value)
{
  #define H_gtk_range_set_value "void gtk_range_set_value(GtkRange* range, gdouble value)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_set_value", "GtkRange*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(value), value, 2, "gtk_range_set_value", "gdouble");
  gtk_range_set_value(XEN_TO_C_GtkRange_(range), XEN_TO_C_gdouble(value));
  return(XEN_FALSE);
}
static XEN gxg_gtk_range_get_value(XEN range)
{
  #define H_gtk_range_get_value "gdouble gtk_range_get_value(GtkRange* range)"
  XEN_ASSERT_TYPE(XEN_GtkRange__P(range), range, 1, "gtk_range_get_value", "GtkRange*");
  return(C_TO_XEN_gdouble(gtk_range_get_value(XEN_TO_C_GtkRange_(range))));
}
static XEN gxg_gtk_rc_add_default_file(XEN filename)
{
  #define H_gtk_rc_add_default_file "void gtk_rc_add_default_file(gchar* filename)"
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 1, "gtk_rc_add_default_file", "gchar*");
  gtk_rc_add_default_file(XEN_TO_C_gchar_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_set_default_files(XEN filenames)
{
  #define H_gtk_rc_set_default_files "void gtk_rc_set_default_files(gchar** filenames)"
  XEN_ASSERT_TYPE(XEN_gchar___P(filenames), filenames, 1, "gtk_rc_set_default_files", "gchar**");
  gtk_rc_set_default_files(XEN_TO_C_gchar__(filenames));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_get_default_files(void)
{
  #define H_gtk_rc_get_default_files "gchar** gtk_rc_get_default_files( void)"
  return(C_TO_XEN_gchar__(gtk_rc_get_default_files()));
}
static XEN gxg_gtk_rc_get_style(XEN widget)
{
  #define H_gtk_rc_get_style "GtkStyle* gtk_rc_get_style(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_rc_get_style", "GtkWidget*");
  return(C_TO_XEN_GtkStyle_(gtk_rc_get_style(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_rc_parse(XEN filename)
{
  #define H_gtk_rc_parse "void gtk_rc_parse(gchar* filename)"
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 1, "gtk_rc_parse", "gchar*");
  gtk_rc_parse(XEN_TO_C_gchar_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_parse_string(XEN rc_string)
{
  #define H_gtk_rc_parse_string "void gtk_rc_parse_string(gchar* rc_string)"
  XEN_ASSERT_TYPE(XEN_gchar__P(rc_string), rc_string, 1, "gtk_rc_parse_string", "gchar*");
  gtk_rc_parse_string(XEN_TO_C_gchar_(rc_string));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_reparse_all(void)
{
  #define H_gtk_rc_reparse_all "gboolean gtk_rc_reparse_all( void)"
  return(C_TO_XEN_gboolean(gtk_rc_reparse_all()));
}
static XEN gxg_gtk_rc_style_get_type(void)
{
  #define H_gtk_rc_style_get_type "GType gtk_rc_style_get_type( void)"
  return(C_TO_XEN_GType(gtk_rc_style_get_type()));
}
static XEN gxg_gtk_rc_style_new(void)
{
  #define H_gtk_rc_style_new "GtkRcStyle* gtk_rc_style_new( void)"
  return(C_TO_XEN_GtkRcStyle_(gtk_rc_style_new()));
}
static XEN gxg_gtk_rc_style_copy(XEN orig)
{
  #define H_gtk_rc_style_copy "GtkRcStyle* gtk_rc_style_copy(GtkRcStyle* orig)"
  XEN_ASSERT_TYPE(XEN_GtkRcStyle__P(orig), orig, 1, "gtk_rc_style_copy", "GtkRcStyle*");
  return(C_TO_XEN_GtkRcStyle_(gtk_rc_style_copy(XEN_TO_C_GtkRcStyle_(orig))));
}
static XEN gxg_gtk_rc_style_ref(XEN rc_style)
{
  #define H_gtk_rc_style_ref "void gtk_rc_style_ref(GtkRcStyle* rc_style)"
  XEN_ASSERT_TYPE(XEN_GtkRcStyle__P(rc_style), rc_style, 1, "gtk_rc_style_ref", "GtkRcStyle*");
  gtk_rc_style_ref(XEN_TO_C_GtkRcStyle_(rc_style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_style_unref(XEN rc_style)
{
  #define H_gtk_rc_style_unref "void gtk_rc_style_unref(GtkRcStyle* rc_style)"
  XEN_ASSERT_TYPE(XEN_GtkRcStyle__P(rc_style), rc_style, 1, "gtk_rc_style_unref", "GtkRcStyle*");
  gtk_rc_style_unref(XEN_TO_C_GtkRcStyle_(rc_style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_rc_find_module_in_path(XEN module_file)
{
  #define H_gtk_rc_find_module_in_path "gchar* gtk_rc_find_module_in_path(gchar* module_file)"
  XEN_ASSERT_TYPE(XEN_gchar__P(module_file), module_file, 1, "gtk_rc_find_module_in_path", "gchar*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_rc_find_module_in_path(XEN_TO_C_gchar_(module_file));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_rc_get_theme_dir(void)
{
  #define H_gtk_rc_get_theme_dir "gchar* gtk_rc_get_theme_dir( void)"
  {
   gchar* result;
   XEN rtn;
   result = gtk_rc_get_theme_dir();
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_rc_get_module_dir(void)
{
  #define H_gtk_rc_get_module_dir "gchar* gtk_rc_get_module_dir( void)"
  {
   gchar* result;
   XEN rtn;
   result = gtk_rc_get_module_dir();
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_rc_get_im_module_path(void)
{
  #define H_gtk_rc_get_im_module_path "gchar* gtk_rc_get_im_module_path( void)"
  {
   gchar* result;
   XEN rtn;
   result = gtk_rc_get_im_module_path();
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_rc_get_im_module_file(void)
{
  #define H_gtk_rc_get_im_module_file "gchar* gtk_rc_get_im_module_file( void)"
  {
   gchar* result;
   XEN rtn;
   result = gtk_rc_get_im_module_file();
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_rc_scanner_new(void)
{
  #define H_gtk_rc_scanner_new "GScanner* gtk_rc_scanner_new( void)"
  return(C_TO_XEN_GScanner_(gtk_rc_scanner_new()));
}
static XEN gxg_gtk_rc_parse_color(XEN scanner, XEN color)
{
  #define H_gtk_rc_parse_color "guint gtk_rc_parse_color(GScanner* scanner, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GScanner__P(scanner), scanner, 1, "gtk_rc_parse_color", "GScanner*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_rc_parse_color", "GdkColor*");
  return(C_TO_XEN_guint(gtk_rc_parse_color(XEN_TO_C_GScanner_(scanner), XEN_TO_C_GdkColor_(color))));
}
static XEN gxg_gtk_rc_parse_state(XEN scanner, XEN state)
{
  #define H_gtk_rc_parse_state "guint gtk_rc_parse_state(GScanner* scanner, GtkStateType* [state])"
  GtkStateType ref_state;
  XEN_ASSERT_TYPE(XEN_GScanner__P(scanner), scanner, 1, "gtk_rc_parse_state", "GScanner*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_guint(gtk_rc_parse_state(XEN_TO_C_GScanner_(scanner), &ref_state));
    return(XEN_LIST_2(result, C_TO_XEN_GtkStateType(ref_state)));
   }
}
static XEN gxg_gtk_rc_parse_priority(XEN scanner, XEN priority)
{
  #define H_gtk_rc_parse_priority "guint gtk_rc_parse_priority(GScanner* scanner, GtkPathPriorityType* [priority])"
  GtkPathPriorityType ref_priority;
  XEN_ASSERT_TYPE(XEN_GScanner__P(scanner), scanner, 1, "gtk_rc_parse_priority", "GScanner*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_guint(gtk_rc_parse_priority(XEN_TO_C_GScanner_(scanner), &ref_priority));
    return(XEN_LIST_2(result, C_TO_XEN_GtkPathPriorityType(ref_priority)));
   }
}
static XEN gxg_gtk_ruler_get_type(void)
{
  #define H_gtk_ruler_get_type "GtkType gtk_ruler_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_ruler_get_type()));
}
static XEN gxg_gtk_ruler_set_metric(XEN ruler, XEN metric)
{
  #define H_gtk_ruler_set_metric "void gtk_ruler_set_metric(GtkRuler* ruler, GtkMetricType metric)"
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_set_metric", "GtkRuler*");
  XEN_ASSERT_TYPE(XEN_GtkMetricType_P(metric), metric, 2, "gtk_ruler_set_metric", "GtkMetricType");
  gtk_ruler_set_metric(XEN_TO_C_GtkRuler_(ruler), XEN_TO_C_GtkMetricType(metric));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ruler_set_range(XEN ruler, XEN lower, XEN upper, XEN position, XEN max_size)
{
  #define H_gtk_ruler_set_range "void gtk_ruler_set_range(GtkRuler* ruler, gdouble lower, gdouble upper, \
gdouble position, gdouble max_size)"
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_set_range", "GtkRuler*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(lower), lower, 2, "gtk_ruler_set_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(upper), upper, 3, "gtk_ruler_set_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(position), position, 4, "gtk_ruler_set_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max_size), max_size, 5, "gtk_ruler_set_range", "gdouble");
  gtk_ruler_set_range(XEN_TO_C_GtkRuler_(ruler), XEN_TO_C_gdouble(lower), XEN_TO_C_gdouble(upper), XEN_TO_C_gdouble(position), 
                      XEN_TO_C_gdouble(max_size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ruler_draw_ticks(XEN ruler)
{
  #define H_gtk_ruler_draw_ticks "void gtk_ruler_draw_ticks(GtkRuler* ruler)"
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_draw_ticks", "GtkRuler*");
  gtk_ruler_draw_ticks(XEN_TO_C_GtkRuler_(ruler));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ruler_draw_pos(XEN ruler)
{
  #define H_gtk_ruler_draw_pos "void gtk_ruler_draw_pos(GtkRuler* ruler)"
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_draw_pos", "GtkRuler*");
  gtk_ruler_draw_pos(XEN_TO_C_GtkRuler_(ruler));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ruler_get_metric(XEN ruler)
{
  #define H_gtk_ruler_get_metric "GtkMetricType gtk_ruler_get_metric(GtkRuler* ruler)"
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_get_metric", "GtkRuler*");
  return(C_TO_XEN_GtkMetricType(gtk_ruler_get_metric(XEN_TO_C_GtkRuler_(ruler))));
}
static XEN gxg_gtk_ruler_get_range(XEN ruler, XEN lower, XEN upper, XEN position, XEN max_size)
{
  #define H_gtk_ruler_get_range "void gtk_ruler_get_range(GtkRuler* ruler, gdouble* [lower], gdouble* [upper], \
gdouble* [position], gdouble* [max_size])"
  gdouble ref_lower;
  gdouble ref_upper;
  gdouble ref_position;
  gdouble ref_max_size;
  XEN_ASSERT_TYPE(XEN_GtkRuler__P(ruler), ruler, 1, "gtk_ruler_get_range", "GtkRuler*");
  gtk_ruler_get_range(XEN_TO_C_GtkRuler_(ruler), &ref_lower, &ref_upper, &ref_position, &ref_max_size);
  return(XEN_LIST_4(C_TO_XEN_gdouble(ref_lower), C_TO_XEN_gdouble(ref_upper), C_TO_XEN_gdouble(ref_position), C_TO_XEN_gdouble(ref_max_size)));
}
static XEN gxg_gtk_scale_get_type(void)
{
  #define H_gtk_scale_get_type "GtkType gtk_scale_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_scale_get_type()));
}
static XEN gxg_gtk_scale_set_digits(XEN scale, XEN digits)
{
  #define H_gtk_scale_set_digits "void gtk_scale_set_digits(GtkScale* scale, gint digits)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_set_digits", "GtkScale*");
  XEN_ASSERT_TYPE(XEN_gint_P(digits), digits, 2, "gtk_scale_set_digits", "gint");
  gtk_scale_set_digits(XEN_TO_C_GtkScale_(scale), XEN_TO_C_gint(digits));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scale_get_digits(XEN scale)
{
  #define H_gtk_scale_get_digits "gint gtk_scale_get_digits(GtkScale* scale)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_get_digits", "GtkScale*");
  return(C_TO_XEN_gint(gtk_scale_get_digits(XEN_TO_C_GtkScale_(scale))));
}
static XEN gxg_gtk_scale_set_draw_value(XEN scale, XEN draw_value)
{
  #define H_gtk_scale_set_draw_value "void gtk_scale_set_draw_value(GtkScale* scale, gboolean draw_value)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_set_draw_value", "GtkScale*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(draw_value), draw_value, 2, "gtk_scale_set_draw_value", "gboolean");
  gtk_scale_set_draw_value(XEN_TO_C_GtkScale_(scale), XEN_TO_C_gboolean(draw_value));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scale_get_draw_value(XEN scale)
{
  #define H_gtk_scale_get_draw_value "gboolean gtk_scale_get_draw_value(GtkScale* scale)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_get_draw_value", "GtkScale*");
  return(C_TO_XEN_gboolean(gtk_scale_get_draw_value(XEN_TO_C_GtkScale_(scale))));
}
static XEN gxg_gtk_scale_set_value_pos(XEN scale, XEN pos)
{
  #define H_gtk_scale_set_value_pos "void gtk_scale_set_value_pos(GtkScale* scale, GtkPositionType pos)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_set_value_pos", "GtkScale*");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(pos), pos, 2, "gtk_scale_set_value_pos", "GtkPositionType");
  gtk_scale_set_value_pos(XEN_TO_C_GtkScale_(scale), XEN_TO_C_GtkPositionType(pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scale_get_value_pos(XEN scale)
{
  #define H_gtk_scale_get_value_pos "GtkPositionType gtk_scale_get_value_pos(GtkScale* scale)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_get_value_pos", "GtkScale*");
  return(C_TO_XEN_GtkPositionType(gtk_scale_get_value_pos(XEN_TO_C_GtkScale_(scale))));
}
static XEN gxg_gtk_scrollbar_get_type(void)
{
  #define H_gtk_scrollbar_get_type "GtkType gtk_scrollbar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_scrollbar_get_type()));
}
static XEN gxg_gtk_scrolled_window_get_type(void)
{
  #define H_gtk_scrolled_window_get_type "GtkType gtk_scrolled_window_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_scrolled_window_get_type()));
}
static XEN gxg_gtk_scrolled_window_new(XEN hadjustment, XEN vadjustment)
{
  #define H_gtk_scrolled_window_new "GtkWidget* gtk_scrolled_window_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 1, "gtk_scrolled_window_new", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(vadjustment) || XEN_FALSE_P(vadjustment), vadjustment, 2, "gtk_scrolled_window_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_scrolled_window_new(XEN_TO_C_GtkAdjustment_(hadjustment), XEN_TO_C_GtkAdjustment_(vadjustment))));
}
static XEN gxg_gtk_scrolled_window_set_hadjustment(XEN scrolled_window, XEN hadjustment)
{
  #define H_gtk_scrolled_window_set_hadjustment "void gtk_scrolled_window_set_hadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_hadjustment", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 2, "gtk_scrolled_window_set_hadjustment", "GtkAdjustment*");
  gtk_scrolled_window_set_hadjustment(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkAdjustment_(hadjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scrolled_window_set_vadjustment(XEN scrolled_window, XEN hadjustment)
{
  #define H_gtk_scrolled_window_set_vadjustment "void gtk_scrolled_window_set_vadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_vadjustment", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 2, "gtk_scrolled_window_set_vadjustment", "GtkAdjustment*");
  gtk_scrolled_window_set_vadjustment(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkAdjustment_(hadjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scrolled_window_get_hadjustment(XEN scrolled_window)
{
  #define H_gtk_scrolled_window_get_hadjustment "GtkAdjustment* gtk_scrolled_window_get_hadjustment(GtkScrolledWindow* scrolled_window)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_hadjustment", "GtkScrolledWindow*");
  return(C_TO_XEN_GtkAdjustment_(gtk_scrolled_window_get_hadjustment(XEN_TO_C_GtkScrolledWindow_(scrolled_window))));
}
static XEN gxg_gtk_scrolled_window_get_vadjustment(XEN scrolled_window)
{
  #define H_gtk_scrolled_window_get_vadjustment "GtkAdjustment* gtk_scrolled_window_get_vadjustment(GtkScrolledWindow* scrolled_window)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_vadjustment", "GtkScrolledWindow*");
  return(C_TO_XEN_GtkAdjustment_(gtk_scrolled_window_get_vadjustment(XEN_TO_C_GtkScrolledWindow_(scrolled_window))));
}
static XEN gxg_gtk_scrolled_window_set_policy(XEN scrolled_window, XEN hscrollbar_policy, XEN vscrollbar_policy)
{
  #define H_gtk_scrolled_window_set_policy "void gtk_scrolled_window_set_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType hscrollbar_policy, GtkPolicyType vscrollbar_policy)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_policy", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkPolicyType_P(hscrollbar_policy), hscrollbar_policy, 2, "gtk_scrolled_window_set_policy", "GtkPolicyType");
  XEN_ASSERT_TYPE(XEN_GtkPolicyType_P(vscrollbar_policy), vscrollbar_policy, 3, "gtk_scrolled_window_set_policy", "GtkPolicyType");
  gtk_scrolled_window_set_policy(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkPolicyType(hscrollbar_policy), 
                                 XEN_TO_C_GtkPolicyType(vscrollbar_policy));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scrolled_window_get_policy(XEN scrolled_window, XEN hscrollbar_policy, XEN vscrollbar_policy)
{
  #define H_gtk_scrolled_window_get_policy "void gtk_scrolled_window_get_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType* [hscrollbar_policy], GtkPolicyType* [vscrollbar_policy])"
  GtkPolicyType ref_hscrollbar_policy;
  GtkPolicyType ref_vscrollbar_policy;
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_policy", "GtkScrolledWindow*");
  gtk_scrolled_window_get_policy(XEN_TO_C_GtkScrolledWindow_(scrolled_window), &ref_hscrollbar_policy, &ref_vscrollbar_policy);
  return(XEN_LIST_2(C_TO_XEN_GtkPolicyType(ref_hscrollbar_policy), C_TO_XEN_GtkPolicyType(ref_vscrollbar_policy)));
}
static XEN gxg_gtk_scrolled_window_set_placement(XEN scrolled_window, XEN window_placement)
{
  #define H_gtk_scrolled_window_set_placement "void gtk_scrolled_window_set_placement(GtkScrolledWindow* scrolled_window, \
GtkCornerType window_placement)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_placement", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkCornerType_P(window_placement), window_placement, 2, "gtk_scrolled_window_set_placement", "GtkCornerType");
  gtk_scrolled_window_set_placement(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkCornerType(window_placement));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scrolled_window_get_placement(XEN scrolled_window)
{
  #define H_gtk_scrolled_window_get_placement "GtkCornerType gtk_scrolled_window_get_placement(GtkScrolledWindow* scrolled_window)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_placement", "GtkScrolledWindow*");
  return(C_TO_XEN_GtkCornerType(gtk_scrolled_window_get_placement(XEN_TO_C_GtkScrolledWindow_(scrolled_window))));
}
static XEN gxg_gtk_scrolled_window_set_shadow_type(XEN scrolled_window, XEN type)
{
  #define H_gtk_scrolled_window_set_shadow_type "void gtk_scrolled_window_set_shadow_type(GtkScrolledWindow* scrolled_window, \
GtkShadowType type)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_shadow_type", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(type), type, 2, "gtk_scrolled_window_set_shadow_type", "GtkShadowType");
  gtk_scrolled_window_set_shadow_type(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkShadowType(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_scrolled_window_get_shadow_type(XEN scrolled_window)
{
  #define H_gtk_scrolled_window_get_shadow_type "GtkShadowType gtk_scrolled_window_get_shadow_type(GtkScrolledWindow* scrolled_window)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_shadow_type", "GtkScrolledWindow*");
  return(C_TO_XEN_GtkShadowType(gtk_scrolled_window_get_shadow_type(XEN_TO_C_GtkScrolledWindow_(scrolled_window))));
}
static XEN gxg_gtk_scrolled_window_add_with_viewport(XEN scrolled_window, XEN child)
{
  #define H_gtk_scrolled_window_add_with_viewport "void gtk_scrolled_window_add_with_viewport(GtkScrolledWindow* scrolled_window, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkScrolledWindow__P(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_add_with_viewport", "GtkScrolledWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_scrolled_window_add_with_viewport", "GtkWidget*");
  gtk_scrolled_window_add_with_viewport(XEN_TO_C_GtkScrolledWindow_(scrolled_window), XEN_TO_C_GtkWidget_(child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_new(XEN targets, XEN ntargets)
{
  #define H_gtk_target_list_new "GtkTargetList* gtk_target_list_new(GtkTargetEntry* targets, guint ntargets)"
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets) || XEN_FALSE_P(targets), targets, 1, "gtk_target_list_new", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(ntargets), ntargets, 2, "gtk_target_list_new", "guint");
  return(C_TO_XEN_GtkTargetList_(gtk_target_list_new(XEN_TO_C_GtkTargetEntry_(targets), XEN_TO_C_guint(ntargets))));
}
static XEN gxg_gtk_target_list_ref(XEN list)
{
  #define H_gtk_target_list_ref "void gtk_target_list_ref(GtkTargetList* list)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_ref", "GtkTargetList*");
  gtk_target_list_ref(XEN_TO_C_GtkTargetList_(list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_unref(XEN list)
{
  #define H_gtk_target_list_unref "void gtk_target_list_unref(GtkTargetList* list)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_unref", "GtkTargetList*");
  gtk_target_list_unref(XEN_TO_C_GtkTargetList_(list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_add(XEN list, XEN target, XEN flags, XEN info)
{
  #define H_gtk_target_list_add "void gtk_target_list_add(GtkTargetList* list, GdkAtom target, guint flags, \
guint info)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_add", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_target_list_add", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint_P(flags), flags, 3, "gtk_target_list_add", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(info), info, 4, "gtk_target_list_add", "guint");
  gtk_target_list_add(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_GdkAtom(target), XEN_TO_C_guint(flags), XEN_TO_C_guint(info));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_add_table(XEN list, XEN targets, XEN ntargets)
{
  #define H_gtk_target_list_add_table "void gtk_target_list_add_table(GtkTargetList* list, GtkTargetEntry* targets, \
guint ntargets)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_add_table", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 2, "gtk_target_list_add_table", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(ntargets), ntargets, 3, "gtk_target_list_add_table", "guint");
  gtk_target_list_add_table(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_GtkTargetEntry_(targets), XEN_TO_C_guint(ntargets));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_remove(XEN list, XEN target)
{
  #define H_gtk_target_list_remove "void gtk_target_list_remove(GtkTargetList* list, GdkAtom target)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_remove", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_target_list_remove", "GdkAtom");
  gtk_target_list_remove(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_GdkAtom(target));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_find(XEN list, XEN target, XEN info)
{
  #define H_gtk_target_list_find "gboolean gtk_target_list_find(GtkTargetList* list, GdkAtom target, \
guint* [info])"
  guint ref_info;
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_find", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_target_list_find", "GdkAtom");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_target_list_find(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_GdkAtom(target), &ref_info));
    return(XEN_LIST_2(result, C_TO_XEN_guint(ref_info)));
   }
}
static XEN gxg_gtk_selection_owner_set(XEN widget, XEN selection, XEN time)
{
  #define H_gtk_selection_owner_set "gboolean gtk_selection_owner_set(GtkWidget* widget, GdkAtom selection, \
guint32 time)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget) || XEN_FALSE_P(widget), widget, 1, "gtk_selection_owner_set", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_selection_owner_set", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 3, "gtk_selection_owner_set", "guint32");
  return(C_TO_XEN_gboolean(gtk_selection_owner_set(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection), XEN_TO_C_guint32(time))));
}
static XEN gxg_gtk_selection_add_target(XEN widget, XEN selection, XEN target, XEN info)
{
  #define H_gtk_selection_add_target "void gtk_selection_add_target(GtkWidget* widget, GdkAtom selection, \
GdkAtom target, guint info)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_selection_add_target", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_selection_add_target", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 3, "gtk_selection_add_target", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint_P(info), info, 4, "gtk_selection_add_target", "guint");
  gtk_selection_add_target(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection), XEN_TO_C_GdkAtom(target), XEN_TO_C_guint(info));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_add_targets(XEN widget, XEN selection, XEN targets, XEN ntargets)
{
  #define H_gtk_selection_add_targets "void gtk_selection_add_targets(GtkWidget* widget, GdkAtom selection, \
GtkTargetEntry* targets, guint ntargets)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_selection_add_targets", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_selection_add_targets", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 3, "gtk_selection_add_targets", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(ntargets), ntargets, 4, "gtk_selection_add_targets", "guint");
  gtk_selection_add_targets(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection), XEN_TO_C_GtkTargetEntry_(targets), 
                            XEN_TO_C_guint(ntargets));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_clear_targets(XEN widget, XEN selection)
{
  #define H_gtk_selection_clear_targets "void gtk_selection_clear_targets(GtkWidget* widget, GdkAtom selection)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_selection_clear_targets", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_selection_clear_targets", "GdkAtom");
  gtk_selection_clear_targets(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_convert(XEN widget, XEN selection, XEN target, XEN time)
{
  #define H_gtk_selection_convert "gboolean gtk_selection_convert(GtkWidget* widget, GdkAtom selection, \
GdkAtom target, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_selection_convert", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_selection_convert", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 3, "gtk_selection_convert", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 4, "gtk_selection_convert", "guint32");
  return(C_TO_XEN_gboolean(gtk_selection_convert(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection), XEN_TO_C_GdkAtom(target), 
                                                 XEN_TO_C_guint32(time))));
}
static XEN gxg_gtk_selection_data_set(XEN selection_data, XEN type, XEN format, XEN data, XEN length)
{
  #define H_gtk_selection_data_set "void gtk_selection_data_set(GtkSelectionData* selection_data, GdkAtom type, \
gint format, guchar* data, gint length)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_set", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(type), type, 2, "gtk_selection_data_set", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_gint_P(format), format, 3, "gtk_selection_data_set", "gint");
  XEN_ASSERT_TYPE(XEN_guchar__P(data), data, 4, "gtk_selection_data_set", "guchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(length), length, 5, "gtk_selection_data_set", "gint");
  gtk_selection_data_set(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_GdkAtom(type), XEN_TO_C_gint(format), XEN_TO_C_guchar_(data), 
                         XEN_TO_C_gint(length));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_data_set_text(XEN selection_data, XEN str, XEN len)
{
  #define H_gtk_selection_data_set_text "gboolean gtk_selection_data_set_text(GtkSelectionData* selection_data, \
gchar* str, gint len)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_set_text", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_selection_data_set_text", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_selection_data_set_text", "gint");
  return(C_TO_XEN_gboolean(gtk_selection_data_set_text(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_gchar_(str), 
                                                       XEN_TO_C_gint(len))));
}
static XEN gxg_gtk_selection_data_get_text(XEN selection_data)
{
  #define H_gtk_selection_data_get_text "guchar* gtk_selection_data_get_text(GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_get_text", "GtkSelectionData*");
  {
   guchar* result;
   XEN rtn;
   result = gtk_selection_data_get_text(XEN_TO_C_GtkSelectionData_(selection_data));
   rtn = C_TO_XEN_guchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_selection_data_get_targets(XEN selection_data, XEN targets, XEN n_atoms)
{
  #define H_gtk_selection_data_get_targets "gboolean gtk_selection_data_get_targets(GtkSelectionData* selection_data, \
GdkAtom** [targets], gint* [n_atoms])"
  GdkAtom* ref_targets = NULL;
  gint ref_n_atoms;
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_get_targets", "GtkSelectionData*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_selection_data_get_targets(XEN_TO_C_GtkSelectionData_(selection_data), &ref_targets, &ref_n_atoms));
    return(XEN_LIST_3(result, C_TO_XEN_GdkAtom_(ref_targets), C_TO_XEN_gint(ref_n_atoms)));
   }
}
static XEN gxg_gtk_selection_data_targets_include_text(XEN selection_data)
{
  #define H_gtk_selection_data_targets_include_text "gboolean gtk_selection_data_targets_include_text(GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_targets_include_text", "GtkSelectionData*");
  return(C_TO_XEN_gboolean(gtk_selection_data_targets_include_text(XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_selection_remove_all(XEN widget)
{
  #define H_gtk_selection_remove_all "void gtk_selection_remove_all(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_selection_remove_all", "GtkWidget*");
  gtk_selection_remove_all(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_data_copy(XEN data)
{
  #define H_gtk_selection_data_copy "GtkSelectionData* gtk_selection_data_copy(GtkSelectionData* data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(data), data, 1, "gtk_selection_data_copy", "GtkSelectionData*");
  return(C_TO_XEN_GtkSelectionData_(gtk_selection_data_copy(XEN_TO_C_GtkSelectionData_(data))));
}
static XEN gxg_gtk_selection_data_free(XEN data)
{
  #define H_gtk_selection_data_free "void gtk_selection_data_free(GtkSelectionData* data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(data), data, 1, "gtk_selection_data_free", "GtkSelectionData*");
  gtk_selection_data_free(XEN_TO_C_GtkSelectionData_(data));
  return(XEN_FALSE);
}
static XEN gxg_gtk_separator_get_type(void)
{
  #define H_gtk_separator_get_type "GtkType gtk_separator_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_separator_get_type()));
}
static XEN gxg_gtk_separator_menu_item_get_type(void)
{
  #define H_gtk_separator_menu_item_get_type "GType gtk_separator_menu_item_get_type( void)"
  return(C_TO_XEN_GType(gtk_separator_menu_item_get_type()));
}
static XEN gxg_gtk_separator_menu_item_new(void)
{
  #define H_gtk_separator_menu_item_new "GtkWidget* gtk_separator_menu_item_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_separator_menu_item_new()));
}
static XEN gxg_gtk_size_group_get_type(void)
{
  #define H_gtk_size_group_get_type "GType gtk_size_group_get_type( void)"
  return(C_TO_XEN_GType(gtk_size_group_get_type()));
}
static XEN gxg_gtk_size_group_new(XEN mode)
{
  #define H_gtk_size_group_new "GtkSizeGroup* gtk_size_group_new(GtkSizeGroupMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkSizeGroupMode_P(mode), mode, 1, "gtk_size_group_new", "GtkSizeGroupMode");
  return(C_TO_XEN_GtkSizeGroup_(gtk_size_group_new(XEN_TO_C_GtkSizeGroupMode(mode))));
}
static XEN gxg_gtk_size_group_set_mode(XEN size_group, XEN mode)
{
  #define H_gtk_size_group_set_mode "void gtk_size_group_set_mode(GtkSizeGroup* size_group, GtkSizeGroupMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkSizeGroup__P(size_group), size_group, 1, "gtk_size_group_set_mode", "GtkSizeGroup*");
  XEN_ASSERT_TYPE(XEN_GtkSizeGroupMode_P(mode), mode, 2, "gtk_size_group_set_mode", "GtkSizeGroupMode");
  gtk_size_group_set_mode(XEN_TO_C_GtkSizeGroup_(size_group), XEN_TO_C_GtkSizeGroupMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_size_group_get_mode(XEN size_group)
{
  #define H_gtk_size_group_get_mode "GtkSizeGroupMode gtk_size_group_get_mode(GtkSizeGroup* size_group)"
  XEN_ASSERT_TYPE(XEN_GtkSizeGroup__P(size_group), size_group, 1, "gtk_size_group_get_mode", "GtkSizeGroup*");
  return(C_TO_XEN_GtkSizeGroupMode(gtk_size_group_get_mode(XEN_TO_C_GtkSizeGroup_(size_group))));
}
static XEN gxg_gtk_size_group_add_widget(XEN size_group, XEN widget)
{
  #define H_gtk_size_group_add_widget "void gtk_size_group_add_widget(GtkSizeGroup* size_group, GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkSizeGroup__P(size_group), size_group, 1, "gtk_size_group_add_widget", "GtkSizeGroup*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_size_group_add_widget", "GtkWidget*");
  gtk_size_group_add_widget(XEN_TO_C_GtkSizeGroup_(size_group), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_size_group_remove_widget(XEN size_group, XEN widget)
{
  #define H_gtk_size_group_remove_widget "void gtk_size_group_remove_widget(GtkSizeGroup* size_group, \
GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkSizeGroup__P(size_group), size_group, 1, "gtk_size_group_remove_widget", "GtkSizeGroup*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_size_group_remove_widget", "GtkWidget*");
  gtk_size_group_remove_widget(XEN_TO_C_GtkSizeGroup_(size_group), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_socket_new(void)
{
  #define H_gtk_socket_new "GtkWidget* gtk_socket_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_socket_new()));
}
static XEN gxg_gtk_socket_get_type(void)
{
  #define H_gtk_socket_get_type "GtkType gtk_socket_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_socket_get_type()));
}
static XEN gxg_gtk_socket_add_id(XEN socket, XEN window_id)
{
  #define H_gtk_socket_add_id "void gtk_socket_add_id(GtkSocket* socket, GdkNativeWindow window_id)"
  XEN_ASSERT_TYPE(XEN_GtkSocket__P(socket), socket, 1, "gtk_socket_add_id", "GtkSocket*");
  XEN_ASSERT_TYPE(XEN_GdkNativeWindow_P(window_id), window_id, 2, "gtk_socket_add_id", "GdkNativeWindow");
  gtk_socket_add_id(XEN_TO_C_GtkSocket_(socket), XEN_TO_C_GdkNativeWindow(window_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_socket_get_id(XEN socket)
{
  #define H_gtk_socket_get_id "GdkNativeWindow gtk_socket_get_id(GtkSocket* socket)"
  XEN_ASSERT_TYPE(XEN_GtkSocket__P(socket), socket, 1, "gtk_socket_get_id", "GtkSocket*");
  return(C_TO_XEN_GdkNativeWindow(gtk_socket_get_id(XEN_TO_C_GtkSocket_(socket))));
}
static XEN gxg_gtk_spin_button_get_type(void)
{
  #define H_gtk_spin_button_get_type "GtkType gtk_spin_button_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_spin_button_get_type()));
}
static XEN gxg_gtk_spin_button_configure(XEN spin_button, XEN adjustment, XEN climb_rate, XEN digits)
{
  #define H_gtk_spin_button_configure "void gtk_spin_button_configure(GtkSpinButton* spin_button, GtkAdjustment* adjustment, \
gdouble climb_rate, guint digits)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_configure", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_spin_button_configure", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(climb_rate), climb_rate, 3, "gtk_spin_button_configure", "gdouble");
  XEN_ASSERT_TYPE(XEN_guint_P(digits), digits, 4, "gtk_spin_button_configure", "guint");
  gtk_spin_button_configure(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_GtkAdjustment_(adjustment), XEN_TO_C_gdouble(climb_rate), 
                            XEN_TO_C_guint(digits));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_new(XEN adjustment, XEN climb_rate, XEN digits)
{
  #define H_gtk_spin_button_new "GtkWidget* gtk_spin_button_new(GtkAdjustment* adjustment, gdouble climb_rate, \
guint digits)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 1, "gtk_spin_button_new", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(climb_rate), climb_rate, 2, "gtk_spin_button_new", "gdouble");
  XEN_ASSERT_TYPE(XEN_guint_P(digits), digits, 3, "gtk_spin_button_new", "guint");
  return(C_TO_XEN_GtkWidget_(gtk_spin_button_new(XEN_TO_C_GtkAdjustment_(adjustment), XEN_TO_C_gdouble(climb_rate), XEN_TO_C_guint(digits))));
}
static XEN gxg_gtk_spin_button_new_with_range(XEN min, XEN max, XEN step)
{
  #define H_gtk_spin_button_new_with_range "GtkWidget* gtk_spin_button_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  XEN_ASSERT_TYPE(XEN_gdouble_P(min), min, 1, "gtk_spin_button_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max), max, 2, "gtk_spin_button_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step), step, 3, "gtk_spin_button_new_with_range", "gdouble");
  return(C_TO_XEN_GtkWidget_(gtk_spin_button_new_with_range(XEN_TO_C_gdouble(min), XEN_TO_C_gdouble(max), XEN_TO_C_gdouble(step))));
}
static XEN gxg_gtk_spin_button_set_adjustment(XEN spin_button, XEN adjustment)
{
  #define H_gtk_spin_button_set_adjustment "void gtk_spin_button_set_adjustment(GtkSpinButton* spin_button, \
GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_adjustment", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_spin_button_set_adjustment", "GtkAdjustment*");
  gtk_spin_button_set_adjustment(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_adjustment(XEN spin_button)
{
  #define H_gtk_spin_button_get_adjustment "GtkAdjustment* gtk_spin_button_get_adjustment(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_adjustment", "GtkSpinButton*");
  return(C_TO_XEN_GtkAdjustment_(gtk_spin_button_get_adjustment(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_set_digits(XEN spin_button, XEN digits)
{
  #define H_gtk_spin_button_set_digits "void gtk_spin_button_set_digits(GtkSpinButton* spin_button, guint digits)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_digits", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_guint_P(digits), digits, 2, "gtk_spin_button_set_digits", "guint");
  gtk_spin_button_set_digits(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_guint(digits));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_digits(XEN spin_button)
{
  #define H_gtk_spin_button_get_digits "guint gtk_spin_button_get_digits(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_digits", "GtkSpinButton*");
  return(C_TO_XEN_guint(gtk_spin_button_get_digits(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_set_increments(XEN spin_button, XEN step, XEN page)
{
  #define H_gtk_spin_button_set_increments "void gtk_spin_button_set_increments(GtkSpinButton* spin_button, \
gdouble step, gdouble page)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_increments", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step), step, 2, "gtk_spin_button_set_increments", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(page), page, 3, "gtk_spin_button_set_increments", "gdouble");
  gtk_spin_button_set_increments(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gdouble(step), XEN_TO_C_gdouble(page));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_increments(XEN spin_button, XEN step, XEN page)
{
  #define H_gtk_spin_button_get_increments "void gtk_spin_button_get_increments(GtkSpinButton* spin_button, \
gdouble* [step], gdouble* [page])"
  gdouble ref_step;
  gdouble ref_page;
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_increments", "GtkSpinButton*");
  gtk_spin_button_get_increments(XEN_TO_C_GtkSpinButton_(spin_button), &ref_step, &ref_page);
  return(XEN_LIST_2(C_TO_XEN_gdouble(ref_step), C_TO_XEN_gdouble(ref_page)));
}
static XEN gxg_gtk_spin_button_set_range(XEN spin_button, XEN min, XEN max)
{
  #define H_gtk_spin_button_set_range "void gtk_spin_button_set_range(GtkSpinButton* spin_button, gdouble min, \
gdouble max)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_range", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(min), min, 2, "gtk_spin_button_set_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max), max, 3, "gtk_spin_button_set_range", "gdouble");
  gtk_spin_button_set_range(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gdouble(min), XEN_TO_C_gdouble(max));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_range(XEN spin_button, XEN min, XEN max)
{
  #define H_gtk_spin_button_get_range "void gtk_spin_button_get_range(GtkSpinButton* spin_button, gdouble* [min], \
gdouble* [max])"
  gdouble ref_min;
  gdouble ref_max;
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_range", "GtkSpinButton*");
  gtk_spin_button_get_range(XEN_TO_C_GtkSpinButton_(spin_button), &ref_min, &ref_max);
  return(XEN_LIST_2(C_TO_XEN_gdouble(ref_min), C_TO_XEN_gdouble(ref_max)));
}
static XEN gxg_gtk_spin_button_get_value(XEN spin_button)
{
  #define H_gtk_spin_button_get_value "gdouble gtk_spin_button_get_value(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_value", "GtkSpinButton*");
  return(C_TO_XEN_gdouble(gtk_spin_button_get_value(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_get_value_as_int(XEN spin_button)
{
  #define H_gtk_spin_button_get_value_as_int "gint gtk_spin_button_get_value_as_int(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_value_as_int", "GtkSpinButton*");
  return(C_TO_XEN_gint(gtk_spin_button_get_value_as_int(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_set_value(XEN spin_button, XEN value)
{
  #define H_gtk_spin_button_set_value "void gtk_spin_button_set_value(GtkSpinButton* spin_button, gdouble value)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_value", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(value), value, 2, "gtk_spin_button_set_value", "gdouble");
  gtk_spin_button_set_value(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gdouble(value));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_set_update_policy(XEN spin_button, XEN policy)
{
  #define H_gtk_spin_button_set_update_policy "void gtk_spin_button_set_update_policy(GtkSpinButton* spin_button, \
GtkSpinButtonUpdatePolicy policy)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_update_policy", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_GtkSpinButtonUpdatePolicy_P(policy), policy, 2, "gtk_spin_button_set_update_policy", "GtkSpinButtonUpdatePolicy");
  gtk_spin_button_set_update_policy(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_GtkSpinButtonUpdatePolicy(policy));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_update_policy(XEN spin_button)
{
  #define H_gtk_spin_button_get_update_policy "GtkSpinButtonUpdatePolicy gtk_spin_button_get_update_policy(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_update_policy", "GtkSpinButton*");
  return(C_TO_XEN_GtkSpinButtonUpdatePolicy(gtk_spin_button_get_update_policy(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_set_numeric(XEN spin_button, XEN numeric)
{
  #define H_gtk_spin_button_set_numeric "void gtk_spin_button_set_numeric(GtkSpinButton* spin_button, \
gboolean numeric)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_numeric", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(numeric), numeric, 2, "gtk_spin_button_set_numeric", "gboolean");
  gtk_spin_button_set_numeric(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gboolean(numeric));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_numeric(XEN spin_button)
{
  #define H_gtk_spin_button_get_numeric "gboolean gtk_spin_button_get_numeric(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_numeric", "GtkSpinButton*");
  return(C_TO_XEN_gboolean(gtk_spin_button_get_numeric(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_spin(XEN spin_button, XEN direction, XEN increment)
{
  #define H_gtk_spin_button_spin "void gtk_spin_button_spin(GtkSpinButton* spin_button, GtkSpinType direction, \
gdouble increment)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_spin", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_GtkSpinType_P(direction), direction, 2, "gtk_spin_button_spin", "GtkSpinType");
  XEN_ASSERT_TYPE(XEN_gdouble_P(increment), increment, 3, "gtk_spin_button_spin", "gdouble");
  gtk_spin_button_spin(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_GtkSpinType(direction), XEN_TO_C_gdouble(increment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_set_wrap(XEN spin_button, XEN wrap)
{
  #define H_gtk_spin_button_set_wrap "void gtk_spin_button_set_wrap(GtkSpinButton* spin_button, gboolean wrap)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_wrap", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(wrap), wrap, 2, "gtk_spin_button_set_wrap", "gboolean");
  gtk_spin_button_set_wrap(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gboolean(wrap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_wrap(XEN spin_button)
{
  #define H_gtk_spin_button_get_wrap "gboolean gtk_spin_button_get_wrap(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_wrap", "GtkSpinButton*");
  return(C_TO_XEN_gboolean(gtk_spin_button_get_wrap(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_set_snap_to_ticks(XEN spin_button, XEN snap_to_ticks)
{
  #define H_gtk_spin_button_set_snap_to_ticks "void gtk_spin_button_set_snap_to_ticks(GtkSpinButton* spin_button, \
gboolean snap_to_ticks)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_set_snap_to_ticks", "GtkSpinButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(snap_to_ticks), snap_to_ticks, 2, "gtk_spin_button_set_snap_to_ticks", "gboolean");
  gtk_spin_button_set_snap_to_ticks(XEN_TO_C_GtkSpinButton_(spin_button), XEN_TO_C_gboolean(snap_to_ticks));
  return(XEN_FALSE);
}
static XEN gxg_gtk_spin_button_get_snap_to_ticks(XEN spin_button)
{
  #define H_gtk_spin_button_get_snap_to_ticks "gboolean gtk_spin_button_get_snap_to_ticks(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_get_snap_to_ticks", "GtkSpinButton*");
  return(C_TO_XEN_gboolean(gtk_spin_button_get_snap_to_ticks(XEN_TO_C_GtkSpinButton_(spin_button))));
}
static XEN gxg_gtk_spin_button_update(XEN spin_button)
{
  #define H_gtk_spin_button_update "void gtk_spin_button_update(GtkSpinButton* spin_button)"
  XEN_ASSERT_TYPE(XEN_GtkSpinButton__P(spin_button), spin_button, 1, "gtk_spin_button_update", "GtkSpinButton*");
  gtk_spin_button_update(XEN_TO_C_GtkSpinButton_(spin_button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_statusbar_get_type(void)
{
  #define H_gtk_statusbar_get_type "GtkType gtk_statusbar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_statusbar_get_type()));
}
static XEN gxg_gtk_statusbar_new(void)
{
  #define H_gtk_statusbar_new "GtkWidget* gtk_statusbar_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_statusbar_new()));
}
static XEN gxg_gtk_statusbar_get_context_id(XEN statusbar, XEN context_description)
{
  #define H_gtk_statusbar_get_context_id "guint gtk_statusbar_get_context_id(GtkStatusbar* statusbar, \
gchar* context_description)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_get_context_id", "GtkStatusbar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(context_description), context_description, 2, "gtk_statusbar_get_context_id", "gchar*");
  return(C_TO_XEN_guint(gtk_statusbar_get_context_id(XEN_TO_C_GtkStatusbar_(statusbar), XEN_TO_C_gchar_(context_description))));
}
static XEN gxg_gtk_statusbar_push(XEN statusbar, XEN context_id, XEN text)
{
  #define H_gtk_statusbar_push "guint gtk_statusbar_push(GtkStatusbar* statusbar, guint context_id, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_push", "GtkStatusbar*");
  XEN_ASSERT_TYPE(XEN_guint_P(context_id), context_id, 2, "gtk_statusbar_push", "guint");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_statusbar_push", "gchar*");
  return(C_TO_XEN_guint(gtk_statusbar_push(XEN_TO_C_GtkStatusbar_(statusbar), XEN_TO_C_guint(context_id), XEN_TO_C_gchar_(text))));
}
static XEN gxg_gtk_statusbar_pop(XEN statusbar, XEN context_id)
{
  #define H_gtk_statusbar_pop "void gtk_statusbar_pop(GtkStatusbar* statusbar, guint context_id)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_pop", "GtkStatusbar*");
  XEN_ASSERT_TYPE(XEN_guint_P(context_id), context_id, 2, "gtk_statusbar_pop", "guint");
  gtk_statusbar_pop(XEN_TO_C_GtkStatusbar_(statusbar), XEN_TO_C_guint(context_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_statusbar_remove(XEN statusbar, XEN context_id, XEN message_id)
{
  #define H_gtk_statusbar_remove "void gtk_statusbar_remove(GtkStatusbar* statusbar, guint context_id, \
guint message_id)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_remove", "GtkStatusbar*");
  XEN_ASSERT_TYPE(XEN_guint_P(context_id), context_id, 2, "gtk_statusbar_remove", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(message_id), message_id, 3, "gtk_statusbar_remove", "guint");
  gtk_statusbar_remove(XEN_TO_C_GtkStatusbar_(statusbar), XEN_TO_C_guint(context_id), XEN_TO_C_guint(message_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_statusbar_set_has_resize_grip(XEN statusbar, XEN setting)
{
  #define H_gtk_statusbar_set_has_resize_grip "void gtk_statusbar_set_has_resize_grip(GtkStatusbar* statusbar, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_set_has_resize_grip", "GtkStatusbar*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_statusbar_set_has_resize_grip", "gboolean");
  gtk_statusbar_set_has_resize_grip(XEN_TO_C_GtkStatusbar_(statusbar), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_statusbar_get_has_resize_grip(XEN statusbar)
{
  #define H_gtk_statusbar_get_has_resize_grip "gboolean gtk_statusbar_get_has_resize_grip(GtkStatusbar* statusbar)"
  XEN_ASSERT_TYPE(XEN_GtkStatusbar__P(statusbar), statusbar, 1, "gtk_statusbar_get_has_resize_grip", "GtkStatusbar*");
  return(C_TO_XEN_gboolean(gtk_statusbar_get_has_resize_grip(XEN_TO_C_GtkStatusbar_(statusbar))));
}
static XEN gxg_gtk_stock_add(XEN items, XEN n_items)
{
  #define H_gtk_stock_add "void gtk_stock_add(GtkStockItem* items, guint n_items)"
  XEN_ASSERT_TYPE(XEN_GtkStockItem__P(items), items, 1, "gtk_stock_add", "GtkStockItem*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_items), n_items, 2, "gtk_stock_add", "guint");
  gtk_stock_add(XEN_TO_C_GtkStockItem_(items), XEN_TO_C_guint(n_items));
  return(XEN_FALSE);
}
static XEN gxg_gtk_stock_add_static(XEN items, XEN n_items)
{
  #define H_gtk_stock_add_static "void gtk_stock_add_static(GtkStockItem* items, guint n_items)"
  XEN_ASSERT_TYPE(XEN_GtkStockItem__P(items), items, 1, "gtk_stock_add_static", "GtkStockItem*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_items), n_items, 2, "gtk_stock_add_static", "guint");
  gtk_stock_add_static(XEN_TO_C_GtkStockItem_(items), XEN_TO_C_guint(n_items));
  return(XEN_FALSE);
}
static XEN gxg_gtk_stock_lookup(XEN stock_id, XEN item)
{
  #define H_gtk_stock_lookup "gboolean gtk_stock_lookup(gchar* stock_id, GtkStockItem* item)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_stock_lookup", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkStockItem__P(item), item, 2, "gtk_stock_lookup", "GtkStockItem*");
  return(C_TO_XEN_gboolean(gtk_stock_lookup(XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkStockItem_(item))));
}
static XEN gxg_gtk_stock_list_ids(void)
{
  #define H_gtk_stock_list_ids "GSList* gtk_stock_list_ids( void)"
  return(C_TO_XEN_GSList_(gtk_stock_list_ids()));
}
static XEN gxg_gtk_stock_item_copy(XEN item)
{
  #define H_gtk_stock_item_copy "GtkStockItem* gtk_stock_item_copy(GtkStockItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkStockItem__P(item), item, 1, "gtk_stock_item_copy", "GtkStockItem*");
  return(C_TO_XEN_GtkStockItem_(gtk_stock_item_copy(XEN_TO_C_GtkStockItem_(item))));
}
static XEN gxg_gtk_stock_item_free(XEN item)
{
  #define H_gtk_stock_item_free "void gtk_stock_item_free(GtkStockItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkStockItem__P(item), item, 1, "gtk_stock_item_free", "GtkStockItem*");
  gtk_stock_item_free(XEN_TO_C_GtkStockItem_(item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_style_get_type(void)
{
  #define H_gtk_style_get_type "GType gtk_style_get_type( void)"
  return(C_TO_XEN_GType(gtk_style_get_type()));
}
static XEN gxg_gtk_style_new(void)
{
  #define H_gtk_style_new "GtkStyle* gtk_style_new( void)"
  return(C_TO_XEN_GtkStyle_(gtk_style_new()));
}
static XEN gxg_gtk_style_copy(XEN style)
{
  #define H_gtk_style_copy "GtkStyle* gtk_style_copy(GtkStyle* style)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_copy", "GtkStyle*");
  return(C_TO_XEN_GtkStyle_(gtk_style_copy(XEN_TO_C_GtkStyle_(style))));
}
static XEN gxg_gtk_style_attach(XEN style, XEN window)
{
  #define H_gtk_style_attach "GtkStyle* gtk_style_attach(GtkStyle* style, GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_attach", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_style_attach", "GdkWindow*");
  return(C_TO_XEN_GtkStyle_(gtk_style_attach(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gtk_style_detach(XEN style)
{
  #define H_gtk_style_detach "void gtk_style_detach(GtkStyle* style)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_detach", "GtkStyle*");
  gtk_style_detach(XEN_TO_C_GtkStyle_(style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_style_set_background(XEN style, XEN window, XEN state_type)
{
  #define H_gtk_style_set_background "void gtk_style_set_background(GtkStyle* style, GdkWindow* window, \
GtkStateType state_type)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_set_background", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_style_set_background", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_style_set_background", "GtkStateType");
  gtk_style_set_background(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_style_apply_default_background(XEN style, XEN window, XEN set_bg, XEN state_type, XEN area, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gtk_style_apply_default_background "void gtk_style_apply_default_background(GtkStyle* style, \
GdkWindow* window, gboolean set_bg, GtkStateType state_type, GdkRectangle* area, gint x, gint y, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_apply_default_background", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_style_apply_default_background", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(set_bg), set_bg, 3, "gtk_style_apply_default_background", "gboolean");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 4, "gtk_style_apply_default_background", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_style_apply_default_background", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 6, "gtk_style_apply_default_background", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 7, "gtk_style_apply_default_background", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 8, "gtk_style_apply_default_background", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 9, "gtk_style_apply_default_background", "gint");
  gtk_style_apply_default_background(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(set_bg), XEN_TO_C_GtkStateType(state_type), 
                                     XEN_TO_C_GdkRectangle_(area), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                                     XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_style_lookup_icon_set(XEN style, XEN stock_id)
{
  #define H_gtk_style_lookup_icon_set "GtkIconSet* gtk_style_lookup_icon_set(GtkStyle* style, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_lookup_icon_set", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_style_lookup_icon_set", "gchar*");
  return(C_TO_XEN_GtkIconSet_(gtk_style_lookup_icon_set(XEN_TO_C_GtkStyle_(style), XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_style_render_icon(XEN style, XEN source, XEN direction, XEN state, XEN size, XEN widget, XEN detail)
{
  #define H_gtk_style_render_icon "GdkPixbuf* gtk_style_render_icon(GtkStyle* style, GtkIconSource* source, \
GtkTextDirection direction, GtkStateType state, GtkIconSize size, GtkWidget* widget, gchar* detail)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_style_render_icon", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 2, "gtk_style_render_icon", "GtkIconSource*");
  XEN_ASSERT_TYPE(XEN_GtkTextDirection_P(direction), direction, 3, "gtk_style_render_icon", "GtkTextDirection");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 4, "gtk_style_render_icon", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 5, "gtk_style_render_icon", "GtkIconSize");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_style_render_icon", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_style_render_icon", "gchar*");
  return(C_TO_XEN_GdkPixbuf_(gtk_style_render_icon(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GtkIconSource_(source), XEN_TO_C_GtkTextDirection(direction), 
                                                   XEN_TO_C_GtkStateType(state), XEN_TO_C_GtkIconSize(size), XEN_TO_C_GtkWidget_(widget), 
                                                   XEN_TO_C_gchar_(detail))));
}
static XEN gxg_gtk_paint_hline(XEN style, XEN window, XEN state_type, XEN area, XEN widget, XEN detail, XEN x1, XEN x2, XEN y)
{
  #define H_gtk_paint_hline "void gtk_paint_hline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x1, gint x2, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_hline", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_hline", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_hline", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 4, "gtk_paint_hline", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 5, "gtk_paint_hline", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 6, "gtk_paint_hline", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x1), x1, 7, "gtk_paint_hline", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(x2), x2, 8, "gtk_paint_hline", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_hline", "gint");
  gtk_paint_hline(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GdkRectangle_(area), 
                  XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x1), XEN_TO_C_gint(x2), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paint_vline(XEN style, XEN window, XEN state_type, XEN area, XEN widget, XEN detail, XEN y1, XEN y2, XEN x)
{
  #define H_gtk_paint_vline "void gtk_paint_vline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GdkRectangle* area, GtkWidget* widget, gchar* detail, gint y1, gint y2, gint x)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_vline", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_vline", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_vline", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 4, "gtk_paint_vline", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 5, "gtk_paint_vline", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 6, "gtk_paint_vline", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(y1), y1, 7, "gtk_paint_vline", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y2), y2, 8, "gtk_paint_vline", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 9, "gtk_paint_vline", "gint");
  gtk_paint_vline(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GdkRectangle_(area), 
                  XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(y1), XEN_TO_C_gint(y2), XEN_TO_C_gint(x));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paint_shadow(XEN arglist)
{
  #define H_gtk_paint_shadow "void gtk_paint_shadow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_shadow", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_shadow", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_shadow", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_shadow", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_shadow", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_shadow", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_shadow", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_shadow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_shadow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_shadow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_shadow", "gint");
  gtk_paint_shadow(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                   XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                   XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_polygon(XEN arglist)
{
  #define H_gtk_paint_polygon "void gtk_paint_polygon(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, GdkPoint* points, gint npoints, \
gboolean fill)"
  XEN style, window, state_type, shadow_type, area, widget, detail, points, npoints, fill;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  points = XEN_LIST_REF(arglist, 7);
  npoints = XEN_LIST_REF(arglist, 8);
  fill = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_polygon", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_polygon", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_polygon", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_polygon", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_polygon", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_polygon", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_polygon", "gchar*");
  XEN_ASSERT_TYPE(XEN_GdkPoint__P(points), points, 8, "gtk_paint_polygon", "GdkPoint*");
  XEN_ASSERT_TYPE(XEN_gint_P(npoints), npoints, 9, "gtk_paint_polygon", "gint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 10, "gtk_paint_polygon", "gboolean");
  gtk_paint_polygon(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                    XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_GdkPoint_(points), 
                    XEN_TO_C_gint(npoints), XEN_TO_C_gboolean(fill));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_arrow(XEN arglist)
{
  #define H_gtk_paint_arrow "void gtk_paint_arrow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, GtkArrowType arrow_type, \
gboolean fill, gint x, gint y, gint width, gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, arrow_type, fill, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  arrow_type = XEN_LIST_REF(arglist, 7);
  fill = XEN_LIST_REF(arglist, 8);
  x = XEN_LIST_REF(arglist, 9);
  y = XEN_LIST_REF(arglist, 10);
  width = XEN_LIST_REF(arglist, 11);
  height = XEN_LIST_REF(arglist, 12);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_arrow", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_arrow", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_arrow", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_arrow", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_arrow", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_arrow", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_arrow", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkArrowType_P(arrow_type), arrow_type, 8, "gtk_paint_arrow", "GtkArrowType");
  XEN_ASSERT_TYPE(XEN_gboolean_P(fill), fill, 9, "gtk_paint_arrow", "gboolean");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 10, "gtk_paint_arrow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 11, "gtk_paint_arrow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 12, "gtk_paint_arrow", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 13, "gtk_paint_arrow", "gint");
  gtk_paint_arrow(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                  XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_GtkArrowType(arrow_type), 
                  XEN_TO_C_gboolean(fill), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_diamond(XEN arglist)
{
  #define H_gtk_paint_diamond "void gtk_paint_diamond(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_diamond", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_diamond", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_diamond", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_diamond", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_diamond", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_diamond", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_diamond", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_diamond", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_diamond", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_diamond", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_diamond", "gint");
  gtk_paint_diamond(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                    XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                    XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_box(XEN arglist)
{
  #define H_gtk_paint_box "void gtk_paint_box(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_box", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_box", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_box", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_box", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_box", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_box", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_box", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_box", "gint");
  gtk_paint_box(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_flat_box(XEN arglist)
{
  #define H_gtk_paint_flat_box "void gtk_paint_flat_box(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_flat_box", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_flat_box", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_flat_box", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_flat_box", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_flat_box", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_flat_box", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_flat_box", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_flat_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_flat_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_flat_box", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_flat_box", "gint");
  gtk_paint_flat_box(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                     XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                     XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_check(XEN arglist)
{
  #define H_gtk_paint_check "void gtk_paint_check(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_check", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_check", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_check", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_check", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_check", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_check", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_check", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_check", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_check", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_check", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_check", "gint");
  gtk_paint_check(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                  XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                  XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_option(XEN arglist)
{
  #define H_gtk_paint_option "void gtk_paint_option(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_option", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_option", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_option", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_option", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_option", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_option", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_option", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_option", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_option", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_option", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_option", "gint");
  gtk_paint_option(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                   XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                   XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_tab(XEN arglist)
{
  #define H_gtk_paint_tab "void gtk_paint_tab(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_tab", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_tab", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_tab", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_tab", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_tab", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_tab", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_tab", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_tab", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_tab", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_tab", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_tab", "gint");
  gtk_paint_tab(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_shadow_gap(XEN arglist)
{
  #define H_gtk_paint_shadow_gap "void gtk_paint_shadow_gap(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height, GtkPositionType gap_side, gint gap_x, gint gap_width)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height, gap_side, gap_x, gap_width;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  gap_side = XEN_LIST_REF(arglist, 11);
  gap_x = XEN_LIST_REF(arglist, 12);
  gap_width = XEN_LIST_REF(arglist, 13);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_shadow_gap", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_shadow_gap", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_shadow_gap", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_shadow_gap", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_shadow_gap", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_shadow_gap", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_shadow_gap", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_shadow_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_shadow_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_shadow_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_shadow_gap", "gint");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(gap_side), gap_side, 12, "gtk_paint_shadow_gap", "GtkPositionType");
  XEN_ASSERT_TYPE(XEN_gint_P(gap_x), gap_x, 13, "gtk_paint_shadow_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(gap_width), gap_width, 14, "gtk_paint_shadow_gap", "gint");
  gtk_paint_shadow_gap(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                       XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                       XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GtkPositionType(gap_side), 
                       XEN_TO_C_gint(gap_x), XEN_TO_C_gint(gap_width));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_box_gap(XEN arglist)
{
  #define H_gtk_paint_box_gap "void gtk_paint_box_gap(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height, GtkPositionType gap_side, gint gap_x, gint gap_width)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height, gap_side, gap_x, gap_width;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  gap_side = XEN_LIST_REF(arglist, 11);
  gap_x = XEN_LIST_REF(arglist, 12);
  gap_width = XEN_LIST_REF(arglist, 13);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_box_gap", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_box_gap", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_box_gap", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_box_gap", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_box_gap", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_box_gap", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_box_gap", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_box_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_box_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_box_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_box_gap", "gint");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(gap_side), gap_side, 12, "gtk_paint_box_gap", "GtkPositionType");
  XEN_ASSERT_TYPE(XEN_gint_P(gap_x), gap_x, 13, "gtk_paint_box_gap", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(gap_width), gap_width, 14, "gtk_paint_box_gap", "gint");
  gtk_paint_box_gap(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                    XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                    XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GtkPositionType(gap_side), XEN_TO_C_gint(gap_x), 
                    XEN_TO_C_gint(gap_width));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_extension(XEN arglist)
{
  #define H_gtk_paint_extension "void gtk_paint_extension(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height, GtkPositionType gap_side)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height, gap_side;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  gap_side = XEN_LIST_REF(arglist, 11);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_extension", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_extension", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_extension", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_extension", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_extension", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_extension", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_extension", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_extension", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_extension", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_extension", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_extension", "gint");
  XEN_ASSERT_TYPE(XEN_GtkPositionType_P(gap_side), gap_side, 12, "gtk_paint_extension", "GtkPositionType");
  gtk_paint_extension(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                      XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                      XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GtkPositionType(gap_side));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_focus(XEN arglist)
{
  #define H_gtk_paint_focus "void gtk_paint_focus(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height)"
  XEN style, window, state_type, area, widget, detail, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  area = XEN_LIST_REF(arglist, 3);
  widget = XEN_LIST_REF(arglist, 4);
  detail = XEN_LIST_REF(arglist, 5);
  x = XEN_LIST_REF(arglist, 6);
  y = XEN_LIST_REF(arglist, 7);
  width = XEN_LIST_REF(arglist, 8);
  height = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_focus", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_focus", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_focus", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 4, "gtk_paint_focus", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 5, "gtk_paint_focus", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 6, "gtk_paint_focus", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 7, "gtk_paint_focus", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 8, "gtk_paint_focus", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 9, "gtk_paint_focus", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 10, "gtk_paint_focus", "gint");
  gtk_paint_focus(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GdkRectangle_(area), 
                  XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), 
                  XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_slider(XEN arglist)
{
  #define H_gtk_paint_slider "void gtk_paint_slider(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height, GtkOrientation orientation)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height, orientation;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  orientation = XEN_LIST_REF(arglist, 11);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_slider", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_slider", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_slider", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_slider", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_slider", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_slider", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_slider", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_slider", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_slider", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_slider", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_slider", "gint");
  XEN_ASSERT_TYPE(XEN_GtkOrientation_P(orientation), orientation, 12, "gtk_paint_slider", "GtkOrientation");
  gtk_paint_slider(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                   XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                   XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GtkOrientation(orientation));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_handle(XEN arglist)
{
  #define H_gtk_paint_handle "void gtk_paint_handle(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, \
gint height, GtkOrientation orientation)"
  XEN style, window, state_type, shadow_type, area, widget, detail, x, y, width, height, orientation;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  shadow_type = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  orientation = XEN_LIST_REF(arglist, 11);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_handle", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_handle", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_handle", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(shadow_type), shadow_type, 4, "gtk_paint_handle", "GtkShadowType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_handle", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_handle", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_handle", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_handle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_handle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_handle", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_handle", "gint");
  XEN_ASSERT_TYPE(XEN_GtkOrientation_P(orientation), orientation, 12, "gtk_paint_handle", "GtkOrientation");
  gtk_paint_handle(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GtkShadowType(shadow_type), 
                   XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                   XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_GtkOrientation(orientation));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_expander(XEN style, XEN window, XEN state_type, XEN area, XEN widget, XEN detail, XEN x, XEN y, XEN expander_style)
{
  #define H_gtk_paint_expander "void gtk_paint_expander(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, GtkExpanderStyle expander_style)"
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_expander", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_expander", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_expander", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 4, "gtk_paint_expander", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 5, "gtk_paint_expander", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 6, "gtk_paint_expander", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 7, "gtk_paint_expander", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 8, "gtk_paint_expander", "gint");
  XEN_ASSERT_TYPE(XEN_GtkExpanderStyle_P(expander_style), expander_style, 9, "gtk_paint_expander", "GtkExpanderStyle");
  gtk_paint_expander(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GdkRectangle_(area), 
                     XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_GtkExpanderStyle(expander_style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paint_layout(XEN arglist)
{
  #define H_gtk_paint_layout "void gtk_paint_layout(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
gboolean use_text, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, PangoLayout* layout)"
  XEN style, window, state_type, use_text, area, widget, detail, x, y, layout;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  use_text = XEN_LIST_REF(arglist, 3);
  area = XEN_LIST_REF(arglist, 4);
  widget = XEN_LIST_REF(arglist, 5);
  detail = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  layout = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_layout", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_layout", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_layout", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_text), use_text, 4, "gtk_paint_layout", "gboolean");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 5, "gtk_paint_layout", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 6, "gtk_paint_layout", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 7, "gtk_paint_layout", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_layout", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_layout", "gint");
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 10, "gtk_paint_layout", "PangoLayout*");
  gtk_paint_layout(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_gboolean(use_text), 
                   XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_gint(x), 
                   XEN_TO_C_gint(y), XEN_TO_C_PangoLayout_(layout));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_paint_resize_grip(XEN arglist)
{
  #define H_gtk_paint_resize_grip "void gtk_paint_resize_grip(GtkStyle* style, GdkWindow* window, GtkStateType state_type, \
GdkRectangle* area, GtkWidget* widget, gchar* detail, GdkWindowEdge edge, gint x, gint y, gint width, \
gint height)"
  XEN style, window, state_type, area, widget, detail, edge, x, y, width, height;
  style = XEN_LIST_REF(arglist, 0);
  window = XEN_LIST_REF(arglist, 1);
  state_type = XEN_LIST_REF(arglist, 2);
  area = XEN_LIST_REF(arglist, 3);
  widget = XEN_LIST_REF(arglist, 4);
  detail = XEN_LIST_REF(arglist, 5);
  edge = XEN_LIST_REF(arglist, 6);
  x = XEN_LIST_REF(arglist, 7);
  y = XEN_LIST_REF(arglist, 8);
  width = XEN_LIST_REF(arglist, 9);
  height = XEN_LIST_REF(arglist, 10);
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style), style, 1, "gtk_paint_resize_grip", "GtkStyle*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_paint_resize_grip", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state_type), state_type, 3, "gtk_paint_resize_grip", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 4, "gtk_paint_resize_grip", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 5, "gtk_paint_resize_grip", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 6, "gtk_paint_resize_grip", "gchar*");
  XEN_ASSERT_TYPE(XEN_GdkWindowEdge_P(edge), edge, 7, "gtk_paint_resize_grip", "GdkWindowEdge");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 8, "gtk_paint_resize_grip", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 9, "gtk_paint_resize_grip", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 10, "gtk_paint_resize_grip", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 11, "gtk_paint_resize_grip", "gint");
  gtk_paint_resize_grip(XEN_TO_C_GtkStyle_(style), XEN_TO_C_GdkWindow_(window), XEN_TO_C_GtkStateType(state_type), XEN_TO_C_GdkRectangle_(area), 
                        XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(detail), XEN_TO_C_GdkWindowEdge(edge), XEN_TO_C_gint(x), 
                        XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_border_copy(XEN border)
{
  #define H_gtk_border_copy "GtkBorder* gtk_border_copy(GtkBorder* border)"
  XEN_ASSERT_TYPE(XEN_GtkBorder__P(border), border, 1, "gtk_border_copy", "GtkBorder*");
  return(C_TO_XEN_GtkBorder_(gtk_border_copy(XEN_TO_C_GtkBorder_(border))));
}
static XEN gxg_gtk_border_free(XEN border)
{
  #define H_gtk_border_free "void gtk_border_free(GtkBorder* border)"
  XEN_ASSERT_TYPE(XEN_GtkBorder__P(border), border, 1, "gtk_border_free", "GtkBorder*");
  gtk_border_free(XEN_TO_C_GtkBorder_(border));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_type(void)
{
  #define H_gtk_table_get_type "GtkType gtk_table_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_table_get_type()));
}
static XEN gxg_gtk_table_new(XEN rows, XEN columns, XEN homogeneous)
{
  #define H_gtk_table_new "GtkWidget* gtk_table_new(guint rows, guint columns, gboolean homogeneous)"
  XEN_ASSERT_TYPE(XEN_guint_P(rows), rows, 1, "gtk_table_new", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(columns), columns, 2, "gtk_table_new", "guint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 3, "gtk_table_new", "gboolean");
  return(C_TO_XEN_GtkWidget_(gtk_table_new(XEN_TO_C_guint(rows), XEN_TO_C_guint(columns), XEN_TO_C_gboolean(homogeneous))));
}
static XEN gxg_gtk_table_resize(XEN table, XEN rows, XEN columns)
{
  #define H_gtk_table_resize "void gtk_table_resize(GtkTable* table, guint rows, guint columns)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_resize", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(rows), rows, 2, "gtk_table_resize", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(columns), columns, 3, "gtk_table_resize", "guint");
  gtk_table_resize(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(rows), XEN_TO_C_guint(columns));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_attach(XEN arglist)
{
  #define H_gtk_table_attach "void gtk_table_attach(GtkTable* table, GtkWidget* child, guint left_attach, \
guint right_attach, guint top_attach, guint bottom_attach, GtkAttachOptions xoptions, GtkAttachOptions yoptions, \
guint xpadding, guint ypadding)"
  XEN table, child, left_attach, right_attach, top_attach, bottom_attach, xoptions, yoptions, xpadding, ypadding;
  table = XEN_LIST_REF(arglist, 0);
  child = XEN_LIST_REF(arglist, 1);
  left_attach = XEN_LIST_REF(arglist, 2);
  right_attach = XEN_LIST_REF(arglist, 3);
  top_attach = XEN_LIST_REF(arglist, 4);
  bottom_attach = XEN_LIST_REF(arglist, 5);
  xoptions = XEN_LIST_REF(arglist, 6);
  yoptions = XEN_LIST_REF(arglist, 7);
  xpadding = XEN_LIST_REF(arglist, 8);
  ypadding = XEN_LIST_REF(arglist, 9);
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_attach", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_table_attach", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint_P(left_attach), left_attach, 3, "gtk_table_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(right_attach), right_attach, 4, "gtk_table_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(top_attach), top_attach, 5, "gtk_table_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(bottom_attach), bottom_attach, 6, "gtk_table_attach", "guint");
  XEN_ASSERT_TYPE(XEN_GtkAttachOptions_P(xoptions), xoptions, 7, "gtk_table_attach", "GtkAttachOptions");
  XEN_ASSERT_TYPE(XEN_GtkAttachOptions_P(yoptions), yoptions, 8, "gtk_table_attach", "GtkAttachOptions");
  XEN_ASSERT_TYPE(XEN_guint_P(xpadding), xpadding, 9, "gtk_table_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(ypadding), ypadding, 10, "gtk_table_attach", "guint");
  gtk_table_attach(XEN_TO_C_GtkTable_(table), XEN_TO_C_GtkWidget_(child), XEN_TO_C_guint(left_attach), XEN_TO_C_guint(right_attach), 
                   XEN_TO_C_guint(top_attach), XEN_TO_C_guint(bottom_attach), XEN_TO_C_GtkAttachOptions(xoptions), XEN_TO_C_GtkAttachOptions(yoptions), 
                   XEN_TO_C_guint(xpadding), XEN_TO_C_guint(ypadding));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_table_attach_defaults(XEN table, XEN widget, XEN left_attach, XEN right_attach, XEN top_attach, XEN bottom_attach)
{
  #define H_gtk_table_attach_defaults "void gtk_table_attach_defaults(GtkTable* table, GtkWidget* widget, \
guint left_attach, guint right_attach, guint top_attach, guint bottom_attach)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_attach_defaults", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_table_attach_defaults", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint_P(left_attach), left_attach, 3, "gtk_table_attach_defaults", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(right_attach), right_attach, 4, "gtk_table_attach_defaults", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(top_attach), top_attach, 5, "gtk_table_attach_defaults", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(bottom_attach), bottom_attach, 6, "gtk_table_attach_defaults", "guint");
  gtk_table_attach_defaults(XEN_TO_C_GtkTable_(table), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_guint(left_attach), XEN_TO_C_guint(right_attach), 
                            XEN_TO_C_guint(top_attach), XEN_TO_C_guint(bottom_attach));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_set_row_spacing(XEN table, XEN row, XEN spacing)
{
  #define H_gtk_table_set_row_spacing "void gtk_table_set_row_spacing(GtkTable* table, guint row, guint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_set_row_spacing", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(row), row, 2, "gtk_table_set_row_spacing", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(spacing), spacing, 3, "gtk_table_set_row_spacing", "guint");
  gtk_table_set_row_spacing(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(row), XEN_TO_C_guint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_row_spacing(XEN table, XEN row)
{
  #define H_gtk_table_get_row_spacing "guint gtk_table_get_row_spacing(GtkTable* table, guint row)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_get_row_spacing", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(row), row, 2, "gtk_table_get_row_spacing", "guint");
  return(C_TO_XEN_guint(gtk_table_get_row_spacing(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(row))));
}
static XEN gxg_gtk_table_set_col_spacing(XEN table, XEN column, XEN spacing)
{
  #define H_gtk_table_set_col_spacing "void gtk_table_set_col_spacing(GtkTable* table, guint column, \
guint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_set_col_spacing", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(column), column, 2, "gtk_table_set_col_spacing", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(spacing), spacing, 3, "gtk_table_set_col_spacing", "guint");
  gtk_table_set_col_spacing(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(column), XEN_TO_C_guint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_col_spacing(XEN table, XEN column)
{
  #define H_gtk_table_get_col_spacing "guint gtk_table_get_col_spacing(GtkTable* table, guint column)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_get_col_spacing", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(column), column, 2, "gtk_table_get_col_spacing", "guint");
  return(C_TO_XEN_guint(gtk_table_get_col_spacing(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(column))));
}
static XEN gxg_gtk_table_set_row_spacings(XEN table, XEN spacing)
{
  #define H_gtk_table_set_row_spacings "void gtk_table_set_row_spacings(GtkTable* table, guint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_set_row_spacings", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(spacing), spacing, 2, "gtk_table_set_row_spacings", "guint");
  gtk_table_set_row_spacings(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_default_row_spacing(XEN table)
{
  #define H_gtk_table_get_default_row_spacing "guint gtk_table_get_default_row_spacing(GtkTable* table)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_get_default_row_spacing", "GtkTable*");
  return(C_TO_XEN_guint(gtk_table_get_default_row_spacing(XEN_TO_C_GtkTable_(table))));
}
static XEN gxg_gtk_table_set_col_spacings(XEN table, XEN spacing)
{
  #define H_gtk_table_set_col_spacings "void gtk_table_set_col_spacings(GtkTable* table, guint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_set_col_spacings", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_guint_P(spacing), spacing, 2, "gtk_table_set_col_spacings", "guint");
  gtk_table_set_col_spacings(XEN_TO_C_GtkTable_(table), XEN_TO_C_guint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_default_col_spacing(XEN table)
{
  #define H_gtk_table_get_default_col_spacing "guint gtk_table_get_default_col_spacing(GtkTable* table)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_get_default_col_spacing", "GtkTable*");
  return(C_TO_XEN_guint(gtk_table_get_default_col_spacing(XEN_TO_C_GtkTable_(table))));
}
static XEN gxg_gtk_table_set_homogeneous(XEN table, XEN homogeneous)
{
  #define H_gtk_table_set_homogeneous "void gtk_table_set_homogeneous(GtkTable* table, gboolean homogeneous)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_set_homogeneous", "GtkTable*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 2, "gtk_table_set_homogeneous", "gboolean");
  gtk_table_set_homogeneous(XEN_TO_C_GtkTable_(table), XEN_TO_C_gboolean(homogeneous));
  return(XEN_FALSE);
}
static XEN gxg_gtk_table_get_homogeneous(XEN table)
{
  #define H_gtk_table_get_homogeneous "gboolean gtk_table_get_homogeneous(GtkTable* table)"
  XEN_ASSERT_TYPE(XEN_GtkTable__P(table), table, 1, "gtk_table_get_homogeneous", "GtkTable*");
  return(C_TO_XEN_gboolean(gtk_table_get_homogeneous(XEN_TO_C_GtkTable_(table))));
}
static XEN gxg_gtk_tearoff_menu_item_get_type(void)
{
  #define H_gtk_tearoff_menu_item_get_type "GtkType gtk_tearoff_menu_item_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tearoff_menu_item_get_type()));
}
static XEN gxg_gtk_tearoff_menu_item_new(void)
{
  #define H_gtk_tearoff_menu_item_new "GtkWidget* gtk_tearoff_menu_item_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_tearoff_menu_item_new()));
}
static XEN gxg_gtk_text_buffer_get_type(void)
{
  #define H_gtk_text_buffer_get_type "GType gtk_text_buffer_get_type( void)"
  return(C_TO_XEN_GType(gtk_text_buffer_get_type()));
}
static XEN gxg_gtk_text_buffer_new(XEN table)
{
  #define H_gtk_text_buffer_new "GtkTextBuffer* gtk_text_buffer_new(GtkTextTagTable* table)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_buffer_new", "GtkTextTagTable*");
  return(C_TO_XEN_GtkTextBuffer_(gtk_text_buffer_new(XEN_TO_C_GtkTextTagTable_(table))));
}
static XEN gxg_gtk_text_buffer_get_line_count(XEN buffer)
{
  #define H_gtk_text_buffer_get_line_count "gint gtk_text_buffer_get_line_count(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_line_count", "GtkTextBuffer*");
  return(C_TO_XEN_gint(gtk_text_buffer_get_line_count(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_get_char_count(XEN buffer)
{
  #define H_gtk_text_buffer_get_char_count "gint gtk_text_buffer_get_char_count(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_char_count", "GtkTextBuffer*");
  return(C_TO_XEN_gint(gtk_text_buffer_get_char_count(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_get_tag_table(XEN buffer)
{
  #define H_gtk_text_buffer_get_tag_table "GtkTextTagTable* gtk_text_buffer_get_tag_table(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_tag_table", "GtkTextBuffer*");
  return(C_TO_XEN_GtkTextTagTable_(gtk_text_buffer_get_tag_table(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_set_text(XEN buffer, XEN text, XEN len)
{
  #define H_gtk_text_buffer_set_text "void gtk_text_buffer_set_text(GtkTextBuffer* buffer, gchar* text, \
gint len)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_set_text", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_text_buffer_set_text", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_text_buffer_set_text", "gint");
  gtk_text_buffer_set_text(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(text), XEN_TO_C_gint(len));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_insert(XEN buffer, XEN iter, XEN text, XEN len)
{
  #define H_gtk_text_buffer_insert "void gtk_text_buffer_insert(GtkTextBuffer* buffer, GtkTextIter* iter, \
gchar* text, gint len)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_text_buffer_insert", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 4, "gtk_text_buffer_insert", "gint");
  gtk_text_buffer_insert(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gchar_(text), XEN_TO_C_gint(len));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_insert_at_cursor(XEN buffer, XEN text, XEN len)
{
  #define H_gtk_text_buffer_insert_at_cursor "void gtk_text_buffer_insert_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_at_cursor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_text_buffer_insert_at_cursor", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_text_buffer_insert_at_cursor", "gint");
  gtk_text_buffer_insert_at_cursor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(text), XEN_TO_C_gint(len));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_insert_interactive(XEN buffer, XEN iter, XEN text, XEN len, XEN default_editable)
{
  #define H_gtk_text_buffer_insert_interactive "gboolean gtk_text_buffer_insert_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_interactive", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_text_buffer_insert_interactive", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 4, "gtk_text_buffer_insert_interactive", "gint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 5, "gtk_text_buffer_insert_interactive", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_insert_interactive(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), 
                                                              XEN_TO_C_gchar_(text), XEN_TO_C_gint(len), XEN_TO_C_gboolean(default_editable))));
}
static XEN gxg_gtk_text_buffer_insert_interactive_at_cursor(XEN buffer, XEN text, XEN len, XEN default_editable)
{
  #define H_gtk_text_buffer_insert_interactive_at_cursor "gboolean gtk_text_buffer_insert_interactive_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_interactive_at_cursor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_text_buffer_insert_interactive_at_cursor", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 3, "gtk_text_buffer_insert_interactive_at_cursor", "gint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 4, "gtk_text_buffer_insert_interactive_at_cursor", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_insert_interactive_at_cursor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(text), 
                                                                        XEN_TO_C_gint(len), XEN_TO_C_gboolean(default_editable))));
}
static XEN gxg_gtk_text_buffer_insert_range(XEN buffer, XEN iter, XEN start, XEN end)
{
  #define H_gtk_text_buffer_insert_range "void gtk_text_buffer_insert_range(GtkTextBuffer* buffer, GtkTextIter* iter, \
GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_range", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_range", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_insert_range", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_insert_range", "GtkTextIter*");
  gtk_text_buffer_insert_range(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextIter_(start), 
                               XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_insert_range_interactive(XEN buffer, XEN iter, XEN start, XEN end, XEN default_editable)
{
  #define H_gtk_text_buffer_insert_range_interactive "gboolean gtk_text_buffer_insert_range_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextIter* start, GtkTextIter* end, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_range_interactive", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 5, "gtk_text_buffer_insert_range_interactive", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_insert_range_interactive(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), 
                                                                    XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end), 
                                                                    XEN_TO_C_gboolean(default_editable))));
}
static XEN gxg_gtk_text_buffer_insert_with_tags(XEN buffer, XEN iter, XEN text, XEN len, XEN tags)
{
  #define H_gtk_text_buffer_insert_with_tags "void gtk_text_buffer_insert_with_tags(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_with_tags", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_with_tags", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_text_buffer_insert_with_tags", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 4, "gtk_text_buffer_insert_with_tags", "gint");
  XEN_ASSERT_TYPE(XEN_etc_P(tags), tags, 5, "gtk_text_buffer_insert_with_tags", "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (XEN_LIST_P(tags)) etc_len = XEN_LIST_LENGTH(tags);
    if (etc_len < 1) XEN_OUT_OF_RANGE_ERROR("gtk_text_buffer_insert_with_tags", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) XEN_OUT_OF_RANGE_ERROR("gtk_text_buffer_insert_with_tags", 4, tags, "... list too long (max len: 6)");
    p_arg0 = XEN_TO_C_GtkTextBuffer_(buffer);
    p_arg1 = XEN_TO_C_GtkTextIter_(iter);
    p_arg2 = XEN_TO_C_gchar_(text);
    p_arg3 = XEN_TO_C_gint(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), NULL); break;
        case 2: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), NULL); break;
        case 4: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), XLT(tags, 4), NULL); break;
        case 6: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), XLT(tags, 4), XLT(tags, 5), NULL); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_text_buffer_insert_with_tags_by_name(XEN buffer, XEN iter, XEN text, XEN len, XEN tags)
{
  #define H_gtk_text_buffer_insert_with_tags_by_name "void gtk_text_buffer_insert_with_tags_by_name(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_with_tags_by_name", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_with_tags_by_name", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_text_buffer_insert_with_tags_by_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 4, "gtk_text_buffer_insert_with_tags_by_name", "gint");
  XEN_ASSERT_TYPE(XEN_etc_P(tags), tags, 5, "gtk_text_buffer_insert_with_tags_by_name", "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (XEN_LIST_P(tags)) etc_len = XEN_LIST_LENGTH(tags);
    if (etc_len < 1) XEN_OUT_OF_RANGE_ERROR("gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) XEN_OUT_OF_RANGE_ERROR("gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list too long (max len: 6)");
    p_arg0 = XEN_TO_C_GtkTextBuffer_(buffer);
    p_arg1 = XEN_TO_C_GtkTextIter_(iter);
    p_arg2 = XEN_TO_C_gchar_(text);
    p_arg3 = XEN_TO_C_gint(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), NULL); break;
        case 2: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLS(tags, 1), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), NULL); break;
        case 4: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), XLS(tags, 4), NULL); break;
        case 6: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), XLS(tags, 4), XLS(tags, 5), NULL); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_text_buffer_delete(XEN buffer, XEN start, XEN end)
{
  #define H_gtk_text_buffer_delete "void gtk_text_buffer_delete(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_delete", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_delete", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_delete", "GtkTextIter*");
  gtk_text_buffer_delete(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_delete_interactive(XEN buffer, XEN start_iter, XEN end_iter, XEN default_editable)
{
  #define H_gtk_text_buffer_delete_interactive "gboolean gtk_text_buffer_delete_interactive(GtkTextBuffer* buffer, \
GtkTextIter* start_iter, GtkTextIter* end_iter, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_delete_interactive", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start_iter), start_iter, 2, "gtk_text_buffer_delete_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end_iter), end_iter, 3, "gtk_text_buffer_delete_interactive", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 4, "gtk_text_buffer_delete_interactive", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_delete_interactive(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start_iter), 
                                                              XEN_TO_C_GtkTextIter_(end_iter), XEN_TO_C_gboolean(default_editable))));
}
static XEN gxg_gtk_text_buffer_get_text(XEN buffer, XEN start, XEN end, XEN include_hidden_chars)
{
  #define H_gtk_text_buffer_get_text "gchar* gtk_text_buffer_get_text(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_text", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_get_text", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_get_text", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(include_hidden_chars), include_hidden_chars, 4, "gtk_text_buffer_get_text", "gboolean");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_buffer_get_text(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), 
                                                                       XEN_TO_C_GtkTextIter_(end), XEN_TO_C_gboolean(include_hidden_chars));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_buffer_get_slice(XEN buffer, XEN start, XEN end, XEN include_hidden_chars)
{
  #define H_gtk_text_buffer_get_slice "gchar* gtk_text_buffer_get_slice(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_slice", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_get_slice", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_get_slice", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(include_hidden_chars), include_hidden_chars, 4, "gtk_text_buffer_get_slice", "gboolean");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_buffer_get_slice(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), 
                                                                        XEN_TO_C_GtkTextIter_(end), XEN_TO_C_gboolean(include_hidden_chars));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_buffer_insert_pixbuf(XEN buffer, XEN iter, XEN pixbuf)
{
  #define H_gtk_text_buffer_insert_pixbuf "void gtk_text_buffer_insert_pixbuf(GtkTextBuffer* buffer, \
GtkTextIter* iter, GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_pixbuf", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_pixbuf", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 3, "gtk_text_buffer_insert_pixbuf", "GdkPixbuf*");
  gtk_text_buffer_insert_pixbuf(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_insert_child_anchor(XEN buffer, XEN iter, XEN anchor)
{
  #define H_gtk_text_buffer_insert_child_anchor "void gtk_text_buffer_insert_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_insert_child_anchor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_insert_child_anchor", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextChildAnchor__P(anchor), anchor, 3, "gtk_text_buffer_insert_child_anchor", "GtkTextChildAnchor*");
  gtk_text_buffer_insert_child_anchor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextChildAnchor_(anchor));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_create_child_anchor(XEN buffer, XEN iter)
{
  #define H_gtk_text_buffer_create_child_anchor "GtkTextChildAnchor* gtk_text_buffer_create_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_create_child_anchor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_create_child_anchor", "GtkTextIter*");
  return(C_TO_XEN_GtkTextChildAnchor_(gtk_text_buffer_create_child_anchor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_buffer_create_mark(XEN buffer, XEN mark_name, XEN where, XEN left_gravity)
{
  #define H_gtk_text_buffer_create_mark "GtkTextMark* gtk_text_buffer_create_mark(GtkTextBuffer* buffer, \
gchar* mark_name, GtkTextIter* where, gboolean left_gravity)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_create_mark", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(mark_name), mark_name, 2, "gtk_text_buffer_create_mark", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(where), where, 3, "gtk_text_buffer_create_mark", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(left_gravity), left_gravity, 4, "gtk_text_buffer_create_mark", "gboolean");
  return(C_TO_XEN_GtkTextMark_(gtk_text_buffer_create_mark(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(mark_name), XEN_TO_C_GtkTextIter_(where), 
                                                           XEN_TO_C_gboolean(left_gravity))));
}
static XEN gxg_gtk_text_buffer_move_mark(XEN buffer, XEN mark, XEN where)
{
  #define H_gtk_text_buffer_move_mark "void gtk_text_buffer_move_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_move_mark", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 2, "gtk_text_buffer_move_mark", "GtkTextMark*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(where), where, 3, "gtk_text_buffer_move_mark", "GtkTextIter*");
  gtk_text_buffer_move_mark(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextMark_(mark), XEN_TO_C_GtkTextIter_(where));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_delete_mark(XEN buffer, XEN mark)
{
  #define H_gtk_text_buffer_delete_mark "void gtk_text_buffer_delete_mark(GtkTextBuffer* buffer, GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_delete_mark", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 2, "gtk_text_buffer_delete_mark", "GtkTextMark*");
  gtk_text_buffer_delete_mark(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextMark_(mark));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_mark(XEN buffer, XEN name)
{
  #define H_gtk_text_buffer_get_mark "GtkTextMark* gtk_text_buffer_get_mark(GtkTextBuffer* buffer, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_mark", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_buffer_get_mark", "gchar*");
  return(C_TO_XEN_GtkTextMark_(gtk_text_buffer_get_mark(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(name))));
}
static XEN gxg_gtk_text_buffer_move_mark_by_name(XEN buffer, XEN name, XEN where)
{
  #define H_gtk_text_buffer_move_mark_by_name "void gtk_text_buffer_move_mark_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* where)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_move_mark_by_name", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_buffer_move_mark_by_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(where), where, 3, "gtk_text_buffer_move_mark_by_name", "GtkTextIter*");
  gtk_text_buffer_move_mark_by_name(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(name), XEN_TO_C_GtkTextIter_(where));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_delete_mark_by_name(XEN buffer, XEN name)
{
  #define H_gtk_text_buffer_delete_mark_by_name "void gtk_text_buffer_delete_mark_by_name(GtkTextBuffer* buffer, \
gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_delete_mark_by_name", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_buffer_delete_mark_by_name", "gchar*");
  gtk_text_buffer_delete_mark_by_name(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_insert(XEN buffer)
{
  #define H_gtk_text_buffer_get_insert "GtkTextMark* gtk_text_buffer_get_insert(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_insert", "GtkTextBuffer*");
  return(C_TO_XEN_GtkTextMark_(gtk_text_buffer_get_insert(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_get_selection_bound(XEN buffer)
{
  #define H_gtk_text_buffer_get_selection_bound "GtkTextMark* gtk_text_buffer_get_selection_bound(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_selection_bound", "GtkTextBuffer*");
  return(C_TO_XEN_GtkTextMark_(gtk_text_buffer_get_selection_bound(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_place_cursor(XEN buffer, XEN where)
{
  #define H_gtk_text_buffer_place_cursor "void gtk_text_buffer_place_cursor(GtkTextBuffer* buffer, GtkTextIter* where)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_place_cursor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(where), where, 2, "gtk_text_buffer_place_cursor", "GtkTextIter*");
  gtk_text_buffer_place_cursor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(where));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_apply_tag(XEN buffer, XEN tag, XEN start, XEN end)
{
  #define H_gtk_text_buffer_apply_tag "void gtk_text_buffer_apply_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_apply_tag", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 2, "gtk_text_buffer_apply_tag", "GtkTextTag*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_apply_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_apply_tag", "GtkTextIter*");
  gtk_text_buffer_apply_tag(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextTag_(tag), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_remove_tag(XEN buffer, XEN tag, XEN start, XEN end)
{
  #define H_gtk_text_buffer_remove_tag "void gtk_text_buffer_remove_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_remove_tag", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 2, "gtk_text_buffer_remove_tag", "GtkTextTag*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_remove_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_remove_tag", "GtkTextIter*");
  gtk_text_buffer_remove_tag(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextTag_(tag), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_apply_tag_by_name(XEN buffer, XEN name, XEN start, XEN end)
{
  #define H_gtk_text_buffer_apply_tag_by_name "void gtk_text_buffer_apply_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_apply_tag_by_name", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_buffer_apply_tag_by_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_apply_tag_by_name", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_apply_tag_by_name", "GtkTextIter*");
  gtk_text_buffer_apply_tag_by_name(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(name), XEN_TO_C_GtkTextIter_(start), 
                                    XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_remove_tag_by_name(XEN buffer, XEN name, XEN start, XEN end)
{
  #define H_gtk_text_buffer_remove_tag_by_name "void gtk_text_buffer_remove_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_remove_tag_by_name", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_buffer_remove_tag_by_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 3, "gtk_text_buffer_remove_tag_by_name", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 4, "gtk_text_buffer_remove_tag_by_name", "GtkTextIter*");
  gtk_text_buffer_remove_tag_by_name(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gchar_(name), XEN_TO_C_GtkTextIter_(start), 
                                     XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_remove_all_tags(XEN buffer, XEN start, XEN end)
{
  #define H_gtk_text_buffer_remove_all_tags "void gtk_text_buffer_remove_all_tags(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_remove_all_tags", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_remove_all_tags", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_remove_all_tags", "GtkTextIter*");
  gtk_text_buffer_remove_all_tags(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_create_tag(XEN buffer, XEN tag_name, XEN tags)
{
  #define H_gtk_text_buffer_create_tag "GtkTextTag* gtk_text_buffer_create_tag(GtkTextBuffer* buffer, \
gchar* tag_name, etc tags)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_create_tag", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tag_name), tag_name, 2, "gtk_text_buffer_create_tag", "gchar*");
  if (XEN_NOT_BOUND_P(tags)) tags = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_etc_P(tags), tags, 3, "gtk_text_buffer_create_tag", "etc");
  {
    int etc_len = 0;
    GtkTextTag* result = NULL;
    GtkTextBuffer* p_arg0;
    gchar* p_arg1;
    if (XEN_LIST_P(tags)) etc_len = XEN_LIST_LENGTH(tags);
    if (etc_len > 6) XEN_OUT_OF_RANGE_ERROR("gtk_text_buffer_create_tag", 2, tags, "... list too long (max len: 6)");
    p_arg0 = XEN_TO_C_GtkTextBuffer_(buffer);
    p_arg1 = XEN_TO_C_gchar_(tag_name);
    switch (etc_len)
      {
        case 0: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, NULL); break;
        case 1: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), NULL); break;
        case 2: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLS(tags, 1), NULL); break;
        case 3: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), NULL); break;
        case 4: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), NULL); break;
        case 5: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), XLS(tags, 4), NULL); break;
        case 6: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLS(tags, 1), XLS(tags, 2), XLS(tags, 3), XLS(tags, 4), XLS(tags, 5), NULL); break;
      }
    return(C_TO_XEN_GtkTextTag_(result));
  }
}
static XEN gxg_gtk_text_buffer_get_iter_at_line_offset(XEN buffer, XEN iter, XEN line_number, XEN char_offset)
{
  #define H_gtk_text_buffer_get_iter_at_line_offset "void gtk_text_buffer_get_iter_at_line_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint char_offset)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line_offset", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_line_offset", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line_offset", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(char_offset), char_offset, 4, "gtk_text_buffer_get_iter_at_line_offset", "gint");
  gtk_text_buffer_get_iter_at_line_offset(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(line_number), 
                                          XEN_TO_C_gint(char_offset));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_iter_at_line_index(XEN buffer, XEN iter, XEN line_number, XEN byte_index)
{
  #define H_gtk_text_buffer_get_iter_at_line_index "void gtk_text_buffer_get_iter_at_line_index(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint byte_index)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line_index", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_line_index", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line_index", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(byte_index), byte_index, 4, "gtk_text_buffer_get_iter_at_line_index", "gint");
  gtk_text_buffer_get_iter_at_line_index(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(line_number), 
                                         XEN_TO_C_gint(byte_index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_iter_at_offset(XEN buffer, XEN iter, XEN char_offset)
{
  #define H_gtk_text_buffer_get_iter_at_offset "void gtk_text_buffer_get_iter_at_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint char_offset)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_offset", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_offset", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(char_offset), char_offset, 3, "gtk_text_buffer_get_iter_at_offset", "gint");
  gtk_text_buffer_get_iter_at_offset(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(char_offset));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_iter_at_line(XEN buffer, XEN iter, XEN line_number)
{
  #define H_gtk_text_buffer_get_iter_at_line "void gtk_text_buffer_get_iter_at_line(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_line", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line", "gint");
  gtk_text_buffer_get_iter_at_line(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(line_number));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_start_iter(XEN buffer, XEN iter)
{
  #define H_gtk_text_buffer_get_start_iter "void gtk_text_buffer_get_start_iter(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_start_iter", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_start_iter", "GtkTextIter*");
  gtk_text_buffer_get_start_iter(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_end_iter(XEN buffer, XEN iter)
{
  #define H_gtk_text_buffer_get_end_iter "void gtk_text_buffer_get_end_iter(GtkTextBuffer* buffer, GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_end_iter", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_end_iter", "GtkTextIter*");
  gtk_text_buffer_get_end_iter(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_bounds(XEN buffer, XEN start, XEN end)
{
  #define H_gtk_text_buffer_get_bounds "void gtk_text_buffer_get_bounds(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_bounds", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_get_bounds", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_get_bounds", "GtkTextIter*");
  gtk_text_buffer_get_bounds(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_iter_at_mark(XEN buffer, XEN iter, XEN mark)
{
  #define H_gtk_text_buffer_get_iter_at_mark "void gtk_text_buffer_get_iter_at_mark(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_mark", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_mark", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 3, "gtk_text_buffer_get_iter_at_mark", "GtkTextMark*");
  gtk_text_buffer_get_iter_at_mark(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextMark_(mark));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_iter_at_child_anchor(XEN buffer, XEN iter, XEN anchor)
{
  #define H_gtk_text_buffer_get_iter_at_child_anchor "void gtk_text_buffer_get_iter_at_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextChildAnchor__P(anchor), anchor, 3, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextChildAnchor*");
  gtk_text_buffer_get_iter_at_child_anchor(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextChildAnchor_(anchor));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_modified(XEN buffer)
{
  #define H_gtk_text_buffer_get_modified "gboolean gtk_text_buffer_get_modified(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_modified", "GtkTextBuffer*");
  return(C_TO_XEN_gboolean(gtk_text_buffer_get_modified(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_buffer_set_modified(XEN buffer, XEN setting)
{
  #define H_gtk_text_buffer_set_modified "void gtk_text_buffer_set_modified(GtkTextBuffer* buffer, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_set_modified", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_text_buffer_set_modified", "gboolean");
  gtk_text_buffer_set_modified(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_add_selection_clipboard(XEN buffer, XEN clipboard)
{
  #define H_gtk_text_buffer_add_selection_clipboard "void gtk_text_buffer_add_selection_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_add_selection_clipboard", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 2, "gtk_text_buffer_add_selection_clipboard", "GtkClipboard*");
  gtk_text_buffer_add_selection_clipboard(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkClipboard_(clipboard));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_remove_selection_clipboard(XEN buffer, XEN clipboard)
{
  #define H_gtk_text_buffer_remove_selection_clipboard "void gtk_text_buffer_remove_selection_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_remove_selection_clipboard", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 2, "gtk_text_buffer_remove_selection_clipboard", "GtkClipboard*");
  gtk_text_buffer_remove_selection_clipboard(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkClipboard_(clipboard));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_cut_clipboard(XEN buffer, XEN clipboard, XEN default_editable)
{
  #define H_gtk_text_buffer_cut_clipboard "void gtk_text_buffer_cut_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_cut_clipboard", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 2, "gtk_text_buffer_cut_clipboard", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 3, "gtk_text_buffer_cut_clipboard", "gboolean");
  gtk_text_buffer_cut_clipboard(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_gboolean(default_editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_copy_clipboard(XEN buffer, XEN clipboard)
{
  #define H_gtk_text_buffer_copy_clipboard "void gtk_text_buffer_copy_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_copy_clipboard", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 2, "gtk_text_buffer_copy_clipboard", "GtkClipboard*");
  gtk_text_buffer_copy_clipboard(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkClipboard_(clipboard));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_paste_clipboard(XEN buffer, XEN clipboard, XEN override_location, XEN default_editable)
{
  #define H_gtk_text_buffer_paste_clipboard "void gtk_text_buffer_paste_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard, GtkTextIter* override_location, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_paste_clipboard", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 2, "gtk_text_buffer_paste_clipboard", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(override_location) || XEN_FALSE_P(override_location), override_location, 3, "gtk_text_buffer_paste_clipboard", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 4, "gtk_text_buffer_paste_clipboard", "gboolean");
  gtk_text_buffer_paste_clipboard(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkTextIter_(override_location), 
                                  XEN_TO_C_gboolean(default_editable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_get_selection_bounds(XEN buffer, XEN start, XEN end)
{
  #define H_gtk_text_buffer_get_selection_bounds "gboolean gtk_text_buffer_get_selection_bounds(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_get_selection_bounds", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_buffer_get_selection_bounds", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_buffer_get_selection_bounds", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_buffer_get_selection_bounds(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(start), 
                                                                XEN_TO_C_GtkTextIter_(end))));
}
static XEN gxg_gtk_text_buffer_delete_selection(XEN buffer, XEN interactive, XEN default_editable)
{
  #define H_gtk_text_buffer_delete_selection "gboolean gtk_text_buffer_delete_selection(GtkTextBuffer* buffer, \
gboolean interactive, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_delete_selection", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(interactive), interactive, 2, "gtk_text_buffer_delete_selection", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 3, "gtk_text_buffer_delete_selection", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_delete_selection(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_gboolean(interactive), 
                                                            XEN_TO_C_gboolean(default_editable))));
}
static XEN gxg_gtk_text_buffer_begin_user_action(XEN buffer)
{
  #define H_gtk_text_buffer_begin_user_action "void gtk_text_buffer_begin_user_action(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_begin_user_action", "GtkTextBuffer*");
  gtk_text_buffer_begin_user_action(XEN_TO_C_GtkTextBuffer_(buffer));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_end_user_action(XEN buffer)
{
  #define H_gtk_text_buffer_end_user_action "void gtk_text_buffer_end_user_action(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_end_user_action", "GtkTextBuffer*");
  gtk_text_buffer_end_user_action(XEN_TO_C_GtkTextBuffer_(buffer));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_child_anchor_get_type(void)
{
  #define H_gtk_text_child_anchor_get_type "GType gtk_text_child_anchor_get_type( void)"
  return(C_TO_XEN_GType(gtk_text_child_anchor_get_type()));
}
static XEN gxg_gtk_text_child_anchor_new(void)
{
  #define H_gtk_text_child_anchor_new "GtkTextChildAnchor* gtk_text_child_anchor_new( void)"
  return(C_TO_XEN_GtkTextChildAnchor_(gtk_text_child_anchor_new()));
}
static XEN gxg_gtk_text_child_anchor_get_widgets(XEN anchor)
{
  #define H_gtk_text_child_anchor_get_widgets "GList* gtk_text_child_anchor_get_widgets(GtkTextChildAnchor* anchor)"
  XEN_ASSERT_TYPE(XEN_GtkTextChildAnchor__P(anchor), anchor, 1, "gtk_text_child_anchor_get_widgets", "GtkTextChildAnchor*");
  return(C_TO_XEN_GList_(gtk_text_child_anchor_get_widgets(XEN_TO_C_GtkTextChildAnchor_(anchor))));
}
static XEN gxg_gtk_text_child_anchor_get_deleted(XEN anchor)
{
  #define H_gtk_text_child_anchor_get_deleted "gboolean gtk_text_child_anchor_get_deleted(GtkTextChildAnchor* anchor)"
  XEN_ASSERT_TYPE(XEN_GtkTextChildAnchor__P(anchor), anchor, 1, "gtk_text_child_anchor_get_deleted", "GtkTextChildAnchor*");
  return(C_TO_XEN_gboolean(gtk_text_child_anchor_get_deleted(XEN_TO_C_GtkTextChildAnchor_(anchor))));
}
static XEN gxg_gtk_text_iter_get_buffer(XEN iter)
{
  #define H_gtk_text_iter_get_buffer "GtkTextBuffer* gtk_text_iter_get_buffer(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_buffer", "GtkTextIter*");
  return(C_TO_XEN_GtkTextBuffer_(gtk_text_iter_get_buffer(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_copy(XEN iter)
{
  #define H_gtk_text_iter_copy "GtkTextIter* gtk_text_iter_copy(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_copy", "GtkTextIter*");
  return(C_TO_XEN_GtkTextIter_(gtk_text_iter_copy(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_free(XEN iter)
{
  #define H_gtk_text_iter_free "void gtk_text_iter_free(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_free", "GtkTextIter*");
  gtk_text_iter_free(XEN_TO_C_GtkTextIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_get_offset(XEN iter)
{
  #define H_gtk_text_iter_get_offset "gint gtk_text_iter_get_offset(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_offset", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_offset(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_line(XEN iter)
{
  #define H_gtk_text_iter_get_line "gint gtk_text_iter_get_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_line", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_line_offset(XEN iter)
{
  #define H_gtk_text_iter_get_line_offset "gint gtk_text_iter_get_line_offset(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_line_offset", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_line_offset(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_line_index(XEN iter)
{
  #define H_gtk_text_iter_get_line_index "gint gtk_text_iter_get_line_index(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_line_index", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_line_index(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_visible_line_offset(XEN iter)
{
  #define H_gtk_text_iter_get_visible_line_offset "gint gtk_text_iter_get_visible_line_offset(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_visible_line_offset", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_visible_line_offset(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_visible_line_index(XEN iter)
{
  #define H_gtk_text_iter_get_visible_line_index "gint gtk_text_iter_get_visible_line_index(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_visible_line_index", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_visible_line_index(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_char(XEN iter)
{
  #define H_gtk_text_iter_get_char "gunichar gtk_text_iter_get_char(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_char", "GtkTextIter*");
  return(C_TO_XEN_gunichar(gtk_text_iter_get_char(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_slice(XEN start, XEN end)
{
  #define H_gtk_text_iter_get_slice "gchar* gtk_text_iter_get_slice(GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 1, "gtk_text_iter_get_slice", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 2, "gtk_text_iter_get_slice", "GtkTextIter*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_iter_get_slice(XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_iter_get_text(XEN start, XEN end)
{
  #define H_gtk_text_iter_get_text "gchar* gtk_text_iter_get_text(GtkTextIter* start, GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 1, "gtk_text_iter_get_text", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 2, "gtk_text_iter_get_text", "GtkTextIter*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_iter_get_text(XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_iter_get_visible_slice(XEN start, XEN end)
{
  #define H_gtk_text_iter_get_visible_slice "gchar* gtk_text_iter_get_visible_slice(GtkTextIter* start, \
GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 1, "gtk_text_iter_get_visible_slice", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 2, "gtk_text_iter_get_visible_slice", "GtkTextIter*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_iter_get_visible_slice(XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_iter_get_visible_text(XEN start, XEN end)
{
  #define H_gtk_text_iter_get_visible_text "gchar* gtk_text_iter_get_visible_text(GtkTextIter* start, \
GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 1, "gtk_text_iter_get_visible_text", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 2, "gtk_text_iter_get_visible_text", "GtkTextIter*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_text_iter_get_visible_text(XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_text_iter_get_pixbuf(XEN iter)
{
  #define H_gtk_text_iter_get_pixbuf "GdkPixbuf* gtk_text_iter_get_pixbuf(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_pixbuf", "GtkTextIter*");
  return(C_TO_XEN_GdkPixbuf_(gtk_text_iter_get_pixbuf(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_marks(XEN iter)
{
  #define H_gtk_text_iter_get_marks "GSList* gtk_text_iter_get_marks(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_marks", "GtkTextIter*");
  return(C_TO_XEN_GSList_(gtk_text_iter_get_marks(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_child_anchor(XEN iter)
{
  #define H_gtk_text_iter_get_child_anchor "GtkTextChildAnchor* gtk_text_iter_get_child_anchor(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_child_anchor", "GtkTextIter*");
  return(C_TO_XEN_GtkTextChildAnchor_(gtk_text_iter_get_child_anchor(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_toggled_tags(XEN iter, XEN toggled_on)
{
  #define H_gtk_text_iter_get_toggled_tags "GSList* gtk_text_iter_get_toggled_tags(GtkTextIter* iter, \
gboolean toggled_on)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_toggled_tags", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(toggled_on), toggled_on, 2, "gtk_text_iter_get_toggled_tags", "gboolean");
  return(C_TO_XEN_GSList_(gtk_text_iter_get_toggled_tags(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gboolean(toggled_on))));
}
static XEN gxg_gtk_text_iter_begins_tag(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_begins_tag "gboolean gtk_text_iter_begins_tag(GtkTextIter* iter, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_begins_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag) || XEN_FALSE_P(tag), tag, 2, "gtk_text_iter_begins_tag", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_begins_tag(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_ends_tag(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_ends_tag "gboolean gtk_text_iter_ends_tag(GtkTextIter* iter, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_ends_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag) || XEN_FALSE_P(tag), tag, 2, "gtk_text_iter_ends_tag", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_ends_tag(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_toggles_tag(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_toggles_tag "gboolean gtk_text_iter_toggles_tag(GtkTextIter* iter, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_toggles_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag) || XEN_FALSE_P(tag), tag, 2, "gtk_text_iter_toggles_tag", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_toggles_tag(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_has_tag(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_has_tag "gboolean gtk_text_iter_has_tag(GtkTextIter* iter, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_has_tag", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 2, "gtk_text_iter_has_tag", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_has_tag(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_get_tags(XEN iter)
{
  #define H_gtk_text_iter_get_tags "GSList* gtk_text_iter_get_tags(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_tags", "GtkTextIter*");
  return(C_TO_XEN_GSList_(gtk_text_iter_get_tags(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_editable(XEN iter, XEN default_setting)
{
  #define H_gtk_text_iter_editable "gboolean gtk_text_iter_editable(GtkTextIter* iter, gboolean default_setting)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_editable", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_setting), default_setting, 2, "gtk_text_iter_editable", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_iter_editable(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gboolean(default_setting))));
}
static XEN gxg_gtk_text_iter_can_insert(XEN iter, XEN default_editability)
{
  #define H_gtk_text_iter_can_insert "gboolean gtk_text_iter_can_insert(GtkTextIter* iter, gboolean default_editability)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_can_insert", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editability), default_editability, 2, "gtk_text_iter_can_insert", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_iter_can_insert(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gboolean(default_editability))));
}
static XEN gxg_gtk_text_iter_starts_word(XEN iter)
{
  #define H_gtk_text_iter_starts_word "gboolean gtk_text_iter_starts_word(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_starts_word", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_starts_word(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_ends_word(XEN iter)
{
  #define H_gtk_text_iter_ends_word "gboolean gtk_text_iter_ends_word(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_ends_word", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_ends_word(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_inside_word(XEN iter)
{
  #define H_gtk_text_iter_inside_word "gboolean gtk_text_iter_inside_word(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_inside_word", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_inside_word(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_starts_sentence(XEN iter)
{
  #define H_gtk_text_iter_starts_sentence "gboolean gtk_text_iter_starts_sentence(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_starts_sentence", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_starts_sentence(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_ends_sentence(XEN iter)
{
  #define H_gtk_text_iter_ends_sentence "gboolean gtk_text_iter_ends_sentence(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_ends_sentence", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_ends_sentence(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_inside_sentence(XEN iter)
{
  #define H_gtk_text_iter_inside_sentence "gboolean gtk_text_iter_inside_sentence(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_inside_sentence", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_inside_sentence(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_starts_line(XEN iter)
{
  #define H_gtk_text_iter_starts_line "gboolean gtk_text_iter_starts_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_starts_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_starts_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_ends_line(XEN iter)
{
  #define H_gtk_text_iter_ends_line "gboolean gtk_text_iter_ends_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_ends_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_ends_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_is_cursor_position(XEN iter)
{
  #define H_gtk_text_iter_is_cursor_position "gboolean gtk_text_iter_is_cursor_position(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_is_cursor_position", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_is_cursor_position(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_chars_in_line(XEN iter)
{
  #define H_gtk_text_iter_get_chars_in_line "gint gtk_text_iter_get_chars_in_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_chars_in_line", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_chars_in_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_bytes_in_line(XEN iter)
{
  #define H_gtk_text_iter_get_bytes_in_line "gint gtk_text_iter_get_bytes_in_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_bytes_in_line", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_get_bytes_in_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_get_attributes(XEN iter, XEN values)
{
  #define H_gtk_text_iter_get_attributes "gboolean gtk_text_iter_get_attributes(GtkTextIter* iter, GtkTextAttributes* values)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_attributes", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(values), values, 2, "gtk_text_iter_get_attributes", "GtkTextAttributes*");
  return(C_TO_XEN_gboolean(gtk_text_iter_get_attributes(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextAttributes_(values))));
}
static XEN gxg_gtk_text_iter_get_language(XEN iter)
{
  #define H_gtk_text_iter_get_language "PangoLanguage* gtk_text_iter_get_language(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_get_language", "GtkTextIter*");
  return(C_TO_XEN_PangoLanguage_(gtk_text_iter_get_language(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_is_end(XEN iter)
{
  #define H_gtk_text_iter_is_end "gboolean gtk_text_iter_is_end(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_is_end", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_is_end(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_is_start(XEN iter)
{
  #define H_gtk_text_iter_is_start "gboolean gtk_text_iter_is_start(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_is_start", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_is_start(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_char(XEN iter)
{
  #define H_gtk_text_iter_forward_char "gboolean gtk_text_iter_forward_char(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_char", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_char(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_backward_char(XEN iter)
{
  #define H_gtk_text_iter_backward_char "gboolean gtk_text_iter_backward_char(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_char", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_char(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_chars(XEN iter, XEN count)
{
  #define H_gtk_text_iter_forward_chars "gboolean gtk_text_iter_forward_chars(GtkTextIter* iter, gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_chars", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_forward_chars", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_chars(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_backward_chars(XEN iter, XEN count)
{
  #define H_gtk_text_iter_backward_chars "gboolean gtk_text_iter_backward_chars(GtkTextIter* iter, gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_chars", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_backward_chars", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_chars(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_forward_line(XEN iter)
{
  #define H_gtk_text_iter_forward_line "gboolean gtk_text_iter_forward_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_backward_line(XEN iter)
{
  #define H_gtk_text_iter_backward_line "gboolean gtk_text_iter_backward_line(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_line(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_lines(XEN iter, XEN count)
{
  #define H_gtk_text_iter_forward_lines "gboolean gtk_text_iter_forward_lines(GtkTextIter* iter, gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_lines", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_forward_lines", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_lines(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_backward_lines(XEN iter, XEN count)
{
  #define H_gtk_text_iter_backward_lines "gboolean gtk_text_iter_backward_lines(GtkTextIter* iter, gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_lines", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_backward_lines", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_lines(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_forward_word_end(XEN iter)
{
  #define H_gtk_text_iter_forward_word_end "gboolean gtk_text_iter_forward_word_end(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_word_end", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_word_end(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_backward_word_start(XEN iter)
{
  #define H_gtk_text_iter_backward_word_start "gboolean gtk_text_iter_backward_word_start(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_word_start", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_word_start(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_word_ends(XEN iter, XEN count)
{
  #define H_gtk_text_iter_forward_word_ends "gboolean gtk_text_iter_forward_word_ends(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_word_ends", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_forward_word_ends", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_word_ends(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_backward_word_starts(XEN iter, XEN count)
{
  #define H_gtk_text_iter_backward_word_starts "gboolean gtk_text_iter_backward_word_starts(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_word_starts", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_backward_word_starts", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_word_starts(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_forward_sentence_end(XEN iter)
{
  #define H_gtk_text_iter_forward_sentence_end "gboolean gtk_text_iter_forward_sentence_end(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_sentence_end", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_sentence_end(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_backward_sentence_start(XEN iter)
{
  #define H_gtk_text_iter_backward_sentence_start "gboolean gtk_text_iter_backward_sentence_start(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_sentence_start", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_sentence_start(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_sentence_ends(XEN iter, XEN count)
{
  #define H_gtk_text_iter_forward_sentence_ends "gboolean gtk_text_iter_forward_sentence_ends(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_sentence_ends", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_forward_sentence_ends", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_sentence_ends(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_backward_sentence_starts(XEN iter, XEN count)
{
  #define H_gtk_text_iter_backward_sentence_starts "gboolean gtk_text_iter_backward_sentence_starts(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_sentence_starts", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_backward_sentence_starts", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_sentence_starts(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_forward_cursor_position(XEN iter)
{
  #define H_gtk_text_iter_forward_cursor_position "gboolean gtk_text_iter_forward_cursor_position(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_cursor_position", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_cursor_position(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_backward_cursor_position(XEN iter)
{
  #define H_gtk_text_iter_backward_cursor_position "gboolean gtk_text_iter_backward_cursor_position(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_cursor_position", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_cursor_position(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_forward_cursor_positions(XEN iter, XEN count)
{
  #define H_gtk_text_iter_forward_cursor_positions "gboolean gtk_text_iter_forward_cursor_positions(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_cursor_positions", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_forward_cursor_positions", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_cursor_positions(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_backward_cursor_positions(XEN iter, XEN count)
{
  #define H_gtk_text_iter_backward_cursor_positions "gboolean gtk_text_iter_backward_cursor_positions(GtkTextIter* iter, \
gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_cursor_positions", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 2, "gtk_text_iter_backward_cursor_positions", "gint");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_cursor_positions(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_iter_set_offset(XEN iter, XEN char_offset)
{
  #define H_gtk_text_iter_set_offset "void gtk_text_iter_set_offset(GtkTextIter* iter, gint char_offset)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_offset", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(char_offset), char_offset, 2, "gtk_text_iter_set_offset", "gint");
  gtk_text_iter_set_offset(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(char_offset));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_set_line(XEN iter, XEN line_number)
{
  #define H_gtk_text_iter_set_line "void gtk_text_iter_set_line(GtkTextIter* iter, gint line_number)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_line", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(line_number), line_number, 2, "gtk_text_iter_set_line", "gint");
  gtk_text_iter_set_line(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(line_number));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_set_line_offset(XEN iter, XEN char_on_line)
{
  #define H_gtk_text_iter_set_line_offset "void gtk_text_iter_set_line_offset(GtkTextIter* iter, gint char_on_line)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_line_offset", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(char_on_line), char_on_line, 2, "gtk_text_iter_set_line_offset", "gint");
  gtk_text_iter_set_line_offset(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(char_on_line));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_set_line_index(XEN iter, XEN byte_on_line)
{
  #define H_gtk_text_iter_set_line_index "void gtk_text_iter_set_line_index(GtkTextIter* iter, gint byte_on_line)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_line_index", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(byte_on_line), byte_on_line, 2, "gtk_text_iter_set_line_index", "gint");
  gtk_text_iter_set_line_index(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(byte_on_line));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_forward_to_end(XEN iter)
{
  #define H_gtk_text_iter_forward_to_end "void gtk_text_iter_forward_to_end(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_to_end", "GtkTextIter*");
  gtk_text_iter_forward_to_end(XEN_TO_C_GtkTextIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_forward_to_line_end(XEN iter)
{
  #define H_gtk_text_iter_forward_to_line_end "gboolean gtk_text_iter_forward_to_line_end(GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_to_line_end", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_to_line_end(XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_iter_set_visible_line_offset(XEN iter, XEN char_on_line)
{
  #define H_gtk_text_iter_set_visible_line_offset "void gtk_text_iter_set_visible_line_offset(GtkTextIter* iter, \
gint char_on_line)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_visible_line_offset", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(char_on_line), char_on_line, 2, "gtk_text_iter_set_visible_line_offset", "gint");
  gtk_text_iter_set_visible_line_offset(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(char_on_line));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_set_visible_line_index(XEN iter, XEN byte_on_line)
{
  #define H_gtk_text_iter_set_visible_line_index "void gtk_text_iter_set_visible_line_index(GtkTextIter* iter, \
gint byte_on_line)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_set_visible_line_index", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(byte_on_line), byte_on_line, 2, "gtk_text_iter_set_visible_line_index", "gint");
  gtk_text_iter_set_visible_line_index(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(byte_on_line));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_iter_forward_to_tag_toggle(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_forward_to_tag_toggle "gboolean gtk_text_iter_forward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_to_tag_toggle", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag) || XEN_FALSE_P(tag), tag, 2, "gtk_text_iter_forward_to_tag_toggle", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_to_tag_toggle(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_backward_to_tag_toggle(XEN iter, XEN tag)
{
  #define H_gtk_text_iter_backward_to_tag_toggle "gboolean gtk_text_iter_backward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_to_tag_toggle", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag) || XEN_FALSE_P(tag), tag, 2, "gtk_text_iter_backward_to_tag_toggle", "GtkTextTag*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_to_tag_toggle(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_iter_forward_find_char(XEN iter, XEN pred, XEN func_data, XEN limit)
{
  #define H_gtk_text_iter_forward_find_char "gboolean gtk_text_iter_forward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_data, GtkTextIter* limit)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_find_char", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextCharPredicate_P(pred), pred, 2, "gtk_text_iter_forward_find_char", "GtkTextCharPredicate");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_text_iter_forward_find_char", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(limit) || XEN_FALSE_P(limit), limit, 4, "gtk_text_iter_forward_find_char", "GtkTextIter*");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(XEN_FALSE, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_gboolean(gtk_text_iter_forward_find_char(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextCharPredicate(pred), 
                                                               XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkTextIter_(limit)));
    xm_unprotect_at(loc);
    return(result);
   }
}
static XEN gxg_gtk_text_iter_backward_find_char(XEN iter, XEN pred, XEN func_data, XEN limit)
{
  #define H_gtk_text_iter_backward_find_char "gboolean gtk_text_iter_backward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_data, GtkTextIter* limit)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_find_char", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextCharPredicate_P(pred), pred, 2, "gtk_text_iter_backward_find_char", "GtkTextCharPredicate");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_text_iter_backward_find_char", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(limit) || XEN_FALSE_P(limit), limit, 4, "gtk_text_iter_backward_find_char", "GtkTextIter*");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(XEN_FALSE, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_gboolean(gtk_text_iter_backward_find_char(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextCharPredicate(pred), 
                                                                XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkTextIter_(limit)));
    xm_unprotect_at(loc);
    return(result);
   }
}
static XEN gxg_gtk_text_iter_forward_search(XEN iter, XEN str, XEN flags, XEN match_start, XEN match_end, XEN limit)
{
  #define H_gtk_text_iter_forward_search "gboolean gtk_text_iter_forward_search(GtkTextIter* iter, gchar* str, \
GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_forward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_text_iter_forward_search", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextSearchFlags_P(flags), flags, 3, "gtk_text_iter_forward_search", "GtkTextSearchFlags");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(match_start) || XEN_FALSE_P(match_start), match_start, 4, "gtk_text_iter_forward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(match_end) || XEN_FALSE_P(match_end), match_end, 5, "gtk_text_iter_forward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(limit) || XEN_FALSE_P(limit), limit, 6, "gtk_text_iter_forward_search", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_forward_search(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gchar_(str), XEN_TO_C_GtkTextSearchFlags(flags), 
                                                        XEN_TO_C_GtkTextIter_(match_start), XEN_TO_C_GtkTextIter_(match_end), 
                                                        XEN_TO_C_GtkTextIter_(limit))));
}
static XEN gxg_gtk_text_iter_backward_search(XEN iter, XEN str, XEN flags, XEN match_start, XEN match_end, XEN limit)
{
  #define H_gtk_text_iter_backward_search "gboolean gtk_text_iter_backward_search(GtkTextIter* iter, \
gchar* str, GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_backward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 2, "gtk_text_iter_backward_search", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkTextSearchFlags_P(flags), flags, 3, "gtk_text_iter_backward_search", "GtkTextSearchFlags");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(match_start) || XEN_FALSE_P(match_start), match_start, 4, "gtk_text_iter_backward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(match_end) || XEN_FALSE_P(match_end), match_end, 5, "gtk_text_iter_backward_search", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(limit) || XEN_FALSE_P(limit), limit, 6, "gtk_text_iter_backward_search", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_backward_search(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gchar_(str), XEN_TO_C_GtkTextSearchFlags(flags), 
                                                         XEN_TO_C_GtkTextIter_(match_start), XEN_TO_C_GtkTextIter_(match_end), 
                                                         XEN_TO_C_GtkTextIter_(limit))));
}
static XEN gxg_gtk_text_iter_equal(XEN lhs, XEN rhs)
{
  #define H_gtk_text_iter_equal "gboolean gtk_text_iter_equal(GtkTextIter* lhs, GtkTextIter* rhs)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(lhs), lhs, 1, "gtk_text_iter_equal", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(rhs), rhs, 2, "gtk_text_iter_equal", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_equal(XEN_TO_C_GtkTextIter_(lhs), XEN_TO_C_GtkTextIter_(rhs))));
}
static XEN gxg_gtk_text_iter_compare(XEN lhs, XEN rhs)
{
  #define H_gtk_text_iter_compare "gint gtk_text_iter_compare(GtkTextIter* lhs, GtkTextIter* rhs)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(lhs), lhs, 1, "gtk_text_iter_compare", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(rhs), rhs, 2, "gtk_text_iter_compare", "GtkTextIter*");
  return(C_TO_XEN_gint(gtk_text_iter_compare(XEN_TO_C_GtkTextIter_(lhs), XEN_TO_C_GtkTextIter_(rhs))));
}
static XEN gxg_gtk_text_iter_in_range(XEN iter, XEN start, XEN end)
{
  #define H_gtk_text_iter_in_range "gboolean gtk_text_iter_in_range(GtkTextIter* iter, GtkTextIter* start, \
GtkTextIter* end)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 1, "gtk_text_iter_in_range", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(start), start, 2, "gtk_text_iter_in_range", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(end), end, 3, "gtk_text_iter_in_range", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_iter_in_range(XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GtkTextIter_(start), XEN_TO_C_GtkTextIter_(end))));
}
static XEN gxg_gtk_text_iter_order(XEN first, XEN second)
{
  #define H_gtk_text_iter_order "void gtk_text_iter_order(GtkTextIter* first, GtkTextIter* second)"
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(first), first, 1, "gtk_text_iter_order", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(second), second, 2, "gtk_text_iter_order", "GtkTextIter*");
  gtk_text_iter_order(XEN_TO_C_GtkTextIter_(first), XEN_TO_C_GtkTextIter_(second));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_mark_get_type(void)
{
  #define H_gtk_text_mark_get_type "GType gtk_text_mark_get_type( void)"
  return(C_TO_XEN_GType(gtk_text_mark_get_type()));
}
static XEN gxg_gtk_text_mark_set_visible(XEN mark, XEN setting)
{
  #define H_gtk_text_mark_set_visible "void gtk_text_mark_set_visible(GtkTextMark* mark, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_set_visible", "GtkTextMark*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_text_mark_set_visible", "gboolean");
  gtk_text_mark_set_visible(XEN_TO_C_GtkTextMark_(mark), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_mark_get_visible(XEN mark)
{
  #define H_gtk_text_mark_get_visible "gboolean gtk_text_mark_get_visible(GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_get_visible", "GtkTextMark*");
  return(C_TO_XEN_gboolean(gtk_text_mark_get_visible(XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_mark_get_name(XEN mark)
{
  #define H_gtk_text_mark_get_name "char* gtk_text_mark_get_name(GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_get_name", "GtkTextMark*");
  return(C_TO_XEN_char_(gtk_text_mark_get_name(XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_mark_get_deleted(XEN mark)
{
  #define H_gtk_text_mark_get_deleted "gboolean gtk_text_mark_get_deleted(GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_get_deleted", "GtkTextMark*");
  return(C_TO_XEN_gboolean(gtk_text_mark_get_deleted(XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_mark_get_buffer(XEN mark)
{
  #define H_gtk_text_mark_get_buffer "GtkTextBuffer* gtk_text_mark_get_buffer(GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_get_buffer", "GtkTextMark*");
  return(C_TO_XEN_GtkTextBuffer_(gtk_text_mark_get_buffer(XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_mark_get_left_gravity(XEN mark)
{
  #define H_gtk_text_mark_get_left_gravity "gboolean gtk_text_mark_get_left_gravity(GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 1, "gtk_text_mark_get_left_gravity", "GtkTextMark*");
  return(C_TO_XEN_gboolean(gtk_text_mark_get_left_gravity(XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_tag_get_type(void)
{
  #define H_gtk_text_tag_get_type "GType gtk_text_tag_get_type( void)"
  return(C_TO_XEN_GType(gtk_text_tag_get_type()));
}
static XEN gxg_gtk_text_tag_new(XEN name)
{
  #define H_gtk_text_tag_new "GtkTextTag* gtk_text_tag_new(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_text_tag_new", "gchar*");
  return(C_TO_XEN_GtkTextTag_(gtk_text_tag_new(XEN_TO_C_gchar_(name))));
}
static XEN gxg_gtk_text_tag_get_priority(XEN tag)
{
  #define H_gtk_text_tag_get_priority "gint gtk_text_tag_get_priority(GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 1, "gtk_text_tag_get_priority", "GtkTextTag*");
  return(C_TO_XEN_gint(gtk_text_tag_get_priority(XEN_TO_C_GtkTextTag_(tag))));
}
static XEN gxg_gtk_text_tag_set_priority(XEN tag, XEN priority)
{
  #define H_gtk_text_tag_set_priority "void gtk_text_tag_set_priority(GtkTextTag* tag, gint priority)"
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 1, "gtk_text_tag_set_priority", "GtkTextTag*");
  XEN_ASSERT_TYPE(XEN_gint_P(priority), priority, 2, "gtk_text_tag_set_priority", "gint");
  gtk_text_tag_set_priority(XEN_TO_C_GtkTextTag_(tag), XEN_TO_C_gint(priority));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_tag_event(XEN tag, XEN event_object, XEN event, XEN iter)
{
  #define H_gtk_text_tag_event "gboolean gtk_text_tag_event(GtkTextTag* tag, GObject* event_object, GdkEvent* event, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 1, "gtk_text_tag_event", "GtkTextTag*");
  XEN_ASSERT_TYPE(XEN_GObject__P(event_object), event_object, 2, "gtk_text_tag_event", "GObject*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 3, "gtk_text_tag_event", "GdkEvent*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 4, "gtk_text_tag_event", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_tag_event(XEN_TO_C_GtkTextTag_(tag), XEN_TO_C_GObject_(event_object), XEN_TO_C_GdkEvent_(event), 
                                              XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_attributes_new(void)
{
  #define H_gtk_text_attributes_new "GtkTextAttributes* gtk_text_attributes_new( void)"
  return(C_TO_XEN_GtkTextAttributes_(gtk_text_attributes_new()));
}
static XEN gxg_gtk_text_attributes_copy(XEN src)
{
  #define H_gtk_text_attributes_copy "GtkTextAttributes* gtk_text_attributes_copy(GtkTextAttributes* src)"
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(src), src, 1, "gtk_text_attributes_copy", "GtkTextAttributes*");
  return(C_TO_XEN_GtkTextAttributes_(gtk_text_attributes_copy(XEN_TO_C_GtkTextAttributes_(src))));
}
static XEN gxg_gtk_text_attributes_copy_values(XEN src, XEN dest)
{
  #define H_gtk_text_attributes_copy_values "void gtk_text_attributes_copy_values(GtkTextAttributes* src, \
GtkTextAttributes* dest)"
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(src), src, 1, "gtk_text_attributes_copy_values", "GtkTextAttributes*");
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(dest), dest, 2, "gtk_text_attributes_copy_values", "GtkTextAttributes*");
  gtk_text_attributes_copy_values(XEN_TO_C_GtkTextAttributes_(src), XEN_TO_C_GtkTextAttributes_(dest));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_attributes_unref(XEN values)
{
  #define H_gtk_text_attributes_unref "void gtk_text_attributes_unref(GtkTextAttributes* values)"
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(values), values, 1, "gtk_text_attributes_unref", "GtkTextAttributes*");
  gtk_text_attributes_unref(XEN_TO_C_GtkTextAttributes_(values));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_attributes_ref(XEN values)
{
  #define H_gtk_text_attributes_ref "void gtk_text_attributes_ref(GtkTextAttributes* values)"
  XEN_ASSERT_TYPE(XEN_GtkTextAttributes__P(values), values, 1, "gtk_text_attributes_ref", "GtkTextAttributes*");
  gtk_text_attributes_ref(XEN_TO_C_GtkTextAttributes_(values));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_tag_table_get_type(void)
{
  #define H_gtk_text_tag_table_get_type "GType gtk_text_tag_table_get_type( void)"
  return(C_TO_XEN_GType(gtk_text_tag_table_get_type()));
}
static XEN gxg_gtk_text_tag_table_new(void)
{
  #define H_gtk_text_tag_table_new "GtkTextTagTable* gtk_text_tag_table_new( void)"
  return(C_TO_XEN_GtkTextTagTable_(gtk_text_tag_table_new()));
}
static XEN gxg_gtk_text_tag_table_add(XEN table, XEN tag)
{
  #define H_gtk_text_tag_table_add "void gtk_text_tag_table_add(GtkTextTagTable* table, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_tag_table_add", "GtkTextTagTable*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 2, "gtk_text_tag_table_add", "GtkTextTag*");
  gtk_text_tag_table_add(XEN_TO_C_GtkTextTagTable_(table), XEN_TO_C_GtkTextTag_(tag));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_tag_table_remove(XEN table, XEN tag)
{
  #define H_gtk_text_tag_table_remove "void gtk_text_tag_table_remove(GtkTextTagTable* table, GtkTextTag* tag)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_tag_table_remove", "GtkTextTagTable*");
  XEN_ASSERT_TYPE(XEN_GtkTextTag__P(tag), tag, 2, "gtk_text_tag_table_remove", "GtkTextTag*");
  gtk_text_tag_table_remove(XEN_TO_C_GtkTextTagTable_(table), XEN_TO_C_GtkTextTag_(tag));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_tag_table_lookup(XEN table, XEN name)
{
  #define H_gtk_text_tag_table_lookup "GtkTextTag* gtk_text_tag_table_lookup(GtkTextTagTable* table, \
gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_tag_table_lookup", "GtkTextTagTable*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_text_tag_table_lookup", "gchar*");
  return(C_TO_XEN_GtkTextTag_(gtk_text_tag_table_lookup(XEN_TO_C_GtkTextTagTable_(table), XEN_TO_C_gchar_(name))));
}
static XEN gxg_gtk_text_tag_table_foreach(XEN table, XEN func, XEN func_data)
{
  #define H_gtk_text_tag_table_foreach "void gtk_text_tag_table_foreach(GtkTextTagTable* table, GtkTextTagTableForeach func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_tag_table_foreach", "GtkTextTagTable*");
  XEN_ASSERT_TYPE(XEN_GtkTextTagTableForeach_P(func), func, 2, "gtk_text_tag_table_foreach", "GtkTextTagTableForeach");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_text_tag_table_foreach", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_text_tag_table_foreach(XEN_TO_C_GtkTextTagTable_(table), XEN_TO_C_GtkTextTagTableForeach(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_text_tag_table_get_size(XEN table)
{
  #define H_gtk_text_tag_table_get_size "gint gtk_text_tag_table_get_size(GtkTextTagTable* table)"
  XEN_ASSERT_TYPE(XEN_GtkTextTagTable__P(table), table, 1, "gtk_text_tag_table_get_size", "GtkTextTagTable*");
  return(C_TO_XEN_gint(gtk_text_tag_table_get_size(XEN_TO_C_GtkTextTagTable_(table))));
}
static XEN gxg_gtk_text_view_get_type(void)
{
  #define H_gtk_text_view_get_type "GtkType gtk_text_view_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_text_view_get_type()));
}
static XEN gxg_gtk_text_view_new(void)
{
  #define H_gtk_text_view_new "GtkWidget* gtk_text_view_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_text_view_new()));
}
static XEN gxg_gtk_text_view_new_with_buffer(XEN buffer)
{
  #define H_gtk_text_view_new_with_buffer "GtkWidget* gtk_text_view_new_with_buffer(GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_view_new_with_buffer", "GtkTextBuffer*");
  return(C_TO_XEN_GtkWidget_(gtk_text_view_new_with_buffer(XEN_TO_C_GtkTextBuffer_(buffer))));
}
static XEN gxg_gtk_text_view_set_buffer(XEN text_view, XEN buffer)
{
  #define H_gtk_text_view_set_buffer "void gtk_text_view_set_buffer(GtkTextView* text_view, GtkTextBuffer* buffer)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_buffer", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 2, "gtk_text_view_set_buffer", "GtkTextBuffer*");
  gtk_text_view_set_buffer(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextBuffer_(buffer));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_buffer(XEN text_view)
{
  #define H_gtk_text_view_get_buffer "GtkTextBuffer* gtk_text_view_get_buffer(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_buffer", "GtkTextView*");
  return(C_TO_XEN_GtkTextBuffer_(gtk_text_view_get_buffer(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_scroll_to_iter(XEN text_view, XEN iter, XEN within_margin, XEN use_align, XEN xalign, XEN yalign)
{
  #define H_gtk_text_view_scroll_to_iter "gboolean gtk_text_view_scroll_to_iter(GtkTextView* text_view, \
GtkTextIter* iter, gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_scroll_to_iter", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_scroll_to_iter", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(within_margin), within_margin, 3, "gtk_text_view_scroll_to_iter", "gdouble");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_align), use_align, 4, "gtk_text_view_scroll_to_iter", "gboolean");
  XEN_ASSERT_TYPE(XEN_gdouble_P(xalign), xalign, 5, "gtk_text_view_scroll_to_iter", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(yalign), yalign, 6, "gtk_text_view_scroll_to_iter", "gdouble");
  return(C_TO_XEN_gboolean(gtk_text_view_scroll_to_iter(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gdouble(within_margin), 
                                                        XEN_TO_C_gboolean(use_align), XEN_TO_C_gdouble(xalign), XEN_TO_C_gdouble(yalign))));
}
static XEN gxg_gtk_text_view_scroll_to_mark(XEN text_view, XEN mark, XEN within_margin, XEN use_align, XEN xalign, XEN yalign)
{
  #define H_gtk_text_view_scroll_to_mark "void gtk_text_view_scroll_to_mark(GtkTextView* text_view, GtkTextMark* mark, \
gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_scroll_to_mark", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 2, "gtk_text_view_scroll_to_mark", "GtkTextMark*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(within_margin), within_margin, 3, "gtk_text_view_scroll_to_mark", "gdouble");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_align), use_align, 4, "gtk_text_view_scroll_to_mark", "gboolean");
  XEN_ASSERT_TYPE(XEN_gdouble_P(xalign), xalign, 5, "gtk_text_view_scroll_to_mark", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(yalign), yalign, 6, "gtk_text_view_scroll_to_mark", "gdouble");
  gtk_text_view_scroll_to_mark(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextMark_(mark), XEN_TO_C_gdouble(within_margin), 
                               XEN_TO_C_gboolean(use_align), XEN_TO_C_gdouble(xalign), XEN_TO_C_gdouble(yalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_scroll_mark_onscreen(XEN text_view, XEN mark)
{
  #define H_gtk_text_view_scroll_mark_onscreen "void gtk_text_view_scroll_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_scroll_mark_onscreen", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 2, "gtk_text_view_scroll_mark_onscreen", "GtkTextMark*");
  gtk_text_view_scroll_mark_onscreen(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextMark_(mark));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_move_mark_onscreen(XEN text_view, XEN mark)
{
  #define H_gtk_text_view_move_mark_onscreen "gboolean gtk_text_view_move_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_move_mark_onscreen", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextMark__P(mark), mark, 2, "gtk_text_view_move_mark_onscreen", "GtkTextMark*");
  return(C_TO_XEN_gboolean(gtk_text_view_move_mark_onscreen(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextMark_(mark))));
}
static XEN gxg_gtk_text_view_place_cursor_onscreen(XEN text_view)
{
  #define H_gtk_text_view_place_cursor_onscreen "gboolean gtk_text_view_place_cursor_onscreen(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_place_cursor_onscreen", "GtkTextView*");
  return(C_TO_XEN_gboolean(gtk_text_view_place_cursor_onscreen(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_get_visible_rect(XEN text_view, XEN visible_rect)
{
  #define H_gtk_text_view_get_visible_rect "void gtk_text_view_get_visible_rect(GtkTextView* text_view, \
GdkRectangle* visible_rect)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_visible_rect", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(visible_rect), visible_rect, 2, "gtk_text_view_get_visible_rect", "GdkRectangle*");
  gtk_text_view_get_visible_rect(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GdkRectangle_(visible_rect));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_set_cursor_visible(XEN text_view, XEN setting)
{
  #define H_gtk_text_view_set_cursor_visible "void gtk_text_view_set_cursor_visible(GtkTextView* text_view, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_cursor_visible", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_text_view_set_cursor_visible", "gboolean");
  gtk_text_view_set_cursor_visible(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_cursor_visible(XEN text_view)
{
  #define H_gtk_text_view_get_cursor_visible "gboolean gtk_text_view_get_cursor_visible(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_cursor_visible", "GtkTextView*");
  return(C_TO_XEN_gboolean(gtk_text_view_get_cursor_visible(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_get_iter_location(XEN text_view, XEN iter, XEN location)
{
  #define H_gtk_text_view_get_iter_location "void gtk_text_view_get_iter_location(GtkTextView* text_view, \
GtkTextIter* iter, GdkRectangle* location)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_iter_location", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_get_iter_location", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(location), location, 3, "gtk_text_view_get_iter_location", "GdkRectangle*");
  gtk_text_view_get_iter_location(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_GdkRectangle_(location));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_iter_at_location(XEN text_view, XEN iter, XEN x, XEN y)
{
  #define H_gtk_text_view_get_iter_at_location "void gtk_text_view_get_iter_at_location(GtkTextView* text_view, \
GtkTextIter* iter, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_iter_at_location", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_get_iter_at_location", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gtk_text_view_get_iter_at_location", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gtk_text_view_get_iter_at_location", "gint");
  gtk_text_view_get_iter_at_location(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_line_yrange(XEN text_view, XEN iter, XEN y, XEN height)
{
  #define H_gtk_text_view_get_line_yrange "void gtk_text_view_get_line_yrange(GtkTextView* text_view, \
GtkTextIter* iter, gint* [y], gint* [height])"
  gint ref_y;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_line_yrange", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_get_line_yrange", "GtkTextIter*");
  gtk_text_view_get_line_yrange(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), &ref_y, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_y), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_text_view_get_line_at_y(XEN text_view, XEN target_iter, XEN y, XEN line_top)
{
  #define H_gtk_text_view_get_line_at_y "void gtk_text_view_get_line_at_y(GtkTextView* text_view, GtkTextIter* target_iter, \
gint y, gint* [line_top])"
  gint ref_line_top;
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_line_at_y", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(target_iter), target_iter, 2, "gtk_text_view_get_line_at_y", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_text_view_get_line_at_y", "gint");
  gtk_text_view_get_line_at_y(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(target_iter), XEN_TO_C_gint(y), &ref_line_top);
  return(XEN_LIST_1(C_TO_XEN_gint(ref_line_top)));
}
static XEN gxg_gtk_text_view_buffer_to_window_coords(XEN text_view, XEN win, XEN buffer_x, XEN buffer_y, XEN window_x, XEN window_y)
{
  #define H_gtk_text_view_buffer_to_window_coords "void gtk_text_view_buffer_to_window_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint buffer_x, gint buffer_y, gint* [window_x], gint* [window_y])"
  gint ref_window_x;
  gint ref_window_y;
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_buffer_to_window_coords", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(win), win, 2, "gtk_text_view_buffer_to_window_coords", "GtkTextWindowType");
  XEN_ASSERT_TYPE(XEN_gint_P(buffer_x), buffer_x, 3, "gtk_text_view_buffer_to_window_coords", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(buffer_y), buffer_y, 4, "gtk_text_view_buffer_to_window_coords", "gint");
  gtk_text_view_buffer_to_window_coords(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextWindowType(win), XEN_TO_C_gint(buffer_x), 
                                        XEN_TO_C_gint(buffer_y), &ref_window_x, &ref_window_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_window_x), C_TO_XEN_gint(ref_window_y)));
}
static XEN gxg_gtk_text_view_window_to_buffer_coords(XEN text_view, XEN win, XEN window_x, XEN window_y, XEN buffer_x, XEN buffer_y)
{
  #define H_gtk_text_view_window_to_buffer_coords "void gtk_text_view_window_to_buffer_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint window_x, gint window_y, gint* [buffer_x], gint* [buffer_y])"
  gint ref_buffer_x;
  gint ref_buffer_y;
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_window_to_buffer_coords", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(win), win, 2, "gtk_text_view_window_to_buffer_coords", "GtkTextWindowType");
  XEN_ASSERT_TYPE(XEN_gint_P(window_x), window_x, 3, "gtk_text_view_window_to_buffer_coords", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(window_y), window_y, 4, "gtk_text_view_window_to_buffer_coords", "gint");
  gtk_text_view_window_to_buffer_coords(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextWindowType(win), XEN_TO_C_gint(window_x), 
                                        XEN_TO_C_gint(window_y), &ref_buffer_x, &ref_buffer_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_buffer_x), C_TO_XEN_gint(ref_buffer_y)));
}
static XEN gxg_gtk_text_view_get_window(XEN text_view, XEN win)
{
  #define H_gtk_text_view_get_window "GdkWindow* gtk_text_view_get_window(GtkTextView* text_view, GtkTextWindowType win)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_window", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(win), win, 2, "gtk_text_view_get_window", "GtkTextWindowType");
  return(C_TO_XEN_GdkWindow_(gtk_text_view_get_window(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextWindowType(win))));
}
static XEN gxg_gtk_text_view_get_window_type(XEN text_view, XEN window)
{
  #define H_gtk_text_view_get_window_type "GtkTextWindowType gtk_text_view_get_window_type(GtkTextView* text_view, \
GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_window_type", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gtk_text_view_get_window_type", "GdkWindow*");
  return(C_TO_XEN_GtkTextWindowType(gtk_text_view_get_window_type(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gtk_text_view_set_border_window_size(XEN text_view, XEN type, XEN size)
{
  #define H_gtk_text_view_set_border_window_size "void gtk_text_view_set_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type, gint size)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_border_window_size", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(type), type, 2, "gtk_text_view_set_border_window_size", "GtkTextWindowType");
  XEN_ASSERT_TYPE(XEN_gint_P(size), size, 3, "gtk_text_view_set_border_window_size", "gint");
  gtk_text_view_set_border_window_size(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextWindowType(type), XEN_TO_C_gint(size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_border_window_size(XEN text_view, XEN type)
{
  #define H_gtk_text_view_get_border_window_size "gint gtk_text_view_get_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_border_window_size", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(type), type, 2, "gtk_text_view_get_border_window_size", "GtkTextWindowType");
  return(C_TO_XEN_gint(gtk_text_view_get_border_window_size(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextWindowType(type))));
}
static XEN gxg_gtk_text_view_forward_display_line(XEN text_view, XEN iter)
{
  #define H_gtk_text_view_forward_display_line "gboolean gtk_text_view_forward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_forward_display_line", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_forward_display_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_view_forward_display_line(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_view_backward_display_line(XEN text_view, XEN iter)
{
  #define H_gtk_text_view_backward_display_line "gboolean gtk_text_view_backward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_backward_display_line", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_backward_display_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_view_backward_display_line(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_view_forward_display_line_end(XEN text_view, XEN iter)
{
  #define H_gtk_text_view_forward_display_line_end "gboolean gtk_text_view_forward_display_line_end(GtkTextView* text_view, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_forward_display_line_end", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_forward_display_line_end", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_view_forward_display_line_end(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_view_backward_display_line_start(XEN text_view, XEN iter)
{
  #define H_gtk_text_view_backward_display_line_start "gboolean gtk_text_view_backward_display_line_start(GtkTextView* text_view, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_backward_display_line_start", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_backward_display_line_start", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_view_backward_display_line_start(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_view_starts_display_line(XEN text_view, XEN iter)
{
  #define H_gtk_text_view_starts_display_line "gboolean gtk_text_view_starts_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_starts_display_line", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_starts_display_line", "GtkTextIter*");
  return(C_TO_XEN_gboolean(gtk_text_view_starts_display_line(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter))));
}
static XEN gxg_gtk_text_view_move_visually(XEN text_view, XEN iter, XEN count)
{
  #define H_gtk_text_view_move_visually "gboolean gtk_text_view_move_visually(GtkTextView* text_view, \
GtkTextIter* iter, gint count)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_move_visually", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_move_visually", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(count), count, 3, "gtk_text_view_move_visually", "gint");
  return(C_TO_XEN_gboolean(gtk_text_view_move_visually(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gint(count))));
}
static XEN gxg_gtk_text_view_add_child_at_anchor(XEN text_view, XEN child, XEN anchor)
{
  #define H_gtk_text_view_add_child_at_anchor "void gtk_text_view_add_child_at_anchor(GtkTextView* text_view, \
GtkWidget* child, GtkTextChildAnchor* anchor)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_add_child_at_anchor", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_text_view_add_child_at_anchor", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTextChildAnchor__P(anchor), anchor, 3, "gtk_text_view_add_child_at_anchor", "GtkTextChildAnchor*");
  gtk_text_view_add_child_at_anchor(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkTextChildAnchor_(anchor));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_add_child_in_window(XEN text_view, XEN child, XEN which_window, XEN xpos, XEN ypos)
{
  #define H_gtk_text_view_add_child_in_window "void gtk_text_view_add_child_in_window(GtkTextView* text_view, \
GtkWidget* child, GtkTextWindowType which_window, gint xpos, gint ypos)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_add_child_in_window", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_text_view_add_child_in_window", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTextWindowType_P(which_window), which_window, 3, "gtk_text_view_add_child_in_window", "GtkTextWindowType");
  XEN_ASSERT_TYPE(XEN_gint_P(xpos), xpos, 4, "gtk_text_view_add_child_in_window", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ypos), ypos, 5, "gtk_text_view_add_child_in_window", "gint");
  gtk_text_view_add_child_in_window(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkTextWindowType(which_window), 
                                    XEN_TO_C_gint(xpos), XEN_TO_C_gint(ypos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_move_child(XEN text_view, XEN child, XEN xpos, XEN ypos)
{
  #define H_gtk_text_view_move_child "void gtk_text_view_move_child(GtkTextView* text_view, GtkWidget* child, \
gint xpos, gint ypos)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_move_child", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_text_view_move_child", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(xpos), xpos, 3, "gtk_text_view_move_child", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ypos), ypos, 4, "gtk_text_view_move_child", "gint");
  gtk_text_view_move_child(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkWidget_(child), XEN_TO_C_gint(xpos), XEN_TO_C_gint(ypos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_set_wrap_mode(XEN text_view, XEN wrap_mode)
{
  #define H_gtk_text_view_set_wrap_mode "void gtk_text_view_set_wrap_mode(GtkTextView* text_view, GtkWrapMode wrap_mode)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_wrap_mode", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkWrapMode_P(wrap_mode), wrap_mode, 2, "gtk_text_view_set_wrap_mode", "GtkWrapMode");
  gtk_text_view_set_wrap_mode(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkWrapMode(wrap_mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_wrap_mode(XEN text_view)
{
  #define H_gtk_text_view_get_wrap_mode "GtkWrapMode gtk_text_view_get_wrap_mode(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_wrap_mode", "GtkTextView*");
  return(C_TO_XEN_GtkWrapMode(gtk_text_view_get_wrap_mode(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_editable(XEN text_view, XEN setting)
{
  #define H_gtk_text_view_set_editable "void gtk_text_view_set_editable(GtkTextView* text_view, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_editable", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_text_view_set_editable", "gboolean");
  gtk_text_view_set_editable(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_editable(XEN text_view)
{
  #define H_gtk_text_view_get_editable "gboolean gtk_text_view_get_editable(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_editable", "GtkTextView*");
  return(C_TO_XEN_gboolean(gtk_text_view_get_editable(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_pixels_above_lines(XEN text_view, XEN pixels_above_lines)
{
  #define H_gtk_text_view_set_pixels_above_lines "void gtk_text_view_set_pixels_above_lines(GtkTextView* text_view, \
gint pixels_above_lines)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_pixels_above_lines", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(pixels_above_lines), pixels_above_lines, 2, "gtk_text_view_set_pixels_above_lines", "gint");
  gtk_text_view_set_pixels_above_lines(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(pixels_above_lines));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_pixels_above_lines(XEN text_view)
{
  #define H_gtk_text_view_get_pixels_above_lines "gint gtk_text_view_get_pixels_above_lines(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_pixels_above_lines", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_pixels_above_lines(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_pixels_below_lines(XEN text_view, XEN pixels_below_lines)
{
  #define H_gtk_text_view_set_pixels_below_lines "void gtk_text_view_set_pixels_below_lines(GtkTextView* text_view, \
gint pixels_below_lines)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_pixels_below_lines", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(pixels_below_lines), pixels_below_lines, 2, "gtk_text_view_set_pixels_below_lines", "gint");
  gtk_text_view_set_pixels_below_lines(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(pixels_below_lines));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_pixels_below_lines(XEN text_view)
{
  #define H_gtk_text_view_get_pixels_below_lines "gint gtk_text_view_get_pixels_below_lines(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_pixels_below_lines", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_pixels_below_lines(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_pixels_inside_wrap(XEN text_view, XEN pixels_inside_wrap)
{
  #define H_gtk_text_view_set_pixels_inside_wrap "void gtk_text_view_set_pixels_inside_wrap(GtkTextView* text_view, \
gint pixels_inside_wrap)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_pixels_inside_wrap", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(pixels_inside_wrap), pixels_inside_wrap, 2, "gtk_text_view_set_pixels_inside_wrap", "gint");
  gtk_text_view_set_pixels_inside_wrap(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(pixels_inside_wrap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_pixels_inside_wrap(XEN text_view)
{
  #define H_gtk_text_view_get_pixels_inside_wrap "gint gtk_text_view_get_pixels_inside_wrap(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_pixels_inside_wrap", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_pixels_inside_wrap(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_justification(XEN text_view, XEN justification)
{
  #define H_gtk_text_view_set_justification "void gtk_text_view_set_justification(GtkTextView* text_view, \
GtkJustification justification)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_justification", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkJustification_P(justification), justification, 2, "gtk_text_view_set_justification", "GtkJustification");
  gtk_text_view_set_justification(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkJustification(justification));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_justification(XEN text_view)
{
  #define H_gtk_text_view_get_justification "GtkJustification gtk_text_view_get_justification(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_justification", "GtkTextView*");
  return(C_TO_XEN_GtkJustification(gtk_text_view_get_justification(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_left_margin(XEN text_view, XEN left_margin)
{
  #define H_gtk_text_view_set_left_margin "void gtk_text_view_set_left_margin(GtkTextView* text_view, \
gint left_margin)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_left_margin", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(left_margin), left_margin, 2, "gtk_text_view_set_left_margin", "gint");
  gtk_text_view_set_left_margin(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(left_margin));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_left_margin(XEN text_view)
{
  #define H_gtk_text_view_get_left_margin "gint gtk_text_view_get_left_margin(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_left_margin", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_left_margin(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_right_margin(XEN text_view, XEN right_margin)
{
  #define H_gtk_text_view_set_right_margin "void gtk_text_view_set_right_margin(GtkTextView* text_view, \
gint right_margin)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_right_margin", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(right_margin), right_margin, 2, "gtk_text_view_set_right_margin", "gint");
  gtk_text_view_set_right_margin(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(right_margin));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_right_margin(XEN text_view)
{
  #define H_gtk_text_view_get_right_margin "gint gtk_text_view_get_right_margin(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_right_margin", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_right_margin(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_indent(XEN text_view, XEN indent)
{
  #define H_gtk_text_view_set_indent "void gtk_text_view_set_indent(GtkTextView* text_view, gint indent)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_indent", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gint_P(indent), indent, 2, "gtk_text_view_set_indent", "gint");
  gtk_text_view_set_indent(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gint(indent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_indent(XEN text_view)
{
  #define H_gtk_text_view_get_indent "gint gtk_text_view_get_indent(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_indent", "GtkTextView*");
  return(C_TO_XEN_gint(gtk_text_view_get_indent(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_tabs(XEN text_view, XEN tabs)
{
  #define H_gtk_text_view_set_tabs "void gtk_text_view_set_tabs(GtkTextView* text_view, PangoTabArray* tabs)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_tabs", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_PangoTabArray__P(tabs) || XEN_FALSE_P(tabs), tabs, 2, "gtk_text_view_set_tabs", "PangoTabArray*");
  gtk_text_view_set_tabs(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_PangoTabArray_(tabs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_tabs(XEN text_view)
{
  #define H_gtk_text_view_get_tabs "PangoTabArray* gtk_text_view_get_tabs(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_tabs", "GtkTextView*");
  return(C_TO_XEN_PangoTabArray_(gtk_text_view_get_tabs(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_get_default_attributes(XEN text_view)
{
  #define H_gtk_text_view_get_default_attributes "GtkTextAttributes* gtk_text_view_get_default_attributes(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_default_attributes", "GtkTextView*");
  return(C_TO_XEN_GtkTextAttributes_(gtk_text_view_get_default_attributes(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_toggle_button_get_type(void)
{
  #define H_gtk_toggle_button_get_type "GtkType gtk_toggle_button_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_toggle_button_get_type()));
}
static XEN gxg_gtk_toggle_button_new(void)
{
  #define H_gtk_toggle_button_new "GtkWidget* gtk_toggle_button_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_toggle_button_new()));
}
static XEN gxg_gtk_toggle_button_new_with_label(XEN label)
{
  #define H_gtk_toggle_button_new_with_label "GtkWidget* gtk_toggle_button_new_with_label(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_toggle_button_new_with_label", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_toggle_button_new_with_label(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_toggle_button_new_with_mnemonic(XEN label)
{
  #define H_gtk_toggle_button_new_with_mnemonic "GtkWidget* gtk_toggle_button_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_toggle_button_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_toggle_button_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_toggle_button_set_mode(XEN toggle_button, XEN draw_indicator)
{
  #define H_gtk_toggle_button_set_mode "void gtk_toggle_button_set_mode(GtkToggleButton* toggle_button, \
gboolean draw_indicator)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_set_mode", "GtkToggleButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(draw_indicator), draw_indicator, 2, "gtk_toggle_button_set_mode", "gboolean");
  gtk_toggle_button_set_mode(XEN_TO_C_GtkToggleButton_(toggle_button), XEN_TO_C_gboolean(draw_indicator));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_button_get_mode(XEN toggle_button)
{
  #define H_gtk_toggle_button_get_mode "gboolean gtk_toggle_button_get_mode(GtkToggleButton* toggle_button)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_get_mode", "GtkToggleButton*");
  return(C_TO_XEN_gboolean(gtk_toggle_button_get_mode(XEN_TO_C_GtkToggleButton_(toggle_button))));
}
static XEN gxg_gtk_toggle_button_set_active(XEN toggle_button, XEN is_active)
{
  #define H_gtk_toggle_button_set_active "void gtk_toggle_button_set_active(GtkToggleButton* toggle_button, \
gboolean is_active)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_set_active", "GtkToggleButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_active), is_active, 2, "gtk_toggle_button_set_active", "gboolean");
  gtk_toggle_button_set_active(XEN_TO_C_GtkToggleButton_(toggle_button), XEN_TO_C_gboolean(is_active));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_button_get_active(XEN toggle_button)
{
  #define H_gtk_toggle_button_get_active "gboolean gtk_toggle_button_get_active(GtkToggleButton* toggle_button)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_get_active", "GtkToggleButton*");
  return(C_TO_XEN_gboolean(gtk_toggle_button_get_active(XEN_TO_C_GtkToggleButton_(toggle_button))));
}
static XEN gxg_gtk_toggle_button_toggled(XEN toggle_button)
{
  #define H_gtk_toggle_button_toggled "void gtk_toggle_button_toggled(GtkToggleButton* toggle_button)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_toggled", "GtkToggleButton*");
  gtk_toggle_button_toggled(XEN_TO_C_GtkToggleButton_(toggle_button));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_button_set_inconsistent(XEN toggle_button, XEN setting)
{
  #define H_gtk_toggle_button_set_inconsistent "void gtk_toggle_button_set_inconsistent(GtkToggleButton* toggle_button, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_set_inconsistent", "GtkToggleButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_toggle_button_set_inconsistent", "gboolean");
  gtk_toggle_button_set_inconsistent(XEN_TO_C_GtkToggleButton_(toggle_button), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_button_get_inconsistent(XEN toggle_button)
{
  #define H_gtk_toggle_button_get_inconsistent "gboolean gtk_toggle_button_get_inconsistent(GtkToggleButton* toggle_button)"
  XEN_ASSERT_TYPE(XEN_GtkToggleButton__P(toggle_button), toggle_button, 1, "gtk_toggle_button_get_inconsistent", "GtkToggleButton*");
  return(C_TO_XEN_gboolean(gtk_toggle_button_get_inconsistent(XEN_TO_C_GtkToggleButton_(toggle_button))));
}
static XEN gxg_gtk_toolbar_get_type(void)
{
  #define H_gtk_toolbar_get_type "GtkType gtk_toolbar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_toolbar_get_type()));
}
static XEN gxg_gtk_toolbar_new(void)
{
  #define H_gtk_toolbar_new "GtkWidget* gtk_toolbar_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_toolbar_new()));
}
static XEN gxg_gtk_toolbar_set_orientation(XEN toolbar, XEN orientation)
{
  #define H_gtk_toolbar_set_orientation "void gtk_toolbar_set_orientation(GtkToolbar* toolbar, GtkOrientation orientation)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_set_orientation", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_GtkOrientation_P(orientation), orientation, 2, "gtk_toolbar_set_orientation", "GtkOrientation");
  gtk_toolbar_set_orientation(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_GtkOrientation(orientation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_set_style(XEN toolbar, XEN style)
{
  #define H_gtk_toolbar_set_style "void gtk_toolbar_set_style(GtkToolbar* toolbar, GtkToolbarStyle style)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_set_style", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_GtkToolbarStyle_P(style), style, 2, "gtk_toolbar_set_style", "GtkToolbarStyle");
  gtk_toolbar_set_style(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_GtkToolbarStyle(style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_set_tooltips(XEN toolbar, XEN enable)
{
  #define H_gtk_toolbar_set_tooltips "void gtk_toolbar_set_tooltips(GtkToolbar* toolbar, gboolean enable)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_set_tooltips", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(enable), enable, 2, "gtk_toolbar_set_tooltips", "gboolean");
  gtk_toolbar_set_tooltips(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_gboolean(enable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_unset_style(XEN toolbar)
{
  #define H_gtk_toolbar_unset_style "void gtk_toolbar_unset_style(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_unset_style", "GtkToolbar*");
  gtk_toolbar_unset_style(XEN_TO_C_GtkToolbar_(toolbar));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_get_orientation(XEN toolbar)
{
  #define H_gtk_toolbar_get_orientation "GtkOrientation gtk_toolbar_get_orientation(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_orientation", "GtkToolbar*");
  return(C_TO_XEN_GtkOrientation(gtk_toolbar_get_orientation(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_style(XEN toolbar)
{
  #define H_gtk_toolbar_get_style "GtkToolbarStyle gtk_toolbar_get_style(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_style", "GtkToolbar*");
  return(C_TO_XEN_GtkToolbarStyle(gtk_toolbar_get_style(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_icon_size(XEN toolbar)
{
  #define H_gtk_toolbar_get_icon_size "GtkIconSize gtk_toolbar_get_icon_size(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_icon_size", "GtkToolbar*");
  return(C_TO_XEN_GtkIconSize(gtk_toolbar_get_icon_size(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_tooltips(XEN toolbar)
{
  #define H_gtk_toolbar_get_tooltips "gboolean gtk_toolbar_get_tooltips(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_tooltips", "GtkToolbar*");
  return(C_TO_XEN_gboolean(gtk_toolbar_get_tooltips(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_tooltips_get_type(void)
{
  #define H_gtk_tooltips_get_type "GtkType gtk_tooltips_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tooltips_get_type()));
}
static XEN gxg_gtk_tooltips_new(void)
{
  #define H_gtk_tooltips_new "GtkTooltips* gtk_tooltips_new( void)"
  return(C_TO_XEN_GtkTooltips_(gtk_tooltips_new()));
}
static XEN gxg_gtk_tooltips_enable(XEN tooltips)
{
  #define H_gtk_tooltips_enable "void gtk_tooltips_enable(GtkTooltips* tooltips)"
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 1, "gtk_tooltips_enable", "GtkTooltips*");
  gtk_tooltips_enable(XEN_TO_C_GtkTooltips_(tooltips));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tooltips_disable(XEN tooltips)
{
  #define H_gtk_tooltips_disable "void gtk_tooltips_disable(GtkTooltips* tooltips)"
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 1, "gtk_tooltips_disable", "GtkTooltips*");
  gtk_tooltips_disable(XEN_TO_C_GtkTooltips_(tooltips));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tooltips_set_tip(XEN tooltips, XEN widget, XEN tip_text, XEN tip_private)
{
  #define H_gtk_tooltips_set_tip "void gtk_tooltips_set_tip(GtkTooltips* tooltips, GtkWidget* widget, \
gchar* tip_text, gchar* tip_private)"
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 1, "gtk_tooltips_set_tip", "GtkTooltips*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 2, "gtk_tooltips_set_tip", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_text), tip_text, 3, "gtk_tooltips_set_tip", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_private), tip_private, 4, "gtk_tooltips_set_tip", "gchar*");
  gtk_tooltips_set_tip(XEN_TO_C_GtkTooltips_(tooltips), XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(tip_text), XEN_TO_C_gchar_(tip_private));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tooltips_data_get(XEN widget)
{
  #define H_gtk_tooltips_data_get "GtkTooltipsData* gtk_tooltips_data_get(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_tooltips_data_get", "GtkWidget*");
  return(C_TO_XEN_GtkTooltipsData_(gtk_tooltips_data_get(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_tooltips_force_window(XEN tooltips)
{
  #define H_gtk_tooltips_force_window "void gtk_tooltips_force_window(GtkTooltips* tooltips)"
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 1, "gtk_tooltips_force_window", "GtkTooltips*");
  gtk_tooltips_force_window(XEN_TO_C_GtkTooltips_(tooltips));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_drag_source_get_type(void)
{
  #define H_gtk_tree_drag_source_get_type "GType gtk_tree_drag_source_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_drag_source_get_type()));
}
static XEN gxg_gtk_tree_drag_source_row_draggable(XEN drag_source, XEN path)
{
  #define H_gtk_tree_drag_source_row_draggable "gboolean gtk_tree_drag_source_row_draggable(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeDragSource__P(drag_source), drag_source, 1, "gtk_tree_drag_source_row_draggable", "GtkTreeDragSource*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_drag_source_row_draggable", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_drag_source_row_draggable(XEN_TO_C_GtkTreeDragSource_(drag_source), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_drag_source_drag_data_delete(XEN drag_source, XEN path)
{
  #define H_gtk_tree_drag_source_drag_data_delete "gboolean gtk_tree_drag_source_drag_data_delete(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeDragSource__P(drag_source), drag_source, 1, "gtk_tree_drag_source_drag_data_delete", "GtkTreeDragSource*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_drag_source_drag_data_delete", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_drag_source_drag_data_delete(XEN_TO_C_GtkTreeDragSource_(drag_source), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_drag_source_drag_data_get(XEN drag_source, XEN path, XEN selection_data)
{
  #define H_gtk_tree_drag_source_drag_data_get "gboolean gtk_tree_drag_source_drag_data_get(GtkTreeDragSource* drag_source, \
GtkTreePath* path, GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeDragSource__P(drag_source), drag_source, 1, "gtk_tree_drag_source_drag_data_get", "GtkTreeDragSource*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_drag_source_drag_data_get", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 3, "gtk_tree_drag_source_drag_data_get", "GtkSelectionData*");
  return(C_TO_XEN_gboolean(gtk_tree_drag_source_drag_data_get(XEN_TO_C_GtkTreeDragSource_(drag_source), XEN_TO_C_GtkTreePath_(path), 
                                                              XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_tree_drag_dest_get_type(void)
{
  #define H_gtk_tree_drag_dest_get_type "GType gtk_tree_drag_dest_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_drag_dest_get_type()));
}
static XEN gxg_gtk_tree_drag_dest_drag_data_received(XEN drag_dest, XEN dest, XEN selection_data)
{
  #define H_gtk_tree_drag_dest_drag_data_received "gboolean gtk_tree_drag_dest_drag_data_received(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest, GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeDragDest__P(drag_dest), drag_dest, 1, "gtk_tree_drag_dest_drag_data_received", "GtkTreeDragDest*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(dest), dest, 2, "gtk_tree_drag_dest_drag_data_received", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 3, "gtk_tree_drag_dest_drag_data_received", "GtkSelectionData*");
  return(C_TO_XEN_gboolean(gtk_tree_drag_dest_drag_data_received(XEN_TO_C_GtkTreeDragDest_(drag_dest), XEN_TO_C_GtkTreePath_(dest), 
                                                                 XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_tree_drag_dest_row_drop_possible(XEN drag_dest, XEN dest_path, XEN selection_data)
{
  #define H_gtk_tree_drag_dest_row_drop_possible "gboolean gtk_tree_drag_dest_row_drop_possible(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest_path, GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeDragDest__P(drag_dest), drag_dest, 1, "gtk_tree_drag_dest_row_drop_possible", "GtkTreeDragDest*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(dest_path), dest_path, 2, "gtk_tree_drag_dest_row_drop_possible", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 3, "gtk_tree_drag_dest_row_drop_possible", "GtkSelectionData*");
  return(C_TO_XEN_gboolean(gtk_tree_drag_dest_row_drop_possible(XEN_TO_C_GtkTreeDragDest_(drag_dest), XEN_TO_C_GtkTreePath_(dest_path), 
                                                                XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_tree_set_row_drag_data(XEN selection_data, XEN tree_model, XEN path)
{
  #define H_gtk_tree_set_row_drag_data "gboolean gtk_tree_set_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel* tree_model, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_tree_set_row_drag_data", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 2, "gtk_tree_set_row_drag_data", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 3, "gtk_tree_set_row_drag_data", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_set_row_drag_data(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_GtkTreeModel_(tree_model), 
                                                      XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_get_row_drag_data(XEN selection_data, XEN tree_model, XEN path)
{
  #define H_gtk_tree_get_row_drag_data "gboolean gtk_tree_get_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel** [tree_model], GtkTreePath** [path])"
  GtkTreeModel* ref_tree_model = NULL;
  GtkTreePath* ref_path = NULL;
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_tree_get_row_drag_data", "GtkSelectionData*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tree_get_row_drag_data(XEN_TO_C_GtkSelectionData_(selection_data), &ref_tree_model, &ref_path));
    return(XEN_LIST_3(result, C_TO_XEN_GtkTreeModel_(ref_tree_model), C_TO_XEN_GtkTreePath_(ref_path)));
   }
}
static XEN gxg_gtk_tree_path_new(void)
{
  #define H_gtk_tree_path_new "GtkTreePath* gtk_tree_path_new( void)"
  return(C_TO_XEN_GtkTreePath_(gtk_tree_path_new()));
}
static XEN gxg_gtk_tree_path_new_from_string(XEN path)
{
  #define H_gtk_tree_path_new_from_string "GtkTreePath* gtk_tree_path_new_from_string(gchar* path)"
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 1, "gtk_tree_path_new_from_string", "gchar*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_path_new_from_string(XEN_TO_C_gchar_(path))));
}
static XEN gxg_gtk_tree_path_to_string(XEN path)
{
  #define H_gtk_tree_path_to_string "gchar* gtk_tree_path_to_string(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_to_string", "GtkTreePath*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_tree_path_to_string(XEN_TO_C_GtkTreePath_(path));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_tree_path_new_first(void)
{
  #define H_gtk_tree_path_new_first "GtkTreePath* gtk_tree_path_new_first( void)"
  return(C_TO_XEN_GtkTreePath_(gtk_tree_path_new_first()));
}
static XEN gxg_gtk_tree_path_append_index(XEN path, XEN index)
{
  #define H_gtk_tree_path_append_index "void gtk_tree_path_append_index(GtkTreePath* path, gint index)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_append_index", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_tree_path_append_index", "gint");
  gtk_tree_path_append_index(XEN_TO_C_GtkTreePath_(path), XEN_TO_C_gint(index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_path_prepend_index(XEN path, XEN index)
{
  #define H_gtk_tree_path_prepend_index "void gtk_tree_path_prepend_index(GtkTreePath* path, gint index)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_prepend_index", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_tree_path_prepend_index", "gint");
  gtk_tree_path_prepend_index(XEN_TO_C_GtkTreePath_(path), XEN_TO_C_gint(index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_path_get_depth(XEN path)
{
  #define H_gtk_tree_path_get_depth "gint gtk_tree_path_get_depth(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_get_depth", "GtkTreePath*");
  return(C_TO_XEN_gint(gtk_tree_path_get_depth(XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_path_get_indices(XEN path)
{
  #define H_gtk_tree_path_get_indices "gint* gtk_tree_path_get_indices(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_get_indices", "GtkTreePath*");
  return(C_TO_XEN_gint_(gtk_tree_path_get_indices(XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_path_free(XEN path)
{
  #define H_gtk_tree_path_free "void gtk_tree_path_free(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_free", "GtkTreePath*");
  gtk_tree_path_free(XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_path_copy(XEN path)
{
  #define H_gtk_tree_path_copy "GtkTreePath* gtk_tree_path_copy(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_copy", "GtkTreePath*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_path_copy(XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_path_compare(XEN a, XEN b)
{
  #define H_gtk_tree_path_compare "gint gtk_tree_path_compare(GtkTreePath* a, GtkTreePath* b)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(a), a, 1, "gtk_tree_path_compare", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(b), b, 2, "gtk_tree_path_compare", "GtkTreePath*");
  return(C_TO_XEN_gint(gtk_tree_path_compare(XEN_TO_C_GtkTreePath_(a), XEN_TO_C_GtkTreePath_(b))));
}
static XEN gxg_gtk_tree_path_next(XEN path)
{
  #define H_gtk_tree_path_next "void gtk_tree_path_next(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_next", "GtkTreePath*");
  gtk_tree_path_next(XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_path_prev(XEN path)
{
  #define H_gtk_tree_path_prev "gboolean gtk_tree_path_prev(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_prev", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_path_prev(XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_path_up(XEN path)
{
  #define H_gtk_tree_path_up "gboolean gtk_tree_path_up(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_up", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_path_up(XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_path_down(XEN path)
{
  #define H_gtk_tree_path_down "void gtk_tree_path_down(GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_down", "GtkTreePath*");
  gtk_tree_path_down(XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_path_is_ancestor(XEN path, XEN descendant)
{
  #define H_gtk_tree_path_is_ancestor "gboolean gtk_tree_path_is_ancestor(GtkTreePath* path, GtkTreePath* descendant)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_is_ancestor", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(descendant), descendant, 2, "gtk_tree_path_is_ancestor", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_path_is_ancestor(XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreePath_(descendant))));
}
static XEN gxg_gtk_tree_path_is_descendant(XEN path, XEN ancestor)
{
  #define H_gtk_tree_path_is_descendant "gboolean gtk_tree_path_is_descendant(GtkTreePath* path, GtkTreePath* ancestor)"
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 1, "gtk_tree_path_is_descendant", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(ancestor), ancestor, 2, "gtk_tree_path_is_descendant", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_path_is_descendant(XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreePath_(ancestor))));
}
static XEN gxg_gtk_tree_row_reference_new(XEN model, XEN path)
{
  #define H_gtk_tree_row_reference_new "GtkTreeRowReference* gtk_tree_row_reference_new(GtkTreeModel* model, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_tree_row_reference_new", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_row_reference_new", "GtkTreePath*");
  return(C_TO_XEN_GtkTreeRowReference_(gtk_tree_row_reference_new(XEN_TO_C_GtkTreeModel_(model), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_row_reference_new_proxy(XEN proxy, XEN model, XEN path)
{
  #define H_gtk_tree_row_reference_new_proxy "GtkTreeRowReference* gtk_tree_row_reference_new_proxy(GObject* proxy, \
GtkTreeModel* model, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GObject__P(proxy), proxy, 1, "gtk_tree_row_reference_new_proxy", "GObject*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 2, "gtk_tree_row_reference_new_proxy", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 3, "gtk_tree_row_reference_new_proxy", "GtkTreePath*");
  return(C_TO_XEN_GtkTreeRowReference_(gtk_tree_row_reference_new_proxy(XEN_TO_C_GObject_(proxy), XEN_TO_C_GtkTreeModel_(model), 
                                                                        XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_row_reference_get_path(XEN reference)
{
  #define H_gtk_tree_row_reference_get_path "GtkTreePath* gtk_tree_row_reference_get_path(GtkTreeRowReference* reference)"
  XEN_ASSERT_TYPE(XEN_GtkTreeRowReference__P(reference), reference, 1, "gtk_tree_row_reference_get_path", "GtkTreeRowReference*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_row_reference_get_path(XEN_TO_C_GtkTreeRowReference_(reference))));
}
static XEN gxg_gtk_tree_row_reference_valid(XEN reference)
{
  #define H_gtk_tree_row_reference_valid "gboolean gtk_tree_row_reference_valid(GtkTreeRowReference* reference)"
  XEN_ASSERT_TYPE(XEN_GtkTreeRowReference__P(reference), reference, 1, "gtk_tree_row_reference_valid", "GtkTreeRowReference*");
  return(C_TO_XEN_gboolean(gtk_tree_row_reference_valid(XEN_TO_C_GtkTreeRowReference_(reference))));
}
static XEN gxg_gtk_tree_row_reference_free(XEN reference)
{
  #define H_gtk_tree_row_reference_free "void gtk_tree_row_reference_free(GtkTreeRowReference* reference)"
  XEN_ASSERT_TYPE(XEN_GtkTreeRowReference__P(reference), reference, 1, "gtk_tree_row_reference_free", "GtkTreeRowReference*");
  gtk_tree_row_reference_free(XEN_TO_C_GtkTreeRowReference_(reference));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_row_reference_inserted(XEN proxy, XEN path)
{
  #define H_gtk_tree_row_reference_inserted "void gtk_tree_row_reference_inserted(GObject* proxy, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GObject__P(proxy), proxy, 1, "gtk_tree_row_reference_inserted", "GObject*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_row_reference_inserted", "GtkTreePath*");
  gtk_tree_row_reference_inserted(XEN_TO_C_GObject_(proxy), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_row_reference_deleted(XEN proxy, XEN path)
{
  #define H_gtk_tree_row_reference_deleted "void gtk_tree_row_reference_deleted(GObject* proxy, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GObject__P(proxy), proxy, 1, "gtk_tree_row_reference_deleted", "GObject*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_row_reference_deleted", "GtkTreePath*");
  gtk_tree_row_reference_deleted(XEN_TO_C_GObject_(proxy), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_row_reference_reordered(XEN proxy, XEN path, XEN iter, XEN new_order)
{
  #define H_gtk_tree_row_reference_reordered "void gtk_tree_row_reference_reordered(GObject* proxy, GtkTreePath* path, \
GtkTreeIter* iter, gint* new_order)"
  XEN_ASSERT_TYPE(XEN_GObject__P(proxy), proxy, 1, "gtk_tree_row_reference_reordered", "GObject*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_row_reference_reordered", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_row_reference_reordered", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint__P(new_order), new_order, 4, "gtk_tree_row_reference_reordered", "gint*");
  gtk_tree_row_reference_reordered(XEN_TO_C_GObject_(proxy), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_gint_(new_order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_iter_copy(XEN iter)
{
  #define H_gtk_tree_iter_copy "GtkTreeIter* gtk_tree_iter_copy(GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 1, "gtk_tree_iter_copy", "GtkTreeIter*");
  return(C_TO_XEN_GtkTreeIter_(gtk_tree_iter_copy(XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_iter_free(XEN iter)
{
  #define H_gtk_tree_iter_free "void gtk_tree_iter_free(GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 1, "gtk_tree_iter_free", "GtkTreeIter*");
  gtk_tree_iter_free(XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_get_type(void)
{
  #define H_gtk_tree_model_get_type "GtkType gtk_tree_model_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tree_model_get_type()));
}
static XEN gxg_gtk_tree_model_get_flags(XEN tree_model)
{
  #define H_gtk_tree_model_get_flags "GtkTreeModelFlags gtk_tree_model_get_flags(GtkTreeModel* tree_model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_flags", "GtkTreeModel*");
  return(C_TO_XEN_GtkTreeModelFlags(gtk_tree_model_get_flags(XEN_TO_C_GtkTreeModel_(tree_model))));
}
static XEN gxg_gtk_tree_model_get_n_columns(XEN tree_model)
{
  #define H_gtk_tree_model_get_n_columns "gint gtk_tree_model_get_n_columns(GtkTreeModel* tree_model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_n_columns", "GtkTreeModel*");
  return(C_TO_XEN_gint(gtk_tree_model_get_n_columns(XEN_TO_C_GtkTreeModel_(tree_model))));
}
static XEN gxg_gtk_tree_model_get_column_type(XEN tree_model, XEN index)
{
  #define H_gtk_tree_model_get_column_type "GType gtk_tree_model_get_column_type(GtkTreeModel* tree_model, \
gint index)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_column_type", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_tree_model_get_column_type", "gint");
  return(C_TO_XEN_GType(gtk_tree_model_get_column_type(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_gint(index))));
}
static XEN gxg_gtk_tree_model_get_iter(XEN tree_model, XEN iter, XEN path)
{
  #define H_gtk_tree_model_get_iter "gboolean gtk_tree_model_get_iter(GtkTreeModel* tree_model, GtkTreeIter* iter, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_iter", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_get_iter", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 3, "gtk_tree_model_get_iter", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_model_get_iter(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_model_get_iter_from_string(XEN tree_model, XEN iter, XEN path_string)
{
  #define H_gtk_tree_model_get_iter_from_string "gboolean gtk_tree_model_get_iter_from_string(GtkTreeModel* tree_model, \
GtkTreeIter* iter, gchar* path_string)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_iter_from_string", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_get_iter_from_string", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path_string), path_string, 3, "gtk_tree_model_get_iter_from_string", "gchar*");
  return(C_TO_XEN_gboolean(gtk_tree_model_get_iter_from_string(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), 
                                                               XEN_TO_C_gchar_(path_string))));
}
static XEN gxg_gtk_tree_model_get_iter_first(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_get_iter_first "gboolean gtk_tree_model_get_iter_first(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_iter_first", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_get_iter_first", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_get_iter_first(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_model_get_path(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_get_path "GtkTreePath* gtk_tree_model_get_path(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_path", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_get_path", "GtkTreeIter*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_model_get_path(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_model_iter_next(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_iter_next "gboolean gtk_tree_model_iter_next(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_next", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_iter_next", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_iter_next(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_model_iter_children(XEN tree_model, XEN iter, XEN parent)
{
  #define H_gtk_tree_model_iter_children "gboolean gtk_tree_model_iter_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_children", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_iter_children", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_model_iter_children", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_iter_children(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), 
                                                        XEN_TO_C_GtkTreeIter_(parent))));
}
static XEN gxg_gtk_tree_model_iter_has_child(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_iter_has_child "gboolean gtk_tree_model_iter_has_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_has_child", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_iter_has_child", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_iter_has_child(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_model_iter_n_children(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_iter_n_children "gint gtk_tree_model_iter_n_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_n_children", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter) || XEN_FALSE_P(iter), iter, 2, "gtk_tree_model_iter_n_children", "GtkTreeIter*");
  return(C_TO_XEN_gint(gtk_tree_model_iter_n_children(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_model_iter_nth_child(XEN tree_model, XEN iter, XEN parent, XEN n)
{
  #define H_gtk_tree_model_iter_nth_child "gboolean gtk_tree_model_iter_nth_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent, gint n)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_nth_child", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_iter_nth_child", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_model_iter_nth_child", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(n), n, 4, "gtk_tree_model_iter_nth_child", "gint");
  return(C_TO_XEN_gboolean(gtk_tree_model_iter_nth_child(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), 
                                                         XEN_TO_C_GtkTreeIter_(parent), XEN_TO_C_gint(n))));
}
static XEN gxg_gtk_tree_model_iter_parent(XEN tree_model, XEN iter, XEN child)
{
  #define H_gtk_tree_model_iter_parent "gboolean gtk_tree_model_iter_parent(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* child)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_iter_parent", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_iter_parent", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(child), child, 3, "gtk_tree_model_iter_parent", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_iter_parent(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(child))));
}
static XEN gxg_gtk_tree_model_ref_node(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_ref_node "void gtk_tree_model_ref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_ref_node", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_ref_node", "GtkTreeIter*");
  gtk_tree_model_ref_node(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_unref_node(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_unref_node "void gtk_tree_model_unref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_unref_node", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_unref_node", "GtkTreeIter*");
  gtk_tree_model_unref_node(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_foreach(XEN model, XEN func, XEN func_data)
{
  #define H_gtk_tree_model_foreach "void gtk_tree_model_foreach(GtkTreeModel* model, GtkTreeModelForeachFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_tree_model_foreach", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModelForeachFunc_P(func), func, 2, "gtk_tree_model_foreach", "GtkTreeModelForeachFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_model_foreach", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_tree_model_foreach(XEN_TO_C_GtkTreeModel_(model), XEN_TO_C_GtkTreeModelForeachFunc(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_model_row_changed(XEN tree_model, XEN path, XEN iter)
{
  #define H_gtk_tree_model_row_changed "void gtk_tree_model_row_changed(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_row_changed", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_model_row_changed", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_model_row_changed", "GtkTreeIter*");
  gtk_tree_model_row_changed(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_row_inserted(XEN tree_model, XEN path, XEN iter)
{
  #define H_gtk_tree_model_row_inserted "void gtk_tree_model_row_inserted(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_row_inserted", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_model_row_inserted", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_model_row_inserted", "GtkTreeIter*");
  gtk_tree_model_row_inserted(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_row_has_child_toggled(XEN tree_model, XEN path, XEN iter)
{
  #define H_gtk_tree_model_row_has_child_toggled "void gtk_tree_model_row_has_child_toggled(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_row_has_child_toggled", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_model_row_has_child_toggled", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_model_row_has_child_toggled", "GtkTreeIter*");
  gtk_tree_model_row_has_child_toggled(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_row_deleted(XEN tree_model, XEN path)
{
  #define H_gtk_tree_model_row_deleted "void gtk_tree_model_row_deleted(GtkTreeModel* tree_model, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_row_deleted", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_model_row_deleted", "GtkTreePath*");
  gtk_tree_model_row_deleted(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_rows_reordered(XEN tree_model, XEN path, XEN iter, XEN new_order)
{
  #define H_gtk_tree_model_rows_reordered "void gtk_tree_model_rows_reordered(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_rows_reordered", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_model_rows_reordered", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_model_rows_reordered", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint__P(new_order), new_order, 4, "gtk_tree_model_rows_reordered", "gint*");
  gtk_tree_model_rows_reordered(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeIter_(iter), 
                                XEN_TO_C_gint_(new_order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_sort_get_type(void)
{
  #define H_gtk_tree_model_sort_get_type "GType gtk_tree_model_sort_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_model_sort_get_type()));
}
static XEN gxg_gtk_tree_model_sort_new_with_model(XEN child_model)
{
  #define H_gtk_tree_model_sort_new_with_model "GtkTreeModel* gtk_tree_model_sort_new_with_model(GtkTreeModel* child_model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(child_model), child_model, 1, "gtk_tree_model_sort_new_with_model", "GtkTreeModel*");
  return(C_TO_XEN_GtkTreeModel_(gtk_tree_model_sort_new_with_model(XEN_TO_C_GtkTreeModel_(child_model))));
}
static XEN gxg_gtk_tree_model_sort_get_model(XEN tree_model)
{
  #define H_gtk_tree_model_sort_get_model "GtkTreeModel* gtk_tree_model_sort_get_model(GtkTreeModelSort* tree_model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model), tree_model, 1, "gtk_tree_model_sort_get_model", "GtkTreeModelSort*");
  return(C_TO_XEN_GtkTreeModel_(gtk_tree_model_sort_get_model(XEN_TO_C_GtkTreeModelSort_(tree_model))));
}
static XEN gxg_gtk_tree_model_sort_convert_child_path_to_path(XEN tree_model_sort, XEN child_path)
{
  #define H_gtk_tree_model_sort_convert_child_path_to_path "GtkTreePath* gtk_tree_model_sort_convert_child_path_to_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* child_path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_child_path_to_path", "GtkTreeModelSort*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(child_path), child_path, 2, "gtk_tree_model_sort_convert_child_path_to_path", "GtkTreePath*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_model_sort_convert_child_path_to_path(XEN_TO_C_GtkTreeModelSort_(tree_model_sort), 
                                                                              XEN_TO_C_GtkTreePath_(child_path))));
}
static XEN gxg_gtk_tree_model_sort_convert_child_iter_to_iter(XEN tree_model_sort, XEN sort_iter, XEN child_iter)
{
  #define H_gtk_tree_model_sort_convert_child_iter_to_iter "void gtk_tree_model_sort_convert_child_iter_to_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* sort_iter, GtkTreeIter* child_iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeModelSort*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sort_iter), sort_iter, 2, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(child_iter), child_iter, 3, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeIter*");
  gtk_tree_model_sort_convert_child_iter_to_iter(XEN_TO_C_GtkTreeModelSort_(tree_model_sort), XEN_TO_C_GtkTreeIter_(sort_iter), 
                                                 XEN_TO_C_GtkTreeIter_(child_iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_sort_convert_path_to_child_path(XEN tree_model_sort, XEN sorted_path)
{
  #define H_gtk_tree_model_sort_convert_path_to_child_path "GtkTreePath* gtk_tree_model_sort_convert_path_to_child_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* sorted_path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_path_to_child_path", "GtkTreeModelSort*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(sorted_path), sorted_path, 2, "gtk_tree_model_sort_convert_path_to_child_path", "GtkTreePath*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_model_sort_convert_path_to_child_path(XEN_TO_C_GtkTreeModelSort_(tree_model_sort), 
                                                                              XEN_TO_C_GtkTreePath_(sorted_path))));
}
static XEN gxg_gtk_tree_model_sort_convert_iter_to_child_iter(XEN tree_model_sort, XEN child_iter, XEN sorted_iter)
{
  #define H_gtk_tree_model_sort_convert_iter_to_child_iter "void gtk_tree_model_sort_convert_iter_to_child_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* child_iter, GtkTreeIter* sorted_iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeModelSort*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(child_iter), child_iter, 2, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sorted_iter), sorted_iter, 3, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeIter*");
  gtk_tree_model_sort_convert_iter_to_child_iter(XEN_TO_C_GtkTreeModelSort_(tree_model_sort), XEN_TO_C_GtkTreeIter_(child_iter), 
                                                 XEN_TO_C_GtkTreeIter_(sorted_iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_sort_reset_default_sort_func(XEN tree_model_sort)
{
  #define H_gtk_tree_model_sort_reset_default_sort_func "void gtk_tree_model_sort_reset_default_sort_func(GtkTreeModelSort* tree_model_sort)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_reset_default_sort_func", "GtkTreeModelSort*");
  gtk_tree_model_sort_reset_default_sort_func(XEN_TO_C_GtkTreeModelSort_(tree_model_sort));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_sort_clear_cache(XEN tree_model_sort)
{
  #define H_gtk_tree_model_sort_clear_cache "void gtk_tree_model_sort_clear_cache(GtkTreeModelSort* tree_model_sort)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_clear_cache", "GtkTreeModelSort*");
  gtk_tree_model_sort_clear_cache(XEN_TO_C_GtkTreeModelSort_(tree_model_sort));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_get_type(void)
{
  #define H_gtk_tree_selection_get_type "GtkType gtk_tree_selection_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tree_selection_get_type()));
}
static XEN gxg_gtk_tree_selection_set_mode(XEN selection, XEN type)
{
  #define H_gtk_tree_selection_set_mode "void gtk_tree_selection_set_mode(GtkTreeSelection* selection, \
GtkSelectionMode type)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_set_mode", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkSelectionMode_P(type), type, 2, "gtk_tree_selection_set_mode", "GtkSelectionMode");
  gtk_tree_selection_set_mode(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkSelectionMode(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_get_mode(XEN selection)
{
  #define H_gtk_tree_selection_get_mode "GtkSelectionMode gtk_tree_selection_get_mode(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_get_mode", "GtkTreeSelection*");
  return(C_TO_XEN_GtkSelectionMode(gtk_tree_selection_get_mode(XEN_TO_C_GtkTreeSelection_(selection))));
}
static XEN gxg_gtk_tree_selection_set_select_function(XEN selection, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_selection_set_select_function "void gtk_tree_selection_set_select_function(GtkTreeSelection* selection, \
GtkTreeSelectionFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_set_select_function", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeSelectionFunc_P(func), func, 2, "gtk_tree_selection_set_select_function", "GtkTreeSelectionFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_selection_set_select_function", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 4, "gtk_tree_selection_set_select_function", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_selection_set_select_function(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeSelectionFunc(func), XEN_TO_C_lambda_data(func_data), 
                                       XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_selection_get_user_data(XEN selection)
{
  #define H_gtk_tree_selection_get_user_data "gpointer gtk_tree_selection_get_user_data(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_get_user_data", "GtkTreeSelection*");
  return(C_TO_XEN_gpointer(gtk_tree_selection_get_user_data(XEN_TO_C_GtkTreeSelection_(selection))));
}
static XEN gxg_gtk_tree_selection_get_tree_view(XEN selection)
{
  #define H_gtk_tree_selection_get_tree_view "GtkTreeView* gtk_tree_selection_get_tree_view(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_get_tree_view", "GtkTreeSelection*");
  return(C_TO_XEN_GtkTreeView_(gtk_tree_selection_get_tree_view(XEN_TO_C_GtkTreeSelection_(selection))));
}
static XEN gxg_gtk_tree_selection_get_selected(XEN selection, XEN model, XEN iter)
{
  #define H_gtk_tree_selection_get_selected "gboolean gtk_tree_selection_get_selected(GtkTreeSelection* selection, \
GtkTreeModel** model, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_get_selected", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel___P(model), model, 2, "gtk_tree_selection_get_selected", "GtkTreeModel**");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_selection_get_selected", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_selection_get_selected(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeModel__(model), 
                                                           XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_selection_selected_foreach(XEN selection, XEN func, XEN func_data)
{
  #define H_gtk_tree_selection_selected_foreach "void gtk_tree_selection_selected_foreach(GtkTreeSelection* selection, \
GtkTreeSelectionForeachFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_selected_foreach", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeSelectionForeachFunc_P(func), func, 2, "gtk_tree_selection_selected_foreach", "GtkTreeSelectionForeachFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_selection_selected_foreach", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_tree_selection_selected_foreach(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeSelectionForeachFunc(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_selection_select_path(XEN selection, XEN path)
{
  #define H_gtk_tree_selection_select_path "void gtk_tree_selection_select_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_select_path", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_selection_select_path", "GtkTreePath*");
  gtk_tree_selection_select_path(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_unselect_path(XEN selection, XEN path)
{
  #define H_gtk_tree_selection_unselect_path "void gtk_tree_selection_unselect_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_unselect_path", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_selection_unselect_path", "GtkTreePath*");
  gtk_tree_selection_unselect_path(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_select_iter(XEN selection, XEN iter)
{
  #define H_gtk_tree_selection_select_iter "void gtk_tree_selection_select_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_select_iter", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_selection_select_iter", "GtkTreeIter*");
  gtk_tree_selection_select_iter(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_unselect_iter(XEN selection, XEN iter)
{
  #define H_gtk_tree_selection_unselect_iter "void gtk_tree_selection_unselect_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_unselect_iter", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_selection_unselect_iter", "GtkTreeIter*");
  gtk_tree_selection_unselect_iter(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_path_is_selected(XEN selection, XEN path)
{
  #define H_gtk_tree_selection_path_is_selected "gboolean gtk_tree_selection_path_is_selected(GtkTreeSelection* selection, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_path_is_selected", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_selection_path_is_selected", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_selection_path_is_selected(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_selection_iter_is_selected(XEN selection, XEN iter)
{
  #define H_gtk_tree_selection_iter_is_selected "gboolean gtk_tree_selection_iter_is_selected(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_iter_is_selected", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_selection_iter_is_selected", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_selection_iter_is_selected(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_selection_select_all(XEN selection)
{
  #define H_gtk_tree_selection_select_all "void gtk_tree_selection_select_all(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_select_all", "GtkTreeSelection*");
  gtk_tree_selection_select_all(XEN_TO_C_GtkTreeSelection_(selection));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_unselect_all(XEN selection)
{
  #define H_gtk_tree_selection_unselect_all "void gtk_tree_selection_unselect_all(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_unselect_all", "GtkTreeSelection*");
  gtk_tree_selection_unselect_all(XEN_TO_C_GtkTreeSelection_(selection));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_select_range(XEN selection, XEN start_path, XEN end_path)
{
  #define H_gtk_tree_selection_select_range "void gtk_tree_selection_select_range(GtkTreeSelection* selection, \
GtkTreePath* start_path, GtkTreePath* end_path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_select_range", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(start_path), start_path, 2, "gtk_tree_selection_select_range", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(end_path), end_path, 3, "gtk_tree_selection_select_range", "GtkTreePath*");
  gtk_tree_selection_select_range(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreePath_(start_path), XEN_TO_C_GtkTreePath_(end_path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_sortable_get_type(void)
{
  #define H_gtk_tree_sortable_get_type "GType gtk_tree_sortable_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_sortable_get_type()));
}
static XEN gxg_gtk_tree_sortable_sort_column_changed(XEN sortable)
{
  #define H_gtk_tree_sortable_sort_column_changed "void gtk_tree_sortable_sort_column_changed(GtkTreeSortable* sortable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_sort_column_changed", "GtkTreeSortable*");
  gtk_tree_sortable_sort_column_changed(XEN_TO_C_GtkTreeSortable_(sortable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_sortable_get_sort_column_id(XEN sortable, XEN sort_column_id, XEN order)
{
  #define H_gtk_tree_sortable_get_sort_column_id "gboolean gtk_tree_sortable_get_sort_column_id(GtkTreeSortable* sortable, \
gint* [sort_column_id], GtkSortType* [order])"
  gint ref_sort_column_id;
  GtkSortType ref_order;
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_get_sort_column_id", "GtkTreeSortable*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tree_sortable_get_sort_column_id(XEN_TO_C_GtkTreeSortable_(sortable), &ref_sort_column_id, 
                                                                    &ref_order));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_sort_column_id), C_TO_XEN_GtkSortType(ref_order)));
   }
}
static XEN gxg_gtk_tree_sortable_set_sort_column_id(XEN sortable, XEN sort_column_id, XEN order)
{
  #define H_gtk_tree_sortable_set_sort_column_id "void gtk_tree_sortable_set_sort_column_id(GtkTreeSortable* sortable, \
gint sort_column_id, GtkSortType order)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_set_sort_column_id", "GtkTreeSortable*");
  XEN_ASSERT_TYPE(XEN_gint_P(sort_column_id), sort_column_id, 2, "gtk_tree_sortable_set_sort_column_id", "gint");
  XEN_ASSERT_TYPE(XEN_GtkSortType_P(order), order, 3, "gtk_tree_sortable_set_sort_column_id", "GtkSortType");
  gtk_tree_sortable_set_sort_column_id(XEN_TO_C_GtkTreeSortable_(sortable), XEN_TO_C_gint(sort_column_id), XEN_TO_C_GtkSortType(order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_sortable_set_sort_func(XEN sortable, XEN sort_column_id, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_sortable_set_sort_func "void gtk_tree_sortable_set_sort_func(GtkTreeSortable* sortable, \
gint sort_column_id, GtkTreeIterCompareFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_set_sort_func", "GtkTreeSortable*");
  XEN_ASSERT_TYPE(XEN_gint_P(sort_column_id), sort_column_id, 2, "gtk_tree_sortable_set_sort_func", "gint");
  XEN_ASSERT_TYPE(XEN_GtkTreeIterCompareFunc_P(func), func, 3, "gtk_tree_sortable_set_sort_func", "GtkTreeIterCompareFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_tree_sortable_set_sort_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 5, "gtk_tree_sortable_set_sort_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_sortable_set_sort_func(XEN_TO_C_GtkTreeSortable_(sortable), XEN_TO_C_gint(sort_column_id), XEN_TO_C_GtkTreeIterCompareFunc(func), 
                                XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_sortable_set_default_sort_func(XEN sortable, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_sortable_set_default_sort_func "void gtk_tree_sortable_set_default_sort_func(GtkTreeSortable* sortable, \
GtkTreeIterCompareFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_set_default_sort_func", "GtkTreeSortable*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIterCompareFunc_P(func), func, 2, "gtk_tree_sortable_set_default_sort_func", "GtkTreeIterCompareFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_sortable_set_default_sort_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 4, "gtk_tree_sortable_set_default_sort_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_sortable_set_default_sort_func(XEN_TO_C_GtkTreeSortable_(sortable), XEN_TO_C_GtkTreeIterCompareFunc(func), XEN_TO_C_lambda_data(func_data), 
                                        XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_sortable_has_default_sort_func(XEN sortable)
{
  #define H_gtk_tree_sortable_has_default_sort_func "gboolean gtk_tree_sortable_has_default_sort_func(GtkTreeSortable* sortable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSortable__P(sortable), sortable, 1, "gtk_tree_sortable_has_default_sort_func", "GtkTreeSortable*");
  return(C_TO_XEN_gboolean(gtk_tree_sortable_has_default_sort_func(XEN_TO_C_GtkTreeSortable_(sortable))));
}
static XEN gxg_gtk_tree_store_get_type(void)
{
  #define H_gtk_tree_store_get_type "GtkType gtk_tree_store_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tree_store_get_type()));
}
static XEN gxg_gtk_tree_store_new(XEN n_columns, XEN types)
{
  #define H_gtk_tree_store_new "GtkTreeStore* gtk_tree_store_new(gint n_columns, etc types)"
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 1, "gtk_tree_store_new", "gint");
  XEN_ASSERT_TYPE(XEN_etc_P(types), types, 2, "gtk_tree_store_new", "etc");
  {
    int etc_len = 0;
    GtkTreeStore* result = NULL;
    gint p_arg0;
    if (XEN_LIST_P(types)) etc_len = XEN_LIST_LENGTH(types);
    if (etc_len < 1) XEN_OUT_OF_RANGE_ERROR("gtk_tree_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) XEN_OUT_OF_RANGE_ERROR("gtk_tree_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = XEN_TO_C_gint(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_tree_store_new(p_arg0, XLG(types, 0)); break;
        case 2: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1)); break;
        case 3: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2)); break;
        case 4: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3)); break;
        case 5: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4)); break;
        case 6: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4), XLG(types, 5)); break;
      }
    return(C_TO_XEN_GtkTreeStore_(result));
  }
}
static XEN gxg_gtk_tree_store_newv(XEN n_columns, XEN types)
{
  #define H_gtk_tree_store_newv "GtkTreeStore* gtk_tree_store_newv(gint n_columns, GType* types)"
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 1, "gtk_tree_store_newv", "gint");
  XEN_ASSERT_TYPE(XEN_GType__P(types), types, 2, "gtk_tree_store_newv", "GType*");
  return(C_TO_XEN_GtkTreeStore_(gtk_tree_store_newv(XEN_TO_C_gint(n_columns), XEN_TO_C_GType_(types))));
}
static XEN gxg_gtk_tree_store_set_column_types(XEN tree_store, XEN n_columns, XEN types)
{
  #define H_gtk_tree_store_set_column_types "void gtk_tree_store_set_column_types(GtkTreeStore* tree_store, \
gint n_columns, GType* types)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_set_column_types", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_columns), n_columns, 2, "gtk_tree_store_set_column_types", "gint");
  XEN_ASSERT_TYPE(XEN_GType__P(types), types, 3, "gtk_tree_store_set_column_types", "GType*");
  gtk_tree_store_set_column_types(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_gint(n_columns), XEN_TO_C_GType_(types));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_set(XEN tree_store, XEN iter, XEN values)
{
  #define H_gtk_tree_store_set "void gtk_tree_store_set(GtkTreeStore* tree_store, GtkTreeIter* iter, \
etc values)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_set", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_set", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_etc_P(values), values, 3, "gtk_tree_store_set", "etc");
  {
    int etc_len = 0;
    GtkTreeStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (XEN_LIST_P(values)) etc_len = XEN_LIST_LENGTH(values);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_tree_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_tree_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_tree_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkTreeStore_(tree_store);
    p_arg1 = XEN_TO_C_GtkTreeIter_(iter);
    switch (etc_len)
      {
        case 2: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), -1); break;
        case 4: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), -1); break;
        case 6: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), -1); break;
        case 8: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), -1); break;
        case 10: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), XLI(values, 8), XLS(values, 9), -1); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_tree_store_remove(XEN tree_store, XEN iter)
{
  #define H_gtk_tree_store_remove "void gtk_tree_store_remove(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_remove", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_remove", "GtkTreeIter*");
  gtk_tree_store_remove(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_insert(XEN tree_store, XEN iter, XEN parent, XEN position)
{
  #define H_gtk_tree_store_insert "void gtk_tree_store_insert(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_insert", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_insert", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_store_insert", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 4, "gtk_tree_store_insert", "gint");
  gtk_tree_store_insert(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(parent), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_insert_before(XEN tree_store, XEN iter, XEN parent, XEN sibling)
{
  #define H_gtk_tree_store_insert_before "void gtk_tree_store_insert_before(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* parent, GtkTreeIter* sibling)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_insert_before", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_insert_before", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_store_insert_before", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sibling) || XEN_FALSE_P(sibling), sibling, 4, "gtk_tree_store_insert_before", "GtkTreeIter*");
  gtk_tree_store_insert_before(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(parent), 
                               XEN_TO_C_GtkTreeIter_(sibling));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_insert_after(XEN tree_store, XEN iter, XEN parent, XEN sibling)
{
  #define H_gtk_tree_store_insert_after "void gtk_tree_store_insert_after(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, GtkTreeIter* sibling)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_insert_after", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_insert_after", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_store_insert_after", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(sibling) || XEN_FALSE_P(sibling), sibling, 4, "gtk_tree_store_insert_after", "GtkTreeIter*");
  gtk_tree_store_insert_after(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(parent), 
                              XEN_TO_C_GtkTreeIter_(sibling));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_prepend(XEN tree_store, XEN iter, XEN parent)
{
  #define H_gtk_tree_store_prepend "void gtk_tree_store_prepend(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_prepend", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_prepend", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_store_prepend", "GtkTreeIter*");
  gtk_tree_store_prepend(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(parent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_append(XEN tree_store, XEN iter, XEN parent)
{
  #define H_gtk_tree_store_append "void gtk_tree_store_append(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_append", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_append", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent) || XEN_FALSE_P(parent), parent, 3, "gtk_tree_store_append", "GtkTreeIter*");
  gtk_tree_store_append(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(parent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_is_ancestor(XEN tree_store, XEN iter, XEN descendant)
{
  #define H_gtk_tree_store_is_ancestor "gboolean gtk_tree_store_is_ancestor(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* descendant)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_is_ancestor", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_is_ancestor", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(descendant), descendant, 3, "gtk_tree_store_is_ancestor", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_store_is_ancestor(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(descendant))));
}
static XEN gxg_gtk_tree_store_iter_depth(XEN tree_store, XEN iter)
{
  #define H_gtk_tree_store_iter_depth "gint gtk_tree_store_iter_depth(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_iter_depth", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_store_iter_depth", "GtkTreeIter*");
  return(C_TO_XEN_gint(gtk_tree_store_iter_depth(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_store_clear(XEN tree_store)
{
  #define H_gtk_tree_store_clear "void gtk_tree_store_clear(GtkTreeStore* tree_store)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_clear", "GtkTreeStore*");
  gtk_tree_store_clear(XEN_TO_C_GtkTreeStore_(tree_store));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_type(void)
{
  #define H_gtk_tree_view_column_get_type "GtkType gtk_tree_view_column_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tree_view_column_get_type()));
}
static XEN gxg_gtk_tree_view_column_new(void)
{
  #define H_gtk_tree_view_column_new "GtkTreeViewColumn* gtk_tree_view_column_new( void)"
  return(C_TO_XEN_GtkTreeViewColumn_(gtk_tree_view_column_new()));
}
static XEN gxg_gtk_tree_view_column_new_with_attributes(XEN title, XEN cell, XEN attributes)
{
  #define H_gtk_tree_view_column_new_with_attributes "GtkTreeViewColumn* gtk_tree_view_column_new_with_attributes(gchar* title, \
GtkCellRenderer* cell, etc attributes)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_tree_view_column_new_with_attributes", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_tree_view_column_new_with_attributes", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_etc_P(attributes), attributes, 3, "gtk_tree_view_column_new_with_attributes", "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* result = NULL;
    gchar* p_arg0;
    GtkCellRenderer* p_arg1;
    if (XEN_LIST_P(attributes)) etc_len = XEN_LIST_LENGTH(attributes);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_gchar_(title);
    p_arg1 = XEN_TO_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(C_TO_XEN_GtkTreeViewColumn_(result));
  }
}
static XEN gxg_gtk_tree_view_column_pack_start(XEN tree_column, XEN cell, XEN expand)
{
  #define H_gtk_tree_view_column_pack_start "void gtk_tree_view_column_pack_start(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_pack_start", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_tree_view_column_pack_start", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_tree_view_column_pack_start", "gboolean");
  gtk_tree_view_column_pack_start(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_pack_end(XEN tree_column, XEN cell, XEN expand)
{
  #define H_gtk_tree_view_column_pack_end "void gtk_tree_view_column_pack_end(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_pack_end", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_tree_view_column_pack_end", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_tree_view_column_pack_end", "gboolean");
  gtk_tree_view_column_pack_end(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_clear(XEN tree_column)
{
  #define H_gtk_tree_view_column_clear "void gtk_tree_view_column_clear(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_clear", "GtkTreeViewColumn*");
  gtk_tree_view_column_clear(XEN_TO_C_GtkTreeViewColumn_(tree_column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_cell_renderers(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_cell_renderers "GList* gtk_tree_view_column_get_cell_renderers(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_cell_renderers", "GtkTreeViewColumn*");
  return(C_TO_XEN_GList_(gtk_tree_view_column_get_cell_renderers(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_add_attribute(XEN tree_column, XEN cell_renderer, XEN attribute, XEN column)
{
  #define H_gtk_tree_view_column_add_attribute "void gtk_tree_view_column_add_attribute(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gchar* attribute, gint column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_add_attribute", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_add_attribute", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(attribute), attribute, 3, "gtk_tree_view_column_add_attribute", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 4, "gtk_tree_view_column_add_attribute", "gint");
  gtk_tree_view_column_add_attribute(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell_renderer), 
                                     XEN_TO_C_gchar_(attribute), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_set_attributes(XEN tree_column, XEN cell_renderer, XEN attributes)
{
  #define H_gtk_tree_view_column_set_attributes "void gtk_tree_view_column_set_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, etc attributes)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_attributes", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_set_attributes", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_etc_P(attributes), attributes, 3, "gtk_tree_view_column_set_attributes", "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* p_arg0;
    GtkCellRenderer* p_arg1;
    if (XEN_LIST_P(attributes)) etc_len = XEN_LIST_LENGTH(attributes);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_column_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkTreeViewColumn_(tree_column);
    p_arg1 = XEN_TO_C_GtkCellRenderer_(cell_renderer);
    switch (etc_len)
      {
        case 2: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_tree_view_column_set_cell_data_func(XEN tree_column, XEN cell_renderer, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_view_column_set_cell_data_func "void gtk_tree_view_column_set_cell_data_func(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, GtkTreeCellDataFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_cell_data_func", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_set_cell_data_func", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GtkTreeCellDataFunc_P(func), func, 3, "gtk_tree_view_column_set_cell_data_func", "GtkTreeCellDataFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_tree_view_column_set_cell_data_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 5, "gtk_tree_view_column_set_cell_data_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_view_column_set_cell_data_func(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell_renderer), 
                                        XEN_TO_C_GtkTreeCellDataFunc(func), XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_view_column_clear_attributes(XEN tree_column, XEN cell_renderer)
{
  #define H_gtk_tree_view_column_clear_attributes "void gtk_tree_view_column_clear_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_clear_attributes", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_clear_attributes", "GtkCellRenderer*");
  gtk_tree_view_column_clear_attributes(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell_renderer));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_set_spacing(XEN tree_column, XEN spacing)
{
  #define H_gtk_tree_view_column_set_spacing "void gtk_tree_view_column_set_spacing(GtkTreeViewColumn* tree_column, \
gint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_spacing", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_tree_view_column_set_spacing", "gint");
  gtk_tree_view_column_set_spacing(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_spacing(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_spacing "gint gtk_tree_view_column_get_spacing(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_spacing", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_spacing(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_visible(XEN tree_column, XEN visible)
{
  #define H_gtk_tree_view_column_set_visible "void gtk_tree_view_column_set_visible(GtkTreeViewColumn* tree_column, \
gboolean visible)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_visible", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible), visible, 2, "gtk_tree_view_column_set_visible", "gboolean");
  gtk_tree_view_column_set_visible(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_visible(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_visible "gboolean gtk_tree_view_column_get_visible(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_visible", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_visible(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_resizable(XEN tree_column, XEN resizable)
{
  #define H_gtk_tree_view_column_set_resizable "void gtk_tree_view_column_set_resizable(GtkTreeViewColumn* tree_column, \
gboolean resizable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_resizable", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(resizable), resizable, 2, "gtk_tree_view_column_set_resizable", "gboolean");
  gtk_tree_view_column_set_resizable(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(resizable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_resizable(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_resizable "gboolean gtk_tree_view_column_get_resizable(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_resizable", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_resizable(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_sizing(XEN tree_column, XEN type)
{
  #define H_gtk_tree_view_column_set_sizing "void gtk_tree_view_column_set_sizing(GtkTreeViewColumn* tree_column, \
GtkTreeViewColumnSizing type)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_sizing", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumnSizing_P(type), type, 2, "gtk_tree_view_column_set_sizing", "GtkTreeViewColumnSizing");
  gtk_tree_view_column_set_sizing(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkTreeViewColumnSizing(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_sizing(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_sizing "GtkTreeViewColumnSizing gtk_tree_view_column_get_sizing(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_sizing", "GtkTreeViewColumn*");
  return(C_TO_XEN_GtkTreeViewColumnSizing(gtk_tree_view_column_get_sizing(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_get_width(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_width "gint gtk_tree_view_column_get_width(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_width", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_width(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_get_fixed_width(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_fixed_width "gint gtk_tree_view_column_get_fixed_width(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_fixed_width", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_fixed_width(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_fixed_width(XEN tree_column, XEN fixed_width)
{
  #define H_gtk_tree_view_column_set_fixed_width "void gtk_tree_view_column_set_fixed_width(GtkTreeViewColumn* tree_column, \
gint fixed_width)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_fixed_width", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(fixed_width), fixed_width, 2, "gtk_tree_view_column_set_fixed_width", "gint");
  gtk_tree_view_column_set_fixed_width(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gint(fixed_width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_set_min_width(XEN tree_column, XEN min_width)
{
  #define H_gtk_tree_view_column_set_min_width "void gtk_tree_view_column_set_min_width(GtkTreeViewColumn* tree_column, \
gint min_width)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_min_width", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(min_width), min_width, 2, "gtk_tree_view_column_set_min_width", "gint");
  gtk_tree_view_column_set_min_width(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gint(min_width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_min_width(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_min_width "gint gtk_tree_view_column_get_min_width(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_min_width", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_min_width(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_max_width(XEN tree_column, XEN max_width)
{
  #define H_gtk_tree_view_column_set_max_width "void gtk_tree_view_column_set_max_width(GtkTreeViewColumn* tree_column, \
gint max_width)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_max_width", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(max_width), max_width, 2, "gtk_tree_view_column_set_max_width", "gint");
  gtk_tree_view_column_set_max_width(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gint(max_width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_max_width(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_max_width "gint gtk_tree_view_column_get_max_width(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_max_width", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_max_width(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_clicked(XEN tree_column)
{
  #define H_gtk_tree_view_column_clicked "void gtk_tree_view_column_clicked(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_clicked", "GtkTreeViewColumn*");
  gtk_tree_view_column_clicked(XEN_TO_C_GtkTreeViewColumn_(tree_column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_set_title(XEN tree_column, XEN title)
{
  #define H_gtk_tree_view_column_set_title "void gtk_tree_view_column_set_title(GtkTreeViewColumn* tree_column, \
gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_title", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_tree_view_column_set_title", "gchar*");
  gtk_tree_view_column_set_title(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_title(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_title "gchar* gtk_tree_view_column_get_title(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_title", "GtkTreeViewColumn*");
  return(C_TO_XEN_gchar_(gtk_tree_view_column_get_title(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_clickable(XEN tree_column, XEN clickable)
{
  #define H_gtk_tree_view_column_set_clickable "void gtk_tree_view_column_set_clickable(GtkTreeViewColumn* tree_column, \
gboolean clickable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_clickable", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(clickable), clickable, 2, "gtk_tree_view_column_set_clickable", "gboolean");
  gtk_tree_view_column_set_clickable(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(clickable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_clickable(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_clickable "gboolean gtk_tree_view_column_get_clickable(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_clickable", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_clickable(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_widget(XEN tree_column, XEN widget)
{
  #define H_gtk_tree_view_column_set_widget "void gtk_tree_view_column_set_widget(GtkTreeViewColumn* tree_column, \
GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_widget", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget) || XEN_FALSE_P(widget), widget, 2, "gtk_tree_view_column_set_widget", "GtkWidget*");
  gtk_tree_view_column_set_widget(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_widget(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_widget "GtkWidget* gtk_tree_view_column_get_widget(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_widget", "GtkTreeViewColumn*");
  return(C_TO_XEN_GtkWidget_(gtk_tree_view_column_get_widget(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_alignment(XEN tree_column, XEN xalign)
{
  #define H_gtk_tree_view_column_set_alignment "void gtk_tree_view_column_set_alignment(GtkTreeViewColumn* tree_column, \
gfloat xalign)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_alignment", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_tree_view_column_set_alignment", "gfloat");
  gtk_tree_view_column_set_alignment(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gfloat(xalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_alignment(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_alignment "gfloat gtk_tree_view_column_get_alignment(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_alignment", "GtkTreeViewColumn*");
  return(C_TO_XEN_gfloat(gtk_tree_view_column_get_alignment(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_reorderable(XEN tree_column, XEN reorderable)
{
  #define H_gtk_tree_view_column_set_reorderable "void gtk_tree_view_column_set_reorderable(GtkTreeViewColumn* tree_column, \
gboolean reorderable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_reorderable", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(reorderable), reorderable, 2, "gtk_tree_view_column_set_reorderable", "gboolean");
  gtk_tree_view_column_set_reorderable(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(reorderable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_reorderable(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_reorderable "gboolean gtk_tree_view_column_get_reorderable(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_reorderable", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_reorderable(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_sort_column_id(XEN tree_column, XEN sort_column_id)
{
  #define H_gtk_tree_view_column_set_sort_column_id "void gtk_tree_view_column_set_sort_column_id(GtkTreeViewColumn* tree_column, \
gint sort_column_id)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_column_id", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(sort_column_id), sort_column_id, 2, "gtk_tree_view_column_set_sort_column_id", "gint");
  gtk_tree_view_column_set_sort_column_id(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gint(sort_column_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_sort_column_id(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_sort_column_id "gint gtk_tree_view_column_get_sort_column_id(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_column_id", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_column_get_sort_column_id(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_sort_indicator(XEN tree_column, XEN setting)
{
  #define H_gtk_tree_view_column_set_sort_indicator "void gtk_tree_view_column_set_sort_indicator(GtkTreeViewColumn* tree_column, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_indicator", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_tree_view_column_set_sort_indicator", "gboolean");
  gtk_tree_view_column_set_sort_indicator(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_sort_indicator(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_sort_indicator "gboolean gtk_tree_view_column_get_sort_indicator(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_indicator", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_sort_indicator(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_set_sort_order(XEN tree_column, XEN order)
{
  #define H_gtk_tree_view_column_set_sort_order "void gtk_tree_view_column_set_sort_order(GtkTreeViewColumn* tree_column, \
GtkSortType order)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_order", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkSortType_P(order), order, 2, "gtk_tree_view_column_set_sort_order", "GtkSortType");
  gtk_tree_view_column_set_sort_order(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkSortType(order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_sort_order(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_sort_order "GtkSortType gtk_tree_view_column_get_sort_order(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_order", "GtkTreeViewColumn*");
  return(C_TO_XEN_GtkSortType(gtk_tree_view_column_get_sort_order(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_column_cell_set_cell_data(XEN tree_column, XEN tree_model, XEN iter, XEN is_expander, XEN is_expanded)
{
  #define H_gtk_tree_view_column_cell_set_cell_data "void gtk_tree_view_column_cell_set_cell_data(GtkTreeViewColumn* tree_column, \
GtkTreeModel* tree_model, GtkTreeIter* iter, gboolean is_expander, gboolean is_expanded)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 2, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 3, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_expander), is_expander, 4, "gtk_tree_view_column_cell_set_cell_data", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_expanded), is_expanded, 5, "gtk_tree_view_column_cell_set_cell_data", "gboolean");
  gtk_tree_view_column_cell_set_cell_data(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter), 
                                          XEN_TO_C_gboolean(is_expander), XEN_TO_C_gboolean(is_expanded));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_cell_get_size(XEN tree_column, XEN cell_area, XEN x_offset, XEN y_offset, XEN width, XEN height)
{
  #define H_gtk_tree_view_column_cell_get_size "void gtk_tree_view_column_cell_get_size(GtkTreeViewColumn* tree_column, \
GdkRectangle* cell_area, gint* [x_offset], gint* [y_offset], gint* [width], gint* [height])"
  gint ref_x_offset;
  gint ref_y_offset;
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_cell_get_size", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(cell_area), cell_area, 2, "gtk_tree_view_column_cell_get_size", "GdkRectangle*");
  gtk_tree_view_column_cell_get_size(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GdkRectangle_(cell_area), &ref_x_offset, 
                                     &ref_y_offset, &ref_width, &ref_height);
  return(XEN_LIST_4(C_TO_XEN_gint(ref_x_offset), C_TO_XEN_gint(ref_y_offset), C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_tree_view_column_cell_is_visible(XEN tree_column)
{
  #define H_gtk_tree_view_column_cell_is_visible "gboolean gtk_tree_view_column_cell_is_visible(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_cell_is_visible", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_cell_is_visible(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_tree_view_get_type(void)
{
  #define H_gtk_tree_view_get_type "GtkType gtk_tree_view_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_tree_view_get_type()));
}
static XEN gxg_gtk_tree_view_new(void)
{
  #define H_gtk_tree_view_new "GtkWidget* gtk_tree_view_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_tree_view_new()));
}
static XEN gxg_gtk_tree_view_new_with_model(XEN model)
{
  #define H_gtk_tree_view_new_with_model "GtkWidget* gtk_tree_view_new_with_model(GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_tree_view_new_with_model", "GtkTreeModel*");
  return(C_TO_XEN_GtkWidget_(gtk_tree_view_new_with_model(XEN_TO_C_GtkTreeModel_(model))));
}
static XEN gxg_gtk_tree_view_get_model(XEN tree_view)
{
  #define H_gtk_tree_view_get_model "GtkTreeModel* gtk_tree_view_get_model(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_model", "GtkTreeView*");
  return(C_TO_XEN_GtkTreeModel_(gtk_tree_view_get_model(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_model(XEN tree_view, XEN model)
{
  #define H_gtk_tree_view_set_model "void gtk_tree_view_set_model(GtkTreeView* tree_view, GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_model", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model) || XEN_FALSE_P(model), model, 2, "gtk_tree_view_set_model", "GtkTreeModel*");
  gtk_tree_view_set_model(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeModel_(model));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_selection(XEN tree_view)
{
  #define H_gtk_tree_view_get_selection "GtkTreeSelection* gtk_tree_view_get_selection(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_selection", "GtkTreeView*");
  return(C_TO_XEN_GtkTreeSelection_(gtk_tree_view_get_selection(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_get_hadjustment(XEN tree_view)
{
  #define H_gtk_tree_view_get_hadjustment "GtkAdjustment* gtk_tree_view_get_hadjustment(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_hadjustment", "GtkTreeView*");
  return(C_TO_XEN_GtkAdjustment_(gtk_tree_view_get_hadjustment(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_hadjustment(XEN tree_view, XEN adjustment)
{
  #define H_gtk_tree_view_set_hadjustment "void gtk_tree_view_set_hadjustment(GtkTreeView* tree_view, \
GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_hadjustment", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_tree_view_set_hadjustment", "GtkAdjustment*");
  gtk_tree_view_set_hadjustment(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_vadjustment(XEN tree_view)
{
  #define H_gtk_tree_view_get_vadjustment "GtkAdjustment* gtk_tree_view_get_vadjustment(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_vadjustment", "GtkTreeView*");
  return(C_TO_XEN_GtkAdjustment_(gtk_tree_view_get_vadjustment(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_vadjustment(XEN tree_view, XEN adjustment)
{
  #define H_gtk_tree_view_set_vadjustment "void gtk_tree_view_set_vadjustment(GtkTreeView* tree_view, \
GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_vadjustment", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_tree_view_set_vadjustment", "GtkAdjustment*");
  gtk_tree_view_set_vadjustment(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_headers_visible(XEN tree_view)
{
  #define H_gtk_tree_view_get_headers_visible "gboolean gtk_tree_view_get_headers_visible(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_headers_visible", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_headers_visible(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_headers_visible(XEN tree_view, XEN headers_visible)
{
  #define H_gtk_tree_view_set_headers_visible "void gtk_tree_view_set_headers_visible(GtkTreeView* tree_view, \
gboolean headers_visible)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_headers_visible", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(headers_visible), headers_visible, 2, "gtk_tree_view_set_headers_visible", "gboolean");
  gtk_tree_view_set_headers_visible(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(headers_visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_columns_autosize(XEN tree_view)
{
  #define H_gtk_tree_view_columns_autosize "void gtk_tree_view_columns_autosize(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_columns_autosize", "GtkTreeView*");
  gtk_tree_view_columns_autosize(XEN_TO_C_GtkTreeView_(tree_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_set_headers_clickable(XEN tree_view, XEN setting)
{
  #define H_gtk_tree_view_set_headers_clickable "void gtk_tree_view_set_headers_clickable(GtkTreeView* tree_view, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_headers_clickable", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_tree_view_set_headers_clickable", "gboolean");
  gtk_tree_view_set_headers_clickable(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_set_rules_hint(XEN tree_view, XEN setting)
{
  #define H_gtk_tree_view_set_rules_hint "void gtk_tree_view_set_rules_hint(GtkTreeView* tree_view, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_rules_hint", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_tree_view_set_rules_hint", "gboolean");
  gtk_tree_view_set_rules_hint(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_rules_hint(XEN tree_view)
{
  #define H_gtk_tree_view_get_rules_hint "gboolean gtk_tree_view_get_rules_hint(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_rules_hint", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_rules_hint(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_append_column(XEN tree_view, XEN column)
{
  #define H_gtk_tree_view_append_column "gint gtk_tree_view_append_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_append_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column), column, 2, "gtk_tree_view_append_column", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_append_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumn_(column))));
}
static XEN gxg_gtk_tree_view_remove_column(XEN tree_view, XEN column)
{
  #define H_gtk_tree_view_remove_column "gint gtk_tree_view_remove_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_remove_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column), column, 2, "gtk_tree_view_remove_column", "GtkTreeViewColumn*");
  return(C_TO_XEN_gint(gtk_tree_view_remove_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumn_(column))));
}
static XEN gxg_gtk_tree_view_insert_column(XEN tree_view, XEN column, XEN position)
{
  #define H_gtk_tree_view_insert_column "gint gtk_tree_view_insert_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, \
gint position)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_insert_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column), column, 2, "gtk_tree_view_insert_column", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_tree_view_insert_column", "gint");
  return(C_TO_XEN_gint(gtk_tree_view_insert_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumn_(column), 
                                                   XEN_TO_C_gint(position))));
}
static XEN gxg_gtk_tree_view_insert_column_with_attributes(XEN tree_view, XEN position, XEN title, XEN cell, XEN attributes)
{
  #define H_gtk_tree_view_insert_column_with_attributes "gint gtk_tree_view_insert_column_with_attributes(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, etc attributes)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_insert_column_with_attributes", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_tree_view_insert_column_with_attributes", "gint");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 3, "gtk_tree_view_insert_column_with_attributes", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 4, "gtk_tree_view_insert_column_with_attributes", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_etc_P(attributes), attributes, 5, "gtk_tree_view_insert_column_with_attributes", "etc");
  {
    int etc_len = 0;
    gint result = 0;
    GtkTreeView* p_arg0;
    gint p_arg1;
    gchar* p_arg2;
    GtkCellRenderer* p_arg3;
    if (XEN_LIST_P(attributes)) etc_len = XEN_LIST_LENGTH(attributes);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkTreeView_(tree_view);
    p_arg1 = XEN_TO_C_gint(position);
    p_arg2 = XEN_TO_C_gchar_(title);
    p_arg3 = XEN_TO_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(C_TO_XEN_gint(result));
  }
}
static XEN gxg_gtk_tree_view_insert_column_with_data_func(XEN tree_view, XEN position, XEN title, XEN cell, XEN func, XEN func_data, XEN dnotify)
{
  #define H_gtk_tree_view_insert_column_with_data_func "gint gtk_tree_view_insert_column_with_data_func(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, GtkTreeCellDataFunc func, lambda_data func_data, \
GtkDestroyNotify dnotify)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_insert_column_with_data_func", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_tree_view_insert_column_with_data_func", "gint");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 3, "gtk_tree_view_insert_column_with_data_func", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 4, "gtk_tree_view_insert_column_with_data_func", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GtkTreeCellDataFunc_P(func), func, 5, "gtk_tree_view_insert_column_with_data_func", "GtkTreeCellDataFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 6, "gtk_tree_view_insert_column_with_data_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(dnotify), dnotify, 7, "gtk_tree_view_insert_column_with_data_func", "GtkDestroyNotify");
  {
    XEN result = XEN_FALSE;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, dnotify);
    result = C_TO_XEN_gint(gtk_tree_view_insert_column_with_data_func(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(position), 
                                                                      XEN_TO_C_gchar_(title), XEN_TO_C_GtkCellRenderer_(cell), 
                                                                      XEN_TO_C_GtkTreeCellDataFunc(func), XEN_TO_C_lambda_data(func_data), 
                                                                      XEN_TO_C_GtkDestroyNotify(dnotify)));
    return(result);
   }
}
static XEN gxg_gtk_tree_view_get_column(XEN tree_view, XEN n)
{
  #define H_gtk_tree_view_get_column "GtkTreeViewColumn* gtk_tree_view_get_column(GtkTreeView* tree_view, \
gint n)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(n), n, 2, "gtk_tree_view_get_column", "gint");
  return(C_TO_XEN_GtkTreeViewColumn_(gtk_tree_view_get_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(n))));
}
static XEN gxg_gtk_tree_view_get_columns(XEN tree_view)
{
  #define H_gtk_tree_view_get_columns "GList* gtk_tree_view_get_columns(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_columns", "GtkTreeView*");
  return(C_TO_XEN_GList_(gtk_tree_view_get_columns(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_move_column_after(XEN tree_view, XEN column, XEN base_column)
{
  #define H_gtk_tree_view_move_column_after "void gtk_tree_view_move_column_after(GtkTreeView* tree_view, \
GtkTreeViewColumn* column, GtkTreeViewColumn* base_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_move_column_after", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column), column, 2, "gtk_tree_view_move_column_after", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(base_column) || XEN_FALSE_P(base_column), base_column, 3, "gtk_tree_view_move_column_after", "GtkTreeViewColumn*");
  gtk_tree_view_move_column_after(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumn_(column), XEN_TO_C_GtkTreeViewColumn_(base_column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_set_expander_column(XEN tree_view, XEN column)
{
  #define H_gtk_tree_view_set_expander_column "void gtk_tree_view_set_expander_column(GtkTreeView* tree_view, \
GtkTreeViewColumn* column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_expander_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column) || XEN_FALSE_P(column), column, 2, "gtk_tree_view_set_expander_column", "GtkTreeViewColumn*");
  gtk_tree_view_set_expander_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumn_(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_expander_column(XEN tree_view)
{
  #define H_gtk_tree_view_get_expander_column "GtkTreeViewColumn* gtk_tree_view_get_expander_column(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_expander_column", "GtkTreeView*");
  return(C_TO_XEN_GtkTreeViewColumn_(gtk_tree_view_get_expander_column(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_column_drag_function(XEN tree_view, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_view_set_column_drag_function "void gtk_tree_view_set_column_drag_function(GtkTreeView* tree_view, \
GtkTreeViewColumnDropFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_column_drag_function", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumnDropFunc_P(func), func, 2, "gtk_tree_view_set_column_drag_function", "GtkTreeViewColumnDropFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_view_set_column_drag_function", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 4, "gtk_tree_view_set_column_drag_function", "GtkDestroyNotify");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_view_set_column_drag_function(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewColumnDropFunc(func), XEN_TO_C_lambda_data(func_data), 
                                       XEN_TO_C_GtkDestroyNotify(destroy));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_view_scroll_to_point(XEN tree_view, XEN tree_x, XEN tree_y)
{
  #define H_gtk_tree_view_scroll_to_point "void gtk_tree_view_scroll_to_point(GtkTreeView* tree_view, \
gint tree_x, gint tree_y)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_scroll_to_point", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(tree_x), tree_x, 2, "gtk_tree_view_scroll_to_point", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(tree_y), tree_y, 3, "gtk_tree_view_scroll_to_point", "gint");
  gtk_tree_view_scroll_to_point(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(tree_x), XEN_TO_C_gint(tree_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_scroll_to_cell(XEN tree_view, XEN path, XEN column, XEN use_align, XEN row_align, XEN col_align)
{
  #define H_gtk_tree_view_scroll_to_cell "void gtk_tree_view_scroll_to_cell(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, gboolean use_align, gfloat row_align, gfloat col_align)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_scroll_to_cell", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path) || XEN_FALSE_P(path), path, 2, "gtk_tree_view_scroll_to_cell", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column) || XEN_FALSE_P(column), column, 3, "gtk_tree_view_scroll_to_cell", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_align), use_align, 4, "gtk_tree_view_scroll_to_cell", "gboolean");
  XEN_ASSERT_TYPE(XEN_gfloat_P(row_align), row_align, 5, "gtk_tree_view_scroll_to_cell", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(col_align), col_align, 6, "gtk_tree_view_scroll_to_cell", "gfloat");
  gtk_tree_view_scroll_to_cell(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewColumn_(column), 
                               XEN_TO_C_gboolean(use_align), XEN_TO_C_gfloat(row_align), XEN_TO_C_gfloat(col_align));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_row_activated(XEN tree_view, XEN path, XEN column)
{
  #define H_gtk_tree_view_row_activated "void gtk_tree_view_row_activated(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_row_activated", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_row_activated", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column), column, 3, "gtk_tree_view_row_activated", "GtkTreeViewColumn*");
  gtk_tree_view_row_activated(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewColumn_(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_expand_all(XEN tree_view)
{
  #define H_gtk_tree_view_expand_all "void gtk_tree_view_expand_all(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_expand_all", "GtkTreeView*");
  gtk_tree_view_expand_all(XEN_TO_C_GtkTreeView_(tree_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_collapse_all(XEN tree_view)
{
  #define H_gtk_tree_view_collapse_all "void gtk_tree_view_collapse_all(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_collapse_all", "GtkTreeView*");
  gtk_tree_view_collapse_all(XEN_TO_C_GtkTreeView_(tree_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_expand_row(XEN tree_view, XEN path, XEN open_all)
{
  #define H_gtk_tree_view_expand_row "gboolean gtk_tree_view_expand_row(GtkTreeView* tree_view, GtkTreePath* path, \
gboolean open_all)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_expand_row", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_expand_row", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(open_all), open_all, 3, "gtk_tree_view_expand_row", "gboolean");
  return(C_TO_XEN_gboolean(gtk_tree_view_expand_row(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_gboolean(open_all))));
}
static XEN gxg_gtk_tree_view_collapse_row(XEN tree_view, XEN path)
{
  #define H_gtk_tree_view_collapse_row "gboolean gtk_tree_view_collapse_row(GtkTreeView* tree_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_collapse_row", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_collapse_row", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_view_collapse_row(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_view_map_expanded_rows(XEN tree_view, XEN func, XEN func_data)
{
  #define H_gtk_tree_view_map_expanded_rows "void gtk_tree_view_map_expanded_rows(GtkTreeView* tree_view, \
GtkTreeViewMappingFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_map_expanded_rows", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewMappingFunc_P(func), func, 2, "gtk_tree_view_map_expanded_rows", "GtkTreeViewMappingFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_view_map_expanded_rows", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_tree_view_map_expanded_rows(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewMappingFunc(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_tree_view_row_expanded(XEN tree_view, XEN path)
{
  #define H_gtk_tree_view_row_expanded "gboolean gtk_tree_view_row_expanded(GtkTreeView* tree_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_row_expanded", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_row_expanded", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_tree_view_row_expanded(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_view_set_reorderable(XEN tree_view, XEN reorderable)
{
  #define H_gtk_tree_view_set_reorderable "void gtk_tree_view_set_reorderable(GtkTreeView* tree_view, \
gboolean reorderable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_reorderable", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(reorderable), reorderable, 2, "gtk_tree_view_set_reorderable", "gboolean");
  gtk_tree_view_set_reorderable(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(reorderable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_reorderable(XEN tree_view)
{
  #define H_gtk_tree_view_get_reorderable "gboolean gtk_tree_view_get_reorderable(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_reorderable", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_reorderable(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_cursor(XEN tree_view, XEN path, XEN focus_column, XEN start_editing)
{
  #define H_gtk_tree_view_set_cursor "void gtk_tree_view_set_cursor(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* focus_column, gboolean start_editing)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_cursor", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_set_cursor", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(focus_column), focus_column, 3, "gtk_tree_view_set_cursor", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(start_editing), start_editing, 4, "gtk_tree_view_set_cursor", "gboolean");
  gtk_tree_view_set_cursor(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewColumn_(focus_column), 
                           XEN_TO_C_gboolean(start_editing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_cursor(XEN tree_view, XEN path, XEN focus_column)
{
  #define H_gtk_tree_view_get_cursor "void gtk_tree_view_get_cursor(GtkTreeView* tree_view, GtkTreePath** [path], \
GtkTreeViewColumn** [focus_column])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_focus_column = NULL;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_cursor", "GtkTreeView*");
  gtk_tree_view_get_cursor(XEN_TO_C_GtkTreeView_(tree_view), &ref_path, &ref_focus_column);
  return(XEN_LIST_2(C_TO_XEN_GtkTreePath_(ref_path), C_TO_XEN_GtkTreeViewColumn_(ref_focus_column)));
}
static XEN gxg_gtk_tree_view_get_bin_window(XEN tree_view)
{
  #define H_gtk_tree_view_get_bin_window "GdkWindow* gtk_tree_view_get_bin_window(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_bin_window", "GtkTreeView*");
  return(C_TO_XEN_GdkWindow_(gtk_tree_view_get_bin_window(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_get_path_at_pos(XEN tree_view, XEN x, XEN y, XEN path, XEN column, XEN cell_x, XEN cell_y)
{
  #define H_gtk_tree_view_get_path_at_pos "gboolean gtk_tree_view_get_path_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_path_at_pos", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gtk_tree_view_get_path_at_pos", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_tree_view_get_path_at_pos", "gint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tree_view_get_path_at_pos(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(x), XEN_TO_C_gint(y), 
                                                             &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
    return(XEN_LIST_5(result, C_TO_XEN_GtkTreePath_(ref_path), C_TO_XEN_GtkTreeViewColumn_(ref_column), C_TO_XEN_gint(ref_cell_x), C_TO_XEN_gint(ref_cell_y)));
   }
}
static XEN gxg_gtk_tree_view_get_cell_area(XEN tree_view, XEN path, XEN column, XEN rect)
{
  #define H_gtk_tree_view_get_cell_area "void gtk_tree_view_get_cell_area(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, GdkRectangle* rect)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_cell_area", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path) || XEN_FALSE_P(path), path, 2, "gtk_tree_view_get_cell_area", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column) || XEN_FALSE_P(column), column, 3, "gtk_tree_view_get_cell_area", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 4, "gtk_tree_view_get_cell_area", "GdkRectangle*");
  gtk_tree_view_get_cell_area(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewColumn_(column), 
                              XEN_TO_C_GdkRectangle_(rect));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_background_area(XEN tree_view, XEN path, XEN column, XEN rect)
{
  #define H_gtk_tree_view_get_background_area "void gtk_tree_view_get_background_area(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* column, GdkRectangle* rect)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_background_area", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path) || XEN_FALSE_P(path), path, 2, "gtk_tree_view_get_background_area", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(column) || XEN_FALSE_P(column), column, 3, "gtk_tree_view_get_background_area", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rect), rect, 4, "gtk_tree_view_get_background_area", "GdkRectangle*");
  gtk_tree_view_get_background_area(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewColumn_(column), 
                                    XEN_TO_C_GdkRectangle_(rect));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_visible_rect(XEN tree_view, XEN visible_rect)
{
  #define H_gtk_tree_view_get_visible_rect "void gtk_tree_view_get_visible_rect(GtkTreeView* tree_view, \
GdkRectangle* visible_rect)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_visible_rect", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(visible_rect), visible_rect, 2, "gtk_tree_view_get_visible_rect", "GdkRectangle*");
  gtk_tree_view_get_visible_rect(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GdkRectangle_(visible_rect));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_widget_to_tree_coords(XEN tree_view, XEN wx, XEN wy, XEN tx, XEN ty)
{
  #define H_gtk_tree_view_widget_to_tree_coords "void gtk_tree_view_widget_to_tree_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [tx], gint* [ty])"
  gint ref_tx;
  gint ref_ty;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_widget_to_tree_coords", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(wx), wx, 2, "gtk_tree_view_widget_to_tree_coords", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(wy), wy, 3, "gtk_tree_view_widget_to_tree_coords", "gint");
  gtk_tree_view_widget_to_tree_coords(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(wx), XEN_TO_C_gint(wy), &ref_tx, &ref_ty);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_tx), C_TO_XEN_gint(ref_ty)));
}
static XEN gxg_gtk_tree_view_tree_to_widget_coords(XEN tree_view, XEN tx, XEN ty, XEN wx, XEN wy)
{
  #define H_gtk_tree_view_tree_to_widget_coords "void gtk_tree_view_tree_to_widget_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [wx], gint* [wy])"
  gint ref_wx;
  gint ref_wy;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_tree_to_widget_coords", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(tx), tx, 2, "gtk_tree_view_tree_to_widget_coords", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(ty), ty, 3, "gtk_tree_view_tree_to_widget_coords", "gint");
  gtk_tree_view_tree_to_widget_coords(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(tx), XEN_TO_C_gint(ty), &ref_wx, &ref_wy);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_wx), C_TO_XEN_gint(ref_wy)));
}
static XEN gxg_gtk_tree_view_enable_model_drag_source(XEN tree_view, XEN start_button_mask, XEN targets, XEN n_targets, XEN actions)
{
  #define H_gtk_tree_view_enable_model_drag_source "void gtk_tree_view_enable_model_drag_source(GtkTreeView* tree_view, \
GdkModifierType start_button_mask, GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_enable_model_drag_source", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(start_button_mask), start_button_mask, 2, "gtk_tree_view_enable_model_drag_source", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 3, "gtk_tree_view_enable_model_drag_source", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_targets), n_targets, 4, "gtk_tree_view_enable_model_drag_source", "gint");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(actions), actions, 5, "gtk_tree_view_enable_model_drag_source", "GdkDragAction");
  gtk_tree_view_enable_model_drag_source(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GdkModifierType(start_button_mask), XEN_TO_C_GtkTargetEntry_(targets), 
                                         XEN_TO_C_gint(n_targets), XEN_TO_C_GdkDragAction(actions));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_enable_model_drag_dest(XEN tree_view, XEN targets, XEN n_targets, XEN actions)
{
  #define H_gtk_tree_view_enable_model_drag_dest "void gtk_tree_view_enable_model_drag_dest(GtkTreeView* tree_view, \
GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_enable_model_drag_dest", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets), targets, 2, "gtk_tree_view_enable_model_drag_dest", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_targets), n_targets, 3, "gtk_tree_view_enable_model_drag_dest", "gint");
  XEN_ASSERT_TYPE(XEN_GdkDragAction_P(actions), actions, 4, "gtk_tree_view_enable_model_drag_dest", "GdkDragAction");
  gtk_tree_view_enable_model_drag_dest(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTargetEntry_(targets), XEN_TO_C_gint(n_targets), 
                                       XEN_TO_C_GdkDragAction(actions));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_unset_rows_drag_source(XEN tree_view)
{
  #define H_gtk_tree_view_unset_rows_drag_source "void gtk_tree_view_unset_rows_drag_source(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_unset_rows_drag_source", "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_source(XEN_TO_C_GtkTreeView_(tree_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_unset_rows_drag_dest(XEN tree_view)
{
  #define H_gtk_tree_view_unset_rows_drag_dest "void gtk_tree_view_unset_rows_drag_dest(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_unset_rows_drag_dest", "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_dest(XEN_TO_C_GtkTreeView_(tree_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_set_drag_dest_row(XEN tree_view, XEN path, XEN pos)
{
  #define H_gtk_tree_view_set_drag_dest_row "void gtk_tree_view_set_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewDropPosition pos)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_drag_dest_row", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_set_drag_dest_row", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewDropPosition_P(pos), pos, 3, "gtk_tree_view_set_drag_dest_row", "GtkTreeViewDropPosition");
  gtk_tree_view_set_drag_dest_row(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkTreeViewDropPosition(pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_drag_dest_row(XEN tree_view, XEN path, XEN pos)
{
  #define H_gtk_tree_view_get_drag_dest_row "void gtk_tree_view_get_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_drag_dest_row", "GtkTreeView*");
  gtk_tree_view_get_drag_dest_row(XEN_TO_C_GtkTreeView_(tree_view), &ref_path, &ref_pos);
  return(XEN_LIST_2(C_TO_XEN_GtkTreePath_(ref_path), C_TO_XEN_GtkTreeViewDropPosition(ref_pos)));
}
static XEN gxg_gtk_tree_view_get_dest_row_at_pos(XEN tree_view, XEN drag_x, XEN drag_y, XEN path, XEN pos)
{
  #define H_gtk_tree_view_get_dest_row_at_pos "gboolean gtk_tree_view_get_dest_row_at_pos(GtkTreeView* tree_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_dest_row_at_pos", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(drag_x), drag_x, 2, "gtk_tree_view_get_dest_row_at_pos", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(drag_y), drag_y, 3, "gtk_tree_view_get_dest_row_at_pos", "gint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tree_view_get_dest_row_at_pos(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(drag_x), 
                                                                 XEN_TO_C_gint(drag_y), &ref_path, &ref_pos));
    return(XEN_LIST_3(result, C_TO_XEN_GtkTreePath_(ref_path), C_TO_XEN_GtkTreeViewDropPosition(ref_pos)));
   }
}
static XEN gxg_gtk_tree_view_create_row_drag_icon(XEN tree_view, XEN path)
{
  #define H_gtk_tree_view_create_row_drag_icon "GdkPixmap* gtk_tree_view_create_row_drag_icon(GtkTreeView* tree_view, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_create_row_drag_icon", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_create_row_drag_icon", "GtkTreePath*");
  return(C_TO_XEN_GdkPixmap_(gtk_tree_view_create_row_drag_icon(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_tree_view_set_enable_search(XEN tree_view, XEN enable_search)
{
  #define H_gtk_tree_view_set_enable_search "void gtk_tree_view_set_enable_search(GtkTreeView* tree_view, \
gboolean enable_search)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_enable_search", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(enable_search), enable_search, 2, "gtk_tree_view_set_enable_search", "gboolean");
  gtk_tree_view_set_enable_search(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(enable_search));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_enable_search(XEN tree_view)
{
  #define H_gtk_tree_view_get_enable_search "gboolean gtk_tree_view_get_enable_search(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_enable_search", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_enable_search(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_get_search_column(XEN tree_view)
{
  #define H_gtk_tree_view_get_search_column "gint gtk_tree_view_get_search_column(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_search_column", "GtkTreeView*");
  return(C_TO_XEN_gint(gtk_tree_view_get_search_column(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_search_column(XEN tree_view, XEN column)
{
  #define H_gtk_tree_view_set_search_column "void gtk_tree_view_set_search_column(GtkTreeView* tree_view, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_search_column", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_tree_view_set_search_column", "gint");
  gtk_tree_view_set_search_column(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_search_equal_func(XEN tree_view)
{
  #define H_gtk_tree_view_get_search_equal_func "GtkTreeViewSearchEqualFunc gtk_tree_view_get_search_equal_func(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_search_equal_func", "GtkTreeView*");
  return(C_TO_XEN_GtkTreeViewSearchEqualFunc(gtk_tree_view_get_search_equal_func(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_search_equal_func(XEN tree_view, XEN func, XEN func_data, XEN search_destroy)
{
  #define H_gtk_tree_view_set_search_equal_func "void gtk_tree_view_set_search_equal_func(GtkTreeView* tree_view, \
GtkTreeViewSearchEqualFunc func, lambda_data func_data, GtkDestroyNotify search_destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_search_equal_func", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewSearchEqualFunc_P(func), func, 2, "gtk_tree_view_set_search_equal_func", "GtkTreeViewSearchEqualFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_view_set_search_equal_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(search_destroy), search_destroy, 4, "gtk_tree_view_set_search_equal_func", "GtkDestroyNotify");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    XEN_LIST_SET(gxg_ptr, 3, search_destroy);
    gtk_tree_view_set_search_equal_func(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewSearchEqualFunc(func), XEN_TO_C_lambda_data(func_data), 
                                    XEN_TO_C_GtkDestroyNotify(search_destroy));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_vbutton_box_get_type(void)
{
  #define H_gtk_vbutton_box_get_type "GtkType gtk_vbutton_box_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vbutton_box_get_type()));
}
static XEN gxg_gtk_vbutton_box_new(void)
{
  #define H_gtk_vbutton_box_new "GtkWidget* gtk_vbutton_box_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_vbutton_box_new()));
}
static XEN gxg_gtk_viewport_get_type(void)
{
  #define H_gtk_viewport_get_type "GtkType gtk_viewport_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_viewport_get_type()));
}
static XEN gxg_gtk_viewport_new(XEN hadjustment, XEN vadjustment)
{
  #define H_gtk_viewport_new "GtkWidget* gtk_viewport_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 1, "gtk_viewport_new", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(vadjustment) || XEN_FALSE_P(vadjustment), vadjustment, 2, "gtk_viewport_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_viewport_new(XEN_TO_C_GtkAdjustment_(hadjustment), XEN_TO_C_GtkAdjustment_(vadjustment))));
}
static XEN gxg_gtk_viewport_get_hadjustment(XEN viewport)
{
  #define H_gtk_viewport_get_hadjustment "GtkAdjustment* gtk_viewport_get_hadjustment(GtkViewport* viewport)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_get_hadjustment", "GtkViewport*");
  return(C_TO_XEN_GtkAdjustment_(gtk_viewport_get_hadjustment(XEN_TO_C_GtkViewport_(viewport))));
}
static XEN gxg_gtk_viewport_get_vadjustment(XEN viewport)
{
  #define H_gtk_viewport_get_vadjustment "GtkAdjustment* gtk_viewport_get_vadjustment(GtkViewport* viewport)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_get_vadjustment", "GtkViewport*");
  return(C_TO_XEN_GtkAdjustment_(gtk_viewport_get_vadjustment(XEN_TO_C_GtkViewport_(viewport))));
}
static XEN gxg_gtk_viewport_set_hadjustment(XEN viewport, XEN adjustment)
{
  #define H_gtk_viewport_set_hadjustment "void gtk_viewport_set_hadjustment(GtkViewport* viewport, GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_set_hadjustment", "GtkViewport*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_viewport_set_hadjustment", "GtkAdjustment*");
  gtk_viewport_set_hadjustment(XEN_TO_C_GtkViewport_(viewport), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_viewport_set_vadjustment(XEN viewport, XEN adjustment)
{
  #define H_gtk_viewport_set_vadjustment "void gtk_viewport_set_vadjustment(GtkViewport* viewport, GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_set_vadjustment", "GtkViewport*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 2, "gtk_viewport_set_vadjustment", "GtkAdjustment*");
  gtk_viewport_set_vadjustment(XEN_TO_C_GtkViewport_(viewport), XEN_TO_C_GtkAdjustment_(adjustment));
  return(XEN_FALSE);
}
static XEN gxg_gtk_viewport_set_shadow_type(XEN viewport, XEN type)
{
  #define H_gtk_viewport_set_shadow_type "void gtk_viewport_set_shadow_type(GtkViewport* viewport, GtkShadowType type)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_set_shadow_type", "GtkViewport*");
  XEN_ASSERT_TYPE(XEN_GtkShadowType_P(type), type, 2, "gtk_viewport_set_shadow_type", "GtkShadowType");
  gtk_viewport_set_shadow_type(XEN_TO_C_GtkViewport_(viewport), XEN_TO_C_GtkShadowType(type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_viewport_get_shadow_type(XEN viewport)
{
  #define H_gtk_viewport_get_shadow_type "GtkShadowType gtk_viewport_get_shadow_type(GtkViewport* viewport)"
  XEN_ASSERT_TYPE(XEN_GtkViewport__P(viewport), viewport, 1, "gtk_viewport_get_shadow_type", "GtkViewport*");
  return(C_TO_XEN_GtkShadowType(gtk_viewport_get_shadow_type(XEN_TO_C_GtkViewport_(viewport))));
}
static XEN gxg_gtk_vpaned_get_type(void)
{
  #define H_gtk_vpaned_get_type "GtkType gtk_vpaned_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vpaned_get_type()));
}
static XEN gxg_gtk_vpaned_new(void)
{
  #define H_gtk_vpaned_new "GtkWidget* gtk_vpaned_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_vpaned_new()));
}
static XEN gxg_gtk_vruler_get_type(void)
{
  #define H_gtk_vruler_get_type "GtkType gtk_vruler_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vruler_get_type()));
}
static XEN gxg_gtk_vruler_new(void)
{
  #define H_gtk_vruler_new "GtkWidget* gtk_vruler_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_vruler_new()));
}
static XEN gxg_gtk_vscale_get_type(void)
{
  #define H_gtk_vscale_get_type "GtkType gtk_vscale_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vscale_get_type()));
}
static XEN gxg_gtk_vscale_new(XEN adjustment)
{
  #define H_gtk_vscale_new "GtkWidget* gtk_vscale_new(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 1, "gtk_vscale_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_vscale_new(XEN_TO_C_GtkAdjustment_(adjustment))));
}
static XEN gxg_gtk_vscale_new_with_range(XEN min, XEN max, XEN step)
{
  #define H_gtk_vscale_new_with_range "GtkWidget* gtk_vscale_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  XEN_ASSERT_TYPE(XEN_gdouble_P(min), min, 1, "gtk_vscale_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(max), max, 2, "gtk_vscale_new_with_range", "gdouble");
  XEN_ASSERT_TYPE(XEN_gdouble_P(step), step, 3, "gtk_vscale_new_with_range", "gdouble");
  return(C_TO_XEN_GtkWidget_(gtk_vscale_new_with_range(XEN_TO_C_gdouble(min), XEN_TO_C_gdouble(max), XEN_TO_C_gdouble(step))));
}
static XEN gxg_gtk_vscrollbar_get_type(void)
{
  #define H_gtk_vscrollbar_get_type "GtkType gtk_vscrollbar_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vscrollbar_get_type()));
}
static XEN gxg_gtk_vscrollbar_new(XEN adjustment)
{
  #define H_gtk_vscrollbar_new "GtkWidget* gtk_vscrollbar_new(GtkAdjustment* adjustment)"
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(adjustment) || XEN_FALSE_P(adjustment), adjustment, 1, "gtk_vscrollbar_new", "GtkAdjustment*");
  return(C_TO_XEN_GtkWidget_(gtk_vscrollbar_new(XEN_TO_C_GtkAdjustment_(adjustment))));
}
static XEN gxg_gtk_vseparator_get_type(void)
{
  #define H_gtk_vseparator_get_type "GtkType gtk_vseparator_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_vseparator_get_type()));
}
static XEN gxg_gtk_vseparator_new(void)
{
  #define H_gtk_vseparator_new "GtkWidget* gtk_vseparator_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_vseparator_new()));
}
static XEN gxg_GTK_WIDGET_STATE(XEN wid)
{
  #define H_GTK_WIDGET_STATE "int GTK_WIDGET_STATE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_STATE", "GtkWidget*");
  return(C_TO_XEN_int(GTK_WIDGET_STATE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_SAVED_STATE(XEN wid)
{
  #define H_GTK_WIDGET_SAVED_STATE "int GTK_WIDGET_SAVED_STATE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_SAVED_STATE", "GtkWidget*");
  return(C_TO_XEN_int(GTK_WIDGET_SAVED_STATE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_FLAGS(XEN wid)
{
  #define H_GTK_WIDGET_FLAGS "int GTK_WIDGET_FLAGS(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_FLAGS", "GtkWidget*");
  return(C_TO_XEN_int(GTK_WIDGET_FLAGS(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_TOPLEVEL(XEN wid)
{
  #define H_GTK_WIDGET_TOPLEVEL "gboolean GTK_WIDGET_TOPLEVEL(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_TOPLEVEL", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_TOPLEVEL(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_NO_WINDOW(XEN wid)
{
  #define H_GTK_WIDGET_NO_WINDOW "gboolean GTK_WIDGET_NO_WINDOW(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_NO_WINDOW", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_NO_WINDOW(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_REALIZED(XEN wid)
{
  #define H_GTK_WIDGET_REALIZED "gboolean GTK_WIDGET_REALIZED(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_REALIZED", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_REALIZED(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_MAPPED(XEN wid)
{
  #define H_GTK_WIDGET_MAPPED "gboolean GTK_WIDGET_MAPPED(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_MAPPED", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_MAPPED(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_VISIBLE(XEN wid)
{
  #define H_GTK_WIDGET_VISIBLE "gboolean GTK_WIDGET_VISIBLE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_VISIBLE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_VISIBLE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_DRAWABLE(XEN wid)
{
  #define H_GTK_WIDGET_DRAWABLE "gboolean GTK_WIDGET_DRAWABLE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_DRAWABLE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_DRAWABLE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_SENSITIVE(XEN wid)
{
  #define H_GTK_WIDGET_SENSITIVE "gboolean GTK_WIDGET_SENSITIVE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_SENSITIVE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_SENSITIVE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_PARENT_SENSITIVE(XEN wid)
{
  #define H_GTK_WIDGET_PARENT_SENSITIVE "gboolean GTK_WIDGET_PARENT_SENSITIVE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_PARENT_SENSITIVE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_PARENT_SENSITIVE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_IS_SENSITIVE(XEN wid)
{
  #define H_GTK_WIDGET_IS_SENSITIVE "gboolean GTK_WIDGET_IS_SENSITIVE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_IS_SENSITIVE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_IS_SENSITIVE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_CAN_FOCUS(XEN wid)
{
  #define H_GTK_WIDGET_CAN_FOCUS "gboolean GTK_WIDGET_CAN_FOCUS(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_CAN_FOCUS", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_CAN_FOCUS(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_HAS_FOCUS(XEN wid)
{
  #define H_GTK_WIDGET_HAS_FOCUS "gboolean GTK_WIDGET_HAS_FOCUS(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_HAS_FOCUS", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_HAS_FOCUS(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_CAN_DEFAULT(XEN wid)
{
  #define H_GTK_WIDGET_CAN_DEFAULT "gboolean GTK_WIDGET_CAN_DEFAULT(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_CAN_DEFAULT", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_CAN_DEFAULT(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_HAS_DEFAULT(XEN wid)
{
  #define H_GTK_WIDGET_HAS_DEFAULT "gboolean GTK_WIDGET_HAS_DEFAULT(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_HAS_DEFAULT", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_HAS_DEFAULT(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_HAS_GRAB(XEN wid)
{
  #define H_GTK_WIDGET_HAS_GRAB "gboolean GTK_WIDGET_HAS_GRAB(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_HAS_GRAB", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_HAS_GRAB(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_RC_STYLE(XEN wid)
{
  #define H_GTK_WIDGET_RC_STYLE "gboolean GTK_WIDGET_RC_STYLE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_RC_STYLE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_RC_STYLE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_COMPOSITE_CHILD(XEN wid)
{
  #define H_GTK_WIDGET_COMPOSITE_CHILD "gboolean GTK_WIDGET_COMPOSITE_CHILD(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_COMPOSITE_CHILD", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_COMPOSITE_CHILD(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_APP_PAINTABLE(XEN wid)
{
  #define H_GTK_WIDGET_APP_PAINTABLE "gboolean GTK_WIDGET_APP_PAINTABLE(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_APP_PAINTABLE", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_APP_PAINTABLE(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_RECEIVES_DEFAULT(XEN wid)
{
  #define H_GTK_WIDGET_RECEIVES_DEFAULT "gboolean GTK_WIDGET_RECEIVES_DEFAULT(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_RECEIVES_DEFAULT", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_RECEIVES_DEFAULT(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_DOUBLE_BUFFERED(XEN wid)
{
  #define H_GTK_WIDGET_DOUBLE_BUFFERED "gboolean GTK_WIDGET_DOUBLE_BUFFERED(GtkWidget* wid)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_DOUBLE_BUFFERED", "GtkWidget*");
  return(C_TO_XEN_gboolean(GTK_WIDGET_DOUBLE_BUFFERED(XEN_TO_C_GtkWidget_(wid))));
}
static XEN gxg_GTK_WIDGET_SET_FLAGS(XEN wid, XEN flag)
{
  #define H_GTK_WIDGET_SET_FLAGS "void GTK_WIDGET_SET_FLAGS(GtkWidget* wid, int flag)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_SET_FLAGS", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_int_P(flag), flag, 2, "GTK_WIDGET_SET_FLAGS", "int");
  GTK_WIDGET_SET_FLAGS(XEN_TO_C_GtkWidget_(wid), XEN_TO_C_int(flag));
  return(XEN_FALSE);
}
static XEN gxg_GTK_WIDGET_UNSET_FLAGS(XEN wid, XEN flag)
{
  #define H_GTK_WIDGET_UNSET_FLAGS "void GTK_WIDGET_UNSET_FLAGS(GtkWidget* wid, int flag)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(wid), wid, 1, "GTK_WIDGET_UNSET_FLAGS", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_int_P(flag), flag, 2, "GTK_WIDGET_UNSET_FLAGS", "int");
  GTK_WIDGET_UNSET_FLAGS(XEN_TO_C_GtkWidget_(wid), XEN_TO_C_int(flag));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_type(void)
{
  #define H_gtk_widget_get_type "GtkType gtk_widget_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_widget_get_type()));
}
static XEN gxg_gtk_widget_ref(XEN widget)
{
  #define H_gtk_widget_ref "GtkWidget* gtk_widget_ref(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_ref", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_widget_ref(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_unref(XEN widget)
{
  #define H_gtk_widget_unref "void gtk_widget_unref(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_unref", "GtkWidget*");
  gtk_widget_unref(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_destroy(XEN widget)
{
  #define H_gtk_widget_destroy "void gtk_widget_destroy(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_destroy", "GtkWidget*");
  gtk_widget_destroy(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_destroyed(XEN widget, XEN widget_pointer)
{
  #define H_gtk_widget_destroyed "void gtk_widget_destroyed(GtkWidget* widget, GtkWidget** [widget_pointer])"
  GtkWidget* ref_widget_pointer = NULL;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_destroyed", "GtkWidget*");
  gtk_widget_destroyed(XEN_TO_C_GtkWidget_(widget), &ref_widget_pointer);
  return(XEN_LIST_1(C_TO_XEN_GtkWidget_(ref_widget_pointer)));
}
static XEN gxg_gtk_widget_unparent(XEN widget)
{
  #define H_gtk_widget_unparent "void gtk_widget_unparent(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_unparent", "GtkWidget*");
  gtk_widget_unparent(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_show(XEN widget)
{
  #define H_gtk_widget_show "void gtk_widget_show(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_show", "GtkWidget*");
  gtk_widget_show(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_show_now(XEN widget)
{
  #define H_gtk_widget_show_now "void gtk_widget_show_now(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_show_now", "GtkWidget*");
  gtk_widget_show_now(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_hide(XEN widget)
{
  #define H_gtk_widget_hide "void gtk_widget_hide(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_hide", "GtkWidget*");
  gtk_widget_hide(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_show_all(XEN widget)
{
  #define H_gtk_widget_show_all "void gtk_widget_show_all(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_show_all", "GtkWidget*");
  gtk_widget_show_all(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_hide_all(XEN widget)
{
  #define H_gtk_widget_hide_all "void gtk_widget_hide_all(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_hide_all", "GtkWidget*");
  gtk_widget_hide_all(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_map(XEN widget)
{
  #define H_gtk_widget_map "void gtk_widget_map(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_map", "GtkWidget*");
  gtk_widget_map(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_unmap(XEN widget)
{
  #define H_gtk_widget_unmap "void gtk_widget_unmap(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_unmap", "GtkWidget*");
  gtk_widget_unmap(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_realize(XEN widget)
{
  #define H_gtk_widget_realize "void gtk_widget_realize(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_realize", "GtkWidget*");
  gtk_widget_realize(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_unrealize(XEN widget)
{
  #define H_gtk_widget_unrealize "void gtk_widget_unrealize(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_unrealize", "GtkWidget*");
  gtk_widget_unrealize(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_queue_draw(XEN widget)
{
  #define H_gtk_widget_queue_draw "void gtk_widget_queue_draw(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_queue_draw", "GtkWidget*");
  gtk_widget_queue_draw(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_queue_draw_area(XEN widget, XEN x, XEN y, XEN width, XEN height)
{
  #define H_gtk_widget_queue_draw_area "void gtk_widget_queue_draw_area(GtkWidget* widget, gint x, gint y, \
gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_queue_draw_area", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gtk_widget_queue_draw_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_widget_queue_draw_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 4, "gtk_widget_queue_draw_area", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 5, "gtk_widget_queue_draw_area", "gint");
  gtk_widget_queue_draw_area(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_queue_resize(XEN widget)
{
  #define H_gtk_widget_queue_resize "void gtk_widget_queue_resize(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_queue_resize", "GtkWidget*");
  gtk_widget_queue_resize(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_size_request(XEN widget, XEN requisition)
{
  #define H_gtk_widget_size_request "void gtk_widget_size_request(GtkWidget* widget, GtkRequisition* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_size_request", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkRequisition__P(requisition), requisition, 2, "gtk_widget_size_request", "GtkRequisition*");
  gtk_widget_size_request(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkRequisition_(requisition));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_size_allocate(XEN widget, XEN allocation)
{
  #define H_gtk_widget_size_allocate "void gtk_widget_size_allocate(GtkWidget* widget, GtkAllocation* allocation)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_size_allocate", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkAllocation__P(allocation), allocation, 2, "gtk_widget_size_allocate", "GtkAllocation*");
  gtk_widget_size_allocate(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkAllocation_(allocation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_child_requisition(XEN widget, XEN requisition)
{
  #define H_gtk_widget_get_child_requisition "void gtk_widget_get_child_requisition(GtkWidget* widget, \
GtkRequisition* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_child_requisition", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkRequisition__P(requisition), requisition, 2, "gtk_widget_get_child_requisition", "GtkRequisition*");
  gtk_widget_get_child_requisition(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkRequisition_(requisition));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_add_accelerator(XEN widget, XEN accel_signal, XEN accel_group, XEN accel_key, XEN accel_mods, XEN accel_flags)
{
  #define H_gtk_widget_add_accelerator "void gtk_widget_add_accelerator(GtkWidget* widget, gchar* accel_signal, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods, GtkAccelFlags accel_flags)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_add_accelerator", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_signal), accel_signal, 2, "gtk_widget_add_accelerator", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 3, "gtk_widget_add_accelerator", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 4, "gtk_widget_add_accelerator", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 5, "gtk_widget_add_accelerator", "GdkModifierType");
  XEN_ASSERT_TYPE(XEN_GtkAccelFlags_P(accel_flags), accel_flags, 6, "gtk_widget_add_accelerator", "GtkAccelFlags");
  gtk_widget_add_accelerator(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(accel_signal), XEN_TO_C_GtkAccelGroup_(accel_group), 
                             XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods), XEN_TO_C_GtkAccelFlags(accel_flags));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_remove_accelerator(XEN widget, XEN accel_group, XEN accel_key, XEN accel_mods)
{
  #define H_gtk_widget_remove_accelerator "gboolean gtk_widget_remove_accelerator(GtkWidget* widget, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_remove_accelerator", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 2, "gtk_widget_remove_accelerator", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 3, "gtk_widget_remove_accelerator", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 4, "gtk_widget_remove_accelerator", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_widget_remove_accelerator(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkAccelGroup_(accel_group), 
                                                         XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods))));
}
static XEN gxg_gtk_widget_list_accel_closures(XEN widget)
{
  #define H_gtk_widget_list_accel_closures "GList* gtk_widget_list_accel_closures(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_list_accel_closures", "GtkWidget*");
  return(C_TO_XEN_GList_(gtk_widget_list_accel_closures(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_mnemonic_activate(XEN widget, XEN group_cycling)
{
  #define H_gtk_widget_mnemonic_activate "gboolean gtk_widget_mnemonic_activate(GtkWidget* widget, gboolean group_cycling)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_mnemonic_activate", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(group_cycling), group_cycling, 2, "gtk_widget_mnemonic_activate", "gboolean");
  return(C_TO_XEN_gboolean(gtk_widget_mnemonic_activate(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(group_cycling))));
}
static XEN gxg_gtk_widget_event(XEN widget, XEN event)
{
  #define H_gtk_widget_event "gboolean gtk_widget_event(GtkWidget* widget, GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_event", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gtk_widget_event", "GdkEvent*");
  return(C_TO_XEN_gboolean(gtk_widget_event(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gtk_widget_send_expose(XEN widget, XEN event)
{
  #define H_gtk_widget_send_expose "gint gtk_widget_send_expose(GtkWidget* widget, GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_send_expose", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gtk_widget_send_expose", "GdkEvent*");
  return(C_TO_XEN_gint(gtk_widget_send_expose(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkEvent_(event))));
}
static XEN gxg_gtk_widget_activate(XEN widget)
{
  #define H_gtk_widget_activate "gboolean gtk_widget_activate(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_activate", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_activate(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_set_scroll_adjustments(XEN widget, XEN hadjustment, XEN vadjustment)
{
  #define H_gtk_widget_set_scroll_adjustments "gboolean gtk_widget_set_scroll_adjustments(GtkWidget* widget, \
GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_scroll_adjustments", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(hadjustment) || XEN_FALSE_P(hadjustment), hadjustment, 2, "gtk_widget_set_scroll_adjustments", "GtkAdjustment*");
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(vadjustment) || XEN_FALSE_P(vadjustment), vadjustment, 3, "gtk_widget_set_scroll_adjustments", "GtkAdjustment*");
  return(C_TO_XEN_gboolean(gtk_widget_set_scroll_adjustments(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkAdjustment_(hadjustment), 
                                                             XEN_TO_C_GtkAdjustment_(vadjustment))));
}
static XEN gxg_gtk_widget_reparent(XEN widget, XEN new_parent)
{
  #define H_gtk_widget_reparent "void gtk_widget_reparent(GtkWidget* widget, GtkWidget* new_parent)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_reparent", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(new_parent), new_parent, 2, "gtk_widget_reparent", "GtkWidget*");
  gtk_widget_reparent(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkWidget_(new_parent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_intersect(XEN widget, XEN area, XEN intersection)
{
  #define H_gtk_widget_intersect "gboolean gtk_widget_intersect(GtkWidget* widget, GdkRectangle* area, \
GdkRectangle* intersection)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_intersect", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(area), area, 2, "gtk_widget_intersect", "GdkRectangle*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(intersection) || XEN_FALSE_P(intersection), intersection, 3, "gtk_widget_intersect", "GdkRectangle*");
  return(C_TO_XEN_gboolean(gtk_widget_intersect(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkRectangle_(area), XEN_TO_C_GdkRectangle_(intersection))));
}
static XEN gxg_gtk_widget_region_intersect(XEN widget, XEN region)
{
  #define H_gtk_widget_region_intersect "GdkRegion* gtk_widget_region_intersect(GtkWidget* widget, GdkRegion* region)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_region_intersect", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkRegion__P(region), region, 2, "gtk_widget_region_intersect", "GdkRegion*");
  return(C_TO_XEN_GdkRegion_(gtk_widget_region_intersect(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkRegion_(region))));
}
static XEN gxg_gtk_widget_freeze_child_notify(XEN widget)
{
  #define H_gtk_widget_freeze_child_notify "void gtk_widget_freeze_child_notify(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_freeze_child_notify", "GtkWidget*");
  gtk_widget_freeze_child_notify(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_child_notify(XEN widget, XEN child_property)
{
  #define H_gtk_widget_child_notify "void gtk_widget_child_notify(GtkWidget* widget, gchar* child_property)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_child_notify", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(child_property), child_property, 2, "gtk_widget_child_notify", "gchar*");
  gtk_widget_child_notify(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(child_property));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_thaw_child_notify(XEN widget)
{
  #define H_gtk_widget_thaw_child_notify "void gtk_widget_thaw_child_notify(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_thaw_child_notify", "GtkWidget*");
  gtk_widget_thaw_child_notify(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_is_focus(XEN widget)
{
  #define H_gtk_widget_is_focus "gboolean gtk_widget_is_focus(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_is_focus", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_is_focus(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_grab_focus(XEN widget)
{
  #define H_gtk_widget_grab_focus "void gtk_widget_grab_focus(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_grab_focus", "GtkWidget*");
  gtk_widget_grab_focus(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_grab_default(XEN widget)
{
  #define H_gtk_widget_grab_default "void gtk_widget_grab_default(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_grab_default", "GtkWidget*");
  gtk_widget_grab_default(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_name(XEN widget, XEN name)
{
  #define H_gtk_widget_set_name "void gtk_widget_set_name(GtkWidget* widget, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_name", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_widget_set_name", "gchar*");
  gtk_widget_set_name(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_name(XEN widget)
{
  #define H_gtk_widget_get_name "gchar* gtk_widget_get_name(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_name", "GtkWidget*");
  return(C_TO_XEN_gchar_(gtk_widget_get_name(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_set_state(XEN widget, XEN state)
{
  #define H_gtk_widget_set_state "void gtk_widget_set_state(GtkWidget* widget, GtkStateType state)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_state", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_widget_set_state", "GtkStateType");
  gtk_widget_set_state(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStateType(state));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_sensitive(XEN widget, XEN sensitive)
{
  #define H_gtk_widget_set_sensitive "void gtk_widget_set_sensitive(GtkWidget* widget, gboolean sensitive)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_sensitive", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(sensitive), sensitive, 2, "gtk_widget_set_sensitive", "gboolean");
  gtk_widget_set_sensitive(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(sensitive));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_app_paintable(XEN widget, XEN app_paintable)
{
  #define H_gtk_widget_set_app_paintable "void gtk_widget_set_app_paintable(GtkWidget* widget, gboolean app_paintable)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_app_paintable", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(app_paintable), app_paintable, 2, "gtk_widget_set_app_paintable", "gboolean");
  gtk_widget_set_app_paintable(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(app_paintable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_double_buffered(XEN widget, XEN double_buffered)
{
  #define H_gtk_widget_set_double_buffered "void gtk_widget_set_double_buffered(GtkWidget* widget, gboolean double_buffered)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_double_buffered", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(double_buffered), double_buffered, 2, "gtk_widget_set_double_buffered", "gboolean");
  gtk_widget_set_double_buffered(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(double_buffered));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_redraw_on_allocate(XEN widget, XEN redraw_on_allocate)
{
  #define H_gtk_widget_set_redraw_on_allocate "void gtk_widget_set_redraw_on_allocate(GtkWidget* widget, \
gboolean redraw_on_allocate)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_redraw_on_allocate", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(redraw_on_allocate), redraw_on_allocate, 2, "gtk_widget_set_redraw_on_allocate", "gboolean");
  gtk_widget_set_redraw_on_allocate(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(redraw_on_allocate));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_parent(XEN widget, XEN parent)
{
  #define H_gtk_widget_set_parent "void gtk_widget_set_parent(GtkWidget* widget, GtkWidget* parent)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_parent", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(parent), parent, 2, "gtk_widget_set_parent", "GtkWidget*");
  gtk_widget_set_parent(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkWidget_(parent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_parent_window(XEN widget, XEN parent_window)
{
  #define H_gtk_widget_set_parent_window "void gtk_widget_set_parent_window(GtkWidget* widget, GdkWindow* parent_window)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_parent_window", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(parent_window), parent_window, 2, "gtk_widget_set_parent_window", "GdkWindow*");
  gtk_widget_set_parent_window(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkWindow_(parent_window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_child_visible(XEN widget, XEN is_visible)
{
  #define H_gtk_widget_set_child_visible "void gtk_widget_set_child_visible(GtkWidget* widget, gboolean is_visible)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_child_visible", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_visible), is_visible, 2, "gtk_widget_set_child_visible", "gboolean");
  gtk_widget_set_child_visible(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(is_visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_accel_path(XEN widget, XEN accel_path, XEN accel_group)
{
  #define H_gtk_widget_set_accel_path "void gtk_widget_set_accel_path(GtkWidget* widget, gchar* accel_path, \
GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_accel_path", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accel_path), accel_path, 2, "gtk_widget_set_accel_path", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 3, "gtk_widget_set_accel_path", "GtkAccelGroup*");
  gtk_widget_set_accel_path(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(accel_path), XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_child_visible(XEN widget)
{
  #define H_gtk_widget_get_child_visible "gboolean gtk_widget_get_child_visible(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_child_visible", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_get_child_visible(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_parent(XEN widget)
{
  #define H_gtk_widget_get_parent "GtkWidget* gtk_widget_get_parent(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_parent", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_widget_get_parent(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_parent_window(XEN widget)
{
  #define H_gtk_widget_get_parent_window "GdkWindow* gtk_widget_get_parent_window(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_parent_window", "GtkWidget*");
  return(C_TO_XEN_GdkWindow_(gtk_widget_get_parent_window(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_child_focus(XEN widget, XEN direction)
{
  #define H_gtk_widget_child_focus "gboolean gtk_widget_child_focus(GtkWidget* widget, GtkDirectionType direction)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_child_focus", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkDirectionType_P(direction), direction, 2, "gtk_widget_child_focus", "GtkDirectionType");
  return(C_TO_XEN_gboolean(gtk_widget_child_focus(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkDirectionType(direction))));
}
static XEN gxg_gtk_widget_set_size_request(XEN widget, XEN width, XEN height)
{
  #define H_gtk_widget_set_size_request "void gtk_widget_set_size_request(GtkWidget* widget, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_size_request", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_widget_set_size_request", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gtk_widget_set_size_request", "gint");
  gtk_widget_set_size_request(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_size_request(XEN widget, XEN width, XEN height)
{
  #define H_gtk_widget_get_size_request "void gtk_widget_get_size_request(GtkWidget* widget, gint* [width], \
gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_size_request", "GtkWidget*");
  gtk_widget_get_size_request(XEN_TO_C_GtkWidget_(widget), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_widget_set_events(XEN widget, XEN events)
{
  #define H_gtk_widget_set_events "void gtk_widget_set_events(GtkWidget* widget, gint events)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_events", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(events), events, 2, "gtk_widget_set_events", "gint");
  gtk_widget_set_events(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(events));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_add_events(XEN widget, XEN events)
{
  #define H_gtk_widget_add_events "void gtk_widget_add_events(GtkWidget* widget, gint events)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_add_events", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(events), events, 2, "gtk_widget_add_events", "gint");
  gtk_widget_add_events(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gint(events));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_extension_events(XEN widget, XEN mode)
{
  #define H_gtk_widget_set_extension_events "void gtk_widget_set_extension_events(GtkWidget* widget, \
GdkExtensionMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_extension_events", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkExtensionMode_P(mode), mode, 2, "gtk_widget_set_extension_events", "GdkExtensionMode");
  gtk_widget_set_extension_events(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkExtensionMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_extension_events(XEN widget)
{
  #define H_gtk_widget_get_extension_events "GdkExtensionMode gtk_widget_get_extension_events(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_extension_events", "GtkWidget*");
  return(C_TO_XEN_GdkExtensionMode(gtk_widget_get_extension_events(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_toplevel(XEN widget)
{
  #define H_gtk_widget_get_toplevel "GtkWidget* gtk_widget_get_toplevel(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_toplevel", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_widget_get_toplevel(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_ancestor(XEN widget, XEN widget_type)
{
  #define H_gtk_widget_get_ancestor "GtkWidget* gtk_widget_get_ancestor(GtkWidget* widget, GtkType widget_type)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_ancestor", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkType_P(widget_type), widget_type, 2, "gtk_widget_get_ancestor", "GtkType");
  return(C_TO_XEN_GtkWidget_(gtk_widget_get_ancestor(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkType(widget_type))));
}
static XEN gxg_gtk_widget_get_colormap(XEN widget)
{
  #define H_gtk_widget_get_colormap "GdkColormap* gtk_widget_get_colormap(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_colormap", "GtkWidget*");
  return(C_TO_XEN_GdkColormap_(gtk_widget_get_colormap(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_visual(XEN widget)
{
  #define H_gtk_widget_get_visual "GdkVisual* gtk_widget_get_visual(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_visual", "GtkWidget*");
  return(C_TO_XEN_GdkVisual_(gtk_widget_get_visual(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_accessible(XEN widget)
{
  #define H_gtk_widget_get_accessible "AtkObject* gtk_widget_get_accessible(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_accessible", "GtkWidget*");
  return(C_TO_XEN_AtkObject_(gtk_widget_get_accessible(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_set_colormap(XEN widget, XEN colormap)
{
  #define H_gtk_widget_set_colormap "void gtk_widget_set_colormap(GtkWidget* widget, GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_colormap", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gtk_widget_set_colormap", "GdkColormap*");
  gtk_widget_set_colormap(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkColormap_(colormap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_events(XEN widget)
{
  #define H_gtk_widget_get_events "gint gtk_widget_get_events(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_events", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_widget_get_events(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_pointer(XEN widget, XEN x, XEN y)
{
  #define H_gtk_widget_get_pointer "void gtk_widget_get_pointer(GtkWidget* widget, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_pointer", "GtkWidget*");
  gtk_widget_get_pointer(XEN_TO_C_GtkWidget_(widget), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gtk_widget_is_ancestor(XEN widget, XEN ancestor)
{
  #define H_gtk_widget_is_ancestor "gboolean gtk_widget_is_ancestor(GtkWidget* widget, GtkWidget* ancestor)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_is_ancestor", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(ancestor), ancestor, 2, "gtk_widget_is_ancestor", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_is_ancestor(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkWidget_(ancestor))));
}
static XEN gxg_gtk_widget_translate_coordinates(XEN src_widget, XEN dest_widget, XEN src_x, XEN src_y, XEN dest_x, XEN dest_y)
{
  #define H_gtk_widget_translate_coordinates "gboolean gtk_widget_translate_coordinates(GtkWidget* src_widget, \
GtkWidget* dest_widget, gint src_x, gint src_y, gint* [dest_x], gint* [dest_y])"
  gint ref_dest_x;
  gint ref_dest_y;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(src_widget), src_widget, 1, "gtk_widget_translate_coordinates", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(dest_widget), dest_widget, 2, "gtk_widget_translate_coordinates", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(src_x), src_x, 3, "gtk_widget_translate_coordinates", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(src_y), src_y, 4, "gtk_widget_translate_coordinates", "gint");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_widget_translate_coordinates(XEN_TO_C_GtkWidget_(src_widget), XEN_TO_C_GtkWidget_(dest_widget), 
                                                                XEN_TO_C_gint(src_x), XEN_TO_C_gint(src_y), &ref_dest_x, 
                                                                &ref_dest_y));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_dest_x), C_TO_XEN_gint(ref_dest_y)));
   }
}
static XEN gxg_gtk_widget_hide_on_delete(XEN widget)
{
  #define H_gtk_widget_hide_on_delete "gboolean gtk_widget_hide_on_delete(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_hide_on_delete", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_hide_on_delete(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_set_style(XEN widget, XEN style)
{
  #define H_gtk_widget_set_style "void gtk_widget_set_style(GtkWidget* widget, GtkStyle* style)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_style", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(style) || XEN_FALSE_P(style), style, 2, "gtk_widget_set_style", "GtkStyle*");
  gtk_widget_set_style(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStyle_(style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_ensure_style(XEN widget)
{
  #define H_gtk_widget_ensure_style "void gtk_widget_ensure_style(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_ensure_style", "GtkWidget*");
  gtk_widget_ensure_style(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_style(XEN widget)
{
  #define H_gtk_widget_get_style "GtkStyle* gtk_widget_get_style(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_style", "GtkWidget*");
  return(C_TO_XEN_GtkStyle_(gtk_widget_get_style(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_modify_style(XEN widget, XEN style)
{
  #define H_gtk_widget_modify_style "void gtk_widget_modify_style(GtkWidget* widget, GtkRcStyle* style)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_style", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkRcStyle__P(style), style, 2, "gtk_widget_modify_style", "GtkRcStyle*");
  gtk_widget_modify_style(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkRcStyle_(style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_modifier_style(XEN widget)
{
  #define H_gtk_widget_get_modifier_style "GtkRcStyle* gtk_widget_get_modifier_style(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_modifier_style", "GtkWidget*");
  return(C_TO_XEN_GtkRcStyle_(gtk_widget_get_modifier_style(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_modify_fg(XEN widget, XEN state, XEN color)
{
  #define H_gtk_widget_modify_fg "void gtk_widget_modify_fg(GtkWidget* widget, GtkStateType state, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_fg", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_widget_modify_fg", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 3, "gtk_widget_modify_fg", "GdkColor*");
  gtk_widget_modify_fg(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStateType(state), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_modify_bg(XEN widget, XEN state, XEN color)
{
  #define H_gtk_widget_modify_bg "void gtk_widget_modify_bg(GtkWidget* widget, GtkStateType state, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_bg", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_widget_modify_bg", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 3, "gtk_widget_modify_bg", "GdkColor*");
  gtk_widget_modify_bg(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStateType(state), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_modify_text(XEN widget, XEN state, XEN color)
{
  #define H_gtk_widget_modify_text "void gtk_widget_modify_text(GtkWidget* widget, GtkStateType state, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_text", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_widget_modify_text", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 3, "gtk_widget_modify_text", "GdkColor*");
  gtk_widget_modify_text(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStateType(state), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_modify_base(XEN widget, XEN state, XEN color)
{
  #define H_gtk_widget_modify_base "void gtk_widget_modify_base(GtkWidget* widget, GtkStateType state, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_base", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkStateType_P(state), state, 2, "gtk_widget_modify_base", "GtkStateType");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 3, "gtk_widget_modify_base", "GdkColor*");
  gtk_widget_modify_base(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkStateType(state), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_modify_font(XEN widget, XEN font_desc)
{
  #define H_gtk_widget_modify_font "void gtk_widget_modify_font(GtkWidget* widget, PangoFontDescription* font_desc)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_modify_font", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(font_desc), font_desc, 2, "gtk_widget_modify_font", "PangoFontDescription*");
  gtk_widget_modify_font(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_PangoFontDescription_(font_desc));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_create_pango_context(XEN widget)
{
  #define H_gtk_widget_create_pango_context "PangoContext* gtk_widget_create_pango_context(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_create_pango_context", "GtkWidget*");
  return(C_TO_XEN_PangoContext_(gtk_widget_create_pango_context(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_pango_context(XEN widget)
{
  #define H_gtk_widget_get_pango_context "PangoContext* gtk_widget_get_pango_context(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_pango_context", "GtkWidget*");
  return(C_TO_XEN_PangoContext_(gtk_widget_get_pango_context(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_create_pango_layout(XEN widget, XEN text)
{
  #define H_gtk_widget_create_pango_layout "PangoLayout* gtk_widget_create_pango_layout(GtkWidget* widget, \
gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_create_pango_layout", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_widget_create_pango_layout", "gchar*");
  return(C_TO_XEN_PangoLayout_(gtk_widget_create_pango_layout(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(text))));
}
static XEN gxg_gtk_widget_render_icon(XEN widget, XEN stock_id, XEN size, XEN detail)
{
  #define H_gtk_widget_render_icon "GdkPixbuf* gtk_widget_render_icon(GtkWidget* widget, gchar* stock_id, \
GtkIconSize size, gchar* detail)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_render_icon", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_widget_render_icon", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 3, "gtk_widget_render_icon", "GtkIconSize");
  XEN_ASSERT_TYPE(XEN_gchar__P(detail), detail, 4, "gtk_widget_render_icon", "gchar*");
  return(C_TO_XEN_GdkPixbuf_(gtk_widget_render_icon(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(stock_id), XEN_TO_C_GtkIconSize(size), 
                                                    XEN_TO_C_gchar_(detail))));
}
static XEN gxg_gtk_widget_set_composite_name(XEN widget, XEN name)
{
  #define H_gtk_widget_set_composite_name "void gtk_widget_set_composite_name(GtkWidget* widget, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_composite_name", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_widget_set_composite_name", "gchar*");
  gtk_widget_set_composite_name(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_composite_name(XEN widget)
{
  #define H_gtk_widget_get_composite_name "gchar* gtk_widget_get_composite_name(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_composite_name", "GtkWidget*");
  return(C_TO_XEN_gchar_(gtk_widget_get_composite_name(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_reset_rc_styles(XEN widget)
{
  #define H_gtk_widget_reset_rc_styles "void gtk_widget_reset_rc_styles(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_reset_rc_styles", "GtkWidget*");
  gtk_widget_reset_rc_styles(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_push_colormap(XEN cmap)
{
  #define H_gtk_widget_push_colormap "void gtk_widget_push_colormap(GdkColormap* cmap)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(cmap), cmap, 1, "gtk_widget_push_colormap", "GdkColormap*");
  gtk_widget_push_colormap(XEN_TO_C_GdkColormap_(cmap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_push_composite_child(void)
{
  #define H_gtk_widget_push_composite_child "void gtk_widget_push_composite_child( void)"
  gtk_widget_push_composite_child();
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_pop_composite_child(void)
{
  #define H_gtk_widget_pop_composite_child "void gtk_widget_pop_composite_child( void)"
  gtk_widget_pop_composite_child();
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_pop_colormap(void)
{
  #define H_gtk_widget_pop_colormap "void gtk_widget_pop_colormap( void)"
  gtk_widget_pop_colormap();
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_set_default_colormap(XEN colormap)
{
  #define H_gtk_widget_set_default_colormap "void gtk_widget_set_default_colormap(GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 1, "gtk_widget_set_default_colormap", "GdkColormap*");
  gtk_widget_set_default_colormap(XEN_TO_C_GdkColormap_(colormap));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_default_style(void)
{
  #define H_gtk_widget_get_default_style "GtkStyle* gtk_widget_get_default_style( void)"
  return(C_TO_XEN_GtkStyle_(gtk_widget_get_default_style()));
}
static XEN gxg_gtk_widget_get_default_colormap(void)
{
  #define H_gtk_widget_get_default_colormap "GdkColormap* gtk_widget_get_default_colormap( void)"
  return(C_TO_XEN_GdkColormap_(gtk_widget_get_default_colormap()));
}
static XEN gxg_gtk_widget_get_default_visual(void)
{
  #define H_gtk_widget_get_default_visual "GdkVisual* gtk_widget_get_default_visual( void)"
  return(C_TO_XEN_GdkVisual_(gtk_widget_get_default_visual()));
}
static XEN gxg_gtk_widget_set_direction(XEN widget, XEN dir)
{
  #define H_gtk_widget_set_direction "void gtk_widget_set_direction(GtkWidget* widget, GtkTextDirection dir)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_direction", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTextDirection_P(dir), dir, 2, "gtk_widget_set_direction", "GtkTextDirection");
  gtk_widget_set_direction(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkTextDirection(dir));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_direction(XEN widget)
{
  #define H_gtk_widget_get_direction "GtkTextDirection gtk_widget_get_direction(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_direction", "GtkWidget*");
  return(C_TO_XEN_GtkTextDirection(gtk_widget_get_direction(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_set_default_direction(XEN dir)
{
  #define H_gtk_widget_set_default_direction "void gtk_widget_set_default_direction(GtkTextDirection dir)"
  XEN_ASSERT_TYPE(XEN_GtkTextDirection_P(dir), dir, 1, "gtk_widget_set_default_direction", "GtkTextDirection");
  gtk_widget_set_default_direction(XEN_TO_C_GtkTextDirection(dir));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_default_direction(void)
{
  #define H_gtk_widget_get_default_direction "GtkTextDirection gtk_widget_get_default_direction( void)"
  return(C_TO_XEN_GtkTextDirection(gtk_widget_get_default_direction()));
}
static XEN gxg_gtk_widget_shape_combine_mask(XEN widget, XEN shape_mask, XEN offset_x, XEN offset_y)
{
  #define H_gtk_widget_shape_combine_mask "void gtk_widget_shape_combine_mask(GtkWidget* widget, GdkBitmap* shape_mask, \
gint offset_x, gint offset_y)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_shape_combine_mask", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(shape_mask) || XEN_FALSE_P(shape_mask), shape_mask, 2, "gtk_widget_shape_combine_mask", "GdkBitmap*");
  XEN_ASSERT_TYPE(XEN_gint_P(offset_x), offset_x, 3, "gtk_widget_shape_combine_mask", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(offset_y), offset_y, 4, "gtk_widget_shape_combine_mask", "gint");
  gtk_widget_shape_combine_mask(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkBitmap_(shape_mask), XEN_TO_C_gint(offset_x), XEN_TO_C_gint(offset_y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_reset_shapes(XEN widget)
{
  #define H_gtk_widget_reset_shapes "void gtk_widget_reset_shapes(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_reset_shapes", "GtkWidget*");
  gtk_widget_reset_shapes(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_path(XEN widget, XEN path_length, XEN path, XEN path_reversed)
{
  #define H_gtk_widget_path "void gtk_widget_path(GtkWidget* widget, guint* path_length, gchar** [path], \
gchar** [path_reversed])"
  gchar* ref_path = NULL;
  gchar* ref_path_reversed = NULL;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_path", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint__P(path_length), path_length, 2, "gtk_widget_path", "guint*");
  gtk_widget_path(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_guint_(path_length), &ref_path, &ref_path_reversed);
  return(XEN_LIST_2(C_TO_XEN_gchar_(ref_path), C_TO_XEN_gchar_(ref_path_reversed)));
}
static XEN gxg_gtk_widget_class_path(XEN widget, XEN path_length, XEN path, XEN path_reversed)
{
  #define H_gtk_widget_class_path "void gtk_widget_class_path(GtkWidget* widget, guint* path_length, \
gchar** [path], gchar** [path_reversed])"
  gchar* ref_path = NULL;
  gchar* ref_path_reversed = NULL;
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_class_path", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint__P(path_length), path_length, 2, "gtk_widget_class_path", "guint*");
  gtk_widget_class_path(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_guint_(path_length), &ref_path, &ref_path_reversed);
  return(XEN_LIST_2(C_TO_XEN_gchar_(ref_path), C_TO_XEN_gchar_(ref_path_reversed)));
}
static XEN gxg_gtk_requisition_copy(XEN requisition)
{
  #define H_gtk_requisition_copy "GtkRequisition* gtk_requisition_copy(GtkRequisition* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkRequisition__P(requisition), requisition, 1, "gtk_requisition_copy", "GtkRequisition*");
  return(C_TO_XEN_GtkRequisition_(gtk_requisition_copy(XEN_TO_C_GtkRequisition_(requisition))));
}
static XEN gxg_gtk_requisition_free(XEN requisition)
{
  #define H_gtk_requisition_free "void gtk_requisition_free(GtkRequisition* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkRequisition__P(requisition), requisition, 1, "gtk_requisition_free", "GtkRequisition*");
  gtk_requisition_free(XEN_TO_C_GtkRequisition_(requisition));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_type(void)
{
  #define H_gtk_window_get_type "GtkType gtk_window_get_type( void)"
  return(C_TO_XEN_GtkType(gtk_window_get_type()));
}
static XEN gxg_gtk_window_new(XEN type)
{
  #define H_gtk_window_new "GtkWidget* gtk_window_new(GtkWindowType type)"
  XEN_ASSERT_TYPE(XEN_GtkWindowType_P(type), type, 1, "gtk_window_new", "GtkWindowType");
  return(C_TO_XEN_GtkWidget_(gtk_window_new(XEN_TO_C_GtkWindowType(type))));
}
static XEN gxg_gtk_window_set_title(XEN window, XEN title)
{
  #define H_gtk_window_set_title "void gtk_window_set_title(GtkWindow* window, gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_title", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_window_set_title", "gchar*");
  gtk_window_set_title(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_title(XEN window)
{
  #define H_gtk_window_get_title "gchar* gtk_window_get_title(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_title", "GtkWindow*");
  return(C_TO_XEN_gchar_(gtk_window_get_title(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_wmclass(XEN window, XEN wmclass_name, XEN wmclass_class)
{
  #define H_gtk_window_set_wmclass "void gtk_window_set_wmclass(GtkWindow* window, gchar* wmclass_name, \
gchar* wmclass_class)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_wmclass", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(wmclass_name), wmclass_name, 2, "gtk_window_set_wmclass", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(wmclass_class), wmclass_class, 3, "gtk_window_set_wmclass", "gchar*");
  gtk_window_set_wmclass(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gchar_(wmclass_name), XEN_TO_C_gchar_(wmclass_class));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_role(XEN window, XEN role)
{
  #define H_gtk_window_set_role "void gtk_window_set_role(GtkWindow* window, gchar* role)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_role", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(role), role, 2, "gtk_window_set_role", "gchar*");
  gtk_window_set_role(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gchar_(role));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_role(XEN window)
{
  #define H_gtk_window_get_role "gchar* gtk_window_get_role(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_role", "GtkWindow*");
  return(C_TO_XEN_gchar_(gtk_window_get_role(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_add_accel_group(XEN window, XEN accel_group)
{
  #define H_gtk_window_add_accel_group "void gtk_window_add_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_add_accel_group", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 2, "gtk_window_add_accel_group", "GtkAccelGroup*");
  gtk_window_add_accel_group(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_remove_accel_group(XEN window, XEN accel_group)
{
  #define H_gtk_window_remove_accel_group "void gtk_window_remove_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_remove_accel_group", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 2, "gtk_window_remove_accel_group", "GtkAccelGroup*");
  gtk_window_remove_accel_group(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkAccelGroup_(accel_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_position(XEN window, XEN position)
{
  #define H_gtk_window_set_position "void gtk_window_set_position(GtkWindow* window, GtkWindowPosition position)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_position", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWindowPosition_P(position), position, 2, "gtk_window_set_position", "GtkWindowPosition");
  gtk_window_set_position(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkWindowPosition(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_activate_focus(XEN window)
{
  #define H_gtk_window_activate_focus "gboolean gtk_window_activate_focus(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_activate_focus", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_activate_focus(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_focus(XEN window, XEN focus)
{
  #define H_gtk_window_set_focus "void gtk_window_set_focus(GtkWindow* window, GtkWidget* focus)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_focus", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(focus) || XEN_FALSE_P(focus), focus, 2, "gtk_window_set_focus", "GtkWidget*");
  gtk_window_set_focus(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkWidget_(focus));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_focus(XEN window)
{
  #define H_gtk_window_get_focus "GtkWidget* gtk_window_get_focus(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_focus", "GtkWindow*");
  return(C_TO_XEN_GtkWidget_(gtk_window_get_focus(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_default(XEN window, XEN default_widget)
{
  #define H_gtk_window_set_default "void gtk_window_set_default(GtkWindow* window, GtkWidget* default_widget)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_default", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(default_widget) || XEN_FALSE_P(default_widget), default_widget, 2, "gtk_window_set_default", "GtkWidget*");
  gtk_window_set_default(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkWidget_(default_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_activate_default(XEN window)
{
  #define H_gtk_window_activate_default "gboolean gtk_window_activate_default(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_activate_default", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_activate_default(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_transient_for(XEN window, XEN parent)
{
  #define H_gtk_window_set_transient_for "void gtk_window_set_transient_for(GtkWindow* window, GtkWindow* parent)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_transient_for", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(parent) || XEN_FALSE_P(parent), parent, 2, "gtk_window_set_transient_for", "GtkWindow*");
  gtk_window_set_transient_for(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkWindow_(parent));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_transient_for(XEN window)
{
  #define H_gtk_window_get_transient_for "GtkWindow* gtk_window_get_transient_for(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_transient_for", "GtkWindow*");
  return(C_TO_XEN_GtkWindow_(gtk_window_get_transient_for(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_type_hint(XEN window, XEN hint)
{
  #define H_gtk_window_set_type_hint "void gtk_window_set_type_hint(GtkWindow* window, GdkWindowTypeHint hint)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_type_hint", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindowTypeHint_P(hint), hint, 2, "gtk_window_set_type_hint", "GdkWindowTypeHint");
  gtk_window_set_type_hint(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkWindowTypeHint(hint));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_type_hint(XEN window)
{
  #define H_gtk_window_get_type_hint "GdkWindowTypeHint gtk_window_get_type_hint(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_type_hint", "GtkWindow*");
  return(C_TO_XEN_GdkWindowTypeHint(gtk_window_get_type_hint(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_destroy_with_parent(XEN window, XEN setting)
{
  #define H_gtk_window_set_destroy_with_parent "void gtk_window_set_destroy_with_parent(GtkWindow* window, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_destroy_with_parent", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_destroy_with_parent", "gboolean");
  gtk_window_set_destroy_with_parent(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_destroy_with_parent(XEN window)
{
  #define H_gtk_window_get_destroy_with_parent "gboolean gtk_window_get_destroy_with_parent(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_destroy_with_parent", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_destroy_with_parent(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_resizable(XEN window, XEN resizable)
{
  #define H_gtk_window_set_resizable "void gtk_window_set_resizable(GtkWindow* window, gboolean resizable)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_resizable", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(resizable), resizable, 2, "gtk_window_set_resizable", "gboolean");
  gtk_window_set_resizable(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(resizable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_resizable(XEN window)
{
  #define H_gtk_window_get_resizable "gboolean gtk_window_get_resizable(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_resizable", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_resizable(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_gravity(XEN window, XEN gravity)
{
  #define H_gtk_window_set_gravity "void gtk_window_set_gravity(GtkWindow* window, GdkGravity gravity)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_gravity", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkGravity_P(gravity), gravity, 2, "gtk_window_set_gravity", "GdkGravity");
  gtk_window_set_gravity(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkGravity(gravity));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_gravity(XEN window)
{
  #define H_gtk_window_get_gravity "GdkGravity gtk_window_get_gravity(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_gravity", "GtkWindow*");
  return(C_TO_XEN_GdkGravity(gtk_window_get_gravity(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_geometry_hints(XEN window, XEN geometry_widget, XEN geometry, XEN geom_mask)
{
  #define H_gtk_window_set_geometry_hints "void gtk_window_set_geometry_hints(GtkWindow* window, GtkWidget* geometry_widget, \
GdkGeometry* geometry, GdkWindowHints geom_mask)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_geometry_hints", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(geometry_widget), geometry_widget, 2, "gtk_window_set_geometry_hints", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(geometry), geometry, 3, "gtk_window_set_geometry_hints", "GdkGeometry*");
  XEN_ASSERT_TYPE(XEN_GdkWindowHints_P(geom_mask), geom_mask, 4, "gtk_window_set_geometry_hints", "GdkWindowHints");
  gtk_window_set_geometry_hints(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GtkWidget_(geometry_widget), XEN_TO_C_GdkGeometry_(geometry), 
                                XEN_TO_C_GdkWindowHints(geom_mask));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_has_frame(XEN window, XEN setting)
{
  #define H_gtk_window_set_has_frame "void gtk_window_set_has_frame(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_has_frame", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_has_frame", "gboolean");
  gtk_window_set_has_frame(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_has_frame(XEN window)
{
  #define H_gtk_window_get_has_frame "gboolean gtk_window_get_has_frame(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_has_frame", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_has_frame(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_frame_dimensions(XEN window, XEN left, XEN top, XEN right, XEN bottom)
{
  #define H_gtk_window_set_frame_dimensions "void gtk_window_set_frame_dimensions(GtkWindow* window, \
gint left, gint top, gint right, gint bottom)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_frame_dimensions", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(left), left, 2, "gtk_window_set_frame_dimensions", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(top), top, 3, "gtk_window_set_frame_dimensions", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(right), right, 4, "gtk_window_set_frame_dimensions", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(bottom), bottom, 5, "gtk_window_set_frame_dimensions", "gint");
  gtk_window_set_frame_dimensions(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gint(left), XEN_TO_C_gint(top), XEN_TO_C_gint(right), 
                                  XEN_TO_C_gint(bottom));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_frame_dimensions(XEN window, XEN left, XEN top, XEN right, XEN bottom)
{
  #define H_gtk_window_get_frame_dimensions "void gtk_window_get_frame_dimensions(GtkWindow* window, \
gint* [left], gint* [top], gint* [right], gint* [bottom])"
  gint ref_left;
  gint ref_top;
  gint ref_right;
  gint ref_bottom;
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_frame_dimensions", "GtkWindow*");
  gtk_window_get_frame_dimensions(XEN_TO_C_GtkWindow_(window), &ref_left, &ref_top, &ref_right, &ref_bottom);
  return(XEN_LIST_4(C_TO_XEN_gint(ref_left), C_TO_XEN_gint(ref_top), C_TO_XEN_gint(ref_right), C_TO_XEN_gint(ref_bottom)));
}
static XEN gxg_gtk_window_set_decorated(XEN window, XEN setting)
{
  #define H_gtk_window_set_decorated "void gtk_window_set_decorated(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_decorated", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_decorated", "gboolean");
  gtk_window_set_decorated(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_decorated(XEN window)
{
  #define H_gtk_window_get_decorated "gboolean gtk_window_get_decorated(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_decorated", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_decorated(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_icon_list(XEN window, XEN list)
{
  #define H_gtk_window_set_icon_list "void gtk_window_set_icon_list(GtkWindow* window, GList* list)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_icon_list", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GList__P(list) || XEN_FALSE_P(list), list, 2, "gtk_window_set_icon_list", "GList*");
  gtk_window_set_icon_list(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GList_(list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_icon_list(XEN window)
{
  #define H_gtk_window_get_icon_list "GList* gtk_window_get_icon_list(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_icon_list", "GtkWindow*");
  return(C_TO_XEN_GList_(gtk_window_get_icon_list(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_icon(XEN window, XEN icon)
{
  #define H_gtk_window_set_icon "void gtk_window_set_icon(GtkWindow* window, GdkPixbuf* icon)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_icon", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(icon) || XEN_FALSE_P(icon), icon, 2, "gtk_window_set_icon", "GdkPixbuf*");
  gtk_window_set_icon(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkPixbuf_(icon));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_icon(XEN window)
{
  #define H_gtk_window_get_icon "GdkPixbuf* gtk_window_get_icon(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_icon", "GtkWindow*");
  return(C_TO_XEN_GdkPixbuf_(gtk_window_get_icon(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_default_icon_list(XEN list)
{
  #define H_gtk_window_set_default_icon_list "void gtk_window_set_default_icon_list(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list) || XEN_FALSE_P(list), list, 1, "gtk_window_set_default_icon_list", "GList*");
  gtk_window_set_default_icon_list(XEN_TO_C_GList_(list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_default_icon_list(void)
{
  #define H_gtk_window_get_default_icon_list "GList* gtk_window_get_default_icon_list( void)"
  return(C_TO_XEN_GList_(gtk_window_get_default_icon_list()));
}
static XEN gxg_gtk_window_set_modal(XEN window, XEN modal)
{
  #define H_gtk_window_set_modal "void gtk_window_set_modal(GtkWindow* window, gboolean modal)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_modal", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(modal), modal, 2, "gtk_window_set_modal", "gboolean");
  gtk_window_set_modal(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(modal));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_modal(XEN window)
{
  #define H_gtk_window_get_modal "gboolean gtk_window_get_modal(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_modal", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_modal(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_list_toplevels(void)
{
  #define H_gtk_window_list_toplevels "GList* gtk_window_list_toplevels( void)"
  return(C_TO_XEN_GList_(gtk_window_list_toplevels()));
}
static XEN gxg_gtk_window_add_mnemonic(XEN window, XEN keyval, XEN target)
{
  #define H_gtk_window_add_mnemonic "void gtk_window_add_mnemonic(GtkWindow* window, guint keyval, GtkWidget* target)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_add_mnemonic", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_window_add_mnemonic", "guint");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(target), target, 3, "gtk_window_add_mnemonic", "GtkWidget*");
  gtk_window_add_mnemonic(XEN_TO_C_GtkWindow_(window), XEN_TO_C_guint(keyval), XEN_TO_C_GtkWidget_(target));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_remove_mnemonic(XEN window, XEN keyval, XEN target)
{
  #define H_gtk_window_remove_mnemonic "void gtk_window_remove_mnemonic(GtkWindow* window, guint keyval, \
GtkWidget* target)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_remove_mnemonic", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_window_remove_mnemonic", "guint");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(target), target, 3, "gtk_window_remove_mnemonic", "GtkWidget*");
  gtk_window_remove_mnemonic(XEN_TO_C_GtkWindow_(window), XEN_TO_C_guint(keyval), XEN_TO_C_GtkWidget_(target));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_mnemonic_activate(XEN window, XEN keyval, XEN modifier)
{
  #define H_gtk_window_mnemonic_activate "gboolean gtk_window_mnemonic_activate(GtkWindow* window, guint keyval, \
GdkModifierType modifier)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_mnemonic_activate", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_guint_P(keyval), keyval, 2, "gtk_window_mnemonic_activate", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifier), modifier, 3, "gtk_window_mnemonic_activate", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_window_mnemonic_activate(XEN_TO_C_GtkWindow_(window), XEN_TO_C_guint(keyval), XEN_TO_C_GdkModifierType(modifier))));
}
static XEN gxg_gtk_window_set_mnemonic_modifier(XEN window, XEN modifier)
{
  #define H_gtk_window_set_mnemonic_modifier "void gtk_window_set_mnemonic_modifier(GtkWindow* window, \
GdkModifierType modifier)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_mnemonic_modifier", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(modifier), modifier, 2, "gtk_window_set_mnemonic_modifier", "GdkModifierType");
  gtk_window_set_mnemonic_modifier(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkModifierType(modifier));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_mnemonic_modifier(XEN window)
{
  #define H_gtk_window_get_mnemonic_modifier "GdkModifierType gtk_window_get_mnemonic_modifier(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_mnemonic_modifier", "GtkWindow*");
  return(C_TO_XEN_GdkModifierType(gtk_window_get_mnemonic_modifier(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_present(XEN window)
{
  #define H_gtk_window_present "void gtk_window_present(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_present", "GtkWindow*");
  gtk_window_present(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_iconify(XEN window)
{
  #define H_gtk_window_iconify "void gtk_window_iconify(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_iconify", "GtkWindow*");
  gtk_window_iconify(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_deiconify(XEN window)
{
  #define H_gtk_window_deiconify "void gtk_window_deiconify(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_deiconify", "GtkWindow*");
  gtk_window_deiconify(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_stick(XEN window)
{
  #define H_gtk_window_stick "void gtk_window_stick(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_stick", "GtkWindow*");
  gtk_window_stick(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_unstick(XEN window)
{
  #define H_gtk_window_unstick "void gtk_window_unstick(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_unstick", "GtkWindow*");
  gtk_window_unstick(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_maximize(XEN window)
{
  #define H_gtk_window_maximize "void gtk_window_maximize(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_maximize", "GtkWindow*");
  gtk_window_maximize(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_unmaximize(XEN window)
{
  #define H_gtk_window_unmaximize "void gtk_window_unmaximize(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_unmaximize", "GtkWindow*");
  gtk_window_unmaximize(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_begin_resize_drag(XEN window, XEN edge, XEN button, XEN root_x, XEN root_y, XEN timestamp)
{
  #define H_gtk_window_begin_resize_drag "void gtk_window_begin_resize_drag(GtkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_begin_resize_drag", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkWindowEdge_P(edge), edge, 2, "gtk_window_begin_resize_drag", "GdkWindowEdge");
  XEN_ASSERT_TYPE(XEN_gint_P(button), button, 3, "gtk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_x), root_x, 4, "gtk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_y), root_y, 5, "gtk_window_begin_resize_drag", "gint");
  XEN_ASSERT_TYPE(XEN_guint32_P(timestamp), timestamp, 6, "gtk_window_begin_resize_drag", "guint32");
  gtk_window_begin_resize_drag(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkWindowEdge(edge), XEN_TO_C_gint(button), XEN_TO_C_gint(root_x), 
                               XEN_TO_C_gint(root_y), XEN_TO_C_guint32(timestamp));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_begin_move_drag(XEN window, XEN button, XEN root_x, XEN root_y, XEN timestamp)
{
  #define H_gtk_window_begin_move_drag "void gtk_window_begin_move_drag(GtkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_begin_move_drag", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(button), button, 2, "gtk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_x), root_x, 3, "gtk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(root_y), root_y, 4, "gtk_window_begin_move_drag", "gint");
  XEN_ASSERT_TYPE(XEN_guint32_P(timestamp), timestamp, 5, "gtk_window_begin_move_drag", "guint32");
  gtk_window_begin_move_drag(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gint(button), XEN_TO_C_gint(root_x), XEN_TO_C_gint(root_y), 
                             XEN_TO_C_guint32(timestamp));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_default_size(XEN window, XEN width, XEN height)
{
  #define H_gtk_window_set_default_size "void gtk_window_set_default_size(GtkWindow* window, gint width, \
gint height)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_default_size", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_window_set_default_size", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gtk_window_set_default_size", "gint");
  gtk_window_set_default_size(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_default_size(XEN window, XEN width, XEN height)
{
  #define H_gtk_window_get_default_size "void gtk_window_get_default_size(GtkWindow* window, gint* [width], \
gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_default_size", "GtkWindow*");
  gtk_window_get_default_size(XEN_TO_C_GtkWindow_(window), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_window_resize(XEN window, XEN width, XEN height)
{
  #define H_gtk_window_resize "void gtk_window_resize(GtkWindow* window, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_resize", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_window_resize", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gtk_window_resize", "gint");
  gtk_window_resize(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gint(width), XEN_TO_C_gint(height));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_size(XEN window, XEN width, XEN height)
{
  #define H_gtk_window_get_size "void gtk_window_get_size(GtkWindow* window, gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_size", "GtkWindow*");
  gtk_window_get_size(XEN_TO_C_GtkWindow_(window), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_width), C_TO_XEN_gint(ref_height)));
}
static XEN gxg_gtk_window_move(XEN window, XEN x, XEN y)
{
  #define H_gtk_window_move "void gtk_window_move(GtkWindow* window, gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_move", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gtk_window_move", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_window_move", "gint");
  gtk_window_move(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gint(x), XEN_TO_C_gint(y));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_position(XEN window, XEN root_x, XEN root_y)
{
  #define H_gtk_window_get_position "void gtk_window_get_position(GtkWindow* window, gint* [root_x], \
gint* [root_y])"
  gint ref_root_x;
  gint ref_root_y;
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_position", "GtkWindow*");
  gtk_window_get_position(XEN_TO_C_GtkWindow_(window), &ref_root_x, &ref_root_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_root_x), C_TO_XEN_gint(ref_root_y)));
}
static XEN gxg_gtk_window_parse_geometry(XEN window, XEN geometry)
{
  #define H_gtk_window_parse_geometry "gboolean gtk_window_parse_geometry(GtkWindow* window, gchar* geometry)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_parse_geometry", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(geometry), geometry, 2, "gtk_window_parse_geometry", "gchar*");
  return(C_TO_XEN_gboolean(gtk_window_parse_geometry(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gchar_(geometry))));
}
static XEN gxg_gtk_window_reshow_with_initial_size(XEN window)
{
  #define H_gtk_window_reshow_with_initial_size "void gtk_window_reshow_with_initial_size(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_reshow_with_initial_size", "GtkWindow*");
  gtk_window_reshow_with_initial_size(XEN_TO_C_GtkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_group_get_type(void)
{
  #define H_gtk_window_group_get_type "GType gtk_window_group_get_type( void)"
  return(C_TO_XEN_GType(gtk_window_group_get_type()));
}
static XEN gxg_pango_color_get_type(void)
{
  #define H_pango_color_get_type "GType pango_color_get_type( void)"
  return(C_TO_XEN_GType(pango_color_get_type()));
}
static XEN gxg_pango_color_copy(XEN src)
{
  #define H_pango_color_copy "PangoColor* pango_color_copy(PangoColor* src)"
  XEN_ASSERT_TYPE(XEN_PangoColor__P(src), src, 1, "pango_color_copy", "PangoColor*");
  return(C_TO_XEN_PangoColor_(pango_color_copy(XEN_TO_C_PangoColor_(src))));
}
static XEN gxg_pango_color_free(XEN color)
{
  #define H_pango_color_free "void pango_color_free(PangoColor* color)"
  XEN_ASSERT_TYPE(XEN_PangoColor__P(color), color, 1, "pango_color_free", "PangoColor*");
  pango_color_free(XEN_TO_C_PangoColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_pango_color_parse(XEN color, XEN spec)
{
  #define H_pango_color_parse "gboolean pango_color_parse(PangoColor* color, char* spec)"
  XEN_ASSERT_TYPE(XEN_PangoColor__P(color), color, 1, "pango_color_parse", "PangoColor*");
  XEN_ASSERT_TYPE(XEN_char__P(spec), spec, 2, "pango_color_parse", "char*");
  return(C_TO_XEN_gboolean(pango_color_parse(XEN_TO_C_PangoColor_(color), XEN_TO_C_char_(spec))));
}
static XEN gxg_pango_attr_type_register(XEN name)
{
  #define H_pango_attr_type_register "PangoAttrType pango_attr_type_register(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "pango_attr_type_register", "gchar*");
  return(C_TO_XEN_PangoAttrType(pango_attr_type_register(XEN_TO_C_gchar_(name))));
}
static XEN gxg_pango_attribute_copy(XEN attr)
{
  #define H_pango_attribute_copy "PangoAttribute* pango_attribute_copy(PangoAttribute* attr)"
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr), attr, 1, "pango_attribute_copy", "PangoAttribute*");
  return(C_TO_XEN_PangoAttribute_(pango_attribute_copy(XEN_TO_C_PangoAttribute_(attr))));
}
static XEN gxg_pango_attribute_destroy(XEN attr)
{
  #define H_pango_attribute_destroy "void pango_attribute_destroy(PangoAttribute* attr)"
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr), attr, 1, "pango_attribute_destroy", "PangoAttribute*");
  pango_attribute_destroy(XEN_TO_C_PangoAttribute_(attr));
  return(XEN_FALSE);
}
static XEN gxg_pango_attribute_equal(XEN attr1, XEN attr2)
{
  #define H_pango_attribute_equal "gboolean pango_attribute_equal(PangoAttribute* attr1, PangoAttribute* attr2)"
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr1), attr1, 1, "pango_attribute_equal", "PangoAttribute*");
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr2), attr2, 2, "pango_attribute_equal", "PangoAttribute*");
  return(C_TO_XEN_gboolean(pango_attribute_equal(XEN_TO_C_PangoAttribute_(attr1), XEN_TO_C_PangoAttribute_(attr2))));
}
static XEN gxg_pango_attr_language_new(XEN language)
{
  #define H_pango_attr_language_new "PangoAttribute* pango_attr_language_new(PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 1, "pango_attr_language_new", "PangoLanguage*");
  return(C_TO_XEN_PangoAttribute_(pango_attr_language_new(XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_attr_family_new(XEN family)
{
  #define H_pango_attr_family_new "PangoAttribute* pango_attr_family_new(char* family)"
  XEN_ASSERT_TYPE(XEN_char__P(family), family, 1, "pango_attr_family_new", "char*");
  return(C_TO_XEN_PangoAttribute_(pango_attr_family_new(XEN_TO_C_char_(family))));
}
static XEN gxg_pango_attr_foreground_new(XEN red, XEN green, XEN blue)
{
  #define H_pango_attr_foreground_new "PangoAttribute* pango_attr_foreground_new(guint16 red, guint16 green, \
guint16 blue)"
  XEN_ASSERT_TYPE(XEN_guint16_P(red), red, 1, "pango_attr_foreground_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(green), green, 2, "pango_attr_foreground_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(blue), blue, 3, "pango_attr_foreground_new", "guint16");
  return(C_TO_XEN_PangoAttribute_(pango_attr_foreground_new(XEN_TO_C_guint16(red), XEN_TO_C_guint16(green), XEN_TO_C_guint16(blue))));
}
static XEN gxg_pango_attr_background_new(XEN red, XEN green, XEN blue)
{
  #define H_pango_attr_background_new "PangoAttribute* pango_attr_background_new(guint16 red, guint16 green, \
guint16 blue)"
  XEN_ASSERT_TYPE(XEN_guint16_P(red), red, 1, "pango_attr_background_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(green), green, 2, "pango_attr_background_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(blue), blue, 3, "pango_attr_background_new", "guint16");
  return(C_TO_XEN_PangoAttribute_(pango_attr_background_new(XEN_TO_C_guint16(red), XEN_TO_C_guint16(green), XEN_TO_C_guint16(blue))));
}
static XEN gxg_pango_attr_size_new(XEN size)
{
  #define H_pango_attr_size_new "PangoAttribute* pango_attr_size_new(int size)"
  XEN_ASSERT_TYPE(XEN_int_P(size), size, 1, "pango_attr_size_new", "int");
  return(C_TO_XEN_PangoAttribute_(pango_attr_size_new(XEN_TO_C_int(size))));
}
static XEN gxg_pango_attr_style_new(XEN style)
{
  #define H_pango_attr_style_new "PangoAttribute* pango_attr_style_new(PangoStyle style)"
  XEN_ASSERT_TYPE(XEN_PangoStyle_P(style), style, 1, "pango_attr_style_new", "PangoStyle");
  return(C_TO_XEN_PangoAttribute_(pango_attr_style_new(XEN_TO_C_PangoStyle(style))));
}
static XEN gxg_pango_attr_weight_new(XEN weight)
{
  #define H_pango_attr_weight_new "PangoAttribute* pango_attr_weight_new(PangoWeight weight)"
  XEN_ASSERT_TYPE(XEN_PangoWeight_P(weight), weight, 1, "pango_attr_weight_new", "PangoWeight");
  return(C_TO_XEN_PangoAttribute_(pango_attr_weight_new(XEN_TO_C_PangoWeight(weight))));
}
static XEN gxg_pango_attr_variant_new(XEN variant)
{
  #define H_pango_attr_variant_new "PangoAttribute* pango_attr_variant_new(PangoVariant variant)"
  XEN_ASSERT_TYPE(XEN_PangoVariant_P(variant), variant, 1, "pango_attr_variant_new", "PangoVariant");
  return(C_TO_XEN_PangoAttribute_(pango_attr_variant_new(XEN_TO_C_PangoVariant(variant))));
}
static XEN gxg_pango_attr_stretch_new(XEN stretch)
{
  #define H_pango_attr_stretch_new "PangoAttribute* pango_attr_stretch_new(PangoStretch stretch)"
  XEN_ASSERT_TYPE(XEN_PangoStretch_P(stretch), stretch, 1, "pango_attr_stretch_new", "PangoStretch");
  return(C_TO_XEN_PangoAttribute_(pango_attr_stretch_new(XEN_TO_C_PangoStretch(stretch))));
}
static XEN gxg_pango_attr_font_desc_new(XEN desc)
{
  #define H_pango_attr_font_desc_new "PangoAttribute* pango_attr_font_desc_new(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_attr_font_desc_new", "PangoFontDescription*");
  return(C_TO_XEN_PangoAttribute_(pango_attr_font_desc_new(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_attr_underline_new(XEN underline)
{
  #define H_pango_attr_underline_new "PangoAttribute* pango_attr_underline_new(PangoUnderline underline)"
  XEN_ASSERT_TYPE(XEN_PangoUnderline_P(underline), underline, 1, "pango_attr_underline_new", "PangoUnderline");
  return(C_TO_XEN_PangoAttribute_(pango_attr_underline_new(XEN_TO_C_PangoUnderline(underline))));
}
static XEN gxg_pango_attr_strikethrough_new(XEN strikethrough)
{
  #define H_pango_attr_strikethrough_new "PangoAttribute* pango_attr_strikethrough_new(gboolean strikethrough)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(strikethrough), strikethrough, 1, "pango_attr_strikethrough_new", "gboolean");
  return(C_TO_XEN_PangoAttribute_(pango_attr_strikethrough_new(XEN_TO_C_gboolean(strikethrough))));
}
static XEN gxg_pango_attr_rise_new(XEN rise)
{
  #define H_pango_attr_rise_new "PangoAttribute* pango_attr_rise_new(int rise)"
  XEN_ASSERT_TYPE(XEN_int_P(rise), rise, 1, "pango_attr_rise_new", "int");
  return(C_TO_XEN_PangoAttribute_(pango_attr_rise_new(XEN_TO_C_int(rise))));
}
static XEN gxg_pango_attr_shape_new(XEN ink_rect, XEN logical_rect)
{
  #define H_pango_attr_shape_new "PangoAttribute* pango_attr_shape_new(PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 1, "pango_attr_shape_new", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 2, "pango_attr_shape_new", "PangoRectangle*");
  return(C_TO_XEN_PangoAttribute_(pango_attr_shape_new(XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect))));
}
static XEN gxg_pango_attr_scale_new(XEN scale_factor)
{
  #define H_pango_attr_scale_new "PangoAttribute* pango_attr_scale_new(double scale_factor)"
  XEN_ASSERT_TYPE(XEN_double_P(scale_factor), scale_factor, 1, "pango_attr_scale_new", "double");
  return(C_TO_XEN_PangoAttribute_(pango_attr_scale_new(XEN_TO_C_double(scale_factor))));
}
static XEN gxg_pango_attr_list_get_type(void)
{
  #define H_pango_attr_list_get_type "GType pango_attr_list_get_type( void)"
  return(C_TO_XEN_GType(pango_attr_list_get_type()));
}
static XEN gxg_pango_attr_list_new(void)
{
  #define H_pango_attr_list_new "PangoAttrList* pango_attr_list_new( void)"
  return(C_TO_XEN_PangoAttrList_(pango_attr_list_new()));
}
static XEN gxg_pango_attr_list_ref(XEN list)
{
  #define H_pango_attr_list_ref "void pango_attr_list_ref(PangoAttrList* list)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_ref", "PangoAttrList*");
  pango_attr_list_ref(XEN_TO_C_PangoAttrList_(list));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_unref(XEN list)
{
  #define H_pango_attr_list_unref "void pango_attr_list_unref(PangoAttrList* list)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_unref", "PangoAttrList*");
  pango_attr_list_unref(XEN_TO_C_PangoAttrList_(list));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_copy(XEN list)
{
  #define H_pango_attr_list_copy "PangoAttrList* pango_attr_list_copy(PangoAttrList* list)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_copy", "PangoAttrList*");
  return(C_TO_XEN_PangoAttrList_(pango_attr_list_copy(XEN_TO_C_PangoAttrList_(list))));
}
static XEN gxg_pango_attr_list_insert(XEN list, XEN attr)
{
  #define H_pango_attr_list_insert "void pango_attr_list_insert(PangoAttrList* list, PangoAttribute* attr)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_insert", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr), attr, 2, "pango_attr_list_insert", "PangoAttribute*");
  pango_attr_list_insert(XEN_TO_C_PangoAttrList_(list), XEN_TO_C_PangoAttribute_(attr));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_insert_before(XEN list, XEN attr)
{
  #define H_pango_attr_list_insert_before "void pango_attr_list_insert_before(PangoAttrList* list, PangoAttribute* attr)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_insert_before", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr), attr, 2, "pango_attr_list_insert_before", "PangoAttribute*");
  pango_attr_list_insert_before(XEN_TO_C_PangoAttrList_(list), XEN_TO_C_PangoAttribute_(attr));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_change(XEN list, XEN attr)
{
  #define H_pango_attr_list_change "void pango_attr_list_change(PangoAttrList* list, PangoAttribute* attr)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_change", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttribute__P(attr), attr, 2, "pango_attr_list_change", "PangoAttribute*");
  pango_attr_list_change(XEN_TO_C_PangoAttrList_(list), XEN_TO_C_PangoAttribute_(attr));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_splice(XEN list, XEN other, XEN pos, XEN len)
{
  #define H_pango_attr_list_splice "void pango_attr_list_splice(PangoAttrList* list, PangoAttrList* other, \
gint pos, gint len)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_splice", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(other), other, 2, "pango_attr_list_splice", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_gint_P(pos), pos, 3, "pango_attr_list_splice", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(len), len, 4, "pango_attr_list_splice", "gint");
  pango_attr_list_splice(XEN_TO_C_PangoAttrList_(list), XEN_TO_C_PangoAttrList_(other), XEN_TO_C_gint(pos), XEN_TO_C_gint(len));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_list_get_iterator(XEN list)
{
  #define H_pango_attr_list_get_iterator "PangoAttrIterator* pango_attr_list_get_iterator(PangoAttrList* list)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_get_iterator", "PangoAttrList*");
  return(C_TO_XEN_PangoAttrIterator_(pango_attr_list_get_iterator(XEN_TO_C_PangoAttrList_(list))));
}
static XEN gxg_pango_attr_iterator_range(XEN iterator, XEN start, XEN end)
{
  #define H_pango_attr_iterator_range "void pango_attr_iterator_range(PangoAttrIterator* iterator, gint* [start], \
gint* [end])"
  gint ref_start;
  gint ref_end;
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_range", "PangoAttrIterator*");
  pango_attr_iterator_range(XEN_TO_C_PangoAttrIterator_(iterator), &ref_start, &ref_end);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_start), C_TO_XEN_gint(ref_end)));
}
static XEN gxg_pango_attr_iterator_next(XEN iterator)
{
  #define H_pango_attr_iterator_next "gboolean pango_attr_iterator_next(PangoAttrIterator* iterator)"
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_next", "PangoAttrIterator*");
  return(C_TO_XEN_gboolean(pango_attr_iterator_next(XEN_TO_C_PangoAttrIterator_(iterator))));
}
static XEN gxg_pango_attr_iterator_copy(XEN iterator)
{
  #define H_pango_attr_iterator_copy "PangoAttrIterator* pango_attr_iterator_copy(PangoAttrIterator* iterator)"
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_copy", "PangoAttrIterator*");
  return(C_TO_XEN_PangoAttrIterator_(pango_attr_iterator_copy(XEN_TO_C_PangoAttrIterator_(iterator))));
}
static XEN gxg_pango_attr_iterator_destroy(XEN iterator)
{
  #define H_pango_attr_iterator_destroy "void pango_attr_iterator_destroy(PangoAttrIterator* iterator)"
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_destroy", "PangoAttrIterator*");
  pango_attr_iterator_destroy(XEN_TO_C_PangoAttrIterator_(iterator));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_iterator_get(XEN iterator, XEN type)
{
  #define H_pango_attr_iterator_get "PangoAttribute* pango_attr_iterator_get(PangoAttrIterator* iterator, \
PangoAttrType type)"
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_get", "PangoAttrIterator*");
  XEN_ASSERT_TYPE(XEN_PangoAttrType_P(type), type, 2, "pango_attr_iterator_get", "PangoAttrType");
  return(C_TO_XEN_PangoAttribute_(pango_attr_iterator_get(XEN_TO_C_PangoAttrIterator_(iterator), XEN_TO_C_PangoAttrType(type))));
}
static XEN gxg_pango_attr_iterator_get_font(XEN iterator, XEN desc, XEN language, XEN extra_attrs)
{
  #define H_pango_attr_iterator_get_font "void pango_attr_iterator_get_font(PangoAttrIterator* iterator, \
PangoFontDescription* desc, PangoLanguage** [language], GSList** [extra_attrs])"
  PangoLanguage* ref_language = NULL;
  GSList* ref_extra_attrs = NULL;
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_get_font", "PangoAttrIterator*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_attr_iterator_get_font", "PangoFontDescription*");
  pango_attr_iterator_get_font(XEN_TO_C_PangoAttrIterator_(iterator), XEN_TO_C_PangoFontDescription_(desc), &ref_language, 
                               &ref_extra_attrs);
  return(XEN_LIST_2(C_TO_XEN_PangoLanguage_(ref_language), C_TO_XEN_GSList_(ref_extra_attrs)));
}
static XEN gxg_pango_parse_markup(XEN markup_text, XEN length, XEN accel_marker, XEN attr_list, XEN text, XEN accel_char, XEN error)
{
  #define H_pango_parse_markup "gboolean pango_parse_markup(char* markup_text, int length, gunichar accel_marker, \
PangoAttrList** attr_list, char** text, gunichar* accel_char, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_char__P(markup_text), markup_text, 1, "pango_parse_markup", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 2, "pango_parse_markup", "int");
  XEN_ASSERT_TYPE(XEN_gunichar_P(accel_marker), accel_marker, 3, "pango_parse_markup", "gunichar");
  XEN_ASSERT_TYPE(XEN_PangoAttrList___P(attr_list), attr_list, 4, "pango_parse_markup", "PangoAttrList**");
  XEN_ASSERT_TYPE(XEN_char___P(text), text, 5, "pango_parse_markup", "char**");
  XEN_ASSERT_TYPE(XEN_gunichar__P(accel_char), accel_char, 6, "pango_parse_markup", "gunichar*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(pango_parse_markup(XEN_TO_C_char_(markup_text), XEN_TO_C_int(length), XEN_TO_C_gunichar(accel_marker), 
                                                  XEN_TO_C_PangoAttrList__(attr_list), XEN_TO_C_char__(text), XEN_TO_C_gunichar_(accel_char), 
                                                  &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_pango_break(XEN text, XEN length, XEN analysis, XEN attrs, XEN attrs_len)
{
  #define H_pango_break "void pango_break(gchar* text, int length, PangoAnalysis* analysis, PangoLogAttr* attrs, \
int attrs_len)"
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 1, "pango_break", "gchar*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 2, "pango_break", "int");
  XEN_ASSERT_TYPE(XEN_PangoAnalysis__P(analysis), analysis, 3, "pango_break", "PangoAnalysis*");
  XEN_ASSERT_TYPE(XEN_PangoLogAttr__P(attrs), attrs, 4, "pango_break", "PangoLogAttr*");
  XEN_ASSERT_TYPE(XEN_int_P(attrs_len), attrs_len, 5, "pango_break", "int");
  pango_break(XEN_TO_C_gchar_(text), XEN_TO_C_int(length), XEN_TO_C_PangoAnalysis_(analysis), XEN_TO_C_PangoLogAttr_(attrs), 
              XEN_TO_C_int(attrs_len));
  return(XEN_FALSE);
}
static XEN gxg_pango_find_paragraph_boundary(XEN text, XEN length, XEN paragraph_delimiter_index, XEN next_paragraph_start)
{
  #define H_pango_find_paragraph_boundary "void pango_find_paragraph_boundary(gchar* text, gint length, \
gint* [paragraph_delimiter_index], gint* [next_paragraph_start])"
  gint ref_paragraph_delimiter_index;
  gint ref_next_paragraph_start;
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 1, "pango_find_paragraph_boundary", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(length), length, 2, "pango_find_paragraph_boundary", "gint");
  pango_find_paragraph_boundary(XEN_TO_C_gchar_(text), XEN_TO_C_gint(length), &ref_paragraph_delimiter_index, &ref_next_paragraph_start);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_paragraph_delimiter_index), C_TO_XEN_gint(ref_next_paragraph_start)));
}
static XEN gxg_pango_get_log_attrs(XEN text, XEN length, XEN level, XEN language, XEN log_attrs, XEN attrs_len)
{
  #define H_pango_get_log_attrs "void pango_get_log_attrs(char* text, int length, int level, PangoLanguage* language, \
PangoLogAttr* log_attrs, int attrs_len)"
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 1, "pango_get_log_attrs", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 2, "pango_get_log_attrs", "int");
  XEN_ASSERT_TYPE(XEN_int_P(level), level, 3, "pango_get_log_attrs", "int");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 4, "pango_get_log_attrs", "PangoLanguage*");
  XEN_ASSERT_TYPE(XEN_PangoLogAttr__P(log_attrs), log_attrs, 5, "pango_get_log_attrs", "PangoLogAttr*");
  XEN_ASSERT_TYPE(XEN_int_P(attrs_len), attrs_len, 6, "pango_get_log_attrs", "int");
  pango_get_log_attrs(XEN_TO_C_char_(text), XEN_TO_C_int(length), XEN_TO_C_int(level), XEN_TO_C_PangoLanguage_(language), 
                      XEN_TO_C_PangoLogAttr_(log_attrs), XEN_TO_C_int(attrs_len));
  return(XEN_FALSE);
}
static XEN gxg_pango_context_get_type(void)
{
  #define H_pango_context_get_type "GType pango_context_get_type( void)"
  return(C_TO_XEN_GType(pango_context_get_type()));
}
static XEN gxg_pango_context_list_families(XEN context, XEN families, XEN n_families)
{
  #define H_pango_context_list_families "void pango_context_list_families(PangoContext* context, PangoFontFamily*** [families], \
int* [n_families])"
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_list_families", "PangoContext*");
  pango_context_list_families(XEN_TO_C_PangoContext_(context), &ref_families, &ref_n_families);
  return(XEN_LIST_2(C_TO_XEN_PangoFontFamily__(ref_families), C_TO_XEN_int(ref_n_families)));
}
static XEN gxg_pango_context_load_font(XEN context, XEN desc)
{
  #define H_pango_context_load_font "PangoFont* pango_context_load_font(PangoContext* context, PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_load_font", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_context_load_font", "PangoFontDescription*");
  return(C_TO_XEN_PangoFont_(pango_context_load_font(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_context_load_fontset(XEN context, XEN desc, XEN language)
{
  #define H_pango_context_load_fontset "PangoFontset* pango_context_load_fontset(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_load_fontset", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_context_load_fontset", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 3, "pango_context_load_fontset", "PangoLanguage*");
  return(C_TO_XEN_PangoFontset_(pango_context_load_fontset(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoFontDescription_(desc), 
                                                           XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_context_get_metrics(XEN context, XEN desc, XEN language)
{
  #define H_pango_context_get_metrics "PangoFontMetrics* pango_context_get_metrics(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_get_metrics", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_context_get_metrics", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 3, "pango_context_get_metrics", "PangoLanguage*");
  return(C_TO_XEN_PangoFontMetrics_(pango_context_get_metrics(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoFontDescription_(desc), 
                                                              XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_context_set_font_description(XEN context, XEN desc)
{
  #define H_pango_context_set_font_description "void pango_context_set_font_description(PangoContext* context, \
PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_set_font_description", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_context_set_font_description", "PangoFontDescription*");
  pango_context_set_font_description(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoFontDescription_(desc));
  return(XEN_FALSE);
}
static XEN gxg_pango_context_get_font_description(XEN context)
{
  #define H_pango_context_get_font_description "PangoFontDescription* pango_context_get_font_description(PangoContext* context)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_get_font_description", "PangoContext*");
  return(C_TO_XEN_PangoFontDescription_(pango_context_get_font_description(XEN_TO_C_PangoContext_(context))));
}
static XEN gxg_pango_context_get_language(XEN context)
{
  #define H_pango_context_get_language "PangoLanguage* pango_context_get_language(PangoContext* context)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_get_language", "PangoContext*");
  return(C_TO_XEN_PangoLanguage_(pango_context_get_language(XEN_TO_C_PangoContext_(context))));
}
static XEN gxg_pango_context_set_language(XEN context, XEN language)
{
  #define H_pango_context_set_language "void pango_context_set_language(PangoContext* context, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_set_language", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 2, "pango_context_set_language", "PangoLanguage*");
  pango_context_set_language(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoLanguage_(language));
  return(XEN_FALSE);
}
static XEN gxg_pango_context_set_base_dir(XEN context, XEN direction)
{
  #define H_pango_context_set_base_dir "void pango_context_set_base_dir(PangoContext* context, PangoDirection direction)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_set_base_dir", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoDirection_P(direction), direction, 2, "pango_context_set_base_dir", "PangoDirection");
  pango_context_set_base_dir(XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoDirection(direction));
  return(XEN_FALSE);
}
static XEN gxg_pango_context_get_base_dir(XEN context)
{
  #define H_pango_context_get_base_dir "PangoDirection pango_context_get_base_dir(PangoContext* context)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_context_get_base_dir", "PangoContext*");
  return(C_TO_XEN_PangoDirection(pango_context_get_base_dir(XEN_TO_C_PangoContext_(context))));
}
static XEN gxg_pango_itemize(XEN context, XEN text, XEN start_index, XEN length, XEN attrs, XEN cached_iter)
{
  #define H_pango_itemize "GList* pango_itemize(PangoContext* context, char* text, int start_index, int length, \
PangoAttrList* attrs, PangoAttrIterator* cached_iter)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_itemize", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 2, "pango_itemize", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(start_index), start_index, 3, "pango_itemize", "int");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 4, "pango_itemize", "int");
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(attrs), attrs, 5, "pango_itemize", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(cached_iter), cached_iter, 6, "pango_itemize", "PangoAttrIterator*");
  return(C_TO_XEN_GList_(pango_itemize(XEN_TO_C_PangoContext_(context), XEN_TO_C_char_(text), XEN_TO_C_int(start_index), 
                                       XEN_TO_C_int(length), XEN_TO_C_PangoAttrList_(attrs), XEN_TO_C_PangoAttrIterator_(cached_iter))));
}
static XEN gxg_pango_coverage_new(void)
{
  #define H_pango_coverage_new "PangoCoverage* pango_coverage_new( void)"
  return(C_TO_XEN_PangoCoverage_(pango_coverage_new()));
}
static XEN gxg_pango_coverage_ref(XEN coverage)
{
  #define H_pango_coverage_ref "PangoCoverage* pango_coverage_ref(PangoCoverage* coverage)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_ref", "PangoCoverage*");
  return(C_TO_XEN_PangoCoverage_(pango_coverage_ref(XEN_TO_C_PangoCoverage_(coverage))));
}
static XEN gxg_pango_coverage_unref(XEN coverage)
{
  #define H_pango_coverage_unref "void pango_coverage_unref(PangoCoverage* coverage)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_unref", "PangoCoverage*");
  pango_coverage_unref(XEN_TO_C_PangoCoverage_(coverage));
  return(XEN_FALSE);
}
static XEN gxg_pango_coverage_copy(XEN coverage)
{
  #define H_pango_coverage_copy "PangoCoverage* pango_coverage_copy(PangoCoverage* coverage)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_copy", "PangoCoverage*");
  return(C_TO_XEN_PangoCoverage_(pango_coverage_copy(XEN_TO_C_PangoCoverage_(coverage))));
}
static XEN gxg_pango_coverage_get(XEN coverage, XEN index)
{
  #define H_pango_coverage_get "PangoCoverageLevel pango_coverage_get(PangoCoverage* coverage, int index)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_get", "PangoCoverage*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 2, "pango_coverage_get", "int");
  return(C_TO_XEN_PangoCoverageLevel(pango_coverage_get(XEN_TO_C_PangoCoverage_(coverage), XEN_TO_C_int(index))));
}
static XEN gxg_pango_coverage_set(XEN coverage, XEN index, XEN level)
{
  #define H_pango_coverage_set "void pango_coverage_set(PangoCoverage* coverage, int index, PangoCoverageLevel level)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_set", "PangoCoverage*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 2, "pango_coverage_set", "int");
  XEN_ASSERT_TYPE(XEN_PangoCoverageLevel_P(level), level, 3, "pango_coverage_set", "PangoCoverageLevel");
  pango_coverage_set(XEN_TO_C_PangoCoverage_(coverage), XEN_TO_C_int(index), XEN_TO_C_PangoCoverageLevel(level));
  return(XEN_FALSE);
}
static XEN gxg_pango_coverage_max(XEN coverage, XEN other)
{
  #define H_pango_coverage_max "void pango_coverage_max(PangoCoverage* coverage, PangoCoverage* other)"
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_max", "PangoCoverage*");
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(other), other, 2, "pango_coverage_max", "PangoCoverage*");
  pango_coverage_max(XEN_TO_C_PangoCoverage_(coverage), XEN_TO_C_PangoCoverage_(other));
  return(XEN_FALSE);
}
static XEN gxg_pango_coverage_to_bytes(XEN coverage, XEN bytes, XEN n_bytes)
{
  #define H_pango_coverage_to_bytes "void pango_coverage_to_bytes(PangoCoverage* coverage, guchar** [bytes], \
int* [n_bytes])"
  guchar* ref_bytes = NULL;
  int ref_n_bytes;
  XEN_ASSERT_TYPE(XEN_PangoCoverage__P(coverage), coverage, 1, "pango_coverage_to_bytes", "PangoCoverage*");
  pango_coverage_to_bytes(XEN_TO_C_PangoCoverage_(coverage), &ref_bytes, &ref_n_bytes);
  return(XEN_LIST_2(C_TO_XEN_guchar_(ref_bytes), C_TO_XEN_int(ref_n_bytes)));
}
static XEN gxg_pango_coverage_from_bytes(XEN bytes, XEN n_bytes)
{
  #define H_pango_coverage_from_bytes "PangoCoverage* pango_coverage_from_bytes(guchar* bytes, int n_bytes)"
  XEN_ASSERT_TYPE(XEN_guchar__P(bytes), bytes, 1, "pango_coverage_from_bytes", "guchar*");
  XEN_ASSERT_TYPE(XEN_int_P(n_bytes), n_bytes, 2, "pango_coverage_from_bytes", "int");
  return(C_TO_XEN_PangoCoverage_(pango_coverage_from_bytes(XEN_TO_C_guchar_(bytes), XEN_TO_C_int(n_bytes))));
}
static XEN gxg_pango_attr_type_get_type(void)
{
  #define H_pango_attr_type_get_type "GType pango_attr_type_get_type( void)"
  return(C_TO_XEN_GType(pango_attr_type_get_type()));
}
static XEN gxg_pango_underline_get_type(void)
{
  #define H_pango_underline_get_type "GType pango_underline_get_type( void)"
  return(C_TO_XEN_GType(pango_underline_get_type()));
}
static XEN gxg_pango_coverage_level_get_type(void)
{
  #define H_pango_coverage_level_get_type "GType pango_coverage_level_get_type( void)"
  return(C_TO_XEN_GType(pango_coverage_level_get_type()));
}
static XEN gxg_pango_style_get_type(void)
{
  #define H_pango_style_get_type "GType pango_style_get_type( void)"
  return(C_TO_XEN_GType(pango_style_get_type()));
}
static XEN gxg_pango_variant_get_type(void)
{
  #define H_pango_variant_get_type "GType pango_variant_get_type( void)"
  return(C_TO_XEN_GType(pango_variant_get_type()));
}
static XEN gxg_pango_weight_get_type(void)
{
  #define H_pango_weight_get_type "GType pango_weight_get_type( void)"
  return(C_TO_XEN_GType(pango_weight_get_type()));
}
static XEN gxg_pango_stretch_get_type(void)
{
  #define H_pango_stretch_get_type "GType pango_stretch_get_type( void)"
  return(C_TO_XEN_GType(pango_stretch_get_type()));
}
static XEN gxg_pango_font_mask_get_type(void)
{
  #define H_pango_font_mask_get_type "GType pango_font_mask_get_type( void)"
  return(C_TO_XEN_GType(pango_font_mask_get_type()));
}
static XEN gxg_pango_alignment_get_type(void)
{
  #define H_pango_alignment_get_type "GType pango_alignment_get_type( void)"
  return(C_TO_XEN_GType(pango_alignment_get_type()));
}
static XEN gxg_pango_wrap_mode_get_type(void)
{
  #define H_pango_wrap_mode_get_type "GType pango_wrap_mode_get_type( void)"
  return(C_TO_XEN_GType(pango_wrap_mode_get_type()));
}
static XEN gxg_pango_tab_align_get_type(void)
{
  #define H_pango_tab_align_get_type "GType pango_tab_align_get_type( void)"
  return(C_TO_XEN_GType(pango_tab_align_get_type()));
}
static XEN gxg_pango_direction_get_type(void)
{
  #define H_pango_direction_get_type "GType pango_direction_get_type( void)"
  return(C_TO_XEN_GType(pango_direction_get_type()));
}
static XEN gxg_pango_font_description_get_type(void)
{
  #define H_pango_font_description_get_type "GType pango_font_description_get_type( void)"
  return(C_TO_XEN_GType(pango_font_description_get_type()));
}
static XEN gxg_pango_font_description_new(void)
{
  #define H_pango_font_description_new "PangoFontDescription* pango_font_description_new( void)"
  return(C_TO_XEN_PangoFontDescription_(pango_font_description_new()));
}
static XEN gxg_pango_font_description_copy(XEN desc)
{
  #define H_pango_font_description_copy "PangoFontDescription* pango_font_description_copy(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_copy", "PangoFontDescription*");
  return(C_TO_XEN_PangoFontDescription_(pango_font_description_copy(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_copy_static(XEN desc)
{
  #define H_pango_font_description_copy_static "PangoFontDescription* pango_font_description_copy_static(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_copy_static", "PangoFontDescription*");
  return(C_TO_XEN_PangoFontDescription_(pango_font_description_copy_static(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_hash(XEN desc)
{
  #define H_pango_font_description_hash "guint pango_font_description_hash(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_hash", "PangoFontDescription*");
  return(C_TO_XEN_guint(pango_font_description_hash(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_equal(XEN desc1, XEN desc2)
{
  #define H_pango_font_description_equal "gboolean pango_font_description_equal(PangoFontDescription* desc1, \
PangoFontDescription* desc2)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc1), desc1, 1, "pango_font_description_equal", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc2), desc2, 2, "pango_font_description_equal", "PangoFontDescription*");
  return(C_TO_XEN_gboolean(pango_font_description_equal(XEN_TO_C_PangoFontDescription_(desc1), XEN_TO_C_PangoFontDescription_(desc2))));
}
static XEN gxg_pango_font_description_free(XEN desc)
{
  #define H_pango_font_description_free "void pango_font_description_free(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_free", "PangoFontDescription*");
  pango_font_description_free(XEN_TO_C_PangoFontDescription_(desc));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_descriptions_free(XEN descs, XEN n_descs)
{
  #define H_pango_font_descriptions_free "void pango_font_descriptions_free(PangoFontDescription** descs, \
int n_descs)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription___P(descs), descs, 1, "pango_font_descriptions_free", "PangoFontDescription**");
  XEN_ASSERT_TYPE(XEN_int_P(n_descs), n_descs, 2, "pango_font_descriptions_free", "int");
  pango_font_descriptions_free(XEN_TO_C_PangoFontDescription__(descs), XEN_TO_C_int(n_descs));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_set_family(XEN desc, XEN family)
{
  #define H_pango_font_description_set_family "void pango_font_description_set_family(PangoFontDescription* desc, \
char* family)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_family", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_char__P(family), family, 2, "pango_font_description_set_family", "char*");
  pango_font_description_set_family(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_char_(family));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_set_family_static(XEN desc, XEN family)
{
  #define H_pango_font_description_set_family_static "void pango_font_description_set_family_static(PangoFontDescription* desc, \
char* family)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_family_static", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_char__P(family), family, 2, "pango_font_description_set_family_static", "char*");
  pango_font_description_set_family_static(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_char_(family));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_family(XEN desc)
{
  #define H_pango_font_description_get_family "char* pango_font_description_get_family(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_family", "PangoFontDescription*");
  return(C_TO_XEN_char_(pango_font_description_get_family(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_set_style(XEN desc, XEN style)
{
  #define H_pango_font_description_set_style "void pango_font_description_set_style(PangoFontDescription* desc, \
PangoStyle style)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_style", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoStyle_P(style), style, 2, "pango_font_description_set_style", "PangoStyle");
  pango_font_description_set_style(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoStyle(style));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_style(XEN desc)
{
  #define H_pango_font_description_get_style "PangoStyle pango_font_description_get_style(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_style", "PangoFontDescription*");
  return(C_TO_XEN_PangoStyle(pango_font_description_get_style(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_set_variant(XEN desc, XEN variant)
{
  #define H_pango_font_description_set_variant "void pango_font_description_set_variant(PangoFontDescription* desc, \
PangoVariant variant)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_variant", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoVariant_P(variant), variant, 2, "pango_font_description_set_variant", "PangoVariant");
  pango_font_description_set_variant(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoVariant(variant));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_variant(XEN desc)
{
  #define H_pango_font_description_get_variant "PangoVariant pango_font_description_get_variant(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_variant", "PangoFontDescription*");
  return(C_TO_XEN_PangoVariant(pango_font_description_get_variant(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_set_weight(XEN desc, XEN weight)
{
  #define H_pango_font_description_set_weight "void pango_font_description_set_weight(PangoFontDescription* desc, \
PangoWeight weight)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_weight", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoWeight_P(weight), weight, 2, "pango_font_description_set_weight", "PangoWeight");
  pango_font_description_set_weight(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoWeight(weight));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_weight(XEN desc)
{
  #define H_pango_font_description_get_weight "PangoWeight pango_font_description_get_weight(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_weight", "PangoFontDescription*");
  return(C_TO_XEN_PangoWeight(pango_font_description_get_weight(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_set_stretch(XEN desc, XEN stretch)
{
  #define H_pango_font_description_set_stretch "void pango_font_description_set_stretch(PangoFontDescription* desc, \
PangoStretch stretch)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_stretch", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoStretch_P(stretch), stretch, 2, "pango_font_description_set_stretch", "PangoStretch");
  pango_font_description_set_stretch(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoStretch(stretch));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_stretch(XEN desc)
{
  #define H_pango_font_description_get_stretch "PangoStretch pango_font_description_get_stretch(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_stretch", "PangoFontDescription*");
  return(C_TO_XEN_PangoStretch(pango_font_description_get_stretch(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_set_size(XEN desc, XEN size)
{
  #define H_pango_font_description_set_size "void pango_font_description_set_size(PangoFontDescription* desc, \
gint size)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_size", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_gint_P(size), size, 2, "pango_font_description_set_size", "gint");
  pango_font_description_set_size(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_gint(size));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_get_size(XEN desc)
{
  #define H_pango_font_description_get_size "gint pango_font_description_get_size(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_size", "PangoFontDescription*");
  return(C_TO_XEN_gint(pango_font_description_get_size(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_get_set_fields(XEN desc)
{
  #define H_pango_font_description_get_set_fields "PangoFontMask pango_font_description_get_set_fields(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_get_set_fields", "PangoFontDescription*");
  return(C_TO_XEN_PangoFontMask(pango_font_description_get_set_fields(XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_description_unset_fields(XEN desc, XEN to_unset)
{
  #define H_pango_font_description_unset_fields "void pango_font_description_unset_fields(PangoFontDescription* desc, \
PangoFontMask to_unset)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_unset_fields", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontMask_P(to_unset), to_unset, 2, "pango_font_description_unset_fields", "PangoFontMask");
  pango_font_description_unset_fields(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoFontMask(to_unset));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_merge(XEN desc, XEN desc_to_merge, XEN replace_existing)
{
  #define H_pango_font_description_merge "void pango_font_description_merge(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_merge", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc_to_merge), desc_to_merge, 2, "pango_font_description_merge", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(replace_existing), replace_existing, 3, "pango_font_description_merge", "gboolean");
  pango_font_description_merge(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoFontDescription_(desc_to_merge), XEN_TO_C_gboolean(replace_existing));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_merge_static(XEN desc, XEN desc_to_merge, XEN replace_existing)
{
  #define H_pango_font_description_merge_static "void pango_font_description_merge_static(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_merge_static", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc_to_merge), desc_to_merge, 2, "pango_font_description_merge_static", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(replace_existing), replace_existing, 3, "pango_font_description_merge_static", "gboolean");
  pango_font_description_merge_static(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoFontDescription_(desc_to_merge), 
                                      XEN_TO_C_gboolean(replace_existing));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_description_better_match(XEN desc, XEN old_match, XEN new_match)
{
  #define H_pango_font_description_better_match "gboolean pango_font_description_better_match(PangoFontDescription* desc, \
PangoFontDescription* old_match, PangoFontDescription* new_match)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_better_match", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(old_match), old_match, 2, "pango_font_description_better_match", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(new_match), new_match, 3, "pango_font_description_better_match", "PangoFontDescription*");
  return(C_TO_XEN_gboolean(pango_font_description_better_match(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoFontDescription_(old_match), 
                                                               XEN_TO_C_PangoFontDescription_(new_match))));
}
static XEN gxg_pango_font_description_from_string(XEN str)
{
  #define H_pango_font_description_from_string "PangoFontDescription* pango_font_description_from_string(char* str)"
  XEN_ASSERT_TYPE(XEN_char__P(str), str, 1, "pango_font_description_from_string", "char*");
  return(C_TO_XEN_PangoFontDescription_(pango_font_description_from_string(XEN_TO_C_char_(str))));
}
static XEN gxg_pango_font_description_to_string(XEN desc)
{
  #define H_pango_font_description_to_string "char* pango_font_description_to_string(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_to_string", "PangoFontDescription*");
  {
   char* result;
   XEN rtn;
   result = pango_font_description_to_string(XEN_TO_C_PangoFontDescription_(desc));
   rtn = C_TO_XEN_char_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_pango_font_description_to_filename(XEN desc)
{
  #define H_pango_font_description_to_filename "char* pango_font_description_to_filename(PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_to_filename", "PangoFontDescription*");
  {
   char* result;
   XEN rtn;
   result = pango_font_description_to_filename(XEN_TO_C_PangoFontDescription_(desc));
   rtn = C_TO_XEN_char_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_pango_font_metrics_get_type(void)
{
  #define H_pango_font_metrics_get_type "GType pango_font_metrics_get_type( void)"
  return(C_TO_XEN_GType(pango_font_metrics_get_type()));
}
static XEN gxg_pango_font_metrics_ref(XEN metrics)
{
  #define H_pango_font_metrics_ref "PangoFontMetrics* pango_font_metrics_ref(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_ref", "PangoFontMetrics*");
  return(C_TO_XEN_PangoFontMetrics_(pango_font_metrics_ref(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_unref(XEN metrics)
{
  #define H_pango_font_metrics_unref "void pango_font_metrics_unref(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_unref", "PangoFontMetrics*");
  pango_font_metrics_unref(XEN_TO_C_PangoFontMetrics_(metrics));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_metrics_get_ascent(XEN metrics)
{
  #define H_pango_font_metrics_get_ascent "int pango_font_metrics_get_ascent(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_ascent", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_ascent(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_descent(XEN metrics)
{
  #define H_pango_font_metrics_get_descent "int pango_font_metrics_get_descent(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_descent", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_descent(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_approximate_char_width(XEN metrics)
{
  #define H_pango_font_metrics_get_approximate_char_width "int pango_font_metrics_get_approximate_char_width(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_approximate_char_width", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_approximate_char_width(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_approximate_digit_width(XEN metrics)
{
  #define H_pango_font_metrics_get_approximate_digit_width "int pango_font_metrics_get_approximate_digit_width(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_approximate_digit_width", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_approximate_digit_width(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_family_get_type(void)
{
  #define H_pango_font_family_get_type "GType pango_font_family_get_type( void)"
  return(C_TO_XEN_GType(pango_font_family_get_type()));
}
static XEN gxg_pango_font_family_list_faces(XEN family, XEN faces, XEN n_faces)
{
  #define H_pango_font_family_list_faces "void pango_font_family_list_faces(PangoFontFamily* family, \
PangoFontFace*** [faces], int* [n_faces])"
  PangoFontFace** ref_faces = NULL;
  int ref_n_faces;
  XEN_ASSERT_TYPE(XEN_PangoFontFamily__P(family), family, 1, "pango_font_family_list_faces", "PangoFontFamily*");
  pango_font_family_list_faces(XEN_TO_C_PangoFontFamily_(family), &ref_faces, &ref_n_faces);
  return(XEN_LIST_2(C_TO_XEN_PangoFontFace__(ref_faces), C_TO_XEN_int(ref_n_faces)));
}
static XEN gxg_pango_font_family_get_name(XEN family)
{
  #define H_pango_font_family_get_name "char* pango_font_family_get_name(PangoFontFamily* family)"
  XEN_ASSERT_TYPE(XEN_PangoFontFamily__P(family), family, 1, "pango_font_family_get_name", "PangoFontFamily*");
  return(C_TO_XEN_char_(pango_font_family_get_name(XEN_TO_C_PangoFontFamily_(family))));
}
static XEN gxg_pango_font_face_get_type(void)
{
  #define H_pango_font_face_get_type "GType pango_font_face_get_type( void)"
  return(C_TO_XEN_GType(pango_font_face_get_type()));
}
static XEN gxg_pango_font_face_describe(XEN face)
{
  #define H_pango_font_face_describe "PangoFontDescription* pango_font_face_describe(PangoFontFace* face)"
  XEN_ASSERT_TYPE(XEN_PangoFontFace__P(face), face, 1, "pango_font_face_describe", "PangoFontFace*");
  return(C_TO_XEN_PangoFontDescription_(pango_font_face_describe(XEN_TO_C_PangoFontFace_(face))));
}
static XEN gxg_pango_font_face_get_face_name(XEN face)
{
  #define H_pango_font_face_get_face_name "char* pango_font_face_get_face_name(PangoFontFace* face)"
  XEN_ASSERT_TYPE(XEN_PangoFontFace__P(face), face, 1, "pango_font_face_get_face_name", "PangoFontFace*");
  return(C_TO_XEN_char_(pango_font_face_get_face_name(XEN_TO_C_PangoFontFace_(face))));
}
static XEN gxg_pango_font_get_type(void)
{
  #define H_pango_font_get_type "GType pango_font_get_type( void)"
  return(C_TO_XEN_GType(pango_font_get_type()));
}
static XEN gxg_pango_font_describe(XEN font)
{
  #define H_pango_font_describe "PangoFontDescription* pango_font_describe(PangoFont* font)"
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 1, "pango_font_describe", "PangoFont*");
  return(C_TO_XEN_PangoFontDescription_(pango_font_describe(XEN_TO_C_PangoFont_(font))));
}
static XEN gxg_pango_font_get_coverage(XEN font, XEN language)
{
  #define H_pango_font_get_coverage "PangoCoverage* pango_font_get_coverage(PangoFont* font, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 1, "pango_font_get_coverage", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 2, "pango_font_get_coverage", "PangoLanguage*");
  return(C_TO_XEN_PangoCoverage_(pango_font_get_coverage(XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_font_get_metrics(XEN font, XEN language)
{
  #define H_pango_font_get_metrics "PangoFontMetrics* pango_font_get_metrics(PangoFont* font, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 1, "pango_font_get_metrics", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 2, "pango_font_get_metrics", "PangoLanguage*");
  return(C_TO_XEN_PangoFontMetrics_(pango_font_get_metrics(XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_font_get_glyph_extents(XEN font, XEN glyph, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_font_get_glyph_extents "void pango_font_get_glyph_extents(PangoFont* font, PangoGlyph glyph, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 1, "pango_font_get_glyph_extents", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoGlyph_P(glyph), glyph, 2, "pango_font_get_glyph_extents", "PangoGlyph");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 3, "pango_font_get_glyph_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 4, "pango_font_get_glyph_extents", "PangoRectangle*");
  pango_font_get_glyph_extents(XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoGlyph(glyph), XEN_TO_C_PangoRectangle_(ink_rect), 
                               XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_font_map_get_type(void)
{
  #define H_pango_font_map_get_type "GType pango_font_map_get_type( void)"
  return(C_TO_XEN_GType(pango_font_map_get_type()));
}
static XEN gxg_pango_font_map_load_font(XEN fontmap, XEN context, XEN desc)
{
  #define H_pango_font_map_load_font "PangoFont* pango_font_map_load_font(PangoFontMap* fontmap, PangoContext* context, \
PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoFontMap__P(fontmap), fontmap, 1, "pango_font_map_load_font", "PangoFontMap*");
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 2, "pango_font_map_load_font", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 3, "pango_font_map_load_font", "PangoFontDescription*");
  return(C_TO_XEN_PangoFont_(pango_font_map_load_font(XEN_TO_C_PangoFontMap_(fontmap), XEN_TO_C_PangoContext_(context), XEN_TO_C_PangoFontDescription_(desc))));
}
static XEN gxg_pango_font_map_load_fontset(XEN fontmap, XEN context, XEN desc, XEN language)
{
  #define H_pango_font_map_load_fontset "PangoFontset* pango_font_map_load_fontset(PangoFontMap* fontmap, \
PangoContext* context, PangoFontDescription* desc, PangoLanguage* language)"
  XEN_ASSERT_TYPE(XEN_PangoFontMap__P(fontmap), fontmap, 1, "pango_font_map_load_fontset", "PangoFontMap*");
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 2, "pango_font_map_load_fontset", "PangoContext*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 3, "pango_font_map_load_fontset", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 4, "pango_font_map_load_fontset", "PangoLanguage*");
  return(C_TO_XEN_PangoFontset_(pango_font_map_load_fontset(XEN_TO_C_PangoFontMap_(fontmap), XEN_TO_C_PangoContext_(context), 
                                                            XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_PangoLanguage_(language))));
}
static XEN gxg_pango_font_map_list_families(XEN fontmap, XEN families, XEN n_families)
{
  #define H_pango_font_map_list_families "void pango_font_map_list_families(PangoFontMap* fontmap, PangoFontFamily*** [families], \
int* [n_families])"
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  XEN_ASSERT_TYPE(XEN_PangoFontMap__P(fontmap), fontmap, 1, "pango_font_map_list_families", "PangoFontMap*");
  pango_font_map_list_families(XEN_TO_C_PangoFontMap_(fontmap), &ref_families, &ref_n_families);
  return(XEN_LIST_2(C_TO_XEN_PangoFontFamily__(ref_families), C_TO_XEN_int(ref_n_families)));
}
static XEN gxg_pango_glyph_string_new(void)
{
  #define H_pango_glyph_string_new "PangoGlyphString* pango_glyph_string_new( void)"
  return(C_TO_XEN_PangoGlyphString_(pango_glyph_string_new()));
}
static XEN gxg_pango_glyph_string_set_size(XEN string, XEN new_len)
{
  #define H_pango_glyph_string_set_size "void pango_glyph_string_set_size(PangoGlyphString* string, gint new_len)"
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(string), string, 1, "pango_glyph_string_set_size", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_gint_P(new_len), new_len, 2, "pango_glyph_string_set_size", "gint");
  pango_glyph_string_set_size(XEN_TO_C_PangoGlyphString_(string), XEN_TO_C_gint(new_len));
  return(XEN_FALSE);
}
static XEN gxg_pango_glyph_string_get_type(void)
{
  #define H_pango_glyph_string_get_type "GType pango_glyph_string_get_type( void)"
  return(C_TO_XEN_GType(pango_glyph_string_get_type()));
}
static XEN gxg_pango_glyph_string_copy(XEN string)
{
  #define H_pango_glyph_string_copy "PangoGlyphString* pango_glyph_string_copy(PangoGlyphString* string)"
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(string), string, 1, "pango_glyph_string_copy", "PangoGlyphString*");
  return(C_TO_XEN_PangoGlyphString_(pango_glyph_string_copy(XEN_TO_C_PangoGlyphString_(string))));
}
static XEN gxg_pango_glyph_string_free(XEN string)
{
  #define H_pango_glyph_string_free "void pango_glyph_string_free(PangoGlyphString* string)"
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(string), string, 1, "pango_glyph_string_free", "PangoGlyphString*");
  pango_glyph_string_free(XEN_TO_C_PangoGlyphString_(string));
  return(XEN_FALSE);
}
static XEN gxg_pango_glyph_string_extents(XEN glyphs, XEN font, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_glyph_string_extents "void pango_glyph_string_extents(PangoGlyphString* glyphs, PangoFont* font, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 1, "pango_glyph_string_extents", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 2, "pango_glyph_string_extents", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 3, "pango_glyph_string_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 4, "pango_glyph_string_extents", "PangoRectangle*");
  pango_glyph_string_extents(XEN_TO_C_PangoGlyphString_(glyphs), XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoRectangle_(ink_rect), 
                             XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_glyph_string_extents_range(XEN glyphs, XEN start, XEN end, XEN font, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_glyph_string_extents_range "void pango_glyph_string_extents_range(PangoGlyphString* glyphs, \
int start, int end, PangoFont* font, PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 1, "pango_glyph_string_extents_range", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_int_P(start), start, 2, "pango_glyph_string_extents_range", "int");
  XEN_ASSERT_TYPE(XEN_int_P(end), end, 3, "pango_glyph_string_extents_range", "int");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 4, "pango_glyph_string_extents_range", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 5, "pango_glyph_string_extents_range", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 6, "pango_glyph_string_extents_range", "PangoRectangle*");
  pango_glyph_string_extents_range(XEN_TO_C_PangoGlyphString_(glyphs), XEN_TO_C_int(start), XEN_TO_C_int(end), XEN_TO_C_PangoFont_(font), 
                                   XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_glyph_string_get_logical_widths(XEN glyphs, XEN text, XEN length, XEN embedding_level, XEN logical_widths)
{
  #define H_pango_glyph_string_get_logical_widths "void pango_glyph_string_get_logical_widths(PangoGlyphString* glyphs, \
char* text, int length, int embedding_level, int* [logical_widths])"
  int ref_logical_widths;
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 1, "pango_glyph_string_get_logical_widths", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 2, "pango_glyph_string_get_logical_widths", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_glyph_string_get_logical_widths", "int");
  XEN_ASSERT_TYPE(XEN_int_P(embedding_level), embedding_level, 4, "pango_glyph_string_get_logical_widths", "int");
  pango_glyph_string_get_logical_widths(XEN_TO_C_PangoGlyphString_(glyphs), XEN_TO_C_char_(text), XEN_TO_C_int(length), XEN_TO_C_int(embedding_level), 
                                        &ref_logical_widths);
  return(XEN_LIST_1(C_TO_XEN_int(ref_logical_widths)));
}
static XEN gxg_pango_glyph_string_index_to_x(XEN glyphs, XEN text, XEN length, XEN analysis, XEN index, XEN trailing, XEN x_pos)
{
  #define H_pango_glyph_string_index_to_x "void pango_glyph_string_index_to_x(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int index, gboolean trailing, int* [x_pos])"
  int ref_x_pos;
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 1, "pango_glyph_string_index_to_x", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 2, "pango_glyph_string_index_to_x", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_glyph_string_index_to_x", "int");
  XEN_ASSERT_TYPE(XEN_PangoAnalysis__P(analysis), analysis, 4, "pango_glyph_string_index_to_x", "PangoAnalysis*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 5, "pango_glyph_string_index_to_x", "int");
  XEN_ASSERT_TYPE(XEN_gboolean_P(trailing), trailing, 6, "pango_glyph_string_index_to_x", "gboolean");
  pango_glyph_string_index_to_x(XEN_TO_C_PangoGlyphString_(glyphs), XEN_TO_C_char_(text), XEN_TO_C_int(length), XEN_TO_C_PangoAnalysis_(analysis), 
                                XEN_TO_C_int(index), XEN_TO_C_gboolean(trailing), &ref_x_pos);
  return(XEN_LIST_1(C_TO_XEN_int(ref_x_pos)));
}
static XEN gxg_pango_glyph_string_x_to_index(XEN glyphs, XEN text, XEN length, XEN analysis, XEN x_pos, XEN index, XEN trailing)
{
  #define H_pango_glyph_string_x_to_index "void pango_glyph_string_x_to_index(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int x_pos, int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 1, "pango_glyph_string_x_to_index", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 2, "pango_glyph_string_x_to_index", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_glyph_string_x_to_index", "int");
  XEN_ASSERT_TYPE(XEN_PangoAnalysis__P(analysis), analysis, 4, "pango_glyph_string_x_to_index", "PangoAnalysis*");
  XEN_ASSERT_TYPE(XEN_int_P(x_pos), x_pos, 5, "pango_glyph_string_x_to_index", "int");
  pango_glyph_string_x_to_index(XEN_TO_C_PangoGlyphString_(glyphs), XEN_TO_C_char_(text), XEN_TO_C_int(length), XEN_TO_C_PangoAnalysis_(analysis), 
                                XEN_TO_C_int(x_pos), &ref_index, &ref_trailing);
  return(XEN_LIST_2(C_TO_XEN_int(ref_index), C_TO_XEN_int(ref_trailing)));
}
static XEN gxg_pango_shape(XEN text, XEN length, XEN analysis, XEN glyphs)
{
  #define H_pango_shape "void pango_shape(gchar* text, gint length, PangoAnalysis* analysis, PangoGlyphString* glyphs)"
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 1, "pango_shape", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(length), length, 2, "pango_shape", "gint");
  XEN_ASSERT_TYPE(XEN_PangoAnalysis__P(analysis), analysis, 3, "pango_shape", "PangoAnalysis*");
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 4, "pango_shape", "PangoGlyphString*");
  pango_shape(XEN_TO_C_gchar_(text), XEN_TO_C_gint(length), XEN_TO_C_PangoAnalysis_(analysis), XEN_TO_C_PangoGlyphString_(glyphs));
  return(XEN_FALSE);
}
static XEN gxg_pango_reorder_items(XEN logical_items)
{
  #define H_pango_reorder_items "GList* pango_reorder_items(GList* logical_items)"
  XEN_ASSERT_TYPE(XEN_GList__P(logical_items), logical_items, 1, "pango_reorder_items", "GList*");
  return(C_TO_XEN_GList_(pango_reorder_items(XEN_TO_C_GList_(logical_items))));
}
static XEN gxg_pango_item_new(void)
{
  #define H_pango_item_new "PangoItem* pango_item_new( void)"
  return(C_TO_XEN_PangoItem_(pango_item_new()));
}
static XEN gxg_pango_item_copy(XEN item)
{
  #define H_pango_item_copy "PangoItem* pango_item_copy(PangoItem* item)"
  XEN_ASSERT_TYPE(XEN_PangoItem__P(item), item, 1, "pango_item_copy", "PangoItem*");
  return(C_TO_XEN_PangoItem_(pango_item_copy(XEN_TO_C_PangoItem_(item))));
}
static XEN gxg_pango_item_free(XEN item)
{
  #define H_pango_item_free "void pango_item_free(PangoItem* item)"
  XEN_ASSERT_TYPE(XEN_PangoItem__P(item), item, 1, "pango_item_free", "PangoItem*");
  pango_item_free(XEN_TO_C_PangoItem_(item));
  return(XEN_FALSE);
}
static XEN gxg_pango_item_split(XEN orig, XEN split_index, XEN split_offset)
{
  #define H_pango_item_split "PangoItem* pango_item_split(PangoItem* orig, int split_index, int split_offset)"
  XEN_ASSERT_TYPE(XEN_PangoItem__P(orig), orig, 1, "pango_item_split", "PangoItem*");
  XEN_ASSERT_TYPE(XEN_int_P(split_index), split_index, 2, "pango_item_split", "int");
  XEN_ASSERT_TYPE(XEN_int_P(split_offset), split_offset, 3, "pango_item_split", "int");
  return(C_TO_XEN_PangoItem_(pango_item_split(XEN_TO_C_PangoItem_(orig), XEN_TO_C_int(split_index), XEN_TO_C_int(split_offset))));
}
static XEN gxg_pango_layout_get_type(void)
{
  #define H_pango_layout_get_type "GType pango_layout_get_type( void)"
  return(C_TO_XEN_GType(pango_layout_get_type()));
}
static XEN gxg_pango_layout_new(XEN context)
{
  #define H_pango_layout_new "PangoLayout* pango_layout_new(PangoContext* context)"
  XEN_ASSERT_TYPE(XEN_PangoContext__P(context), context, 1, "pango_layout_new", "PangoContext*");
  return(C_TO_XEN_PangoLayout_(pango_layout_new(XEN_TO_C_PangoContext_(context))));
}
static XEN gxg_pango_layout_copy(XEN src)
{
  #define H_pango_layout_copy "PangoLayout* pango_layout_copy(PangoLayout* src)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(src), src, 1, "pango_layout_copy", "PangoLayout*");
  return(C_TO_XEN_PangoLayout_(pango_layout_copy(XEN_TO_C_PangoLayout_(src))));
}
static XEN gxg_pango_layout_get_context(XEN layout)
{
  #define H_pango_layout_get_context "PangoContext* pango_layout_get_context(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_context", "PangoLayout*");
  return(C_TO_XEN_PangoContext_(pango_layout_get_context(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_attributes(XEN layout, XEN attrs)
{
  #define H_pango_layout_set_attributes "void pango_layout_set_attributes(PangoLayout* layout, PangoAttrList* attrs)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_attributes", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(attrs), attrs, 2, "pango_layout_set_attributes", "PangoAttrList*");
  pango_layout_set_attributes(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoAttrList_(attrs));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_attributes(XEN layout)
{
  #define H_pango_layout_get_attributes "PangoAttrList* pango_layout_get_attributes(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_attributes", "PangoLayout*");
  return(C_TO_XEN_PangoAttrList_(pango_layout_get_attributes(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_text(XEN layout, XEN text, XEN length)
{
  #define H_pango_layout_set_text "void pango_layout_set_text(PangoLayout* layout, char* text, int length)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_text", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 2, "pango_layout_set_text", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_layout_set_text", "int");
  pango_layout_set_text(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_char_(text), XEN_TO_C_int(length));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_text(XEN layout)
{
  #define H_pango_layout_get_text "char* pango_layout_get_text(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_text", "PangoLayout*");
  return(C_TO_XEN_char_(pango_layout_get_text(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_markup(XEN layout, XEN markup, XEN length)
{
  #define H_pango_layout_set_markup "void pango_layout_set_markup(PangoLayout* layout, char* markup, \
int length)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_markup", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_char__P(markup), markup, 2, "pango_layout_set_markup", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_layout_set_markup", "int");
  pango_layout_set_markup(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_char_(markup), XEN_TO_C_int(length));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_set_markup_with_accel(XEN layout, XEN markup, XEN length, XEN accel_marker, XEN accel_char)
{
  #define H_pango_layout_set_markup_with_accel "void pango_layout_set_markup_with_accel(PangoLayout* layout, \
char* markup, int length, gunichar accel_marker, gunichar* accel_char)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_markup_with_accel", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_char__P(markup), markup, 2, "pango_layout_set_markup_with_accel", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 3, "pango_layout_set_markup_with_accel", "int");
  XEN_ASSERT_TYPE(XEN_gunichar_P(accel_marker), accel_marker, 4, "pango_layout_set_markup_with_accel", "gunichar");
  XEN_ASSERT_TYPE(XEN_gunichar__P(accel_char), accel_char, 5, "pango_layout_set_markup_with_accel", "gunichar*");
  pango_layout_set_markup_with_accel(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_char_(markup), XEN_TO_C_int(length), XEN_TO_C_gunichar(accel_marker), 
                                     XEN_TO_C_gunichar_(accel_char));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_set_font_description(XEN layout, XEN desc)
{
  #define H_pango_layout_set_font_description "void pango_layout_set_font_description(PangoLayout* layout, \
PangoFontDescription* desc)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_font_description", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 2, "pango_layout_set_font_description", "PangoFontDescription*");
  pango_layout_set_font_description(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoFontDescription_(desc));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_set_width(XEN layout, XEN width)
{
  #define H_pango_layout_set_width "void pango_layout_set_width(PangoLayout* layout, int width)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_width", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 2, "pango_layout_set_width", "int");
  pango_layout_set_width(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(width));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_width(XEN layout)
{
  #define H_pango_layout_get_width "int pango_layout_get_width(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_width", "PangoLayout*");
  return(C_TO_XEN_int(pango_layout_get_width(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_wrap(XEN layout, XEN wrap)
{
  #define H_pango_layout_set_wrap "void pango_layout_set_wrap(PangoLayout* layout, PangoWrapMode wrap)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_wrap", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoWrapMode_P(wrap), wrap, 2, "pango_layout_set_wrap", "PangoWrapMode");
  pango_layout_set_wrap(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoWrapMode(wrap));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_wrap(XEN layout)
{
  #define H_pango_layout_get_wrap "PangoWrapMode pango_layout_get_wrap(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_wrap", "PangoLayout*");
  return(C_TO_XEN_PangoWrapMode(pango_layout_get_wrap(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_indent(XEN layout, XEN indent)
{
  #define H_pango_layout_set_indent "void pango_layout_set_indent(PangoLayout* layout, int indent)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_indent", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(indent), indent, 2, "pango_layout_set_indent", "int");
  pango_layout_set_indent(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(indent));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_indent(XEN layout)
{
  #define H_pango_layout_get_indent "int pango_layout_get_indent(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_indent", "PangoLayout*");
  return(C_TO_XEN_int(pango_layout_get_indent(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_spacing(XEN layout, XEN spacing)
{
  #define H_pango_layout_set_spacing "void pango_layout_set_spacing(PangoLayout* layout, int spacing)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_spacing", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(spacing), spacing, 2, "pango_layout_set_spacing", "int");
  pango_layout_set_spacing(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(spacing));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_spacing(XEN layout)
{
  #define H_pango_layout_get_spacing "int pango_layout_get_spacing(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_spacing", "PangoLayout*");
  return(C_TO_XEN_int(pango_layout_get_spacing(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_justify(XEN layout, XEN justify)
{
  #define H_pango_layout_set_justify "void pango_layout_set_justify(PangoLayout* layout, gboolean justify)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_justify", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(justify), justify, 2, "pango_layout_set_justify", "gboolean");
  pango_layout_set_justify(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_gboolean(justify));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_justify(XEN layout)
{
  #define H_pango_layout_get_justify "gboolean pango_layout_get_justify(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_justify", "PangoLayout*");
  return(C_TO_XEN_gboolean(pango_layout_get_justify(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_alignment(XEN layout, XEN alignment)
{
  #define H_pango_layout_set_alignment "void pango_layout_set_alignment(PangoLayout* layout, PangoAlignment alignment)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_alignment", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoAlignment_P(alignment), alignment, 2, "pango_layout_set_alignment", "PangoAlignment");
  pango_layout_set_alignment(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoAlignment(alignment));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_alignment(XEN layout)
{
  #define H_pango_layout_get_alignment "PangoAlignment pango_layout_get_alignment(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_alignment", "PangoLayout*");
  return(C_TO_XEN_PangoAlignment(pango_layout_get_alignment(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_tabs(XEN layout, XEN tabs)
{
  #define H_pango_layout_set_tabs "void pango_layout_set_tabs(PangoLayout* layout, PangoTabArray* tabs)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_tabs", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoTabArray__P(tabs) || XEN_FALSE_P(tabs), tabs, 2, "pango_layout_set_tabs", "PangoTabArray*");
  pango_layout_set_tabs(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoTabArray_(tabs));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_tabs(XEN layout)
{
  #define H_pango_layout_get_tabs "PangoTabArray* pango_layout_get_tabs(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_tabs", "PangoLayout*");
  return(C_TO_XEN_PangoTabArray_(pango_layout_get_tabs(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_set_single_paragraph_mode(XEN layout, XEN setting)
{
  #define H_pango_layout_set_single_paragraph_mode "void pango_layout_set_single_paragraph_mode(PangoLayout* layout, \
gboolean setting)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_single_paragraph_mode", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "pango_layout_set_single_paragraph_mode", "gboolean");
  pango_layout_set_single_paragraph_mode(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_single_paragraph_mode(XEN layout)
{
  #define H_pango_layout_get_single_paragraph_mode "gboolean pango_layout_get_single_paragraph_mode(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_single_paragraph_mode", "PangoLayout*");
  return(C_TO_XEN_gboolean(pango_layout_get_single_paragraph_mode(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_context_changed(XEN layout)
{
  #define H_pango_layout_context_changed "void pango_layout_context_changed(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_context_changed", "PangoLayout*");
  pango_layout_context_changed(XEN_TO_C_PangoLayout_(layout));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_log_attrs(XEN layout, XEN attrs, XEN n_attrs)
{
  #define H_pango_layout_get_log_attrs "void pango_layout_get_log_attrs(PangoLayout* layout, PangoLogAttr** [attrs], \
gint* [n_attrs])"
  PangoLogAttr* ref_attrs = NULL;
  gint ref_n_attrs;
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_log_attrs", "PangoLayout*");
  pango_layout_get_log_attrs(XEN_TO_C_PangoLayout_(layout), &ref_attrs, &ref_n_attrs);
  return(XEN_LIST_2(C_TO_XEN_PangoLogAttr_(ref_attrs), C_TO_XEN_gint(ref_n_attrs)));
}
static XEN gxg_pango_layout_index_to_pos(XEN layout, XEN index, XEN pos)
{
  #define H_pango_layout_index_to_pos "void pango_layout_index_to_pos(PangoLayout* layout, int index, \
PangoRectangle* pos)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_index_to_pos", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 2, "pango_layout_index_to_pos", "int");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(pos), pos, 3, "pango_layout_index_to_pos", "PangoRectangle*");
  pango_layout_index_to_pos(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(index), XEN_TO_C_PangoRectangle_(pos));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_cursor_pos(XEN layout, XEN index, XEN strong_pos, XEN weak_pos)
{
  #define H_pango_layout_get_cursor_pos "void pango_layout_get_cursor_pos(PangoLayout* layout, int index, \
PangoRectangle* strong_pos, PangoRectangle* weak_pos)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_cursor_pos", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 2, "pango_layout_get_cursor_pos", "int");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(strong_pos), strong_pos, 3, "pango_layout_get_cursor_pos", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(weak_pos), weak_pos, 4, "pango_layout_get_cursor_pos", "PangoRectangle*");
  pango_layout_get_cursor_pos(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(index), XEN_TO_C_PangoRectangle_(strong_pos), XEN_TO_C_PangoRectangle_(weak_pos));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_move_cursor_visually(XEN layout, XEN strong, XEN old_index, XEN old_trailing, XEN direction, XEN new_index, XEN new_trailing)
{
  #define H_pango_layout_move_cursor_visually "void pango_layout_move_cursor_visually(PangoLayout* layout, \
gboolean strong, int old_index, int old_trailing, int direction, int* new_index, int* new_trailing)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_move_cursor_visually", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(strong), strong, 2, "pango_layout_move_cursor_visually", "gboolean");
  XEN_ASSERT_TYPE(XEN_int_P(old_index), old_index, 3, "pango_layout_move_cursor_visually", "int");
  XEN_ASSERT_TYPE(XEN_int_P(old_trailing), old_trailing, 4, "pango_layout_move_cursor_visually", "int");
  XEN_ASSERT_TYPE(XEN_int_P(direction), direction, 5, "pango_layout_move_cursor_visually", "int");
  XEN_ASSERT_TYPE(XEN_int__P(new_index), new_index, 6, "pango_layout_move_cursor_visually", "int*");
  XEN_ASSERT_TYPE(XEN_int__P(new_trailing), new_trailing, 7, "pango_layout_move_cursor_visually", "int*");
  pango_layout_move_cursor_visually(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_gboolean(strong), XEN_TO_C_int(old_index), XEN_TO_C_int(old_trailing), 
                                    XEN_TO_C_int(direction), XEN_TO_C_int_(new_index), XEN_TO_C_int_(new_trailing));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_xy_to_index(XEN layout, XEN x, XEN y, XEN index, XEN trailing)
{
  #define H_pango_layout_xy_to_index "gboolean pango_layout_xy_to_index(PangoLayout* layout, int x, int y, \
int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_xy_to_index", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 2, "pango_layout_xy_to_index", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 3, "pango_layout_xy_to_index", "int");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(pango_layout_xy_to_index(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(x), XEN_TO_C_int(y), 
                                                        &ref_index, &ref_trailing));
    return(XEN_LIST_3(result, C_TO_XEN_int(ref_index), C_TO_XEN_int(ref_trailing)));
   }
}
static XEN gxg_pango_layout_get_extents(XEN layout, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_get_extents "void pango_layout_get_extents(PangoLayout* layout, PangoRectangle* ink_rect, \
PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_extents", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_get_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_get_extents", "PangoRectangle*");
  pango_layout_get_extents(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_pixel_extents(XEN layout, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_get_pixel_extents "void pango_layout_get_pixel_extents(PangoLayout* layout, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_pixel_extents", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_get_pixel_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_get_pixel_extents", "PangoRectangle*");
  pango_layout_get_pixel_extents(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_size(XEN layout, XEN width, XEN height)
{
  #define H_pango_layout_get_size "void pango_layout_get_size(PangoLayout* layout, int* [width], int* [height])"
  int ref_width;
  int ref_height;
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_size", "PangoLayout*");
  pango_layout_get_size(XEN_TO_C_PangoLayout_(layout), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_int(ref_width), C_TO_XEN_int(ref_height)));
}
static XEN gxg_pango_layout_get_pixel_size(XEN layout, XEN width, XEN height)
{
  #define H_pango_layout_get_pixel_size "void pango_layout_get_pixel_size(PangoLayout* layout, int* [width], \
int* [height])"
  int ref_width;
  int ref_height;
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_pixel_size", "PangoLayout*");
  pango_layout_get_pixel_size(XEN_TO_C_PangoLayout_(layout), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_int(ref_width), C_TO_XEN_int(ref_height)));
}
static XEN gxg_pango_layout_get_line_count(XEN layout)
{
  #define H_pango_layout_get_line_count "int pango_layout_get_line_count(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_line_count", "PangoLayout*");
  return(C_TO_XEN_int(pango_layout_get_line_count(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_get_line(XEN layout, XEN line)
{
  #define H_pango_layout_get_line "PangoLayoutLine* pango_layout_get_line(PangoLayout* layout, int line)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_line", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(line), line, 2, "pango_layout_get_line", "int");
  return(C_TO_XEN_PangoLayoutLine_(pango_layout_get_line(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(line))));
}
static XEN gxg_pango_layout_get_lines(XEN layout)
{
  #define H_pango_layout_get_lines "GSList* pango_layout_get_lines(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_lines", "PangoLayout*");
  return(C_TO_XEN_GSList_(pango_layout_get_lines(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_line_ref(XEN line)
{
  #define H_pango_layout_line_ref "void pango_layout_line_ref(PangoLayoutLine* line)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_ref", "PangoLayoutLine*");
  pango_layout_line_ref(XEN_TO_C_PangoLayoutLine_(line));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_line_unref(XEN line)
{
  #define H_pango_layout_line_unref "void pango_layout_line_unref(PangoLayoutLine* line)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_unref", "PangoLayoutLine*");
  pango_layout_line_unref(XEN_TO_C_PangoLayoutLine_(line));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_line_x_to_index(XEN line, XEN x_pos, XEN index, XEN trailing)
{
  #define H_pango_layout_line_x_to_index "gboolean pango_layout_line_x_to_index(PangoLayoutLine* line, \
int x_pos, int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_x_to_index", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_int_P(x_pos), x_pos, 2, "pango_layout_line_x_to_index", "int");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(pango_layout_line_x_to_index(XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_int(x_pos), &ref_index, 
                                                            &ref_trailing));
    return(XEN_LIST_3(result, C_TO_XEN_int(ref_index), C_TO_XEN_int(ref_trailing)));
   }
}
static XEN gxg_pango_layout_line_index_to_x(XEN line, XEN index, XEN trailing, XEN x_pos)
{
  #define H_pango_layout_line_index_to_x "void pango_layout_line_index_to_x(PangoLayoutLine* line, int index, \
gboolean trailing, int* [x_pos])"
  int ref_x_pos;
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_index_to_x", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_int_P(index), index, 2, "pango_layout_line_index_to_x", "int");
  XEN_ASSERT_TYPE(XEN_gboolean_P(trailing), trailing, 3, "pango_layout_line_index_to_x", "gboolean");
  pango_layout_line_index_to_x(XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_int(index), XEN_TO_C_gboolean(trailing), &ref_x_pos);
  return(XEN_LIST_1(C_TO_XEN_int(ref_x_pos)));
}
static XEN gxg_pango_layout_line_get_x_ranges(XEN line, XEN start_index, XEN end_index, XEN ranges, XEN n_ranges)
{
  #define H_pango_layout_line_get_x_ranges "void pango_layout_line_get_x_ranges(PangoLayoutLine* line, \
int start_index, int end_index, int** [ranges], int* [n_ranges])"
  int* ref_ranges = NULL;
  int ref_n_ranges;
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_get_x_ranges", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_int_P(start_index), start_index, 2, "pango_layout_line_get_x_ranges", "int");
  XEN_ASSERT_TYPE(XEN_int_P(end_index), end_index, 3, "pango_layout_line_get_x_ranges", "int");
  pango_layout_line_get_x_ranges(XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_int(start_index), XEN_TO_C_int(end_index), &ref_ranges, 
                                 &ref_n_ranges);
  return(XEN_LIST_2(C_TO_XEN_int_(ref_ranges), C_TO_XEN_int(ref_n_ranges)));
}
static XEN gxg_pango_layout_line_get_extents(XEN line, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_line_get_extents "void pango_layout_line_get_extents(PangoLayoutLine* line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 1, "pango_layout_line_get_extents", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_line_get_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_line_get_extents", "PangoRectangle*");
  pango_layout_line_get_extents(XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_line_get_pixel_extents(XEN layout_line, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_line_get_pixel_extents "void pango_layout_line_get_pixel_extents(PangoLayoutLine* layout_line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(layout_line), layout_line, 1, "pango_layout_line_get_pixel_extents", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_line_get_pixel_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_line_get_pixel_extents", "PangoRectangle*");
  pango_layout_line_get_pixel_extents(XEN_TO_C_PangoLayoutLine_(layout_line), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_iter(XEN layout)
{
  #define H_pango_layout_get_iter "PangoLayoutIter* pango_layout_get_iter(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_iter", "PangoLayout*");
  return(C_TO_XEN_PangoLayoutIter_(pango_layout_get_iter(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_layout_iter_free(XEN iter)
{
  #define H_pango_layout_iter_free "void pango_layout_iter_free(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_free", "PangoLayoutIter*");
  pango_layout_iter_free(XEN_TO_C_PangoLayoutIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_index(XEN iter)
{
  #define H_pango_layout_iter_get_index "int pango_layout_iter_get_index(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_index", "PangoLayoutIter*");
  return(C_TO_XEN_int(pango_layout_iter_get_index(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_get_run(XEN iter)
{
  #define H_pango_layout_iter_get_run "PangoLayoutRun* pango_layout_iter_get_run(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_run", "PangoLayoutIter*");
  return(C_TO_XEN_PangoLayoutRun_(pango_layout_iter_get_run(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_get_line(XEN iter)
{
  #define H_pango_layout_iter_get_line "PangoLayoutLine* pango_layout_iter_get_line(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_line", "PangoLayoutIter*");
  return(C_TO_XEN_PangoLayoutLine_(pango_layout_iter_get_line(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_at_last_line(XEN iter)
{
  #define H_pango_layout_iter_at_last_line "gboolean pango_layout_iter_at_last_line(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_at_last_line", "PangoLayoutIter*");
  return(C_TO_XEN_gboolean(pango_layout_iter_at_last_line(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_next_char(XEN iter)
{
  #define H_pango_layout_iter_next_char "gboolean pango_layout_iter_next_char(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_next_char", "PangoLayoutIter*");
  return(C_TO_XEN_gboolean(pango_layout_iter_next_char(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_next_cluster(XEN iter)
{
  #define H_pango_layout_iter_next_cluster "gboolean pango_layout_iter_next_cluster(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_next_cluster", "PangoLayoutIter*");
  return(C_TO_XEN_gboolean(pango_layout_iter_next_cluster(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_next_run(XEN iter)
{
  #define H_pango_layout_iter_next_run "gboolean pango_layout_iter_next_run(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_next_run", "PangoLayoutIter*");
  return(C_TO_XEN_gboolean(pango_layout_iter_next_run(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_next_line(XEN iter)
{
  #define H_pango_layout_iter_next_line "gboolean pango_layout_iter_next_line(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_next_line", "PangoLayoutIter*");
  return(C_TO_XEN_gboolean(pango_layout_iter_next_line(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_layout_iter_get_char_extents(XEN iter, XEN logical_rect)
{
  #define H_pango_layout_iter_get_char_extents "void pango_layout_iter_get_char_extents(PangoLayoutIter* iter, \
PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_char_extents", "PangoLayoutIter*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 2, "pango_layout_iter_get_char_extents", "PangoRectangle*");
  pango_layout_iter_get_char_extents(XEN_TO_C_PangoLayoutIter_(iter), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_cluster_extents(XEN iter, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_iter_get_cluster_extents "void pango_layout_iter_get_cluster_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_cluster_extents", "PangoLayoutIter*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_iter_get_cluster_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_iter_get_cluster_extents", "PangoRectangle*");
  pango_layout_iter_get_cluster_extents(XEN_TO_C_PangoLayoutIter_(iter), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_run_extents(XEN iter, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_iter_get_run_extents "void pango_layout_iter_get_run_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_run_extents", "PangoLayoutIter*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_iter_get_run_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_iter_get_run_extents", "PangoRectangle*");
  pango_layout_iter_get_run_extents(XEN_TO_C_PangoLayoutIter_(iter), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_line_extents(XEN iter, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_iter_get_line_extents "void pango_layout_iter_get_line_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_line_extents", "PangoLayoutIter*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_iter_get_line_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_iter_get_line_extents", "PangoRectangle*");
  pango_layout_iter_get_line_extents(XEN_TO_C_PangoLayoutIter_(iter), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_line_yrange(XEN iter, XEN y0, XEN y1)
{
  #define H_pango_layout_iter_get_line_yrange "void pango_layout_iter_get_line_yrange(PangoLayoutIter* iter, \
int* [y0], int* [y1])"
  int ref_y0;
  int ref_y1;
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_line_yrange", "PangoLayoutIter*");
  pango_layout_iter_get_line_yrange(XEN_TO_C_PangoLayoutIter_(iter), &ref_y0, &ref_y1);
  return(XEN_LIST_2(C_TO_XEN_int(ref_y0), C_TO_XEN_int(ref_y1)));
}
static XEN gxg_pango_layout_iter_get_layout_extents(XEN iter, XEN ink_rect, XEN logical_rect)
{
  #define H_pango_layout_iter_get_layout_extents "void pango_layout_iter_get_layout_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_layout_extents", "PangoLayoutIter*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(ink_rect), ink_rect, 2, "pango_layout_iter_get_layout_extents", "PangoRectangle*");
  XEN_ASSERT_TYPE(XEN_PangoRectangle__P(logical_rect), logical_rect, 3, "pango_layout_iter_get_layout_extents", "PangoRectangle*");
  pango_layout_iter_get_layout_extents(XEN_TO_C_PangoLayoutIter_(iter), XEN_TO_C_PangoRectangle_(ink_rect), XEN_TO_C_PangoRectangle_(logical_rect));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_iter_get_baseline(XEN iter)
{
  #define H_pango_layout_iter_get_baseline "int pango_layout_iter_get_baseline(PangoLayoutIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoLayoutIter__P(iter), iter, 1, "pango_layout_iter_get_baseline", "PangoLayoutIter*");
  return(C_TO_XEN_int(pango_layout_iter_get_baseline(XEN_TO_C_PangoLayoutIter_(iter))));
}
static XEN gxg_pango_language_get_type(void)
{
  #define H_pango_language_get_type "GType pango_language_get_type( void)"
  return(C_TO_XEN_GType(pango_language_get_type()));
}
static XEN gxg_pango_language_from_string(XEN language)
{
  #define H_pango_language_from_string "PangoLanguage* pango_language_from_string(char* language)"
  XEN_ASSERT_TYPE(XEN_char__P(language), language, 1, "pango_language_from_string", "char*");
  return(C_TO_XEN_PangoLanguage_(pango_language_from_string(XEN_TO_C_char_(language))));
}
static XEN gxg_pango_language_matches(XEN language, XEN range_list)
{
  #define H_pango_language_matches "gboolean pango_language_matches(PangoLanguage* language, char* range_list)"
  XEN_ASSERT_TYPE(XEN_PangoLanguage__P(language), language, 1, "pango_language_matches", "PangoLanguage*");
  XEN_ASSERT_TYPE(XEN_char__P(range_list), range_list, 2, "pango_language_matches", "char*");
  return(C_TO_XEN_gboolean(pango_language_matches(XEN_TO_C_PangoLanguage_(language), XEN_TO_C_char_(range_list))));
}
static XEN gxg_G_OBJECT_TYPE(XEN object)
{
  #define H_G_OBJECT_TYPE "GType G_OBJECT_TYPE(GtkObject* object)"
  XEN_ASSERT_TYPE(XEN_GtkObject__P(object), object, 1, "G_OBJECT_TYPE", "GtkObject*");
  return(C_TO_XEN_GType(G_OBJECT_TYPE(XEN_TO_C_GtkObject_(object))));
}
static XEN gxg_g_utf8_validate(XEN str, XEN max_len, XEN end)
{
  #define H_g_utf8_validate "gboolean g_utf8_validate(gchar* str, gssize max_len, gchar** [end])"
  gchar* ref_end = NULL;
  XEN_ASSERT_TYPE(XEN_gchar__P(str), str, 1, "g_utf8_validate", "gchar*");
  XEN_ASSERT_TYPE(XEN_gssize_P(max_len), max_len, 2, "g_utf8_validate", "gssize");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(g_utf8_validate((const gchar*)XEN_TO_C_gchar_(str), XEN_TO_C_gssize(max_len), (const gchar**)&ref_end));
    return(XEN_LIST_2(result, C_TO_XEN_gchar_(ref_end)));
   }
}
static XEN gxg_g_list_free(XEN list)
{
  #define H_g_list_free "void g_list_free(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list), list, 1, "g_list_free", "GList*");
  g_list_free(XEN_TO_C_GList_(list));
  return(XEN_FALSE);
}
static XEN gxg_g_list_reverse(XEN list)
{
  #define H_g_list_reverse "GList* g_list_reverse(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list) || XEN_FALSE_P(list), list, 1, "g_list_reverse", "GList*");
  return(C_TO_XEN_GList_(g_list_reverse(XEN_TO_C_GList_(list))));
}
static XEN gxg_g_list_copy(XEN list)
{
  #define H_g_list_copy "GList* g_list_copy(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list) || XEN_FALSE_P(list), list, 1, "g_list_copy", "GList*");
  return(C_TO_XEN_GList_(g_list_copy(XEN_TO_C_GList_(list))));
}
static XEN gxg_g_list_last(XEN list)
{
  #define H_g_list_last "GList* g_list_last(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list), list, 1, "g_list_last", "GList*");
  return(C_TO_XEN_GList_(g_list_last(XEN_TO_C_GList_(list))));
}
static XEN gxg_g_list_first(XEN list)
{
  #define H_g_list_first "GList* g_list_first(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list), list, 1, "g_list_first", "GList*");
  return(C_TO_XEN_GList_(g_list_first(XEN_TO_C_GList_(list))));
}
static XEN gxg_g_list_length(XEN list)
{
  #define H_g_list_length "guint g_list_length(GList* list)"
  XEN_ASSERT_TYPE(XEN_GList__P(list) || XEN_FALSE_P(list), list, 1, "g_list_length", "GList*");
  return(C_TO_XEN_guint(g_list_length(XEN_TO_C_GList_(list))));
}
static XEN gxg_g_free(XEN mem)
{
  #define H_g_free "void g_free(gpointer mem)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(mem), mem, 1, "g_free", "gpointer");
  g_free(XEN_TO_C_gpointer(mem));
  return(XEN_FALSE);
}
static XEN gxg_g_list_remove_link(XEN list, XEN llink)
{
  #define H_g_list_remove_link "GList* g_list_remove_link(GList* list, GList* llink)"
  XEN_ASSERT_TYPE(XEN_GList__P(list), list, 1, "g_list_remove_link", "GList*");
  XEN_ASSERT_TYPE(XEN_GList__P(llink), llink, 2, "g_list_remove_link", "GList*");
  return(C_TO_XEN_GList_(g_list_remove_link(XEN_TO_C_GList_(list), XEN_TO_C_GList_(llink))));
}
static XEN gxg_g_object_get_data(XEN object, XEN key)
{
  #define H_g_object_get_data "gpointer g_object_get_data(GObject* object, gchar* key)"
  XEN_ASSERT_TYPE(XEN_GObject__P(object), object, 1, "g_object_get_data", "GObject*");
  XEN_ASSERT_TYPE(XEN_gchar__P(key), key, 2, "g_object_get_data", "gchar*");
  return(C_TO_XEN_gpointer(g_object_get_data(XEN_TO_C_GObject_(object), (const gchar*)XEN_TO_C_gchar_(key))));
}
static XEN gxg_g_object_set_data(XEN object, XEN key, XEN data)
{
  #define H_g_object_set_data "void g_object_set_data(GObject* object, gchar* key, gpointer data)"
  XEN_ASSERT_TYPE(XEN_GObject__P(object), object, 1, "g_object_set_data", "GObject*");
  XEN_ASSERT_TYPE(XEN_gchar__P(key), key, 2, "g_object_set_data", "gchar*");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 3, "g_object_set_data", "gpointer");
  g_object_set_data(XEN_TO_C_GObject_(object), (const gchar*)XEN_TO_C_gchar_(key), XEN_TO_C_gpointer(data));
  return(XEN_FALSE);
}
static XEN gxg_g_list_nth_data(XEN list, XEN n)
{
  #define H_g_list_nth_data "gpointer g_list_nth_data(GList* list, guint n)"
  XEN_ASSERT_TYPE(XEN_GList__P(list), list, 1, "g_list_nth_data", "GList*");
  XEN_ASSERT_TYPE(XEN_guint_P(n), n, 2, "g_list_nth_data", "guint");
  return(C_TO_XEN_gpointer(g_list_nth_data(XEN_TO_C_GList_(list), XEN_TO_C_guint(n))));
}
static XEN gxg_g_quark_from_string(XEN string)
{
  #define H_g_quark_from_string "GQuark g_quark_from_string(gchar* string)"
  XEN_ASSERT_TYPE(XEN_gchar__P(string), string, 1, "g_quark_from_string", "gchar*");
  return(C_TO_XEN_GQuark(g_quark_from_string(XEN_TO_C_gchar_(string))));
}
static XEN gxg_g_quark_to_string(XEN quark)
{
  #define H_g_quark_to_string "gchar* g_quark_to_string(GQuark quark)"
  XEN_ASSERT_TYPE(XEN_GQuark_P(quark), quark, 1, "g_quark_to_string", "GQuark");
  return(C_TO_XEN_gchar_(g_quark_to_string(XEN_TO_C_GQuark(quark))));
}
#if HAVE_GDK_DRAW_PIXBUF
static XEN gxg_gdk_draw_pixbuf(XEN arglist)
{
  #define H_gdk_draw_pixbuf "void gdk_draw_pixbuf(GdkDrawable* drawable, GdkGC* gc, GdkPixbuf* pixbuf, \
int src_x, int src_y, int dest_x, int dest_y, int width, int height, GdkRgbDither dither, int x_dither, \
int y_dither)"
  XEN drawable, gc, pixbuf, src_x, src_y, dest_x, dest_y, width, height, dither, x_dither, y_dither;
  drawable = XEN_LIST_REF(arglist, 0);
  gc = XEN_LIST_REF(arglist, 1);
  pixbuf = XEN_LIST_REF(arglist, 2);
  src_x = XEN_LIST_REF(arglist, 3);
  src_y = XEN_LIST_REF(arglist, 4);
  dest_x = XEN_LIST_REF(arglist, 5);
  dest_y = XEN_LIST_REF(arglist, 6);
  width = XEN_LIST_REF(arglist, 7);
  height = XEN_LIST_REF(arglist, 8);
  dither = XEN_LIST_REF(arglist, 9);
  x_dither = XEN_LIST_REF(arglist, 10);
  y_dither = XEN_LIST_REF(arglist, 11);
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_pixbuf", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_pixbuf", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 3, "gdk_draw_pixbuf", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_int_P(src_x), src_x, 4, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(src_y), src_y, 5, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_x), dest_x, 6, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(dest_y), dest_y, 7, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 8, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 9, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_GdkRgbDither_P(dither), dither, 10, "gdk_draw_pixbuf", "GdkRgbDither");
  XEN_ASSERT_TYPE(XEN_int_P(x_dither), x_dither, 11, "gdk_draw_pixbuf", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y_dither), y_dither, 12, "gdk_draw_pixbuf", "int");
  gdk_draw_pixbuf(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_int(src_x), 
                  XEN_TO_C_int(src_y), XEN_TO_C_int(dest_x), XEN_TO_C_int(dest_y), XEN_TO_C_int(width), XEN_TO_C_int(height), 
                  XEN_TO_C_GdkRgbDither(dither), XEN_TO_C_int(x_dither), XEN_TO_C_int(y_dither));
  return(xen_return_first(XEN_FALSE, arglist));
}
static XEN gxg_gtk_tree_model_get_string_from_iter(XEN tree_model, XEN iter)
{
  #define H_gtk_tree_model_get_string_from_iter "gchar* gtk_tree_model_get_string_from_iter(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(tree_model), tree_model, 1, "gtk_tree_model_get_string_from_iter", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_get_string_from_iter", "GtkTreeIter*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_tree_model_get_string_from_iter(XEN_TO_C_GtkTreeModel_(tree_model), XEN_TO_C_GtkTreeIter_(iter));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_tree_model_sort_iter_is_valid(XEN tree_model_sort, XEN iter)
{
  #define H_gtk_tree_model_sort_iter_is_valid "gboolean gtk_tree_model_sort_iter_is_valid(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelSort__P(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_iter_is_valid", "GtkTreeModelSort*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_tree_model_sort_iter_is_valid", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_tree_model_sort_iter_is_valid(XEN_TO_C_GtkTreeModelSort_(tree_model_sort), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_tree_view_expand_to_path(XEN tree_view, XEN path)
{
  #define H_gtk_tree_view_expand_to_path "void gtk_tree_view_expand_to_path(GtkTreeView* tree_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_expand_to_path", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_tree_view_expand_to_path", "GtkTreePath*");
  gtk_tree_view_expand_to_path(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_selection_get_selected_rows(XEN selection, XEN model)
{
  #define H_gtk_tree_selection_get_selected_rows "GList* gtk_tree_selection_get_selected_rows(GtkTreeSelection* selection, \
GtkTreeModel** model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_get_selected_rows", "GtkTreeSelection*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel___P(model), model, 2, "gtk_tree_selection_get_selected_rows", "GtkTreeModel**");
  return(C_TO_XEN_GList_(gtk_tree_selection_get_selected_rows(XEN_TO_C_GtkTreeSelection_(selection), XEN_TO_C_GtkTreeModel__(model))));
}
static XEN gxg_gtk_tree_selection_count_selected_rows(XEN selection)
{
  #define H_gtk_tree_selection_count_selected_rows "int gtk_tree_selection_count_selected_rows(GtkTreeSelection* selection)"
  XEN_ASSERT_TYPE(XEN_GtkTreeSelection__P(selection), selection, 1, "gtk_tree_selection_count_selected_rows", "GtkTreeSelection*");
  return(C_TO_XEN_int(gtk_tree_selection_count_selected_rows(XEN_TO_C_GtkTreeSelection_(selection))));
}
static XEN gxg_gtk_menu_shell_select_first(XEN menu_shell, XEN search_sensitive)
{
  #define H_gtk_menu_shell_select_first "void gtk_menu_shell_select_first(GtkMenuShell* menu_shell, gboolean search_sensitive)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_select_first", "GtkMenuShell*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(search_sensitive), search_sensitive, 2, "gtk_menu_shell_select_first", "gboolean");
  gtk_menu_shell_select_first(XEN_TO_C_GtkMenuShell_(menu_shell), XEN_TO_C_gboolean(search_sensitive));
  return(XEN_FALSE);
}
static XEN gxg_gtk_notebook_get_n_pages(XEN notebook)
{
  #define H_gtk_notebook_get_n_pages "int gtk_notebook_get_n_pages(GtkNotebook* notebook)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_get_n_pages", "GtkNotebook*");
  return(C_TO_XEN_int(gtk_notebook_get_n_pages(XEN_TO_C_GtkNotebook_(notebook))));
}
static XEN gxg_gtk_list_store_reorder(XEN store, XEN new_order)
{
  #define H_gtk_list_store_reorder "void gtk_list_store_reorder(GtkListStore* store, int* new_order)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(store), store, 1, "gtk_list_store_reorder", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_int__P(new_order), new_order, 2, "gtk_list_store_reorder", "int*");
  gtk_list_store_reorder(XEN_TO_C_GtkListStore_(store), XEN_TO_C_int_(new_order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_swap(XEN store, XEN a, XEN b)
{
  #define H_gtk_list_store_swap "void gtk_list_store_swap(GtkListStore* store, GtkTreeIter* a, GtkTreeIter* b)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(store), store, 1, "gtk_list_store_swap", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(a), a, 2, "gtk_list_store_swap", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(b), b, 3, "gtk_list_store_swap", "GtkTreeIter*");
  gtk_list_store_swap(XEN_TO_C_GtkListStore_(store), XEN_TO_C_GtkTreeIter_(a), XEN_TO_C_GtkTreeIter_(b));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_reorder(XEN tree_store, XEN parent, XEN new_order)
{
  #define H_gtk_tree_store_reorder "void gtk_tree_store_reorder(GtkTreeStore* tree_store, GtkTreeIter* parent, \
int* new_order)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_reorder", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(parent), parent, 2, "gtk_tree_store_reorder", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_int__P(new_order), new_order, 3, "gtk_tree_store_reorder", "int*");
  gtk_tree_store_reorder(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(parent), XEN_TO_C_int_(new_order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_store_swap(XEN tree_store, XEN a, XEN b)
{
  #define H_gtk_tree_store_swap "void gtk_tree_store_swap(GtkTreeStore* tree_store, GtkTreeIter* a, GtkTreeIter* b)"
  XEN_ASSERT_TYPE(XEN_GtkTreeStore__P(tree_store), tree_store, 1, "gtk_tree_store_swap", "GtkTreeStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(a), a, 2, "gtk_tree_store_swap", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(b), b, 3, "gtk_tree_store_swap", "GtkTreeIter*");
  gtk_tree_store_swap(XEN_TO_C_GtkTreeStore_(tree_store), XEN_TO_C_GtkTreeIter_(a), XEN_TO_C_GtkTreeIter_(b));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_get_type(void)
{
  #define H_gdk_display_get_type "GType gdk_display_get_type( void)"
  return(C_TO_XEN_GType(gdk_display_get_type()));
}
static XEN gxg_gdk_display_open(XEN display_name)
{
  #define H_gdk_display_open "GdkDisplay* gdk_display_open(gchar* display_name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(display_name), display_name, 1, "gdk_display_open", "gchar*");
  return(C_TO_XEN_GdkDisplay_(gdk_display_open(XEN_TO_C_gchar_(display_name))));
}
static XEN gxg_gdk_display_get_name(XEN display)
{
  #define H_gdk_display_get_name "gchar* gdk_display_get_name(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_name", "GdkDisplay*");
  return(C_TO_XEN_gchar_(gdk_display_get_name(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_n_screens(XEN display)
{
  #define H_gdk_display_get_n_screens "int gdk_display_get_n_screens(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_n_screens", "GdkDisplay*");
  return(C_TO_XEN_int(gdk_display_get_n_screens(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_screen(XEN display, XEN screen_num)
{
  #define H_gdk_display_get_screen "GdkScreen* gdk_display_get_screen(GdkDisplay* display, int screen_num)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_screen", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_int_P(screen_num), screen_num, 2, "gdk_display_get_screen", "int");
  return(C_TO_XEN_GdkScreen_(gdk_display_get_screen(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_int(screen_num))));
}
static XEN gxg_gdk_display_get_default_screen(XEN display)
{
  #define H_gdk_display_get_default_screen "GdkScreen* gdk_display_get_default_screen(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_default_screen", "GdkDisplay*");
  return(C_TO_XEN_GdkScreen_(gdk_display_get_default_screen(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_pointer_ungrab(XEN display, XEN time)
{
  #define H_gdk_display_pointer_ungrab "void gdk_display_pointer_ungrab(GdkDisplay* display, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_pointer_ungrab", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 2, "gdk_display_pointer_ungrab", "guint32");
  gdk_display_pointer_ungrab(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_keyboard_ungrab(XEN display, XEN time)
{
  #define H_gdk_display_keyboard_ungrab "void gdk_display_keyboard_ungrab(GdkDisplay* display, guint32 time)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_keyboard_ungrab", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_guint32_P(time), time, 2, "gdk_display_keyboard_ungrab", "guint32");
  gdk_display_keyboard_ungrab(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_guint32(time));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_pointer_is_grabbed(XEN display)
{
  #define H_gdk_display_pointer_is_grabbed "gboolean gdk_display_pointer_is_grabbed(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_pointer_is_grabbed", "GdkDisplay*");
  return(C_TO_XEN_gboolean(gdk_display_pointer_is_grabbed(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_beep(XEN display)
{
  #define H_gdk_display_beep "void gdk_display_beep(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_beep", "GdkDisplay*");
  gdk_display_beep(XEN_TO_C_GdkDisplay_(display));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_sync(XEN display)
{
  #define H_gdk_display_sync "void gdk_display_sync(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_sync", "GdkDisplay*");
  gdk_display_sync(XEN_TO_C_GdkDisplay_(display));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_close(XEN display)
{
  #define H_gdk_display_close "void gdk_display_close(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_close", "GdkDisplay*");
  gdk_display_close(XEN_TO_C_GdkDisplay_(display));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_list_devices(XEN display)
{
  #define H_gdk_display_list_devices "GList* gdk_display_list_devices(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_list_devices", "GdkDisplay*");
  return(C_TO_XEN_GList_(gdk_display_list_devices(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_event(XEN display)
{
  #define H_gdk_display_get_event "GdkEvent* gdk_display_get_event(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_event", "GdkDisplay*");
  return(C_TO_XEN_GdkEvent_(gdk_display_get_event(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_peek_event(XEN display)
{
  #define H_gdk_display_peek_event "GdkEvent* gdk_display_peek_event(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_peek_event", "GdkDisplay*");
  return(C_TO_XEN_GdkEvent_(gdk_display_peek_event(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_put_event(XEN display, XEN event)
{
  #define H_gdk_display_put_event "void gdk_display_put_event(GdkDisplay* display, GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_put_event", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gdk_display_put_event", "GdkEvent*");
  gdk_display_put_event(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_add_client_message_filter(XEN display, XEN message_type, XEN func, XEN func_data)
{
  #define H_gdk_display_add_client_message_filter "void gdk_display_add_client_message_filter(GdkDisplay* display, \
GdkAtom message_type, GdkFilterFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_add_client_message_filter", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(message_type), message_type, 2, "gdk_display_add_client_message_filter", "GdkAtom");
  XEN_ASSERT_TYPE(XEN_GdkFilterFunc_P(func), func, 3, "gdk_display_add_client_message_filter", "GdkFilterFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gdk_display_add_client_message_filter", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gdk_display_add_client_message_filter(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_GdkAtom(message_type), XEN_TO_C_GdkFilterFunc(func), 
                                      XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gdk_display_set_double_click_time(XEN display, XEN msec)
{
  #define H_gdk_display_set_double_click_time "void gdk_display_set_double_click_time(GdkDisplay* display, \
guint msec)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_set_double_click_time", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_guint_P(msec), msec, 2, "gdk_display_set_double_click_time", "guint");
  gdk_display_set_double_click_time(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_guint(msec));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_get_default(void)
{
  #define H_gdk_display_get_default "GdkDisplay* gdk_display_get_default( void)"
  return(C_TO_XEN_GdkDisplay_(gdk_display_get_default()));
}
static XEN gxg_gdk_display_get_core_pointer(XEN display)
{
  #define H_gdk_display_get_core_pointer "GdkDevice* gdk_display_get_core_pointer(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_core_pointer", "GdkDisplay*");
  return(C_TO_XEN_GdkDevice_(gdk_display_get_core_pointer(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_pointer(XEN display, XEN screen, XEN x, XEN y, XEN mask)
{
  #define H_gdk_display_get_pointer "void gdk_display_get_pointer(GdkDisplay* display, GdkScreen** [screen], \
int* [x], int* [y], GdkModifierType* [mask])"
  GdkScreen* ref_screen = NULL;
  int ref_x;
  int ref_y;
  GdkModifierType ref_mask;
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_pointer", "GdkDisplay*");
  gdk_display_get_pointer(XEN_TO_C_GdkDisplay_(display), &ref_screen, &ref_x, &ref_y, &ref_mask);
  return(XEN_LIST_4(C_TO_XEN_GdkScreen_(ref_screen), C_TO_XEN_int(ref_x), C_TO_XEN_int(ref_y), C_TO_XEN_GdkModifierType(ref_mask)));
}
static XEN gxg_gdk_display_get_window_at_pointer(XEN display, XEN win_x, XEN win_y)
{
  #define H_gdk_display_get_window_at_pointer "GdkWindow* gdk_display_get_window_at_pointer(GdkDisplay* display, \
int* [win_x], int* [win_y])"
  int ref_win_x;
  int ref_win_y;
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_window_at_pointer", "GdkDisplay*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkWindow_(gdk_display_get_window_at_pointer(XEN_TO_C_GdkDisplay_(display), &ref_win_x, &ref_win_y));
    return(XEN_LIST_3(result, C_TO_XEN_int(ref_win_x), C_TO_XEN_int(ref_win_y)));
   }
}
static XEN gxg_gdk_screen_get_type(void)
{
  #define H_gdk_screen_get_type "GType gdk_screen_get_type( void)"
  return(C_TO_XEN_GType(gdk_screen_get_type()));
}
static XEN gxg_gdk_screen_get_default_colormap(XEN screen)
{
  #define H_gdk_screen_get_default_colormap "GdkColormap* gdk_screen_get_default_colormap(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_default_colormap", "GdkScreen*");
  return(C_TO_XEN_GdkColormap_(gdk_screen_get_default_colormap(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_set_default_colormap(XEN screen, XEN colormap)
{
  #define H_gdk_screen_set_default_colormap "void gdk_screen_set_default_colormap(GdkScreen* screen, \
GdkColormap* colormap)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_set_default_colormap", "GdkScreen*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap), colormap, 2, "gdk_screen_set_default_colormap", "GdkColormap*");
  gdk_screen_set_default_colormap(XEN_TO_C_GdkScreen_(screen), XEN_TO_C_GdkColormap_(colormap));
  return(XEN_FALSE);
}
static XEN gxg_gdk_screen_get_system_colormap(XEN screen)
{
  #define H_gdk_screen_get_system_colormap "GdkColormap* gdk_screen_get_system_colormap(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_system_colormap", "GdkScreen*");
  return(C_TO_XEN_GdkColormap_(gdk_screen_get_system_colormap(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_system_visual(XEN screen)
{
  #define H_gdk_screen_get_system_visual "GdkVisual* gdk_screen_get_system_visual(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_system_visual", "GdkScreen*");
  return(C_TO_XEN_GdkVisual_(gdk_screen_get_system_visual(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_rgb_colormap(XEN screen)
{
  #define H_gdk_screen_get_rgb_colormap "GdkColormap* gdk_screen_get_rgb_colormap(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_rgb_colormap", "GdkScreen*");
  return(C_TO_XEN_GdkColormap_(gdk_screen_get_rgb_colormap(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_rgb_visual(XEN screen)
{
  #define H_gdk_screen_get_rgb_visual "GdkVisual* gdk_screen_get_rgb_visual(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_rgb_visual", "GdkScreen*");
  return(C_TO_XEN_GdkVisual_(gdk_screen_get_rgb_visual(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_root_window(XEN screen)
{
  #define H_gdk_screen_get_root_window "GdkWindow* gdk_screen_get_root_window(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_root_window", "GdkScreen*");
  return(C_TO_XEN_GdkWindow_(gdk_screen_get_root_window(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_display(XEN screen)
{
  #define H_gdk_screen_get_display "GdkDisplay* gdk_screen_get_display(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_display", "GdkScreen*");
  return(C_TO_XEN_GdkDisplay_(gdk_screen_get_display(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_number(XEN screen)
{
  #define H_gdk_screen_get_number "int gdk_screen_get_number(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_number", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_number(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_width(XEN screen)
{
  #define H_gdk_screen_get_width "int gdk_screen_get_width(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_width", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_width(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_height(XEN screen)
{
  #define H_gdk_screen_get_height "int gdk_screen_get_height(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_height", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_height(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_width_mm(XEN screen)
{
  #define H_gdk_screen_get_width_mm "int gdk_screen_get_width_mm(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_width_mm", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_width_mm(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_height_mm(XEN screen)
{
  #define H_gdk_screen_get_height_mm "int gdk_screen_get_height_mm(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_height_mm", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_height_mm(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_list_visuals(XEN screen)
{
  #define H_gdk_screen_list_visuals "GList* gdk_screen_list_visuals(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_list_visuals", "GdkScreen*");
  return(C_TO_XEN_GList_(gdk_screen_list_visuals(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_toplevel_windows(XEN screen)
{
  #define H_gdk_screen_get_toplevel_windows "GList* gdk_screen_get_toplevel_windows(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_toplevel_windows", "GdkScreen*");
  return(C_TO_XEN_GList_(gdk_screen_get_toplevel_windows(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_make_display_name(XEN screen)
{
  #define H_gdk_screen_make_display_name "gchar* gdk_screen_make_display_name(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_make_display_name", "GdkScreen*");
  {
   gchar* result;
   XEN rtn;
   result = gdk_screen_make_display_name(XEN_TO_C_GdkScreen_(screen));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gdk_screen_get_n_monitors(XEN screen)
{
  #define H_gdk_screen_get_n_monitors "int gdk_screen_get_n_monitors(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_n_monitors", "GdkScreen*");
  return(C_TO_XEN_int(gdk_screen_get_n_monitors(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_screen_get_monitor_geometry(XEN screen, XEN monitor_num, XEN dest)
{
  #define H_gdk_screen_get_monitor_geometry "void gdk_screen_get_monitor_geometry(GdkScreen* screen, \
int monitor_num, GdkRectangle* dest)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_monitor_geometry", "GdkScreen*");
  XEN_ASSERT_TYPE(XEN_int_P(monitor_num), monitor_num, 2, "gdk_screen_get_monitor_geometry", "int");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(dest), dest, 3, "gdk_screen_get_monitor_geometry", "GdkRectangle*");
  gdk_screen_get_monitor_geometry(XEN_TO_C_GdkScreen_(screen), XEN_TO_C_int(monitor_num), XEN_TO_C_GdkRectangle_(dest));
  return(XEN_FALSE);
}
static XEN gxg_gdk_screen_get_monitor_at_point(XEN screen, XEN x, XEN y)
{
  #define H_gdk_screen_get_monitor_at_point "int gdk_screen_get_monitor_at_point(GdkScreen* screen, int x, \
int y)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_monitor_at_point", "GdkScreen*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 2, "gdk_screen_get_monitor_at_point", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 3, "gdk_screen_get_monitor_at_point", "int");
  return(C_TO_XEN_int(gdk_screen_get_monitor_at_point(XEN_TO_C_GdkScreen_(screen), XEN_TO_C_int(x), XEN_TO_C_int(y))));
}
static XEN gxg_gdk_screen_get_monitor_at_window(XEN screen, XEN window)
{
  #define H_gdk_screen_get_monitor_at_window "int gdk_screen_get_monitor_at_window(GdkScreen* screen, \
GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_get_monitor_at_window", "GdkScreen*");
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 2, "gdk_screen_get_monitor_at_window", "GdkWindow*");
  return(C_TO_XEN_int(gdk_screen_get_monitor_at_window(XEN_TO_C_GdkScreen_(screen), XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gdk_screen_broadcast_client_message(XEN screen, XEN event)
{
  #define H_gdk_screen_broadcast_client_message "void gdk_screen_broadcast_client_message(GdkScreen* screen, \
GdkEvent* event)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_screen_broadcast_client_message", "GdkScreen*");
  XEN_ASSERT_TYPE(XEN_GdkEvent__P(event), event, 2, "gdk_screen_broadcast_client_message", "GdkEvent*");
  gdk_screen_broadcast_client_message(XEN_TO_C_GdkScreen_(screen), XEN_TO_C_GdkEvent_(event));
  return(XEN_FALSE);
}
static XEN gxg_gdk_screen_get_default(void)
{
  #define H_gdk_screen_get_default "GdkScreen* gdk_screen_get_default( void)"
  return(C_TO_XEN_GdkScreen_(gdk_screen_get_default()));
}
static XEN gxg_gtk_clipboard_get_for_display(XEN display, XEN selection)
{
  #define H_gtk_clipboard_get_for_display "GtkClipboard* gtk_clipboard_get_for_display(GdkDisplay* display, \
GdkAtom selection)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gtk_clipboard_get_for_display", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_clipboard_get_for_display", "GdkAtom");
  return(C_TO_XEN_GtkClipboard_(gtk_clipboard_get_for_display(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_GdkAtom(selection))));
}
static XEN gxg_gtk_clipboard_get_display(XEN clipboard)
{
  #define H_gtk_clipboard_get_display "GdkDisplay* gtk_clipboard_get_display(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_get_display", "GtkClipboard*");
  return(C_TO_XEN_GdkDisplay_(gtk_clipboard_get_display(XEN_TO_C_GtkClipboard_(clipboard))));
}
static XEN gxg_gtk_widget_get_screen(XEN widget)
{
  #define H_gtk_widget_get_screen "GdkScreen* gtk_widget_get_screen(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_screen", "GtkWidget*");
  return(C_TO_XEN_GdkScreen_(gtk_widget_get_screen(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_has_screen(XEN widget)
{
  #define H_gtk_widget_has_screen "gboolean gtk_widget_has_screen(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_has_screen", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_has_screen(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_display(XEN widget)
{
  #define H_gtk_widget_get_display "GdkDisplay* gtk_widget_get_display(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_display", "GtkWidget*");
  return(C_TO_XEN_GdkDisplay_(gtk_widget_get_display(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_root_window(XEN widget)
{
  #define H_gtk_widget_get_root_window "GdkWindow* gtk_widget_get_root_window(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_root_window", "GtkWidget*");
  return(C_TO_XEN_GdkWindow_(gtk_widget_get_root_window(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_get_clipboard(XEN widget, XEN selection)
{
  #define H_gtk_widget_get_clipboard "GtkClipboard* gtk_widget_get_clipboard(GtkWidget* widget, GdkAtom selection)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_clipboard", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(selection), selection, 2, "gtk_widget_get_clipboard", "GdkAtom");
  return(C_TO_XEN_GtkClipboard_(gtk_widget_get_clipboard(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GdkAtom(selection))));
}
#endif

#if HAVE_GTK_TREE_VIEW_COLUMN_CELL_GET_POSITION
static XEN gxg_gdk_get_display_arg_name(void)
{
  #define H_gdk_get_display_arg_name "gchar* gdk_get_display_arg_name( void)"
  return(C_TO_XEN_gchar_(gdk_get_display_arg_name()));
}
static XEN gxg_gdk_notify_startup_complete(void)
{
  #define H_gdk_notify_startup_complete "void gdk_notify_startup_complete( void)"
  gdk_notify_startup_complete();
  return(XEN_FALSE);
}
static XEN gxg_gdk_pixmap_new(XEN window, XEN width, XEN height, XEN depth)
{
  #define H_gdk_pixmap_new "GdkPixmap* gdk_pixmap_new(GdkDrawable* window, gint width, gint height, gint depth)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_new", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gdk_pixmap_new", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 3, "gdk_pixmap_new", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(depth), depth, 4, "gdk_pixmap_new", "gint");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_new(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_gint(width), XEN_TO_C_gint(height), XEN_TO_C_gint(depth))));
}
static XEN gxg_gdk_bitmap_create_from_data(XEN window, XEN data, XEN width, XEN height)
{
  #define H_gdk_bitmap_create_from_data "GdkBitmap* gdk_bitmap_create_from_data(GdkDrawable* window, \
gchar* data, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_bitmap_create_from_data", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_gchar__P(data), data, 2, "gdk_bitmap_create_from_data", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 3, "gdk_bitmap_create_from_data", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 4, "gdk_bitmap_create_from_data", "gint");
  return(C_TO_XEN_GdkBitmap_(gdk_bitmap_create_from_data(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_gchar_(data), XEN_TO_C_gint(width), 
                                                         XEN_TO_C_gint(height))));
}
static XEN gxg_gdk_pixmap_create_from_data(XEN window, XEN data, XEN width, XEN height, XEN depth, XEN fg, XEN bg)
{
  #define H_gdk_pixmap_create_from_data "GdkPixmap* gdk_pixmap_create_from_data(GdkDrawable* window, \
gchar* data, gint width, gint height, gint depth, GdkColor* fg, GdkColor* bg)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_create_from_data", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_gchar__P(data), data, 2, "gdk_pixmap_create_from_data", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 3, "gdk_pixmap_create_from_data", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 4, "gdk_pixmap_create_from_data", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(depth), depth, 5, "gdk_pixmap_create_from_data", "gint");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(fg), fg, 6, "gdk_pixmap_create_from_data", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(bg), bg, 7, "gdk_pixmap_create_from_data", "GdkColor*");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_create_from_data(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_gchar_(data), XEN_TO_C_gint(width), 
                                                         XEN_TO_C_gint(height), XEN_TO_C_gint(depth), XEN_TO_C_GdkColor_(fg), 
                                                         XEN_TO_C_GdkColor_(bg))));
}
static XEN gxg_gdk_pixmap_create_from_xpm(XEN window, XEN mask, XEN transparent_color, XEN filename)
{
  #define H_gdk_pixmap_create_from_xpm "GdkPixmap* gdk_pixmap_create_from_xpm(GdkDrawable* window, GdkBitmap** mask, \
GdkColor* transparent_color, gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_create_from_xpm", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap___P(mask) || XEN_FALSE_P(mask), mask, 2, "gdk_pixmap_create_from_xpm", "GdkBitmap**");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(transparent_color), transparent_color, 3, "gdk_pixmap_create_from_xpm", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 4, "gdk_pixmap_create_from_xpm", "gchar*");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_create_from_xpm(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_GdkBitmap__(mask), XEN_TO_C_GdkColor_(transparent_color), 
                                                        XEN_TO_C_gchar_(filename))));
}
static XEN gxg_gdk_pixmap_colormap_create_from_xpm(XEN window, XEN colormap, XEN mask, XEN transparent_color, XEN filename)
{
  #define H_gdk_pixmap_colormap_create_from_xpm "GdkPixmap* gdk_pixmap_colormap_create_from_xpm(GdkDrawable* window, \
GdkColormap* colormap, GdkBitmap** mask, GdkColor* transparent_color, gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_colormap_create_from_xpm", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap) || XEN_FALSE_P(colormap), colormap, 2, "gdk_pixmap_colormap_create_from_xpm", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap___P(mask) || XEN_FALSE_P(mask), mask, 3, "gdk_pixmap_colormap_create_from_xpm", "GdkBitmap**");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(transparent_color), transparent_color, 4, "gdk_pixmap_colormap_create_from_xpm", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 5, "gdk_pixmap_colormap_create_from_xpm", "gchar*");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_colormap_create_from_xpm(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_GdkColormap_(colormap), 
                                                                 XEN_TO_C_GdkBitmap__(mask), XEN_TO_C_GdkColor_(transparent_color), 
                                                                 XEN_TO_C_gchar_(filename))));
}
static XEN gxg_gdk_pixmap_create_from_xpm_d(XEN window, XEN mask, XEN transparent_color, XEN data)
{
  #define H_gdk_pixmap_create_from_xpm_d "GdkPixmap* gdk_pixmap_create_from_xpm_d(GdkDrawable* window, \
GdkBitmap** mask, GdkColor* transparent_color, gchar** data)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_create_from_xpm_d", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap___P(mask) || XEN_FALSE_P(mask), mask, 2, "gdk_pixmap_create_from_xpm_d", "GdkBitmap**");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(transparent_color), transparent_color, 3, "gdk_pixmap_create_from_xpm_d", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gchar___P(data), data, 4, "gdk_pixmap_create_from_xpm_d", "gchar**");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_create_from_xpm_d(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_GdkBitmap__(mask), XEN_TO_C_GdkColor_(transparent_color), 
                                                          XEN_TO_C_gchar__(data))));
}
static XEN gxg_gdk_pixmap_colormap_create_from_xpm_d(XEN window, XEN colormap, XEN mask, XEN transparent_color, XEN data)
{
  #define H_gdk_pixmap_colormap_create_from_xpm_d "GdkPixmap* gdk_pixmap_colormap_create_from_xpm_d(GdkDrawable* window, \
GdkColormap* colormap, GdkBitmap** mask, GdkColor* transparent_color, gchar** data)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(window), window, 1, "gdk_pixmap_colormap_create_from_xpm_d", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(colormap) || XEN_FALSE_P(colormap), colormap, 2, "gdk_pixmap_colormap_create_from_xpm_d", "GdkColormap*");
  XEN_ASSERT_TYPE(XEN_GdkBitmap___P(mask) || XEN_FALSE_P(mask), mask, 3, "gdk_pixmap_colormap_create_from_xpm_d", "GdkBitmap**");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(transparent_color), transparent_color, 4, "gdk_pixmap_colormap_create_from_xpm_d", "GdkColor*");
  XEN_ASSERT_TYPE(XEN_gchar___P(data), data, 5, "gdk_pixmap_colormap_create_from_xpm_d", "gchar**");
  return(C_TO_XEN_GdkPixmap_(gdk_pixmap_colormap_create_from_xpm_d(XEN_TO_C_GdkDrawable_(window), XEN_TO_C_GdkColormap_(colormap), 
                                                                   XEN_TO_C_GdkBitmap__(mask), XEN_TO_C_GdkColor_(transparent_color), 
                                                                   XEN_TO_C_gchar__(data))));
}
static XEN gxg_gtk_tree_view_column_cell_get_position(XEN tree_column, XEN cell_renderer, XEN start_pos, XEN width)
{
  #define H_gtk_tree_view_column_cell_get_position "gboolean gtk_tree_view_column_cell_get_position(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gint* [start_pos], gint* [width])"
  gint ref_start_pos;
  gint ref_width;
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_cell_get_position", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_cell_get_position", "GtkCellRenderer*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tree_view_column_cell_get_position(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_GtkCellRenderer_(cell_renderer), 
                                                                      &ref_start_pos, &ref_width));
    return(XEN_LIST_3(result, C_TO_XEN_gint(ref_start_pos), C_TO_XEN_gint(ref_width)));
   }
}
static XEN gxg_gtk_window_set_auto_startup_notification(XEN setting)
{
  #define H_gtk_window_set_auto_startup_notification "void gtk_window_set_auto_startup_notification(gboolean setting)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 1, "gtk_window_set_auto_startup_notification", "gboolean");
  gtk_window_set_auto_startup_notification(XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_move_after(XEN store, XEN iter, XEN position)
{
  #define H_gtk_list_store_move_after "void gtk_list_store_move_after(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(store), store, 1, "gtk_list_store_move_after", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_move_after", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(position) || XEN_FALSE_P(position), position, 3, "gtk_list_store_move_after", "GtkTreeIter*");
  gtk_list_store_move_after(XEN_TO_C_GtkListStore_(store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_move_before(XEN store, XEN iter, XEN position)
{
  #define H_gtk_list_store_move_before "void gtk_list_store_move_before(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(store), store, 1, "gtk_list_store_move_before", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_move_before", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(position) || XEN_FALSE_P(position), position, 3, "gtk_list_store_move_before", "GtkTreeIter*");
  gtk_list_store_move_before(XEN_TO_C_GtkListStore_(store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_GtkTreeIter_(position));
  return(XEN_FALSE);
}
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
static XEN gxg_gdk_cursor_new_from_pixbuf(XEN display, XEN pixbuf, XEN x, XEN y)
{
  #define H_gdk_cursor_new_from_pixbuf "GdkCursor* gdk_cursor_new_from_pixbuf(GdkDisplay* display, GdkPixbuf* pixbuf, \
gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_cursor_new_from_pixbuf", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 2, "gdk_cursor_new_from_pixbuf", "GdkPixbuf*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 3, "gdk_cursor_new_from_pixbuf", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 4, "gdk_cursor_new_from_pixbuf", "gint");
  return(C_TO_XEN_GdkCursor_(gdk_cursor_new_from_pixbuf(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_GdkPixbuf_(pixbuf), XEN_TO_C_gint(x), 
                                                        XEN_TO_C_gint(y))));
}
static XEN gxg_gdk_display_flush(XEN display)
{
  #define H_gdk_display_flush "void gdk_display_flush(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_flush", "GdkDisplay*");
  gdk_display_flush(XEN_TO_C_GdkDisplay_(display));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_supports_cursor_alpha(XEN display)
{
  #define H_gdk_display_supports_cursor_alpha "gboolean gdk_display_supports_cursor_alpha(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_supports_cursor_alpha", "GdkDisplay*");
  return(C_TO_XEN_gboolean(gdk_display_supports_cursor_alpha(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_supports_cursor_color(XEN display)
{
  #define H_gdk_display_supports_cursor_color "gboolean gdk_display_supports_cursor_color(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_supports_cursor_color", "GdkDisplay*");
  return(C_TO_XEN_gboolean(gdk_display_supports_cursor_color(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_default_cursor_size(XEN display)
{
  #define H_gdk_display_get_default_cursor_size "guint gdk_display_get_default_cursor_size(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_default_cursor_size", "GdkDisplay*");
  return(C_TO_XEN_guint(gdk_display_get_default_cursor_size(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_display_get_maximal_cursor_size(XEN display, XEN width, XEN height)
{
  #define H_gdk_display_get_maximal_cursor_size "void gdk_display_get_maximal_cursor_size(GdkDisplay* display, \
guint* [width], guint* [height])"
  guint ref_width;
  guint ref_height;
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_maximal_cursor_size", "GdkDisplay*");
  gdk_display_get_maximal_cursor_size(XEN_TO_C_GdkDisplay_(display), &ref_width, &ref_height);
  return(XEN_LIST_2(C_TO_XEN_guint(ref_width), C_TO_XEN_guint(ref_height)));
}
static XEN gxg_gdk_window_set_keep_above(XEN window, XEN setting)
{
  #define H_gdk_window_set_keep_above "void gdk_window_set_keep_above(GdkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_keep_above", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gdk_window_set_keep_above", "gboolean");
  gdk_window_set_keep_above(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_set_keep_below(XEN window, XEN setting)
{
  #define H_gdk_window_set_keep_below "void gdk_window_set_keep_below(GdkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_keep_below", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gdk_window_set_keep_below", "gboolean");
  gdk_window_set_keep_below(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_alignment_set_padding(XEN alignment, XEN padding_top, XEN padding_bottom, XEN padding_left, XEN padding_right)
{
  #define H_gtk_alignment_set_padding "void gtk_alignment_set_padding(GtkAlignment* alignment, guint padding_top, \
guint padding_bottom, guint padding_left, guint padding_right)"
  XEN_ASSERT_TYPE(XEN_GtkAlignment__P(alignment), alignment, 1, "gtk_alignment_set_padding", "GtkAlignment*");
  XEN_ASSERT_TYPE(XEN_guint_P(padding_top), padding_top, 2, "gtk_alignment_set_padding", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(padding_bottom), padding_bottom, 3, "gtk_alignment_set_padding", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(padding_left), padding_left, 4, "gtk_alignment_set_padding", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(padding_right), padding_right, 5, "gtk_alignment_set_padding", "guint");
  gtk_alignment_set_padding(XEN_TO_C_GtkAlignment_(alignment), XEN_TO_C_guint(padding_top), XEN_TO_C_guint(padding_bottom), 
                            XEN_TO_C_guint(padding_left), XEN_TO_C_guint(padding_right));
  return(XEN_FALSE);
}
static XEN gxg_gtk_alignment_get_padding(XEN alignment, XEN padding_top, XEN padding_bottom, XEN padding_left, XEN padding_right)
{
  #define H_gtk_alignment_get_padding "void gtk_alignment_get_padding(GtkAlignment* alignment, guint* [padding_top], \
guint* [padding_bottom], guint* [padding_left], guint* [padding_right])"
  guint ref_padding_top;
  guint ref_padding_bottom;
  guint ref_padding_left;
  guint ref_padding_right;
  XEN_ASSERT_TYPE(XEN_GtkAlignment__P(alignment), alignment, 1, "gtk_alignment_get_padding", "GtkAlignment*");
  gtk_alignment_get_padding(XEN_TO_C_GtkAlignment_(alignment), &ref_padding_top, &ref_padding_bottom, &ref_padding_left, 
                            &ref_padding_right);
  return(XEN_LIST_4(C_TO_XEN_guint(ref_padding_top), C_TO_XEN_guint(ref_padding_bottom), C_TO_XEN_guint(ref_padding_left), C_TO_XEN_guint(ref_padding_right)));
}
static XEN gxg_gtk_button_box_get_child_secondary(XEN widget, XEN child)
{
  #define H_gtk_button_box_get_child_secondary "gboolean gtk_button_box_get_child_secondary(GtkButtonBox* widget, \
GtkWidget* child)"
  XEN_ASSERT_TYPE(XEN_GtkButtonBox__P(widget), widget, 1, "gtk_button_box_get_child_secondary", "GtkButtonBox*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_button_box_get_child_secondary", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_button_box_get_child_secondary(XEN_TO_C_GtkButtonBox_(widget), XEN_TO_C_GtkWidget_(child))));
}
static XEN gxg_gtk_button_set_focus_on_click(XEN button, XEN focus_on_click)
{
  #define H_gtk_button_set_focus_on_click "void gtk_button_set_focus_on_click(GtkButton* button, gboolean focus_on_click)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_focus_on_click", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(focus_on_click), focus_on_click, 2, "gtk_button_set_focus_on_click", "gboolean");
  gtk_button_set_focus_on_click(XEN_TO_C_GtkButton_(button), XEN_TO_C_gboolean(focus_on_click));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_focus_on_click(XEN button)
{
  #define H_gtk_button_get_focus_on_click "gboolean gtk_button_get_focus_on_click(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_focus_on_click", "GtkButton*");
  return(C_TO_XEN_gboolean(gtk_button_get_focus_on_click(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_calendar_set_display_options(XEN calendar, XEN flags)
{
  #define H_gtk_calendar_set_display_options "void gtk_calendar_set_display_options(GtkCalendar* calendar, \
GtkCalendarDisplayOptions flags)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_set_display_options", "GtkCalendar*");
  XEN_ASSERT_TYPE(XEN_GtkCalendarDisplayOptions_P(flags), flags, 2, "gtk_calendar_set_display_options", "GtkCalendarDisplayOptions");
  gtk_calendar_set_display_options(XEN_TO_C_GtkCalendar_(calendar), XEN_TO_C_GtkCalendarDisplayOptions(flags));
  return(XEN_FALSE);
}
static XEN gxg_gtk_calendar_get_display_options(XEN calendar)
{
  #define H_gtk_calendar_get_display_options "GtkCalendarDisplayOptions gtk_calendar_get_display_options(GtkCalendar* calendar)"
  XEN_ASSERT_TYPE(XEN_GtkCalendar__P(calendar), calendar, 1, "gtk_calendar_get_display_options", "GtkCalendar*");
  return(C_TO_XEN_GtkCalendarDisplayOptions(gtk_calendar_get_display_options(XEN_TO_C_GtkCalendar_(calendar))));
}
static XEN gxg_gtk_check_menu_item_set_draw_as_radio(XEN check_menu_item, XEN draw_as_radio)
{
  #define H_gtk_check_menu_item_set_draw_as_radio "void gtk_check_menu_item_set_draw_as_radio(GtkCheckMenuItem* check_menu_item, \
gboolean draw_as_radio)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_draw_as_radio", "GtkCheckMenuItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(draw_as_radio), draw_as_radio, 2, "gtk_check_menu_item_set_draw_as_radio", "gboolean");
  gtk_check_menu_item_set_draw_as_radio(XEN_TO_C_GtkCheckMenuItem_(check_menu_item), XEN_TO_C_gboolean(draw_as_radio));
  return(XEN_FALSE);
}
static XEN gxg_gtk_check_menu_item_get_draw_as_radio(XEN check_menu_item)
{
  #define H_gtk_check_menu_item_get_draw_as_radio "gboolean gtk_check_menu_item_get_draw_as_radio(GtkCheckMenuItem* check_menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkCheckMenuItem__P(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_draw_as_radio", "GtkCheckMenuItem*");
  return(C_TO_XEN_gboolean(gtk_check_menu_item_get_draw_as_radio(XEN_TO_C_GtkCheckMenuItem_(check_menu_item))));
}
static XEN gxg_gtk_entry_set_completion(XEN entry, XEN completion)
{
  #define H_gtk_entry_set_completion "void gtk_entry_set_completion(GtkEntry* entry, GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_completion", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 2, "gtk_entry_set_completion", "GtkEntryCompletion*");
  gtk_entry_set_completion(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_GtkEntryCompletion_(completion));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_completion(XEN entry)
{
  #define H_gtk_entry_get_completion "GtkEntryCompletion* gtk_entry_get_completion(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_completion", "GtkEntry*");
  return(C_TO_XEN_GtkEntryCompletion_(gtk_entry_get_completion(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_event_box_get_visible_window(XEN event_box)
{
  #define H_gtk_event_box_get_visible_window "gboolean gtk_event_box_get_visible_window(GtkEventBox* event_box)"
  XEN_ASSERT_TYPE(XEN_GtkEventBox__P(event_box), event_box, 1, "gtk_event_box_get_visible_window", "GtkEventBox*");
  return(C_TO_XEN_gboolean(gtk_event_box_get_visible_window(XEN_TO_C_GtkEventBox_(event_box))));
}
static XEN gxg_gtk_event_box_set_visible_window(XEN event_box, XEN visible_window)
{
  #define H_gtk_event_box_set_visible_window "void gtk_event_box_set_visible_window(GtkEventBox* event_box, \
gboolean visible_window)"
  XEN_ASSERT_TYPE(XEN_GtkEventBox__P(event_box), event_box, 1, "gtk_event_box_set_visible_window", "GtkEventBox*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible_window), visible_window, 2, "gtk_event_box_set_visible_window", "gboolean");
  gtk_event_box_set_visible_window(XEN_TO_C_GtkEventBox_(event_box), XEN_TO_C_gboolean(visible_window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_event_box_get_above_child(XEN event_box)
{
  #define H_gtk_event_box_get_above_child "gboolean gtk_event_box_get_above_child(GtkEventBox* event_box)"
  XEN_ASSERT_TYPE(XEN_GtkEventBox__P(event_box), event_box, 1, "gtk_event_box_get_above_child", "GtkEventBox*");
  return(C_TO_XEN_gboolean(gtk_event_box_get_above_child(XEN_TO_C_GtkEventBox_(event_box))));
}
static XEN gxg_gtk_event_box_set_above_child(XEN event_box, XEN above_child)
{
  #define H_gtk_event_box_set_above_child "void gtk_event_box_set_above_child(GtkEventBox* event_box, \
gboolean above_child)"
  XEN_ASSERT_TYPE(XEN_GtkEventBox__P(event_box), event_box, 1, "gtk_event_box_set_above_child", "GtkEventBox*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(above_child), above_child, 2, "gtk_event_box_set_above_child", "gboolean");
  gtk_event_box_set_above_child(XEN_TO_C_GtkEventBox_(event_box), XEN_TO_C_gboolean(above_child));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_source_get_icon_name(XEN source)
{
  #define H_gtk_icon_source_get_icon_name "gchar* gtk_icon_source_get_icon_name(GtkIconSource* source)"
  XEN_ASSERT_TYPE(XEN_GtkIconSource__P(source), source, 1, "gtk_icon_source_get_icon_name", "GtkIconSource*");
  return(C_TO_XEN_gchar_(gtk_icon_source_get_icon_name(XEN_TO_C_GtkIconSource_(source))));
}
static XEN gxg_gtk_menu_attach(XEN menu, XEN child, XEN left_attach, XEN right_attach, XEN top_attach, XEN bottom_attach)
{
  #define H_gtk_menu_attach "void gtk_menu_attach(GtkMenu* menu, GtkWidget* child, guint left_attach, \
guint right_attach, guint top_attach, guint bottom_attach)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_attach", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_menu_attach", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint_P(left_attach), left_attach, 3, "gtk_menu_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(right_attach), right_attach, 4, "gtk_menu_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(top_attach), top_attach, 5, "gtk_menu_attach", "guint");
  XEN_ASSERT_TYPE(XEN_guint_P(bottom_attach), bottom_attach, 6, "gtk_menu_attach", "guint");
  gtk_menu_attach(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_GtkWidget_(child), XEN_TO_C_guint(left_attach), XEN_TO_C_guint(right_attach), 
                  XEN_TO_C_guint(top_attach), XEN_TO_C_guint(bottom_attach));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_buffer_select_range(XEN buffer, XEN ins, XEN bound)
{
  #define H_gtk_text_buffer_select_range "void gtk_text_buffer_select_range(GtkTextBuffer* buffer, GtkTextIter* ins, \
GtkTextIter* bound)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_select_range", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(ins), ins, 2, "gtk_text_buffer_select_range", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(bound), bound, 3, "gtk_text_buffer_select_range", "GtkTextIter*");
  gtk_text_buffer_select_range(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(ins), XEN_TO_C_GtkTextIter_(bound));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_set_overwrite(XEN text_view, XEN overwrite)
{
  #define H_gtk_text_view_set_overwrite "void gtk_text_view_set_overwrite(GtkTextView* text_view, gboolean overwrite)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_overwrite", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(overwrite), overwrite, 2, "gtk_text_view_set_overwrite", "gboolean");
  gtk_text_view_set_overwrite(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gboolean(overwrite));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_overwrite(XEN text_view)
{
  #define H_gtk_text_view_get_overwrite "gboolean gtk_text_view_get_overwrite(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_overwrite", "GtkTextView*");
  return(C_TO_XEN_gboolean(gtk_text_view_get_overwrite(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_text_view_set_accepts_tab(XEN text_view, XEN accepts_tab)
{
  #define H_gtk_text_view_set_accepts_tab "void gtk_text_view_set_accepts_tab(GtkTextView* text_view, \
gboolean accepts_tab)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_set_accepts_tab", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(accepts_tab), accepts_tab, 2, "gtk_text_view_set_accepts_tab", "gboolean");
  gtk_text_view_set_accepts_tab(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_gboolean(accepts_tab));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_accepts_tab(XEN text_view)
{
  #define H_gtk_text_view_get_accepts_tab "gboolean gtk_text_view_get_accepts_tab(GtkTextView* text_view)"
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_accepts_tab", "GtkTextView*");
  return(C_TO_XEN_gboolean(gtk_text_view_get_accepts_tab(XEN_TO_C_GtkTextView_(text_view))));
}
static XEN gxg_gtk_toolbar_insert(XEN toolbar, XEN item, XEN pos)
{
  #define H_gtk_toolbar_insert "void gtk_toolbar_insert(GtkToolbar* toolbar, GtkToolItem* item, gint pos)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_insert", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(item), item, 2, "gtk_toolbar_insert", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gint_P(pos), pos, 3, "gtk_toolbar_insert", "gint");
  gtk_toolbar_insert(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_GtkToolItem_(item), XEN_TO_C_gint(pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_get_item_index(XEN toolbar, XEN item)
{
  #define H_gtk_toolbar_get_item_index "gint gtk_toolbar_get_item_index(GtkToolbar* toolbar, GtkToolItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_item_index", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(item), item, 2, "gtk_toolbar_get_item_index", "GtkToolItem*");
  return(C_TO_XEN_gint(gtk_toolbar_get_item_index(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_GtkToolItem_(item))));
}
static XEN gxg_gtk_toolbar_get_n_items(XEN toolbar)
{
  #define H_gtk_toolbar_get_n_items "gint gtk_toolbar_get_n_items(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_n_items", "GtkToolbar*");
  return(C_TO_XEN_gint(gtk_toolbar_get_n_items(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_nth_item(XEN toolbar, XEN n)
{
  #define H_gtk_toolbar_get_nth_item "GtkToolItem* gtk_toolbar_get_nth_item(GtkToolbar* toolbar, gint n)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_nth_item", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_gint_P(n), n, 2, "gtk_toolbar_get_nth_item", "gint");
  return(C_TO_XEN_GtkToolItem_(gtk_toolbar_get_nth_item(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_gint(n))));
}
static XEN gxg_gtk_toolbar_set_show_arrow(XEN toolbar, XEN show_arrow)
{
  #define H_gtk_toolbar_set_show_arrow "void gtk_toolbar_set_show_arrow(GtkToolbar* toolbar, gboolean show_arrow)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_set_show_arrow", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_arrow), show_arrow, 2, "gtk_toolbar_set_show_arrow", "gboolean");
  gtk_toolbar_set_show_arrow(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_gboolean(show_arrow));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toolbar_get_show_arrow(XEN toolbar)
{
  #define H_gtk_toolbar_get_show_arrow "gboolean gtk_toolbar_get_show_arrow(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_show_arrow", "GtkToolbar*");
  return(C_TO_XEN_gboolean(gtk_toolbar_get_show_arrow(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_relief_style(XEN toolbar)
{
  #define H_gtk_toolbar_get_relief_style "GtkReliefStyle gtk_toolbar_get_relief_style(GtkToolbar* toolbar)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_relief_style", "GtkToolbar*");
  return(C_TO_XEN_GtkReliefStyle(gtk_toolbar_get_relief_style(XEN_TO_C_GtkToolbar_(toolbar))));
}
static XEN gxg_gtk_toolbar_get_drop_index(XEN toolbar, XEN x, XEN y)
{
  #define H_gtk_toolbar_get_drop_index "gint gtk_toolbar_get_drop_index(GtkToolbar* toolbar, gint x, \
gint y)"
  XEN_ASSERT_TYPE(XEN_GtkToolbar__P(toolbar), toolbar, 1, "gtk_toolbar_get_drop_index", "GtkToolbar*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gtk_toolbar_get_drop_index", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_toolbar_get_drop_index", "gint");
  return(C_TO_XEN_gint(gtk_toolbar_get_drop_index(XEN_TO_C_GtkToolbar_(toolbar), XEN_TO_C_gint(x), XEN_TO_C_gint(y))));
}
static XEN gxg_gtk_tree_view_column_set_expand(XEN tree_column, XEN expand)
{
  #define H_gtk_tree_view_column_set_expand "void gtk_tree_view_column_set_expand(GtkTreeViewColumn* tree_column, \
gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_set_expand", "GtkTreeViewColumn*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 2, "gtk_tree_view_column_set_expand", "gboolean");
  gtk_tree_view_column_set_expand(XEN_TO_C_GtkTreeViewColumn_(tree_column), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_column_get_expand(XEN tree_column)
{
  #define H_gtk_tree_view_column_get_expand "gboolean gtk_tree_view_column_get_expand(GtkTreeViewColumn* tree_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeViewColumn__P(tree_column), tree_column, 1, "gtk_tree_view_column_get_expand", "GtkTreeViewColumn*");
  return(C_TO_XEN_gboolean(gtk_tree_view_column_get_expand(XEN_TO_C_GtkTreeViewColumn_(tree_column))));
}
static XEN gxg_gtk_widget_set_no_show_all(XEN widget, XEN no_show_all)
{
  #define H_gtk_widget_set_no_show_all "void gtk_widget_set_no_show_all(GtkWidget* widget, gboolean no_show_all)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_set_no_show_all", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(no_show_all), no_show_all, 2, "gtk_widget_set_no_show_all", "gboolean");
  gtk_widget_set_no_show_all(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_gboolean(no_show_all));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_get_no_show_all(XEN widget)
{
  #define H_gtk_widget_get_no_show_all "gboolean gtk_widget_get_no_show_all(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_get_no_show_all", "GtkWidget*");
  return(C_TO_XEN_gboolean(gtk_widget_get_no_show_all(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_queue_resize_no_redraw(XEN widget)
{
  #define H_gtk_widget_queue_resize_no_redraw "void gtk_widget_queue_resize_no_redraw(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_queue_resize_no_redraw", "GtkWidget*");
  gtk_widget_queue_resize_no_redraw(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_default_icon(XEN icon)
{
  #define H_gtk_window_set_default_icon "void gtk_window_set_default_icon(GdkPixbuf* icon)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(icon), icon, 1, "gtk_window_set_default_icon", "GdkPixbuf*");
  gtk_window_set_default_icon(XEN_TO_C_GdkPixbuf_(icon));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_keep_above(XEN window, XEN setting)
{
  #define H_gtk_window_set_keep_above "void gtk_window_set_keep_above(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_keep_above", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_keep_above", "gboolean");
  gtk_window_set_keep_above(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_set_keep_below(XEN window, XEN setting)
{
  #define H_gtk_window_set_keep_below "void gtk_window_set_keep_below(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_keep_below", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_keep_below", "gboolean");
  gtk_window_set_keep_below(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_dialog_new(XEN title, XEN parent, XEN action, XEN buttons)
{
  #define H_gtk_file_chooser_dialog_new "GtkWidget* gtk_file_chooser_dialog_new(gchar* title, GtkWindow* parent, \
GtkFileChooserAction action, etc buttons)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_file_chooser_dialog_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(parent) || XEN_FALSE_P(parent), parent, 2, "gtk_file_chooser_dialog_new", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 3, "gtk_file_chooser_dialog_new", "GtkFileChooserAction");
  if (XEN_NOT_BOUND_P(buttons)) buttons = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_etc_P(buttons), buttons, 4, "gtk_file_chooser_dialog_new", "etc");
  {
    int etc_len = 0;
    GtkWidget* result = NULL;
    gchar* p_arg0;
    GtkWindow* p_arg1;
    GtkFileChooserAction p_arg2;
    if (XEN_LIST_P(buttons)) etc_len = XEN_LIST_LENGTH(buttons);
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_file_chooser_dialog_new", 3, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_file_chooser_dialog_new", 3, buttons, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_gchar_(title);
    p_arg1 = XEN_TO_C_GtkWindow_(parent);
    p_arg2 = XEN_TO_C_GtkFileChooserAction(action);
    switch (etc_len)
      {
        case 0: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, NULL); break;
        case 2: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), NULL); break;
        case 4: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), NULL); break;
        case 6: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), NULL); break;
        case 8: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), NULL); break;
        case 10: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), XLS(buttons, 8), XLI(buttons, 9), NULL); break;
      }
    return(C_TO_XEN_GtkWidget_(result));
  }
}
static XEN gxg_gtk_file_chooser_dialog_get_type(void)
{
  #define H_gtk_file_chooser_dialog_get_type "GType gtk_file_chooser_dialog_get_type( void)"
  return(C_TO_XEN_GType(gtk_file_chooser_dialog_get_type()));
}
static XEN gxg_gtk_file_chooser_widget_get_type(void)
{
  #define H_gtk_file_chooser_widget_get_type "GType gtk_file_chooser_widget_get_type( void)"
  return(C_TO_XEN_GType(gtk_file_chooser_widget_get_type()));
}
static XEN gxg_gtk_file_chooser_widget_new(XEN action)
{
  #define H_gtk_file_chooser_widget_new "GtkWidget* gtk_file_chooser_widget_new(GtkFileChooserAction action)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 1, "gtk_file_chooser_widget_new", "GtkFileChooserAction");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_widget_new(XEN_TO_C_GtkFileChooserAction(action))));
}
static XEN gxg_gtk_tree_model_filter_get_type(void)
{
  #define H_gtk_tree_model_filter_get_type "GType gtk_tree_model_filter_get_type( void)"
  return(C_TO_XEN_GType(gtk_tree_model_filter_get_type()));
}
static XEN gxg_gtk_tree_model_filter_new(XEN child_model, XEN root)
{
  #define H_gtk_tree_model_filter_new "GtkTreeModel* gtk_tree_model_filter_new(GtkTreeModel* child_model, \
GtkTreePath* root)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(child_model), child_model, 1, "gtk_tree_model_filter_new", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(root) || XEN_FALSE_P(root), root, 2, "gtk_tree_model_filter_new", "GtkTreePath*");
  return(C_TO_XEN_GtkTreeModel_(gtk_tree_model_filter_new(XEN_TO_C_GtkTreeModel_(child_model), XEN_TO_C_GtkTreePath_(root))));
}
static XEN gxg_gtk_tree_model_filter_set_visible_column(XEN filter, XEN column)
{
  #define H_gtk_tree_model_filter_set_visible_column "void gtk_tree_model_filter_set_visible_column(GtkTreeModelFilter* filter, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_set_visible_column", "GtkTreeModelFilter*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_tree_model_filter_set_visible_column", "gint");
  gtk_tree_model_filter_set_visible_column(XEN_TO_C_GtkTreeModelFilter_(filter), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_filter_get_model(XEN filter)
{
  #define H_gtk_tree_model_filter_get_model "GtkTreeModel* gtk_tree_model_filter_get_model(GtkTreeModelFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_get_model", "GtkTreeModelFilter*");
  return(C_TO_XEN_GtkTreeModel_(gtk_tree_model_filter_get_model(XEN_TO_C_GtkTreeModelFilter_(filter))));
}
static XEN gxg_gtk_tree_model_filter_convert_child_iter_to_iter(XEN filter, XEN filter_iter, XEN child_iter)
{
  #define H_gtk_tree_model_filter_convert_child_iter_to_iter "void gtk_tree_model_filter_convert_child_iter_to_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* filter_iter, GtkTreeIter* child_iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeModelFilter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(filter_iter), filter_iter, 2, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(child_iter), child_iter, 3, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeIter*");
  gtk_tree_model_filter_convert_child_iter_to_iter(XEN_TO_C_GtkTreeModelFilter_(filter), XEN_TO_C_GtkTreeIter_(filter_iter), 
                                                   XEN_TO_C_GtkTreeIter_(child_iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_filter_convert_iter_to_child_iter(XEN filter, XEN child_iter, XEN filter_iter)
{
  #define H_gtk_tree_model_filter_convert_iter_to_child_iter "void gtk_tree_model_filter_convert_iter_to_child_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* child_iter, GtkTreeIter* filter_iter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeModelFilter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(child_iter), child_iter, 2, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(filter_iter), filter_iter, 3, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeIter*");
  gtk_tree_model_filter_convert_iter_to_child_iter(XEN_TO_C_GtkTreeModelFilter_(filter), XEN_TO_C_GtkTreeIter_(child_iter), 
                                                   XEN_TO_C_GtkTreeIter_(filter_iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_filter_convert_child_path_to_path(XEN filter, XEN child_path)
{
  #define H_gtk_tree_model_filter_convert_child_path_to_path "GtkTreePath* gtk_tree_model_filter_convert_child_path_to_path(GtkTreeModelFilter* filter, \
GtkTreePath* child_path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_convert_child_path_to_path", "GtkTreeModelFilter*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(child_path), child_path, 2, "gtk_tree_model_filter_convert_child_path_to_path", "GtkTreePath*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_model_filter_convert_child_path_to_path(XEN_TO_C_GtkTreeModelFilter_(filter), XEN_TO_C_GtkTreePath_(child_path))));
}
static XEN gxg_gtk_tree_model_filter_convert_path_to_child_path(XEN path, XEN filter_path)
{
  #define H_gtk_tree_model_filter_convert_path_to_child_path "GtkTreePath* gtk_tree_model_filter_convert_path_to_child_path(GtkTreeModelFilter* path, \
GtkTreePath* filter_path)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(path), path, 1, "gtk_tree_model_filter_convert_path_to_child_path", "GtkTreeModelFilter*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(filter_path), filter_path, 2, "gtk_tree_model_filter_convert_path_to_child_path", "GtkTreePath*");
  return(C_TO_XEN_GtkTreePath_(gtk_tree_model_filter_convert_path_to_child_path(XEN_TO_C_GtkTreeModelFilter_(path), XEN_TO_C_GtkTreePath_(filter_path))));
}
static XEN gxg_gtk_tree_model_filter_refilter(XEN filter)
{
  #define H_gtk_tree_model_filter_refilter "void gtk_tree_model_filter_refilter(GtkTreeModelFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_refilter", "GtkTreeModelFilter*");
  gtk_tree_model_filter_refilter(XEN_TO_C_GtkTreeModelFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_model_filter_clear_cache(XEN filter)
{
  #define H_gtk_tree_model_filter_clear_cache "void gtk_tree_model_filter_clear_cache(GtkTreeModelFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModelFilter__P(filter), filter, 1, "gtk_tree_model_filter_clear_cache", "GtkTreeModelFilter*");
  gtk_tree_model_filter_clear_cache(XEN_TO_C_GtkTreeModelFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_get_type(void)
{
  #define H_gtk_action_get_type "GType gtk_action_get_type( void)"
  return(C_TO_XEN_GType(gtk_action_get_type()));
}
static XEN gxg_gtk_action_get_name(XEN action)
{
  #define H_gtk_action_get_name "gchar* gtk_action_get_name(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_get_name", "GtkAction*");
  return(C_TO_XEN_gchar_(gtk_action_get_name(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_activate(XEN action)
{
  #define H_gtk_action_activate "void gtk_action_activate(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_activate", "GtkAction*");
  gtk_action_activate(XEN_TO_C_GtkAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_create_icon(XEN action, XEN icon_size)
{
  #define H_gtk_action_create_icon "GtkWidget* gtk_action_create_icon(GtkAction* action, GtkIconSize icon_size)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_create_icon", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(icon_size), icon_size, 2, "gtk_action_create_icon", "GtkIconSize");
  return(C_TO_XEN_GtkWidget_(gtk_action_create_icon(XEN_TO_C_GtkAction_(action), XEN_TO_C_GtkIconSize(icon_size))));
}
static XEN gxg_gtk_action_create_menu_item(XEN action)
{
  #define H_gtk_action_create_menu_item "GtkWidget* gtk_action_create_menu_item(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_create_menu_item", "GtkAction*");
  return(C_TO_XEN_GtkWidget_(gtk_action_create_menu_item(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_create_tool_item(XEN action)
{
  #define H_gtk_action_create_tool_item "GtkWidget* gtk_action_create_tool_item(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_create_tool_item", "GtkAction*");
  return(C_TO_XEN_GtkWidget_(gtk_action_create_tool_item(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_connect_proxy(XEN action, XEN proxy)
{
  #define H_gtk_action_connect_proxy "void gtk_action_connect_proxy(GtkAction* action, GtkWidget* proxy)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_connect_proxy", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(proxy), proxy, 2, "gtk_action_connect_proxy", "GtkWidget*");
  gtk_action_connect_proxy(XEN_TO_C_GtkAction_(action), XEN_TO_C_GtkWidget_(proxy));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_disconnect_proxy(XEN action, XEN proxy)
{
  #define H_gtk_action_disconnect_proxy "void gtk_action_disconnect_proxy(GtkAction* action, GtkWidget* proxy)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_disconnect_proxy", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(proxy), proxy, 2, "gtk_action_disconnect_proxy", "GtkWidget*");
  gtk_action_disconnect_proxy(XEN_TO_C_GtkAction_(action), XEN_TO_C_GtkWidget_(proxy));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_get_proxies(XEN action)
{
  #define H_gtk_action_get_proxies "GSList* gtk_action_get_proxies(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_get_proxies", "GtkAction*");
  return(C_TO_XEN_GSList_(gtk_action_get_proxies(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_connect_accelerator(XEN action)
{
  #define H_gtk_action_connect_accelerator "void gtk_action_connect_accelerator(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_connect_accelerator", "GtkAction*");
  gtk_action_connect_accelerator(XEN_TO_C_GtkAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_disconnect_accelerator(XEN action)
{
  #define H_gtk_action_disconnect_accelerator "void gtk_action_disconnect_accelerator(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_disconnect_accelerator", "GtkAction*");
  gtk_action_disconnect_accelerator(XEN_TO_C_GtkAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_get_type(void)
{
  #define H_gtk_action_group_get_type "GType gtk_action_group_get_type( void)"
  return(C_TO_XEN_GType(gtk_action_group_get_type()));
}
static XEN gxg_gtk_action_group_new(XEN name)
{
  #define H_gtk_action_group_new "GtkActionGroup* gtk_action_group_new(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_action_group_new", "gchar*");
  return(C_TO_XEN_GtkActionGroup_(gtk_action_group_new(XEN_TO_C_gchar_(name))));
}
static XEN gxg_gtk_action_group_get_name(XEN action_group)
{
  #define H_gtk_action_group_get_name "gchar* gtk_action_group_get_name(GtkActionGroup* action_group)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_get_name", "GtkActionGroup*");
  return(C_TO_XEN_gchar_(gtk_action_group_get_name(XEN_TO_C_GtkActionGroup_(action_group))));
}
static XEN gxg_gtk_action_group_get_action(XEN action_group, XEN action_name)
{
  #define H_gtk_action_group_get_action "GtkAction* gtk_action_group_get_action(GtkActionGroup* action_group, \
gchar* action_name)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_get_action", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_gchar__P(action_name), action_name, 2, "gtk_action_group_get_action", "gchar*");
  return(C_TO_XEN_GtkAction_(gtk_action_group_get_action(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_gchar_(action_name))));
}
static XEN gxg_gtk_action_group_list_actions(XEN action_group)
{
  #define H_gtk_action_group_list_actions "GList* gtk_action_group_list_actions(GtkActionGroup* action_group)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_list_actions", "GtkActionGroup*");
  return(C_TO_XEN_GList_(gtk_action_group_list_actions(XEN_TO_C_GtkActionGroup_(action_group))));
}
static XEN gxg_gtk_action_group_add_action(XEN action_group, XEN action)
{
  #define H_gtk_action_group_add_action "void gtk_action_group_add_action(GtkActionGroup* action_group, \
GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_add_action", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 2, "gtk_action_group_add_action", "GtkAction*");
  gtk_action_group_add_action(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_remove_action(XEN action_group, XEN action)
{
  #define H_gtk_action_group_remove_action "void gtk_action_group_remove_action(GtkActionGroup* action_group, \
GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_remove_action", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 2, "gtk_action_group_remove_action", "GtkAction*");
  gtk_action_group_remove_action(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_add_actions(XEN action_group, XEN entries, XEN n_entries, XEN user_data)
{
  #define H_gtk_action_group_add_actions "void gtk_action_group_add_actions(GtkActionGroup* action_group, \
GtkActionEntry* entries, guint n_entries, gpointer user_data)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_add_actions", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkActionEntry__P(entries), entries, 2, "gtk_action_group_add_actions", "GtkActionEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_entries), n_entries, 3, "gtk_action_group_add_actions", "guint");
  XEN_ASSERT_TYPE(XEN_gpointer_P(user_data), user_data, 4, "gtk_action_group_add_actions", "gpointer");
  gtk_action_group_add_actions(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkActionEntry_(entries), XEN_TO_C_guint(n_entries), 
                               XEN_TO_C_gpointer(user_data));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_add_toggle_actions(XEN action_group, XEN entries, XEN n_entries, XEN user_data)
{
  #define H_gtk_action_group_add_toggle_actions "void gtk_action_group_add_toggle_actions(GtkActionGroup* action_group, \
GtkToggleActionEntry* entries, guint n_entries, gpointer user_data)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_add_toggle_actions", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkToggleActionEntry__P(entries), entries, 2, "gtk_action_group_add_toggle_actions", "GtkToggleActionEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_entries), n_entries, 3, "gtk_action_group_add_toggle_actions", "guint");
  XEN_ASSERT_TYPE(XEN_gpointer_P(user_data), user_data, 4, "gtk_action_group_add_toggle_actions", "gpointer");
  gtk_action_group_add_toggle_actions(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkToggleActionEntry_(entries), XEN_TO_C_guint(n_entries), 
                                      XEN_TO_C_gpointer(user_data));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_add_toggle_actions_full(XEN action_group, XEN entries, XEN n_entries, XEN func_data, XEN destroy)
{
  #define H_gtk_action_group_add_toggle_actions_full "void gtk_action_group_add_toggle_actions_full(GtkActionGroup* action_group, \
GtkToggleActionEntry* entries, guint n_entries, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_add_toggle_actions_full", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkToggleActionEntry__P(entries), entries, 2, "gtk_action_group_add_toggle_actions_full", "GtkToggleActionEntry*");
  XEN_ASSERT_TYPE(XEN_guint_P(n_entries), n_entries, 3, "gtk_action_group_add_toggle_actions_full", "guint");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_action_group_add_toggle_actions_full", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 5, "gtk_action_group_add_toggle_actions_full", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(XEN_FALSE, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_action_group_add_toggle_actions_full(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkToggleActionEntry_(entries), 
                                         XEN_TO_C_guint(n_entries), XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_action_group_set_translation_domain(XEN action_group, XEN domain)
{
  #define H_gtk_action_group_set_translation_domain "void gtk_action_group_set_translation_domain(GtkActionGroup* action_group, \
gchar* domain)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_set_translation_domain", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_gchar__P(domain), domain, 2, "gtk_action_group_set_translation_domain", "gchar*");
  gtk_action_group_set_translation_domain(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_gchar_(domain));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_type(void)
{
  #define H_gtk_combo_box_get_type "GType gtk_combo_box_get_type( void)"
  return(C_TO_XEN_GType(gtk_combo_box_get_type()));
}
static XEN gxg_gtk_combo_box_set_wrap_width(XEN combo_box, XEN width)
{
  #define H_gtk_combo_box_set_wrap_width "void gtk_combo_box_set_wrap_width(GtkComboBox* combo_box, gint width)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_wrap_width", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 2, "gtk_combo_box_set_wrap_width", "gint");
  gtk_combo_box_set_wrap_width(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_set_row_span_column(XEN combo_box, XEN row_span)
{
  #define H_gtk_combo_box_set_row_span_column "void gtk_combo_box_set_row_span_column(GtkComboBox* combo_box, \
gint row_span)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_row_span_column", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(row_span), row_span, 2, "gtk_combo_box_set_row_span_column", "gint");
  gtk_combo_box_set_row_span_column(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(row_span));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_set_column_span_column(XEN combo_box, XEN column_span)
{
  #define H_gtk_combo_box_set_column_span_column "void gtk_combo_box_set_column_span_column(GtkComboBox* combo_box, \
gint column_span)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_column_span_column", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(column_span), column_span, 2, "gtk_combo_box_set_column_span_column", "gint");
  gtk_combo_box_set_column_span_column(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(column_span));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_active(XEN combo_box)
{
  #define H_gtk_combo_box_get_active "gint gtk_combo_box_get_active(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_active", "GtkComboBox*");
  return(C_TO_XEN_gint(gtk_combo_box_get_active(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_set_active(XEN combo_box, XEN index)
{
  #define H_gtk_combo_box_set_active "void gtk_combo_box_set_active(GtkComboBox* combo_box, gint index)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_active", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_combo_box_set_active", "gint");
  gtk_combo_box_set_active(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_active_iter(XEN combo_box, XEN iter)
{
  #define H_gtk_combo_box_get_active_iter "gboolean gtk_combo_box_get_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_active_iter", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_combo_box_get_active_iter", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_combo_box_get_active_iter(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_GtkTreeIter_(iter))));
}
static XEN gxg_gtk_combo_box_set_active_iter(XEN combo_box, XEN iter)
{
  #define H_gtk_combo_box_set_active_iter "void gtk_combo_box_set_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_active_iter", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_combo_box_set_active_iter", "GtkTreeIter*");
  gtk_combo_box_set_active_iter(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_GtkTreeIter_(iter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_model(XEN combo_box)
{
  #define H_gtk_combo_box_get_model "GtkTreeModel* gtk_combo_box_get_model(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_model", "GtkComboBox*");
  return(C_TO_XEN_GtkTreeModel_(gtk_combo_box_get_model(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_new_text(void)
{
  #define H_gtk_combo_box_new_text "GtkWidget* gtk_combo_box_new_text( void)"
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_new_text()));
}
static XEN gxg_gtk_combo_box_append_text(XEN combo_box, XEN text)
{
  #define H_gtk_combo_box_append_text "void gtk_combo_box_append_text(GtkComboBox* combo_box, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_append_text", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_combo_box_append_text", "gchar*");
  gtk_combo_box_append_text(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_insert_text(XEN combo_box, XEN position, XEN text)
{
  #define H_gtk_combo_box_insert_text "void gtk_combo_box_insert_text(GtkComboBox* combo_box, gint position, \
gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_insert_text", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_combo_box_insert_text", "gint");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_combo_box_insert_text", "gchar*");
  gtk_combo_box_insert_text(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(position), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_prepend_text(XEN combo_box, XEN text)
{
  #define H_gtk_combo_box_prepend_text "void gtk_combo_box_prepend_text(GtkComboBox* combo_box, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_prepend_text", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 2, "gtk_combo_box_prepend_text", "gchar*");
  gtk_combo_box_prepend_text(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_entry_get_type(void)
{
  #define H_gtk_combo_box_entry_get_type "GType gtk_combo_box_entry_get_type( void)"
  return(C_TO_XEN_GType(gtk_combo_box_entry_get_type()));
}
static XEN gxg_gtk_combo_box_entry_get_text_column(XEN entry_box)
{
  #define H_gtk_combo_box_entry_get_text_column "gint gtk_combo_box_entry_get_text_column(GtkComboBoxEntry* entry_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBoxEntry__P(entry_box), entry_box, 1, "gtk_combo_box_entry_get_text_column", "GtkComboBoxEntry*");
  return(C_TO_XEN_gint(gtk_combo_box_entry_get_text_column(XEN_TO_C_GtkComboBoxEntry_(entry_box))));
}
static XEN gxg_gtk_expander_get_type(void)
{
  #define H_gtk_expander_get_type "GType gtk_expander_get_type( void)"
  return(C_TO_XEN_GType(gtk_expander_get_type()));
}
static XEN gxg_gtk_expander_new(XEN label)
{
  #define H_gtk_expander_new "GtkWidget* gtk_expander_new(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_expander_new", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_expander_new(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_expander_new_with_mnemonic(XEN label)
{
  #define H_gtk_expander_new_with_mnemonic "GtkWidget* gtk_expander_new_with_mnemonic(gchar* label)"
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 1, "gtk_expander_new_with_mnemonic", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_expander_new_with_mnemonic(XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_expander_set_expanded(XEN expander, XEN expanded)
{
  #define H_gtk_expander_set_expanded "void gtk_expander_set_expanded(GtkExpander* expander, gboolean expanded)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_expanded", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expanded), expanded, 2, "gtk_expander_set_expanded", "gboolean");
  gtk_expander_set_expanded(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_gboolean(expanded));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_expanded(XEN expander)
{
  #define H_gtk_expander_get_expanded "gboolean gtk_expander_get_expanded(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_expanded", "GtkExpander*");
  return(C_TO_XEN_gboolean(gtk_expander_get_expanded(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_expander_set_spacing(XEN expander, XEN spacing)
{
  #define H_gtk_expander_set_spacing "void gtk_expander_set_spacing(GtkExpander* expander, gint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_spacing", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_expander_set_spacing", "gint");
  gtk_expander_set_spacing(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_gint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_spacing(XEN expander)
{
  #define H_gtk_expander_get_spacing "gint gtk_expander_get_spacing(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_spacing", "GtkExpander*");
  return(C_TO_XEN_gint(gtk_expander_get_spacing(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_expander_set_label(XEN expander, XEN label)
{
  #define H_gtk_expander_set_label "void gtk_expander_set_label(GtkExpander* expander, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_label", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_expander_set_label", "gchar*");
  gtk_expander_set_label(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_gchar_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_label(XEN expander)
{
  #define H_gtk_expander_get_label "gchar* gtk_expander_get_label(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_label", "GtkExpander*");
  return(C_TO_XEN_gchar_(gtk_expander_get_label(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_expander_set_use_underline(XEN expander, XEN use_underline)
{
  #define H_gtk_expander_set_use_underline "void gtk_expander_set_use_underline(GtkExpander* expander, \
gboolean use_underline)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_use_underline", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_underline), use_underline, 2, "gtk_expander_set_use_underline", "gboolean");
  gtk_expander_set_use_underline(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_gboolean(use_underline));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_use_underline(XEN expander)
{
  #define H_gtk_expander_get_use_underline "gboolean gtk_expander_get_use_underline(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_use_underline", "GtkExpander*");
  return(C_TO_XEN_gboolean(gtk_expander_get_use_underline(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_expander_set_label_widget(XEN expander, XEN label_widget)
{
  #define H_gtk_expander_set_label_widget "void gtk_expander_set_label_widget(GtkExpander* expander, \
GtkWidget* label_widget)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_label_widget", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(label_widget), label_widget, 2, "gtk_expander_set_label_widget", "GtkWidget*");
  gtk_expander_set_label_widget(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_GtkWidget_(label_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_label_widget(XEN expander)
{
  #define H_gtk_expander_get_label_widget "GtkWidget* gtk_expander_get_label_widget(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_label_widget", "GtkExpander*");
  return(C_TO_XEN_GtkWidget_(gtk_expander_get_label_widget(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_font_button_get_type(void)
{
  #define H_gtk_font_button_get_type "GType gtk_font_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_font_button_get_type()));
}
static XEN gxg_gtk_font_button_new(void)
{
  #define H_gtk_font_button_new "GtkWidget* gtk_font_button_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_font_button_new()));
}
static XEN gxg_gtk_font_button_new_with_font(XEN fontname)
{
  #define H_gtk_font_button_new_with_font "GtkWidget* gtk_font_button_new_with_font(gchar* fontname)"
  XEN_ASSERT_TYPE(XEN_gchar__P(fontname), fontname, 1, "gtk_font_button_new_with_font", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_font_button_new_with_font(XEN_TO_C_gchar_(fontname))));
}
static XEN gxg_gtk_font_button_get_title(XEN font_button)
{
  #define H_gtk_font_button_get_title "gchar* gtk_font_button_get_title(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_title", "GtkFontButton*");
  return(C_TO_XEN_gchar_(gtk_font_button_get_title(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_title(XEN font_button, XEN title)
{
  #define H_gtk_font_button_set_title "void gtk_font_button_set_title(GtkFontButton* font_button, gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_title", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_font_button_set_title", "gchar*");
  gtk_font_button_set_title(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gtk_font_button_get_use_font(XEN font_button)
{
  #define H_gtk_font_button_get_use_font "gboolean gtk_font_button_get_use_font(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_use_font", "GtkFontButton*");
  return(C_TO_XEN_gboolean(gtk_font_button_get_use_font(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_use_font(XEN font_button, XEN use_font)
{
  #define H_gtk_font_button_set_use_font "void gtk_font_button_set_use_font(GtkFontButton* font_button, \
gboolean use_font)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_use_font", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_font), use_font, 2, "gtk_font_button_set_use_font", "gboolean");
  gtk_font_button_set_use_font(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gboolean(use_font));
  return(XEN_FALSE);
}
static XEN gxg_gtk_font_button_get_use_size(XEN font_button)
{
  #define H_gtk_font_button_get_use_size "gboolean gtk_font_button_get_use_size(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_use_size", "GtkFontButton*");
  return(C_TO_XEN_gboolean(gtk_font_button_get_use_size(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_use_size(XEN font_button, XEN use_size)
{
  #define H_gtk_font_button_set_use_size "void gtk_font_button_set_use_size(GtkFontButton* font_button, \
gboolean use_size)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_use_size", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_size), use_size, 2, "gtk_font_button_set_use_size", "gboolean");
  gtk_font_button_set_use_size(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gboolean(use_size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_font_button_get_font_name(XEN font_button)
{
  #define H_gtk_font_button_get_font_name "gchar* gtk_font_button_get_font_name(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_font_name", "GtkFontButton*");
  return(C_TO_XEN_gchar_(gtk_font_button_get_font_name(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_font_name(XEN font_button, XEN fontname)
{
  #define H_gtk_font_button_set_font_name "gboolean gtk_font_button_set_font_name(GtkFontButton* font_button, \
gchar* fontname)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_font_name", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(fontname), fontname, 2, "gtk_font_button_set_font_name", "gchar*");
  return(C_TO_XEN_gboolean(gtk_font_button_set_font_name(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gchar_(fontname))));
}
static XEN gxg_gtk_font_button_get_show_style(XEN font_button)
{
  #define H_gtk_font_button_get_show_style "gboolean gtk_font_button_get_show_style(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_show_style", "GtkFontButton*");
  return(C_TO_XEN_gboolean(gtk_font_button_get_show_style(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_show_style(XEN font_button, XEN show_style)
{
  #define H_gtk_font_button_set_show_style "void gtk_font_button_set_show_style(GtkFontButton* font_button, \
gboolean show_style)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_show_style", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_style), show_style, 2, "gtk_font_button_set_show_style", "gboolean");
  gtk_font_button_set_show_style(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gboolean(show_style));
  return(XEN_FALSE);
}
static XEN gxg_gtk_font_button_get_show_size(XEN font_button)
{
  #define H_gtk_font_button_get_show_size "gboolean gtk_font_button_get_show_size(GtkFontButton* font_button)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_get_show_size", "GtkFontButton*");
  return(C_TO_XEN_gboolean(gtk_font_button_get_show_size(XEN_TO_C_GtkFontButton_(font_button))));
}
static XEN gxg_gtk_font_button_set_show_size(XEN font_button, XEN show_size)
{
  #define H_gtk_font_button_set_show_size "void gtk_font_button_set_show_size(GtkFontButton* font_button, \
gboolean show_size)"
  XEN_ASSERT_TYPE(XEN_GtkFontButton__P(font_button), font_button, 1, "gtk_font_button_set_show_size", "GtkFontButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_size), show_size, 2, "gtk_font_button_set_show_size", "gboolean");
  gtk_font_button_set_show_size(XEN_TO_C_GtkFontButton_(font_button), XEN_TO_C_gboolean(show_size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_get_type(void)
{
  #define H_gtk_color_button_get_type "GType gtk_color_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_color_button_get_type()));
}
static XEN gxg_gtk_color_button_new(void)
{
  #define H_gtk_color_button_new "GtkWidget* gtk_color_button_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_color_button_new()));
}
static XEN gxg_gtk_color_button_new_with_color(XEN color)
{
  #define H_gtk_color_button_new_with_color "GtkWidget* gtk_color_button_new_with_color(GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 1, "gtk_color_button_new_with_color", "GdkColor*");
  return(C_TO_XEN_GtkWidget_(gtk_color_button_new_with_color(XEN_TO_C_GdkColor_(color))));
}
static XEN gxg_gtk_color_button_set_color(XEN color_button, XEN color)
{
  #define H_gtk_color_button_set_color "void gtk_color_button_set_color(GtkColorButton* color_button, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_set_color", "GtkColorButton*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_button_set_color", "GdkColor*");
  gtk_color_button_set_color(XEN_TO_C_GtkColorButton_(color_button), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_set_alpha(XEN color_button, XEN alpha)
{
  #define H_gtk_color_button_set_alpha "void gtk_color_button_set_alpha(GtkColorButton* color_button, \
guint16 alpha)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_set_alpha", "GtkColorButton*");
  XEN_ASSERT_TYPE(XEN_guint16_P(alpha), alpha, 2, "gtk_color_button_set_alpha", "guint16");
  gtk_color_button_set_alpha(XEN_TO_C_GtkColorButton_(color_button), XEN_TO_C_guint16(alpha));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_get_color(XEN color_button, XEN color)
{
  #define H_gtk_color_button_get_color "void gtk_color_button_get_color(GtkColorButton* color_button, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_get_color", "GtkColorButton*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_color_button_get_color", "GdkColor*");
  gtk_color_button_get_color(XEN_TO_C_GtkColorButton_(color_button), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_get_alpha(XEN color_button)
{
  #define H_gtk_color_button_get_alpha "guint16 gtk_color_button_get_alpha(GtkColorButton* color_button)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_get_alpha", "GtkColorButton*");
  return(C_TO_XEN_guint16(gtk_color_button_get_alpha(XEN_TO_C_GtkColorButton_(color_button))));
}
static XEN gxg_gtk_color_button_set_use_alpha(XEN color_button, XEN use_alpha)
{
  #define H_gtk_color_button_set_use_alpha "void gtk_color_button_set_use_alpha(GtkColorButton* color_button, \
gboolean use_alpha)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_set_use_alpha", "GtkColorButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_alpha), use_alpha, 2, "gtk_color_button_set_use_alpha", "gboolean");
  gtk_color_button_set_use_alpha(XEN_TO_C_GtkColorButton_(color_button), XEN_TO_C_gboolean(use_alpha));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_get_use_alpha(XEN color_button)
{
  #define H_gtk_color_button_get_use_alpha "gboolean gtk_color_button_get_use_alpha(GtkColorButton* color_button)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_get_use_alpha", "GtkColorButton*");
  return(C_TO_XEN_gboolean(gtk_color_button_get_use_alpha(XEN_TO_C_GtkColorButton_(color_button))));
}
static XEN gxg_gtk_color_button_set_title(XEN color_button, XEN title)
{
  #define H_gtk_color_button_set_title "void gtk_color_button_set_title(GtkColorButton* color_button, \
gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_set_title", "GtkColorButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_color_button_set_title", "gchar*");
  gtk_color_button_set_title(XEN_TO_C_GtkColorButton_(color_button), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gtk_color_button_get_title(XEN color_button)
{
  #define H_gtk_color_button_get_title "gchar* gtk_color_button_get_title(GtkColorButton* color_button)"
  XEN_ASSERT_TYPE(XEN_GtkColorButton__P(color_button), color_button, 1, "gtk_color_button_get_title", "GtkColorButton*");
  return(C_TO_XEN_gchar_(gtk_color_button_get_title(XEN_TO_C_GtkColorButton_(color_button))));
}
static XEN gxg_gtk_entry_completion_get_type(void)
{
  #define H_gtk_entry_completion_get_type "GType gtk_entry_completion_get_type( void)"
  return(C_TO_XEN_GType(gtk_entry_completion_get_type()));
}
static XEN gxg_gtk_entry_completion_new(void)
{
  #define H_gtk_entry_completion_new "GtkEntryCompletion* gtk_entry_completion_new( void)"
  return(C_TO_XEN_GtkEntryCompletion_(gtk_entry_completion_new()));
}
static XEN gxg_gtk_entry_completion_get_entry(XEN entry)
{
  #define H_gtk_entry_completion_get_entry "GtkWidget* gtk_entry_completion_get_entry(GtkEntryCompletion* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(entry), entry, 1, "gtk_entry_completion_get_entry", "GtkEntryCompletion*");
  return(C_TO_XEN_GtkWidget_(gtk_entry_completion_get_entry(XEN_TO_C_GtkEntryCompletion_(entry))));
}
static XEN gxg_gtk_entry_completion_set_model(XEN completion, XEN model)
{
  #define H_gtk_entry_completion_set_model "void gtk_entry_completion_set_model(GtkEntryCompletion* completion, \
GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_model", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model) || XEN_FALSE_P(model), model, 2, "gtk_entry_completion_set_model", "GtkTreeModel*");
  gtk_entry_completion_set_model(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_GtkTreeModel_(model));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_get_model(XEN completion)
{
  #define H_gtk_entry_completion_get_model "GtkTreeModel* gtk_entry_completion_get_model(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_get_model", "GtkEntryCompletion*");
  return(C_TO_XEN_GtkTreeModel_(gtk_entry_completion_get_model(XEN_TO_C_GtkEntryCompletion_(completion))));
}
static XEN gxg_gtk_entry_completion_set_match_func(XEN completion, XEN func, XEN func_data, XEN func_notify)
{
  #define H_gtk_entry_completion_set_match_func "void gtk_entry_completion_set_match_func(GtkEntryCompletion* completion, \
GtkEntryCompletionMatchFunc func, lambda_data func_data, GtkDestroyNotify func_notify)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_match_func", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletionMatchFunc_P(func), func, 2, "gtk_entry_completion_set_match_func", "GtkEntryCompletionMatchFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_entry_completion_set_match_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(func_notify), func_notify, 4, "gtk_entry_completion_set_match_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, func_notify);
    gtk_entry_completion_set_match_func(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_GtkEntryCompletionMatchFunc(func), 
                                    XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(func_notify));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_entry_completion_set_minimum_key_length(XEN completion, XEN length)
{
  #define H_gtk_entry_completion_set_minimum_key_length "void gtk_entry_completion_set_minimum_key_length(GtkEntryCompletion* completion, \
gint length)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_minimum_key_length", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gint_P(length), length, 2, "gtk_entry_completion_set_minimum_key_length", "gint");
  gtk_entry_completion_set_minimum_key_length(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gint(length));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_get_minimum_key_length(XEN completion)
{
  #define H_gtk_entry_completion_get_minimum_key_length "gint gtk_entry_completion_get_minimum_key_length(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_get_minimum_key_length", "GtkEntryCompletion*");
  return(C_TO_XEN_gint(gtk_entry_completion_get_minimum_key_length(XEN_TO_C_GtkEntryCompletion_(completion))));
}
static XEN gxg_gtk_entry_completion_complete(XEN completion)
{
  #define H_gtk_entry_completion_complete "void gtk_entry_completion_complete(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_complete", "GtkEntryCompletion*");
  gtk_entry_completion_complete(XEN_TO_C_GtkEntryCompletion_(completion));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_insert_action_text(XEN completion, XEN index, XEN text)
{
  #define H_gtk_entry_completion_insert_action_text "void gtk_entry_completion_insert_action_text(GtkEntryCompletion* completion, \
gint index, gchar* text)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_insert_action_text", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_entry_completion_insert_action_text", "gint");
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 3, "gtk_entry_completion_insert_action_text", "gchar*");
  gtk_entry_completion_insert_action_text(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gint(index), XEN_TO_C_gchar_(text));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_insert_action_markup(XEN completion, XEN index, XEN markup)
{
  #define H_gtk_entry_completion_insert_action_markup "void gtk_entry_completion_insert_action_markup(GtkEntryCompletion* completion, \
gint index, gchar* markup)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_insert_action_markup", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_entry_completion_insert_action_markup", "gint");
  XEN_ASSERT_TYPE(XEN_gchar__P(markup), markup, 3, "gtk_entry_completion_insert_action_markup", "gchar*");
  gtk_entry_completion_insert_action_markup(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gint(index), XEN_TO_C_gchar_(markup));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_delete_action(XEN completion, XEN index)
{
  #define H_gtk_entry_completion_delete_action "void gtk_entry_completion_delete_action(GtkEntryCompletion* completion, \
gint index)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_delete_action", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gint_P(index), index, 2, "gtk_entry_completion_delete_action", "gint");
  gtk_entry_completion_delete_action(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gint(index));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_set_text_column(XEN completion, XEN column)
{
  #define H_gtk_entry_completion_set_text_column "void gtk_entry_completion_set_text_column(GtkEntryCompletion* completion, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_text_column", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_entry_completion_set_text_column", "gint");
  gtk_entry_completion_set_text_column(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_get_type(void)
{
  #define H_gtk_ui_manager_get_type "GType gtk_ui_manager_get_type( void)"
  return(C_TO_XEN_GType(gtk_ui_manager_get_type()));
}
static XEN gxg_gtk_ui_manager_new(void)
{
  #define H_gtk_ui_manager_new "GtkUIManager* gtk_ui_manager_new( void)"
  return(C_TO_XEN_GtkUIManager_(gtk_ui_manager_new()));
}
static XEN gxg_gtk_ui_manager_set_add_tearoffs(XEN self, XEN add_tearoffs)
{
  #define H_gtk_ui_manager_set_add_tearoffs "void gtk_ui_manager_set_add_tearoffs(GtkUIManager* self, \
gboolean add_tearoffs)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_set_add_tearoffs", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(add_tearoffs), add_tearoffs, 2, "gtk_ui_manager_set_add_tearoffs", "gboolean");
  gtk_ui_manager_set_add_tearoffs(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_gboolean(add_tearoffs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_get_add_tearoffs(XEN self)
{
  #define H_gtk_ui_manager_get_add_tearoffs "gboolean gtk_ui_manager_get_add_tearoffs(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_add_tearoffs", "GtkUIManager*");
  return(C_TO_XEN_gboolean(gtk_ui_manager_get_add_tearoffs(XEN_TO_C_GtkUIManager_(self))));
}
static XEN gxg_gtk_ui_manager_insert_action_group(XEN self, XEN action_group, XEN pos)
{
  #define H_gtk_ui_manager_insert_action_group "void gtk_ui_manager_insert_action_group(GtkUIManager* self, \
GtkActionGroup* action_group, gint pos)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_insert_action_group", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 2, "gtk_ui_manager_insert_action_group", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_gint_P(pos), pos, 3, "gtk_ui_manager_insert_action_group", "gint");
  gtk_ui_manager_insert_action_group(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_gint(pos));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_remove_action_group(XEN self, XEN action_group)
{
  #define H_gtk_ui_manager_remove_action_group "void gtk_ui_manager_remove_action_group(GtkUIManager* self, \
GtkActionGroup* action_group)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_remove_action_group", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 2, "gtk_ui_manager_remove_action_group", "GtkActionGroup*");
  gtk_ui_manager_remove_action_group(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_GtkActionGroup_(action_group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_get_action_groups(XEN self)
{
  #define H_gtk_ui_manager_get_action_groups "GList* gtk_ui_manager_get_action_groups(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_action_groups", "GtkUIManager*");
  return(C_TO_XEN_GList_(gtk_ui_manager_get_action_groups(XEN_TO_C_GtkUIManager_(self))));
}
static XEN gxg_gtk_ui_manager_get_accel_group(XEN self)
{
  #define H_gtk_ui_manager_get_accel_group "GtkAccelGroup* gtk_ui_manager_get_accel_group(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_accel_group", "GtkUIManager*");
  return(C_TO_XEN_GtkAccelGroup_(gtk_ui_manager_get_accel_group(XEN_TO_C_GtkUIManager_(self))));
}
static XEN gxg_gtk_ui_manager_get_widget(XEN self, XEN path)
{
  #define H_gtk_ui_manager_get_widget "GtkWidget* gtk_ui_manager_get_widget(GtkUIManager* self, gchar* path)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_widget", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 2, "gtk_ui_manager_get_widget", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_ui_manager_get_widget(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_gchar_(path))));
}
static XEN gxg_gtk_ui_manager_get_action(XEN self, XEN path)
{
  #define H_gtk_ui_manager_get_action "GtkAction* gtk_ui_manager_get_action(GtkUIManager* self, gchar* path)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_action", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 2, "gtk_ui_manager_get_action", "gchar*");
  return(C_TO_XEN_GtkAction_(gtk_ui_manager_get_action(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_gchar_(path))));
}
static XEN gxg_gtk_ui_manager_add_ui_from_string(XEN self, XEN buffer, XEN length, XEN error)
{
  #define H_gtk_ui_manager_add_ui_from_string "guint gtk_ui_manager_add_ui_from_string(GtkUIManager* self, \
gchar* buffer, gssize length, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_add_ui_from_string", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_gchar__P(buffer), buffer, 2, "gtk_ui_manager_add_ui_from_string", "gchar*");
  XEN_ASSERT_TYPE(XEN_gssize_P(length), length, 3, "gtk_ui_manager_add_ui_from_string", "gssize");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_guint(gtk_ui_manager_add_ui_from_string(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_gchar_(buffer), XEN_TO_C_gssize(length), 
                                                              &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_ui_manager_add_ui_from_file(XEN self, XEN filename, XEN error)
{
  #define H_gtk_ui_manager_add_ui_from_file "guint gtk_ui_manager_add_ui_from_file(GtkUIManager* self, \
gchar* filename, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_add_ui_from_file", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 2, "gtk_ui_manager_add_ui_from_file", "gchar*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_guint(gtk_ui_manager_add_ui_from_file(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_gchar_(filename), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_ui_manager_add_ui(XEN self, XEN merge_id, XEN path, XEN name, XEN action, XEN type, XEN top)
{
  #define H_gtk_ui_manager_add_ui "void gtk_ui_manager_add_ui(GtkUIManager* self, guint merge_id, gchar* path, \
gchar* name, gchar* action, GtkUIManagerItemType type, gboolean top)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_add_ui", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_guint_P(merge_id), merge_id, 2, "gtk_ui_manager_add_ui", "guint");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 3, "gtk_ui_manager_add_ui", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 4, "gtk_ui_manager_add_ui", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(action), action, 5, "gtk_ui_manager_add_ui", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkUIManagerItemType_P(type), type, 6, "gtk_ui_manager_add_ui", "GtkUIManagerItemType");
  XEN_ASSERT_TYPE(XEN_gboolean_P(top), top, 7, "gtk_ui_manager_add_ui", "gboolean");
  gtk_ui_manager_add_ui(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_guint(merge_id), XEN_TO_C_gchar_(path), XEN_TO_C_gchar_(name), 
                        XEN_TO_C_gchar_(action), XEN_TO_C_GtkUIManagerItemType(type), XEN_TO_C_gboolean(top));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_remove_ui(XEN self, XEN merge_id)
{
  #define H_gtk_ui_manager_remove_ui "void gtk_ui_manager_remove_ui(GtkUIManager* self, guint merge_id)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_remove_ui", "GtkUIManager*");
  XEN_ASSERT_TYPE(XEN_guint_P(merge_id), merge_id, 2, "gtk_ui_manager_remove_ui", "guint");
  gtk_ui_manager_remove_ui(XEN_TO_C_GtkUIManager_(self), XEN_TO_C_guint(merge_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_get_ui(XEN self)
{
  #define H_gtk_ui_manager_get_ui "gchar* gtk_ui_manager_get_ui(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_get_ui", "GtkUIManager*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_ui_manager_get_ui(XEN_TO_C_GtkUIManager_(self));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_ui_manager_ensure_update(XEN self)
{
  #define H_gtk_ui_manager_ensure_update "void gtk_ui_manager_ensure_update(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_ensure_update", "GtkUIManager*");
  gtk_ui_manager_ensure_update(XEN_TO_C_GtkUIManager_(self));
  return(XEN_FALSE);
}
static XEN gxg_gtk_ui_manager_new_merge_id(XEN self)
{
  #define H_gtk_ui_manager_new_merge_id "guint gtk_ui_manager_new_merge_id(GtkUIManager* self)"
  XEN_ASSERT_TYPE(XEN_GtkUIManager__P(self), self, 1, "gtk_ui_manager_new_merge_id", "GtkUIManager*");
  return(C_TO_XEN_guint(gtk_ui_manager_new_merge_id(XEN_TO_C_GtkUIManager_(self))));
}
static XEN gxg_gtk_radio_tool_button_get_type(void)
{
  #define H_gtk_radio_tool_button_get_type "GType gtk_radio_tool_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_radio_tool_button_get_type()));
}
static XEN gxg_gtk_radio_tool_button_new(XEN group)
{
  #define H_gtk_radio_tool_button_new "GtkToolItem* gtk_radio_tool_button_new(GSList* group)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_tool_button_new", "GSList*");
  return(C_TO_XEN_GtkToolItem_(gtk_radio_tool_button_new(XEN_TO_C_GSList_(group))));
}
static XEN gxg_gtk_radio_tool_button_new_from_stock(XEN group, XEN stock_id)
{
  #define H_gtk_radio_tool_button_new_from_stock "GtkToolItem* gtk_radio_tool_button_new_from_stock(GSList* group, \
gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 1, "gtk_radio_tool_button_new_from_stock", "GSList*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_radio_tool_button_new_from_stock", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_radio_tool_button_new_from_stock(XEN_TO_C_GSList_(group), XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_radio_tool_button_get_group(XEN button)
{
  #define H_gtk_radio_tool_button_get_group "GSList* gtk_radio_tool_button_get_group(GtkRadioToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkRadioToolButton__P(button), button, 1, "gtk_radio_tool_button_get_group", "GtkRadioToolButton*");
  return(C_TO_XEN_GSList_(gtk_radio_tool_button_get_group(XEN_TO_C_GtkRadioToolButton_(button))));
}
static XEN gxg_gtk_radio_tool_button_set_group(XEN button, XEN group)
{
  #define H_gtk_radio_tool_button_set_group "void gtk_radio_tool_button_set_group(GtkRadioToolButton* button, \
GSList* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioToolButton__P(button), button, 1, "gtk_radio_tool_button_set_group", "GtkRadioToolButton*");
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 2, "gtk_radio_tool_button_set_group", "GSList*");
  gtk_radio_tool_button_set_group(XEN_TO_C_GtkRadioToolButton_(button), XEN_TO_C_GSList_(group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_radio_action_get_type(void)
{
  #define H_gtk_radio_action_get_type "GType gtk_radio_action_get_type( void)"
  return(C_TO_XEN_GType(gtk_radio_action_get_type()));
}
static XEN gxg_gtk_radio_action_get_group(XEN action)
{
  #define H_gtk_radio_action_get_group "GSList* gtk_radio_action_get_group(GtkRadioAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkRadioAction__P(action), action, 1, "gtk_radio_action_get_group", "GtkRadioAction*");
  return(C_TO_XEN_GSList_(gtk_radio_action_get_group(XEN_TO_C_GtkRadioAction_(action))));
}
static XEN gxg_gtk_radio_action_set_group(XEN action, XEN group)
{
  #define H_gtk_radio_action_set_group "void gtk_radio_action_set_group(GtkRadioAction* action, GSList* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioAction__P(action), action, 1, "gtk_radio_action_set_group", "GtkRadioAction*");
  XEN_ASSERT_TYPE(XEN_GSList__P(group) || XEN_FALSE_P(group), group, 2, "gtk_radio_action_set_group", "GSList*");
  gtk_radio_action_set_group(XEN_TO_C_GtkRadioAction_(action), XEN_TO_C_GSList_(group));
  return(XEN_FALSE);
}
static XEN gxg_gtk_radio_action_get_current_value(XEN action)
{
  #define H_gtk_radio_action_get_current_value "gint gtk_radio_action_get_current_value(GtkRadioAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkRadioAction__P(action), action, 1, "gtk_radio_action_get_current_value", "GtkRadioAction*");
  return(C_TO_XEN_gint(gtk_radio_action_get_current_value(XEN_TO_C_GtkRadioAction_(action))));
}
static XEN gxg_gtk_separator_tool_item_get_type(void)
{
  #define H_gtk_separator_tool_item_get_type "GType gtk_separator_tool_item_get_type( void)"
  return(C_TO_XEN_GType(gtk_separator_tool_item_get_type()));
}
static XEN gxg_gtk_separator_tool_item_new(void)
{
  #define H_gtk_separator_tool_item_new "GtkToolItem* gtk_separator_tool_item_new( void)"
  return(C_TO_XEN_GtkToolItem_(gtk_separator_tool_item_new()));
}
static XEN gxg_gtk_toggle_action_get_type(void)
{
  #define H_gtk_toggle_action_get_type "GType gtk_toggle_action_get_type( void)"
  return(C_TO_XEN_GType(gtk_toggle_action_get_type()));
}
static XEN gxg_gtk_toggle_action_toggled(XEN action)
{
  #define H_gtk_toggle_action_toggled "void gtk_toggle_action_toggled(GtkToggleAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkToggleAction__P(action), action, 1, "gtk_toggle_action_toggled", "GtkToggleAction*");
  gtk_toggle_action_toggled(XEN_TO_C_GtkToggleAction_(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_action_set_active(XEN action, XEN is_active)
{
  #define H_gtk_toggle_action_set_active "void gtk_toggle_action_set_active(GtkToggleAction* action, \
gboolean is_active)"
  XEN_ASSERT_TYPE(XEN_GtkToggleAction__P(action), action, 1, "gtk_toggle_action_set_active", "GtkToggleAction*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_active), is_active, 2, "gtk_toggle_action_set_active", "gboolean");
  gtk_toggle_action_set_active(XEN_TO_C_GtkToggleAction_(action), XEN_TO_C_gboolean(is_active));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_action_get_active(XEN action)
{
  #define H_gtk_toggle_action_get_active "gboolean gtk_toggle_action_get_active(GtkToggleAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkToggleAction__P(action), action, 1, "gtk_toggle_action_get_active", "GtkToggleAction*");
  return(C_TO_XEN_gboolean(gtk_toggle_action_get_active(XEN_TO_C_GtkToggleAction_(action))));
}
static XEN gxg_gtk_toggle_action_set_draw_as_radio(XEN action, XEN draw_as_radio)
{
  #define H_gtk_toggle_action_set_draw_as_radio "void gtk_toggle_action_set_draw_as_radio(GtkToggleAction* action, \
gboolean draw_as_radio)"
  XEN_ASSERT_TYPE(XEN_GtkToggleAction__P(action), action, 1, "gtk_toggle_action_set_draw_as_radio", "GtkToggleAction*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(draw_as_radio), draw_as_radio, 2, "gtk_toggle_action_set_draw_as_radio", "gboolean");
  gtk_toggle_action_set_draw_as_radio(XEN_TO_C_GtkToggleAction_(action), XEN_TO_C_gboolean(draw_as_radio));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_action_get_draw_as_radio(XEN action)
{
  #define H_gtk_toggle_action_get_draw_as_radio "gboolean gtk_toggle_action_get_draw_as_radio(GtkToggleAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkToggleAction__P(action), action, 1, "gtk_toggle_action_get_draw_as_radio", "GtkToggleAction*");
  return(C_TO_XEN_gboolean(gtk_toggle_action_get_draw_as_radio(XEN_TO_C_GtkToggleAction_(action))));
}
static XEN gxg_gtk_toggle_tool_button_get_type(void)
{
  #define H_gtk_toggle_tool_button_get_type "GType gtk_toggle_tool_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_toggle_tool_button_get_type()));
}
static XEN gxg_gtk_toggle_tool_button_new(void)
{
  #define H_gtk_toggle_tool_button_new "GtkToolItem* gtk_toggle_tool_button_new( void)"
  return(C_TO_XEN_GtkToolItem_(gtk_toggle_tool_button_new()));
}
static XEN gxg_gtk_toggle_tool_button_new_from_stock(XEN stock_id)
{
  #define H_gtk_toggle_tool_button_new_from_stock "GtkToolItem* gtk_toggle_tool_button_new_from_stock(gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_toggle_tool_button_new_from_stock", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_toggle_tool_button_new_from_stock(XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_toggle_tool_button_set_active(XEN button, XEN is_active)
{
  #define H_gtk_toggle_tool_button_set_active "void gtk_toggle_tool_button_set_active(GtkToggleToolButton* button, \
gboolean is_active)"
  XEN_ASSERT_TYPE(XEN_GtkToggleToolButton__P(button), button, 1, "gtk_toggle_tool_button_set_active", "GtkToggleToolButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_active), is_active, 2, "gtk_toggle_tool_button_set_active", "gboolean");
  gtk_toggle_tool_button_set_active(XEN_TO_C_GtkToggleToolButton_(button), XEN_TO_C_gboolean(is_active));
  return(XEN_FALSE);
}
static XEN gxg_gtk_toggle_tool_button_get_active(XEN button)
{
  #define H_gtk_toggle_tool_button_get_active "gboolean gtk_toggle_tool_button_get_active(GtkToggleToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToggleToolButton__P(button), button, 1, "gtk_toggle_tool_button_get_active", "GtkToggleToolButton*");
  return(C_TO_XEN_gboolean(gtk_toggle_tool_button_get_active(XEN_TO_C_GtkToggleToolButton_(button))));
}
static XEN gxg_g_timeout_add_full(XEN priority, XEN interval, XEN func, XEN func_data, XEN notify)
{
  #define H_g_timeout_add_full "guint g_timeout_add_full(gint priority, guint interval, GSourceFunc func, \
lambda_data func_data, GtkDestroyNotify notify)"
  XEN_ASSERT_TYPE(XEN_gint_P(priority), priority, 1, "g_timeout_add_full", "gint");
  XEN_ASSERT_TYPE(XEN_guint_P(interval), interval, 2, "g_timeout_add_full", "guint");
  XEN_ASSERT_TYPE(XEN_GSourceFunc_P(func), func, 3, "g_timeout_add_full", "GSourceFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "g_timeout_add_full", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(notify), notify, 5, "g_timeout_add_full", "GtkDestroyNotify");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    XEN_LIST_SET(gxg_ptr, 3, notify);
    result = C_TO_XEN_guint(g_timeout_add_full(XEN_TO_C_gint(priority), XEN_TO_C_guint(interval), XEN_TO_C_GSourceFunc(func), 
                                               XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(notify)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_g_timeout_add(XEN interval, XEN func, XEN func_data)
{
  #define H_g_timeout_add "guint g_timeout_add(guint interval, GSourceFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_guint_P(interval), interval, 1, "g_timeout_add", "guint");
  XEN_ASSERT_TYPE(XEN_GSourceFunc_P(func), func, 2, "g_timeout_add", "GSourceFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "g_timeout_add", "lambda_data");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_guint(g_timeout_add(XEN_TO_C_guint(interval), XEN_TO_C_GSourceFunc(func), XEN_TO_C_lambda_data(func_data)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_g_idle_add(XEN func, XEN func_data)
{
  #define H_g_idle_add "guint g_idle_add(GSourceFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GSourceFunc_P(func), func, 1, "g_idle_add", "GSourceFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 2, "g_idle_add", "lambda_data");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    result = C_TO_XEN_guint(g_idle_add(XEN_TO_C_GSourceFunc(func), XEN_TO_C_lambda_data(func_data)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_g_idle_add_full(XEN priority, XEN func, XEN func_data, XEN notify)
{
  #define H_g_idle_add_full "guint g_idle_add_full(gint priority, GSourceFunc func, lambda_data func_data, \
GtkDestroyNotify notify)"
  XEN_ASSERT_TYPE(XEN_gint_P(priority), priority, 1, "g_idle_add_full", "gint");
  XEN_ASSERT_TYPE(XEN_GSourceFunc_P(func), func, 2, "g_idle_add_full", "GSourceFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "g_idle_add_full", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(notify), notify, 4, "g_idle_add_full", "GtkDestroyNotify");
  {
    XEN result = XEN_FALSE;
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    XEN_LIST_SET(gxg_ptr, 3, notify);
    result = C_TO_XEN_guint(g_idle_add_full(XEN_TO_C_gint(priority), XEN_TO_C_GSourceFunc(func), XEN_TO_C_lambda_data(func_data), 
                                            XEN_TO_C_GtkDestroyNotify(notify)));
    XEN_LIST_SET(gxg_ptr, 2, XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("idler"), result, C_TO_XEN_INT(loc)));
    return(result);
   }
}
static XEN gxg_g_idle_remove_by_data(XEN data)
{
  #define H_g_idle_remove_by_data "gboolean g_idle_remove_by_data(gpointer data)"
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 1, "g_idle_remove_by_data", "gpointer");
  return(C_TO_XEN_gboolean(g_idle_remove_by_data(XEN_TO_C_gpointer(data))));
  xm_unprotect_at(XEN_TO_C_INT(XEN_CADDR(data)));
}
static XEN gxg_g_source_remove(XEN tag)
{
  #define H_g_source_remove "gboolean g_source_remove(guint tag)"
  XEN_ASSERT_TYPE(XEN_guint_P(tag), tag, 1, "g_source_remove", "guint");
  return(C_TO_XEN_gboolean(g_source_remove(XEN_TO_C_guint(tag))));
  xm_unprotect_at(XEN_TO_C_INT(XEN_CADDR(tag)));
}
static XEN gxg_gtk_file_filter_get_type(void)
{
  #define H_gtk_file_filter_get_type "GType gtk_file_filter_get_type( void)"
  return(C_TO_XEN_GType(gtk_file_filter_get_type()));
}
static XEN gxg_gtk_file_filter_new(void)
{
  #define H_gtk_file_filter_new "GtkFileFilter* gtk_file_filter_new( void)"
  return(C_TO_XEN_GtkFileFilter_(gtk_file_filter_new()));
}
static XEN gxg_gtk_file_filter_set_name(XEN filter, XEN name)
{
  #define H_gtk_file_filter_set_name "void gtk_file_filter_set_name(GtkFileFilter* filter, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_set_name", "GtkFileFilter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_file_filter_set_name", "gchar*");
  gtk_file_filter_set_name(XEN_TO_C_GtkFileFilter_(filter), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_filter_get_name(XEN filter)
{
  #define H_gtk_file_filter_get_name "gchar* gtk_file_filter_get_name(GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_get_name", "GtkFileFilter*");
  return(C_TO_XEN_gchar_(gtk_file_filter_get_name(XEN_TO_C_GtkFileFilter_(filter))));
}
static XEN gxg_gtk_file_filter_add_mime_type(XEN filter, XEN mime_type)
{
  #define H_gtk_file_filter_add_mime_type "void gtk_file_filter_add_mime_type(GtkFileFilter* filter, \
gchar* mime_type)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_add_mime_type", "GtkFileFilter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(mime_type), mime_type, 2, "gtk_file_filter_add_mime_type", "gchar*");
  gtk_file_filter_add_mime_type(XEN_TO_C_GtkFileFilter_(filter), XEN_TO_C_gchar_(mime_type));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_filter_add_pattern(XEN filter, XEN pattern)
{
  #define H_gtk_file_filter_add_pattern "void gtk_file_filter_add_pattern(GtkFileFilter* filter, gchar* pattern)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_add_pattern", "GtkFileFilter*");
  XEN_ASSERT_TYPE(XEN_gchar__P(pattern), pattern, 2, "gtk_file_filter_add_pattern", "gchar*");
  gtk_file_filter_add_pattern(XEN_TO_C_GtkFileFilter_(filter), XEN_TO_C_gchar_(pattern));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_filter_add_custom(XEN filter, XEN needed, XEN func, XEN func_data, XEN notify)
{
  #define H_gtk_file_filter_add_custom "void gtk_file_filter_add_custom(GtkFileFilter* filter, GtkFileFilterFlags needed, \
GtkFileFilterFunc func, lambda_data func_data, GtkDestroyNotify notify)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_add_custom", "GtkFileFilter*");
  XEN_ASSERT_TYPE(XEN_GtkFileFilterFlags_P(needed), needed, 2, "gtk_file_filter_add_custom", "GtkFileFilterFlags");
  XEN_ASSERT_TYPE(XEN_GtkFileFilterFunc_P(func), func, 3, "gtk_file_filter_add_custom", "GtkFileFilterFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_file_filter_add_custom", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(notify), notify, 5, "gtk_file_filter_add_custom", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, notify);
    gtk_file_filter_add_custom(XEN_TO_C_GtkFileFilter_(filter), XEN_TO_C_GtkFileFilterFlags(needed), XEN_TO_C_GtkFileFilterFunc(func), 
                           XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(notify));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_file_filter_get_needed(XEN filter)
{
  #define H_gtk_file_filter_get_needed "GtkFileFilterFlags gtk_file_filter_get_needed(GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_get_needed", "GtkFileFilter*");
  return(C_TO_XEN_GtkFileFilterFlags(gtk_file_filter_get_needed(XEN_TO_C_GtkFileFilter_(filter))));
}
static XEN gxg_gtk_file_filter_filter(XEN filter, XEN filter_info)
{
  #define H_gtk_file_filter_filter "gboolean gtk_file_filter_filter(GtkFileFilter* filter, GtkFileFilterInfo* filter_info)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_filter", "GtkFileFilter*");
  XEN_ASSERT_TYPE(XEN_GtkFileFilterInfo__P(filter_info), filter_info, 2, "gtk_file_filter_filter", "GtkFileFilterInfo*");
  return(C_TO_XEN_gboolean(gtk_file_filter_filter(XEN_TO_C_GtkFileFilter_(filter), XEN_TO_C_GtkFileFilterInfo_(filter_info))));
}
static XEN gxg_gtk_cell_layout_get_type(void)
{
  #define H_gtk_cell_layout_get_type "GType gtk_cell_layout_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_layout_get_type()));
}
static XEN gxg_gtk_cell_layout_pack_start(XEN cell_layout, XEN cell, XEN expand)
{
  #define H_gtk_cell_layout_pack_start "void gtk_cell_layout_pack_start(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_pack_start", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_pack_start", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_cell_layout_pack_start", "gboolean");
  gtk_cell_layout_pack_start(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_layout_pack_end(XEN cell_layout, XEN cell, XEN expand)
{
  #define H_gtk_cell_layout_pack_end "void gtk_cell_layout_pack_end(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_pack_end", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_pack_end", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 3, "gtk_cell_layout_pack_end", "gboolean");
  gtk_cell_layout_pack_end(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_layout_clear(XEN cell_layout)
{
  #define H_gtk_cell_layout_clear "void gtk_cell_layout_clear(GtkCellLayout* cell_layout)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_clear", "GtkCellLayout*");
  gtk_cell_layout_clear(XEN_TO_C_GtkCellLayout_(cell_layout));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_layout_set_attributes(XEN cell_layout, XEN cell, XEN attributes)
{
  #define H_gtk_cell_layout_set_attributes "void gtk_cell_layout_set_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, etc attributes)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_set_attributes", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_set_attributes", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_etc_P(attributes), attributes, 3, "gtk_cell_layout_set_attributes", "etc");
  {
    int etc_len = 0;
    GtkCellLayout* p_arg0;
    GtkCellRenderer* p_arg1;
    if (XEN_LIST_P(attributes)) etc_len = XEN_LIST_LENGTH(attributes);
    if (etc_len < 2) XEN_OUT_OF_RANGE_ERROR("gtk_cell_layout_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) XEN_OUT_OF_RANGE_ERROR("gtk_cell_layout_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) XEN_OUT_OF_RANGE_ERROR("gtk_cell_layout_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = XEN_TO_C_GtkCellLayout_(cell_layout);
    p_arg1 = XEN_TO_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(XEN_FALSE);
  }
}
static XEN gxg_gtk_cell_layout_add_attribute(XEN cell_layout, XEN cell, XEN attribute, XEN column)
{
  #define H_gtk_cell_layout_add_attribute "void gtk_cell_layout_add_attribute(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, gchar* attribute, gint column)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_add_attribute", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_add_attribute", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gchar__P(attribute), attribute, 3, "gtk_cell_layout_add_attribute", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 4, "gtk_cell_layout_add_attribute", "gint");
  gtk_cell_layout_add_attribute(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gchar_(attribute), 
                                XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_layout_set_cell_data_func(XEN cell_layout, XEN cell, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_cell_layout_set_cell_data_func "void gtk_cell_layout_set_cell_data_func(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, GtkCellLayoutDataFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_set_cell_data_func", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_set_cell_data_func", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_GtkCellLayoutDataFunc_P(func), func, 3, "gtk_cell_layout_set_cell_data_func", "GtkCellLayoutDataFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "gtk_cell_layout_set_cell_data_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 5, "gtk_cell_layout_set_cell_data_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_cell_layout_set_cell_data_func(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_GtkCellLayoutDataFunc(func), 
                                   XEN_TO_C_lambda_data(func_data), XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_cell_layout_clear_attributes(XEN cell_layout, XEN cell)
{
  #define H_gtk_cell_layout_clear_attributes "void gtk_cell_layout_clear_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_clear_attributes", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_clear_attributes", "GtkCellRenderer*");
  gtk_cell_layout_clear_attributes(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_type(void)
{
  #define H_gtk_file_chooser_get_type "GType gtk_file_chooser_get_type( void)"
  return(C_TO_XEN_GType(gtk_file_chooser_get_type()));
}
static XEN gxg_gtk_file_chooser_set_action(XEN chooser, XEN action)
{
  #define H_gtk_file_chooser_set_action "void gtk_file_chooser_set_action(GtkFileChooser* chooser, GtkFileChooserAction action)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_action", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 2, "gtk_file_chooser_set_action", "GtkFileChooserAction");
  gtk_file_chooser_set_action(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkFileChooserAction(action));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_action(XEN chooser)
{
  #define H_gtk_file_chooser_get_action "GtkFileChooserAction gtk_file_chooser_get_action(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_action", "GtkFileChooser*");
  return(C_TO_XEN_GtkFileChooserAction(gtk_file_chooser_get_action(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_set_local_only(XEN chooser, XEN files_only)
{
  #define H_gtk_file_chooser_set_local_only "void gtk_file_chooser_set_local_only(GtkFileChooser* chooser, \
gboolean files_only)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_local_only", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(files_only), files_only, 2, "gtk_file_chooser_set_local_only", "gboolean");
  gtk_file_chooser_set_local_only(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gboolean(files_only));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_local_only(XEN chooser)
{
  #define H_gtk_file_chooser_get_local_only "gboolean gtk_file_chooser_get_local_only(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_local_only", "GtkFileChooser*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_get_local_only(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_set_select_multiple(XEN chooser, XEN select_multiple)
{
  #define H_gtk_file_chooser_set_select_multiple "void gtk_file_chooser_set_select_multiple(GtkFileChooser* chooser, \
gboolean select_multiple)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_select_multiple", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(select_multiple), select_multiple, 2, "gtk_file_chooser_set_select_multiple", "gboolean");
  gtk_file_chooser_set_select_multiple(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gboolean(select_multiple));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_select_multiple(XEN chooser)
{
  #define H_gtk_file_chooser_get_select_multiple "gboolean gtk_file_chooser_get_select_multiple(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_select_multiple", "GtkFileChooser*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_get_select_multiple(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_set_current_name(XEN chooser, XEN name)
{
  #define H_gtk_file_chooser_set_current_name "void gtk_file_chooser_set_current_name(GtkFileChooser* chooser, \
gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_current_name", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_file_chooser_set_current_name", "gchar*");
  gtk_file_chooser_set_current_name(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_filename(XEN chooser)
{
  #define H_gtk_file_chooser_get_filename "gchar* gtk_file_chooser_get_filename(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_filename", "GtkFileChooser*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_file_chooser_get_filename(XEN_TO_C_GtkFileChooser_(chooser));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_unselect_filename(XEN chooser, XEN filename)
{
  #define H_gtk_file_chooser_unselect_filename "void gtk_file_chooser_unselect_filename(GtkFileChooser* chooser, \
char* filename)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_unselect_filename", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 2, "gtk_file_chooser_unselect_filename", "char*");
  gtk_file_chooser_unselect_filename(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(filename));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_select_all(XEN chooser)
{
  #define H_gtk_file_chooser_select_all "void gtk_file_chooser_select_all(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_select_all", "GtkFileChooser*");
  gtk_file_chooser_select_all(XEN_TO_C_GtkFileChooser_(chooser));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_unselect_all(XEN chooser)
{
  #define H_gtk_file_chooser_unselect_all "void gtk_file_chooser_unselect_all(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_unselect_all", "GtkFileChooser*");
  gtk_file_chooser_unselect_all(XEN_TO_C_GtkFileChooser_(chooser));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_filenames(XEN chooser)
{
  #define H_gtk_file_chooser_get_filenames "GSList* gtk_file_chooser_get_filenames(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_filenames", "GtkFileChooser*");
  return(C_TO_XEN_GSList_(gtk_file_chooser_get_filenames(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_get_current_folder(XEN chooser)
{
  #define H_gtk_file_chooser_get_current_folder "gchar* gtk_file_chooser_get_current_folder(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_current_folder", "GtkFileChooser*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_file_chooser_get_current_folder(XEN_TO_C_GtkFileChooser_(chooser));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_get_uri(XEN chooser)
{
  #define H_gtk_file_chooser_get_uri "gchar* gtk_file_chooser_get_uri(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_uri", "GtkFileChooser*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_file_chooser_get_uri(XEN_TO_C_GtkFileChooser_(chooser));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_unselect_uri(XEN chooser, XEN uri)
{
  #define H_gtk_file_chooser_unselect_uri "void gtk_file_chooser_unselect_uri(GtkFileChooser* chooser, \
char* uri)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_unselect_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(uri), uri, 2, "gtk_file_chooser_unselect_uri", "char*");
  gtk_file_chooser_unselect_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(uri));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_uris(XEN chooser)
{
  #define H_gtk_file_chooser_get_uris "GSList* gtk_file_chooser_get_uris(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_uris", "GtkFileChooser*");
  return(C_TO_XEN_GSList_(gtk_file_chooser_get_uris(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_get_current_folder_uri(XEN chooser)
{
  #define H_gtk_file_chooser_get_current_folder_uri "gchar* gtk_file_chooser_get_current_folder_uri(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_current_folder_uri", "GtkFileChooser*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_file_chooser_get_current_folder_uri(XEN_TO_C_GtkFileChooser_(chooser));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_set_preview_widget(XEN chooser, XEN preview_widget)
{
  #define H_gtk_file_chooser_set_preview_widget "void gtk_file_chooser_set_preview_widget(GtkFileChooser* chooser, \
GtkWidget* preview_widget)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_preview_widget", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(preview_widget), preview_widget, 2, "gtk_file_chooser_set_preview_widget", "GtkWidget*");
  gtk_file_chooser_set_preview_widget(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkWidget_(preview_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_preview_widget(XEN chooser)
{
  #define H_gtk_file_chooser_get_preview_widget "GtkWidget* gtk_file_chooser_get_preview_widget(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_preview_widget", "GtkFileChooser*");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_get_preview_widget(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_set_preview_widget_active(XEN chooser, XEN active)
{
  #define H_gtk_file_chooser_set_preview_widget_active "void gtk_file_chooser_set_preview_widget_active(GtkFileChooser* chooser, \
gboolean active)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_preview_widget_active", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(active), active, 2, "gtk_file_chooser_set_preview_widget_active", "gboolean");
  gtk_file_chooser_set_preview_widget_active(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gboolean(active));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_preview_widget_active(XEN chooser)
{
  #define H_gtk_file_chooser_get_preview_widget_active "gboolean gtk_file_chooser_get_preview_widget_active(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_preview_widget_active", "GtkFileChooser*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_get_preview_widget_active(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_get_preview_filename(XEN file_chooser)
{
  #define H_gtk_file_chooser_get_preview_filename "char* gtk_file_chooser_get_preview_filename(GtkFileChooser* file_chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(file_chooser), file_chooser, 1, "gtk_file_chooser_get_preview_filename", "GtkFileChooser*");
  {
   char* result;
   XEN rtn;
   result = gtk_file_chooser_get_preview_filename(XEN_TO_C_GtkFileChooser_(file_chooser));
   rtn = C_TO_XEN_char_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_get_preview_uri(XEN file_chooser)
{
  #define H_gtk_file_chooser_get_preview_uri "char* gtk_file_chooser_get_preview_uri(GtkFileChooser* file_chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(file_chooser), file_chooser, 1, "gtk_file_chooser_get_preview_uri", "GtkFileChooser*");
  {
   char* result;
   XEN rtn;
   result = gtk_file_chooser_get_preview_uri(XEN_TO_C_GtkFileChooser_(file_chooser));
   rtn = C_TO_XEN_char_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_file_chooser_set_extra_widget(XEN chooser, XEN extra_widget)
{
  #define H_gtk_file_chooser_set_extra_widget "void gtk_file_chooser_set_extra_widget(GtkFileChooser* chooser, \
GtkWidget* extra_widget)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_extra_widget", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(extra_widget), extra_widget, 2, "gtk_file_chooser_set_extra_widget", "GtkWidget*");
  gtk_file_chooser_set_extra_widget(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkWidget_(extra_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_extra_widget(XEN chooser)
{
  #define H_gtk_file_chooser_get_extra_widget "GtkWidget* gtk_file_chooser_get_extra_widget(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_extra_widget", "GtkFileChooser*");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_get_extra_widget(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_add_filter(XEN chooser, XEN filter)
{
  #define H_gtk_file_chooser_add_filter "void gtk_file_chooser_add_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_add_filter", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 2, "gtk_file_chooser_add_filter", "GtkFileFilter*");
  gtk_file_chooser_add_filter(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkFileFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_remove_filter(XEN chooser, XEN filter)
{
  #define H_gtk_file_chooser_remove_filter "void gtk_file_chooser_remove_filter(GtkFileChooser* chooser, \
GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_remove_filter", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 2, "gtk_file_chooser_remove_filter", "GtkFileFilter*");
  gtk_file_chooser_remove_filter(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkFileFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_list_filters(XEN chooser)
{
  #define H_gtk_file_chooser_list_filters "GSList* gtk_file_chooser_list_filters(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_list_filters", "GtkFileChooser*");
  return(C_TO_XEN_GSList_(gtk_file_chooser_list_filters(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_set_filter(XEN chooser, XEN filter)
{
  #define H_gtk_file_chooser_set_filter "void gtk_file_chooser_set_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_filter", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 2, "gtk_file_chooser_set_filter", "GtkFileFilter*");
  gtk_file_chooser_set_filter(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_GtkFileFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_filter(XEN chooser)
{
  #define H_gtk_file_chooser_get_filter "GtkFileFilter* gtk_file_chooser_get_filter(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_filter", "GtkFileChooser*");
  return(C_TO_XEN_GtkFileFilter_(gtk_file_chooser_get_filter(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_add_shortcut_folder(XEN chooser, XEN folder, XEN error)
{
  #define H_gtk_file_chooser_add_shortcut_folder "gboolean gtk_file_chooser_add_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_add_shortcut_folder", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(folder), folder, 2, "gtk_file_chooser_add_shortcut_folder", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_file_chooser_add_shortcut_folder(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(folder), 
                                                                    &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_file_chooser_remove_shortcut_folder(XEN chooser, XEN folder, XEN error)
{
  #define H_gtk_file_chooser_remove_shortcut_folder "gboolean gtk_file_chooser_remove_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_remove_shortcut_folder", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(folder), folder, 2, "gtk_file_chooser_remove_shortcut_folder", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_file_chooser_remove_shortcut_folder(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(folder), 
                                                                       &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_file_chooser_list_shortcut_folders(XEN chooser)
{
  #define H_gtk_file_chooser_list_shortcut_folders "GSList* gtk_file_chooser_list_shortcut_folders(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_list_shortcut_folders", "GtkFileChooser*");
  return(C_TO_XEN_GSList_(gtk_file_chooser_list_shortcut_folders(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_add_shortcut_folder_uri(XEN chooser, XEN folder, XEN error)
{
  #define H_gtk_file_chooser_add_shortcut_folder_uri "gboolean gtk_file_chooser_add_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_add_shortcut_folder_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(folder), folder, 2, "gtk_file_chooser_add_shortcut_folder_uri", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_file_chooser_add_shortcut_folder_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(folder), 
                                                                        &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_file_chooser_remove_shortcut_folder_uri(XEN chooser, XEN folder, XEN error)
{
  #define H_gtk_file_chooser_remove_shortcut_folder_uri "gboolean gtk_file_chooser_remove_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_remove_shortcut_folder_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(folder), folder, 2, "gtk_file_chooser_remove_shortcut_folder_uri", "char*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_file_chooser_remove_shortcut_folder_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(folder), 
                                                                           &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_file_chooser_list_shortcut_folder_uris(XEN chooser)
{
  #define H_gtk_file_chooser_list_shortcut_folder_uris "GSList* gtk_file_chooser_list_shortcut_folder_uris(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_list_shortcut_folder_uris", "GtkFileChooser*");
  return(C_TO_XEN_GSList_(gtk_file_chooser_list_shortcut_folder_uris(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_icon_theme_get_type(void)
{
  #define H_gtk_icon_theme_get_type "GType gtk_icon_theme_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_theme_get_type()));
}
static XEN gxg_gtk_icon_theme_new(void)
{
  #define H_gtk_icon_theme_new "GtkIconTheme* gtk_icon_theme_new( void)"
  return(C_TO_XEN_GtkIconTheme_(gtk_icon_theme_new()));
}
static XEN gxg_gtk_icon_theme_get_default(void)
{
  #define H_gtk_icon_theme_get_default "GtkIconTheme* gtk_icon_theme_get_default( void)"
  return(C_TO_XEN_GtkIconTheme_(gtk_icon_theme_get_default()));
}
static XEN gxg_gtk_icon_theme_get_for_screen(XEN screen)
{
  #define H_gtk_icon_theme_get_for_screen "GtkIconTheme* gtk_icon_theme_get_for_screen(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gtk_icon_theme_get_for_screen", "GdkScreen*");
  return(C_TO_XEN_GtkIconTheme_(gtk_icon_theme_get_for_screen(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gtk_icon_theme_set_screen(XEN icon_theme, XEN screen)
{
  #define H_gtk_icon_theme_set_screen "void gtk_icon_theme_set_screen(GtkIconTheme* icon_theme, GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_set_screen", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen) || XEN_FALSE_P(screen), screen, 2, "gtk_icon_theme_set_screen", "GdkScreen*");
  gtk_icon_theme_set_screen(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_GdkScreen_(screen));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_theme_get_search_path(XEN icon_theme, XEN path, XEN n_elements)
{
  #define H_gtk_icon_theme_get_search_path "void gtk_icon_theme_get_search_path(GtkIconTheme* icon_theme, \
gchar*** [path], gint* [n_elements])"
  gchar** ref_path = NULL;
  gint ref_n_elements;
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_get_search_path", "GtkIconTheme*");
  gtk_icon_theme_get_search_path(XEN_TO_C_GtkIconTheme_(icon_theme), &ref_path, &ref_n_elements);
  return(XEN_LIST_2(C_TO_XEN_gchar__(ref_path), C_TO_XEN_gint(ref_n_elements)));
}
static XEN gxg_gtk_icon_theme_append_search_path(XEN icon_theme, XEN path)
{
  #define H_gtk_icon_theme_append_search_path "void gtk_icon_theme_append_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_append_search_path", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 2, "gtk_icon_theme_append_search_path", "gchar*");
  gtk_icon_theme_append_search_path(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_theme_prepend_search_path(XEN icon_theme, XEN path)
{
  #define H_gtk_icon_theme_prepend_search_path "void gtk_icon_theme_prepend_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_prepend_search_path", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(path), path, 2, "gtk_icon_theme_prepend_search_path", "gchar*");
  gtk_icon_theme_prepend_search_path(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_theme_set_custom_theme(XEN icon_theme, XEN theme_name)
{
  #define H_gtk_icon_theme_set_custom_theme "void gtk_icon_theme_set_custom_theme(GtkIconTheme* icon_theme, \
gchar* theme_name)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_set_custom_theme", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(theme_name), theme_name, 2, "gtk_icon_theme_set_custom_theme", "gchar*");
  gtk_icon_theme_set_custom_theme(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(theme_name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_theme_has_icon(XEN icon_theme, XEN icon_name)
{
  #define H_gtk_icon_theme_has_icon "gboolean gtk_icon_theme_has_icon(GtkIconTheme* icon_theme, gchar* icon_name)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_has_icon", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_icon_theme_has_icon", "gchar*");
  return(C_TO_XEN_gboolean(gtk_icon_theme_has_icon(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(icon_name))));
}
static XEN gxg_gtk_icon_theme_lookup_icon(XEN icon_theme, XEN icon_name, XEN size, XEN flags)
{
  #define H_gtk_icon_theme_lookup_icon "GtkIconInfo* gtk_icon_theme_lookup_icon(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, GtkIconLookupFlags flags)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_lookup_icon", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_icon_theme_lookup_icon", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(size), size, 3, "gtk_icon_theme_lookup_icon", "gint");
  XEN_ASSERT_TYPE(XEN_GtkIconLookupFlags_P(flags), flags, 4, "gtk_icon_theme_lookup_icon", "GtkIconLookupFlags");
  return(C_TO_XEN_GtkIconInfo_(gtk_icon_theme_lookup_icon(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(icon_name), 
                                                          XEN_TO_C_gint(size), XEN_TO_C_GtkIconLookupFlags(flags))));
}
static XEN gxg_gtk_icon_theme_load_icon(XEN icon_theme, XEN icon_name, XEN size, XEN flags, XEN error)
{
  #define H_gtk_icon_theme_load_icon "GdkPixbuf* gtk_icon_theme_load_icon(GtkIconTheme* icon_theme, gchar* icon_name, \
gint size, GtkIconLookupFlags flags, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_load_icon", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_icon_theme_load_icon", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(size), size, 3, "gtk_icon_theme_load_icon", "gint");
  XEN_ASSERT_TYPE(XEN_GtkIconLookupFlags_P(flags), flags, 4, "gtk_icon_theme_load_icon", "GtkIconLookupFlags");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbuf_(gtk_icon_theme_load_icon(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(icon_name), 
                                                          XEN_TO_C_gint(size), XEN_TO_C_GtkIconLookupFlags(flags), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_icon_theme_list_icons(XEN icon_theme, XEN context)
{
  #define H_gtk_icon_theme_list_icons "GList* gtk_icon_theme_list_icons(GtkIconTheme* icon_theme, gchar* context)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_list_icons", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(context), context, 2, "gtk_icon_theme_list_icons", "gchar*");
  return(C_TO_XEN_GList_(gtk_icon_theme_list_icons(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(context))));
}
static XEN gxg_gtk_icon_theme_get_example_icon_name(XEN icon_theme)
{
  #define H_gtk_icon_theme_get_example_icon_name "char* gtk_icon_theme_get_example_icon_name(GtkIconTheme* icon_theme)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_get_example_icon_name", "GtkIconTheme*");
  return(C_TO_XEN_char_(gtk_icon_theme_get_example_icon_name(XEN_TO_C_GtkIconTheme_(icon_theme))));
}
static XEN gxg_gtk_icon_theme_rescan_if_needed(XEN icon_theme)
{
  #define H_gtk_icon_theme_rescan_if_needed "gboolean gtk_icon_theme_rescan_if_needed(GtkIconTheme* icon_theme)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_rescan_if_needed", "GtkIconTheme*");
  return(C_TO_XEN_gboolean(gtk_icon_theme_rescan_if_needed(XEN_TO_C_GtkIconTheme_(icon_theme))));
}
static XEN gxg_gtk_icon_theme_add_builtin_icon(XEN icon_name, XEN size, XEN pixbuf)
{
  #define H_gtk_icon_theme_add_builtin_icon "void gtk_icon_theme_add_builtin_icon(gchar* icon_name, gint size, \
GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 1, "gtk_icon_theme_add_builtin_icon", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(size), size, 2, "gtk_icon_theme_add_builtin_icon", "gint");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 3, "gtk_icon_theme_add_builtin_icon", "GdkPixbuf*");
  gtk_icon_theme_add_builtin_icon(XEN_TO_C_gchar_(icon_name), XEN_TO_C_gint(size), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_info_get_type(void)
{
  #define H_gtk_icon_info_get_type "GType gtk_icon_info_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_info_get_type()));
}
static XEN gxg_gtk_icon_info_copy(XEN icon_info)
{
  #define H_gtk_icon_info_copy "GtkIconInfo* gtk_icon_info_copy(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_copy", "GtkIconInfo*");
  return(C_TO_XEN_GtkIconInfo_(gtk_icon_info_copy(XEN_TO_C_GtkIconInfo_(icon_info))));
}
static XEN gxg_gtk_icon_info_free(XEN icon_info)
{
  #define H_gtk_icon_info_free "void gtk_icon_info_free(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_free", "GtkIconInfo*");
  gtk_icon_info_free(XEN_TO_C_GtkIconInfo_(icon_info));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_info_get_base_size(XEN icon_info)
{
  #define H_gtk_icon_info_get_base_size "gint gtk_icon_info_get_base_size(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_base_size", "GtkIconInfo*");
  return(C_TO_XEN_gint(gtk_icon_info_get_base_size(XEN_TO_C_GtkIconInfo_(icon_info))));
}
static XEN gxg_gtk_icon_info_get_filename(XEN icon_info)
{
  #define H_gtk_icon_info_get_filename "gchar* gtk_icon_info_get_filename(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_filename", "GtkIconInfo*");
  return(C_TO_XEN_gchar_(gtk_icon_info_get_filename(XEN_TO_C_GtkIconInfo_(icon_info))));
}
static XEN gxg_gtk_icon_info_get_builtin_pixbuf(XEN icon_info)
{
  #define H_gtk_icon_info_get_builtin_pixbuf "GdkPixbuf* gtk_icon_info_get_builtin_pixbuf(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_builtin_pixbuf", "GtkIconInfo*");
  return(C_TO_XEN_GdkPixbuf_(gtk_icon_info_get_builtin_pixbuf(XEN_TO_C_GtkIconInfo_(icon_info))));
}
static XEN gxg_gtk_icon_info_load_icon(XEN icon_info, XEN error)
{
  #define H_gtk_icon_info_load_icon "GdkPixbuf* gtk_icon_info_load_icon(GtkIconInfo* icon_info, GError** [error])"
  GError* ref_error = NULL;
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_load_icon", "GtkIconInfo*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_GdkPixbuf_(gtk_icon_info_load_icon(XEN_TO_C_GtkIconInfo_(icon_info), &ref_error));
    return(XEN_LIST_2(result, C_TO_XEN_GError_(ref_error)));
   }
}
static XEN gxg_gtk_icon_info_set_raw_coordinates(XEN icon_info, XEN raw_coordinates)
{
  #define H_gtk_icon_info_set_raw_coordinates "void gtk_icon_info_set_raw_coordinates(GtkIconInfo* icon_info, \
gboolean raw_coordinates)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_set_raw_coordinates", "GtkIconInfo*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(raw_coordinates), raw_coordinates, 2, "gtk_icon_info_set_raw_coordinates", "gboolean");
  gtk_icon_info_set_raw_coordinates(XEN_TO_C_GtkIconInfo_(icon_info), XEN_TO_C_gboolean(raw_coordinates));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_info_get_embedded_rect(XEN icon_info, XEN rectangle)
{
  #define H_gtk_icon_info_get_embedded_rect "gboolean gtk_icon_info_get_embedded_rect(GtkIconInfo* icon_info, \
GdkRectangle* rectangle)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_embedded_rect", "GtkIconInfo*");
  XEN_ASSERT_TYPE(XEN_GdkRectangle__P(rectangle), rectangle, 2, "gtk_icon_info_get_embedded_rect", "GdkRectangle*");
  return(C_TO_XEN_gboolean(gtk_icon_info_get_embedded_rect(XEN_TO_C_GtkIconInfo_(icon_info), XEN_TO_C_GdkRectangle_(rectangle))));
}
static XEN gxg_gtk_icon_info_get_attach_points(XEN icon_info, XEN points, XEN n_points)
{
  #define H_gtk_icon_info_get_attach_points "gboolean gtk_icon_info_get_attach_points(GtkIconInfo* icon_info, \
GdkPoint** [points], gint* [n_points])"
  GdkPoint* ref_points = NULL;
  gint ref_n_points;
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_attach_points", "GtkIconInfo*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_icon_info_get_attach_points(XEN_TO_C_GtkIconInfo_(icon_info), &ref_points, &ref_n_points));
    return(XEN_LIST_3(result, C_TO_XEN_GdkPoint_(ref_points), C_TO_XEN_gint(ref_n_points)));
   }
}
static XEN gxg_gtk_icon_info_get_display_name(XEN icon_info)
{
  #define H_gtk_icon_info_get_display_name "gchar* gtk_icon_info_get_display_name(GtkIconInfo* icon_info)"
  XEN_ASSERT_TYPE(XEN_GtkIconInfo__P(icon_info), icon_info, 1, "gtk_icon_info_get_display_name", "GtkIconInfo*");
  return(C_TO_XEN_gchar_(gtk_icon_info_get_display_name(XEN_TO_C_GtkIconInfo_(icon_info))));
}
static XEN gxg_gtk_tool_button_get_type(void)
{
  #define H_gtk_tool_button_get_type "GType gtk_tool_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_tool_button_get_type()));
}
static XEN gxg_gtk_tool_button_new(XEN icon_widget, XEN label)
{
  #define H_gtk_tool_button_new "GtkToolItem* gtk_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(icon_widget) || XEN_FALSE_P(icon_widget), icon_widget, 1, "gtk_tool_button_new", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_tool_button_new", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_tool_button_new(XEN_TO_C_GtkWidget_(icon_widget), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_tool_button_new_from_stock(XEN stock_id)
{
  #define H_gtk_tool_button_new_from_stock "GtkToolItem* gtk_tool_button_new_from_stock(gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_tool_button_new_from_stock", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_tool_button_new_from_stock(XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_tool_button_set_label(XEN button, XEN label)
{
  #define H_gtk_tool_button_set_label "void gtk_tool_button_set_label(GtkToolButton* button, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_set_label", "GtkToolButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_tool_button_set_label", "gchar*");
  gtk_tool_button_set_label(XEN_TO_C_GtkToolButton_(button), XEN_TO_C_gchar_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_button_get_label(XEN button)
{
  #define H_gtk_tool_button_get_label "gchar* gtk_tool_button_get_label(GtkToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_get_label", "GtkToolButton*");
  return(C_TO_XEN_gchar_(gtk_tool_button_get_label(XEN_TO_C_GtkToolButton_(button))));
}
static XEN gxg_gtk_tool_button_set_use_underline(XEN button, XEN use_underline)
{
  #define H_gtk_tool_button_set_use_underline "void gtk_tool_button_set_use_underline(GtkToolButton* button, \
gboolean use_underline)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_set_use_underline", "GtkToolButton*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_underline), use_underline, 2, "gtk_tool_button_set_use_underline", "gboolean");
  gtk_tool_button_set_use_underline(XEN_TO_C_GtkToolButton_(button), XEN_TO_C_gboolean(use_underline));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_button_get_use_underline(XEN button)
{
  #define H_gtk_tool_button_get_use_underline "gboolean gtk_tool_button_get_use_underline(GtkToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_get_use_underline", "GtkToolButton*");
  return(C_TO_XEN_gboolean(gtk_tool_button_get_use_underline(XEN_TO_C_GtkToolButton_(button))));
}
static XEN gxg_gtk_tool_button_set_stock_id(XEN button, XEN stock_id)
{
  #define H_gtk_tool_button_set_stock_id "void gtk_tool_button_set_stock_id(GtkToolButton* button, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_set_stock_id", "GtkToolButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_tool_button_set_stock_id", "gchar*");
  gtk_tool_button_set_stock_id(XEN_TO_C_GtkToolButton_(button), XEN_TO_C_gchar_(stock_id));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_button_get_stock_id(XEN button)
{
  #define H_gtk_tool_button_get_stock_id "gchar* gtk_tool_button_get_stock_id(GtkToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_get_stock_id", "GtkToolButton*");
  return(C_TO_XEN_gchar_(gtk_tool_button_get_stock_id(XEN_TO_C_GtkToolButton_(button))));
}
static XEN gxg_gtk_tool_button_set_icon_widget(XEN button, XEN icon_widget)
{
  #define H_gtk_tool_button_set_icon_widget "void gtk_tool_button_set_icon_widget(GtkToolButton* button, \
GtkWidget* icon_widget)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_set_icon_widget", "GtkToolButton*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(icon_widget) || XEN_FALSE_P(icon_widget), icon_widget, 2, "gtk_tool_button_set_icon_widget", "GtkWidget*");
  gtk_tool_button_set_icon_widget(XEN_TO_C_GtkToolButton_(button), XEN_TO_C_GtkWidget_(icon_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_button_get_icon_widget(XEN button)
{
  #define H_gtk_tool_button_get_icon_widget "GtkWidget* gtk_tool_button_get_icon_widget(GtkToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_get_icon_widget", "GtkToolButton*");
  return(C_TO_XEN_GtkWidget_(gtk_tool_button_get_icon_widget(XEN_TO_C_GtkToolButton_(button))));
}
static XEN gxg_gtk_tool_button_set_label_widget(XEN button, XEN label_widget)
{
  #define H_gtk_tool_button_set_label_widget "void gtk_tool_button_set_label_widget(GtkToolButton* button, \
GtkWidget* label_widget)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_set_label_widget", "GtkToolButton*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(label_widget) || XEN_FALSE_P(label_widget), label_widget, 2, "gtk_tool_button_set_label_widget", "GtkWidget*");
  gtk_tool_button_set_label_widget(XEN_TO_C_GtkToolButton_(button), XEN_TO_C_GtkWidget_(label_widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_button_get_label_widget(XEN button)
{
  #define H_gtk_tool_button_get_label_widget "GtkWidget* gtk_tool_button_get_label_widget(GtkToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkToolButton__P(button), button, 1, "gtk_tool_button_get_label_widget", "GtkToolButton*");
  return(C_TO_XEN_GtkWidget_(gtk_tool_button_get_label_widget(XEN_TO_C_GtkToolButton_(button))));
}
static XEN gxg_gtk_tool_item_get_type(void)
{
  #define H_gtk_tool_item_get_type "GType gtk_tool_item_get_type( void)"
  return(C_TO_XEN_GType(gtk_tool_item_get_type()));
}
static XEN gxg_gtk_tool_item_new(void)
{
  #define H_gtk_tool_item_new "GtkToolItem* gtk_tool_item_new( void)"
  return(C_TO_XEN_GtkToolItem_(gtk_tool_item_new()));
}
static XEN gxg_gtk_tool_item_set_homogeneous(XEN tool_item, XEN homogeneous)
{
  #define H_gtk_tool_item_set_homogeneous "void gtk_tool_item_set_homogeneous(GtkToolItem* tool_item, \
gboolean homogeneous)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_set_homogeneous", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(homogeneous), homogeneous, 2, "gtk_tool_item_set_homogeneous", "gboolean");
  gtk_tool_item_set_homogeneous(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_gboolean(homogeneous));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_homogeneous(XEN tool_item)
{
  #define H_gtk_tool_item_get_homogeneous "gboolean gtk_tool_item_get_homogeneous(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_homogeneous", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_homogeneous(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_set_expand(XEN tool_item, XEN expand)
{
  #define H_gtk_tool_item_set_expand "void gtk_tool_item_set_expand(GtkToolItem* tool_item, gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_set_expand", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 2, "gtk_tool_item_set_expand", "gboolean");
  gtk_tool_item_set_expand(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_expand(XEN tool_item)
{
  #define H_gtk_tool_item_get_expand "gboolean gtk_tool_item_get_expand(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_expand", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_expand(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_set_tooltip(XEN tool_item, XEN tooltips, XEN tip_text, XEN tip_private)
{
  #define H_gtk_tool_item_set_tooltip "void gtk_tool_item_set_tooltip(GtkToolItem* tool_item, GtkTooltips* tooltips, \
gchar* tip_text, gchar* tip_private)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_set_tooltip", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 2, "gtk_tool_item_set_tooltip", "GtkTooltips*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_text), tip_text, 3, "gtk_tool_item_set_tooltip", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_private), tip_private, 4, "gtk_tool_item_set_tooltip", "gchar*");
  gtk_tool_item_set_tooltip(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_GtkTooltips_(tooltips), XEN_TO_C_gchar_(tip_text), 
                            XEN_TO_C_gchar_(tip_private));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_set_use_drag_window(XEN toolitem, XEN use_drag_window)
{
  #define H_gtk_tool_item_set_use_drag_window "void gtk_tool_item_set_use_drag_window(GtkToolItem* toolitem, \
gboolean use_drag_window)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_set_use_drag_window", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_drag_window), use_drag_window, 2, "gtk_tool_item_set_use_drag_window", "gboolean");
  gtk_tool_item_set_use_drag_window(XEN_TO_C_GtkToolItem_(toolitem), XEN_TO_C_gboolean(use_drag_window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_use_drag_window(XEN toolitem)
{
  #define H_gtk_tool_item_get_use_drag_window "gboolean gtk_tool_item_get_use_drag_window(GtkToolItem* toolitem)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_get_use_drag_window", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_use_drag_window(XEN_TO_C_GtkToolItem_(toolitem))));
}
static XEN gxg_gtk_tool_item_set_visible_horizontal(XEN toolitem, XEN visible_horizontal)
{
  #define H_gtk_tool_item_set_visible_horizontal "void gtk_tool_item_set_visible_horizontal(GtkToolItem* toolitem, \
gboolean visible_horizontal)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_set_visible_horizontal", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible_horizontal), visible_horizontal, 2, "gtk_tool_item_set_visible_horizontal", "gboolean");
  gtk_tool_item_set_visible_horizontal(XEN_TO_C_GtkToolItem_(toolitem), XEN_TO_C_gboolean(visible_horizontal));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_visible_horizontal(XEN toolitem)
{
  #define H_gtk_tool_item_get_visible_horizontal "gboolean gtk_tool_item_get_visible_horizontal(GtkToolItem* toolitem)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_get_visible_horizontal", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_visible_horizontal(XEN_TO_C_GtkToolItem_(toolitem))));
}
static XEN gxg_gtk_tool_item_set_visible_vertical(XEN toolitem, XEN visible_vertical)
{
  #define H_gtk_tool_item_set_visible_vertical "void gtk_tool_item_set_visible_vertical(GtkToolItem* toolitem, \
gboolean visible_vertical)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_set_visible_vertical", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible_vertical), visible_vertical, 2, "gtk_tool_item_set_visible_vertical", "gboolean");
  gtk_tool_item_set_visible_vertical(XEN_TO_C_GtkToolItem_(toolitem), XEN_TO_C_gboolean(visible_vertical));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_visible_vertical(XEN toolitem)
{
  #define H_gtk_tool_item_get_visible_vertical "gboolean gtk_tool_item_get_visible_vertical(GtkToolItem* toolitem)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(toolitem), toolitem, 1, "gtk_tool_item_get_visible_vertical", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_visible_vertical(XEN_TO_C_GtkToolItem_(toolitem))));
}
static XEN gxg_gtk_tool_item_get_is_important(XEN tool_item)
{
  #define H_gtk_tool_item_get_is_important "gboolean gtk_tool_item_get_is_important(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_is_important", "GtkToolItem*");
  return(C_TO_XEN_gboolean(gtk_tool_item_get_is_important(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_set_is_important(XEN tool_item, XEN is_important)
{
  #define H_gtk_tool_item_set_is_important "void gtk_tool_item_set_is_important(GtkToolItem* tool_item, \
gboolean is_important)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_set_is_important", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(is_important), is_important, 2, "gtk_tool_item_set_is_important", "gboolean");
  gtk_tool_item_set_is_important(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_gboolean(is_important));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tool_item_get_icon_size(XEN tool_item)
{
  #define H_gtk_tool_item_get_icon_size "GtkIconSize gtk_tool_item_get_icon_size(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_icon_size", "GtkToolItem*");
  return(C_TO_XEN_GtkIconSize(gtk_tool_item_get_icon_size(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_get_orientation(XEN tool_item)
{
  #define H_gtk_tool_item_get_orientation "GtkOrientation gtk_tool_item_get_orientation(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_orientation", "GtkToolItem*");
  return(C_TO_XEN_GtkOrientation(gtk_tool_item_get_orientation(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_get_toolbar_style(XEN tool_item)
{
  #define H_gtk_tool_item_get_toolbar_style "GtkToolbarStyle gtk_tool_item_get_toolbar_style(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_toolbar_style", "GtkToolItem*");
  return(C_TO_XEN_GtkToolbarStyle(gtk_tool_item_get_toolbar_style(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_get_relief_style(XEN tool_item)
{
  #define H_gtk_tool_item_get_relief_style "GtkReliefStyle gtk_tool_item_get_relief_style(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_relief_style", "GtkToolItem*");
  return(C_TO_XEN_GtkReliefStyle(gtk_tool_item_get_relief_style(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_retrieve_proxy_menu_item(XEN tool_item)
{
  #define H_gtk_tool_item_retrieve_proxy_menu_item "GtkWidget* gtk_tool_item_retrieve_proxy_menu_item(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_retrieve_proxy_menu_item", "GtkToolItem*");
  return(C_TO_XEN_GtkWidget_(gtk_tool_item_retrieve_proxy_menu_item(XEN_TO_C_GtkToolItem_(tool_item))));
}
static XEN gxg_gtk_tool_item_get_proxy_menu_item(XEN tool_item, XEN menu_item_id)
{
  #define H_gtk_tool_item_get_proxy_menu_item "GtkWidget* gtk_tool_item_get_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_get_proxy_menu_item", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gchar__P(menu_item_id), menu_item_id, 2, "gtk_tool_item_get_proxy_menu_item", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_tool_item_get_proxy_menu_item(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_gchar_(menu_item_id))));
}
static XEN gxg_gtk_tool_item_set_proxy_menu_item(XEN tool_item, XEN menu_item_id, XEN menu_item)
{
  #define H_gtk_tool_item_set_proxy_menu_item "void gtk_tool_item_set_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id, GtkWidget* menu_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item) || XEN_FALSE_P(tool_item), tool_item, 1, "gtk_tool_item_set_proxy_menu_item", "GtkToolItem*");
  XEN_ASSERT_TYPE(XEN_gchar__P(menu_item_id), menu_item_id, 2, "gtk_tool_item_set_proxy_menu_item", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_item) || XEN_FALSE_P(menu_item), menu_item, 3, "gtk_tool_item_set_proxy_menu_item", "GtkWidget*");
  gtk_tool_item_set_proxy_menu_item(XEN_TO_C_GtkToolItem_(tool_item), XEN_TO_C_gchar_(menu_item_id), XEN_TO_C_GtkWidget_(menu_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_remove(XEN list_store, XEN iter)
{
  #define H_gtk_list_store_remove "gboolean gtk_list_store_remove(GtkListStore* list_store, GtkTreeIter* iter)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_remove", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_remove", "GtkTreeIter*");
  return(C_TO_XEN_gboolean(gtk_list_store_remove(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter))));
}
#endif

#if HAVE_GTK_EXPANDER_GET_USE_MARKUP
static XEN gxg_gdk_drawable_copy_to_image(XEN drawable, XEN image, XEN src_x, XEN src_y, XEN dest_x, XEN dest_y, XEN width, XEN height)
{
  #define H_gdk_drawable_copy_to_image "GdkImage* gdk_drawable_copy_to_image(GdkDrawable* drawable, GdkImage* image, \
gint src_x, gint src_y, gint dest_x, gint dest_y, gint width, gint height)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_drawable_copy_to_image", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkImage__P(image), image, 2, "gdk_drawable_copy_to_image", "GdkImage*");
  XEN_ASSERT_TYPE(XEN_gint_P(src_x), src_x, 3, "gdk_drawable_copy_to_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(src_y), src_y, 4, "gdk_drawable_copy_to_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(dest_x), dest_x, 5, "gdk_drawable_copy_to_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(dest_y), dest_y, 6, "gdk_drawable_copy_to_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(width), width, 7, "gdk_drawable_copy_to_image", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(height), height, 8, "gdk_drawable_copy_to_image", "gint");
  return(C_TO_XEN_GdkImage_(gdk_drawable_copy_to_image(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkImage_(image), XEN_TO_C_gint(src_x), 
                                                       XEN_TO_C_gint(src_y), XEN_TO_C_gint(dest_x), XEN_TO_C_gint(dest_y), 
                                                       XEN_TO_C_gint(width), XEN_TO_C_gint(height))));
}
static XEN gxg_gtk_accel_group_activate(XEN accel_group, XEN accel_quark, XEN acceleratable, XEN accel_key, XEN accel_mods)
{
  #define H_gtk_accel_group_activate "gboolean gtk_accel_group_activate(GtkAccelGroup* accel_group, GQuark accel_quark, \
GObject* acceleratable, guint accel_key, GdkModifierType accel_mods)"
  XEN_ASSERT_TYPE(XEN_GtkAccelGroup__P(accel_group), accel_group, 1, "gtk_accel_group_activate", "GtkAccelGroup*");
  XEN_ASSERT_TYPE(XEN_GQuark_P(accel_quark), accel_quark, 2, "gtk_accel_group_activate", "GQuark");
  XEN_ASSERT_TYPE(XEN_GObject__P(acceleratable), acceleratable, 3, "gtk_accel_group_activate", "GObject*");
  XEN_ASSERT_TYPE(XEN_guint_P(accel_key), accel_key, 4, "gtk_accel_group_activate", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accel_mods), accel_mods, 5, "gtk_accel_group_activate", "GdkModifierType");
  return(C_TO_XEN_gboolean(gtk_accel_group_activate(XEN_TO_C_GtkAccelGroup_(accel_group), XEN_TO_C_GQuark(accel_quark), XEN_TO_C_GObject_(acceleratable), 
                                                    XEN_TO_C_guint(accel_key), XEN_TO_C_GdkModifierType(accel_mods))));
}
static XEN gxg_gtk_menu_set_monitor(XEN menu, XEN monitor_num)
{
  #define H_gtk_menu_set_monitor "void gtk_menu_set_monitor(GtkMenu* menu, gint monitor_num)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_monitor", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_gint_P(monitor_num), monitor_num, 2, "gtk_menu_set_monitor", "gint");
  gtk_menu_set_monitor(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_gint(monitor_num));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_can_activate_accel(XEN widget, XEN signal_id)
{
  #define H_gtk_widget_can_activate_accel "gboolean gtk_widget_can_activate_accel(GtkWidget* widget, \
guint signal_id)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_can_activate_accel", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_guint_P(signal_id), signal_id, 2, "gtk_widget_can_activate_accel", "guint");
  return(C_TO_XEN_gboolean(gtk_widget_can_activate_accel(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_guint(signal_id))));
}
static XEN gxg_gtk_window_is_active(XEN window)
{
  #define H_gtk_window_is_active "gboolean gtk_window_is_active(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_is_active", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_is_active(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_has_toplevel_focus(XEN window)
{
  #define H_gtk_window_has_toplevel_focus "gboolean gtk_window_has_toplevel_focus(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_has_toplevel_focus", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_has_toplevel_focus(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_combo_box_new(void)
{
  #define H_gtk_combo_box_new "GtkWidget* gtk_combo_box_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_new()));
}
static XEN gxg_gtk_combo_box_new_with_model(XEN model)
{
  #define H_gtk_combo_box_new_with_model "GtkWidget* gtk_combo_box_new_with_model(GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_combo_box_new_with_model", "GtkTreeModel*");
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_new_with_model(XEN_TO_C_GtkTreeModel_(model))));
}
static XEN gxg_gtk_combo_box_set_model(XEN combo_box, XEN model)
{
  #define H_gtk_combo_box_set_model "void gtk_combo_box_set_model(GtkComboBox* combo_box, GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_model", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model) || XEN_FALSE_P(model), model, 2, "gtk_combo_box_set_model", "GtkTreeModel*");
  gtk_combo_box_set_model(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_GtkTreeModel_(model));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_remove_text(XEN combo_box, XEN position)
{
  #define H_gtk_combo_box_remove_text "void gtk_combo_box_remove_text(GtkComboBox* combo_box, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_remove_text", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 2, "gtk_combo_box_remove_text", "gint");
  gtk_combo_box_remove_text(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_entry_new(void)
{
  #define H_gtk_combo_box_entry_new "GtkWidget* gtk_combo_box_entry_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_entry_new()));
}
static XEN gxg_gtk_combo_box_entry_new_with_model(XEN model, XEN text_column)
{
  #define H_gtk_combo_box_entry_new_with_model "GtkWidget* gtk_combo_box_entry_new_with_model(GtkTreeModel* model, \
gint text_column)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_combo_box_entry_new_with_model", "GtkTreeModel*");
  XEN_ASSERT_TYPE(XEN_gint_P(text_column), text_column, 2, "gtk_combo_box_entry_new_with_model", "gint");
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_entry_new_with_model(XEN_TO_C_GtkTreeModel_(model), XEN_TO_C_gint(text_column))));
}
static XEN gxg_gtk_combo_box_entry_set_text_column(XEN entry_box, XEN text_column)
{
  #define H_gtk_combo_box_entry_set_text_column "void gtk_combo_box_entry_set_text_column(GtkComboBoxEntry* entry_box, \
gint text_column)"
  XEN_ASSERT_TYPE(XEN_GtkComboBoxEntry__P(entry_box), entry_box, 1, "gtk_combo_box_entry_set_text_column", "GtkComboBoxEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(text_column), text_column, 2, "gtk_combo_box_entry_set_text_column", "gint");
  gtk_combo_box_entry_set_text_column(XEN_TO_C_GtkComboBoxEntry_(entry_box), XEN_TO_C_gint(text_column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_set_use_markup(XEN expander, XEN use_markup)
{
  #define H_gtk_expander_set_use_markup "void gtk_expander_set_use_markup(GtkExpander* expander, gboolean use_markup)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_set_use_markup", "GtkExpander*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_markup), use_markup, 2, "gtk_expander_set_use_markup", "gboolean");
  gtk_expander_set_use_markup(XEN_TO_C_GtkExpander_(expander), XEN_TO_C_gboolean(use_markup));
  return(XEN_FALSE);
}
static XEN gxg_gtk_expander_get_use_markup(XEN expander)
{
  #define H_gtk_expander_get_use_markup "gboolean gtk_expander_get_use_markup(GtkExpander* expander)"
  XEN_ASSERT_TYPE(XEN_GtkExpander__P(expander), expander, 1, "gtk_expander_get_use_markup", "GtkExpander*");
  return(C_TO_XEN_gboolean(gtk_expander_get_use_markup(XEN_TO_C_GtkExpander_(expander))));
}
static XEN gxg_gtk_radio_tool_button_new_from_widget(XEN group)
{
  #define H_gtk_radio_tool_button_new_from_widget "GtkToolItem* gtk_radio_tool_button_new_from_widget(GtkRadioToolButton* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioToolButton__P(group), group, 1, "gtk_radio_tool_button_new_from_widget", "GtkRadioToolButton*");
  return(C_TO_XEN_GtkToolItem_(gtk_radio_tool_button_new_from_widget(XEN_TO_C_GtkRadioToolButton_(group))));
}
static XEN gxg_gtk_separator_tool_item_get_draw(XEN item)
{
  #define H_gtk_separator_tool_item_get_draw "gboolean gtk_separator_tool_item_get_draw(GtkSeparatorToolItem* item)"
  XEN_ASSERT_TYPE(XEN_GtkSeparatorToolItem__P(item), item, 1, "gtk_separator_tool_item_get_draw", "GtkSeparatorToolItem*");
  return(C_TO_XEN_gboolean(gtk_separator_tool_item_get_draw(XEN_TO_C_GtkSeparatorToolItem_(item))));
}
static XEN gxg_gtk_separator_tool_item_set_draw(XEN tool_item, XEN draw)
{
  #define H_gtk_separator_tool_item_set_draw "void gtk_separator_tool_item_set_draw(GtkSeparatorToolItem* tool_item, \
gboolean draw)"
  XEN_ASSERT_TYPE(XEN_GtkSeparatorToolItem__P(tool_item), tool_item, 1, "gtk_separator_tool_item_set_draw", "GtkSeparatorToolItem*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(draw), draw, 2, "gtk_separator_tool_item_set_draw", "gboolean");
  gtk_separator_tool_item_set_draw(XEN_TO_C_GtkSeparatorToolItem_(tool_item), XEN_TO_C_gboolean(draw));
  return(XEN_FALSE);
}
#endif

#if HAVE_GTK_MENU_SHELL_CANCEL
static XEN gxg_gtk_notebook_append_page(XEN notebook, XEN child, XEN tab_label)
{
  #define H_gtk_notebook_append_page "gint gtk_notebook_append_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_append_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_append_page", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_append_page", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_notebook_append_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label))));
}
static XEN gxg_gtk_notebook_append_page_menu(XEN notebook, XEN child, XEN tab_label, XEN menu_label)
{
  #define H_gtk_notebook_append_page_menu "gint gtk_notebook_append_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_append_page_menu", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_append_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_append_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_label) || XEN_FALSE_P(menu_label), menu_label, 4, "gtk_notebook_append_page_menu", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_notebook_append_page_menu(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label), 
                                                     XEN_TO_C_GtkWidget_(menu_label))));
}
static XEN gxg_gtk_notebook_prepend_page(XEN notebook, XEN child, XEN tab_label)
{
  #define H_gtk_notebook_prepend_page "gint gtk_notebook_prepend_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_prepend_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_prepend_page", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_prepend_page", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_notebook_prepend_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label))));
}
static XEN gxg_gtk_notebook_prepend_page_menu(XEN notebook, XEN child, XEN tab_label, XEN menu_label)
{
  #define H_gtk_notebook_prepend_page_menu "gint gtk_notebook_prepend_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_prepend_page_menu", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_label) || XEN_FALSE_P(menu_label), menu_label, 4, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  return(C_TO_XEN_gint(gtk_notebook_prepend_page_menu(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label), 
                                                      XEN_TO_C_GtkWidget_(menu_label))));
}
static XEN gxg_gtk_notebook_insert_page(XEN notebook, XEN child, XEN tab_label, XEN position)
{
  #define H_gtk_notebook_insert_page "gint gtk_notebook_insert_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_insert_page", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_insert_page", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_insert_page", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 4, "gtk_notebook_insert_page", "gint");
  return(C_TO_XEN_gint(gtk_notebook_insert_page(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label), 
                                                XEN_TO_C_gint(position))));
}
static XEN gxg_gtk_notebook_insert_page_menu(XEN notebook, XEN child, XEN tab_label, XEN menu_label, XEN position)
{
  #define H_gtk_notebook_insert_page_menu "gint gtk_notebook_insert_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label, gint position)"
  XEN_ASSERT_TYPE(XEN_GtkNotebook__P(notebook), notebook, 1, "gtk_notebook_insert_page_menu", "GtkNotebook*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(child), child, 2, "gtk_notebook_insert_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(tab_label) || XEN_FALSE_P(tab_label), tab_label, 3, "gtk_notebook_insert_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu_label) || XEN_FALSE_P(menu_label), menu_label, 4, "gtk_notebook_insert_page_menu", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 5, "gtk_notebook_insert_page_menu", "gint");
  return(C_TO_XEN_gint(gtk_notebook_insert_page_menu(XEN_TO_C_GtkNotebook_(notebook), XEN_TO_C_GtkWidget_(child), XEN_TO_C_GtkWidget_(tab_label), 
                                                     XEN_TO_C_GtkWidget_(menu_label), XEN_TO_C_gint(position))));
}
static XEN gxg_gtk_radio_tool_button_new_with_stock_from_widget(XEN group, XEN stock_id)
{
  #define H_gtk_radio_tool_button_new_with_stock_from_widget "GtkToolItem* gtk_radio_tool_button_new_with_stock_from_widget(GtkRadioToolButton* group, \
gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_GtkRadioToolButton__P(group), group, 1, "gtk_radio_tool_button_new_with_stock_from_widget", "GtkRadioToolButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 2, "gtk_radio_tool_button_new_with_stock_from_widget", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_radio_tool_button_new_with_stock_from_widget(XEN_TO_C_GtkRadioToolButton_(group), XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gdk_display_set_double_click_distance(XEN display, XEN distance)
{
  #define H_gdk_display_set_double_click_distance "void gdk_display_set_double_click_distance(GdkDisplay* display, \
guint distance)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_set_double_click_distance", "GdkDisplay*");
  XEN_ASSERT_TYPE(XEN_guint_P(distance), distance, 2, "gdk_display_set_double_click_distance", "guint");
  gdk_display_set_double_click_distance(XEN_TO_C_GdkDisplay_(display), XEN_TO_C_guint(distance));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_get_default_group(XEN display)
{
  #define H_gdk_display_get_default_group "GdkWindow* gdk_display_get_default_group(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_get_default_group", "GdkDisplay*");
  return(C_TO_XEN_GdkWindow_(gdk_display_get_default_group(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gdk_window_set_accept_focus(XEN window, XEN accept_focus)
{
  #define H_gdk_window_set_accept_focus "void gdk_window_set_accept_focus(GdkWindow* window, gboolean accept_focus)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_accept_focus", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(accept_focus), accept_focus, 2, "gdk_window_set_accept_focus", "gboolean");
  gdk_window_set_accept_focus(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(accept_focus));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_get_group(XEN window)
{
  #define H_gdk_window_get_group "GdkWindow* gdk_window_get_group(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_get_group", "GdkWindow*");
  return(C_TO_XEN_GdkWindow_(gdk_window_get_group(XEN_TO_C_GdkWindow_(window))));
}
static XEN gxg_gtk_action_group_get_sensitive(XEN action_group)
{
  #define H_gtk_action_group_get_sensitive "gboolean gtk_action_group_get_sensitive(GtkActionGroup* action_group)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_get_sensitive", "GtkActionGroup*");
  return(C_TO_XEN_gboolean(gtk_action_group_get_sensitive(XEN_TO_C_GtkActionGroup_(action_group))));
}
static XEN gxg_gtk_action_group_set_sensitive(XEN action_group, XEN sensitive)
{
  #define H_gtk_action_group_set_sensitive "void gtk_action_group_set_sensitive(GtkActionGroup* action_group, \
gboolean sensitive)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_set_sensitive", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(sensitive), sensitive, 2, "gtk_action_group_set_sensitive", "gboolean");
  gtk_action_group_set_sensitive(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_gboolean(sensitive));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_get_visible(XEN action_group)
{
  #define H_gtk_action_group_get_visible "gboolean gtk_action_group_get_visible(GtkActionGroup* action_group)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_get_visible", "GtkActionGroup*");
  return(C_TO_XEN_gboolean(gtk_action_group_get_visible(XEN_TO_C_GtkActionGroup_(action_group))));
}
static XEN gxg_gtk_action_group_set_visible(XEN action_group, XEN visible)
{
  #define H_gtk_action_group_set_visible "void gtk_action_group_set_visible(GtkActionGroup* action_group, \
gboolean visible)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_set_visible", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible), visible, 2, "gtk_action_group_set_visible", "gboolean");
  gtk_action_group_set_visible(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_gboolean(visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_group_add_action_with_accel(XEN action_group, XEN action, XEN accelerator)
{
  #define H_gtk_action_group_add_action_with_accel "void gtk_action_group_add_action_with_accel(GtkActionGroup* action_group, \
GtkAction* action, gchar* accelerator)"
  XEN_ASSERT_TYPE(XEN_GtkActionGroup__P(action_group), action_group, 1, "gtk_action_group_add_action_with_accel", "GtkActionGroup*");
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 2, "gtk_action_group_add_action_with_accel", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_gchar__P(accelerator), accelerator, 3, "gtk_action_group_add_action_with_accel", "gchar*");
  gtk_action_group_add_action_with_accel(XEN_TO_C_GtkActionGroup_(action_group), XEN_TO_C_GtkAction_(action), XEN_TO_C_gchar_(accelerator));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_new(XEN name, XEN label, XEN tooltip, XEN stock_id)
{
  #define H_gtk_action_new "GtkAction* gtk_action_new(gchar* name, gchar* label, gchar* tooltip, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tooltip), tooltip, 3, "gtk_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 4, "gtk_action_new", "gchar*");
  return(C_TO_XEN_GtkAction_(gtk_action_new(XEN_TO_C_gchar_(name), XEN_TO_C_gchar_(label), XEN_TO_C_gchar_(tooltip), XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_action_is_sensitive(XEN action)
{
  #define H_gtk_action_is_sensitive "gboolean gtk_action_is_sensitive(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_is_sensitive", "GtkAction*");
  return(C_TO_XEN_gboolean(gtk_action_is_sensitive(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_get_sensitive(XEN action)
{
  #define H_gtk_action_get_sensitive "gboolean gtk_action_get_sensitive(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_get_sensitive", "GtkAction*");
  return(C_TO_XEN_gboolean(gtk_action_get_sensitive(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_is_visible(XEN action)
{
  #define H_gtk_action_is_visible "gboolean gtk_action_is_visible(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_is_visible", "GtkAction*");
  return(C_TO_XEN_gboolean(gtk_action_is_visible(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_action_get_visible(XEN action)
{
  #define H_gtk_action_get_visible "gboolean gtk_action_get_visible(GtkAction* action)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_get_visible", "GtkAction*");
  return(C_TO_XEN_gboolean(gtk_action_get_visible(XEN_TO_C_GtkAction_(action))));
}
static XEN gxg_gtk_button_set_alignment(XEN button, XEN xalign, XEN yalign)
{
  #define H_gtk_button_set_alignment "void gtk_button_set_alignment(GtkButton* button, gfloat xalign, \
gfloat yalign)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_alignment", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_button_set_alignment", "gfloat");
  XEN_ASSERT_TYPE(XEN_gfloat_P(yalign), yalign, 3, "gtk_button_set_alignment", "gfloat");
  gtk_button_set_alignment(XEN_TO_C_GtkButton_(button), XEN_TO_C_gfloat(xalign), XEN_TO_C_gfloat(yalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_alignment(XEN button, XEN xalign, XEN yalign)
{
  #define H_gtk_button_get_alignment "void gtk_button_get_alignment(GtkButton* button, gfloat* [xalign], \
gfloat* [yalign])"
  gfloat ref_xalign;
  gfloat ref_yalign;
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_alignment", "GtkButton*");
  gtk_button_get_alignment(XEN_TO_C_GtkButton_(button), &ref_xalign, &ref_yalign);
  return(XEN_LIST_2(C_TO_XEN_gfloat(ref_xalign), C_TO_XEN_gfloat(ref_yalign)));
}
static XEN gxg_gtk_cell_layout_reorder(XEN cell_layout, XEN cell, XEN position)
{
  #define H_gtk_cell_layout_reorder "void gtk_cell_layout_reorder(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gint position)"
  XEN_ASSERT_TYPE(XEN_GtkCellLayout__P(cell_layout), cell_layout, 1, "gtk_cell_layout_reorder", "GtkCellLayout*");
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 2, "gtk_cell_layout_reorder", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_cell_layout_reorder", "gint");
  gtk_cell_layout_reorder(XEN_TO_C_GtkCellLayout_(cell_layout), XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_clipboard_request_targets(XEN clipboard, XEN func, XEN func_data)
{
  #define H_gtk_clipboard_request_targets "void gtk_clipboard_request_targets(GtkClipboard* clipboard, \
GtkClipboardTargetsReceivedFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_request_targets", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkClipboardTargetsReceivedFunc_P(func), func, 2, "gtk_clipboard_request_targets", "GtkClipboardTargetsReceivedFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_clipboard_request_targets", "lambda_data");
  {
    int loc;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    loc = xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 2, C_TO_XEN_INT(loc));
    gtk_clipboard_request_targets(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkClipboardTargetsReceivedFunc(func), XEN_TO_C_lambda_data(func_data));
    xm_unprotect_at(loc);
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_clipboard_wait_for_targets(XEN clipboard, XEN targets, XEN n_targets)
{
  #define H_gtk_clipboard_wait_for_targets "gboolean gtk_clipboard_wait_for_targets(GtkClipboard* clipboard, \
GdkAtom** [targets], gint* [n_targets])"
  GdkAtom* ref_targets = NULL;
  gint ref_n_targets;
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_for_targets", "GtkClipboard*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_clipboard_wait_for_targets(XEN_TO_C_GtkClipboard_(clipboard), &ref_targets, &ref_n_targets));
    return(XEN_LIST_3(result, C_TO_XEN_GdkAtom_(ref_targets), C_TO_XEN_gint(ref_n_targets)));
   }
}
static XEN gxg_gtk_menu_shell_cancel(XEN menu_shell)
{
  #define H_gtk_menu_shell_cancel "void gtk_menu_shell_cancel(GtkMenuShell* menu_shell)"
  XEN_ASSERT_TYPE(XEN_GtkMenuShell__P(menu_shell), menu_shell, 1, "gtk_menu_shell_cancel", "GtkMenuShell*");
  gtk_menu_shell_cancel(XEN_TO_C_GtkMenuShell_(menu_shell));
  return(XEN_FALSE);
}
static XEN gxg_gtk_paned_get_child1(XEN paned)
{
  #define H_gtk_paned_get_child1 "GtkWidget* gtk_paned_get_child1(GtkPaned* paned)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_get_child1", "GtkPaned*");
  return(C_TO_XEN_GtkWidget_(gtk_paned_get_child1(XEN_TO_C_GtkPaned_(paned))));
}
static XEN gxg_gtk_paned_get_child2(XEN paned)
{
  #define H_gtk_paned_get_child2 "GtkWidget* gtk_paned_get_child2(GtkPaned* paned)"
  XEN_ASSERT_TYPE(XEN_GtkPaned__P(paned), paned, 1, "gtk_paned_get_child2", "GtkPaned*");
  return(C_TO_XEN_GtkWidget_(gtk_paned_get_child2(XEN_TO_C_GtkPaned_(paned))));
}
static XEN gxg_gtk_radio_action_new(XEN name, XEN label, XEN tooltip, XEN stock_id, XEN value)
{
  #define H_gtk_radio_action_new "GtkRadioAction* gtk_radio_action_new(gchar* name, gchar* label, gchar* tooltip, \
gchar* stock_id, gint value)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_radio_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tooltip), tooltip, 3, "gtk_radio_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 4, "gtk_radio_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gint_P(value), value, 5, "gtk_radio_action_new", "gint");
  return(C_TO_XEN_GtkRadioAction_(gtk_radio_action_new(XEN_TO_C_gchar_(name), XEN_TO_C_gchar_(label), XEN_TO_C_gchar_(tooltip), 
                                                       XEN_TO_C_gchar_(stock_id), XEN_TO_C_gint(value))));
}
static XEN gxg_gtk_toggle_action_new(XEN name, XEN label, XEN tooltip, XEN stock_id)
{
  #define H_gtk_toggle_action_new "GtkToggleAction* gtk_toggle_action_new(gchar* name, gchar* label, \
gchar* tooltip, gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_toggle_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_toggle_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tooltip), tooltip, 3, "gtk_toggle_action_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 4, "gtk_toggle_action_new", "gchar*");
  return(C_TO_XEN_GtkToggleAction_(gtk_toggle_action_new(XEN_TO_C_gchar_(name), XEN_TO_C_gchar_(label), XEN_TO_C_gchar_(tooltip), 
                                                         XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_window_set_accept_focus(XEN window, XEN setting)
{
  #define H_gtk_window_set_accept_focus "void gtk_window_set_accept_focus(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_accept_focus", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_accept_focus", "gboolean");
  gtk_window_set_accept_focus(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_accept_focus(XEN window)
{
  #define H_gtk_window_get_accept_focus "gboolean gtk_window_get_accept_focus(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_accept_focus", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_accept_focus(XEN_TO_C_GtkWindow_(window))));
}
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
static XEN gxg_gtk_accel_map_get_type(void)
{
  #define H_gtk_accel_map_get_type "GType gtk_accel_map_get_type( void)"
  return(C_TO_XEN_GType(gtk_accel_map_get_type()));
}
static XEN gxg_gtk_accel_map_get(void)
{
  #define H_gtk_accel_map_get "GtkAccelMap* gtk_accel_map_get( void)"
  return(C_TO_XEN_GtkAccelMap_(gtk_accel_map_get()));
}
static XEN gxg_gtk_combo_box_popup(XEN combo_box)
{
  #define H_gtk_combo_box_popup "void gtk_combo_box_popup(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_popup", "GtkComboBox*");
  gtk_combo_box_popup(XEN_TO_C_GtkComboBox_(combo_box));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_popdown(XEN combo_box)
{
  #define H_gtk_combo_box_popdown "void gtk_combo_box_popdown(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_popdown", "GtkComboBox*");
  gtk_combo_box_popdown(XEN_TO_C_GtkComboBox_(combo_box));
  return(XEN_FALSE);
}
static XEN gxg_gtk_radio_menu_item_new_from_widget(XEN group)
{
  #define H_gtk_radio_menu_item_new_from_widget "GtkWidget* gtk_radio_menu_item_new_from_widget(GtkRadioMenuItem* group)"
  XEN_ASSERT_TYPE(XEN_GtkRadioMenuItem__P(group), group, 1, "gtk_radio_menu_item_new_from_widget", "GtkRadioMenuItem*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new_from_widget(XEN_TO_C_GtkRadioMenuItem_(group))));
}
static XEN gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget(XEN group, XEN label)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_menu_item_new_with_mnemonic_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkRadioMenuItem__P(group), group, 1, "gtk_radio_menu_item_new_with_mnemonic_from_widget", "GtkRadioMenuItem*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_menu_item_new_with_mnemonic_from_widget", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new_with_mnemonic_from_widget(XEN_TO_C_GtkRadioMenuItem_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_radio_menu_item_new_with_label_from_widget(XEN group, XEN label)
{
  #define H_gtk_radio_menu_item_new_with_label_from_widget "GtkWidget* gtk_radio_menu_item_new_with_label_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkRadioMenuItem__P(group), group, 1, "gtk_radio_menu_item_new_with_label_from_widget", "GtkRadioMenuItem*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_radio_menu_item_new_with_label_from_widget", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_radio_menu_item_new_with_label_from_widget(XEN_TO_C_GtkRadioMenuItem_(group), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_scale_get_layout(XEN scale)
{
  #define H_gtk_scale_get_layout "PangoLayout* gtk_scale_get_layout(GtkScale* scale)"
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_get_layout", "GtkScale*");
  return(C_TO_XEN_PangoLayout_(gtk_scale_get_layout(XEN_TO_C_GtkScale_(scale))));
}
static XEN gxg_gtk_scale_get_layout_offsets(XEN scale, XEN x, XEN y)
{
  #define H_gtk_scale_get_layout_offsets "void gtk_scale_get_layout_offsets(GtkScale* scale, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  XEN_ASSERT_TYPE(XEN_GtkScale__P(scale), scale, 1, "gtk_scale_get_layout_offsets", "GtkScale*");
  gtk_scale_get_layout_offsets(XEN_TO_C_GtkScale_(scale), &ref_x, &ref_y);
  return(XEN_LIST_2(C_TO_XEN_gint(ref_x), C_TO_XEN_gint(ref_y)));
}
static XEN gxg_gtk_tooltips_get_info_from_tip_window(XEN tip_window, XEN tooltips, XEN current_widget)
{
  #define H_gtk_tooltips_get_info_from_tip_window "gboolean gtk_tooltips_get_info_from_tip_window(GtkWindow* tip_window, \
GtkTooltips** [tooltips], GtkWidget** [current_widget])"
  GtkTooltips* ref_tooltips = NULL;
  GtkWidget* ref_current_widget = NULL;
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(tip_window), tip_window, 1, "gtk_tooltips_get_info_from_tip_window", "GtkWindow*");
  {
    XEN result = XEN_FALSE;
    result = C_TO_XEN_gboolean(gtk_tooltips_get_info_from_tip_window(XEN_TO_C_GtkWindow_(tip_window), &ref_tooltips, &ref_current_widget));
    return(XEN_LIST_3(result, C_TO_XEN_GtkTooltips_(ref_tooltips), C_TO_XEN_GtkWidget_(ref_current_widget)));
   }
}
#endif

#if HAVE_GTK_COMBO_BOX_ENTRY_NEW_TEXT
static XEN gxg_gtk_combo_box_entry_new_text(void)
{
  #define H_gtk_combo_box_entry_new_text "GtkWidget* gtk_combo_box_entry_new_text( void)"
  return(C_TO_XEN_GtkWidget_(gtk_combo_box_entry_new_text()));
}
static XEN gxg_gtk_drag_source_get_target_list(XEN widget)
{
  #define H_gtk_drag_source_get_target_list "GtkTargetList* gtk_drag_source_get_target_list(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_get_target_list", "GtkWidget*");
  return(C_TO_XEN_GtkTargetList_(gtk_drag_source_get_target_list(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_drag_source_set_target_list(XEN widget, XEN target_list)
{
  #define H_gtk_drag_source_set_target_list "void gtk_drag_source_set_target_list(GtkWidget* widget, \
GtkTargetList* target_list)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_set_target_list", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(target_list) || XEN_FALSE_P(target_list), target_list, 2, "gtk_drag_source_set_target_list", "GtkTargetList*");
  gtk_drag_source_set_target_list(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkTargetList_(target_list));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_set_alignment(XEN entry, XEN xalign)
{
  #define H_gtk_entry_set_alignment "void gtk_entry_set_alignment(GtkEntry* entry, gfloat xalign)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_set_alignment", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gfloat_P(xalign), xalign, 2, "gtk_entry_set_alignment", "gfloat");
  gtk_entry_set_alignment(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gfloat(xalign));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_get_alignment(XEN entry)
{
  #define H_gtk_entry_get_alignment "gfloat gtk_entry_get_alignment(GtkEntry* entry)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_get_alignment", "GtkEntry*");
  return(C_TO_XEN_gfloat(gtk_entry_get_alignment(XEN_TO_C_GtkEntry_(entry))));
}
static XEN gxg_gtk_file_chooser_set_use_preview_label(XEN chooser, XEN use_label)
{
  #define H_gtk_file_chooser_set_use_preview_label "void gtk_file_chooser_set_use_preview_label(GtkFileChooser* chooser, \
gboolean use_label)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_use_preview_label", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(use_label), use_label, 2, "gtk_file_chooser_set_use_preview_label", "gboolean");
  gtk_file_chooser_set_use_preview_label(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gboolean(use_label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_use_preview_label(XEN chooser)
{
  #define H_gtk_file_chooser_get_use_preview_label "gboolean gtk_file_chooser_get_use_preview_label(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_use_preview_label", "GtkFileChooser*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_get_use_preview_label(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_file_chooser_widget_new_with_backend(XEN action, XEN backend)
{
  #define H_gtk_file_chooser_widget_new_with_backend "GtkWidget* gtk_file_chooser_widget_new_with_backend(GtkFileChooserAction action, \
gchar* backend)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 1, "gtk_file_chooser_widget_new_with_backend", "GtkFileChooserAction");
  XEN_ASSERT_TYPE(XEN_gchar__P(backend), backend, 2, "gtk_file_chooser_widget_new_with_backend", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_widget_new_with_backend(XEN_TO_C_GtkFileChooserAction(action), XEN_TO_C_gchar_(backend))));
}
static XEN gxg_gtk_widget_list_mnemonic_labels(XEN widget)
{
  #define H_gtk_widget_list_mnemonic_labels "GList* gtk_widget_list_mnemonic_labels(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_list_mnemonic_labels", "GtkWidget*");
  return(C_TO_XEN_GList_(gtk_widget_list_mnemonic_labels(XEN_TO_C_GtkWidget_(widget))));
}
static XEN gxg_gtk_widget_add_mnemonic_label(XEN widget, XEN label)
{
  #define H_gtk_widget_add_mnemonic_label "void gtk_widget_add_mnemonic_label(GtkWidget* widget, GtkWidget* label)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_add_mnemonic_label", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(label), label, 2, "gtk_widget_add_mnemonic_label", "GtkWidget*");
  gtk_widget_add_mnemonic_label(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkWidget_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_widget_remove_mnemonic_label(XEN widget, XEN label)
{
  #define H_gtk_widget_remove_mnemonic_label "void gtk_widget_remove_mnemonic_label(GtkWidget* widget, \
GtkWidget* label)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_widget_remove_mnemonic_label", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(label), label, 2, "gtk_widget_remove_mnemonic_label", "GtkWidget*");
  gtk_widget_remove_mnemonic_label(XEN_TO_C_GtkWidget_(widget), XEN_TO_C_GtkWidget_(label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_activate_key(XEN window, XEN event)
{
  #define H_gtk_window_activate_key "gboolean gtk_window_activate_key(GtkWindow* window, GdkEventKey* event)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_activate_key", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(event), event, 2, "gtk_window_activate_key", "GdkEventKey*");
  return(C_TO_XEN_gboolean(gtk_window_activate_key(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkEventKey_(event))));
}
static XEN gxg_gtk_window_propagate_key_event(XEN window, XEN event)
{
  #define H_gtk_window_propagate_key_event "gboolean gtk_window_propagate_key_event(GtkWindow* window, \
GdkEventKey* event)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_propagate_key_event", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(event), event, 2, "gtk_window_propagate_key_event", "GdkEventKey*");
  return(C_TO_XEN_gboolean(gtk_window_propagate_key_event(XEN_TO_C_GtkWindow_(window), XEN_TO_C_GdkEventKey_(event))));
}
#endif

#if HAVE_GBOOLEAN_GTK_FILE_CHOOSER_SET_FILENAME
static XEN gxg_gtk_file_chooser_set_filename(XEN chooser, XEN filename)
{
  #define H_gtk_file_chooser_set_filename "gboolean gtk_file_chooser_set_filename(GtkFileChooser* chooser, \
char* filename)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_filename", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 2, "gtk_file_chooser_set_filename", "char*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_set_filename(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(filename))));
}
static XEN gxg_gtk_file_chooser_select_filename(XEN chooser, XEN filename)
{
  #define H_gtk_file_chooser_select_filename "gboolean gtk_file_chooser_select_filename(GtkFileChooser* chooser, \
char* filename)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_select_filename", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(filename), filename, 2, "gtk_file_chooser_select_filename", "char*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_select_filename(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(filename))));
}
static XEN gxg_gtk_file_chooser_set_current_folder(XEN chooser, XEN filename)
{
  #define H_gtk_file_chooser_set_current_folder "gboolean gtk_file_chooser_set_current_folder(GtkFileChooser* chooser, \
gchar* filename)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_current_folder", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gchar__P(filename), filename, 2, "gtk_file_chooser_set_current_folder", "gchar*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_set_current_folder(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gchar_(filename))));
}
static XEN gxg_gtk_file_chooser_set_uri(XEN chooser, XEN uri)
{
  #define H_gtk_file_chooser_set_uri "gboolean gtk_file_chooser_set_uri(GtkFileChooser* chooser, char* uri)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(uri), uri, 2, "gtk_file_chooser_set_uri", "char*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_set_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(uri))));
}
static XEN gxg_gtk_file_chooser_select_uri(XEN chooser, XEN uri)
{
  #define H_gtk_file_chooser_select_uri "gboolean gtk_file_chooser_select_uri(GtkFileChooser* chooser, \
char* uri)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_select_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_char__P(uri), uri, 2, "gtk_file_chooser_select_uri", "char*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_select_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_char_(uri))));
}
static XEN gxg_gtk_file_chooser_set_current_folder_uri(XEN chooser, XEN uri)
{
  #define H_gtk_file_chooser_set_current_folder_uri "gboolean gtk_file_chooser_set_current_folder_uri(GtkFileChooser* chooser, \
gchar* uri)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_current_folder_uri", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gchar__P(uri), uri, 2, "gtk_file_chooser_set_current_folder_uri", "gchar*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_set_current_folder_uri(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gchar_(uri))));
}
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
static XEN gxg_gtk_cell_view_get_type(void)
{
  #define H_gtk_cell_view_get_type "GType gtk_cell_view_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_view_get_type()));
}
static XEN gxg_gtk_cell_view_new(void)
{
  #define H_gtk_cell_view_new "GtkWidget* gtk_cell_view_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_cell_view_new()));
}
static XEN gxg_gtk_cell_view_new_with_text(XEN text)
{
  #define H_gtk_cell_view_new_with_text "GtkWidget* gtk_cell_view_new_with_text(gchar* text)"
  XEN_ASSERT_TYPE(XEN_gchar__P(text), text, 1, "gtk_cell_view_new_with_text", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_cell_view_new_with_text(XEN_TO_C_gchar_(text))));
}
static XEN gxg_gtk_cell_view_new_with_markup(XEN markup)
{
  #define H_gtk_cell_view_new_with_markup "GtkWidget* gtk_cell_view_new_with_markup(gchar* markup)"
  XEN_ASSERT_TYPE(XEN_gchar__P(markup), markup, 1, "gtk_cell_view_new_with_markup", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_cell_view_new_with_markup(XEN_TO_C_gchar_(markup))));
}
static XEN gxg_gtk_cell_view_new_with_pixbuf(XEN pixbuf)
{
  #define H_gtk_cell_view_new_with_pixbuf "GtkWidget* gtk_cell_view_new_with_pixbuf(GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 1, "gtk_cell_view_new_with_pixbuf", "GdkPixbuf*");
  return(C_TO_XEN_GtkWidget_(gtk_cell_view_new_with_pixbuf(XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gtk_cell_view_set_model(XEN cell_view, XEN model)
{
  #define H_gtk_cell_view_set_model "void gtk_cell_view_set_model(GtkCellView* cell_view, GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cell_view), cell_view, 1, "gtk_cell_view_set_model", "GtkCellView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model) || XEN_FALSE_P(model), model, 2, "gtk_cell_view_set_model", "GtkTreeModel*");
  gtk_cell_view_set_model(XEN_TO_C_GtkCellView_(cell_view), XEN_TO_C_GtkTreeModel_(model));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_view_set_displayed_row(XEN cell_view, XEN path)
{
  #define H_gtk_cell_view_set_displayed_row "void gtk_cell_view_set_displayed_row(GtkCellView* cell_view, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cell_view), cell_view, 1, "gtk_cell_view_set_displayed_row", "GtkCellView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_cell_view_set_displayed_row", "GtkTreePath*");
  gtk_cell_view_set_displayed_row(XEN_TO_C_GtkCellView_(cell_view), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_view_get_displayed_row(XEN cell_view)
{
  #define H_gtk_cell_view_get_displayed_row "GtkTreePath* gtk_cell_view_get_displayed_row(GtkCellView* cell_view)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cell_view), cell_view, 1, "gtk_cell_view_get_displayed_row", "GtkCellView*");
  return(C_TO_XEN_GtkTreePath_(gtk_cell_view_get_displayed_row(XEN_TO_C_GtkCellView_(cell_view))));
}
static XEN gxg_gtk_cell_view_get_size_of_row(XEN cell_view, XEN path, XEN requisition)
{
  #define H_gtk_cell_view_get_size_of_row "gboolean gtk_cell_view_get_size_of_row(GtkCellView* cell_view, \
GtkTreePath* path, GtkRequisition* requisition)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cell_view), cell_view, 1, "gtk_cell_view_get_size_of_row", "GtkCellView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_cell_view_get_size_of_row", "GtkTreePath*");
  XEN_ASSERT_TYPE(XEN_GtkRequisition__P(requisition), requisition, 3, "gtk_cell_view_get_size_of_row", "GtkRequisition*");
  return(C_TO_XEN_gboolean(gtk_cell_view_get_size_of_row(XEN_TO_C_GtkCellView_(cell_view), XEN_TO_C_GtkTreePath_(path), XEN_TO_C_GtkRequisition_(requisition))));
}
static XEN gxg_gtk_cell_view_set_background_color(XEN cell_view, XEN color)
{
  #define H_gtk_cell_view_set_background_color "void gtk_cell_view_set_background_color(GtkCellView* cell_view, \
GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cell_view), cell_view, 1, "gtk_cell_view_set_background_color", "GtkCellView*");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 2, "gtk_cell_view_set_background_color", "GdkColor*");
  gtk_cell_view_set_background_color(XEN_TO_C_GtkCellView_(cell_view), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_view_get_cell_renderers(XEN cellview)
{
  #define H_gtk_cell_view_get_cell_renderers "GList* gtk_cell_view_get_cell_renderers(GtkCellView* cellview)"
  XEN_ASSERT_TYPE(XEN_GtkCellView__P(cellview), cellview, 1, "gtk_cell_view_get_cell_renderers", "GtkCellView*");
  return(C_TO_XEN_GList_(gtk_cell_view_get_cell_renderers(XEN_TO_C_GtkCellView_(cellview))));
}
static XEN gxg_gdk_window_set_focus_on_map(XEN window, XEN focus_on_map)
{
  #define H_gdk_window_set_focus_on_map "void gdk_window_set_focus_on_map(GdkWindow* window, gboolean focus_on_map)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_set_focus_on_map", "GdkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(focus_on_map), focus_on_map, 2, "gdk_window_set_focus_on_map", "gboolean");
  gdk_window_set_focus_on_map(XEN_TO_C_GdkWindow_(window), XEN_TO_C_gboolean(focus_on_map));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_enable_synchronized_configure(XEN window)
{
  #define H_gdk_window_enable_synchronized_configure "void gdk_window_enable_synchronized_configure(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_enable_synchronized_configure", "GdkWindow*");
  gdk_window_enable_synchronized_configure(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gdk_window_configure_finished(XEN window)
{
  #define H_gdk_window_configure_finished "void gdk_window_configure_finished(GdkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GdkWindow__P(window), window, 1, "gdk_window_configure_finished", "GdkWindow*");
  gdk_window_configure_finished(XEN_TO_C_GdkWindow_(window));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_wrap_width(XEN combo_box)
{
  #define H_gtk_combo_box_get_wrap_width "gint gtk_combo_box_get_wrap_width(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_wrap_width", "GtkComboBox*");
  return(C_TO_XEN_gint(gtk_combo_box_get_wrap_width(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_get_row_span_column(XEN combo_box)
{
  #define H_gtk_combo_box_get_row_span_column "gint gtk_combo_box_get_row_span_column(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_row_span_column", "GtkComboBox*");
  return(C_TO_XEN_gint(gtk_combo_box_get_row_span_column(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_get_column_span_column(XEN combo_box)
{
  #define H_gtk_combo_box_get_column_span_column "gint gtk_combo_box_get_column_span_column(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_column_span_column", "GtkComboBox*");
  return(C_TO_XEN_gint(gtk_combo_box_get_column_span_column(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_get_add_tearoffs(XEN combo_box)
{
  #define H_gtk_combo_box_get_add_tearoffs "gboolean gtk_combo_box_get_add_tearoffs(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_add_tearoffs", "GtkComboBox*");
  return(C_TO_XEN_gboolean(gtk_combo_box_get_add_tearoffs(XEN_TO_C_GtkComboBox_(combo_box))));
}
static XEN gxg_gtk_combo_box_set_add_tearoffs(XEN combo_box, XEN add_tearoffs)
{
  #define H_gtk_combo_box_set_add_tearoffs "void gtk_combo_box_set_add_tearoffs(GtkComboBox* combo_box, \
gboolean add_tearoffs)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_add_tearoffs", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(add_tearoffs), add_tearoffs, 2, "gtk_combo_box_set_add_tearoffs", "gboolean");
  gtk_combo_box_set_add_tearoffs(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_gboolean(add_tearoffs));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_active_text(XEN combo_box)
{
  #define H_gtk_combo_box_get_active_text "gchar* gtk_combo_box_get_active_text(GtkComboBox* combo_box)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_get_active_text", "GtkComboBox*");
  {
   gchar* result;
   XEN rtn;
   result = gtk_combo_box_get_active_text(XEN_TO_C_GtkComboBox_(combo_box));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_drag_dest_add_text_targets(XEN widget)
{
  #define H_gtk_drag_dest_add_text_targets "void gtk_drag_dest_add_text_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_add_text_targets", "GtkWidget*");
  gtk_drag_dest_add_text_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_add_text_targets(XEN widget)
{
  #define H_gtk_drag_source_add_text_targets "void gtk_drag_source_add_text_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_add_text_targets", "GtkWidget*");
  gtk_drag_source_add_text_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_insert_prefix(XEN completion)
{
  #define H_gtk_entry_completion_insert_prefix "void gtk_entry_completion_insert_prefix(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_insert_prefix", "GtkEntryCompletion*");
  gtk_entry_completion_insert_prefix(XEN_TO_C_GtkEntryCompletion_(completion));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_set_inline_completion(XEN completion, XEN inline_completion)
{
  #define H_gtk_entry_completion_set_inline_completion "void gtk_entry_completion_set_inline_completion(GtkEntryCompletion* completion, \
gboolean inline_completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_inline_completion", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(inline_completion), inline_completion, 2, "gtk_entry_completion_set_inline_completion", "gboolean");
  gtk_entry_completion_set_inline_completion(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gboolean(inline_completion));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_get_inline_completion(XEN completion)
{
  #define H_gtk_entry_completion_get_inline_completion "gboolean gtk_entry_completion_get_inline_completion(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_get_inline_completion", "GtkEntryCompletion*");
  return(C_TO_XEN_gboolean(gtk_entry_completion_get_inline_completion(XEN_TO_C_GtkEntryCompletion_(completion))));
}
static XEN gxg_gtk_entry_completion_set_popup_completion(XEN completion, XEN popup_completion)
{
  #define H_gtk_entry_completion_set_popup_completion "void gtk_entry_completion_set_popup_completion(GtkEntryCompletion* completion, \
gboolean popup_completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_set_popup_completion", "GtkEntryCompletion*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(popup_completion), popup_completion, 2, "gtk_entry_completion_set_popup_completion", "gboolean");
  gtk_entry_completion_set_popup_completion(XEN_TO_C_GtkEntryCompletion_(completion), XEN_TO_C_gboolean(popup_completion));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_completion_get_popup_completion(XEN completion)
{
  #define H_gtk_entry_completion_get_popup_completion "gboolean gtk_entry_completion_get_popup_completion(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_get_popup_completion", "GtkEntryCompletion*");
  return(C_TO_XEN_gboolean(gtk_entry_completion_get_popup_completion(XEN_TO_C_GtkEntryCompletion_(completion))));
}
static XEN gxg_gtk_entry_completion_get_text_column(XEN completion)
{
  #define H_gtk_entry_completion_get_text_column "gint gtk_entry_completion_get_text_column(GtkEntryCompletion* completion)"
  XEN_ASSERT_TYPE(XEN_GtkEntryCompletion__P(completion), completion, 1, "gtk_entry_completion_get_text_column", "GtkEntryCompletion*");
  return(C_TO_XEN_gint(gtk_entry_completion_get_text_column(XEN_TO_C_GtkEntryCompletion_(completion))));
}
static XEN gxg_gtk_icon_theme_get_icon_sizes(XEN icon_theme, XEN icon_name)
{
  #define H_gtk_icon_theme_get_icon_sizes "gint* gtk_icon_theme_get_icon_sizes(GtkIconTheme* icon_theme, \
gchar* icon_name)"
  XEN_ASSERT_TYPE(XEN_GtkIconTheme__P(icon_theme), icon_theme, 1, "gtk_icon_theme_get_icon_sizes", "GtkIconTheme*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_icon_theme_get_icon_sizes", "gchar*");
  return(C_TO_XEN_gint_(gtk_icon_theme_get_icon_sizes(XEN_TO_C_GtkIconTheme_(icon_theme), XEN_TO_C_gchar_(icon_name))));
}
static XEN gxg_gtk_menu_get_for_attach_widget(XEN widget )
{
  #define H_gtk_menu_get_for_attach_widget "GList* gtk_menu_get_for_attach_widget(GtkWidget* widget, \
)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget ), widget , 1, "gtk_menu_get_for_attach_widget", "GtkWidget*");
  return(C_TO_XEN_GList_(gtk_menu_get_for_attach_widget(XEN_TO_C_GtkWidget_(widget ))));
}
static XEN gxg_gtk_tree_view_set_fixed_height_mode(XEN tree_view, XEN enable)
{
  #define H_gtk_tree_view_set_fixed_height_mode "void gtk_tree_view_set_fixed_height_mode(GtkTreeView* tree_view, \
gboolean enable)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_fixed_height_mode", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(enable), enable, 2, "gtk_tree_view_set_fixed_height_mode", "gboolean");
  gtk_tree_view_set_fixed_height_mode(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(enable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_fixed_height_mode(XEN tree_view)
{
  #define H_gtk_tree_view_get_fixed_height_mode "gboolean gtk_tree_view_get_fixed_height_mode(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_fixed_height_mode", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_fixed_height_mode(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_hover_selection(XEN tree_view, XEN hover)
{
  #define H_gtk_tree_view_set_hover_selection "void gtk_tree_view_set_hover_selection(GtkTreeView* tree_view, \
gboolean hover)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_hover_selection", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(hover), hover, 2, "gtk_tree_view_set_hover_selection", "gboolean");
  gtk_tree_view_set_hover_selection(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(hover));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_hover_selection(XEN tree_view)
{
  #define H_gtk_tree_view_get_hover_selection "gboolean gtk_tree_view_get_hover_selection(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_hover_selection", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_hover_selection(XEN_TO_C_GtkTreeView_(tree_view))));
}
static XEN gxg_gtk_tree_view_set_row_separator_func(XEN tree_view, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_tree_view_set_row_separator_func "void gtk_tree_view_set_row_separator_func(GtkTreeView* tree_view, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_row_separator_func", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewRowSeparatorFunc_P(func), func, 2, "gtk_tree_view_set_row_separator_func", "GtkTreeViewRowSeparatorFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_tree_view_set_row_separator_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 4, "gtk_tree_view_set_row_separator_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_tree_view_set_row_separator_func(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_GtkTreeViewRowSeparatorFunc(func), XEN_TO_C_lambda_data(func_data), 
                                     XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_window_set_focus_on_map(XEN window, XEN setting)
{
  #define H_gtk_window_set_focus_on_map "void gtk_window_set_focus_on_map(GtkWindow* window, gboolean setting)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_focus_on_map", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(setting), setting, 2, "gtk_window_set_focus_on_map", "gboolean");
  gtk_window_set_focus_on_map(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gboolean(setting));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_focus_on_map(XEN window)
{
  #define H_gtk_window_get_focus_on_map "gboolean gtk_window_get_focus_on_map(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_focus_on_map", "GtkWindow*");
  return(C_TO_XEN_gboolean(gtk_window_get_focus_on_map(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_icon_name(XEN window, XEN name)
{
  #define H_gtk_window_set_icon_name "void gtk_window_set_icon_name(GtkWindow* window, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_set_icon_name", "GtkWindow*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_window_set_icon_name", "gchar*");
  gtk_window_set_icon_name(XEN_TO_C_GtkWindow_(window), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_window_get_icon_name(XEN window)
{
  #define H_gtk_window_get_icon_name "gchar* gtk_window_get_icon_name(GtkWindow* window)"
  XEN_ASSERT_TYPE(XEN_GtkWindow__P(window), window, 1, "gtk_window_get_icon_name", "GtkWindow*");
  return(C_TO_XEN_gchar_(gtk_window_get_icon_name(XEN_TO_C_GtkWindow_(window))));
}
static XEN gxg_gtk_window_set_default_icon_name(XEN name)
{
  #define H_gtk_window_set_default_icon_name "void gtk_window_set_default_icon_name(gchar* name)"
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 1, "gtk_window_set_default_icon_name", "gchar*");
  gtk_window_set_default_icon_name(XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_type(void)
{
  #define H_gtk_about_dialog_get_type "GType gtk_about_dialog_get_type( void)"
  return(C_TO_XEN_GType(gtk_about_dialog_get_type()));
}
static XEN gxg_gtk_about_dialog_new(void)
{
  #define H_gtk_about_dialog_new "GtkWidget* gtk_about_dialog_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_about_dialog_new()));
}
static XEN gxg_gtk_about_dialog_get_name(XEN about)
{
  #define H_gtk_about_dialog_get_name "gchar* gtk_about_dialog_get_name(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_name", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_name(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_name(XEN about, XEN name)
{
  #define H_gtk_about_dialog_set_name "void gtk_about_dialog_set_name(GtkAboutDialog* about, gchar* name)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_name", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(name), name, 2, "gtk_about_dialog_set_name", "gchar*");
  gtk_about_dialog_set_name(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_version(XEN about)
{
  #define H_gtk_about_dialog_get_version "gchar* gtk_about_dialog_get_version(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_version", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_version(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_version(XEN about, XEN version)
{
  #define H_gtk_about_dialog_set_version "void gtk_about_dialog_set_version(GtkAboutDialog* about, gchar* version)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_version", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(version), version, 2, "gtk_about_dialog_set_version", "gchar*");
  gtk_about_dialog_set_version(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(version));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_copyright(XEN about)
{
  #define H_gtk_about_dialog_get_copyright "gchar* gtk_about_dialog_get_copyright(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_copyright", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_copyright(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_copyright(XEN about, XEN copyright)
{
  #define H_gtk_about_dialog_set_copyright "void gtk_about_dialog_set_copyright(GtkAboutDialog* about, \
gchar* copyright)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_copyright", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(copyright), copyright, 2, "gtk_about_dialog_set_copyright", "gchar*");
  gtk_about_dialog_set_copyright(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(copyright));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_comments(XEN about)
{
  #define H_gtk_about_dialog_get_comments "gchar* gtk_about_dialog_get_comments(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_comments", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_comments(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_comments(XEN about, XEN comments)
{
  #define H_gtk_about_dialog_set_comments "void gtk_about_dialog_set_comments(GtkAboutDialog* about, \
gchar* comments)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_comments", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(comments), comments, 2, "gtk_about_dialog_set_comments", "gchar*");
  gtk_about_dialog_set_comments(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(comments));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_license(XEN about)
{
  #define H_gtk_about_dialog_get_license "gchar* gtk_about_dialog_get_license(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_license", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_license(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_license(XEN about, XEN license)
{
  #define H_gtk_about_dialog_set_license "void gtk_about_dialog_set_license(GtkAboutDialog* about, gchar* license)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_license", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(license), license, 2, "gtk_about_dialog_set_license", "gchar*");
  gtk_about_dialog_set_license(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(license));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_website(XEN about)
{
  #define H_gtk_about_dialog_get_website "gchar* gtk_about_dialog_get_website(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_website", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_website(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_website(XEN about, XEN website)
{
  #define H_gtk_about_dialog_set_website "void gtk_about_dialog_set_website(GtkAboutDialog* about, gchar* website)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_website", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(website), website, 2, "gtk_about_dialog_set_website", "gchar*");
  gtk_about_dialog_set_website(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(website));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_website_label(XEN about)
{
  #define H_gtk_about_dialog_get_website_label "gchar* gtk_about_dialog_get_website_label(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_website_label", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_website_label(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_website_label(XEN about, XEN website_label)
{
  #define H_gtk_about_dialog_set_website_label "void gtk_about_dialog_set_website_label(GtkAboutDialog* about, \
gchar* website_label)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_website_label", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(website_label), website_label, 2, "gtk_about_dialog_set_website_label", "gchar*");
  gtk_about_dialog_set_website_label(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(website_label));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_authors(XEN about)
{
  #define H_gtk_about_dialog_get_authors "gchar** gtk_about_dialog_get_authors(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_authors", "GtkAboutDialog*");
    return(C_TO_XEN_gchar__((gchar**)gtk_about_dialog_get_authors(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_authors(XEN about, XEN authors)
{
  #define H_gtk_about_dialog_set_authors "void gtk_about_dialog_set_authors(GtkAboutDialog* about, gchar** authors)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_authors", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar___P(authors), authors, 2, "gtk_about_dialog_set_authors", "gchar**");
  gtk_about_dialog_set_authors(XEN_TO_C_GtkAboutDialog_(about), (const gchar**)XEN_TO_C_gchar__(authors));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_documenters(XEN about)
{
  #define H_gtk_about_dialog_get_documenters "gchar** gtk_about_dialog_get_documenters(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_documenters", "GtkAboutDialog*");
    return(C_TO_XEN_gchar__((gchar**)gtk_about_dialog_get_documenters(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_documenters(XEN about, XEN documenters)
{
  #define H_gtk_about_dialog_set_documenters "void gtk_about_dialog_set_documenters(GtkAboutDialog* about, \
gchar** documenters)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_documenters", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar___P(documenters), documenters, 2, "gtk_about_dialog_set_documenters", "gchar**");
  gtk_about_dialog_set_documenters(XEN_TO_C_GtkAboutDialog_(about), (const gchar**)XEN_TO_C_gchar__(documenters));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_artists(XEN about)
{
  #define H_gtk_about_dialog_get_artists "gchar** gtk_about_dialog_get_artists(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_artists", "GtkAboutDialog*");
    return(C_TO_XEN_gchar__((gchar**)gtk_about_dialog_get_artists(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_artists(XEN about, XEN artists)
{
  #define H_gtk_about_dialog_set_artists "void gtk_about_dialog_set_artists(GtkAboutDialog* about, gchar** artists)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_artists", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar___P(artists), artists, 2, "gtk_about_dialog_set_artists", "gchar**");
  gtk_about_dialog_set_artists(XEN_TO_C_GtkAboutDialog_(about), (const gchar**)XEN_TO_C_gchar__(artists));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_translator_credits(XEN about)
{
  #define H_gtk_about_dialog_get_translator_credits "gchar* gtk_about_dialog_get_translator_credits(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_translator_credits", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_translator_credits(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_translator_credits(XEN about, XEN translator_credits)
{
  #define H_gtk_about_dialog_set_translator_credits "void gtk_about_dialog_set_translator_credits(GtkAboutDialog* about, \
gchar* translator_credits)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_translator_credits", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(translator_credits), translator_credits, 2, "gtk_about_dialog_set_translator_credits", "gchar*");
  gtk_about_dialog_set_translator_credits(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(translator_credits));
  return(XEN_FALSE);
}
static XEN gxg_gtk_about_dialog_get_logo(XEN about)
{
  #define H_gtk_about_dialog_get_logo "GdkPixbuf* gtk_about_dialog_get_logo(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_logo", "GtkAboutDialog*");
  return(C_TO_XEN_GdkPixbuf_(gtk_about_dialog_get_logo(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_logo(XEN about, XEN logo)
{
  #define H_gtk_about_dialog_set_logo "void gtk_about_dialog_set_logo(GtkAboutDialog* about, GdkPixbuf* logo)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_logo", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(logo) || XEN_FALSE_P(logo), logo, 2, "gtk_about_dialog_set_logo", "GdkPixbuf*");
  gtk_about_dialog_set_logo(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_GdkPixbuf_(logo));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_type(void)
{
  #define H_gtk_icon_view_get_type "GType gtk_icon_view_get_type( void)"
  return(C_TO_XEN_GType(gtk_icon_view_get_type()));
}
static XEN gxg_gtk_icon_view_new(void)
{
  #define H_gtk_icon_view_new "GtkWidget* gtk_icon_view_new( void)"
  return(C_TO_XEN_GtkWidget_(gtk_icon_view_new()));
}
static XEN gxg_gtk_icon_view_new_with_model(XEN model)
{
  #define H_gtk_icon_view_new_with_model "GtkWidget* gtk_icon_view_new_with_model(GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model), model, 1, "gtk_icon_view_new_with_model", "GtkTreeModel*");
  return(C_TO_XEN_GtkWidget_(gtk_icon_view_new_with_model(XEN_TO_C_GtkTreeModel_(model))));
}
static XEN gxg_gtk_icon_view_set_model(XEN icon_view, XEN model)
{
  #define H_gtk_icon_view_set_model "void gtk_icon_view_set_model(GtkIconView* icon_view, GtkTreeModel* model)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_model", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkTreeModel__P(model) || XEN_FALSE_P(model), model, 2, "gtk_icon_view_set_model", "GtkTreeModel*");
  gtk_icon_view_set_model(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkTreeModel_(model));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_model(XEN icon_view)
{
  #define H_gtk_icon_view_get_model "GtkTreeModel* gtk_icon_view_get_model(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_model", "GtkIconView*");
  return(C_TO_XEN_GtkTreeModel_(gtk_icon_view_get_model(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_text_column(XEN icon_view, XEN column)
{
  #define H_gtk_icon_view_set_text_column "void gtk_icon_view_set_text_column(GtkIconView* icon_view, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_text_column", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_icon_view_set_text_column", "gint");
  gtk_icon_view_set_text_column(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_text_column(XEN icon_view)
{
  #define H_gtk_icon_view_get_text_column "gint gtk_icon_view_get_text_column(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_text_column", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_text_column(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_markup_column(XEN icon_view, XEN column)
{
  #define H_gtk_icon_view_set_markup_column "void gtk_icon_view_set_markup_column(GtkIconView* icon_view, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_markup_column", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_icon_view_set_markup_column", "gint");
  gtk_icon_view_set_markup_column(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_markup_column(XEN icon_view)
{
  #define H_gtk_icon_view_get_markup_column "gint gtk_icon_view_get_markup_column(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_markup_column", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_markup_column(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_pixbuf_column(XEN icon_view, XEN column)
{
  #define H_gtk_icon_view_set_pixbuf_column "void gtk_icon_view_set_pixbuf_column(GtkIconView* icon_view, \
gint column)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_pixbuf_column", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(column), column, 2, "gtk_icon_view_set_pixbuf_column", "gint");
  gtk_icon_view_set_pixbuf_column(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(column));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_pixbuf_column(XEN icon_view)
{
  #define H_gtk_icon_view_get_pixbuf_column "gint gtk_icon_view_get_pixbuf_column(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_pixbuf_column", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_pixbuf_column(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_orientation(XEN icon_view, XEN orientation)
{
  #define H_gtk_icon_view_set_orientation "void gtk_icon_view_set_orientation(GtkIconView* icon_view, \
GtkOrientation orientation)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_orientation", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkOrientation_P(orientation), orientation, 2, "gtk_icon_view_set_orientation", "GtkOrientation");
  gtk_icon_view_set_orientation(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkOrientation(orientation));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_orientation(XEN icon_view)
{
  #define H_gtk_icon_view_get_orientation "GtkOrientation gtk_icon_view_get_orientation(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_orientation", "GtkIconView*");
  return(C_TO_XEN_GtkOrientation(gtk_icon_view_get_orientation(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_get_path_at_pos(XEN icon_view, XEN x, XEN y)
{
  #define H_gtk_icon_view_get_path_at_pos "GtkTreePath* gtk_icon_view_get_path_at_pos(GtkIconView* icon_view, \
gint x, gint y)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_path_at_pos", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 2, "gtk_icon_view_get_path_at_pos", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 3, "gtk_icon_view_get_path_at_pos", "gint");
  return(C_TO_XEN_GtkTreePath_(gtk_icon_view_get_path_at_pos(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(x), XEN_TO_C_gint(y))));
}
static XEN gxg_gtk_icon_view_selected_foreach(XEN icon_view, XEN func, XEN func_data)
{
  #define H_gtk_icon_view_selected_foreach "void gtk_icon_view_selected_foreach(GtkIconView* icon_view, \
GtkIconViewForeachFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_selected_foreach", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkIconViewForeachFunc_P(func), func, 2, "gtk_icon_view_selected_foreach", "GtkIconViewForeachFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_icon_view_selected_foreach", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gtk_icon_view_selected_foreach(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkIconViewForeachFunc(func), XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_icon_view_set_selection_mode(XEN icon_view, XEN mode)
{
  #define H_gtk_icon_view_set_selection_mode "void gtk_icon_view_set_selection_mode(GtkIconView* icon_view, \
GtkSelectionMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_selection_mode", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkSelectionMode_P(mode), mode, 2, "gtk_icon_view_set_selection_mode", "GtkSelectionMode");
  gtk_icon_view_set_selection_mode(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkSelectionMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_selection_mode(XEN icon_view)
{
  #define H_gtk_icon_view_get_selection_mode "GtkSelectionMode gtk_icon_view_get_selection_mode(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_selection_mode", "GtkIconView*");
  return(C_TO_XEN_GtkSelectionMode(gtk_icon_view_get_selection_mode(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_select_path(XEN icon_view, XEN path)
{
  #define H_gtk_icon_view_select_path "void gtk_icon_view_select_path(GtkIconView* icon_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_select_path", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_icon_view_select_path", "GtkTreePath*");
  gtk_icon_view_select_path(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_unselect_path(XEN icon_view, XEN path)
{
  #define H_gtk_icon_view_unselect_path "void gtk_icon_view_unselect_path(GtkIconView* icon_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_unselect_path", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_icon_view_unselect_path", "GtkTreePath*");
  gtk_icon_view_unselect_path(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_path_is_selected(XEN icon_view, XEN path)
{
  #define H_gtk_icon_view_path_is_selected "gboolean gtk_icon_view_path_is_selected(GtkIconView* icon_view, \
GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_path_is_selected", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_icon_view_path_is_selected", "GtkTreePath*");
  return(C_TO_XEN_gboolean(gtk_icon_view_path_is_selected(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkTreePath_(path))));
}
static XEN gxg_gtk_icon_view_get_selected_items(XEN icon_view)
{
  #define H_gtk_icon_view_get_selected_items "GList* gtk_icon_view_get_selected_items(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_selected_items", "GtkIconView*");
  return(C_TO_XEN_GList_(gtk_icon_view_get_selected_items(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_select_all(XEN icon_view)
{
  #define H_gtk_icon_view_select_all "void gtk_icon_view_select_all(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_select_all", "GtkIconView*");
  gtk_icon_view_select_all(XEN_TO_C_GtkIconView_(icon_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_unselect_all(XEN icon_view)
{
  #define H_gtk_icon_view_unselect_all "void gtk_icon_view_unselect_all(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_unselect_all", "GtkIconView*");
  gtk_icon_view_unselect_all(XEN_TO_C_GtkIconView_(icon_view));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_item_activated(XEN icon_view, XEN path)
{
  #define H_gtk_icon_view_item_activated "void gtk_icon_view_item_activated(GtkIconView* icon_view, GtkTreePath* path)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_item_activated", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_GtkTreePath__P(path), path, 2, "gtk_icon_view_item_activated", "GtkTreePath*");
  gtk_icon_view_item_activated(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_GtkTreePath_(path));
  return(XEN_FALSE);
}
static XEN gxg_gtk_cell_renderer_combo_get_type(void)
{
  #define H_gtk_cell_renderer_combo_get_type "GType gtk_cell_renderer_combo_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_renderer_combo_get_type()));
}
static XEN gxg_gtk_cell_renderer_combo_new(void)
{
  #define H_gtk_cell_renderer_combo_new "GtkCellRenderer* gtk_cell_renderer_combo_new( void)"
  return(C_TO_XEN_GtkCellRenderer_(gtk_cell_renderer_combo_new()));
}
static XEN gxg_gtk_cell_renderer_progress_get_type(void)
{
  #define H_gtk_cell_renderer_progress_get_type "GType gtk_cell_renderer_progress_get_type( void)"
  return(C_TO_XEN_GType(gtk_cell_renderer_progress_get_type()));
}
static XEN gxg_gtk_cell_renderer_progress_new(void)
{
  #define H_gtk_cell_renderer_progress_new "GtkCellRenderer* gtk_cell_renderer_progress_new( void)"
  return(C_TO_XEN_GtkCellRenderer_(gtk_cell_renderer_progress_new()));
}
#endif

#if HAVE_GTK_LABEL_SET_ELLIPSIZE
static XEN gxg_gtk_combo_box_set_row_separator_func(XEN combo_box, XEN func, XEN func_data, XEN destroy)
{
  #define H_gtk_combo_box_set_row_separator_func "void gtk_combo_box_set_row_separator_func(GtkComboBox* combo_box, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_data, GtkDestroyNotify destroy)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo_box), combo_box, 1, "gtk_combo_box_set_row_separator_func", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_GtkTreeViewRowSeparatorFunc_P(func), func, 2, "gtk_combo_box_set_row_separator_func", "GtkTreeViewRowSeparatorFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_combo_box_set_row_separator_func", "lambda_data");
  XEN_ASSERT_TYPE(XEN_GtkDestroyNotify_P(destroy), destroy, 4, "gtk_combo_box_set_row_separator_func", "GtkDestroyNotify");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    XEN_LIST_SET(gxg_ptr, 3, destroy);
    gtk_combo_box_set_row_separator_func(XEN_TO_C_GtkComboBox_(combo_box), XEN_TO_C_GtkTreeViewRowSeparatorFunc(func), XEN_TO_C_lambda_data(func_data), 
                                     XEN_TO_C_GtkDestroyNotify(destroy));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_label_set_ellipsize(XEN label, XEN mode)
{
  #define H_gtk_label_set_ellipsize "void gtk_label_set_ellipsize(GtkLabel* label, PangoEllipsizeMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_ellipsize", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_PangoEllipsizeMode_P(mode), mode, 2, "gtk_label_set_ellipsize", "PangoEllipsizeMode");
  gtk_label_set_ellipsize(XEN_TO_C_GtkLabel_(label), XEN_TO_C_PangoEllipsizeMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_ellipsize(XEN label)
{
  #define H_gtk_label_get_ellipsize "PangoEllipsizeMode gtk_label_get_ellipsize(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_ellipsize", "GtkLabel*");
  return(C_TO_XEN_PangoEllipsizeMode(gtk_label_get_ellipsize(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_pango_attr_fallback_new(XEN enable_fallback)
{
  #define H_pango_attr_fallback_new "PangoAttribute* pango_attr_fallback_new(gboolean enable_fallback)"
  XEN_ASSERT_TYPE(XEN_gboolean_P(enable_fallback), enable_fallback, 1, "pango_attr_fallback_new", "gboolean");
  return(C_TO_XEN_PangoAttribute_(pango_attr_fallback_new(XEN_TO_C_gboolean(enable_fallback))));
}
static XEN gxg_pango_attr_letter_spacing_new(XEN letter_spacing)
{
  #define H_pango_attr_letter_spacing_new "PangoAttribute* pango_attr_letter_spacing_new(int letter_spacing)"
  XEN_ASSERT_TYPE(XEN_int_P(letter_spacing), letter_spacing, 1, "pango_attr_letter_spacing_new", "int");
  return(C_TO_XEN_PangoAttribute_(pango_attr_letter_spacing_new(XEN_TO_C_int(letter_spacing))));
}
static XEN gxg_pango_attr_list_filter(XEN list, XEN func, XEN data)
{
  #define H_pango_attr_list_filter "PangoAttrList* pango_attr_list_filter(PangoAttrList* list, PangoAttrFilterFunc func, \
gpointer data)"
  XEN_ASSERT_TYPE(XEN_PangoAttrList__P(list), list, 1, "pango_attr_list_filter", "PangoAttrList*");
  XEN_ASSERT_TYPE(XEN_PangoAttrFilterFunc_P(func), func, 2, "pango_attr_list_filter", "PangoAttrFilterFunc");
  XEN_ASSERT_TYPE(XEN_gpointer_P(data), data, 3, "pango_attr_list_filter", "gpointer");
  return(C_TO_XEN_PangoAttrList_(pango_attr_list_filter(XEN_TO_C_PangoAttrList_(list), XEN_TO_C_PangoAttrFilterFunc(func), 
                                                        XEN_TO_C_gpointer(data))));
}
static XEN gxg_pango_attr_iterator_get_attrs(XEN iterator)
{
  #define H_pango_attr_iterator_get_attrs "GSList* pango_attr_iterator_get_attrs(PangoAttrIterator* iterator)"
  XEN_ASSERT_TYPE(XEN_PangoAttrIterator__P(iterator), iterator, 1, "pango_attr_iterator_get_attrs", "PangoAttrIterator*");
  return(C_TO_XEN_GSList_(pango_attr_iterator_get_attrs(XEN_TO_C_PangoAttrIterator_(iterator))));
}
static XEN gxg_pango_font_metrics_get_underline_position(XEN metrics)
{
  #define H_pango_font_metrics_get_underline_position "int pango_font_metrics_get_underline_position(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_underline_position", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_underline_position(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_underline_thickness(XEN metrics)
{
  #define H_pango_font_metrics_get_underline_thickness "int pango_font_metrics_get_underline_thickness(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_underline_thickness", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_underline_thickness(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_strikethrough_position(XEN metrics)
{
  #define H_pango_font_metrics_get_strikethrough_position "int pango_font_metrics_get_strikethrough_position(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_strikethrough_position", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_strikethrough_position(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_metrics_get_strikethrough_thickness(XEN metrics)
{
  #define H_pango_font_metrics_get_strikethrough_thickness "int pango_font_metrics_get_strikethrough_thickness(PangoFontMetrics* metrics)"
  XEN_ASSERT_TYPE(XEN_PangoFontMetrics__P(metrics), metrics, 1, "pango_font_metrics_get_strikethrough_thickness", "PangoFontMetrics*");
  return(C_TO_XEN_int(pango_font_metrics_get_strikethrough_thickness(XEN_TO_C_PangoFontMetrics_(metrics))));
}
static XEN gxg_pango_font_family_is_monospace(XEN family)
{
  #define H_pango_font_family_is_monospace "gboolean pango_font_family_is_monospace(PangoFontFamily* family)"
  XEN_ASSERT_TYPE(XEN_PangoFontFamily__P(family), family, 1, "pango_font_family_is_monospace", "PangoFontFamily*");
  return(C_TO_XEN_gboolean(pango_font_family_is_monospace(XEN_TO_C_PangoFontFamily_(family))));
}
static XEN gxg_pango_font_face_list_sizes(XEN face, XEN sizes, XEN n_sizes)
{
  #define H_pango_font_face_list_sizes "void pango_font_face_list_sizes(PangoFontFace* face, int** [sizes], \
int* [n_sizes])"
  int* ref_sizes = NULL;
  int ref_n_sizes;
  XEN_ASSERT_TYPE(XEN_PangoFontFace__P(face), face, 1, "pango_font_face_list_sizes", "PangoFontFace*");
  pango_font_face_list_sizes(XEN_TO_C_PangoFontFace_(face), &ref_sizes, &ref_n_sizes);
  return(XEN_LIST_2(C_TO_XEN_int_(ref_sizes), C_TO_XEN_int(ref_n_sizes)));
}
static XEN gxg_pango_layout_set_auto_dir(XEN layout, XEN auto_dir)
{
  #define H_pango_layout_set_auto_dir "void pango_layout_set_auto_dir(PangoLayout* layout, gboolean auto_dir)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_set_auto_dir", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(auto_dir), auto_dir, 2, "pango_layout_set_auto_dir", "gboolean");
  pango_layout_set_auto_dir(XEN_TO_C_PangoLayout_(layout), XEN_TO_C_gboolean(auto_dir));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_auto_dir(XEN layout)
{
  #define H_pango_layout_get_auto_dir "gboolean pango_layout_get_auto_dir(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_auto_dir", "PangoLayout*");
  return(C_TO_XEN_gboolean(pango_layout_get_auto_dir(XEN_TO_C_PangoLayout_(layout))));
}
static XEN gxg_pango_script_for_unichar(XEN ch)
{
  #define H_pango_script_for_unichar "PangoScript pango_script_for_unichar(gunichar ch)"
  XEN_ASSERT_TYPE(XEN_gunichar_P(ch), ch, 1, "pango_script_for_unichar", "gunichar");
  return(C_TO_XEN_PangoScript(pango_script_for_unichar(XEN_TO_C_gunichar(ch))));
}
static XEN gxg_pango_script_iter_new(XEN text, XEN length)
{
  #define H_pango_script_iter_new "PangoScriptIter* pango_script_iter_new(char* text, int length)"
  XEN_ASSERT_TYPE(XEN_char__P(text), text, 1, "pango_script_iter_new", "char*");
  XEN_ASSERT_TYPE(XEN_int_P(length), length, 2, "pango_script_iter_new", "int");
  return(C_TO_XEN_PangoScriptIter_(pango_script_iter_new(XEN_TO_C_char_(text), XEN_TO_C_int(length))));
}
static XEN gxg_pango_script_iter_get_range(XEN iter, XEN start, XEN end, XEN script)
{
  #define H_pango_script_iter_get_range "void pango_script_iter_get_range(PangoScriptIter* iter, char** [start], \
char** [end], PangoScript* [script])"
  char* ref_start = NULL;
  char* ref_end = NULL;
  PangoScript ref_script;
  XEN_ASSERT_TYPE(XEN_PangoScriptIter__P(iter), iter, 1, "pango_script_iter_get_range", "PangoScriptIter*");
  pango_script_iter_get_range(XEN_TO_C_PangoScriptIter_(iter), (const char**)&ref_start, (const char**)&ref_end, &ref_script);
  return(XEN_LIST_3(C_TO_XEN_char_(ref_start), C_TO_XEN_char_(ref_end), C_TO_XEN_PangoScript(ref_script)));
}
static XEN gxg_pango_script_iter_next(XEN iter)
{
  #define H_pango_script_iter_next "gboolean pango_script_iter_next(PangoScriptIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoScriptIter__P(iter), iter, 1, "pango_script_iter_next", "PangoScriptIter*");
  return(C_TO_XEN_gboolean(pango_script_iter_next(XEN_TO_C_PangoScriptIter_(iter))));
}
static XEN gxg_pango_script_iter_free(XEN iter)
{
  #define H_pango_script_iter_free "void pango_script_iter_free(PangoScriptIter* iter)"
  XEN_ASSERT_TYPE(XEN_PangoScriptIter__P(iter), iter, 1, "pango_script_iter_free", "PangoScriptIter*");
  pango_script_iter_free(XEN_TO_C_PangoScriptIter_(iter));
  return(XEN_FALSE);
}
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
static XEN gxg_gtk_file_chooser_button_get_type(void)
{
  #define H_gtk_file_chooser_button_get_type "GType gtk_file_chooser_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_file_chooser_button_get_type()));
}
static XEN gxg_gtk_file_chooser_button_new_with_dialog(XEN dialog)
{
  #define H_gtk_file_chooser_button_new_with_dialog "GtkWidget* gtk_file_chooser_button_new_with_dialog(GtkWidget* dialog)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(dialog), dialog, 1, "gtk_file_chooser_button_new_with_dialog", "GtkWidget*");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_button_new_with_dialog(XEN_TO_C_GtkWidget_(dialog))));
}
static XEN gxg_gtk_file_chooser_button_get_title(XEN button)
{
  #define H_gtk_file_chooser_button_get_title "gchar* gtk_file_chooser_button_get_title(GtkFileChooserButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserButton__P(button), button, 1, "gtk_file_chooser_button_get_title", "GtkFileChooserButton*");
  return(C_TO_XEN_gchar_(gtk_file_chooser_button_get_title(XEN_TO_C_GtkFileChooserButton_(button))));
}
static XEN gxg_gtk_file_chooser_button_set_title(XEN button, XEN title)
{
  #define H_gtk_file_chooser_button_set_title "void gtk_file_chooser_button_set_title(GtkFileChooserButton* button, \
gchar* title)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserButton__P(button), button, 1, "gtk_file_chooser_button_set_title", "GtkFileChooserButton*");
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 2, "gtk_file_chooser_button_set_title", "gchar*");
  gtk_file_chooser_button_set_title(XEN_TO_C_GtkFileChooserButton_(button), XEN_TO_C_gchar_(title));
  return(XEN_FALSE);
}
static XEN gxg_gdk_drag_drop_succeeded(XEN context)
{
  #define H_gdk_drag_drop_succeeded "gboolean gdk_drag_drop_succeeded(GdkDragContext* context)"
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(context), context, 1, "gdk_drag_drop_succeeded", "GdkDragContext*");
  return(C_TO_XEN_gboolean(gdk_drag_drop_succeeded(XEN_TO_C_GdkDragContext_(context))));
}
static XEN gxg_gdk_rgb_colormap_ditherable(XEN cmap)
{
  #define H_gdk_rgb_colormap_ditherable "gboolean gdk_rgb_colormap_ditherable(GdkColormap* cmap)"
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(cmap), cmap, 1, "gdk_rgb_colormap_ditherable", "GdkColormap*");
  return(C_TO_XEN_gboolean(gdk_rgb_colormap_ditherable(XEN_TO_C_GdkColormap_(cmap))));
}
static XEN gxg_gtk_action_set_sensitive(XEN action, XEN sensitive)
{
  #define H_gtk_action_set_sensitive "void gtk_action_set_sensitive(GtkAction* action, gboolean sensitive)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_set_sensitive", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(sensitive), sensitive, 2, "gtk_action_set_sensitive", "gboolean");
  gtk_action_set_sensitive(XEN_TO_C_GtkAction_(action), XEN_TO_C_gboolean(sensitive));
  return(XEN_FALSE);
}
static XEN gxg_gtk_action_set_visible(XEN action, XEN visible)
{
  #define H_gtk_action_set_visible "void gtk_action_set_visible(GtkAction* action, gboolean visible)"
  XEN_ASSERT_TYPE(XEN_GtkAction__P(action), action, 1, "gtk_action_set_visible", "GtkAction*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(visible), visible, 2, "gtk_action_set_visible", "gboolean");
  gtk_action_set_visible(XEN_TO_C_GtkAction_(action), XEN_TO_C_gboolean(visible));
  return(XEN_FALSE);
}
static XEN gxg_gtk_combo_box_get_focus_on_click(XEN combo)
{
  #define H_gtk_combo_box_get_focus_on_click "gboolean gtk_combo_box_get_focus_on_click(GtkComboBox* combo)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo), combo, 1, "gtk_combo_box_get_focus_on_click", "GtkComboBox*");
  return(C_TO_XEN_gboolean(gtk_combo_box_get_focus_on_click(XEN_TO_C_GtkComboBox_(combo))));
}
static XEN gxg_gtk_combo_box_set_focus_on_click(XEN combo, XEN focus_on_click)
{
  #define H_gtk_combo_box_set_focus_on_click "void gtk_combo_box_set_focus_on_click(GtkComboBox* combo, \
gboolean focus_on_click)"
  XEN_ASSERT_TYPE(XEN_GtkComboBox__P(combo), combo, 1, "gtk_combo_box_set_focus_on_click", "GtkComboBox*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(focus_on_click), focus_on_click, 2, "gtk_combo_box_set_focus_on_click", "gboolean");
  gtk_combo_box_set_focus_on_click(XEN_TO_C_GtkComboBox_(combo), XEN_TO_C_gboolean(focus_on_click));
  return(XEN_FALSE);
}
static XEN gxg_gtk_entry_layout_index_to_text_index(XEN entry, XEN layout_index)
{
  #define H_gtk_entry_layout_index_to_text_index "gint gtk_entry_layout_index_to_text_index(GtkEntry* entry, \
gint layout_index)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_layout_index_to_text_index", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(layout_index), layout_index, 2, "gtk_entry_layout_index_to_text_index", "gint");
  return(C_TO_XEN_gint(gtk_entry_layout_index_to_text_index(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gint(layout_index))));
}
static XEN gxg_gtk_entry_text_index_to_layout_index(XEN entry, XEN text_index)
{
  #define H_gtk_entry_text_index_to_layout_index "gint gtk_entry_text_index_to_layout_index(GtkEntry* entry, \
gint text_index)"
  XEN_ASSERT_TYPE(XEN_GtkEntry__P(entry), entry, 1, "gtk_entry_text_index_to_layout_index", "GtkEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(text_index), text_index, 2, "gtk_entry_text_index_to_layout_index", "gint");
  return(C_TO_XEN_gint(gtk_entry_text_index_to_layout_index(XEN_TO_C_GtkEntry_(entry), XEN_TO_C_gint(text_index))));
}
static XEN gxg_gtk_file_chooser_set_show_hidden(XEN chooser, XEN show_hidden)
{
  #define H_gtk_file_chooser_set_show_hidden "void gtk_file_chooser_set_show_hidden(GtkFileChooser* chooser, \
gboolean show_hidden)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_set_show_hidden", "GtkFileChooser*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(show_hidden), show_hidden, 2, "gtk_file_chooser_set_show_hidden", "gboolean");
  gtk_file_chooser_set_show_hidden(XEN_TO_C_GtkFileChooser_(chooser), XEN_TO_C_gboolean(show_hidden));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_get_show_hidden(XEN chooser)
{
  #define H_gtk_file_chooser_get_show_hidden "gboolean gtk_file_chooser_get_show_hidden(GtkFileChooser* chooser)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooser__P(chooser), chooser, 1, "gtk_file_chooser_get_show_hidden", "GtkFileChooser*");
  return(C_TO_XEN_gboolean(gtk_file_chooser_get_show_hidden(XEN_TO_C_GtkFileChooser_(chooser))));
}
static XEN gxg_gtk_tree_view_set_hover_expand(XEN tree_view, XEN expand)
{
  #define H_gtk_tree_view_set_hover_expand "void gtk_tree_view_set_hover_expand(GtkTreeView* tree_view, \
gboolean expand)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_set_hover_expand", "GtkTreeView*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(expand), expand, 2, "gtk_tree_view_set_hover_expand", "gboolean");
  gtk_tree_view_set_hover_expand(XEN_TO_C_GtkTreeView_(tree_view), XEN_TO_C_gboolean(expand));
  return(XEN_FALSE);
}
static XEN gxg_gtk_tree_view_get_hover_expand(XEN tree_view)
{
  #define H_gtk_tree_view_get_hover_expand "gboolean gtk_tree_view_get_hover_expand(GtkTreeView* tree_view)"
  XEN_ASSERT_TYPE(XEN_GtkTreeView__P(tree_view), tree_view, 1, "gtk_tree_view_get_hover_expand", "GtkTreeView*");
  return(C_TO_XEN_gboolean(gtk_tree_view_get_hover_expand(XEN_TO_C_GtkTreeView_(tree_view))));
}
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
static XEN gxg_gtk_tool_item_rebuild_menu(XEN tool_item)
{
  #define H_gtk_tool_item_rebuild_menu "void gtk_tool_item_rebuild_menu(GtkToolItem* tool_item)"
  XEN_ASSERT_TYPE(XEN_GtkToolItem__P(tool_item), tool_item, 1, "gtk_tool_item_rebuild_menu", "GtkToolItem*");
  gtk_tool_item_rebuild_menu(XEN_TO_C_GtkToolItem_(tool_item));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_tool_button_get_type(void)
{
  #define H_gtk_menu_tool_button_get_type "GType gtk_menu_tool_button_get_type( void)"
  return(C_TO_XEN_GType(gtk_menu_tool_button_get_type()));
}
static XEN gxg_gtk_menu_tool_button_new(XEN icon_widget, XEN label)
{
  #define H_gtk_menu_tool_button_new "GtkToolItem* gtk_menu_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(icon_widget) || XEN_FALSE_P(icon_widget), icon_widget, 1, "gtk_menu_tool_button_new", "GtkWidget*");
  XEN_ASSERT_TYPE(XEN_gchar__P(label), label, 2, "gtk_menu_tool_button_new", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_menu_tool_button_new(XEN_TO_C_GtkWidget_(icon_widget), XEN_TO_C_gchar_(label))));
}
static XEN gxg_gtk_menu_tool_button_new_from_stock(XEN stock_id)
{
  #define H_gtk_menu_tool_button_new_from_stock "GtkToolItem* gtk_menu_tool_button_new_from_stock(gchar* stock_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(stock_id), stock_id, 1, "gtk_menu_tool_button_new_from_stock", "gchar*");
  return(C_TO_XEN_GtkToolItem_(gtk_menu_tool_button_new_from_stock(XEN_TO_C_gchar_(stock_id))));
}
static XEN gxg_gtk_menu_tool_button_set_menu(XEN button, XEN menu)
{
  #define H_gtk_menu_tool_button_set_menu "void gtk_menu_tool_button_set_menu(GtkMenuToolButton* button, \
GtkWidget* menu)"
  XEN_ASSERT_TYPE(XEN_GtkMenuToolButton__P(button), button, 1, "gtk_menu_tool_button_set_menu", "GtkMenuToolButton*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(menu), menu, 2, "gtk_menu_tool_button_set_menu", "GtkWidget*");
  gtk_menu_tool_button_set_menu(XEN_TO_C_GtkMenuToolButton_(button), XEN_TO_C_GtkWidget_(menu));
  return(XEN_FALSE);
}
static XEN gxg_gtk_menu_tool_button_get_menu(XEN button)
{
  #define H_gtk_menu_tool_button_get_menu "GtkWidget* gtk_menu_tool_button_get_menu(GtkMenuToolButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkMenuToolButton__P(button), button, 1, "gtk_menu_tool_button_get_menu", "GtkMenuToolButton*");
  return(C_TO_XEN_GtkWidget_(gtk_menu_tool_button_get_menu(XEN_TO_C_GtkMenuToolButton_(button))));
}
static XEN gxg_gtk_menu_tool_button_set_arrow_tooltip(XEN button, XEN tooltips, XEN tip_text, XEN tip_private)
{
  #define H_gtk_menu_tool_button_set_arrow_tooltip "void gtk_menu_tool_button_set_arrow_tooltip(GtkMenuToolButton* button, \
GtkTooltips* tooltips, gchar* tip_text, gchar* tip_private)"
  XEN_ASSERT_TYPE(XEN_GtkMenuToolButton__P(button), button, 1, "gtk_menu_tool_button_set_arrow_tooltip", "GtkMenuToolButton*");
  XEN_ASSERT_TYPE(XEN_GtkTooltips__P(tooltips), tooltips, 2, "gtk_menu_tool_button_set_arrow_tooltip", "GtkTooltips*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_text), tip_text, 3, "gtk_menu_tool_button_set_arrow_tooltip", "gchar*");
  XEN_ASSERT_TYPE(XEN_gchar__P(tip_private), tip_private, 4, "gtk_menu_tool_button_set_arrow_tooltip", "gchar*");
  gtk_menu_tool_button_set_arrow_tooltip(XEN_TO_C_GtkMenuToolButton_(button), XEN_TO_C_GtkTooltips_(tooltips), XEN_TO_C_gchar_(tip_text), 
                                         XEN_TO_C_gchar_(tip_private));
  return(XEN_FALSE);
}
static XEN gxg_gdk_display_supports_clipboard_persistence(XEN display)
{
  #define H_gdk_display_supports_clipboard_persistence "gboolean gdk_display_supports_clipboard_persistence(GdkDisplay* display)"
  XEN_ASSERT_TYPE(XEN_GdkDisplay__P(display), display, 1, "gdk_display_supports_clipboard_persistence", "GdkDisplay*");
  return(C_TO_XEN_gboolean(gdk_display_supports_clipboard_persistence(XEN_TO_C_GdkDisplay_(display))));
}
static XEN gxg_gtk_about_dialog_get_logo_icon_name(XEN about)
{
  #define H_gtk_about_dialog_get_logo_icon_name "gchar* gtk_about_dialog_get_logo_icon_name(GtkAboutDialog* about)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_get_logo_icon_name", "GtkAboutDialog*");
  return(C_TO_XEN_gchar_(gtk_about_dialog_get_logo_icon_name(XEN_TO_C_GtkAboutDialog_(about))));
}
static XEN gxg_gtk_about_dialog_set_logo_icon_name(XEN about, XEN icon_name)
{
  #define H_gtk_about_dialog_set_logo_icon_name "void gtk_about_dialog_set_logo_icon_name(GtkAboutDialog* about, \
gchar* icon_name)"
  XEN_ASSERT_TYPE(XEN_GtkAboutDialog__P(about), about, 1, "gtk_about_dialog_set_logo_icon_name", "GtkAboutDialog*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_about_dialog_set_logo_icon_name", "gchar*");
  gtk_about_dialog_set_logo_icon_name(XEN_TO_C_GtkAboutDialog_(about), XEN_TO_C_gchar_(icon_name));
  return(XEN_FALSE);
}
static XEN gxg_gtk_accelerator_get_label(XEN accelerator_key, XEN accelerator_mods)
{
  #define H_gtk_accelerator_get_label "gchar* gtk_accelerator_get_label(guint accelerator_key, GdkModifierType accelerator_mods)"
  XEN_ASSERT_TYPE(XEN_guint_P(accelerator_key), accelerator_key, 1, "gtk_accelerator_get_label", "guint");
  XEN_ASSERT_TYPE(XEN_GdkModifierType_P(accelerator_mods), accelerator_mods, 2, "gtk_accelerator_get_label", "GdkModifierType");
  {
   gchar* result;
   XEN rtn;
   result = gtk_accelerator_get_label(XEN_TO_C_guint(accelerator_key), XEN_TO_C_GdkModifierType(accelerator_mods));
   rtn = C_TO_XEN_gchar_(result);
   g_free(result);
   return(rtn);
  }
}
static XEN gxg_gtk_clipboard_wait_is_target_available(XEN clipboard, XEN target)
{
  #define H_gtk_clipboard_wait_is_target_available "gboolean gtk_clipboard_wait_is_target_available(GtkClipboard* clipboard, \
GdkAtom target)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_is_target_available", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GdkAtom_P(target), target, 2, "gtk_clipboard_wait_is_target_available", "GdkAtom");
  return(C_TO_XEN_gboolean(gtk_clipboard_wait_is_target_available(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GdkAtom(target))));
}
static XEN gxg_gtk_clipboard_set_can_store(XEN clipboard, XEN targets, XEN n_targets)
{
  #define H_gtk_clipboard_set_can_store "void gtk_clipboard_set_can_store(GtkClipboard* clipboard, GtkTargetEntry* targets, \
gint n_targets)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_set_can_store", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkTargetEntry__P(targets) || XEN_FALSE_P(targets), targets, 2, "gtk_clipboard_set_can_store", "GtkTargetEntry*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_targets), n_targets, 3, "gtk_clipboard_set_can_store", "gint");
  gtk_clipboard_set_can_store(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkTargetEntry_(targets), XEN_TO_C_gint(n_targets));
  return(XEN_FALSE);
}
static XEN gxg_gtk_clipboard_store(XEN clipboard)
{
  #define H_gtk_clipboard_store "void gtk_clipboard_store(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_store", "GtkClipboard*");
  gtk_clipboard_store(XEN_TO_C_GtkClipboard_(clipboard));
  return(XEN_FALSE);
}
static XEN gxg_gtk_alternative_dialog_button_order(XEN screen)
{
  #define H_gtk_alternative_dialog_button_order "gboolean gtk_alternative_dialog_button_order(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen) || XEN_FALSE_P(screen), screen, 1, "gtk_alternative_dialog_button_order", "GdkScreen*");
  return(C_TO_XEN_gboolean(gtk_alternative_dialog_button_order(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gtk_drag_dest_add_image_targets(XEN widget)
{
  #define H_gtk_drag_dest_add_image_targets "void gtk_drag_dest_add_image_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_add_image_targets", "GtkWidget*");
  gtk_drag_dest_add_image_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_dest_add_uri_targets(XEN widget)
{
  #define H_gtk_drag_dest_add_uri_targets "void gtk_drag_dest_add_uri_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_dest_add_uri_targets", "GtkWidget*");
  gtk_drag_dest_add_uri_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_add_image_targets(XEN widget)
{
  #define H_gtk_drag_source_add_image_targets "void gtk_drag_source_add_image_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_add_image_targets", "GtkWidget*");
  gtk_drag_source_add_image_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_drag_source_add_uri_targets(XEN widget)
{
  #define H_gtk_drag_source_add_uri_targets "void gtk_drag_source_add_uri_targets(GtkWidget* widget)"
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(widget), widget, 1, "gtk_drag_source_add_uri_targets", "GtkWidget*");
  gtk_drag_source_add_uri_targets(XEN_TO_C_GtkWidget_(widget));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_button_get_width_chars(XEN button)
{
  #define H_gtk_file_chooser_button_get_width_chars "gint gtk_file_chooser_button_get_width_chars(GtkFileChooserButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserButton__P(button), button, 1, "gtk_file_chooser_button_get_width_chars", "GtkFileChooserButton*");
  return(C_TO_XEN_gint(gtk_file_chooser_button_get_width_chars(XEN_TO_C_GtkFileChooserButton_(button))));
}
static XEN gxg_gtk_file_chooser_button_set_width_chars(XEN button, XEN n_chars)
{
  #define H_gtk_file_chooser_button_set_width_chars "void gtk_file_chooser_button_set_width_chars(GtkFileChooserButton* button, \
gint n_chars)"
  XEN_ASSERT_TYPE(XEN_GtkFileChooserButton__P(button), button, 1, "gtk_file_chooser_button_set_width_chars", "GtkFileChooserButton*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_chars), n_chars, 2, "gtk_file_chooser_button_set_width_chars", "gint");
  gtk_file_chooser_button_set_width_chars(XEN_TO_C_GtkFileChooserButton_(button), XEN_TO_C_gint(n_chars));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_new_from_icon_name(XEN icon_name, XEN size)
{
  #define H_gtk_image_new_from_icon_name "GtkWidget* gtk_image_new_from_icon_name(gchar* icon_name, GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 1, "gtk_image_new_from_icon_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 2, "gtk_image_new_from_icon_name", "GtkIconSize");
  return(C_TO_XEN_GtkWidget_(gtk_image_new_from_icon_name(XEN_TO_C_gchar_(icon_name), XEN_TO_C_GtkIconSize(size))));
}
static XEN gxg_gtk_image_set_from_icon_name(XEN image, XEN icon_name, XEN size)
{
  #define H_gtk_image_set_from_icon_name "void gtk_image_set_from_icon_name(GtkImage* image, gchar* icon_name, \
GtkIconSize size)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_from_icon_name", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_gchar__P(icon_name), icon_name, 2, "gtk_image_set_from_icon_name", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkIconSize_P(size), size, 3, "gtk_image_set_from_icon_name", "GtkIconSize");
  gtk_image_set_from_icon_name(XEN_TO_C_GtkImage_(image), XEN_TO_C_gchar_(icon_name), XEN_TO_C_GtkIconSize(size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_set_pixel_size(XEN image, XEN pixel_size)
{
  #define H_gtk_image_set_pixel_size "void gtk_image_set_pixel_size(GtkImage* image, gint pixel_size)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_set_pixel_size", "GtkImage*");
  XEN_ASSERT_TYPE(XEN_gint_P(pixel_size), pixel_size, 2, "gtk_image_set_pixel_size", "gint");
  gtk_image_set_pixel_size(XEN_TO_C_GtkImage_(image), XEN_TO_C_gint(pixel_size));
  return(XEN_FALSE);
}
static XEN gxg_gtk_image_get_pixel_size(XEN image)
{
  #define H_gtk_image_get_pixel_size "gint gtk_image_get_pixel_size(GtkImage* image)"
  XEN_ASSERT_TYPE(XEN_GtkImage__P(image), image, 1, "gtk_image_get_pixel_size", "GtkImage*");
  return(C_TO_XEN_gint(gtk_image_get_pixel_size(XEN_TO_C_GtkImage_(image))));
}
static XEN gxg_gtk_label_set_width_chars(XEN label, XEN n_chars)
{
  #define H_gtk_label_set_width_chars "void gtk_label_set_width_chars(GtkLabel* label, gint n_chars)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_width_chars", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_chars), n_chars, 2, "gtk_label_set_width_chars", "gint");
  gtk_label_set_width_chars(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gint(n_chars));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_width_chars(XEN label)
{
  #define H_gtk_label_get_width_chars "gint gtk_label_get_width_chars(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_width_chars", "GtkLabel*");
  return(C_TO_XEN_gint(gtk_label_get_width_chars(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_target_list_add_text_targets(XEN list, XEN info)
{
  #define H_gtk_target_list_add_text_targets "void gtk_target_list_add_text_targets(GtkTargetList* list, \
guint info)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_add_text_targets", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_guint_P(info), info, 2, "gtk_target_list_add_text_targets", "guint");
  gtk_target_list_add_text_targets(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_guint(info));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_add_image_targets(XEN list, XEN info, XEN writable)
{
  #define H_gtk_target_list_add_image_targets "void gtk_target_list_add_image_targets(GtkTargetList* list, \
guint info, gboolean writable)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_add_image_targets", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_guint_P(info), info, 2, "gtk_target_list_add_image_targets", "guint");
  XEN_ASSERT_TYPE(XEN_gboolean_P(writable), writable, 3, "gtk_target_list_add_image_targets", "gboolean");
  gtk_target_list_add_image_targets(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_guint(info), XEN_TO_C_gboolean(writable));
  return(XEN_FALSE);
}
static XEN gxg_gtk_target_list_add_uri_targets(XEN list, XEN info)
{
  #define H_gtk_target_list_add_uri_targets "void gtk_target_list_add_uri_targets(GtkTargetList* list, \
guint info)"
  XEN_ASSERT_TYPE(XEN_GtkTargetList__P(list), list, 1, "gtk_target_list_add_uri_targets", "GtkTargetList*");
  XEN_ASSERT_TYPE(XEN_guint_P(info), info, 2, "gtk_target_list_add_uri_targets", "guint");
  gtk_target_list_add_uri_targets(XEN_TO_C_GtkTargetList_(list), XEN_TO_C_guint(info));
  return(XEN_FALSE);
}
static XEN gxg_gtk_selection_data_set_pixbuf(XEN selection_data, XEN pixbuf)
{
  #define H_gtk_selection_data_set_pixbuf "gboolean gtk_selection_data_set_pixbuf(GtkSelectionData* selection_data, \
GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_set_pixbuf", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 2, "gtk_selection_data_set_pixbuf", "GdkPixbuf*");
  return(C_TO_XEN_gboolean(gtk_selection_data_set_pixbuf(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_GdkPixbuf_(pixbuf))));
}
static XEN gxg_gtk_selection_data_get_pixbuf(XEN selection_data)
{
  #define H_gtk_selection_data_get_pixbuf "GdkPixbuf* gtk_selection_data_get_pixbuf(GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_get_pixbuf", "GtkSelectionData*");
  return(C_TO_XEN_GdkPixbuf_(gtk_selection_data_get_pixbuf(XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_selection_data_set_uris(XEN selection_data, XEN uris)
{
  #define H_gtk_selection_data_set_uris "gboolean gtk_selection_data_set_uris(GtkSelectionData* selection_data, \
gchar** uris)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_set_uris", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_gchar___P(uris), uris, 2, "gtk_selection_data_set_uris", "gchar**");
  return(C_TO_XEN_gboolean(gtk_selection_data_set_uris(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_gchar__(uris))));
}
static XEN gxg_gtk_selection_data_get_uris(XEN selection_data)
{
  #define H_gtk_selection_data_get_uris "gchar** gtk_selection_data_get_uris(GtkSelectionData* selection_data)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_get_uris", "GtkSelectionData*");
  return(C_TO_XEN_gchar__(gtk_selection_data_get_uris(XEN_TO_C_GtkSelectionData_(selection_data))));
}
static XEN gxg_gtk_text_buffer_backspace(XEN buffer, XEN iter, XEN interactive, XEN default_editable)
{
  #define H_gtk_text_buffer_backspace "gboolean gtk_text_buffer_backspace(GtkTextBuffer* buffer, GtkTextIter* iter, \
gboolean interactive, gboolean default_editable)"
  XEN_ASSERT_TYPE(XEN_GtkTextBuffer__P(buffer), buffer, 1, "gtk_text_buffer_backspace", "GtkTextBuffer*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_buffer_backspace", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(interactive), interactive, 3, "gtk_text_buffer_backspace", "gboolean");
  XEN_ASSERT_TYPE(XEN_gboolean_P(default_editable), default_editable, 4, "gtk_text_buffer_backspace", "gboolean");
  return(C_TO_XEN_gboolean(gtk_text_buffer_backspace(XEN_TO_C_GtkTextBuffer_(buffer), XEN_TO_C_GtkTextIter_(iter), XEN_TO_C_gboolean(interactive), 
                                                     XEN_TO_C_gboolean(default_editable))));
}
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
static XEN gxg_gtk_clipboard_set_image(XEN clipboard, XEN pixbuf)
{
  #define H_gtk_clipboard_set_image "void gtk_clipboard_set_image(GtkClipboard* clipboard, GdkPixbuf* pixbuf)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_set_image", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GdkPixbuf__P(pixbuf), pixbuf, 2, "gtk_clipboard_set_image", "GdkPixbuf*");
  gtk_clipboard_set_image(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GdkPixbuf_(pixbuf));
  return(XEN_FALSE);
}
static XEN gxg_gtk_clipboard_request_image(XEN clipboard, XEN func, XEN func_data)
{
  #define H_gtk_clipboard_request_image "void gtk_clipboard_request_image(GtkClipboard* clipboard, GtkClipboardImageReceivedFunc func, \
lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_request_image", "GtkClipboard*");
  XEN_ASSERT_TYPE(XEN_GtkClipboardImageReceivedFunc_P(func), func, 2, "gtk_clipboard_request_image", "GtkClipboardImageReceivedFunc");
  if (XEN_NOT_BOUND_P(func_data)) func_data = XEN_FALSE; 
  else XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 3, "gtk_clipboard_request_image", "lambda_data");
  {
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    gtk_clipboard_request_image(XEN_TO_C_GtkClipboard_(clipboard), XEN_TO_C_GtkClipboardImageReceivedFunc(func), XEN_TO_C_lambda_data(func_data));
    return(XEN_FALSE);
   }
}
static XEN gxg_gtk_clipboard_wait_for_image(XEN clipboard)
{
  #define H_gtk_clipboard_wait_for_image "GdkPixbuf* gtk_clipboard_wait_for_image(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_for_image", "GtkClipboard*");
  return(C_TO_XEN_GdkPixbuf_(gtk_clipboard_wait_for_image(XEN_TO_C_GtkClipboard_(clipboard))));
}
static XEN gxg_gtk_clipboard_wait_is_image_available(XEN clipboard)
{
  #define H_gtk_clipboard_wait_is_image_available "gboolean gtk_clipboard_wait_is_image_available(GtkClipboard* clipboard)"
  XEN_ASSERT_TYPE(XEN_GtkClipboard__P(clipboard), clipboard, 1, "gtk_clipboard_wait_is_image_available", "GtkClipboard*");
  return(C_TO_XEN_gboolean(gtk_clipboard_wait_is_image_available(XEN_TO_C_GtkClipboard_(clipboard))));
}
static XEN gxg_gtk_file_filter_add_pixbuf_formats(XEN filter)
{
  #define H_gtk_file_filter_add_pixbuf_formats "void gtk_file_filter_add_pixbuf_formats(GtkFileFilter* filter)"
  XEN_ASSERT_TYPE(XEN_GtkFileFilter__P(filter), filter, 1, "gtk_file_filter_add_pixbuf_formats", "GtkFileFilter*");
  gtk_file_filter_add_pixbuf_formats(XEN_TO_C_GtkFileFilter_(filter));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_set_single_line_mode(XEN label, XEN single_line_mode)
{
  #define H_gtk_label_set_single_line_mode "void gtk_label_set_single_line_mode(GtkLabel* label, gboolean single_line_mode)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_single_line_mode", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(single_line_mode), single_line_mode, 2, "gtk_label_set_single_line_mode", "gboolean");
  gtk_label_set_single_line_mode(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gboolean(single_line_mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_single_line_mode(XEN label)
{
  #define H_gtk_label_get_single_line_mode "gboolean gtk_label_get_single_line_mode(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_single_line_mode", "GtkLabel*");
  return(C_TO_XEN_gboolean(gtk_label_get_single_line_mode(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_progress_bar_set_ellipsize(XEN pbar, XEN mode)
{
  #define H_gtk_progress_bar_set_ellipsize "void gtk_progress_bar_set_ellipsize(GtkProgressBar* pbar, \
PangoEllipsizeMode mode)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_set_ellipsize", "GtkProgressBar*");
  XEN_ASSERT_TYPE(XEN_PangoEllipsizeMode_P(mode), mode, 2, "gtk_progress_bar_set_ellipsize", "PangoEllipsizeMode");
  gtk_progress_bar_set_ellipsize(XEN_TO_C_GtkProgressBar_(pbar), XEN_TO_C_PangoEllipsizeMode(mode));
  return(XEN_FALSE);
}
static XEN gxg_gtk_progress_bar_get_ellipsize(XEN pbar)
{
  #define H_gtk_progress_bar_get_ellipsize "PangoEllipsizeMode gtk_progress_bar_get_ellipsize(GtkProgressBar* pbar)"
  XEN_ASSERT_TYPE(XEN_GtkProgressBar__P(pbar), pbar, 1, "gtk_progress_bar_get_ellipsize", "GtkProgressBar*");
  return(C_TO_XEN_PangoEllipsizeMode(gtk_progress_bar_get_ellipsize(XEN_TO_C_GtkProgressBar_(pbar))));
}
static XEN gxg_gtk_selection_data_targets_include_image(XEN selection_data, XEN writable)
{
  #define H_gtk_selection_data_targets_include_image "gboolean gtk_selection_data_targets_include_image(GtkSelectionData* selection_data, \
gboolean writable)"
  XEN_ASSERT_TYPE(XEN_GtkSelectionData__P(selection_data), selection_data, 1, "gtk_selection_data_targets_include_image", "GtkSelectionData*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(writable), writable, 2, "gtk_selection_data_targets_include_image", "gboolean");
  return(C_TO_XEN_gboolean(gtk_selection_data_targets_include_image(XEN_TO_C_GtkSelectionData_(selection_data), XEN_TO_C_gboolean(writable))));
}
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
static XEN gxg_gdk_draw_glyphs_transformed(XEN drawable, XEN gc, XEN matrix, XEN font, XEN x, XEN y, XEN glyphs)
{
  #define H_gdk_draw_glyphs_transformed "void gdk_draw_glyphs_transformed(GdkDrawable* drawable, GdkGC* gc, \
PangoMatrix* matrix, PangoFont* font, gint x, gint y, PangoGlyphString* glyphs)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_glyphs_transformed", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_glyphs_transformed", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_PangoMatrix__P(matrix), matrix, 3, "gdk_draw_glyphs_transformed", "PangoMatrix*");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 4, "gdk_draw_glyphs_transformed", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 5, "gdk_draw_glyphs_transformed", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 6, "gdk_draw_glyphs_transformed", "gint");
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 7, "gdk_draw_glyphs_transformed", "PangoGlyphString*");
  gdk_draw_glyphs_transformed(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_PangoMatrix_(matrix), XEN_TO_C_PangoFont_(font), 
                              XEN_TO_C_gint(x), XEN_TO_C_gint(y), XEN_TO_C_PangoGlyphString_(glyphs));
  return(XEN_FALSE);
}
static XEN gxg_gdk_draw_trapezoids(XEN drawable, XEN gc, XEN trapezoids, XEN n_trapezoids)
{
  #define H_gdk_draw_trapezoids "void gdk_draw_trapezoids(GdkDrawable* drawable, GdkGC* gc, GdkTrapezoid* trapezoids, \
gint n_trapezoids)"
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 1, "gdk_draw_trapezoids", "GdkDrawable*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_draw_trapezoids", "GdkGC*");
  XEN_ASSERT_TYPE(XEN_GdkTrapezoid__P(trapezoids), trapezoids, 3, "gdk_draw_trapezoids", "GdkTrapezoid*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_trapezoids), n_trapezoids, 4, "gdk_draw_trapezoids", "gint");
  gdk_draw_trapezoids(XEN_TO_C_GdkDrawable_(drawable), XEN_TO_C_GdkGC_(gc), XEN_TO_C_GdkTrapezoid_(trapezoids), XEN_TO_C_gint(n_trapezoids));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pango_renderer_get_type(void)
{
  #define H_gdk_pango_renderer_get_type "GType gdk_pango_renderer_get_type( void)"
  return(C_TO_XEN_GType(gdk_pango_renderer_get_type()));
}
static XEN gxg_gdk_pango_renderer_new(XEN screen)
{
  #define H_gdk_pango_renderer_new "PangoRenderer* gdk_pango_renderer_new(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_pango_renderer_new", "GdkScreen*");
  return(C_TO_XEN_PangoRenderer_(gdk_pango_renderer_new(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_pango_renderer_get_default(XEN screen)
{
  #define H_gdk_pango_renderer_get_default "PangoRenderer* gdk_pango_renderer_get_default(GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen), screen, 1, "gdk_pango_renderer_get_default", "GdkScreen*");
  return(C_TO_XEN_PangoRenderer_(gdk_pango_renderer_get_default(XEN_TO_C_GdkScreen_(screen))));
}
static XEN gxg_gdk_pango_renderer_set_drawable(XEN gdk_renderer, XEN drawable)
{
  #define H_gdk_pango_renderer_set_drawable "void gdk_pango_renderer_set_drawable(GdkPangoRenderer* gdk_renderer, \
GdkDrawable* drawable)"
  XEN_ASSERT_TYPE(XEN_GdkPangoRenderer__P(gdk_renderer), gdk_renderer, 1, "gdk_pango_renderer_set_drawable", "GdkPangoRenderer*");
  XEN_ASSERT_TYPE(XEN_GdkDrawable__P(drawable), drawable, 2, "gdk_pango_renderer_set_drawable", "GdkDrawable*");
  gdk_pango_renderer_set_drawable(XEN_TO_C_GdkPangoRenderer_(gdk_renderer), XEN_TO_C_GdkDrawable_(drawable));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pango_renderer_set_gc(XEN gdk_renderer, XEN gc)
{
  #define H_gdk_pango_renderer_set_gc "void gdk_pango_renderer_set_gc(GdkPangoRenderer* gdk_renderer, \
GdkGC* gc)"
  XEN_ASSERT_TYPE(XEN_GdkPangoRenderer__P(gdk_renderer), gdk_renderer, 1, "gdk_pango_renderer_set_gc", "GdkPangoRenderer*");
  XEN_ASSERT_TYPE(XEN_GdkGC__P(gc), gc, 2, "gdk_pango_renderer_set_gc", "GdkGC*");
  gdk_pango_renderer_set_gc(XEN_TO_C_GdkPangoRenderer_(gdk_renderer), XEN_TO_C_GdkGC_(gc));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pango_renderer_set_stipple(XEN gdk_renderer, XEN part, XEN stipple)
{
  #define H_gdk_pango_renderer_set_stipple "void gdk_pango_renderer_set_stipple(GdkPangoRenderer* gdk_renderer, \
PangoRenderPart part, GdkBitmap* stipple)"
  XEN_ASSERT_TYPE(XEN_GdkPangoRenderer__P(gdk_renderer), gdk_renderer, 1, "gdk_pango_renderer_set_stipple", "GdkPangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "gdk_pango_renderer_set_stipple", "PangoRenderPart");
  XEN_ASSERT_TYPE(XEN_GdkBitmap__P(stipple), stipple, 3, "gdk_pango_renderer_set_stipple", "GdkBitmap*");
  gdk_pango_renderer_set_stipple(XEN_TO_C_GdkPangoRenderer_(gdk_renderer), XEN_TO_C_PangoRenderPart(part), XEN_TO_C_GdkBitmap_(stipple));
  return(XEN_FALSE);
}
static XEN gxg_gdk_pango_renderer_set_override_color(XEN gdk_renderer, XEN part, XEN color)
{
  #define H_gdk_pango_renderer_set_override_color "void gdk_pango_renderer_set_override_color(GdkPangoRenderer* gdk_renderer, \
PangoRenderPart part, GdkColor* color)"
  XEN_ASSERT_TYPE(XEN_GdkPangoRenderer__P(gdk_renderer), gdk_renderer, 1, "gdk_pango_renderer_set_override_color", "GdkPangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "gdk_pango_renderer_set_override_color", "PangoRenderPart");
  XEN_ASSERT_TYPE(XEN_GdkColor__P(color), color, 3, "gdk_pango_renderer_set_override_color", "GdkColor*");
  gdk_pango_renderer_set_override_color(XEN_TO_C_GdkPangoRenderer_(gdk_renderer), XEN_TO_C_PangoRenderPart(part), XEN_TO_C_GdkColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_set_image(XEN button, XEN image)
{
  #define H_gtk_button_set_image "void gtk_button_set_image(GtkButton* button, GtkWidget* image)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_set_image", "GtkButton*");
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(image), image, 2, "gtk_button_set_image", "GtkWidget*");
  gtk_button_set_image(XEN_TO_C_GtkButton_(button), XEN_TO_C_GtkWidget_(image));
  return(XEN_FALSE);
}
static XEN gxg_gtk_button_get_image(XEN button)
{
  #define H_gtk_button_get_image "GtkWidget* gtk_button_get_image(GtkButton* button)"
  XEN_ASSERT_TYPE(XEN_GtkButton__P(button), button, 1, "gtk_button_get_image", "GtkButton*");
  return(C_TO_XEN_GtkWidget_(gtk_button_get_image(XEN_TO_C_GtkButton_(button))));
}
static XEN gxg_gtk_dialog_set_alternative_button_order_from_array(XEN dialog, XEN n_params, XEN new_order)
{
  #define H_gtk_dialog_set_alternative_button_order_from_array "void gtk_dialog_set_alternative_button_order_from_array(GtkDialog* dialog, \
gint n_params, gint* new_order)"
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(dialog), dialog, 1, "gtk_dialog_set_alternative_button_order_from_array", "GtkDialog*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_params), n_params, 2, "gtk_dialog_set_alternative_button_order_from_array", "gint");
  XEN_ASSERT_TYPE(XEN_gint__P(new_order), new_order, 3, "gtk_dialog_set_alternative_button_order_from_array", "gint*");
  gtk_dialog_set_alternative_button_order_from_array(XEN_TO_C_GtkDialog_(dialog), XEN_TO_C_gint(n_params), XEN_TO_C_gint_(new_order));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_set_angle(XEN label, XEN angle)
{
  #define H_gtk_label_set_angle "void gtk_label_set_angle(GtkLabel* label, gdouble angle)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_angle", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gdouble_P(angle), angle, 2, "gtk_label_set_angle", "gdouble");
  gtk_label_set_angle(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gdouble(angle));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_angle(XEN label)
{
  #define H_gtk_label_get_angle "gdouble gtk_label_get_angle(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_angle", "GtkLabel*");
  return(C_TO_XEN_gdouble(gtk_label_get_angle(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_menu_set_screen(XEN menu, XEN screen)
{
  #define H_gtk_menu_set_screen "void gtk_menu_set_screen(GtkMenu* menu, GdkScreen* screen)"
  XEN_ASSERT_TYPE(XEN_GtkMenu__P(menu), menu, 1, "gtk_menu_set_screen", "GtkMenu*");
  XEN_ASSERT_TYPE(XEN_GdkScreen__P(screen) || XEN_FALSE_P(screen), screen, 2, "gtk_menu_set_screen", "GdkScreen*");
  gtk_menu_set_screen(XEN_TO_C_GtkMenu_(menu), XEN_TO_C_GdkScreen_(screen));
  return(XEN_FALSE);
}
static XEN gxg_pango_attr_underline_color_new(XEN red, XEN green, XEN blue)
{
  #define H_pango_attr_underline_color_new "PangoAttribute* pango_attr_underline_color_new(guint16 red, \
guint16 green, guint16 blue)"
  XEN_ASSERT_TYPE(XEN_guint16_P(red), red, 1, "pango_attr_underline_color_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(green), green, 2, "pango_attr_underline_color_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(blue), blue, 3, "pango_attr_underline_color_new", "guint16");
  return(C_TO_XEN_PangoAttribute_(pango_attr_underline_color_new(XEN_TO_C_guint16(red), XEN_TO_C_guint16(green), XEN_TO_C_guint16(blue))));
}
static XEN gxg_pango_attr_strikethrough_color_new(XEN red, XEN green, XEN blue)
{
  #define H_pango_attr_strikethrough_color_new "PangoAttribute* pango_attr_strikethrough_color_new(guint16 red, \
guint16 green, guint16 blue)"
  XEN_ASSERT_TYPE(XEN_guint16_P(red), red, 1, "pango_attr_strikethrough_color_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(green), green, 2, "pango_attr_strikethrough_color_new", "guint16");
  XEN_ASSERT_TYPE(XEN_guint16_P(blue), blue, 3, "pango_attr_strikethrough_color_new", "guint16");
  return(C_TO_XEN_PangoAttribute_(pango_attr_strikethrough_color_new(XEN_TO_C_guint16(red), XEN_TO_C_guint16(green), XEN_TO_C_guint16(blue))));
}
static XEN gxg_pango_render_part_get_type(void)
{
  #define H_pango_render_part_get_type "GType pango_render_part_get_type( void)"
  return(C_TO_XEN_GType(pango_render_part_get_type()));
}
static XEN gxg_pango_renderer_get_type(void)
{
  #define H_pango_renderer_get_type "GType pango_renderer_get_type( void)"
  return(C_TO_XEN_GType(pango_renderer_get_type()));
}
static XEN gxg_pango_renderer_draw_layout(XEN renderer, XEN layout, XEN x, XEN y)
{
  #define H_pango_renderer_draw_layout "void pango_renderer_draw_layout(PangoRenderer* renderer, PangoLayout* layout, \
int x, int y)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_layout", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 2, "pango_renderer_draw_layout", "PangoLayout*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 3, "pango_renderer_draw_layout", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 4, "pango_renderer_draw_layout", "int");
  pango_renderer_draw_layout(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoLayout_(layout), XEN_TO_C_int(x), XEN_TO_C_int(y));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_layout_line(XEN renderer, XEN line, XEN x, XEN y)
{
  #define H_pango_renderer_draw_layout_line "void pango_renderer_draw_layout_line(PangoRenderer* renderer, \
PangoLayoutLine* line, int x, int y)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_layout_line", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoLayoutLine__P(line), line, 2, "pango_renderer_draw_layout_line", "PangoLayoutLine*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 3, "pango_renderer_draw_layout_line", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 4, "pango_renderer_draw_layout_line", "int");
  pango_renderer_draw_layout_line(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoLayoutLine_(line), XEN_TO_C_int(x), XEN_TO_C_int(y));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_glyphs(XEN renderer, XEN font, XEN glyphs, XEN x, XEN y)
{
  #define H_pango_renderer_draw_glyphs "void pango_renderer_draw_glyphs(PangoRenderer* renderer, PangoFont* font, \
PangoGlyphString* glyphs, int x, int y)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_glyphs", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 2, "pango_renderer_draw_glyphs", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoGlyphString__P(glyphs), glyphs, 3, "pango_renderer_draw_glyphs", "PangoGlyphString*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 4, "pango_renderer_draw_glyphs", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 5, "pango_renderer_draw_glyphs", "int");
  pango_renderer_draw_glyphs(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoGlyphString_(glyphs), 
                             XEN_TO_C_int(x), XEN_TO_C_int(y));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_rectangle(XEN renderer, XEN part, XEN x, XEN y, XEN width, XEN height)
{
  #define H_pango_renderer_draw_rectangle "void pango_renderer_draw_rectangle(PangoRenderer* renderer, \
PangoRenderPart part, int x, int y, int width, int height)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_rectangle", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "pango_renderer_draw_rectangle", "PangoRenderPart");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 3, "pango_renderer_draw_rectangle", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 4, "pango_renderer_draw_rectangle", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 5, "pango_renderer_draw_rectangle", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 6, "pango_renderer_draw_rectangle", "int");
  pango_renderer_draw_rectangle(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoRenderPart(part), XEN_TO_C_int(x), XEN_TO_C_int(y), 
                                XEN_TO_C_int(width), XEN_TO_C_int(height));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_error_underline(XEN renderer, XEN x, XEN y, XEN width, XEN height)
{
  #define H_pango_renderer_draw_error_underline "void pango_renderer_draw_error_underline(PangoRenderer* renderer, \
int x, int y, int width, int height)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_error_underline", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_int_P(x), x, 2, "pango_renderer_draw_error_underline", "int");
  XEN_ASSERT_TYPE(XEN_int_P(y), y, 3, "pango_renderer_draw_error_underline", "int");
  XEN_ASSERT_TYPE(XEN_int_P(width), width, 4, "pango_renderer_draw_error_underline", "int");
  XEN_ASSERT_TYPE(XEN_int_P(height), height, 5, "pango_renderer_draw_error_underline", "int");
  pango_renderer_draw_error_underline(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_int(x), XEN_TO_C_int(y), XEN_TO_C_int(width), 
                                      XEN_TO_C_int(height));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_trapezoid(XEN renderer, XEN part, XEN y1, XEN x11, XEN x21, XEN y2, XEN x12, XEN x22)
{
  #define H_pango_renderer_draw_trapezoid "void pango_renderer_draw_trapezoid(PangoRenderer* renderer, \
PangoRenderPart part, double y1, double x11, double x21, double y2, double x12, double x22)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_trapezoid", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "pango_renderer_draw_trapezoid", "PangoRenderPart");
  XEN_ASSERT_TYPE(XEN_double_P(y1), y1, 3, "pango_renderer_draw_trapezoid", "double");
  XEN_ASSERT_TYPE(XEN_double_P(x11), x11, 4, "pango_renderer_draw_trapezoid", "double");
  XEN_ASSERT_TYPE(XEN_double_P(x21), x21, 5, "pango_renderer_draw_trapezoid", "double");
  XEN_ASSERT_TYPE(XEN_double_P(y2), y2, 6, "pango_renderer_draw_trapezoid", "double");
  XEN_ASSERT_TYPE(XEN_double_P(x12), x12, 7, "pango_renderer_draw_trapezoid", "double");
  XEN_ASSERT_TYPE(XEN_double_P(x22), x22, 8, "pango_renderer_draw_trapezoid", "double");
  pango_renderer_draw_trapezoid(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoRenderPart(part), XEN_TO_C_double(y1), XEN_TO_C_double(x11), 
                                XEN_TO_C_double(x21), XEN_TO_C_double(y2), XEN_TO_C_double(x12), XEN_TO_C_double(x22));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_draw_glyph(XEN renderer, XEN font, XEN glyph, XEN x, XEN y)
{
  #define H_pango_renderer_draw_glyph "void pango_renderer_draw_glyph(PangoRenderer* renderer, PangoFont* font, \
PangoGlyph glyph, double x, double y)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_draw_glyph", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoFont__P(font), font, 2, "pango_renderer_draw_glyph", "PangoFont*");
  XEN_ASSERT_TYPE(XEN_PangoGlyph_P(glyph), glyph, 3, "pango_renderer_draw_glyph", "PangoGlyph");
  XEN_ASSERT_TYPE(XEN_double_P(x), x, 4, "pango_renderer_draw_glyph", "double");
  XEN_ASSERT_TYPE(XEN_double_P(y), y, 5, "pango_renderer_draw_glyph", "double");
  pango_renderer_draw_glyph(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoFont_(font), XEN_TO_C_PangoGlyph(glyph), XEN_TO_C_double(x), 
                            XEN_TO_C_double(y));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_activate(XEN renderer)
{
  #define H_pango_renderer_activate "void pango_renderer_activate(PangoRenderer* renderer)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_activate", "PangoRenderer*");
  pango_renderer_activate(XEN_TO_C_PangoRenderer_(renderer));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_deactivate(XEN renderer)
{
  #define H_pango_renderer_deactivate "void pango_renderer_deactivate(PangoRenderer* renderer)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_deactivate", "PangoRenderer*");
  pango_renderer_deactivate(XEN_TO_C_PangoRenderer_(renderer));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_part_changed(XEN renderer, XEN part)
{
  #define H_pango_renderer_part_changed "void pango_renderer_part_changed(PangoRenderer* renderer, PangoRenderPart part)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_part_changed", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "pango_renderer_part_changed", "PangoRenderPart");
  pango_renderer_part_changed(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoRenderPart(part));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_set_color(XEN renderer, XEN part, XEN color)
{
  #define H_pango_renderer_set_color "void pango_renderer_set_color(PangoRenderer* renderer, PangoRenderPart part, \
PangoColor* color)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_set_color", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "pango_renderer_set_color", "PangoRenderPart");
  XEN_ASSERT_TYPE(XEN_PangoColor__P(color), color, 3, "pango_renderer_set_color", "PangoColor*");
  pango_renderer_set_color(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoRenderPart(part), XEN_TO_C_PangoColor_(color));
  return(XEN_FALSE);
}
static XEN gxg_pango_renderer_get_color(XEN renderer, XEN part)
{
  #define H_pango_renderer_get_color "PangoColor* pango_renderer_get_color(PangoRenderer* renderer, PangoRenderPart part)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_get_color", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoRenderPart_P(part), part, 2, "pango_renderer_get_color", "PangoRenderPart");
  return(C_TO_XEN_PangoColor_(pango_renderer_get_color(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoRenderPart(part))));
}
static XEN gxg_pango_renderer_set_matrix(XEN renderer, XEN matrix)
{
  #define H_pango_renderer_set_matrix "void pango_renderer_set_matrix(PangoRenderer* renderer, PangoMatrix* matrix)"
  XEN_ASSERT_TYPE(XEN_PangoRenderer__P(renderer), renderer, 1, "pango_renderer_set_matrix", "PangoRenderer*");
  XEN_ASSERT_TYPE(XEN_PangoMatrix__P(matrix), matrix, 2, "pango_renderer_set_matrix", "PangoMatrix*");
  pango_renderer_set_matrix(XEN_TO_C_PangoRenderer_(renderer), XEN_TO_C_PangoMatrix_(matrix));
  return(XEN_FALSE);
}
static XEN gxg_g_log_set_handler(XEN log_domain, XEN log_levels, XEN func, XEN func_data)
{
  #define H_g_log_set_handler "guint g_log_set_handler(gchar* log_domain, GLogLevelFlags log_levels, \
GLogFunc func, lambda_data func_data)"
  XEN_ASSERT_TYPE(XEN_gchar__P(log_domain), log_domain, 1, "g_log_set_handler", "gchar*");
  XEN_ASSERT_TYPE(XEN_GLogLevelFlags_P(log_levels), log_levels, 2, "g_log_set_handler", "GLogLevelFlags");
  XEN_ASSERT_TYPE(XEN_GLogFunc_P(func), func, 3, "g_log_set_handler", "GLogFunc");
  XEN_ASSERT_TYPE(XEN_lambda_data_P(func_data), func_data, 4, "g_log_set_handler", "lambda_data");
  {
    XEN result = XEN_FALSE;
    XEN gxg_ptr = XEN_LIST_5(func, func_data, XEN_FALSE, XEN_FALSE, XEN_FALSE);
    xm_protect(gxg_ptr);
    result = C_TO_XEN_guint(g_log_set_handler(XEN_TO_C_gchar_(log_domain), XEN_TO_C_GLogLevelFlags(log_levels), XEN_TO_C_GLogFunc(func), 
                                              XEN_TO_C_lambda_data(func_data)));
    return(result);
   }
}
static XEN gxg_g_log_remove_handler(XEN log_domain, XEN handler_id)
{
  #define H_g_log_remove_handler "void g_log_remove_handler(gchar* log_domain, guint handler_id)"
  XEN_ASSERT_TYPE(XEN_gchar__P(log_domain), log_domain, 1, "g_log_remove_handler", "gchar*");
  XEN_ASSERT_TYPE(XEN_guint_P(handler_id), handler_id, 2, "g_log_remove_handler", "guint");
  g_log_remove_handler(XEN_TO_C_gchar_(log_domain), XEN_TO_C_guint(handler_id));
  return(XEN_FALSE);
}
#endif

#if HAVE_GTK_TEXT_LAYOUT_GET_ITER_AT_POSITION
static XEN gxg_gtk_cell_renderer_stop_editing(XEN cell, XEN canceled)
{
  #define H_gtk_cell_renderer_stop_editing "void gtk_cell_renderer_stop_editing(GtkCellRenderer* cell, \
gboolean canceled)"
  XEN_ASSERT_TYPE(XEN_GtkCellRenderer__P(cell), cell, 1, "gtk_cell_renderer_stop_editing", "GtkCellRenderer*");
  XEN_ASSERT_TYPE(XEN_gboolean_P(canceled), canceled, 2, "gtk_cell_renderer_stop_editing", "gboolean");
  gtk_cell_renderer_stop_editing(XEN_TO_C_GtkCellRenderer_(cell), XEN_TO_C_gboolean(canceled));
  return(XEN_FALSE);
}
static XEN gxg_gtk_file_chooser_button_new(XEN title, XEN action)
{
  #define H_gtk_file_chooser_button_new "GtkWidget* gtk_file_chooser_button_new(gchar* title, GtkFileChooserAction action)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_file_chooser_button_new", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 2, "gtk_file_chooser_button_new", "GtkFileChooserAction");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_button_new((const gchar*)XEN_TO_C_gchar_(title), XEN_TO_C_GtkFileChooserAction(action))));
}
static XEN gxg_gtk_file_chooser_button_new_with_backend(XEN title, XEN action, XEN backend)
{
  #define H_gtk_file_chooser_button_new_with_backend "GtkWidget* gtk_file_chooser_button_new_with_backend(gchar* title, \
GtkFileChooserAction action, gchar* backend)"
  XEN_ASSERT_TYPE(XEN_gchar__P(title), title, 1, "gtk_file_chooser_button_new_with_backend", "gchar*");
  XEN_ASSERT_TYPE(XEN_GtkFileChooserAction_P(action), action, 2, "gtk_file_chooser_button_new_with_backend", "GtkFileChooserAction");
  XEN_ASSERT_TYPE(XEN_gchar__P(backend), backend, 3, "gtk_file_chooser_button_new_with_backend", "gchar*");
  return(C_TO_XEN_GtkWidget_(gtk_file_chooser_button_new_with_backend((const gchar*)XEN_TO_C_gchar_(title), XEN_TO_C_GtkFileChooserAction(action), 
                                                                      (const gchar*)XEN_TO_C_gchar_(backend))));
}
static XEN gxg_gtk_icon_view_set_columns(XEN icon_view, XEN columns)
{
  #define H_gtk_icon_view_set_columns "void gtk_icon_view_set_columns(GtkIconView* icon_view, gint columns)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_columns", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(columns), columns, 2, "gtk_icon_view_set_columns", "gint");
  gtk_icon_view_set_columns(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(columns));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_columns(XEN icon_view)
{
  #define H_gtk_icon_view_get_columns "gint gtk_icon_view_get_columns(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_columns", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_columns(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_item_width(XEN icon_view, XEN item_width)
{
  #define H_gtk_icon_view_set_item_width "void gtk_icon_view_set_item_width(GtkIconView* icon_view, gint item_width)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_item_width", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(item_width), item_width, 2, "gtk_icon_view_set_item_width", "gint");
  gtk_icon_view_set_item_width(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(item_width));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_item_width(XEN icon_view)
{
  #define H_gtk_icon_view_get_item_width "gint gtk_icon_view_get_item_width(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_item_width", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_item_width(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_spacing(XEN icon_view, XEN spacing)
{
  #define H_gtk_icon_view_set_spacing "void gtk_icon_view_set_spacing(GtkIconView* icon_view, gint spacing)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_spacing", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(spacing), spacing, 2, "gtk_icon_view_set_spacing", "gint");
  gtk_icon_view_set_spacing(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_spacing(XEN icon_view)
{
  #define H_gtk_icon_view_get_spacing "gint gtk_icon_view_get_spacing(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_spacing", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_spacing(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_row_spacing(XEN icon_view, XEN row_spacing)
{
  #define H_gtk_icon_view_set_row_spacing "void gtk_icon_view_set_row_spacing(GtkIconView* icon_view, \
gint row_spacing)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_row_spacing", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(row_spacing), row_spacing, 2, "gtk_icon_view_set_row_spacing", "gint");
  gtk_icon_view_set_row_spacing(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(row_spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_row_spacing(XEN icon_view)
{
  #define H_gtk_icon_view_get_row_spacing "gint gtk_icon_view_get_row_spacing(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_row_spacing", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_row_spacing(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_column_spacing(XEN icon_view, XEN column_spacing)
{
  #define H_gtk_icon_view_set_column_spacing "void gtk_icon_view_set_column_spacing(GtkIconView* icon_view, \
gint column_spacing)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_column_spacing", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(column_spacing), column_spacing, 2, "gtk_icon_view_set_column_spacing", "gint");
  gtk_icon_view_set_column_spacing(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(column_spacing));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_column_spacing(XEN icon_view)
{
  #define H_gtk_icon_view_get_column_spacing "gint gtk_icon_view_get_column_spacing(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_column_spacing", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_column_spacing(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_icon_view_set_margin(XEN icon_view, XEN margin)
{
  #define H_gtk_icon_view_set_margin "void gtk_icon_view_set_margin(GtkIconView* icon_view, gint margin)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_set_margin", "GtkIconView*");
  XEN_ASSERT_TYPE(XEN_gint_P(margin), margin, 2, "gtk_icon_view_set_margin", "gint");
  gtk_icon_view_set_margin(XEN_TO_C_GtkIconView_(icon_view), XEN_TO_C_gint(margin));
  return(XEN_FALSE);
}
static XEN gxg_gtk_icon_view_get_margin(XEN icon_view)
{
  #define H_gtk_icon_view_get_margin "gint gtk_icon_view_get_margin(GtkIconView* icon_view)"
  XEN_ASSERT_TYPE(XEN_GtkIconView__P(icon_view), icon_view, 1, "gtk_icon_view_get_margin", "GtkIconView*");
  return(C_TO_XEN_gint(gtk_icon_view_get_margin(XEN_TO_C_GtkIconView_(icon_view))));
}
static XEN gxg_gtk_label_set_max_width_chars(XEN label, XEN n_chars)
{
  #define H_gtk_label_set_max_width_chars "void gtk_label_set_max_width_chars(GtkLabel* label, gint n_chars)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_set_max_width_chars", "GtkLabel*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_chars), n_chars, 2, "gtk_label_set_max_width_chars", "gint");
  gtk_label_set_max_width_chars(XEN_TO_C_GtkLabel_(label), XEN_TO_C_gint(n_chars));
  return(XEN_FALSE);
}
static XEN gxg_gtk_label_get_max_width_chars(XEN label)
{
  #define H_gtk_label_get_max_width_chars "gint gtk_label_get_max_width_chars(GtkLabel* label)"
  XEN_ASSERT_TYPE(XEN_GtkLabel__P(label), label, 1, "gtk_label_get_max_width_chars", "GtkLabel*");
  return(C_TO_XEN_gint(gtk_label_get_max_width_chars(XEN_TO_C_GtkLabel_(label))));
}
static XEN gxg_gtk_list_store_insert_with_values(XEN list_store, XEN iter, XEN position)
{
  #define H_gtk_list_store_insert_with_values "void gtk_list_store_insert_with_values(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, ...)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_insert_with_values", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_insert_with_values", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_list_store_insert_with_values", "gint");
  gtk_list_store_insert_with_values(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_gint(position));
  return(XEN_FALSE);
}
static XEN gxg_gtk_list_store_insert_with_valuesv(XEN list_store, XEN iter, XEN position, XEN columns, XEN values, XEN n_values)
{
  #define H_gtk_list_store_insert_with_valuesv "void gtk_list_store_insert_with_valuesv(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, gint* columns, GValue* values, gint n_values)"
  XEN_ASSERT_TYPE(XEN_GtkListStore__P(list_store), list_store, 1, "gtk_list_store_insert_with_valuesv", "GtkListStore*");
  XEN_ASSERT_TYPE(XEN_GtkTreeIter__P(iter), iter, 2, "gtk_list_store_insert_with_valuesv", "GtkTreeIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(position), position, 3, "gtk_list_store_insert_with_valuesv", "gint");
  XEN_ASSERT_TYPE(XEN_gint__P(columns), columns, 4, "gtk_list_store_insert_with_valuesv", "gint*");
  XEN_ASSERT_TYPE(XEN_GValue__P(values), values, 5, "gtk_list_store_insert_with_valuesv", "GValue*");
  XEN_ASSERT_TYPE(XEN_gint_P(n_values), n_values, 6, "gtk_list_store_insert_with_valuesv", "gint");
  gtk_list_store_insert_with_valuesv(XEN_TO_C_GtkListStore_(list_store), XEN_TO_C_GtkTreeIter_(iter), XEN_TO_C_gint(position), 
                                     XEN_TO_C_gint_(columns), XEN_TO_C_GValue_(values), XEN_TO_C_gint(n_values));
  return(XEN_FALSE);
}
static XEN gxg_gtk_text_view_get_iter_at_position(XEN text_view, XEN iter, XEN trailing, XEN x, XEN y)
{
  #define H_gtk_text_view_get_iter_at_position "void gtk_text_view_get_iter_at_position(GtkTextView* text_view, \
GtkTextIter* iter, gint* [trailing], gint x, gint y)"
  gint ref_trailing;
  XEN_ASSERT_TYPE(XEN_GtkTextView__P(text_view), text_view, 1, "gtk_text_view_get_iter_at_position", "GtkTextView*");
  XEN_ASSERT_TYPE(XEN_GtkTextIter__P(iter), iter, 2, "gtk_text_view_get_iter_at_position", "GtkTextIter*");
  XEN_ASSERT_TYPE(XEN_gint_P(x), x, 4, "gtk_text_view_get_iter_at_position", "gint");
  XEN_ASSERT_TYPE(XEN_gint_P(y), y, 5, "gtk_text_view_get_iter_at_position", "gint");
  gtk_text_view_get_iter_at_position(XEN_TO_C_GtkTextView_(text_view), XEN_TO_C_GtkTextIter_(iter), &ref_trailing, XEN_TO_C_gint(x), 
                                     XEN_TO_C_gint(y));
  return(XEN_LIST_1(C_TO_XEN_gint(ref_trailing)));
}
static XEN gxg_pango_attr_size_new_absolute(XEN size)
{
  #define H_pango_attr_size_new_absolute "PangoAttribute* pango_attr_size_new_absolute(int size)"
  XEN_ASSERT_TYPE(XEN_int_P(size), size, 1, "pango_attr_size_new_absolute", "int");
  return(C_TO_XEN_PangoAttribute_(pango_attr_size_new_absolute(XEN_TO_C_int(size))));
}
static XEN gxg_pango_font_description_set_absolute_size(XEN desc, XEN size)
{
  #define H_pango_font_description_set_absolute_size "void pango_font_description_set_absolute_size(PangoFontDescription* desc, \
double size)"
  XEN_ASSERT_TYPE(XEN_PangoFontDescription__P(desc), desc, 1, "pango_font_description_set_absolute_size", "PangoFontDescription*");
  XEN_ASSERT_TYPE(XEN_double_P(size), size, 2, "pango_font_description_set_absolute_size", "double");
  pango_font_description_set_absolute_size(XEN_TO_C_PangoFontDescription_(desc), XEN_TO_C_double(size));
  return(XEN_FALSE);
}
static XEN gxg_pango_layout_get_font_description(XEN layout)
{
  #define H_pango_layout_get_font_description "PangoFontDescription* pango_layout_get_font_description(PangoLayout* layout)"
  XEN_ASSERT_TYPE(XEN_PangoLayout__P(layout), layout, 1, "pango_layout_get_font_description", "PangoLayout*");
    return(C_TO_XEN_PangoFontDescription_((PangoFontDescription*)pango_layout_get_font_description(XEN_TO_C_PangoLayout_(layout))));
}
#endif

#define WRAPPED_OBJECT_P(Obj) (XEN_LIST_P(Obj) && (XEN_LIST_LENGTH(Obj) >= 2) && (XEN_SYMBOL_P(XEN_CAR(Obj))))

static XEN gxg_GPOINTER(XEN obj) {return(XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("gpointer"), (WRAPPED_OBJECT_P(obj)) ? XEN_CADR(obj) : obj));}
static XEN gxg_GDK_COLORMAP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkColormap_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_DRAG_CONTEXT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkDragContext_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_DRAWABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkDrawable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_GC(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkGC_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_IMAGE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkImage_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_DEVICE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkDevice_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_KEYMAP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkKeymap_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_PIXMAP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPixmap_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_VISUAL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkVisual_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_WINDOW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkWindow_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_PIXBUF(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPixbuf_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_PIXBUF_ANIMATION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPixbufAnimation_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_PIXBUF_ANIMATION_ITER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPixbufAnimationIter_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_PIXBUF_LOADER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPixbufLoader_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VBOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ACCEL_GROUP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAccelGroup_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ACCEL_LABEL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAccelLabel_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ACCESSIBLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAccessible_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ADJUSTMENT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAdjustment_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ALIGNMENT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAlignment_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ARROW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkArrow_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ASPECT_FRAME(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAspectFrame_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_BUTTON_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkButtonBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_BIN(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkBin_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CALENDAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCalendar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_EDITABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellEditable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRenderer_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER_PIXBUF(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRendererPixbuf_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER_TEXT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRendererText_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER_TOGGLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRendererToggle_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CHECK_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCheckButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CHECK_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCheckMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_COLOR_SELECTION_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkColorSelectionDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_COLOR_SELECTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkColorSelection_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CONTAINER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkContainer_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CURVE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCurve_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_DRAWING_AREA(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkDrawingArea_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_EDITABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkEditable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ENTRY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkEntry_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_EVENT_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkEventBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FILE_SELECTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileSelection_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FIXED(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFixed_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FONT_SELECTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFontSelection_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FONT_SELECTION_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFontSelectionDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FRAME(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFrame_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_GAMMA_CURVE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkGammaCurve_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HANDLE_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHandleBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HBUTTON_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHButtonBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HBOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HPANED(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHPaned_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HRULER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHRuler_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HSCALE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHScale_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HSCROLLBAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHScrollbar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_HSEPARATOR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkHSeparator_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ICON_FACTORY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIconFactory_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_IMAGE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkImage_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_IMAGE_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkImageMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_IM_CONTEXT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIMContext_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_IM_CONTEXT_SIMPLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIMContextSimple_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_IM_MULTICONTEXT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIMMulticontext_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_INPUT_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkInputDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_INVISIBLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkInvisible_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_LABEL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkLabel_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_LAYOUT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkLayout_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_LIST_STORE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkListStore_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MENU_BAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMenuBar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MENU(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMenu_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MENU_SHELL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMenuShell_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MESSAGE_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMessageDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_MISC(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMisc_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_NOTEBOOK(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkNotebook_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_OBJECT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkObject_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_PANED(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkPaned_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_PLUG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkPlug_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_PROGRESS_BAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkProgressBar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RADIO_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRadioButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RADIO_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRadioMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RANGE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRange_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RULER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRuler_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SCALE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkScale_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SCROLLBAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkScrollbar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SCROLLED_WINDOW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkScrolledWindow_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SEPARATOR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSeparator_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SEPARATOR_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSeparatorMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SIZE_GROUP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSizeGroup_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SOCKET(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSocket_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SPIN_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSpinButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_STATUSBAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkStatusbar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_STYLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkStyle_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEAROFF_MENU_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTearoffMenuItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_BUFFER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextBuffer_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_CHILD_ANCHOR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextChildAnchor_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_MARK(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextMark_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_TAG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextTag_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_TAG_TABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextTagTable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TEXT_VIEW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTextView_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOGGLE_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToggleButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOOLBAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToolbar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOOLTIPS(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTooltips_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_DRAG_SOURCE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeDragSource_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_DRAG_DEST(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeDragDest_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_MODEL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeModel_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_MODEL_SORT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeModelSort_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_SELECTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeSelection_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_SORTABLE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeSortable_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_STORE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeStore_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_VIEW_COLUMN(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeViewColumn_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_VIEW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeView_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VBUTTON_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVButtonBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VIEWPORT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkViewport_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VPANED(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVPaned_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VRULER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVRuler_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VSCALE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVScale_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VSCROLLBAR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVScrollbar_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_VSEPARATOR(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkVSeparator_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_WIDGET(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkWidget_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_WINDOW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkWindow_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_CONTEXT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoContext_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_FONT_FAMILY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoFontFamily_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_FONT_FACE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoFontFace_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_FONT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoFont_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_FONT_MAP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoFontMap_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_LAYOUT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoLayout_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_G_OBJECT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GObject_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_ANY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventAny_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_EXPOSE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventExpose_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_NOEXPOSE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventNoExpose_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_VISIBILITY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventVisibility_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_MOTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventMotion_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_SCROLL(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventScroll_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_KEY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventKey_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_CROSSING(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventCrossing_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_FOCUS(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventFocus_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_CONFIGURE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventConfigure_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_PROPERTY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventProperty_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_SELECTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventSelection_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_PROXIMITY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventProximity_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_SETTING(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventSetting_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_WINDOWSTATE(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventWindowState_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_EVENT_DND(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkEventDND_"), XEN_CADR(obj)) : XEN_FALSE);}
#if HAVE_GDK_DRAW_PIXBUF
static XEN gxg_GDK_SCREEN(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkScreen_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GDK_DISPLAY_OBJECT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkDisplay_"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
static XEN gxg_GTK_FILE_CHOOSER_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileChooserDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FILE_CHOOSER_WIDGET(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileChooserWidget_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TREE_MODEL_FILTER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkTreeModelFilter_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ACTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAction_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ACTION_GROUP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkActionGroup_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_COMBO_BOX(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkComboBox_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_COMBO_BOX_ENTRY(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkComboBoxEntry_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_EXPANDER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkExpander_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FONT_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFontButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_COLOR_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkColorButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ENTRY_COMPLETION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkEntryCompletion_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_UI_MANAGER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkUIManager_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RADIO_TOOL_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRadioToolButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_RADIO_ACTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkRadioAction_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_SEPARATOR_TOOL_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkSeparatorToolItem_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOGGLE_ACTION(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToggleAction_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOGGLE_TOOL_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToggleToolButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FILE_FILTER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileFilter_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_LAYOUT(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellLayout_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CLIPBOARD(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkClipboard_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_FILE_CHOOSER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileChooser_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ICON_THEME(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIconTheme_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOOL_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToolButton_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_TOOL_ITEM(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkToolItem_"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
static XEN gxg_GTK_ACCEL_MAP(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAccelMap"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
static XEN gxg_GTK_CELL_VIEW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellView_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ABOUT_DIALOG(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkAboutDialog_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER_COMBO(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRendererCombo_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_CELL_RENDERER_PROGRESS(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkCellRendererProgress_"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_GTK_ICON_VIEW(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkIconView_"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
static XEN gxg_GTK_FILE_CHOOSER_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkFileChooserButton_"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
static XEN gxg_GTK_MENU_TOOL_BUTTON(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GtkMenuToolButton_"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
static XEN gxg_GDK_PANGO_RENDERER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("GdkPangoRenderer"), XEN_CADR(obj)) : XEN_FALSE);}
static XEN gxg_PANGO_RENDERER(XEN obj) {return((WRAPPED_OBJECT_P(obj)) ? XEN_LIST_2(C_STRING_TO_XEN_SYMBOL("PangoRenderer"), XEN_CADR(obj)) : XEN_FALSE);}
#endif

static XEN gxg_GDK_IS_COLORMAP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_COLORMAP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_DRAG_CONTEXT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_DRAG_CONTEXT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_DRAWABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_DRAWABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_GC(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_GC((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_IMAGE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_IMAGE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_DEVICE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_DEVICE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_KEYMAP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_KEYMAP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_PIXMAP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PIXMAP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_VISUAL(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_VISUAL((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_WINDOW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_WINDOW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_PIXBUF(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PIXBUF((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_PIXBUF_ANIMATION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PIXBUF_ANIMATION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_PIXBUF_ANIMATION_ITER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PIXBUF_ANIMATION_ITER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_PIXBUF_LOADER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PIXBUF_LOADER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VBOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VBOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ACCEL_GROUP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACCEL_GROUP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ACCEL_LABEL(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACCEL_LABEL((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ACCESSIBLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACCESSIBLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ADJUSTMENT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ADJUSTMENT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ALIGNMENT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ALIGNMENT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ARROW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ARROW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ASPECT_FRAME(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ASPECT_FRAME((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_BUTTON_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_BUTTON_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_BIN(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_BIN((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CALENDAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CALENDAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_EDITABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_EDITABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER_PIXBUF(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER_PIXBUF((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER_TEXT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER_TEXT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER_TOGGLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER_TOGGLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CHECK_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CHECK_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CHECK_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CHECK_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_COLOR_SELECTION_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_COLOR_SELECTION_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_COLOR_SELECTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_COLOR_SELECTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CONTAINER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CONTAINER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CURVE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CURVE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_DRAWING_AREA(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_DRAWING_AREA((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_EDITABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_EDITABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ENTRY(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ENTRY((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_EVENT_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_EVENT_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FILE_SELECTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_SELECTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FIXED(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FIXED((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FONT_SELECTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FONT_SELECTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FONT_SELECTION_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FONT_SELECTION_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FRAME(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FRAME((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_GAMMA_CURVE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_GAMMA_CURVE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HANDLE_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HANDLE_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HBUTTON_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HBUTTON_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HBOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HBOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HPANED(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HPANED((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HRULER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HRULER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HSCALE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HSCALE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HSCROLLBAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HSCROLLBAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_HSEPARATOR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_HSEPARATOR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ICON_FACTORY(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ICON_FACTORY((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_IMAGE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_IMAGE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_IMAGE_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_IMAGE_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_IM_CONTEXT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_IM_CONTEXT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_IM_CONTEXT_SIMPLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_IM_CONTEXT_SIMPLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_IM_MULTICONTEXT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_IM_MULTICONTEXT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_INPUT_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_INPUT_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_INVISIBLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_INVISIBLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_LABEL(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_LABEL((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_LAYOUT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_LAYOUT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_LIST_STORE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_LIST_STORE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MENU_BAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MENU_BAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MENU(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MENU((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MENU_SHELL(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MENU_SHELL((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MESSAGE_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MESSAGE_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_MISC(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MISC((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_NOTEBOOK(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_NOTEBOOK((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_OBJECT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_OBJECT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_PANED(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_PANED((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_PLUG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_PLUG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_PROGRESS_BAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_PROGRESS_BAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RADIO_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RADIO_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RADIO_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RADIO_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RANGE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RANGE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RC_STYLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RC_STYLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RULER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RULER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SCALE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SCALE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SCROLLBAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SCROLLBAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SCROLLED_WINDOW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SCROLLED_WINDOW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SEPARATOR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SEPARATOR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SEPARATOR_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SEPARATOR_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SIZE_GROUP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SIZE_GROUP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SOCKET(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SOCKET((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SPIN_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SPIN_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_STATUSBAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_STATUSBAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_STYLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_STYLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEAROFF_MENU_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEAROFF_MENU_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_BUFFER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_BUFFER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_CHILD_ANCHOR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_CHILD_ANCHOR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_MARK(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_MARK((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_TAG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_TAG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_TAG_TABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_TAG_TABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TEXT_VIEW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TEXT_VIEW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOGGLE_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOGGLE_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOOLBAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOOLBAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOOLTIPS(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOOLTIPS((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_DRAG_SOURCE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_DRAG_SOURCE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_DRAG_DEST(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_DRAG_DEST((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_MODEL(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_MODEL((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_MODEL_SORT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_MODEL_SORT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_SELECTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_SELECTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_SORTABLE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_SORTABLE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_STORE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_STORE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_VIEW_COLUMN(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_VIEW_COLUMN((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_VIEW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_VIEW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VBUTTON_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VBUTTON_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VIEWPORT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VIEWPORT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VPANED(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VPANED((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VRULER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VRULER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VSCALE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VSCALE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VSCROLLBAR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VSCROLLBAR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_VSEPARATOR(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_VSEPARATOR((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_WIDGET(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_WIDGET((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_WINDOW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_WINDOW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_CONTEXT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_CONTEXT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_FONT_FAMILY(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_FONT_FAMILY((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_FONT_FACE(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_FONT_FACE((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_FONT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_FONT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_FONT_MAP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_FONT_MAP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_LAYOUT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_LAYOUT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_G_IS_OBJECT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && G_IS_OBJECT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#if HAVE_GDK_DRAW_PIXBUF
static XEN gxg_GDK_IS_SCREEN(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_SCREEN((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GDK_IS_DISPLAY(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_DISPLAY((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
static XEN gxg_GTK_IS_FILE_CHOOSER_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_CHOOSER_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FILE_CHOOSER_WIDGET(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_CHOOSER_WIDGET((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TREE_MODEL_FILTER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TREE_MODEL_FILTER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ACTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ACTION_GROUP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACTION_GROUP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_COMBO_BOX(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_COMBO_BOX((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_COMBO_BOX_ENTRY(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_COMBO_BOX_ENTRY((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_EXPANDER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_EXPANDER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FONT_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FONT_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_COLOR_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_COLOR_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ENTRY_COMPLETION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ENTRY_COMPLETION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_UI_MANAGER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_UI_MANAGER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RADIO_TOOL_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RADIO_TOOL_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_RADIO_ACTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_RADIO_ACTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_SEPARATOR_TOOL_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_SEPARATOR_TOOL_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOGGLE_ACTION(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOGGLE_ACTION((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOGGLE_TOOL_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOGGLE_TOOL_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FILE_FILTER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_FILTER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_LAYOUT(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_LAYOUT((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CLIPBOARD(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CLIPBOARD((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_FILE_CHOOSER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_CHOOSER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ICON_THEME(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ICON_THEME((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOOL_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOOL_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_TOOL_ITEM(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_TOOL_ITEM((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
static XEN gxg_GTK_IS_ACCEL_MAP(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ACCEL_MAP((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
static XEN gxg_GTK_IS_CELL_VIEW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_VIEW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ABOUT_DIALOG(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ABOUT_DIALOG((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER_COMBO(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER_COMBO((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_CELL_RENDERER_PROGRESS(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_CELL_RENDERER_PROGRESS((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_GTK_IS_ICON_VIEW(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_ICON_VIEW((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
static XEN gxg_GTK_IS_FILE_CHOOSER_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_FILE_CHOOSER_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
static XEN gxg_GTK_IS_MENU_TOOL_BUTTON(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GTK_IS_MENU_TOOL_BUTTON((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
static XEN gxg_GDK_IS_PANGO_RENDERER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && GDK_IS_PANGO_RENDERER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
static XEN gxg_PANGO_IS_RENDERER(XEN obj) {return(C_TO_XEN_BOOLEAN(WRAPPED_OBJECT_P(obj) && PANGO_IS_RENDERER((GTypeInstance *)XEN_TO_C_ULONG(XEN_CADR(obj)))));}
#endif



/* ---------------------------------------- special functions ---------------------------------------- */

static XEN gxg_vector2GdkPoints(XEN arg1)
{
  #define H_vector2GdkPoints "(vector->GdkPoints vect) packages point data in vect as an (opaque) array of GdkPoints"
  int i, j, len;
  GdkPoint *pt;
  XEN_ASSERT_TYPE(XEN_VECTOR_P(arg1), arg1, XEN_ONLY_ARG, "vector->GdkPoints", "vector of x,y values");
  len = XEN_VECTOR_LENGTH(arg1) / 2;
  if (len <= 0) XEN_ASSERT_TYPE(0, arg1, 1, "vector->GdkPoints", "positive integer");
  pt = (GdkPoint *)CALLOC(len, sizeof(GdkPoint));
  for (i = 0, j = 0; i < len; i++, j += 2)
    {
      pt[i].x = XEN_TO_C_INT(XEN_VECTOR_REF(arg1, j));
      pt[i].y = XEN_TO_C_INT(XEN_VECTOR_REF(arg1, j + 1));
    }
  return(C_TO_XEN_ULONG((unsigned long)pt));
}

static XEN gxg_freeGdkPoints(XEN arg1)
{
  void *pts;
  #define H_freeGdkPoints "(freeGdkPoints vect) frees an (opaque) GdkPoint array created by vector->Gdkpoints"
  XEN_ASSERT_TYPE(XEN_ULONG_P(arg1), arg1, XEN_ONLY_ARG, "freeGdkPoints", "opaque GdkPoint array");
  pts = (void *)(XEN_TO_C_ULONG(arg1));
  FREE(pts);
  return(XEN_FALSE);
}

static XEN gxg_make_target_entry(XEN lst)
{
  GtkTargetEntry* targets;
  XEN val;
  int i, len;
  #define H_make_target_entry "(make-target-entry lst) -> GtkTargetEntry*, each member of 'lst' should be (list target flags info)"
  XEN_ASSERT_TYPE(XEN_LIST_P(lst), lst, XEN_ONLY_ARG, "make-target-entry", "a list of lists describing each target");
  len = XEN_LIST_LENGTH(lst);
  if (len == 0) return(XEN_FALSE);
  targets = (GtkTargetEntry *)CALLOC(len, sizeof(GtkTargetEntry));
  for (i = 0; i < len; i++)
    {
      val = XEN_LIST_REF(lst, i);
      targets[i].target = strdup(XEN_TO_C_STRING(XEN_LIST_REF(val, 0)));
      targets[i].flags = (guint)XEN_TO_C_ULONG(XEN_LIST_REF(val, 1));
      targets[i].info = (guint)XEN_TO_C_ULONG(XEN_LIST_REF(val, 2));
    }
  return(C_TO_XEN_GtkTargetEntry_(targets));
}
static XEN c_array_to_xen_list(XEN val, XEN clen);
static XEN xen_list_to_c_array(XEN val, XEN type);

  #define XG_DEFINE_PROCEDURE(Name, Value, A1, A2, A3, Help) XEN_DEFINE_PROCEDURE(XG_PRE #Name XG_POST, Value, A1, A2, A3, Help)
#if HAVE_GUILE
static void define_functions(void)
{
  xm_gc_table = XEN_MAKE_VECTOR(1, XEN_FALSE);
  XEN_PROTECT_FROM_GC(xm_gc_table);
  xm_protected_size = 512;
  xm_protected = XEN_MAKE_VECTOR(xm_protected_size, XEN_FALSE);
  XEN_VECTOR_SET(xm_gc_table, 0, xm_protected);

  XG_DEFINE_PROCEDURE(c-array->list, c_array_to_xen_list, 2, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(list->c-array, xen_list_to_c_array, 2, 0, 0, NULL);

  XG_DEFINE_PROCEDURE(freeGdkPoints, gxg_freeGdkPoints, 1, 0, 0, H_freeGdkPoints);
  XG_DEFINE_PROCEDURE(vector->GdkPoints, gxg_vector2GdkPoints, 1, 0, 0, H_vector2GdkPoints);
  XG_DEFINE_PROCEDURE(->string, c_to_xen_string, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(make-target-entry, gxg_make_target_entry, 1, 0, 0, H_make_target_entry);
  XG_DEFINE_PROCEDURE(g_type_name, gxg_g_type_name, 1, 0, 0, H_g_type_name);
  XG_DEFINE_PROCEDURE(g_type_qname, gxg_g_type_qname, 1, 0, 0, H_g_type_qname);
  XG_DEFINE_PROCEDURE(g_type_from_name, gxg_g_type_from_name, 1, 0, 0, H_g_type_from_name);
  XG_DEFINE_PROCEDURE(g_type_parent, gxg_g_type_parent, 1, 0, 0, H_g_type_parent);
  XG_DEFINE_PROCEDURE(g_type_is_a, gxg_g_type_is_a, 2, 0, 0, H_g_type_is_a);
  XG_DEFINE_PROCEDURE(g_cclosure_new, gxg_g_cclosure_new, 3, 0, 0, H_g_cclosure_new);
  XG_DEFINE_PROCEDURE(g_signal_newv, gxg_g_signal_newv, 0, 0, 1, H_g_signal_newv);
  XG_DEFINE_PROCEDURE(g_signal_lookup, gxg_g_signal_lookup, 2, 0, 0, H_g_signal_lookup);
  XG_DEFINE_PROCEDURE(g_signal_name, gxg_g_signal_name, 1, 0, 0, H_g_signal_name);
  XG_DEFINE_PROCEDURE(g_signal_query, gxg_g_signal_query, 2, 0, 0, H_g_signal_query);
  XG_DEFINE_PROCEDURE(g_signal_list_ids, gxg_g_signal_list_ids, 2, 0, 0, H_g_signal_list_ids);
  XG_DEFINE_PROCEDURE(g_signal_parse_name, gxg_g_signal_parse_name, 3, 2, 0, H_g_signal_parse_name);
  XG_DEFINE_PROCEDURE(g_signal_get_invocation_hint, gxg_g_signal_get_invocation_hint, 1, 0, 0, H_g_signal_get_invocation_hint);
  XG_DEFINE_PROCEDURE(g_signal_stop_emission, gxg_g_signal_stop_emission, 3, 0, 0, H_g_signal_stop_emission);
  XG_DEFINE_PROCEDURE(g_signal_stop_emission_by_name, gxg_g_signal_stop_emission_by_name, 2, 0, 0, H_g_signal_stop_emission_by_name);
  XG_DEFINE_PROCEDURE(g_signal_add_emission_hook, gxg_g_signal_add_emission_hook, 5, 0, 0, H_g_signal_add_emission_hook);
  XG_DEFINE_PROCEDURE(g_signal_remove_emission_hook, gxg_g_signal_remove_emission_hook, 2, 0, 0, H_g_signal_remove_emission_hook);
  XG_DEFINE_PROCEDURE(g_signal_has_handler_pending, gxg_g_signal_has_handler_pending, 4, 0, 0, H_g_signal_has_handler_pending);
  XG_DEFINE_PROCEDURE(g_signal_connect_closure_by_id, gxg_g_signal_connect_closure_by_id, 5, 0, 0, H_g_signal_connect_closure_by_id);
  XG_DEFINE_PROCEDURE(g_signal_connect_closure, gxg_g_signal_connect_closure, 4, 0, 0, H_g_signal_connect_closure);
  XG_DEFINE_PROCEDURE(g_signal_connect_data, gxg_g_signal_connect_data, 6, 0, 0, H_g_signal_connect_data);
  XG_DEFINE_PROCEDURE(g_signal_handler_block, gxg_g_signal_handler_block, 2, 0, 0, H_g_signal_handler_block);
  XG_DEFINE_PROCEDURE(g_signal_handler_unblock, gxg_g_signal_handler_unblock, 2, 0, 0, H_g_signal_handler_unblock);
  XG_DEFINE_PROCEDURE(g_signal_handler_disconnect, gxg_g_signal_handler_disconnect, 2, 0, 0, H_g_signal_handler_disconnect);
  XG_DEFINE_PROCEDURE(g_signal_handler_is_connected, gxg_g_signal_handler_is_connected, 2, 0, 0, H_g_signal_handler_is_connected);
  XG_DEFINE_PROCEDURE(g_signal_handler_find, gxg_g_signal_handler_find, 7, 0, 0, H_g_signal_handler_find);
  XG_DEFINE_PROCEDURE(g_signal_handlers_block_matched, gxg_g_signal_handlers_block_matched, 7, 0, 0, H_g_signal_handlers_block_matched);
  XG_DEFINE_PROCEDURE(g_signal_handlers_unblock_matched, gxg_g_signal_handlers_unblock_matched, 7, 0, 0, H_g_signal_handlers_unblock_matched);
  XG_DEFINE_PROCEDURE(g_signal_handlers_disconnect_matched, gxg_g_signal_handlers_disconnect_matched, 7, 0, 0, H_g_signal_handlers_disconnect_matched);
  XG_DEFINE_PROCEDURE(g_signal_handlers_destroy, gxg_g_signal_handlers_destroy, 1, 0, 0, H_g_signal_handlers_destroy);
  XG_DEFINE_PROCEDURE(g_object_ref, gxg_g_object_ref, 1, 0, 0, H_g_object_ref);
  XG_DEFINE_PROCEDURE(g_object_unref, gxg_g_object_unref, 1, 0, 0, H_g_object_unref);
  XG_DEFINE_PROCEDURE(gdk_colormap_get_type, gxg_gdk_colormap_get_type, 0, 0, 0, H_gdk_colormap_get_type);
  XG_DEFINE_PROCEDURE(gdk_colormap_new, gxg_gdk_colormap_new, 2, 0, 0, H_gdk_colormap_new);
  XG_DEFINE_PROCEDURE(gdk_colormap_get_system, gxg_gdk_colormap_get_system, 0, 0, 0, H_gdk_colormap_get_system);
  XG_DEFINE_PROCEDURE(gdk_colormap_alloc_colors, gxg_gdk_colormap_alloc_colors, 6, 0, 0, H_gdk_colormap_alloc_colors);
  XG_DEFINE_PROCEDURE(gdk_colormap_alloc_color, gxg_gdk_colormap_alloc_color, 4, 0, 0, H_gdk_colormap_alloc_color);
  XG_DEFINE_PROCEDURE(gdk_colormap_query_color, gxg_gdk_colormap_query_color, 3, 0, 0, H_gdk_colormap_query_color);
  XG_DEFINE_PROCEDURE(gdk_colormap_get_visual, gxg_gdk_colormap_get_visual, 1, 0, 0, H_gdk_colormap_get_visual);
  XG_DEFINE_PROCEDURE(gdk_color_copy, gxg_gdk_color_copy, 1, 0, 0, H_gdk_color_copy);
  XG_DEFINE_PROCEDURE(gdk_color_free, gxg_gdk_color_free, 1, 0, 0, H_gdk_color_free);
  XG_DEFINE_PROCEDURE(gdk_color_parse, gxg_gdk_color_parse, 2, 0, 0, H_gdk_color_parse);
  XG_DEFINE_PROCEDURE(gdk_color_hash, gxg_gdk_color_hash, 1, 0, 0, H_gdk_color_hash);
  XG_DEFINE_PROCEDURE(gdk_color_equal, gxg_gdk_color_equal, 2, 0, 0, H_gdk_color_equal);
  XG_DEFINE_PROCEDURE(gdk_color_get_type, gxg_gdk_color_get_type, 0, 0, 0, H_gdk_color_get_type);
  XG_DEFINE_PROCEDURE(gdk_cursor_get_type, gxg_gdk_cursor_get_type, 0, 0, 0, H_gdk_cursor_get_type);
  XG_DEFINE_PROCEDURE(gdk_cursor_new, gxg_gdk_cursor_new, 1, 0, 0, H_gdk_cursor_new);
  XG_DEFINE_PROCEDURE(gdk_cursor_new_from_pixmap, gxg_gdk_cursor_new_from_pixmap, 6, 0, 0, H_gdk_cursor_new_from_pixmap);
  XG_DEFINE_PROCEDURE(gdk_cursor_ref, gxg_gdk_cursor_ref, 1, 0, 0, H_gdk_cursor_ref);
  XG_DEFINE_PROCEDURE(gdk_cursor_unref, gxg_gdk_cursor_unref, 1, 0, 0, H_gdk_cursor_unref);
  XG_DEFINE_PROCEDURE(gdk_drag_context_get_type, gxg_gdk_drag_context_get_type, 0, 0, 0, H_gdk_drag_context_get_type);
  XG_DEFINE_PROCEDURE(gdk_drag_context_new, gxg_gdk_drag_context_new, 0, 0, 0, H_gdk_drag_context_new);
  XG_DEFINE_PROCEDURE(gdk_drag_status, gxg_gdk_drag_status, 3, 0, 0, H_gdk_drag_status);
  XG_DEFINE_PROCEDURE(gdk_drop_reply, gxg_gdk_drop_reply, 3, 0, 0, H_gdk_drop_reply);
  XG_DEFINE_PROCEDURE(gdk_drop_finish, gxg_gdk_drop_finish, 3, 0, 0, H_gdk_drop_finish);
  XG_DEFINE_PROCEDURE(gdk_drag_get_selection, gxg_gdk_drag_get_selection, 1, 0, 0, H_gdk_drag_get_selection);
  XG_DEFINE_PROCEDURE(gdk_drag_begin, gxg_gdk_drag_begin, 2, 0, 0, H_gdk_drag_begin);
  XG_DEFINE_PROCEDURE(gdk_drag_get_protocol, gxg_gdk_drag_get_protocol, 1, 1, 0, H_gdk_drag_get_protocol);
  XG_DEFINE_PROCEDURE(gdk_drag_find_window, gxg_gdk_drag_find_window, 4, 2, 0, H_gdk_drag_find_window);
  XG_DEFINE_PROCEDURE(gdk_drag_motion, gxg_gdk_drag_motion, 8, 0, 0, H_gdk_drag_motion);
  XG_DEFINE_PROCEDURE(gdk_drag_drop, gxg_gdk_drag_drop, 2, 0, 0, H_gdk_drag_drop);
  XG_DEFINE_PROCEDURE(gdk_drag_abort, gxg_gdk_drag_abort, 2, 0, 0, H_gdk_drag_abort);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_type, gxg_gdk_drawable_get_type, 0, 0, 0, H_gdk_drawable_get_type);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_size, gxg_gdk_drawable_get_size, 1, 2, 0, H_gdk_drawable_get_size);
  XG_DEFINE_PROCEDURE(gdk_drawable_set_colormap, gxg_gdk_drawable_set_colormap, 2, 0, 0, H_gdk_drawable_set_colormap);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_colormap, gxg_gdk_drawable_get_colormap, 1, 0, 0, H_gdk_drawable_get_colormap);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_visual, gxg_gdk_drawable_get_visual, 1, 0, 0, H_gdk_drawable_get_visual);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_depth, gxg_gdk_drawable_get_depth, 1, 0, 0, H_gdk_drawable_get_depth);
  XG_DEFINE_PROCEDURE(gdk_draw_point, gxg_gdk_draw_point, 4, 0, 0, H_gdk_draw_point);
  XG_DEFINE_PROCEDURE(gdk_draw_line, gxg_gdk_draw_line, 6, 0, 0, H_gdk_draw_line);
  XG_DEFINE_PROCEDURE(gdk_draw_rectangle, gxg_gdk_draw_rectangle, 7, 0, 0, H_gdk_draw_rectangle);
  XG_DEFINE_PROCEDURE(gdk_draw_arc, gxg_gdk_draw_arc, 9, 0, 0, H_gdk_draw_arc);
  XG_DEFINE_PROCEDURE(gdk_draw_polygon, gxg_gdk_draw_polygon, 5, 0, 0, H_gdk_draw_polygon);
  XG_DEFINE_PROCEDURE(gdk_draw_drawable, gxg_gdk_draw_drawable, 9, 0, 0, H_gdk_draw_drawable);
  XG_DEFINE_PROCEDURE(gdk_draw_image, gxg_gdk_draw_image, 9, 0, 0, H_gdk_draw_image);
  XG_DEFINE_PROCEDURE(gdk_draw_points, gxg_gdk_draw_points, 4, 0, 0, H_gdk_draw_points);
  XG_DEFINE_PROCEDURE(gdk_draw_segments, gxg_gdk_draw_segments, 4, 0, 0, H_gdk_draw_segments);
  XG_DEFINE_PROCEDURE(gdk_draw_lines, gxg_gdk_draw_lines, 4, 0, 0, H_gdk_draw_lines);
  XG_DEFINE_PROCEDURE(gdk_draw_glyphs, gxg_gdk_draw_glyphs, 6, 0, 0, H_gdk_draw_glyphs);
  XG_DEFINE_PROCEDURE(gdk_draw_layout_line, gxg_gdk_draw_layout_line, 5, 0, 0, H_gdk_draw_layout_line);
  XG_DEFINE_PROCEDURE(gdk_draw_layout, gxg_gdk_draw_layout, 5, 0, 0, H_gdk_draw_layout);
  XG_DEFINE_PROCEDURE(gdk_draw_layout_line_with_colors, gxg_gdk_draw_layout_line_with_colors, 7, 0, 0, H_gdk_draw_layout_line_with_colors);
  XG_DEFINE_PROCEDURE(gdk_draw_layout_with_colors, gxg_gdk_draw_layout_with_colors, 7, 0, 0, H_gdk_draw_layout_with_colors);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_image, gxg_gdk_drawable_get_image, 5, 0, 0, H_gdk_drawable_get_image);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_clip_region, gxg_gdk_drawable_get_clip_region, 1, 0, 0, H_gdk_drawable_get_clip_region);
  XG_DEFINE_PROCEDURE(gdk_drawable_get_visible_region, gxg_gdk_drawable_get_visible_region, 1, 0, 0, H_gdk_drawable_get_visible_region);
  XG_DEFINE_PROCEDURE(gdk_cursor_type_get_type, gxg_gdk_cursor_type_get_type, 0, 0, 0, H_gdk_cursor_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_drag_action_get_type, gxg_gdk_drag_action_get_type, 0, 0, 0, H_gdk_drag_action_get_type);
  XG_DEFINE_PROCEDURE(gdk_drag_protocol_get_type, gxg_gdk_drag_protocol_get_type, 0, 0, 0, H_gdk_drag_protocol_get_type);
  XG_DEFINE_PROCEDURE(gdk_filter_return_get_type, gxg_gdk_filter_return_get_type, 0, 0, 0, H_gdk_filter_return_get_type);
  XG_DEFINE_PROCEDURE(gdk_event_type_get_type, gxg_gdk_event_type_get_type, 0, 0, 0, H_gdk_event_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_event_mask_get_type, gxg_gdk_event_mask_get_type, 0, 0, 0, H_gdk_event_mask_get_type);
  XG_DEFINE_PROCEDURE(gdk_visibility_state_get_type, gxg_gdk_visibility_state_get_type, 0, 0, 0, H_gdk_visibility_state_get_type);
  XG_DEFINE_PROCEDURE(gdk_scroll_direction_get_type, gxg_gdk_scroll_direction_get_type, 0, 0, 0, H_gdk_scroll_direction_get_type);
  XG_DEFINE_PROCEDURE(gdk_notify_type_get_type, gxg_gdk_notify_type_get_type, 0, 0, 0, H_gdk_notify_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_crossing_mode_get_type, gxg_gdk_crossing_mode_get_type, 0, 0, 0, H_gdk_crossing_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_property_state_get_type, gxg_gdk_property_state_get_type, 0, 0, 0, H_gdk_property_state_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_state_get_type, gxg_gdk_window_state_get_type, 0, 0, 0, H_gdk_window_state_get_type);
  XG_DEFINE_PROCEDURE(gdk_setting_action_get_type, gxg_gdk_setting_action_get_type, 0, 0, 0, H_gdk_setting_action_get_type);
  XG_DEFINE_PROCEDURE(gdk_font_type_get_type, gxg_gdk_font_type_get_type, 0, 0, 0, H_gdk_font_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_cap_style_get_type, gxg_gdk_cap_style_get_type, 0, 0, 0, H_gdk_cap_style_get_type);
  XG_DEFINE_PROCEDURE(gdk_fill_get_type, gxg_gdk_fill_get_type, 0, 0, 0, H_gdk_fill_get_type);
  XG_DEFINE_PROCEDURE(gdk_function_get_type, gxg_gdk_function_get_type, 0, 0, 0, H_gdk_function_get_type);
  XG_DEFINE_PROCEDURE(gdk_join_style_get_type, gxg_gdk_join_style_get_type, 0, 0, 0, H_gdk_join_style_get_type);
  XG_DEFINE_PROCEDURE(gdk_line_style_get_type, gxg_gdk_line_style_get_type, 0, 0, 0, H_gdk_line_style_get_type);
  XG_DEFINE_PROCEDURE(gdk_subwindow_mode_get_type, gxg_gdk_subwindow_mode_get_type, 0, 0, 0, H_gdk_subwindow_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_gc_values_mask_get_type, gxg_gdk_gc_values_mask_get_type, 0, 0, 0, H_gdk_gc_values_mask_get_type);
  XG_DEFINE_PROCEDURE(gdk_image_type_get_type, gxg_gdk_image_type_get_type, 0, 0, 0, H_gdk_image_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_extension_mode_get_type, gxg_gdk_extension_mode_get_type, 0, 0, 0, H_gdk_extension_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_input_source_get_type, gxg_gdk_input_source_get_type, 0, 0, 0, H_gdk_input_source_get_type);
  XG_DEFINE_PROCEDURE(gdk_input_mode_get_type, gxg_gdk_input_mode_get_type, 0, 0, 0, H_gdk_input_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_axis_use_get_type, gxg_gdk_axis_use_get_type, 0, 0, 0, H_gdk_axis_use_get_type);
  XG_DEFINE_PROCEDURE(gdk_prop_mode_get_type, gxg_gdk_prop_mode_get_type, 0, 0, 0, H_gdk_prop_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_fill_rule_get_type, gxg_gdk_fill_rule_get_type, 0, 0, 0, H_gdk_fill_rule_get_type);
  XG_DEFINE_PROCEDURE(gdk_overlap_type_get_type, gxg_gdk_overlap_type_get_type, 0, 0, 0, H_gdk_overlap_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_rgb_dither_get_type, gxg_gdk_rgb_dither_get_type, 0, 0, 0, H_gdk_rgb_dither_get_type);
  XG_DEFINE_PROCEDURE(gdk_byte_order_get_type, gxg_gdk_byte_order_get_type, 0, 0, 0, H_gdk_byte_order_get_type);
  XG_DEFINE_PROCEDURE(gdk_modifier_type_get_type, gxg_gdk_modifier_type_get_type, 0, 0, 0, H_gdk_modifier_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_input_condition_get_type, gxg_gdk_input_condition_get_type, 0, 0, 0, H_gdk_input_condition_get_type);
  XG_DEFINE_PROCEDURE(gdk_status_get_type, gxg_gdk_status_get_type, 0, 0, 0, H_gdk_status_get_type);
  XG_DEFINE_PROCEDURE(gdk_grab_status_get_type, gxg_gdk_grab_status_get_type, 0, 0, 0, H_gdk_grab_status_get_type);
  XG_DEFINE_PROCEDURE(gdk_visual_type_get_type, gxg_gdk_visual_type_get_type, 0, 0, 0, H_gdk_visual_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_class_get_type, gxg_gdk_window_class_get_type, 0, 0, 0, H_gdk_window_class_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_type_get_type, gxg_gdk_window_type_get_type, 0, 0, 0, H_gdk_window_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_attributes_type_get_type, gxg_gdk_window_attributes_type_get_type, 0, 0, 0, H_gdk_window_attributes_type_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_hints_get_type, gxg_gdk_window_hints_get_type, 0, 0, 0, H_gdk_window_hints_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_type_hint_get_type, gxg_gdk_window_type_hint_get_type, 0, 0, 0, H_gdk_window_type_hint_get_type);
  XG_DEFINE_PROCEDURE(gdk_wm_decoration_get_type, gxg_gdk_wm_decoration_get_type, 0, 0, 0, H_gdk_wm_decoration_get_type);
  XG_DEFINE_PROCEDURE(gdk_wm_function_get_type, gxg_gdk_wm_function_get_type, 0, 0, 0, H_gdk_wm_function_get_type);
  XG_DEFINE_PROCEDURE(gdk_gravity_get_type, gxg_gdk_gravity_get_type, 0, 0, 0, H_gdk_gravity_get_type);
  XG_DEFINE_PROCEDURE(gdk_window_edge_get_type, gxg_gdk_window_edge_get_type, 0, 0, 0, H_gdk_window_edge_get_type);
  XG_DEFINE_PROCEDURE(gdk_event_get_type, gxg_gdk_event_get_type, 0, 0, 0, H_gdk_event_get_type);
  XG_DEFINE_PROCEDURE(gdk_events_pending, gxg_gdk_events_pending, 0, 0, 0, H_gdk_events_pending);
  XG_DEFINE_PROCEDURE(gdk_event_get, gxg_gdk_event_get, 0, 0, 0, H_gdk_event_get);
  XG_DEFINE_PROCEDURE(gdk_event_peek, gxg_gdk_event_peek, 0, 0, 0, H_gdk_event_peek);
  XG_DEFINE_PROCEDURE(gdk_event_get_graphics_expose, gxg_gdk_event_get_graphics_expose, 1, 0, 0, H_gdk_event_get_graphics_expose);
  XG_DEFINE_PROCEDURE(gdk_event_put, gxg_gdk_event_put, 1, 0, 0, H_gdk_event_put);
  XG_DEFINE_PROCEDURE(gdk_event_copy, gxg_gdk_event_copy, 1, 0, 0, H_gdk_event_copy);
  XG_DEFINE_PROCEDURE(gdk_event_free, gxg_gdk_event_free, 1, 0, 0, H_gdk_event_free);
  XG_DEFINE_PROCEDURE(gdk_event_get_time, gxg_gdk_event_get_time, 1, 0, 0, H_gdk_event_get_time);
  XG_DEFINE_PROCEDURE(gdk_event_get_state, gxg_gdk_event_get_state, 1, 1, 0, H_gdk_event_get_state);
  XG_DEFINE_PROCEDURE(gdk_event_get_coords, gxg_gdk_event_get_coords, 1, 2, 0, H_gdk_event_get_coords);
  XG_DEFINE_PROCEDURE(gdk_event_get_root_coords, gxg_gdk_event_get_root_coords, 1, 2, 0, H_gdk_event_get_root_coords);
  XG_DEFINE_PROCEDURE(gdk_event_get_axis, gxg_gdk_event_get_axis, 2, 1, 0, H_gdk_event_get_axis);
  XG_DEFINE_PROCEDURE(gdk_event_handler_set, gxg_gdk_event_handler_set, 3, 0, 0, H_gdk_event_handler_set);
  XG_DEFINE_PROCEDURE(gdk_set_show_events, gxg_gdk_set_show_events, 1, 0, 0, H_gdk_set_show_events);
  XG_DEFINE_PROCEDURE(gdk_get_show_events, gxg_gdk_get_show_events, 0, 0, 0, H_gdk_get_show_events);
  XG_DEFINE_PROCEDURE(gdk_add_client_message_filter, gxg_gdk_add_client_message_filter, 2, 1, 0, H_gdk_add_client_message_filter);
  XG_DEFINE_PROCEDURE(gdk_gc_get_type, gxg_gdk_gc_get_type, 0, 0, 0, H_gdk_gc_get_type);
  XG_DEFINE_PROCEDURE(gdk_gc_new, gxg_gdk_gc_new, 1, 0, 0, H_gdk_gc_new);
  XG_DEFINE_PROCEDURE(gdk_gc_new_with_values, gxg_gdk_gc_new_with_values, 3, 0, 0, H_gdk_gc_new_with_values);
  XG_DEFINE_PROCEDURE(gdk_gc_get_values, gxg_gdk_gc_get_values, 2, 0, 0, H_gdk_gc_get_values);
  XG_DEFINE_PROCEDURE(gdk_gc_set_values, gxg_gdk_gc_set_values, 3, 0, 0, H_gdk_gc_set_values);
  XG_DEFINE_PROCEDURE(gdk_gc_set_foreground, gxg_gdk_gc_set_foreground, 2, 0, 0, H_gdk_gc_set_foreground);
  XG_DEFINE_PROCEDURE(gdk_gc_set_background, gxg_gdk_gc_set_background, 2, 0, 0, H_gdk_gc_set_background);
  XG_DEFINE_PROCEDURE(gdk_gc_set_function, gxg_gdk_gc_set_function, 2, 0, 0, H_gdk_gc_set_function);
  XG_DEFINE_PROCEDURE(gdk_gc_set_fill, gxg_gdk_gc_set_fill, 2, 0, 0, H_gdk_gc_set_fill);
  XG_DEFINE_PROCEDURE(gdk_gc_set_tile, gxg_gdk_gc_set_tile, 2, 0, 0, H_gdk_gc_set_tile);
  XG_DEFINE_PROCEDURE(gdk_gc_set_stipple, gxg_gdk_gc_set_stipple, 2, 0, 0, H_gdk_gc_set_stipple);
  XG_DEFINE_PROCEDURE(gdk_gc_set_ts_origin, gxg_gdk_gc_set_ts_origin, 3, 0, 0, H_gdk_gc_set_ts_origin);
  XG_DEFINE_PROCEDURE(gdk_gc_set_clip_origin, gxg_gdk_gc_set_clip_origin, 3, 0, 0, H_gdk_gc_set_clip_origin);
  XG_DEFINE_PROCEDURE(gdk_gc_set_clip_mask, gxg_gdk_gc_set_clip_mask, 2, 0, 0, H_gdk_gc_set_clip_mask);
  XG_DEFINE_PROCEDURE(gdk_gc_set_clip_rectangle, gxg_gdk_gc_set_clip_rectangle, 2, 0, 0, H_gdk_gc_set_clip_rectangle);
  XG_DEFINE_PROCEDURE(gdk_gc_set_clip_region, gxg_gdk_gc_set_clip_region, 2, 0, 0, H_gdk_gc_set_clip_region);
  XG_DEFINE_PROCEDURE(gdk_gc_set_subwindow, gxg_gdk_gc_set_subwindow, 2, 0, 0, H_gdk_gc_set_subwindow);
  XG_DEFINE_PROCEDURE(gdk_gc_set_exposures, gxg_gdk_gc_set_exposures, 2, 0, 0, H_gdk_gc_set_exposures);
  XG_DEFINE_PROCEDURE(gdk_gc_set_line_attributes, gxg_gdk_gc_set_line_attributes, 5, 0, 0, H_gdk_gc_set_line_attributes);
  XG_DEFINE_PROCEDURE(gdk_gc_set_dashes, gxg_gdk_gc_set_dashes, 4, 0, 0, H_gdk_gc_set_dashes);
  XG_DEFINE_PROCEDURE(gdk_gc_offset, gxg_gdk_gc_offset, 3, 0, 0, H_gdk_gc_offset);
  XG_DEFINE_PROCEDURE(gdk_gc_copy, gxg_gdk_gc_copy, 2, 0, 0, H_gdk_gc_copy);
  XG_DEFINE_PROCEDURE(gdk_gc_set_colormap, gxg_gdk_gc_set_colormap, 2, 0, 0, H_gdk_gc_set_colormap);
  XG_DEFINE_PROCEDURE(gdk_gc_get_colormap, gxg_gdk_gc_get_colormap, 1, 0, 0, H_gdk_gc_get_colormap);
  XG_DEFINE_PROCEDURE(gdk_gc_set_rgb_fg_color, gxg_gdk_gc_set_rgb_fg_color, 2, 0, 0, H_gdk_gc_set_rgb_fg_color);
  XG_DEFINE_PROCEDURE(gdk_gc_set_rgb_bg_color, gxg_gdk_gc_set_rgb_bg_color, 2, 0, 0, H_gdk_gc_set_rgb_bg_color);
  XG_DEFINE_PROCEDURE(gdk_init, gxg_gdk_init, 0, 2, 0, H_gdk_init);
  XG_DEFINE_PROCEDURE(gdk_init_check, gxg_gdk_init_check, 0, 2, 0, H_gdk_init_check);
  XG_DEFINE_PROCEDURE(gdk_set_locale, gxg_gdk_set_locale, 0, 0, 0, H_gdk_set_locale);
  XG_DEFINE_PROCEDURE(gdk_get_program_class, gxg_gdk_get_program_class, 0, 0, 0, H_gdk_get_program_class);
  XG_DEFINE_PROCEDURE(gdk_set_program_class, gxg_gdk_set_program_class, 1, 0, 0, H_gdk_set_program_class);
  XG_DEFINE_PROCEDURE(gdk_error_trap_push, gxg_gdk_error_trap_push, 0, 0, 0, H_gdk_error_trap_push);
  XG_DEFINE_PROCEDURE(gdk_error_trap_pop, gxg_gdk_error_trap_pop, 0, 0, 0, H_gdk_error_trap_pop);
  XG_DEFINE_PROCEDURE(gdk_get_display, gxg_gdk_get_display, 0, 0, 0, H_gdk_get_display);
  XG_DEFINE_PROCEDURE(gdk_pointer_grab, gxg_gdk_pointer_grab, 6, 0, 0, H_gdk_pointer_grab);
  XG_DEFINE_PROCEDURE(gdk_pointer_ungrab, gxg_gdk_pointer_ungrab, 1, 0, 0, H_gdk_pointer_ungrab);
  XG_DEFINE_PROCEDURE(gdk_keyboard_grab, gxg_gdk_keyboard_grab, 3, 0, 0, H_gdk_keyboard_grab);
  XG_DEFINE_PROCEDURE(gdk_keyboard_ungrab, gxg_gdk_keyboard_ungrab, 1, 0, 0, H_gdk_keyboard_ungrab);
  XG_DEFINE_PROCEDURE(gdk_pointer_is_grabbed, gxg_gdk_pointer_is_grabbed, 0, 0, 0, H_gdk_pointer_is_grabbed);
  XG_DEFINE_PROCEDURE(gdk_screen_width, gxg_gdk_screen_width, 0, 0, 0, H_gdk_screen_width);
  XG_DEFINE_PROCEDURE(gdk_screen_height, gxg_gdk_screen_height, 0, 0, 0, H_gdk_screen_height);
  XG_DEFINE_PROCEDURE(gdk_screen_width_mm, gxg_gdk_screen_width_mm, 0, 0, 0, H_gdk_screen_width_mm);
  XG_DEFINE_PROCEDURE(gdk_screen_height_mm, gxg_gdk_screen_height_mm, 0, 0, 0, H_gdk_screen_height_mm);
  XG_DEFINE_PROCEDURE(gdk_flush, gxg_gdk_flush, 0, 0, 0, H_gdk_flush);
  XG_DEFINE_PROCEDURE(gdk_beep, gxg_gdk_beep, 0, 0, 0, H_gdk_beep);
  XG_DEFINE_PROCEDURE(gdk_set_double_click_time, gxg_gdk_set_double_click_time, 1, 0, 0, H_gdk_set_double_click_time);
  XG_DEFINE_PROCEDURE(gdk_rectangle_intersect, gxg_gdk_rectangle_intersect, 3, 0, 0, H_gdk_rectangle_intersect);
  XG_DEFINE_PROCEDURE(gdk_rectangle_union, gxg_gdk_rectangle_union, 3, 0, 0, H_gdk_rectangle_union);
  XG_DEFINE_PROCEDURE(gdk_rectangle_get_type, gxg_gdk_rectangle_get_type, 0, 0, 0, H_gdk_rectangle_get_type);
  XG_DEFINE_PROCEDURE(gdk_event_send_clientmessage_toall, gxg_gdk_event_send_clientmessage_toall, 1, 0, 0, H_gdk_event_send_clientmessage_toall);
  XG_DEFINE_PROCEDURE(gdk_event_send_client_message, gxg_gdk_event_send_client_message, 2, 0, 0, H_gdk_event_send_client_message);
  XG_DEFINE_PROCEDURE(gdk_threads_enter, gxg_gdk_threads_enter, 0, 0, 0, H_gdk_threads_enter);
  XG_DEFINE_PROCEDURE(gdk_threads_leave, gxg_gdk_threads_leave, 0, 0, 0, H_gdk_threads_leave);
  XG_DEFINE_PROCEDURE(gdk_threads_init, gxg_gdk_threads_init, 0, 0, 0, H_gdk_threads_init);
  XG_DEFINE_PROCEDURE(gdk_image_get_type, gxg_gdk_image_get_type, 0, 0, 0, H_gdk_image_get_type);
  XG_DEFINE_PROCEDURE(gdk_image_new, gxg_gdk_image_new, 4, 0, 0, H_gdk_image_new);
  XG_DEFINE_PROCEDURE(gdk_device_get_type, gxg_gdk_device_get_type, 0, 0, 0, H_gdk_device_get_type);
  XG_DEFINE_PROCEDURE(gdk_devices_list, gxg_gdk_devices_list, 0, 0, 0, H_gdk_devices_list);
  XG_DEFINE_PROCEDURE(gdk_device_set_source, gxg_gdk_device_set_source, 2, 0, 0, H_gdk_device_set_source);
  XG_DEFINE_PROCEDURE(gdk_device_set_mode, gxg_gdk_device_set_mode, 2, 0, 0, H_gdk_device_set_mode);
  XG_DEFINE_PROCEDURE(gdk_device_set_key, gxg_gdk_device_set_key, 4, 0, 0, H_gdk_device_set_key);
  XG_DEFINE_PROCEDURE(gdk_device_set_axis_use, gxg_gdk_device_set_axis_use, 3, 0, 0, H_gdk_device_set_axis_use);
  XG_DEFINE_PROCEDURE(gdk_device_get_state, gxg_gdk_device_get_state, 3, 1, 0, H_gdk_device_get_state);
  XG_DEFINE_PROCEDURE(gdk_device_get_history, gxg_gdk_device_get_history, 4, 2, 0, H_gdk_device_get_history);
  XG_DEFINE_PROCEDURE(gdk_device_free_history, gxg_gdk_device_free_history, 2, 0, 0, H_gdk_device_free_history);
  XG_DEFINE_PROCEDURE(gdk_device_get_axis, gxg_gdk_device_get_axis, 4, 0, 0, H_gdk_device_get_axis);
  XG_DEFINE_PROCEDURE(gdk_input_set_extension_events, gxg_gdk_input_set_extension_events, 3, 0, 0, H_gdk_input_set_extension_events);
  XG_DEFINE_PROCEDURE(gdk_device_get_core_pointer, gxg_gdk_device_get_core_pointer, 0, 0, 0, H_gdk_device_get_core_pointer);
  XG_DEFINE_PROCEDURE(gdk_keymap_get_type, gxg_gdk_keymap_get_type, 0, 0, 0, H_gdk_keymap_get_type);
  XG_DEFINE_PROCEDURE(gdk_keymap_get_default, gxg_gdk_keymap_get_default, 0, 0, 0, H_gdk_keymap_get_default);
  XG_DEFINE_PROCEDURE(gdk_keymap_lookup_key, gxg_gdk_keymap_lookup_key, 2, 0, 0, H_gdk_keymap_lookup_key);
  XG_DEFINE_PROCEDURE(gdk_keymap_get_entries_for_keyval, gxg_gdk_keymap_get_entries_for_keyval, 2, 2, 0, H_gdk_keymap_get_entries_for_keyval);
  XG_DEFINE_PROCEDURE(gdk_keymap_get_entries_for_keycode, gxg_gdk_keymap_get_entries_for_keycode, 2, 3, 0, H_gdk_keymap_get_entries_for_keycode);
  XG_DEFINE_PROCEDURE(gdk_keymap_get_direction, gxg_gdk_keymap_get_direction, 1, 0, 0, H_gdk_keymap_get_direction);
  XG_DEFINE_PROCEDURE(gdk_keyval_name, gxg_gdk_keyval_name, 1, 0, 0, H_gdk_keyval_name);
  XG_DEFINE_PROCEDURE(gdk_keyval_from_name, gxg_gdk_keyval_from_name, 1, 0, 0, H_gdk_keyval_from_name);
  XG_DEFINE_PROCEDURE(gdk_keyval_convert_case, gxg_gdk_keyval_convert_case, 1, 2, 0, H_gdk_keyval_convert_case);
  XG_DEFINE_PROCEDURE(gdk_keyval_to_upper, gxg_gdk_keyval_to_upper, 1, 0, 0, H_gdk_keyval_to_upper);
  XG_DEFINE_PROCEDURE(gdk_keyval_to_lower, gxg_gdk_keyval_to_lower, 1, 0, 0, H_gdk_keyval_to_lower);
  XG_DEFINE_PROCEDURE(gdk_keyval_is_upper, gxg_gdk_keyval_is_upper, 1, 0, 0, H_gdk_keyval_is_upper);
  XG_DEFINE_PROCEDURE(gdk_keyval_is_lower, gxg_gdk_keyval_is_lower, 1, 0, 0, H_gdk_keyval_is_lower);
  XG_DEFINE_PROCEDURE(gdk_keyval_to_unicode, gxg_gdk_keyval_to_unicode, 1, 0, 0, H_gdk_keyval_to_unicode);
  XG_DEFINE_PROCEDURE(gdk_unicode_to_keyval, gxg_gdk_unicode_to_keyval, 1, 0, 0, H_gdk_unicode_to_keyval);
  XG_DEFINE_PROCEDURE(gdk_pango_context_get, gxg_gdk_pango_context_get, 0, 0, 0, H_gdk_pango_context_get);
  XG_DEFINE_PROCEDURE(gdk_pango_layout_line_get_clip_region, gxg_gdk_pango_layout_line_get_clip_region, 5, 0, 0, H_gdk_pango_layout_line_get_clip_region);
  XG_DEFINE_PROCEDURE(gdk_pango_layout_get_clip_region, gxg_gdk_pango_layout_get_clip_region, 5, 0, 0, H_gdk_pango_layout_get_clip_region);
  XG_DEFINE_PROCEDURE(gdk_pango_attr_stipple_new, gxg_gdk_pango_attr_stipple_new, 1, 0, 0, H_gdk_pango_attr_stipple_new);
  XG_DEFINE_PROCEDURE(gdk_pango_attr_embossed_new, gxg_gdk_pango_attr_embossed_new, 1, 0, 0, H_gdk_pango_attr_embossed_new);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_render_threshold_alpha, gxg_gdk_pixbuf_render_threshold_alpha, 9, 0, 0, H_gdk_pixbuf_render_threshold_alpha);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_render_pixmap_and_mask_for_colormap, gxg_gdk_pixbuf_render_pixmap_and_mask_for_colormap, 3, 2, 0, H_gdk_pixbuf_render_pixmap_and_mask_for_colormap);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_render_pixmap_and_mask, gxg_gdk_pixbuf_render_pixmap_and_mask, 2, 2, 0, H_gdk_pixbuf_render_pixmap_and_mask);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_from_drawable, gxg_gdk_pixbuf_get_from_drawable, 9, 0, 0, H_gdk_pixbuf_get_from_drawable);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_from_image, gxg_gdk_pixbuf_get_from_image, 9, 0, 0, H_gdk_pixbuf_get_from_image);
  XG_DEFINE_PROCEDURE(gdk_pixmap_get_type, gxg_gdk_pixmap_get_type, 0, 0, 0, H_gdk_pixmap_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixmap_foreign_new, gxg_gdk_pixmap_foreign_new, 1, 0, 0, H_gdk_pixmap_foreign_new);
  XG_DEFINE_PROCEDURE(gdk_pixmap_lookup, gxg_gdk_pixmap_lookup, 1, 0, 0, H_gdk_pixmap_lookup);
  XG_DEFINE_PROCEDURE(gdk_atom_intern, gxg_gdk_atom_intern, 2, 0, 0, H_gdk_atom_intern);
  XG_DEFINE_PROCEDURE(gdk_atom_name, gxg_gdk_atom_name, 1, 0, 0, H_gdk_atom_name);
  XG_DEFINE_PROCEDURE(gdk_property_get, gxg_gdk_property_get, 0, 0, 1, H_gdk_property_get);
  XG_DEFINE_PROCEDURE(gdk_property_change, gxg_gdk_property_change, 7, 0, 0, H_gdk_property_change);
  XG_DEFINE_PROCEDURE(gdk_property_delete, gxg_gdk_property_delete, 2, 0, 0, H_gdk_property_delete);
  XG_DEFINE_PROCEDURE(gdk_utf8_to_string_target, gxg_gdk_utf8_to_string_target, 1, 0, 0, H_gdk_utf8_to_string_target);
  XG_DEFINE_PROCEDURE(gdk_region_new, gxg_gdk_region_new, 0, 0, 0, H_gdk_region_new);
  XG_DEFINE_PROCEDURE(gdk_region_polygon, gxg_gdk_region_polygon, 3, 0, 0, H_gdk_region_polygon);
  XG_DEFINE_PROCEDURE(gdk_region_copy, gxg_gdk_region_copy, 1, 0, 0, H_gdk_region_copy);
  XG_DEFINE_PROCEDURE(gdk_region_rectangle, gxg_gdk_region_rectangle, 1, 0, 0, H_gdk_region_rectangle);
  XG_DEFINE_PROCEDURE(gdk_region_destroy, gxg_gdk_region_destroy, 1, 0, 0, H_gdk_region_destroy);
  XG_DEFINE_PROCEDURE(gdk_region_get_clipbox, gxg_gdk_region_get_clipbox, 2, 0, 0, H_gdk_region_get_clipbox);
  XG_DEFINE_PROCEDURE(gdk_region_get_rectangles, gxg_gdk_region_get_rectangles, 1, 2, 0, H_gdk_region_get_rectangles);
  XG_DEFINE_PROCEDURE(gdk_region_empty, gxg_gdk_region_empty, 1, 0, 0, H_gdk_region_empty);
  XG_DEFINE_PROCEDURE(gdk_region_equal, gxg_gdk_region_equal, 2, 0, 0, H_gdk_region_equal);
  XG_DEFINE_PROCEDURE(gdk_region_point_in, gxg_gdk_region_point_in, 3, 0, 0, H_gdk_region_point_in);
  XG_DEFINE_PROCEDURE(gdk_region_rect_in, gxg_gdk_region_rect_in, 2, 0, 0, H_gdk_region_rect_in);
  XG_DEFINE_PROCEDURE(gdk_region_offset, gxg_gdk_region_offset, 3, 0, 0, H_gdk_region_offset);
  XG_DEFINE_PROCEDURE(gdk_region_shrink, gxg_gdk_region_shrink, 3, 0, 0, H_gdk_region_shrink);
  XG_DEFINE_PROCEDURE(gdk_region_union_with_rect, gxg_gdk_region_union_with_rect, 2, 0, 0, H_gdk_region_union_with_rect);
  XG_DEFINE_PROCEDURE(gdk_region_intersect, gxg_gdk_region_intersect, 2, 0, 0, H_gdk_region_intersect);
  XG_DEFINE_PROCEDURE(gdk_region_union, gxg_gdk_region_union, 2, 0, 0, H_gdk_region_union);
  XG_DEFINE_PROCEDURE(gdk_region_subtract, gxg_gdk_region_subtract, 2, 0, 0, H_gdk_region_subtract);
  XG_DEFINE_PROCEDURE(gdk_region_xor, gxg_gdk_region_xor, 2, 0, 0, H_gdk_region_xor);
  XG_DEFINE_PROCEDURE(gdk_rgb_find_color, gxg_gdk_rgb_find_color, 2, 0, 0, H_gdk_rgb_find_color);
  XG_DEFINE_PROCEDURE(gdk_draw_rgb_image, gxg_gdk_draw_rgb_image, 9, 0, 0, H_gdk_draw_rgb_image);
  XG_DEFINE_PROCEDURE(gdk_draw_rgb_image_dithalign, gxg_gdk_draw_rgb_image_dithalign, 0, 0, 1, H_gdk_draw_rgb_image_dithalign);
  XG_DEFINE_PROCEDURE(gdk_draw_rgb_32_image, gxg_gdk_draw_rgb_32_image, 9, 0, 0, H_gdk_draw_rgb_32_image);
  XG_DEFINE_PROCEDURE(gdk_draw_rgb_32_image_dithalign, gxg_gdk_draw_rgb_32_image_dithalign, 0, 0, 1, H_gdk_draw_rgb_32_image_dithalign);
  XG_DEFINE_PROCEDURE(gdk_draw_gray_image, gxg_gdk_draw_gray_image, 9, 0, 0, H_gdk_draw_gray_image);
  XG_DEFINE_PROCEDURE(gdk_draw_indexed_image, gxg_gdk_draw_indexed_image, 0, 0, 1, H_gdk_draw_indexed_image);
  XG_DEFINE_PROCEDURE(gdk_rgb_cmap_new, gxg_gdk_rgb_cmap_new, 2, 0, 0, H_gdk_rgb_cmap_new);
  XG_DEFINE_PROCEDURE(gdk_rgb_cmap_free, gxg_gdk_rgb_cmap_free, 1, 0, 0, H_gdk_rgb_cmap_free);
  XG_DEFINE_PROCEDURE(gdk_rgb_ditherable, gxg_gdk_rgb_ditherable, 0, 0, 0, H_gdk_rgb_ditherable);
  XG_DEFINE_PROCEDURE(gdk_rgb_set_verbose, gxg_gdk_rgb_set_verbose, 1, 0, 0, H_gdk_rgb_set_verbose);
  XG_DEFINE_PROCEDURE(gdk_rgb_set_install, gxg_gdk_rgb_set_install, 1, 0, 0, H_gdk_rgb_set_install);
  XG_DEFINE_PROCEDURE(gdk_rgb_set_min_colors, gxg_gdk_rgb_set_min_colors, 1, 0, 0, H_gdk_rgb_set_min_colors);
  XG_DEFINE_PROCEDURE(gdk_rgb_get_colormap, gxg_gdk_rgb_get_colormap, 0, 0, 0, H_gdk_rgb_get_colormap);
  XG_DEFINE_PROCEDURE(gdk_rgb_get_visual, gxg_gdk_rgb_get_visual, 0, 0, 0, H_gdk_rgb_get_visual);
  XG_DEFINE_PROCEDURE(gdk_selection_owner_set, gxg_gdk_selection_owner_set, 4, 0, 0, H_gdk_selection_owner_set);
  XG_DEFINE_PROCEDURE(gdk_selection_owner_get, gxg_gdk_selection_owner_get, 1, 0, 0, H_gdk_selection_owner_get);
  XG_DEFINE_PROCEDURE(gdk_selection_convert, gxg_gdk_selection_convert, 4, 0, 0, H_gdk_selection_convert);
  XG_DEFINE_PROCEDURE(gdk_selection_property_get, gxg_gdk_selection_property_get, 1, 3, 0, H_gdk_selection_property_get);
  XG_DEFINE_PROCEDURE(gdk_selection_send_notify, gxg_gdk_selection_send_notify, 5, 0, 0, H_gdk_selection_send_notify);
  XG_DEFINE_PROCEDURE(gdk_visual_get_type, gxg_gdk_visual_get_type, 0, 0, 0, H_gdk_visual_get_type);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best_depth, gxg_gdk_visual_get_best_depth, 0, 0, 0, H_gdk_visual_get_best_depth);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best_type, gxg_gdk_visual_get_best_type, 0, 0, 0, H_gdk_visual_get_best_type);
  XG_DEFINE_PROCEDURE(gdk_visual_get_system, gxg_gdk_visual_get_system, 0, 0, 0, H_gdk_visual_get_system);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best, gxg_gdk_visual_get_best, 0, 0, 0, H_gdk_visual_get_best);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best_with_depth, gxg_gdk_visual_get_best_with_depth, 1, 0, 0, H_gdk_visual_get_best_with_depth);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best_with_type, gxg_gdk_visual_get_best_with_type, 1, 0, 0, H_gdk_visual_get_best_with_type);
  XG_DEFINE_PROCEDURE(gdk_visual_get_best_with_both, gxg_gdk_visual_get_best_with_both, 2, 0, 0, H_gdk_visual_get_best_with_both);
  XG_DEFINE_PROCEDURE(gdk_query_depths, gxg_gdk_query_depths, 0, 2, 0, H_gdk_query_depths);
  XG_DEFINE_PROCEDURE(gdk_query_visual_types, gxg_gdk_query_visual_types, 0, 2, 0, H_gdk_query_visual_types);
  XG_DEFINE_PROCEDURE(gdk_list_visuals, gxg_gdk_list_visuals, 0, 0, 0, H_gdk_list_visuals);
  XG_DEFINE_PROCEDURE(gdk_window_new, gxg_gdk_window_new, 3, 0, 0, H_gdk_window_new);
  XG_DEFINE_PROCEDURE(gdk_window_destroy, gxg_gdk_window_destroy, 1, 0, 0, H_gdk_window_destroy);
  XG_DEFINE_PROCEDURE(gdk_window_get_window_type, gxg_gdk_window_get_window_type, 1, 0, 0, H_gdk_window_get_window_type);
  XG_DEFINE_PROCEDURE(gdk_window_at_pointer, gxg_gdk_window_at_pointer, 0, 2, 0, H_gdk_window_at_pointer);
  XG_DEFINE_PROCEDURE(gdk_window_show, gxg_gdk_window_show, 1, 0, 0, H_gdk_window_show);
  XG_DEFINE_PROCEDURE(gdk_window_hide, gxg_gdk_window_hide, 1, 0, 0, H_gdk_window_hide);
  XG_DEFINE_PROCEDURE(gdk_window_withdraw, gxg_gdk_window_withdraw, 1, 0, 0, H_gdk_window_withdraw);
  XG_DEFINE_PROCEDURE(gdk_window_show_unraised, gxg_gdk_window_show_unraised, 1, 0, 0, H_gdk_window_show_unraised);
  XG_DEFINE_PROCEDURE(gdk_window_move, gxg_gdk_window_move, 3, 0, 0, H_gdk_window_move);
  XG_DEFINE_PROCEDURE(gdk_window_resize, gxg_gdk_window_resize, 3, 0, 0, H_gdk_window_resize);
  XG_DEFINE_PROCEDURE(gdk_window_move_resize, gxg_gdk_window_move_resize, 5, 0, 0, H_gdk_window_move_resize);
  XG_DEFINE_PROCEDURE(gdk_window_reparent, gxg_gdk_window_reparent, 4, 0, 0, H_gdk_window_reparent);
  XG_DEFINE_PROCEDURE(gdk_window_clear, gxg_gdk_window_clear, 1, 0, 0, H_gdk_window_clear);
  XG_DEFINE_PROCEDURE(gdk_window_clear_area, gxg_gdk_window_clear_area, 5, 0, 0, H_gdk_window_clear_area);
  XG_DEFINE_PROCEDURE(gdk_window_clear_area_e, gxg_gdk_window_clear_area_e, 5, 0, 0, H_gdk_window_clear_area_e);
  XG_DEFINE_PROCEDURE(gdk_window_raise, gxg_gdk_window_raise, 1, 0, 0, H_gdk_window_raise);
  XG_DEFINE_PROCEDURE(gdk_window_lower, gxg_gdk_window_lower, 1, 0, 0, H_gdk_window_lower);
  XG_DEFINE_PROCEDURE(gdk_window_focus, gxg_gdk_window_focus, 2, 0, 0, H_gdk_window_focus);
  XG_DEFINE_PROCEDURE(gdk_window_set_user_data, gxg_gdk_window_set_user_data, 2, 0, 0, H_gdk_window_set_user_data);
  XG_DEFINE_PROCEDURE(gdk_window_set_override_redirect, gxg_gdk_window_set_override_redirect, 2, 0, 0, H_gdk_window_set_override_redirect);
  XG_DEFINE_PROCEDURE(gdk_window_add_filter, gxg_gdk_window_add_filter, 2, 1, 0, H_gdk_window_add_filter);
  XG_DEFINE_PROCEDURE(gdk_window_remove_filter, gxg_gdk_window_remove_filter, 2, 1, 0, H_gdk_window_remove_filter);
  XG_DEFINE_PROCEDURE(gdk_window_scroll, gxg_gdk_window_scroll, 3, 0, 0, H_gdk_window_scroll);
  XG_DEFINE_PROCEDURE(gdk_window_shape_combine_mask, gxg_gdk_window_shape_combine_mask, 4, 0, 0, H_gdk_window_shape_combine_mask);
  XG_DEFINE_PROCEDURE(gdk_window_shape_combine_region, gxg_gdk_window_shape_combine_region, 4, 0, 0, H_gdk_window_shape_combine_region);
  XG_DEFINE_PROCEDURE(gdk_window_set_child_shapes, gxg_gdk_window_set_child_shapes, 1, 0, 0, H_gdk_window_set_child_shapes);
  XG_DEFINE_PROCEDURE(gdk_window_merge_child_shapes, gxg_gdk_window_merge_child_shapes, 1, 0, 0, H_gdk_window_merge_child_shapes);
  XG_DEFINE_PROCEDURE(gdk_window_is_visible, gxg_gdk_window_is_visible, 1, 0, 0, H_gdk_window_is_visible);
  XG_DEFINE_PROCEDURE(gdk_window_is_viewable, gxg_gdk_window_is_viewable, 1, 0, 0, H_gdk_window_is_viewable);
  XG_DEFINE_PROCEDURE(gdk_window_get_state, gxg_gdk_window_get_state, 1, 0, 0, H_gdk_window_get_state);
  XG_DEFINE_PROCEDURE(gdk_window_set_static_gravities, gxg_gdk_window_set_static_gravities, 2, 0, 0, H_gdk_window_set_static_gravities);
  XG_DEFINE_PROCEDURE(gdk_window_foreign_new, gxg_gdk_window_foreign_new, 1, 0, 0, H_gdk_window_foreign_new);
  XG_DEFINE_PROCEDURE(gdk_window_lookup, gxg_gdk_window_lookup, 1, 0, 0, H_gdk_window_lookup);
  XG_DEFINE_PROCEDURE(gdk_window_get_root_origin, gxg_gdk_window_get_root_origin, 1, 2, 0, H_gdk_window_get_root_origin);
  XG_DEFINE_PROCEDURE(gdk_window_get_frame_extents, gxg_gdk_window_get_frame_extents, 2, 0, 0, H_gdk_window_get_frame_extents);
  XG_DEFINE_PROCEDURE(gdk_window_get_pointer, gxg_gdk_window_get_pointer, 1, 3, 0, H_gdk_window_get_pointer);
  XG_DEFINE_PROCEDURE(gdk_window_get_parent, gxg_gdk_window_get_parent, 1, 0, 0, H_gdk_window_get_parent);
  XG_DEFINE_PROCEDURE(gdk_window_get_toplevel, gxg_gdk_window_get_toplevel, 1, 0, 0, H_gdk_window_get_toplevel);
  XG_DEFINE_PROCEDURE(gdk_window_get_children, gxg_gdk_window_get_children, 1, 0, 0, H_gdk_window_get_children);
  XG_DEFINE_PROCEDURE(gdk_window_peek_children, gxg_gdk_window_peek_children, 1, 0, 0, H_gdk_window_peek_children);
  XG_DEFINE_PROCEDURE(gdk_window_get_events, gxg_gdk_window_get_events, 1, 0, 0, H_gdk_window_get_events);
  XG_DEFINE_PROCEDURE(gdk_window_set_events, gxg_gdk_window_set_events, 2, 0, 0, H_gdk_window_set_events);
  XG_DEFINE_PROCEDURE(gdk_window_set_icon_list, gxg_gdk_window_set_icon_list, 2, 0, 0, H_gdk_window_set_icon_list);
  XG_DEFINE_PROCEDURE(gdk_window_set_icon, gxg_gdk_window_set_icon, 4, 0, 0, H_gdk_window_set_icon);
  XG_DEFINE_PROCEDURE(gdk_window_set_icon_name, gxg_gdk_window_set_icon_name, 2, 0, 0, H_gdk_window_set_icon_name);
  XG_DEFINE_PROCEDURE(gdk_window_set_group, gxg_gdk_window_set_group, 2, 0, 0, H_gdk_window_set_group);
  XG_DEFINE_PROCEDURE(gdk_window_set_decorations, gxg_gdk_window_set_decorations, 2, 0, 0, H_gdk_window_set_decorations);
  XG_DEFINE_PROCEDURE(gdk_window_get_decorations, gxg_gdk_window_get_decorations, 1, 1, 0, H_gdk_window_get_decorations);
  XG_DEFINE_PROCEDURE(gdk_window_set_functions, gxg_gdk_window_set_functions, 2, 0, 0, H_gdk_window_set_functions);
  XG_DEFINE_PROCEDURE(gdk_window_get_toplevels, gxg_gdk_window_get_toplevels, 0, 0, 0, H_gdk_window_get_toplevels);
  XG_DEFINE_PROCEDURE(gdk_window_iconify, gxg_gdk_window_iconify, 1, 0, 0, H_gdk_window_iconify);
  XG_DEFINE_PROCEDURE(gdk_window_deiconify, gxg_gdk_window_deiconify, 1, 0, 0, H_gdk_window_deiconify);
  XG_DEFINE_PROCEDURE(gdk_window_stick, gxg_gdk_window_stick, 1, 0, 0, H_gdk_window_stick);
  XG_DEFINE_PROCEDURE(gdk_window_unstick, gxg_gdk_window_unstick, 1, 0, 0, H_gdk_window_unstick);
  XG_DEFINE_PROCEDURE(gdk_window_maximize, gxg_gdk_window_maximize, 1, 0, 0, H_gdk_window_maximize);
  XG_DEFINE_PROCEDURE(gdk_window_unmaximize, gxg_gdk_window_unmaximize, 1, 0, 0, H_gdk_window_unmaximize);
  XG_DEFINE_PROCEDURE(gdk_window_register_dnd, gxg_gdk_window_register_dnd, 1, 0, 0, H_gdk_window_register_dnd);
  XG_DEFINE_PROCEDURE(gdk_window_begin_resize_drag, gxg_gdk_window_begin_resize_drag, 6, 0, 0, H_gdk_window_begin_resize_drag);
  XG_DEFINE_PROCEDURE(gdk_window_begin_move_drag, gxg_gdk_window_begin_move_drag, 5, 0, 0, H_gdk_window_begin_move_drag);
  XG_DEFINE_PROCEDURE(gdk_window_invalidate_rect, gxg_gdk_window_invalidate_rect, 3, 0, 0, H_gdk_window_invalidate_rect);
  XG_DEFINE_PROCEDURE(gdk_window_invalidate_region, gxg_gdk_window_invalidate_region, 3, 0, 0, H_gdk_window_invalidate_region);
  XG_DEFINE_PROCEDURE(gdk_window_invalidate_maybe_recurse, gxg_gdk_window_invalidate_maybe_recurse, 3, 1, 0, H_gdk_window_invalidate_maybe_recurse);
  XG_DEFINE_PROCEDURE(gdk_window_get_update_area, gxg_gdk_window_get_update_area, 1, 0, 0, H_gdk_window_get_update_area);
  XG_DEFINE_PROCEDURE(gdk_window_freeze_updates, gxg_gdk_window_freeze_updates, 1, 0, 0, H_gdk_window_freeze_updates);
  XG_DEFINE_PROCEDURE(gdk_window_thaw_updates, gxg_gdk_window_thaw_updates, 1, 0, 0, H_gdk_window_thaw_updates);
  XG_DEFINE_PROCEDURE(gdk_window_process_all_updates, gxg_gdk_window_process_all_updates, 0, 0, 0, H_gdk_window_process_all_updates);
  XG_DEFINE_PROCEDURE(gdk_window_process_updates, gxg_gdk_window_process_updates, 2, 0, 0, H_gdk_window_process_updates);
  XG_DEFINE_PROCEDURE(gdk_window_set_debug_updates, gxg_gdk_window_set_debug_updates, 1, 0, 0, H_gdk_window_set_debug_updates);
  XG_DEFINE_PROCEDURE(gdk_window_constrain_size, gxg_gdk_window_constrain_size, 4, 2, 0, H_gdk_window_constrain_size);
  XG_DEFINE_PROCEDURE(gdk_window_get_internal_paint_info, gxg_gdk_window_get_internal_paint_info, 1, 3, 0, H_gdk_window_get_internal_paint_info);
  XG_DEFINE_PROCEDURE(gtk_window_remove_embedded_xid, gxg_gtk_window_remove_embedded_xid, 2, 0, 0, H_gtk_window_remove_embedded_xid);
  XG_DEFINE_PROCEDURE(gtk_window_add_embedded_xid, gxg_gtk_window_add_embedded_xid, 2, 0, 0, H_gtk_window_add_embedded_xid);
  XG_DEFINE_PROCEDURE(gdk_window_set_type_hint, gxg_gdk_window_set_type_hint, 2, 0, 0, H_gdk_window_set_type_hint);
  XG_DEFINE_PROCEDURE(gdk_window_set_modal_hint, gxg_gdk_window_set_modal_hint, 2, 0, 0, H_gdk_window_set_modal_hint);
  XG_DEFINE_PROCEDURE(gdk_window_set_geometry_hints, gxg_gdk_window_set_geometry_hints, 3, 0, 0, H_gdk_window_set_geometry_hints);
  XG_DEFINE_PROCEDURE(gdk_set_sm_client_id, gxg_gdk_set_sm_client_id, 1, 0, 0, H_gdk_set_sm_client_id);
  XG_DEFINE_PROCEDURE(gdk_window_begin_paint_rect, gxg_gdk_window_begin_paint_rect, 2, 0, 0, H_gdk_window_begin_paint_rect);
  XG_DEFINE_PROCEDURE(gdk_window_begin_paint_region, gxg_gdk_window_begin_paint_region, 2, 0, 0, H_gdk_window_begin_paint_region);
  XG_DEFINE_PROCEDURE(gdk_window_end_paint, gxg_gdk_window_end_paint, 1, 0, 0, H_gdk_window_end_paint);
  XG_DEFINE_PROCEDURE(gdk_window_set_title, gxg_gdk_window_set_title, 2, 0, 0, H_gdk_window_set_title);
  XG_DEFINE_PROCEDURE(gdk_window_set_role, gxg_gdk_window_set_role, 2, 0, 0, H_gdk_window_set_role);
  XG_DEFINE_PROCEDURE(gdk_window_set_transient_for, gxg_gdk_window_set_transient_for, 2, 0, 0, H_gdk_window_set_transient_for);
  XG_DEFINE_PROCEDURE(gdk_window_set_background, gxg_gdk_window_set_background, 2, 0, 0, H_gdk_window_set_background);
  XG_DEFINE_PROCEDURE(gdk_window_set_back_pixmap, gxg_gdk_window_set_back_pixmap, 3, 0, 0, H_gdk_window_set_back_pixmap);
  XG_DEFINE_PROCEDURE(gdk_window_set_cursor, gxg_gdk_window_set_cursor, 2, 0, 0, H_gdk_window_set_cursor);
  XG_DEFINE_PROCEDURE(gdk_window_get_user_data, gxg_gdk_window_get_user_data, 1, 1, 0, H_gdk_window_get_user_data);
  XG_DEFINE_PROCEDURE(gdk_window_get_geometry, gxg_gdk_window_get_geometry, 1, 5, 0, H_gdk_window_get_geometry);
  XG_DEFINE_PROCEDURE(gdk_window_get_position, gxg_gdk_window_get_position, 1, 2, 0, H_gdk_window_get_position);
  XG_DEFINE_PROCEDURE(gdk_window_get_origin, gxg_gdk_window_get_origin, 1, 2, 0, H_gdk_window_get_origin);
  XG_DEFINE_PROCEDURE(gdk_get_default_root_window, gxg_gdk_get_default_root_window, 0, 0, 0, H_gdk_get_default_root_window);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_error_quark, gxg_gdk_pixbuf_error_quark, 0, 0, 0, H_gdk_pixbuf_error_quark);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_type, gxg_gdk_pixbuf_get_type, 0, 0, 0, H_gdk_pixbuf_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_colorspace, gxg_gdk_pixbuf_get_colorspace, 1, 0, 0, H_gdk_pixbuf_get_colorspace);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_n_channels, gxg_gdk_pixbuf_get_n_channels, 1, 0, 0, H_gdk_pixbuf_get_n_channels);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_has_alpha, gxg_gdk_pixbuf_get_has_alpha, 1, 0, 0, H_gdk_pixbuf_get_has_alpha);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_bits_per_sample, gxg_gdk_pixbuf_get_bits_per_sample, 1, 0, 0, H_gdk_pixbuf_get_bits_per_sample);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_pixels, gxg_gdk_pixbuf_get_pixels, 1, 0, 0, H_gdk_pixbuf_get_pixels);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_width, gxg_gdk_pixbuf_get_width, 1, 0, 0, H_gdk_pixbuf_get_width);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_height, gxg_gdk_pixbuf_get_height, 1, 0, 0, H_gdk_pixbuf_get_height);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_rowstride, gxg_gdk_pixbuf_get_rowstride, 1, 0, 0, H_gdk_pixbuf_get_rowstride);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new, gxg_gdk_pixbuf_new, 5, 0, 0, H_gdk_pixbuf_new);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_copy, gxg_gdk_pixbuf_copy, 1, 0, 0, H_gdk_pixbuf_copy);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new_subpixbuf, gxg_gdk_pixbuf_new_subpixbuf, 5, 0, 0, H_gdk_pixbuf_new_subpixbuf);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new_from_file, gxg_gdk_pixbuf_new_from_file, 1, 1, 0, H_gdk_pixbuf_new_from_file);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new_from_data, gxg_gdk_pixbuf_new_from_data, 9, 0, 0, H_gdk_pixbuf_new_from_data);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new_from_xpm_data, gxg_gdk_pixbuf_new_from_xpm_data, 1, 0, 0, H_gdk_pixbuf_new_from_xpm_data);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_new_from_inline, gxg_gdk_pixbuf_new_from_inline, 3, 1, 0, H_gdk_pixbuf_new_from_inline);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_fill, gxg_gdk_pixbuf_fill, 2, 0, 0, H_gdk_pixbuf_fill);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_savev, gxg_gdk_pixbuf_savev, 5, 1, 0, H_gdk_pixbuf_savev);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_add_alpha, gxg_gdk_pixbuf_add_alpha, 5, 0, 0, H_gdk_pixbuf_add_alpha);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_copy_area, gxg_gdk_pixbuf_copy_area, 8, 0, 0, H_gdk_pixbuf_copy_area);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_saturate_and_pixelate, gxg_gdk_pixbuf_saturate_and_pixelate, 4, 0, 0, H_gdk_pixbuf_saturate_and_pixelate);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_scale, gxg_gdk_pixbuf_scale, 0, 0, 1, H_gdk_pixbuf_scale);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_composite, gxg_gdk_pixbuf_composite, 0, 0, 1, H_gdk_pixbuf_composite);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_composite_color, gxg_gdk_pixbuf_composite_color, 0, 0, 1, H_gdk_pixbuf_composite_color);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_scale_simple, gxg_gdk_pixbuf_scale_simple, 4, 0, 0, H_gdk_pixbuf_scale_simple);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_composite_color_simple, gxg_gdk_pixbuf_composite_color_simple, 8, 0, 0, H_gdk_pixbuf_composite_color_simple);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_get_type, gxg_gdk_pixbuf_animation_get_type, 0, 0, 0, H_gdk_pixbuf_animation_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_new_from_file, gxg_gdk_pixbuf_animation_new_from_file, 1, 1, 0, H_gdk_pixbuf_animation_new_from_file);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_get_width, gxg_gdk_pixbuf_animation_get_width, 1, 0, 0, H_gdk_pixbuf_animation_get_width);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_get_height, gxg_gdk_pixbuf_animation_get_height, 1, 0, 0, H_gdk_pixbuf_animation_get_height);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_is_static_image, gxg_gdk_pixbuf_animation_is_static_image, 1, 0, 0, H_gdk_pixbuf_animation_is_static_image);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_get_static_image, gxg_gdk_pixbuf_animation_get_static_image, 1, 0, 0, H_gdk_pixbuf_animation_get_static_image);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_get_iter, gxg_gdk_pixbuf_animation_get_iter, 2, 0, 0, H_gdk_pixbuf_animation_get_iter);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_iter_get_type, gxg_gdk_pixbuf_animation_iter_get_type, 0, 0, 0, H_gdk_pixbuf_animation_iter_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_iter_get_delay_time, gxg_gdk_pixbuf_animation_iter_get_delay_time, 1, 0, 0, H_gdk_pixbuf_animation_iter_get_delay_time);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_iter_get_pixbuf, gxg_gdk_pixbuf_animation_iter_get_pixbuf, 1, 0, 0, H_gdk_pixbuf_animation_iter_get_pixbuf);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_iter_on_currently_loading_frame, gxg_gdk_pixbuf_animation_iter_on_currently_loading_frame, 1, 0, 0, H_gdk_pixbuf_animation_iter_on_currently_loading_frame);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_animation_iter_advance, gxg_gdk_pixbuf_animation_iter_advance, 2, 0, 0, H_gdk_pixbuf_animation_iter_advance);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_get_option, gxg_gdk_pixbuf_get_option, 2, 0, 0, H_gdk_pixbuf_get_option);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_get_type, gxg_gdk_pixbuf_loader_get_type, 0, 0, 0, H_gdk_pixbuf_loader_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_new, gxg_gdk_pixbuf_loader_new, 0, 0, 0, H_gdk_pixbuf_loader_new);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_new_with_type, gxg_gdk_pixbuf_loader_new_with_type, 1, 1, 0, H_gdk_pixbuf_loader_new_with_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_write, gxg_gdk_pixbuf_loader_write, 3, 1, 0, H_gdk_pixbuf_loader_write);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_get_pixbuf, gxg_gdk_pixbuf_loader_get_pixbuf, 1, 0, 0, H_gdk_pixbuf_loader_get_pixbuf);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_get_animation, gxg_gdk_pixbuf_loader_get_animation, 1, 0, 0, H_gdk_pixbuf_loader_get_animation);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_loader_close, gxg_gdk_pixbuf_loader_close, 1, 1, 0, H_gdk_pixbuf_loader_close);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_alpha_mode_get_type, gxg_gdk_pixbuf_alpha_mode_get_type, 0, 0, 0, H_gdk_pixbuf_alpha_mode_get_type);
  XG_DEFINE_PROCEDURE(gdk_colorspace_get_type, gxg_gdk_colorspace_get_type, 0, 0, 0, H_gdk_colorspace_get_type);
  XG_DEFINE_PROCEDURE(gdk_pixbuf_error_get_type, gxg_gdk_pixbuf_error_get_type, 0, 0, 0, H_gdk_pixbuf_error_get_type);
  XG_DEFINE_PROCEDURE(gdk_interp_type_get_type, gxg_gdk_interp_type_get_type, 0, 0, 0, H_gdk_interp_type_get_type);
  XG_DEFINE_PROCEDURE(gtk_vbox_get_type, gxg_gtk_vbox_get_type, 0, 0, 0, H_gtk_vbox_get_type);
  XG_DEFINE_PROCEDURE(gtk_vbox_new, gxg_gtk_vbox_new, 2, 0, 0, H_gtk_vbox_new);
  XG_DEFINE_PROCEDURE(gtk_accel_group_get_type, gxg_gtk_accel_group_get_type, 0, 0, 0, H_gtk_accel_group_get_type);
  XG_DEFINE_PROCEDURE(gtk_accel_group_new, gxg_gtk_accel_group_new, 0, 0, 0, H_gtk_accel_group_new);
  XG_DEFINE_PROCEDURE(gtk_accel_group_lock, gxg_gtk_accel_group_lock, 1, 0, 0, H_gtk_accel_group_lock);
  XG_DEFINE_PROCEDURE(gtk_accel_group_unlock, gxg_gtk_accel_group_unlock, 1, 0, 0, H_gtk_accel_group_unlock);
  XG_DEFINE_PROCEDURE(gtk_accel_group_connect, gxg_gtk_accel_group_connect, 5, 0, 0, H_gtk_accel_group_connect);
  XG_DEFINE_PROCEDURE(gtk_accel_group_connect_by_path, gxg_gtk_accel_group_connect_by_path, 3, 0, 0, H_gtk_accel_group_connect_by_path);
  XG_DEFINE_PROCEDURE(gtk_accel_group_disconnect, gxg_gtk_accel_group_disconnect, 2, 0, 0, H_gtk_accel_group_disconnect);
  XG_DEFINE_PROCEDURE(gtk_accel_group_disconnect_key, gxg_gtk_accel_group_disconnect_key, 3, 0, 0, H_gtk_accel_group_disconnect_key);
  XG_DEFINE_PROCEDURE(gtk_accel_groups_activate, gxg_gtk_accel_groups_activate, 3, 0, 0, H_gtk_accel_groups_activate);
  XG_DEFINE_PROCEDURE(gtk_accel_groups_from_object, gxg_gtk_accel_groups_from_object, 1, 0, 0, H_gtk_accel_groups_from_object);
  XG_DEFINE_PROCEDURE(gtk_accel_group_find, gxg_gtk_accel_group_find, 2, 1, 0, H_gtk_accel_group_find);
  XG_DEFINE_PROCEDURE(gtk_accel_group_from_accel_closure, gxg_gtk_accel_group_from_accel_closure, 1, 0, 0, H_gtk_accel_group_from_accel_closure);
  XG_DEFINE_PROCEDURE(gtk_accelerator_valid, gxg_gtk_accelerator_valid, 2, 0, 0, H_gtk_accelerator_valid);
  XG_DEFINE_PROCEDURE(gtk_accelerator_parse, gxg_gtk_accelerator_parse, 1, 2, 0, H_gtk_accelerator_parse);
  XG_DEFINE_PROCEDURE(gtk_accelerator_name, gxg_gtk_accelerator_name, 2, 0, 0, H_gtk_accelerator_name);
  XG_DEFINE_PROCEDURE(gtk_accelerator_set_default_mod_mask, gxg_gtk_accelerator_set_default_mod_mask, 1, 0, 0, H_gtk_accelerator_set_default_mod_mask);
  XG_DEFINE_PROCEDURE(gtk_accelerator_get_default_mod_mask, gxg_gtk_accelerator_get_default_mod_mask, 0, 0, 0, H_gtk_accelerator_get_default_mod_mask);
  XG_DEFINE_PROCEDURE(gtk_accel_group_query, gxg_gtk_accel_group_query, 3, 1, 0, H_gtk_accel_group_query);
  XG_DEFINE_PROCEDURE(gtk_accel_label_get_type, gxg_gtk_accel_label_get_type, 0, 0, 0, H_gtk_accel_label_get_type);
  XG_DEFINE_PROCEDURE(gtk_accel_label_new, gxg_gtk_accel_label_new, 1, 0, 0, H_gtk_accel_label_new);
  XG_DEFINE_PROCEDURE(gtk_accel_label_get_accel_widget, gxg_gtk_accel_label_get_accel_widget, 1, 0, 0, H_gtk_accel_label_get_accel_widget);
  XG_DEFINE_PROCEDURE(gtk_accel_label_get_accel_width, gxg_gtk_accel_label_get_accel_width, 1, 0, 0, H_gtk_accel_label_get_accel_width);
  XG_DEFINE_PROCEDURE(gtk_accel_label_set_accel_widget, gxg_gtk_accel_label_set_accel_widget, 2, 0, 0, H_gtk_accel_label_set_accel_widget);
  XG_DEFINE_PROCEDURE(gtk_accel_label_set_accel_closure, gxg_gtk_accel_label_set_accel_closure, 2, 0, 0, H_gtk_accel_label_set_accel_closure);
  XG_DEFINE_PROCEDURE(gtk_accel_label_refetch, gxg_gtk_accel_label_refetch, 1, 0, 0, H_gtk_accel_label_refetch);
  XG_DEFINE_PROCEDURE(gtk_accel_map_add_entry, gxg_gtk_accel_map_add_entry, 3, 0, 0, H_gtk_accel_map_add_entry);
  XG_DEFINE_PROCEDURE(gtk_accel_map_lookup_entry, gxg_gtk_accel_map_lookup_entry, 2, 0, 0, H_gtk_accel_map_lookup_entry);
  XG_DEFINE_PROCEDURE(gtk_accel_map_change_entry, gxg_gtk_accel_map_change_entry, 4, 0, 0, H_gtk_accel_map_change_entry);
  XG_DEFINE_PROCEDURE(gtk_accel_map_load, gxg_gtk_accel_map_load, 1, 0, 0, H_gtk_accel_map_load);
  XG_DEFINE_PROCEDURE(gtk_accel_map_save, gxg_gtk_accel_map_save, 1, 0, 0, H_gtk_accel_map_save);
  XG_DEFINE_PROCEDURE(gtk_accel_map_foreach, gxg_gtk_accel_map_foreach, 2, 0, 0, H_gtk_accel_map_foreach);
  XG_DEFINE_PROCEDURE(gtk_accel_map_load_fd, gxg_gtk_accel_map_load_fd, 1, 0, 0, H_gtk_accel_map_load_fd);
  XG_DEFINE_PROCEDURE(gtk_accel_map_load_scanner, gxg_gtk_accel_map_load_scanner, 1, 0, 0, H_gtk_accel_map_load_scanner);
  XG_DEFINE_PROCEDURE(gtk_accel_map_save_fd, gxg_gtk_accel_map_save_fd, 1, 0, 0, H_gtk_accel_map_save_fd);
  XG_DEFINE_PROCEDURE(gtk_accel_map_add_filter, gxg_gtk_accel_map_add_filter, 1, 0, 0, H_gtk_accel_map_add_filter);
  XG_DEFINE_PROCEDURE(gtk_accel_map_foreach_unfiltered, gxg_gtk_accel_map_foreach_unfiltered, 2, 0, 0, H_gtk_accel_map_foreach_unfiltered);
  XG_DEFINE_PROCEDURE(gtk_accessible_get_type, gxg_gtk_accessible_get_type, 0, 0, 0, H_gtk_accessible_get_type);
  XG_DEFINE_PROCEDURE(gtk_accessible_connect_widget_destroyed, gxg_gtk_accessible_connect_widget_destroyed, 1, 0, 0, H_gtk_accessible_connect_widget_destroyed);
  XG_DEFINE_PROCEDURE(gtk_adjustment_get_type, gxg_gtk_adjustment_get_type, 0, 0, 0, H_gtk_adjustment_get_type);
  XG_DEFINE_PROCEDURE(gtk_adjustment_new, gxg_gtk_adjustment_new, 6, 0, 0, H_gtk_adjustment_new);
  XG_DEFINE_PROCEDURE(gtk_adjustment_changed, gxg_gtk_adjustment_changed, 1, 0, 0, H_gtk_adjustment_changed);
  XG_DEFINE_PROCEDURE(gtk_adjustment_value_changed, gxg_gtk_adjustment_value_changed, 1, 0, 0, H_gtk_adjustment_value_changed);
  XG_DEFINE_PROCEDURE(gtk_adjustment_clamp_page, gxg_gtk_adjustment_clamp_page, 3, 0, 0, H_gtk_adjustment_clamp_page);
  XG_DEFINE_PROCEDURE(gtk_adjustment_get_value, gxg_gtk_adjustment_get_value, 1, 0, 0, H_gtk_adjustment_get_value);
  XG_DEFINE_PROCEDURE(gtk_adjustment_set_value, gxg_gtk_adjustment_set_value, 2, 0, 0, H_gtk_adjustment_set_value);
  XG_DEFINE_PROCEDURE(gtk_alignment_get_type, gxg_gtk_alignment_get_type, 0, 0, 0, H_gtk_alignment_get_type);
  XG_DEFINE_PROCEDURE(gtk_alignment_new, gxg_gtk_alignment_new, 4, 0, 0, H_gtk_alignment_new);
  XG_DEFINE_PROCEDURE(gtk_alignment_set, gxg_gtk_alignment_set, 5, 0, 0, H_gtk_alignment_set);
  XG_DEFINE_PROCEDURE(gtk_arrow_get_type, gxg_gtk_arrow_get_type, 0, 0, 0, H_gtk_arrow_get_type);
  XG_DEFINE_PROCEDURE(gtk_arrow_new, gxg_gtk_arrow_new, 2, 0, 0, H_gtk_arrow_new);
  XG_DEFINE_PROCEDURE(gtk_arrow_set, gxg_gtk_arrow_set, 3, 0, 0, H_gtk_arrow_set);
  XG_DEFINE_PROCEDURE(gtk_aspect_frame_get_type, gxg_gtk_aspect_frame_get_type, 0, 0, 0, H_gtk_aspect_frame_get_type);
  XG_DEFINE_PROCEDURE(gtk_aspect_frame_new, gxg_gtk_aspect_frame_new, 5, 0, 0, H_gtk_aspect_frame_new);
  XG_DEFINE_PROCEDURE(gtk_aspect_frame_set, gxg_gtk_aspect_frame_set, 5, 0, 0, H_gtk_aspect_frame_set);
  XG_DEFINE_PROCEDURE(gtk_button_box_get_type, gxg_gtk_button_box_get_type, 0, 0, 0, H_gtk_button_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_button_box_get_layout, gxg_gtk_button_box_get_layout, 1, 0, 0, H_gtk_button_box_get_layout);
  XG_DEFINE_PROCEDURE(gtk_button_box_set_layout, gxg_gtk_button_box_set_layout, 2, 0, 0, H_gtk_button_box_set_layout);
  XG_DEFINE_PROCEDURE(gtk_button_box_set_child_secondary, gxg_gtk_button_box_set_child_secondary, 3, 0, 0, H_gtk_button_box_set_child_secondary);
  XG_DEFINE_PROCEDURE(gtk_binding_set_new, gxg_gtk_binding_set_new, 1, 0, 0, H_gtk_binding_set_new);
  XG_DEFINE_PROCEDURE(gtk_binding_set_by_class, gxg_gtk_binding_set_by_class, 1, 0, 0, H_gtk_binding_set_by_class);
  XG_DEFINE_PROCEDURE(gtk_binding_set_find, gxg_gtk_binding_set_find, 1, 0, 0, H_gtk_binding_set_find);
  XG_DEFINE_PROCEDURE(gtk_bindings_activate, gxg_gtk_bindings_activate, 3, 0, 0, H_gtk_bindings_activate);
  XG_DEFINE_PROCEDURE(gtk_binding_set_activate, gxg_gtk_binding_set_activate, 4, 0, 0, H_gtk_binding_set_activate);
  XG_DEFINE_PROCEDURE(gtk_binding_entry_clear, gxg_gtk_binding_entry_clear, 3, 0, 0, H_gtk_binding_entry_clear);
  XG_DEFINE_PROCEDURE(gtk_binding_set_add_path, gxg_gtk_binding_set_add_path, 4, 0, 0, H_gtk_binding_set_add_path);
  XG_DEFINE_PROCEDURE(gtk_binding_entry_remove, gxg_gtk_binding_entry_remove, 3, 0, 0, H_gtk_binding_entry_remove);
  XG_DEFINE_PROCEDURE(gtk_binding_entry_add_signall, gxg_gtk_binding_entry_add_signall, 5, 0, 0, H_gtk_binding_entry_add_signall);
  XG_DEFINE_PROCEDURE(gtk_binding_parse_binding, gxg_gtk_binding_parse_binding, 1, 0, 0, H_gtk_binding_parse_binding);
  XG_DEFINE_PROCEDURE(gtk_bin_get_type, gxg_gtk_bin_get_type, 0, 0, 0, H_gtk_bin_get_type);
  XG_DEFINE_PROCEDURE(gtk_bin_get_child, gxg_gtk_bin_get_child, 1, 0, 0, H_gtk_bin_get_child);
  XG_DEFINE_PROCEDURE(gtk_box_get_type, gxg_gtk_box_get_type, 0, 0, 0, H_gtk_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_box_pack_start, gxg_gtk_box_pack_start, 5, 0, 0, H_gtk_box_pack_start);
  XG_DEFINE_PROCEDURE(gtk_box_pack_end, gxg_gtk_box_pack_end, 5, 0, 0, H_gtk_box_pack_end);
  XG_DEFINE_PROCEDURE(gtk_box_pack_start_defaults, gxg_gtk_box_pack_start_defaults, 2, 0, 0, H_gtk_box_pack_start_defaults);
  XG_DEFINE_PROCEDURE(gtk_box_pack_end_defaults, gxg_gtk_box_pack_end_defaults, 2, 0, 0, H_gtk_box_pack_end_defaults);
  XG_DEFINE_PROCEDURE(gtk_box_set_homogeneous, gxg_gtk_box_set_homogeneous, 2, 0, 0, H_gtk_box_set_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_box_get_homogeneous, gxg_gtk_box_get_homogeneous, 1, 0, 0, H_gtk_box_get_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_box_set_spacing, gxg_gtk_box_set_spacing, 2, 0, 0, H_gtk_box_set_spacing);
  XG_DEFINE_PROCEDURE(gtk_box_get_spacing, gxg_gtk_box_get_spacing, 1, 0, 0, H_gtk_box_get_spacing);
  XG_DEFINE_PROCEDURE(gtk_box_reorder_child, gxg_gtk_box_reorder_child, 3, 0, 0, H_gtk_box_reorder_child);
  XG_DEFINE_PROCEDURE(gtk_box_query_child_packing, gxg_gtk_box_query_child_packing, 2, 4, 0, H_gtk_box_query_child_packing);
  XG_DEFINE_PROCEDURE(gtk_box_set_child_packing, gxg_gtk_box_set_child_packing, 6, 0, 0, H_gtk_box_set_child_packing);
  XG_DEFINE_PROCEDURE(gtk_button_get_type, gxg_gtk_button_get_type, 0, 0, 0, H_gtk_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_button_new, gxg_gtk_button_new, 0, 0, 0, H_gtk_button_new);
  XG_DEFINE_PROCEDURE(gtk_button_new_with_label, gxg_gtk_button_new_with_label, 1, 0, 0, H_gtk_button_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_button_new_from_stock, gxg_gtk_button_new_from_stock, 1, 0, 0, H_gtk_button_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_button_new_with_mnemonic, gxg_gtk_button_new_with_mnemonic, 1, 0, 0, H_gtk_button_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_button_pressed, gxg_gtk_button_pressed, 1, 0, 0, H_gtk_button_pressed);
  XG_DEFINE_PROCEDURE(gtk_button_released, gxg_gtk_button_released, 1, 0, 0, H_gtk_button_released);
  XG_DEFINE_PROCEDURE(gtk_button_clicked, gxg_gtk_button_clicked, 1, 0, 0, H_gtk_button_clicked);
  XG_DEFINE_PROCEDURE(gtk_button_enter, gxg_gtk_button_enter, 1, 0, 0, H_gtk_button_enter);
  XG_DEFINE_PROCEDURE(gtk_button_leave, gxg_gtk_button_leave, 1, 0, 0, H_gtk_button_leave);
  XG_DEFINE_PROCEDURE(gtk_button_set_relief, gxg_gtk_button_set_relief, 2, 0, 0, H_gtk_button_set_relief);
  XG_DEFINE_PROCEDURE(gtk_button_get_relief, gxg_gtk_button_get_relief, 1, 0, 0, H_gtk_button_get_relief);
  XG_DEFINE_PROCEDURE(gtk_button_set_label, gxg_gtk_button_set_label, 2, 0, 0, H_gtk_button_set_label);
  XG_DEFINE_PROCEDURE(gtk_button_get_label, gxg_gtk_button_get_label, 1, 0, 0, H_gtk_button_get_label);
  XG_DEFINE_PROCEDURE(gtk_button_set_use_underline, gxg_gtk_button_set_use_underline, 2, 0, 0, H_gtk_button_set_use_underline);
  XG_DEFINE_PROCEDURE(gtk_button_get_use_underline, gxg_gtk_button_get_use_underline, 1, 0, 0, H_gtk_button_get_use_underline);
  XG_DEFINE_PROCEDURE(gtk_button_set_use_stock, gxg_gtk_button_set_use_stock, 2, 0, 0, H_gtk_button_set_use_stock);
  XG_DEFINE_PROCEDURE(gtk_button_get_use_stock, gxg_gtk_button_get_use_stock, 1, 0, 0, H_gtk_button_get_use_stock);
  XG_DEFINE_PROCEDURE(gtk_calendar_get_type, gxg_gtk_calendar_get_type, 0, 0, 0, H_gtk_calendar_get_type);
  XG_DEFINE_PROCEDURE(gtk_calendar_new, gxg_gtk_calendar_new, 0, 0, 0, H_gtk_calendar_new);
  XG_DEFINE_PROCEDURE(gtk_calendar_select_month, gxg_gtk_calendar_select_month, 3, 0, 0, H_gtk_calendar_select_month);
  XG_DEFINE_PROCEDURE(gtk_calendar_select_day, gxg_gtk_calendar_select_day, 2, 0, 0, H_gtk_calendar_select_day);
  XG_DEFINE_PROCEDURE(gtk_calendar_mark_day, gxg_gtk_calendar_mark_day, 2, 0, 0, H_gtk_calendar_mark_day);
  XG_DEFINE_PROCEDURE(gtk_calendar_unmark_day, gxg_gtk_calendar_unmark_day, 2, 0, 0, H_gtk_calendar_unmark_day);
  XG_DEFINE_PROCEDURE(gtk_calendar_clear_marks, gxg_gtk_calendar_clear_marks, 1, 0, 0, H_gtk_calendar_clear_marks);
  XG_DEFINE_PROCEDURE(gtk_calendar_get_date, gxg_gtk_calendar_get_date, 1, 3, 0, H_gtk_calendar_get_date);
  XG_DEFINE_PROCEDURE(gtk_calendar_freeze, gxg_gtk_calendar_freeze, 1, 0, 0, H_gtk_calendar_freeze);
  XG_DEFINE_PROCEDURE(gtk_calendar_thaw, gxg_gtk_calendar_thaw, 1, 0, 0, H_gtk_calendar_thaw);
  XG_DEFINE_PROCEDURE(gtk_cell_editable_get_type, gxg_gtk_cell_editable_get_type, 0, 0, 0, H_gtk_cell_editable_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_editable_start_editing, gxg_gtk_cell_editable_start_editing, 2, 0, 0, H_gtk_cell_editable_start_editing);
  XG_DEFINE_PROCEDURE(gtk_cell_editable_editing_done, gxg_gtk_cell_editable_editing_done, 1, 0, 0, H_gtk_cell_editable_editing_done);
  XG_DEFINE_PROCEDURE(gtk_cell_editable_remove_widget, gxg_gtk_cell_editable_remove_widget, 1, 0, 0, H_gtk_cell_editable_remove_widget);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_get_type, gxg_gtk_cell_renderer_get_type, 0, 0, 0, H_gtk_cell_renderer_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_get_size, gxg_gtk_cell_renderer_get_size, 3, 4, 0, H_gtk_cell_renderer_get_size);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_render, gxg_gtk_cell_renderer_render, 7, 0, 0, H_gtk_cell_renderer_render);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_activate, gxg_gtk_cell_renderer_activate, 7, 0, 0, H_gtk_cell_renderer_activate);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_start_editing, gxg_gtk_cell_renderer_start_editing, 7, 0, 0, H_gtk_cell_renderer_start_editing);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_set_fixed_size, gxg_gtk_cell_renderer_set_fixed_size, 3, 0, 0, H_gtk_cell_renderer_set_fixed_size);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_get_fixed_size, gxg_gtk_cell_renderer_get_fixed_size, 1, 2, 0, H_gtk_cell_renderer_get_fixed_size);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_pixbuf_get_type, gxg_gtk_cell_renderer_pixbuf_get_type, 0, 0, 0, H_gtk_cell_renderer_pixbuf_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_pixbuf_new, gxg_gtk_cell_renderer_pixbuf_new, 0, 0, 0, H_gtk_cell_renderer_pixbuf_new);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_text_get_type, gxg_gtk_cell_renderer_text_get_type, 0, 0, 0, H_gtk_cell_renderer_text_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_text_new, gxg_gtk_cell_renderer_text_new, 0, 0, 0, H_gtk_cell_renderer_text_new);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_text_set_fixed_height_from_font, gxg_gtk_cell_renderer_text_set_fixed_height_from_font, 2, 0, 0, H_gtk_cell_renderer_text_set_fixed_height_from_font);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_get_type, gxg_gtk_cell_renderer_toggle_get_type, 0, 0, 0, H_gtk_cell_renderer_toggle_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_new, gxg_gtk_cell_renderer_toggle_new, 0, 0, 0, H_gtk_cell_renderer_toggle_new);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_get_radio, gxg_gtk_cell_renderer_toggle_get_radio, 1, 0, 0, H_gtk_cell_renderer_toggle_get_radio);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_set_radio, gxg_gtk_cell_renderer_toggle_set_radio, 2, 0, 0, H_gtk_cell_renderer_toggle_set_radio);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_get_active, gxg_gtk_cell_renderer_toggle_get_active, 1, 0, 0, H_gtk_cell_renderer_toggle_get_active);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_toggle_set_active, gxg_gtk_cell_renderer_toggle_set_active, 2, 0, 0, H_gtk_cell_renderer_toggle_set_active);
  XG_DEFINE_PROCEDURE(gtk_check_button_get_type, gxg_gtk_check_button_get_type, 0, 0, 0, H_gtk_check_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_check_button_new, gxg_gtk_check_button_new, 0, 0, 0, H_gtk_check_button_new);
  XG_DEFINE_PROCEDURE(gtk_check_button_new_with_label, gxg_gtk_check_button_new_with_label, 1, 0, 0, H_gtk_check_button_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_check_button_new_with_mnemonic, gxg_gtk_check_button_new_with_mnemonic, 1, 0, 0, H_gtk_check_button_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_get_type, gxg_gtk_check_menu_item_get_type, 0, 0, 0, H_gtk_check_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_new, gxg_gtk_check_menu_item_new, 0, 0, 0, H_gtk_check_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_new_with_label, gxg_gtk_check_menu_item_new_with_label, 1, 0, 0, H_gtk_check_menu_item_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_new_with_mnemonic, gxg_gtk_check_menu_item_new_with_mnemonic, 1, 0, 0, H_gtk_check_menu_item_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_set_active, gxg_gtk_check_menu_item_set_active, 2, 0, 0, H_gtk_check_menu_item_set_active);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_get_active, gxg_gtk_check_menu_item_get_active, 1, 0, 0, H_gtk_check_menu_item_get_active);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_toggled, gxg_gtk_check_menu_item_toggled, 1, 0, 0, H_gtk_check_menu_item_toggled);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_set_inconsistent, gxg_gtk_check_menu_item_set_inconsistent, 2, 0, 0, H_gtk_check_menu_item_set_inconsistent);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_get_inconsistent, gxg_gtk_check_menu_item_get_inconsistent, 1, 0, 0, H_gtk_check_menu_item_get_inconsistent);
  XG_DEFINE_PROCEDURE(gtk_clipboard_get, gxg_gtk_clipboard_get, 1, 0, 0, H_gtk_clipboard_get);
  XG_DEFINE_PROCEDURE(gtk_clipboard_set_with_data, gxg_gtk_clipboard_set_with_data, 5, 1, 0, H_gtk_clipboard_set_with_data);
  XG_DEFINE_PROCEDURE(gtk_clipboard_get_owner, gxg_gtk_clipboard_get_owner, 1, 0, 0, H_gtk_clipboard_get_owner);
  XG_DEFINE_PROCEDURE(gtk_clipboard_clear, gxg_gtk_clipboard_clear, 1, 0, 0, H_gtk_clipboard_clear);
  XG_DEFINE_PROCEDURE(gtk_clipboard_set_text, gxg_gtk_clipboard_set_text, 3, 0, 0, H_gtk_clipboard_set_text);
  XG_DEFINE_PROCEDURE(gtk_clipboard_request_contents, gxg_gtk_clipboard_request_contents, 3, 1, 0, H_gtk_clipboard_request_contents);
  XG_DEFINE_PROCEDURE(gtk_clipboard_request_text, gxg_gtk_clipboard_request_text, 2, 1, 0, H_gtk_clipboard_request_text);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_for_contents, gxg_gtk_clipboard_wait_for_contents, 2, 0, 0, H_gtk_clipboard_wait_for_contents);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_for_text, gxg_gtk_clipboard_wait_for_text, 1, 0, 0, H_gtk_clipboard_wait_for_text);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_is_text_available, gxg_gtk_clipboard_wait_is_text_available, 1, 0, 0, H_gtk_clipboard_wait_is_text_available);
  XG_DEFINE_PROCEDURE(gtk_color_selection_dialog_get_type, gxg_gtk_color_selection_dialog_get_type, 0, 0, 0, H_gtk_color_selection_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_color_selection_dialog_new, gxg_gtk_color_selection_dialog_new, 1, 0, 0, H_gtk_color_selection_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_type, gxg_gtk_color_selection_get_type, 0, 0, 0, H_gtk_color_selection_get_type);
  XG_DEFINE_PROCEDURE(gtk_color_selection_new, gxg_gtk_color_selection_new, 0, 0, 0, H_gtk_color_selection_new);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_has_opacity_control, gxg_gtk_color_selection_get_has_opacity_control, 1, 0, 0, H_gtk_color_selection_get_has_opacity_control);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_has_opacity_control, gxg_gtk_color_selection_set_has_opacity_control, 2, 0, 0, H_gtk_color_selection_set_has_opacity_control);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_has_palette, gxg_gtk_color_selection_get_has_palette, 1, 0, 0, H_gtk_color_selection_get_has_palette);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_has_palette, gxg_gtk_color_selection_set_has_palette, 2, 0, 0, H_gtk_color_selection_set_has_palette);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_current_color, gxg_gtk_color_selection_set_current_color, 2, 0, 0, H_gtk_color_selection_set_current_color);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_current_alpha, gxg_gtk_color_selection_set_current_alpha, 2, 0, 0, H_gtk_color_selection_set_current_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_current_color, gxg_gtk_color_selection_get_current_color, 2, 0, 0, H_gtk_color_selection_get_current_color);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_current_alpha, gxg_gtk_color_selection_get_current_alpha, 1, 0, 0, H_gtk_color_selection_get_current_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_previous_color, gxg_gtk_color_selection_set_previous_color, 2, 0, 0, H_gtk_color_selection_set_previous_color);
  XG_DEFINE_PROCEDURE(gtk_color_selection_set_previous_alpha, gxg_gtk_color_selection_set_previous_alpha, 2, 0, 0, H_gtk_color_selection_set_previous_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_previous_color, gxg_gtk_color_selection_get_previous_color, 2, 0, 0, H_gtk_color_selection_get_previous_color);
  XG_DEFINE_PROCEDURE(gtk_color_selection_get_previous_alpha, gxg_gtk_color_selection_get_previous_alpha, 1, 0, 0, H_gtk_color_selection_get_previous_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_selection_is_adjusting, gxg_gtk_color_selection_is_adjusting, 1, 0, 0, H_gtk_color_selection_is_adjusting);
  XG_DEFINE_PROCEDURE(gtk_color_selection_palette_from_string, gxg_gtk_color_selection_palette_from_string, 1, 2, 0, H_gtk_color_selection_palette_from_string);
  XG_DEFINE_PROCEDURE(gtk_color_selection_palette_to_string, gxg_gtk_color_selection_palette_to_string, 2, 0, 0, H_gtk_color_selection_palette_to_string);
  XG_DEFINE_PROCEDURE(GTK_IS_RESIZE_CONTAINER, gxg_GTK_IS_RESIZE_CONTAINER, 1, 0, 0, H_GTK_IS_RESIZE_CONTAINER);
  XG_DEFINE_PROCEDURE(gtk_container_get_type, gxg_gtk_container_get_type, 0, 0, 0, H_gtk_container_get_type);
  XG_DEFINE_PROCEDURE(gtk_container_set_border_width, gxg_gtk_container_set_border_width, 2, 0, 0, H_gtk_container_set_border_width);
  XG_DEFINE_PROCEDURE(gtk_container_get_border_width, gxg_gtk_container_get_border_width, 1, 0, 0, H_gtk_container_get_border_width);
  XG_DEFINE_PROCEDURE(gtk_container_add, gxg_gtk_container_add, 2, 0, 0, H_gtk_container_add);
  XG_DEFINE_PROCEDURE(gtk_container_remove, gxg_gtk_container_remove, 2, 0, 0, H_gtk_container_remove);
  XG_DEFINE_PROCEDURE(gtk_container_set_resize_mode, gxg_gtk_container_set_resize_mode, 2, 0, 0, H_gtk_container_set_resize_mode);
  XG_DEFINE_PROCEDURE(gtk_container_get_resize_mode, gxg_gtk_container_get_resize_mode, 1, 0, 0, H_gtk_container_get_resize_mode);
  XG_DEFINE_PROCEDURE(gtk_container_check_resize, gxg_gtk_container_check_resize, 1, 0, 0, H_gtk_container_check_resize);
  XG_DEFINE_PROCEDURE(gtk_container_foreach, gxg_gtk_container_foreach, 2, 1, 0, H_gtk_container_foreach);
  XG_DEFINE_PROCEDURE(gtk_container_get_children, gxg_gtk_container_get_children, 1, 0, 0, H_gtk_container_get_children);
  XG_DEFINE_PROCEDURE(gtk_curve_get_type, gxg_gtk_curve_get_type, 0, 0, 0, H_gtk_curve_get_type);
  XG_DEFINE_PROCEDURE(gtk_curve_new, gxg_gtk_curve_new, 0, 0, 0, H_gtk_curve_new);
  XG_DEFINE_PROCEDURE(gtk_curve_reset, gxg_gtk_curve_reset, 1, 0, 0, H_gtk_curve_reset);
  XG_DEFINE_PROCEDURE(gtk_curve_set_gamma, gxg_gtk_curve_set_gamma, 2, 0, 0, H_gtk_curve_set_gamma);
  XG_DEFINE_PROCEDURE(gtk_curve_set_range, gxg_gtk_curve_set_range, 5, 0, 0, H_gtk_curve_set_range);
  XG_DEFINE_PROCEDURE(gtk_curve_get_vector, gxg_gtk_curve_get_vector, 3, 0, 0, H_gtk_curve_get_vector);
  XG_DEFINE_PROCEDURE(gtk_curve_set_vector, gxg_gtk_curve_set_vector, 3, 0, 0, H_gtk_curve_set_vector);
  XG_DEFINE_PROCEDURE(gtk_curve_set_curve_type, gxg_gtk_curve_set_curve_type, 2, 0, 0, H_gtk_curve_set_curve_type);
  XG_DEFINE_PROCEDURE(gtk_dialog_get_type, gxg_gtk_dialog_get_type, 0, 0, 0, H_gtk_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_dialog_new, gxg_gtk_dialog_new, 0, 0, 0, H_gtk_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_dialog_new_with_buttons, gxg_gtk_dialog_new_with_buttons, 3, 1, 0, H_gtk_dialog_new_with_buttons);
  XG_DEFINE_PROCEDURE(gtk_dialog_add_action_widget, gxg_gtk_dialog_add_action_widget, 3, 0, 0, H_gtk_dialog_add_action_widget);
  XG_DEFINE_PROCEDURE(gtk_dialog_add_button, gxg_gtk_dialog_add_button, 3, 0, 0, H_gtk_dialog_add_button);
  XG_DEFINE_PROCEDURE(gtk_dialog_add_buttons, gxg_gtk_dialog_add_buttons, 2, 0, 0, H_gtk_dialog_add_buttons);
  XG_DEFINE_PROCEDURE(gtk_dialog_set_response_sensitive, gxg_gtk_dialog_set_response_sensitive, 3, 0, 0, H_gtk_dialog_set_response_sensitive);
  XG_DEFINE_PROCEDURE(gtk_dialog_set_default_response, gxg_gtk_dialog_set_default_response, 2, 0, 0, H_gtk_dialog_set_default_response);
  XG_DEFINE_PROCEDURE(gtk_dialog_set_has_separator, gxg_gtk_dialog_set_has_separator, 2, 0, 0, H_gtk_dialog_set_has_separator);
  XG_DEFINE_PROCEDURE(gtk_dialog_get_has_separator, gxg_gtk_dialog_get_has_separator, 1, 0, 0, H_gtk_dialog_get_has_separator);
  XG_DEFINE_PROCEDURE(gtk_dialog_response, gxg_gtk_dialog_response, 2, 0, 0, H_gtk_dialog_response);
  XG_DEFINE_PROCEDURE(gtk_dialog_run, gxg_gtk_dialog_run, 1, 0, 0, H_gtk_dialog_run);
  XG_DEFINE_PROCEDURE(gtk_drag_get_data, gxg_gtk_drag_get_data, 4, 0, 0, H_gtk_drag_get_data);
  XG_DEFINE_PROCEDURE(gtk_drag_finish, gxg_gtk_drag_finish, 4, 0, 0, H_gtk_drag_finish);
  XG_DEFINE_PROCEDURE(gtk_drag_get_source_widget, gxg_gtk_drag_get_source_widget, 1, 0, 0, H_gtk_drag_get_source_widget);
  XG_DEFINE_PROCEDURE(gtk_drag_highlight, gxg_gtk_drag_highlight, 1, 0, 0, H_gtk_drag_highlight);
  XG_DEFINE_PROCEDURE(gtk_drag_unhighlight, gxg_gtk_drag_unhighlight, 1, 0, 0, H_gtk_drag_unhighlight);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_set, gxg_gtk_drag_dest_set, 5, 0, 0, H_gtk_drag_dest_set);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_set_proxy, gxg_gtk_drag_dest_set_proxy, 4, 0, 0, H_gtk_drag_dest_set_proxy);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_unset, gxg_gtk_drag_dest_unset, 1, 0, 0, H_gtk_drag_dest_unset);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_find_target, gxg_gtk_drag_dest_find_target, 3, 0, 0, H_gtk_drag_dest_find_target);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_get_target_list, gxg_gtk_drag_dest_get_target_list, 1, 0, 0, H_gtk_drag_dest_get_target_list);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_set_target_list, gxg_gtk_drag_dest_set_target_list, 2, 0, 0, H_gtk_drag_dest_set_target_list);
  XG_DEFINE_PROCEDURE(gtk_drag_source_set, gxg_gtk_drag_source_set, 5, 0, 0, H_gtk_drag_source_set);
  XG_DEFINE_PROCEDURE(gtk_drag_source_unset, gxg_gtk_drag_source_unset, 1, 0, 0, H_gtk_drag_source_unset);
  XG_DEFINE_PROCEDURE(gtk_drag_source_set_icon, gxg_gtk_drag_source_set_icon, 4, 0, 0, H_gtk_drag_source_set_icon);
  XG_DEFINE_PROCEDURE(gtk_drag_source_set_icon_pixbuf, gxg_gtk_drag_source_set_icon_pixbuf, 2, 0, 0, H_gtk_drag_source_set_icon_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_drag_source_set_icon_stock, gxg_gtk_drag_source_set_icon_stock, 2, 0, 0, H_gtk_drag_source_set_icon_stock);
  XG_DEFINE_PROCEDURE(gtk_drag_begin, gxg_gtk_drag_begin, 5, 0, 0, H_gtk_drag_begin);
  XG_DEFINE_PROCEDURE(gtk_drag_set_icon_widget, gxg_gtk_drag_set_icon_widget, 4, 0, 0, H_gtk_drag_set_icon_widget);
  XG_DEFINE_PROCEDURE(gtk_drag_set_icon_pixmap, gxg_gtk_drag_set_icon_pixmap, 6, 0, 0, H_gtk_drag_set_icon_pixmap);
  XG_DEFINE_PROCEDURE(gtk_drag_set_icon_pixbuf, gxg_gtk_drag_set_icon_pixbuf, 4, 0, 0, H_gtk_drag_set_icon_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_drag_set_icon_stock, gxg_gtk_drag_set_icon_stock, 4, 0, 0, H_gtk_drag_set_icon_stock);
  XG_DEFINE_PROCEDURE(gtk_drag_set_icon_default, gxg_gtk_drag_set_icon_default, 1, 0, 0, H_gtk_drag_set_icon_default);
  XG_DEFINE_PROCEDURE(gtk_drag_check_threshold, gxg_gtk_drag_check_threshold, 5, 0, 0, H_gtk_drag_check_threshold);
  XG_DEFINE_PROCEDURE(gtk_drawing_area_get_type, gxg_gtk_drawing_area_get_type, 0, 0, 0, H_gtk_drawing_area_get_type);
  XG_DEFINE_PROCEDURE(gtk_drawing_area_new, gxg_gtk_drawing_area_new, 0, 0, 0, H_gtk_drawing_area_new);
  XG_DEFINE_PROCEDURE(gtk_editable_get_type, gxg_gtk_editable_get_type, 0, 0, 0, H_gtk_editable_get_type);
  XG_DEFINE_PROCEDURE(gtk_editable_select_region, gxg_gtk_editable_select_region, 3, 0, 0, H_gtk_editable_select_region);
  XG_DEFINE_PROCEDURE(gtk_editable_get_selection_bounds, gxg_gtk_editable_get_selection_bounds, 1, 2, 0, H_gtk_editable_get_selection_bounds);
  XG_DEFINE_PROCEDURE(gtk_editable_insert_text, gxg_gtk_editable_insert_text, 3, 1, 0, H_gtk_editable_insert_text);
  XG_DEFINE_PROCEDURE(gtk_editable_delete_text, gxg_gtk_editable_delete_text, 3, 0, 0, H_gtk_editable_delete_text);
  XG_DEFINE_PROCEDURE(gtk_editable_get_chars, gxg_gtk_editable_get_chars, 3, 0, 0, H_gtk_editable_get_chars);
  XG_DEFINE_PROCEDURE(gtk_editable_cut_clipboard, gxg_gtk_editable_cut_clipboard, 1, 0, 0, H_gtk_editable_cut_clipboard);
  XG_DEFINE_PROCEDURE(gtk_editable_copy_clipboard, gxg_gtk_editable_copy_clipboard, 1, 0, 0, H_gtk_editable_copy_clipboard);
  XG_DEFINE_PROCEDURE(gtk_editable_paste_clipboard, gxg_gtk_editable_paste_clipboard, 1, 0, 0, H_gtk_editable_paste_clipboard);
  XG_DEFINE_PROCEDURE(gtk_editable_delete_selection, gxg_gtk_editable_delete_selection, 1, 0, 0, H_gtk_editable_delete_selection);
  XG_DEFINE_PROCEDURE(gtk_editable_set_position, gxg_gtk_editable_set_position, 2, 0, 0, H_gtk_editable_set_position);
  XG_DEFINE_PROCEDURE(gtk_editable_get_position, gxg_gtk_editable_get_position, 1, 0, 0, H_gtk_editable_get_position);
  XG_DEFINE_PROCEDURE(gtk_editable_set_editable, gxg_gtk_editable_set_editable, 2, 0, 0, H_gtk_editable_set_editable);
  XG_DEFINE_PROCEDURE(gtk_editable_get_editable, gxg_gtk_editable_get_editable, 1, 0, 0, H_gtk_editable_get_editable);
  XG_DEFINE_PROCEDURE(gtk_entry_get_type, gxg_gtk_entry_get_type, 0, 0, 0, H_gtk_entry_get_type);
  XG_DEFINE_PROCEDURE(gtk_entry_new, gxg_gtk_entry_new, 0, 0, 0, H_gtk_entry_new);
  XG_DEFINE_PROCEDURE(gtk_entry_set_visibility, gxg_gtk_entry_set_visibility, 2, 0, 0, H_gtk_entry_set_visibility);
  XG_DEFINE_PROCEDURE(gtk_entry_get_visibility, gxg_gtk_entry_get_visibility, 1, 0, 0, H_gtk_entry_get_visibility);
  XG_DEFINE_PROCEDURE(gtk_entry_set_invisible_char, gxg_gtk_entry_set_invisible_char, 2, 0, 0, H_gtk_entry_set_invisible_char);
  XG_DEFINE_PROCEDURE(gtk_entry_get_invisible_char, gxg_gtk_entry_get_invisible_char, 1, 0, 0, H_gtk_entry_get_invisible_char);
  XG_DEFINE_PROCEDURE(gtk_entry_set_has_frame, gxg_gtk_entry_set_has_frame, 2, 0, 0, H_gtk_entry_set_has_frame);
  XG_DEFINE_PROCEDURE(gtk_entry_get_has_frame, gxg_gtk_entry_get_has_frame, 1, 0, 0, H_gtk_entry_get_has_frame);
  XG_DEFINE_PROCEDURE(gtk_entry_set_max_length, gxg_gtk_entry_set_max_length, 2, 0, 0, H_gtk_entry_set_max_length);
  XG_DEFINE_PROCEDURE(gtk_entry_get_max_length, gxg_gtk_entry_get_max_length, 1, 0, 0, H_gtk_entry_get_max_length);
  XG_DEFINE_PROCEDURE(gtk_entry_set_activates_default, gxg_gtk_entry_set_activates_default, 2, 0, 0, H_gtk_entry_set_activates_default);
  XG_DEFINE_PROCEDURE(gtk_entry_get_activates_default, gxg_gtk_entry_get_activates_default, 1, 0, 0, H_gtk_entry_get_activates_default);
  XG_DEFINE_PROCEDURE(gtk_entry_set_width_chars, gxg_gtk_entry_set_width_chars, 2, 0, 0, H_gtk_entry_set_width_chars);
  XG_DEFINE_PROCEDURE(gtk_entry_get_width_chars, gxg_gtk_entry_get_width_chars, 1, 0, 0, H_gtk_entry_get_width_chars);
  XG_DEFINE_PROCEDURE(gtk_entry_set_text, gxg_gtk_entry_set_text, 2, 0, 0, H_gtk_entry_set_text);
  XG_DEFINE_PROCEDURE(gtk_entry_get_text, gxg_gtk_entry_get_text, 1, 0, 0, H_gtk_entry_get_text);
  XG_DEFINE_PROCEDURE(gtk_entry_get_layout, gxg_gtk_entry_get_layout, 1, 0, 0, H_gtk_entry_get_layout);
  XG_DEFINE_PROCEDURE(gtk_entry_get_layout_offsets, gxg_gtk_entry_get_layout_offsets, 1, 2, 0, H_gtk_entry_get_layout_offsets);
  XG_DEFINE_PROCEDURE(gtk_event_box_get_type, gxg_gtk_event_box_get_type, 0, 0, 0, H_gtk_event_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_event_box_new, gxg_gtk_event_box_new, 0, 0, 0, H_gtk_event_box_new);
  XG_DEFINE_PROCEDURE(gtk_file_selection_get_type, gxg_gtk_file_selection_get_type, 0, 0, 0, H_gtk_file_selection_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_selection_new, gxg_gtk_file_selection_new, 1, 0, 0, H_gtk_file_selection_new);
  XG_DEFINE_PROCEDURE(gtk_file_selection_set_filename, gxg_gtk_file_selection_set_filename, 2, 0, 0, H_gtk_file_selection_set_filename);
  XG_DEFINE_PROCEDURE(gtk_file_selection_get_filename, gxg_gtk_file_selection_get_filename, 1, 0, 0, H_gtk_file_selection_get_filename);
  XG_DEFINE_PROCEDURE(gtk_file_selection_complete, gxg_gtk_file_selection_complete, 2, 0, 0, H_gtk_file_selection_complete);
  XG_DEFINE_PROCEDURE(gtk_file_selection_show_fileop_buttons, gxg_gtk_file_selection_show_fileop_buttons, 1, 0, 0, H_gtk_file_selection_show_fileop_buttons);
  XG_DEFINE_PROCEDURE(gtk_file_selection_hide_fileop_buttons, gxg_gtk_file_selection_hide_fileop_buttons, 1, 0, 0, H_gtk_file_selection_hide_fileop_buttons);
  XG_DEFINE_PROCEDURE(gtk_file_selection_get_selections, gxg_gtk_file_selection_get_selections, 1, 0, 0, H_gtk_file_selection_get_selections);
  XG_DEFINE_PROCEDURE(gtk_file_selection_set_select_multiple, gxg_gtk_file_selection_set_select_multiple, 2, 0, 0, H_gtk_file_selection_set_select_multiple);
  XG_DEFINE_PROCEDURE(gtk_file_selection_get_select_multiple, gxg_gtk_file_selection_get_select_multiple, 1, 0, 0, H_gtk_file_selection_get_select_multiple);
  XG_DEFINE_PROCEDURE(gtk_icon_set_get_type, gxg_gtk_icon_set_get_type, 0, 0, 0, H_gtk_icon_set_get_type);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_type, gxg_gtk_icon_source_get_type, 0, 0, 0, H_gtk_icon_source_get_type);
  XG_DEFINE_PROCEDURE(gtk_selection_data_get_type, gxg_gtk_selection_data_get_type, 0, 0, 0, H_gtk_selection_data_get_type);
  XG_DEFINE_PROCEDURE(gtk_border_get_type, gxg_gtk_border_get_type, 0, 0, 0, H_gtk_border_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_path_get_type, gxg_gtk_tree_path_get_type, 0, 0, 0, H_gtk_tree_path_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_iter_get_type, gxg_gtk_tree_iter_get_type, 0, 0, 0, H_gtk_tree_iter_get_type);
  XG_DEFINE_PROCEDURE(gtk_identifier_get_type, gxg_gtk_identifier_get_type, 0, 0, 0, H_gtk_identifier_get_type);
  XG_DEFINE_PROCEDURE(gtk_requisition_get_type, gxg_gtk_requisition_get_type, 0, 0, 0, H_gtk_requisition_get_type);
  XG_DEFINE_PROCEDURE(gtk_fixed_get_type, gxg_gtk_fixed_get_type, 0, 0, 0, H_gtk_fixed_get_type);
  XG_DEFINE_PROCEDURE(gtk_fixed_new, gxg_gtk_fixed_new, 0, 0, 0, H_gtk_fixed_new);
  XG_DEFINE_PROCEDURE(gtk_fixed_put, gxg_gtk_fixed_put, 4, 0, 0, H_gtk_fixed_put);
  XG_DEFINE_PROCEDURE(gtk_fixed_move, gxg_gtk_fixed_move, 4, 0, 0, H_gtk_fixed_move);
  XG_DEFINE_PROCEDURE(gtk_fixed_set_has_window, gxg_gtk_fixed_set_has_window, 2, 0, 0, H_gtk_fixed_set_has_window);
  XG_DEFINE_PROCEDURE(gtk_fixed_get_has_window, gxg_gtk_fixed_get_has_window, 1, 0, 0, H_gtk_fixed_get_has_window);
  XG_DEFINE_PROCEDURE(gtk_font_selection_get_type, gxg_gtk_font_selection_get_type, 0, 0, 0, H_gtk_font_selection_get_type);
  XG_DEFINE_PROCEDURE(gtk_font_selection_new, gxg_gtk_font_selection_new, 0, 0, 0, H_gtk_font_selection_new);
  XG_DEFINE_PROCEDURE(gtk_font_selection_get_font_name, gxg_gtk_font_selection_get_font_name, 1, 0, 0, H_gtk_font_selection_get_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_selection_set_font_name, gxg_gtk_font_selection_set_font_name, 2, 0, 0, H_gtk_font_selection_set_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_selection_get_preview_text, gxg_gtk_font_selection_get_preview_text, 1, 0, 0, H_gtk_font_selection_get_preview_text);
  XG_DEFINE_PROCEDURE(gtk_font_selection_set_preview_text, gxg_gtk_font_selection_set_preview_text, 2, 0, 0, H_gtk_font_selection_set_preview_text);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_get_type, gxg_gtk_font_selection_dialog_get_type, 0, 0, 0, H_gtk_font_selection_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_new, gxg_gtk_font_selection_dialog_new, 1, 0, 0, H_gtk_font_selection_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_get_font_name, gxg_gtk_font_selection_dialog_get_font_name, 1, 0, 0, H_gtk_font_selection_dialog_get_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_set_font_name, gxg_gtk_font_selection_dialog_set_font_name, 2, 0, 0, H_gtk_font_selection_dialog_set_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_get_preview_text, gxg_gtk_font_selection_dialog_get_preview_text, 1, 0, 0, H_gtk_font_selection_dialog_get_preview_text);
  XG_DEFINE_PROCEDURE(gtk_font_selection_dialog_set_preview_text, gxg_gtk_font_selection_dialog_set_preview_text, 2, 0, 0, H_gtk_font_selection_dialog_set_preview_text);
  XG_DEFINE_PROCEDURE(gtk_frame_get_type, gxg_gtk_frame_get_type, 0, 0, 0, H_gtk_frame_get_type);
  XG_DEFINE_PROCEDURE(gtk_frame_new, gxg_gtk_frame_new, 1, 0, 0, H_gtk_frame_new);
  XG_DEFINE_PROCEDURE(gtk_frame_set_label, gxg_gtk_frame_set_label, 2, 0, 0, H_gtk_frame_set_label);
  XG_DEFINE_PROCEDURE(gtk_frame_get_label, gxg_gtk_frame_get_label, 1, 0, 0, H_gtk_frame_get_label);
  XG_DEFINE_PROCEDURE(gtk_frame_set_label_widget, gxg_gtk_frame_set_label_widget, 2, 0, 0, H_gtk_frame_set_label_widget);
  XG_DEFINE_PROCEDURE(gtk_frame_get_label_widget, gxg_gtk_frame_get_label_widget, 1, 0, 0, H_gtk_frame_get_label_widget);
  XG_DEFINE_PROCEDURE(gtk_frame_set_label_align, gxg_gtk_frame_set_label_align, 3, 0, 0, H_gtk_frame_set_label_align);
  XG_DEFINE_PROCEDURE(gtk_frame_get_label_align, gxg_gtk_frame_get_label_align, 1, 2, 0, H_gtk_frame_get_label_align);
  XG_DEFINE_PROCEDURE(gtk_frame_set_shadow_type, gxg_gtk_frame_set_shadow_type, 2, 0, 0, H_gtk_frame_set_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_frame_get_shadow_type, gxg_gtk_frame_get_shadow_type, 1, 0, 0, H_gtk_frame_get_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_gamma_curve_get_type, gxg_gtk_gamma_curve_get_type, 0, 0, 0, H_gtk_gamma_curve_get_type);
  XG_DEFINE_PROCEDURE(gtk_gamma_curve_new, gxg_gtk_gamma_curve_new, 0, 0, 0, H_gtk_gamma_curve_new);
  XG_DEFINE_PROCEDURE(gtk_gc_get, gxg_gtk_gc_get, 4, 0, 0, H_gtk_gc_get);
  XG_DEFINE_PROCEDURE(gtk_gc_release, gxg_gtk_gc_release, 1, 0, 0, H_gtk_gc_release);
  XG_DEFINE_PROCEDURE(gtk_handle_box_get_type, gxg_gtk_handle_box_get_type, 0, 0, 0, H_gtk_handle_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_handle_box_new, gxg_gtk_handle_box_new, 0, 0, 0, H_gtk_handle_box_new);
  XG_DEFINE_PROCEDURE(gtk_handle_box_set_shadow_type, gxg_gtk_handle_box_set_shadow_type, 2, 0, 0, H_gtk_handle_box_set_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_handle_box_get_shadow_type, gxg_gtk_handle_box_get_shadow_type, 1, 0, 0, H_gtk_handle_box_get_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_handle_box_set_handle_position, gxg_gtk_handle_box_set_handle_position, 2, 0, 0, H_gtk_handle_box_set_handle_position);
  XG_DEFINE_PROCEDURE(gtk_handle_box_get_handle_position, gxg_gtk_handle_box_get_handle_position, 1, 0, 0, H_gtk_handle_box_get_handle_position);
  XG_DEFINE_PROCEDURE(gtk_handle_box_set_snap_edge, gxg_gtk_handle_box_set_snap_edge, 2, 0, 0, H_gtk_handle_box_set_snap_edge);
  XG_DEFINE_PROCEDURE(gtk_handle_box_get_snap_edge, gxg_gtk_handle_box_get_snap_edge, 1, 0, 0, H_gtk_handle_box_get_snap_edge);
  XG_DEFINE_PROCEDURE(gtk_hbutton_box_get_type, gxg_gtk_hbutton_box_get_type, 0, 0, 0, H_gtk_hbutton_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_hbutton_box_new, gxg_gtk_hbutton_box_new, 0, 0, 0, H_gtk_hbutton_box_new);
  XG_DEFINE_PROCEDURE(gtk_hbox_get_type, gxg_gtk_hbox_get_type, 0, 0, 0, H_gtk_hbox_get_type);
  XG_DEFINE_PROCEDURE(gtk_hbox_new, gxg_gtk_hbox_new, 2, 0, 0, H_gtk_hbox_new);
  XG_DEFINE_PROCEDURE(gtk_hpaned_get_type, gxg_gtk_hpaned_get_type, 0, 0, 0, H_gtk_hpaned_get_type);
  XG_DEFINE_PROCEDURE(gtk_hpaned_new, gxg_gtk_hpaned_new, 0, 0, 0, H_gtk_hpaned_new);
  XG_DEFINE_PROCEDURE(gtk_hruler_get_type, gxg_gtk_hruler_get_type, 0, 0, 0, H_gtk_hruler_get_type);
  XG_DEFINE_PROCEDURE(gtk_hruler_new, gxg_gtk_hruler_new, 0, 0, 0, H_gtk_hruler_new);
  XG_DEFINE_PROCEDURE(gtk_hscale_get_type, gxg_gtk_hscale_get_type, 0, 0, 0, H_gtk_hscale_get_type);
  XG_DEFINE_PROCEDURE(gtk_hscale_new, gxg_gtk_hscale_new, 1, 0, 0, H_gtk_hscale_new);
  XG_DEFINE_PROCEDURE(gtk_hscale_new_with_range, gxg_gtk_hscale_new_with_range, 3, 0, 0, H_gtk_hscale_new_with_range);
  XG_DEFINE_PROCEDURE(gtk_hscrollbar_get_type, gxg_gtk_hscrollbar_get_type, 0, 0, 0, H_gtk_hscrollbar_get_type);
  XG_DEFINE_PROCEDURE(gtk_hscrollbar_new, gxg_gtk_hscrollbar_new, 1, 0, 0, H_gtk_hscrollbar_new);
  XG_DEFINE_PROCEDURE(gtk_hseparator_get_type, gxg_gtk_hseparator_get_type, 0, 0, 0, H_gtk_hseparator_get_type);
  XG_DEFINE_PROCEDURE(gtk_hseparator_new, gxg_gtk_hseparator_new, 0, 0, 0, H_gtk_hseparator_new);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_get_type, gxg_gtk_icon_factory_get_type, 0, 0, 0, H_gtk_icon_factory_get_type);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_new, gxg_gtk_icon_factory_new, 0, 0, 0, H_gtk_icon_factory_new);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_add, gxg_gtk_icon_factory_add, 3, 0, 0, H_gtk_icon_factory_add);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_lookup, gxg_gtk_icon_factory_lookup, 2, 0, 0, H_gtk_icon_factory_lookup);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_add_default, gxg_gtk_icon_factory_add_default, 1, 0, 0, H_gtk_icon_factory_add_default);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_remove_default, gxg_gtk_icon_factory_remove_default, 1, 0, 0, H_gtk_icon_factory_remove_default);
  XG_DEFINE_PROCEDURE(gtk_icon_factory_lookup_default, gxg_gtk_icon_factory_lookup_default, 1, 0, 0, H_gtk_icon_factory_lookup_default);
  XG_DEFINE_PROCEDURE(gtk_icon_size_lookup, gxg_gtk_icon_size_lookup, 1, 2, 0, H_gtk_icon_size_lookup);
  XG_DEFINE_PROCEDURE(gtk_icon_size_register, gxg_gtk_icon_size_register, 3, 0, 0, H_gtk_icon_size_register);
  XG_DEFINE_PROCEDURE(gtk_icon_size_register_alias, gxg_gtk_icon_size_register_alias, 2, 0, 0, H_gtk_icon_size_register_alias);
  XG_DEFINE_PROCEDURE(gtk_icon_size_from_name, gxg_gtk_icon_size_from_name, 1, 0, 0, H_gtk_icon_size_from_name);
  XG_DEFINE_PROCEDURE(gtk_icon_size_get_name, gxg_gtk_icon_size_get_name, 1, 0, 0, H_gtk_icon_size_get_name);
  XG_DEFINE_PROCEDURE(gtk_icon_set_new, gxg_gtk_icon_set_new, 0, 0, 0, H_gtk_icon_set_new);
  XG_DEFINE_PROCEDURE(gtk_icon_set_new_from_pixbuf, gxg_gtk_icon_set_new_from_pixbuf, 1, 0, 0, H_gtk_icon_set_new_from_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_icon_set_ref, gxg_gtk_icon_set_ref, 1, 0, 0, H_gtk_icon_set_ref);
  XG_DEFINE_PROCEDURE(gtk_icon_set_unref, gxg_gtk_icon_set_unref, 1, 0, 0, H_gtk_icon_set_unref);
  XG_DEFINE_PROCEDURE(gtk_icon_set_copy, gxg_gtk_icon_set_copy, 1, 0, 0, H_gtk_icon_set_copy);
  XG_DEFINE_PROCEDURE(gtk_icon_set_render_icon, gxg_gtk_icon_set_render_icon, 7, 0, 0, H_gtk_icon_set_render_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_set_add_source, gxg_gtk_icon_set_add_source, 2, 0, 0, H_gtk_icon_set_add_source);
  XG_DEFINE_PROCEDURE(gtk_icon_set_get_sizes, gxg_gtk_icon_set_get_sizes, 1, 2, 0, H_gtk_icon_set_get_sizes);
  XG_DEFINE_PROCEDURE(gtk_icon_source_new, gxg_gtk_icon_source_new, 0, 0, 0, H_gtk_icon_source_new);
  XG_DEFINE_PROCEDURE(gtk_icon_source_copy, gxg_gtk_icon_source_copy, 1, 0, 0, H_gtk_icon_source_copy);
  XG_DEFINE_PROCEDURE(gtk_icon_source_free, gxg_gtk_icon_source_free, 1, 0, 0, H_gtk_icon_source_free);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_filename, gxg_gtk_icon_source_set_filename, 2, 0, 0, H_gtk_icon_source_set_filename);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_pixbuf, gxg_gtk_icon_source_set_pixbuf, 2, 0, 0, H_gtk_icon_source_set_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_filename, gxg_gtk_icon_source_get_filename, 1, 0, 0, H_gtk_icon_source_get_filename);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_pixbuf, gxg_gtk_icon_source_get_pixbuf, 1, 0, 0, H_gtk_icon_source_get_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_direction_wildcarded, gxg_gtk_icon_source_set_direction_wildcarded, 2, 0, 0, H_gtk_icon_source_set_direction_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_state_wildcarded, gxg_gtk_icon_source_set_state_wildcarded, 2, 0, 0, H_gtk_icon_source_set_state_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_size_wildcarded, gxg_gtk_icon_source_set_size_wildcarded, 2, 0, 0, H_gtk_icon_source_set_size_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_size_wildcarded, gxg_gtk_icon_source_get_size_wildcarded, 1, 0, 0, H_gtk_icon_source_get_size_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_state_wildcarded, gxg_gtk_icon_source_get_state_wildcarded, 1, 0, 0, H_gtk_icon_source_get_state_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_direction_wildcarded, gxg_gtk_icon_source_get_direction_wildcarded, 1, 0, 0, H_gtk_icon_source_get_direction_wildcarded);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_direction, gxg_gtk_icon_source_set_direction, 2, 0, 0, H_gtk_icon_source_set_direction);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_state, gxg_gtk_icon_source_set_state, 2, 0, 0, H_gtk_icon_source_set_state);
  XG_DEFINE_PROCEDURE(gtk_icon_source_set_size, gxg_gtk_icon_source_set_size, 2, 0, 0, H_gtk_icon_source_set_size);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_direction, gxg_gtk_icon_source_get_direction, 1, 0, 0, H_gtk_icon_source_get_direction);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_state, gxg_gtk_icon_source_get_state, 1, 0, 0, H_gtk_icon_source_get_state);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_size, gxg_gtk_icon_source_get_size, 1, 0, 0, H_gtk_icon_source_get_size);
  XG_DEFINE_PROCEDURE(gtk_image_get_type, gxg_gtk_image_get_type, 0, 0, 0, H_gtk_image_get_type);
  XG_DEFINE_PROCEDURE(gtk_image_new, gxg_gtk_image_new, 0, 0, 0, H_gtk_image_new);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_pixmap, gxg_gtk_image_new_from_pixmap, 2, 0, 0, H_gtk_image_new_from_pixmap);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_image, gxg_gtk_image_new_from_image, 2, 0, 0, H_gtk_image_new_from_image);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_file, gxg_gtk_image_new_from_file, 1, 0, 0, H_gtk_image_new_from_file);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_pixbuf, gxg_gtk_image_new_from_pixbuf, 1, 0, 0, H_gtk_image_new_from_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_stock, gxg_gtk_image_new_from_stock, 2, 0, 0, H_gtk_image_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_icon_set, gxg_gtk_image_new_from_icon_set, 2, 0, 0, H_gtk_image_new_from_icon_set);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_animation, gxg_gtk_image_new_from_animation, 1, 0, 0, H_gtk_image_new_from_animation);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_pixmap, gxg_gtk_image_set_from_pixmap, 3, 0, 0, H_gtk_image_set_from_pixmap);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_image, gxg_gtk_image_set_from_image, 3, 0, 0, H_gtk_image_set_from_image);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_file, gxg_gtk_image_set_from_file, 2, 0, 0, H_gtk_image_set_from_file);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_pixbuf, gxg_gtk_image_set_from_pixbuf, 2, 0, 0, H_gtk_image_set_from_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_stock, gxg_gtk_image_set_from_stock, 3, 0, 0, H_gtk_image_set_from_stock);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_icon_set, gxg_gtk_image_set_from_icon_set, 3, 0, 0, H_gtk_image_set_from_icon_set);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_animation, gxg_gtk_image_set_from_animation, 2, 0, 0, H_gtk_image_set_from_animation);
  XG_DEFINE_PROCEDURE(gtk_image_get_storage_type, gxg_gtk_image_get_storage_type, 1, 0, 0, H_gtk_image_get_storage_type);
  XG_DEFINE_PROCEDURE(gtk_image_get_pixmap, gxg_gtk_image_get_pixmap, 1, 2, 0, H_gtk_image_get_pixmap);
  XG_DEFINE_PROCEDURE(gtk_image_get_image, gxg_gtk_image_get_image, 1, 2, 0, H_gtk_image_get_image);
  XG_DEFINE_PROCEDURE(gtk_image_get_pixbuf, gxg_gtk_image_get_pixbuf, 1, 0, 0, H_gtk_image_get_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_image_get_stock, gxg_gtk_image_get_stock, 1, 2, 0, H_gtk_image_get_stock);
  XG_DEFINE_PROCEDURE(gtk_image_get_icon_set, gxg_gtk_image_get_icon_set, 1, 2, 0, H_gtk_image_get_icon_set);
  XG_DEFINE_PROCEDURE(gtk_image_get_animation, gxg_gtk_image_get_animation, 1, 0, 0, H_gtk_image_get_animation);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_get_type, gxg_gtk_image_menu_item_get_type, 0, 0, 0, H_gtk_image_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_new, gxg_gtk_image_menu_item_new, 0, 0, 0, H_gtk_image_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_new_with_label, gxg_gtk_image_menu_item_new_with_label, 1, 0, 0, H_gtk_image_menu_item_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_new_with_mnemonic, gxg_gtk_image_menu_item_new_with_mnemonic, 1, 0, 0, H_gtk_image_menu_item_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_new_from_stock, gxg_gtk_image_menu_item_new_from_stock, 2, 0, 0, H_gtk_image_menu_item_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_set_image, gxg_gtk_image_menu_item_set_image, 2, 0, 0, H_gtk_image_menu_item_set_image);
  XG_DEFINE_PROCEDURE(gtk_image_menu_item_get_image, gxg_gtk_image_menu_item_get_image, 1, 0, 0, H_gtk_image_menu_item_get_image);
  XG_DEFINE_PROCEDURE(gtk_im_context_get_type, gxg_gtk_im_context_get_type, 0, 0, 0, H_gtk_im_context_get_type);
  XG_DEFINE_PROCEDURE(gtk_im_context_set_client_window, gxg_gtk_im_context_set_client_window, 2, 0, 0, H_gtk_im_context_set_client_window);
  XG_DEFINE_PROCEDURE(gtk_im_context_get_preedit_string, gxg_gtk_im_context_get_preedit_string, 1, 3, 0, H_gtk_im_context_get_preedit_string);
  XG_DEFINE_PROCEDURE(gtk_im_context_filter_keypress, gxg_gtk_im_context_filter_keypress, 2, 0, 0, H_gtk_im_context_filter_keypress);
  XG_DEFINE_PROCEDURE(gtk_im_context_focus_in, gxg_gtk_im_context_focus_in, 1, 0, 0, H_gtk_im_context_focus_in);
  XG_DEFINE_PROCEDURE(gtk_im_context_focus_out, gxg_gtk_im_context_focus_out, 1, 0, 0, H_gtk_im_context_focus_out);
  XG_DEFINE_PROCEDURE(gtk_im_context_reset, gxg_gtk_im_context_reset, 1, 0, 0, H_gtk_im_context_reset);
  XG_DEFINE_PROCEDURE(gtk_im_context_set_cursor_location, gxg_gtk_im_context_set_cursor_location, 2, 0, 0, H_gtk_im_context_set_cursor_location);
  XG_DEFINE_PROCEDURE(gtk_im_context_set_use_preedit, gxg_gtk_im_context_set_use_preedit, 2, 0, 0, H_gtk_im_context_set_use_preedit);
  XG_DEFINE_PROCEDURE(gtk_im_context_set_surrounding, gxg_gtk_im_context_set_surrounding, 4, 0, 0, H_gtk_im_context_set_surrounding);
  XG_DEFINE_PROCEDURE(gtk_im_context_get_surrounding, gxg_gtk_im_context_get_surrounding, 1, 2, 0, H_gtk_im_context_get_surrounding);
  XG_DEFINE_PROCEDURE(gtk_im_context_delete_surrounding, gxg_gtk_im_context_delete_surrounding, 3, 0, 0, H_gtk_im_context_delete_surrounding);
  XG_DEFINE_PROCEDURE(gtk_im_context_simple_get_type, gxg_gtk_im_context_simple_get_type, 0, 0, 0, H_gtk_im_context_simple_get_type);
  XG_DEFINE_PROCEDURE(gtk_im_context_simple_new, gxg_gtk_im_context_simple_new, 0, 0, 0, H_gtk_im_context_simple_new);
  XG_DEFINE_PROCEDURE(gtk_im_context_simple_add_table, gxg_gtk_im_context_simple_add_table, 4, 0, 0, H_gtk_im_context_simple_add_table);
  XG_DEFINE_PROCEDURE(gtk_im_multicontext_get_type, gxg_gtk_im_multicontext_get_type, 0, 0, 0, H_gtk_im_multicontext_get_type);
  XG_DEFINE_PROCEDURE(gtk_im_multicontext_new, gxg_gtk_im_multicontext_new, 0, 0, 0, H_gtk_im_multicontext_new);
  XG_DEFINE_PROCEDURE(gtk_im_multicontext_append_menuitems, gxg_gtk_im_multicontext_append_menuitems, 2, 0, 0, H_gtk_im_multicontext_append_menuitems);
  XG_DEFINE_PROCEDURE(gtk_input_dialog_get_type, gxg_gtk_input_dialog_get_type, 0, 0, 0, H_gtk_input_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_input_dialog_new, gxg_gtk_input_dialog_new, 0, 0, 0, H_gtk_input_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_invisible_get_type, gxg_gtk_invisible_get_type, 0, 0, 0, H_gtk_invisible_get_type);
  XG_DEFINE_PROCEDURE(gtk_invisible_new, gxg_gtk_invisible_new, 0, 0, 0, H_gtk_invisible_new);
  XG_DEFINE_PROCEDURE(gtk_item_get_type, gxg_gtk_item_get_type, 0, 0, 0, H_gtk_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_item_select, gxg_gtk_item_select, 1, 0, 0, H_gtk_item_select);
  XG_DEFINE_PROCEDURE(gtk_item_deselect, gxg_gtk_item_deselect, 1, 0, 0, H_gtk_item_deselect);
  XG_DEFINE_PROCEDURE(gtk_item_toggle, gxg_gtk_item_toggle, 1, 0, 0, H_gtk_item_toggle);
  XG_DEFINE_PROCEDURE(gtk_label_get_type, gxg_gtk_label_get_type, 0, 0, 0, H_gtk_label_get_type);
  XG_DEFINE_PROCEDURE(gtk_label_new, gxg_gtk_label_new, 1, 0, 0, H_gtk_label_new);
  XG_DEFINE_PROCEDURE(gtk_label_new_with_mnemonic, gxg_gtk_label_new_with_mnemonic, 1, 0, 0, H_gtk_label_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_label_set_text, gxg_gtk_label_set_text, 2, 0, 0, H_gtk_label_set_text);
  XG_DEFINE_PROCEDURE(gtk_label_get_text, gxg_gtk_label_get_text, 1, 0, 0, H_gtk_label_get_text);
  XG_DEFINE_PROCEDURE(gtk_label_set_attributes, gxg_gtk_label_set_attributes, 2, 0, 0, H_gtk_label_set_attributes);
  XG_DEFINE_PROCEDURE(gtk_label_get_attributes, gxg_gtk_label_get_attributes, 1, 0, 0, H_gtk_label_get_attributes);
  XG_DEFINE_PROCEDURE(gtk_label_set_label, gxg_gtk_label_set_label, 2, 0, 0, H_gtk_label_set_label);
  XG_DEFINE_PROCEDURE(gtk_label_get_label, gxg_gtk_label_get_label, 1, 0, 0, H_gtk_label_get_label);
  XG_DEFINE_PROCEDURE(gtk_label_set_markup, gxg_gtk_label_set_markup, 2, 0, 0, H_gtk_label_set_markup);
  XG_DEFINE_PROCEDURE(gtk_label_set_use_markup, gxg_gtk_label_set_use_markup, 2, 0, 0, H_gtk_label_set_use_markup);
  XG_DEFINE_PROCEDURE(gtk_label_get_use_markup, gxg_gtk_label_get_use_markup, 1, 0, 0, H_gtk_label_get_use_markup);
  XG_DEFINE_PROCEDURE(gtk_label_set_use_underline, gxg_gtk_label_set_use_underline, 2, 0, 0, H_gtk_label_set_use_underline);
  XG_DEFINE_PROCEDURE(gtk_label_get_use_underline, gxg_gtk_label_get_use_underline, 1, 0, 0, H_gtk_label_get_use_underline);
  XG_DEFINE_PROCEDURE(gtk_label_set_markup_with_mnemonic, gxg_gtk_label_set_markup_with_mnemonic, 2, 0, 0, H_gtk_label_set_markup_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_label_get_mnemonic_keyval, gxg_gtk_label_get_mnemonic_keyval, 1, 0, 0, H_gtk_label_get_mnemonic_keyval);
  XG_DEFINE_PROCEDURE(gtk_label_set_mnemonic_widget, gxg_gtk_label_set_mnemonic_widget, 2, 0, 0, H_gtk_label_set_mnemonic_widget);
  XG_DEFINE_PROCEDURE(gtk_label_get_mnemonic_widget, gxg_gtk_label_get_mnemonic_widget, 1, 0, 0, H_gtk_label_get_mnemonic_widget);
  XG_DEFINE_PROCEDURE(gtk_label_set_text_with_mnemonic, gxg_gtk_label_set_text_with_mnemonic, 2, 0, 0, H_gtk_label_set_text_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_label_set_justify, gxg_gtk_label_set_justify, 2, 0, 0, H_gtk_label_set_justify);
  XG_DEFINE_PROCEDURE(gtk_label_get_justify, gxg_gtk_label_get_justify, 1, 0, 0, H_gtk_label_get_justify);
  XG_DEFINE_PROCEDURE(gtk_label_set_pattern, gxg_gtk_label_set_pattern, 2, 0, 0, H_gtk_label_set_pattern);
  XG_DEFINE_PROCEDURE(gtk_label_set_line_wrap, gxg_gtk_label_set_line_wrap, 2, 0, 0, H_gtk_label_set_line_wrap);
  XG_DEFINE_PROCEDURE(gtk_label_get_line_wrap, gxg_gtk_label_get_line_wrap, 1, 0, 0, H_gtk_label_get_line_wrap);
  XG_DEFINE_PROCEDURE(gtk_label_set_selectable, gxg_gtk_label_set_selectable, 2, 0, 0, H_gtk_label_set_selectable);
  XG_DEFINE_PROCEDURE(gtk_label_get_selectable, gxg_gtk_label_get_selectable, 1, 0, 0, H_gtk_label_get_selectable);
  XG_DEFINE_PROCEDURE(gtk_label_select_region, gxg_gtk_label_select_region, 3, 0, 0, H_gtk_label_select_region);
  XG_DEFINE_PROCEDURE(gtk_label_get_selection_bounds, gxg_gtk_label_get_selection_bounds, 1, 2, 0, H_gtk_label_get_selection_bounds);
  XG_DEFINE_PROCEDURE(gtk_label_get_layout, gxg_gtk_label_get_layout, 1, 0, 0, H_gtk_label_get_layout);
  XG_DEFINE_PROCEDURE(gtk_label_get_layout_offsets, gxg_gtk_label_get_layout_offsets, 1, 2, 0, H_gtk_label_get_layout_offsets);
  XG_DEFINE_PROCEDURE(gtk_layout_get_type, gxg_gtk_layout_get_type, 0, 0, 0, H_gtk_layout_get_type);
  XG_DEFINE_PROCEDURE(gtk_layout_new, gxg_gtk_layout_new, 2, 0, 0, H_gtk_layout_new);
  XG_DEFINE_PROCEDURE(gtk_layout_put, gxg_gtk_layout_put, 4, 0, 0, H_gtk_layout_put);
  XG_DEFINE_PROCEDURE(gtk_layout_move, gxg_gtk_layout_move, 4, 0, 0, H_gtk_layout_move);
  XG_DEFINE_PROCEDURE(gtk_layout_set_size, gxg_gtk_layout_set_size, 3, 0, 0, H_gtk_layout_set_size);
  XG_DEFINE_PROCEDURE(gtk_layout_get_size, gxg_gtk_layout_get_size, 1, 2, 0, H_gtk_layout_get_size);
  XG_DEFINE_PROCEDURE(gtk_layout_get_hadjustment, gxg_gtk_layout_get_hadjustment, 1, 0, 0, H_gtk_layout_get_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_layout_get_vadjustment, gxg_gtk_layout_get_vadjustment, 1, 0, 0, H_gtk_layout_get_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_layout_set_hadjustment, gxg_gtk_layout_set_hadjustment, 2, 0, 0, H_gtk_layout_set_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_layout_set_vadjustment, gxg_gtk_layout_set_vadjustment, 2, 0, 0, H_gtk_layout_set_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_list_store_get_type, gxg_gtk_list_store_get_type, 0, 0, 0, H_gtk_list_store_get_type);
  XG_DEFINE_PROCEDURE(gtk_list_store_new, gxg_gtk_list_store_new, 2, 0, 0, H_gtk_list_store_new);
  XG_DEFINE_PROCEDURE(gtk_list_store_newv, gxg_gtk_list_store_newv, 2, 0, 0, H_gtk_list_store_newv);
  XG_DEFINE_PROCEDURE(gtk_list_store_set_column_types, gxg_gtk_list_store_set_column_types, 3, 0, 0, H_gtk_list_store_set_column_types);
  XG_DEFINE_PROCEDURE(gtk_list_store_set, gxg_gtk_list_store_set, 3, 0, 0, H_gtk_list_store_set);
  XG_DEFINE_PROCEDURE(gtk_list_store_insert, gxg_gtk_list_store_insert, 3, 0, 0, H_gtk_list_store_insert);
  XG_DEFINE_PROCEDURE(gtk_list_store_insert_before, gxg_gtk_list_store_insert_before, 3, 0, 0, H_gtk_list_store_insert_before);
  XG_DEFINE_PROCEDURE(gtk_list_store_insert_after, gxg_gtk_list_store_insert_after, 3, 0, 0, H_gtk_list_store_insert_after);
  XG_DEFINE_PROCEDURE(gtk_list_store_prepend, gxg_gtk_list_store_prepend, 2, 0, 0, H_gtk_list_store_prepend);
  XG_DEFINE_PROCEDURE(gtk_list_store_append, gxg_gtk_list_store_append, 2, 0, 0, H_gtk_list_store_append);
  XG_DEFINE_PROCEDURE(gtk_list_store_clear, gxg_gtk_list_store_clear, 1, 0, 0, H_gtk_list_store_clear);
  XG_DEFINE_PROCEDURE(gtk_check_version, gxg_gtk_check_version, 3, 0, 0, H_gtk_check_version);
  XG_DEFINE_PROCEDURE(gtk_init, gxg_gtk_init, 0, 2, 0, H_gtk_init);
  XG_DEFINE_PROCEDURE(gtk_init_check, gxg_gtk_init_check, 0, 2, 0, H_gtk_init_check);
  XG_DEFINE_PROCEDURE(gtk_disable_setlocale, gxg_gtk_disable_setlocale, 0, 0, 0, H_gtk_disable_setlocale);
  XG_DEFINE_PROCEDURE(gtk_set_locale, gxg_gtk_set_locale, 0, 0, 0, H_gtk_set_locale);
  XG_DEFINE_PROCEDURE(gtk_get_default_language, gxg_gtk_get_default_language, 0, 0, 0, H_gtk_get_default_language);
  XG_DEFINE_PROCEDURE(gtk_events_pending, gxg_gtk_events_pending, 0, 0, 0, H_gtk_events_pending);
  XG_DEFINE_PROCEDURE(gtk_main_do_event, gxg_gtk_main_do_event, 1, 0, 0, H_gtk_main_do_event);
  XG_DEFINE_PROCEDURE(gtk_main, gxg_gtk_main, 0, 0, 0, H_gtk_main);
  XG_DEFINE_PROCEDURE(gtk_main_level, gxg_gtk_main_level, 0, 0, 0, H_gtk_main_level);
  XG_DEFINE_PROCEDURE(gtk_main_quit, gxg_gtk_main_quit, 0, 0, 0, H_gtk_main_quit);
  XG_DEFINE_PROCEDURE(gtk_main_iteration, gxg_gtk_main_iteration, 0, 0, 0, H_gtk_main_iteration);
  XG_DEFINE_PROCEDURE(gtk_main_iteration_do, gxg_gtk_main_iteration_do, 1, 0, 0, H_gtk_main_iteration_do);
  XG_DEFINE_PROCEDURE(gtk_true, gxg_gtk_true, 0, 0, 0, H_gtk_true);
  XG_DEFINE_PROCEDURE(gtk_false, gxg_gtk_false, 0, 0, 0, H_gtk_false);
  XG_DEFINE_PROCEDURE(gtk_grab_add, gxg_gtk_grab_add, 1, 0, 0, H_gtk_grab_add);
  XG_DEFINE_PROCEDURE(gtk_grab_get_current, gxg_gtk_grab_get_current, 0, 0, 0, H_gtk_grab_get_current);
  XG_DEFINE_PROCEDURE(gtk_grab_remove, gxg_gtk_grab_remove, 1, 0, 0, H_gtk_grab_remove);
  XG_DEFINE_PROCEDURE(gtk_init_add, gxg_gtk_init_add, 1, 1, 0, H_gtk_init_add);
  XG_DEFINE_PROCEDURE(gtk_quit_add_destroy, gxg_gtk_quit_add_destroy, 2, 0, 0, H_gtk_quit_add_destroy);
  XG_DEFINE_PROCEDURE(gtk_quit_add, gxg_gtk_quit_add, 2, 1, 0, H_gtk_quit_add);
  XG_DEFINE_PROCEDURE(gtk_quit_remove, gxg_gtk_quit_remove, 1, 0, 0, H_gtk_quit_remove);
  XG_DEFINE_PROCEDURE(gtk_quit_remove_by_data, gxg_gtk_quit_remove_by_data, 1, 0, 0, H_gtk_quit_remove_by_data);
  XG_DEFINE_PROCEDURE(gtk_key_snooper_install, gxg_gtk_key_snooper_install, 1, 1, 0, H_gtk_key_snooper_install);
  XG_DEFINE_PROCEDURE(gtk_key_snooper_remove, gxg_gtk_key_snooper_remove, 1, 0, 0, H_gtk_key_snooper_remove);
  XG_DEFINE_PROCEDURE(gtk_get_current_event, gxg_gtk_get_current_event, 0, 0, 0, H_gtk_get_current_event);
  XG_DEFINE_PROCEDURE(gtk_get_current_event_time, gxg_gtk_get_current_event_time, 0, 0, 0, H_gtk_get_current_event_time);
  XG_DEFINE_PROCEDURE(gtk_get_current_event_state, gxg_gtk_get_current_event_state, 0, 1, 0, H_gtk_get_current_event_state);
  XG_DEFINE_PROCEDURE(gtk_get_event_widget, gxg_gtk_get_event_widget, 1, 0, 0, H_gtk_get_event_widget);
  XG_DEFINE_PROCEDURE(gtk_propagate_event, gxg_gtk_propagate_event, 2, 0, 0, H_gtk_propagate_event);
  XG_DEFINE_PROCEDURE(gtk_menu_bar_get_type, gxg_gtk_menu_bar_get_type, 0, 0, 0, H_gtk_menu_bar_get_type);
  XG_DEFINE_PROCEDURE(gtk_menu_bar_new, gxg_gtk_menu_bar_new, 0, 0, 0, H_gtk_menu_bar_new);
  XG_DEFINE_PROCEDURE(gtk_menu_get_type, gxg_gtk_menu_get_type, 0, 0, 0, H_gtk_menu_get_type);
  XG_DEFINE_PROCEDURE(gtk_menu_new, gxg_gtk_menu_new, 0, 0, 0, H_gtk_menu_new);
  XG_DEFINE_PROCEDURE(gtk_menu_popup, gxg_gtk_menu_popup, 7, 0, 0, H_gtk_menu_popup);
  XG_DEFINE_PROCEDURE(gtk_menu_reposition, gxg_gtk_menu_reposition, 1, 0, 0, H_gtk_menu_reposition);
  XG_DEFINE_PROCEDURE(gtk_menu_popdown, gxg_gtk_menu_popdown, 1, 0, 0, H_gtk_menu_popdown);
  XG_DEFINE_PROCEDURE(gtk_menu_get_active, gxg_gtk_menu_get_active, 1, 0, 0, H_gtk_menu_get_active);
  XG_DEFINE_PROCEDURE(gtk_menu_set_active, gxg_gtk_menu_set_active, 2, 0, 0, H_gtk_menu_set_active);
  XG_DEFINE_PROCEDURE(gtk_menu_set_accel_group, gxg_gtk_menu_set_accel_group, 2, 0, 0, H_gtk_menu_set_accel_group);
  XG_DEFINE_PROCEDURE(gtk_menu_get_accel_group, gxg_gtk_menu_get_accel_group, 1, 0, 0, H_gtk_menu_get_accel_group);
  XG_DEFINE_PROCEDURE(gtk_menu_set_accel_path, gxg_gtk_menu_set_accel_path, 2, 0, 0, H_gtk_menu_set_accel_path);
  XG_DEFINE_PROCEDURE(gtk_menu_detach, gxg_gtk_menu_detach, 1, 0, 0, H_gtk_menu_detach);
  XG_DEFINE_PROCEDURE(gtk_menu_get_attach_widget, gxg_gtk_menu_get_attach_widget, 1, 0, 0, H_gtk_menu_get_attach_widget);
  XG_DEFINE_PROCEDURE(gtk_menu_set_tearoff_state, gxg_gtk_menu_set_tearoff_state, 2, 0, 0, H_gtk_menu_set_tearoff_state);
  XG_DEFINE_PROCEDURE(gtk_menu_get_tearoff_state, gxg_gtk_menu_get_tearoff_state, 1, 0, 0, H_gtk_menu_get_tearoff_state);
  XG_DEFINE_PROCEDURE(gtk_menu_set_title, gxg_gtk_menu_set_title, 2, 0, 0, H_gtk_menu_set_title);
  XG_DEFINE_PROCEDURE(gtk_menu_get_title, gxg_gtk_menu_get_title, 1, 0, 0, H_gtk_menu_get_title);
  XG_DEFINE_PROCEDURE(gtk_menu_reorder_child, gxg_gtk_menu_reorder_child, 3, 0, 0, H_gtk_menu_reorder_child);
  XG_DEFINE_PROCEDURE(gtk_menu_item_get_type, gxg_gtk_menu_item_get_type, 0, 0, 0, H_gtk_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_menu_item_new, gxg_gtk_menu_item_new, 0, 0, 0, H_gtk_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_menu_item_new_with_label, gxg_gtk_menu_item_new_with_label, 1, 0, 0, H_gtk_menu_item_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_menu_item_new_with_mnemonic, gxg_gtk_menu_item_new_with_mnemonic, 1, 0, 0, H_gtk_menu_item_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_menu_item_set_submenu, gxg_gtk_menu_item_set_submenu, 2, 0, 0, H_gtk_menu_item_set_submenu);
  XG_DEFINE_PROCEDURE(gtk_menu_item_get_submenu, gxg_gtk_menu_item_get_submenu, 1, 0, 0, H_gtk_menu_item_get_submenu);
  XG_DEFINE_PROCEDURE(gtk_menu_item_remove_submenu, gxg_gtk_menu_item_remove_submenu, 1, 0, 0, H_gtk_menu_item_remove_submenu);
  XG_DEFINE_PROCEDURE(gtk_menu_item_select, gxg_gtk_menu_item_select, 1, 0, 0, H_gtk_menu_item_select);
  XG_DEFINE_PROCEDURE(gtk_menu_item_deselect, gxg_gtk_menu_item_deselect, 1, 0, 0, H_gtk_menu_item_deselect);
  XG_DEFINE_PROCEDURE(gtk_menu_item_activate, gxg_gtk_menu_item_activate, 1, 0, 0, H_gtk_menu_item_activate);
  XG_DEFINE_PROCEDURE(gtk_menu_item_toggle_size_request, gxg_gtk_menu_item_toggle_size_request, 2, 0, 0, H_gtk_menu_item_toggle_size_request);
  XG_DEFINE_PROCEDURE(gtk_menu_item_toggle_size_allocate, gxg_gtk_menu_item_toggle_size_allocate, 2, 0, 0, H_gtk_menu_item_toggle_size_allocate);
  XG_DEFINE_PROCEDURE(gtk_menu_item_set_right_justified, gxg_gtk_menu_item_set_right_justified, 2, 0, 0, H_gtk_menu_item_set_right_justified);
  XG_DEFINE_PROCEDURE(gtk_menu_item_get_right_justified, gxg_gtk_menu_item_get_right_justified, 1, 0, 0, H_gtk_menu_item_get_right_justified);
  XG_DEFINE_PROCEDURE(gtk_menu_item_set_accel_path, gxg_gtk_menu_item_set_accel_path, 2, 0, 0, H_gtk_menu_item_set_accel_path);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_get_type, gxg_gtk_menu_shell_get_type, 0, 0, 0, H_gtk_menu_shell_get_type);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_append, gxg_gtk_menu_shell_append, 2, 0, 0, H_gtk_menu_shell_append);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_prepend, gxg_gtk_menu_shell_prepend, 2, 0, 0, H_gtk_menu_shell_prepend);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_insert, gxg_gtk_menu_shell_insert, 3, 0, 0, H_gtk_menu_shell_insert);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_deactivate, gxg_gtk_menu_shell_deactivate, 1, 0, 0, H_gtk_menu_shell_deactivate);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_select_item, gxg_gtk_menu_shell_select_item, 2, 0, 0, H_gtk_menu_shell_select_item);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_deselect, gxg_gtk_menu_shell_deselect, 1, 0, 0, H_gtk_menu_shell_deselect);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_activate_item, gxg_gtk_menu_shell_activate_item, 3, 0, 0, H_gtk_menu_shell_activate_item);
  XG_DEFINE_PROCEDURE(gtk_message_dialog_get_type, gxg_gtk_message_dialog_get_type, 0, 0, 0, H_gtk_message_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_misc_get_type, gxg_gtk_misc_get_type, 0, 0, 0, H_gtk_misc_get_type);
  XG_DEFINE_PROCEDURE(gtk_misc_set_alignment, gxg_gtk_misc_set_alignment, 3, 0, 0, H_gtk_misc_set_alignment);
  XG_DEFINE_PROCEDURE(gtk_misc_get_alignment, gxg_gtk_misc_get_alignment, 1, 2, 0, H_gtk_misc_get_alignment);
  XG_DEFINE_PROCEDURE(gtk_misc_set_padding, gxg_gtk_misc_set_padding, 3, 0, 0, H_gtk_misc_set_padding);
  XG_DEFINE_PROCEDURE(gtk_misc_get_padding, gxg_gtk_misc_get_padding, 1, 2, 0, H_gtk_misc_get_padding);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_type, gxg_gtk_notebook_get_type, 0, 0, 0, H_gtk_notebook_get_type);
  XG_DEFINE_PROCEDURE(gtk_notebook_new, gxg_gtk_notebook_new, 0, 0, 0, H_gtk_notebook_new);
  XG_DEFINE_PROCEDURE(gtk_notebook_remove_page, gxg_gtk_notebook_remove_page, 2, 0, 0, H_gtk_notebook_remove_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_current_page, gxg_gtk_notebook_get_current_page, 1, 0, 0, H_gtk_notebook_get_current_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_nth_page, gxg_gtk_notebook_get_nth_page, 2, 0, 0, H_gtk_notebook_get_nth_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_page_num, gxg_gtk_notebook_page_num, 2, 0, 0, H_gtk_notebook_page_num);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_current_page, gxg_gtk_notebook_set_current_page, 2, 0, 0, H_gtk_notebook_set_current_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_next_page, gxg_gtk_notebook_next_page, 1, 0, 0, H_gtk_notebook_next_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_prev_page, gxg_gtk_notebook_prev_page, 1, 0, 0, H_gtk_notebook_prev_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_show_border, gxg_gtk_notebook_set_show_border, 2, 0, 0, H_gtk_notebook_set_show_border);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_show_border, gxg_gtk_notebook_get_show_border, 1, 0, 0, H_gtk_notebook_get_show_border);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_show_tabs, gxg_gtk_notebook_set_show_tabs, 2, 0, 0, H_gtk_notebook_set_show_tabs);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_show_tabs, gxg_gtk_notebook_get_show_tabs, 1, 0, 0, H_gtk_notebook_get_show_tabs);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_tab_pos, gxg_gtk_notebook_set_tab_pos, 2, 0, 0, H_gtk_notebook_set_tab_pos);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_tab_pos, gxg_gtk_notebook_get_tab_pos, 1, 0, 0, H_gtk_notebook_get_tab_pos);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_scrollable, gxg_gtk_notebook_set_scrollable, 2, 0, 0, H_gtk_notebook_set_scrollable);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_scrollable, gxg_gtk_notebook_get_scrollable, 1, 0, 0, H_gtk_notebook_get_scrollable);
  XG_DEFINE_PROCEDURE(gtk_notebook_popup_enable, gxg_gtk_notebook_popup_enable, 1, 0, 0, H_gtk_notebook_popup_enable);
  XG_DEFINE_PROCEDURE(gtk_notebook_popup_disable, gxg_gtk_notebook_popup_disable, 1, 0, 0, H_gtk_notebook_popup_disable);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_tab_label, gxg_gtk_notebook_get_tab_label, 2, 0, 0, H_gtk_notebook_get_tab_label);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_tab_label, gxg_gtk_notebook_set_tab_label, 3, 0, 0, H_gtk_notebook_set_tab_label);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_tab_label_text, gxg_gtk_notebook_set_tab_label_text, 3, 0, 0, H_gtk_notebook_set_tab_label_text);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_tab_label_text, gxg_gtk_notebook_get_tab_label_text, 2, 0, 0, H_gtk_notebook_get_tab_label_text);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_menu_label, gxg_gtk_notebook_get_menu_label, 2, 0, 0, H_gtk_notebook_get_menu_label);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_menu_label, gxg_gtk_notebook_set_menu_label, 3, 0, 0, H_gtk_notebook_set_menu_label);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_menu_label_text, gxg_gtk_notebook_set_menu_label_text, 3, 0, 0, H_gtk_notebook_set_menu_label_text);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_menu_label_text, gxg_gtk_notebook_get_menu_label_text, 2, 0, 0, H_gtk_notebook_get_menu_label_text);
  XG_DEFINE_PROCEDURE(gtk_notebook_query_tab_label_packing, gxg_gtk_notebook_query_tab_label_packing, 2, 3, 0, H_gtk_notebook_query_tab_label_packing);
  XG_DEFINE_PROCEDURE(gtk_notebook_set_tab_label_packing, gxg_gtk_notebook_set_tab_label_packing, 5, 0, 0, H_gtk_notebook_set_tab_label_packing);
  XG_DEFINE_PROCEDURE(gtk_notebook_reorder_child, gxg_gtk_notebook_reorder_child, 3, 0, 0, H_gtk_notebook_reorder_child);
  XG_DEFINE_PROCEDURE(GTK_OBJECT_TYPE_NAME, gxg_GTK_OBJECT_TYPE_NAME, 1, 0, 0, H_GTK_OBJECT_TYPE_NAME);
  XG_DEFINE_PROCEDURE(GTK_OBJECT_FLAGS, gxg_GTK_OBJECT_FLAGS, 1, 0, 0, H_GTK_OBJECT_FLAGS);
  XG_DEFINE_PROCEDURE(GTK_OBJECT_FLOATING, gxg_GTK_OBJECT_FLOATING, 1, 0, 0, H_GTK_OBJECT_FLOATING);
  XG_DEFINE_PROCEDURE(GTK_OBJECT_SET_FLAGS, gxg_GTK_OBJECT_SET_FLAGS, 2, 0, 0, H_GTK_OBJECT_SET_FLAGS);
  XG_DEFINE_PROCEDURE(GTK_OBJECT_UNSET_FLAGS, gxg_GTK_OBJECT_UNSET_FLAGS, 2, 0, 0, H_GTK_OBJECT_UNSET_FLAGS);
  XG_DEFINE_PROCEDURE(gtk_object_get_type, gxg_gtk_object_get_type, 0, 0, 0, H_gtk_object_get_type);
  XG_DEFINE_PROCEDURE(gtk_object_sink, gxg_gtk_object_sink, 1, 0, 0, H_gtk_object_sink);
  XG_DEFINE_PROCEDURE(gtk_object_destroy, gxg_gtk_object_destroy, 1, 0, 0, H_gtk_object_destroy);
  XG_DEFINE_PROCEDURE(gtk_paned_get_type, gxg_gtk_paned_get_type, 0, 0, 0, H_gtk_paned_get_type);
  XG_DEFINE_PROCEDURE(gtk_paned_add1, gxg_gtk_paned_add1, 2, 0, 0, H_gtk_paned_add1);
  XG_DEFINE_PROCEDURE(gtk_paned_add2, gxg_gtk_paned_add2, 2, 0, 0, H_gtk_paned_add2);
  XG_DEFINE_PROCEDURE(gtk_paned_pack1, gxg_gtk_paned_pack1, 4, 0, 0, H_gtk_paned_pack1);
  XG_DEFINE_PROCEDURE(gtk_paned_pack2, gxg_gtk_paned_pack2, 4, 0, 0, H_gtk_paned_pack2);
  XG_DEFINE_PROCEDURE(gtk_paned_get_position, gxg_gtk_paned_get_position, 1, 0, 0, H_gtk_paned_get_position);
  XG_DEFINE_PROCEDURE(gtk_paned_set_position, gxg_gtk_paned_set_position, 2, 0, 0, H_gtk_paned_set_position);
  XG_DEFINE_PROCEDURE(gtk_plug_get_type, gxg_gtk_plug_get_type, 0, 0, 0, H_gtk_plug_get_type);
  XG_DEFINE_PROCEDURE(gtk_plug_construct, gxg_gtk_plug_construct, 2, 0, 0, H_gtk_plug_construct);
  XG_DEFINE_PROCEDURE(gtk_plug_new, gxg_gtk_plug_new, 1, 0, 0, H_gtk_plug_new);
  XG_DEFINE_PROCEDURE(gtk_plug_get_id, gxg_gtk_plug_get_id, 1, 0, 0, H_gtk_plug_get_id);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_type, gxg_gtk_progress_bar_get_type, 0, 0, 0, H_gtk_progress_bar_get_type);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_new, gxg_gtk_progress_bar_new, 0, 0, 0, H_gtk_progress_bar_new);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_pulse, gxg_gtk_progress_bar_pulse, 1, 0, 0, H_gtk_progress_bar_pulse);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_set_text, gxg_gtk_progress_bar_set_text, 2, 0, 0, H_gtk_progress_bar_set_text);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_set_fraction, gxg_gtk_progress_bar_set_fraction, 2, 0, 0, H_gtk_progress_bar_set_fraction);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_set_pulse_step, gxg_gtk_progress_bar_set_pulse_step, 2, 0, 0, H_gtk_progress_bar_set_pulse_step);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_set_orientation, gxg_gtk_progress_bar_set_orientation, 2, 0, 0, H_gtk_progress_bar_set_orientation);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_text, gxg_gtk_progress_bar_get_text, 1, 0, 0, H_gtk_progress_bar_get_text);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_fraction, gxg_gtk_progress_bar_get_fraction, 1, 0, 0, H_gtk_progress_bar_get_fraction);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_pulse_step, gxg_gtk_progress_bar_get_pulse_step, 1, 0, 0, H_gtk_progress_bar_get_pulse_step);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_orientation, gxg_gtk_progress_bar_get_orientation, 1, 0, 0, H_gtk_progress_bar_get_orientation);
  XG_DEFINE_PROCEDURE(gtk_radio_button_get_type, gxg_gtk_radio_button_get_type, 0, 0, 0, H_gtk_radio_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new, gxg_gtk_radio_button_new, 1, 0, 0, H_gtk_radio_button_new);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new_from_widget, gxg_gtk_radio_button_new_from_widget, 1, 0, 0, H_gtk_radio_button_new_from_widget);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new_with_label, gxg_gtk_radio_button_new_with_label, 2, 0, 0, H_gtk_radio_button_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new_with_label_from_widget, gxg_gtk_radio_button_new_with_label_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_label_from_widget);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new_with_mnemonic, gxg_gtk_radio_button_new_with_mnemonic, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_radio_button_new_with_mnemonic_from_widget, gxg_gtk_radio_button_new_with_mnemonic_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic_from_widget);
  XG_DEFINE_PROCEDURE(gtk_radio_button_get_group, gxg_gtk_radio_button_get_group, 1, 0, 0, H_gtk_radio_button_get_group);
  XG_DEFINE_PROCEDURE(gtk_radio_button_set_group, gxg_gtk_radio_button_set_group, 2, 0, 0, H_gtk_radio_button_set_group);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_get_type, gxg_gtk_radio_menu_item_get_type, 0, 0, 0, H_gtk_radio_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new, gxg_gtk_radio_menu_item_new, 1, 0, 0, H_gtk_radio_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new_with_label, gxg_gtk_radio_menu_item_new_with_label, 2, 0, 0, H_gtk_radio_menu_item_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new_with_mnemonic, gxg_gtk_radio_menu_item_new_with_mnemonic, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_get_group, gxg_gtk_radio_menu_item_get_group, 1, 0, 0, H_gtk_radio_menu_item_get_group);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_set_group, gxg_gtk_radio_menu_item_set_group, 2, 0, 0, H_gtk_radio_menu_item_set_group);
  XG_DEFINE_PROCEDURE(gtk_range_get_type, gxg_gtk_range_get_type, 0, 0, 0, H_gtk_range_get_type);
  XG_DEFINE_PROCEDURE(gtk_range_set_update_policy, gxg_gtk_range_set_update_policy, 2, 0, 0, H_gtk_range_set_update_policy);
  XG_DEFINE_PROCEDURE(gtk_range_get_update_policy, gxg_gtk_range_get_update_policy, 1, 0, 0, H_gtk_range_get_update_policy);
  XG_DEFINE_PROCEDURE(gtk_range_set_adjustment, gxg_gtk_range_set_adjustment, 2, 0, 0, H_gtk_range_set_adjustment);
  XG_DEFINE_PROCEDURE(gtk_range_get_adjustment, gxg_gtk_range_get_adjustment, 1, 0, 0, H_gtk_range_get_adjustment);
  XG_DEFINE_PROCEDURE(gtk_range_set_inverted, gxg_gtk_range_set_inverted, 2, 0, 0, H_gtk_range_set_inverted);
  XG_DEFINE_PROCEDURE(gtk_range_get_inverted, gxg_gtk_range_get_inverted, 1, 0, 0, H_gtk_range_get_inverted);
  XG_DEFINE_PROCEDURE(gtk_range_set_increments, gxg_gtk_range_set_increments, 3, 0, 0, H_gtk_range_set_increments);
  XG_DEFINE_PROCEDURE(gtk_range_set_range, gxg_gtk_range_set_range, 3, 0, 0, H_gtk_range_set_range);
  XG_DEFINE_PROCEDURE(gtk_range_set_value, gxg_gtk_range_set_value, 2, 0, 0, H_gtk_range_set_value);
  XG_DEFINE_PROCEDURE(gtk_range_get_value, gxg_gtk_range_get_value, 1, 0, 0, H_gtk_range_get_value);
  XG_DEFINE_PROCEDURE(gtk_rc_add_default_file, gxg_gtk_rc_add_default_file, 1, 0, 0, H_gtk_rc_add_default_file);
  XG_DEFINE_PROCEDURE(gtk_rc_set_default_files, gxg_gtk_rc_set_default_files, 1, 0, 0, H_gtk_rc_set_default_files);
  XG_DEFINE_PROCEDURE(gtk_rc_get_default_files, gxg_gtk_rc_get_default_files, 0, 0, 0, H_gtk_rc_get_default_files);
  XG_DEFINE_PROCEDURE(gtk_rc_get_style, gxg_gtk_rc_get_style, 1, 0, 0, H_gtk_rc_get_style);
  XG_DEFINE_PROCEDURE(gtk_rc_parse, gxg_gtk_rc_parse, 1, 0, 0, H_gtk_rc_parse);
  XG_DEFINE_PROCEDURE(gtk_rc_parse_string, gxg_gtk_rc_parse_string, 1, 0, 0, H_gtk_rc_parse_string);
  XG_DEFINE_PROCEDURE(gtk_rc_reparse_all, gxg_gtk_rc_reparse_all, 0, 0, 0, H_gtk_rc_reparse_all);
  XG_DEFINE_PROCEDURE(gtk_rc_style_get_type, gxg_gtk_rc_style_get_type, 0, 0, 0, H_gtk_rc_style_get_type);
  XG_DEFINE_PROCEDURE(gtk_rc_style_new, gxg_gtk_rc_style_new, 0, 0, 0, H_gtk_rc_style_new);
  XG_DEFINE_PROCEDURE(gtk_rc_style_copy, gxg_gtk_rc_style_copy, 1, 0, 0, H_gtk_rc_style_copy);
  XG_DEFINE_PROCEDURE(gtk_rc_style_ref, gxg_gtk_rc_style_ref, 1, 0, 0, H_gtk_rc_style_ref);
  XG_DEFINE_PROCEDURE(gtk_rc_style_unref, gxg_gtk_rc_style_unref, 1, 0, 0, H_gtk_rc_style_unref);
  XG_DEFINE_PROCEDURE(gtk_rc_find_module_in_path, gxg_gtk_rc_find_module_in_path, 1, 0, 0, H_gtk_rc_find_module_in_path);
  XG_DEFINE_PROCEDURE(gtk_rc_get_theme_dir, gxg_gtk_rc_get_theme_dir, 0, 0, 0, H_gtk_rc_get_theme_dir);
  XG_DEFINE_PROCEDURE(gtk_rc_get_module_dir, gxg_gtk_rc_get_module_dir, 0, 0, 0, H_gtk_rc_get_module_dir);
  XG_DEFINE_PROCEDURE(gtk_rc_get_im_module_path, gxg_gtk_rc_get_im_module_path, 0, 0, 0, H_gtk_rc_get_im_module_path);
  XG_DEFINE_PROCEDURE(gtk_rc_get_im_module_file, gxg_gtk_rc_get_im_module_file, 0, 0, 0, H_gtk_rc_get_im_module_file);
  XG_DEFINE_PROCEDURE(gtk_rc_scanner_new, gxg_gtk_rc_scanner_new, 0, 0, 0, H_gtk_rc_scanner_new);
  XG_DEFINE_PROCEDURE(gtk_rc_parse_color, gxg_gtk_rc_parse_color, 2, 0, 0, H_gtk_rc_parse_color);
  XG_DEFINE_PROCEDURE(gtk_rc_parse_state, gxg_gtk_rc_parse_state, 1, 1, 0, H_gtk_rc_parse_state);
  XG_DEFINE_PROCEDURE(gtk_rc_parse_priority, gxg_gtk_rc_parse_priority, 1, 1, 0, H_gtk_rc_parse_priority);
  XG_DEFINE_PROCEDURE(gtk_ruler_get_type, gxg_gtk_ruler_get_type, 0, 0, 0, H_gtk_ruler_get_type);
  XG_DEFINE_PROCEDURE(gtk_ruler_set_metric, gxg_gtk_ruler_set_metric, 2, 0, 0, H_gtk_ruler_set_metric);
  XG_DEFINE_PROCEDURE(gtk_ruler_set_range, gxg_gtk_ruler_set_range, 5, 0, 0, H_gtk_ruler_set_range);
  XG_DEFINE_PROCEDURE(gtk_ruler_draw_ticks, gxg_gtk_ruler_draw_ticks, 1, 0, 0, H_gtk_ruler_draw_ticks);
  XG_DEFINE_PROCEDURE(gtk_ruler_draw_pos, gxg_gtk_ruler_draw_pos, 1, 0, 0, H_gtk_ruler_draw_pos);
  XG_DEFINE_PROCEDURE(gtk_ruler_get_metric, gxg_gtk_ruler_get_metric, 1, 0, 0, H_gtk_ruler_get_metric);
  XG_DEFINE_PROCEDURE(gtk_ruler_get_range, gxg_gtk_ruler_get_range, 1, 4, 0, H_gtk_ruler_get_range);
  XG_DEFINE_PROCEDURE(gtk_scale_get_type, gxg_gtk_scale_get_type, 0, 0, 0, H_gtk_scale_get_type);
  XG_DEFINE_PROCEDURE(gtk_scale_set_digits, gxg_gtk_scale_set_digits, 2, 0, 0, H_gtk_scale_set_digits);
  XG_DEFINE_PROCEDURE(gtk_scale_get_digits, gxg_gtk_scale_get_digits, 1, 0, 0, H_gtk_scale_get_digits);
  XG_DEFINE_PROCEDURE(gtk_scale_set_draw_value, gxg_gtk_scale_set_draw_value, 2, 0, 0, H_gtk_scale_set_draw_value);
  XG_DEFINE_PROCEDURE(gtk_scale_get_draw_value, gxg_gtk_scale_get_draw_value, 1, 0, 0, H_gtk_scale_get_draw_value);
  XG_DEFINE_PROCEDURE(gtk_scale_set_value_pos, gxg_gtk_scale_set_value_pos, 2, 0, 0, H_gtk_scale_set_value_pos);
  XG_DEFINE_PROCEDURE(gtk_scale_get_value_pos, gxg_gtk_scale_get_value_pos, 1, 0, 0, H_gtk_scale_get_value_pos);
  XG_DEFINE_PROCEDURE(gtk_scrollbar_get_type, gxg_gtk_scrollbar_get_type, 0, 0, 0, H_gtk_scrollbar_get_type);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_type, gxg_gtk_scrolled_window_get_type, 0, 0, 0, H_gtk_scrolled_window_get_type);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_new, gxg_gtk_scrolled_window_new, 2, 0, 0, H_gtk_scrolled_window_new);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_set_hadjustment, gxg_gtk_scrolled_window_set_hadjustment, 2, 0, 0, H_gtk_scrolled_window_set_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_set_vadjustment, gxg_gtk_scrolled_window_set_vadjustment, 2, 0, 0, H_gtk_scrolled_window_set_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_hadjustment, gxg_gtk_scrolled_window_get_hadjustment, 1, 0, 0, H_gtk_scrolled_window_get_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_vadjustment, gxg_gtk_scrolled_window_get_vadjustment, 1, 0, 0, H_gtk_scrolled_window_get_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_set_policy, gxg_gtk_scrolled_window_set_policy, 3, 0, 0, H_gtk_scrolled_window_set_policy);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_policy, gxg_gtk_scrolled_window_get_policy, 1, 2, 0, H_gtk_scrolled_window_get_policy);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_set_placement, gxg_gtk_scrolled_window_set_placement, 2, 0, 0, H_gtk_scrolled_window_set_placement);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_placement, gxg_gtk_scrolled_window_get_placement, 1, 0, 0, H_gtk_scrolled_window_get_placement);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_set_shadow_type, gxg_gtk_scrolled_window_set_shadow_type, 2, 0, 0, H_gtk_scrolled_window_set_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_get_shadow_type, gxg_gtk_scrolled_window_get_shadow_type, 1, 0, 0, H_gtk_scrolled_window_get_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_scrolled_window_add_with_viewport, gxg_gtk_scrolled_window_add_with_viewport, 2, 0, 0, H_gtk_scrolled_window_add_with_viewport);
  XG_DEFINE_PROCEDURE(gtk_target_list_new, gxg_gtk_target_list_new, 2, 0, 0, H_gtk_target_list_new);
  XG_DEFINE_PROCEDURE(gtk_target_list_ref, gxg_gtk_target_list_ref, 1, 0, 0, H_gtk_target_list_ref);
  XG_DEFINE_PROCEDURE(gtk_target_list_unref, gxg_gtk_target_list_unref, 1, 0, 0, H_gtk_target_list_unref);
  XG_DEFINE_PROCEDURE(gtk_target_list_add, gxg_gtk_target_list_add, 4, 0, 0, H_gtk_target_list_add);
  XG_DEFINE_PROCEDURE(gtk_target_list_add_table, gxg_gtk_target_list_add_table, 3, 0, 0, H_gtk_target_list_add_table);
  XG_DEFINE_PROCEDURE(gtk_target_list_remove, gxg_gtk_target_list_remove, 2, 0, 0, H_gtk_target_list_remove);
  XG_DEFINE_PROCEDURE(gtk_target_list_find, gxg_gtk_target_list_find, 2, 1, 0, H_gtk_target_list_find);
  XG_DEFINE_PROCEDURE(gtk_selection_owner_set, gxg_gtk_selection_owner_set, 3, 0, 0, H_gtk_selection_owner_set);
  XG_DEFINE_PROCEDURE(gtk_selection_add_target, gxg_gtk_selection_add_target, 4, 0, 0, H_gtk_selection_add_target);
  XG_DEFINE_PROCEDURE(gtk_selection_add_targets, gxg_gtk_selection_add_targets, 4, 0, 0, H_gtk_selection_add_targets);
  XG_DEFINE_PROCEDURE(gtk_selection_clear_targets, gxg_gtk_selection_clear_targets, 2, 0, 0, H_gtk_selection_clear_targets);
  XG_DEFINE_PROCEDURE(gtk_selection_convert, gxg_gtk_selection_convert, 4, 0, 0, H_gtk_selection_convert);
  XG_DEFINE_PROCEDURE(gtk_selection_data_set, gxg_gtk_selection_data_set, 5, 0, 0, H_gtk_selection_data_set);
  XG_DEFINE_PROCEDURE(gtk_selection_data_set_text, gxg_gtk_selection_data_set_text, 3, 0, 0, H_gtk_selection_data_set_text);
  XG_DEFINE_PROCEDURE(gtk_selection_data_get_text, gxg_gtk_selection_data_get_text, 1, 0, 0, H_gtk_selection_data_get_text);
  XG_DEFINE_PROCEDURE(gtk_selection_data_get_targets, gxg_gtk_selection_data_get_targets, 1, 2, 0, H_gtk_selection_data_get_targets);
  XG_DEFINE_PROCEDURE(gtk_selection_data_targets_include_text, gxg_gtk_selection_data_targets_include_text, 1, 0, 0, H_gtk_selection_data_targets_include_text);
  XG_DEFINE_PROCEDURE(gtk_selection_remove_all, gxg_gtk_selection_remove_all, 1, 0, 0, H_gtk_selection_remove_all);
  XG_DEFINE_PROCEDURE(gtk_selection_data_copy, gxg_gtk_selection_data_copy, 1, 0, 0, H_gtk_selection_data_copy);
  XG_DEFINE_PROCEDURE(gtk_selection_data_free, gxg_gtk_selection_data_free, 1, 0, 0, H_gtk_selection_data_free);
  XG_DEFINE_PROCEDURE(gtk_separator_get_type, gxg_gtk_separator_get_type, 0, 0, 0, H_gtk_separator_get_type);
  XG_DEFINE_PROCEDURE(gtk_separator_menu_item_get_type, gxg_gtk_separator_menu_item_get_type, 0, 0, 0, H_gtk_separator_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_separator_menu_item_new, gxg_gtk_separator_menu_item_new, 0, 0, 0, H_gtk_separator_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_size_group_get_type, gxg_gtk_size_group_get_type, 0, 0, 0, H_gtk_size_group_get_type);
  XG_DEFINE_PROCEDURE(gtk_size_group_new, gxg_gtk_size_group_new, 1, 0, 0, H_gtk_size_group_new);
  XG_DEFINE_PROCEDURE(gtk_size_group_set_mode, gxg_gtk_size_group_set_mode, 2, 0, 0, H_gtk_size_group_set_mode);
  XG_DEFINE_PROCEDURE(gtk_size_group_get_mode, gxg_gtk_size_group_get_mode, 1, 0, 0, H_gtk_size_group_get_mode);
  XG_DEFINE_PROCEDURE(gtk_size_group_add_widget, gxg_gtk_size_group_add_widget, 2, 0, 0, H_gtk_size_group_add_widget);
  XG_DEFINE_PROCEDURE(gtk_size_group_remove_widget, gxg_gtk_size_group_remove_widget, 2, 0, 0, H_gtk_size_group_remove_widget);
  XG_DEFINE_PROCEDURE(gtk_socket_new, gxg_gtk_socket_new, 0, 0, 0, H_gtk_socket_new);
  XG_DEFINE_PROCEDURE(gtk_socket_get_type, gxg_gtk_socket_get_type, 0, 0, 0, H_gtk_socket_get_type);
  XG_DEFINE_PROCEDURE(gtk_socket_add_id, gxg_gtk_socket_add_id, 2, 0, 0, H_gtk_socket_add_id);
  XG_DEFINE_PROCEDURE(gtk_socket_get_id, gxg_gtk_socket_get_id, 1, 0, 0, H_gtk_socket_get_id);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_type, gxg_gtk_spin_button_get_type, 0, 0, 0, H_gtk_spin_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_spin_button_configure, gxg_gtk_spin_button_configure, 4, 0, 0, H_gtk_spin_button_configure);
  XG_DEFINE_PROCEDURE(gtk_spin_button_new, gxg_gtk_spin_button_new, 3, 0, 0, H_gtk_spin_button_new);
  XG_DEFINE_PROCEDURE(gtk_spin_button_new_with_range, gxg_gtk_spin_button_new_with_range, 3, 0, 0, H_gtk_spin_button_new_with_range);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_adjustment, gxg_gtk_spin_button_set_adjustment, 2, 0, 0, H_gtk_spin_button_set_adjustment);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_adjustment, gxg_gtk_spin_button_get_adjustment, 1, 0, 0, H_gtk_spin_button_get_adjustment);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_digits, gxg_gtk_spin_button_set_digits, 2, 0, 0, H_gtk_spin_button_set_digits);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_digits, gxg_gtk_spin_button_get_digits, 1, 0, 0, H_gtk_spin_button_get_digits);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_increments, gxg_gtk_spin_button_set_increments, 3, 0, 0, H_gtk_spin_button_set_increments);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_increments, gxg_gtk_spin_button_get_increments, 1, 2, 0, H_gtk_spin_button_get_increments);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_range, gxg_gtk_spin_button_set_range, 3, 0, 0, H_gtk_spin_button_set_range);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_range, gxg_gtk_spin_button_get_range, 1, 2, 0, H_gtk_spin_button_get_range);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_value, gxg_gtk_spin_button_get_value, 1, 0, 0, H_gtk_spin_button_get_value);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_value_as_int, gxg_gtk_spin_button_get_value_as_int, 1, 0, 0, H_gtk_spin_button_get_value_as_int);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_value, gxg_gtk_spin_button_set_value, 2, 0, 0, H_gtk_spin_button_set_value);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_update_policy, gxg_gtk_spin_button_set_update_policy, 2, 0, 0, H_gtk_spin_button_set_update_policy);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_update_policy, gxg_gtk_spin_button_get_update_policy, 1, 0, 0, H_gtk_spin_button_get_update_policy);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_numeric, gxg_gtk_spin_button_set_numeric, 2, 0, 0, H_gtk_spin_button_set_numeric);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_numeric, gxg_gtk_spin_button_get_numeric, 1, 0, 0, H_gtk_spin_button_get_numeric);
  XG_DEFINE_PROCEDURE(gtk_spin_button_spin, gxg_gtk_spin_button_spin, 3, 0, 0, H_gtk_spin_button_spin);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_wrap, gxg_gtk_spin_button_set_wrap, 2, 0, 0, H_gtk_spin_button_set_wrap);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_wrap, gxg_gtk_spin_button_get_wrap, 1, 0, 0, H_gtk_spin_button_get_wrap);
  XG_DEFINE_PROCEDURE(gtk_spin_button_set_snap_to_ticks, gxg_gtk_spin_button_set_snap_to_ticks, 2, 0, 0, H_gtk_spin_button_set_snap_to_ticks);
  XG_DEFINE_PROCEDURE(gtk_spin_button_get_snap_to_ticks, gxg_gtk_spin_button_get_snap_to_ticks, 1, 0, 0, H_gtk_spin_button_get_snap_to_ticks);
  XG_DEFINE_PROCEDURE(gtk_spin_button_update, gxg_gtk_spin_button_update, 1, 0, 0, H_gtk_spin_button_update);
  XG_DEFINE_PROCEDURE(gtk_statusbar_get_type, gxg_gtk_statusbar_get_type, 0, 0, 0, H_gtk_statusbar_get_type);
  XG_DEFINE_PROCEDURE(gtk_statusbar_new, gxg_gtk_statusbar_new, 0, 0, 0, H_gtk_statusbar_new);
  XG_DEFINE_PROCEDURE(gtk_statusbar_get_context_id, gxg_gtk_statusbar_get_context_id, 2, 0, 0, H_gtk_statusbar_get_context_id);
  XG_DEFINE_PROCEDURE(gtk_statusbar_push, gxg_gtk_statusbar_push, 3, 0, 0, H_gtk_statusbar_push);
  XG_DEFINE_PROCEDURE(gtk_statusbar_pop, gxg_gtk_statusbar_pop, 2, 0, 0, H_gtk_statusbar_pop);
  XG_DEFINE_PROCEDURE(gtk_statusbar_remove, gxg_gtk_statusbar_remove, 3, 0, 0, H_gtk_statusbar_remove);
  XG_DEFINE_PROCEDURE(gtk_statusbar_set_has_resize_grip, gxg_gtk_statusbar_set_has_resize_grip, 2, 0, 0, H_gtk_statusbar_set_has_resize_grip);
  XG_DEFINE_PROCEDURE(gtk_statusbar_get_has_resize_grip, gxg_gtk_statusbar_get_has_resize_grip, 1, 0, 0, H_gtk_statusbar_get_has_resize_grip);
  XG_DEFINE_PROCEDURE(gtk_stock_add, gxg_gtk_stock_add, 2, 0, 0, H_gtk_stock_add);
  XG_DEFINE_PROCEDURE(gtk_stock_add_static, gxg_gtk_stock_add_static, 2, 0, 0, H_gtk_stock_add_static);
  XG_DEFINE_PROCEDURE(gtk_stock_lookup, gxg_gtk_stock_lookup, 2, 0, 0, H_gtk_stock_lookup);
  XG_DEFINE_PROCEDURE(gtk_stock_list_ids, gxg_gtk_stock_list_ids, 0, 0, 0, H_gtk_stock_list_ids);
  XG_DEFINE_PROCEDURE(gtk_stock_item_copy, gxg_gtk_stock_item_copy, 1, 0, 0, H_gtk_stock_item_copy);
  XG_DEFINE_PROCEDURE(gtk_stock_item_free, gxg_gtk_stock_item_free, 1, 0, 0, H_gtk_stock_item_free);
  XG_DEFINE_PROCEDURE(gtk_style_get_type, gxg_gtk_style_get_type, 0, 0, 0, H_gtk_style_get_type);
  XG_DEFINE_PROCEDURE(gtk_style_new, gxg_gtk_style_new, 0, 0, 0, H_gtk_style_new);
  XG_DEFINE_PROCEDURE(gtk_style_copy, gxg_gtk_style_copy, 1, 0, 0, H_gtk_style_copy);
  XG_DEFINE_PROCEDURE(gtk_style_attach, gxg_gtk_style_attach, 2, 0, 0, H_gtk_style_attach);
  XG_DEFINE_PROCEDURE(gtk_style_detach, gxg_gtk_style_detach, 1, 0, 0, H_gtk_style_detach);
  XG_DEFINE_PROCEDURE(gtk_style_set_background, gxg_gtk_style_set_background, 3, 0, 0, H_gtk_style_set_background);
  XG_DEFINE_PROCEDURE(gtk_style_apply_default_background, gxg_gtk_style_apply_default_background, 9, 0, 0, H_gtk_style_apply_default_background);
  XG_DEFINE_PROCEDURE(gtk_style_lookup_icon_set, gxg_gtk_style_lookup_icon_set, 2, 0, 0, H_gtk_style_lookup_icon_set);
  XG_DEFINE_PROCEDURE(gtk_style_render_icon, gxg_gtk_style_render_icon, 7, 0, 0, H_gtk_style_render_icon);
  XG_DEFINE_PROCEDURE(gtk_paint_hline, gxg_gtk_paint_hline, 9, 0, 0, H_gtk_paint_hline);
  XG_DEFINE_PROCEDURE(gtk_paint_vline, gxg_gtk_paint_vline, 9, 0, 0, H_gtk_paint_vline);
  XG_DEFINE_PROCEDURE(gtk_paint_shadow, gxg_gtk_paint_shadow, 0, 0, 1, H_gtk_paint_shadow);
  XG_DEFINE_PROCEDURE(gtk_paint_polygon, gxg_gtk_paint_polygon, 0, 0, 1, H_gtk_paint_polygon);
  XG_DEFINE_PROCEDURE(gtk_paint_arrow, gxg_gtk_paint_arrow, 0, 0, 1, H_gtk_paint_arrow);
  XG_DEFINE_PROCEDURE(gtk_paint_diamond, gxg_gtk_paint_diamond, 0, 0, 1, H_gtk_paint_diamond);
  XG_DEFINE_PROCEDURE(gtk_paint_box, gxg_gtk_paint_box, 0, 0, 1, H_gtk_paint_box);
  XG_DEFINE_PROCEDURE(gtk_paint_flat_box, gxg_gtk_paint_flat_box, 0, 0, 1, H_gtk_paint_flat_box);
  XG_DEFINE_PROCEDURE(gtk_paint_check, gxg_gtk_paint_check, 0, 0, 1, H_gtk_paint_check);
  XG_DEFINE_PROCEDURE(gtk_paint_option, gxg_gtk_paint_option, 0, 0, 1, H_gtk_paint_option);
  XG_DEFINE_PROCEDURE(gtk_paint_tab, gxg_gtk_paint_tab, 0, 0, 1, H_gtk_paint_tab);
  XG_DEFINE_PROCEDURE(gtk_paint_shadow_gap, gxg_gtk_paint_shadow_gap, 0, 0, 1, H_gtk_paint_shadow_gap);
  XG_DEFINE_PROCEDURE(gtk_paint_box_gap, gxg_gtk_paint_box_gap, 0, 0, 1, H_gtk_paint_box_gap);
  XG_DEFINE_PROCEDURE(gtk_paint_extension, gxg_gtk_paint_extension, 0, 0, 1, H_gtk_paint_extension);
  XG_DEFINE_PROCEDURE(gtk_paint_focus, gxg_gtk_paint_focus, 0, 0, 1, H_gtk_paint_focus);
  XG_DEFINE_PROCEDURE(gtk_paint_slider, gxg_gtk_paint_slider, 0, 0, 1, H_gtk_paint_slider);
  XG_DEFINE_PROCEDURE(gtk_paint_handle, gxg_gtk_paint_handle, 0, 0, 1, H_gtk_paint_handle);
  XG_DEFINE_PROCEDURE(gtk_paint_expander, gxg_gtk_paint_expander, 9, 0, 0, H_gtk_paint_expander);
  XG_DEFINE_PROCEDURE(gtk_paint_layout, gxg_gtk_paint_layout, 0, 0, 1, H_gtk_paint_layout);
  XG_DEFINE_PROCEDURE(gtk_paint_resize_grip, gxg_gtk_paint_resize_grip, 0, 0, 1, H_gtk_paint_resize_grip);
  XG_DEFINE_PROCEDURE(gtk_border_copy, gxg_gtk_border_copy, 1, 0, 0, H_gtk_border_copy);
  XG_DEFINE_PROCEDURE(gtk_border_free, gxg_gtk_border_free, 1, 0, 0, H_gtk_border_free);
  XG_DEFINE_PROCEDURE(gtk_table_get_type, gxg_gtk_table_get_type, 0, 0, 0, H_gtk_table_get_type);
  XG_DEFINE_PROCEDURE(gtk_table_new, gxg_gtk_table_new, 3, 0, 0, H_gtk_table_new);
  XG_DEFINE_PROCEDURE(gtk_table_resize, gxg_gtk_table_resize, 3, 0, 0, H_gtk_table_resize);
  XG_DEFINE_PROCEDURE(gtk_table_attach, gxg_gtk_table_attach, 0, 0, 1, H_gtk_table_attach);
  XG_DEFINE_PROCEDURE(gtk_table_attach_defaults, gxg_gtk_table_attach_defaults, 6, 0, 0, H_gtk_table_attach_defaults);
  XG_DEFINE_PROCEDURE(gtk_table_set_row_spacing, gxg_gtk_table_set_row_spacing, 3, 0, 0, H_gtk_table_set_row_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_get_row_spacing, gxg_gtk_table_get_row_spacing, 2, 0, 0, H_gtk_table_get_row_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_set_col_spacing, gxg_gtk_table_set_col_spacing, 3, 0, 0, H_gtk_table_set_col_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_get_col_spacing, gxg_gtk_table_get_col_spacing, 2, 0, 0, H_gtk_table_get_col_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_set_row_spacings, gxg_gtk_table_set_row_spacings, 2, 0, 0, H_gtk_table_set_row_spacings);
  XG_DEFINE_PROCEDURE(gtk_table_get_default_row_spacing, gxg_gtk_table_get_default_row_spacing, 1, 0, 0, H_gtk_table_get_default_row_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_set_col_spacings, gxg_gtk_table_set_col_spacings, 2, 0, 0, H_gtk_table_set_col_spacings);
  XG_DEFINE_PROCEDURE(gtk_table_get_default_col_spacing, gxg_gtk_table_get_default_col_spacing, 1, 0, 0, H_gtk_table_get_default_col_spacing);
  XG_DEFINE_PROCEDURE(gtk_table_set_homogeneous, gxg_gtk_table_set_homogeneous, 2, 0, 0, H_gtk_table_set_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_table_get_homogeneous, gxg_gtk_table_get_homogeneous, 1, 0, 0, H_gtk_table_get_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_tearoff_menu_item_get_type, gxg_gtk_tearoff_menu_item_get_type, 0, 0, 0, H_gtk_tearoff_menu_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_tearoff_menu_item_new, gxg_gtk_tearoff_menu_item_new, 0, 0, 0, H_gtk_tearoff_menu_item_new);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_type, gxg_gtk_text_buffer_get_type, 0, 0, 0, H_gtk_text_buffer_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_new, gxg_gtk_text_buffer_new, 1, 0, 0, H_gtk_text_buffer_new);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_line_count, gxg_gtk_text_buffer_get_line_count, 1, 0, 0, H_gtk_text_buffer_get_line_count);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_char_count, gxg_gtk_text_buffer_get_char_count, 1, 0, 0, H_gtk_text_buffer_get_char_count);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_tag_table, gxg_gtk_text_buffer_get_tag_table, 1, 0, 0, H_gtk_text_buffer_get_tag_table);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_set_text, gxg_gtk_text_buffer_set_text, 3, 0, 0, H_gtk_text_buffer_set_text);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert, gxg_gtk_text_buffer_insert, 4, 0, 0, H_gtk_text_buffer_insert);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_at_cursor, gxg_gtk_text_buffer_insert_at_cursor, 3, 0, 0, H_gtk_text_buffer_insert_at_cursor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_interactive, gxg_gtk_text_buffer_insert_interactive, 5, 0, 0, H_gtk_text_buffer_insert_interactive);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_interactive_at_cursor, gxg_gtk_text_buffer_insert_interactive_at_cursor, 4, 0, 0, H_gtk_text_buffer_insert_interactive_at_cursor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_range, gxg_gtk_text_buffer_insert_range, 4, 0, 0, H_gtk_text_buffer_insert_range);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_range_interactive, gxg_gtk_text_buffer_insert_range_interactive, 5, 0, 0, H_gtk_text_buffer_insert_range_interactive);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_with_tags, gxg_gtk_text_buffer_insert_with_tags, 5, 0, 0, H_gtk_text_buffer_insert_with_tags);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_with_tags_by_name, gxg_gtk_text_buffer_insert_with_tags_by_name, 5, 0, 0, H_gtk_text_buffer_insert_with_tags_by_name);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_delete, gxg_gtk_text_buffer_delete, 3, 0, 0, H_gtk_text_buffer_delete);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_delete_interactive, gxg_gtk_text_buffer_delete_interactive, 4, 0, 0, H_gtk_text_buffer_delete_interactive);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_text, gxg_gtk_text_buffer_get_text, 4, 0, 0, H_gtk_text_buffer_get_text);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_slice, gxg_gtk_text_buffer_get_slice, 4, 0, 0, H_gtk_text_buffer_get_slice);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_pixbuf, gxg_gtk_text_buffer_insert_pixbuf, 3, 0, 0, H_gtk_text_buffer_insert_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_insert_child_anchor, gxg_gtk_text_buffer_insert_child_anchor, 3, 0, 0, H_gtk_text_buffer_insert_child_anchor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_create_child_anchor, gxg_gtk_text_buffer_create_child_anchor, 2, 0, 0, H_gtk_text_buffer_create_child_anchor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_create_mark, gxg_gtk_text_buffer_create_mark, 4, 0, 0, H_gtk_text_buffer_create_mark);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_move_mark, gxg_gtk_text_buffer_move_mark, 3, 0, 0, H_gtk_text_buffer_move_mark);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_delete_mark, gxg_gtk_text_buffer_delete_mark, 2, 0, 0, H_gtk_text_buffer_delete_mark);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_mark, gxg_gtk_text_buffer_get_mark, 2, 0, 0, H_gtk_text_buffer_get_mark);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_move_mark_by_name, gxg_gtk_text_buffer_move_mark_by_name, 3, 0, 0, H_gtk_text_buffer_move_mark_by_name);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_delete_mark_by_name, gxg_gtk_text_buffer_delete_mark_by_name, 2, 0, 0, H_gtk_text_buffer_delete_mark_by_name);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_insert, gxg_gtk_text_buffer_get_insert, 1, 0, 0, H_gtk_text_buffer_get_insert);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_selection_bound, gxg_gtk_text_buffer_get_selection_bound, 1, 0, 0, H_gtk_text_buffer_get_selection_bound);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_place_cursor, gxg_gtk_text_buffer_place_cursor, 2, 0, 0, H_gtk_text_buffer_place_cursor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_apply_tag, gxg_gtk_text_buffer_apply_tag, 4, 0, 0, H_gtk_text_buffer_apply_tag);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_remove_tag, gxg_gtk_text_buffer_remove_tag, 4, 0, 0, H_gtk_text_buffer_remove_tag);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_apply_tag_by_name, gxg_gtk_text_buffer_apply_tag_by_name, 4, 0, 0, H_gtk_text_buffer_apply_tag_by_name);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_remove_tag_by_name, gxg_gtk_text_buffer_remove_tag_by_name, 4, 0, 0, H_gtk_text_buffer_remove_tag_by_name);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_remove_all_tags, gxg_gtk_text_buffer_remove_all_tags, 3, 0, 0, H_gtk_text_buffer_remove_all_tags);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_create_tag, gxg_gtk_text_buffer_create_tag, 2, 1, 0, H_gtk_text_buffer_create_tag);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_line_offset, gxg_gtk_text_buffer_get_iter_at_line_offset, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_offset);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_line_index, gxg_gtk_text_buffer_get_iter_at_line_index, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_index);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_offset, gxg_gtk_text_buffer_get_iter_at_offset, 3, 0, 0, H_gtk_text_buffer_get_iter_at_offset);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_line, gxg_gtk_text_buffer_get_iter_at_line, 3, 0, 0, H_gtk_text_buffer_get_iter_at_line);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_start_iter, gxg_gtk_text_buffer_get_start_iter, 2, 0, 0, H_gtk_text_buffer_get_start_iter);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_end_iter, gxg_gtk_text_buffer_get_end_iter, 2, 0, 0, H_gtk_text_buffer_get_end_iter);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_bounds, gxg_gtk_text_buffer_get_bounds, 3, 0, 0, H_gtk_text_buffer_get_bounds);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_mark, gxg_gtk_text_buffer_get_iter_at_mark, 3, 0, 0, H_gtk_text_buffer_get_iter_at_mark);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_iter_at_child_anchor, gxg_gtk_text_buffer_get_iter_at_child_anchor, 3, 0, 0, H_gtk_text_buffer_get_iter_at_child_anchor);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_modified, gxg_gtk_text_buffer_get_modified, 1, 0, 0, H_gtk_text_buffer_get_modified);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_set_modified, gxg_gtk_text_buffer_set_modified, 2, 0, 0, H_gtk_text_buffer_set_modified);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_add_selection_clipboard, gxg_gtk_text_buffer_add_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_add_selection_clipboard);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_remove_selection_clipboard, gxg_gtk_text_buffer_remove_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_remove_selection_clipboard);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_cut_clipboard, gxg_gtk_text_buffer_cut_clipboard, 3, 0, 0, H_gtk_text_buffer_cut_clipboard);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_copy_clipboard, gxg_gtk_text_buffer_copy_clipboard, 2, 0, 0, H_gtk_text_buffer_copy_clipboard);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_paste_clipboard, gxg_gtk_text_buffer_paste_clipboard, 4, 0, 0, H_gtk_text_buffer_paste_clipboard);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_get_selection_bounds, gxg_gtk_text_buffer_get_selection_bounds, 3, 0, 0, H_gtk_text_buffer_get_selection_bounds);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_delete_selection, gxg_gtk_text_buffer_delete_selection, 3, 0, 0, H_gtk_text_buffer_delete_selection);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_begin_user_action, gxg_gtk_text_buffer_begin_user_action, 1, 0, 0, H_gtk_text_buffer_begin_user_action);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_end_user_action, gxg_gtk_text_buffer_end_user_action, 1, 0, 0, H_gtk_text_buffer_end_user_action);
  XG_DEFINE_PROCEDURE(gtk_text_child_anchor_get_type, gxg_gtk_text_child_anchor_get_type, 0, 0, 0, H_gtk_text_child_anchor_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_child_anchor_new, gxg_gtk_text_child_anchor_new, 0, 0, 0, H_gtk_text_child_anchor_new);
  XG_DEFINE_PROCEDURE(gtk_text_child_anchor_get_widgets, gxg_gtk_text_child_anchor_get_widgets, 1, 0, 0, H_gtk_text_child_anchor_get_widgets);
  XG_DEFINE_PROCEDURE(gtk_text_child_anchor_get_deleted, gxg_gtk_text_child_anchor_get_deleted, 1, 0, 0, H_gtk_text_child_anchor_get_deleted);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_buffer, gxg_gtk_text_iter_get_buffer, 1, 0, 0, H_gtk_text_iter_get_buffer);
  XG_DEFINE_PROCEDURE(gtk_text_iter_copy, gxg_gtk_text_iter_copy, 1, 0, 0, H_gtk_text_iter_copy);
  XG_DEFINE_PROCEDURE(gtk_text_iter_free, gxg_gtk_text_iter_free, 1, 0, 0, H_gtk_text_iter_free);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_offset, gxg_gtk_text_iter_get_offset, 1, 0, 0, H_gtk_text_iter_get_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_line, gxg_gtk_text_iter_get_line, 1, 0, 0, H_gtk_text_iter_get_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_line_offset, gxg_gtk_text_iter_get_line_offset, 1, 0, 0, H_gtk_text_iter_get_line_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_line_index, gxg_gtk_text_iter_get_line_index, 1, 0, 0, H_gtk_text_iter_get_line_index);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_visible_line_offset, gxg_gtk_text_iter_get_visible_line_offset, 1, 0, 0, H_gtk_text_iter_get_visible_line_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_visible_line_index, gxg_gtk_text_iter_get_visible_line_index, 1, 0, 0, H_gtk_text_iter_get_visible_line_index);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_char, gxg_gtk_text_iter_get_char, 1, 0, 0, H_gtk_text_iter_get_char);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_slice, gxg_gtk_text_iter_get_slice, 2, 0, 0, H_gtk_text_iter_get_slice);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_text, gxg_gtk_text_iter_get_text, 2, 0, 0, H_gtk_text_iter_get_text);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_visible_slice, gxg_gtk_text_iter_get_visible_slice, 2, 0, 0, H_gtk_text_iter_get_visible_slice);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_visible_text, gxg_gtk_text_iter_get_visible_text, 2, 0, 0, H_gtk_text_iter_get_visible_text);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_pixbuf, gxg_gtk_text_iter_get_pixbuf, 1, 0, 0, H_gtk_text_iter_get_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_marks, gxg_gtk_text_iter_get_marks, 1, 0, 0, H_gtk_text_iter_get_marks);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_child_anchor, gxg_gtk_text_iter_get_child_anchor, 1, 0, 0, H_gtk_text_iter_get_child_anchor);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_toggled_tags, gxg_gtk_text_iter_get_toggled_tags, 2, 0, 0, H_gtk_text_iter_get_toggled_tags);
  XG_DEFINE_PROCEDURE(gtk_text_iter_begins_tag, gxg_gtk_text_iter_begins_tag, 2, 0, 0, H_gtk_text_iter_begins_tag);
  XG_DEFINE_PROCEDURE(gtk_text_iter_ends_tag, gxg_gtk_text_iter_ends_tag, 2, 0, 0, H_gtk_text_iter_ends_tag);
  XG_DEFINE_PROCEDURE(gtk_text_iter_toggles_tag, gxg_gtk_text_iter_toggles_tag, 2, 0, 0, H_gtk_text_iter_toggles_tag);
  XG_DEFINE_PROCEDURE(gtk_text_iter_has_tag, gxg_gtk_text_iter_has_tag, 2, 0, 0, H_gtk_text_iter_has_tag);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_tags, gxg_gtk_text_iter_get_tags, 1, 0, 0, H_gtk_text_iter_get_tags);
  XG_DEFINE_PROCEDURE(gtk_text_iter_editable, gxg_gtk_text_iter_editable, 2, 0, 0, H_gtk_text_iter_editable);
  XG_DEFINE_PROCEDURE(gtk_text_iter_can_insert, gxg_gtk_text_iter_can_insert, 2, 0, 0, H_gtk_text_iter_can_insert);
  XG_DEFINE_PROCEDURE(gtk_text_iter_starts_word, gxg_gtk_text_iter_starts_word, 1, 0, 0, H_gtk_text_iter_starts_word);
  XG_DEFINE_PROCEDURE(gtk_text_iter_ends_word, gxg_gtk_text_iter_ends_word, 1, 0, 0, H_gtk_text_iter_ends_word);
  XG_DEFINE_PROCEDURE(gtk_text_iter_inside_word, gxg_gtk_text_iter_inside_word, 1, 0, 0, H_gtk_text_iter_inside_word);
  XG_DEFINE_PROCEDURE(gtk_text_iter_starts_sentence, gxg_gtk_text_iter_starts_sentence, 1, 0, 0, H_gtk_text_iter_starts_sentence);
  XG_DEFINE_PROCEDURE(gtk_text_iter_ends_sentence, gxg_gtk_text_iter_ends_sentence, 1, 0, 0, H_gtk_text_iter_ends_sentence);
  XG_DEFINE_PROCEDURE(gtk_text_iter_inside_sentence, gxg_gtk_text_iter_inside_sentence, 1, 0, 0, H_gtk_text_iter_inside_sentence);
  XG_DEFINE_PROCEDURE(gtk_text_iter_starts_line, gxg_gtk_text_iter_starts_line, 1, 0, 0, H_gtk_text_iter_starts_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_ends_line, gxg_gtk_text_iter_ends_line, 1, 0, 0, H_gtk_text_iter_ends_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_is_cursor_position, gxg_gtk_text_iter_is_cursor_position, 1, 0, 0, H_gtk_text_iter_is_cursor_position);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_chars_in_line, gxg_gtk_text_iter_get_chars_in_line, 1, 0, 0, H_gtk_text_iter_get_chars_in_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_bytes_in_line, gxg_gtk_text_iter_get_bytes_in_line, 1, 0, 0, H_gtk_text_iter_get_bytes_in_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_attributes, gxg_gtk_text_iter_get_attributes, 2, 0, 0, H_gtk_text_iter_get_attributes);
  XG_DEFINE_PROCEDURE(gtk_text_iter_get_language, gxg_gtk_text_iter_get_language, 1, 0, 0, H_gtk_text_iter_get_language);
  XG_DEFINE_PROCEDURE(gtk_text_iter_is_end, gxg_gtk_text_iter_is_end, 1, 0, 0, H_gtk_text_iter_is_end);
  XG_DEFINE_PROCEDURE(gtk_text_iter_is_start, gxg_gtk_text_iter_is_start, 1, 0, 0, H_gtk_text_iter_is_start);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_char, gxg_gtk_text_iter_forward_char, 1, 0, 0, H_gtk_text_iter_forward_char);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_char, gxg_gtk_text_iter_backward_char, 1, 0, 0, H_gtk_text_iter_backward_char);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_chars, gxg_gtk_text_iter_forward_chars, 2, 0, 0, H_gtk_text_iter_forward_chars);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_chars, gxg_gtk_text_iter_backward_chars, 2, 0, 0, H_gtk_text_iter_backward_chars);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_line, gxg_gtk_text_iter_forward_line, 1, 0, 0, H_gtk_text_iter_forward_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_line, gxg_gtk_text_iter_backward_line, 1, 0, 0, H_gtk_text_iter_backward_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_lines, gxg_gtk_text_iter_forward_lines, 2, 0, 0, H_gtk_text_iter_forward_lines);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_lines, gxg_gtk_text_iter_backward_lines, 2, 0, 0, H_gtk_text_iter_backward_lines);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_word_end, gxg_gtk_text_iter_forward_word_end, 1, 0, 0, H_gtk_text_iter_forward_word_end);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_word_start, gxg_gtk_text_iter_backward_word_start, 1, 0, 0, H_gtk_text_iter_backward_word_start);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_word_ends, gxg_gtk_text_iter_forward_word_ends, 2, 0, 0, H_gtk_text_iter_forward_word_ends);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_word_starts, gxg_gtk_text_iter_backward_word_starts, 2, 0, 0, H_gtk_text_iter_backward_word_starts);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_sentence_end, gxg_gtk_text_iter_forward_sentence_end, 1, 0, 0, H_gtk_text_iter_forward_sentence_end);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_sentence_start, gxg_gtk_text_iter_backward_sentence_start, 1, 0, 0, H_gtk_text_iter_backward_sentence_start);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_sentence_ends, gxg_gtk_text_iter_forward_sentence_ends, 2, 0, 0, H_gtk_text_iter_forward_sentence_ends);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_sentence_starts, gxg_gtk_text_iter_backward_sentence_starts, 2, 0, 0, H_gtk_text_iter_backward_sentence_starts);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_cursor_position, gxg_gtk_text_iter_forward_cursor_position, 1, 0, 0, H_gtk_text_iter_forward_cursor_position);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_cursor_position, gxg_gtk_text_iter_backward_cursor_position, 1, 0, 0, H_gtk_text_iter_backward_cursor_position);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_cursor_positions, gxg_gtk_text_iter_forward_cursor_positions, 2, 0, 0, H_gtk_text_iter_forward_cursor_positions);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_cursor_positions, gxg_gtk_text_iter_backward_cursor_positions, 2, 0, 0, H_gtk_text_iter_backward_cursor_positions);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_offset, gxg_gtk_text_iter_set_offset, 2, 0, 0, H_gtk_text_iter_set_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_line, gxg_gtk_text_iter_set_line, 2, 0, 0, H_gtk_text_iter_set_line);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_line_offset, gxg_gtk_text_iter_set_line_offset, 2, 0, 0, H_gtk_text_iter_set_line_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_line_index, gxg_gtk_text_iter_set_line_index, 2, 0, 0, H_gtk_text_iter_set_line_index);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_to_end, gxg_gtk_text_iter_forward_to_end, 1, 0, 0, H_gtk_text_iter_forward_to_end);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_to_line_end, gxg_gtk_text_iter_forward_to_line_end, 1, 0, 0, H_gtk_text_iter_forward_to_line_end);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_visible_line_offset, gxg_gtk_text_iter_set_visible_line_offset, 2, 0, 0, H_gtk_text_iter_set_visible_line_offset);
  XG_DEFINE_PROCEDURE(gtk_text_iter_set_visible_line_index, gxg_gtk_text_iter_set_visible_line_index, 2, 0, 0, H_gtk_text_iter_set_visible_line_index);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_to_tag_toggle, gxg_gtk_text_iter_forward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_forward_to_tag_toggle);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_to_tag_toggle, gxg_gtk_text_iter_backward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_backward_to_tag_toggle);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_find_char, gxg_gtk_text_iter_forward_find_char, 4, 0, 0, H_gtk_text_iter_forward_find_char);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_find_char, gxg_gtk_text_iter_backward_find_char, 4, 0, 0, H_gtk_text_iter_backward_find_char);
  XG_DEFINE_PROCEDURE(gtk_text_iter_forward_search, gxg_gtk_text_iter_forward_search, 6, 0, 0, H_gtk_text_iter_forward_search);
  XG_DEFINE_PROCEDURE(gtk_text_iter_backward_search, gxg_gtk_text_iter_backward_search, 6, 0, 0, H_gtk_text_iter_backward_search);
  XG_DEFINE_PROCEDURE(gtk_text_iter_equal, gxg_gtk_text_iter_equal, 2, 0, 0, H_gtk_text_iter_equal);
  XG_DEFINE_PROCEDURE(gtk_text_iter_compare, gxg_gtk_text_iter_compare, 2, 0, 0, H_gtk_text_iter_compare);
  XG_DEFINE_PROCEDURE(gtk_text_iter_in_range, gxg_gtk_text_iter_in_range, 3, 0, 0, H_gtk_text_iter_in_range);
  XG_DEFINE_PROCEDURE(gtk_text_iter_order, gxg_gtk_text_iter_order, 2, 0, 0, H_gtk_text_iter_order);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_type, gxg_gtk_text_mark_get_type, 0, 0, 0, H_gtk_text_mark_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_mark_set_visible, gxg_gtk_text_mark_set_visible, 2, 0, 0, H_gtk_text_mark_set_visible);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_visible, gxg_gtk_text_mark_get_visible, 1, 0, 0, H_gtk_text_mark_get_visible);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_name, gxg_gtk_text_mark_get_name, 1, 0, 0, H_gtk_text_mark_get_name);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_deleted, gxg_gtk_text_mark_get_deleted, 1, 0, 0, H_gtk_text_mark_get_deleted);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_buffer, gxg_gtk_text_mark_get_buffer, 1, 0, 0, H_gtk_text_mark_get_buffer);
  XG_DEFINE_PROCEDURE(gtk_text_mark_get_left_gravity, gxg_gtk_text_mark_get_left_gravity, 1, 0, 0, H_gtk_text_mark_get_left_gravity);
  XG_DEFINE_PROCEDURE(gtk_text_tag_get_type, gxg_gtk_text_tag_get_type, 0, 0, 0, H_gtk_text_tag_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_tag_new, gxg_gtk_text_tag_new, 1, 0, 0, H_gtk_text_tag_new);
  XG_DEFINE_PROCEDURE(gtk_text_tag_get_priority, gxg_gtk_text_tag_get_priority, 1, 0, 0, H_gtk_text_tag_get_priority);
  XG_DEFINE_PROCEDURE(gtk_text_tag_set_priority, gxg_gtk_text_tag_set_priority, 2, 0, 0, H_gtk_text_tag_set_priority);
  XG_DEFINE_PROCEDURE(gtk_text_tag_event, gxg_gtk_text_tag_event, 4, 0, 0, H_gtk_text_tag_event);
  XG_DEFINE_PROCEDURE(gtk_text_attributes_new, gxg_gtk_text_attributes_new, 0, 0, 0, H_gtk_text_attributes_new);
  XG_DEFINE_PROCEDURE(gtk_text_attributes_copy, gxg_gtk_text_attributes_copy, 1, 0, 0, H_gtk_text_attributes_copy);
  XG_DEFINE_PROCEDURE(gtk_text_attributes_copy_values, gxg_gtk_text_attributes_copy_values, 2, 0, 0, H_gtk_text_attributes_copy_values);
  XG_DEFINE_PROCEDURE(gtk_text_attributes_unref, gxg_gtk_text_attributes_unref, 1, 0, 0, H_gtk_text_attributes_unref);
  XG_DEFINE_PROCEDURE(gtk_text_attributes_ref, gxg_gtk_text_attributes_ref, 1, 0, 0, H_gtk_text_attributes_ref);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_get_type, gxg_gtk_text_tag_table_get_type, 0, 0, 0, H_gtk_text_tag_table_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_new, gxg_gtk_text_tag_table_new, 0, 0, 0, H_gtk_text_tag_table_new);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_add, gxg_gtk_text_tag_table_add, 2, 0, 0, H_gtk_text_tag_table_add);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_remove, gxg_gtk_text_tag_table_remove, 2, 0, 0, H_gtk_text_tag_table_remove);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_lookup, gxg_gtk_text_tag_table_lookup, 2, 0, 0, H_gtk_text_tag_table_lookup);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_foreach, gxg_gtk_text_tag_table_foreach, 3, 0, 0, H_gtk_text_tag_table_foreach);
  XG_DEFINE_PROCEDURE(gtk_text_tag_table_get_size, gxg_gtk_text_tag_table_get_size, 1, 0, 0, H_gtk_text_tag_table_get_size);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_type, gxg_gtk_text_view_get_type, 0, 0, 0, H_gtk_text_view_get_type);
  XG_DEFINE_PROCEDURE(gtk_text_view_new, gxg_gtk_text_view_new, 0, 0, 0, H_gtk_text_view_new);
  XG_DEFINE_PROCEDURE(gtk_text_view_new_with_buffer, gxg_gtk_text_view_new_with_buffer, 1, 0, 0, H_gtk_text_view_new_with_buffer);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_buffer, gxg_gtk_text_view_set_buffer, 2, 0, 0, H_gtk_text_view_set_buffer);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_buffer, gxg_gtk_text_view_get_buffer, 1, 0, 0, H_gtk_text_view_get_buffer);
  XG_DEFINE_PROCEDURE(gtk_text_view_scroll_to_iter, gxg_gtk_text_view_scroll_to_iter, 6, 0, 0, H_gtk_text_view_scroll_to_iter);
  XG_DEFINE_PROCEDURE(gtk_text_view_scroll_to_mark, gxg_gtk_text_view_scroll_to_mark, 6, 0, 0, H_gtk_text_view_scroll_to_mark);
  XG_DEFINE_PROCEDURE(gtk_text_view_scroll_mark_onscreen, gxg_gtk_text_view_scroll_mark_onscreen, 2, 0, 0, H_gtk_text_view_scroll_mark_onscreen);
  XG_DEFINE_PROCEDURE(gtk_text_view_move_mark_onscreen, gxg_gtk_text_view_move_mark_onscreen, 2, 0, 0, H_gtk_text_view_move_mark_onscreen);
  XG_DEFINE_PROCEDURE(gtk_text_view_place_cursor_onscreen, gxg_gtk_text_view_place_cursor_onscreen, 1, 0, 0, H_gtk_text_view_place_cursor_onscreen);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_visible_rect, gxg_gtk_text_view_get_visible_rect, 2, 0, 0, H_gtk_text_view_get_visible_rect);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_cursor_visible, gxg_gtk_text_view_set_cursor_visible, 2, 0, 0, H_gtk_text_view_set_cursor_visible);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_cursor_visible, gxg_gtk_text_view_get_cursor_visible, 1, 0, 0, H_gtk_text_view_get_cursor_visible);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_iter_location, gxg_gtk_text_view_get_iter_location, 3, 0, 0, H_gtk_text_view_get_iter_location);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_iter_at_location, gxg_gtk_text_view_get_iter_at_location, 4, 0, 0, H_gtk_text_view_get_iter_at_location);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_line_yrange, gxg_gtk_text_view_get_line_yrange, 2, 2, 0, H_gtk_text_view_get_line_yrange);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_line_at_y, gxg_gtk_text_view_get_line_at_y, 3, 1, 0, H_gtk_text_view_get_line_at_y);
  XG_DEFINE_PROCEDURE(gtk_text_view_buffer_to_window_coords, gxg_gtk_text_view_buffer_to_window_coords, 4, 2, 0, H_gtk_text_view_buffer_to_window_coords);
  XG_DEFINE_PROCEDURE(gtk_text_view_window_to_buffer_coords, gxg_gtk_text_view_window_to_buffer_coords, 4, 2, 0, H_gtk_text_view_window_to_buffer_coords);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_window, gxg_gtk_text_view_get_window, 2, 0, 0, H_gtk_text_view_get_window);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_window_type, gxg_gtk_text_view_get_window_type, 2, 0, 0, H_gtk_text_view_get_window_type);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_border_window_size, gxg_gtk_text_view_set_border_window_size, 3, 0, 0, H_gtk_text_view_set_border_window_size);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_border_window_size, gxg_gtk_text_view_get_border_window_size, 2, 0, 0, H_gtk_text_view_get_border_window_size);
  XG_DEFINE_PROCEDURE(gtk_text_view_forward_display_line, gxg_gtk_text_view_forward_display_line, 2, 0, 0, H_gtk_text_view_forward_display_line);
  XG_DEFINE_PROCEDURE(gtk_text_view_backward_display_line, gxg_gtk_text_view_backward_display_line, 2, 0, 0, H_gtk_text_view_backward_display_line);
  XG_DEFINE_PROCEDURE(gtk_text_view_forward_display_line_end, gxg_gtk_text_view_forward_display_line_end, 2, 0, 0, H_gtk_text_view_forward_display_line_end);
  XG_DEFINE_PROCEDURE(gtk_text_view_backward_display_line_start, gxg_gtk_text_view_backward_display_line_start, 2, 0, 0, H_gtk_text_view_backward_display_line_start);
  XG_DEFINE_PROCEDURE(gtk_text_view_starts_display_line, gxg_gtk_text_view_starts_display_line, 2, 0, 0, H_gtk_text_view_starts_display_line);
  XG_DEFINE_PROCEDURE(gtk_text_view_move_visually, gxg_gtk_text_view_move_visually, 3, 0, 0, H_gtk_text_view_move_visually);
  XG_DEFINE_PROCEDURE(gtk_text_view_add_child_at_anchor, gxg_gtk_text_view_add_child_at_anchor, 3, 0, 0, H_gtk_text_view_add_child_at_anchor);
  XG_DEFINE_PROCEDURE(gtk_text_view_add_child_in_window, gxg_gtk_text_view_add_child_in_window, 5, 0, 0, H_gtk_text_view_add_child_in_window);
  XG_DEFINE_PROCEDURE(gtk_text_view_move_child, gxg_gtk_text_view_move_child, 4, 0, 0, H_gtk_text_view_move_child);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_wrap_mode, gxg_gtk_text_view_set_wrap_mode, 2, 0, 0, H_gtk_text_view_set_wrap_mode);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_wrap_mode, gxg_gtk_text_view_get_wrap_mode, 1, 0, 0, H_gtk_text_view_get_wrap_mode);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_editable, gxg_gtk_text_view_set_editable, 2, 0, 0, H_gtk_text_view_set_editable);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_editable, gxg_gtk_text_view_get_editable, 1, 0, 0, H_gtk_text_view_get_editable);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_pixels_above_lines, gxg_gtk_text_view_set_pixels_above_lines, 2, 0, 0, H_gtk_text_view_set_pixels_above_lines);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_pixels_above_lines, gxg_gtk_text_view_get_pixels_above_lines, 1, 0, 0, H_gtk_text_view_get_pixels_above_lines);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_pixels_below_lines, gxg_gtk_text_view_set_pixels_below_lines, 2, 0, 0, H_gtk_text_view_set_pixels_below_lines);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_pixels_below_lines, gxg_gtk_text_view_get_pixels_below_lines, 1, 0, 0, H_gtk_text_view_get_pixels_below_lines);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_pixels_inside_wrap, gxg_gtk_text_view_set_pixels_inside_wrap, 2, 0, 0, H_gtk_text_view_set_pixels_inside_wrap);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_pixels_inside_wrap, gxg_gtk_text_view_get_pixels_inside_wrap, 1, 0, 0, H_gtk_text_view_get_pixels_inside_wrap);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_justification, gxg_gtk_text_view_set_justification, 2, 0, 0, H_gtk_text_view_set_justification);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_justification, gxg_gtk_text_view_get_justification, 1, 0, 0, H_gtk_text_view_get_justification);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_left_margin, gxg_gtk_text_view_set_left_margin, 2, 0, 0, H_gtk_text_view_set_left_margin);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_left_margin, gxg_gtk_text_view_get_left_margin, 1, 0, 0, H_gtk_text_view_get_left_margin);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_right_margin, gxg_gtk_text_view_set_right_margin, 2, 0, 0, H_gtk_text_view_set_right_margin);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_right_margin, gxg_gtk_text_view_get_right_margin, 1, 0, 0, H_gtk_text_view_get_right_margin);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_indent, gxg_gtk_text_view_set_indent, 2, 0, 0, H_gtk_text_view_set_indent);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_indent, gxg_gtk_text_view_get_indent, 1, 0, 0, H_gtk_text_view_get_indent);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_tabs, gxg_gtk_text_view_set_tabs, 2, 0, 0, H_gtk_text_view_set_tabs);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_tabs, gxg_gtk_text_view_get_tabs, 1, 0, 0, H_gtk_text_view_get_tabs);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_default_attributes, gxg_gtk_text_view_get_default_attributes, 1, 0, 0, H_gtk_text_view_get_default_attributes);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_get_type, gxg_gtk_toggle_button_get_type, 0, 0, 0, H_gtk_toggle_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_new, gxg_gtk_toggle_button_new, 0, 0, 0, H_gtk_toggle_button_new);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_new_with_label, gxg_gtk_toggle_button_new_with_label, 1, 0, 0, H_gtk_toggle_button_new_with_label);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_new_with_mnemonic, gxg_gtk_toggle_button_new_with_mnemonic, 1, 0, 0, H_gtk_toggle_button_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_set_mode, gxg_gtk_toggle_button_set_mode, 2, 0, 0, H_gtk_toggle_button_set_mode);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_get_mode, gxg_gtk_toggle_button_get_mode, 1, 0, 0, H_gtk_toggle_button_get_mode);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_set_active, gxg_gtk_toggle_button_set_active, 2, 0, 0, H_gtk_toggle_button_set_active);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_get_active, gxg_gtk_toggle_button_get_active, 1, 0, 0, H_gtk_toggle_button_get_active);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_toggled, gxg_gtk_toggle_button_toggled, 1, 0, 0, H_gtk_toggle_button_toggled);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_set_inconsistent, gxg_gtk_toggle_button_set_inconsistent, 2, 0, 0, H_gtk_toggle_button_set_inconsistent);
  XG_DEFINE_PROCEDURE(gtk_toggle_button_get_inconsistent, gxg_gtk_toggle_button_get_inconsistent, 1, 0, 0, H_gtk_toggle_button_get_inconsistent);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_type, gxg_gtk_toolbar_get_type, 0, 0, 0, H_gtk_toolbar_get_type);
  XG_DEFINE_PROCEDURE(gtk_toolbar_new, gxg_gtk_toolbar_new, 0, 0, 0, H_gtk_toolbar_new);
  XG_DEFINE_PROCEDURE(gtk_toolbar_set_orientation, gxg_gtk_toolbar_set_orientation, 2, 0, 0, H_gtk_toolbar_set_orientation);
  XG_DEFINE_PROCEDURE(gtk_toolbar_set_style, gxg_gtk_toolbar_set_style, 2, 0, 0, H_gtk_toolbar_set_style);
  XG_DEFINE_PROCEDURE(gtk_toolbar_set_tooltips, gxg_gtk_toolbar_set_tooltips, 2, 0, 0, H_gtk_toolbar_set_tooltips);
  XG_DEFINE_PROCEDURE(gtk_toolbar_unset_style, gxg_gtk_toolbar_unset_style, 1, 0, 0, H_gtk_toolbar_unset_style);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_orientation, gxg_gtk_toolbar_get_orientation, 1, 0, 0, H_gtk_toolbar_get_orientation);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_style, gxg_gtk_toolbar_get_style, 1, 0, 0, H_gtk_toolbar_get_style);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_icon_size, gxg_gtk_toolbar_get_icon_size, 1, 0, 0, H_gtk_toolbar_get_icon_size);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_tooltips, gxg_gtk_toolbar_get_tooltips, 1, 0, 0, H_gtk_toolbar_get_tooltips);
  XG_DEFINE_PROCEDURE(gtk_tooltips_get_type, gxg_gtk_tooltips_get_type, 0, 0, 0, H_gtk_tooltips_get_type);
  XG_DEFINE_PROCEDURE(gtk_tooltips_new, gxg_gtk_tooltips_new, 0, 0, 0, H_gtk_tooltips_new);
  XG_DEFINE_PROCEDURE(gtk_tooltips_enable, gxg_gtk_tooltips_enable, 1, 0, 0, H_gtk_tooltips_enable);
  XG_DEFINE_PROCEDURE(gtk_tooltips_disable, gxg_gtk_tooltips_disable, 1, 0, 0, H_gtk_tooltips_disable);
  XG_DEFINE_PROCEDURE(gtk_tooltips_set_tip, gxg_gtk_tooltips_set_tip, 4, 0, 0, H_gtk_tooltips_set_tip);
  XG_DEFINE_PROCEDURE(gtk_tooltips_data_get, gxg_gtk_tooltips_data_get, 1, 0, 0, H_gtk_tooltips_data_get);
  XG_DEFINE_PROCEDURE(gtk_tooltips_force_window, gxg_gtk_tooltips_force_window, 1, 0, 0, H_gtk_tooltips_force_window);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_source_get_type, gxg_gtk_tree_drag_source_get_type, 0, 0, 0, H_gtk_tree_drag_source_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_source_row_draggable, gxg_gtk_tree_drag_source_row_draggable, 2, 0, 0, H_gtk_tree_drag_source_row_draggable);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_source_drag_data_delete, gxg_gtk_tree_drag_source_drag_data_delete, 2, 0, 0, H_gtk_tree_drag_source_drag_data_delete);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_source_drag_data_get, gxg_gtk_tree_drag_source_drag_data_get, 3, 0, 0, H_gtk_tree_drag_source_drag_data_get);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_dest_get_type, gxg_gtk_tree_drag_dest_get_type, 0, 0, 0, H_gtk_tree_drag_dest_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_dest_drag_data_received, gxg_gtk_tree_drag_dest_drag_data_received, 3, 0, 0, H_gtk_tree_drag_dest_drag_data_received);
  XG_DEFINE_PROCEDURE(gtk_tree_drag_dest_row_drop_possible, gxg_gtk_tree_drag_dest_row_drop_possible, 3, 0, 0, H_gtk_tree_drag_dest_row_drop_possible);
  XG_DEFINE_PROCEDURE(gtk_tree_set_row_drag_data, gxg_gtk_tree_set_row_drag_data, 3, 0, 0, H_gtk_tree_set_row_drag_data);
  XG_DEFINE_PROCEDURE(gtk_tree_get_row_drag_data, gxg_gtk_tree_get_row_drag_data, 1, 2, 0, H_gtk_tree_get_row_drag_data);
  XG_DEFINE_PROCEDURE(gtk_tree_path_new, gxg_gtk_tree_path_new, 0, 0, 0, H_gtk_tree_path_new);
  XG_DEFINE_PROCEDURE(gtk_tree_path_new_from_string, gxg_gtk_tree_path_new_from_string, 1, 0, 0, H_gtk_tree_path_new_from_string);
  XG_DEFINE_PROCEDURE(gtk_tree_path_to_string, gxg_gtk_tree_path_to_string, 1, 0, 0, H_gtk_tree_path_to_string);
  XG_DEFINE_PROCEDURE(gtk_tree_path_new_first, gxg_gtk_tree_path_new_first, 0, 0, 0, H_gtk_tree_path_new_first);
  XG_DEFINE_PROCEDURE(gtk_tree_path_append_index, gxg_gtk_tree_path_append_index, 2, 0, 0, H_gtk_tree_path_append_index);
  XG_DEFINE_PROCEDURE(gtk_tree_path_prepend_index, gxg_gtk_tree_path_prepend_index, 2, 0, 0, H_gtk_tree_path_prepend_index);
  XG_DEFINE_PROCEDURE(gtk_tree_path_get_depth, gxg_gtk_tree_path_get_depth, 1, 0, 0, H_gtk_tree_path_get_depth);
  XG_DEFINE_PROCEDURE(gtk_tree_path_get_indices, gxg_gtk_tree_path_get_indices, 1, 0, 0, H_gtk_tree_path_get_indices);
  XG_DEFINE_PROCEDURE(gtk_tree_path_free, gxg_gtk_tree_path_free, 1, 0, 0, H_gtk_tree_path_free);
  XG_DEFINE_PROCEDURE(gtk_tree_path_copy, gxg_gtk_tree_path_copy, 1, 0, 0, H_gtk_tree_path_copy);
  XG_DEFINE_PROCEDURE(gtk_tree_path_compare, gxg_gtk_tree_path_compare, 2, 0, 0, H_gtk_tree_path_compare);
  XG_DEFINE_PROCEDURE(gtk_tree_path_next, gxg_gtk_tree_path_next, 1, 0, 0, H_gtk_tree_path_next);
  XG_DEFINE_PROCEDURE(gtk_tree_path_prev, gxg_gtk_tree_path_prev, 1, 0, 0, H_gtk_tree_path_prev);
  XG_DEFINE_PROCEDURE(gtk_tree_path_up, gxg_gtk_tree_path_up, 1, 0, 0, H_gtk_tree_path_up);
  XG_DEFINE_PROCEDURE(gtk_tree_path_down, gxg_gtk_tree_path_down, 1, 0, 0, H_gtk_tree_path_down);
  XG_DEFINE_PROCEDURE(gtk_tree_path_is_ancestor, gxg_gtk_tree_path_is_ancestor, 2, 0, 0, H_gtk_tree_path_is_ancestor);
  XG_DEFINE_PROCEDURE(gtk_tree_path_is_descendant, gxg_gtk_tree_path_is_descendant, 2, 0, 0, H_gtk_tree_path_is_descendant);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_new, gxg_gtk_tree_row_reference_new, 2, 0, 0, H_gtk_tree_row_reference_new);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_new_proxy, gxg_gtk_tree_row_reference_new_proxy, 3, 0, 0, H_gtk_tree_row_reference_new_proxy);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_get_path, gxg_gtk_tree_row_reference_get_path, 1, 0, 0, H_gtk_tree_row_reference_get_path);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_valid, gxg_gtk_tree_row_reference_valid, 1, 0, 0, H_gtk_tree_row_reference_valid);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_free, gxg_gtk_tree_row_reference_free, 1, 0, 0, H_gtk_tree_row_reference_free);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_inserted, gxg_gtk_tree_row_reference_inserted, 2, 0, 0, H_gtk_tree_row_reference_inserted);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_deleted, gxg_gtk_tree_row_reference_deleted, 2, 0, 0, H_gtk_tree_row_reference_deleted);
  XG_DEFINE_PROCEDURE(gtk_tree_row_reference_reordered, gxg_gtk_tree_row_reference_reordered, 4, 0, 0, H_gtk_tree_row_reference_reordered);
  XG_DEFINE_PROCEDURE(gtk_tree_iter_copy, gxg_gtk_tree_iter_copy, 1, 0, 0, H_gtk_tree_iter_copy);
  XG_DEFINE_PROCEDURE(gtk_tree_iter_free, gxg_gtk_tree_iter_free, 1, 0, 0, H_gtk_tree_iter_free);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_type, gxg_gtk_tree_model_get_type, 0, 0, 0, H_gtk_tree_model_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_flags, gxg_gtk_tree_model_get_flags, 1, 0, 0, H_gtk_tree_model_get_flags);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_n_columns, gxg_gtk_tree_model_get_n_columns, 1, 0, 0, H_gtk_tree_model_get_n_columns);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_column_type, gxg_gtk_tree_model_get_column_type, 2, 0, 0, H_gtk_tree_model_get_column_type);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_iter, gxg_gtk_tree_model_get_iter, 3, 0, 0, H_gtk_tree_model_get_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_iter_from_string, gxg_gtk_tree_model_get_iter_from_string, 3, 0, 0, H_gtk_tree_model_get_iter_from_string);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_iter_first, gxg_gtk_tree_model_get_iter_first, 2, 0, 0, H_gtk_tree_model_get_iter_first);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_path, gxg_gtk_tree_model_get_path, 2, 0, 0, H_gtk_tree_model_get_path);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_next, gxg_gtk_tree_model_iter_next, 2, 0, 0, H_gtk_tree_model_iter_next);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_children, gxg_gtk_tree_model_iter_children, 3, 0, 0, H_gtk_tree_model_iter_children);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_has_child, gxg_gtk_tree_model_iter_has_child, 2, 0, 0, H_gtk_tree_model_iter_has_child);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_n_children, gxg_gtk_tree_model_iter_n_children, 2, 0, 0, H_gtk_tree_model_iter_n_children);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_nth_child, gxg_gtk_tree_model_iter_nth_child, 4, 0, 0, H_gtk_tree_model_iter_nth_child);
  XG_DEFINE_PROCEDURE(gtk_tree_model_iter_parent, gxg_gtk_tree_model_iter_parent, 3, 0, 0, H_gtk_tree_model_iter_parent);
  XG_DEFINE_PROCEDURE(gtk_tree_model_ref_node, gxg_gtk_tree_model_ref_node, 2, 0, 0, H_gtk_tree_model_ref_node);
  XG_DEFINE_PROCEDURE(gtk_tree_model_unref_node, gxg_gtk_tree_model_unref_node, 2, 0, 0, H_gtk_tree_model_unref_node);
  XG_DEFINE_PROCEDURE(gtk_tree_model_foreach, gxg_gtk_tree_model_foreach, 2, 1, 0, H_gtk_tree_model_foreach);
  XG_DEFINE_PROCEDURE(gtk_tree_model_row_changed, gxg_gtk_tree_model_row_changed, 3, 0, 0, H_gtk_tree_model_row_changed);
  XG_DEFINE_PROCEDURE(gtk_tree_model_row_inserted, gxg_gtk_tree_model_row_inserted, 3, 0, 0, H_gtk_tree_model_row_inserted);
  XG_DEFINE_PROCEDURE(gtk_tree_model_row_has_child_toggled, gxg_gtk_tree_model_row_has_child_toggled, 3, 0, 0, H_gtk_tree_model_row_has_child_toggled);
  XG_DEFINE_PROCEDURE(gtk_tree_model_row_deleted, gxg_gtk_tree_model_row_deleted, 2, 0, 0, H_gtk_tree_model_row_deleted);
  XG_DEFINE_PROCEDURE(gtk_tree_model_rows_reordered, gxg_gtk_tree_model_rows_reordered, 4, 0, 0, H_gtk_tree_model_rows_reordered);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_get_type, gxg_gtk_tree_model_sort_get_type, 0, 0, 0, H_gtk_tree_model_sort_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_new_with_model, gxg_gtk_tree_model_sort_new_with_model, 1, 0, 0, H_gtk_tree_model_sort_new_with_model);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_get_model, gxg_gtk_tree_model_sort_get_model, 1, 0, 0, H_gtk_tree_model_sort_get_model);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_convert_child_path_to_path, gxg_gtk_tree_model_sort_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_sort_convert_child_path_to_path);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_convert_child_iter_to_iter, gxg_gtk_tree_model_sort_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_child_iter_to_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_convert_path_to_child_path, gxg_gtk_tree_model_sort_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_sort_convert_path_to_child_path);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_convert_iter_to_child_iter, gxg_gtk_tree_model_sort_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_iter_to_child_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_reset_default_sort_func, gxg_gtk_tree_model_sort_reset_default_sort_func, 1, 0, 0, H_gtk_tree_model_sort_reset_default_sort_func);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_clear_cache, gxg_gtk_tree_model_sort_clear_cache, 1, 0, 0, H_gtk_tree_model_sort_clear_cache);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_type, gxg_gtk_tree_selection_get_type, 0, 0, 0, H_gtk_tree_selection_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_set_mode, gxg_gtk_tree_selection_set_mode, 2, 0, 0, H_gtk_tree_selection_set_mode);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_mode, gxg_gtk_tree_selection_get_mode, 1, 0, 0, H_gtk_tree_selection_get_mode);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_set_select_function, gxg_gtk_tree_selection_set_select_function, 4, 0, 0, H_gtk_tree_selection_set_select_function);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_user_data, gxg_gtk_tree_selection_get_user_data, 1, 0, 0, H_gtk_tree_selection_get_user_data);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_tree_view, gxg_gtk_tree_selection_get_tree_view, 1, 0, 0, H_gtk_tree_selection_get_tree_view);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_selected, gxg_gtk_tree_selection_get_selected, 3, 0, 0, H_gtk_tree_selection_get_selected);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_selected_foreach, gxg_gtk_tree_selection_selected_foreach, 2, 1, 0, H_gtk_tree_selection_selected_foreach);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_select_path, gxg_gtk_tree_selection_select_path, 2, 0, 0, H_gtk_tree_selection_select_path);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_unselect_path, gxg_gtk_tree_selection_unselect_path, 2, 0, 0, H_gtk_tree_selection_unselect_path);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_select_iter, gxg_gtk_tree_selection_select_iter, 2, 0, 0, H_gtk_tree_selection_select_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_unselect_iter, gxg_gtk_tree_selection_unselect_iter, 2, 0, 0, H_gtk_tree_selection_unselect_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_path_is_selected, gxg_gtk_tree_selection_path_is_selected, 2, 0, 0, H_gtk_tree_selection_path_is_selected);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_iter_is_selected, gxg_gtk_tree_selection_iter_is_selected, 2, 0, 0, H_gtk_tree_selection_iter_is_selected);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_select_all, gxg_gtk_tree_selection_select_all, 1, 0, 0, H_gtk_tree_selection_select_all);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_unselect_all, gxg_gtk_tree_selection_unselect_all, 1, 0, 0, H_gtk_tree_selection_unselect_all);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_select_range, gxg_gtk_tree_selection_select_range, 3, 0, 0, H_gtk_tree_selection_select_range);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_get_type, gxg_gtk_tree_sortable_get_type, 0, 0, 0, H_gtk_tree_sortable_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_sort_column_changed, gxg_gtk_tree_sortable_sort_column_changed, 1, 0, 0, H_gtk_tree_sortable_sort_column_changed);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_get_sort_column_id, gxg_gtk_tree_sortable_get_sort_column_id, 1, 2, 0, H_gtk_tree_sortable_get_sort_column_id);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_set_sort_column_id, gxg_gtk_tree_sortable_set_sort_column_id, 3, 0, 0, H_gtk_tree_sortable_set_sort_column_id);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_set_sort_func, gxg_gtk_tree_sortable_set_sort_func, 5, 0, 0, H_gtk_tree_sortable_set_sort_func);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_set_default_sort_func, gxg_gtk_tree_sortable_set_default_sort_func, 4, 0, 0, H_gtk_tree_sortable_set_default_sort_func);
  XG_DEFINE_PROCEDURE(gtk_tree_sortable_has_default_sort_func, gxg_gtk_tree_sortable_has_default_sort_func, 1, 0, 0, H_gtk_tree_sortable_has_default_sort_func);
  XG_DEFINE_PROCEDURE(gtk_tree_store_get_type, gxg_gtk_tree_store_get_type, 0, 0, 0, H_gtk_tree_store_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_store_new, gxg_gtk_tree_store_new, 2, 0, 0, H_gtk_tree_store_new);
  XG_DEFINE_PROCEDURE(gtk_tree_store_newv, gxg_gtk_tree_store_newv, 2, 0, 0, H_gtk_tree_store_newv);
  XG_DEFINE_PROCEDURE(gtk_tree_store_set_column_types, gxg_gtk_tree_store_set_column_types, 3, 0, 0, H_gtk_tree_store_set_column_types);
  XG_DEFINE_PROCEDURE(gtk_tree_store_set, gxg_gtk_tree_store_set, 3, 0, 0, H_gtk_tree_store_set);
  XG_DEFINE_PROCEDURE(gtk_tree_store_remove, gxg_gtk_tree_store_remove, 2, 0, 0, H_gtk_tree_store_remove);
  XG_DEFINE_PROCEDURE(gtk_tree_store_insert, gxg_gtk_tree_store_insert, 4, 0, 0, H_gtk_tree_store_insert);
  XG_DEFINE_PROCEDURE(gtk_tree_store_insert_before, gxg_gtk_tree_store_insert_before, 4, 0, 0, H_gtk_tree_store_insert_before);
  XG_DEFINE_PROCEDURE(gtk_tree_store_insert_after, gxg_gtk_tree_store_insert_after, 4, 0, 0, H_gtk_tree_store_insert_after);
  XG_DEFINE_PROCEDURE(gtk_tree_store_prepend, gxg_gtk_tree_store_prepend, 3, 0, 0, H_gtk_tree_store_prepend);
  XG_DEFINE_PROCEDURE(gtk_tree_store_append, gxg_gtk_tree_store_append, 3, 0, 0, H_gtk_tree_store_append);
  XG_DEFINE_PROCEDURE(gtk_tree_store_is_ancestor, gxg_gtk_tree_store_is_ancestor, 3, 0, 0, H_gtk_tree_store_is_ancestor);
  XG_DEFINE_PROCEDURE(gtk_tree_store_iter_depth, gxg_gtk_tree_store_iter_depth, 2, 0, 0, H_gtk_tree_store_iter_depth);
  XG_DEFINE_PROCEDURE(gtk_tree_store_clear, gxg_gtk_tree_store_clear, 1, 0, 0, H_gtk_tree_store_clear);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_type, gxg_gtk_tree_view_column_get_type, 0, 0, 0, H_gtk_tree_view_column_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_new, gxg_gtk_tree_view_column_new, 0, 0, 0, H_gtk_tree_view_column_new);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_new_with_attributes, gxg_gtk_tree_view_column_new_with_attributes, 3, 0, 0, H_gtk_tree_view_column_new_with_attributes);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_pack_start, gxg_gtk_tree_view_column_pack_start, 3, 0, 0, H_gtk_tree_view_column_pack_start);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_pack_end, gxg_gtk_tree_view_column_pack_end, 3, 0, 0, H_gtk_tree_view_column_pack_end);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_clear, gxg_gtk_tree_view_column_clear, 1, 0, 0, H_gtk_tree_view_column_clear);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_cell_renderers, gxg_gtk_tree_view_column_get_cell_renderers, 1, 0, 0, H_gtk_tree_view_column_get_cell_renderers);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_add_attribute, gxg_gtk_tree_view_column_add_attribute, 4, 0, 0, H_gtk_tree_view_column_add_attribute);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_attributes, gxg_gtk_tree_view_column_set_attributes, 3, 0, 0, H_gtk_tree_view_column_set_attributes);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_cell_data_func, gxg_gtk_tree_view_column_set_cell_data_func, 5, 0, 0, H_gtk_tree_view_column_set_cell_data_func);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_clear_attributes, gxg_gtk_tree_view_column_clear_attributes, 2, 0, 0, H_gtk_tree_view_column_clear_attributes);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_spacing, gxg_gtk_tree_view_column_set_spacing, 2, 0, 0, H_gtk_tree_view_column_set_spacing);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_spacing, gxg_gtk_tree_view_column_get_spacing, 1, 0, 0, H_gtk_tree_view_column_get_spacing);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_visible, gxg_gtk_tree_view_column_set_visible, 2, 0, 0, H_gtk_tree_view_column_set_visible);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_visible, gxg_gtk_tree_view_column_get_visible, 1, 0, 0, H_gtk_tree_view_column_get_visible);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_resizable, gxg_gtk_tree_view_column_set_resizable, 2, 0, 0, H_gtk_tree_view_column_set_resizable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_resizable, gxg_gtk_tree_view_column_get_resizable, 1, 0, 0, H_gtk_tree_view_column_get_resizable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_sizing, gxg_gtk_tree_view_column_set_sizing, 2, 0, 0, H_gtk_tree_view_column_set_sizing);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_sizing, gxg_gtk_tree_view_column_get_sizing, 1, 0, 0, H_gtk_tree_view_column_get_sizing);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_width, gxg_gtk_tree_view_column_get_width, 1, 0, 0, H_gtk_tree_view_column_get_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_fixed_width, gxg_gtk_tree_view_column_get_fixed_width, 1, 0, 0, H_gtk_tree_view_column_get_fixed_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_fixed_width, gxg_gtk_tree_view_column_set_fixed_width, 2, 0, 0, H_gtk_tree_view_column_set_fixed_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_min_width, gxg_gtk_tree_view_column_set_min_width, 2, 0, 0, H_gtk_tree_view_column_set_min_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_min_width, gxg_gtk_tree_view_column_get_min_width, 1, 0, 0, H_gtk_tree_view_column_get_min_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_max_width, gxg_gtk_tree_view_column_set_max_width, 2, 0, 0, H_gtk_tree_view_column_set_max_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_max_width, gxg_gtk_tree_view_column_get_max_width, 1, 0, 0, H_gtk_tree_view_column_get_max_width);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_clicked, gxg_gtk_tree_view_column_clicked, 1, 0, 0, H_gtk_tree_view_column_clicked);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_title, gxg_gtk_tree_view_column_set_title, 2, 0, 0, H_gtk_tree_view_column_set_title);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_title, gxg_gtk_tree_view_column_get_title, 1, 0, 0, H_gtk_tree_view_column_get_title);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_clickable, gxg_gtk_tree_view_column_set_clickable, 2, 0, 0, H_gtk_tree_view_column_set_clickable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_clickable, gxg_gtk_tree_view_column_get_clickable, 1, 0, 0, H_gtk_tree_view_column_get_clickable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_widget, gxg_gtk_tree_view_column_set_widget, 2, 0, 0, H_gtk_tree_view_column_set_widget);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_widget, gxg_gtk_tree_view_column_get_widget, 1, 0, 0, H_gtk_tree_view_column_get_widget);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_alignment, gxg_gtk_tree_view_column_set_alignment, 2, 0, 0, H_gtk_tree_view_column_set_alignment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_alignment, gxg_gtk_tree_view_column_get_alignment, 1, 0, 0, H_gtk_tree_view_column_get_alignment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_reorderable, gxg_gtk_tree_view_column_set_reorderable, 2, 0, 0, H_gtk_tree_view_column_set_reorderable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_reorderable, gxg_gtk_tree_view_column_get_reorderable, 1, 0, 0, H_gtk_tree_view_column_get_reorderable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_sort_column_id, gxg_gtk_tree_view_column_set_sort_column_id, 2, 0, 0, H_gtk_tree_view_column_set_sort_column_id);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_sort_column_id, gxg_gtk_tree_view_column_get_sort_column_id, 1, 0, 0, H_gtk_tree_view_column_get_sort_column_id);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_sort_indicator, gxg_gtk_tree_view_column_set_sort_indicator, 2, 0, 0, H_gtk_tree_view_column_set_sort_indicator);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_sort_indicator, gxg_gtk_tree_view_column_get_sort_indicator, 1, 0, 0, H_gtk_tree_view_column_get_sort_indicator);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_sort_order, gxg_gtk_tree_view_column_set_sort_order, 2, 0, 0, H_gtk_tree_view_column_set_sort_order);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_sort_order, gxg_gtk_tree_view_column_get_sort_order, 1, 0, 0, H_gtk_tree_view_column_get_sort_order);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_cell_set_cell_data, gxg_gtk_tree_view_column_cell_set_cell_data, 5, 0, 0, H_gtk_tree_view_column_cell_set_cell_data);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_cell_get_size, gxg_gtk_tree_view_column_cell_get_size, 2, 4, 0, H_gtk_tree_view_column_cell_get_size);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_cell_is_visible, gxg_gtk_tree_view_column_cell_is_visible, 1, 0, 0, H_gtk_tree_view_column_cell_is_visible);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_type, gxg_gtk_tree_view_get_type, 0, 0, 0, H_gtk_tree_view_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_view_new, gxg_gtk_tree_view_new, 0, 0, 0, H_gtk_tree_view_new);
  XG_DEFINE_PROCEDURE(gtk_tree_view_new_with_model, gxg_gtk_tree_view_new_with_model, 1, 0, 0, H_gtk_tree_view_new_with_model);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_model, gxg_gtk_tree_view_get_model, 1, 0, 0, H_gtk_tree_view_get_model);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_model, gxg_gtk_tree_view_set_model, 2, 0, 0, H_gtk_tree_view_set_model);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_selection, gxg_gtk_tree_view_get_selection, 1, 0, 0, H_gtk_tree_view_get_selection);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_hadjustment, gxg_gtk_tree_view_get_hadjustment, 1, 0, 0, H_gtk_tree_view_get_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_hadjustment, gxg_gtk_tree_view_set_hadjustment, 2, 0, 0, H_gtk_tree_view_set_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_vadjustment, gxg_gtk_tree_view_get_vadjustment, 1, 0, 0, H_gtk_tree_view_get_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_vadjustment, gxg_gtk_tree_view_set_vadjustment, 2, 0, 0, H_gtk_tree_view_set_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_headers_visible, gxg_gtk_tree_view_get_headers_visible, 1, 0, 0, H_gtk_tree_view_get_headers_visible);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_headers_visible, gxg_gtk_tree_view_set_headers_visible, 2, 0, 0, H_gtk_tree_view_set_headers_visible);
  XG_DEFINE_PROCEDURE(gtk_tree_view_columns_autosize, gxg_gtk_tree_view_columns_autosize, 1, 0, 0, H_gtk_tree_view_columns_autosize);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_headers_clickable, gxg_gtk_tree_view_set_headers_clickable, 2, 0, 0, H_gtk_tree_view_set_headers_clickable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_rules_hint, gxg_gtk_tree_view_set_rules_hint, 2, 0, 0, H_gtk_tree_view_set_rules_hint);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_rules_hint, gxg_gtk_tree_view_get_rules_hint, 1, 0, 0, H_gtk_tree_view_get_rules_hint);
  XG_DEFINE_PROCEDURE(gtk_tree_view_append_column, gxg_gtk_tree_view_append_column, 2, 0, 0, H_gtk_tree_view_append_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_remove_column, gxg_gtk_tree_view_remove_column, 2, 0, 0, H_gtk_tree_view_remove_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_insert_column, gxg_gtk_tree_view_insert_column, 3, 0, 0, H_gtk_tree_view_insert_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_insert_column_with_attributes, gxg_gtk_tree_view_insert_column_with_attributes, 5, 0, 0, H_gtk_tree_view_insert_column_with_attributes);
  XG_DEFINE_PROCEDURE(gtk_tree_view_insert_column_with_data_func, gxg_gtk_tree_view_insert_column_with_data_func, 7, 0, 0, H_gtk_tree_view_insert_column_with_data_func);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_column, gxg_gtk_tree_view_get_column, 2, 0, 0, H_gtk_tree_view_get_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_columns, gxg_gtk_tree_view_get_columns, 1, 0, 0, H_gtk_tree_view_get_columns);
  XG_DEFINE_PROCEDURE(gtk_tree_view_move_column_after, gxg_gtk_tree_view_move_column_after, 3, 0, 0, H_gtk_tree_view_move_column_after);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_expander_column, gxg_gtk_tree_view_set_expander_column, 2, 0, 0, H_gtk_tree_view_set_expander_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_expander_column, gxg_gtk_tree_view_get_expander_column, 1, 0, 0, H_gtk_tree_view_get_expander_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_column_drag_function, gxg_gtk_tree_view_set_column_drag_function, 4, 0, 0, H_gtk_tree_view_set_column_drag_function);
  XG_DEFINE_PROCEDURE(gtk_tree_view_scroll_to_point, gxg_gtk_tree_view_scroll_to_point, 3, 0, 0, H_gtk_tree_view_scroll_to_point);
  XG_DEFINE_PROCEDURE(gtk_tree_view_scroll_to_cell, gxg_gtk_tree_view_scroll_to_cell, 6, 0, 0, H_gtk_tree_view_scroll_to_cell);
  XG_DEFINE_PROCEDURE(gtk_tree_view_row_activated, gxg_gtk_tree_view_row_activated, 3, 0, 0, H_gtk_tree_view_row_activated);
  XG_DEFINE_PROCEDURE(gtk_tree_view_expand_all, gxg_gtk_tree_view_expand_all, 1, 0, 0, H_gtk_tree_view_expand_all);
  XG_DEFINE_PROCEDURE(gtk_tree_view_collapse_all, gxg_gtk_tree_view_collapse_all, 1, 0, 0, H_gtk_tree_view_collapse_all);
  XG_DEFINE_PROCEDURE(gtk_tree_view_expand_row, gxg_gtk_tree_view_expand_row, 3, 0, 0, H_gtk_tree_view_expand_row);
  XG_DEFINE_PROCEDURE(gtk_tree_view_collapse_row, gxg_gtk_tree_view_collapse_row, 2, 0, 0, H_gtk_tree_view_collapse_row);
  XG_DEFINE_PROCEDURE(gtk_tree_view_map_expanded_rows, gxg_gtk_tree_view_map_expanded_rows, 2, 1, 0, H_gtk_tree_view_map_expanded_rows);
  XG_DEFINE_PROCEDURE(gtk_tree_view_row_expanded, gxg_gtk_tree_view_row_expanded, 2, 0, 0, H_gtk_tree_view_row_expanded);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_reorderable, gxg_gtk_tree_view_set_reorderable, 2, 0, 0, H_gtk_tree_view_set_reorderable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_reorderable, gxg_gtk_tree_view_get_reorderable, 1, 0, 0, H_gtk_tree_view_get_reorderable);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_cursor, gxg_gtk_tree_view_set_cursor, 4, 0, 0, H_gtk_tree_view_set_cursor);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_cursor, gxg_gtk_tree_view_get_cursor, 1, 2, 0, H_gtk_tree_view_get_cursor);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_bin_window, gxg_gtk_tree_view_get_bin_window, 1, 0, 0, H_gtk_tree_view_get_bin_window);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_path_at_pos, gxg_gtk_tree_view_get_path_at_pos, 3, 4, 0, H_gtk_tree_view_get_path_at_pos);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_cell_area, gxg_gtk_tree_view_get_cell_area, 4, 0, 0, H_gtk_tree_view_get_cell_area);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_background_area, gxg_gtk_tree_view_get_background_area, 4, 0, 0, H_gtk_tree_view_get_background_area);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_visible_rect, gxg_gtk_tree_view_get_visible_rect, 2, 0, 0, H_gtk_tree_view_get_visible_rect);
  XG_DEFINE_PROCEDURE(gtk_tree_view_widget_to_tree_coords, gxg_gtk_tree_view_widget_to_tree_coords, 3, 2, 0, H_gtk_tree_view_widget_to_tree_coords);
  XG_DEFINE_PROCEDURE(gtk_tree_view_tree_to_widget_coords, gxg_gtk_tree_view_tree_to_widget_coords, 3, 2, 0, H_gtk_tree_view_tree_to_widget_coords);
  XG_DEFINE_PROCEDURE(gtk_tree_view_enable_model_drag_source, gxg_gtk_tree_view_enable_model_drag_source, 5, 0, 0, H_gtk_tree_view_enable_model_drag_source);
  XG_DEFINE_PROCEDURE(gtk_tree_view_enable_model_drag_dest, gxg_gtk_tree_view_enable_model_drag_dest, 4, 0, 0, H_gtk_tree_view_enable_model_drag_dest);
  XG_DEFINE_PROCEDURE(gtk_tree_view_unset_rows_drag_source, gxg_gtk_tree_view_unset_rows_drag_source, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_source);
  XG_DEFINE_PROCEDURE(gtk_tree_view_unset_rows_drag_dest, gxg_gtk_tree_view_unset_rows_drag_dest, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_dest);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_drag_dest_row, gxg_gtk_tree_view_set_drag_dest_row, 3, 0, 0, H_gtk_tree_view_set_drag_dest_row);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_drag_dest_row, gxg_gtk_tree_view_get_drag_dest_row, 1, 2, 0, H_gtk_tree_view_get_drag_dest_row);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_dest_row_at_pos, gxg_gtk_tree_view_get_dest_row_at_pos, 3, 2, 0, H_gtk_tree_view_get_dest_row_at_pos);
  XG_DEFINE_PROCEDURE(gtk_tree_view_create_row_drag_icon, gxg_gtk_tree_view_create_row_drag_icon, 2, 0, 0, H_gtk_tree_view_create_row_drag_icon);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_enable_search, gxg_gtk_tree_view_set_enable_search, 2, 0, 0, H_gtk_tree_view_set_enable_search);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_enable_search, gxg_gtk_tree_view_get_enable_search, 1, 0, 0, H_gtk_tree_view_get_enable_search);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_search_column, gxg_gtk_tree_view_get_search_column, 1, 0, 0, H_gtk_tree_view_get_search_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_search_column, gxg_gtk_tree_view_set_search_column, 2, 0, 0, H_gtk_tree_view_set_search_column);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_search_equal_func, gxg_gtk_tree_view_get_search_equal_func, 1, 0, 0, H_gtk_tree_view_get_search_equal_func);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_search_equal_func, gxg_gtk_tree_view_set_search_equal_func, 4, 0, 0, H_gtk_tree_view_set_search_equal_func);
  XG_DEFINE_PROCEDURE(gtk_vbutton_box_get_type, gxg_gtk_vbutton_box_get_type, 0, 0, 0, H_gtk_vbutton_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_vbutton_box_new, gxg_gtk_vbutton_box_new, 0, 0, 0, H_gtk_vbutton_box_new);
  XG_DEFINE_PROCEDURE(gtk_viewport_get_type, gxg_gtk_viewport_get_type, 0, 0, 0, H_gtk_viewport_get_type);
  XG_DEFINE_PROCEDURE(gtk_viewport_new, gxg_gtk_viewport_new, 2, 0, 0, H_gtk_viewport_new);
  XG_DEFINE_PROCEDURE(gtk_viewport_get_hadjustment, gxg_gtk_viewport_get_hadjustment, 1, 0, 0, H_gtk_viewport_get_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_viewport_get_vadjustment, gxg_gtk_viewport_get_vadjustment, 1, 0, 0, H_gtk_viewport_get_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_viewport_set_hadjustment, gxg_gtk_viewport_set_hadjustment, 2, 0, 0, H_gtk_viewport_set_hadjustment);
  XG_DEFINE_PROCEDURE(gtk_viewport_set_vadjustment, gxg_gtk_viewport_set_vadjustment, 2, 0, 0, H_gtk_viewport_set_vadjustment);
  XG_DEFINE_PROCEDURE(gtk_viewport_set_shadow_type, gxg_gtk_viewport_set_shadow_type, 2, 0, 0, H_gtk_viewport_set_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_viewport_get_shadow_type, gxg_gtk_viewport_get_shadow_type, 1, 0, 0, H_gtk_viewport_get_shadow_type);
  XG_DEFINE_PROCEDURE(gtk_vpaned_get_type, gxg_gtk_vpaned_get_type, 0, 0, 0, H_gtk_vpaned_get_type);
  XG_DEFINE_PROCEDURE(gtk_vpaned_new, gxg_gtk_vpaned_new, 0, 0, 0, H_gtk_vpaned_new);
  XG_DEFINE_PROCEDURE(gtk_vruler_get_type, gxg_gtk_vruler_get_type, 0, 0, 0, H_gtk_vruler_get_type);
  XG_DEFINE_PROCEDURE(gtk_vruler_new, gxg_gtk_vruler_new, 0, 0, 0, H_gtk_vruler_new);
  XG_DEFINE_PROCEDURE(gtk_vscale_get_type, gxg_gtk_vscale_get_type, 0, 0, 0, H_gtk_vscale_get_type);
  XG_DEFINE_PROCEDURE(gtk_vscale_new, gxg_gtk_vscale_new, 1, 0, 0, H_gtk_vscale_new);
  XG_DEFINE_PROCEDURE(gtk_vscale_new_with_range, gxg_gtk_vscale_new_with_range, 3, 0, 0, H_gtk_vscale_new_with_range);
  XG_DEFINE_PROCEDURE(gtk_vscrollbar_get_type, gxg_gtk_vscrollbar_get_type, 0, 0, 0, H_gtk_vscrollbar_get_type);
  XG_DEFINE_PROCEDURE(gtk_vscrollbar_new, gxg_gtk_vscrollbar_new, 1, 0, 0, H_gtk_vscrollbar_new);
  XG_DEFINE_PROCEDURE(gtk_vseparator_get_type, gxg_gtk_vseparator_get_type, 0, 0, 0, H_gtk_vseparator_get_type);
  XG_DEFINE_PROCEDURE(gtk_vseparator_new, gxg_gtk_vseparator_new, 0, 0, 0, H_gtk_vseparator_new);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_STATE, gxg_GTK_WIDGET_STATE, 1, 0, 0, H_GTK_WIDGET_STATE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_SAVED_STATE, gxg_GTK_WIDGET_SAVED_STATE, 1, 0, 0, H_GTK_WIDGET_SAVED_STATE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_FLAGS, gxg_GTK_WIDGET_FLAGS, 1, 0, 0, H_GTK_WIDGET_FLAGS);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_TOPLEVEL, gxg_GTK_WIDGET_TOPLEVEL, 1, 0, 0, H_GTK_WIDGET_TOPLEVEL);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_NO_WINDOW, gxg_GTK_WIDGET_NO_WINDOW, 1, 0, 0, H_GTK_WIDGET_NO_WINDOW);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_REALIZED, gxg_GTK_WIDGET_REALIZED, 1, 0, 0, H_GTK_WIDGET_REALIZED);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_MAPPED, gxg_GTK_WIDGET_MAPPED, 1, 0, 0, H_GTK_WIDGET_MAPPED);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_VISIBLE, gxg_GTK_WIDGET_VISIBLE, 1, 0, 0, H_GTK_WIDGET_VISIBLE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_DRAWABLE, gxg_GTK_WIDGET_DRAWABLE, 1, 0, 0, H_GTK_WIDGET_DRAWABLE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_SENSITIVE, gxg_GTK_WIDGET_SENSITIVE, 1, 0, 0, H_GTK_WIDGET_SENSITIVE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_PARENT_SENSITIVE, gxg_GTK_WIDGET_PARENT_SENSITIVE, 1, 0, 0, H_GTK_WIDGET_PARENT_SENSITIVE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_IS_SENSITIVE, gxg_GTK_WIDGET_IS_SENSITIVE, 1, 0, 0, H_GTK_WIDGET_IS_SENSITIVE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_CAN_FOCUS, gxg_GTK_WIDGET_CAN_FOCUS, 1, 0, 0, H_GTK_WIDGET_CAN_FOCUS);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_HAS_FOCUS, gxg_GTK_WIDGET_HAS_FOCUS, 1, 0, 0, H_GTK_WIDGET_HAS_FOCUS);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_CAN_DEFAULT, gxg_GTK_WIDGET_CAN_DEFAULT, 1, 0, 0, H_GTK_WIDGET_CAN_DEFAULT);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_HAS_DEFAULT, gxg_GTK_WIDGET_HAS_DEFAULT, 1, 0, 0, H_GTK_WIDGET_HAS_DEFAULT);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_HAS_GRAB, gxg_GTK_WIDGET_HAS_GRAB, 1, 0, 0, H_GTK_WIDGET_HAS_GRAB);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_RC_STYLE, gxg_GTK_WIDGET_RC_STYLE, 1, 0, 0, H_GTK_WIDGET_RC_STYLE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_COMPOSITE_CHILD, gxg_GTK_WIDGET_COMPOSITE_CHILD, 1, 0, 0, H_GTK_WIDGET_COMPOSITE_CHILD);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_APP_PAINTABLE, gxg_GTK_WIDGET_APP_PAINTABLE, 1, 0, 0, H_GTK_WIDGET_APP_PAINTABLE);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_RECEIVES_DEFAULT, gxg_GTK_WIDGET_RECEIVES_DEFAULT, 1, 0, 0, H_GTK_WIDGET_RECEIVES_DEFAULT);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_DOUBLE_BUFFERED, gxg_GTK_WIDGET_DOUBLE_BUFFERED, 1, 0, 0, H_GTK_WIDGET_DOUBLE_BUFFERED);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_SET_FLAGS, gxg_GTK_WIDGET_SET_FLAGS, 2, 0, 0, H_GTK_WIDGET_SET_FLAGS);
  XG_DEFINE_PROCEDURE(GTK_WIDGET_UNSET_FLAGS, gxg_GTK_WIDGET_UNSET_FLAGS, 2, 0, 0, H_GTK_WIDGET_UNSET_FLAGS);
  XG_DEFINE_PROCEDURE(gtk_widget_get_type, gxg_gtk_widget_get_type, 0, 0, 0, H_gtk_widget_get_type);
  XG_DEFINE_PROCEDURE(gtk_widget_ref, gxg_gtk_widget_ref, 1, 0, 0, H_gtk_widget_ref);
  XG_DEFINE_PROCEDURE(gtk_widget_unref, gxg_gtk_widget_unref, 1, 0, 0, H_gtk_widget_unref);
  XG_DEFINE_PROCEDURE(gtk_widget_destroy, gxg_gtk_widget_destroy, 1, 0, 0, H_gtk_widget_destroy);
  XG_DEFINE_PROCEDURE(gtk_widget_destroyed, gxg_gtk_widget_destroyed, 1, 1, 0, H_gtk_widget_destroyed);
  XG_DEFINE_PROCEDURE(gtk_widget_unparent, gxg_gtk_widget_unparent, 1, 0, 0, H_gtk_widget_unparent);
  XG_DEFINE_PROCEDURE(gtk_widget_show, gxg_gtk_widget_show, 1, 0, 0, H_gtk_widget_show);
  XG_DEFINE_PROCEDURE(gtk_widget_show_now, gxg_gtk_widget_show_now, 1, 0, 0, H_gtk_widget_show_now);
  XG_DEFINE_PROCEDURE(gtk_widget_hide, gxg_gtk_widget_hide, 1, 0, 0, H_gtk_widget_hide);
  XG_DEFINE_PROCEDURE(gtk_widget_show_all, gxg_gtk_widget_show_all, 1, 0, 0, H_gtk_widget_show_all);
  XG_DEFINE_PROCEDURE(gtk_widget_hide_all, gxg_gtk_widget_hide_all, 1, 0, 0, H_gtk_widget_hide_all);
  XG_DEFINE_PROCEDURE(gtk_widget_map, gxg_gtk_widget_map, 1, 0, 0, H_gtk_widget_map);
  XG_DEFINE_PROCEDURE(gtk_widget_unmap, gxg_gtk_widget_unmap, 1, 0, 0, H_gtk_widget_unmap);
  XG_DEFINE_PROCEDURE(gtk_widget_realize, gxg_gtk_widget_realize, 1, 0, 0, H_gtk_widget_realize);
  XG_DEFINE_PROCEDURE(gtk_widget_unrealize, gxg_gtk_widget_unrealize, 1, 0, 0, H_gtk_widget_unrealize);
  XG_DEFINE_PROCEDURE(gtk_widget_queue_draw, gxg_gtk_widget_queue_draw, 1, 0, 0, H_gtk_widget_queue_draw);
  XG_DEFINE_PROCEDURE(gtk_widget_queue_draw_area, gxg_gtk_widget_queue_draw_area, 5, 0, 0, H_gtk_widget_queue_draw_area);
  XG_DEFINE_PROCEDURE(gtk_widget_queue_resize, gxg_gtk_widget_queue_resize, 1, 0, 0, H_gtk_widget_queue_resize);
  XG_DEFINE_PROCEDURE(gtk_widget_size_request, gxg_gtk_widget_size_request, 2, 0, 0, H_gtk_widget_size_request);
  XG_DEFINE_PROCEDURE(gtk_widget_size_allocate, gxg_gtk_widget_size_allocate, 2, 0, 0, H_gtk_widget_size_allocate);
  XG_DEFINE_PROCEDURE(gtk_widget_get_child_requisition, gxg_gtk_widget_get_child_requisition, 2, 0, 0, H_gtk_widget_get_child_requisition);
  XG_DEFINE_PROCEDURE(gtk_widget_add_accelerator, gxg_gtk_widget_add_accelerator, 6, 0, 0, H_gtk_widget_add_accelerator);
  XG_DEFINE_PROCEDURE(gtk_widget_remove_accelerator, gxg_gtk_widget_remove_accelerator, 4, 0, 0, H_gtk_widget_remove_accelerator);
  XG_DEFINE_PROCEDURE(gtk_widget_list_accel_closures, gxg_gtk_widget_list_accel_closures, 1, 0, 0, H_gtk_widget_list_accel_closures);
  XG_DEFINE_PROCEDURE(gtk_widget_mnemonic_activate, gxg_gtk_widget_mnemonic_activate, 2, 0, 0, H_gtk_widget_mnemonic_activate);
  XG_DEFINE_PROCEDURE(gtk_widget_event, gxg_gtk_widget_event, 2, 0, 0, H_gtk_widget_event);
  XG_DEFINE_PROCEDURE(gtk_widget_send_expose, gxg_gtk_widget_send_expose, 2, 0, 0, H_gtk_widget_send_expose);
  XG_DEFINE_PROCEDURE(gtk_widget_activate, gxg_gtk_widget_activate, 1, 0, 0, H_gtk_widget_activate);
  XG_DEFINE_PROCEDURE(gtk_widget_set_scroll_adjustments, gxg_gtk_widget_set_scroll_adjustments, 3, 0, 0, H_gtk_widget_set_scroll_adjustments);
  XG_DEFINE_PROCEDURE(gtk_widget_reparent, gxg_gtk_widget_reparent, 2, 0, 0, H_gtk_widget_reparent);
  XG_DEFINE_PROCEDURE(gtk_widget_intersect, gxg_gtk_widget_intersect, 3, 0, 0, H_gtk_widget_intersect);
  XG_DEFINE_PROCEDURE(gtk_widget_region_intersect, gxg_gtk_widget_region_intersect, 2, 0, 0, H_gtk_widget_region_intersect);
  XG_DEFINE_PROCEDURE(gtk_widget_freeze_child_notify, gxg_gtk_widget_freeze_child_notify, 1, 0, 0, H_gtk_widget_freeze_child_notify);
  XG_DEFINE_PROCEDURE(gtk_widget_child_notify, gxg_gtk_widget_child_notify, 2, 0, 0, H_gtk_widget_child_notify);
  XG_DEFINE_PROCEDURE(gtk_widget_thaw_child_notify, gxg_gtk_widget_thaw_child_notify, 1, 0, 0, H_gtk_widget_thaw_child_notify);
  XG_DEFINE_PROCEDURE(gtk_widget_is_focus, gxg_gtk_widget_is_focus, 1, 0, 0, H_gtk_widget_is_focus);
  XG_DEFINE_PROCEDURE(gtk_widget_grab_focus, gxg_gtk_widget_grab_focus, 1, 0, 0, H_gtk_widget_grab_focus);
  XG_DEFINE_PROCEDURE(gtk_widget_grab_default, gxg_gtk_widget_grab_default, 1, 0, 0, H_gtk_widget_grab_default);
  XG_DEFINE_PROCEDURE(gtk_widget_set_name, gxg_gtk_widget_set_name, 2, 0, 0, H_gtk_widget_set_name);
  XG_DEFINE_PROCEDURE(gtk_widget_get_name, gxg_gtk_widget_get_name, 1, 0, 0, H_gtk_widget_get_name);
  XG_DEFINE_PROCEDURE(gtk_widget_set_state, gxg_gtk_widget_set_state, 2, 0, 0, H_gtk_widget_set_state);
  XG_DEFINE_PROCEDURE(gtk_widget_set_sensitive, gxg_gtk_widget_set_sensitive, 2, 0, 0, H_gtk_widget_set_sensitive);
  XG_DEFINE_PROCEDURE(gtk_widget_set_app_paintable, gxg_gtk_widget_set_app_paintable, 2, 0, 0, H_gtk_widget_set_app_paintable);
  XG_DEFINE_PROCEDURE(gtk_widget_set_double_buffered, gxg_gtk_widget_set_double_buffered, 2, 0, 0, H_gtk_widget_set_double_buffered);
  XG_DEFINE_PROCEDURE(gtk_widget_set_redraw_on_allocate, gxg_gtk_widget_set_redraw_on_allocate, 2, 0, 0, H_gtk_widget_set_redraw_on_allocate);
  XG_DEFINE_PROCEDURE(gtk_widget_set_parent, gxg_gtk_widget_set_parent, 2, 0, 0, H_gtk_widget_set_parent);
  XG_DEFINE_PROCEDURE(gtk_widget_set_parent_window, gxg_gtk_widget_set_parent_window, 2, 0, 0, H_gtk_widget_set_parent_window);
  XG_DEFINE_PROCEDURE(gtk_widget_set_child_visible, gxg_gtk_widget_set_child_visible, 2, 0, 0, H_gtk_widget_set_child_visible);
  XG_DEFINE_PROCEDURE(gtk_widget_set_accel_path, gxg_gtk_widget_set_accel_path, 3, 0, 0, H_gtk_widget_set_accel_path);
  XG_DEFINE_PROCEDURE(gtk_widget_get_child_visible, gxg_gtk_widget_get_child_visible, 1, 0, 0, H_gtk_widget_get_child_visible);
  XG_DEFINE_PROCEDURE(gtk_widget_get_parent, gxg_gtk_widget_get_parent, 1, 0, 0, H_gtk_widget_get_parent);
  XG_DEFINE_PROCEDURE(gtk_widget_get_parent_window, gxg_gtk_widget_get_parent_window, 1, 0, 0, H_gtk_widget_get_parent_window);
  XG_DEFINE_PROCEDURE(gtk_widget_child_focus, gxg_gtk_widget_child_focus, 2, 0, 0, H_gtk_widget_child_focus);
  XG_DEFINE_PROCEDURE(gtk_widget_set_size_request, gxg_gtk_widget_set_size_request, 3, 0, 0, H_gtk_widget_set_size_request);
  XG_DEFINE_PROCEDURE(gtk_widget_get_size_request, gxg_gtk_widget_get_size_request, 1, 2, 0, H_gtk_widget_get_size_request);
  XG_DEFINE_PROCEDURE(gtk_widget_set_events, gxg_gtk_widget_set_events, 2, 0, 0, H_gtk_widget_set_events);
  XG_DEFINE_PROCEDURE(gtk_widget_add_events, gxg_gtk_widget_add_events, 2, 0, 0, H_gtk_widget_add_events);
  XG_DEFINE_PROCEDURE(gtk_widget_set_extension_events, gxg_gtk_widget_set_extension_events, 2, 0, 0, H_gtk_widget_set_extension_events);
  XG_DEFINE_PROCEDURE(gtk_widget_get_extension_events, gxg_gtk_widget_get_extension_events, 1, 0, 0, H_gtk_widget_get_extension_events);
  XG_DEFINE_PROCEDURE(gtk_widget_get_toplevel, gxg_gtk_widget_get_toplevel, 1, 0, 0, H_gtk_widget_get_toplevel);
  XG_DEFINE_PROCEDURE(gtk_widget_get_ancestor, gxg_gtk_widget_get_ancestor, 2, 0, 0, H_gtk_widget_get_ancestor);
  XG_DEFINE_PROCEDURE(gtk_widget_get_colormap, gxg_gtk_widget_get_colormap, 1, 0, 0, H_gtk_widget_get_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_get_visual, gxg_gtk_widget_get_visual, 1, 0, 0, H_gtk_widget_get_visual);
  XG_DEFINE_PROCEDURE(gtk_widget_get_accessible, gxg_gtk_widget_get_accessible, 1, 0, 0, H_gtk_widget_get_accessible);
  XG_DEFINE_PROCEDURE(gtk_widget_set_colormap, gxg_gtk_widget_set_colormap, 2, 0, 0, H_gtk_widget_set_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_get_events, gxg_gtk_widget_get_events, 1, 0, 0, H_gtk_widget_get_events);
  XG_DEFINE_PROCEDURE(gtk_widget_get_pointer, gxg_gtk_widget_get_pointer, 1, 2, 0, H_gtk_widget_get_pointer);
  XG_DEFINE_PROCEDURE(gtk_widget_is_ancestor, gxg_gtk_widget_is_ancestor, 2, 0, 0, H_gtk_widget_is_ancestor);
  XG_DEFINE_PROCEDURE(gtk_widget_translate_coordinates, gxg_gtk_widget_translate_coordinates, 4, 2, 0, H_gtk_widget_translate_coordinates);
  XG_DEFINE_PROCEDURE(gtk_widget_hide_on_delete, gxg_gtk_widget_hide_on_delete, 1, 0, 0, H_gtk_widget_hide_on_delete);
  XG_DEFINE_PROCEDURE(gtk_widget_set_style, gxg_gtk_widget_set_style, 2, 0, 0, H_gtk_widget_set_style);
  XG_DEFINE_PROCEDURE(gtk_widget_ensure_style, gxg_gtk_widget_ensure_style, 1, 0, 0, H_gtk_widget_ensure_style);
  XG_DEFINE_PROCEDURE(gtk_widget_get_style, gxg_gtk_widget_get_style, 1, 0, 0, H_gtk_widget_get_style);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_style, gxg_gtk_widget_modify_style, 2, 0, 0, H_gtk_widget_modify_style);
  XG_DEFINE_PROCEDURE(gtk_widget_get_modifier_style, gxg_gtk_widget_get_modifier_style, 1, 0, 0, H_gtk_widget_get_modifier_style);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_fg, gxg_gtk_widget_modify_fg, 3, 0, 0, H_gtk_widget_modify_fg);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_bg, gxg_gtk_widget_modify_bg, 3, 0, 0, H_gtk_widget_modify_bg);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_text, gxg_gtk_widget_modify_text, 3, 0, 0, H_gtk_widget_modify_text);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_base, gxg_gtk_widget_modify_base, 3, 0, 0, H_gtk_widget_modify_base);
  XG_DEFINE_PROCEDURE(gtk_widget_modify_font, gxg_gtk_widget_modify_font, 2, 0, 0, H_gtk_widget_modify_font);
  XG_DEFINE_PROCEDURE(gtk_widget_create_pango_context, gxg_gtk_widget_create_pango_context, 1, 0, 0, H_gtk_widget_create_pango_context);
  XG_DEFINE_PROCEDURE(gtk_widget_get_pango_context, gxg_gtk_widget_get_pango_context, 1, 0, 0, H_gtk_widget_get_pango_context);
  XG_DEFINE_PROCEDURE(gtk_widget_create_pango_layout, gxg_gtk_widget_create_pango_layout, 2, 0, 0, H_gtk_widget_create_pango_layout);
  XG_DEFINE_PROCEDURE(gtk_widget_render_icon, gxg_gtk_widget_render_icon, 4, 0, 0, H_gtk_widget_render_icon);
  XG_DEFINE_PROCEDURE(gtk_widget_set_composite_name, gxg_gtk_widget_set_composite_name, 2, 0, 0, H_gtk_widget_set_composite_name);
  XG_DEFINE_PROCEDURE(gtk_widget_get_composite_name, gxg_gtk_widget_get_composite_name, 1, 0, 0, H_gtk_widget_get_composite_name);
  XG_DEFINE_PROCEDURE(gtk_widget_reset_rc_styles, gxg_gtk_widget_reset_rc_styles, 1, 0, 0, H_gtk_widget_reset_rc_styles);
  XG_DEFINE_PROCEDURE(gtk_widget_push_colormap, gxg_gtk_widget_push_colormap, 1, 0, 0, H_gtk_widget_push_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_push_composite_child, gxg_gtk_widget_push_composite_child, 0, 0, 0, H_gtk_widget_push_composite_child);
  XG_DEFINE_PROCEDURE(gtk_widget_pop_composite_child, gxg_gtk_widget_pop_composite_child, 0, 0, 0, H_gtk_widget_pop_composite_child);
  XG_DEFINE_PROCEDURE(gtk_widget_pop_colormap, gxg_gtk_widget_pop_colormap, 0, 0, 0, H_gtk_widget_pop_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_set_default_colormap, gxg_gtk_widget_set_default_colormap, 1, 0, 0, H_gtk_widget_set_default_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_get_default_style, gxg_gtk_widget_get_default_style, 0, 0, 0, H_gtk_widget_get_default_style);
  XG_DEFINE_PROCEDURE(gtk_widget_get_default_colormap, gxg_gtk_widget_get_default_colormap, 0, 0, 0, H_gtk_widget_get_default_colormap);
  XG_DEFINE_PROCEDURE(gtk_widget_get_default_visual, gxg_gtk_widget_get_default_visual, 0, 0, 0, H_gtk_widget_get_default_visual);
  XG_DEFINE_PROCEDURE(gtk_widget_set_direction, gxg_gtk_widget_set_direction, 2, 0, 0, H_gtk_widget_set_direction);
  XG_DEFINE_PROCEDURE(gtk_widget_get_direction, gxg_gtk_widget_get_direction, 1, 0, 0, H_gtk_widget_get_direction);
  XG_DEFINE_PROCEDURE(gtk_widget_set_default_direction, gxg_gtk_widget_set_default_direction, 1, 0, 0, H_gtk_widget_set_default_direction);
  XG_DEFINE_PROCEDURE(gtk_widget_get_default_direction, gxg_gtk_widget_get_default_direction, 0, 0, 0, H_gtk_widget_get_default_direction);
  XG_DEFINE_PROCEDURE(gtk_widget_shape_combine_mask, gxg_gtk_widget_shape_combine_mask, 4, 0, 0, H_gtk_widget_shape_combine_mask);
  XG_DEFINE_PROCEDURE(gtk_widget_reset_shapes, gxg_gtk_widget_reset_shapes, 1, 0, 0, H_gtk_widget_reset_shapes);
  XG_DEFINE_PROCEDURE(gtk_widget_path, gxg_gtk_widget_path, 2, 2, 0, H_gtk_widget_path);
  XG_DEFINE_PROCEDURE(gtk_widget_class_path, gxg_gtk_widget_class_path, 2, 2, 0, H_gtk_widget_class_path);
  XG_DEFINE_PROCEDURE(gtk_requisition_copy, gxg_gtk_requisition_copy, 1, 0, 0, H_gtk_requisition_copy);
  XG_DEFINE_PROCEDURE(gtk_requisition_free, gxg_gtk_requisition_free, 1, 0, 0, H_gtk_requisition_free);
  XG_DEFINE_PROCEDURE(gtk_window_get_type, gxg_gtk_window_get_type, 0, 0, 0, H_gtk_window_get_type);
  XG_DEFINE_PROCEDURE(gtk_window_new, gxg_gtk_window_new, 1, 0, 0, H_gtk_window_new);
  XG_DEFINE_PROCEDURE(gtk_window_set_title, gxg_gtk_window_set_title, 2, 0, 0, H_gtk_window_set_title);
  XG_DEFINE_PROCEDURE(gtk_window_get_title, gxg_gtk_window_get_title, 1, 0, 0, H_gtk_window_get_title);
  XG_DEFINE_PROCEDURE(gtk_window_set_wmclass, gxg_gtk_window_set_wmclass, 3, 0, 0, H_gtk_window_set_wmclass);
  XG_DEFINE_PROCEDURE(gtk_window_set_role, gxg_gtk_window_set_role, 2, 0, 0, H_gtk_window_set_role);
  XG_DEFINE_PROCEDURE(gtk_window_get_role, gxg_gtk_window_get_role, 1, 0, 0, H_gtk_window_get_role);
  XG_DEFINE_PROCEDURE(gtk_window_add_accel_group, gxg_gtk_window_add_accel_group, 2, 0, 0, H_gtk_window_add_accel_group);
  XG_DEFINE_PROCEDURE(gtk_window_remove_accel_group, gxg_gtk_window_remove_accel_group, 2, 0, 0, H_gtk_window_remove_accel_group);
  XG_DEFINE_PROCEDURE(gtk_window_set_position, gxg_gtk_window_set_position, 2, 0, 0, H_gtk_window_set_position);
  XG_DEFINE_PROCEDURE(gtk_window_activate_focus, gxg_gtk_window_activate_focus, 1, 0, 0, H_gtk_window_activate_focus);
  XG_DEFINE_PROCEDURE(gtk_window_set_focus, gxg_gtk_window_set_focus, 2, 0, 0, H_gtk_window_set_focus);
  XG_DEFINE_PROCEDURE(gtk_window_get_focus, gxg_gtk_window_get_focus, 1, 0, 0, H_gtk_window_get_focus);
  XG_DEFINE_PROCEDURE(gtk_window_set_default, gxg_gtk_window_set_default, 2, 0, 0, H_gtk_window_set_default);
  XG_DEFINE_PROCEDURE(gtk_window_activate_default, gxg_gtk_window_activate_default, 1, 0, 0, H_gtk_window_activate_default);
  XG_DEFINE_PROCEDURE(gtk_window_set_transient_for, gxg_gtk_window_set_transient_for, 2, 0, 0, H_gtk_window_set_transient_for);
  XG_DEFINE_PROCEDURE(gtk_window_get_transient_for, gxg_gtk_window_get_transient_for, 1, 0, 0, H_gtk_window_get_transient_for);
  XG_DEFINE_PROCEDURE(gtk_window_set_type_hint, gxg_gtk_window_set_type_hint, 2, 0, 0, H_gtk_window_set_type_hint);
  XG_DEFINE_PROCEDURE(gtk_window_get_type_hint, gxg_gtk_window_get_type_hint, 1, 0, 0, H_gtk_window_get_type_hint);
  XG_DEFINE_PROCEDURE(gtk_window_set_destroy_with_parent, gxg_gtk_window_set_destroy_with_parent, 2, 0, 0, H_gtk_window_set_destroy_with_parent);
  XG_DEFINE_PROCEDURE(gtk_window_get_destroy_with_parent, gxg_gtk_window_get_destroy_with_parent, 1, 0, 0, H_gtk_window_get_destroy_with_parent);
  XG_DEFINE_PROCEDURE(gtk_window_set_resizable, gxg_gtk_window_set_resizable, 2, 0, 0, H_gtk_window_set_resizable);
  XG_DEFINE_PROCEDURE(gtk_window_get_resizable, gxg_gtk_window_get_resizable, 1, 0, 0, H_gtk_window_get_resizable);
  XG_DEFINE_PROCEDURE(gtk_window_set_gravity, gxg_gtk_window_set_gravity, 2, 0, 0, H_gtk_window_set_gravity);
  XG_DEFINE_PROCEDURE(gtk_window_get_gravity, gxg_gtk_window_get_gravity, 1, 0, 0, H_gtk_window_get_gravity);
  XG_DEFINE_PROCEDURE(gtk_window_set_geometry_hints, gxg_gtk_window_set_geometry_hints, 4, 0, 0, H_gtk_window_set_geometry_hints);
  XG_DEFINE_PROCEDURE(gtk_window_set_has_frame, gxg_gtk_window_set_has_frame, 2, 0, 0, H_gtk_window_set_has_frame);
  XG_DEFINE_PROCEDURE(gtk_window_get_has_frame, gxg_gtk_window_get_has_frame, 1, 0, 0, H_gtk_window_get_has_frame);
  XG_DEFINE_PROCEDURE(gtk_window_set_frame_dimensions, gxg_gtk_window_set_frame_dimensions, 5, 0, 0, H_gtk_window_set_frame_dimensions);
  XG_DEFINE_PROCEDURE(gtk_window_get_frame_dimensions, gxg_gtk_window_get_frame_dimensions, 1, 4, 0, H_gtk_window_get_frame_dimensions);
  XG_DEFINE_PROCEDURE(gtk_window_set_decorated, gxg_gtk_window_set_decorated, 2, 0, 0, H_gtk_window_set_decorated);
  XG_DEFINE_PROCEDURE(gtk_window_get_decorated, gxg_gtk_window_get_decorated, 1, 0, 0, H_gtk_window_get_decorated);
  XG_DEFINE_PROCEDURE(gtk_window_set_icon_list, gxg_gtk_window_set_icon_list, 2, 0, 0, H_gtk_window_set_icon_list);
  XG_DEFINE_PROCEDURE(gtk_window_get_icon_list, gxg_gtk_window_get_icon_list, 1, 0, 0, H_gtk_window_get_icon_list);
  XG_DEFINE_PROCEDURE(gtk_window_set_icon, gxg_gtk_window_set_icon, 2, 0, 0, H_gtk_window_set_icon);
  XG_DEFINE_PROCEDURE(gtk_window_get_icon, gxg_gtk_window_get_icon, 1, 0, 0, H_gtk_window_get_icon);
  XG_DEFINE_PROCEDURE(gtk_window_set_default_icon_list, gxg_gtk_window_set_default_icon_list, 1, 0, 0, H_gtk_window_set_default_icon_list);
  XG_DEFINE_PROCEDURE(gtk_window_get_default_icon_list, gxg_gtk_window_get_default_icon_list, 0, 0, 0, H_gtk_window_get_default_icon_list);
  XG_DEFINE_PROCEDURE(gtk_window_set_modal, gxg_gtk_window_set_modal, 2, 0, 0, H_gtk_window_set_modal);
  XG_DEFINE_PROCEDURE(gtk_window_get_modal, gxg_gtk_window_get_modal, 1, 0, 0, H_gtk_window_get_modal);
  XG_DEFINE_PROCEDURE(gtk_window_list_toplevels, gxg_gtk_window_list_toplevels, 0, 0, 0, H_gtk_window_list_toplevels);
  XG_DEFINE_PROCEDURE(gtk_window_add_mnemonic, gxg_gtk_window_add_mnemonic, 3, 0, 0, H_gtk_window_add_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_window_remove_mnemonic, gxg_gtk_window_remove_mnemonic, 3, 0, 0, H_gtk_window_remove_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_window_mnemonic_activate, gxg_gtk_window_mnemonic_activate, 3, 0, 0, H_gtk_window_mnemonic_activate);
  XG_DEFINE_PROCEDURE(gtk_window_set_mnemonic_modifier, gxg_gtk_window_set_mnemonic_modifier, 2, 0, 0, H_gtk_window_set_mnemonic_modifier);
  XG_DEFINE_PROCEDURE(gtk_window_get_mnemonic_modifier, gxg_gtk_window_get_mnemonic_modifier, 1, 0, 0, H_gtk_window_get_mnemonic_modifier);
  XG_DEFINE_PROCEDURE(gtk_window_present, gxg_gtk_window_present, 1, 0, 0, H_gtk_window_present);
  XG_DEFINE_PROCEDURE(gtk_window_iconify, gxg_gtk_window_iconify, 1, 0, 0, H_gtk_window_iconify);
  XG_DEFINE_PROCEDURE(gtk_window_deiconify, gxg_gtk_window_deiconify, 1, 0, 0, H_gtk_window_deiconify);
  XG_DEFINE_PROCEDURE(gtk_window_stick, gxg_gtk_window_stick, 1, 0, 0, H_gtk_window_stick);
  XG_DEFINE_PROCEDURE(gtk_window_unstick, gxg_gtk_window_unstick, 1, 0, 0, H_gtk_window_unstick);
  XG_DEFINE_PROCEDURE(gtk_window_maximize, gxg_gtk_window_maximize, 1, 0, 0, H_gtk_window_maximize);
  XG_DEFINE_PROCEDURE(gtk_window_unmaximize, gxg_gtk_window_unmaximize, 1, 0, 0, H_gtk_window_unmaximize);
  XG_DEFINE_PROCEDURE(gtk_window_begin_resize_drag, gxg_gtk_window_begin_resize_drag, 6, 0, 0, H_gtk_window_begin_resize_drag);
  XG_DEFINE_PROCEDURE(gtk_window_begin_move_drag, gxg_gtk_window_begin_move_drag, 5, 0, 0, H_gtk_window_begin_move_drag);
  XG_DEFINE_PROCEDURE(gtk_window_set_default_size, gxg_gtk_window_set_default_size, 3, 0, 0, H_gtk_window_set_default_size);
  XG_DEFINE_PROCEDURE(gtk_window_get_default_size, gxg_gtk_window_get_default_size, 1, 2, 0, H_gtk_window_get_default_size);
  XG_DEFINE_PROCEDURE(gtk_window_resize, gxg_gtk_window_resize, 3, 0, 0, H_gtk_window_resize);
  XG_DEFINE_PROCEDURE(gtk_window_get_size, gxg_gtk_window_get_size, 1, 2, 0, H_gtk_window_get_size);
  XG_DEFINE_PROCEDURE(gtk_window_move, gxg_gtk_window_move, 3, 0, 0, H_gtk_window_move);
  XG_DEFINE_PROCEDURE(gtk_window_get_position, gxg_gtk_window_get_position, 1, 2, 0, H_gtk_window_get_position);
  XG_DEFINE_PROCEDURE(gtk_window_parse_geometry, gxg_gtk_window_parse_geometry, 2, 0, 0, H_gtk_window_parse_geometry);
  XG_DEFINE_PROCEDURE(gtk_window_reshow_with_initial_size, gxg_gtk_window_reshow_with_initial_size, 1, 0, 0, H_gtk_window_reshow_with_initial_size);
  XG_DEFINE_PROCEDURE(gtk_window_group_get_type, gxg_gtk_window_group_get_type, 0, 0, 0, H_gtk_window_group_get_type);
  XG_DEFINE_PROCEDURE(pango_color_get_type, gxg_pango_color_get_type, 0, 0, 0, H_pango_color_get_type);
  XG_DEFINE_PROCEDURE(pango_color_copy, gxg_pango_color_copy, 1, 0, 0, H_pango_color_copy);
  XG_DEFINE_PROCEDURE(pango_color_free, gxg_pango_color_free, 1, 0, 0, H_pango_color_free);
  XG_DEFINE_PROCEDURE(pango_color_parse, gxg_pango_color_parse, 2, 0, 0, H_pango_color_parse);
  XG_DEFINE_PROCEDURE(pango_attr_type_register, gxg_pango_attr_type_register, 1, 0, 0, H_pango_attr_type_register);
  XG_DEFINE_PROCEDURE(pango_attribute_copy, gxg_pango_attribute_copy, 1, 0, 0, H_pango_attribute_copy);
  XG_DEFINE_PROCEDURE(pango_attribute_destroy, gxg_pango_attribute_destroy, 1, 0, 0, H_pango_attribute_destroy);
  XG_DEFINE_PROCEDURE(pango_attribute_equal, gxg_pango_attribute_equal, 2, 0, 0, H_pango_attribute_equal);
  XG_DEFINE_PROCEDURE(pango_attr_language_new, gxg_pango_attr_language_new, 1, 0, 0, H_pango_attr_language_new);
  XG_DEFINE_PROCEDURE(pango_attr_family_new, gxg_pango_attr_family_new, 1, 0, 0, H_pango_attr_family_new);
  XG_DEFINE_PROCEDURE(pango_attr_foreground_new, gxg_pango_attr_foreground_new, 3, 0, 0, H_pango_attr_foreground_new);
  XG_DEFINE_PROCEDURE(pango_attr_background_new, gxg_pango_attr_background_new, 3, 0, 0, H_pango_attr_background_new);
  XG_DEFINE_PROCEDURE(pango_attr_size_new, gxg_pango_attr_size_new, 1, 0, 0, H_pango_attr_size_new);
  XG_DEFINE_PROCEDURE(pango_attr_style_new, gxg_pango_attr_style_new, 1, 0, 0, H_pango_attr_style_new);
  XG_DEFINE_PROCEDURE(pango_attr_weight_new, gxg_pango_attr_weight_new, 1, 0, 0, H_pango_attr_weight_new);
  XG_DEFINE_PROCEDURE(pango_attr_variant_new, gxg_pango_attr_variant_new, 1, 0, 0, H_pango_attr_variant_new);
  XG_DEFINE_PROCEDURE(pango_attr_stretch_new, gxg_pango_attr_stretch_new, 1, 0, 0, H_pango_attr_stretch_new);
  XG_DEFINE_PROCEDURE(pango_attr_font_desc_new, gxg_pango_attr_font_desc_new, 1, 0, 0, H_pango_attr_font_desc_new);
  XG_DEFINE_PROCEDURE(pango_attr_underline_new, gxg_pango_attr_underline_new, 1, 0, 0, H_pango_attr_underline_new);
  XG_DEFINE_PROCEDURE(pango_attr_strikethrough_new, gxg_pango_attr_strikethrough_new, 1, 0, 0, H_pango_attr_strikethrough_new);
  XG_DEFINE_PROCEDURE(pango_attr_rise_new, gxg_pango_attr_rise_new, 1, 0, 0, H_pango_attr_rise_new);
  XG_DEFINE_PROCEDURE(pango_attr_shape_new, gxg_pango_attr_shape_new, 2, 0, 0, H_pango_attr_shape_new);
  XG_DEFINE_PROCEDURE(pango_attr_scale_new, gxg_pango_attr_scale_new, 1, 0, 0, H_pango_attr_scale_new);
  XG_DEFINE_PROCEDURE(pango_attr_list_get_type, gxg_pango_attr_list_get_type, 0, 0, 0, H_pango_attr_list_get_type);
  XG_DEFINE_PROCEDURE(pango_attr_list_new, gxg_pango_attr_list_new, 0, 0, 0, H_pango_attr_list_new);
  XG_DEFINE_PROCEDURE(pango_attr_list_ref, gxg_pango_attr_list_ref, 1, 0, 0, H_pango_attr_list_ref);
  XG_DEFINE_PROCEDURE(pango_attr_list_unref, gxg_pango_attr_list_unref, 1, 0, 0, H_pango_attr_list_unref);
  XG_DEFINE_PROCEDURE(pango_attr_list_copy, gxg_pango_attr_list_copy, 1, 0, 0, H_pango_attr_list_copy);
  XG_DEFINE_PROCEDURE(pango_attr_list_insert, gxg_pango_attr_list_insert, 2, 0, 0, H_pango_attr_list_insert);
  XG_DEFINE_PROCEDURE(pango_attr_list_insert_before, gxg_pango_attr_list_insert_before, 2, 0, 0, H_pango_attr_list_insert_before);
  XG_DEFINE_PROCEDURE(pango_attr_list_change, gxg_pango_attr_list_change, 2, 0, 0, H_pango_attr_list_change);
  XG_DEFINE_PROCEDURE(pango_attr_list_splice, gxg_pango_attr_list_splice, 4, 0, 0, H_pango_attr_list_splice);
  XG_DEFINE_PROCEDURE(pango_attr_list_get_iterator, gxg_pango_attr_list_get_iterator, 1, 0, 0, H_pango_attr_list_get_iterator);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_range, gxg_pango_attr_iterator_range, 1, 2, 0, H_pango_attr_iterator_range);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_next, gxg_pango_attr_iterator_next, 1, 0, 0, H_pango_attr_iterator_next);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_copy, gxg_pango_attr_iterator_copy, 1, 0, 0, H_pango_attr_iterator_copy);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_destroy, gxg_pango_attr_iterator_destroy, 1, 0, 0, H_pango_attr_iterator_destroy);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_get, gxg_pango_attr_iterator_get, 2, 0, 0, H_pango_attr_iterator_get);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_get_font, gxg_pango_attr_iterator_get_font, 2, 2, 0, H_pango_attr_iterator_get_font);
  XG_DEFINE_PROCEDURE(pango_parse_markup, gxg_pango_parse_markup, 6, 1, 0, H_pango_parse_markup);
  XG_DEFINE_PROCEDURE(pango_break, gxg_pango_break, 5, 0, 0, H_pango_break);
  XG_DEFINE_PROCEDURE(pango_find_paragraph_boundary, gxg_pango_find_paragraph_boundary, 2, 2, 0, H_pango_find_paragraph_boundary);
  XG_DEFINE_PROCEDURE(pango_get_log_attrs, gxg_pango_get_log_attrs, 6, 0, 0, H_pango_get_log_attrs);
  XG_DEFINE_PROCEDURE(pango_context_get_type, gxg_pango_context_get_type, 0, 0, 0, H_pango_context_get_type);
  XG_DEFINE_PROCEDURE(pango_context_list_families, gxg_pango_context_list_families, 1, 2, 0, H_pango_context_list_families);
  XG_DEFINE_PROCEDURE(pango_context_load_font, gxg_pango_context_load_font, 2, 0, 0, H_pango_context_load_font);
  XG_DEFINE_PROCEDURE(pango_context_load_fontset, gxg_pango_context_load_fontset, 3, 0, 0, H_pango_context_load_fontset);
  XG_DEFINE_PROCEDURE(pango_context_get_metrics, gxg_pango_context_get_metrics, 3, 0, 0, H_pango_context_get_metrics);
  XG_DEFINE_PROCEDURE(pango_context_set_font_description, gxg_pango_context_set_font_description, 2, 0, 0, H_pango_context_set_font_description);
  XG_DEFINE_PROCEDURE(pango_context_get_font_description, gxg_pango_context_get_font_description, 1, 0, 0, H_pango_context_get_font_description);
  XG_DEFINE_PROCEDURE(pango_context_get_language, gxg_pango_context_get_language, 1, 0, 0, H_pango_context_get_language);
  XG_DEFINE_PROCEDURE(pango_context_set_language, gxg_pango_context_set_language, 2, 0, 0, H_pango_context_set_language);
  XG_DEFINE_PROCEDURE(pango_context_set_base_dir, gxg_pango_context_set_base_dir, 2, 0, 0, H_pango_context_set_base_dir);
  XG_DEFINE_PROCEDURE(pango_context_get_base_dir, gxg_pango_context_get_base_dir, 1, 0, 0, H_pango_context_get_base_dir);
  XG_DEFINE_PROCEDURE(pango_itemize, gxg_pango_itemize, 6, 0, 0, H_pango_itemize);
  XG_DEFINE_PROCEDURE(pango_coverage_new, gxg_pango_coverage_new, 0, 0, 0, H_pango_coverage_new);
  XG_DEFINE_PROCEDURE(pango_coverage_ref, gxg_pango_coverage_ref, 1, 0, 0, H_pango_coverage_ref);
  XG_DEFINE_PROCEDURE(pango_coverage_unref, gxg_pango_coverage_unref, 1, 0, 0, H_pango_coverage_unref);
  XG_DEFINE_PROCEDURE(pango_coverage_copy, gxg_pango_coverage_copy, 1, 0, 0, H_pango_coverage_copy);
  XG_DEFINE_PROCEDURE(pango_coverage_get, gxg_pango_coverage_get, 2, 0, 0, H_pango_coverage_get);
  XG_DEFINE_PROCEDURE(pango_coverage_set, gxg_pango_coverage_set, 3, 0, 0, H_pango_coverage_set);
  XG_DEFINE_PROCEDURE(pango_coverage_max, gxg_pango_coverage_max, 2, 0, 0, H_pango_coverage_max);
  XG_DEFINE_PROCEDURE(pango_coverage_to_bytes, gxg_pango_coverage_to_bytes, 1, 2, 0, H_pango_coverage_to_bytes);
  XG_DEFINE_PROCEDURE(pango_coverage_from_bytes, gxg_pango_coverage_from_bytes, 2, 0, 0, H_pango_coverage_from_bytes);
  XG_DEFINE_PROCEDURE(pango_attr_type_get_type, gxg_pango_attr_type_get_type, 0, 0, 0, H_pango_attr_type_get_type);
  XG_DEFINE_PROCEDURE(pango_underline_get_type, gxg_pango_underline_get_type, 0, 0, 0, H_pango_underline_get_type);
  XG_DEFINE_PROCEDURE(pango_coverage_level_get_type, gxg_pango_coverage_level_get_type, 0, 0, 0, H_pango_coverage_level_get_type);
  XG_DEFINE_PROCEDURE(pango_style_get_type, gxg_pango_style_get_type, 0, 0, 0, H_pango_style_get_type);
  XG_DEFINE_PROCEDURE(pango_variant_get_type, gxg_pango_variant_get_type, 0, 0, 0, H_pango_variant_get_type);
  XG_DEFINE_PROCEDURE(pango_weight_get_type, gxg_pango_weight_get_type, 0, 0, 0, H_pango_weight_get_type);
  XG_DEFINE_PROCEDURE(pango_stretch_get_type, gxg_pango_stretch_get_type, 0, 0, 0, H_pango_stretch_get_type);
  XG_DEFINE_PROCEDURE(pango_font_mask_get_type, gxg_pango_font_mask_get_type, 0, 0, 0, H_pango_font_mask_get_type);
  XG_DEFINE_PROCEDURE(pango_alignment_get_type, gxg_pango_alignment_get_type, 0, 0, 0, H_pango_alignment_get_type);
  XG_DEFINE_PROCEDURE(pango_wrap_mode_get_type, gxg_pango_wrap_mode_get_type, 0, 0, 0, H_pango_wrap_mode_get_type);
  XG_DEFINE_PROCEDURE(pango_tab_align_get_type, gxg_pango_tab_align_get_type, 0, 0, 0, H_pango_tab_align_get_type);
  XG_DEFINE_PROCEDURE(pango_direction_get_type, gxg_pango_direction_get_type, 0, 0, 0, H_pango_direction_get_type);
  XG_DEFINE_PROCEDURE(pango_font_description_get_type, gxg_pango_font_description_get_type, 0, 0, 0, H_pango_font_description_get_type);
  XG_DEFINE_PROCEDURE(pango_font_description_new, gxg_pango_font_description_new, 0, 0, 0, H_pango_font_description_new);
  XG_DEFINE_PROCEDURE(pango_font_description_copy, gxg_pango_font_description_copy, 1, 0, 0, H_pango_font_description_copy);
  XG_DEFINE_PROCEDURE(pango_font_description_copy_static, gxg_pango_font_description_copy_static, 1, 0, 0, H_pango_font_description_copy_static);
  XG_DEFINE_PROCEDURE(pango_font_description_hash, gxg_pango_font_description_hash, 1, 0, 0, H_pango_font_description_hash);
  XG_DEFINE_PROCEDURE(pango_font_description_equal, gxg_pango_font_description_equal, 2, 0, 0, H_pango_font_description_equal);
  XG_DEFINE_PROCEDURE(pango_font_description_free, gxg_pango_font_description_free, 1, 0, 0, H_pango_font_description_free);
  XG_DEFINE_PROCEDURE(pango_font_descriptions_free, gxg_pango_font_descriptions_free, 2, 0, 0, H_pango_font_descriptions_free);
  XG_DEFINE_PROCEDURE(pango_font_description_set_family, gxg_pango_font_description_set_family, 2, 0, 0, H_pango_font_description_set_family);
  XG_DEFINE_PROCEDURE(pango_font_description_set_family_static, gxg_pango_font_description_set_family_static, 2, 0, 0, H_pango_font_description_set_family_static);
  XG_DEFINE_PROCEDURE(pango_font_description_get_family, gxg_pango_font_description_get_family, 1, 0, 0, H_pango_font_description_get_family);
  XG_DEFINE_PROCEDURE(pango_font_description_set_style, gxg_pango_font_description_set_style, 2, 0, 0, H_pango_font_description_set_style);
  XG_DEFINE_PROCEDURE(pango_font_description_get_style, gxg_pango_font_description_get_style, 1, 0, 0, H_pango_font_description_get_style);
  XG_DEFINE_PROCEDURE(pango_font_description_set_variant, gxg_pango_font_description_set_variant, 2, 0, 0, H_pango_font_description_set_variant);
  XG_DEFINE_PROCEDURE(pango_font_description_get_variant, gxg_pango_font_description_get_variant, 1, 0, 0, H_pango_font_description_get_variant);
  XG_DEFINE_PROCEDURE(pango_font_description_set_weight, gxg_pango_font_description_set_weight, 2, 0, 0, H_pango_font_description_set_weight);
  XG_DEFINE_PROCEDURE(pango_font_description_get_weight, gxg_pango_font_description_get_weight, 1, 0, 0, H_pango_font_description_get_weight);
  XG_DEFINE_PROCEDURE(pango_font_description_set_stretch, gxg_pango_font_description_set_stretch, 2, 0, 0, H_pango_font_description_set_stretch);
  XG_DEFINE_PROCEDURE(pango_font_description_get_stretch, gxg_pango_font_description_get_stretch, 1, 0, 0, H_pango_font_description_get_stretch);
  XG_DEFINE_PROCEDURE(pango_font_description_set_size, gxg_pango_font_description_set_size, 2, 0, 0, H_pango_font_description_set_size);
  XG_DEFINE_PROCEDURE(pango_font_description_get_size, gxg_pango_font_description_get_size, 1, 0, 0, H_pango_font_description_get_size);
  XG_DEFINE_PROCEDURE(pango_font_description_get_set_fields, gxg_pango_font_description_get_set_fields, 1, 0, 0, H_pango_font_description_get_set_fields);
  XG_DEFINE_PROCEDURE(pango_font_description_unset_fields, gxg_pango_font_description_unset_fields, 2, 0, 0, H_pango_font_description_unset_fields);
  XG_DEFINE_PROCEDURE(pango_font_description_merge, gxg_pango_font_description_merge, 3, 0, 0, H_pango_font_description_merge);
  XG_DEFINE_PROCEDURE(pango_font_description_merge_static, gxg_pango_font_description_merge_static, 3, 0, 0, H_pango_font_description_merge_static);
  XG_DEFINE_PROCEDURE(pango_font_description_better_match, gxg_pango_font_description_better_match, 3, 0, 0, H_pango_font_description_better_match);
  XG_DEFINE_PROCEDURE(pango_font_description_from_string, gxg_pango_font_description_from_string, 1, 0, 0, H_pango_font_description_from_string);
  XG_DEFINE_PROCEDURE(pango_font_description_to_string, gxg_pango_font_description_to_string, 1, 0, 0, H_pango_font_description_to_string);
  XG_DEFINE_PROCEDURE(pango_font_description_to_filename, gxg_pango_font_description_to_filename, 1, 0, 0, H_pango_font_description_to_filename);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_type, gxg_pango_font_metrics_get_type, 0, 0, 0, H_pango_font_metrics_get_type);
  XG_DEFINE_PROCEDURE(pango_font_metrics_ref, gxg_pango_font_metrics_ref, 1, 0, 0, H_pango_font_metrics_ref);
  XG_DEFINE_PROCEDURE(pango_font_metrics_unref, gxg_pango_font_metrics_unref, 1, 0, 0, H_pango_font_metrics_unref);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_ascent, gxg_pango_font_metrics_get_ascent, 1, 0, 0, H_pango_font_metrics_get_ascent);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_descent, gxg_pango_font_metrics_get_descent, 1, 0, 0, H_pango_font_metrics_get_descent);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_approximate_char_width, gxg_pango_font_metrics_get_approximate_char_width, 1, 0, 0, H_pango_font_metrics_get_approximate_char_width);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_approximate_digit_width, gxg_pango_font_metrics_get_approximate_digit_width, 1, 0, 0, H_pango_font_metrics_get_approximate_digit_width);
  XG_DEFINE_PROCEDURE(pango_font_family_get_type, gxg_pango_font_family_get_type, 0, 0, 0, H_pango_font_family_get_type);
  XG_DEFINE_PROCEDURE(pango_font_family_list_faces, gxg_pango_font_family_list_faces, 1, 2, 0, H_pango_font_family_list_faces);
  XG_DEFINE_PROCEDURE(pango_font_family_get_name, gxg_pango_font_family_get_name, 1, 0, 0, H_pango_font_family_get_name);
  XG_DEFINE_PROCEDURE(pango_font_face_get_type, gxg_pango_font_face_get_type, 0, 0, 0, H_pango_font_face_get_type);
  XG_DEFINE_PROCEDURE(pango_font_face_describe, gxg_pango_font_face_describe, 1, 0, 0, H_pango_font_face_describe);
  XG_DEFINE_PROCEDURE(pango_font_face_get_face_name, gxg_pango_font_face_get_face_name, 1, 0, 0, H_pango_font_face_get_face_name);
  XG_DEFINE_PROCEDURE(pango_font_get_type, gxg_pango_font_get_type, 0, 0, 0, H_pango_font_get_type);
  XG_DEFINE_PROCEDURE(pango_font_describe, gxg_pango_font_describe, 1, 0, 0, H_pango_font_describe);
  XG_DEFINE_PROCEDURE(pango_font_get_coverage, gxg_pango_font_get_coverage, 2, 0, 0, H_pango_font_get_coverage);
  XG_DEFINE_PROCEDURE(pango_font_get_metrics, gxg_pango_font_get_metrics, 2, 0, 0, H_pango_font_get_metrics);
  XG_DEFINE_PROCEDURE(pango_font_get_glyph_extents, gxg_pango_font_get_glyph_extents, 4, 0, 0, H_pango_font_get_glyph_extents);
  XG_DEFINE_PROCEDURE(pango_font_map_get_type, gxg_pango_font_map_get_type, 0, 0, 0, H_pango_font_map_get_type);
  XG_DEFINE_PROCEDURE(pango_font_map_load_font, gxg_pango_font_map_load_font, 3, 0, 0, H_pango_font_map_load_font);
  XG_DEFINE_PROCEDURE(pango_font_map_load_fontset, gxg_pango_font_map_load_fontset, 4, 0, 0, H_pango_font_map_load_fontset);
  XG_DEFINE_PROCEDURE(pango_font_map_list_families, gxg_pango_font_map_list_families, 1, 2, 0, H_pango_font_map_list_families);
  XG_DEFINE_PROCEDURE(pango_glyph_string_new, gxg_pango_glyph_string_new, 0, 0, 0, H_pango_glyph_string_new);
  XG_DEFINE_PROCEDURE(pango_glyph_string_set_size, gxg_pango_glyph_string_set_size, 2, 0, 0, H_pango_glyph_string_set_size);
  XG_DEFINE_PROCEDURE(pango_glyph_string_get_type, gxg_pango_glyph_string_get_type, 0, 0, 0, H_pango_glyph_string_get_type);
  XG_DEFINE_PROCEDURE(pango_glyph_string_copy, gxg_pango_glyph_string_copy, 1, 0, 0, H_pango_glyph_string_copy);
  XG_DEFINE_PROCEDURE(pango_glyph_string_free, gxg_pango_glyph_string_free, 1, 0, 0, H_pango_glyph_string_free);
  XG_DEFINE_PROCEDURE(pango_glyph_string_extents, gxg_pango_glyph_string_extents, 4, 0, 0, H_pango_glyph_string_extents);
  XG_DEFINE_PROCEDURE(pango_glyph_string_extents_range, gxg_pango_glyph_string_extents_range, 6, 0, 0, H_pango_glyph_string_extents_range);
  XG_DEFINE_PROCEDURE(pango_glyph_string_get_logical_widths, gxg_pango_glyph_string_get_logical_widths, 4, 1, 0, H_pango_glyph_string_get_logical_widths);
  XG_DEFINE_PROCEDURE(pango_glyph_string_index_to_x, gxg_pango_glyph_string_index_to_x, 6, 1, 0, H_pango_glyph_string_index_to_x);
  XG_DEFINE_PROCEDURE(pango_glyph_string_x_to_index, gxg_pango_glyph_string_x_to_index, 5, 2, 0, H_pango_glyph_string_x_to_index);
  XG_DEFINE_PROCEDURE(pango_shape, gxg_pango_shape, 4, 0, 0, H_pango_shape);
  XG_DEFINE_PROCEDURE(pango_reorder_items, gxg_pango_reorder_items, 1, 0, 0, H_pango_reorder_items);
  XG_DEFINE_PROCEDURE(pango_item_new, gxg_pango_item_new, 0, 0, 0, H_pango_item_new);
  XG_DEFINE_PROCEDURE(pango_item_copy, gxg_pango_item_copy, 1, 0, 0, H_pango_item_copy);
  XG_DEFINE_PROCEDURE(pango_item_free, gxg_pango_item_free, 1, 0, 0, H_pango_item_free);
  XG_DEFINE_PROCEDURE(pango_item_split, gxg_pango_item_split, 3, 0, 0, H_pango_item_split);
  XG_DEFINE_PROCEDURE(pango_layout_get_type, gxg_pango_layout_get_type, 0, 0, 0, H_pango_layout_get_type);
  XG_DEFINE_PROCEDURE(pango_layout_new, gxg_pango_layout_new, 1, 0, 0, H_pango_layout_new);
  XG_DEFINE_PROCEDURE(pango_layout_copy, gxg_pango_layout_copy, 1, 0, 0, H_pango_layout_copy);
  XG_DEFINE_PROCEDURE(pango_layout_get_context, gxg_pango_layout_get_context, 1, 0, 0, H_pango_layout_get_context);
  XG_DEFINE_PROCEDURE(pango_layout_set_attributes, gxg_pango_layout_set_attributes, 2, 0, 0, H_pango_layout_set_attributes);
  XG_DEFINE_PROCEDURE(pango_layout_get_attributes, gxg_pango_layout_get_attributes, 1, 0, 0, H_pango_layout_get_attributes);
  XG_DEFINE_PROCEDURE(pango_layout_set_text, gxg_pango_layout_set_text, 3, 0, 0, H_pango_layout_set_text);
  XG_DEFINE_PROCEDURE(pango_layout_get_text, gxg_pango_layout_get_text, 1, 0, 0, H_pango_layout_get_text);
  XG_DEFINE_PROCEDURE(pango_layout_set_markup, gxg_pango_layout_set_markup, 3, 0, 0, H_pango_layout_set_markup);
  XG_DEFINE_PROCEDURE(pango_layout_set_markup_with_accel, gxg_pango_layout_set_markup_with_accel, 5, 0, 0, H_pango_layout_set_markup_with_accel);
  XG_DEFINE_PROCEDURE(pango_layout_set_font_description, gxg_pango_layout_set_font_description, 2, 0, 0, H_pango_layout_set_font_description);
  XG_DEFINE_PROCEDURE(pango_layout_set_width, gxg_pango_layout_set_width, 2, 0, 0, H_pango_layout_set_width);
  XG_DEFINE_PROCEDURE(pango_layout_get_width, gxg_pango_layout_get_width, 1, 0, 0, H_pango_layout_get_width);
  XG_DEFINE_PROCEDURE(pango_layout_set_wrap, gxg_pango_layout_set_wrap, 2, 0, 0, H_pango_layout_set_wrap);
  XG_DEFINE_PROCEDURE(pango_layout_get_wrap, gxg_pango_layout_get_wrap, 1, 0, 0, H_pango_layout_get_wrap);
  XG_DEFINE_PROCEDURE(pango_layout_set_indent, gxg_pango_layout_set_indent, 2, 0, 0, H_pango_layout_set_indent);
  XG_DEFINE_PROCEDURE(pango_layout_get_indent, gxg_pango_layout_get_indent, 1, 0, 0, H_pango_layout_get_indent);
  XG_DEFINE_PROCEDURE(pango_layout_set_spacing, gxg_pango_layout_set_spacing, 2, 0, 0, H_pango_layout_set_spacing);
  XG_DEFINE_PROCEDURE(pango_layout_get_spacing, gxg_pango_layout_get_spacing, 1, 0, 0, H_pango_layout_get_spacing);
  XG_DEFINE_PROCEDURE(pango_layout_set_justify, gxg_pango_layout_set_justify, 2, 0, 0, H_pango_layout_set_justify);
  XG_DEFINE_PROCEDURE(pango_layout_get_justify, gxg_pango_layout_get_justify, 1, 0, 0, H_pango_layout_get_justify);
  XG_DEFINE_PROCEDURE(pango_layout_set_alignment, gxg_pango_layout_set_alignment, 2, 0, 0, H_pango_layout_set_alignment);
  XG_DEFINE_PROCEDURE(pango_layout_get_alignment, gxg_pango_layout_get_alignment, 1, 0, 0, H_pango_layout_get_alignment);
  XG_DEFINE_PROCEDURE(pango_layout_set_tabs, gxg_pango_layout_set_tabs, 2, 0, 0, H_pango_layout_set_tabs);
  XG_DEFINE_PROCEDURE(pango_layout_get_tabs, gxg_pango_layout_get_tabs, 1, 0, 0, H_pango_layout_get_tabs);
  XG_DEFINE_PROCEDURE(pango_layout_set_single_paragraph_mode, gxg_pango_layout_set_single_paragraph_mode, 2, 0, 0, H_pango_layout_set_single_paragraph_mode);
  XG_DEFINE_PROCEDURE(pango_layout_get_single_paragraph_mode, gxg_pango_layout_get_single_paragraph_mode, 1, 0, 0, H_pango_layout_get_single_paragraph_mode);
  XG_DEFINE_PROCEDURE(pango_layout_context_changed, gxg_pango_layout_context_changed, 1, 0, 0, H_pango_layout_context_changed);
  XG_DEFINE_PROCEDURE(pango_layout_get_log_attrs, gxg_pango_layout_get_log_attrs, 1, 2, 0, H_pango_layout_get_log_attrs);
  XG_DEFINE_PROCEDURE(pango_layout_index_to_pos, gxg_pango_layout_index_to_pos, 3, 0, 0, H_pango_layout_index_to_pos);
  XG_DEFINE_PROCEDURE(pango_layout_get_cursor_pos, gxg_pango_layout_get_cursor_pos, 4, 0, 0, H_pango_layout_get_cursor_pos);
  XG_DEFINE_PROCEDURE(pango_layout_move_cursor_visually, gxg_pango_layout_move_cursor_visually, 7, 0, 0, H_pango_layout_move_cursor_visually);
  XG_DEFINE_PROCEDURE(pango_layout_xy_to_index, gxg_pango_layout_xy_to_index, 3, 2, 0, H_pango_layout_xy_to_index);
  XG_DEFINE_PROCEDURE(pango_layout_get_extents, gxg_pango_layout_get_extents, 3, 0, 0, H_pango_layout_get_extents);
  XG_DEFINE_PROCEDURE(pango_layout_get_pixel_extents, gxg_pango_layout_get_pixel_extents, 3, 0, 0, H_pango_layout_get_pixel_extents);
  XG_DEFINE_PROCEDURE(pango_layout_get_size, gxg_pango_layout_get_size, 1, 2, 0, H_pango_layout_get_size);
  XG_DEFINE_PROCEDURE(pango_layout_get_pixel_size, gxg_pango_layout_get_pixel_size, 1, 2, 0, H_pango_layout_get_pixel_size);
  XG_DEFINE_PROCEDURE(pango_layout_get_line_count, gxg_pango_layout_get_line_count, 1, 0, 0, H_pango_layout_get_line_count);
  XG_DEFINE_PROCEDURE(pango_layout_get_line, gxg_pango_layout_get_line, 2, 0, 0, H_pango_layout_get_line);
  XG_DEFINE_PROCEDURE(pango_layout_get_lines, gxg_pango_layout_get_lines, 1, 0, 0, H_pango_layout_get_lines);
  XG_DEFINE_PROCEDURE(pango_layout_line_ref, gxg_pango_layout_line_ref, 1, 0, 0, H_pango_layout_line_ref);
  XG_DEFINE_PROCEDURE(pango_layout_line_unref, gxg_pango_layout_line_unref, 1, 0, 0, H_pango_layout_line_unref);
  XG_DEFINE_PROCEDURE(pango_layout_line_x_to_index, gxg_pango_layout_line_x_to_index, 2, 2, 0, H_pango_layout_line_x_to_index);
  XG_DEFINE_PROCEDURE(pango_layout_line_index_to_x, gxg_pango_layout_line_index_to_x, 3, 1, 0, H_pango_layout_line_index_to_x);
  XG_DEFINE_PROCEDURE(pango_layout_line_get_x_ranges, gxg_pango_layout_line_get_x_ranges, 3, 2, 0, H_pango_layout_line_get_x_ranges);
  XG_DEFINE_PROCEDURE(pango_layout_line_get_extents, gxg_pango_layout_line_get_extents, 3, 0, 0, H_pango_layout_line_get_extents);
  XG_DEFINE_PROCEDURE(pango_layout_line_get_pixel_extents, gxg_pango_layout_line_get_pixel_extents, 3, 0, 0, H_pango_layout_line_get_pixel_extents);
  XG_DEFINE_PROCEDURE(pango_layout_get_iter, gxg_pango_layout_get_iter, 1, 0, 0, H_pango_layout_get_iter);
  XG_DEFINE_PROCEDURE(pango_layout_iter_free, gxg_pango_layout_iter_free, 1, 0, 0, H_pango_layout_iter_free);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_index, gxg_pango_layout_iter_get_index, 1, 0, 0, H_pango_layout_iter_get_index);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_run, gxg_pango_layout_iter_get_run, 1, 0, 0, H_pango_layout_iter_get_run);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_line, gxg_pango_layout_iter_get_line, 1, 0, 0, H_pango_layout_iter_get_line);
  XG_DEFINE_PROCEDURE(pango_layout_iter_at_last_line, gxg_pango_layout_iter_at_last_line, 1, 0, 0, H_pango_layout_iter_at_last_line);
  XG_DEFINE_PROCEDURE(pango_layout_iter_next_char, gxg_pango_layout_iter_next_char, 1, 0, 0, H_pango_layout_iter_next_char);
  XG_DEFINE_PROCEDURE(pango_layout_iter_next_cluster, gxg_pango_layout_iter_next_cluster, 1, 0, 0, H_pango_layout_iter_next_cluster);
  XG_DEFINE_PROCEDURE(pango_layout_iter_next_run, gxg_pango_layout_iter_next_run, 1, 0, 0, H_pango_layout_iter_next_run);
  XG_DEFINE_PROCEDURE(pango_layout_iter_next_line, gxg_pango_layout_iter_next_line, 1, 0, 0, H_pango_layout_iter_next_line);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_char_extents, gxg_pango_layout_iter_get_char_extents, 2, 0, 0, H_pango_layout_iter_get_char_extents);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_cluster_extents, gxg_pango_layout_iter_get_cluster_extents, 3, 0, 0, H_pango_layout_iter_get_cluster_extents);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_run_extents, gxg_pango_layout_iter_get_run_extents, 3, 0, 0, H_pango_layout_iter_get_run_extents);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_line_extents, gxg_pango_layout_iter_get_line_extents, 3, 0, 0, H_pango_layout_iter_get_line_extents);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_line_yrange, gxg_pango_layout_iter_get_line_yrange, 1, 2, 0, H_pango_layout_iter_get_line_yrange);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_layout_extents, gxg_pango_layout_iter_get_layout_extents, 3, 0, 0, H_pango_layout_iter_get_layout_extents);
  XG_DEFINE_PROCEDURE(pango_layout_iter_get_baseline, gxg_pango_layout_iter_get_baseline, 1, 0, 0, H_pango_layout_iter_get_baseline);
  XG_DEFINE_PROCEDURE(pango_language_get_type, gxg_pango_language_get_type, 0, 0, 0, H_pango_language_get_type);
  XG_DEFINE_PROCEDURE(pango_language_from_string, gxg_pango_language_from_string, 1, 0, 0, H_pango_language_from_string);
  XG_DEFINE_PROCEDURE(pango_language_matches, gxg_pango_language_matches, 2, 0, 0, H_pango_language_matches);
  XG_DEFINE_PROCEDURE(G_OBJECT_TYPE, gxg_G_OBJECT_TYPE, 1, 0, 0, H_G_OBJECT_TYPE);
  XG_DEFINE_PROCEDURE(g_utf8_validate, gxg_g_utf8_validate, 2, 1, 0, H_g_utf8_validate);
  XG_DEFINE_PROCEDURE(g_list_free, gxg_g_list_free, 1, 0, 0, H_g_list_free);
  XG_DEFINE_PROCEDURE(g_list_reverse, gxg_g_list_reverse, 1, 0, 0, H_g_list_reverse);
  XG_DEFINE_PROCEDURE(g_list_copy, gxg_g_list_copy, 1, 0, 0, H_g_list_copy);
  XG_DEFINE_PROCEDURE(g_list_last, gxg_g_list_last, 1, 0, 0, H_g_list_last);
  XG_DEFINE_PROCEDURE(g_list_first, gxg_g_list_first, 1, 0, 0, H_g_list_first);
  XG_DEFINE_PROCEDURE(g_list_length, gxg_g_list_length, 1, 0, 0, H_g_list_length);
  XG_DEFINE_PROCEDURE(g_free, gxg_g_free, 1, 0, 0, H_g_free);
  XG_DEFINE_PROCEDURE(g_list_remove_link, gxg_g_list_remove_link, 2, 0, 0, H_g_list_remove_link);
  XG_DEFINE_PROCEDURE(g_object_get_data, gxg_g_object_get_data, 2, 0, 0, H_g_object_get_data);
  XG_DEFINE_PROCEDURE(g_object_set_data, gxg_g_object_set_data, 3, 0, 0, H_g_object_set_data);
  XG_DEFINE_PROCEDURE(g_list_nth_data, gxg_g_list_nth_data, 2, 0, 0, H_g_list_nth_data);
  XG_DEFINE_PROCEDURE(g_quark_from_string, gxg_g_quark_from_string, 1, 0, 0, H_g_quark_from_string);
  XG_DEFINE_PROCEDURE(g_quark_to_string, gxg_g_quark_to_string, 1, 0, 0, H_g_quark_to_string);
#if HAVE_GDK_DRAW_PIXBUF
  XG_DEFINE_PROCEDURE(gdk_draw_pixbuf, gxg_gdk_draw_pixbuf, 0, 0, 1, H_gdk_draw_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_tree_model_get_string_from_iter, gxg_gtk_tree_model_get_string_from_iter, 2, 0, 0, H_gtk_tree_model_get_string_from_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_sort_iter_is_valid, gxg_gtk_tree_model_sort_iter_is_valid, 2, 0, 0, H_gtk_tree_model_sort_iter_is_valid);
  XG_DEFINE_PROCEDURE(gtk_tree_view_expand_to_path, gxg_gtk_tree_view_expand_to_path, 2, 0, 0, H_gtk_tree_view_expand_to_path);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_get_selected_rows, gxg_gtk_tree_selection_get_selected_rows, 2, 0, 0, H_gtk_tree_selection_get_selected_rows);
  XG_DEFINE_PROCEDURE(gtk_tree_selection_count_selected_rows, gxg_gtk_tree_selection_count_selected_rows, 1, 0, 0, H_gtk_tree_selection_count_selected_rows);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_select_first, gxg_gtk_menu_shell_select_first, 2, 0, 0, H_gtk_menu_shell_select_first);
  XG_DEFINE_PROCEDURE(gtk_notebook_get_n_pages, gxg_gtk_notebook_get_n_pages, 1, 0, 0, H_gtk_notebook_get_n_pages);
  XG_DEFINE_PROCEDURE(gtk_list_store_reorder, gxg_gtk_list_store_reorder, 2, 0, 0, H_gtk_list_store_reorder);
  XG_DEFINE_PROCEDURE(gtk_list_store_swap, gxg_gtk_list_store_swap, 3, 0, 0, H_gtk_list_store_swap);
  XG_DEFINE_PROCEDURE(gtk_tree_store_reorder, gxg_gtk_tree_store_reorder, 3, 0, 0, H_gtk_tree_store_reorder);
  XG_DEFINE_PROCEDURE(gtk_tree_store_swap, gxg_gtk_tree_store_swap, 3, 0, 0, H_gtk_tree_store_swap);
  XG_DEFINE_PROCEDURE(gdk_display_get_type, gxg_gdk_display_get_type, 0, 0, 0, H_gdk_display_get_type);
  XG_DEFINE_PROCEDURE(gdk_display_open, gxg_gdk_display_open, 1, 0, 0, H_gdk_display_open);
  XG_DEFINE_PROCEDURE(gdk_display_get_name, gxg_gdk_display_get_name, 1, 0, 0, H_gdk_display_get_name);
  XG_DEFINE_PROCEDURE(gdk_display_get_n_screens, gxg_gdk_display_get_n_screens, 1, 0, 0, H_gdk_display_get_n_screens);
  XG_DEFINE_PROCEDURE(gdk_display_get_screen, gxg_gdk_display_get_screen, 2, 0, 0, H_gdk_display_get_screen);
  XG_DEFINE_PROCEDURE(gdk_display_get_default_screen, gxg_gdk_display_get_default_screen, 1, 0, 0, H_gdk_display_get_default_screen);
  XG_DEFINE_PROCEDURE(gdk_display_pointer_ungrab, gxg_gdk_display_pointer_ungrab, 2, 0, 0, H_gdk_display_pointer_ungrab);
  XG_DEFINE_PROCEDURE(gdk_display_keyboard_ungrab, gxg_gdk_display_keyboard_ungrab, 2, 0, 0, H_gdk_display_keyboard_ungrab);
  XG_DEFINE_PROCEDURE(gdk_display_pointer_is_grabbed, gxg_gdk_display_pointer_is_grabbed, 1, 0, 0, H_gdk_display_pointer_is_grabbed);
  XG_DEFINE_PROCEDURE(gdk_display_beep, gxg_gdk_display_beep, 1, 0, 0, H_gdk_display_beep);
  XG_DEFINE_PROCEDURE(gdk_display_sync, gxg_gdk_display_sync, 1, 0, 0, H_gdk_display_sync);
  XG_DEFINE_PROCEDURE(gdk_display_close, gxg_gdk_display_close, 1, 0, 0, H_gdk_display_close);
  XG_DEFINE_PROCEDURE(gdk_display_list_devices, gxg_gdk_display_list_devices, 1, 0, 0, H_gdk_display_list_devices);
  XG_DEFINE_PROCEDURE(gdk_display_get_event, gxg_gdk_display_get_event, 1, 0, 0, H_gdk_display_get_event);
  XG_DEFINE_PROCEDURE(gdk_display_peek_event, gxg_gdk_display_peek_event, 1, 0, 0, H_gdk_display_peek_event);
  XG_DEFINE_PROCEDURE(gdk_display_put_event, gxg_gdk_display_put_event, 2, 0, 0, H_gdk_display_put_event);
  XG_DEFINE_PROCEDURE(gdk_display_add_client_message_filter, gxg_gdk_display_add_client_message_filter, 3, 1, 0, H_gdk_display_add_client_message_filter);
  XG_DEFINE_PROCEDURE(gdk_display_set_double_click_time, gxg_gdk_display_set_double_click_time, 2, 0, 0, H_gdk_display_set_double_click_time);
  XG_DEFINE_PROCEDURE(gdk_display_get_default, gxg_gdk_display_get_default, 0, 0, 0, H_gdk_display_get_default);
  XG_DEFINE_PROCEDURE(gdk_display_get_core_pointer, gxg_gdk_display_get_core_pointer, 1, 0, 0, H_gdk_display_get_core_pointer);
  XG_DEFINE_PROCEDURE(gdk_display_get_pointer, gxg_gdk_display_get_pointer, 1, 4, 0, H_gdk_display_get_pointer);
  XG_DEFINE_PROCEDURE(gdk_display_get_window_at_pointer, gxg_gdk_display_get_window_at_pointer, 1, 2, 0, H_gdk_display_get_window_at_pointer);
  XG_DEFINE_PROCEDURE(gdk_screen_get_type, gxg_gdk_screen_get_type, 0, 0, 0, H_gdk_screen_get_type);
  XG_DEFINE_PROCEDURE(gdk_screen_get_default_colormap, gxg_gdk_screen_get_default_colormap, 1, 0, 0, H_gdk_screen_get_default_colormap);
  XG_DEFINE_PROCEDURE(gdk_screen_set_default_colormap, gxg_gdk_screen_set_default_colormap, 2, 0, 0, H_gdk_screen_set_default_colormap);
  XG_DEFINE_PROCEDURE(gdk_screen_get_system_colormap, gxg_gdk_screen_get_system_colormap, 1, 0, 0, H_gdk_screen_get_system_colormap);
  XG_DEFINE_PROCEDURE(gdk_screen_get_system_visual, gxg_gdk_screen_get_system_visual, 1, 0, 0, H_gdk_screen_get_system_visual);
  XG_DEFINE_PROCEDURE(gdk_screen_get_rgb_colormap, gxg_gdk_screen_get_rgb_colormap, 1, 0, 0, H_gdk_screen_get_rgb_colormap);
  XG_DEFINE_PROCEDURE(gdk_screen_get_rgb_visual, gxg_gdk_screen_get_rgb_visual, 1, 0, 0, H_gdk_screen_get_rgb_visual);
  XG_DEFINE_PROCEDURE(gdk_screen_get_root_window, gxg_gdk_screen_get_root_window, 1, 0, 0, H_gdk_screen_get_root_window);
  XG_DEFINE_PROCEDURE(gdk_screen_get_display, gxg_gdk_screen_get_display, 1, 0, 0, H_gdk_screen_get_display);
  XG_DEFINE_PROCEDURE(gdk_screen_get_number, gxg_gdk_screen_get_number, 1, 0, 0, H_gdk_screen_get_number);
  XG_DEFINE_PROCEDURE(gdk_screen_get_width, gxg_gdk_screen_get_width, 1, 0, 0, H_gdk_screen_get_width);
  XG_DEFINE_PROCEDURE(gdk_screen_get_height, gxg_gdk_screen_get_height, 1, 0, 0, H_gdk_screen_get_height);
  XG_DEFINE_PROCEDURE(gdk_screen_get_width_mm, gxg_gdk_screen_get_width_mm, 1, 0, 0, H_gdk_screen_get_width_mm);
  XG_DEFINE_PROCEDURE(gdk_screen_get_height_mm, gxg_gdk_screen_get_height_mm, 1, 0, 0, H_gdk_screen_get_height_mm);
  XG_DEFINE_PROCEDURE(gdk_screen_list_visuals, gxg_gdk_screen_list_visuals, 1, 0, 0, H_gdk_screen_list_visuals);
  XG_DEFINE_PROCEDURE(gdk_screen_get_toplevel_windows, gxg_gdk_screen_get_toplevel_windows, 1, 0, 0, H_gdk_screen_get_toplevel_windows);
  XG_DEFINE_PROCEDURE(gdk_screen_make_display_name, gxg_gdk_screen_make_display_name, 1, 0, 0, H_gdk_screen_make_display_name);
  XG_DEFINE_PROCEDURE(gdk_screen_get_n_monitors, gxg_gdk_screen_get_n_monitors, 1, 0, 0, H_gdk_screen_get_n_monitors);
  XG_DEFINE_PROCEDURE(gdk_screen_get_monitor_geometry, gxg_gdk_screen_get_monitor_geometry, 3, 0, 0, H_gdk_screen_get_monitor_geometry);
  XG_DEFINE_PROCEDURE(gdk_screen_get_monitor_at_point, gxg_gdk_screen_get_monitor_at_point, 3, 0, 0, H_gdk_screen_get_monitor_at_point);
  XG_DEFINE_PROCEDURE(gdk_screen_get_monitor_at_window, gxg_gdk_screen_get_monitor_at_window, 2, 0, 0, H_gdk_screen_get_monitor_at_window);
  XG_DEFINE_PROCEDURE(gdk_screen_broadcast_client_message, gxg_gdk_screen_broadcast_client_message, 2, 0, 0, H_gdk_screen_broadcast_client_message);
  XG_DEFINE_PROCEDURE(gdk_screen_get_default, gxg_gdk_screen_get_default, 0, 0, 0, H_gdk_screen_get_default);
  XG_DEFINE_PROCEDURE(gtk_clipboard_get_for_display, gxg_gtk_clipboard_get_for_display, 2, 0, 0, H_gtk_clipboard_get_for_display);
  XG_DEFINE_PROCEDURE(gtk_clipboard_get_display, gxg_gtk_clipboard_get_display, 1, 0, 0, H_gtk_clipboard_get_display);
  XG_DEFINE_PROCEDURE(gtk_widget_get_screen, gxg_gtk_widget_get_screen, 1, 0, 0, H_gtk_widget_get_screen);
  XG_DEFINE_PROCEDURE(gtk_widget_has_screen, gxg_gtk_widget_has_screen, 1, 0, 0, H_gtk_widget_has_screen);
  XG_DEFINE_PROCEDURE(gtk_widget_get_display, gxg_gtk_widget_get_display, 1, 0, 0, H_gtk_widget_get_display);
  XG_DEFINE_PROCEDURE(gtk_widget_get_root_window, gxg_gtk_widget_get_root_window, 1, 0, 0, H_gtk_widget_get_root_window);
  XG_DEFINE_PROCEDURE(gtk_widget_get_clipboard, gxg_gtk_widget_get_clipboard, 2, 0, 0, H_gtk_widget_get_clipboard);
#endif

#if HAVE_GTK_TREE_VIEW_COLUMN_CELL_GET_POSITION
  XG_DEFINE_PROCEDURE(gdk_get_display_arg_name, gxg_gdk_get_display_arg_name, 0, 0, 0, H_gdk_get_display_arg_name);
  XG_DEFINE_PROCEDURE(gdk_notify_startup_complete, gxg_gdk_notify_startup_complete, 0, 0, 0, H_gdk_notify_startup_complete);
  XG_DEFINE_PROCEDURE(gdk_pixmap_new, gxg_gdk_pixmap_new, 4, 0, 0, H_gdk_pixmap_new);
  XG_DEFINE_PROCEDURE(gdk_bitmap_create_from_data, gxg_gdk_bitmap_create_from_data, 4, 0, 0, H_gdk_bitmap_create_from_data);
  XG_DEFINE_PROCEDURE(gdk_pixmap_create_from_data, gxg_gdk_pixmap_create_from_data, 7, 0, 0, H_gdk_pixmap_create_from_data);
  XG_DEFINE_PROCEDURE(gdk_pixmap_create_from_xpm, gxg_gdk_pixmap_create_from_xpm, 4, 0, 0, H_gdk_pixmap_create_from_xpm);
  XG_DEFINE_PROCEDURE(gdk_pixmap_colormap_create_from_xpm, gxg_gdk_pixmap_colormap_create_from_xpm, 5, 0, 0, H_gdk_pixmap_colormap_create_from_xpm);
  XG_DEFINE_PROCEDURE(gdk_pixmap_create_from_xpm_d, gxg_gdk_pixmap_create_from_xpm_d, 4, 0, 0, H_gdk_pixmap_create_from_xpm_d);
  XG_DEFINE_PROCEDURE(gdk_pixmap_colormap_create_from_xpm_d, gxg_gdk_pixmap_colormap_create_from_xpm_d, 5, 0, 0, H_gdk_pixmap_colormap_create_from_xpm_d);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_cell_get_position, gxg_gtk_tree_view_column_cell_get_position, 2, 2, 0, H_gtk_tree_view_column_cell_get_position);
  XG_DEFINE_PROCEDURE(gtk_window_set_auto_startup_notification, gxg_gtk_window_set_auto_startup_notification, 1, 0, 0, H_gtk_window_set_auto_startup_notification);
  XG_DEFINE_PROCEDURE(gtk_list_store_move_after, gxg_gtk_list_store_move_after, 3, 0, 0, H_gtk_list_store_move_after);
  XG_DEFINE_PROCEDURE(gtk_list_store_move_before, gxg_gtk_list_store_move_before, 3, 0, 0, H_gtk_list_store_move_before);
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
  XG_DEFINE_PROCEDURE(gdk_cursor_new_from_pixbuf, gxg_gdk_cursor_new_from_pixbuf, 4, 0, 0, H_gdk_cursor_new_from_pixbuf);
  XG_DEFINE_PROCEDURE(gdk_display_flush, gxg_gdk_display_flush, 1, 0, 0, H_gdk_display_flush);
  XG_DEFINE_PROCEDURE(gdk_display_supports_cursor_alpha, gxg_gdk_display_supports_cursor_alpha, 1, 0, 0, H_gdk_display_supports_cursor_alpha);
  XG_DEFINE_PROCEDURE(gdk_display_supports_cursor_color, gxg_gdk_display_supports_cursor_color, 1, 0, 0, H_gdk_display_supports_cursor_color);
  XG_DEFINE_PROCEDURE(gdk_display_get_default_cursor_size, gxg_gdk_display_get_default_cursor_size, 1, 0, 0, H_gdk_display_get_default_cursor_size);
  XG_DEFINE_PROCEDURE(gdk_display_get_maximal_cursor_size, gxg_gdk_display_get_maximal_cursor_size, 1, 2, 0, H_gdk_display_get_maximal_cursor_size);
  XG_DEFINE_PROCEDURE(gdk_window_set_keep_above, gxg_gdk_window_set_keep_above, 2, 0, 0, H_gdk_window_set_keep_above);
  XG_DEFINE_PROCEDURE(gdk_window_set_keep_below, gxg_gdk_window_set_keep_below, 2, 0, 0, H_gdk_window_set_keep_below);
  XG_DEFINE_PROCEDURE(gtk_alignment_set_padding, gxg_gtk_alignment_set_padding, 5, 0, 0, H_gtk_alignment_set_padding);
  XG_DEFINE_PROCEDURE(gtk_alignment_get_padding, gxg_gtk_alignment_get_padding, 1, 4, 0, H_gtk_alignment_get_padding);
  XG_DEFINE_PROCEDURE(gtk_button_box_get_child_secondary, gxg_gtk_button_box_get_child_secondary, 2, 0, 0, H_gtk_button_box_get_child_secondary);
  XG_DEFINE_PROCEDURE(gtk_button_set_focus_on_click, gxg_gtk_button_set_focus_on_click, 2, 0, 0, H_gtk_button_set_focus_on_click);
  XG_DEFINE_PROCEDURE(gtk_button_get_focus_on_click, gxg_gtk_button_get_focus_on_click, 1, 0, 0, H_gtk_button_get_focus_on_click);
  XG_DEFINE_PROCEDURE(gtk_calendar_set_display_options, gxg_gtk_calendar_set_display_options, 2, 0, 0, H_gtk_calendar_set_display_options);
  XG_DEFINE_PROCEDURE(gtk_calendar_get_display_options, gxg_gtk_calendar_get_display_options, 1, 0, 0, H_gtk_calendar_get_display_options);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_set_draw_as_radio, gxg_gtk_check_menu_item_set_draw_as_radio, 2, 0, 0, H_gtk_check_menu_item_set_draw_as_radio);
  XG_DEFINE_PROCEDURE(gtk_check_menu_item_get_draw_as_radio, gxg_gtk_check_menu_item_get_draw_as_radio, 1, 0, 0, H_gtk_check_menu_item_get_draw_as_radio);
  XG_DEFINE_PROCEDURE(gtk_entry_set_completion, gxg_gtk_entry_set_completion, 2, 0, 0, H_gtk_entry_set_completion);
  XG_DEFINE_PROCEDURE(gtk_entry_get_completion, gxg_gtk_entry_get_completion, 1, 0, 0, H_gtk_entry_get_completion);
  XG_DEFINE_PROCEDURE(gtk_event_box_get_visible_window, gxg_gtk_event_box_get_visible_window, 1, 0, 0, H_gtk_event_box_get_visible_window);
  XG_DEFINE_PROCEDURE(gtk_event_box_set_visible_window, gxg_gtk_event_box_set_visible_window, 2, 0, 0, H_gtk_event_box_set_visible_window);
  XG_DEFINE_PROCEDURE(gtk_event_box_get_above_child, gxg_gtk_event_box_get_above_child, 1, 0, 0, H_gtk_event_box_get_above_child);
  XG_DEFINE_PROCEDURE(gtk_event_box_set_above_child, gxg_gtk_event_box_set_above_child, 2, 0, 0, H_gtk_event_box_set_above_child);
  XG_DEFINE_PROCEDURE(gtk_icon_source_get_icon_name, gxg_gtk_icon_source_get_icon_name, 1, 0, 0, H_gtk_icon_source_get_icon_name);
  XG_DEFINE_PROCEDURE(gtk_menu_attach, gxg_gtk_menu_attach, 6, 0, 0, H_gtk_menu_attach);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_select_range, gxg_gtk_text_buffer_select_range, 3, 0, 0, H_gtk_text_buffer_select_range);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_overwrite, gxg_gtk_text_view_set_overwrite, 2, 0, 0, H_gtk_text_view_set_overwrite);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_overwrite, gxg_gtk_text_view_get_overwrite, 1, 0, 0, H_gtk_text_view_get_overwrite);
  XG_DEFINE_PROCEDURE(gtk_text_view_set_accepts_tab, gxg_gtk_text_view_set_accepts_tab, 2, 0, 0, H_gtk_text_view_set_accepts_tab);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_accepts_tab, gxg_gtk_text_view_get_accepts_tab, 1, 0, 0, H_gtk_text_view_get_accepts_tab);
  XG_DEFINE_PROCEDURE(gtk_toolbar_insert, gxg_gtk_toolbar_insert, 3, 0, 0, H_gtk_toolbar_insert);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_item_index, gxg_gtk_toolbar_get_item_index, 2, 0, 0, H_gtk_toolbar_get_item_index);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_n_items, gxg_gtk_toolbar_get_n_items, 1, 0, 0, H_gtk_toolbar_get_n_items);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_nth_item, gxg_gtk_toolbar_get_nth_item, 2, 0, 0, H_gtk_toolbar_get_nth_item);
  XG_DEFINE_PROCEDURE(gtk_toolbar_set_show_arrow, gxg_gtk_toolbar_set_show_arrow, 2, 0, 0, H_gtk_toolbar_set_show_arrow);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_show_arrow, gxg_gtk_toolbar_get_show_arrow, 1, 0, 0, H_gtk_toolbar_get_show_arrow);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_relief_style, gxg_gtk_toolbar_get_relief_style, 1, 0, 0, H_gtk_toolbar_get_relief_style);
  XG_DEFINE_PROCEDURE(gtk_toolbar_get_drop_index, gxg_gtk_toolbar_get_drop_index, 3, 0, 0, H_gtk_toolbar_get_drop_index);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_set_expand, gxg_gtk_tree_view_column_set_expand, 2, 0, 0, H_gtk_tree_view_column_set_expand);
  XG_DEFINE_PROCEDURE(gtk_tree_view_column_get_expand, gxg_gtk_tree_view_column_get_expand, 1, 0, 0, H_gtk_tree_view_column_get_expand);
  XG_DEFINE_PROCEDURE(gtk_widget_set_no_show_all, gxg_gtk_widget_set_no_show_all, 2, 0, 0, H_gtk_widget_set_no_show_all);
  XG_DEFINE_PROCEDURE(gtk_widget_get_no_show_all, gxg_gtk_widget_get_no_show_all, 1, 0, 0, H_gtk_widget_get_no_show_all);
  XG_DEFINE_PROCEDURE(gtk_widget_queue_resize_no_redraw, gxg_gtk_widget_queue_resize_no_redraw, 1, 0, 0, H_gtk_widget_queue_resize_no_redraw);
  XG_DEFINE_PROCEDURE(gtk_window_set_default_icon, gxg_gtk_window_set_default_icon, 1, 0, 0, H_gtk_window_set_default_icon);
  XG_DEFINE_PROCEDURE(gtk_window_set_keep_above, gxg_gtk_window_set_keep_above, 2, 0, 0, H_gtk_window_set_keep_above);
  XG_DEFINE_PROCEDURE(gtk_window_set_keep_below, gxg_gtk_window_set_keep_below, 2, 0, 0, H_gtk_window_set_keep_below);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_dialog_new, gxg_gtk_file_chooser_dialog_new, 3, 1, 0, H_gtk_file_chooser_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_dialog_get_type, gxg_gtk_file_chooser_dialog_get_type, 0, 0, 0, H_gtk_file_chooser_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_widget_get_type, gxg_gtk_file_chooser_widget_get_type, 0, 0, 0, H_gtk_file_chooser_widget_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_widget_new, gxg_gtk_file_chooser_widget_new, 1, 0, 0, H_gtk_file_chooser_widget_new);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_get_type, gxg_gtk_tree_model_filter_get_type, 0, 0, 0, H_gtk_tree_model_filter_get_type);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_new, gxg_gtk_tree_model_filter_new, 2, 0, 0, H_gtk_tree_model_filter_new);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_set_visible_column, gxg_gtk_tree_model_filter_set_visible_column, 2, 0, 0, H_gtk_tree_model_filter_set_visible_column);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_get_model, gxg_gtk_tree_model_filter_get_model, 1, 0, 0, H_gtk_tree_model_filter_get_model);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_convert_child_iter_to_iter, gxg_gtk_tree_model_filter_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_child_iter_to_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_convert_iter_to_child_iter, gxg_gtk_tree_model_filter_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_iter_to_child_iter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_convert_child_path_to_path, gxg_gtk_tree_model_filter_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_filter_convert_child_path_to_path);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_convert_path_to_child_path, gxg_gtk_tree_model_filter_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_filter_convert_path_to_child_path);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_refilter, gxg_gtk_tree_model_filter_refilter, 1, 0, 0, H_gtk_tree_model_filter_refilter);
  XG_DEFINE_PROCEDURE(gtk_tree_model_filter_clear_cache, gxg_gtk_tree_model_filter_clear_cache, 1, 0, 0, H_gtk_tree_model_filter_clear_cache);
  XG_DEFINE_PROCEDURE(gtk_action_get_type, gxg_gtk_action_get_type, 0, 0, 0, H_gtk_action_get_type);
  XG_DEFINE_PROCEDURE(gtk_action_get_name, gxg_gtk_action_get_name, 1, 0, 0, H_gtk_action_get_name);
  XG_DEFINE_PROCEDURE(gtk_action_activate, gxg_gtk_action_activate, 1, 0, 0, H_gtk_action_activate);
  XG_DEFINE_PROCEDURE(gtk_action_create_icon, gxg_gtk_action_create_icon, 2, 0, 0, H_gtk_action_create_icon);
  XG_DEFINE_PROCEDURE(gtk_action_create_menu_item, gxg_gtk_action_create_menu_item, 1, 0, 0, H_gtk_action_create_menu_item);
  XG_DEFINE_PROCEDURE(gtk_action_create_tool_item, gxg_gtk_action_create_tool_item, 1, 0, 0, H_gtk_action_create_tool_item);
  XG_DEFINE_PROCEDURE(gtk_action_connect_proxy, gxg_gtk_action_connect_proxy, 2, 0, 0, H_gtk_action_connect_proxy);
  XG_DEFINE_PROCEDURE(gtk_action_disconnect_proxy, gxg_gtk_action_disconnect_proxy, 2, 0, 0, H_gtk_action_disconnect_proxy);
  XG_DEFINE_PROCEDURE(gtk_action_get_proxies, gxg_gtk_action_get_proxies, 1, 0, 0, H_gtk_action_get_proxies);
  XG_DEFINE_PROCEDURE(gtk_action_connect_accelerator, gxg_gtk_action_connect_accelerator, 1, 0, 0, H_gtk_action_connect_accelerator);
  XG_DEFINE_PROCEDURE(gtk_action_disconnect_accelerator, gxg_gtk_action_disconnect_accelerator, 1, 0, 0, H_gtk_action_disconnect_accelerator);
  XG_DEFINE_PROCEDURE(gtk_action_group_get_type, gxg_gtk_action_group_get_type, 0, 0, 0, H_gtk_action_group_get_type);
  XG_DEFINE_PROCEDURE(gtk_action_group_new, gxg_gtk_action_group_new, 1, 0, 0, H_gtk_action_group_new);
  XG_DEFINE_PROCEDURE(gtk_action_group_get_name, gxg_gtk_action_group_get_name, 1, 0, 0, H_gtk_action_group_get_name);
  XG_DEFINE_PROCEDURE(gtk_action_group_get_action, gxg_gtk_action_group_get_action, 2, 0, 0, H_gtk_action_group_get_action);
  XG_DEFINE_PROCEDURE(gtk_action_group_list_actions, gxg_gtk_action_group_list_actions, 1, 0, 0, H_gtk_action_group_list_actions);
  XG_DEFINE_PROCEDURE(gtk_action_group_add_action, gxg_gtk_action_group_add_action, 2, 0, 0, H_gtk_action_group_add_action);
  XG_DEFINE_PROCEDURE(gtk_action_group_remove_action, gxg_gtk_action_group_remove_action, 2, 0, 0, H_gtk_action_group_remove_action);
  XG_DEFINE_PROCEDURE(gtk_action_group_add_actions, gxg_gtk_action_group_add_actions, 4, 0, 0, H_gtk_action_group_add_actions);
  XG_DEFINE_PROCEDURE(gtk_action_group_add_toggle_actions, gxg_gtk_action_group_add_toggle_actions, 4, 0, 0, H_gtk_action_group_add_toggle_actions);
  XG_DEFINE_PROCEDURE(gtk_action_group_add_toggle_actions_full, gxg_gtk_action_group_add_toggle_actions_full, 5, 0, 0, H_gtk_action_group_add_toggle_actions_full);
  XG_DEFINE_PROCEDURE(gtk_action_group_set_translation_domain, gxg_gtk_action_group_set_translation_domain, 2, 0, 0, H_gtk_action_group_set_translation_domain);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_type, gxg_gtk_combo_box_get_type, 0, 0, 0, H_gtk_combo_box_get_type);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_wrap_width, gxg_gtk_combo_box_set_wrap_width, 2, 0, 0, H_gtk_combo_box_set_wrap_width);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_row_span_column, gxg_gtk_combo_box_set_row_span_column, 2, 0, 0, H_gtk_combo_box_set_row_span_column);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_column_span_column, gxg_gtk_combo_box_set_column_span_column, 2, 0, 0, H_gtk_combo_box_set_column_span_column);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_active, gxg_gtk_combo_box_get_active, 1, 0, 0, H_gtk_combo_box_get_active);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_active, gxg_gtk_combo_box_set_active, 2, 0, 0, H_gtk_combo_box_set_active);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_active_iter, gxg_gtk_combo_box_get_active_iter, 2, 0, 0, H_gtk_combo_box_get_active_iter);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_active_iter, gxg_gtk_combo_box_set_active_iter, 2, 0, 0, H_gtk_combo_box_set_active_iter);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_model, gxg_gtk_combo_box_get_model, 1, 0, 0, H_gtk_combo_box_get_model);
  XG_DEFINE_PROCEDURE(gtk_combo_box_new_text, gxg_gtk_combo_box_new_text, 0, 0, 0, H_gtk_combo_box_new_text);
  XG_DEFINE_PROCEDURE(gtk_combo_box_append_text, gxg_gtk_combo_box_append_text, 2, 0, 0, H_gtk_combo_box_append_text);
  XG_DEFINE_PROCEDURE(gtk_combo_box_insert_text, gxg_gtk_combo_box_insert_text, 3, 0, 0, H_gtk_combo_box_insert_text);
  XG_DEFINE_PROCEDURE(gtk_combo_box_prepend_text, gxg_gtk_combo_box_prepend_text, 2, 0, 0, H_gtk_combo_box_prepend_text);
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_get_type, gxg_gtk_combo_box_entry_get_type, 0, 0, 0, H_gtk_combo_box_entry_get_type);
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_get_text_column, gxg_gtk_combo_box_entry_get_text_column, 1, 0, 0, H_gtk_combo_box_entry_get_text_column);
  XG_DEFINE_PROCEDURE(gtk_expander_get_type, gxg_gtk_expander_get_type, 0, 0, 0, H_gtk_expander_get_type);
  XG_DEFINE_PROCEDURE(gtk_expander_new, gxg_gtk_expander_new, 1, 0, 0, H_gtk_expander_new);
  XG_DEFINE_PROCEDURE(gtk_expander_new_with_mnemonic, gxg_gtk_expander_new_with_mnemonic, 1, 0, 0, H_gtk_expander_new_with_mnemonic);
  XG_DEFINE_PROCEDURE(gtk_expander_set_expanded, gxg_gtk_expander_set_expanded, 2, 0, 0, H_gtk_expander_set_expanded);
  XG_DEFINE_PROCEDURE(gtk_expander_get_expanded, gxg_gtk_expander_get_expanded, 1, 0, 0, H_gtk_expander_get_expanded);
  XG_DEFINE_PROCEDURE(gtk_expander_set_spacing, gxg_gtk_expander_set_spacing, 2, 0, 0, H_gtk_expander_set_spacing);
  XG_DEFINE_PROCEDURE(gtk_expander_get_spacing, gxg_gtk_expander_get_spacing, 1, 0, 0, H_gtk_expander_get_spacing);
  XG_DEFINE_PROCEDURE(gtk_expander_set_label, gxg_gtk_expander_set_label, 2, 0, 0, H_gtk_expander_set_label);
  XG_DEFINE_PROCEDURE(gtk_expander_get_label, gxg_gtk_expander_get_label, 1, 0, 0, H_gtk_expander_get_label);
  XG_DEFINE_PROCEDURE(gtk_expander_set_use_underline, gxg_gtk_expander_set_use_underline, 2, 0, 0, H_gtk_expander_set_use_underline);
  XG_DEFINE_PROCEDURE(gtk_expander_get_use_underline, gxg_gtk_expander_get_use_underline, 1, 0, 0, H_gtk_expander_get_use_underline);
  XG_DEFINE_PROCEDURE(gtk_expander_set_label_widget, gxg_gtk_expander_set_label_widget, 2, 0, 0, H_gtk_expander_set_label_widget);
  XG_DEFINE_PROCEDURE(gtk_expander_get_label_widget, gxg_gtk_expander_get_label_widget, 1, 0, 0, H_gtk_expander_get_label_widget);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_type, gxg_gtk_font_button_get_type, 0, 0, 0, H_gtk_font_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_font_button_new, gxg_gtk_font_button_new, 0, 0, 0, H_gtk_font_button_new);
  XG_DEFINE_PROCEDURE(gtk_font_button_new_with_font, gxg_gtk_font_button_new_with_font, 1, 0, 0, H_gtk_font_button_new_with_font);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_title, gxg_gtk_font_button_get_title, 1, 0, 0, H_gtk_font_button_get_title);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_title, gxg_gtk_font_button_set_title, 2, 0, 0, H_gtk_font_button_set_title);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_use_font, gxg_gtk_font_button_get_use_font, 1, 0, 0, H_gtk_font_button_get_use_font);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_use_font, gxg_gtk_font_button_set_use_font, 2, 0, 0, H_gtk_font_button_set_use_font);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_use_size, gxg_gtk_font_button_get_use_size, 1, 0, 0, H_gtk_font_button_get_use_size);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_use_size, gxg_gtk_font_button_set_use_size, 2, 0, 0, H_gtk_font_button_set_use_size);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_font_name, gxg_gtk_font_button_get_font_name, 1, 0, 0, H_gtk_font_button_get_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_font_name, gxg_gtk_font_button_set_font_name, 2, 0, 0, H_gtk_font_button_set_font_name);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_show_style, gxg_gtk_font_button_get_show_style, 1, 0, 0, H_gtk_font_button_get_show_style);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_show_style, gxg_gtk_font_button_set_show_style, 2, 0, 0, H_gtk_font_button_set_show_style);
  XG_DEFINE_PROCEDURE(gtk_font_button_get_show_size, gxg_gtk_font_button_get_show_size, 1, 0, 0, H_gtk_font_button_get_show_size);
  XG_DEFINE_PROCEDURE(gtk_font_button_set_show_size, gxg_gtk_font_button_set_show_size, 2, 0, 0, H_gtk_font_button_set_show_size);
  XG_DEFINE_PROCEDURE(gtk_color_button_get_type, gxg_gtk_color_button_get_type, 0, 0, 0, H_gtk_color_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_color_button_new, gxg_gtk_color_button_new, 0, 0, 0, H_gtk_color_button_new);
  XG_DEFINE_PROCEDURE(gtk_color_button_new_with_color, gxg_gtk_color_button_new_with_color, 1, 0, 0, H_gtk_color_button_new_with_color);
  XG_DEFINE_PROCEDURE(gtk_color_button_set_color, gxg_gtk_color_button_set_color, 2, 0, 0, H_gtk_color_button_set_color);
  XG_DEFINE_PROCEDURE(gtk_color_button_set_alpha, gxg_gtk_color_button_set_alpha, 2, 0, 0, H_gtk_color_button_set_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_button_get_color, gxg_gtk_color_button_get_color, 2, 0, 0, H_gtk_color_button_get_color);
  XG_DEFINE_PROCEDURE(gtk_color_button_get_alpha, gxg_gtk_color_button_get_alpha, 1, 0, 0, H_gtk_color_button_get_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_button_set_use_alpha, gxg_gtk_color_button_set_use_alpha, 2, 0, 0, H_gtk_color_button_set_use_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_button_get_use_alpha, gxg_gtk_color_button_get_use_alpha, 1, 0, 0, H_gtk_color_button_get_use_alpha);
  XG_DEFINE_PROCEDURE(gtk_color_button_set_title, gxg_gtk_color_button_set_title, 2, 0, 0, H_gtk_color_button_set_title);
  XG_DEFINE_PROCEDURE(gtk_color_button_get_title, gxg_gtk_color_button_get_title, 1, 0, 0, H_gtk_color_button_get_title);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_type, gxg_gtk_entry_completion_get_type, 0, 0, 0, H_gtk_entry_completion_get_type);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_new, gxg_gtk_entry_completion_new, 0, 0, 0, H_gtk_entry_completion_new);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_entry, gxg_gtk_entry_completion_get_entry, 1, 0, 0, H_gtk_entry_completion_get_entry);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_model, gxg_gtk_entry_completion_set_model, 2, 0, 0, H_gtk_entry_completion_set_model);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_model, gxg_gtk_entry_completion_get_model, 1, 0, 0, H_gtk_entry_completion_get_model);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_match_func, gxg_gtk_entry_completion_set_match_func, 4, 0, 0, H_gtk_entry_completion_set_match_func);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_minimum_key_length, gxg_gtk_entry_completion_set_minimum_key_length, 2, 0, 0, H_gtk_entry_completion_set_minimum_key_length);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_minimum_key_length, gxg_gtk_entry_completion_get_minimum_key_length, 1, 0, 0, H_gtk_entry_completion_get_minimum_key_length);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_complete, gxg_gtk_entry_completion_complete, 1, 0, 0, H_gtk_entry_completion_complete);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_insert_action_text, gxg_gtk_entry_completion_insert_action_text, 3, 0, 0, H_gtk_entry_completion_insert_action_text);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_insert_action_markup, gxg_gtk_entry_completion_insert_action_markup, 3, 0, 0, H_gtk_entry_completion_insert_action_markup);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_delete_action, gxg_gtk_entry_completion_delete_action, 2, 0, 0, H_gtk_entry_completion_delete_action);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_text_column, gxg_gtk_entry_completion_set_text_column, 2, 0, 0, H_gtk_entry_completion_set_text_column);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_type, gxg_gtk_ui_manager_get_type, 0, 0, 0, H_gtk_ui_manager_get_type);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_new, gxg_gtk_ui_manager_new, 0, 0, 0, H_gtk_ui_manager_new);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_set_add_tearoffs, gxg_gtk_ui_manager_set_add_tearoffs, 2, 0, 0, H_gtk_ui_manager_set_add_tearoffs);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_add_tearoffs, gxg_gtk_ui_manager_get_add_tearoffs, 1, 0, 0, H_gtk_ui_manager_get_add_tearoffs);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_insert_action_group, gxg_gtk_ui_manager_insert_action_group, 3, 0, 0, H_gtk_ui_manager_insert_action_group);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_remove_action_group, gxg_gtk_ui_manager_remove_action_group, 2, 0, 0, H_gtk_ui_manager_remove_action_group);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_action_groups, gxg_gtk_ui_manager_get_action_groups, 1, 0, 0, H_gtk_ui_manager_get_action_groups);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_accel_group, gxg_gtk_ui_manager_get_accel_group, 1, 0, 0, H_gtk_ui_manager_get_accel_group);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_widget, gxg_gtk_ui_manager_get_widget, 2, 0, 0, H_gtk_ui_manager_get_widget);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_action, gxg_gtk_ui_manager_get_action, 2, 0, 0, H_gtk_ui_manager_get_action);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_add_ui_from_string, gxg_gtk_ui_manager_add_ui_from_string, 3, 1, 0, H_gtk_ui_manager_add_ui_from_string);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_add_ui_from_file, gxg_gtk_ui_manager_add_ui_from_file, 2, 1, 0, H_gtk_ui_manager_add_ui_from_file);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_add_ui, gxg_gtk_ui_manager_add_ui, 7, 0, 0, H_gtk_ui_manager_add_ui);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_remove_ui, gxg_gtk_ui_manager_remove_ui, 2, 0, 0, H_gtk_ui_manager_remove_ui);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_get_ui, gxg_gtk_ui_manager_get_ui, 1, 0, 0, H_gtk_ui_manager_get_ui);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_ensure_update, gxg_gtk_ui_manager_ensure_update, 1, 0, 0, H_gtk_ui_manager_ensure_update);
  XG_DEFINE_PROCEDURE(gtk_ui_manager_new_merge_id, gxg_gtk_ui_manager_new_merge_id, 1, 0, 0, H_gtk_ui_manager_new_merge_id);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_get_type, gxg_gtk_radio_tool_button_get_type, 0, 0, 0, H_gtk_radio_tool_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_new, gxg_gtk_radio_tool_button_new, 1, 0, 0, H_gtk_radio_tool_button_new);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_new_from_stock, gxg_gtk_radio_tool_button_new_from_stock, 2, 0, 0, H_gtk_radio_tool_button_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_get_group, gxg_gtk_radio_tool_button_get_group, 1, 0, 0, H_gtk_radio_tool_button_get_group);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_set_group, gxg_gtk_radio_tool_button_set_group, 2, 0, 0, H_gtk_radio_tool_button_set_group);
  XG_DEFINE_PROCEDURE(gtk_radio_action_get_type, gxg_gtk_radio_action_get_type, 0, 0, 0, H_gtk_radio_action_get_type);
  XG_DEFINE_PROCEDURE(gtk_radio_action_get_group, gxg_gtk_radio_action_get_group, 1, 0, 0, H_gtk_radio_action_get_group);
  XG_DEFINE_PROCEDURE(gtk_radio_action_set_group, gxg_gtk_radio_action_set_group, 2, 0, 0, H_gtk_radio_action_set_group);
  XG_DEFINE_PROCEDURE(gtk_radio_action_get_current_value, gxg_gtk_radio_action_get_current_value, 1, 0, 0, H_gtk_radio_action_get_current_value);
  XG_DEFINE_PROCEDURE(gtk_separator_tool_item_get_type, gxg_gtk_separator_tool_item_get_type, 0, 0, 0, H_gtk_separator_tool_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_separator_tool_item_new, gxg_gtk_separator_tool_item_new, 0, 0, 0, H_gtk_separator_tool_item_new);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_get_type, gxg_gtk_toggle_action_get_type, 0, 0, 0, H_gtk_toggle_action_get_type);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_toggled, gxg_gtk_toggle_action_toggled, 1, 0, 0, H_gtk_toggle_action_toggled);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_set_active, gxg_gtk_toggle_action_set_active, 2, 0, 0, H_gtk_toggle_action_set_active);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_get_active, gxg_gtk_toggle_action_get_active, 1, 0, 0, H_gtk_toggle_action_get_active);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_set_draw_as_radio, gxg_gtk_toggle_action_set_draw_as_radio, 2, 0, 0, H_gtk_toggle_action_set_draw_as_radio);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_get_draw_as_radio, gxg_gtk_toggle_action_get_draw_as_radio, 1, 0, 0, H_gtk_toggle_action_get_draw_as_radio);
  XG_DEFINE_PROCEDURE(gtk_toggle_tool_button_get_type, gxg_gtk_toggle_tool_button_get_type, 0, 0, 0, H_gtk_toggle_tool_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_toggle_tool_button_new, gxg_gtk_toggle_tool_button_new, 0, 0, 0, H_gtk_toggle_tool_button_new);
  XG_DEFINE_PROCEDURE(gtk_toggle_tool_button_new_from_stock, gxg_gtk_toggle_tool_button_new_from_stock, 1, 0, 0, H_gtk_toggle_tool_button_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_toggle_tool_button_set_active, gxg_gtk_toggle_tool_button_set_active, 2, 0, 0, H_gtk_toggle_tool_button_set_active);
  XG_DEFINE_PROCEDURE(gtk_toggle_tool_button_get_active, gxg_gtk_toggle_tool_button_get_active, 1, 0, 0, H_gtk_toggle_tool_button_get_active);
  XG_DEFINE_PROCEDURE(g_timeout_add_full, gxg_g_timeout_add_full, 5, 0, 0, H_g_timeout_add_full);
  XG_DEFINE_PROCEDURE(g_timeout_add, gxg_g_timeout_add, 2, 1, 0, H_g_timeout_add);
  XG_DEFINE_PROCEDURE(g_idle_add, gxg_g_idle_add, 1, 1, 0, H_g_idle_add);
  XG_DEFINE_PROCEDURE(g_idle_add_full, gxg_g_idle_add_full, 4, 0, 0, H_g_idle_add_full);
  XG_DEFINE_PROCEDURE(g_idle_remove_by_data, gxg_g_idle_remove_by_data, 1, 0, 0, H_g_idle_remove_by_data);
  XG_DEFINE_PROCEDURE(g_source_remove, gxg_g_source_remove, 1, 0, 0, H_g_source_remove);
  XG_DEFINE_PROCEDURE(gtk_file_filter_get_type, gxg_gtk_file_filter_get_type, 0, 0, 0, H_gtk_file_filter_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_filter_new, gxg_gtk_file_filter_new, 0, 0, 0, H_gtk_file_filter_new);
  XG_DEFINE_PROCEDURE(gtk_file_filter_set_name, gxg_gtk_file_filter_set_name, 2, 0, 0, H_gtk_file_filter_set_name);
  XG_DEFINE_PROCEDURE(gtk_file_filter_get_name, gxg_gtk_file_filter_get_name, 1, 0, 0, H_gtk_file_filter_get_name);
  XG_DEFINE_PROCEDURE(gtk_file_filter_add_mime_type, gxg_gtk_file_filter_add_mime_type, 2, 0, 0, H_gtk_file_filter_add_mime_type);
  XG_DEFINE_PROCEDURE(gtk_file_filter_add_pattern, gxg_gtk_file_filter_add_pattern, 2, 0, 0, H_gtk_file_filter_add_pattern);
  XG_DEFINE_PROCEDURE(gtk_file_filter_add_custom, gxg_gtk_file_filter_add_custom, 5, 0, 0, H_gtk_file_filter_add_custom);
  XG_DEFINE_PROCEDURE(gtk_file_filter_get_needed, gxg_gtk_file_filter_get_needed, 1, 0, 0, H_gtk_file_filter_get_needed);
  XG_DEFINE_PROCEDURE(gtk_file_filter_filter, gxg_gtk_file_filter_filter, 2, 0, 0, H_gtk_file_filter_filter);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_get_type, gxg_gtk_cell_layout_get_type, 0, 0, 0, H_gtk_cell_layout_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_pack_start, gxg_gtk_cell_layout_pack_start, 3, 0, 0, H_gtk_cell_layout_pack_start);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_pack_end, gxg_gtk_cell_layout_pack_end, 3, 0, 0, H_gtk_cell_layout_pack_end);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_clear, gxg_gtk_cell_layout_clear, 1, 0, 0, H_gtk_cell_layout_clear);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_set_attributes, gxg_gtk_cell_layout_set_attributes, 3, 0, 0, H_gtk_cell_layout_set_attributes);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_add_attribute, gxg_gtk_cell_layout_add_attribute, 4, 0, 0, H_gtk_cell_layout_add_attribute);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_set_cell_data_func, gxg_gtk_cell_layout_set_cell_data_func, 5, 0, 0, H_gtk_cell_layout_set_cell_data_func);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_clear_attributes, gxg_gtk_cell_layout_clear_attributes, 2, 0, 0, H_gtk_cell_layout_clear_attributes);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_type, gxg_gtk_file_chooser_get_type, 0, 0, 0, H_gtk_file_chooser_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_action, gxg_gtk_file_chooser_set_action, 2, 0, 0, H_gtk_file_chooser_set_action);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_action, gxg_gtk_file_chooser_get_action, 1, 0, 0, H_gtk_file_chooser_get_action);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_local_only, gxg_gtk_file_chooser_set_local_only, 2, 0, 0, H_gtk_file_chooser_set_local_only);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_local_only, gxg_gtk_file_chooser_get_local_only, 1, 0, 0, H_gtk_file_chooser_get_local_only);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_select_multiple, gxg_gtk_file_chooser_set_select_multiple, 2, 0, 0, H_gtk_file_chooser_set_select_multiple);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_select_multiple, gxg_gtk_file_chooser_get_select_multiple, 1, 0, 0, H_gtk_file_chooser_get_select_multiple);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_current_name, gxg_gtk_file_chooser_set_current_name, 2, 0, 0, H_gtk_file_chooser_set_current_name);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_filename, gxg_gtk_file_chooser_get_filename, 1, 0, 0, H_gtk_file_chooser_get_filename);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_unselect_filename, gxg_gtk_file_chooser_unselect_filename, 2, 0, 0, H_gtk_file_chooser_unselect_filename);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_select_all, gxg_gtk_file_chooser_select_all, 1, 0, 0, H_gtk_file_chooser_select_all);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_unselect_all, gxg_gtk_file_chooser_unselect_all, 1, 0, 0, H_gtk_file_chooser_unselect_all);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_filenames, gxg_gtk_file_chooser_get_filenames, 1, 0, 0, H_gtk_file_chooser_get_filenames);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_current_folder, gxg_gtk_file_chooser_get_current_folder, 1, 0, 0, H_gtk_file_chooser_get_current_folder);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_uri, gxg_gtk_file_chooser_get_uri, 1, 0, 0, H_gtk_file_chooser_get_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_unselect_uri, gxg_gtk_file_chooser_unselect_uri, 2, 0, 0, H_gtk_file_chooser_unselect_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_uris, gxg_gtk_file_chooser_get_uris, 1, 0, 0, H_gtk_file_chooser_get_uris);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_current_folder_uri, gxg_gtk_file_chooser_get_current_folder_uri, 1, 0, 0, H_gtk_file_chooser_get_current_folder_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_preview_widget, gxg_gtk_file_chooser_set_preview_widget, 2, 0, 0, H_gtk_file_chooser_set_preview_widget);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_preview_widget, gxg_gtk_file_chooser_get_preview_widget, 1, 0, 0, H_gtk_file_chooser_get_preview_widget);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_preview_widget_active, gxg_gtk_file_chooser_set_preview_widget_active, 2, 0, 0, H_gtk_file_chooser_set_preview_widget_active);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_preview_widget_active, gxg_gtk_file_chooser_get_preview_widget_active, 1, 0, 0, H_gtk_file_chooser_get_preview_widget_active);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_preview_filename, gxg_gtk_file_chooser_get_preview_filename, 1, 0, 0, H_gtk_file_chooser_get_preview_filename);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_preview_uri, gxg_gtk_file_chooser_get_preview_uri, 1, 0, 0, H_gtk_file_chooser_get_preview_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_extra_widget, gxg_gtk_file_chooser_set_extra_widget, 2, 0, 0, H_gtk_file_chooser_set_extra_widget);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_extra_widget, gxg_gtk_file_chooser_get_extra_widget, 1, 0, 0, H_gtk_file_chooser_get_extra_widget);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_add_filter, gxg_gtk_file_chooser_add_filter, 2, 0, 0, H_gtk_file_chooser_add_filter);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_remove_filter, gxg_gtk_file_chooser_remove_filter, 2, 0, 0, H_gtk_file_chooser_remove_filter);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_list_filters, gxg_gtk_file_chooser_list_filters, 1, 0, 0, H_gtk_file_chooser_list_filters);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_filter, gxg_gtk_file_chooser_set_filter, 2, 0, 0, H_gtk_file_chooser_set_filter);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_filter, gxg_gtk_file_chooser_get_filter, 1, 0, 0, H_gtk_file_chooser_get_filter);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_add_shortcut_folder, gxg_gtk_file_chooser_add_shortcut_folder, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_remove_shortcut_folder, gxg_gtk_file_chooser_remove_shortcut_folder, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_list_shortcut_folders, gxg_gtk_file_chooser_list_shortcut_folders, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folders);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_add_shortcut_folder_uri, gxg_gtk_file_chooser_add_shortcut_folder_uri, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_remove_shortcut_folder_uri, gxg_gtk_file_chooser_remove_shortcut_folder_uri, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_list_shortcut_folder_uris, gxg_gtk_file_chooser_list_shortcut_folder_uris, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folder_uris);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_type, gxg_gtk_icon_theme_get_type, 0, 0, 0, H_gtk_icon_theme_get_type);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_new, gxg_gtk_icon_theme_new, 0, 0, 0, H_gtk_icon_theme_new);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_default, gxg_gtk_icon_theme_get_default, 0, 0, 0, H_gtk_icon_theme_get_default);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_for_screen, gxg_gtk_icon_theme_get_for_screen, 1, 0, 0, H_gtk_icon_theme_get_for_screen);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_set_screen, gxg_gtk_icon_theme_set_screen, 2, 0, 0, H_gtk_icon_theme_set_screen);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_search_path, gxg_gtk_icon_theme_get_search_path, 1, 2, 0, H_gtk_icon_theme_get_search_path);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_append_search_path, gxg_gtk_icon_theme_append_search_path, 2, 0, 0, H_gtk_icon_theme_append_search_path);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_prepend_search_path, gxg_gtk_icon_theme_prepend_search_path, 2, 0, 0, H_gtk_icon_theme_prepend_search_path);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_set_custom_theme, gxg_gtk_icon_theme_set_custom_theme, 2, 0, 0, H_gtk_icon_theme_set_custom_theme);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_has_icon, gxg_gtk_icon_theme_has_icon, 2, 0, 0, H_gtk_icon_theme_has_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_lookup_icon, gxg_gtk_icon_theme_lookup_icon, 4, 0, 0, H_gtk_icon_theme_lookup_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_load_icon, gxg_gtk_icon_theme_load_icon, 4, 1, 0, H_gtk_icon_theme_load_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_list_icons, gxg_gtk_icon_theme_list_icons, 2, 0, 0, H_gtk_icon_theme_list_icons);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_example_icon_name, gxg_gtk_icon_theme_get_example_icon_name, 1, 0, 0, H_gtk_icon_theme_get_example_icon_name);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_rescan_if_needed, gxg_gtk_icon_theme_rescan_if_needed, 1, 0, 0, H_gtk_icon_theme_rescan_if_needed);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_add_builtin_icon, gxg_gtk_icon_theme_add_builtin_icon, 3, 0, 0, H_gtk_icon_theme_add_builtin_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_type, gxg_gtk_icon_info_get_type, 0, 0, 0, H_gtk_icon_info_get_type);
  XG_DEFINE_PROCEDURE(gtk_icon_info_copy, gxg_gtk_icon_info_copy, 1, 0, 0, H_gtk_icon_info_copy);
  XG_DEFINE_PROCEDURE(gtk_icon_info_free, gxg_gtk_icon_info_free, 1, 0, 0, H_gtk_icon_info_free);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_base_size, gxg_gtk_icon_info_get_base_size, 1, 0, 0, H_gtk_icon_info_get_base_size);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_filename, gxg_gtk_icon_info_get_filename, 1, 0, 0, H_gtk_icon_info_get_filename);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_builtin_pixbuf, gxg_gtk_icon_info_get_builtin_pixbuf, 1, 0, 0, H_gtk_icon_info_get_builtin_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_icon_info_load_icon, gxg_gtk_icon_info_load_icon, 1, 1, 0, H_gtk_icon_info_load_icon);
  XG_DEFINE_PROCEDURE(gtk_icon_info_set_raw_coordinates, gxg_gtk_icon_info_set_raw_coordinates, 2, 0, 0, H_gtk_icon_info_set_raw_coordinates);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_embedded_rect, gxg_gtk_icon_info_get_embedded_rect, 2, 0, 0, H_gtk_icon_info_get_embedded_rect);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_attach_points, gxg_gtk_icon_info_get_attach_points, 1, 2, 0, H_gtk_icon_info_get_attach_points);
  XG_DEFINE_PROCEDURE(gtk_icon_info_get_display_name, gxg_gtk_icon_info_get_display_name, 1, 0, 0, H_gtk_icon_info_get_display_name);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_type, gxg_gtk_tool_button_get_type, 0, 0, 0, H_gtk_tool_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_tool_button_new, gxg_gtk_tool_button_new, 2, 0, 0, H_gtk_tool_button_new);
  XG_DEFINE_PROCEDURE(gtk_tool_button_new_from_stock, gxg_gtk_tool_button_new_from_stock, 1, 0, 0, H_gtk_tool_button_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_tool_button_set_label, gxg_gtk_tool_button_set_label, 2, 0, 0, H_gtk_tool_button_set_label);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_label, gxg_gtk_tool_button_get_label, 1, 0, 0, H_gtk_tool_button_get_label);
  XG_DEFINE_PROCEDURE(gtk_tool_button_set_use_underline, gxg_gtk_tool_button_set_use_underline, 2, 0, 0, H_gtk_tool_button_set_use_underline);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_use_underline, gxg_gtk_tool_button_get_use_underline, 1, 0, 0, H_gtk_tool_button_get_use_underline);
  XG_DEFINE_PROCEDURE(gtk_tool_button_set_stock_id, gxg_gtk_tool_button_set_stock_id, 2, 0, 0, H_gtk_tool_button_set_stock_id);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_stock_id, gxg_gtk_tool_button_get_stock_id, 1, 0, 0, H_gtk_tool_button_get_stock_id);
  XG_DEFINE_PROCEDURE(gtk_tool_button_set_icon_widget, gxg_gtk_tool_button_set_icon_widget, 2, 0, 0, H_gtk_tool_button_set_icon_widget);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_icon_widget, gxg_gtk_tool_button_get_icon_widget, 1, 0, 0, H_gtk_tool_button_get_icon_widget);
  XG_DEFINE_PROCEDURE(gtk_tool_button_set_label_widget, gxg_gtk_tool_button_set_label_widget, 2, 0, 0, H_gtk_tool_button_set_label_widget);
  XG_DEFINE_PROCEDURE(gtk_tool_button_get_label_widget, gxg_gtk_tool_button_get_label_widget, 1, 0, 0, H_gtk_tool_button_get_label_widget);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_type, gxg_gtk_tool_item_get_type, 0, 0, 0, H_gtk_tool_item_get_type);
  XG_DEFINE_PROCEDURE(gtk_tool_item_new, gxg_gtk_tool_item_new, 0, 0, 0, H_gtk_tool_item_new);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_homogeneous, gxg_gtk_tool_item_set_homogeneous, 2, 0, 0, H_gtk_tool_item_set_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_homogeneous, gxg_gtk_tool_item_get_homogeneous, 1, 0, 0, H_gtk_tool_item_get_homogeneous);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_expand, gxg_gtk_tool_item_set_expand, 2, 0, 0, H_gtk_tool_item_set_expand);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_expand, gxg_gtk_tool_item_get_expand, 1, 0, 0, H_gtk_tool_item_get_expand);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_tooltip, gxg_gtk_tool_item_set_tooltip, 4, 0, 0, H_gtk_tool_item_set_tooltip);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_use_drag_window, gxg_gtk_tool_item_set_use_drag_window, 2, 0, 0, H_gtk_tool_item_set_use_drag_window);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_use_drag_window, gxg_gtk_tool_item_get_use_drag_window, 1, 0, 0, H_gtk_tool_item_get_use_drag_window);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_visible_horizontal, gxg_gtk_tool_item_set_visible_horizontal, 2, 0, 0, H_gtk_tool_item_set_visible_horizontal);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_visible_horizontal, gxg_gtk_tool_item_get_visible_horizontal, 1, 0, 0, H_gtk_tool_item_get_visible_horizontal);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_visible_vertical, gxg_gtk_tool_item_set_visible_vertical, 2, 0, 0, H_gtk_tool_item_set_visible_vertical);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_visible_vertical, gxg_gtk_tool_item_get_visible_vertical, 1, 0, 0, H_gtk_tool_item_get_visible_vertical);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_is_important, gxg_gtk_tool_item_get_is_important, 1, 0, 0, H_gtk_tool_item_get_is_important);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_is_important, gxg_gtk_tool_item_set_is_important, 2, 0, 0, H_gtk_tool_item_set_is_important);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_icon_size, gxg_gtk_tool_item_get_icon_size, 1, 0, 0, H_gtk_tool_item_get_icon_size);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_orientation, gxg_gtk_tool_item_get_orientation, 1, 0, 0, H_gtk_tool_item_get_orientation);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_toolbar_style, gxg_gtk_tool_item_get_toolbar_style, 1, 0, 0, H_gtk_tool_item_get_toolbar_style);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_relief_style, gxg_gtk_tool_item_get_relief_style, 1, 0, 0, H_gtk_tool_item_get_relief_style);
  XG_DEFINE_PROCEDURE(gtk_tool_item_retrieve_proxy_menu_item, gxg_gtk_tool_item_retrieve_proxy_menu_item, 1, 0, 0, H_gtk_tool_item_retrieve_proxy_menu_item);
  XG_DEFINE_PROCEDURE(gtk_tool_item_get_proxy_menu_item, gxg_gtk_tool_item_get_proxy_menu_item, 2, 0, 0, H_gtk_tool_item_get_proxy_menu_item);
  XG_DEFINE_PROCEDURE(gtk_tool_item_set_proxy_menu_item, gxg_gtk_tool_item_set_proxy_menu_item, 3, 0, 0, H_gtk_tool_item_set_proxy_menu_item);
  XG_DEFINE_PROCEDURE(gtk_list_store_remove, gxg_gtk_list_store_remove, 2, 0, 0, H_gtk_list_store_remove);
#endif

#if HAVE_GTK_EXPANDER_GET_USE_MARKUP
  XG_DEFINE_PROCEDURE(gdk_drawable_copy_to_image, gxg_gdk_drawable_copy_to_image, 8, 0, 0, H_gdk_drawable_copy_to_image);
  XG_DEFINE_PROCEDURE(gtk_accel_group_activate, gxg_gtk_accel_group_activate, 5, 0, 0, H_gtk_accel_group_activate);
  XG_DEFINE_PROCEDURE(gtk_menu_set_monitor, gxg_gtk_menu_set_monitor, 2, 0, 0, H_gtk_menu_set_monitor);
  XG_DEFINE_PROCEDURE(gtk_widget_can_activate_accel, gxg_gtk_widget_can_activate_accel, 2, 0, 0, H_gtk_widget_can_activate_accel);
  XG_DEFINE_PROCEDURE(gtk_window_is_active, gxg_gtk_window_is_active, 1, 0, 0, H_gtk_window_is_active);
  XG_DEFINE_PROCEDURE(gtk_window_has_toplevel_focus, gxg_gtk_window_has_toplevel_focus, 1, 0, 0, H_gtk_window_has_toplevel_focus);
  XG_DEFINE_PROCEDURE(gtk_combo_box_new, gxg_gtk_combo_box_new, 0, 0, 0, H_gtk_combo_box_new);
  XG_DEFINE_PROCEDURE(gtk_combo_box_new_with_model, gxg_gtk_combo_box_new_with_model, 1, 0, 0, H_gtk_combo_box_new_with_model);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_model, gxg_gtk_combo_box_set_model, 2, 0, 0, H_gtk_combo_box_set_model);
  XG_DEFINE_PROCEDURE(gtk_combo_box_remove_text, gxg_gtk_combo_box_remove_text, 2, 0, 0, H_gtk_combo_box_remove_text);
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_new, gxg_gtk_combo_box_entry_new, 0, 0, 0, H_gtk_combo_box_entry_new);
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_new_with_model, gxg_gtk_combo_box_entry_new_with_model, 2, 0, 0, H_gtk_combo_box_entry_new_with_model);
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_set_text_column, gxg_gtk_combo_box_entry_set_text_column, 2, 0, 0, H_gtk_combo_box_entry_set_text_column);
  XG_DEFINE_PROCEDURE(gtk_expander_set_use_markup, gxg_gtk_expander_set_use_markup, 2, 0, 0, H_gtk_expander_set_use_markup);
  XG_DEFINE_PROCEDURE(gtk_expander_get_use_markup, gxg_gtk_expander_get_use_markup, 1, 0, 0, H_gtk_expander_get_use_markup);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_new_from_widget, gxg_gtk_radio_tool_button_new_from_widget, 1, 0, 0, H_gtk_radio_tool_button_new_from_widget);
  XG_DEFINE_PROCEDURE(gtk_separator_tool_item_get_draw, gxg_gtk_separator_tool_item_get_draw, 1, 0, 0, H_gtk_separator_tool_item_get_draw);
  XG_DEFINE_PROCEDURE(gtk_separator_tool_item_set_draw, gxg_gtk_separator_tool_item_set_draw, 2, 0, 0, H_gtk_separator_tool_item_set_draw);
#endif

#if HAVE_GTK_MENU_SHELL_CANCEL
  XG_DEFINE_PROCEDURE(gtk_notebook_append_page, gxg_gtk_notebook_append_page, 3, 0, 0, H_gtk_notebook_append_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_append_page_menu, gxg_gtk_notebook_append_page_menu, 4, 0, 0, H_gtk_notebook_append_page_menu);
  XG_DEFINE_PROCEDURE(gtk_notebook_prepend_page, gxg_gtk_notebook_prepend_page, 3, 0, 0, H_gtk_notebook_prepend_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_prepend_page_menu, gxg_gtk_notebook_prepend_page_menu, 4, 0, 0, H_gtk_notebook_prepend_page_menu);
  XG_DEFINE_PROCEDURE(gtk_notebook_insert_page, gxg_gtk_notebook_insert_page, 4, 0, 0, H_gtk_notebook_insert_page);
  XG_DEFINE_PROCEDURE(gtk_notebook_insert_page_menu, gxg_gtk_notebook_insert_page_menu, 5, 0, 0, H_gtk_notebook_insert_page_menu);
  XG_DEFINE_PROCEDURE(gtk_radio_tool_button_new_with_stock_from_widget, gxg_gtk_radio_tool_button_new_with_stock_from_widget, 2, 0, 0, H_gtk_radio_tool_button_new_with_stock_from_widget);
  XG_DEFINE_PROCEDURE(gdk_display_set_double_click_distance, gxg_gdk_display_set_double_click_distance, 2, 0, 0, H_gdk_display_set_double_click_distance);
  XG_DEFINE_PROCEDURE(gdk_display_get_default_group, gxg_gdk_display_get_default_group, 1, 0, 0, H_gdk_display_get_default_group);
  XG_DEFINE_PROCEDURE(gdk_window_set_accept_focus, gxg_gdk_window_set_accept_focus, 2, 0, 0, H_gdk_window_set_accept_focus);
  XG_DEFINE_PROCEDURE(gdk_window_get_group, gxg_gdk_window_get_group, 1, 0, 0, H_gdk_window_get_group);
  XG_DEFINE_PROCEDURE(gtk_action_group_get_sensitive, gxg_gtk_action_group_get_sensitive, 1, 0, 0, H_gtk_action_group_get_sensitive);
  XG_DEFINE_PROCEDURE(gtk_action_group_set_sensitive, gxg_gtk_action_group_set_sensitive, 2, 0, 0, H_gtk_action_group_set_sensitive);
  XG_DEFINE_PROCEDURE(gtk_action_group_get_visible, gxg_gtk_action_group_get_visible, 1, 0, 0, H_gtk_action_group_get_visible);
  XG_DEFINE_PROCEDURE(gtk_action_group_set_visible, gxg_gtk_action_group_set_visible, 2, 0, 0, H_gtk_action_group_set_visible);
  XG_DEFINE_PROCEDURE(gtk_action_group_add_action_with_accel, gxg_gtk_action_group_add_action_with_accel, 3, 0, 0, H_gtk_action_group_add_action_with_accel);
  XG_DEFINE_PROCEDURE(gtk_action_new, gxg_gtk_action_new, 4, 0, 0, H_gtk_action_new);
  XG_DEFINE_PROCEDURE(gtk_action_is_sensitive, gxg_gtk_action_is_sensitive, 1, 0, 0, H_gtk_action_is_sensitive);
  XG_DEFINE_PROCEDURE(gtk_action_get_sensitive, gxg_gtk_action_get_sensitive, 1, 0, 0, H_gtk_action_get_sensitive);
  XG_DEFINE_PROCEDURE(gtk_action_is_visible, gxg_gtk_action_is_visible, 1, 0, 0, H_gtk_action_is_visible);
  XG_DEFINE_PROCEDURE(gtk_action_get_visible, gxg_gtk_action_get_visible, 1, 0, 0, H_gtk_action_get_visible);
  XG_DEFINE_PROCEDURE(gtk_button_set_alignment, gxg_gtk_button_set_alignment, 3, 0, 0, H_gtk_button_set_alignment);
  XG_DEFINE_PROCEDURE(gtk_button_get_alignment, gxg_gtk_button_get_alignment, 1, 2, 0, H_gtk_button_get_alignment);
  XG_DEFINE_PROCEDURE(gtk_cell_layout_reorder, gxg_gtk_cell_layout_reorder, 3, 0, 0, H_gtk_cell_layout_reorder);
  XG_DEFINE_PROCEDURE(gtk_clipboard_request_targets, gxg_gtk_clipboard_request_targets, 2, 1, 0, H_gtk_clipboard_request_targets);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_for_targets, gxg_gtk_clipboard_wait_for_targets, 1, 2, 0, H_gtk_clipboard_wait_for_targets);
  XG_DEFINE_PROCEDURE(gtk_menu_shell_cancel, gxg_gtk_menu_shell_cancel, 1, 0, 0, H_gtk_menu_shell_cancel);
  XG_DEFINE_PROCEDURE(gtk_paned_get_child1, gxg_gtk_paned_get_child1, 1, 0, 0, H_gtk_paned_get_child1);
  XG_DEFINE_PROCEDURE(gtk_paned_get_child2, gxg_gtk_paned_get_child2, 1, 0, 0, H_gtk_paned_get_child2);
  XG_DEFINE_PROCEDURE(gtk_radio_action_new, gxg_gtk_radio_action_new, 5, 0, 0, H_gtk_radio_action_new);
  XG_DEFINE_PROCEDURE(gtk_toggle_action_new, gxg_gtk_toggle_action_new, 4, 0, 0, H_gtk_toggle_action_new);
  XG_DEFINE_PROCEDURE(gtk_window_set_accept_focus, gxg_gtk_window_set_accept_focus, 2, 0, 0, H_gtk_window_set_accept_focus);
  XG_DEFINE_PROCEDURE(gtk_window_get_accept_focus, gxg_gtk_window_get_accept_focus, 1, 0, 0, H_gtk_window_get_accept_focus);
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
  XG_DEFINE_PROCEDURE(gtk_accel_map_get_type, gxg_gtk_accel_map_get_type, 0, 0, 0, H_gtk_accel_map_get_type);
  XG_DEFINE_PROCEDURE(gtk_accel_map_get, gxg_gtk_accel_map_get, 0, 0, 0, H_gtk_accel_map_get);
  XG_DEFINE_PROCEDURE(gtk_combo_box_popup, gxg_gtk_combo_box_popup, 1, 0, 0, H_gtk_combo_box_popup);
  XG_DEFINE_PROCEDURE(gtk_combo_box_popdown, gxg_gtk_combo_box_popdown, 1, 0, 0, H_gtk_combo_box_popdown);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new_from_widget, gxg_gtk_radio_menu_item_new_from_widget, 1, 0, 0, H_gtk_radio_menu_item_new_from_widget);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new_with_mnemonic_from_widget, gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic_from_widget);
  XG_DEFINE_PROCEDURE(gtk_radio_menu_item_new_with_label_from_widget, gxg_gtk_radio_menu_item_new_with_label_from_widget, 2, 0, 0, H_gtk_radio_menu_item_new_with_label_from_widget);
  XG_DEFINE_PROCEDURE(gtk_scale_get_layout, gxg_gtk_scale_get_layout, 1, 0, 0, H_gtk_scale_get_layout);
  XG_DEFINE_PROCEDURE(gtk_scale_get_layout_offsets, gxg_gtk_scale_get_layout_offsets, 1, 2, 0, H_gtk_scale_get_layout_offsets);
  XG_DEFINE_PROCEDURE(gtk_tooltips_get_info_from_tip_window, gxg_gtk_tooltips_get_info_from_tip_window, 1, 2, 0, H_gtk_tooltips_get_info_from_tip_window);
#endif

#if HAVE_GTK_COMBO_BOX_ENTRY_NEW_TEXT
  XG_DEFINE_PROCEDURE(gtk_combo_box_entry_new_text, gxg_gtk_combo_box_entry_new_text, 0, 0, 0, H_gtk_combo_box_entry_new_text);
  XG_DEFINE_PROCEDURE(gtk_drag_source_get_target_list, gxg_gtk_drag_source_get_target_list, 1, 0, 0, H_gtk_drag_source_get_target_list);
  XG_DEFINE_PROCEDURE(gtk_drag_source_set_target_list, gxg_gtk_drag_source_set_target_list, 2, 0, 0, H_gtk_drag_source_set_target_list);
  XG_DEFINE_PROCEDURE(gtk_entry_set_alignment, gxg_gtk_entry_set_alignment, 2, 0, 0, H_gtk_entry_set_alignment);
  XG_DEFINE_PROCEDURE(gtk_entry_get_alignment, gxg_gtk_entry_get_alignment, 1, 0, 0, H_gtk_entry_get_alignment);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_use_preview_label, gxg_gtk_file_chooser_set_use_preview_label, 2, 0, 0, H_gtk_file_chooser_set_use_preview_label);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_use_preview_label, gxg_gtk_file_chooser_get_use_preview_label, 1, 0, 0, H_gtk_file_chooser_get_use_preview_label);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_widget_new_with_backend, gxg_gtk_file_chooser_widget_new_with_backend, 2, 0, 0, H_gtk_file_chooser_widget_new_with_backend);
  XG_DEFINE_PROCEDURE(gtk_widget_list_mnemonic_labels, gxg_gtk_widget_list_mnemonic_labels, 1, 0, 0, H_gtk_widget_list_mnemonic_labels);
  XG_DEFINE_PROCEDURE(gtk_widget_add_mnemonic_label, gxg_gtk_widget_add_mnemonic_label, 2, 0, 0, H_gtk_widget_add_mnemonic_label);
  XG_DEFINE_PROCEDURE(gtk_widget_remove_mnemonic_label, gxg_gtk_widget_remove_mnemonic_label, 2, 0, 0, H_gtk_widget_remove_mnemonic_label);
  XG_DEFINE_PROCEDURE(gtk_window_activate_key, gxg_gtk_window_activate_key, 2, 0, 0, H_gtk_window_activate_key);
  XG_DEFINE_PROCEDURE(gtk_window_propagate_key_event, gxg_gtk_window_propagate_key_event, 2, 0, 0, H_gtk_window_propagate_key_event);
#endif

#if HAVE_GBOOLEAN_GTK_FILE_CHOOSER_SET_FILENAME
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_filename, gxg_gtk_file_chooser_set_filename, 2, 0, 0, H_gtk_file_chooser_set_filename);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_select_filename, gxg_gtk_file_chooser_select_filename, 2, 0, 0, H_gtk_file_chooser_select_filename);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_current_folder, gxg_gtk_file_chooser_set_current_folder, 2, 0, 0, H_gtk_file_chooser_set_current_folder);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_uri, gxg_gtk_file_chooser_set_uri, 2, 0, 0, H_gtk_file_chooser_set_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_select_uri, gxg_gtk_file_chooser_select_uri, 2, 0, 0, H_gtk_file_chooser_select_uri);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_current_folder_uri, gxg_gtk_file_chooser_set_current_folder_uri, 2, 0, 0, H_gtk_file_chooser_set_current_folder_uri);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  XG_DEFINE_PROCEDURE(gtk_cell_view_get_type, gxg_gtk_cell_view_get_type, 0, 0, 0, H_gtk_cell_view_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_view_new, gxg_gtk_cell_view_new, 0, 0, 0, H_gtk_cell_view_new);
  XG_DEFINE_PROCEDURE(gtk_cell_view_new_with_text, gxg_gtk_cell_view_new_with_text, 1, 0, 0, H_gtk_cell_view_new_with_text);
  XG_DEFINE_PROCEDURE(gtk_cell_view_new_with_markup, gxg_gtk_cell_view_new_with_markup, 1, 0, 0, H_gtk_cell_view_new_with_markup);
  XG_DEFINE_PROCEDURE(gtk_cell_view_new_with_pixbuf, gxg_gtk_cell_view_new_with_pixbuf, 1, 0, 0, H_gtk_cell_view_new_with_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_cell_view_set_model, gxg_gtk_cell_view_set_model, 2, 0, 0, H_gtk_cell_view_set_model);
  XG_DEFINE_PROCEDURE(gtk_cell_view_set_displayed_row, gxg_gtk_cell_view_set_displayed_row, 2, 0, 0, H_gtk_cell_view_set_displayed_row);
  XG_DEFINE_PROCEDURE(gtk_cell_view_get_displayed_row, gxg_gtk_cell_view_get_displayed_row, 1, 0, 0, H_gtk_cell_view_get_displayed_row);
  XG_DEFINE_PROCEDURE(gtk_cell_view_get_size_of_row, gxg_gtk_cell_view_get_size_of_row, 3, 0, 0, H_gtk_cell_view_get_size_of_row);
  XG_DEFINE_PROCEDURE(gtk_cell_view_set_background_color, gxg_gtk_cell_view_set_background_color, 2, 0, 0, H_gtk_cell_view_set_background_color);
  XG_DEFINE_PROCEDURE(gtk_cell_view_get_cell_renderers, gxg_gtk_cell_view_get_cell_renderers, 1, 0, 0, H_gtk_cell_view_get_cell_renderers);
  XG_DEFINE_PROCEDURE(gdk_window_set_focus_on_map, gxg_gdk_window_set_focus_on_map, 2, 0, 0, H_gdk_window_set_focus_on_map);
  XG_DEFINE_PROCEDURE(gdk_window_enable_synchronized_configure, gxg_gdk_window_enable_synchronized_configure, 1, 0, 0, H_gdk_window_enable_synchronized_configure);
  XG_DEFINE_PROCEDURE(gdk_window_configure_finished, gxg_gdk_window_configure_finished, 1, 0, 0, H_gdk_window_configure_finished);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_wrap_width, gxg_gtk_combo_box_get_wrap_width, 1, 0, 0, H_gtk_combo_box_get_wrap_width);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_row_span_column, gxg_gtk_combo_box_get_row_span_column, 1, 0, 0, H_gtk_combo_box_get_row_span_column);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_column_span_column, gxg_gtk_combo_box_get_column_span_column, 1, 0, 0, H_gtk_combo_box_get_column_span_column);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_add_tearoffs, gxg_gtk_combo_box_get_add_tearoffs, 1, 0, 0, H_gtk_combo_box_get_add_tearoffs);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_add_tearoffs, gxg_gtk_combo_box_set_add_tearoffs, 2, 0, 0, H_gtk_combo_box_set_add_tearoffs);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_active_text, gxg_gtk_combo_box_get_active_text, 1, 0, 0, H_gtk_combo_box_get_active_text);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_add_text_targets, gxg_gtk_drag_dest_add_text_targets, 1, 0, 0, H_gtk_drag_dest_add_text_targets);
  XG_DEFINE_PROCEDURE(gtk_drag_source_add_text_targets, gxg_gtk_drag_source_add_text_targets, 1, 0, 0, H_gtk_drag_source_add_text_targets);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_insert_prefix, gxg_gtk_entry_completion_insert_prefix, 1, 0, 0, H_gtk_entry_completion_insert_prefix);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_inline_completion, gxg_gtk_entry_completion_set_inline_completion, 2, 0, 0, H_gtk_entry_completion_set_inline_completion);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_inline_completion, gxg_gtk_entry_completion_get_inline_completion, 1, 0, 0, H_gtk_entry_completion_get_inline_completion);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_set_popup_completion, gxg_gtk_entry_completion_set_popup_completion, 2, 0, 0, H_gtk_entry_completion_set_popup_completion);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_popup_completion, gxg_gtk_entry_completion_get_popup_completion, 1, 0, 0, H_gtk_entry_completion_get_popup_completion);
  XG_DEFINE_PROCEDURE(gtk_entry_completion_get_text_column, gxg_gtk_entry_completion_get_text_column, 1, 0, 0, H_gtk_entry_completion_get_text_column);
  XG_DEFINE_PROCEDURE(gtk_icon_theme_get_icon_sizes, gxg_gtk_icon_theme_get_icon_sizes, 2, 0, 0, H_gtk_icon_theme_get_icon_sizes);
  XG_DEFINE_PROCEDURE(gtk_menu_get_for_attach_widget, gxg_gtk_menu_get_for_attach_widget, 1, 0, 0, H_gtk_menu_get_for_attach_widget);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_fixed_height_mode, gxg_gtk_tree_view_set_fixed_height_mode, 2, 0, 0, H_gtk_tree_view_set_fixed_height_mode);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_fixed_height_mode, gxg_gtk_tree_view_get_fixed_height_mode, 1, 0, 0, H_gtk_tree_view_get_fixed_height_mode);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_hover_selection, gxg_gtk_tree_view_set_hover_selection, 2, 0, 0, H_gtk_tree_view_set_hover_selection);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_hover_selection, gxg_gtk_tree_view_get_hover_selection, 1, 0, 0, H_gtk_tree_view_get_hover_selection);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_row_separator_func, gxg_gtk_tree_view_set_row_separator_func, 4, 0, 0, H_gtk_tree_view_set_row_separator_func);
  XG_DEFINE_PROCEDURE(gtk_window_set_focus_on_map, gxg_gtk_window_set_focus_on_map, 2, 0, 0, H_gtk_window_set_focus_on_map);
  XG_DEFINE_PROCEDURE(gtk_window_get_focus_on_map, gxg_gtk_window_get_focus_on_map, 1, 0, 0, H_gtk_window_get_focus_on_map);
  XG_DEFINE_PROCEDURE(gtk_window_set_icon_name, gxg_gtk_window_set_icon_name, 2, 0, 0, H_gtk_window_set_icon_name);
  XG_DEFINE_PROCEDURE(gtk_window_get_icon_name, gxg_gtk_window_get_icon_name, 1, 0, 0, H_gtk_window_get_icon_name);
  XG_DEFINE_PROCEDURE(gtk_window_set_default_icon_name, gxg_gtk_window_set_default_icon_name, 1, 0, 0, H_gtk_window_set_default_icon_name);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_type, gxg_gtk_about_dialog_get_type, 0, 0, 0, H_gtk_about_dialog_get_type);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_new, gxg_gtk_about_dialog_new, 0, 0, 0, H_gtk_about_dialog_new);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_name, gxg_gtk_about_dialog_get_name, 1, 0, 0, H_gtk_about_dialog_get_name);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_name, gxg_gtk_about_dialog_set_name, 2, 0, 0, H_gtk_about_dialog_set_name);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_version, gxg_gtk_about_dialog_get_version, 1, 0, 0, H_gtk_about_dialog_get_version);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_version, gxg_gtk_about_dialog_set_version, 2, 0, 0, H_gtk_about_dialog_set_version);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_copyright, gxg_gtk_about_dialog_get_copyright, 1, 0, 0, H_gtk_about_dialog_get_copyright);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_copyright, gxg_gtk_about_dialog_set_copyright, 2, 0, 0, H_gtk_about_dialog_set_copyright);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_comments, gxg_gtk_about_dialog_get_comments, 1, 0, 0, H_gtk_about_dialog_get_comments);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_comments, gxg_gtk_about_dialog_set_comments, 2, 0, 0, H_gtk_about_dialog_set_comments);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_license, gxg_gtk_about_dialog_get_license, 1, 0, 0, H_gtk_about_dialog_get_license);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_license, gxg_gtk_about_dialog_set_license, 2, 0, 0, H_gtk_about_dialog_set_license);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_website, gxg_gtk_about_dialog_get_website, 1, 0, 0, H_gtk_about_dialog_get_website);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_website, gxg_gtk_about_dialog_set_website, 2, 0, 0, H_gtk_about_dialog_set_website);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_website_label, gxg_gtk_about_dialog_get_website_label, 1, 0, 0, H_gtk_about_dialog_get_website_label);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_website_label, gxg_gtk_about_dialog_set_website_label, 2, 0, 0, H_gtk_about_dialog_set_website_label);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_authors, gxg_gtk_about_dialog_get_authors, 1, 0, 0, H_gtk_about_dialog_get_authors);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_authors, gxg_gtk_about_dialog_set_authors, 2, 0, 0, H_gtk_about_dialog_set_authors);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_documenters, gxg_gtk_about_dialog_get_documenters, 1, 0, 0, H_gtk_about_dialog_get_documenters);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_documenters, gxg_gtk_about_dialog_set_documenters, 2, 0, 0, H_gtk_about_dialog_set_documenters);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_artists, gxg_gtk_about_dialog_get_artists, 1, 0, 0, H_gtk_about_dialog_get_artists);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_artists, gxg_gtk_about_dialog_set_artists, 2, 0, 0, H_gtk_about_dialog_set_artists);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_translator_credits, gxg_gtk_about_dialog_get_translator_credits, 1, 0, 0, H_gtk_about_dialog_get_translator_credits);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_translator_credits, gxg_gtk_about_dialog_set_translator_credits, 2, 0, 0, H_gtk_about_dialog_set_translator_credits);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_logo, gxg_gtk_about_dialog_get_logo, 1, 0, 0, H_gtk_about_dialog_get_logo);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_logo, gxg_gtk_about_dialog_set_logo, 2, 0, 0, H_gtk_about_dialog_set_logo);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_type, gxg_gtk_icon_view_get_type, 0, 0, 0, H_gtk_icon_view_get_type);
  XG_DEFINE_PROCEDURE(gtk_icon_view_new, gxg_gtk_icon_view_new, 0, 0, 0, H_gtk_icon_view_new);
  XG_DEFINE_PROCEDURE(gtk_icon_view_new_with_model, gxg_gtk_icon_view_new_with_model, 1, 0, 0, H_gtk_icon_view_new_with_model);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_model, gxg_gtk_icon_view_set_model, 2, 0, 0, H_gtk_icon_view_set_model);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_model, gxg_gtk_icon_view_get_model, 1, 0, 0, H_gtk_icon_view_get_model);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_text_column, gxg_gtk_icon_view_set_text_column, 2, 0, 0, H_gtk_icon_view_set_text_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_text_column, gxg_gtk_icon_view_get_text_column, 1, 0, 0, H_gtk_icon_view_get_text_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_markup_column, gxg_gtk_icon_view_set_markup_column, 2, 0, 0, H_gtk_icon_view_set_markup_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_markup_column, gxg_gtk_icon_view_get_markup_column, 1, 0, 0, H_gtk_icon_view_get_markup_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_pixbuf_column, gxg_gtk_icon_view_set_pixbuf_column, 2, 0, 0, H_gtk_icon_view_set_pixbuf_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_pixbuf_column, gxg_gtk_icon_view_get_pixbuf_column, 1, 0, 0, H_gtk_icon_view_get_pixbuf_column);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_orientation, gxg_gtk_icon_view_set_orientation, 2, 0, 0, H_gtk_icon_view_set_orientation);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_orientation, gxg_gtk_icon_view_get_orientation, 1, 0, 0, H_gtk_icon_view_get_orientation);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_path_at_pos, gxg_gtk_icon_view_get_path_at_pos, 3, 0, 0, H_gtk_icon_view_get_path_at_pos);
  XG_DEFINE_PROCEDURE(gtk_icon_view_selected_foreach, gxg_gtk_icon_view_selected_foreach, 3, 0, 0, H_gtk_icon_view_selected_foreach);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_selection_mode, gxg_gtk_icon_view_set_selection_mode, 2, 0, 0, H_gtk_icon_view_set_selection_mode);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_selection_mode, gxg_gtk_icon_view_get_selection_mode, 1, 0, 0, H_gtk_icon_view_get_selection_mode);
  XG_DEFINE_PROCEDURE(gtk_icon_view_select_path, gxg_gtk_icon_view_select_path, 2, 0, 0, H_gtk_icon_view_select_path);
  XG_DEFINE_PROCEDURE(gtk_icon_view_unselect_path, gxg_gtk_icon_view_unselect_path, 2, 0, 0, H_gtk_icon_view_unselect_path);
  XG_DEFINE_PROCEDURE(gtk_icon_view_path_is_selected, gxg_gtk_icon_view_path_is_selected, 2, 0, 0, H_gtk_icon_view_path_is_selected);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_selected_items, gxg_gtk_icon_view_get_selected_items, 1, 0, 0, H_gtk_icon_view_get_selected_items);
  XG_DEFINE_PROCEDURE(gtk_icon_view_select_all, gxg_gtk_icon_view_select_all, 1, 0, 0, H_gtk_icon_view_select_all);
  XG_DEFINE_PROCEDURE(gtk_icon_view_unselect_all, gxg_gtk_icon_view_unselect_all, 1, 0, 0, H_gtk_icon_view_unselect_all);
  XG_DEFINE_PROCEDURE(gtk_icon_view_item_activated, gxg_gtk_icon_view_item_activated, 2, 0, 0, H_gtk_icon_view_item_activated);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_combo_get_type, gxg_gtk_cell_renderer_combo_get_type, 0, 0, 0, H_gtk_cell_renderer_combo_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_combo_new, gxg_gtk_cell_renderer_combo_new, 0, 0, 0, H_gtk_cell_renderer_combo_new);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_progress_get_type, gxg_gtk_cell_renderer_progress_get_type, 0, 0, 0, H_gtk_cell_renderer_progress_get_type);
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_progress_new, gxg_gtk_cell_renderer_progress_new, 0, 0, 0, H_gtk_cell_renderer_progress_new);
#endif

#if HAVE_GTK_LABEL_SET_ELLIPSIZE
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_row_separator_func, gxg_gtk_combo_box_set_row_separator_func, 4, 0, 0, H_gtk_combo_box_set_row_separator_func);
  XG_DEFINE_PROCEDURE(gtk_label_set_ellipsize, gxg_gtk_label_set_ellipsize, 2, 0, 0, H_gtk_label_set_ellipsize);
  XG_DEFINE_PROCEDURE(gtk_label_get_ellipsize, gxg_gtk_label_get_ellipsize, 1, 0, 0, H_gtk_label_get_ellipsize);
  XG_DEFINE_PROCEDURE(pango_attr_fallback_new, gxg_pango_attr_fallback_new, 1, 0, 0, H_pango_attr_fallback_new);
  XG_DEFINE_PROCEDURE(pango_attr_letter_spacing_new, gxg_pango_attr_letter_spacing_new, 1, 0, 0, H_pango_attr_letter_spacing_new);
  XG_DEFINE_PROCEDURE(pango_attr_list_filter, gxg_pango_attr_list_filter, 3, 0, 0, H_pango_attr_list_filter);
  XG_DEFINE_PROCEDURE(pango_attr_iterator_get_attrs, gxg_pango_attr_iterator_get_attrs, 1, 0, 0, H_pango_attr_iterator_get_attrs);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_underline_position, gxg_pango_font_metrics_get_underline_position, 1, 0, 0, H_pango_font_metrics_get_underline_position);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_underline_thickness, gxg_pango_font_metrics_get_underline_thickness, 1, 0, 0, H_pango_font_metrics_get_underline_thickness);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_strikethrough_position, gxg_pango_font_metrics_get_strikethrough_position, 1, 0, 0, H_pango_font_metrics_get_strikethrough_position);
  XG_DEFINE_PROCEDURE(pango_font_metrics_get_strikethrough_thickness, gxg_pango_font_metrics_get_strikethrough_thickness, 1, 0, 0, H_pango_font_metrics_get_strikethrough_thickness);
  XG_DEFINE_PROCEDURE(pango_font_family_is_monospace, gxg_pango_font_family_is_monospace, 1, 0, 0, H_pango_font_family_is_monospace);
  XG_DEFINE_PROCEDURE(pango_font_face_list_sizes, gxg_pango_font_face_list_sizes, 1, 2, 0, H_pango_font_face_list_sizes);
  XG_DEFINE_PROCEDURE(pango_layout_set_auto_dir, gxg_pango_layout_set_auto_dir, 2, 0, 0, H_pango_layout_set_auto_dir);
  XG_DEFINE_PROCEDURE(pango_layout_get_auto_dir, gxg_pango_layout_get_auto_dir, 1, 0, 0, H_pango_layout_get_auto_dir);
  XG_DEFINE_PROCEDURE(pango_script_for_unichar, gxg_pango_script_for_unichar, 1, 0, 0, H_pango_script_for_unichar);
  XG_DEFINE_PROCEDURE(pango_script_iter_new, gxg_pango_script_iter_new, 2, 0, 0, H_pango_script_iter_new);
  XG_DEFINE_PROCEDURE(pango_script_iter_get_range, gxg_pango_script_iter_get_range, 1, 3, 0, H_pango_script_iter_get_range);
  XG_DEFINE_PROCEDURE(pango_script_iter_next, gxg_pango_script_iter_next, 1, 0, 0, H_pango_script_iter_next);
  XG_DEFINE_PROCEDURE(pango_script_iter_free, gxg_pango_script_iter_free, 1, 0, 0, H_pango_script_iter_free);
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_get_type, gxg_gtk_file_chooser_button_get_type, 0, 0, 0, H_gtk_file_chooser_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_new_with_dialog, gxg_gtk_file_chooser_button_new_with_dialog, 1, 0, 0, H_gtk_file_chooser_button_new_with_dialog);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_get_title, gxg_gtk_file_chooser_button_get_title, 1, 0, 0, H_gtk_file_chooser_button_get_title);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_set_title, gxg_gtk_file_chooser_button_set_title, 2, 0, 0, H_gtk_file_chooser_button_set_title);
  XG_DEFINE_PROCEDURE(gdk_drag_drop_succeeded, gxg_gdk_drag_drop_succeeded, 1, 0, 0, H_gdk_drag_drop_succeeded);
  XG_DEFINE_PROCEDURE(gdk_rgb_colormap_ditherable, gxg_gdk_rgb_colormap_ditherable, 1, 0, 0, H_gdk_rgb_colormap_ditherable);
  XG_DEFINE_PROCEDURE(gtk_action_set_sensitive, gxg_gtk_action_set_sensitive, 2, 0, 0, H_gtk_action_set_sensitive);
  XG_DEFINE_PROCEDURE(gtk_action_set_visible, gxg_gtk_action_set_visible, 2, 0, 0, H_gtk_action_set_visible);
  XG_DEFINE_PROCEDURE(gtk_combo_box_get_focus_on_click, gxg_gtk_combo_box_get_focus_on_click, 1, 0, 0, H_gtk_combo_box_get_focus_on_click);
  XG_DEFINE_PROCEDURE(gtk_combo_box_set_focus_on_click, gxg_gtk_combo_box_set_focus_on_click, 2, 0, 0, H_gtk_combo_box_set_focus_on_click);
  XG_DEFINE_PROCEDURE(gtk_entry_layout_index_to_text_index, gxg_gtk_entry_layout_index_to_text_index, 2, 0, 0, H_gtk_entry_layout_index_to_text_index);
  XG_DEFINE_PROCEDURE(gtk_entry_text_index_to_layout_index, gxg_gtk_entry_text_index_to_layout_index, 2, 0, 0, H_gtk_entry_text_index_to_layout_index);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_set_show_hidden, gxg_gtk_file_chooser_set_show_hidden, 2, 0, 0, H_gtk_file_chooser_set_show_hidden);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_get_show_hidden, gxg_gtk_file_chooser_get_show_hidden, 1, 0, 0, H_gtk_file_chooser_get_show_hidden);
  XG_DEFINE_PROCEDURE(gtk_tree_view_set_hover_expand, gxg_gtk_tree_view_set_hover_expand, 2, 0, 0, H_gtk_tree_view_set_hover_expand);
  XG_DEFINE_PROCEDURE(gtk_tree_view_get_hover_expand, gxg_gtk_tree_view_get_hover_expand, 1, 0, 0, H_gtk_tree_view_get_hover_expand);
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
  XG_DEFINE_PROCEDURE(gtk_tool_item_rebuild_menu, gxg_gtk_tool_item_rebuild_menu, 1, 0, 0, H_gtk_tool_item_rebuild_menu);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_get_type, gxg_gtk_menu_tool_button_get_type, 0, 0, 0, H_gtk_menu_tool_button_get_type);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_new, gxg_gtk_menu_tool_button_new, 2, 0, 0, H_gtk_menu_tool_button_new);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_new_from_stock, gxg_gtk_menu_tool_button_new_from_stock, 1, 0, 0, H_gtk_menu_tool_button_new_from_stock);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_set_menu, gxg_gtk_menu_tool_button_set_menu, 2, 0, 0, H_gtk_menu_tool_button_set_menu);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_get_menu, gxg_gtk_menu_tool_button_get_menu, 1, 0, 0, H_gtk_menu_tool_button_get_menu);
  XG_DEFINE_PROCEDURE(gtk_menu_tool_button_set_arrow_tooltip, gxg_gtk_menu_tool_button_set_arrow_tooltip, 4, 0, 0, H_gtk_menu_tool_button_set_arrow_tooltip);
  XG_DEFINE_PROCEDURE(gdk_display_supports_clipboard_persistence, gxg_gdk_display_supports_clipboard_persistence, 1, 0, 0, H_gdk_display_supports_clipboard_persistence);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_get_logo_icon_name, gxg_gtk_about_dialog_get_logo_icon_name, 1, 0, 0, H_gtk_about_dialog_get_logo_icon_name);
  XG_DEFINE_PROCEDURE(gtk_about_dialog_set_logo_icon_name, gxg_gtk_about_dialog_set_logo_icon_name, 2, 0, 0, H_gtk_about_dialog_set_logo_icon_name);
  XG_DEFINE_PROCEDURE(gtk_accelerator_get_label, gxg_gtk_accelerator_get_label, 2, 0, 0, H_gtk_accelerator_get_label);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_is_target_available, gxg_gtk_clipboard_wait_is_target_available, 2, 0, 0, H_gtk_clipboard_wait_is_target_available);
  XG_DEFINE_PROCEDURE(gtk_clipboard_set_can_store, gxg_gtk_clipboard_set_can_store, 3, 0, 0, H_gtk_clipboard_set_can_store);
  XG_DEFINE_PROCEDURE(gtk_clipboard_store, gxg_gtk_clipboard_store, 1, 0, 0, H_gtk_clipboard_store);
  XG_DEFINE_PROCEDURE(gtk_alternative_dialog_button_order, gxg_gtk_alternative_dialog_button_order, 1, 0, 0, H_gtk_alternative_dialog_button_order);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_add_image_targets, gxg_gtk_drag_dest_add_image_targets, 1, 0, 0, H_gtk_drag_dest_add_image_targets);
  XG_DEFINE_PROCEDURE(gtk_drag_dest_add_uri_targets, gxg_gtk_drag_dest_add_uri_targets, 1, 0, 0, H_gtk_drag_dest_add_uri_targets);
  XG_DEFINE_PROCEDURE(gtk_drag_source_add_image_targets, gxg_gtk_drag_source_add_image_targets, 1, 0, 0, H_gtk_drag_source_add_image_targets);
  XG_DEFINE_PROCEDURE(gtk_drag_source_add_uri_targets, gxg_gtk_drag_source_add_uri_targets, 1, 0, 0, H_gtk_drag_source_add_uri_targets);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_get_width_chars, gxg_gtk_file_chooser_button_get_width_chars, 1, 0, 0, H_gtk_file_chooser_button_get_width_chars);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_set_width_chars, gxg_gtk_file_chooser_button_set_width_chars, 2, 0, 0, H_gtk_file_chooser_button_set_width_chars);
  XG_DEFINE_PROCEDURE(gtk_image_new_from_icon_name, gxg_gtk_image_new_from_icon_name, 2, 0, 0, H_gtk_image_new_from_icon_name);
  XG_DEFINE_PROCEDURE(gtk_image_set_from_icon_name, gxg_gtk_image_set_from_icon_name, 3, 0, 0, H_gtk_image_set_from_icon_name);
  XG_DEFINE_PROCEDURE(gtk_image_set_pixel_size, gxg_gtk_image_set_pixel_size, 2, 0, 0, H_gtk_image_set_pixel_size);
  XG_DEFINE_PROCEDURE(gtk_image_get_pixel_size, gxg_gtk_image_get_pixel_size, 1, 0, 0, H_gtk_image_get_pixel_size);
  XG_DEFINE_PROCEDURE(gtk_label_set_width_chars, gxg_gtk_label_set_width_chars, 2, 0, 0, H_gtk_label_set_width_chars);
  XG_DEFINE_PROCEDURE(gtk_label_get_width_chars, gxg_gtk_label_get_width_chars, 1, 0, 0, H_gtk_label_get_width_chars);
  XG_DEFINE_PROCEDURE(gtk_target_list_add_text_targets, gxg_gtk_target_list_add_text_targets, 2, 0, 0, H_gtk_target_list_add_text_targets);
  XG_DEFINE_PROCEDURE(gtk_target_list_add_image_targets, gxg_gtk_target_list_add_image_targets, 3, 0, 0, H_gtk_target_list_add_image_targets);
  XG_DEFINE_PROCEDURE(gtk_target_list_add_uri_targets, gxg_gtk_target_list_add_uri_targets, 2, 0, 0, H_gtk_target_list_add_uri_targets);
  XG_DEFINE_PROCEDURE(gtk_selection_data_set_pixbuf, gxg_gtk_selection_data_set_pixbuf, 2, 0, 0, H_gtk_selection_data_set_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_selection_data_get_pixbuf, gxg_gtk_selection_data_get_pixbuf, 1, 0, 0, H_gtk_selection_data_get_pixbuf);
  XG_DEFINE_PROCEDURE(gtk_selection_data_set_uris, gxg_gtk_selection_data_set_uris, 2, 0, 0, H_gtk_selection_data_set_uris);
  XG_DEFINE_PROCEDURE(gtk_selection_data_get_uris, gxg_gtk_selection_data_get_uris, 1, 0, 0, H_gtk_selection_data_get_uris);
  XG_DEFINE_PROCEDURE(gtk_text_buffer_backspace, gxg_gtk_text_buffer_backspace, 4, 0, 0, H_gtk_text_buffer_backspace);
#endif

#if HAVE_GTK_LABEL_GET_SINGLE_LINE_MODE
  XG_DEFINE_PROCEDURE(gtk_clipboard_set_image, gxg_gtk_clipboard_set_image, 2, 0, 0, H_gtk_clipboard_set_image);
  XG_DEFINE_PROCEDURE(gtk_clipboard_request_image, gxg_gtk_clipboard_request_image, 2, 1, 0, H_gtk_clipboard_request_image);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_for_image, gxg_gtk_clipboard_wait_for_image, 1, 0, 0, H_gtk_clipboard_wait_for_image);
  XG_DEFINE_PROCEDURE(gtk_clipboard_wait_is_image_available, gxg_gtk_clipboard_wait_is_image_available, 1, 0, 0, H_gtk_clipboard_wait_is_image_available);
  XG_DEFINE_PROCEDURE(gtk_file_filter_add_pixbuf_formats, gxg_gtk_file_filter_add_pixbuf_formats, 1, 0, 0, H_gtk_file_filter_add_pixbuf_formats);
  XG_DEFINE_PROCEDURE(gtk_label_set_single_line_mode, gxg_gtk_label_set_single_line_mode, 2, 0, 0, H_gtk_label_set_single_line_mode);
  XG_DEFINE_PROCEDURE(gtk_label_get_single_line_mode, gxg_gtk_label_get_single_line_mode, 1, 0, 0, H_gtk_label_get_single_line_mode);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_set_ellipsize, gxg_gtk_progress_bar_set_ellipsize, 2, 0, 0, H_gtk_progress_bar_set_ellipsize);
  XG_DEFINE_PROCEDURE(gtk_progress_bar_get_ellipsize, gxg_gtk_progress_bar_get_ellipsize, 1, 0, 0, H_gtk_progress_bar_get_ellipsize);
  XG_DEFINE_PROCEDURE(gtk_selection_data_targets_include_image, gxg_gtk_selection_data_targets_include_image, 2, 0, 0, H_gtk_selection_data_targets_include_image);
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
  XG_DEFINE_PROCEDURE(gdk_draw_glyphs_transformed, gxg_gdk_draw_glyphs_transformed, 7, 0, 0, H_gdk_draw_glyphs_transformed);
  XG_DEFINE_PROCEDURE(gdk_draw_trapezoids, gxg_gdk_draw_trapezoids, 4, 0, 0, H_gdk_draw_trapezoids);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_get_type, gxg_gdk_pango_renderer_get_type, 0, 0, 0, H_gdk_pango_renderer_get_type);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_new, gxg_gdk_pango_renderer_new, 1, 0, 0, H_gdk_pango_renderer_new);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_get_default, gxg_gdk_pango_renderer_get_default, 1, 0, 0, H_gdk_pango_renderer_get_default);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_set_drawable, gxg_gdk_pango_renderer_set_drawable, 2, 0, 0, H_gdk_pango_renderer_set_drawable);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_set_gc, gxg_gdk_pango_renderer_set_gc, 2, 0, 0, H_gdk_pango_renderer_set_gc);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_set_stipple, gxg_gdk_pango_renderer_set_stipple, 3, 0, 0, H_gdk_pango_renderer_set_stipple);
  XG_DEFINE_PROCEDURE(gdk_pango_renderer_set_override_color, gxg_gdk_pango_renderer_set_override_color, 3, 0, 0, H_gdk_pango_renderer_set_override_color);
  XG_DEFINE_PROCEDURE(gtk_button_set_image, gxg_gtk_button_set_image, 2, 0, 0, H_gtk_button_set_image);
  XG_DEFINE_PROCEDURE(gtk_button_get_image, gxg_gtk_button_get_image, 1, 0, 0, H_gtk_button_get_image);
  XG_DEFINE_PROCEDURE(gtk_dialog_set_alternative_button_order_from_array, gxg_gtk_dialog_set_alternative_button_order_from_array, 3, 0, 0, H_gtk_dialog_set_alternative_button_order_from_array);
  XG_DEFINE_PROCEDURE(gtk_label_set_angle, gxg_gtk_label_set_angle, 2, 0, 0, H_gtk_label_set_angle);
  XG_DEFINE_PROCEDURE(gtk_label_get_angle, gxg_gtk_label_get_angle, 1, 0, 0, H_gtk_label_get_angle);
  XG_DEFINE_PROCEDURE(gtk_menu_set_screen, gxg_gtk_menu_set_screen, 2, 0, 0, H_gtk_menu_set_screen);
  XG_DEFINE_PROCEDURE(pango_attr_underline_color_new, gxg_pango_attr_underline_color_new, 3, 0, 0, H_pango_attr_underline_color_new);
  XG_DEFINE_PROCEDURE(pango_attr_strikethrough_color_new, gxg_pango_attr_strikethrough_color_new, 3, 0, 0, H_pango_attr_strikethrough_color_new);
  XG_DEFINE_PROCEDURE(pango_render_part_get_type, gxg_pango_render_part_get_type, 0, 0, 0, H_pango_render_part_get_type);
  XG_DEFINE_PROCEDURE(pango_renderer_get_type, gxg_pango_renderer_get_type, 0, 0, 0, H_pango_renderer_get_type);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_layout, gxg_pango_renderer_draw_layout, 4, 0, 0, H_pango_renderer_draw_layout);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_layout_line, gxg_pango_renderer_draw_layout_line, 4, 0, 0, H_pango_renderer_draw_layout_line);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_glyphs, gxg_pango_renderer_draw_glyphs, 5, 0, 0, H_pango_renderer_draw_glyphs);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_rectangle, gxg_pango_renderer_draw_rectangle, 6, 0, 0, H_pango_renderer_draw_rectangle);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_error_underline, gxg_pango_renderer_draw_error_underline, 5, 0, 0, H_pango_renderer_draw_error_underline);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_trapezoid, gxg_pango_renderer_draw_trapezoid, 8, 0, 0, H_pango_renderer_draw_trapezoid);
  XG_DEFINE_PROCEDURE(pango_renderer_draw_glyph, gxg_pango_renderer_draw_glyph, 5, 0, 0, H_pango_renderer_draw_glyph);
  XG_DEFINE_PROCEDURE(pango_renderer_activate, gxg_pango_renderer_activate, 1, 0, 0, H_pango_renderer_activate);
  XG_DEFINE_PROCEDURE(pango_renderer_deactivate, gxg_pango_renderer_deactivate, 1, 0, 0, H_pango_renderer_deactivate);
  XG_DEFINE_PROCEDURE(pango_renderer_part_changed, gxg_pango_renderer_part_changed, 2, 0, 0, H_pango_renderer_part_changed);
  XG_DEFINE_PROCEDURE(pango_renderer_set_color, gxg_pango_renderer_set_color, 3, 0, 0, H_pango_renderer_set_color);
  XG_DEFINE_PROCEDURE(pango_renderer_get_color, gxg_pango_renderer_get_color, 2, 0, 0, H_pango_renderer_get_color);
  XG_DEFINE_PROCEDURE(pango_renderer_set_matrix, gxg_pango_renderer_set_matrix, 2, 0, 0, H_pango_renderer_set_matrix);
  XG_DEFINE_PROCEDURE(g_log_set_handler, gxg_g_log_set_handler, 4, 0, 0, H_g_log_set_handler);
  XG_DEFINE_PROCEDURE(g_log_remove_handler, gxg_g_log_remove_handler, 2, 0, 0, H_g_log_remove_handler);
#endif

#if HAVE_GTK_TEXT_LAYOUT_GET_ITER_AT_POSITION
  XG_DEFINE_PROCEDURE(gtk_cell_renderer_stop_editing, gxg_gtk_cell_renderer_stop_editing, 2, 0, 0, H_gtk_cell_renderer_stop_editing);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_new, gxg_gtk_file_chooser_button_new, 2, 0, 0, H_gtk_file_chooser_button_new);
  XG_DEFINE_PROCEDURE(gtk_file_chooser_button_new_with_backend, gxg_gtk_file_chooser_button_new_with_backend, 3, 0, 0, H_gtk_file_chooser_button_new_with_backend);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_columns, gxg_gtk_icon_view_set_columns, 2, 0, 0, H_gtk_icon_view_set_columns);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_columns, gxg_gtk_icon_view_get_columns, 1, 0, 0, H_gtk_icon_view_get_columns);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_item_width, gxg_gtk_icon_view_set_item_width, 2, 0, 0, H_gtk_icon_view_set_item_width);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_item_width, gxg_gtk_icon_view_get_item_width, 1, 0, 0, H_gtk_icon_view_get_item_width);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_spacing, gxg_gtk_icon_view_set_spacing, 2, 0, 0, H_gtk_icon_view_set_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_spacing, gxg_gtk_icon_view_get_spacing, 1, 0, 0, H_gtk_icon_view_get_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_row_spacing, gxg_gtk_icon_view_set_row_spacing, 2, 0, 0, H_gtk_icon_view_set_row_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_row_spacing, gxg_gtk_icon_view_get_row_spacing, 1, 0, 0, H_gtk_icon_view_get_row_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_column_spacing, gxg_gtk_icon_view_set_column_spacing, 2, 0, 0, H_gtk_icon_view_set_column_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_column_spacing, gxg_gtk_icon_view_get_column_spacing, 1, 0, 0, H_gtk_icon_view_get_column_spacing);
  XG_DEFINE_PROCEDURE(gtk_icon_view_set_margin, gxg_gtk_icon_view_set_margin, 2, 0, 0, H_gtk_icon_view_set_margin);
  XG_DEFINE_PROCEDURE(gtk_icon_view_get_margin, gxg_gtk_icon_view_get_margin, 1, 0, 0, H_gtk_icon_view_get_margin);
  XG_DEFINE_PROCEDURE(gtk_label_set_max_width_chars, gxg_gtk_label_set_max_width_chars, 2, 0, 0, H_gtk_label_set_max_width_chars);
  XG_DEFINE_PROCEDURE(gtk_label_get_max_width_chars, gxg_gtk_label_get_max_width_chars, 1, 0, 0, H_gtk_label_get_max_width_chars);
  XG_DEFINE_PROCEDURE(gtk_list_store_insert_with_values, gxg_gtk_list_store_insert_with_values, 3, 0, 0, H_gtk_list_store_insert_with_values);
  XG_DEFINE_PROCEDURE(gtk_list_store_insert_with_valuesv, gxg_gtk_list_store_insert_with_valuesv, 6, 0, 0, H_gtk_list_store_insert_with_valuesv);
  XG_DEFINE_PROCEDURE(gtk_text_view_get_iter_at_position, gxg_gtk_text_view_get_iter_at_position, 4, 1, 0, H_gtk_text_view_get_iter_at_position);
  XG_DEFINE_PROCEDURE(pango_attr_size_new_absolute, gxg_pango_attr_size_new_absolute, 1, 0, 0, H_pango_attr_size_new_absolute);
  XG_DEFINE_PROCEDURE(pango_font_description_set_absolute_size, gxg_pango_font_description_set_absolute_size, 2, 0, 0, H_pango_font_description_set_absolute_size);
  XG_DEFINE_PROCEDURE(pango_layout_get_font_description, gxg_pango_layout_get_font_description, 1, 0, 0, H_pango_layout_get_font_description);
#endif

  XG_DEFINE_PROCEDURE(GPOINTER, gxg_GPOINTER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_COLORMAP, gxg_GDK_COLORMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_DRAG_CONTEXT, gxg_GDK_DRAG_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_DRAWABLE, gxg_GDK_DRAWABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_GC, gxg_GDK_GC, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IMAGE, gxg_GDK_IMAGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_DEVICE, gxg_GDK_DEVICE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_KEYMAP, gxg_GDK_KEYMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_PIXMAP, gxg_GDK_PIXMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_VISUAL, gxg_GDK_VISUAL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_WINDOW, gxg_GDK_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_PIXBUF, gxg_GDK_PIXBUF, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_PIXBUF_ANIMATION, gxg_GDK_PIXBUF_ANIMATION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_PIXBUF_ANIMATION_ITER, gxg_GDK_PIXBUF_ANIMATION_ITER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_PIXBUF_LOADER, gxg_GDK_PIXBUF_LOADER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VBOX, gxg_GTK_VBOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ACCEL_GROUP, gxg_GTK_ACCEL_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ACCEL_LABEL, gxg_GTK_ACCEL_LABEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ACCESSIBLE, gxg_GTK_ACCESSIBLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ADJUSTMENT, gxg_GTK_ADJUSTMENT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ALIGNMENT, gxg_GTK_ALIGNMENT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ARROW, gxg_GTK_ARROW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ASPECT_FRAME, gxg_GTK_ASPECT_FRAME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_BUTTON_BOX, gxg_GTK_BUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_BIN, gxg_GTK_BIN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_BOX, gxg_GTK_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_BUTTON, gxg_GTK_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CALENDAR, gxg_GTK_CALENDAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_EDITABLE, gxg_GTK_CELL_EDITABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER, gxg_GTK_CELL_RENDERER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER_PIXBUF, gxg_GTK_CELL_RENDERER_PIXBUF, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER_TEXT, gxg_GTK_CELL_RENDERER_TEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER_TOGGLE, gxg_GTK_CELL_RENDERER_TOGGLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CHECK_BUTTON, gxg_GTK_CHECK_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CHECK_MENU_ITEM, gxg_GTK_CHECK_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_COLOR_SELECTION_DIALOG, gxg_GTK_COLOR_SELECTION_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_COLOR_SELECTION, gxg_GTK_COLOR_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CONTAINER, gxg_GTK_CONTAINER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CURVE, gxg_GTK_CURVE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_DIALOG, gxg_GTK_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_DRAWING_AREA, gxg_GTK_DRAWING_AREA, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_EDITABLE, gxg_GTK_EDITABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ENTRY, gxg_GTK_ENTRY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_EVENT_BOX, gxg_GTK_EVENT_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FILE_SELECTION, gxg_GTK_FILE_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FIXED, gxg_GTK_FIXED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FONT_SELECTION, gxg_GTK_FONT_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FONT_SELECTION_DIALOG, gxg_GTK_FONT_SELECTION_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FRAME, gxg_GTK_FRAME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_GAMMA_CURVE, gxg_GTK_GAMMA_CURVE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HANDLE_BOX, gxg_GTK_HANDLE_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HBUTTON_BOX, gxg_GTK_HBUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HBOX, gxg_GTK_HBOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HPANED, gxg_GTK_HPANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HRULER, gxg_GTK_HRULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HSCALE, gxg_GTK_HSCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HSCROLLBAR, gxg_GTK_HSCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_HSEPARATOR, gxg_GTK_HSEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ICON_FACTORY, gxg_GTK_ICON_FACTORY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IMAGE, gxg_GTK_IMAGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IMAGE_MENU_ITEM, gxg_GTK_IMAGE_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IM_CONTEXT, gxg_GTK_IM_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IM_CONTEXT_SIMPLE, gxg_GTK_IM_CONTEXT_SIMPLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IM_MULTICONTEXT, gxg_GTK_IM_MULTICONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_INPUT_DIALOG, gxg_GTK_INPUT_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_INVISIBLE, gxg_GTK_INVISIBLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ITEM, gxg_GTK_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_LABEL, gxg_GTK_LABEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_LAYOUT, gxg_GTK_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_LIST_STORE, gxg_GTK_LIST_STORE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MENU_BAR, gxg_GTK_MENU_BAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MENU, gxg_GTK_MENU, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MENU_ITEM, gxg_GTK_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MENU_SHELL, gxg_GTK_MENU_SHELL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MESSAGE_DIALOG, gxg_GTK_MESSAGE_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_MISC, gxg_GTK_MISC, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_NOTEBOOK, gxg_GTK_NOTEBOOK, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_OBJECT, gxg_GTK_OBJECT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_PANED, gxg_GTK_PANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_PLUG, gxg_GTK_PLUG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_PROGRESS_BAR, gxg_GTK_PROGRESS_BAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RADIO_BUTTON, gxg_GTK_RADIO_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RADIO_MENU_ITEM, gxg_GTK_RADIO_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RANGE, gxg_GTK_RANGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RULER, gxg_GTK_RULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SCALE, gxg_GTK_SCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SCROLLBAR, gxg_GTK_SCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SCROLLED_WINDOW, gxg_GTK_SCROLLED_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SEPARATOR, gxg_GTK_SEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SEPARATOR_MENU_ITEM, gxg_GTK_SEPARATOR_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SIZE_GROUP, gxg_GTK_SIZE_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SOCKET, gxg_GTK_SOCKET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SPIN_BUTTON, gxg_GTK_SPIN_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_STATUSBAR, gxg_GTK_STATUSBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_STYLE, gxg_GTK_STYLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TABLE, gxg_GTK_TABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEAROFF_MENU_ITEM, gxg_GTK_TEAROFF_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_BUFFER, gxg_GTK_TEXT_BUFFER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_CHILD_ANCHOR, gxg_GTK_TEXT_CHILD_ANCHOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_MARK, gxg_GTK_TEXT_MARK, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_TAG, gxg_GTK_TEXT_TAG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_TAG_TABLE, gxg_GTK_TEXT_TAG_TABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TEXT_VIEW, gxg_GTK_TEXT_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOGGLE_BUTTON, gxg_GTK_TOGGLE_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOOLBAR, gxg_GTK_TOOLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOOLTIPS, gxg_GTK_TOOLTIPS, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_DRAG_SOURCE, gxg_GTK_TREE_DRAG_SOURCE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_DRAG_DEST, gxg_GTK_TREE_DRAG_DEST, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_MODEL, gxg_GTK_TREE_MODEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_MODEL_SORT, gxg_GTK_TREE_MODEL_SORT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_SELECTION, gxg_GTK_TREE_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_SORTABLE, gxg_GTK_TREE_SORTABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_STORE, gxg_GTK_TREE_STORE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_VIEW_COLUMN, gxg_GTK_TREE_VIEW_COLUMN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_VIEW, gxg_GTK_TREE_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VBUTTON_BOX, gxg_GTK_VBUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VIEWPORT, gxg_GTK_VIEWPORT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VPANED, gxg_GTK_VPANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VRULER, gxg_GTK_VRULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VSCALE, gxg_GTK_VSCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VSCROLLBAR, gxg_GTK_VSCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_VSEPARATOR, gxg_GTK_VSEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_WIDGET, gxg_GTK_WIDGET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_WINDOW, gxg_GTK_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_CONTEXT, gxg_PANGO_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_FONT_FAMILY, gxg_PANGO_FONT_FAMILY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_FONT_FACE, gxg_PANGO_FONT_FACE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_FONT, gxg_PANGO_FONT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_FONT_MAP, gxg_PANGO_FONT_MAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_LAYOUT, gxg_PANGO_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(G_OBJECT, gxg_G_OBJECT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_ANY, gxg_GDK_EVENT_ANY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_EXPOSE, gxg_GDK_EVENT_EXPOSE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_NOEXPOSE, gxg_GDK_EVENT_NOEXPOSE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_VISIBILITY, gxg_GDK_EVENT_VISIBILITY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_MOTION, gxg_GDK_EVENT_MOTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_BUTTON, gxg_GDK_EVENT_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_SCROLL, gxg_GDK_EVENT_SCROLL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_KEY, gxg_GDK_EVENT_KEY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_CROSSING, gxg_GDK_EVENT_CROSSING, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_FOCUS, gxg_GDK_EVENT_FOCUS, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_CONFIGURE, gxg_GDK_EVENT_CONFIGURE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_PROPERTY, gxg_GDK_EVENT_PROPERTY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_SELECTION, gxg_GDK_EVENT_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_PROXIMITY, gxg_GDK_EVENT_PROXIMITY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_SETTING, gxg_GDK_EVENT_SETTING, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_WINDOWSTATE, gxg_GDK_EVENT_WINDOWSTATE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_EVENT_DND, gxg_GDK_EVENT_DND, 1, 0, 0, NULL);
#if HAVE_GDK_DRAW_PIXBUF
  XG_DEFINE_PROCEDURE(GDK_SCREEN, gxg_GDK_SCREEN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_DISPLAY_OBJECT, gxg_GDK_DISPLAY_OBJECT, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
  XG_DEFINE_PROCEDURE(GTK_FILE_CHOOSER_DIALOG, gxg_GTK_FILE_CHOOSER_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FILE_CHOOSER_WIDGET, gxg_GTK_FILE_CHOOSER_WIDGET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TREE_MODEL_FILTER, gxg_GTK_TREE_MODEL_FILTER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ACTION, gxg_GTK_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ACTION_GROUP, gxg_GTK_ACTION_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_COMBO_BOX, gxg_GTK_COMBO_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_COMBO_BOX_ENTRY, gxg_GTK_COMBO_BOX_ENTRY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_EXPANDER, gxg_GTK_EXPANDER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FONT_BUTTON, gxg_GTK_FONT_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_COLOR_BUTTON, gxg_GTK_COLOR_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ENTRY_COMPLETION, gxg_GTK_ENTRY_COMPLETION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_UI_MANAGER, gxg_GTK_UI_MANAGER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RADIO_TOOL_BUTTON, gxg_GTK_RADIO_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_RADIO_ACTION, gxg_GTK_RADIO_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_SEPARATOR_TOOL_ITEM, gxg_GTK_SEPARATOR_TOOL_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOGGLE_ACTION, gxg_GTK_TOGGLE_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOGGLE_TOOL_BUTTON, gxg_GTK_TOGGLE_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FILE_FILTER, gxg_GTK_FILE_FILTER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_LAYOUT, gxg_GTK_CELL_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CLIPBOARD, gxg_GTK_CLIPBOARD, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_FILE_CHOOSER, gxg_GTK_FILE_CHOOSER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ICON_THEME, gxg_GTK_ICON_THEME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOOL_BUTTON, gxg_GTK_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_TOOL_ITEM, gxg_GTK_TOOL_ITEM, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
  XG_DEFINE_PROCEDURE(GTK_ACCEL_MAP, gxg_GTK_ACCEL_MAP, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  XG_DEFINE_PROCEDURE(GTK_CELL_VIEW, gxg_GTK_CELL_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ABOUT_DIALOG, gxg_GTK_ABOUT_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER_COMBO, gxg_GTK_CELL_RENDERER_COMBO, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_CELL_RENDERER_PROGRESS, gxg_GTK_CELL_RENDERER_PROGRESS, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_ICON_VIEW, gxg_GTK_ICON_VIEW, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
  XG_DEFINE_PROCEDURE(GTK_FILE_CHOOSER_BUTTON, gxg_GTK_FILE_CHOOSER_BUTTON, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
  XG_DEFINE_PROCEDURE(GTK_MENU_TOOL_BUTTON, gxg_GTK_MENU_TOOL_BUTTON, 1, 0, 0, NULL);
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
  XG_DEFINE_PROCEDURE(GDK_PANGO_RENDERER, gxg_GDK_PANGO_RENDERER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_RENDERER, gxg_PANGO_RENDERER, 1, 0, 0, NULL);
#endif

  XG_DEFINE_PROCEDURE(GDK_IS_COLORMAP, gxg_GDK_IS_COLORMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_DRAG_CONTEXT, gxg_GDK_IS_DRAG_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_DRAWABLE, gxg_GDK_IS_DRAWABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_GC, gxg_GDK_IS_GC, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_IMAGE, gxg_GDK_IS_IMAGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_DEVICE, gxg_GDK_IS_DEVICE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_KEYMAP, gxg_GDK_IS_KEYMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_PIXMAP, gxg_GDK_IS_PIXMAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_VISUAL, gxg_GDK_IS_VISUAL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_WINDOW, gxg_GDK_IS_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_PIXBUF, gxg_GDK_IS_PIXBUF, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_PIXBUF_ANIMATION, gxg_GDK_IS_PIXBUF_ANIMATION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_PIXBUF_ANIMATION_ITER, gxg_GDK_IS_PIXBUF_ANIMATION_ITER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_PIXBUF_LOADER, gxg_GDK_IS_PIXBUF_LOADER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VBOX, gxg_GTK_IS_VBOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ACCEL_GROUP, gxg_GTK_IS_ACCEL_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ACCEL_LABEL, gxg_GTK_IS_ACCEL_LABEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ACCESSIBLE, gxg_GTK_IS_ACCESSIBLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ADJUSTMENT, gxg_GTK_IS_ADJUSTMENT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ALIGNMENT, gxg_GTK_IS_ALIGNMENT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ARROW, gxg_GTK_IS_ARROW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ASPECT_FRAME, gxg_GTK_IS_ASPECT_FRAME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_BUTTON_BOX, gxg_GTK_IS_BUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_BIN, gxg_GTK_IS_BIN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_BOX, gxg_GTK_IS_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_BUTTON, gxg_GTK_IS_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CALENDAR, gxg_GTK_IS_CALENDAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_EDITABLE, gxg_GTK_IS_CELL_EDITABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER, gxg_GTK_IS_CELL_RENDERER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER_PIXBUF, gxg_GTK_IS_CELL_RENDERER_PIXBUF, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER_TEXT, gxg_GTK_IS_CELL_RENDERER_TEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER_TOGGLE, gxg_GTK_IS_CELL_RENDERER_TOGGLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CHECK_BUTTON, gxg_GTK_IS_CHECK_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CHECK_MENU_ITEM, gxg_GTK_IS_CHECK_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_COLOR_SELECTION_DIALOG, gxg_GTK_IS_COLOR_SELECTION_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_COLOR_SELECTION, gxg_GTK_IS_COLOR_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CONTAINER, gxg_GTK_IS_CONTAINER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CURVE, gxg_GTK_IS_CURVE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_DIALOG, gxg_GTK_IS_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_DRAWING_AREA, gxg_GTK_IS_DRAWING_AREA, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_EDITABLE, gxg_GTK_IS_EDITABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ENTRY, gxg_GTK_IS_ENTRY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_EVENT_BOX, gxg_GTK_IS_EVENT_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_SELECTION, gxg_GTK_IS_FILE_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FIXED, gxg_GTK_IS_FIXED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FONT_SELECTION, gxg_GTK_IS_FONT_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FONT_SELECTION_DIALOG, gxg_GTK_IS_FONT_SELECTION_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FRAME, gxg_GTK_IS_FRAME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_GAMMA_CURVE, gxg_GTK_IS_GAMMA_CURVE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HANDLE_BOX, gxg_GTK_IS_HANDLE_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HBUTTON_BOX, gxg_GTK_IS_HBUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HBOX, gxg_GTK_IS_HBOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HPANED, gxg_GTK_IS_HPANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HRULER, gxg_GTK_IS_HRULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HSCALE, gxg_GTK_IS_HSCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HSCROLLBAR, gxg_GTK_IS_HSCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_HSEPARATOR, gxg_GTK_IS_HSEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ICON_FACTORY, gxg_GTK_IS_ICON_FACTORY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_IMAGE, gxg_GTK_IS_IMAGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_IMAGE_MENU_ITEM, gxg_GTK_IS_IMAGE_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_IM_CONTEXT, gxg_GTK_IS_IM_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_IM_CONTEXT_SIMPLE, gxg_GTK_IS_IM_CONTEXT_SIMPLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_IM_MULTICONTEXT, gxg_GTK_IS_IM_MULTICONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_INPUT_DIALOG, gxg_GTK_IS_INPUT_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_INVISIBLE, gxg_GTK_IS_INVISIBLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ITEM, gxg_GTK_IS_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_LABEL, gxg_GTK_IS_LABEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_LAYOUT, gxg_GTK_IS_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_LIST_STORE, gxg_GTK_IS_LIST_STORE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MENU_BAR, gxg_GTK_IS_MENU_BAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MENU, gxg_GTK_IS_MENU, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MENU_ITEM, gxg_GTK_IS_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MENU_SHELL, gxg_GTK_IS_MENU_SHELL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MESSAGE_DIALOG, gxg_GTK_IS_MESSAGE_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_MISC, gxg_GTK_IS_MISC, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_NOTEBOOK, gxg_GTK_IS_NOTEBOOK, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_OBJECT, gxg_GTK_IS_OBJECT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_PANED, gxg_GTK_IS_PANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_PLUG, gxg_GTK_IS_PLUG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_PROGRESS_BAR, gxg_GTK_IS_PROGRESS_BAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RADIO_BUTTON, gxg_GTK_IS_RADIO_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RADIO_MENU_ITEM, gxg_GTK_IS_RADIO_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RANGE, gxg_GTK_IS_RANGE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RC_STYLE, gxg_GTK_IS_RC_STYLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RULER, gxg_GTK_IS_RULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SCALE, gxg_GTK_IS_SCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SCROLLBAR, gxg_GTK_IS_SCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SCROLLED_WINDOW, gxg_GTK_IS_SCROLLED_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SEPARATOR, gxg_GTK_IS_SEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SEPARATOR_MENU_ITEM, gxg_GTK_IS_SEPARATOR_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SIZE_GROUP, gxg_GTK_IS_SIZE_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SOCKET, gxg_GTK_IS_SOCKET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SPIN_BUTTON, gxg_GTK_IS_SPIN_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_STATUSBAR, gxg_GTK_IS_STATUSBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_STYLE, gxg_GTK_IS_STYLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TABLE, gxg_GTK_IS_TABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEAROFF_MENU_ITEM, gxg_GTK_IS_TEAROFF_MENU_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_BUFFER, gxg_GTK_IS_TEXT_BUFFER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_CHILD_ANCHOR, gxg_GTK_IS_TEXT_CHILD_ANCHOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_MARK, gxg_GTK_IS_TEXT_MARK, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_TAG, gxg_GTK_IS_TEXT_TAG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_TAG_TABLE, gxg_GTK_IS_TEXT_TAG_TABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TEXT_VIEW, gxg_GTK_IS_TEXT_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOGGLE_BUTTON, gxg_GTK_IS_TOGGLE_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOOLBAR, gxg_GTK_IS_TOOLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOOLTIPS, gxg_GTK_IS_TOOLTIPS, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_DRAG_SOURCE, gxg_GTK_IS_TREE_DRAG_SOURCE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_DRAG_DEST, gxg_GTK_IS_TREE_DRAG_DEST, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_MODEL, gxg_GTK_IS_TREE_MODEL, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_MODEL_SORT, gxg_GTK_IS_TREE_MODEL_SORT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_SELECTION, gxg_GTK_IS_TREE_SELECTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_SORTABLE, gxg_GTK_IS_TREE_SORTABLE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_STORE, gxg_GTK_IS_TREE_STORE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_VIEW_COLUMN, gxg_GTK_IS_TREE_VIEW_COLUMN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_VIEW, gxg_GTK_IS_TREE_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VBUTTON_BOX, gxg_GTK_IS_VBUTTON_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VIEWPORT, gxg_GTK_IS_VIEWPORT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VPANED, gxg_GTK_IS_VPANED, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VRULER, gxg_GTK_IS_VRULER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VSCALE, gxg_GTK_IS_VSCALE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VSCROLLBAR, gxg_GTK_IS_VSCROLLBAR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_VSEPARATOR, gxg_GTK_IS_VSEPARATOR, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_WIDGET, gxg_GTK_IS_WIDGET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_WINDOW, gxg_GTK_IS_WINDOW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_CONTEXT, gxg_PANGO_IS_CONTEXT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_FONT_FAMILY, gxg_PANGO_IS_FONT_FAMILY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_FONT_FACE, gxg_PANGO_IS_FONT_FACE, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_FONT, gxg_PANGO_IS_FONT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_FONT_MAP, gxg_PANGO_IS_FONT_MAP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_LAYOUT, gxg_PANGO_IS_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(G_IS_OBJECT, gxg_G_IS_OBJECT, 1, 0, 0, NULL);
#if HAVE_GDK_DRAW_PIXBUF
  XG_DEFINE_PROCEDURE(GDK_IS_SCREEN, gxg_GDK_IS_SCREEN, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GDK_IS_DISPLAY, gxg_GDK_IS_DISPLAY, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_CHOOSER_DIALOG, gxg_GTK_IS_FILE_CHOOSER_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_CHOOSER_WIDGET, gxg_GTK_IS_FILE_CHOOSER_WIDGET, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TREE_MODEL_FILTER, gxg_GTK_IS_TREE_MODEL_FILTER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ACTION, gxg_GTK_IS_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ACTION_GROUP, gxg_GTK_IS_ACTION_GROUP, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_COMBO_BOX, gxg_GTK_IS_COMBO_BOX, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_COMBO_BOX_ENTRY, gxg_GTK_IS_COMBO_BOX_ENTRY, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_EXPANDER, gxg_GTK_IS_EXPANDER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FONT_BUTTON, gxg_GTK_IS_FONT_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_COLOR_BUTTON, gxg_GTK_IS_COLOR_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ENTRY_COMPLETION, gxg_GTK_IS_ENTRY_COMPLETION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_UI_MANAGER, gxg_GTK_IS_UI_MANAGER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RADIO_TOOL_BUTTON, gxg_GTK_IS_RADIO_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_RADIO_ACTION, gxg_GTK_IS_RADIO_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_SEPARATOR_TOOL_ITEM, gxg_GTK_IS_SEPARATOR_TOOL_ITEM, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOGGLE_ACTION, gxg_GTK_IS_TOGGLE_ACTION, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOGGLE_TOOL_BUTTON, gxg_GTK_IS_TOGGLE_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_FILTER, gxg_GTK_IS_FILE_FILTER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_LAYOUT, gxg_GTK_IS_CELL_LAYOUT, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CLIPBOARD, gxg_GTK_IS_CLIPBOARD, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_CHOOSER, gxg_GTK_IS_FILE_CHOOSER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ICON_THEME, gxg_GTK_IS_ICON_THEME, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOOL_BUTTON, gxg_GTK_IS_TOOL_BUTTON, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_TOOL_ITEM, gxg_GTK_IS_TOOL_ITEM, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
  XG_DEFINE_PROCEDURE(GTK_IS_ACCEL_MAP, gxg_GTK_IS_ACCEL_MAP, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_VIEW, gxg_GTK_IS_CELL_VIEW, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ABOUT_DIALOG, gxg_GTK_IS_ABOUT_DIALOG, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER_COMBO, gxg_GTK_IS_CELL_RENDERER_COMBO, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_CELL_RENDERER_PROGRESS, gxg_GTK_IS_CELL_RENDERER_PROGRESS, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GTK_IS_ICON_VIEW, gxg_GTK_IS_ICON_VIEW, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
  XG_DEFINE_PROCEDURE(GTK_IS_FILE_CHOOSER_BUTTON, gxg_GTK_IS_FILE_CHOOSER_BUTTON, 1, 0, 0, NULL);
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
  XG_DEFINE_PROCEDURE(GTK_IS_MENU_TOOL_BUTTON, gxg_GTK_IS_MENU_TOOL_BUTTON, 1, 0, 0, NULL);
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
  XG_DEFINE_PROCEDURE(GDK_IS_PANGO_RENDERER, gxg_GDK_IS_PANGO_RENDERER, 1, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PANGO_IS_RENDERER, gxg_PANGO_IS_RENDERER, 1, 0, 0, NULL);
#endif

}

#endif
/* ---------------------------------------- structs ---------------------------------------- */

  #define XG_DEFINE_READER(Name, Value, A1, A2, A3, Help) XEN_DEFINE_PROCEDURE(XG_FIELD_PRE #Name XG_POST, Value, A1, A2, A3, Help)
  #if HAVE_RUBY
  #define XG_DEFINE_ACCESSOR(Name, Value, SetValue, A1, A2, A3, A4) \
    XEN_DEFINE_PROCEDURE_WITH_SETTER(XG_FIELD_PRE #Name XG_POST, Value, NULL, XG_FIELD_PRE "set_" #Name XG_POST, SetValue, A1, A2, A3, A4)
  #else
  #define XG_DEFINE_ACCESSOR(Name, Value, SetValue, A1, A2, A3, A4) \
    XEN_DEFINE_PROCEDURE_WITH_SETTER(XG_FIELD_PRE #Name XG_POST, Value, NULL, "set! " XG_FIELD_PRE #Name XG_POST, SetValue, A1, A2, A3, A4)
  #endif

/* conversions */
static XEN c_array_to_xen_list(XEN val_1, XEN clen)
{
  XEN result = XEN_EMPTY_LIST;
  XEN val;
  int i, len = -1;
  char *ctype;
  if (XEN_INTEGER_P(clen))
    len = XEN_TO_C_INT(clen);
  if (!(XEN_LIST_P(val_1))) return(XEN_FALSE); /* type:location cons */
  val = XEN_COPY_ARG(val_1); /* protect Ruby arg */
  ctype = XEN_SYMBOL_TO_C_STRING(XEN_CAR(val));
  if (strcmp(ctype, "gint_") == 0)
    {
      gint* arr; arr = (gint*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gint(arr[i]), result);
    }
  if (strcmp(ctype, "gboolean_") == 0)
    {
      gboolean* arr; arr = (gboolean*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gboolean(arr[i]), result);
    }
  if (strcmp(ctype, "GType_") == 0)
    {
      GType* arr; arr = (GType*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GType(arr[i]), result);
    }
  if (strcmp(ctype, "guint_") == 0)
    {
      guint* arr; arr = (guint*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_guint(arr[i]), result);
    }
  if (strcmp(ctype, "gint8_") == 0)
    {
      gint8* arr; arr = (gint8*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gint8(arr[i]), result);
    }
  if (strcmp(ctype, "gchar__") == 0)
    {
      gchar** arr; arr = (gchar**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gchar_(arr[i]), result);
    }
  if (strcmp(ctype, "gdouble_") == 0)
    {
      gdouble* arr; arr = (gdouble*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gdouble(arr[i]), result);
    }
  if (strcmp(ctype, "guchar_") == 0)
    {
      guchar* arr; arr = (guchar*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_guchar(arr[i]), result);
    }
  if (strcmp(ctype, "guint32_") == 0)
    {
      guint32* arr; arr = (guint32*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_guint32(arr[i]), result);
    }
  if (strcmp(ctype, "GdkVisualType_") == 0)
    {
      GdkVisualType* arr; arr = (GdkVisualType*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GdkVisualType(arr[i]), result);
    }
  if (strcmp(ctype, "char__") == 0)
    {
      char** arr; arr = (char**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_char_(arr[i]), result);
    }
  if (strcmp(ctype, "guint8_") == 0)
    {
      guint8* arr; arr = (guint8*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_guint8(arr[i]), result);
    }
  if (strcmp(ctype, "gfloat_") == 0)
    {
      gfloat* arr; arr = (gfloat*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gfloat(arr[i]), result);
    }
  if (strcmp(ctype, "GtkIconSize_") == 0)
    {
      GtkIconSize* arr; arr = (GtkIconSize*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GtkIconSize(arr[i]), result);
    }
  if (strcmp(ctype, "guint16_") == 0)
    {
      guint16* arr; arr = (guint16*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_guint16(arr[i]), result);
    }
  if (strcmp(ctype, "gunichar_") == 0)
    {
      gunichar* arr; arr = (gunichar*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_gunichar(arr[i]), result);
    }
  if (strcmp(ctype, "int_") == 0)
    {
      int* arr; arr = (int*)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_int(arr[i]), result);
    }
  if (strcmp(ctype, "GdkPixmap__") == 0)
    {
      GdkPixmap** arr; arr = (GdkPixmap**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GdkPixmap_(arr[i]), result);
    }
  if (strcmp(ctype, "GdkGC__") == 0)
    {
      GdkGC** arr; arr = (GdkGC**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GdkGC_(arr[i]), result);
    }
  if (strcmp(ctype, "PangoFontFace__") == 0)
    {
      PangoFontFace** arr; arr = (PangoFontFace**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_PangoFontFace_(arr[i]), result);
    }
  if (strcmp(ctype, "PangoFontDescription__") == 0)
    {
      PangoFontDescription** arr; arr = (PangoFontDescription**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_PangoFontDescription_(arr[i]), result);
    }
  if (strcmp(ctype, "PangoFontFamily__") == 0)
    {
      PangoFontFamily** arr; arr = (PangoFontFamily**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_PangoFontFamily_(arr[i]), result);
    }
  if (strcmp(ctype, "PangoAttrList__") == 0)
    {
      PangoAttrList** arr; arr = (PangoAttrList**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_PangoAttrList_(arr[i]), result);
    }
  if (strcmp(ctype, "GtkTreeModel__") == 0)
    {
      GtkTreeModel** arr; arr = (GtkTreeModel**)XEN_TO_C_ULONG(XEN_CADR(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++); len = i;}
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_GtkTreeModel_(arr[i]), result);
    }
  if (strcmp(ctype, "GList_") == 0)
    { /* tagging these pointers is currently up to the caller */
      GList* lst;
      lst = (GList*)XEN_TO_C_ULONG(XEN_CADR(val));
      len = g_list_length(lst);
      for (i = len - 1; i >= 0; i--) result = XEN_CONS(C_TO_XEN_ULONG(g_list_nth_data(lst, i)), result);
    }
  return(result);
}

static XEN xen_list_to_c_array(XEN val, XEN type)
{
  int i, len;
  char *ctype;
  len = XEN_LIST_LENGTH(val);
  ctype = XEN_TO_C_STRING(type);
  if (strcmp(ctype, "gint*") == 0)
    {
      gint* arr; arr = (gint*)CALLOC(len + 1, sizeof(gint));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gint(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gint_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gboolean*") == 0)
    {
      gboolean* arr; arr = (gboolean*)CALLOC(len + 1, sizeof(gboolean));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gboolean(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gboolean_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GType*") == 0)
    {
      GType* arr; arr = (GType*)CALLOC(len + 1, sizeof(GType));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GType(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GType_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "guint*") == 0)
    {
      guint* arr; arr = (guint*)CALLOC(len + 1, sizeof(guint));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_guint(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("guint_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gint8*") == 0)
    {
      gint8* arr; arr = (gint8*)CALLOC(len + 1, sizeof(gint8));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gint8(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gint8_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gchar**") == 0)
    {
      gchar** arr; arr = (gchar**)CALLOC(len + 1, sizeof(gchar*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gchar_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gchar__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gdouble*") == 0)
    {
      gdouble* arr; arr = (gdouble*)CALLOC(len + 1, sizeof(gdouble));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gdouble(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gdouble_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "guchar*") == 0)
    {
      guchar* arr; arr = (guchar*)CALLOC(len + 1, sizeof(guchar));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_guchar(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("guchar_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "guint32*") == 0)
    {
      guint32* arr; arr = (guint32*)CALLOC(len + 1, sizeof(guint32));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_guint32(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("guint32_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GdkVisualType*") == 0)
    {
      GdkVisualType* arr; arr = (GdkVisualType*)CALLOC(len + 1, sizeof(GdkVisualType));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GdkVisualType(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkVisualType_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "char**") == 0)
    {
      char** arr; arr = (char**)CALLOC(len + 1, sizeof(char*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_char_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("char__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "guint8*") == 0)
    {
      guint8* arr; arr = (guint8*)CALLOC(len + 1, sizeof(guint8));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_guint8(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("guint8_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gfloat*") == 0)
    {
      gfloat* arr; arr = (gfloat*)CALLOC(len + 1, sizeof(gfloat));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gfloat(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gfloat_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GtkIconSize*") == 0)
    {
      GtkIconSize* arr; arr = (GtkIconSize*)CALLOC(len + 1, sizeof(GtkIconSize));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GtkIconSize(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkIconSize_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "guint16*") == 0)
    {
      guint16* arr; arr = (guint16*)CALLOC(len + 1, sizeof(guint16));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_guint16(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("guint16_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "gunichar*") == 0)
    {
      gunichar* arr; arr = (gunichar*)CALLOC(len + 1, sizeof(gunichar));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_gunichar(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("gunichar_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "int*") == 0)
    {
      int* arr; arr = (int*)CALLOC(len + 1, sizeof(int));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_int(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("int_"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GdkPixmap**") == 0)
    {
      GdkPixmap** arr; arr = (GdkPixmap**)CALLOC(len + 1, sizeof(GdkPixmap*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GdkPixmap_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkPixmap__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GdkGC**") == 0)
    {
      GdkGC** arr; arr = (GdkGC**)CALLOC(len + 1, sizeof(GdkGC*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GdkGC_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkGC__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "PangoFontFace**") == 0)
    {
      PangoFontFace** arr; arr = (PangoFontFace**)CALLOC(len + 1, sizeof(PangoFontFace*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_PangoFontFace_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoFontFace__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "PangoFontDescription**") == 0)
    {
      PangoFontDescription** arr; arr = (PangoFontDescription**)CALLOC(len + 1, sizeof(PangoFontDescription*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_PangoFontDescription_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoFontDescription__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "PangoFontFamily**") == 0)
    {
      PangoFontFamily** arr; arr = (PangoFontFamily**)CALLOC(len + 1, sizeof(PangoFontFamily*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_PangoFontFamily_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoFontFamily__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "PangoAttrList**") == 0)
    {
      PangoAttrList** arr; arr = (PangoAttrList**)CALLOC(len + 1, sizeof(PangoAttrList*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_PangoAttrList_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoAttrList__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  if (strcmp(ctype, "GtkTreeModel**") == 0)
    {
      GtkTreeModel** arr; arr = (GtkTreeModel**)CALLOC(len + 1, sizeof(GtkTreeModel*));
      for (i = 0; i < len; i++, val = XEN_CDR(val)) arr[i] = XEN_TO_C_GtkTreeModel_(XEN_CAR(val));
      return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkTreeModel__"), C_TO_XEN_ULONG((unsigned long)arr), make_xm_obj(arr)));
    }
  return(XEN_FALSE);
}


static XEN gxg_size(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(ptr), ptr, XEN_ONLY_ARG, "size", "GdkColormap");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkColormap_(ptr))->size)));
}

static XEN gxg_colors(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColormap__P(ptr) || XEN_GdkRgbCmap__P(ptr), ptr, XEN_ONLY_ARG, "colors", "GdkColormap" " or " "GdkRgbCmap");
  if (XEN_GdkColormap__P(ptr)) return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GdkColormap_(ptr))->colors)));
  return(C_TO_XEN_guint32_((guint32*)((XEN_TO_C_GdkRgbCmap_(ptr))->colors)));
}

gxg_static XEN gxg_visual(XEN ptr)
{
  if (XEN_GdkColormap__P(ptr)) return(C_TO_XEN_GdkVisual_((GdkVisual*)((XEN_TO_C_GdkColormap_(ptr))->visual)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_GdkVisual_((GdkVisual*)((XEN_TO_C_GdkImage_(ptr))->visual)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_GdkVisual_((GdkVisual*)((XEN_TO_C_GdkWindowAttr_(ptr))->visual)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "visual", "pointer to struct with visual field");
}

static XEN gxg_windowing_data(XEN ptr)
{
  if (XEN_GdkColormap__P(ptr)) return(C_TO_XEN_gpointer((gpointer)((XEN_TO_C_GdkColormap_(ptr))->windowing_data)));
  if (XEN_GdkDragContext__P(ptr)) return(C_TO_XEN_gpointer((gpointer)((XEN_TO_C_GdkDragContext_(ptr))->windowing_data)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_gpointer((gpointer)((XEN_TO_C_GdkImage_(ptr))->windowing_data)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "windowing_data", "pointer to struct with windowing_data field");
}

gxg_static XEN gxg_type(XEN ptr)
{
  if (XEN_GdkCursor__P(ptr)) return(C_TO_XEN_GdkCursorType((GdkCursorType)((XEN_TO_C_GdkCursor_(ptr))->type)));
  if (XEN_GdkEventAny__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventAny_(ptr))->type)));
  if (XEN_GdkEventExpose__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventExpose_(ptr))->type)));
  if (XEN_GdkEventNoExpose__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventNoExpose_(ptr))->type)));
  if (XEN_GdkEventVisibility__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventVisibility_(ptr))->type)));
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventMotion_(ptr))->type)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventButton_(ptr))->type)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventScroll_(ptr))->type)));
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventKey_(ptr))->type)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventCrossing_(ptr))->type)));
  if (XEN_GdkEventFocus__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventFocus_(ptr))->type)));
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventConfigure_(ptr))->type)));
  if (XEN_GdkEventProperty__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventProperty_(ptr))->type)));
  if (XEN_GdkEventSelection__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventSelection_(ptr))->type)));
  if (XEN_GdkEventProximity__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventProximity_(ptr))->type)));
  if (XEN_GdkEventSetting__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventSetting_(ptr))->type)));
  if (XEN_GdkEventWindowState__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventWindowState_(ptr))->type)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_GdkEventType((GdkEventType)((XEN_TO_C_GdkEventDND_(ptr))->type)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_GdkImageType((GdkImageType)((XEN_TO_C_GdkImage_(ptr))->type)));
  if (XEN_GdkVisual__P(ptr)) return(C_TO_XEN_GdkVisualType((GdkVisualType)((XEN_TO_C_GdkVisual_(ptr))->type)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "type", "pointer to struct with type field");
}

static XEN gxg_ref_count(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkCursor__P(ptr), ptr, XEN_ONLY_ARG, "ref_count", "GdkCursor");
  return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkCursor_(ptr))->ref_count)));
}

static XEN gxg_protocol(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "protocol", "GdkDragContext");
  return(C_TO_XEN_GdkDragProtocol((GdkDragProtocol)((XEN_TO_C_GdkDragContext_(ptr))->protocol)));
}

static XEN gxg_is_source(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "is_source", "GdkDragContext");
  return(C_TO_XEN_gboolean((gboolean)((XEN_TO_C_GdkDragContext_(ptr))->is_source)));
}

static XEN gxg_source_window(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "source_window", "GdkDragContext");
  return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkDragContext_(ptr))->source_window)));
}

static XEN gxg_dest_window(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "dest_window", "GdkDragContext");
  return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkDragContext_(ptr))->dest_window)));
}

static XEN gxg_targets(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "targets", "GdkDragContext");
  return(C_TO_XEN_GList_((GList*)((XEN_TO_C_GdkDragContext_(ptr))->targets)));
}

static XEN gxg_actions(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "actions", "GdkDragContext");
  return(C_TO_XEN_GdkDragAction((GdkDragAction)((XEN_TO_C_GdkDragContext_(ptr))->actions)));
}

static XEN gxg_suggested_action(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "suggested_action", "GdkDragContext");
  return(C_TO_XEN_GdkDragAction((GdkDragAction)((XEN_TO_C_GdkDragContext_(ptr))->suggested_action)));
}

static XEN gxg_action(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr) || XEN_GdkEventSetting__P(ptr), ptr, XEN_ONLY_ARG, "action", "GdkDragContext" " or " "GdkEventSetting");
  if (XEN_GdkDragContext__P(ptr)) return(C_TO_XEN_GdkDragAction((GdkDragAction)((XEN_TO_C_GdkDragContext_(ptr))->action)));
  return(C_TO_XEN_GdkSettingAction((GdkSettingAction)((XEN_TO_C_GdkEventSetting_(ptr))->action)));
}

static XEN gxg_start_time(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDragContext__P(ptr), ptr, XEN_ONLY_ARG, "start_time", "GdkDragContext");
  return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkDragContext_(ptr))->start_time)));
}

gxg_static XEN gxg_window(XEN ptr)
{
  if (XEN_GdkEventAny__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventAny_(ptr))->window)));
  if (XEN_GdkEventExpose__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventExpose_(ptr))->window)));
  if (XEN_GdkEventNoExpose__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventNoExpose_(ptr))->window)));
  if (XEN_GdkEventVisibility__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventVisibility_(ptr))->window)));
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventMotion_(ptr))->window)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventButton_(ptr))->window)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventScroll_(ptr))->window)));
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventKey_(ptr))->window)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventCrossing_(ptr))->window)));
  if (XEN_GdkEventFocus__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventFocus_(ptr))->window)));
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventConfigure_(ptr))->window)));
  if (XEN_GdkEventProperty__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventProperty_(ptr))->window)));
  if (XEN_GdkEventSelection__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventSelection_(ptr))->window)));
  if (XEN_GdkEventProximity__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventProximity_(ptr))->window)));
  if (XEN_GdkEventSetting__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventSetting_(ptr))->window)));
  if (XEN_GdkEventWindowState__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventWindowState_(ptr))->window)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventDND_(ptr))->window)));
  if (XEN_GtkWidget__P(ptr)) return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GtkWidget_(ptr))->window)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "window", "pointer to struct with window field");
}

gxg_static XEN gxg_send_event(XEN ptr)
{
  if (XEN_GdkEventAny__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventAny_(ptr))->send_event)));
  if (XEN_GdkEventExpose__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventExpose_(ptr))->send_event)));
  if (XEN_GdkEventNoExpose__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventNoExpose_(ptr))->send_event)));
  if (XEN_GdkEventVisibility__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventVisibility_(ptr))->send_event)));
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventMotion_(ptr))->send_event)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventButton_(ptr))->send_event)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventScroll_(ptr))->send_event)));
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventKey_(ptr))->send_event)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventCrossing_(ptr))->send_event)));
  if (XEN_GdkEventFocus__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventFocus_(ptr))->send_event)));
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventConfigure_(ptr))->send_event)));
  if (XEN_GdkEventProperty__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventProperty_(ptr))->send_event)));
  if (XEN_GdkEventSelection__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventSelection_(ptr))->send_event)));
  if (XEN_GdkEventProximity__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventProximity_(ptr))->send_event)));
  if (XEN_GdkEventSetting__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventSetting_(ptr))->send_event)));
  if (XEN_GdkEventWindowState__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventWindowState_(ptr))->send_event)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_gint8((gint8)((XEN_TO_C_GdkEventDND_(ptr))->send_event)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "send_event", "pointer to struct with send_event field");
}

static XEN gxg_region(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventExpose__P(ptr), ptr, XEN_ONLY_ARG, "region", "GdkEventExpose");
  return(C_TO_XEN_GdkRegion_((GdkRegion*)((XEN_TO_C_GdkEventExpose_(ptr))->region)));
}

gxg_static XEN gxg_count(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventExpose__P(ptr), ptr, XEN_ONLY_ARG, "count", "GdkEventExpose");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventExpose_(ptr))->count)));
}

gxg_static XEN gxg_state(XEN ptr)
{
  if (XEN_GdkEventVisibility__P(ptr)) return(C_TO_XEN_GdkVisibilityState((GdkVisibilityState)((XEN_TO_C_GdkEventVisibility_(ptr))->state)));
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventMotion_(ptr))->state)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventButton_(ptr))->state)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventScroll_(ptr))->state)));
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventKey_(ptr))->state)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventCrossing_(ptr))->state)));
  if (XEN_GdkEventProperty__P(ptr)) return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventProperty_(ptr))->state)));
  if (XEN_GtkWidget__P(ptr)) return(C_TO_XEN_guint8((guint8)((XEN_TO_C_GtkWidget_(ptr))->state)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "state", "pointer to struct with state field");
}

gxg_static XEN gxg_time(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventMotion_(ptr))->time)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventButton_(ptr))->time)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventScroll_(ptr))->time)));
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventKey_(ptr))->time)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventCrossing_(ptr))->time)));
  if (XEN_GdkEventProperty__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventProperty_(ptr))->time)));
  if (XEN_GdkEventSelection__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventSelection_(ptr))->time)));
  if (XEN_GdkEventProximity__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventProximity_(ptr))->time)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkEventDND_(ptr))->time)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "time", "pointer to struct with time field");
}

gxg_static XEN gxg_x(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventMotion_(ptr))->x)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventButton_(ptr))->x)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventScroll_(ptr))->x)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventCrossing_(ptr))->x)));
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventConfigure_(ptr))->x)));
  if (XEN_GdkPoint__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkPoint_(ptr))->x)));
  if (XEN_GdkRectangle__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkRectangle_(ptr))->x)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkWindowAttr_(ptr))->x)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "x", "pointer to struct with x field");
}

gxg_static XEN gxg_y(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventMotion_(ptr))->y)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventButton_(ptr))->y)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventScroll_(ptr))->y)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventCrossing_(ptr))->y)));
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventConfigure_(ptr))->y)));
  if (XEN_GdkPoint__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkPoint_(ptr))->y)));
  if (XEN_GdkRectangle__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkRectangle_(ptr))->y)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkWindowAttr_(ptr))->y)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "y", "pointer to struct with y field");
}

static XEN gxg_axes(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gdouble_((gdouble*)((XEN_TO_C_GdkEventMotion_(ptr))->axes)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gdouble_((gdouble*)((XEN_TO_C_GdkEventButton_(ptr))->axes)));
  if (XEN_GdkDevice__P(ptr)) return(C_TO_XEN_GdkDeviceAxis_((GdkDeviceAxis*)((XEN_TO_C_GdkDevice_(ptr))->axes)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "axes", "pointer to struct with axes field");
}

gxg_static XEN gxg_is_hint(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventMotion__P(ptr), ptr, XEN_ONLY_ARG, "is_hint", "GdkEventMotion");
  return(C_TO_XEN_gint16((gint16)((XEN_TO_C_GdkEventMotion_(ptr))->is_hint)));
}

static XEN gxg_device(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_GdkDevice_((GdkDevice*)((XEN_TO_C_GdkEventMotion_(ptr))->device)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_GdkDevice_((GdkDevice*)((XEN_TO_C_GdkEventButton_(ptr))->device)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_GdkDevice_((GdkDevice*)((XEN_TO_C_GdkEventScroll_(ptr))->device)));
  if (XEN_GdkEventProximity__P(ptr)) return(C_TO_XEN_GdkDevice_((GdkDevice*)((XEN_TO_C_GdkEventProximity_(ptr))->device)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "device", "pointer to struct with device field");
}

gxg_static XEN gxg_x_root(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventMotion_(ptr))->x_root)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventButton_(ptr))->x_root)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventScroll_(ptr))->x_root)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventCrossing_(ptr))->x_root)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_gshort((gshort)((XEN_TO_C_GdkEventDND_(ptr))->x_root)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "x_root", "pointer to struct with x_root field");
}

gxg_static XEN gxg_y_root(XEN ptr)
{
  if (XEN_GdkEventMotion__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventMotion_(ptr))->y_root)));
  if (XEN_GdkEventButton__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventButton_(ptr))->y_root)));
  if (XEN_GdkEventScroll__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventScroll_(ptr))->y_root)));
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkEventCrossing_(ptr))->y_root)));
  if (XEN_GdkEventDND__P(ptr)) return(C_TO_XEN_gshort((gshort)((XEN_TO_C_GdkEventDND_(ptr))->y_root)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "y_root", "pointer to struct with y_root field");
}

gxg_static XEN gxg_button(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventButton__P(ptr), ptr, XEN_ONLY_ARG, "button", "GdkEventButton");
  return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventButton_(ptr))->button)));
}

static XEN gxg_direction(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventScroll__P(ptr), ptr, XEN_ONLY_ARG, "direction", "GdkEventScroll");
  return(C_TO_XEN_GdkScrollDirection((GdkScrollDirection)((XEN_TO_C_GdkEventScroll_(ptr))->direction)));
}

static XEN gxg_keyval(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(ptr), ptr, XEN_ONLY_ARG, "keyval", "GdkEventKey");
  return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkEventKey_(ptr))->keyval)));
}

static XEN gxg_length(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(ptr), ptr, XEN_ONLY_ARG, "length", "GdkEventKey");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventKey_(ptr))->length)));
}

static XEN gxg_string(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(ptr), ptr, XEN_ONLY_ARG, "string", "GdkEventKey");
  return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GdkEventKey_(ptr))->string)));
}

static XEN gxg_hardware_keycode(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(ptr), ptr, XEN_ONLY_ARG, "hardware_keycode", "GdkEventKey");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkEventKey_(ptr))->hardware_keycode)));
}

static XEN gxg_group(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventKey__P(ptr) || XEN_GdkKeymapKey__P(ptr), ptr, XEN_ONLY_ARG, "group", "GdkEventKey" " or " "GdkKeymapKey");
  if (XEN_GdkEventKey__P(ptr)) return(C_TO_XEN_guint8((guint8)((XEN_TO_C_GdkEventKey_(ptr))->group)));
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkKeymapKey_(ptr))->group)));
}

gxg_static XEN gxg_subwindow(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventCrossing__P(ptr), ptr, XEN_ONLY_ARG, "subwindow", "GdkEventCrossing");
  return(C_TO_XEN_GdkWindow_((GdkWindow*)((XEN_TO_C_GdkEventCrossing_(ptr))->subwindow)));
}

gxg_static XEN gxg_mode(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventCrossing__P(ptr) || XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "mode", "GdkEventCrossing" " or " "GdkDevice");
  if (XEN_GdkEventCrossing__P(ptr)) return(C_TO_XEN_GdkCrossingMode((GdkCrossingMode)((XEN_TO_C_GdkEventCrossing_(ptr))->mode)));
  return(C_TO_XEN_GdkInputMode((GdkInputMode)((XEN_TO_C_GdkDevice_(ptr))->mode)));
}

gxg_static XEN gxg_detail(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventCrossing__P(ptr), ptr, XEN_ONLY_ARG, "detail", "GdkEventCrossing");
  return(C_TO_XEN_GdkNotifyType((GdkNotifyType)((XEN_TO_C_GdkEventCrossing_(ptr))->detail)));
}

gxg_static XEN gxg_focus(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventCrossing__P(ptr), ptr, XEN_ONLY_ARG, "focus", "GdkEventCrossing");
  return(C_TO_XEN_gboolean((gboolean)((XEN_TO_C_GdkEventCrossing_(ptr))->focus)));
}

static XEN gxg_in(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventFocus__P(ptr), ptr, XEN_ONLY_ARG, "in", "GdkEventFocus");
  return(C_TO_XEN_gint16((gint16)((XEN_TO_C_GdkEventFocus_(ptr))->in)));
}

gxg_static XEN gxg_width(XEN ptr)
{
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventConfigure_(ptr))->width)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkImage_(ptr))->width)));
  if (XEN_GdkRectangle__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkRectangle_(ptr))->width)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkWindowAttr_(ptr))->width)));
  if (XEN_GtkRequisition__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkRequisition_(ptr))->width)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "width", "pointer to struct with width field");
}

gxg_static XEN gxg_height(XEN ptr)
{
  if (XEN_GdkEventConfigure__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkEventConfigure_(ptr))->height)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkImage_(ptr))->height)));
  if (XEN_GdkRectangle__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkRectangle_(ptr))->height)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkWindowAttr_(ptr))->height)));
  if (XEN_GtkRequisition__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkRequisition_(ptr))->height)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "height", "pointer to struct with height field");
}

gxg_static XEN gxg_atom(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventProperty__P(ptr), ptr, XEN_ONLY_ARG, "atom", "GdkEventProperty");
  return(C_TO_XEN_GdkAtom((GdkAtom)((XEN_TO_C_GdkEventProperty_(ptr))->atom)));
}

gxg_static XEN gxg_selection(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventSelection__P(ptr), ptr, XEN_ONLY_ARG, "selection", "GdkEventSelection");
  return(C_TO_XEN_GdkAtom((GdkAtom)((XEN_TO_C_GdkEventSelection_(ptr))->selection)));
}

gxg_static XEN gxg_target(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventSelection__P(ptr), ptr, XEN_ONLY_ARG, "target", "GdkEventSelection");
  return(C_TO_XEN_GdkAtom((GdkAtom)((XEN_TO_C_GdkEventSelection_(ptr))->target)));
}

gxg_static XEN gxg_property(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventSelection__P(ptr), ptr, XEN_ONLY_ARG, "property", "GdkEventSelection");
  return(C_TO_XEN_GdkAtom((GdkAtom)((XEN_TO_C_GdkEventSelection_(ptr))->property)));
}

gxg_static XEN gxg_requestor(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventSelection__P(ptr), ptr, XEN_ONLY_ARG, "requestor", "GdkEventSelection");
  return(C_TO_XEN_GdkNativeWindow((GdkNativeWindow)((XEN_TO_C_GdkEventSelection_(ptr))->requestor)));
}

gxg_static XEN gxg_name(XEN ptr)
{
  if (XEN_GdkEventSetting__P(ptr)) return(C_TO_XEN_char_((char*)((XEN_TO_C_GdkEventSetting_(ptr))->name)));
  if (XEN_GdkDevice__P(ptr)) return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GdkDevice_(ptr))->name)));
  if (XEN_GtkWidget__P(ptr)) return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GtkWidget_(ptr))->name)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "name", "pointer to struct with name field");
}

static XEN gxg_changed_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventWindowState__P(ptr), ptr, XEN_ONLY_ARG, "changed_mask", "GdkEventWindowState");
  return(C_TO_XEN_GdkWindowState((GdkWindowState)((XEN_TO_C_GdkEventWindowState_(ptr))->changed_mask)));
}

static XEN gxg_new_window_state(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventWindowState__P(ptr), ptr, XEN_ONLY_ARG, "new_window_state", "GdkEventWindowState");
  return(C_TO_XEN_GdkWindowState((GdkWindowState)((XEN_TO_C_GdkEventWindowState_(ptr))->new_window_state)));
}

static XEN gxg_context(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkEventDND__P(ptr), ptr, XEN_ONLY_ARG, "context", "GdkEventDND");
  return(C_TO_XEN_GdkDragContext_((GdkDragContext*)((XEN_TO_C_GdkEventDND_(ptr))->context)));
}

gxg_static XEN gxg_function(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "function", "GdkGCValues");
  return(C_TO_XEN_GdkFunction((GdkFunction)((XEN_TO_C_GdkGCValues_(ptr))->function)));
}

static XEN gxg_fill(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "fill", "GdkGCValues");
  return(C_TO_XEN_GdkFill((GdkFill)((XEN_TO_C_GdkGCValues_(ptr))->fill)));
}

gxg_static XEN gxg_tile(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "tile", "GdkGCValues");
  return(C_TO_XEN_GdkPixmap_((GdkPixmap*)((XEN_TO_C_GdkGCValues_(ptr))->tile)));
}

gxg_static XEN gxg_stipple(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "stipple", "GdkGCValues");
  return(C_TO_XEN_GdkPixmap_((GdkPixmap*)((XEN_TO_C_GdkGCValues_(ptr))->stipple)));
}

gxg_static XEN gxg_clip_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "clip_mask", "GdkGCValues");
  return(C_TO_XEN_GdkPixmap_((GdkPixmap*)((XEN_TO_C_GdkGCValues_(ptr))->clip_mask)));
}

gxg_static XEN gxg_subwindow_mode(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "subwindow_mode", "GdkGCValues");
  return(C_TO_XEN_GdkSubwindowMode((GdkSubwindowMode)((XEN_TO_C_GdkGCValues_(ptr))->subwindow_mode)));
}

gxg_static XEN gxg_ts_x_origin(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr) || XEN_GdkGC__P(ptr), ptr, XEN_ONLY_ARG, "ts_x_origin", "GdkGCValues" " or " "GdkGC");
  if (XEN_GdkGCValues__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->ts_x_origin)));
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGC_(ptr))->ts_x_origin)));
}

gxg_static XEN gxg_ts_y_origin(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr) || XEN_GdkGC__P(ptr), ptr, XEN_ONLY_ARG, "ts_y_origin", "GdkGCValues" " or " "GdkGC");
  if (XEN_GdkGCValues__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->ts_y_origin)));
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGC_(ptr))->ts_y_origin)));
}

gxg_static XEN gxg_clip_x_origin(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr) || XEN_GdkGC__P(ptr), ptr, XEN_ONLY_ARG, "clip_x_origin", "GdkGCValues" " or " "GdkGC");
  if (XEN_GdkGCValues__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->clip_x_origin)));
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGC_(ptr))->clip_x_origin)));
}

gxg_static XEN gxg_clip_y_origin(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr) || XEN_GdkGC__P(ptr), ptr, XEN_ONLY_ARG, "clip_y_origin", "GdkGCValues" " or " "GdkGC");
  if (XEN_GdkGCValues__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->clip_y_origin)));
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGC_(ptr))->clip_y_origin)));
}

gxg_static XEN gxg_graphics_exposures(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "graphics_exposures", "GdkGCValues");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->graphics_exposures)));
}

gxg_static XEN gxg_line_width(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "line_width", "GdkGCValues");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGCValues_(ptr))->line_width)));
}

gxg_static XEN gxg_line_style(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "line_style", "GdkGCValues");
  return(C_TO_XEN_GdkLineStyle((GdkLineStyle)((XEN_TO_C_GdkGCValues_(ptr))->line_style)));
}

gxg_static XEN gxg_cap_style(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "cap_style", "GdkGCValues");
  return(C_TO_XEN_GdkCapStyle((GdkCapStyle)((XEN_TO_C_GdkGCValues_(ptr))->cap_style)));
}

gxg_static XEN gxg_join_style(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGCValues__P(ptr), ptr, XEN_ONLY_ARG, "join_style", "GdkGCValues");
  return(C_TO_XEN_GdkJoinStyle((GdkJoinStyle)((XEN_TO_C_GdkGCValues_(ptr))->join_style)));
}

gxg_static XEN gxg_colormap(XEN ptr)
{
  if (XEN_GdkGC__P(ptr)) return(C_TO_XEN_GdkColormap_((GdkColormap*)((XEN_TO_C_GdkGC_(ptr))->colormap)));
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_GdkColormap_((GdkColormap*)((XEN_TO_C_GdkImage_(ptr))->colormap)));
  if (XEN_GdkWindowAttr__P(ptr)) return(C_TO_XEN_GdkColormap_((GdkColormap*)((XEN_TO_C_GdkWindowAttr_(ptr))->colormap)));
  if (XEN_GtkStyle__P(ptr)) return(C_TO_XEN_GdkColormap_((GdkColormap*)((XEN_TO_C_GtkStyle_(ptr))->colormap)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "colormap", "pointer to struct with colormap field");
}

gxg_static XEN gxg_byte_order(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkImage__P(ptr) || XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "byte_order", "GdkImage" " or " "GdkVisual");
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_GdkByteOrder((GdkByteOrder)((XEN_TO_C_GdkImage_(ptr))->byte_order)));
  return(C_TO_XEN_GdkByteOrder((GdkByteOrder)((XEN_TO_C_GdkVisual_(ptr))->byte_order)));
}

gxg_static XEN gxg_depth(XEN ptr)
{
  if (XEN_GdkImage__P(ptr)) return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkImage_(ptr))->depth)));
  if (XEN_GdkVisual__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->depth)));
  if (XEN_GtkStyle__P(ptr)) return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkStyle_(ptr))->depth)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "depth", "pointer to struct with depth field");
}

static XEN gxg_bpp(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkImage__P(ptr), ptr, XEN_ONLY_ARG, "bpp", "GdkImage");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkImage_(ptr))->bpp)));
}

static XEN gxg_bpl(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkImage__P(ptr), ptr, XEN_ONLY_ARG, "bpl", "GdkImage");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkImage_(ptr))->bpl)));
}

gxg_static XEN gxg_bits_per_pixel(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkImage__P(ptr), ptr, XEN_ONLY_ARG, "bits_per_pixel", "GdkImage");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkImage_(ptr))->bits_per_pixel)));
}

static XEN gxg_mem(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkImage__P(ptr), ptr, XEN_ONLY_ARG, "mem", "GdkImage");
  return(C_TO_XEN_gpointer((gpointer)((XEN_TO_C_GdkImage_(ptr))->mem)));
}

static XEN gxg_source(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "source", "GdkDevice");
  return(C_TO_XEN_GdkInputSource((GdkInputSource)((XEN_TO_C_GdkDevice_(ptr))->source)));
}

static XEN gxg_has_cursor(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "has_cursor", "GdkDevice");
  return(C_TO_XEN_gboolean((gboolean)((XEN_TO_C_GdkDevice_(ptr))->has_cursor)));
}

static XEN gxg_num_axes(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "num_axes", "GdkDevice");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkDevice_(ptr))->num_axes)));
}

static XEN gxg_num_keys(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "num_keys", "GdkDevice");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkDevice_(ptr))->num_keys)));
}

static XEN gxg_keys(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkDevice__P(ptr), ptr, XEN_ONLY_ARG, "keys", "GdkDevice");
  return(C_TO_XEN_GdkDeviceKey_((GdkDeviceKey*)((XEN_TO_C_GdkDevice_(ptr))->keys)));
}

gxg_static XEN gxg_keycode(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkKeymapKey__P(ptr), ptr, XEN_ONLY_ARG, "keycode", "GdkKeymapKey");
  return(C_TO_XEN_guint((guint)((XEN_TO_C_GdkKeymapKey_(ptr))->keycode)));
}

static XEN gxg_level(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkKeymapKey__P(ptr), ptr, XEN_ONLY_ARG, "level", "GdkKeymapKey");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkKeymapKey_(ptr))->level)));
}

static XEN gxg_n_colors(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkRgbCmap__P(ptr), ptr, XEN_ONLY_ARG, "n_colors", "GdkRgbCmap");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkRgbCmap_(ptr))->n_colors)));
}

static XEN gxg_info_list(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkRgbCmap__P(ptr), ptr, XEN_ONLY_ARG, "info_list", "GdkRgbCmap");
  return(C_TO_XEN_GSList_((GSList*)((XEN_TO_C_GdkRgbCmap_(ptr))->info_list)));
}

gxg_static XEN gxg_colormap_size(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "colormap_size", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->colormap_size)));
}

gxg_static XEN gxg_bits_per_rgb(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "bits_per_rgb", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->bits_per_rgb)));
}

gxg_static XEN gxg_red_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "red_mask", "GdkVisual");
  return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkVisual_(ptr))->red_mask)));
}

static XEN gxg_red_shift(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "red_shift", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->red_shift)));
}

static XEN gxg_red_prec(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "red_prec", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->red_prec)));
}

gxg_static XEN gxg_green_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "green_mask", "GdkVisual");
  return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkVisual_(ptr))->green_mask)));
}

static XEN gxg_green_shift(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "green_shift", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->green_shift)));
}

static XEN gxg_green_prec(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "green_prec", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->green_prec)));
}

gxg_static XEN gxg_blue_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "blue_mask", "GdkVisual");
  return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkVisual_(ptr))->blue_mask)));
}

static XEN gxg_blue_shift(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "blue_shift", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->blue_shift)));
}

static XEN gxg_blue_prec(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkVisual__P(ptr), ptr, XEN_ONLY_ARG, "blue_prec", "GdkVisual");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkVisual_(ptr))->blue_prec)));
}

static XEN gxg_title(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "title", "GdkWindowAttr");
  return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GdkWindowAttr_(ptr))->title)));
}

gxg_static XEN gxg_event_mask(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "event_mask", "GdkWindowAttr");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkWindowAttr_(ptr))->event_mask)));
}

static XEN gxg_window_type(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "window_type", "GdkWindowAttr");
  return(C_TO_XEN_GdkWindowType((GdkWindowType)((XEN_TO_C_GdkWindowAttr_(ptr))->window_type)));
}

gxg_static XEN gxg_cursor(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "cursor", "GdkWindowAttr");
  return(C_TO_XEN_GdkCursor_((GdkCursor*)((XEN_TO_C_GdkWindowAttr_(ptr))->cursor)));
}

static XEN gxg_wmclass_name(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "wmclass_name", "GdkWindowAttr");
  return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GdkWindowAttr_(ptr))->wmclass_name)));
}

static XEN gxg_wmclass_class(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "wmclass_class", "GdkWindowAttr");
  return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GdkWindowAttr_(ptr))->wmclass_class)));
}

gxg_static XEN gxg_override_redirect(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkWindowAttr__P(ptr), ptr, XEN_ONLY_ARG, "override_redirect", "GdkWindowAttr");
  return(C_TO_XEN_gboolean((gboolean)((XEN_TO_C_GdkWindowAttr_(ptr))->override_redirect)));
}

gxg_static XEN gxg_min_width(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "min_width", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->min_width)));
}

gxg_static XEN gxg_min_height(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "min_height", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->min_height)));
}

gxg_static XEN gxg_max_width(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "max_width", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->max_width)));
}

gxg_static XEN gxg_max_height(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "max_height", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->max_height)));
}

static XEN gxg_base_width(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "base_width", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->base_width)));
}

static XEN gxg_base_height(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "base_height", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->base_height)));
}

gxg_static XEN gxg_width_inc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "width_inc", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->width_inc)));
}

gxg_static XEN gxg_height_inc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "height_inc", "GdkGeometry");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GdkGeometry_(ptr))->height_inc)));
}

static XEN gxg_min_aspect(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "min_aspect", "GdkGeometry");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkGeometry_(ptr))->min_aspect)));
}

static XEN gxg_max_aspect(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "max_aspect", "GdkGeometry");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GdkGeometry_(ptr))->max_aspect)));
}

gxg_static XEN gxg_win_gravity(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkGeometry__P(ptr), ptr, XEN_ONLY_ARG, "win_gravity", "GdkGeometry");
  return(C_TO_XEN_GdkGravity((GdkGravity)((XEN_TO_C_GdkGeometry_(ptr))->win_gravity)));
}

static XEN gxg_lower(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "lower", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->lower)));
}

static XEN gxg_upper(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "upper", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->upper)));
}

static XEN gxg_step_increment(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "step_increment", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->step_increment)));
}

static XEN gxg_page_increment(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "page_increment", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->page_increment)));
}

static XEN gxg_page_size(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "page_size", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->page_size)));
}

static XEN gxg_colorsel(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkColorSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "colorsel", "GtkColorSelectionDialog");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkColorSelectionDialog_(ptr))->colorsel)));
}

static XEN gxg_ok_button(XEN ptr)
{
  if (XEN_GtkColorSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkColorSelectionDialog_(ptr))->ok_button)));
  if (XEN_GtkFileSelection__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->ok_button)));
  if (XEN_GtkFontSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->ok_button)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "ok_button", "pointer to struct with ok_button field");
}

static XEN gxg_cancel_button(XEN ptr)
{
  if (XEN_GtkColorSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkColorSelectionDialog_(ptr))->cancel_button)));
  if (XEN_GtkFileSelection__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->cancel_button)));
  if (XEN_GtkFontSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->cancel_button)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "cancel_button", "pointer to struct with cancel_button field");
}

static XEN gxg_help_button(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkColorSelectionDialog__P(ptr) || XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "help_button", "GtkColorSelectionDialog" " or " "GtkFileSelection");
  if (XEN_GtkColorSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkColorSelectionDialog_(ptr))->help_button)));
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->help_button)));
}

static XEN gxg_vbox(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(ptr), ptr, XEN_ONLY_ARG, "vbox", "GtkDialog");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkDialog_(ptr))->vbox)));
}

static XEN gxg_action_area(XEN ptr)
{
  if (XEN_GtkDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkDialog_(ptr))->action_area)));
  if (XEN_GtkFileSelection__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->action_area)));
  if (XEN_GtkFontSelectionDialog__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->action_area)));
  XEN_ASSERT_TYPE(0, ptr, XEN_ONLY_ARG, "action_area", "pointer to struct with action_area field");
}

static XEN gxg_separator(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkDialog__P(ptr), ptr, XEN_ONLY_ARG, "separator", "GtkDialog");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkDialog_(ptr))->separator)));
}

static XEN gxg_dir_list(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "dir_list", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->dir_list)));
}

static XEN gxg_file_list(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "file_list", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->file_list)));
}

static XEN gxg_selection_entry(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "selection_entry", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->selection_entry)));
}

static XEN gxg_selection_text(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "selection_text", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->selection_text)));
}

static XEN gxg_main_vbox(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr) || XEN_GtkFontSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "main_vbox", "GtkFileSelection" " or " "GtkFontSelectionDialog");
  if (XEN_GtkFileSelection__P(ptr)) return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->main_vbox)));
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->main_vbox)));
}

static XEN gxg_history_pulldown(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "history_pulldown", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->history_pulldown)));
}

static XEN gxg_history_menu(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "history_menu", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->history_menu)));
}

static XEN gxg_history_list(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "history_list", "GtkFileSelection");
  return(C_TO_XEN_GList_((GList*)((XEN_TO_C_GtkFileSelection_(ptr))->history_list)));
}

static XEN gxg_fileop_dialog(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_dialog", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_dialog)));
}

static XEN gxg_fileop_entry(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_entry", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_entry)));
}

static XEN gxg_fileop_file(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_file", "GtkFileSelection");
  return(C_TO_XEN_gchar_((gchar*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_file)));
}

static XEN gxg_cmpl_state(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "cmpl_state", "GtkFileSelection");
  return(C_TO_XEN_gpointer((gpointer)((XEN_TO_C_GtkFileSelection_(ptr))->cmpl_state)));
}

static XEN gxg_fileop_c_dir(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_c_dir", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_c_dir)));
}

static XEN gxg_fileop_del_file(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_del_file", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_del_file)));
}

static XEN gxg_fileop_ren_file(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "fileop_ren_file", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->fileop_ren_file)));
}

static XEN gxg_button_area(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFileSelection__P(ptr), ptr, XEN_ONLY_ARG, "button_area", "GtkFileSelection");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFileSelection_(ptr))->button_area)));
}

static XEN gxg_fontsel(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "fontsel", "GtkFontSelectionDialog");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->fontsel)));
}

static XEN gxg_apply_button(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "apply_button", "GtkFontSelectionDialog");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->apply_button)));
}

static XEN gxg_dialog_width(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "dialog_width", "GtkFontSelectionDialog");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->dialog_width)));
}

static XEN gxg_auto_resize(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkFontSelectionDialog__P(ptr), ptr, XEN_ONLY_ARG, "auto_resize", "GtkFontSelectionDialog");
  return(C_TO_XEN_gboolean((gboolean)((XEN_TO_C_GtkFontSelectionDialog_(ptr))->auto_resize)));
}

static XEN gxg_fg(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "fg", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->fg)));
}

static XEN gxg_bg(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "bg", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->bg)));
}

static XEN gxg_light(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "light", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->light)));
}

static XEN gxg_dark(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "dark", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->dark)));
}

static XEN gxg_mid(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "mid", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->mid)));
}

static XEN gxg_text(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "text", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->text)));
}

static XEN gxg_base(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "base", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->base)));
}

static XEN gxg_text_aa(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "text_aa", "GtkStyle");
  return(C_TO_XEN_GdkColor_((GdkColor*)((XEN_TO_C_GtkStyle_(ptr))->text_aa)));
}

static XEN gxg_font_desc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "font_desc", "GtkStyle");
  return(C_TO_XEN_PangoFontDescription_((PangoFontDescription*)((XEN_TO_C_GtkStyle_(ptr))->font_desc)));
}

static XEN gxg_xthickness(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "xthickness", "GtkStyle");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkStyle_(ptr))->xthickness)));
}

static XEN gxg_ythickness(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "ythickness", "GtkStyle");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkStyle_(ptr))->ythickness)));
}

static XEN gxg_fg_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "fg_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->fg_gc)));
}

static XEN gxg_bg_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "bg_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->bg_gc)));
}

static XEN gxg_light_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "light_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->light_gc)));
}

static XEN gxg_dark_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "dark_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->dark_gc)));
}

static XEN gxg_mid_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "mid_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->mid_gc)));
}

static XEN gxg_text_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "text_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->text_gc)));
}

static XEN gxg_base_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "base_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->base_gc)));
}

static XEN gxg_text_aa_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "text_aa_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC__((GdkGC**)((XEN_TO_C_GtkStyle_(ptr))->text_aa_gc)));
}

static XEN gxg_black_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "black_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC_((GdkGC*)((XEN_TO_C_GtkStyle_(ptr))->black_gc)));
}

static XEN gxg_white_gc(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "white_gc", "GtkStyle");
  return(C_TO_XEN_GdkGC_((GdkGC*)((XEN_TO_C_GtkStyle_(ptr))->white_gc)));
}

static XEN gxg_bg_pixmap(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "bg_pixmap", "GtkStyle");
  return(C_TO_XEN_GdkPixmap__((GdkPixmap**)((XEN_TO_C_GtkStyle_(ptr))->bg_pixmap)));
}

static XEN gxg_attach_count(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "attach_count", "GtkStyle");
  return(C_TO_XEN_gint((gint)((XEN_TO_C_GtkStyle_(ptr))->attach_count)));
}

static XEN gxg_rc_style(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "rc_style", "GtkStyle");
  return(C_TO_XEN_GtkRcStyle_((GtkRcStyle*)((XEN_TO_C_GtkStyle_(ptr))->rc_style)));
}

static XEN gxg_styles(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "styles", "GtkStyle");
  return(C_TO_XEN_GSList_((GSList*)((XEN_TO_C_GtkStyle_(ptr))->styles)));
}

static XEN gxg_property_cache(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "property_cache", "GtkStyle");
  return(C_TO_XEN_GArray_((GArray*)((XEN_TO_C_GtkStyle_(ptr))->property_cache)));
}

static XEN gxg_icon_factories(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkStyle__P(ptr), ptr, XEN_ONLY_ARG, "icon_factories", "GtkStyle");
  return(C_TO_XEN_GSList_((GSList*)((XEN_TO_C_GtkStyle_(ptr))->icon_factories)));
}

static XEN gxg_saved_state(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(ptr), ptr, XEN_ONLY_ARG, "saved_state", "GtkWidget");
  return(C_TO_XEN_guint8((guint8)((XEN_TO_C_GtkWidget_(ptr))->saved_state)));
}

static XEN gxg_style(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(ptr), ptr, XEN_ONLY_ARG, "style", "GtkWidget");
  return(C_TO_XEN_GtkStyle_((GtkStyle*)((XEN_TO_C_GtkWidget_(ptr))->style)));
}

gxg_static XEN gxg_parent(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkWidget__P(ptr), ptr, XEN_ONLY_ARG, "parent", "GtkWidget");
  return(C_TO_XEN_GtkWidget_((GtkWidget*)((XEN_TO_C_GtkWidget_(ptr))->parent)));
}

gxg_static XEN gxg_pixel(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ONLY_ARG, "pixel", "GdkColor");
  return(C_TO_XEN_guint32((guint32)((XEN_TO_C_GdkColor_(ptr))->pixel)));
}

gxg_static XEN gxg_red(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ONLY_ARG, "red", "GdkColor");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkColor_(ptr))->red)));
}

gxg_static XEN gxg_green(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ONLY_ARG, "green", "GdkColor");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkColor_(ptr))->green)));
}

gxg_static XEN gxg_blue(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ONLY_ARG, "blue", "GdkColor");
  return(C_TO_XEN_guint16((guint16)((XEN_TO_C_GdkColor_(ptr))->blue)));
}

static XEN gxg_value(XEN ptr)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ONLY_ARG, "value", "GtkAdjustment");
  return(C_TO_XEN_gdouble((gdouble)((XEN_TO_C_GtkAdjustment_(ptr))->value)));
}

gxg_static XEN gxg_set_pixel(XEN ptr, XEN val)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ARG_1, "pixel", "GdkColor");
  (XEN_TO_C_GdkColor_(ptr))->pixel = XEN_TO_C_guint32(val);
  return(val);
}

gxg_static XEN gxg_set_red(XEN ptr, XEN val)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ARG_1, "red", "GdkColor");
  (XEN_TO_C_GdkColor_(ptr))->red = XEN_TO_C_guint16(val);
  return(val);
}

gxg_static XEN gxg_set_green(XEN ptr, XEN val)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ARG_1, "green", "GdkColor");
  (XEN_TO_C_GdkColor_(ptr))->green = XEN_TO_C_guint16(val);
  return(val);
}

gxg_static XEN gxg_set_blue(XEN ptr, XEN val)
{
  XEN_ASSERT_TYPE(XEN_GdkColor__P(ptr), ptr, XEN_ARG_1, "blue", "GdkColor");
  (XEN_TO_C_GdkColor_(ptr))->blue = XEN_TO_C_guint16(val);
  return(val);
}

static XEN gxg_set_value(XEN ptr, XEN val)
{
  XEN_ASSERT_TYPE(XEN_GtkAdjustment__P(ptr), ptr, XEN_ARG_1, "value", "GtkAdjustment");
  (XEN_TO_C_GtkAdjustment_(ptr))->value = XEN_TO_C_gdouble(val);
  return(val);
}
static XEN gxg_make_GdkColor(XEN arglist)
{
  GdkColor* result;
  int i, len;
  result = (GdkColor*)CALLOC(1, sizeof(GdkColor));
  len = XEN_LIST_LENGTH(arglist);
  for (i = 0; i < len; i++)
    switch (i)
      {
      case 0: result->pixel = XEN_TO_C_guint32(XEN_LIST_REF(arglist, 0));
      case 1: result->red = XEN_TO_C_guint16(XEN_LIST_REF(arglist, 1));
      case 2: result->green = XEN_TO_C_guint16(XEN_LIST_REF(arglist, 2));
      case 3: result->blue = XEN_TO_C_guint16(XEN_LIST_REF(arglist, 3));
      }
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkColor_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GdkCursor(XEN arglist)
{
  GdkCursor* result;
  int i, len;
  result = (GdkCursor*)CALLOC(1, sizeof(GdkCursor));
  len = XEN_LIST_LENGTH(arglist);
  for (i = 0; i < len; i++)
    switch (i)
      {
      case 0: result->type = XEN_TO_C_GdkCursorType(XEN_LIST_REF(arglist, 0));
      case 1: result->ref_count = XEN_TO_C_guint(XEN_LIST_REF(arglist, 1));
      }
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkCursor_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GdkPoint(XEN arglist)
{
  GdkPoint* result;
  int i, len;
  result = (GdkPoint*)CALLOC(1, sizeof(GdkPoint));
  len = XEN_LIST_LENGTH(arglist);
  for (i = 0; i < len; i++)
    switch (i)
      {
      case 0: result->x = XEN_TO_C_gint(XEN_LIST_REF(arglist, 0));
      case 1: result->y = XEN_TO_C_gint(XEN_LIST_REF(arglist, 1));
      }
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkPoint_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GdkRectangle(XEN arglist)
{
  GdkRectangle* result;
  int i, len;
  result = (GdkRectangle*)CALLOC(1, sizeof(GdkRectangle));
  len = XEN_LIST_LENGTH(arglist);
  for (i = 0; i < len; i++)
    switch (i)
      {
      case 0: result->x = XEN_TO_C_gint(XEN_LIST_REF(arglist, 0));
      case 1: result->y = XEN_TO_C_gint(XEN_LIST_REF(arglist, 1));
      case 2: result->width = XEN_TO_C_gint(XEN_LIST_REF(arglist, 2));
      case 3: result->height = XEN_TO_C_gint(XEN_LIST_REF(arglist, 3));
      }
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GdkRectangle_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GtkStockItem(void)
{
  GtkStockItem* result;
  result = (GtkStockItem*)CALLOC(1, sizeof(GtkStockItem));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkStockItem_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GtkTextIter(void)
{
  GtkTextIter* result;
  result = (GtkTextIter*)CALLOC(1, sizeof(GtkTextIter));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkTextIter_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GtkTreeIter(void)
{
  GtkTreeIter* result;
  result = (GtkTreeIter*)CALLOC(1, sizeof(GtkTreeIter));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkTreeIter_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_GtkRequisition(XEN arglist)
{
  GtkRequisition* result;
  int i, len;
  result = (GtkRequisition*)CALLOC(1, sizeof(GtkRequisition));
  len = XEN_LIST_LENGTH(arglist);
  for (i = 0; i < len; i++)
    switch (i)
      {
      case 0: result->width = XEN_TO_C_gint(XEN_LIST_REF(arglist, 0));
      case 1: result->height = XEN_TO_C_gint(XEN_LIST_REF(arglist, 1));
      }
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("GtkRequisition_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_PangoColor(void)
{
  PangoColor* result;
  result = (PangoColor*)CALLOC(1, sizeof(PangoColor));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoColor_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_PangoRectangle(void)
{
  PangoRectangle* result;
  result = (PangoRectangle*)CALLOC(1, sizeof(PangoRectangle));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoRectangle_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

static XEN gxg_make_PangoLogAttr(void)
{
  PangoLogAttr* result;
  result = (PangoLogAttr*)CALLOC(1, sizeof(PangoLogAttr));
  return(XEN_LIST_3(C_STRING_TO_XEN_SYMBOL("PangoLogAttr_"), C_TO_XEN_ULONG((unsigned long)result), make_xm_obj(result)));
}

#if HAVE_GUILE
static void define_structs(void)
{

#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(parent, gxg_parent, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(style, gxg_style, 1, 0, 0, NULL);
  XG_DEFINE_READER(saved_state, gxg_saved_state, 1, 0, 0, NULL);
  XG_DEFINE_READER(icon_factories, gxg_icon_factories, 1, 0, 0, NULL);
  XG_DEFINE_READER(property_cache, gxg_property_cache, 1, 0, 0, NULL);
  XG_DEFINE_READER(styles, gxg_styles, 1, 0, 0, NULL);
  XG_DEFINE_READER(rc_style, gxg_rc_style, 1, 0, 0, NULL);
  XG_DEFINE_READER(attach_count, gxg_attach_count, 1, 0, 0, NULL);
  XG_DEFINE_READER(bg_pixmap, gxg_bg_pixmap, 1, 0, 0, NULL);
  XG_DEFINE_READER(white_gc, gxg_white_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(black_gc, gxg_black_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(text_aa_gc, gxg_text_aa_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(base_gc, gxg_base_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(text_gc, gxg_text_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(mid_gc, gxg_mid_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(dark_gc, gxg_dark_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(light_gc, gxg_light_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(bg_gc, gxg_bg_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(fg_gc, gxg_fg_gc, 1, 0, 0, NULL);
  XG_DEFINE_READER(ythickness, gxg_ythickness, 1, 0, 0, NULL);
  XG_DEFINE_READER(xthickness, gxg_xthickness, 1, 0, 0, NULL);
  XG_DEFINE_READER(font_desc, gxg_font_desc, 1, 0, 0, NULL);
  XG_DEFINE_READER(text_aa, gxg_text_aa, 1, 0, 0, NULL);
  XG_DEFINE_READER(base, gxg_base, 1, 0, 0, NULL);
  XG_DEFINE_READER(text, gxg_text, 1, 0, 0, NULL);
  XG_DEFINE_READER(mid, gxg_mid, 1, 0, 0, NULL);
  XG_DEFINE_READER(dark, gxg_dark, 1, 0, 0, NULL);
  XG_DEFINE_READER(light, gxg_light, 1, 0, 0, NULL);
  XG_DEFINE_READER(bg, gxg_bg, 1, 0, 0, NULL);
  XG_DEFINE_READER(fg, gxg_fg, 1, 0, 0, NULL);
  XG_DEFINE_READER(auto_resize, gxg_auto_resize, 1, 0, 0, NULL);
  XG_DEFINE_READER(dialog_width, gxg_dialog_width, 1, 0, 0, NULL);
  XG_DEFINE_READER(apply_button, gxg_apply_button, 1, 0, 0, NULL);
  XG_DEFINE_READER(fontsel, gxg_fontsel, 1, 0, 0, NULL);
  XG_DEFINE_READER(button_area, gxg_button_area, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_ren_file, gxg_fileop_ren_file, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_del_file, gxg_fileop_del_file, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_c_dir, gxg_fileop_c_dir, 1, 0, 0, NULL);
  XG_DEFINE_READER(cmpl_state, gxg_cmpl_state, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_file, gxg_fileop_file, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_entry, gxg_fileop_entry, 1, 0, 0, NULL);
  XG_DEFINE_READER(fileop_dialog, gxg_fileop_dialog, 1, 0, 0, NULL);
  XG_DEFINE_READER(history_list, gxg_history_list, 1, 0, 0, NULL);
  XG_DEFINE_READER(history_menu, gxg_history_menu, 1, 0, 0, NULL);
  XG_DEFINE_READER(history_pulldown, gxg_history_pulldown, 1, 0, 0, NULL);
  XG_DEFINE_READER(main_vbox, gxg_main_vbox, 1, 0, 0, NULL);
  XG_DEFINE_READER(selection_text, gxg_selection_text, 1, 0, 0, NULL);
  XG_DEFINE_READER(selection_entry, gxg_selection_entry, 1, 0, 0, NULL);
  XG_DEFINE_READER(file_list, gxg_file_list, 1, 0, 0, NULL);
  XG_DEFINE_READER(dir_list, gxg_dir_list, 1, 0, 0, NULL);
  XG_DEFINE_READER(separator, gxg_separator, 1, 0, 0, NULL);
  XG_DEFINE_READER(action_area, gxg_action_area, 1, 0, 0, NULL);
  XG_DEFINE_READER(vbox, gxg_vbox, 1, 0, 0, NULL);
  XG_DEFINE_READER(help_button, gxg_help_button, 1, 0, 0, NULL);
  XG_DEFINE_READER(cancel_button, gxg_cancel_button, 1, 0, 0, NULL);
  XG_DEFINE_READER(ok_button, gxg_ok_button, 1, 0, 0, NULL);
  XG_DEFINE_READER(colorsel, gxg_colorsel, 1, 0, 0, NULL);
  XG_DEFINE_READER(page_size, gxg_page_size, 1, 0, 0, NULL);
  XG_DEFINE_READER(page_increment, gxg_page_increment, 1, 0, 0, NULL);
  XG_DEFINE_READER(step_increment, gxg_step_increment, 1, 0, 0, NULL);
  XG_DEFINE_READER(upper, gxg_upper, 1, 0, 0, NULL);
  XG_DEFINE_READER(lower, gxg_lower, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(win_gravity, gxg_win_gravity, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(max_aspect, gxg_max_aspect, 1, 0, 0, NULL);
  XG_DEFINE_READER(min_aspect, gxg_min_aspect, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(height_inc, gxg_height_inc, 1, 0, 0, NULL);
  XG_DEFINE_READER(width_inc, gxg_width_inc, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(base_height, gxg_base_height, 1, 0, 0, NULL);
  XG_DEFINE_READER(base_width, gxg_base_width, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(max_height, gxg_max_height, 1, 0, 0, NULL);
  XG_DEFINE_READER(max_width, gxg_max_width, 1, 0, 0, NULL);
  XG_DEFINE_READER(min_height, gxg_min_height, 1, 0, 0, NULL);
  XG_DEFINE_READER(min_width, gxg_min_width, 1, 0, 0, NULL);
  XG_DEFINE_READER(override_redirect, gxg_override_redirect, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(wmclass_class, gxg_wmclass_class, 1, 0, 0, NULL);
  XG_DEFINE_READER(wmclass_name, gxg_wmclass_name, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(cursor, gxg_cursor, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(window_type, gxg_window_type, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(event_mask, gxg_event_mask, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(title, gxg_title, 1, 0, 0, NULL);
  XG_DEFINE_READER(blue_prec, gxg_blue_prec, 1, 0, 0, NULL);
  XG_DEFINE_READER(blue_shift, gxg_blue_shift, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(blue_mask, gxg_blue_mask, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(green_prec, gxg_green_prec, 1, 0, 0, NULL);
  XG_DEFINE_READER(green_shift, gxg_green_shift, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(green_mask, gxg_green_mask, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(red_prec, gxg_red_prec, 1, 0, 0, NULL);
  XG_DEFINE_READER(red_shift, gxg_red_shift, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(red_mask, gxg_red_mask, 1, 0, 0, NULL);
  XG_DEFINE_READER(bits_per_rgb, gxg_bits_per_rgb, 1, 0, 0, NULL);
  XG_DEFINE_READER(colormap_size, gxg_colormap_size, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(info_list, gxg_info_list, 1, 0, 0, NULL);
  XG_DEFINE_READER(n_colors, gxg_n_colors, 1, 0, 0, NULL);
  XG_DEFINE_READER(level, gxg_level, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(keycode, gxg_keycode, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(keys, gxg_keys, 1, 0, 0, NULL);
  XG_DEFINE_READER(num_keys, gxg_num_keys, 1, 0, 0, NULL);
  XG_DEFINE_READER(num_axes, gxg_num_axes, 1, 0, 0, NULL);
  XG_DEFINE_READER(has_cursor, gxg_has_cursor, 1, 0, 0, NULL);
  XG_DEFINE_READER(source, gxg_source, 1, 0, 0, NULL);
  XG_DEFINE_READER(mem, gxg_mem, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(bits_per_pixel, gxg_bits_per_pixel, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(bpl, gxg_bpl, 1, 0, 0, NULL);
  XG_DEFINE_READER(bpp, gxg_bpp, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(depth, gxg_depth, 1, 0, 0, NULL);
  XG_DEFINE_READER(byte_order, gxg_byte_order, 1, 0, 0, NULL);
  XG_DEFINE_READER(colormap, gxg_colormap, 1, 0, 0, NULL);
  XG_DEFINE_READER(join_style, gxg_join_style, 1, 0, 0, NULL);
  XG_DEFINE_READER(cap_style, gxg_cap_style, 1, 0, 0, NULL);
  XG_DEFINE_READER(line_style, gxg_line_style, 1, 0, 0, NULL);
  XG_DEFINE_READER(line_width, gxg_line_width, 1, 0, 0, NULL);
  XG_DEFINE_READER(graphics_exposures, gxg_graphics_exposures, 1, 0, 0, NULL);
  XG_DEFINE_READER(clip_y_origin, gxg_clip_y_origin, 1, 0, 0, NULL);
  XG_DEFINE_READER(clip_x_origin, gxg_clip_x_origin, 1, 0, 0, NULL);
  XG_DEFINE_READER(ts_y_origin, gxg_ts_y_origin, 1, 0, 0, NULL);
  XG_DEFINE_READER(ts_x_origin, gxg_ts_x_origin, 1, 0, 0, NULL);
  XG_DEFINE_READER(subwindow_mode, gxg_subwindow_mode, 1, 0, 0, NULL);
  XG_DEFINE_READER(clip_mask, gxg_clip_mask, 1, 0, 0, NULL);
  XG_DEFINE_READER(stipple, gxg_stipple, 1, 0, 0, NULL);
  XG_DEFINE_READER(tile, gxg_tile, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(fill, gxg_fill, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(function, gxg_function, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(context, gxg_context, 1, 0, 0, NULL);
  XG_DEFINE_READER(new_window_state, gxg_new_window_state, 1, 0, 0, NULL);
  XG_DEFINE_READER(changed_mask, gxg_changed_mask, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(name, gxg_name, 1, 0, 0, NULL);
  XG_DEFINE_READER(requestor, gxg_requestor, 1, 0, 0, NULL);
  XG_DEFINE_READER(property, gxg_property, 1, 0, 0, NULL);
  XG_DEFINE_READER(target, gxg_target, 1, 0, 0, NULL);
  XG_DEFINE_READER(selection, gxg_selection, 1, 0, 0, NULL);
  XG_DEFINE_READER(atom, gxg_atom, 1, 0, 0, NULL);
  XG_DEFINE_READER(height, gxg_height, 1, 0, 0, NULL);
  XG_DEFINE_READER(width, gxg_width, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(in, gxg_in, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(focus, gxg_focus, 1, 0, 0, NULL);
  XG_DEFINE_READER(detail, gxg_detail, 1, 0, 0, NULL);
  XG_DEFINE_READER(mode, gxg_mode, 1, 0, 0, NULL);
  XG_DEFINE_READER(subwindow, gxg_subwindow, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(group, gxg_group, 1, 0, 0, NULL);
  XG_DEFINE_READER(hardware_keycode, gxg_hardware_keycode, 1, 0, 0, NULL);
  XG_DEFINE_READER(string, gxg_string, 1, 0, 0, NULL);
  XG_DEFINE_READER(length, gxg_length, 1, 0, 0, NULL);
  XG_DEFINE_READER(keyval, gxg_keyval, 1, 0, 0, NULL);
  XG_DEFINE_READER(direction, gxg_direction, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(button, gxg_button, 1, 0, 0, NULL);
  XG_DEFINE_READER(y_root, gxg_y_root, 1, 0, 0, NULL);
  XG_DEFINE_READER(x_root, gxg_x_root, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(device, gxg_device, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(is_hint, gxg_is_hint, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(axes, gxg_axes, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(y, gxg_y, 1, 0, 0, NULL);
  XG_DEFINE_READER(x, gxg_x, 1, 0, 0, NULL);
  XG_DEFINE_READER(time, gxg_time, 1, 0, 0, NULL);
  XG_DEFINE_READER(state, gxg_state, 1, 0, 0, NULL);
  XG_DEFINE_READER(count, gxg_count, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(region, gxg_region, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(send_event, gxg_send_event, 1, 0, 0, NULL);
  XG_DEFINE_READER(window, gxg_window, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(start_time, gxg_start_time, 1, 0, 0, NULL);
  XG_DEFINE_READER(action, gxg_action, 1, 0, 0, NULL);
  XG_DEFINE_READER(suggested_action, gxg_suggested_action, 1, 0, 0, NULL);
  XG_DEFINE_READER(actions, gxg_actions, 1, 0, 0, NULL);
  XG_DEFINE_READER(targets, gxg_targets, 1, 0, 0, NULL);
  XG_DEFINE_READER(dest_window, gxg_dest_window, 1, 0, 0, NULL);
  XG_DEFINE_READER(source_window, gxg_source_window, 1, 0, 0, NULL);
  XG_DEFINE_READER(is_source, gxg_is_source, 1, 0, 0, NULL);
  XG_DEFINE_READER(protocol, gxg_protocol, 1, 0, 0, NULL);
  XG_DEFINE_READER(ref_count, gxg_ref_count, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(type, gxg_type, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(windowing_data, gxg_windowing_data, 1, 0, 0, NULL);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_READER(visual, gxg_visual, 1, 0, 0, NULL);
#endif
  XG_DEFINE_READER(colors, gxg_colors, 1, 0, 0, NULL);
  XG_DEFINE_READER(size, gxg_size, 1, 0, 0, NULL);
  XG_DEFINE_ACCESSOR(value, gxg_value, gxg_set_value, 1, 0, 2, 0);
#if (!WITH_GTK_AND_X11)
  XG_DEFINE_ACCESSOR(blue, gxg_blue, gxg_set_blue, 1, 0, 2, 0);
  XG_DEFINE_ACCESSOR(green, gxg_green, gxg_set_green, 1, 0, 2, 0);
  XG_DEFINE_ACCESSOR(red, gxg_red, gxg_set_red, 1, 0, 2, 0);
  XG_DEFINE_ACCESSOR(pixel, gxg_pixel, gxg_set_pixel, 1, 0, 2, 0);
#endif
  XG_DEFINE_PROCEDURE(GdkColor, gxg_make_GdkColor, 0, 0, 1, NULL);
  XG_DEFINE_PROCEDURE(GdkCursor, gxg_make_GdkCursor, 0, 0, 1, NULL);
  XG_DEFINE_PROCEDURE(GdkPoint, gxg_make_GdkPoint, 0, 0, 1, NULL);
  XG_DEFINE_PROCEDURE(GdkRectangle, gxg_make_GdkRectangle, 0, 0, 1, NULL);
  XG_DEFINE_PROCEDURE(GtkStockItem, gxg_make_GtkStockItem, 0, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GtkTextIter, gxg_make_GtkTextIter, 0, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GtkTreeIter, gxg_make_GtkTreeIter, 0, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(GtkRequisition, gxg_make_GtkRequisition, 0, 0, 1, NULL);
  XG_DEFINE_PROCEDURE(PangoColor, gxg_make_PangoColor, 0, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PangoRectangle, gxg_make_PangoRectangle, 0, 0, 0, NULL);
  XG_DEFINE_PROCEDURE(PangoLogAttr, gxg_make_PangoLogAttr, 0, 0, 0, NULL);
}

#else
  #include "xg-ruby.c"
#endif
/* ---------------------------------------- constants ---------------------------------------- */

static void define_integers(void)
{

#if HAVE_GUILE
#if HAVE_SCM_C_DEFINE
  #define DEFINE_INTEGER(Name) scm_c_define(XG_PRE #Name XG_POST, C_TO_XEN_INT(Name))
  #define DEFINE_ULONG(Name) scm_c_define(XG_PRE #Name XG_POST, C_TO_XEN_ULONG(Name))
#else
  #define DEFINE_INTEGER(Name) gh_define(XG_PRE #Name XG_POST, C_TO_XEN_INT(Name))
  #define DEFINE_ULONG(Name) gh_define(XG_PRE #Name XG_POST, C_TO_XEN_ULONG(Name))
#endif
#else
  #define DEFINE_INTEGER(Name) rb_define_global_const(XG_PRE #Name XG_POST, C_TO_XEN_INT(Name))
  #define DEFINE_ULONG(Name) rb_define_global_const(XG_PRE #Name XG_POST, C_TO_XEN_ULONG(Name))
#endif

  g_type_init();
  DEFINE_INTEGER(G_SIGNAL_RUN_FIRST);
  DEFINE_INTEGER(G_SIGNAL_RUN_LAST);
  DEFINE_INTEGER(G_SIGNAL_RUN_CLEANUP);
  DEFINE_INTEGER(G_SIGNAL_NO_RECURSE);
  DEFINE_INTEGER(G_SIGNAL_DETAILED);
  DEFINE_INTEGER(G_SIGNAL_ACTION);
  DEFINE_INTEGER(G_SIGNAL_NO_HOOKS);
  DEFINE_INTEGER(G_CONNECT_AFTER);
  DEFINE_INTEGER(G_CONNECT_SWAPPED);
  DEFINE_INTEGER(G_SIGNAL_MATCH_ID);
  DEFINE_INTEGER(G_SIGNAL_MATCH_DETAIL);
  DEFINE_INTEGER(G_SIGNAL_MATCH_CLOSURE);
  DEFINE_INTEGER(G_SIGNAL_MATCH_FUNC);
  DEFINE_INTEGER(G_SIGNAL_MATCH_DATA);
  DEFINE_INTEGER(G_SIGNAL_MATCH_UNBLOCKED);
  DEFINE_INTEGER(GDK_X_CURSOR);
  DEFINE_INTEGER(GDK_ARROW);
  DEFINE_INTEGER(GDK_BASED_ARROW_DOWN);
  DEFINE_INTEGER(GDK_BASED_ARROW_UP);
  DEFINE_INTEGER(GDK_BOAT);
  DEFINE_INTEGER(GDK_BOGOSITY);
  DEFINE_INTEGER(GDK_BOTTOM_LEFT_CORNER);
  DEFINE_INTEGER(GDK_BOTTOM_RIGHT_CORNER);
  DEFINE_INTEGER(GDK_BOTTOM_SIDE);
  DEFINE_INTEGER(GDK_BOTTOM_TEE);
  DEFINE_INTEGER(GDK_BOX_SPIRAL);
  DEFINE_INTEGER(GDK_CENTER_PTR);
  DEFINE_INTEGER(GDK_CIRCLE);
  DEFINE_INTEGER(GDK_CLOCK);
  DEFINE_INTEGER(GDK_COFFEE_MUG);
  DEFINE_INTEGER(GDK_CROSS);
  DEFINE_INTEGER(GDK_CROSS_REVERSE);
  DEFINE_INTEGER(GDK_CROSSHAIR);
  DEFINE_INTEGER(GDK_DIAMOND_CROSS);
  DEFINE_INTEGER(GDK_DOT);
  DEFINE_INTEGER(GDK_DOTBOX);
  DEFINE_INTEGER(GDK_DOUBLE_ARROW);
  DEFINE_INTEGER(GDK_DRAFT_LARGE);
  DEFINE_INTEGER(GDK_DRAFT_SMALL);
  DEFINE_INTEGER(GDK_DRAPED_BOX);
  DEFINE_INTEGER(GDK_EXCHANGE);
  DEFINE_INTEGER(GDK_FLEUR);
  DEFINE_INTEGER(GDK_GOBBLER);
  DEFINE_INTEGER(GDK_GUMBY);
  DEFINE_INTEGER(GDK_HAND1);
  DEFINE_INTEGER(GDK_HAND2);
  DEFINE_INTEGER(GDK_HEART);
  DEFINE_INTEGER(GDK_ICON);
  DEFINE_INTEGER(GDK_IRON_CROSS);
  DEFINE_INTEGER(GDK_LEFT_PTR);
  DEFINE_INTEGER(GDK_LEFT_SIDE);
  DEFINE_INTEGER(GDK_LEFT_TEE);
  DEFINE_INTEGER(GDK_LEFTBUTTON);
  DEFINE_INTEGER(GDK_LL_ANGLE);
  DEFINE_INTEGER(GDK_LR_ANGLE);
  DEFINE_INTEGER(GDK_MAN);
  DEFINE_INTEGER(GDK_MIDDLEBUTTON);
  DEFINE_INTEGER(GDK_MOUSE);
  DEFINE_INTEGER(GDK_PENCIL);
  DEFINE_INTEGER(GDK_PIRATE);
  DEFINE_INTEGER(GDK_PLUS);
  DEFINE_INTEGER(GDK_QUESTION_ARROW);
  DEFINE_INTEGER(GDK_RIGHT_PTR);
  DEFINE_INTEGER(GDK_RIGHT_SIDE);
  DEFINE_INTEGER(GDK_RIGHT_TEE);
  DEFINE_INTEGER(GDK_RIGHTBUTTON);
  DEFINE_INTEGER(GDK_RTL_LOGO);
  DEFINE_INTEGER(GDK_SAILBOAT);
  DEFINE_INTEGER(GDK_SB_DOWN_ARROW);
  DEFINE_INTEGER(GDK_SB_H_DOUBLE_ARROW);
  DEFINE_INTEGER(GDK_SB_LEFT_ARROW);
  DEFINE_INTEGER(GDK_SB_RIGHT_ARROW);
  DEFINE_INTEGER(GDK_SB_UP_ARROW);
  DEFINE_INTEGER(GDK_SB_V_DOUBLE_ARROW);
  DEFINE_INTEGER(GDK_SHUTTLE);
  DEFINE_INTEGER(GDK_SIZING);
  DEFINE_INTEGER(GDK_SPIDER);
  DEFINE_INTEGER(GDK_SPRAYCAN);
  DEFINE_INTEGER(GDK_STAR);
  DEFINE_INTEGER(GDK_TARGET);
  DEFINE_INTEGER(GDK_TCROSS);
  DEFINE_INTEGER(GDK_TOP_LEFT_ARROW);
  DEFINE_INTEGER(GDK_TOP_LEFT_CORNER);
  DEFINE_INTEGER(GDK_TOP_RIGHT_CORNER);
  DEFINE_INTEGER(GDK_TOP_SIDE);
  DEFINE_INTEGER(GDK_TOP_TEE);
  DEFINE_INTEGER(GDK_TREK);
  DEFINE_INTEGER(GDK_UL_ANGLE);
  DEFINE_INTEGER(GDK_UMBRELLA);
  DEFINE_INTEGER(GDK_UR_ANGLE);
  DEFINE_INTEGER(GDK_WATCH);
  DEFINE_INTEGER(GDK_XTERM);
  DEFINE_INTEGER(GDK_LAST_CURSOR );
  DEFINE_INTEGER(GDK_CURSOR_IS_PIXMAP);
  DEFINE_INTEGER(GDK_ACTION_DEFAULT);
  DEFINE_INTEGER(GDK_ACTION_COPY);
  DEFINE_INTEGER(GDK_ACTION_MOVE);
  DEFINE_INTEGER(GDK_ACTION_LINK);
  DEFINE_INTEGER(GDK_ACTION_PRIVATE);
  DEFINE_INTEGER(GDK_ACTION_ASK);
  DEFINE_INTEGER(GDK_DRAG_PROTO_MOTIF);
  DEFINE_INTEGER(GDK_DRAG_PROTO_XDND);
  DEFINE_INTEGER(GDK_DRAG_PROTO_ROOTWIN);
  DEFINE_INTEGER(GDK_DRAG_PROTO_NONE);
  DEFINE_INTEGER(GDK_DRAG_PROTO_WIN32_DROPFILES);
  DEFINE_INTEGER(GDK_DRAG_PROTO_OLE2);
  DEFINE_INTEGER(GDK_DRAG_PROTO_LOCAL);
  DEFINE_INTEGER(GDK_PRIORITY_EVENTS);
  DEFINE_INTEGER(GDK_PRIORITY_REDRAW);
  DEFINE_INTEGER(GDK_NOTHING);
  DEFINE_INTEGER(GDK_DELETE);
  DEFINE_INTEGER(GDK_DESTROY);
  DEFINE_INTEGER(GDK_EXPOSE);
  DEFINE_INTEGER(GDK_MOTION_NOTIFY);
  DEFINE_INTEGER(GDK_BUTTON_PRESS);
  DEFINE_INTEGER(GDK_2BUTTON_PRESS);
  DEFINE_INTEGER(GDK_3BUTTON_PRESS);
  DEFINE_INTEGER(GDK_BUTTON_RELEASE);
  DEFINE_INTEGER(GDK_KEY_PRESS);
  DEFINE_INTEGER(GDK_KEY_RELEASE);
  DEFINE_INTEGER(GDK_ENTER_NOTIFY);
  DEFINE_INTEGER(GDK_LEAVE_NOTIFY);
  DEFINE_INTEGER(GDK_FOCUS_CHANGE);
  DEFINE_INTEGER(GDK_CONFIGURE);
  DEFINE_INTEGER(GDK_MAP);
  DEFINE_INTEGER(GDK_UNMAP);
  DEFINE_INTEGER(GDK_PROPERTY_NOTIFY);
  DEFINE_INTEGER(GDK_SELECTION_CLEAR);
  DEFINE_INTEGER(GDK_SELECTION_REQUEST);
  DEFINE_INTEGER(GDK_SELECTION_NOTIFY);
  DEFINE_INTEGER(GDK_PROXIMITY_IN);
  DEFINE_INTEGER(GDK_PROXIMITY_OUT);
  DEFINE_INTEGER(GDK_DRAG_ENTER);
  DEFINE_INTEGER(GDK_DRAG_LEAVE);
  DEFINE_INTEGER(GDK_DRAG_MOTION);
  DEFINE_INTEGER(GDK_DRAG_STATUS);
  DEFINE_INTEGER(GDK_DROP_START);
  DEFINE_INTEGER(GDK_DROP_FINISHED);
  DEFINE_INTEGER(GDK_CLIENT_EVENT);
  DEFINE_INTEGER(GDK_VISIBILITY_NOTIFY);
  DEFINE_INTEGER(GDK_NO_EXPOSE);
  DEFINE_INTEGER(GDK_SCROLL);
  DEFINE_INTEGER(GDK_WINDOW_STATE);
  DEFINE_INTEGER(GDK_SETTING);
  DEFINE_INTEGER(GDK_EXPOSURE_MASK);
  DEFINE_INTEGER(GDK_POINTER_MOTION_MASK);
  DEFINE_INTEGER(GDK_POINTER_MOTION_HINT_MASK);
  DEFINE_INTEGER(GDK_BUTTON_MOTION_MASK);
  DEFINE_INTEGER(GDK_BUTTON1_MOTION_MASK);
  DEFINE_INTEGER(GDK_BUTTON2_MOTION_MASK);
  DEFINE_INTEGER(GDK_BUTTON3_MOTION_MASK);
  DEFINE_INTEGER(GDK_BUTTON_PRESS_MASK);
  DEFINE_INTEGER(GDK_BUTTON_RELEASE_MASK);
  DEFINE_INTEGER(GDK_KEY_PRESS_MASK);
  DEFINE_INTEGER(GDK_KEY_RELEASE_MASK);
  DEFINE_INTEGER(GDK_ENTER_NOTIFY_MASK);
  DEFINE_INTEGER(GDK_LEAVE_NOTIFY_MASK);
  DEFINE_INTEGER(GDK_FOCUS_CHANGE_MASK);
  DEFINE_INTEGER(GDK_STRUCTURE_MASK);
  DEFINE_INTEGER(GDK_PROPERTY_CHANGE_MASK);
  DEFINE_INTEGER(GDK_VISIBILITY_NOTIFY_MASK);
  DEFINE_INTEGER(GDK_PROXIMITY_IN_MASK);
  DEFINE_INTEGER(GDK_PROXIMITY_OUT_MASK);
  DEFINE_INTEGER(GDK_SUBSTRUCTURE_MASK);
  DEFINE_INTEGER(GDK_SCROLL_MASK);
  DEFINE_INTEGER(GDK_ALL_EVENTS_MASK);
  DEFINE_INTEGER(GDK_VISIBILITY_UNOBSCURED );
  DEFINE_INTEGER(GDK_VISIBILITY_PARTIAL );
  DEFINE_INTEGER(GDK_VISIBILITY_FULLY_OBSCURED);
  DEFINE_INTEGER(GDK_SCROLL_UP);
  DEFINE_INTEGER(GDK_SCROLL_DOWN);
  DEFINE_INTEGER(GDK_SCROLL_LEFT);
  DEFINE_INTEGER(GDK_SCROLL_RIGHT);
  DEFINE_INTEGER(GDK_NOTIFY_ANCESTOR);
  DEFINE_INTEGER(GDK_NOTIFY_VIRTUAL);
  DEFINE_INTEGER(GDK_NOTIFY_INFERIOR);
  DEFINE_INTEGER(GDK_NOTIFY_NONLINEAR);
  DEFINE_INTEGER(GDK_NOTIFY_NONLINEAR_VIRTUAL);
  DEFINE_INTEGER(GDK_NOTIFY_UNKNOWN);
  DEFINE_INTEGER(GDK_CROSSING_NORMAL);
  DEFINE_INTEGER(GDK_CROSSING_GRAB);
  DEFINE_INTEGER(GDK_CROSSING_UNGRAB);
  DEFINE_INTEGER(GDK_PROPERTY_NEW_VALUE);
  DEFINE_INTEGER(GDK_PROPERTY_DELETE);
  DEFINE_INTEGER(GDK_WINDOW_STATE_WITHDRAWN);
  DEFINE_INTEGER(GDK_WINDOW_STATE_ICONIFIED);
  DEFINE_INTEGER(GDK_WINDOW_STATE_MAXIMIZED);
  DEFINE_INTEGER(GDK_WINDOW_STATE_STICKY);
  DEFINE_INTEGER(GDK_SETTING_ACTION_NEW);
  DEFINE_INTEGER(GDK_SETTING_ACTION_CHANGED);
  DEFINE_INTEGER(GDK_SETTING_ACTION_DELETED);
  DEFINE_INTEGER(GDK_CAP_NOT_LAST);
  DEFINE_INTEGER(GDK_CAP_BUTT);
  DEFINE_INTEGER(GDK_CAP_ROUND);
  DEFINE_INTEGER(GDK_CAP_PROJECTING);
  DEFINE_INTEGER(GDK_SOLID);
  DEFINE_INTEGER(GDK_TILED);
  DEFINE_INTEGER(GDK_STIPPLED);
  DEFINE_INTEGER(GDK_OPAQUE_STIPPLED);
  DEFINE_INTEGER(GDK_COPY);
  DEFINE_INTEGER(GDK_INVERT);
  DEFINE_INTEGER(GDK_XOR);
  DEFINE_INTEGER(GDK_CLEAR);
  DEFINE_INTEGER(GDK_AND);
  DEFINE_INTEGER(GDK_AND_REVERSE);
  DEFINE_INTEGER(GDK_AND_INVERT);
  DEFINE_INTEGER(GDK_NOOP);
  DEFINE_INTEGER(GDK_OR);
  DEFINE_INTEGER(GDK_EQUIV);
  DEFINE_INTEGER(GDK_OR_REVERSE);
  DEFINE_INTEGER(GDK_COPY_INVERT);
  DEFINE_INTEGER(GDK_OR_INVERT);
  DEFINE_INTEGER(GDK_NAND);
  DEFINE_INTEGER(GDK_NOR);
  DEFINE_INTEGER(GDK_SET);
  DEFINE_INTEGER(GDK_JOIN_MITER);
  DEFINE_INTEGER(GDK_JOIN_ROUND);
  DEFINE_INTEGER(GDK_JOIN_BEVEL);
  DEFINE_INTEGER(GDK_LINE_SOLID);
  DEFINE_INTEGER(GDK_LINE_ON_OFF_DASH);
  DEFINE_INTEGER(GDK_LINE_DOUBLE_DASH);
  DEFINE_INTEGER(GDK_CLIP_BY_CHILDREN);
  DEFINE_INTEGER(GDK_INCLUDE_INFERIORS);
  DEFINE_INTEGER(GDK_GC_FOREGROUND);
  DEFINE_INTEGER(GDK_GC_BACKGROUND);
  DEFINE_INTEGER(GDK_GC_FONT);
  DEFINE_INTEGER(GDK_GC_FUNCTION);
  DEFINE_INTEGER(GDK_GC_FILL);
  DEFINE_INTEGER(GDK_GC_TILE);
  DEFINE_INTEGER(GDK_GC_STIPPLE);
  DEFINE_INTEGER(GDK_GC_CLIP_MASK);
  DEFINE_INTEGER(GDK_GC_SUBWINDOW);
  DEFINE_INTEGER(GDK_GC_TS_X_ORIGIN);
  DEFINE_INTEGER(GDK_GC_TS_Y_ORIGIN);
  DEFINE_INTEGER(GDK_GC_CLIP_X_ORIGIN);
  DEFINE_INTEGER(GDK_GC_CLIP_Y_ORIGIN);
  DEFINE_INTEGER(GDK_GC_EXPOSURES);
  DEFINE_INTEGER(GDK_GC_LINE_WIDTH);
  DEFINE_INTEGER(GDK_GC_LINE_STYLE);
  DEFINE_INTEGER(GDK_GC_CAP_STYLE);
  DEFINE_INTEGER(GDK_GC_JOIN_STYLE);
  DEFINE_INTEGER(GDK_IMAGE_NORMAL);
  DEFINE_INTEGER(GDK_IMAGE_SHARED);
  DEFINE_INTEGER(GDK_IMAGE_FASTEST);
  DEFINE_INTEGER(GDK_EXTENSION_EVENTS_NONE);
  DEFINE_INTEGER(GDK_EXTENSION_EVENTS_ALL);
  DEFINE_INTEGER(GDK_EXTENSION_EVENTS_CURSOR);
  DEFINE_INTEGER(GDK_SOURCE_MOUSE);
  DEFINE_INTEGER(GDK_SOURCE_PEN);
  DEFINE_INTEGER(GDK_SOURCE_ERASER);
  DEFINE_INTEGER(GDK_SOURCE_CURSOR);
  DEFINE_INTEGER(GDK_MODE_DISABLED);
  DEFINE_INTEGER(GDK_MODE_SCREEN);
  DEFINE_INTEGER(GDK_MODE_WINDOW);
  DEFINE_INTEGER(GDK_AXIS_IGNORE);
  DEFINE_INTEGER(GDK_AXIS_X);
  DEFINE_INTEGER(GDK_AXIS_Y);
  DEFINE_INTEGER(GDK_AXIS_PRESSURE);
  DEFINE_INTEGER(GDK_AXIS_XTILT);
  DEFINE_INTEGER(GDK_AXIS_YTILT);
  DEFINE_INTEGER(GDK_AXIS_WHEEL);
  DEFINE_INTEGER(GDK_AXIS_LAST);
  DEFINE_INTEGER(GDK_EVEN_ODD_RULE);
  DEFINE_INTEGER(GDK_WINDING_RULE);
  DEFINE_INTEGER(GDK_OVERLAP_RECTANGLE_IN);
  DEFINE_INTEGER(GDK_OVERLAP_RECTANGLE_OUT);
  DEFINE_INTEGER(GDK_OVERLAP_RECTANGLE_PART);
  DEFINE_INTEGER(GDK_MAX_TIMECOORD_AXES);
  DEFINE_INTEGER(GDK_VoidSymbol);
  DEFINE_INTEGER(GDK_BackSpace);
  DEFINE_INTEGER(GDK_Tab);
  DEFINE_INTEGER(GDK_Linefeed);
  DEFINE_INTEGER(GDK_Clear);
  DEFINE_INTEGER(GDK_Return);
  DEFINE_INTEGER(GDK_Pause);
  DEFINE_INTEGER(GDK_Scroll_Lock);
  DEFINE_INTEGER(GDK_Sys_Req);
  DEFINE_INTEGER(GDK_Escape);
  DEFINE_INTEGER(GDK_Delete);
  DEFINE_INTEGER(GDK_Home);
  DEFINE_INTEGER(GDK_Left);
  DEFINE_INTEGER(GDK_Up);
  DEFINE_INTEGER(GDK_Right);
  DEFINE_INTEGER(GDK_Down);
  DEFINE_INTEGER(GDK_Prior);
  DEFINE_INTEGER(GDK_Page_Up);
  DEFINE_INTEGER(GDK_Next);
  DEFINE_INTEGER(GDK_Page_Down);
  DEFINE_INTEGER(GDK_End);
  DEFINE_INTEGER(GDK_Begin);
  DEFINE_INTEGER(GDK_Select);
  DEFINE_INTEGER(GDK_Print);
  DEFINE_INTEGER(GDK_Execute);
  DEFINE_INTEGER(GDK_Insert);
  DEFINE_INTEGER(GDK_Undo);
  DEFINE_INTEGER(GDK_Redo);
  DEFINE_INTEGER(GDK_Menu);
  DEFINE_INTEGER(GDK_Find);
  DEFINE_INTEGER(GDK_Cancel);
  DEFINE_INTEGER(GDK_Help);
  DEFINE_INTEGER(GDK_Break);
  DEFINE_INTEGER(GDK_Mode_switch);
  DEFINE_INTEGER(GDK_script_switch);
  DEFINE_INTEGER(GDK_Num_Lock);
  DEFINE_INTEGER(GDK_KP_Space);
  DEFINE_INTEGER(GDK_KP_Tab);
  DEFINE_INTEGER(GDK_KP_Enter);
  DEFINE_INTEGER(GDK_KP_F1);
  DEFINE_INTEGER(GDK_KP_F2);
  DEFINE_INTEGER(GDK_KP_F3);
  DEFINE_INTEGER(GDK_KP_F4);
  DEFINE_INTEGER(GDK_KP_Home);
  DEFINE_INTEGER(GDK_KP_Left);
  DEFINE_INTEGER(GDK_KP_Up);
  DEFINE_INTEGER(GDK_KP_Right);
  DEFINE_INTEGER(GDK_KP_Down);
  DEFINE_INTEGER(GDK_KP_Prior);
  DEFINE_INTEGER(GDK_KP_Page_Up);
  DEFINE_INTEGER(GDK_KP_Next);
  DEFINE_INTEGER(GDK_KP_Page_Down);
  DEFINE_INTEGER(GDK_KP_End);
  DEFINE_INTEGER(GDK_KP_Begin);
  DEFINE_INTEGER(GDK_KP_Insert);
  DEFINE_INTEGER(GDK_KP_Delete);
  DEFINE_INTEGER(GDK_KP_Equal);
  DEFINE_INTEGER(GDK_KP_Multiply);
  DEFINE_INTEGER(GDK_KP_Add);
  DEFINE_INTEGER(GDK_KP_Separator);
  DEFINE_INTEGER(GDK_KP_Subtract);
  DEFINE_INTEGER(GDK_KP_Decimal);
  DEFINE_INTEGER(GDK_KP_Divide);
  DEFINE_INTEGER(GDK_KP_0);
  DEFINE_INTEGER(GDK_KP_1);
  DEFINE_INTEGER(GDK_KP_2);
  DEFINE_INTEGER(GDK_KP_3);
  DEFINE_INTEGER(GDK_KP_4);
  DEFINE_INTEGER(GDK_KP_5);
  DEFINE_INTEGER(GDK_KP_6);
  DEFINE_INTEGER(GDK_KP_7);
  DEFINE_INTEGER(GDK_KP_8);
  DEFINE_INTEGER(GDK_KP_9);
  DEFINE_INTEGER(GDK_F1);
  DEFINE_INTEGER(GDK_F2);
  DEFINE_INTEGER(GDK_F3);
  DEFINE_INTEGER(GDK_F4);
  DEFINE_INTEGER(GDK_F5);
  DEFINE_INTEGER(GDK_F6);
  DEFINE_INTEGER(GDK_F7);
  DEFINE_INTEGER(GDK_F8);
  DEFINE_INTEGER(GDK_F9);
  DEFINE_INTEGER(GDK_F10);
  DEFINE_INTEGER(GDK_F11);
  DEFINE_INTEGER(GDK_L1);
  DEFINE_INTEGER(GDK_F12);
  DEFINE_INTEGER(GDK_L2);
  DEFINE_INTEGER(GDK_F13);
  DEFINE_INTEGER(GDK_L3);
  DEFINE_INTEGER(GDK_F14);
  DEFINE_INTEGER(GDK_L4);
  DEFINE_INTEGER(GDK_F15);
  DEFINE_INTEGER(GDK_L5);
  DEFINE_INTEGER(GDK_F16);
  DEFINE_INTEGER(GDK_L6);
  DEFINE_INTEGER(GDK_F17);
  DEFINE_INTEGER(GDK_L7);
  DEFINE_INTEGER(GDK_F18);
  DEFINE_INTEGER(GDK_L8);
  DEFINE_INTEGER(GDK_F19);
  DEFINE_INTEGER(GDK_L9);
  DEFINE_INTEGER(GDK_F20);
  DEFINE_INTEGER(GDK_L10);
  DEFINE_INTEGER(GDK_F21);
  DEFINE_INTEGER(GDK_R1);
  DEFINE_INTEGER(GDK_F22);
  DEFINE_INTEGER(GDK_R2);
  DEFINE_INTEGER(GDK_F23);
  DEFINE_INTEGER(GDK_R3);
  DEFINE_INTEGER(GDK_F24);
  DEFINE_INTEGER(GDK_R4);
  DEFINE_INTEGER(GDK_F25);
  DEFINE_INTEGER(GDK_R5);
  DEFINE_INTEGER(GDK_F26);
  DEFINE_INTEGER(GDK_R6);
  DEFINE_INTEGER(GDK_F27);
  DEFINE_INTEGER(GDK_R7);
  DEFINE_INTEGER(GDK_F28);
  DEFINE_INTEGER(GDK_R8);
  DEFINE_INTEGER(GDK_F29);
  DEFINE_INTEGER(GDK_R9);
  DEFINE_INTEGER(GDK_F30);
  DEFINE_INTEGER(GDK_R10);
  DEFINE_INTEGER(GDK_F31);
  DEFINE_INTEGER(GDK_R11);
  DEFINE_INTEGER(GDK_F32);
  DEFINE_INTEGER(GDK_R12);
  DEFINE_INTEGER(GDK_F33);
  DEFINE_INTEGER(GDK_R13);
  DEFINE_INTEGER(GDK_F34);
  DEFINE_INTEGER(GDK_R14);
  DEFINE_INTEGER(GDK_F35);
  DEFINE_INTEGER(GDK_R15);
  DEFINE_INTEGER(GDK_Shift_L);
  DEFINE_INTEGER(GDK_Shift_R);
  DEFINE_INTEGER(GDK_Control_L);
  DEFINE_INTEGER(GDK_Control_R);
  DEFINE_INTEGER(GDK_Caps_Lock);
  DEFINE_INTEGER(GDK_Shift_Lock);
  DEFINE_INTEGER(GDK_Meta_L);
  DEFINE_INTEGER(GDK_Meta_R);
  DEFINE_INTEGER(GDK_Alt_L);
  DEFINE_INTEGER(GDK_Alt_R);
  DEFINE_INTEGER(GDK_space);
  DEFINE_INTEGER(GDK_exclam);
  DEFINE_INTEGER(GDK_quotedbl);
  DEFINE_INTEGER(GDK_numbersign);
  DEFINE_INTEGER(GDK_dollar);
  DEFINE_INTEGER(GDK_percent);
  DEFINE_INTEGER(GDK_ampersand);
  DEFINE_INTEGER(GDK_apostrophe);
  DEFINE_INTEGER(GDK_quoteright);
  DEFINE_INTEGER(GDK_parenleft);
  DEFINE_INTEGER(GDK_parenright);
  DEFINE_INTEGER(GDK_asterisk);
  DEFINE_INTEGER(GDK_plus);
  DEFINE_INTEGER(GDK_comma);
  DEFINE_INTEGER(GDK_minus);
  DEFINE_INTEGER(GDK_period);
  DEFINE_INTEGER(GDK_slash);
  DEFINE_INTEGER(GDK_0);
  DEFINE_INTEGER(GDK_1);
  DEFINE_INTEGER(GDK_2);
  DEFINE_INTEGER(GDK_3);
  DEFINE_INTEGER(GDK_4);
  DEFINE_INTEGER(GDK_5);
  DEFINE_INTEGER(GDK_6);
  DEFINE_INTEGER(GDK_7);
  DEFINE_INTEGER(GDK_8);
  DEFINE_INTEGER(GDK_9);
  DEFINE_INTEGER(GDK_colon);
  DEFINE_INTEGER(GDK_semicolon);
  DEFINE_INTEGER(GDK_less);
  DEFINE_INTEGER(GDK_equal);
  DEFINE_INTEGER(GDK_greater);
  DEFINE_INTEGER(GDK_question);
  DEFINE_INTEGER(GDK_at);
  DEFINE_INTEGER(GDK_A);
  DEFINE_INTEGER(GDK_B);
  DEFINE_INTEGER(GDK_C);
  DEFINE_INTEGER(GDK_D);
  DEFINE_INTEGER(GDK_E);
  DEFINE_INTEGER(GDK_F);
  DEFINE_INTEGER(GDK_G);
  DEFINE_INTEGER(GDK_H);
  DEFINE_INTEGER(GDK_I);
  DEFINE_INTEGER(GDK_J);
  DEFINE_INTEGER(GDK_K);
  DEFINE_INTEGER(GDK_L);
  DEFINE_INTEGER(GDK_M);
  DEFINE_INTEGER(GDK_N);
  DEFINE_INTEGER(GDK_O);
  DEFINE_INTEGER(GDK_P);
  DEFINE_INTEGER(GDK_Q);
  DEFINE_INTEGER(GDK_R);
  DEFINE_INTEGER(GDK_S);
  DEFINE_INTEGER(GDK_T);
  DEFINE_INTEGER(GDK_U);
  DEFINE_INTEGER(GDK_V);
  DEFINE_INTEGER(GDK_W);
  DEFINE_INTEGER(GDK_X);
  DEFINE_INTEGER(GDK_Y);
  DEFINE_INTEGER(GDK_Z);
  DEFINE_INTEGER(GDK_bracketleft);
  DEFINE_INTEGER(GDK_backslash);
  DEFINE_INTEGER(GDK_bracketright);
  DEFINE_INTEGER(GDK_asciicircum);
  DEFINE_INTEGER(GDK_underscore);
  DEFINE_INTEGER(GDK_grave);
  DEFINE_INTEGER(GDK_quoteleft);
  DEFINE_INTEGER(GDK_a);
  DEFINE_INTEGER(GDK_b);
  DEFINE_INTEGER(GDK_c);
  DEFINE_INTEGER(GDK_d);
  DEFINE_INTEGER(GDK_e);
  DEFINE_INTEGER(GDK_f);
  DEFINE_INTEGER(GDK_g);
  DEFINE_INTEGER(GDK_h);
  DEFINE_INTEGER(GDK_i);
  DEFINE_INTEGER(GDK_j);
  DEFINE_INTEGER(GDK_k);
  DEFINE_INTEGER(GDK_l);
  DEFINE_INTEGER(GDK_m);
  DEFINE_INTEGER(GDK_n);
  DEFINE_INTEGER(GDK_o);
  DEFINE_INTEGER(GDK_p);
  DEFINE_INTEGER(GDK_q);
  DEFINE_INTEGER(GDK_r);
  DEFINE_INTEGER(GDK_s);
  DEFINE_INTEGER(GDK_t);
  DEFINE_INTEGER(GDK_u);
  DEFINE_INTEGER(GDK_v);
  DEFINE_INTEGER(GDK_w);
  DEFINE_INTEGER(GDK_x);
  DEFINE_INTEGER(GDK_y);
  DEFINE_INTEGER(GDK_z);
  DEFINE_INTEGER(GDK_braceleft);
  DEFINE_INTEGER(GDK_bar);
  DEFINE_INTEGER(GDK_braceright);
  DEFINE_INTEGER(GDK_asciitilde);
  DEFINE_INTEGER(GDK_PROP_MODE_REPLACE);
  DEFINE_INTEGER(GDK_PROP_MODE_PREPEND);
  DEFINE_INTEGER(GDK_PROP_MODE_APPEND);
  DEFINE_INTEGER(GDK_RGB_DITHER_NONE);
  DEFINE_INTEGER(GDK_RGB_DITHER_NORMAL);
  DEFINE_INTEGER(GDK_RGB_DITHER_MAX);
  DEFINE_INTEGER(GDK_CURRENT_TIME);
  DEFINE_INTEGER(GDK_PARENT_RELATIVE);
  DEFINE_INTEGER(GDK_LSB_FIRST);
  DEFINE_INTEGER(GDK_MSB_FIRST);
  DEFINE_INTEGER(GDK_SHIFT_MASK);
  DEFINE_INTEGER(GDK_LOCK_MASK);
  DEFINE_INTEGER(GDK_CONTROL_MASK);
  DEFINE_INTEGER(GDK_MOD1_MASK);
  DEFINE_INTEGER(GDK_MOD2_MASK);
  DEFINE_INTEGER(GDK_MOD3_MASK);
  DEFINE_INTEGER(GDK_MOD4_MASK);
  DEFINE_INTEGER(GDK_MOD5_MASK);
  DEFINE_INTEGER(GDK_BUTTON1_MASK);
  DEFINE_INTEGER(GDK_BUTTON2_MASK);
  DEFINE_INTEGER(GDK_BUTTON3_MASK);
  DEFINE_INTEGER(GDK_BUTTON4_MASK);
  DEFINE_INTEGER(GDK_BUTTON5_MASK);
  DEFINE_INTEGER(GDK_RELEASE_MASK);
  DEFINE_INTEGER(GDK_MODIFIER_MASK);
  DEFINE_INTEGER(GDK_INPUT_READ);
  DEFINE_INTEGER(GDK_INPUT_WRITE);
  DEFINE_INTEGER(GDK_INPUT_EXCEPTION);
  DEFINE_INTEGER(GDK_OK);
  DEFINE_INTEGER(GDK_ERROR);
  DEFINE_INTEGER(GDK_ERROR_PARAM);
  DEFINE_INTEGER(GDK_ERROR_FILE);
  DEFINE_INTEGER(GDK_ERROR_MEM);
  DEFINE_INTEGER(GDK_GRAB_SUCCESS);
  DEFINE_INTEGER(GDK_GRAB_ALREADY_GRABBED);
  DEFINE_INTEGER(GDK_GRAB_INVALID_TIME);
  DEFINE_INTEGER(GDK_GRAB_NOT_VIEWABLE);
  DEFINE_INTEGER(GDK_GRAB_FROZEN);
  DEFINE_INTEGER(GDK_VISUAL_STATIC_GRAY);
  DEFINE_INTEGER(GDK_VISUAL_GRAYSCALE);
  DEFINE_INTEGER(GDK_VISUAL_STATIC_COLOR);
  DEFINE_INTEGER(GDK_VISUAL_PSEUDO_COLOR);
  DEFINE_INTEGER(GDK_VISUAL_TRUE_COLOR);
  DEFINE_INTEGER(GDK_VISUAL_DIRECT_COLOR);
  DEFINE_INTEGER(GDK_INPUT_OUTPUT);
  DEFINE_INTEGER(GDK_INPUT_ONLY);
  DEFINE_INTEGER(GDK_WINDOW_ROOT);
  DEFINE_INTEGER(GDK_WINDOW_TOPLEVEL);
  DEFINE_INTEGER(GDK_WINDOW_CHILD);
  DEFINE_INTEGER(GDK_WINDOW_DIALOG);
  DEFINE_INTEGER(GDK_WINDOW_TEMP);
  DEFINE_INTEGER(GDK_WINDOW_FOREIGN);
  DEFINE_INTEGER(GDK_WA_TITLE);
  DEFINE_INTEGER(GDK_WA_X);
  DEFINE_INTEGER(GDK_WA_Y);
  DEFINE_INTEGER(GDK_WA_CURSOR);
  DEFINE_INTEGER(GDK_WA_COLORMAP);
  DEFINE_INTEGER(GDK_WA_VISUAL);
  DEFINE_INTEGER(GDK_WA_WMCLASS);
  DEFINE_INTEGER(GDK_WA_NOREDIR);
  DEFINE_INTEGER(GDK_HINT_POS);
  DEFINE_INTEGER(GDK_HINT_MIN_SIZE);
  DEFINE_INTEGER(GDK_HINT_MAX_SIZE);
  DEFINE_INTEGER(GDK_HINT_BASE_SIZE);
  DEFINE_INTEGER(GDK_HINT_ASPECT);
  DEFINE_INTEGER(GDK_HINT_RESIZE_INC);
  DEFINE_INTEGER(GDK_HINT_WIN_GRAVITY);
  DEFINE_INTEGER(GDK_HINT_USER_POS);
  DEFINE_INTEGER(GDK_HINT_USER_SIZE);
  DEFINE_INTEGER(GDK_WINDOW_TYPE_HINT_NORMAL);
  DEFINE_INTEGER(GDK_WINDOW_TYPE_HINT_DIALOG);
  DEFINE_INTEGER(GDK_WINDOW_TYPE_HINT_MENU);
  DEFINE_INTEGER(GDK_WINDOW_TYPE_HINT_TOOLBAR);
  DEFINE_INTEGER(GDK_DECOR_ALL);
  DEFINE_INTEGER(GDK_DECOR_BORDER);
  DEFINE_INTEGER(GDK_DECOR_RESIZEH);
  DEFINE_INTEGER(GDK_DECOR_TITLE);
  DEFINE_INTEGER(GDK_DECOR_MENU);
  DEFINE_INTEGER(GDK_DECOR_MINIMIZE);
  DEFINE_INTEGER(GDK_DECOR_MAXIMIZE);
  DEFINE_INTEGER(GDK_FUNC_ALL);
  DEFINE_INTEGER(GDK_FUNC_RESIZE);
  DEFINE_INTEGER(GDK_FUNC_MOVE);
  DEFINE_INTEGER(GDK_FUNC_MINIMIZE);
  DEFINE_INTEGER(GDK_FUNC_MAXIMIZE);
  DEFINE_INTEGER(GDK_FUNC_CLOSE);
  DEFINE_INTEGER(GDK_GRAVITY_NORTH_WEST);
  DEFINE_INTEGER(GDK_GRAVITY_NORTH);
  DEFINE_INTEGER(GDK_GRAVITY_NORTH_EAST);
  DEFINE_INTEGER(GDK_GRAVITY_WEST);
  DEFINE_INTEGER(GDK_GRAVITY_CENTER);
  DEFINE_INTEGER(GDK_GRAVITY_EAST);
  DEFINE_INTEGER(GDK_GRAVITY_SOUTH_WEST);
  DEFINE_INTEGER(GDK_GRAVITY_SOUTH);
  DEFINE_INTEGER(GDK_GRAVITY_SOUTH_EAST);
  DEFINE_INTEGER(GDK_GRAVITY_STATIC);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_NORTH_WEST);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_NORTH);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_NORTH_EAST);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_WEST);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_EAST);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_SOUTH_WEST);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_SOUTH);
  DEFINE_INTEGER(GDK_WINDOW_EDGE_SOUTH_EAST);
  DEFINE_INTEGER(GDK_PIXBUF_ALPHA_BILEVEL);
  DEFINE_INTEGER(GDK_PIXBUF_ALPHA_FULL);
  DEFINE_INTEGER(GDK_COLORSPACE_RGB);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_CORRUPT_IMAGE);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_BAD_OPTION);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_UNKNOWN_TYPE);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION);
  DEFINE_INTEGER(GDK_PIXBUF_ERROR_FAILED);
  DEFINE_INTEGER(GDK_INTERP_NEAREST);
  DEFINE_INTEGER(GDK_INTERP_TILES);
  DEFINE_INTEGER(GDK_INTERP_BILINEAR);
  DEFINE_INTEGER(GDK_INTERP_HYPER);
  DEFINE_INTEGER(GDK_PIXBUF_MAJOR);
  DEFINE_INTEGER(GDK_PIXBUF_MINOR);
  DEFINE_INTEGER(GDK_PIXBUF_MICRO);
  DEFINE_INTEGER(GTK_ACCEL_VISIBLE);
  DEFINE_INTEGER(GTK_ACCEL_LOCKED);
  DEFINE_INTEGER(GTK_ACCEL_MASK);
  DEFINE_INTEGER(GTK_BUTTONBOX_DEFAULT);
  DEFINE_INTEGER(GTK_CALENDAR_SHOW_HEADING);
  DEFINE_INTEGER(GTK_CALENDAR_SHOW_DAY_NAMES);
  DEFINE_INTEGER(GTK_CALENDAR_NO_MONTH_CHANGE);
  DEFINE_INTEGER(GTK_CALENDAR_SHOW_WEEK_NUMBERS);
  DEFINE_INTEGER(GTK_CALENDAR_WEEK_START_MONDAY);
  DEFINE_INTEGER(GTK_CELL_RENDERER_SELECTED);
  DEFINE_INTEGER(GTK_CELL_RENDERER_PRELIT);
  DEFINE_INTEGER(GTK_CELL_RENDERER_INSENSITIVE);
  DEFINE_INTEGER(GTK_CELL_RENDERER_SORTED);
  DEFINE_INTEGER(GTK_DIALOG_MODAL);
  DEFINE_INTEGER(GTK_DIALOG_DESTROY_WITH_PARENT);
  DEFINE_INTEGER(GTK_DIALOG_NO_SEPARATOR);
  DEFINE_INTEGER(GTK_RESPONSE_NONE);
  DEFINE_INTEGER(GTK_RESPONSE_REJECT);
  DEFINE_INTEGER(GTK_RESPONSE_ACCEPT);
  DEFINE_INTEGER(GTK_RESPONSE_DELETE_EVENT);
  DEFINE_INTEGER(GTK_RESPONSE_OK);
  DEFINE_INTEGER(GTK_RESPONSE_CANCEL);
  DEFINE_INTEGER(GTK_RESPONSE_CLOSE);
  DEFINE_INTEGER(GTK_RESPONSE_YES);
  DEFINE_INTEGER(GTK_RESPONSE_NO);
  DEFINE_INTEGER(GTK_RESPONSE_APPLY);
  DEFINE_INTEGER(GTK_RESPONSE_HELP);
  DEFINE_INTEGER(GTK_DEST_DEFAULT_MOTION);
  DEFINE_INTEGER(GTK_DEST_DEFAULT_HIGHLIGHT);
  DEFINE_INTEGER(GTK_DEST_DEFAULT_DROP);
  DEFINE_INTEGER(GTK_DEST_DEFAULT_ALL);
  DEFINE_INTEGER(GTK_ARROW_UP);
  DEFINE_INTEGER(GTK_ARROW_DOWN);
  DEFINE_INTEGER(GTK_ARROW_LEFT);
  DEFINE_INTEGER(GTK_ARROW_RIGHT);
  DEFINE_INTEGER(GTK_EXPAND);
  DEFINE_INTEGER(GTK_SHRINK);
  DEFINE_INTEGER(GTK_FILL);
  DEFINE_INTEGER(GTK_BUTTONBOX_DEFAULT_STYLE);
  DEFINE_INTEGER(GTK_BUTTONBOX_SPREAD);
  DEFINE_INTEGER(GTK_BUTTONBOX_EDGE);
  DEFINE_INTEGER(GTK_BUTTONBOX_START);
  DEFINE_INTEGER(GTK_BUTTONBOX_END);
  DEFINE_INTEGER(GTK_CURVE_TYPE_LINEAR);
  DEFINE_INTEGER(GTK_CURVE_TYPE_SPLINE);
  DEFINE_INTEGER(GTK_CURVE_TYPE_FREE);
  DEFINE_INTEGER(GTK_DELETE_CHARS);
  DEFINE_INTEGER(GTK_DELETE_WORD_ENDS);
  DEFINE_INTEGER(GTK_DELETE_WORDS);
  DEFINE_INTEGER(GTK_DELETE_DISPLAY_LINES);
  DEFINE_INTEGER(GTK_DELETE_DISPLAY_LINE_ENDS);
  DEFINE_INTEGER(GTK_DELETE_PARAGRAPH_ENDS);
  DEFINE_INTEGER(GTK_DELETE_PARAGRAPHS);
  DEFINE_INTEGER(GTK_DELETE_WHITESPACE);
  DEFINE_INTEGER(GTK_DIR_TAB_FORWARD);
  DEFINE_INTEGER(GTK_DIR_TAB_BACKWARD);
  DEFINE_INTEGER(GTK_DIR_UP);
  DEFINE_INTEGER(GTK_DIR_DOWN);
  DEFINE_INTEGER(GTK_DIR_LEFT);
  DEFINE_INTEGER(GTK_DIR_RIGHT);
  DEFINE_INTEGER(GTK_EXPANDER_COLLAPSED);
  DEFINE_INTEGER(GTK_EXPANDER_SEMI_COLLAPSED);
  DEFINE_INTEGER(GTK_EXPANDER_SEMI_EXPANDED);
  DEFINE_INTEGER(GTK_EXPANDER_EXPANDED);
  DEFINE_INTEGER(GTK_ICON_SIZE_INVALID);
  DEFINE_INTEGER(GTK_ICON_SIZE_MENU);
  DEFINE_INTEGER(GTK_ICON_SIZE_SMALL_TOOLBAR);
  DEFINE_INTEGER(GTK_ICON_SIZE_LARGE_TOOLBAR);
  DEFINE_INTEGER(GTK_ICON_SIZE_BUTTON);
  DEFINE_INTEGER(GTK_ICON_SIZE_DND);
  DEFINE_INTEGER(GTK_ICON_SIZE_DIALOG);
  DEFINE_INTEGER(GTK_TEXT_DIR_NONE);
  DEFINE_INTEGER(GTK_TEXT_DIR_LTR);
  DEFINE_INTEGER(GTK_TEXT_DIR_RTL);
  DEFINE_INTEGER(GTK_JUSTIFY_LEFT);
  DEFINE_INTEGER(GTK_JUSTIFY_RIGHT);
  DEFINE_INTEGER(GTK_JUSTIFY_CENTER);
  DEFINE_INTEGER(GTK_JUSTIFY_FILL);
  DEFINE_INTEGER(GTK_MENU_DIR_PARENT);
  DEFINE_INTEGER(GTK_MENU_DIR_CHILD);
  DEFINE_INTEGER(GTK_MENU_DIR_NEXT);
  DEFINE_INTEGER(GTK_MENU_DIR_PREV);
  DEFINE_INTEGER(GTK_PIXELS);
  DEFINE_INTEGER(GTK_INCHES);
  DEFINE_INTEGER(GTK_CENTIMETERS);
  DEFINE_INTEGER(GTK_MOVEMENT_LOGICAL_POSITIONS);
  DEFINE_INTEGER(GTK_MOVEMENT_VISUAL_POSITIONS);
  DEFINE_INTEGER(GTK_MOVEMENT_WORDS);
  DEFINE_INTEGER(GTK_MOVEMENT_DISPLAY_LINES);
  DEFINE_INTEGER(GTK_MOVEMENT_DISPLAY_LINE_ENDS);
  DEFINE_INTEGER(GTK_MOVEMENT_PARAGRAPHS);
  DEFINE_INTEGER(GTK_MOVEMENT_PARAGRAPH_ENDS);
  DEFINE_INTEGER(GTK_MOVEMENT_PAGES);
  DEFINE_INTEGER(GTK_MOVEMENT_BUFFER_ENDS);
  DEFINE_INTEGER(GTK_ORIENTATION_HORIZONTAL);
  DEFINE_INTEGER(GTK_ORIENTATION_VERTICAL);
  DEFINE_INTEGER(GTK_CORNER_TOP_LEFT);
  DEFINE_INTEGER(GTK_CORNER_BOTTOM_LEFT);
  DEFINE_INTEGER(GTK_CORNER_TOP_RIGHT);
  DEFINE_INTEGER(GTK_CORNER_BOTTOM_RIGHT);
  DEFINE_INTEGER(GTK_PACK_START);
  DEFINE_INTEGER(GTK_PACK_END);
  DEFINE_INTEGER(GTK_PATH_PRIO_LOWEST);
  DEFINE_INTEGER(GTK_PATH_PRIO_GTK);
  DEFINE_INTEGER(GTK_PATH_PRIO_APPLICATION);
  DEFINE_INTEGER(GTK_PATH_PRIO_THEME);
  DEFINE_INTEGER(GTK_PATH_PRIO_RC);
  DEFINE_INTEGER(GTK_PATH_PRIO_HIGHEST);
  DEFINE_INTEGER(GTK_PATH_PRIO_MASK);
  DEFINE_INTEGER(GTK_PATH_WIDGET);
  DEFINE_INTEGER(GTK_PATH_WIDGET_CLASS);
  DEFINE_INTEGER(GTK_PATH_CLASS);
  DEFINE_INTEGER(GTK_POLICY_ALWAYS);
  DEFINE_INTEGER(GTK_POLICY_AUTOMATIC);
  DEFINE_INTEGER(GTK_POLICY_NEVER);
  DEFINE_INTEGER(GTK_POS_LEFT);
  DEFINE_INTEGER(GTK_POS_RIGHT);
  DEFINE_INTEGER(GTK_POS_TOP);
  DEFINE_INTEGER(GTK_POS_BOTTOM);
  DEFINE_INTEGER(GTK_RELIEF_NORMAL);
  DEFINE_INTEGER(GTK_RELIEF_HALF);
  DEFINE_INTEGER(GTK_RELIEF_NONE);
  DEFINE_INTEGER(GTK_RESIZE_PARENT);
  DEFINE_INTEGER(GTK_RESIZE_QUEUE);
  DEFINE_INTEGER(GTK_RESIZE_IMMEDIATE);
  DEFINE_INTEGER(GTK_SCROLL_NONE);
  DEFINE_INTEGER(GTK_SCROLL_JUMP);
  DEFINE_INTEGER(GTK_SCROLL_STEP_BACKWARD);
  DEFINE_INTEGER(GTK_SCROLL_STEP_FORWARD);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_BACKWARD);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_FORWARD);
  DEFINE_INTEGER(GTK_SCROLL_STEP_UP);
  DEFINE_INTEGER(GTK_SCROLL_STEP_DOWN);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_UP);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_DOWN);
  DEFINE_INTEGER(GTK_SCROLL_STEP_LEFT);
  DEFINE_INTEGER(GTK_SCROLL_STEP_RIGHT);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_LEFT);
  DEFINE_INTEGER(GTK_SCROLL_PAGE_RIGHT);
  DEFINE_INTEGER(GTK_SCROLL_START);
  DEFINE_INTEGER(GTK_SCROLL_END);
  DEFINE_INTEGER(GTK_SELECTION_NONE);
  DEFINE_INTEGER(GTK_SELECTION_SINGLE);
  DEFINE_INTEGER(GTK_SELECTION_BROWSE);
  DEFINE_INTEGER(GTK_SELECTION_MULTIPLE);
  DEFINE_INTEGER(GTK_SELECTION_EXTENDED);
  DEFINE_INTEGER(GTK_SHADOW_NONE);
  DEFINE_INTEGER(GTK_SHADOW_IN);
  DEFINE_INTEGER(GTK_SHADOW_OUT);
  DEFINE_INTEGER(GTK_SHADOW_ETCHED_IN);
  DEFINE_INTEGER(GTK_SHADOW_ETCHED_OUT);
  DEFINE_INTEGER(GTK_STATE_NORMAL);
  DEFINE_INTEGER(GTK_STATE_ACTIVE);
  DEFINE_INTEGER(GTK_STATE_PRELIGHT);
  DEFINE_INTEGER(GTK_STATE_SELECTED);
  DEFINE_INTEGER(GTK_STATE_INSENSITIVE);
  DEFINE_INTEGER(GTK_TOOLBAR_ICONS);
  DEFINE_INTEGER(GTK_TOOLBAR_TEXT);
  DEFINE_INTEGER(GTK_TOOLBAR_BOTH);
  DEFINE_INTEGER(GTK_TOOLBAR_BOTH_HORIZ);
  DEFINE_INTEGER(GTK_UPDATE_CONTINUOUS);
  DEFINE_INTEGER(GTK_UPDATE_DISCONTINUOUS);
  DEFINE_INTEGER(GTK_UPDATE_DELAYED);
  DEFINE_INTEGER(GTK_WIN_POS_NONE);
  DEFINE_INTEGER(GTK_WIN_POS_CENTER);
  DEFINE_INTEGER(GTK_WIN_POS_MOUSE);
  DEFINE_INTEGER(GTK_WIN_POS_CENTER_ALWAYS);
  DEFINE_INTEGER(GTK_WIN_POS_CENTER_ON_PARENT);
  DEFINE_INTEGER(GTK_WINDOW_TOPLEVEL);
  DEFINE_INTEGER(GTK_WINDOW_POPUP);
  DEFINE_INTEGER(GTK_WRAP_NONE);
  DEFINE_INTEGER(GTK_WRAP_CHAR);
  DEFINE_INTEGER(GTK_WRAP_WORD);
  DEFINE_INTEGER(GTK_SORT_ASCENDING);
  DEFINE_INTEGER(GTK_SORT_DESCENDING);
  DEFINE_INTEGER(GTK_IMAGE_EMPTY);
  DEFINE_INTEGER(GTK_IMAGE_PIXMAP);
  DEFINE_INTEGER(GTK_IMAGE_IMAGE);
  DEFINE_INTEGER(GTK_IMAGE_PIXBUF);
  DEFINE_INTEGER(GTK_IMAGE_STOCK);
  DEFINE_INTEGER(GTK_IMAGE_ICON_SET);
  DEFINE_INTEGER(GTK_IMAGE_ANIMATION);
  DEFINE_INTEGER(GTK_MAX_COMPOSE_LEN);
  DEFINE_INTEGER(GTK_PRIORITY_RESIZE);
  DEFINE_INTEGER(GTK_MESSAGE_INFO);
  DEFINE_INTEGER(GTK_MESSAGE_WARNING);
  DEFINE_INTEGER(GTK_MESSAGE_QUESTION);
  DEFINE_INTEGER(GTK_MESSAGE_ERROR);
  DEFINE_INTEGER(GTK_BUTTONS_NONE);
  DEFINE_INTEGER(GTK_BUTTONS_OK);
  DEFINE_INTEGER(GTK_BUTTONS_CLOSE);
  DEFINE_INTEGER(GTK_BUTTONS_CANCEL);
  DEFINE_INTEGER(GTK_BUTTONS_YES_NO);
  DEFINE_INTEGER(GTK_BUTTONS_OK_CANCEL);
  DEFINE_INTEGER(GTK_NOTEBOOK_TAB_FIRST);
  DEFINE_INTEGER(GTK_NOTEBOOK_TAB_LAST);
  DEFINE_INTEGER(GTK_IN_DESTRUCTION);
  DEFINE_INTEGER(GTK_FLOATING);
  DEFINE_INTEGER(GTK_RESERVED_1);
  DEFINE_INTEGER(GTK_RESERVED_2);
  DEFINE_INTEGER(GTK_PROGRESS_LEFT_TO_RIGHT);
  DEFINE_INTEGER(GTK_PROGRESS_RIGHT_TO_LEFT);
  DEFINE_INTEGER(GTK_PROGRESS_BOTTOM_TO_TOP);
  DEFINE_INTEGER(GTK_PROGRESS_TOP_TO_BOTTOM);
  DEFINE_INTEGER(GTK_RC_FG);
  DEFINE_INTEGER(GTK_RC_BG);
  DEFINE_INTEGER(GTK_RC_TEXT);
  DEFINE_INTEGER(GTK_RC_BASE);
  DEFINE_INTEGER(GTK_RC_TOKEN_INVALID);
  DEFINE_INTEGER(GTK_RC_TOKEN_INCLUDE);
  DEFINE_INTEGER(GTK_RC_TOKEN_NORMAL);
  DEFINE_INTEGER(GTK_RC_TOKEN_ACTIVE);
  DEFINE_INTEGER(GTK_RC_TOKEN_PRELIGHT);
  DEFINE_INTEGER(GTK_RC_TOKEN_SELECTED);
  DEFINE_INTEGER(GTK_RC_TOKEN_INSENSITIVE);
  DEFINE_INTEGER(GTK_RC_TOKEN_FG);
  DEFINE_INTEGER(GTK_RC_TOKEN_BG);
  DEFINE_INTEGER(GTK_RC_TOKEN_TEXT);
  DEFINE_INTEGER(GTK_RC_TOKEN_BASE);
  DEFINE_INTEGER(GTK_RC_TOKEN_XTHICKNESS);
  DEFINE_INTEGER(GTK_RC_TOKEN_YTHICKNESS);
  DEFINE_INTEGER(GTK_RC_TOKEN_FONT);
  DEFINE_INTEGER(GTK_RC_TOKEN_FONTSET);
  DEFINE_INTEGER(GTK_RC_TOKEN_FONT_NAME);
  DEFINE_INTEGER(GTK_RC_TOKEN_BG_PIXMAP);
  DEFINE_INTEGER(GTK_RC_TOKEN_PIXMAP_PATH);
  DEFINE_INTEGER(GTK_RC_TOKEN_STYLE);
  DEFINE_INTEGER(GTK_RC_TOKEN_BINDING);
  DEFINE_INTEGER(GTK_RC_TOKEN_BIND);
  DEFINE_INTEGER(GTK_RC_TOKEN_WIDGET);
  DEFINE_INTEGER(GTK_RC_TOKEN_WIDGET_CLASS);
  DEFINE_INTEGER(GTK_RC_TOKEN_CLASS);
  DEFINE_INTEGER(GTK_RC_TOKEN_LOWEST);
  DEFINE_INTEGER(GTK_RC_TOKEN_GTK);
  DEFINE_INTEGER(GTK_RC_TOKEN_APPLICATION);
  DEFINE_INTEGER(GTK_RC_TOKEN_THEME);
  DEFINE_INTEGER(GTK_RC_TOKEN_RC);
  DEFINE_INTEGER(GTK_RC_TOKEN_HIGHEST);
  DEFINE_INTEGER(GTK_RC_TOKEN_ENGINE);
  DEFINE_INTEGER(GTK_RC_TOKEN_MODULE_PATH);
  DEFINE_INTEGER(GTK_RC_TOKEN_IM_MODULE_PATH);
  DEFINE_INTEGER(GTK_RC_TOKEN_IM_MODULE_FILE);
  DEFINE_INTEGER(GTK_RC_TOKEN_STOCK);
  DEFINE_INTEGER(GTK_RC_TOKEN_LTR);
  DEFINE_INTEGER(GTK_RC_TOKEN_RTL);
  DEFINE_INTEGER(GTK_RC_TOKEN_LAST);
  DEFINE_INTEGER(GTK_SIZE_GROUP_NONE);
  DEFINE_INTEGER(GTK_SIZE_GROUP_HORIZONTAL);
  DEFINE_INTEGER(GTK_SIZE_GROUP_VERTICAL);
  DEFINE_INTEGER(GTK_SIZE_GROUP_BOTH);
  DEFINE_INTEGER(GTK_INPUT_ERROR);
  DEFINE_INTEGER(GTK_UPDATE_ALWAYS);
  DEFINE_INTEGER(GTK_UPDATE_IF_VALID);
  DEFINE_INTEGER(GTK_SPIN_STEP_FORWARD);
  DEFINE_INTEGER(GTK_SPIN_STEP_BACKWARD);
  DEFINE_INTEGER(GTK_SPIN_PAGE_FORWARD);
  DEFINE_INTEGER(GTK_SPIN_PAGE_BACKWARD);
  DEFINE_INTEGER(GTK_SPIN_HOME);
  DEFINE_INTEGER(GTK_SPIN_END);
  DEFINE_INTEGER(GTK_SPIN_USER_DEFINED);
  DEFINE_INTEGER(GTK_TEXT_SEARCH_VISIBLE_ONLY);
  DEFINE_INTEGER(GTK_TEXT_SEARCH_TEXT_ONLY);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_PRIVATE);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_WIDGET);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_TEXT);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_LEFT);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_RIGHT);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_TOP);
  DEFINE_INTEGER(GTK_TEXT_WINDOW_BOTTOM);
  DEFINE_INTEGER(GTK_TEXT_VIEW_PRIORITY_VALIDATE);
  DEFINE_INTEGER(GTK_TREE_MODEL_ITERS_PERSIST);
  DEFINE_INTEGER(GTK_TREE_MODEL_LIST_ONLY);
  DEFINE_INTEGER(GTK_TREE_VIEW_COLUMN_GROW_ONLY);
  DEFINE_INTEGER(GTK_TREE_VIEW_COLUMN_AUTOSIZE);
  DEFINE_INTEGER(GTK_TREE_VIEW_COLUMN_FIXED);
  DEFINE_INTEGER(GTK_TREE_VIEW_DROP_BEFORE);
  DEFINE_INTEGER(GTK_TREE_VIEW_DROP_AFTER);
  DEFINE_INTEGER(GTK_TREE_VIEW_DROP_INTO_OR_BEFORE);
  DEFINE_INTEGER(GTK_TREE_VIEW_DROP_INTO_OR_AFTER);
  DEFINE_INTEGER(GTK_MAJOR_VERSION);
  DEFINE_INTEGER(GTK_MINOR_VERSION);
  DEFINE_INTEGER(GTK_MICRO_VERSION);
  DEFINE_INTEGER(GTK_BINARY_AGE);
  DEFINE_INTEGER(GTK_INTERFACE_AGE);
  DEFINE_INTEGER(GTK_TOPLEVEL);
  DEFINE_INTEGER(GTK_NO_WINDOW);
  DEFINE_INTEGER(GTK_REALIZED);
  DEFINE_INTEGER(GTK_MAPPED);
  DEFINE_INTEGER(GTK_VISIBLE);
  DEFINE_INTEGER(GTK_SENSITIVE);
  DEFINE_INTEGER(GTK_PARENT_SENSITIVE);
  DEFINE_INTEGER(GTK_CAN_FOCUS);
  DEFINE_INTEGER(GTK_HAS_FOCUS);
  DEFINE_INTEGER(GTK_CAN_DEFAULT);
  DEFINE_INTEGER(GTK_HAS_DEFAULT);
  DEFINE_INTEGER(GTK_HAS_GRAB);
  DEFINE_INTEGER(GTK_RC_STYLE);
  DEFINE_INTEGER(GTK_COMPOSITE_CHILD);
  DEFINE_INTEGER(GTK_NO_REPARENT);
  DEFINE_INTEGER(GTK_APP_PAINTABLE);
  DEFINE_INTEGER(GTK_RECEIVES_DEFAULT);
  DEFINE_INTEGER(GTK_DOUBLE_BUFFERED);
  DEFINE_INTEGER(GTK_WIDGET_HELP_TOOLTIP);
  DEFINE_INTEGER(GTK_WIDGET_HELP_WHATS_THIS);
  DEFINE_INTEGER(PANGO_ATTR_INVALID);
  DEFINE_INTEGER(PANGO_ATTR_LANGUAGE);
  DEFINE_INTEGER(PANGO_ATTR_FAMILY);
  DEFINE_INTEGER(PANGO_ATTR_STYLE);
  DEFINE_INTEGER(PANGO_ATTR_WEIGHT);
  DEFINE_INTEGER(PANGO_ATTR_VARIANT);
  DEFINE_INTEGER(PANGO_ATTR_STRETCH);
  DEFINE_INTEGER(PANGO_ATTR_SIZE);
  DEFINE_INTEGER(PANGO_ATTR_FONT_DESC);
  DEFINE_INTEGER(PANGO_ATTR_FOREGROUND);
  DEFINE_INTEGER(PANGO_ATTR_BACKGROUND);
  DEFINE_INTEGER(PANGO_ATTR_UNDERLINE);
  DEFINE_INTEGER(PANGO_ATTR_STRIKETHROUGH);
  DEFINE_INTEGER(PANGO_ATTR_RISE);
  DEFINE_INTEGER(PANGO_ATTR_SHAPE);
  DEFINE_INTEGER(PANGO_ATTR_SCALE);
  DEFINE_INTEGER(PANGO_UNDERLINE_NONE);
  DEFINE_INTEGER(PANGO_UNDERLINE_SINGLE);
  DEFINE_INTEGER(PANGO_UNDERLINE_DOUBLE);
  DEFINE_INTEGER(PANGO_UNDERLINE_LOW);
  DEFINE_INTEGER(PANGO_COVERAGE_NONE);
  DEFINE_INTEGER(PANGO_COVERAGE_FALLBACK);
  DEFINE_INTEGER(PANGO_COVERAGE_APPROXIMATE);
  DEFINE_INTEGER(PANGO_COVERAGE_EXACT);
  DEFINE_INTEGER(PANGO_STYLE_NORMAL);
  DEFINE_INTEGER(PANGO_STYLE_OBLIQUE);
  DEFINE_INTEGER(PANGO_STYLE_ITALIC);
  DEFINE_INTEGER(PANGO_VARIANT_NORMAL);
  DEFINE_INTEGER(PANGO_VARIANT_SMALL_CAPS);
  DEFINE_INTEGER(PANGO_WEIGHT_ULTRALIGHT);
  DEFINE_INTEGER(PANGO_WEIGHT_LIGHT);
  DEFINE_INTEGER(PANGO_WEIGHT_NORMAL);
  DEFINE_INTEGER(PANGO_WEIGHT_BOLD);
  DEFINE_INTEGER(PANGO_WEIGHT_ULTRABOLD);
  DEFINE_INTEGER(PANGO_WEIGHT_HEAVY);
  DEFINE_INTEGER(PANGO_STRETCH_ULTRA_CONDENSED);
  DEFINE_INTEGER(PANGO_STRETCH_EXTRA_CONDENSED);
  DEFINE_INTEGER(PANGO_STRETCH_CONDENSED);
  DEFINE_INTEGER(PANGO_STRETCH_SEMI_CONDENSED);
  DEFINE_INTEGER(PANGO_STRETCH_NORMAL);
  DEFINE_INTEGER(PANGO_STRETCH_SEMI_EXPANDED);
  DEFINE_INTEGER(PANGO_STRETCH_EXPANDED);
  DEFINE_INTEGER(PANGO_STRETCH_EXTRA_EXPANDED);
  DEFINE_INTEGER(PANGO_STRETCH_ULTRA_EXPANDED);
  DEFINE_INTEGER(PANGO_FONT_MASK_FAMILY);
  DEFINE_INTEGER(PANGO_FONT_MASK_STYLE);
  DEFINE_INTEGER(PANGO_FONT_MASK_VARIANT);
  DEFINE_INTEGER(PANGO_FONT_MASK_WEIGHT);
  DEFINE_INTEGER(PANGO_FONT_MASK_STRETCH);
  DEFINE_INTEGER(PANGO_FONT_MASK_SIZE);
  DEFINE_INTEGER(PANGO_ALIGN_LEFT);
  DEFINE_INTEGER(PANGO_ALIGN_CENTER);
  DEFINE_INTEGER(PANGO_ALIGN_RIGHT);
  DEFINE_INTEGER(PANGO_WRAP_WORD);
  DEFINE_INTEGER(PANGO_WRAP_CHAR);
  DEFINE_INTEGER(PANGO_DIRECTION_LTR);
  DEFINE_INTEGER(PANGO_DIRECTION_RTL);
  DEFINE_INTEGER(PANGO_DIRECTION_TTB_LTR);
  DEFINE_INTEGER(PANGO_DIRECTION_TTB_RTL);
  DEFINE_INTEGER(G_NORMALIZE_DEFAULT);
  DEFINE_INTEGER(G_NORMALIZE_NFD);
  DEFINE_INTEGER(G_NORMALIZE_DEFAULT_COMPOSE);
  DEFINE_INTEGER(G_NORMALIZE_NFC);
  DEFINE_INTEGER(G_NORMALIZE_ALL);
  DEFINE_INTEGER(G_NORMALIZE_NFKD);
  DEFINE_INTEGER(G_NORMALIZE_ALL_COMPOSE);
  DEFINE_INTEGER(G_NORMALIZE_NFKC);
  DEFINE_INTEGER(G_PRIORITY_HIGH);
  DEFINE_INTEGER(G_PRIORITY_DEFAULT);
  DEFINE_INTEGER(G_PRIORITY_HIGH_IDLE);
  DEFINE_INTEGER(G_PRIORITY_DEFAULT_IDLE);
  DEFINE_INTEGER(G_PRIORITY_LOW);
#if HAVE_GTK_TREE_VIEW_COLUMN_CELL_GET_POSITION
  DEFINE_INTEGER(GTK_CELL_RENDERER_FOCUSED);
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
  DEFINE_INTEGER(GDK_WINDOW_STATE_FULLSCREEN);
  DEFINE_INTEGER(GDK_WINDOW_STATE_ABOVE);
  DEFINE_INTEGER(GDK_WINDOW_STATE_BELOW);
  DEFINE_INTEGER(GTK_MOVEMENT_HORIZONTAL_PAGES);
  DEFINE_INTEGER(GTK_SCROLL_STEPS);
  DEFINE_INTEGER(GTK_SCROLL_PAGES);
  DEFINE_INTEGER(GTK_SCROLL_ENDS);
  DEFINE_INTEGER(GTK_SCROLL_HORIZONTAL_STEPS);
  DEFINE_INTEGER(GTK_SCROLL_HORIZONTAL_PAGES);
  DEFINE_INTEGER(GTK_SCROLL_HORIZONTAL_ENDS);
  DEFINE_INTEGER(GTK_WRAP_WORD_CHAR);
  DEFINE_INTEGER(GTK_NO_SHOW_ALL);
  DEFINE_INTEGER(GTK_UI_MANAGER_AUTO);
  DEFINE_INTEGER(GTK_UI_MANAGER_MENUBAR);
  DEFINE_INTEGER(GTK_UI_MANAGER_MENU);
  DEFINE_INTEGER(GTK_UI_MANAGER_TOOLBAR);
  DEFINE_INTEGER(GTK_UI_MANAGER_PLACEHOLDER);
  DEFINE_INTEGER(GTK_UI_MANAGER_POPUP);
  DEFINE_INTEGER(GTK_UI_MANAGER_MENUITEM);
  DEFINE_INTEGER(GTK_UI_MANAGER_TOOLITEM);
  DEFINE_INTEGER(GTK_UI_MANAGER_SEPARATOR);
  DEFINE_INTEGER(GTK_UI_MANAGER_ACCELERATOR);
  DEFINE_INTEGER(GTK_FILE_FILTER_FILENAME);
  DEFINE_INTEGER(GTK_FILE_FILTER_URI);
  DEFINE_INTEGER(GTK_FILE_FILTER_DISPLAY_NAME);
  DEFINE_INTEGER(GTK_FILE_FILTER_MIME_TYPE);
  DEFINE_INTEGER(GTK_ICON_LOOKUP_NO_SVG);
  DEFINE_INTEGER(GTK_ICON_LOOKUP_FORCE_SVG);
  DEFINE_INTEGER(GTK_ICON_LOOKUP_USE_BUILTIN);
  DEFINE_INTEGER(GTK_FILE_CHOOSER_ACTION_OPEN);
  DEFINE_INTEGER(GTK_FILE_CHOOSER_ACTION_SAVE);
#endif

#if HAVE_GTK_COMBO_BOX_ENTRY_NEW_TEXT
  DEFINE_INTEGER(GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
  DEFINE_INTEGER(GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  DEFINE_INTEGER(GDK_OWNER_CHANGE);
#endif

#if HAVE_GTK_LABEL_SET_ELLIPSIZE
  DEFINE_INTEGER(PANGO_ATTR_FALLBACK);
  DEFINE_INTEGER(PANGO_ATTR_LETTER_SPACING);
  DEFINE_INTEGER(PANGO_UNDERLINE_ERROR);
  DEFINE_INTEGER(PANGO_WRAP_WORD_CHAR);
  DEFINE_INTEGER(PANGO_ELLIPSIZE_NONE);
  DEFINE_INTEGER(PANGO_ELLIPSIZE_START);
  DEFINE_INTEGER(PANGO_ELLIPSIZE_MIDDLE);
  DEFINE_INTEGER(PANGO_ELLIPSIZE_END);
  DEFINE_INTEGER(PANGO_SCRIPT_INVALID_CODE);
  DEFINE_INTEGER(PANGO_SCRIPT_COMMON);
  DEFINE_INTEGER(PANGO_SCRIPT_INHERITED);
  DEFINE_INTEGER(PANGO_SCRIPT_ARABIC);
  DEFINE_INTEGER(PANGO_SCRIPT_ARMENIAN);
  DEFINE_INTEGER(PANGO_SCRIPT_BENGALI);
  DEFINE_INTEGER(PANGO_SCRIPT_BOPOMOFO);
  DEFINE_INTEGER(PANGO_SCRIPT_CHEROKEE);
  DEFINE_INTEGER(PANGO_SCRIPT_COPTIC);
  DEFINE_INTEGER(PANGO_SCRIPT_CYRILLIC);
  DEFINE_INTEGER(PANGO_SCRIPT_DESERET);
  DEFINE_INTEGER(PANGO_SCRIPT_DEVANAGARI);
  DEFINE_INTEGER(PANGO_SCRIPT_ETHIOPIC);
  DEFINE_INTEGER(PANGO_SCRIPT_GEORGIAN);
  DEFINE_INTEGER(PANGO_SCRIPT_GOTHIC);
  DEFINE_INTEGER(PANGO_SCRIPT_GREEK);
  DEFINE_INTEGER(PANGO_SCRIPT_GUJARATI);
  DEFINE_INTEGER(PANGO_SCRIPT_GURMUKHI);
  DEFINE_INTEGER(PANGO_SCRIPT_HAN);
  DEFINE_INTEGER(PANGO_SCRIPT_HANGUL);
  DEFINE_INTEGER(PANGO_SCRIPT_HEBREW);
  DEFINE_INTEGER(PANGO_SCRIPT_HIRAGANA);
  DEFINE_INTEGER(PANGO_SCRIPT_KANNADA);
  DEFINE_INTEGER(PANGO_SCRIPT_KATAKANA);
  DEFINE_INTEGER(PANGO_SCRIPT_KHMER);
  DEFINE_INTEGER(PANGO_SCRIPT_LAO);
  DEFINE_INTEGER(PANGO_SCRIPT_LATIN);
  DEFINE_INTEGER(PANGO_SCRIPT_MALAYALAM);
  DEFINE_INTEGER(PANGO_SCRIPT_MONGOLIAN);
  DEFINE_INTEGER(PANGO_SCRIPT_MYANMAR);
  DEFINE_INTEGER(PANGO_SCRIPT_OGHAM);
  DEFINE_INTEGER(PANGO_SCRIPT_OLD_ITALIC);
  DEFINE_INTEGER(PANGO_SCRIPT_ORIYA);
  DEFINE_INTEGER(PANGO_SCRIPT_RUNIC);
  DEFINE_INTEGER(PANGO_SCRIPT_SINHALA);
  DEFINE_INTEGER(PANGO_SCRIPT_SYRIAC);
  DEFINE_INTEGER(PANGO_SCRIPT_TAMIL);
  DEFINE_INTEGER(PANGO_SCRIPT_TELUGU);
  DEFINE_INTEGER(PANGO_SCRIPT_THAANA);
  DEFINE_INTEGER(PANGO_SCRIPT_THAI);
  DEFINE_INTEGER(PANGO_SCRIPT_TIBETAN);
  DEFINE_INTEGER(PANGO_SCRIPT_CANADIAN_ABORIGINAL);
  DEFINE_INTEGER(PANGO_SCRIPT_YI);
  DEFINE_INTEGER(PANGO_SCRIPT_TAGALOG);
  DEFINE_INTEGER(PANGO_SCRIPT_HANUNOO);
  DEFINE_INTEGER(PANGO_SCRIPT_BUHID);
  DEFINE_INTEGER(PANGO_SCRIPT_TAGBANWA);
  DEFINE_INTEGER(PANGO_SCRIPT_BRAILLE);
  DEFINE_INTEGER(PANGO_SCRIPT_CYPRIOT);
  DEFINE_INTEGER(PANGO_SCRIPT_LIMBU);
  DEFINE_INTEGER(PANGO_SCRIPT_OSMANYA);
  DEFINE_INTEGER(PANGO_SCRIPT_SHAVIAN);
  DEFINE_INTEGER(PANGO_SCRIPT_LINEAR_B);
  DEFINE_INTEGER(PANGO_SCRIPT_TAI_LE);
  DEFINE_INTEGER(PANGO_SCRIPT_UGARITIC);
  DEFINE_INTEGER(PANGO_TAB_LEFT);
  DEFINE_INTEGER(PANGO_DIRECTION_WEAK_LTR);
  DEFINE_INTEGER(PANGO_DIRECTION_WEAK_RTL);
  DEFINE_INTEGER(PANGO_DIRECTION_NEUTRAL);
  DEFINE_INTEGER(GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID);
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
  DEFINE_INTEGER(GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID);
  DEFINE_INTEGER(GTK_IMAGE_ICON_NAME);
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
  DEFINE_INTEGER(PANGO_ATTR_UNDERLINE_COLOR);
  DEFINE_INTEGER(PANGO_ATTR_STRIKETHROUGH_COLOR);
  DEFINE_INTEGER(PANGO_RENDER_PART_FOREGROUND);
  DEFINE_INTEGER(PANGO_RENDER_PART_BACKGROUND);
  DEFINE_INTEGER(PANGO_RENDER_PART_UNDERLINE);
  DEFINE_INTEGER(PANGO_RENDER_PART_STRIKETHROUGH);
  DEFINE_INTEGER(G_LOG_FLAG_RECURSION);
  DEFINE_INTEGER(G_LOG_FLAG_FATAL);
  DEFINE_INTEGER(G_LOG_LEVEL_ERROR);
  DEFINE_INTEGER(G_LOG_LEVEL_CRITICAL);
  DEFINE_INTEGER(G_LOG_LEVEL_WARNING);
  DEFINE_INTEGER(G_LOG_LEVEL_MESSAGE);
  DEFINE_INTEGER(G_LOG_LEVEL_INFO);
  DEFINE_INTEGER(G_LOG_LEVEL_DEBUG);
  DEFINE_INTEGER(G_LOG_LEVEL_MASK);
  DEFINE_INTEGER(G_LOG_FATAL_MASK);
#endif

#if HAVE_GTK_TEXT_LAYOUT_GET_ITER_AT_POSITION
  DEFINE_INTEGER(PANGO_WEIGHT_SEMIBOLD);
#endif

  DEFINE_ULONG(GDK_TYPE_PIXBUF);
  DEFINE_ULONG(GDK_TYPE_PIXBUF_ANIMATION);
  DEFINE_ULONG(GDK_TYPE_PIXBUF_ANIMATION_ITER);
  DEFINE_ULONG(GDK_PIXBUF_ERROR);
  DEFINE_ULONG(GDK_TYPE_PIXBUF_LOADER);
  DEFINE_ULONG(GDK_TYPE_PIXBUF_ALPHA_MODE);
  DEFINE_ULONG(GDK_TYPE_COLORSPACE);
  DEFINE_ULONG(GDK_TYPE_PIXBUF_ERROR);
  DEFINE_ULONG(GDK_TYPE_INTERP_TYPE);
  DEFINE_ULONG(GTK_TYPE_ICON_SET);
  DEFINE_ULONG(GTK_TYPE_ICON_SOURCE);
  DEFINE_ULONG(GTK_TYPE_SELECTION_DATA);
  DEFINE_ULONG(GTK_TYPE_BORDER);
  DEFINE_ULONG(GTK_TYPE_TREE_ITER);
  DEFINE_ULONG(GTK_TYPE_TREE_PATH);
  DEFINE_ULONG(GTK_TYPE_IDENTIFIER);
  DEFINE_ULONG(GTK_TYPE_REQUISITION);
  DEFINE_ULONG(GTK_TYPE_ACCEL_GROUP);
  DEFINE_ULONG(GTK_TYPE_ACCEL_LABEL);
  DEFINE_ULONG(GTK_TYPE_ACCESSIBLE);
  DEFINE_ULONG(GTK_TYPE_ADJUSTMENT);
  DEFINE_ULONG(GTK_TYPE_ALIGNMENT);
  DEFINE_ULONG(GTK_TYPE_ARROW);
  DEFINE_ULONG(GTK_TYPE_ASPECT_FRAME);
  DEFINE_ULONG(GTK_TYPE_BUTTON_BOX);
  DEFINE_ULONG(GTK_TYPE_BIN);
  DEFINE_ULONG(GTK_TYPE_BOX);
  DEFINE_ULONG(GTK_TYPE_BUTTON);
  DEFINE_ULONG(GTK_TYPE_CALENDAR);
  DEFINE_ULONG(GTK_TYPE_CELL_EDITABLE);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER_PIXBUF);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER_TEXT);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER_TOGGLE);
  DEFINE_ULONG(GTK_TYPE_CHECK_BUTTON);
  DEFINE_ULONG(GTK_TYPE_CHECK_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_COLOR_SELECTION_DIALOG);
  DEFINE_ULONG(GTK_TYPE_COLOR_SELECTION);
  DEFINE_ULONG(GTK_TYPE_CONTAINER);
  DEFINE_ULONG(GTK_TYPE_CURVE);
  DEFINE_ULONG(GTK_TYPE_DIALOG);
  DEFINE_ULONG(GTK_TYPE_DRAWING_AREA);
  DEFINE_ULONG(GTK_TYPE_EDITABLE);
  DEFINE_ULONG(GTK_TYPE_ENTRY);
  DEFINE_ULONG(GTK_TYPE_EVENT_BOX);
  DEFINE_ULONG(GTK_TYPE_FILE_SELECTION);
  DEFINE_ULONG(GTK_TYPE_FIXED);
  DEFINE_ULONG(GTK_TYPE_FONT_SELECTION);
  DEFINE_ULONG(GTK_TYPE_FONT_SELECTION_DIALOG);
  DEFINE_ULONG(GTK_TYPE_FRAME);
  DEFINE_ULONG(GTK_TYPE_GAMMA_CURVE);
  DEFINE_ULONG(GTK_TYPE_HANDLE_BOX);
  DEFINE_ULONG(GTK_TYPE_HBUTTON_BOX);
  DEFINE_ULONG(GTK_TYPE_HBOX);
  DEFINE_ULONG(GTK_TYPE_HPANED);
  DEFINE_ULONG(GTK_TYPE_HRULER);
  DEFINE_ULONG(GTK_TYPE_HSCALE);
  DEFINE_ULONG(GTK_TYPE_HSCROLLBAR);
  DEFINE_ULONG(GTK_TYPE_HSEPARATOR);
  DEFINE_ULONG(GTK_TYPE_IMAGE);
  DEFINE_ULONG(GTK_TYPE_IMAGE_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_IM_CONTEXT);
  DEFINE_ULONG(GTK_TYPE_IM_CONTEXT_SIMPLE);
  DEFINE_ULONG(GTK_TYPE_IM_MULTICONTEXT);
  DEFINE_ULONG(GTK_TYPE_INPUT_DIALOG);
  DEFINE_ULONG(GTK_TYPE_INVISIBLE);
  DEFINE_ULONG(GTK_TYPE_ITEM);
  DEFINE_ULONG(GTK_TYPE_LABEL);
  DEFINE_ULONG(GTK_TYPE_LAYOUT);
  DEFINE_ULONG(GTK_TYPE_LIST_STORE);
  DEFINE_ULONG(GTK_TYPE_MENU_BAR);
  DEFINE_ULONG(GTK_TYPE_MENU);
  DEFINE_ULONG(GTK_TYPE_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_MENU_SHELL);
  DEFINE_ULONG(GTK_TYPE_MESSAGE_DIALOG);
  DEFINE_ULONG(GTK_TYPE_MISC);
  DEFINE_ULONG(GTK_TYPE_NOTEBOOK);
  DEFINE_ULONG(GTK_TYPE_OBJECT);
  DEFINE_ULONG(GTK_TYPE_PANED);
  DEFINE_ULONG(GTK_TYPE_PLUG);
  DEFINE_ULONG(GTK_TYPE_PROGRESS_BAR);
  DEFINE_ULONG(GTK_TYPE_RADIO_BUTTON);
  DEFINE_ULONG(GTK_TYPE_RADIO_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_RANGE);
  DEFINE_ULONG(GTK_TYPE_RC_STYLE);
  DEFINE_ULONG(GTK_TYPE_RULER);
  DEFINE_ULONG(GTK_TYPE_SCALE);
  DEFINE_ULONG(GTK_TYPE_SCROLLBAR);
  DEFINE_ULONG(GTK_TYPE_SCROLLED_WINDOW);
  DEFINE_ULONG(GTK_TYPE_SEPARATOR);
  DEFINE_ULONG(GTK_TYPE_SEPARATOR_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_SIZE_GROUP);
  DEFINE_ULONG(GTK_TYPE_SOCKET);
  DEFINE_ULONG(GTK_TYPE_SPIN_BUTTON);
  DEFINE_ULONG(GTK_TYPE_STATUSBAR);
  DEFINE_ULONG(GTK_TYPE_STYLE);
  DEFINE_ULONG(GTK_TYPE_TABLE);
  DEFINE_ULONG(GTK_TYPE_TEAROFF_MENU_ITEM);
  DEFINE_ULONG(GTK_TYPE_TEXT_BUFFER);
  DEFINE_ULONG(GTK_TYPE_TEXT_CHILD_ANCHOR);
  DEFINE_ULONG(GTK_TYPE_TEXT_MARK);
  DEFINE_ULONG(GTK_TYPE_TEXT_TAG);
  DEFINE_ULONG(GTK_TYPE_TEXT_TAG_TABLE);
  DEFINE_ULONG(GTK_TYPE_TEXT_VIEW);
  DEFINE_ULONG(GTK_TYPE_TOGGLE_BUTTON);
  DEFINE_ULONG(GTK_TYPE_TOOLBAR);
  DEFINE_ULONG(GTK_TYPE_TOOLTIPS);
  DEFINE_ULONG(GTK_TYPE_TREE_DRAG_SOURCE);
  DEFINE_ULONG(GTK_TYPE_TREE_DRAG_DEST);
  DEFINE_ULONG(GTK_TYPE_TREE_MODEL);
  DEFINE_ULONG(GTK_TYPE_TREE_MODEL_SORT);
  DEFINE_ULONG(GTK_TYPE_TREE_SELECTION);
  DEFINE_ULONG(GTK_TYPE_TREE_SORTABLE);
  DEFINE_ULONG(GTK_TYPE_TREE_STORE);
  DEFINE_ULONG(GTK_TYPE_TREE_VIEW_COLUMN);
  DEFINE_ULONG(GTK_TYPE_TREE_VIEW);
  DEFINE_ULONG(GTK_TYPE_VBUTTON_BOX);
  DEFINE_ULONG(GTK_TYPE_VBOX);
  DEFINE_ULONG(GTK_TYPE_VIEWPORT);
  DEFINE_ULONG(GTK_TYPE_VPANED);
  DEFINE_ULONG(GTK_TYPE_VRULER);
  DEFINE_ULONG(GTK_TYPE_VSCALE);
  DEFINE_ULONG(GTK_TYPE_VSCROLLBAR);
  DEFINE_ULONG(GTK_TYPE_VSEPARATOR);
  DEFINE_ULONG(GTK_TYPE_WIDGET);
  DEFINE_ULONG(GTK_TYPE_WINDOW);
  DEFINE_ULONG(GTK_TYPE_WINDOW_GROUP);
  DEFINE_ULONG(GDK_TYPE_COLORMAP);
  DEFINE_ULONG(GDK_TYPE_COLOR);
  DEFINE_ULONG(GDK_TYPE_CURSOR);
  DEFINE_ULONG(GDK_TYPE_DRAG_CONTEXT);
  DEFINE_ULONG(GDK_TYPE_DRAWABLE);
  DEFINE_ULONG(GDK_TYPE_CURSOR_TYPE);
  DEFINE_ULONG(GDK_TYPE_DRAG_ACTION);
  DEFINE_ULONG(GDK_TYPE_DRAG_PROTOCOL);
  DEFINE_ULONG(GDK_TYPE_FILTER_RETURN);
  DEFINE_ULONG(GDK_TYPE_EVENT_TYPE);
  DEFINE_ULONG(GDK_TYPE_EVENT_MASK);
  DEFINE_ULONG(GDK_TYPE_VISIBILITY_STATE);
  DEFINE_ULONG(GDK_TYPE_SCROLL_DIRECTION);
  DEFINE_ULONG(GDK_TYPE_NOTIFY_TYPE);
  DEFINE_ULONG(GDK_TYPE_CROSSING_MODE);
  DEFINE_ULONG(GDK_TYPE_PROPERTY_STATE);
  DEFINE_ULONG(GDK_TYPE_WINDOW_STATE);
  DEFINE_ULONG(GDK_TYPE_SETTING_ACTION);
  DEFINE_ULONG(GDK_TYPE_FONT_TYPE);
  DEFINE_ULONG(GDK_TYPE_CAP_STYLE);
  DEFINE_ULONG(GDK_TYPE_FILL);
  DEFINE_ULONG(GDK_TYPE_FUNCTION);
  DEFINE_ULONG(GDK_TYPE_JOIN_STYLE);
  DEFINE_ULONG(GDK_TYPE_LINE_STYLE);
  DEFINE_ULONG(GDK_TYPE_SUBWINDOW_MODE);
  DEFINE_ULONG(GDK_TYPE_GC_VALUES_MASK);
  DEFINE_ULONG(GDK_TYPE_IMAGE_TYPE);
  DEFINE_ULONG(GDK_TYPE_EXTENSION_MODE);
  DEFINE_ULONG(GDK_TYPE_INPUT_SOURCE);
  DEFINE_ULONG(GDK_TYPE_INPUT_MODE);
  DEFINE_ULONG(GDK_TYPE_AXIS_USE);
  DEFINE_ULONG(GDK_TYPE_PROP_MODE);
  DEFINE_ULONG(GDK_TYPE_FILL_RULE);
  DEFINE_ULONG(GDK_TYPE_OVERLAP_TYPE);
  DEFINE_ULONG(GDK_TYPE_RGB_DITHER);
  DEFINE_ULONG(GDK_TYPE_BYTE_ORDER);
  DEFINE_ULONG(GDK_TYPE_MODIFIER_TYPE);
  DEFINE_ULONG(GDK_TYPE_INPUT_CONDITION);
  DEFINE_ULONG(GDK_TYPE_STATUS);
  DEFINE_ULONG(GDK_TYPE_GRAB_STATUS);
  DEFINE_ULONG(GDK_TYPE_VISUAL_TYPE);
  DEFINE_ULONG(GDK_TYPE_WINDOW_CLASS);
  DEFINE_ULONG(GDK_TYPE_WINDOW_TYPE);
  DEFINE_ULONG(GDK_TYPE_WINDOW_ATTRIBUTES_TYPE);
  DEFINE_ULONG(GDK_TYPE_WINDOW_HINTS);
  DEFINE_ULONG(GDK_TYPE_WINDOW_TYPE_HINT);
  DEFINE_ULONG(GDK_TYPE_WM_DECORATION);
  DEFINE_ULONG(GDK_TYPE_WM_FUNCTION);
  DEFINE_ULONG(GDK_TYPE_GRAVITY);
  DEFINE_ULONG(GDK_TYPE_WINDOW_EDGE);
  DEFINE_ULONG(GDK_TYPE_EVENT);
  DEFINE_ULONG(GDK_TYPE_GC);
  DEFINE_ULONG(GDK_TYPE_RECTANGLE);
  DEFINE_ULONG(GDK_TYPE_IMAGE);
  DEFINE_ULONG(GDK_TYPE_DEVICE);
  DEFINE_ULONG(GDK_TYPE_KEYMAP);
  DEFINE_ULONG(GDK_TYPE_PIXMAP);
  DEFINE_ULONG(GDK_TYPE_VISUAL);
  DEFINE_ULONG(GDK_TYPE_WINDOW);
  DEFINE_ULONG(G_TYPE_IO_CONDITION);
  DEFINE_ULONG(G_TYPE_INVALID);
  DEFINE_ULONG(G_TYPE_NONE);
  DEFINE_ULONG(G_TYPE_INTERFACE);
  DEFINE_ULONG(G_TYPE_CHAR);
  DEFINE_ULONG(G_TYPE_UCHAR);
  DEFINE_ULONG(G_TYPE_BOOLEAN);
  DEFINE_ULONG(G_TYPE_INT);
  DEFINE_ULONG(G_TYPE_UINT);
  DEFINE_ULONG(G_TYPE_LONG);
  DEFINE_ULONG(G_TYPE_ULONG);
  DEFINE_ULONG(G_TYPE_INT64);
  DEFINE_ULONG(G_TYPE_UINT64);
  DEFINE_ULONG(G_TYPE_ENUM);
  DEFINE_ULONG(G_TYPE_FLAGS);
  DEFINE_ULONG(G_TYPE_FLOAT);
  DEFINE_ULONG(G_TYPE_DOUBLE);
  DEFINE_ULONG(G_TYPE_STRING);
  DEFINE_ULONG(G_TYPE_POINTER);
  DEFINE_ULONG(G_TYPE_BOXED);
  DEFINE_ULONG(G_TYPE_PARAM);
  DEFINE_ULONG(G_TYPE_OBJECT);
  DEFINE_ULONG(G_UNICODE_CONTROL);
  DEFINE_ULONG(G_UNICODE_FORMAT);
  DEFINE_ULONG(G_UNICODE_UNASSIGNED);
  DEFINE_ULONG(G_UNICODE_PRIVATE_USE);
  DEFINE_ULONG(G_UNICODE_SURROGATE);
  DEFINE_ULONG(G_UNICODE_LOWERCASE_LETTER);
  DEFINE_ULONG(G_UNICODE_MODIFIER_LETTER);
  DEFINE_ULONG(G_UNICODE_OTHER_LETTER);
  DEFINE_ULONG(G_UNICODE_TITLECASE_LETTER);
  DEFINE_ULONG(G_UNICODE_UPPERCASE_LETTER);
  DEFINE_ULONG(G_UNICODE_COMBINING_MARK);
  DEFINE_ULONG(G_UNICODE_ENCLOSING_MARK);
  DEFINE_ULONG(G_UNICODE_NON_SPACING_MARK);
  DEFINE_ULONG(G_UNICODE_DECIMAL_NUMBER);
  DEFINE_ULONG(G_UNICODE_LETTER_NUMBER);
  DEFINE_ULONG(G_UNICODE_OTHER_NUMBER);
  DEFINE_ULONG(G_UNICODE_CONNECT_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_DASH_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_CLOSE_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_FINAL_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_INITIAL_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_OTHER_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_OPEN_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_CURRENCY_SYMBOL);
  DEFINE_ULONG(G_UNICODE_MODIFIER_SYMBOL);
  DEFINE_ULONG(G_UNICODE_MATH_SYMBOL);
  DEFINE_ULONG(G_UNICODE_OTHER_SYMBOL);
  DEFINE_ULONG(G_UNICODE_LINE_SEPARATOR);
  DEFINE_ULONG(G_UNICODE_PARAGRAPH_SEPARATOR);
  DEFINE_ULONG(G_UNICODE_SPACE_SEPARATOR);
  DEFINE_ULONG(G_UNICODE_BREAK_MANDATORY);
  DEFINE_ULONG(G_UNICODE_BREAK_CARRIAGE_RETURN);
  DEFINE_ULONG(G_UNICODE_BREAK_LINE_FEED);
  DEFINE_ULONG(G_UNICODE_BREAK_COMBINING_MARK);
  DEFINE_ULONG(G_UNICODE_BREAK_SURROGATE);
  DEFINE_ULONG(G_UNICODE_BREAK_ZERO_WIDTH_SPACE);
  DEFINE_ULONG(G_UNICODE_BREAK_INSEPARABLE);
  DEFINE_ULONG(G_UNICODE_BREAK_NON_BREAKING_GLUE);
  DEFINE_ULONG(G_UNICODE_BREAK_CONTINGENT);
  DEFINE_ULONG(G_UNICODE_BREAK_SPACE);
  DEFINE_ULONG(G_UNICODE_BREAK_AFTER);
  DEFINE_ULONG(G_UNICODE_BREAK_BEFORE);
  DEFINE_ULONG(G_UNICODE_BREAK_BEFORE_AND_AFTER);
  DEFINE_ULONG(G_UNICODE_BREAK_HYPHEN);
  DEFINE_ULONG(G_UNICODE_BREAK_NON_STARTER);
  DEFINE_ULONG(G_UNICODE_BREAK_OPEN_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_BREAK_CLOSE_PUNCTUATION);
  DEFINE_ULONG(G_UNICODE_BREAK_QUOTATION);
  DEFINE_ULONG(G_UNICODE_BREAK_EXCLAMATION);
  DEFINE_ULONG(G_UNICODE_BREAK_IDEOGRAPHIC);
  DEFINE_ULONG(G_UNICODE_BREAK_NUMERIC);
  DEFINE_ULONG(G_UNICODE_BREAK_INFIX_SEPARATOR);
  DEFINE_ULONG(G_UNICODE_BREAK_SYMBOL);
  DEFINE_ULONG(G_UNICODE_BREAK_ALPHABETIC);
  DEFINE_ULONG(G_UNICODE_BREAK_PREFIX);
  DEFINE_ULONG(G_UNICODE_BREAK_POSTFIX);
  DEFINE_ULONG(G_UNICODE_BREAK_COMPLEX_CONTEXT);
  DEFINE_ULONG(G_UNICODE_BREAK_AMBIGUOUS);
  DEFINE_ULONG(G_UNICODE_BREAK_UNKNOWN);
#if HAVE_GDK_DRAW_PIXBUF
  DEFINE_ULONG(GDK_TYPE_SCREEN);
  DEFINE_ULONG(GDK_TYPE_DISPLAY);
#endif

#if HAVE_GTK_FILE_CHOOSER_DIALOG_NEW
  DEFINE_ULONG(GTK_TYPE_FILE_CHOOSER_DIALOG);
  DEFINE_ULONG(GTK_TYPE_FILE_CHOOSER_WIDGET);
  DEFINE_ULONG(GTK_TYPE_TREE_MODEL_FILTER);
  DEFINE_ULONG(GTK_TYPE_ACTION);
  DEFINE_ULONG(GTK_TYPE_ACTION_GROUP);
  DEFINE_ULONG(GTK_TYPE_COMBO_BOX);
  DEFINE_ULONG(GTK_TYPE_COMBO_BOX_ENTRY);
  DEFINE_ULONG(GTK_TYPE_EXPANDER);
  DEFINE_ULONG(GTK_TYPE_FONT_BUTTON);
  DEFINE_ULONG(GTK_TYPE_COLOR_BUTTON);
  DEFINE_ULONG(GTK_TYPE_ENTRY_COMPLETION);
  DEFINE_ULONG(GTK_TYPE_UI_MANAGER);
  DEFINE_ULONG(GTK_TYPE_RADIO_TOOL_BUTTON);
  DEFINE_ULONG(GTK_TYPE_RADIO_ACTION);
  DEFINE_ULONG(GTK_TYPE_SEPARATOR_TOOL_ITEM);
  DEFINE_ULONG(GTK_TYPE_TOGGLE_ACTION);
  DEFINE_ULONG(GTK_TYPE_TOGGLE_TOOL_BUTTON);
  DEFINE_ULONG(GTK_TYPE_FILE_FILTER);
  DEFINE_ULONG(GTK_TYPE_CELL_LAYOUT);
  DEFINE_ULONG(GTK_TYPE_CLIPBOARD);
  DEFINE_ULONG(GTK_TYPE_FILE_CHOOSER);
  DEFINE_ULONG(GTK_TYPE_ICON_INFO);
  DEFINE_ULONG(GTK_TYPE_ICON_THEME);
  DEFINE_ULONG(GTK_TYPE_TOOL_BUTTON);
  DEFINE_ULONG(GTK_TYPE_TOOL_ITEM);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  DEFINE_ULONG(GTK_TYPE_CELL_VIEW);
  DEFINE_ULONG(GTK_TYPE_ABOUT_DIALOG);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER_COMBO);
  DEFINE_ULONG(GTK_TYPE_CELL_RENDERER_PROGRESS);
  DEFINE_ULONG(GTK_TYPE_ICON_VIEW);
#endif

#if HAVE_GTK_FILE_CHOOSER_BUTTON_NEW
  DEFINE_ULONG(GTK_TYPE_FILE_CHOOSER_BUTTON);
#endif

#if HAVE_GTK_MENU_TOOL_BUTTON_NEW
  DEFINE_ULONG(GTK_TYPE_MENU_TOOL_BUTTON);
#endif

#if HAVE_GDK_PANGO_RENDERER_NEW
  DEFINE_ULONG(GDK_TYPE_PANGO_RENDERER);
  DEFINE_ULONG(PANGO_TYPE_RENDERER);
  DEFINE_ULONG(PANGO_TYPE_RENDER_PART);
#endif

}

static void define_doubles(void)
{

#if HAVE_GUILE
#if HAVE_SCM_C_DEFINE
  #define DEFINE_DOUBLE(Name) scm_c_define(XG_PRE #Name XG_POST, C_TO_XEN_DOUBLE(Name))
#else
  #define DEFINE_DOUBLE(Name) gh_define(XG_PRE #Name XG_POST, C_TO_XEN_DOUBLE(Name))
#endif
#else
  #define DEFINE_DOUBLE(Name) rb_define_global_const(XG_PRE #Name XG_POST, C_TO_XEN_DOUBLE(Name))
#endif

  DEFINE_DOUBLE(PANGO_SCALE_XX_SMALL);
  DEFINE_DOUBLE(PANGO_SCALE_X_SMALL);
  DEFINE_DOUBLE(PANGO_SCALE_SMALL);
  DEFINE_DOUBLE(PANGO_SCALE_MEDIUM);
  DEFINE_DOUBLE(PANGO_SCALE_LARGE);
  DEFINE_DOUBLE(PANGO_SCALE_X_LARGE);
  DEFINE_DOUBLE(PANGO_SCALE_XX_LARGE);
}

/* -------------------------------- predefined Atoms -------------------------------- */

static void define_atoms(void)
{
#if HAVE_GUILE
#if HAVE_SCM_C_DEFINE
  #define DEFINE_ATOM(Name) scm_permanent_object(scm_c_define(XG_PRE #Name XG_POST, C_TO_XEN_GdkAtom(Name)))
#else
  #define DEFINE_ATOM(Name) gh_define(XG_PRE #Name XG_POST, C_TO_XEN_GdkAtom(Name))
#endif
#else
  #define DEFINE_ATOM(Name) rb_define_global_const(XG_PRE #Name XG_POST, C_TO_XEN_GdkAtom(Name))
#endif

  DEFINE_ATOM(GDK_SELECTION_PRIMARY);
  DEFINE_ATOM(GDK_SELECTION_SECONDARY);
  DEFINE_ATOM(GDK_SELECTION_CLIPBOARD);
  DEFINE_ATOM(GDK_TARGET_BITMAP);
  DEFINE_ATOM(GDK_TARGET_COLORMAP);
  DEFINE_ATOM(GDK_TARGET_DRAWABLE);
  DEFINE_ATOM(GDK_TARGET_PIXMAP);
  DEFINE_ATOM(GDK_TARGET_STRING);
  DEFINE_ATOM(GDK_SELECTION_TYPE_ATOM);
  DEFINE_ATOM(GDK_SELECTION_TYPE_BITMAP);
  DEFINE_ATOM(GDK_SELECTION_TYPE_COLORMAP);
  DEFINE_ATOM(GDK_SELECTION_TYPE_DRAWABLE);
  DEFINE_ATOM(GDK_SELECTION_TYPE_INTEGER);
  DEFINE_ATOM(GDK_SELECTION_TYPE_PIXMAP);
  DEFINE_ATOM(GDK_SELECTION_TYPE_WINDOW);
  DEFINE_ATOM(GDK_SELECTION_TYPE_STRING);
  DEFINE_ATOM(GDK_NONE);
}

/* -------------------------------- strings -------------------------------- */

static void define_strings(void)
{
  
#if HAVE_GUILE
#if HAVE_SCM_C_DEFINE
  #define DEFINE_STRING(Name) scm_c_define(XG_PRE #Name XG_POST, C_TO_XEN_STRING(Name))
#else
  #define DEFINE_STRING(Name) gh_define(XG_PRE #Name XG_POST, C_TO_XEN_STRING(Name))
#endif
#else
  #define DEFINE_STRING(Name) rb_define_global_const(XG_PRE #Name XG_POST, C_TO_XEN_STRING(Name))
#endif
  DEFINE_STRING(GDK_PIXBUF_VERSION);
  DEFINE_STRING(GTK_STOCK_DIALOG_INFO);
  DEFINE_STRING(GTK_STOCK_DIALOG_WARNING);
  DEFINE_STRING(GTK_STOCK_DIALOG_ERROR);
  DEFINE_STRING(GTK_STOCK_DIALOG_QUESTION);
  DEFINE_STRING(GTK_STOCK_DND);
  DEFINE_STRING(GTK_STOCK_DND_MULTIPLE);
  DEFINE_STRING(GTK_STOCK_ADD);
  DEFINE_STRING(GTK_STOCK_APPLY);
  DEFINE_STRING(GTK_STOCK_BOLD);
  DEFINE_STRING(GTK_STOCK_CANCEL);
  DEFINE_STRING(GTK_STOCK_CDROM);
  DEFINE_STRING(GTK_STOCK_CLEAR);
  DEFINE_STRING(GTK_STOCK_CLOSE);
  DEFINE_STRING(GTK_STOCK_CONVERT);
  DEFINE_STRING(GTK_STOCK_COPY);
  DEFINE_STRING(GTK_STOCK_CUT);
  DEFINE_STRING(GTK_STOCK_DELETE);
  DEFINE_STRING(GTK_STOCK_EXECUTE);
  DEFINE_STRING(GTK_STOCK_FIND);
  DEFINE_STRING(GTK_STOCK_FIND_AND_REPLACE);
  DEFINE_STRING(GTK_STOCK_FLOPPY);
  DEFINE_STRING(GTK_STOCK_GOTO_BOTTOM);
  DEFINE_STRING(GTK_STOCK_GOTO_FIRST);
  DEFINE_STRING(GTK_STOCK_GOTO_LAST);
  DEFINE_STRING(GTK_STOCK_GOTO_TOP);
  DEFINE_STRING(GTK_STOCK_GO_BACK);
  DEFINE_STRING(GTK_STOCK_GO_DOWN);
  DEFINE_STRING(GTK_STOCK_GO_FORWARD);
  DEFINE_STRING(GTK_STOCK_GO_UP);
  DEFINE_STRING(GTK_STOCK_HELP);
  DEFINE_STRING(GTK_STOCK_HOME);
  DEFINE_STRING(GTK_STOCK_INDEX);
  DEFINE_STRING(GTK_STOCK_ITALIC);
  DEFINE_STRING(GTK_STOCK_JUMP_TO);
  DEFINE_STRING(GTK_STOCK_JUSTIFY_CENTER);
  DEFINE_STRING(GTK_STOCK_JUSTIFY_FILL);
  DEFINE_STRING(GTK_STOCK_JUSTIFY_LEFT);
  DEFINE_STRING(GTK_STOCK_JUSTIFY_RIGHT);
  DEFINE_STRING(GTK_STOCK_MISSING_IMAGE);
  DEFINE_STRING(GTK_STOCK_NEW);
  DEFINE_STRING(GTK_STOCK_NO);
  DEFINE_STRING(GTK_STOCK_OK);
  DEFINE_STRING(GTK_STOCK_OPEN);
  DEFINE_STRING(GTK_STOCK_PASTE);
  DEFINE_STRING(GTK_STOCK_PREFERENCES);
  DEFINE_STRING(GTK_STOCK_PRINT);
  DEFINE_STRING(GTK_STOCK_PRINT_PREVIEW);
  DEFINE_STRING(GTK_STOCK_PROPERTIES);
  DEFINE_STRING(GTK_STOCK_QUIT);
  DEFINE_STRING(GTK_STOCK_REDO);
  DEFINE_STRING(GTK_STOCK_REFRESH);
  DEFINE_STRING(GTK_STOCK_REMOVE);
  DEFINE_STRING(GTK_STOCK_REVERT_TO_SAVED);
  DEFINE_STRING(GTK_STOCK_SAVE);
  DEFINE_STRING(GTK_STOCK_SAVE_AS);
  DEFINE_STRING(GTK_STOCK_SELECT_COLOR);
  DEFINE_STRING(GTK_STOCK_SELECT_FONT);
  DEFINE_STRING(GTK_STOCK_SORT_ASCENDING);
  DEFINE_STRING(GTK_STOCK_SORT_DESCENDING);
  DEFINE_STRING(GTK_STOCK_SPELL_CHECK);
  DEFINE_STRING(GTK_STOCK_STOP);
  DEFINE_STRING(GTK_STOCK_STRIKETHROUGH);
  DEFINE_STRING(GTK_STOCK_UNDELETE);
  DEFINE_STRING(GTK_STOCK_UNDERLINE);
  DEFINE_STRING(GTK_STOCK_UNDO);
  DEFINE_STRING(GTK_STOCK_YES);
  DEFINE_STRING(GTK_STOCK_ZOOM_100);
  DEFINE_STRING(GTK_STOCK_ZOOM_FIT);
  DEFINE_STRING(GTK_STOCK_ZOOM_IN);
  DEFINE_STRING(GTK_STOCK_ZOOM_OUT);
#if HAVE_GTK_MENU_SHELL_CANCEL
  DEFINE_STRING(GTK_STOCK_COLOR_PICKER);
  DEFINE_STRING(GTK_STOCK_HARDDISK);
  DEFINE_STRING(GTK_STOCK_INDENT);
  DEFINE_STRING(GTK_STOCK_UNINDENT);
#endif

#if HAVE_GTK_COMBO_BOX_POPUP
  DEFINE_STRING(GTK_STOCK_NETWORK);
#endif

#if HAVE_GTK_ABOUT_DIALOG_NEW
  DEFINE_STRING(GTK_STOCK_ABOUT);
  DEFINE_STRING(GTK_STOCK_CONNECT);
  DEFINE_STRING(GTK_STOCK_DIRECTORY);
  DEFINE_STRING(GTK_STOCK_DISCONNECT);
  DEFINE_STRING(GTK_STOCK_EDIT);
  DEFINE_STRING(GTK_STOCK_FILE);
  DEFINE_STRING(GTK_STOCK_MEDIA_FORWARD);
  DEFINE_STRING(GTK_STOCK_MEDIA_NEXT);
  DEFINE_STRING(GTK_STOCK_MEDIA_PAUSE);
  DEFINE_STRING(GTK_STOCK_MEDIA_PLAY);
  DEFINE_STRING(GTK_STOCK_MEDIA_PREVIOUS);
  DEFINE_STRING(GTK_STOCK_MEDIA_RECORD);
  DEFINE_STRING(GTK_STOCK_MEDIA_REWIND);
  DEFINE_STRING(GTK_STOCK_MEDIA_STOP);
#endif

}

/* -------------------------------- initialization -------------------------------- */

static bool xg_already_inited = false;

#if WITH_GTK_AND_X11
#if HAVE_GUILE
 void init_x11(void);
#else
 void Init_libx11(void);
#endif
#endif

#if HAVE_GUILE
 void init_xg(void);
 void init_xg(void)
#else
 void Init_libxg(void);
 void Init_libxg(void)
#endif
{
  if (!xg_already_inited)
    {
      define_xm_obj();
      define_integers();
      define_doubles();
      define_functions();
      define_structs();
      define_atoms();
      define_strings();
      XEN_YES_WE_HAVE("xg");
#if HAVE_GUILE
      XEN_EVAL_C_STRING("(define xg-version \"19-May-05\")");
#endif
#if HAVE_RUBY
      rb_define_global_const("Xg_Version", C_TO_XEN_STRING("19-May-05"));
#endif
      xg_already_inited = true;
#if WITH_GTK_AND_X11
#if HAVE_GUILE
      init_x11();
#else
      Init_libx11();
#endif
#endif

    }
}
